#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "admin_pqlx.h"
#include "admin_externs.h"
static GtkListStore *dataStores[TTLDATAMODELS];
GtkWidget *makeDataModel(int model)
{
GtkWidget *treeview;
switch(model)
{
case DATADIRS:
dataStores[model] = gtk_list_store_new(DD_TTLHDRS, G_TYPE_STRING, G_TYPE_STRING, 
G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT);
break;
case CHANNELS:
dataStores[model] = gtk_list_store_new(CH_TTLHDRS, G_TYPE_STRING, G_TYPE_STRING,
G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT,
G_TYPE_INT, G_TYPE_STRING);
break;
case LOGEXEC:
dataStores[model] = gtk_list_store_new(LOGE_TTLHDRS, G_TYPE_STRING, 
G_TYPE_STRING, G_TYPE_STRING,
G_TYPE_STRING, G_TYPE_STRING);
break;
case LOGMSGS:
dataStores[model] = gtk_list_store_new(LOGM_TTLHDRS, G_TYPE_STRING, G_TYPE_STRING, 
G_TYPE_STRING);
break;
case EQEXEC:
case EQQUED:
case EQPEND:
dataStores[model] = gtk_list_store_new(EQ_TTLHDRS, G_TYPE_INT, G_TYPE_STRING);
break;
case SPSEPS:
dataStores[model] = gtk_list_store_new(SPSE_TTLHDRS, G_TYPE_INT, G_TYPE_STRING, 
G_TYPE_STRING);
break;
case PSDCFG:
dataStores[model] = gtk_list_store_new(PSDCFG_TTLHDRS, G_TYPE_STRING);
break;
}
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL(dataStores[model]));
return (treeview);
}
void addDataCols(int model, GtkTreeView *treeview)
{
int   i;
GtkCellRenderer *renderer;
GtkTreeViewColumn *col;
switch(model)
{
case DATADIRS:
for (i=0; i<DD_TTLHDRS; i++)
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(dd_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break; 
case CHANNELS: 
for (i=0; i<CH_TTLHDRS; i++) 
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(ch_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break;
case LOGEXEC:
for (i=0; i<LOGE_TTLHDRS; i++) 
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(loge_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break;
case LOGMSGS:
for (i=0; i<LOGM_TTLHDRS; i++) 
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(logm_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break;
case EQEXEC:
case EQQUED:
case EQPEND:
for (i=0; i<EQ_TTLHDRS; i++) 
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(eq_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break;
case SPSEPS:
for (i=0; i<SPSE_TTLHDRS; i++) 
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(spse_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break;
case PSDCFG:
for (i=0; i<PSDCFG_TTLHDRS; i++) 
{
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(psdcfg_hdrs[i], renderer, "text", i, NULL);
gtk_tree_view_insert_column(treeview, col, i);
}
break;
}
}
static void updateExecInfo(int instanceNum)
{
SRVRLOG *mainSrvrLog = admin.states.log.srvrLog;
SQLDI sqldi;
if (instanceNum) 
return;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DBADMIN;
sqldi.descr.tableData = LOGEXECUPD;
sqldi.data = mainSrvrLog;
db_request(&sqldi);
add_Data(LOGEXEC, instanceNum);
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DBADMIN;
sqldi.descr.tableData = ADMIN_CHNINFO;
sqldi.data = &admin.dbInfo;
db_request(&sqldi);
add_Data(CHANNELS, 0);
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DBADMIN;
sqldi.descr.tableData = ADMIN_DDINFO;
sqldi.data = &admin.dbInfo;
db_request(&sqldi);
add_Data(DATADIRS, 0);
}
static void updateStats(GSList *list)
{
int  ttlChn;
char *startD, *endD, *formatStr;
GSList *iter;
CHNSTATS *chnData;
switch ((long long) list)
{
case 0:   
case NONE:  
startD = g_strdup("0000-00-00 00:00:00");
endD = g_strdup(startD);
ttlChn = 0;
break;
default:
ttlChn = g_slist_length(list);   
iter = list;
chnData = iter->data;
startD = chnData->dataDate[STARTTIME];
endD = chnData->dataDate[ENDTIME];
for (iter = g_slist_next(iter);
iter;
iter = g_slist_next(iter))
{
chnData = iter->data;
if (strcmp(chnData->dataDate[STARTTIME], startD) < 0)
startD = chnData->dataDate[STARTTIME];
if (strcmp(chnData->dataDate[ENDTIME], endD) > 0)
endD = chnData->dataDate[ENDTIME];
}
startD = g_strdup(startD);
endD = g_strdup(endD);
break;
}
formatStr = g_strdup_printf("<span weight=\"bold\" foreground=\"#FFFFFF\">\n%d</span>", ttlChn); 
gtk_label_set_markup(GTK_LABEL(chnStats[CHN_TTL]), formatStr); free(formatStr);
formatStr = g_strdup_printf("<span weight=\"bold\" foreground=\"#FFFFFF\">%s</span>", startD); 
gtk_label_set_markup(GTK_LABEL(chnStats[CHN_STARTD]), (const gchar *) formatStr); free(formatStr);
formatStr = g_strdup_printf("<span weight=\"bold\" foreground=\"#FFFFFF\">%s</span>", endD); 
gtk_label_set_markup(GTK_LABEL(chnStats[CHN_ENDD]), (const gchar *) formatStr); free(formatStr);
free(startD); free(endD);
}
void add_Data(int storeType, int instanceNum)
{
static gboolean reset = FALSE;  
GtkTreeIter treeIter;
GtkListStore *store = dataStores[storeType];
switch (storeType)
{
case DATADIRS:
{
GSList *iter;
DATADIR *dataDir;
if (store)
gtk_list_store_clear(store);
for(iter = admin.dbInfo.dataDirs;
iter;
iter = g_slist_next(iter))
{
dataDir = iter->data;
gtk_list_store_append(store, &treeIter);
gtk_list_store_set(store, &treeIter, 
0, dataDir->directory,
1, dataDir->status,
2, dataDir->lastFile,
3, dataDir->ttlTrace,
4, dataDir->ttlResp,
-1);
}
admin.sel[storeType] = NONE;
}
break;
case PSDCFG:
{
char *chnGrp;
GSList *iter, *list = (admin.state == DBEDIT) ? admin.states.edit.psdConf.list : admin.dbInfo.psdConfs;
PSDCONF *psdConf;
if (store)
gtk_list_store_clear(store);
for(iter = list;
iter;
iter = g_slist_next(iter))
{
psdConf = iter->data;
chnGrp = g_strdup_printf("%s*", psdConf->chnGroup);
gtk_list_store_append(store, &treeIter);
gtk_list_store_set(store, &treeIter, 
0, chnGrp,
-1);
free(chnGrp);
}
admin.sel[storeType] = NONE;
}
break;
case CHANNELS:
{
GSList  *iter, *list = (admin.states.channels.list 
? admin.states.channels.list
: admin.dbInfo.chnInfo);
CHNSTATS *chnData;
if (store)
gtk_list_store_clear(store);
if (list == (GSList *) NONE)
{
updateStats(list);
break;
}
for(iter = list;
iter;
iter = g_slist_next(iter))
{
chnData = iter->data;
gtk_list_store_append(store, &treeIter);
gtk_list_store_set(store, &treeIter, 
0, chnData->name,
1, chnData->dataDate[STARTTIME],
2, chnData->dataDate[ENDTIME],
3, chnData->nTrace,
4, chnData->nPSD,
5, chnData->nSPSepoch,
6, chnData->response,
-1);
}
updateStats(list);
}
break;
case LOGEXEC:
{
GSList  *iter;
SRVREXEC *srvrExec=&admin.dbInfo.srvrExec;
SRVRLOG  *srvrLog;
char  *status;
if (store)
gtk_list_store_clear(store);
for(iter = srvrExec->data.execs;
iter;
iter = g_slist_next(iter))
{
srvrLog = iter->data;
gtk_list_store_append(store, &treeIter);
status = (iter != srvrExec->data.execs &&
!strlen(srvrLog->data.duration))
? srvrStatus[SRVREXEC_CRASH]
: strlen(srvrLog->data.duration)
? srvrStatus[SRVREXEC_DONE]
: srvrStatus[SRVREXEC_EXEC];
gtk_list_store_set(store, &treeIter, 
0, srvrLog->data.pgmName,
1, srvrLog->data.time[STARTTIME],
2, srvrLog->data.time[ENDTIME],
3, srvrLog->data.duration,
4, status,
-1);
}
reset = TRUE;
if (!srvrExec->data.execs) 
gtk_list_store_clear(dataStores[LOGMSGS]);
}
break;
case LOGMSGS:
{
static int lastKey, srvrInstance=NONE, msgType=NONE;
static gboolean updating = FALSE;
GSList *iter;
SRVRLOG *srvrLog=g_slist_nth_data(admin.dbInfo.srvrExec.data.execs, instanceNum);
LOGMSG *logMsg=NULL;
if (!srvrLog)
break;  
if (reset ||
srvrInstance != instanceNum ||
msgType != admin.settings.logDisplay)
{ 
if (store)
gtk_list_store_clear(store);
lastKey = NONE;
srvrInstance = instanceNum;
msgType = admin.settings.logDisplay;
reset = FALSE;
}
if (!instanceNum &&    
!srvrLog->data.complete)
{
updating = TRUE;
}
for(iter = srvrLog->data.msgs[msgType];
iter;
iter = g_slist_next(iter))
{
logMsg = iter->data;
if (logMsg->keys.logKey <= lastKey)
continue;
updating 
? gtk_list_store_prepend(store, &treeIter)
: gtk_list_store_append(store, &treeIter);
gtk_list_store_set(store, &treeIter, 
0, logMsgTypes[logMsg->data.type],
1, logMsg->data.time,
2, logMsg->data.msg,
-1);
}
lastKey = logMsg ? logMsg->keys.logKey : NONE;
admin.states.log.srvrNum = instanceNum;
admin.states.log.srvrLog = srvrLog;
scrollTV(LOGMSGS, 0);
if (srvrLog->data.complete)
{ 
gtk_widget_hide(evtQdisp);
if (!strlen(srvrLog->data.duration))
updateExecInfo(instanceNum);
updating = FALSE;
}
setSrvrExecState(instanceNum);
}
break;
case EQEXEC:
{
int   i, j;
EVENTQLIST *eqList = &admin.states.log.EQList;
GSList  *iter;
for (i=EQEXEC, j=0 ; i<= EQPEND; i++, j++) 
{
store = dataStores[i];
gtk_list_store_clear(store);
for (iter = eqList->events;
iter;
iter = g_slist_next(iter))
{
EQREC *eqR = iter->data;
if (eqR->status == j)
{
gtk_list_store_append(store, &treeIter);
gtk_list_store_set(store, &treeIter, 
0, eqR->count,
1, eqR->descr,
-1);
}
}
}
gtk_widget_set_size_request(evtQdisp, -1, -1);
}
break;
case SPSEPS:
{
GSList  *iter, *list = (admin.states.channels.list 
? admin.states.channels.list
: admin.dbInfo.chnInfo);
CHNSTATS *chnData = g_slist_nth_data(list, instanceNum);
SPSEPOCH *spsE;
if (store)
gtk_list_store_clear(store);
for(iter = chnData->spsEpochs;
iter;
iter = g_slist_next(iter))
{
spsE = iter->data;
gtk_list_store_append(store, &treeIter);
gtk_list_store_set(store, &treeIter, 
0, 1000000/spsE->sampInt,
1, spsE->dates[STARTTIME],
2, spsE->dates[ENDTIME],
-1);
}
gtk_window_resize(GTK_WINDOW(spsEwin), 1, 1);
}
break;
}
}
void scrollTV(int store, int pos)
{
GtkTreeView *tv;
GtkTreePath *path;
char row[20];
tv = (GtkTreeView *) dataVIEW[store];
switch(store)
{
case LOGMSGS: 
case LOGEXEC: 
case PSDCFG:
sprintf(row, "%d", pos);
break;
}
if (row < 0)  
return;
path = gtk_tree_path_new_from_string(row);
gtk_tree_view_scroll_to_cell(tv, path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(tv, path, NULL, FALSE);
gtk_tree_path_free(path);
}
void clearStore(int storeType)
{
GtkListStore *store = dataStores[storeType];
gtk_list_store_clear(store);
}
void freeDataDirInfo(DATADIR *dataDir)
{
free(dataDir->directory);
free(dataDir->lastFile);
free(dataDir->status);
free(dataDir);
}
#define DIRSTRING "Please Select a Directory"
#define FILESTRING "Please Select a File"
#define URIPREFIX "file://"
gboolean getDataDir(int which)
{
static GtkWidget *fileSel, *dirEntry=NULL;
gboolean   ret=TRUE;
char    *dirName;
if (!fileSel)
{
GtkWidget  *hbox, *vbox, *label, *frame, *entry;
char  *title = (which == FILE_SEL_ID) ? FILESTRING : DIRSTRING;
GtkFileChooserAction ca = (which == FILE_SEL_ID) ? GTK_FILE_CHOOSER_ACTION_OPEN 
: GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER;
fileSel = gtk_file_chooser_dialog_new(title,
GTK_WINDOW(topWindow),
ca,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
frame = gtk_frame_new("");
vbox = gtk_vbox_new(FALSE, 2);
hbox = gtk_hbox_new(FALSE, 2);
label = gtk_label_new("Directory: ");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
dirEntry = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Enter Full-Path Directory Name (e.g., when directory is not available through the Selector above)");
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 40);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 40);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_widget_show_all(frame);
gtk_file_chooser_set_extra_widget(GTK_FILE_CHOOSER(fileSel), frame);
}
else
{ 
char *title = (which == FILE_SEL_ID) ? FILESTRING : DIRSTRING;
GtkFileChooserAction ca = (which == FILE_SEL_ID) ? GTK_FILE_CHOOSER_ACTION_OPEN 
: GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER;
gtk_window_set_title(GTK_WINDOW(fileSel), title);
gtk_file_chooser_set_action(GTK_FILE_CHOOSER(fileSel), ca);
gtk_widget_show(fileSel);
}
switch (gtk_dialog_run(GTK_DIALOG(fileSel)))
{ 
case GTK_RESPONSE_OK:  
{
char *directory = g_strdup(gtk_entry_get_text(GTK_ENTRY(dirEntry)));
dirName = (strlen(directory) 
? g_strdup(directory)
: gtk_file_chooser_get_uri(GTK_FILE_CHOOSER(fileSel)));
free(directory);
if (!strncmp(dirName, URIPREFIX, strlen(URIPREFIX)))
{ 
char *dir = dirName;
dirName = g_strjoinv("", g_strsplit(dir, URIPREFIX, -1));
free(dir);
}
ret = TRUE;
} 
break;
default:
ret = FALSE;
break;
}
if (!ret)
{ 
gtk_widget_hide(fileSel);
return (ret);
}
switch (which)
{
case FILE_SEL_DD:
{
DATADIR *dataDir;
dataDir = calloc(1, sizeof(DATADIR));
dataDir->directory = dirName;
dataDir->lastFile = g_strdup("NONE");
dataDir->status = g_strdup("ACTIVE");
dataDir->statusI = ACTIVE;
dataDir->admin.cmdFlag = DU_NEW;
admin.dbInfo.dataDirs = g_slist_append(admin.dbInfo.dataDirs, dataDir);
}
break;
case FILE_SEL_PNG:
admin.states.png.pdfWWWDir = dirName;
break;
case FILE_SEL_ID:
admin.settings.srvrCFG.identFile = dirName;
break;
}
gtk_widget_hide(fileSel);
return (ret);
}
void dispInfo(GtkTreeView *treeview, gpointer w)
{
int which = GPOINTER_TO_INT(w);
switch (which)
{
case PSDCFG:
{
char str[25], *chnName;
GSList *list;
PSDCONF *psdCfg;
switch (admin.state)
{
case DBEDIT:
list = admin.states.edit.psdConf.list;
break;
default:
list = admin.dbInfo.psdConfs;
break;
}
psdCfg = g_slist_nth_data(list, admin.sel[which]);
chnName = g_strdup_printf("<span foreground=\"white\">%s*</span>", psdCfg->chnGroup);
gtk_label_set_markup(GTK_LABEL(psdConf[PSDCFG_CHNGRP]), (const gchar *) chnName);
free(chnName);
gtk_spin_button_set_value(GTK_SPIN_BUTTON(psdConf[PSDCFG_OVERLAP]), (gdouble) psdCfg->overlap);
sprintf(str, "%d", psdCfg->min_power);
gtk_entry_set_text(GTK_ENTRY(psdConf[PSDCFG_MINDB]), str);
sprintf(str, "%d", psdCfg->max_power);
gtk_entry_set_text(GTK_ENTRY(psdConf[PSDCFG_MAXDB]), str);
sprintf(str, "%d", psdCfg->psd_dur);
gtk_entry_set_text(GTK_ENTRY(psdConf[PSDCFG_DURATION]), str);
sprintf(str, "%g", psdCfg->max_period);
gtk_entry_set_text(GTK_ENTRY(psdConf[PSDCFG_MAXPER]), str);
gtk_combo_box_set_active(GTK_COMBO_BOX(psdConf[PSDCFG_TYPE]), psdCfg->type);
}
break;
}
}
void getInfo(GtkTreeView *treeview, gpointer w)
{
int which = GPOINTER_TO_INT(w);
if (admin.state != DBEDIT || 
admin.sel[which] == NONE) 
return;
switch (which)
{
case PSDCFG:
{
PSDCONF *psdCfg = g_slist_nth_data(admin.states.edit.psdConf.list, admin.sel[which]),
*psdCfgOrig;
psdCfg->overlap = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(psdConf[PSDCFG_OVERLAP]));
sscanf(gtk_entry_get_text(GTK_ENTRY(psdConf[PSDCFG_MINDB])), "%d", &psdCfg->min_power);
sscanf(gtk_entry_get_text(GTK_ENTRY(psdConf[PSDCFG_MAXDB])), "%d", &psdCfg->max_power);
sscanf(gtk_entry_get_text(GTK_ENTRY(psdConf[PSDCFG_DURATION])), "%d", &psdCfg->psd_dur);
sscanf(gtk_entry_get_text(GTK_ENTRY(psdConf[PSDCFG_MAXPER])), "%f", &psdCfg->max_period);
psdCfg->type = gtk_combo_box_get_active(GTK_COMBO_BOX(psdConf[PSDCFG_TYPE]));
if (psdCfg->admin.cmdFlag == DU_NEW)
break;
psdCfgOrig = g_slist_nth_data(admin.dbInfo.psdConfs, admin.sel[which]);
if (memcmp(psdCfgOrig, psdCfg, sizeof(PSDCONF)))  
psdCfg->admin.cmdFlag = DU_UPD;
if (psdCfg->admin.cmdFlag == DU_UPD &&
psdCfg->admin.data == TRUE)
{
char *str;
str = g_strdup_printf("For Channel Group '%s', Data has already been Analyzed\n"
"When Modifying PSD Configuration Parameters, ALL Previously "
"Analyzed Data will be Deleted and PSD's Re-Generated\n\n"
"If you do not want this, Use the CANCEL Button at bottom\n",
psdCfg->chnGroup);
dispMsgDialog(str);
free(str);
}
}
break;
}
}
