#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "admin_pqlx.h"
#include "admin_externs.h"
enum {
TV_UPDATE,
TV_TOEND
};
#define POLLINTERVAL (1*1000)
#if 0
typedef struct _POLLARGS
{
int  type;
int  key; 
} POLLARGS;
#endif
static gint pollID[TTLPOLLTYPES] = { NONE, NONE };
static gboolean updateData(gpointer a)
{
int action = GPOINTER_TO_INT(a);
switch (action)
{
case TV_UPDATE:
{
add_Data(LOGMSGS, admin.states.log.srvrNum);
}
break;
case TV_TOEND:
scrollTV(LOGMSGS, 0);
break;
}
return FALSE;
}
static gboolean pollLogReturn(SQLDI *sqldi)
{ 
SRVRLOG  *srvrLog = sqldi->data;
int   type = sqldi->args.sqr-1;
switch (type)
{
case POLL_LOG:
pollID[type] = NONE;
if (srvrLog->data.updated[MSGTYPE_LOG] ||
srvrLog->data.updated[MSGTYPE_ERR])
{ 
g_idle_add((GSourceFunc) updateData, GINT_TO_POINTER(TV_UPDATE));
}
if (!srvrLog->data.complete)
{ 
setPolling(type, FALSE);
}
else
pollQuit();
break;
case POLL_EVENTQ:
{
EVENTQLIST *eqList = sqldi->data;
pollID[type] = NONE;
add_Data(EQEXEC, NONE);
(eqList == NULL)
? pollQuit()    
: setPolling(type, FALSE); 
}
break;
}
free(sqldi);
return FALSE;
}
static gboolean pollSend(gpointer t)
{ 
gboolean execAgain = TRUE;
int type = GPOINTER_TO_INT(t);
SQLDI *sqldi;
if (pollID[type] == NONE) 
return FALSE;
switch(type)
{
case POLL_LOG:
{
sqldi = calloc(1, sizeof(SQLDI));
sqldi->args.sqr = type + 1;
sqldi->args.callType = ASYNC;
sqldi->args.returnFunc = pollLogReturn;
sqldi->args.dataEvent = DBADMIN;
sqldi->descr.tableData = LOGMSGTBLNEXT;
sqldi->data = admin.states.log.srvrLog;
db_request(sqldi);
execAgain = FALSE;
}
break;
case POLL_EVENTQ:
{
sqldi = calloc(1, sizeof(SQLDI));
sqldi->args.sqr = type + 1;
sqldi->args.callType = ASYNC;
sqldi->args.returnFunc = pollLogReturn;
sqldi->args.dataEvent = DBADMIN;
sqldi->descr.tableData = ADMIN_EVENTQ;
sqldi->data = &admin.states.log.EQList;
db_request(sqldi);
execAgain = FALSE;
}
break;
}
return execAgain;
}
void setPolling(int type, gboolean immediate)
{ 
guint timeOut = immediate ? 1 : POLLINTERVAL;
switch(type)
{
case TTLPOLLTYPES:
{
int  i;
for (i=0;i<TTLPOLLTYPES;i++)
{
setPolling(i, immediate);  
}
}
break;
case POLL_EVENTQ:
timeOut *= 2;
case POLL_LOG:
if (pollID[type] > 0) 
return;
pollID[type] = g_timeout_add(timeOut, (GSourceFunc) pollSend, GINT_TO_POINTER(type));
break;
}
}
void pollQuit()
{ 
int  i;
for (i=0;i<TTLPOLLTYPES;i++)
{
pollID[i] = NONE;
admin.states.log.polling[i] = FALSE;
}
}
