#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "admin_pqlx.h"
#include "admin_externs.h"
enum {
NPWN,
NPWC,
EPWO,
EPWN,
EPWC,
TTLPWORDS
};
static void PNGTest(GtkButton *button, gpointer w)
{
int  which = GPOINTER_TO_INT(w);
static GtkWidget *pngTest, *da;
const char *str;
int  width, height;
admin.states.png.which = which;
if (!pngTest)
{
GtkWidget *content, *dialog, *content_area;
pngTest = dialog = gtk_dialog_new_with_buttons("Sample PNG Output",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
NULL);
content_area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
content = gtk_vbox_new(FALSE, 0);
da = gtk_drawing_area_new();
g_signal_connect(da, "configure_event", G_CALLBACK(pngDisp_cfg), GINT_TO_POINTER(PNGTEST));
g_signal_connect(da, "expose_event", G_CALLBACK(pngDisp_exp), GINT_TO_POINTER(PNGTEST));
gtk_container_add(GTK_CONTAINER(content), da);
gtk_container_add(GTK_CONTAINER(content_area), content);
gtk_widget_show_all(dialog);
gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
}
switch (which)
{
case NORMPNG:
{
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGNW]));
if (strlen(str))
sscanf(str, "%d", &width);
else
width = NORMPNGMINW;
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGNH]));
if (strlen(str))
sscanf(str, "%d", &height);
else
height = NORMPNGMINH;
}
break;
case ICONPNG:
{
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGIW]));
if (strlen(str))
sscanf(str, "%d", &width);
else
width = ICONPNGMINW;
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGIH]));
if (strlen(str))
sscanf(str, "%d", &height);
else
height = ICONPNGMINH;
}
break;
}
gtk_widget_set_size_request(da, width, height);
gtk_widget_queue_resize(da);
gtk_dialog_run(GTK_DIALOG(pngTest));
gtk_widget_hide(pngTest);
}
static void PNGSize(GtkButton *button, gpointer w)
{
int  which = GPOINTER_TO_INT(w);
static GtkWidget *pngSize, *da;
GdkGeometry geom;
admin.states.png.which = which;
if (!pngSize)
{
GtkWidget *content, *dialog, *content_area;
GtkTooltips *tips;
static char  toolTip[1000];
pngSize = dialog = gtk_dialog_new_with_buttons("Select PNG Size",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
content_area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
content = gtk_vbox_new(FALSE, 0);
tips = gtk_tooltips_new();
sprintf(toolTip, "Resize Window to Desired PNG Size\nOK Button to Select");
da = gtk_drawing_area_new();
g_signal_connect(da, "configure_event", G_CALLBACK(pngDisp_cfg), GINT_TO_POINTER(PNGSIZE));
g_signal_connect(da, "expose_event", G_CALLBACK(pngDisp_exp), GINT_TO_POINTER(PNGSIZE));
gtk_container_add(GTK_CONTAINER(content), da);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(content_area), content);
gtk_widget_show_all(dialog);
}
switch (which)
{
case NORMPNG:
{
const char *str;
int  width, height;
memset(&geom, 0, sizeof(GdkGeometry));
geom.min_width = NORMPNGMINW;
geom.min_height = NORMPNGMINH;
gtk_window_set_geometry_hints(GTK_WINDOW(pngSize), da, &geom, GDK_HINT_MIN_SIZE);
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGNW]));
if (strlen(str))
sscanf(str, "%d", &width);
else
width = NORMPNGMINW;
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGNH]));
if (strlen(str))
sscanf(str, "%d", &height);
else
height = NORMPNGMINH;
gtk_widget_set_size_request(da, width, height);
gtk_window_set_policy(GTK_WINDOW(pngSize), TRUE, TRUE, FALSE);
}
break;
case ICONPNG:
{
const char *str;
int  width, height;
memset(&geom, 0, sizeof(GdkGeometry));
geom.min_width = ICONPNGMINW;
geom.min_height = ICONPNGMINH;
geom.max_width = ICONPNGMAXW;
geom.max_height = ICONPNGMAXH;
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGIW]));
if (strlen(str))
sscanf(str, "%d", &width);
else
width = ICONPNGMAXW;
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGIH]));
if (strlen(str))
sscanf(str, "%d", &height);
else
height = ICONPNGMAXH;
gtk_widget_set_size_request(da, width, height);
gtk_window_set_policy(GTK_WINDOW(pngSize), TRUE, TRUE, FALSE);
gtk_window_set_geometry_hints(GTK_WINDOW(pngSize), da, &geom, 
(GdkWindowHints) (GDK_HINT_MAX_SIZE | GDK_HINT_MIN_SIZE));
}
break;
}
gtk_widget_queue_resize(da);
switch(gtk_dialog_run(GTK_DIALOG(pngSize)))
{
case GTK_RESPONSE_OK:
{
int  width, height;
char str[25];
width = da->allocation.width;
height = da->allocation.height;
switch(which)
{
case NORMPNG:
sprintf(str, "%d", width);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGNW]), str);
sprintf(str, "%d", height);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGNH]), str);
break;
case ICONPNG:
sprintf(str, "%d", width);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGIW]), str);
sprintf(str, "%d", height);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGIH]), str);
break;
}
}
break;
case GTK_RESPONSE_CANCEL: 
break;
}
gtk_widget_hide(pngSize);
}
static gboolean validPW(const char *oldP, const char *newP, const char *confP)
{ 
gboolean ret = TRUE;
while (ret)
{
if (oldP && strcmp(oldP, admin.dbInfo.dbListing.adminPWord))
{
dispMsgDialog("Current Password Is Not Correct...\nTry Again...\n");
ret = FALSE;
continue;
}
if (!strlen(newP))
{
dispMsgDialog("Password Cannot be Blank...\nTry Again...\n");
ret = FALSE;
continue;
}
if (strcmp(newP, confP))
{
dispMsgDialog("Passwords Do Not Match...\nTry Again...\n");
ret = FALSE;
continue;
}
break;
}
return (ret);
}
void setPassword()
{
static GtkWidget *pwordD[2], *hint[2], *pWord[TTLPWORDS];
gboolean confirmed;
int  dispState = admin.state;
if (!pwordD[dispState])
{
GtkWidget *dialog, *label, *content_area, *content, *hbox, *entry, *vbox;
GtkSizeGroup *SG1;
char  *buttonText;
SG1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
buttonText = (dispState == DBCREATE) 
? "Create DB"
: "Save";
pwordD[dispState] = dialog = gtk_dialog_new_with_buttons("Set Password",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
buttonText, GTK_RESPONSE_OK,
NULL);
content_area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
content = gtk_vbox_new(FALSE, 0);
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(content), vbox, FALSE, FALSE, 0);
switch(dispState)
{
case DBCREATE:
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Password: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
pWord[NPWN] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Specify the DB Password");
gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Confirm: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
pWord[NPWC] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Confirm the Password");
gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Hint: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
hint[dispState] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Set the DB Password Hint");
gtk_entry_set_visibility(GTK_ENTRY(entry), TRUE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
break;
case DBEDIT:
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Old Password: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
pWord[EPWO] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Specify the Previous DB Password");
gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("New Password: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
pWord[EPWN] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Specify the New DB Password");
gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Confirm: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
pWord[EPWC] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Confirm the New DB Password");
gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Hint: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
hint[dispState] = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Specify the New DB Password Hint");
gtk_entry_set_visibility(GTK_ENTRY(entry), TRUE);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
break;
}
g_object_unref(SG1);
gtk_container_add(GTK_CONTAINER(content_area), content);
gtk_widget_show_all(dialog);
}
switch(dispState)
{
case DBCREATE:
gtk_entry_set_text(GTK_ENTRY(pWord[NPWN]), "");
gtk_entry_set_text(GTK_ENTRY(pWord[NPWC]), "");
gtk_widget_grab_focus(pWord[NPWN]);
break;
case DBEDIT:
gtk_entry_set_text(GTK_ENTRY(pWord[EPWO]), "");
gtk_entry_set_text(GTK_ENTRY(pWord[EPWN]), "");
gtk_entry_set_text(GTK_ENTRY(pWord[EPWC]), "");
gtk_widget_grab_focus(pWord[EPWO]);
break;
}
gtk_entry_set_text(GTK_ENTRY(hint[dispState]), "");
gtk_window_resize(GTK_WINDOW(pwordD[dispState]), 1, 1);
gtk_window_set_position(GTK_WINDOW(topWindow), GTK_WIN_POS_CENTER);
confirmed = FALSE;
while (!confirmed)
{
switch(gtk_dialog_run(GTK_DIALOG(pwordD[dispState])))
{
case GTK_RESPONSE_OK:
{
const char *newP, *confP, *oldP, *hintStr;
switch(dispState)
{
case DBCREATE:
oldP = NULL;
newP = gtk_entry_get_text(GTK_ENTRY(pWord[NPWN]));
confP = gtk_entry_get_text(GTK_ENTRY(pWord[NPWC]));
if (!validPW(oldP, newP, confP))
{
gtk_entry_set_text(GTK_ENTRY(pWord[NPWN]), "");
gtk_entry_set_text(GTK_ENTRY(pWord[NPWC]), "");
continue;
}
confirmed = TRUE;
admin.dbInfo.dbListing.adminPWord = g_strdup(newP);
hintStr = gtk_entry_get_text(GTK_ENTRY(hint[dispState]));
if (hintStr)
admin.dbInfo.dbListing.hint = g_strdup(hintStr);
else
admin.dbInfo.dbListing.hint = g_strdup("");
gtk_widget_hide(pwordD[dispState]);
dbAction(NULL, GINT_TO_POINTER(DBACTIONCREATE));
break;
case DBEDIT:
oldP = gtk_entry_get_text(GTK_ENTRY(pWord[EPWO]));
newP = gtk_entry_get_text(GTK_ENTRY(pWord[EPWN]));
confP = gtk_entry_get_text(GTK_ENTRY(pWord[EPWC]));
if (!validPW(oldP, newP, confP))
{
gtk_entry_set_text(GTK_ENTRY(pWord[EPWO]), "");
gtk_entry_set_text(GTK_ENTRY(pWord[EPWN]), "");
gtk_entry_set_text(GTK_ENTRY(pWord[EPWC]), "");
continue;
}
confirmed = TRUE;
free(admin.dbInfo.dbListing.adminPWord);
admin.dbInfo.dbListing.adminPWord = g_strdup(newP);
free(admin.dbInfo.dbListing.hint);
hintStr = gtk_entry_get_text(GTK_ENTRY(hint[dispState]));
if (hintStr)
admin.dbInfo.dbListing.hint = g_strdup(hintStr);
else
admin.dbInfo.dbListing.hint = g_strdup("");
gtk_widget_hide(pwordD[dispState]);
break;
}
}
break;
case GTK_RESPONSE_CANCEL: 
confirmed = TRUE;
gtk_widget_hide(pwordD[dispState]);
break;
}
}
}
static GtkWidget *restrictON;
static void timeRestrict(GtkToggleButton *button, gpointer nil)
{
switch (gtk_toggle_button_get_active(button))
{
case TRUE:
gtk_widget_show(restrictON);
break;
case FALSE:
gtk_widget_hide(restrictON);
break;
}
}
static void srvrExecConfig(GtkButton *button, gpointer a)
{
int  action = GPOINTER_TO_INT(a);
static GtkWidget *srvrExec, *numCPU, *dirScan, *refSys, *restricted, 
*time[TTLTRTIMES][TTLTRSEGS];
if (action == SRVR_CFG_DESTROY)
{
gtk_widget_destroy(srvrExec);
srvrExec = NULL;
setSrvrCFGDefaults(&admin.settings.srvrCFG);
return;
}
if (!srvrExec)
{
GtkWidget *dialog, *content_area, *content, *label, *frame, *vbox, *hbox, *combo, *entry,
*radioB1, *radioB2, *check, *but;
GtkSizeGroup *SG1;
int   i;
SG1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
srvrExec = dialog = gtk_dialog_new_with_buttons("Set Server Configuration",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
content_area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
content = gtk_vbox_new(FALSE, 0);
frame = gtk_frame_new("General Options:");
gtk_container_add(GTK_CONTAINER(content), frame);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Number of CPU's: ");
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
numCPU = combo = gtk_combo_box_new_text();
gtk_widget_set_tooltip_text(combo, "Specify the Number of CPU's the Server is to Use");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 0);
for(i=1; i<=admin.settings.maxCPU; i++)
{
char *nCPU = g_strdup_printf(" %d", i);
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), nCPU);
free(nCPU);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(numCPU), i-2);
label = gtk_label_new("Directory Scanning: ");
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
dirScan = radioB1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_box_pack_start(GTK_BOX(hbox), radioB1, FALSE, FALSE, 2);
radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
gtk_box_pack_start(GTK_BOX(hbox), radioB2, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
gtk_widget_set_tooltip_text(radioB1, "Scan Data Directories");
gtk_widget_set_tooltip_text(radioB2, "Do NOT Scan Data Directories");
label = gtk_label_new("Refresh ALL System\nPDF's & Spectrograms: ");
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
refSys = check = gtk_check_button_new_with_label("Yes");
gtk_box_pack_start(GTK_BOX(hbox), check, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
gtk_widget_set_tooltip_text(check, "Re-Generate System PDF's & Spectrograms");
frame = gtk_frame_new("Process Specific Files:");
gtk_container_add(GTK_CONTAINER(content), frame);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
label = gtk_label_new("File Name: ");
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
srvrCFGIDFile = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
gtk_widget_set_tooltip_text(check, "Re-Process Files Contained in Specified File\n"
"One File per Line, Full Directory Path and Name");
but = gtk_button_new_with_label("..."); 
gtk_box_pack_end(GTK_BOX(hbox), but, FALSE, FALSE, 0);
g_signal_connect(but, "clicked", G_CALLBACK(DDAction), GINT_TO_POINTER(IDFILE_ADD));
gtk_widget_set_tooltip_text(but, "Select the File");
frame = gtk_frame_new("Time Restricted Execution:");
gtk_container_add(GTK_CONTAINER(content), frame);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
label = gtk_label_new("Time Restriction: ");
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
restricted = radioB1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_box_pack_start(GTK_BOX(hbox), radioB1, FALSE, FALSE, 2);
radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
gtk_box_pack_start(GTK_BOX(hbox), radioB2, FALSE, FALSE, 2);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radioB2), TRUE);
gtk_widget_set_tooltip_text(radioB1, "Restrict Execution Hours");
gtk_widget_set_tooltip_text(radioB2, "Execution is Un-Restricted");
g_signal_connect(restricted, "toggled", G_CALLBACK(timeRestrict), NULL);
restrictON = frame = gtk_frame_new("Between The Hours Of:");
gtk_container_add(GTK_CONTAINER(vbox), frame);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
label = gtk_label_new("Start Time: ");
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
time[TRSTARTT][TRHOUR] = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
for(i=0; i<24; i++)
{
char *t = g_strdup_printf(" %02d", i);
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), t);
free(t);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
label = gtk_label_new(" : ");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
time[TRSTARTT][TRMIN] = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
for(i=0; i<60; i+=10)
{
char *t = g_strdup_printf(" %02d", i);
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), t);
free(t);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
label = gtk_label_new("End Time: ");
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
time[TRENDT][TRHOUR] = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
for(i=0; i<24; i++)
{
char *t = g_strdup_printf(" %02d", i);
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), t);
free(t);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
label = gtk_label_new(" : ");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
time[TRENDT][TRMIN] = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
for(i=0; i<60; i+=10)
{
char *t = g_strdup_printf(" %02d", i);
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), t);
free(t);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
gtk_container_add(GTK_CONTAINER(content_area), content);
gtk_widget_show_all(dialog);
gtk_widget_hide(restrictON);
}
switch(gtk_dialog_run(GTK_DIALOG(srvrExec)))
{
case GTK_RESPONSE_OK:
{
int  i, j;
SRVREXECCFG *srvrCFG = &admin.settings.srvrCFG;
srvrCFG->numCPU = gtk_combo_box_get_active(GTK_COMBO_BOX(numCPU)) + 1;
srvrCFG->dirScan = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dirScan));
srvrCFG->refreshSysPNG = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(refSys));
srvrCFG->timeRestricted.set = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(restricted));
if (srvrCFG->timeRestricted.set)
{
int setting;
for (i=0; i < TTLTRTIMES; i++)
{
for (j=0; j < TTLTRSEGS; j++)
{
setting = gtk_combo_box_get_active(GTK_COMBO_BOX(time[i][j]));
switch (j)
{
case TRHOUR:
srvrCFG->timeRestricted.bounds[i].time[j] = setting;
break;
case TRMIN:
srvrCFG->timeRestricted.bounds[i].time[j] = setting * 10;
break;
}
}
}
if (srvrCFG->timeRestricted.bounds[TRSTARTT].time[TRHOUR] ==
srvrCFG->timeRestricted.bounds[TRENDT].time[TRHOUR] &&
srvrCFG->timeRestricted.bounds[TRSTARTT].time[TRMIN] ==
srvrCFG->timeRestricted.bounds[TRENDT].time[TRMIN])
srvrCFG->timeRestricted.set = FALSE;
}
}
break;
case GTK_RESPONSE_CANCEL: 
IFFREE(admin.settings.srvrCFG.identFile);
admin.settings.srvrCFG.identFile = NULL;
gtk_entry_set_text(GTK_ENTRY(srvrCFGIDFile), "");
break;
}
gtk_widget_hide(srvrExec);
}
static GtkWidget *makeSideBar(int which)
{
GtkWidget *menu_box, *label, *sep, *button, *widget, *eBox, *frame, *box, *combo;
static GtkSizeGroup *SG;
int   i;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#00044d\" font_desc=\"18\">PQLX</span>");
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#00044d\" font_desc=\"18\">ADMIN</span>");
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &white);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
switch (which)
{
case A_INFO:
SG = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
button = gtk_button_new_with_label("Manage");
g_signal_connect((button), "clicked", G_CALLBACK(servers), NULL);
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Connect To and Manage a PQLX Database");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
button = gtk_button_new_with_label("NEW");
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONNEW));
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Create NEW PQLX Database");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
#if 0
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &white);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
button = gtk_button_new_with_label("Controls");
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
#endif
break;
case A_CHAN:
buttons[BUTEXECEXEC] = button = gtk_button_new_with_label("re-PSD");
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONREPSD));
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Re-Compute PSD's for a Specified Time Period");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
break;
case A_LOGS:
button = gtk_button_new_with_label("REFRESH");
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONLOGREF));
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Refresh Execution LOG List");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
eBox = gtk_event_box_new();
srvrFrame = frame = gtk_frame_new("PQLX Server");
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &ltblue);
buttons[BUTEXECEXEC] = button = gtk_button_new_with_label("RUN");
g_signal_connect(button, "clicked", G_CALLBACK(pgmExec), GINT_TO_POINTER(PGMEXEC_SRVR));
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Run The PQLX Server Program");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
buttons[BUTPAUSEEXEC] = button = gtk_button_new_with_label("PAUSE");
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONSRVRPAUSE));
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "PAUSE The PQLX Server Program");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
buttons[BUTRESUMEEXEC] = button = gtk_button_new_with_label("RESUME");
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONSRVRRESUME));
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "RESUME Execution of the PQLX Server Program");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
buttons[BUTEXECCFG] = button = gtk_button_new_with_label("Configure");
g_signal_connect(button, "clicked", G_CALLBACK(srvrExecConfig), GINT_TO_POINTER(SRVR_CFG_SHOW));
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "CONFIGURE The PQLX Server Program for Execution");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
eBox = gtk_event_box_new();
frame = gtk_frame_new("LOG Display");
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &ltblue);
combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
gtk_widget_set_tooltip_text(combo, "Define LOG Messages to Display");
for (i=0;i<TTLSRVRLOGTYPES;i++)
gtk_combo_box_append_text(GTK_COMBO_BOX (combo), logMsgTypes[i]);
admin.settings.logDisplay = MSGTYPE_LOG;
gtk_combo_box_set_active(GTK_COMBO_BOX (combo), admin.settings.logDisplay);
g_signal_connect(combo, "changed", G_CALLBACK(comboCBack), GINT_TO_POINTER(CBO_LOGMSGTYPE));
button = gtk_button_new_with_label("pqlx");
g_signal_connect(button, "clicked", G_CALLBACK(pgmExec), GINT_TO_POINTER(PGMEXEC_PQLX));
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Run 'pqlx'");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
break;
}
button = gtk_button_new_with_label("DISCONNECT");
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONCANCEL));
g_signal_connect(button, "clicked", G_CALLBACK(srvrExecConfig), GINT_TO_POINTER(SRVR_CFG_DESTROY));
gtk_widget_set_tooltip_text(button, "Disconnect from DB");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &white);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
button = gtk_button_new_with_label("About");
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(adminQuit), NULL);
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 1);
gtk_widget_set_tooltip_text(button, "Quit PQLX Admin");
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &ltblue);
gtk_size_group_add_widget(SG, widget);
return menu_box;
}
static GtkSizeGroup *SG3, *SG6;
static GtkWidget *makePNGConfig(int pngPlot)
{
int   i;
char  *labelStr;
GtkWidget *pngBox;
GtkWidget *hbox, *label, *entry, *frame, *combo, *vbox4,
*vbox, *button, *hbox2, *cb, *vbox3, *radioB1, *radioB2,
*hbox3, *hbox4, *vbox5;
pngBox = vbox5 = gtk_vbox_new(FALSE, 0);
switch (pngPlot)
{
case PNGPLOT_PDF:
{
char   *stat;
GtkSizeGroup *SG4, *SG7;
SG4 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
SG7 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox4 = gtk_hbox_new(TRUE, 15);
gtk_box_pack_start(GTK_BOX(vbox5), hbox4, FALSE, FALSE, 2);
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox4), vbox, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 2);
button = gtk_button_new_with_label("..."); 
gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 0);
g_signal_connect(button, "clicked", G_CALLBACK(DDAction), GINT_TO_POINTER(PNG_ADD));
gtk_size_group_add_widget(SG6, button);
gtk_widget_set_tooltip_text(button, "Select PNG Output Directory");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">Directory: </span>");
dbInfo[DBPNGDIR] = entry = gtk_entry_new();
gtk_size_group_add_widget(SG3, entry);
gtk_size_group_add_widget(SG6, entry);
gtk_box_pack_end(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_end(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "PDF PNG Output Directory\nLeave blank for NO OUTPUT");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">Date Format: </span>");
dbInfo[DBPNGDF] = combo = gtk_combo_box_new_text();
for(i=0; i<TTLPDFDATEFORMATS; i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX (combo), dateFormats[i]);
}
gtk_size_group_add_widget(SG3, combo);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(combo, "PNG Display Date Format");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], combo);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], combo);
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox4), vbox, TRUE, TRUE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
labelStr = g_strdup_printf("<span foreground=\"white\"> %s </span>", "Plot HLNM");
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) labelStr); free(labelStr);
dbInfo[DBPNGHLNM] = cb = gtk_check_button_new();
gtk_box_pack_start(GTK_BOX(hbox), cb, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_misc_set_alignment(GTK_MISC(label), 0, .5);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], cb);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], cb);
hbox2 = gtk_hbox_new(TRUE, 5);
gtk_box_pack_start(GTK_BOX(vbox5), hbox2, FALSE, FALSE, 2);
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox2), frame, TRUE, TRUE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Normal PNG </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
vbox3 = gtk_vbox_new(FALSE, 5);
gtk_container_add(GTK_CONTAINER(frame), vbox3);
hbox4 = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox3), hbox4, FALSE, FALSE, 5);
gtk_size_group_add_widget(SG7, hbox4);
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox4), frame, TRUE, TRUE, 5);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Appearance </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
hbox = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Width: </span>");
dbInfo[DBPNGNW] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_size_group_add_widget(SG6, entry);
gtk_widget_set_tooltip_text(entry, "PNG Width (in Pixels) Specify 0 = Create NO PNG");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Height: </span>");
dbInfo[DBPNGNH] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_size_group_add_widget(SG6, entry);
gtk_widget_set_tooltip_text(entry, "PNG Height (in Pixels)");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
button = gtk_button_new_with_label("..."); 
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 5);
g_signal_connect(button, "clicked", G_CALLBACK(PNGSize), GINT_TO_POINTER(NORMPNG));
gtk_widget_set_tooltip_text(button, "Select PNG Size");
gtk_size_group_add_widget(SG6, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
hbox4 = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox), hbox4, FALSE, FALSE, 5);
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox4), frame, TRUE, TRUE, 5);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Border </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
hbox3 = gtk_hbox_new(FALSE, 30);
gtk_container_add(GTK_CONTAINER(frame), hbox3);
vbox4 = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox3), vbox4, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox4), hbox, FALSE, FALSE, 2);
dbInfo[DBPNGNB] = radioB1 = gtk_radio_button_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox), radioB1, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">ON</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox4), hbox, FALSE, FALSE, 2);
radioB2 = gtk_radio_button_new(gtk_radio_button_get_group((GtkRadioButton *) radioB1));
gtk_box_pack_start(GTK_BOX(hbox), radioB2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">OFF</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(radioB1, "Display Border");
gtk_widget_set_tooltip_text(radioB2, "Do NOT Display Border");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], radioB1);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], radioB1);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], radioB1);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], radioB1);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], radioB2);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], radioB2);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], radioB2);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], radioB2);
dbInfo[DBPNGNBC] = cb = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (cb), "PDF Border");
gtk_box_pack_start(GTK_BOX(hbox3), cb, FALSE, FALSE, 2);
gtk_widget_set_tooltip_text(cb, "Set the PNG Border Colour");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], cb);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], cb);
hbox4 = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox3), hbox4, FALSE, FALSE, 5);
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox4), frame, TRUE, TRUE, 5);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Statistics </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
gtk_widget_set_tooltip_text(label, "Statistics to Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%3))
{
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
stat = g_strdup_printf("<span foreground=\"white\"> %s </span>", statStr[i]);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) stat);
free(stat);
stats[i] = cb = gtk_check_button_new();
gtk_box_pack_start(GTK_BOX(hbox), cb, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_misc_set_alignment(GTK_MISC(label), 0, .5);
gtk_size_group_add_widget(SG4, label);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], cb);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], cb);
}
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox2), frame, TRUE, TRUE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Icon PNG </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
vbox3 = gtk_vbox_new(FALSE, 5);
gtk_container_add(GTK_CONTAINER(frame), vbox3);
hbox4 = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox3), hbox4, FALSE, FALSE, 5);
gtk_size_group_add_widget(SG7, hbox4);
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox4), frame, TRUE, TRUE, 5);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Appearance </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
hbox = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Width: </span>");
dbInfo[DBPNGIW] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_size_group_add_widget(SG6, entry);
gtk_widget_set_tooltip_text(entry, "Icon PNG Width (in Pixels) Specify 0 = Create NO Icon PNG");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Height: </span>");
dbInfo[DBPNGIH] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_size_group_add_widget(SG6, entry);
gtk_widget_set_tooltip_text(entry, "Icon PNG Height (in Pixels)");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
button = gtk_button_new_with_label("..."); 
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 5);
g_signal_connect(button, "clicked", G_CALLBACK(PNGSize), GINT_TO_POINTER(ICONPNG));
gtk_widget_set_tooltip_text(button, "Select Icon PNG Size");
gtk_size_group_add_widget(SG6, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
hbox4 = gtk_hbox_new(FALSE, 5);
gtk_box_pack_start(GTK_BOX(vbox), hbox4, FALSE, FALSE, 5);
frame = gtk_frame_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox4), frame, TRUE, TRUE, 5);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\"> Border </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
hbox3 = gtk_hbox_new(FALSE, 30);
gtk_container_add(GTK_CONTAINER(frame), hbox3);
vbox4 = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox3), vbox4, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox4), hbox, FALSE, FALSE, 2);
dbInfo[DBPNGIB] = radioB1 = gtk_radio_button_new(NULL);
gtk_box_pack_start(GTK_BOX(hbox), radioB1, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">ON</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox4), hbox, FALSE, FALSE, 2);
radioB2 = gtk_radio_button_new(gtk_radio_button_get_group((GtkRadioButton *) radioB1));
gtk_box_pack_start(GTK_BOX(hbox), radioB2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">OFF</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(radioB1, "Display Border");
gtk_widget_set_tooltip_text(radioB2, "Do NOT Display Border");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], radioB1);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], radioB1);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], radioB1);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], radioB1);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], radioB2);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], radioB2);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], radioB2);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], radioB2);
dbInfo[DBPNGIBC] = cb = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (cb), "Icon PDF Border");
gtk_box_pack_start(GTK_BOX(hbox3), cb, FALSE, FALSE, 2);
gtk_widget_set_tooltip_text(cb, "Set the PNG Border Colour");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], cb);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], cb);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], cb);
hbox = gtk_hbox_new(FALSE, 10);
gtk_box_pack_start(GTK_BOX(vbox5), hbox, TRUE, TRUE, 2);
hbox2 = gtk_hbutton_box_new();
gtk_box_pack_start(GTK_BOX(hbox), hbox2, TRUE, TRUE, 2);
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox2), GTK_BUTTONBOX_CENTER);
button = gtk_button_new_with_label("TEST");
gtk_box_pack_end(GTK_BOX(hbox2), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(PNGTest), GINT_TO_POINTER(NORMPNG));
gtk_widget_set_tooltip_text(button, "Display PNG With Current Settings");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
hbox2 = gtk_hbutton_box_new();
gtk_box_pack_start(GTK_BOX(hbox), hbox2, TRUE, TRUE, 2);
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox2), GTK_BUTTONBOX_CENTER);
button = gtk_button_new_with_label("TEST");
gtk_box_pack_end(GTK_BOX(hbox2), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(PNGTest), GINT_TO_POINTER(ICONPNG));
gtk_widget_set_tooltip_text(button, "Display Icon PNG With Current Settings");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
g_object_unref(SG4);
g_object_unref(SG7);
}
break;
}
return (pngBox);
}
static GtkWidget *makeInfoTab(int which, GtkSizeGroup *SG5)
{
int   i;
GtkWidget *eb2;
GtkWidget *vbox2, *hbox, *label, *entry, *sep, *combo, *sw, *dv, *vbox, *button, *hbox2; 
static GtkSizeGroup *SG1, *SG2;
if (!SG1)
{
SG1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
SG2 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
SG3 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
SG6 = gtk_size_group_new(GTK_SIZE_GROUP_VERTICAL);
}
eb2 = gtk_event_box_new();
gtk_widget_modify_bg(eb2, GTK_STATE_NORMAL, &darkblue);
switch (which)
{
case INFO_DESC:  
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(eb2), vbox2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#00FF00\">Description</span>");
gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_bg(sep,GTK_STATE_NORMAL, &green);
gtk_box_pack_start(GTK_BOX(vbox2), sep, FALSE, FALSE, 3);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
vbox = gtk_vbox_new(FALSE, 0); 
gtk_box_pack_start(GTK_BOX(hbox2), vbox, TRUE, TRUE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">DB Name: </span>"); 
dbInfo[DBDBNAME] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_size_group_add_widget(SG3, entry);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Name of the PQLX Database");
gtk_editable_set_editable(GTK_EDITABLE (entry), FALSE);
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">\t\tHostname: </span>");
dbInfo[DBHOSTNAME] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG2, label);
gtk_size_group_add_widget(SG3, entry);
gtk_size_group_add_widget(SG6, entry);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Hostname Providing this PQLX Database");
gtk_editable_set_editable(GTK_EDITABLE (entry), FALSE);
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][OFF], entry);
button = gtk_button_new_with_label("..."); 
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(serverSelect), NULL);
gtk_size_group_add_widget(SG6, button);
gtk_widget_set_tooltip_text(button, "Select PQLX DB Server");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Description: </span>");
dbInfo[DBDESC] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 100);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 45);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "PQLX Database Description");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Organization: </span>");
dbInfo[DBORG] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 45);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 45);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Organization Providing this PQLX Database");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Type: </span>");
dbInfo[DBTYPE] = combo = gtk_combo_box_new_text();
for(i=0; i<TTLDBTYPES; i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX (combo), types[i]);
}
gtk_size_group_add_widget(SG3, combo);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(combo, "Database Type: either PRODUCTION or SCRATCH");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], combo);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], combo);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Access: </span>");
dbInfo[DBACCESS] = combo = gtk_combo_box_new_text();
for(i=0; i<TTLDBACCESS; i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX (combo), accessTypes[i]);
}
gtk_size_group_add_widget(SG3, combo);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG2, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(combo, "Database Access: either PUBLIC or PRIVATE");
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], combo);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], combo);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Data Admin: </span>");
dbInfo[DBDADMIN] = entry = gtk_entry_new();
gtk_size_group_add_widget(SG3, entry);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Name of Data Administrator");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">E-Mail: </span>");
dbInfo[DBDADMINEM] = entry = gtk_entry_new();
gtk_size_group_add_widget(SG3, entry);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG2, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Data Admin E-Mail Address");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">Technical Admin: </span>");
dbInfo[DBTADMIN] = entry = gtk_entry_new();
gtk_size_group_add_widget(SG3, entry);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG1, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Name of Technical Administrator");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">E-Mail: </span>");
dbInfo[DBTADMINEM] = entry = gtk_entry_new();
gtk_size_group_add_widget(SG3, entry);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG2, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_widget_set_tooltip_text(entry, "Technical Admin E-Mail Address");
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
#if 0
vbox = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(hbox2), vbox, FALSE, FALSE, 2);
gtk_button_box_set_layout(GTK_BUTTON_BOX (vbox), GTK_BUTTONBOX_START);
button = gtk_button_new_with_label("EDIT");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONEDIT));
gtk_widget_set_tooltip_text(button, "EDIT DB Definition Parameters");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][OFF], button);
#endif
break;
case INFO_DATADIR:  
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(eb2), vbox2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#00FF00\">Data Directories </span>");
gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_bg(sep,GTK_STATE_NORMAL, &green);
gtk_box_pack_start(GTK_BOX(vbox2), sep, FALSE, FALSE, 3); 
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, TRUE, TRUE, 2);
sw = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
dataVIEW[DATADIRS] = dv = makeDataModel(DATADIRS);
g_signal_connect(dv, "cursor-changed", G_CALLBACK(dataModelSel), GINT_TO_POINTER(DATADIRS));
gtk_container_add(GTK_CONTAINER(sw), dv);
gtk_box_pack_start(GTK_BOX(hbox), sw, TRUE, TRUE, 2);
addDataCols(DATADIRS, GTK_TREE_VIEW(dv));
vbox = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 2);
gtk_button_box_set_layout(GTK_BUTTON_BOX (vbox), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(vbox), 10);
button = gtk_button_new_with_label("ADD");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(DDAction), GINT_TO_POINTER(DD_ADD));
gtk_widget_set_tooltip_text(button, "ADD a Directory for Scanning");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], button);
button = gtk_button_new_with_label("Enable");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(DDAction), GINT_TO_POINTER(DD_ENABLE));
gtk_widget_set_tooltip_text(button, "Enable a Directory for Scanning");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], button);
button = gtk_button_new_with_label("Disable");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(DDAction), GINT_TO_POINTER(DD_DISABLE));
gtk_widget_set_tooltip_text(button, "Disable a Directory from being Scanned");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], button);
button = gtk_button_new_with_label("Delete");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(DDAction), GINT_TO_POINTER(DD_DELETE));
gtk_widget_set_tooltip_text(button, "Delete a Directory from the Scan List");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
break;
case INFO_PSDCFG:
{
GtkAdjustment *spinAdj;
GtkWidget *ctr;
GtkSizeGroup *SG8, *SG9;
char  toolTip[500];
SG8 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
SG9 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(eb2), vbox2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span weight=\"bold\" foreground=\"#00FF00\">PSD Analysis Configuration</span>");
gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_bg(sep,GTK_STATE_NORMAL, &green);
gtk_box_pack_start(GTK_BOX(vbox2), sep, FALSE, FALSE, 3);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 1);
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 10);
sw = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
dataVIEW[PSDCFG] = dv = makeDataModel(PSDCFG);
g_signal_connect(dv, "cursor-changed", G_CALLBACK(getInfo), GINT_TO_POINTER(PSDCFG));
g_signal_connect(dv, "cursor-changed", G_CALLBACK(dataModelSel), GINT_TO_POINTER(PSDCFG));
g_signal_connect(dv, "cursor-changed", G_CALLBACK(dispInfo), GINT_TO_POINTER(PSDCFG));
gtk_container_add(GTK_CONTAINER(sw), dv);
gtk_box_pack_start(GTK_BOX(vbox), sw, FALSE, FALSE, 2);
addDataCols(PSDCFG, GTK_TREE_VIEW(dv));
gtk_widget_set_size_request(sw, 100, 330);
button = gtk_button_new_with_label("NEW");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(PSDAction), GINT_TO_POINTER(PSDCFG_ADD));
gtk_widget_set_tooltip_text(button, "Add a New Channel Group for PSD Analysis");
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), vbox2, FALSE, FALSE, 10);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">Channel Group: </span>");
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
psdConf[PSDCFG_CHNGRP] = label = gtk_label_new("");
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span foreground=\"white\">Overlap Percentage: </span>");
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
spinAdj = (GtkAdjustment *) gtk_adjustment_new((gdouble) 
50, 
(gdouble) 5.0, (gdouble) 95.0, (gdouble) 5.0, 
(gdouble) 5.0, (gdouble) 0.0);
psdConf[PSDCFG_OVERLAP] = ctr = gtk_spin_button_new(spinAdj, 1, 0);
gtk_size_group_add_widget(SG9, ctr);
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox2), ctr, FALSE, FALSE, 2);
strcpy(toolTip, "Define Overlap Percentage of PSD's");
gtk_widget_set_tooltip_text(ctr, toolTip);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], ctr);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], ctr);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], ctr);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], ctr);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Minimum dB: </span>");
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
psdConf[PSDCFG_MINDB] = entry = gtk_entry_new();
gtk_widget_set_size_request(entry, 75, -1);
gtk_size_group_add_widget(SG9, entry);
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox2), entry, FALSE, FALSE, 2);
strcpy(toolTip, "Define Minimum dB to Resolve");
gtk_widget_set_tooltip_text(entry, toolTip);
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Maximum dB: </span>");
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
psdConf[PSDCFG_MAXDB] = entry = gtk_entry_new();
gtk_size_group_add_widget(SG9, entry);
gtk_widget_set_size_request(entry, 75, -1);
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox2), entry, FALSE, FALSE, 2);
strcpy(toolTip, "Define Maximum dB to Resolve");
gtk_widget_set_tooltip_text(entry, toolTip);
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Window Length: </span>");
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
psdConf[PSDCFG_DURATION] = entry = gtk_entry_new();
gtk_widget_set_size_request(entry, 75, -1);
gtk_size_group_add_widget(SG9, entry);
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox2), entry, FALSE, FALSE, 2);
strcpy(toolTip, "Define PSD Window Length (in Seconds)");
gtk_widget_set_tooltip_text(entry, toolTip);
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Maximum Period: </span>");
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
psdConf[PSDCFG_MAXPER] = entry = gtk_entry_new();
gtk_widget_set_size_request(entry, 75, -1);
gtk_size_group_add_widget(SG9, entry);
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox2), entry, FALSE, FALSE, 2);
strcpy(toolTip, "Define Maximum Period to Resolve To");
gtk_widget_set_tooltip_text(entry, toolTip);
g_ptr_array_add(dispState[DBNOCONN][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBDISPLAY][DISPEDITABLE][OFF], entry);
g_ptr_array_add(dispState[DBEDIT][DISPEDITABLE][ON], entry);
g_ptr_array_add(dispState[DBCREATE][DISPEDITABLE][ON], entry);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 3);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span foreground=\"white\">Data Type: </span>");
gtk_size_group_add_widget(SG8, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
psdConf[PSDCFG_TYPE] = combo = gtk_combo_box_new_text();
for(i=0; i<PSDCFG_TTLTYPES; i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX (combo), PSDtypes[i]);
}
gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox2), combo, FALSE, FALSE, 2);
strcpy(toolTip, "Define How Gaps should be Analyzed\n"
"\tContinuous - Gaps Included\n"
"\tTriggered - Gaps Excluded");
gtk_widget_set_tooltip_text(combo, toolTip);
g_ptr_array_add(dispState[DBNOCONN][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBDISPLAY][DISPSENS][OFF], combo);
g_ptr_array_add(dispState[DBEDIT][DISPSENS][ON], combo);
g_ptr_array_add(dispState[DBCREATE][DISPSENS][ON], combo);
g_object_unref(SG8);
g_object_unref(SG9);
}
break;
case INFO_PNG:   
{
GtkWidget *pngBox;
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(eb2), vbox2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span weight=\"bold\" foreground=\"#00FF00\">PNG Plot Settings</span>");
gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_bg(sep,GTK_STATE_NORMAL, &green);
gtk_box_pack_start(GTK_BOX(vbox2), sep, FALSE, FALSE, 3);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
for (i = 0; i < TTLPNGPLOTS; i++)
{
pngPlot[i] = pngBox = makePNGConfig(i);
gtk_box_pack_start(GTK_BOX(hbox2), pngBox, FALSE, FALSE, 2);
}
}
break;
}
if (which == TTLDBINFOTABS-1)
{
g_object_unref(SG1);
g_object_unref(SG2); 
g_object_unref(SG3);
g_object_unref(SG6);
}
return (eb2);
}
static void makeTab(int which, GtkNotebook *nb)
{
int   i, j;
GtkWidget *vbox2, *hbox, *label, *entry, *sep, *frame, *eb1,
*sw, *dv, *vbox, *button, *hbox2,
*nB, *eb2, *vbox5;
GtkSizeGroup *SG5;
NBtabs[which] = eb1 = gtk_event_box_new();
gtk_widget_modify_bg(eb1, GTK_STATE_NORMAL, &darkblue);
switch (which)
{
case A_INFO:
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME (frame), GTK_SHADOW_IN);
gtk_container_add(GTK_CONTAINER(eb1), frame);
vbox5 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox5);
DBDefNB = nB = gtk_notebook_new();
g_signal_connect(nB, "switch-page", G_CALLBACK(changeTab), GINT_TO_POINTER(NB_DEF));
gtk_box_pack_start(GTK_BOX(vbox5), nB, FALSE, FALSE, 0);
SG5 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
for (i=0; i < TTLDBINFOTABS; i++)
{
DBDefTabs[i] = eb2 = makeInfoTab(i, SG5);
gtk_notebook_append_page(GTK_NOTEBOOK(nB), eb2, gtk_label_new(info_tabs[i]));
}
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox5), hbox2, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_bg(sep,GTK_STATE_NORMAL, &green);
gtk_box_pack_start(GTK_BOX(vbox5), sep, FALSE, FALSE, 3);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_box_pack_start(GTK_BOX(vbox5), hbox2, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 10);
gtk_box_pack_start(GTK_BOX(hbox2), hbox, TRUE, TRUE, 2);
button = gtk_button_new_with_label("EDIT");
gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONEDIT));
gtk_widget_set_tooltip_text(button, "EDIT DB Definition Parameters");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
button = gtk_button_new_with_label("SAVE");
gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONSAVE));
gtk_widget_set_tooltip_text(button, "SAVE All Modified DB Information");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
buttons[BUTCOPYDB] = button = gtk_button_new_with_label("COPY"); 
gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONCOPY));
gtk_widget_set_tooltip_text(button, "Copy DB Info From a PQLX Database");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
button = gtk_button_new_with_label("PASSWORD");
gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(setPassword), NULL);
gtk_widget_set_tooltip_text(button, "Set the Password");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][OFF], button);
hbox = gtk_hbox_new(FALSE, 10);
gtk_box_pack_start(GTK_BOX(hbox2), hbox, TRUE, TRUE, 2);
dbDelete = button = gtk_button_new_with_label("DELETE"); 
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONDELETE));
gtk_widget_set_tooltip_text(button, "DELETE this PQLX Database");
gtk_size_group_add_widget(SG5, button);
button = gtk_button_new_with_label("CANCEL");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONCANCEL));
gtk_widget_set_tooltip_text(button, "Cancel");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][ON], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
button = gtk_button_new_with_label("Next>>");
gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 1);
g_signal_connect(button, "clicked", G_CALLBACK(dbAction), GINT_TO_POINTER(DBACTIONNEXT));
gtk_widget_set_tooltip_text(button, "Cancel");
gtk_size_group_add_widget(SG5, button);
g_ptr_array_add(dispState[DBNOCONN][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBDISPLAY][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBEDIT][DISPVISIBLE][OFF], button);
g_ptr_array_add(dispState[DBCREATE][DISPVISIBLE][ON], button);
g_object_unref(SG5);
break;
case A_CHAN:
{
GtkTreeSelection *select;
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME (frame), GTK_SHADOW_IN);
gtk_container_add(GTK_CONTAINER(eb1), frame);
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#00FF00\">Channel Statistics</span>");
gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_bg(sep,GTK_STATE_NORMAL, &green);
gtk_box_pack_start(GTK_BOX(vbox2), sep, FALSE, FALSE, 3); 
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 0, 5);
gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">Search: </span>");
search = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Search on Channel List - Wildcards Allowed\n"
"(Search Automatically Surrounded With *)");
g_signal_connect(entry, "key-release-event", G_CALLBACK(chanSearch), NULL);
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 30, 0);
gtk_box_pack_start(GTK_BOX(hbox), hbox2, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">Total\nChannels:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
chnStats[CHN_TTL] = label = gtk_label_new("");
gtk_widget_set_size_request(label, 35, 0);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">2999</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 30, 0);
gtk_box_pack_start(GTK_BOX(hbox), hbox2, FALSE, FALSE, 2);
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">Start Date</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 2);
chnStats[CHN_STARTD] = label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">2010-11-20</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(TRUE, 15);
gtk_widget_set_size_request(hbox2, 30, 0);
gtk_box_pack_start(GTK_BOX(hbox), hbox2, FALSE, FALSE, 2);
vbox = gtk_vbox_new(TRUE, 0);
gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 2);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">End Date</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 2);
chnStats[CHN_ENDD] = label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">2010-11-20</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, TRUE, TRUE, 2);
sw = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
dataVIEW[CHANNELS] = dv = makeDataModel(CHANNELS);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(dataVIEW[CHANNELS]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(dv, "row-activated", G_CALLBACK(spsPopup), NULL);
gtk_container_add(GTK_CONTAINER(sw), dv);
gtk_box_pack_start(GTK_BOX(hbox), sw, TRUE, TRUE, 2);
addDataCols(CHANNELS, GTK_TREE_VIEW(dv));
}
break;
case A_LOGS:
{
GtkWidget *vbox, *vbox1, *label, *vpane, *labelBox;
char  *labelS;
vpane = gtk_vpaned_new();
gtk_container_add(GTK_CONTAINER(eb1), vpane);
vbox1 = gtk_vbox_new(TRUE, 0);
gtk_paned_pack1(GTK_PANED(vpane), vbox1, TRUE, TRUE);
vbox = gtk_vbox_new(FALSE, 0);
labelBox = gtk_event_box_new();
gtk_widget_modify_bg(labelBox, GTK_STATE_NORMAL, &darkblue);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">Server Executions</span>");
sw = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
dataVIEW[LOGEXEC] = dv = makeDataModel(LOGEXEC);
g_signal_connect(dv, "row-activated", G_CALLBACK(logSelect), NULL);
g_signal_connect(dv, "cursor-changed", G_CALLBACK(logDisplay), NULL);
gtk_container_add(GTK_CONTAINER(sw), dv);
gtk_container_add(GTK_CONTAINER(labelBox), label);
gtk_box_pack_start(GTK_BOX(vbox), labelBox, FALSE, FALSE, 1);
gtk_box_pack_end(GTK_BOX(vbox), sw, TRUE, TRUE, 1);
gtk_container_add(GTK_CONTAINER(vbox1), vbox);
addDataCols(LOGEXEC, GTK_TREE_VIEW(dv));
vbox1 = gtk_vbox_new(FALSE, 0);
evtQdisp = vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox1), vbox, FALSE, FALSE, 1);
labelBox = gtk_event_box_new();
gtk_widget_modify_bg(labelBox, GTK_STATE_NORMAL, &darkblue);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">Event Q</span>");
gtk_container_add(GTK_CONTAINER(labelBox), label);
gtk_box_pack_start(GTK_BOX(vbox), labelBox, FALSE, FALSE, 1);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 1);
for (i=EQEXEC, j=0 ; i<= EQPEND; i++, j++) 
{
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
labelS = g_strdup_printf("<span weight=\"bold\" foreground=\"white\"> %s </span>", eventQS[j]);
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) labelS);  free(labelS);
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
vbox = gtk_vbox_new(TRUE, 0);
dataVIEW[EQEXEC] = dv = makeDataModel(i);
addDataCols(i, GTK_TREE_VIEW(dv));
gtk_box_pack_start(GTK_BOX(vbox), dv, TRUE, TRUE, 3);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(hbox), frame, TRUE, TRUE, 5);
}
vbox = gtk_vbox_new(FALSE, 0);
labelBox = gtk_event_box_new();
gtk_widget_modify_bg(labelBox, GTK_STATE_NORMAL, &darkblue);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">LOG</span>");
gtk_container_add(GTK_CONTAINER(labelBox), label);
gtk_box_pack_start(GTK_BOX(vbox), labelBox, FALSE, FALSE, 1);
sw = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
dataVIEW[LOGMSGS] = dv = makeDataModel(LOGMSGS);
gtk_container_add(GTK_CONTAINER(sw), dv);
gtk_box_pack_end(GTK_BOX(vbox), sw, TRUE, TRUE, 1);
gtk_box_pack_start(GTK_BOX(vbox1), vbox, TRUE, TRUE, 1);
gtk_paned_pack2(GTK_PANED(vpane), vbox1, TRUE, TRUE);
gtk_paned_set_position((GtkPaned *) vpane, 120);
addDataCols(LOGMSGS, GTK_TREE_VIEW(dv));
}
break;
}
gtk_notebook_append_page(nb, eb1, gtk_label_new(admin_tabs[which]));
}
void make_adminScreens()
{
int  i, j, k;
char *version;
GtkWidget *vbox, *hbox;
GtkWidget *NB, *dataBox, *SB;
for (i=0;i<TTLDBDISPSTATES;i++)
for (j=0;j<TTLDISPTYPES;j++)
for (k=0;k<TTLDISPDIRS;k++)
dispState[i][j][k] = g_ptr_array_new();
topWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
version = g_strdup_printf("PQLX DB Admin - version %s", PQL_VERSION);
gtk_window_set_title(GTK_WINDOW(topWindow), version);  free(version);
gtk_window_set_position(GTK_WINDOW(topWindow), GTK_WIN_POS_CENTER);
gtk_widget_set_events(topWindow, gtk_widget_get_events (topWindow) 
| GDK_KEY_PRESS_MASK);
gtk_container_set_border_width(GTK_CONTAINER(topWindow), 2);
g_signal_connect(topWindow, "destroy", G_CALLBACK(gtk_main_quit), NULL);
dataBox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(topWindow), dataBox);
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(dataBox), vbox, FALSE, FALSE, 0);
for (i=0;i<TTLADMINTABS;i++)
{
sideBar[i] = SB = makeSideBar(i);
gtk_box_pack_start(GTK_BOX(hbox), SB, FALSE, FALSE, 0);
}
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(dataBox), vbox, TRUE, TRUE, 0);
NB = gtk_notebook_new();
gtk_box_pack_start(GTK_BOX(vbox), NB, TRUE, TRUE, 0);
for (i=0;i<TTLADMINTABS;i++)
makeTab(i, (GtkNotebook *) NB);
g_signal_connect(NB, "switch-page", G_CALLBACK(changeTab), GINT_TO_POINTER(NB_MAIN));
return;
}
