#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>
#include "admin_pqlx.h"
#include "admin_externs.h"
static struct {
GtkWidget *dialog;
GtkWidget *dates[TTLDATES];
} rePSDd;
static void getDate(GtkButton *button, gpointer w)
{
static GtkWidget *dialog[TTLDATES], *calendar[TTLDATES];
GtkWidget *text;
char  *titleStr=NULL;
int   which = GPOINTER_TO_INT(w);
text = rePSDd.dates[which];
switch(which)
{
case STARTDT:
titleStr = "Start Date";
break;
case ENDDT:
titleStr = "END Date";
break;
}
if (!dialog[which])
{
dialog[which] = gtk_dialog_new_with_buttons(titleStr,
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
calendar[which] = gtk_calendar_new();
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog[which])->vbox), calendar[which]);
gtk_widget_show_all(dialog[which]);
}
else
{
gtk_widget_show(dialog[which]);
}
if (gtk_dialog_run(GTK_DIALOG(dialog[which])) == GTK_RESPONSE_OK)
{
guint year, month, day;
char *dateStr;
gtk_calendar_get_date(GTK_CALENDAR(calendar[which]), &year, &month, &day);
dateStr = g_strdup_printf("%i/%02d/%02d", year, month+1, day);
gtk_entry_set_text(GTK_ENTRY(text), dateStr);
free(dateStr);
}
gtk_widget_hide(dialog[which]);
gtk_window_present(GTK_WINDOW(rePSDd.dialog));
}
static gboolean getREPSDdates(REPSD *rePSD)
{
gboolean ret = TRUE;
int  i;
if (!rePSDd.dialog)
{
char  *titleStr = "re-PSD Date Range Select";
GtkTooltips *tips = gtk_tooltips_new();
char  toolTip[1000];
GtkSizeGroup *size_group;
GtkWidget *dialog = gtk_dialog_new_with_buttons(titleStr,
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
GtkWidget *content_area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
GtkWidget *hbox, *button, *entry, *content, *label;
content = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Begin Date: ");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
rePSDd.dates[STARTDT] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 11);
button = gtk_button_new_with_label("...");
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(content), hbox);
strcpy(toolTip, "Specify the Beginning Date\n\tformat: YYYY/MM/DD");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
strcpy(toolTip, "Begin Date Selection using Calendar");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(getDate), GINT_TO_POINTER(STARTDT));
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End Date: ");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
rePSDd.dates[ENDDT] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 11);
button = gtk_button_new_with_label("...");
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(content), hbox);
strcpy(toolTip, "Specify the End Date\n\tformat: YYYY/MM/DD");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
strcpy(toolTip, "End Date Selection using Calendar");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(getDate), GINT_TO_POINTER(ENDDT));
gtk_container_add(GTK_CONTAINER(content_area), content);
gtk_widget_show_all(dialog);
gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
g_object_unref(size_group);
rePSDd.dialog = dialog;
}
for (i = 0; i<TTLDATES; i++)
{
gtk_entry_set_text(GTK_ENTRY(rePSDd.dates[i]), "");
}
switch (gtk_dialog_run(GTK_DIALOG(rePSDd.dialog)))
{
case GTK_RESPONSE_OK:
for (i=0; i<TTLDATES; i++)
{
char *dateStr = (char *) gtk_entry_get_text(GTK_ENTRY(rePSDd.dates[i]));
if (strlen(dateStr))
{
GDateDay day;
GDateMonth month;
GDateYear year;
int  yr, mn, dy;
gboolean invalid;
sscanf(dateStr, "%d/%d/%d", &yr, &mn, &dy);
year = yr; month = mn; day = dy;
invalid = chkDateFormat(year, month, day);
if (!invalid)
{
rePSD->dtBounds[i] = g_date_new_dmy(day, month, year);
}
else
{
dispMsgDialog("Date NOT Valid, Request Cancelled");
ret = FALSE;
break;
}
}
else
{
ret = FALSE;
break;
}
}
break;
case GTK_RESPONSE_CANCEL:
ret = FALSE;
break;
}
gtk_widget_hide(rePSDd.dialog);
return (ret);
}
void freeList(GSList *list)
{
GSList *iter;
for (iter = list;
iter;
iter = g_slist_next(iter))
{
free(iter->data);
}
g_slist_free(list);
}
static gint findWWW(PNGWWW *pngWWW, int *type)
{
return (*type - pngWWW->type);
}
void changeTab(GtkNotebook *notebook, GtkWidget *page, guint new_page, gpointer n)
{ 
int  nb = GPOINTER_TO_INT(n);
switch (nb)
{
case NB_MAIN:
if (new_page != admin.tab.main)
{
gtk_widget_hide(sideBar[admin.tab.main]);
gtk_widget_show(sideBar[new_page]);
admin.tab.main = new_page;
}
break;
case NB_DEF:
admin.tab.sub = new_page;
break;
}
switch (admin.tab.main)
{
case A_INFO:  
if (admin.tab.sub == INFO_DESC &&
admin.state == DBEDIT)
gtk_widget_show(dbDelete);
else
gtk_widget_hide(dbDelete);
break;
}
}
void adminQuit(GtkButton *button, gpointer nil)
{
if (pqlxStates.conn.state == SRVRCONNECTED)
{
disconnectDB();
}
gtk_main_quit();  
}
static GtkWidget *msgDialog;
void dispMsgWait(int type)
{
GtkWidget *content, *label;
char *msg;
switch (type)
{
case DBACTIONSRVRPAUSE:
msg = g_strdup("\n\tRequesting Server to PAUSE Execution\t\n\n\tPlease Wait...\t\n");
break;
case DBACTIONSRVRRESUME:
msg = g_strdup("\n\tRequesting Server to RESUME Execution\t\n\n\tPlease Wait...\t\n");
break;
case DBACTIONREPSD:
msg = g_strdup("\n\tProcessing PSD Deletions\t\n\n\tPlease Wait...\t\n");
break;
}
msgDialog = gtk_dialog_new();
content = gtk_dialog_get_content_area(GTK_DIALOG(msgDialog));
label = gtk_label_new(msg);
gtk_container_add(GTK_CONTAINER(content), label);
gtk_widget_show_all(msgDialog);
free(msg);
}
void dispMsgDialog(char *msg)
{
GtkWidget *dispWidget;
dispWidget = gtk_message_dialog_new(NULL, GTK_DIALOG_DESTROY_WITH_PARENT, 
GTK_MESSAGE_INFO, GTK_BUTTONS_OK, 
"%s", msg);
gtk_window_set_position(GTK_WINDOW(dispWidget), GTK_WIN_POS_CENTER_ON_PARENT);
gtk_dialog_run(GTK_DIALOG(dispWidget));
gtk_widget_destroy(dispWidget);
}
gboolean dispQ(char *msg)
{
GtkWidget *dispWidget;
gint  resp;
dispWidget = gtk_message_dialog_new(NULL, GTK_DIALOG_DESTROY_WITH_PARENT, 
GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, 
"%s", msg);
gtk_window_set_position(GTK_WINDOW(dispWidget), GTK_WIN_POS_CENTER_ON_PARENT);
resp = gtk_dialog_run(GTK_DIALOG(dispWidget));
gtk_widget_destroy(dispWidget);
return (resp == GTK_RESPONSE_YES ? TRUE : FALSE);
}
gboolean dispDBInfo(gpointer a)
{ 
int  i, action = GPOINTER_TO_INT(a);
GSList *www;
GdkColor color;
switch(action)
{
case SRVRDETSET:
{
int  type;
char str[100];
PNGWWW *pdfWWW;
setDispState(DBDISPLAY);
for(i=1;i<TTLADMINTABS;i++)
{
gtk_widget_show(NBtabs[i]);
}
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBHOSTNAME]), 
(admin.dbInfo.dbListing.hostName ? admin.dbInfo.dbListing.hostName : ""));
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDBNAME]), 
(admin.dbInfo.dbListing.dbName ? admin.dbInfo.dbListing.dbName : ""));
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDESC]), 
(admin.dbInfo.dbListing.description ? admin.dbInfo.dbListing.description : ""));
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBORG]), 
(admin.dbInfo.dbListing.organisation ? admin.dbInfo.dbListing.organisation : ""));
gtk_combo_box_set_active(GTK_COMBO_BOX(dbInfo[DBTYPE]), admin.dbInfo.dbListing.typeI);
gtk_combo_box_set_active(GTK_COMBO_BOX(dbInfo[DBACCESS]), admin.dbInfo.dbListing.accessI);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDADMIN]), 
(admin.dbInfo.dbListing.dataAdminName ? admin.dbInfo.dbListing.dataAdminName : ""));
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDADMINEM]), 
(admin.dbInfo.dbListing.dataAdminEmail ? admin.dbInfo.dbListing.dataAdminEmail : ""));
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBTADMIN]), 
(admin.dbInfo.dbListing.techAdminName ? admin.dbInfo.dbListing.techAdminName : ""));
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBTADMINEM]), 
(admin.dbInfo.dbListing.techAdminEmail ? admin.dbInfo.dbListing.techAdminEmail : ""));
add_Data(DATADIRS, NONE);
add_Data(PSDCFG, NONE);
type = SYSPDFPNG;
www = g_slist_find_custom(admin.dbInfo.pngWWW, &type, (GCompareFunc) findWWW);
if (www)
{
pdfWWW = www->data;
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGDIR]), (pdfWWW->dir ? pdfWWW->dir : "NONE"));
gtk_combo_box_set_active(GTK_COMBO_BOX(dbInfo[DBPNGDF]), pdfWWW->dateFmt);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(dbInfo[DBPNGHLNM]), pdfWWW->HLNM);
sprintf(str, "%d", pdfWWW->width);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGNW]), str);
sprintf(str, "%d", pdfWWW->height);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGNH]), str);
memset(&color, 0, sizeof(GdkColor));
color.red = pdfWWW->r*256;
color.green = pdfWWW->g*256;
color.blue = pdfWWW->b*256;
gtk_color_button_set_color(GTK_COLOR_BUTTON (dbInfo[DBPNGNBC]), &color);
for (i=0;i<TTLPDFSTATS;i++)
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stats[i]), pdfWWW->stats[i]);
sprintf(str, "%d", pdfWWW->Iwidth);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGIW]), str);
sprintf(str, "%d", pdfWWW->Iheight);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGIH]), str);
memset(&color, 0, sizeof(GdkColor));
color.red = pdfWWW->Ir*256;
color.green = pdfWWW->Ig*256;
color.blue = pdfWWW->Ib*256;
gtk_color_button_set_color(GTK_COLOR_BUTTON (dbInfo[DBPNGIBC]), &color);
}
add_Data(CHANNELS, NONE);
add_Data(LOGEXEC, NONE);
gtk_widget_grab_focus(GTK_WIDGET(dbInfo[DBDBNAME]));
}
break;
case SRVRDETGET:
{
int   type;
const gchar *str;
PNGWWW  *pngWWW;
admin.dbInfo.dbListing.hostName = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBHOSTNAME])));
admin.dbInfo.dbListing.dbName = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBDBNAME])));
admin.dbInfo.dbListing.description = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBDESC])));
admin.dbInfo.dbListing.organisation = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBORG])));
admin.dbInfo.dbListing.typeI = gtk_combo_box_get_active(GTK_COMBO_BOX(dbInfo[DBTYPE]));
admin.dbInfo.dbListing.accessI = gtk_combo_box_get_active(GTK_COMBO_BOX(dbInfo[DBACCESS]));
admin.dbInfo.dbListing.dataAdminName = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBDADMIN])));
admin.dbInfo.dbListing.dataAdminEmail = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBDADMINEM]))); 
admin.dbInfo.dbListing.techAdminName = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBTADMIN])));
admin.dbInfo.dbListing.techAdminEmail = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBTADMINEM]))); 
getInfo(NULL, GINT_TO_POINTER(PSDCFG));
freeList(admin.dbInfo.psdConfs);
admin.dbInfo.psdConfs = admin.states.edit.psdConf.list;
admin.states.edit.psdConf.list = NULL;
type = SYSPDFPNG;
www = g_slist_find_custom(admin.dbInfo.pngWWW, &type, (GCompareFunc) findWWW);
if (www)
{
pngWWW = www->data;
if (strcmp(pngWWW->dir, gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGDIR]))))
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = EVENT_PUT_SYSPDF;
sqldi.args.dataEvent = EVENTQ;
db_request(&sqldi);
dispMsgDialog("PNG Output Directory has changed.\n""To Re-Generate System PDF PNG's, go to Exec/Logs Tab and Execute the Server\n");
}
IFFREE(pngWWW->dir);
}
else
{ 
pngWWW = calloc(1, sizeof(PNGWWW));
pngWWW->type = type;
admin.dbInfo.pngWWW = g_slist_prepend(admin.dbInfo.pngWWW, pngWWW);
}
pngWWW->dir = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGDIR]))); 
pngWWW->dateFmt = gtk_combo_box_get_active(GTK_COMBO_BOX(dbInfo[DBPNGDF]));
pngWWW->HLNM = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dbInfo[DBPNGHLNM]));
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGNW]));
pngWWW->width = atoi(str);
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGNH]));
pngWWW->height = atoi(str);
pngWWW->border = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dbInfo[DBPNGNB]));
memset(&color, 0, sizeof(GdkColor));
gtk_color_button_get_color(GTK_COLOR_BUTTON (dbInfo[DBPNGNBC]), &color);
pngWWW->r = color.red / 256;
pngWWW->g = color.green / 256;
pngWWW->b = color.blue / 256;
for (i=0;i<TTLPDFSTATS;i++)
pngWWW->stats[i] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(stats[i]));
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGIW]));
pngWWW->Iwidth = atoi(str);
str = gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGIH]));
pngWWW->Iheight = atoi(str);
pngWWW->Iborder = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dbInfo[DBPNGIB]));
memset(&color, 0, sizeof(GdkColor));
gtk_color_button_get_color(GTK_COLOR_BUTTON (dbInfo[DBPNGIBC]), &color);
pngWWW->Ir = color.red / 256;
pngWWW->Ig = color.green / 256;
pngWWW->Ib = color.blue / 256;
type = SYSSPECPNG;
www = g_slist_find_custom(admin.dbInfo.pngWWW, &type, (GCompareFunc) findWWW);
if (www)
{
pngWWW = www->data;
#if 0
if (strcmp(pngWWW->dir, gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGDIR]))))
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = EVENT_PUT_SYSPDF;
sqldi.args.dataEvent = EVENTQ;
db_request(&sqldi);
dispMsgDialog("PNG Output Directory has changed.\n""To Re-Generate System PDF PNG's, go to Exec/Logs Tab and Execute the Server\n");
}
#endif
IFFREE(pngWWW->dir);
pngWWW->dir = g_strdup(gtk_entry_get_text(GTK_ENTRY(dbInfo[DBPNGDIR])));
}
}
break;
case SRVRDETCLEAR:
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBHOSTNAME]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDBNAME]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDESC]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBORG]), "");
gtk_combo_box_set_active(GTK_COMBO_BOX(dbInfo[DBTYPE]), -1);
gtk_combo_box_set_active(GTK_COMBO_BOX(dbInfo[DBACCESS]), -1);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDADMIN]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBDADMINEM]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBTADMIN]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBTADMINEM]), "");
clearStore(DATADIRS);
clearStore(PSDCFG);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGDIR]), "");
gtk_combo_box_set_active(GTK_COMBO_BOX(dbInfo[DBPNGDF]), -1);
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGNW]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGNH]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGIW]), "");
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGIH]), "");
memset(&color, 0, sizeof(GdkColor));
color.red = 0;
color.green = 0;
color.blue = 0;
gtk_color_button_set_color(GTK_COLOR_BUTTON (dbInfo[DBPNGNBC]), &color);
gtk_color_button_set_color(GTK_COLOR_BUTTON (dbInfo[DBPNGIBC]), &color);
for (i=0;i<TTLPDFSTATS;i++)
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stats[i]), FALSE);
gtk_widget_grab_focus(GTK_WIDGET(dbInfo[DBDBNAME]));
break;
}
return FALSE;
}
void setSrvrExecState(int srvrNum)
{
int srvrState;
SRVRLOG *srvrLog = g_slist_nth_data(admin.dbInfo.srvrExec.data.execs, 0);
switch (srvrNum)
{
case 0:
{
LOGMSG *logMsg = srvrLog->data.msgs[MSGTYPE_LOG]
? g_slist_last(srvrLog->data.msgs[MSGTYPE_LOG])->data
: NULL;
char *lastMsg = logMsg
? logMsg->data.msg
: NULL;
if (!lastMsg)
break;
if (!strcmp(lastMsg, PQLXPAUSEMSG))
srvrState = SRVREXEC_PAUSE;
else
{
if (srvrLog->data.complete)
srvrState = SRVREXEC_DONE;
else
srvrState = SRVREXEC_EXEC;
}
}
break;
default: 
srvrState = SRVREXEC_DONE;
break;
}
switch (srvrState)
{
case SRVREXEC_DONE:
gtk_widget_hide(buttons[BUTRESUMEEXEC]);
gtk_widget_hide(buttons[BUTPAUSEEXEC]);
gtk_widget_show(buttons[BUTEXECEXEC]);
gtk_widget_show(buttons[BUTEXECCFG]);
break;
case SRVREXEC_EXEC:
if (msgDialog)
{
gtk_widget_destroy(msgDialog);
msgDialog = NULL;
}
gtk_widget_hide(buttons[BUTRESUMEEXEC]);
gtk_widget_show(buttons[BUTPAUSEEXEC]);
gtk_widget_hide(buttons[BUTEXECEXEC]);
gtk_widget_hide(buttons[BUTEXECCFG]);
break;
case SRVREXEC_PAUSE:
if (msgDialog)
{
gtk_widget_destroy(msgDialog);
msgDialog = NULL;
}
gtk_widget_show(buttons[BUTRESUMEEXEC]);
gtk_widget_hide(buttons[BUTPAUSEEXEC]);
gtk_widget_hide(buttons[BUTEXECEXEC]);
gtk_widget_hide(buttons[BUTEXECCFG]);
break;
}
switch (srvrNum)
{
case 0:
gtk_widget_set_sensitive(buttons[BUTRESUMEEXEC], TRUE);
gtk_widget_set_sensitive(buttons[BUTPAUSEEXEC], TRUE);
break;
default: 
gtk_widget_set_sensitive(buttons[BUTRESUMEEXEC], FALSE);
gtk_widget_set_sensitive(buttons[BUTPAUSEEXEC], FALSE);
break;
}
}
static gboolean rePSDReturn(SQLDI *sqldi)
{
gtk_widget_destroy(msgDialog); msgDialog = NULL;
free(sqldi);
return FALSE;
}
void dbAction(GtkButton *button, gpointer a)
{
int action = GPOINTER_TO_INT(a), ret;
int nextState = NONE;
switch (action)
{
case DBACTIONNEW:  
switch(admin.state)
{
case DBNOCONN:
break;
default:
disconnectDB();
break;
}
nextState = DBCREATE;
break;
case DBACTIONSRVRPAUSE:
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = EVENTQ;
sqldi.descr.tableData = EVENT_PAUSE;
db_request(&sqldi);
dispMsgWait(action);
}
break;
case DBACTIONSRVRRESUME:
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = EVENTQ;
sqldi.descr.tableData = EVENT_RESUME;
db_request(&sqldi);
dispMsgWait(action);
}
break;
case DBACTIONCOPY:  
{
SQLDI sqldi;
DBDEF dbInfo;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&dbInfo, 0, sizeof(DBDEF));
}
break;
case DBACTIONCREATE: 
{
SQLDI sqldi;
LOGIN login;
dispDBInfo(GINT_TO_POINTER(SRVRDETGET));
memset(&sqldi, 0, sizeof(SQLDI));
memset(&login, 0, sizeof(LOGIN));
strcpy(login.keys.hostname, admin.dbInfo.dbListing.hostName);
strcpy(login.keys.dbname, "PQLXMETA");
strcpy(login.keys.username, PQLXADMIN);
strcpy(login.keys.password, PQLXADMINPW);
sqldi.data = &login;
sqldi.args.dataEvent = CONNECT;
ret = db_request(&sqldi);
switch (ret)
{
case PQLXSUCCESS:
pqlxStates.conn.state = SRVRCONNECTED;
break;
default:
dispMsgDialog("Cannot connect to DB PQLXMETA!\n""Unable to make PQLX DB.\n""Please see error file for details\n");
break;
}
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.data = &admin.dbInfo;
sqldi.descr.tableData = ADMIN_DBCREATE;
sqldi.args.dataEvent = DBADMIN;
ret = db_request(&sqldi);
switch (ret)
{
case PQLXSUCCESS:
connectDB(admin.dbInfo.dbListing.hostName, admin.dbInfo.dbListing.dbName);
nextState = DBDISPLAY;
dispMsgDialog("PQLX DB Creation Successful\n"
"To Execute the Server, Use the EXECUTE Button on the 'Exec/Logs' Tab\n");
break;
default:
dispMsgDialog("PQLX DB Creation Failed!\nPlease see error file for details\n"
"(Located in $PQLXLOG)\n");
break;
}
}
break;
case DBACTIONDELETE: 
{
SQLDI sqldi;
DBLST dbListing;
char *msg, *srvrNm, *dbNm;
msg = g_strdup_printf("Do you wish to Delete PQLX Database %s?\n""Deleting will Remove ALL DB Information,\n"
"\tincluding ALL PSD's!", admin.dbInfo.dbListing.dbName);
if (!dispQ(msg))
{
free(msg);
break;
}
free(msg);
srvrNm = g_strdup(admin.dbInfo.dbListing.hostName);
dbNm = g_strdup(admin.dbInfo.dbListing.dbName);
disconnectDB();
memset(&sqldi, 0, sizeof(SQLDI));
memset(&dbListing, 0, sizeof(DBLST));
dbListing.hostName = srvrNm;
dbListing.dbName = dbNm;
sqldi.data = &dbListing;
sqldi.descr.tableData = ADMIN_DBDEL;
sqldi.args.dataEvent = DBADMIN;
db_request(&sqldi);
refreshSrvr(srvrNm);
free(srvrNm); free(dbNm);
nextState = DBNOCONN;
}
break;
case DBACTIONSAVE:  
{
SQLDI sqldi;
dispDBInfo(GINT_TO_POINTER(SRVRDETGET));
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.data = &admin.dbInfo;
sqldi.descr.tableData = ADMIN_DBSAVE;
sqldi.args.dataEvent = DBADMIN;
ret = db_request(&sqldi);
switch (ret)
{
case PQLXSUCCESS:
connectDB(admin.dbInfo.dbListing.hostName, admin.dbInfo.dbListing.dbName);
nextState = DBDISPLAY;
break;
default:
dispMsgDialog("PQLX DB Update Failed!\nPlease see error file for details\n");
break;
}
nextState = DBDISPLAY;
}
break;
case DBACTIONCANCEL: 
switch (admin.state)
{ 
case DBEDIT:
freeList(admin.states.edit.psdConf.list);
admin.states.edit.psdConf.list = NULL;
break;
}
nextState = (admin.state == DBEDIT) ? DBDISPLAY : DBNOCONN;
switch (nextState)
{
case DBNOCONN:
disconnectDB();
break;
case DBDISPLAY:
dispDBInfo(GINT_TO_POINTER(SRVRDETSET));
break;
}
break;
case DBACTIONEDIT:  
{
GSList *iter;
PSDCONF *psdCfg;
nextState = DBEDIT;
if (admin.states.edit.psdConf.list)
freeList(admin.states.edit.psdConf.list);
admin.states.edit.psdConf.list = g_slist_copy(admin.dbInfo.psdConfs);
for (iter = admin.states.edit.psdConf.list;
iter;
iter = g_slist_next(iter))
{
psdCfg = calloc(1, sizeof(PSDCONF));
memcpy(psdCfg, iter->data, sizeof(PSDCONF));
iter->data = psdCfg;
}
}
break;
case DBACTIONPREV:
{
int cur = gtk_notebook_get_current_page(GTK_NOTEBOOK(DBDefNB));
if (cur>0)
gtk_notebook_set_current_page(GTK_NOTEBOOK(DBDefNB),cur-1);
}
break;
case DBACTIONNEXT:
{
int cur = gtk_notebook_get_current_page(GTK_NOTEBOOK(DBDefNB));
int next = (cur == INFO_DATADIR) ? cur + 2 : cur + 1; 
gtk_widget_hide(buttons[BUTCOPYDB]);
if (next < TTLDBINFOTABS)
{ 
gtk_widget_show(DBDefTabs[next]);
gtk_notebook_set_current_page(GTK_NOTEBOOK(DBDefNB),next);
}
else
{ 
setPassword();
}
}
break;
case DBACTIONLOGREF:
{
SQLDI sqldi;
SRVREXEC *srvrExec = &admin.dbInfo.srvrExec;
pollQuit();
freeExecInfo(srvrExec);
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.data = srvrExec;
sqldi.args.dataEvent = DBADMIN;
sqldi.descr.tableData = LOGEXECTBL;
db_request(&sqldi);
if (srvrExec->data.execs)
{ 
add_Data(LOGEXEC, NONE);
scrollTV(LOGEXEC, 0);
}
}
break;
case DBACTIONREPSD:
{
SQLDI *sqldi;
static REPSD rePSD;
CHNSTATS *chnData;
GList *iter, *selList;
GSList *chnList = (admin.states.channels.list 
? admin.states.channels.list
: admin.dbInfo.chnInfo);
memset(&rePSD, 0, sizeof(REPSD));
selList = gtk_tree_selection_get_selected_rows(
gtk_tree_view_get_selection(GTK_TREE_VIEW(dataVIEW[CHANNELS])),
NULL);
if (!selList)
{
dispMsgDialog("No Channel(s) Selected, Request Cancelled");
break;
}
for (iter = selList;
iter;
iter = g_list_next(iter))
{
GtkTreePath *path = iter->data;
char *rowS = gtk_tree_path_to_string(path);
gtk_tree_path_free(path);
chnData = g_slist_nth_data(chnList, atoi(rowS)); free(rowS);
rePSD.channels = g_slist_prepend(rePSD.channels, chnData);
}
g_list_free(selList);
if (!getREPSDdates(&rePSD))
break;
sqldi = calloc(1, sizeof(SQLDI));
dispMsgWait(action);
sqldi->args.dataEvent = DBADMIN;
sqldi->descr.tableData = ADMIN_REPSD;
sqldi->args.sqr = admin.settings.maxCPU + 1; 
sqldi->args.callType = ASYNC;
sqldi->args.returnFunc = rePSDReturn;
sqldi->data = &rePSD;
db_request(sqldi);
}
break;
}
switch (nextState)
{
case NONE:  
break;
default:
setDispState(nextState);
break;
}
}
void DDAction(GtkButton *button, gpointer a)
{
int action = GPOINTER_TO_INT(a);
switch (action)
{
case IDFILE_ADD:
if (getDataDir(FILE_SEL_ID))
gtk_entry_set_text(GTK_ENTRY(srvrCFGIDFile), admin.settings.srvrCFG.identFile);
break;
case PNG_ADD:
if (getDataDir(FILE_SEL_PNG))
gtk_entry_set_text(GTK_ENTRY(dbInfo[DBPNGDIR]), admin.states.png.pdfWWWDir);
break;
case DD_ADD:
if (getDataDir(FILE_SEL_DD))
add_Data(DATADIRS, NONE);
break;
case DD_ENABLE:
{
DATADIR *dataDir;
if (admin.sel[DATADIRS] != NONE)
{
dataDir = g_slist_nth_data(admin.dbInfo.dataDirs, admin.sel[DATADIRS]);
if (dataDir->status)
free(dataDir->status);
dataDir->status = g_strdup(ACTIVESTR);
dataDir->statusI = ACTIVE;
dataDir->admin.cmdFlag = DU_UPD;
}
add_Data(DATADIRS, NONE);
}
break;
case DD_DISABLE:
{
DATADIR *dataDir;
if (admin.sel[DATADIRS] != NONE)
{
dataDir = g_slist_nth_data(admin.dbInfo.dataDirs, admin.sel[DATADIRS]);
if (dataDir->status)
free(dataDir->status);
dataDir->status = g_strdup(INACTIVESTR);
dataDir->statusI = INACTIVE;
dataDir->admin.cmdFlag = DU_UPD;
}
add_Data(DATADIRS, NONE);
}
break;
case DD_DELETE:
{
DATADIR *dataDir;
if (admin.sel[DATADIRS] != NONE)
{
dataDir = g_slist_nth_data(admin.dbInfo.dataDirs, admin.sel[DATADIRS]);
admin.dbInfo.dataDirs = g_slist_remove(admin.dbInfo.dataDirs, dataDir);
freeDataDirInfo(dataDir);
}
add_Data(DATADIRS, NONE);
}
break;
}
}
static char *getChnGrp()
{
static GtkWidget *chngrpD, *chnGrpNm;
char *chnGrp;
gboolean confirmed;
if (!chngrpD)
{
GtkWidget *dialog, *label, *content_area, *content, *hbox, *entry, *vbox;
GtkSizeGroup *SG1;
char  *buttonText;
SG1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
buttonText = "ADD";
chngrpD = dialog = gtk_dialog_new_with_buttons("NEW Channel Group",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
buttonText, GTK_RESPONSE_OK,
NULL);
content_area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
content = gtk_vbox_new(FALSE, 0);
vbox = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(content), vbox, FALSE, FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
label = gtk_label_new("Channel Group Name: ");
gtk_misc_set_alignment(GTK_MISC(label), 1, .5);
gtk_size_group_add_widget(SG1, label);
chnGrpNm = entry = gtk_entry_new();
gtk_widget_set_tooltip_text(entry, "Specify the New Channel Group Name - 2 Characters");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
g_object_unref(SG1);
gtk_container_add(GTK_CONTAINER(content_area), content);
gtk_widget_show_all(dialog);
}
gtk_entry_set_text(GTK_ENTRY(chnGrpNm), "");
gtk_window_resize(GTK_WINDOW(chngrpD), 1, 1);
gtk_window_set_position(GTK_WINDOW(topWindow), GTK_WIN_POS_CENTER);
do {
switch(gtk_dialog_run(GTK_DIALOG(chngrpD)))
{
case GTK_RESPONSE_OK:
{
const char *chn = gtk_entry_get_text(GTK_ENTRY(chnGrpNm));
if (strlen(chn) < 2)
{
dispMsgDialog("Channel Group Name must be 2 characters long");
confirmed = FALSE;
break;
}
chnGrp = g_strdup_printf("%c%c", chn[0], chn[1]);
confirmed = TRUE;
}
break;
case GTK_RESPONSE_CANCEL: 
chnGrp = NULL;
confirmed = TRUE;
break;
}
} while (!confirmed);
gtk_widget_hide(chngrpD);
return (chnGrp);
}
static gint findChnGrp(PSDCONF *psdCfg, PSDCONF *srch)
{
return (strcmp(psdCfg->chnGroup, srch->chnGroup));
}
void PSDAction(GtkButton *button, gpointer a)
{
int action = GPOINTER_TO_INT(a);
switch (action)
{
case PSDCFG_ADD:
{
char *chnGrp;
int  pos;
PSDCONF *psdCfg;
GSList *item;
chnGrp = getChnGrp();
if (!chnGrp)
return;  
psdCfg = calloc(1, sizeof(PSDCONF));
psdCfg->chnGroup = chnGrp;
if ((item = g_slist_find_custom(admin.states.edit.psdConf.list, psdCfg, (GCompareFunc) findChnGrp)))
{
char *msg = g_strdup_printf("Channel Group '%s' already exists, cannot create duplicate\n"
"Please Edit the Existing Channel Group", chnGrp);
dispMsgDialog(msg);
free(msg);
free(chnGrp);
free(psdCfg);
scrollTV(PSDCFG, g_slist_position(admin.states.edit.psdConf.list, item));
break;
}
psdCfg->admin.cmdFlag = DU_NEW;
admin.states.edit.psdConf.list = g_slist_insert_sorted(admin.states.edit.psdConf.list,
psdCfg, (GCompareFunc) findChnGrp);
item = g_slist_find_custom(admin.states.edit.psdConf.list, psdCfg, (GCompareFunc) findChnGrp);
pos = g_slist_position(admin.states.edit.psdConf.list, item);
add_Data(PSDCFG, 0);
scrollTV(PSDCFG, pos);
}
break;
}
}
void dataModelSel(GtkTreeView *treeview, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
char *rowS;
GtkTreePath *path;
gtk_tree_view_get_cursor(treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
gtk_tree_path_free(path);
admin.sel[which] = atoi(rowS);
g_free(rowS);
}
static void _setSensitive(GtkWidget *widget, gpointer s)
{
gboolean sens = (gboolean) GPOINTER_TO_INT(s);
gtk_widget_set_sensitive(widget, sens);
}
static void _setVisible(GtkWidget *widget, gpointer v)
{
gboolean vis = (gboolean) GPOINTER_TO_INT(v);
vis ? gtk_widget_show(widget) : gtk_widget_hide(widget);
}
static void _setEditable(GtkWidget *widget, gpointer e)
{
gboolean edit = (gboolean) GPOINTER_TO_INT(e);
gtk_editable_set_editable(GTK_EDITABLE(widget), edit);
}
void setDispState(int state)
{
int i;
admin.state = state;
switch(state)
{
case DBDISPLAY:
for(i=1;i<TTLADMINTABS;i++)
{
gtk_widget_show(NBtabs[i]);  
}
for(i=1;i<TTLDBINFOTABS;i++)
{
gtk_widget_show(DBDefTabs[i]); 
}
gtk_notebook_set_current_page(GTK_NOTEBOOK(DBDefNB),INFO_DESC);
break;
case DBCREATE:
case DBNOCONN:
{ 
for(i=1;i<TTLADMINTABS;i++)
{
gtk_widget_hide(NBtabs[i]);  
}
for(i=1;i<TTLDBINFOTABS;i++)
{
gtk_widget_hide(DBDefTabs[i]); 
}
char *titleBar;
titleBar = g_strdup_printf("PQLX DB Admin - v%s", PROG_VERSION);
gtk_window_set_title (GTK_WINDOW(topWindow), titleBar); free(titleBar);
g_idle_add((GSourceFunc) dispDBInfo, GINT_TO_POINTER(SRVRDETCLEAR));
gtk_notebook_set_current_page(GTK_NOTEBOOK(DBDefNB), INFO_DESC);
}
break;
case DBEDIT:
if (admin.tab.main == A_INFO &&
admin.tab.sub == INFO_DESC)
gtk_widget_show(dbDelete);
else
gtk_widget_hide(dbDelete);
break;
}
for (i=0;i<TTLDISPDIRS;i++)
{
g_ptr_array_foreach(dispState[state][DISPSENS][i], (GFunc) _setSensitive, GINT_TO_POINTER(i));
g_ptr_array_foreach(dispState[state][DISPVISIBLE][i], (GFunc) _setVisible, GINT_TO_POINTER(i));
g_ptr_array_foreach(dispState[state][DISPEDITABLE][i], (GFunc) _setEditable, GINT_TO_POINTER(i));
}
gtk_window_resize(GTK_WINDOW(topWindow), 1, 1);
}
void comboCBack(GtkComboBox *combo, gpointer t)
{
int type = GPOINTER_TO_INT(t);
switch (type)
{
case CBO_LOGMSGTYPE:
admin.settings.logDisplay = gtk_combo_box_get_active(combo);
add_Data(LOGMSGS, admin.states.log.srvrNum);
break;
}
}
void logDisplay(GtkTreeView *treeview, gpointer which)
{ 
char *rowS;
GtkTreePath *path;
int  rowNum;
SRVRLOG *srvrLog;
pollQuit();  
gtk_tree_view_get_cursor(treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
gtk_tree_path_free(path);
rowNum = atoi(rowS); g_free(rowS);
srvrLog = g_slist_nth_data(admin.dbInfo.srvrExec.data.execs, rowNum);
if (!srvrLog->data.msgs[MSGTYPE_LOG])
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = LOGMSGTBL;
sqldi.args.dataEvent = DBADMIN;
sqldi.data = srvrLog;
db_request(&sqldi);
}
add_Data(LOGMSGS, rowNum);
if (!rowNum &&     
!strcmp(srvrLog->data.pgmName, PQLXSRVR) &&  
!srvrLog->data.complete) 
{        
gtk_widget_show(evtQdisp);
setPolling(TTLPOLLTYPES, FALSE);
}
else
{
gtk_widget_hide(evtQdisp);
}
}
void logSelect(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer nil)
{ 
char *rowS;
int  rowNum;
SRVRLOG *srvrLog;
pollQuit();  
rowS = gtk_tree_path_to_string(arg1);
if (!rowS)
return;
rowNum = atoi(rowS);  g_free(rowS);
srvrLog = g_slist_nth_data(admin.dbInfo.srvrExec.data.execs, rowNum);
freeLogInfo(srvrLog);
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = LOGMSGTBL;
sqldi.args.dataEvent = DBADMIN;
sqldi.data = srvrLog;
db_request(&sqldi);
}
add_Data(LOGMSGS, rowNum);
if (!rowNum &&     
!srvrLog->data.complete) 
{        
gtk_widget_show(evtQdisp);
setPolling(TTLPOLLTYPES, FALSE);
}
else
{
gtk_widget_hide(evtQdisp);
}
}
static gboolean destroyWindow(GtkWidget *widget, void *nothing)
{
gtk_widget_hide(widget);
return TRUE;
}
void spsPopup(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer nil)
{ 
char *row, *formatStr;
int  rowNum;
static GtkWidget *chnName;
CHNSTATS *chnData;
GSList  *list = (admin.states.channels.list 
? admin.states.channels.list
: admin.dbInfo.chnInfo);
row = gtk_tree_path_to_string(arg1);
if (!row)
return;
rowNum = atoi(row);
g_free(row);
chnData = g_slist_nth_data(list, rowNum);
if (!spsEwin)
{
GtkWidget *vbox, *label, *hbox, *labelBox, *dv;
spsEwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(spsEwin), "SPS Epochs");
gtk_window_set_position(GTK_WINDOW(spsEwin), GTK_WIN_POS_CENTER_ON_PARENT);
g_signal_connect(spsEwin, "delete-event", G_CALLBACK(destroyWindow), NULL);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(spsEwin), vbox);
labelBox = gtk_event_box_new();
gtk_widget_set_size_request(labelBox, 0, 30);
gtk_widget_modify_bg(labelBox, GTK_STATE_NORMAL, &darkblue);
gtk_box_pack_start(GTK_BOX(vbox), labelBox, FALSE, FALSE, 1);
hbox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(labelBox), hbox);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"#FFFFFF\">Channel:\t</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
chnName = label = gtk_label_new("");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
dataVIEW[SPSEPS] = dv = makeDataModel(SPSEPS);
gtk_container_add(GTK_CONTAINER(vbox), dv);
addDataCols(SPSEPS, GTK_TREE_VIEW(dv));
gtk_widget_show_all(spsEwin);
}
else
{
gtk_window_present(GTK_WINDOW(spsEwin));
}
formatStr = g_strdup_printf("<span weight=\"bold\" foreground=\"#FFFFFF\">%s</span>",
chnData->name);
gtk_label_set_markup(GTK_LABEL(chnName), formatStr); free(formatStr);
add_Data(SPSEPS, rowNum);
}
gboolean chanSearch(GtkEntry *entry, GdkEventKey *event, gpointer nil)
{ 
GSList  *iter;
CHNSTATS *chnStats;
gchar  *tmp = g_strdup_printf("*%s*", gtk_entry_get_text(entry)), *search;
search = g_ascii_strup(tmp, -1);  free(tmp);
if (admin.states.channels.list != (GSList *) NONE)
g_slist_free(admin.states.channels.list);
admin.states.channels.list = NULL;
for(iter = admin.dbInfo.chnInfo;
iter;
iter = g_slist_next(iter))
{
chnStats = iter->data;
if (!globmatch(chnStats->name, search))
continue;
admin.states.channels.list = g_slist_append(admin.states.channels.list, chnStats);
}
if (!admin.states.channels.list)  
admin.states.channels.list = (GSList *) NONE;
free(search);
add_Data(CHANNELS, 0);
return TRUE;
}
#define WAITTIME 10
#define ONESECOND 1000000
void pgmExec(GtkButton *button, gpointer p)
{
int pgmExec = GPOINTER_TO_INT(p);
SRVREXECCFG *srvrCFG = &admin.settings.srvrCFG;
switch (pgmExec)
{
case PGMEXEC_SRVR:
{ 
gchar   **args, *binDir;
GSpawnFlags flags = 0;
int   numArgs, argNum, i;
binDir = getenv(ENVBIN);
if (!binDir)
{
fprintf(stderr, "Environment Variable %s not set, Exit 'pqlx-admin', Define and Re-execute\n",
ENVBIN);
break;
}
if (srvrCFG->refreshSysPNG)
{ 
SQLDI  sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DBADMIN;
sqldi.descr.tableData = SYSPDFREFRESH;
db_request(&sqldi);
}
numArgs = 4;
if (!srvrCFG->dirScan)
numArgs++;
if (srvrCFG->identFile)
numArgs++;
if (srvrCFG->timeRestricted.set)
numArgs +=2;
args = calloc(numArgs, sizeof(gchar *));
argNum = 0;
args[argNum++] = g_strdup_printf("%s/pqlxSrvr", binDir);
args[argNum++] = g_strdup_printf("--dbName=%s:%s", 
admin.dbInfo.dbListing.hostName, 
admin.dbInfo.dbListing.dbName);
args[argNum++] = g_strdup_printf("--numCPU=%d", srvrCFG->numCPU);
if (!srvrCFG->dirScan)
args[argNum++] = g_strdup("--noScan");
if (srvrCFG->identFile)
args[argNum++] = g_strdup_printf("--identFile=%s", srvrCFG->identFile);
if (srvrCFG->timeRestricted.set)
{
args[argNum++] = g_strdup_printf("--TRStart=%02d:%02d", 
srvrCFG->timeRestricted.bounds[TRSTARTT].time[TRHOUR],
srvrCFG->timeRestricted.bounds[TRSTARTT].time[TRMIN]);
args[argNum++] = g_strdup_printf("--TREnd=%02d:%02d", 
srvrCFG->timeRestricted.bounds[TRENDT].time[TRHOUR],
srvrCFG->timeRestricted.bounds[TRENDT].time[TRMIN]);
}
args[argNum] = NULL;
if (!g_spawn_async(NULL, args, NULL, flags, NULL, NULL, NULL, NULL))
{
fprintf(stderr, "Invocation of program 'pqlxSrvr' Failed\n");
break;
}
for (i=0;i<numArgs;i++)
IFFREE(args[i]);
free(args);
{ 
int   tries = 0;
SQLDI  sqldi;
SRVREXEC *srvrExec=&admin.dbInfo.srvrExec;
SRVRLOG  *srvrLog;
NEWEXEC  newExec;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&newExec, 0, sizeof(NEWEXEC));
if (srvrExec->data.execs)
{
srvrLog = (srvrExec->data.execs)->data;
newExec.keys.lastExec = srvrLog->keys.execKey;
}
sqldi.data = &newExec;
sqldi.args.dataEvent = DBADMIN;
sqldi.descr.tableData = LOGNEXTEXEC;
db_request(&sqldi);
while(!newExec.data.started &&
tries < (ONESECOND)/(WAITTIME))
{ 
usleep(WAITTIME);
db_request(&sqldi);
tries++;
}
if (!newExec.data.started)
{
dispMsgDialog("Server has not started, execution probably failed.\n"
"Try to execute from the command line\n");
break;
}
dbAction(NULL, GINT_TO_POINTER(DBACTIONLOGREF));
}
}
break;
case PGMEXEC_PQLX:
{ 
int   numArgs, i;
gchar   **args, *binDir;
GSpawnFlags flags = 0;
binDir = getenv(ENVBIN);
if (!binDir)
{
fprintf(stderr, "Environment Variable %s not set, Exit 'pqlx-admin', Define and Re-execute\n",
ENVBIN);
break;
}
numArgs = 4;
args = calloc(numArgs, sizeof(gchar *));
args[0] = g_strdup_printf("%s/pqlx", binDir);
args[1] = g_strdup("-d");
args[2] = g_strdup_printf("%s:%s", 
admin.dbInfo.dbListing.hostName, 
admin.dbInfo.dbListing.dbName);
args[3] = NULL;
if (!g_spawn_async(NULL, args, NULL, flags, NULL, NULL, NULL, NULL))
{
fprintf(stderr, "Invocation of program 'pqlx' Failed\n");
break;
}
for (i=0;i<numArgs;i++)
IFFREE(args[i]);
free(args);
}
break;
}
}
