#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "admin_pqlx.h"
#include "admin_externs.h"
#include "pqlx_defs.h"
#include "pqlx_pdf_head.h"
#include "util_externs.h"
void makeFONTGC(int which, GdkColor *fg, GdkColor *bg);
void initFontP();
void plotPDF(PLOTPDFARGS *);
void colorBar(GdkPixmap *pmap, int w, int h);
#include "pdfReqData.h"
static void getPDFReq(PDFREQ *pdfReq)
{
int  i;
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = PDFSTATLINES;
pdfReq->keys.yBounds[YMIN] = -200;
pdfReq->keys.yBounds[YMAX] = -50;
pdfReq->data.name = g_strdup("MN.TNV.--.BHE");
pdfReq->data.dateFmt = 1;
pdfReq->data.sTime.date.yr = 2003;
pdfReq->data.sTime.date.jday = 1;
pdfReq->data.eTime.date.yr = 2004;
pdfReq->data.eTime.date.jday = 9;
pdfReq->data.numPSDs = 17295;
pdfReq->data.numRecs = 4362;
pdfReq->data.pdf = pdfData;
pdfReq->data.stats = &pdfStats;
pdfStats.stats = pdfStats1;
for (i=0;i<TTLPDFSTATS;i++)
pdfReq->keys.statistics[i] = TRUE; 
sqldi.data = pdfReq;
db_request(&sqldi);
admin.states.png.statLines = pdfReq->data.statLines;
pdfReq->data.statLines = NULL;
}
static void initPDFFont()
{
int   i;
GdkColor *fg, *bg;
static gboolean called=FALSE;
if (called)
return;
called = TRUE;
initFontP();
for(i=PDFFMSG;i<NUMFONTGCP;i++)
{
switch(i)
{
case PDFFMSG:
fg = &darkBlue; bg = &lightGrey2;
break;
case PDFFTEXT:
case WWWFTEXT:
fg = &myBlack; bg = &myWhite;
break;
case PDFFTRC:
fg = &myBlack; bg = &lightGrey1;
break;
case PDFSTATSTEXT:
fg = &myBlack; bg = &lightGrey2;
break;
}
makeFONTGC(i, fg, bg);
}
}
static GdkPixmap *pngPMap[TTLPNGDISP];
gboolean pngDisp_cfg(GtkWidget *da, GdkEventConfigure *event, gpointer w)
{
int  which = GPOINTER_TO_INT(w); 
GdkPixmap   **pMap = &pngPMap[which];
static GdkGC  *PDFgc;
static PLOTPDFARGS plotPDFArgs;
static PDFREQ  pdfReq;
static gboolean  called = FALSE;
int  width = da->allocation.width, height = da->allocation.height;
int  plotType = admin.states.png.which == NORMPNG ? PDFPLOT : WWWPLOT;
int  dateFmt = gtk_combo_box_get_active(GTK_COMBO_BOX (dbInfo[DBPNGDF]));
if (da->allocation.height==1) 
return TRUE;     
if (!called)
{
called = TRUE;
memset(&pdfReq, 0, sizeof(PDFREQ));
PDFgc = gdk_gc_new(da->window);
gdk_gc_set_rgb_bg_color(PDFgc, &myBlack);
gdk_gc_set_rgb_fg_color(PDFgc, &myWhite);
getPDFReq(&pdfReq);
initPDFFont();
}
if (*pMap)
{
g_object_unref(*pMap);
}
*pMap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(*pMap, PDFgc, TRUE, 0, 0, width, height);
plotPDFArgs.pmap = *pMap;
plotPDFArgs.req = (gpointer) &pdfReq;
plotPDFArgs.width = width;
plotPDFArgs.height = height;
plotPDFArgs.scr = PDFMAIN;  
plotPDFArgs.type = plotType;
plotPDFArgs.fdUnits = 0;
plotPDFArgs.dateFmt = dateFmt >= 0 ? dateFmt : 0;
plotPDFArgs.hlnm = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (dbInfo[DBPNGHLNM]));
switch (which)
{
case PNGTEST:
{ 
int  i;
g_slist_free(pdfReq.data.statLines);
pdfReq.data.statLines = NULL;
if (plotType == WWWPLOT)  
break;
for (i=0;i<TTLPDFSTATS;i++)
{
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(stats[i])))
pdfReq.data.statLines = g_slist_append(pdfReq.data.statLines,
g_slist_nth_data(admin.states.png.statLines, i));
}
}
break;
case PNGSIZE: 
g_slist_free(pdfReq.data.statLines);
pdfReq.data.statLines = NULL;
break;
}
plotPDF(&plotPDFArgs);
switch (plotType)
{ 
case PDFPLOT:
{
GdkPixmap *cbpmap;
int w, h;
w = PDFSIDEM-5;
h = da->allocation.height - (PDFTOPM + PDFBOTM);
cbpmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_rectangle (cbpmap, PDFgc, TRUE, 0, 0, w, h);
colorBar(cbpmap, w, h);
gdk_draw_drawable(*pMap, da->style->fg_gc[GTK_WIDGET_STATE (da)], cbpmap, 0, 0, 
da->allocation.width-PDFSIDEM+3, PDFTOPM, -1, -1);
g_object_unref(cbpmap);
}
break;
}
if (which == PNGTEST) 
{
GdkColor color;
GdkGC  *bdryGC=NULL;
int   start=0;
switch (plotType)
{
case PDFPLOT:
{
if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dbInfo[DBPNGNB])))
break;
bdryGC = gdk_gc_new(da->window);
gtk_color_button_get_color(GTK_COLOR_BUTTON (dbInfo[DBPNGNBC]), &color);
gdk_gc_set_rgb_fg_color(bdryGC, &color);
gdk_gc_set_line_attributes(bdryGC, 2, 0, 0, 0);
start = 1;
}
break;
case WWWPLOT:
{
if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dbInfo[DBPNGIB])))
break;
bdryGC = gdk_gc_new(da->window);
gtk_color_button_get_color(GTK_COLOR_BUTTON (dbInfo[DBPNGIBC]), &color);
gdk_gc_set_rgb_fg_color(bdryGC, &color);
gdk_gc_set_line_attributes(bdryGC, 1, 0, 0, 0);
start = 0;
}
break;
}
if (bdryGC)
{
GdkPoint line[5];
line[0].x = start; line[0].y = start;
line[1].x = width-1; line[1].y = 0;
line[2].x = width-1; line[2].y = height-1;
line[3].x = start; line[3].y = height-1;
line[4].x = start; line[4].y = start;
gdk_draw_lines(*pMap, bdryGC, line, 5);
g_object_unref(bdryGC);
bdryGC = NULL;
}
}
gtk_widget_queue_draw_area(da, 0, 0, width, height); 
return TRUE;
}
gboolean pngDisp_exp(GtkWidget *da, GdkEventExpose *event, gpointer w)
{
int  which = GPOINTER_TO_INT(w);
GdkPixmap *pMap = pngPMap[which];
if (!da->window || 
!pMap)
return TRUE;
gdk_draw_drawable(da->window,
da->style->fg_gc[GTK_WIDGET_STATE (da)],
pMap,
event->area.x, event->area.y,
event->area.x, event->area.y,
event->area.width, event->area.height);
return TRUE;
}
