#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <getopt.h>
#include <glib.h>
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_externs.h"
extern char *progname;
static SRVRDB *startDB;
void make_pql(gboolean);
void setCombos();
void make_pdf();
void make_stn();
void printHelp()
{
fprintf(stderr, "PQL II & PQLX - Version\t%s\n", PROG_VERSION);
fprintf(stderr, "Usage: pqlx [ -h ] [ -d [HOST:]DBNAME] [ TRACES | -s sort_file ] [ -i instrument_sort_file ] [-l (=low resolution mode)]\n");
fprintf(stderr, "Usage:\npqlx [ -h ] [ -d [HOST:]DBNAME] [ TRACES | -s sort_file ]\n"
"\t[ -i instrument_sort_file ]\n"
"\t[ --mi multi-plex mini-SEED channels to include, ',' separated, no spaces ]\n"
"\t[ --me multi-plex mini-SEED channels to exclude, ',' separated, no spaces ]\n"
"\t[ --ml multi-plex mini-SEED trace length, ',' separated, no spaces\n""\t\tusing D,H,M,S specifiers, in any combination\n"
"\t\te.g.: 1D,2H,3M,4S = 1Day, 2Hours, 3Minutes, and 4Seconds ]\n" 
"\t[ -l (=low resolution mode) ]\n");
}
static int myCmdLine(int argc, char **argv)
{
PQLDATA *pqlIn;
int  i, opt, system, numArgs = 0;
gboolean read_traces = TRUE;
char *chnStr;
int option_index = 0;
static struct option long_options[] = {
{"mi", 1, 0, 0},
{"me", 1, 0, 0},
{"ml", 1, 0, 0},
{0, 0, 0, 0}
};
startDB = NULL;
while(1) 
{
option_index = 0;
opt = getopt_long(argc, argv, "i:lhs:t:d:", long_options, &option_index);
if (opt == -1)
break;
switch(opt)
{
case 0:
if (!mseed_opts)
mseed_opts = calloc(1, sizeof(MPLX_MSEED));
switch(option_index)
{
case 0:
for(chnStr = strtok(optarg, CHNARGSEP);
chnStr;
chnStr = strtok(NULL, CHNARGSEP))
{
g_strstrip(chnStr);
TOUPPER(chnStr);
mseed_opts->incChans = g_slist_prepend(mseed_opts->incChans, g_strdup(chnStr));
}
break;
case 1:
for(chnStr = strtok(optarg, CHNARGSEP);
chnStr;
chnStr = strtok(NULL, CHNARGSEP))
{
g_strstrip(chnStr);
TOUPPER(chnStr);
mseed_opts->excChans = g_slist_prepend(mseed_opts->excChans, g_strdup(chnStr));
}
break;
case 2:
mseed_opts->length = parseMMLen(optarg);
break;
}
break;
case 'd':
{
char *dbName;
startDB = calloc(1, sizeof(SRVRDB));
dbName = g_strdup(optarg);
if (strrchr(dbName, ':'))
{
startDB->name[SRVRDEFAULT] = g_strdup(strtok(dbName, ":"));
startDB->name[DBDEFAULT] = g_strdup(strtok(NULL, ":"));
}
else
{
startDB->name[SRVRDEFAULT] = g_strdup("localhost");
startDB->name[DBDEFAULT] = g_strdup(dbName);
}
numArgs += 2;
}
break;
case 'h':
printHelp();
exit(0);
break;
#if 0
case 'l':
low_res = TRUE;
break;
#endif
case 's':
{ 
char fileStr[255];
FILE *fp;
char *sortFile;
read_traces = FALSE;
sortFile = g_strdup(optarg);
if ((fp = fopen(sortFile, "r")) == NULL)
{
fprintf(stderr, "Unable to open sort file %s, exiting.\n", sortFile);
exit(-1);
}
i=0;
while (fgets(fileStr, 255, fp))
{
fileStr[strlen(fileStr)-1] = 0;
pqlIn = calloc(1, sizeof(PQLDATA));
pqlIn->fileName = g_strdup(fileStr);
states.input.Files = g_slist_prepend(states.input.Files, pqlIn);
i++;
}
states.input.Files = g_slist_reverse(states.input.Files);
fclose(fp);
free(sortFile);
strcpy(criteria[0].desc, "Sort File");
states.input.numFiles = g_slist_length(states.input.Files);
}
break;
case 'i':
{
char *instFile = g_strdup(optarg), idNO[10];
FILE *fp = fopen(instFile, "r");
GHashTable *hash;
int  i, *pos;
if (!fp)
{
fprintf(stderr, "Unable to open file %s, ignoring...\n", instFile);
free(instFile);
break;
}
hash = settings.general.sort.instOrder = g_hash_table_new(g_str_hash, g_str_equal);
i=1;
while (fgets(idNO, 10, fp))
{
idNO[strlen(idNO)-1] = 0;
pos = malloc(sizeof(int));
*pos = i++;
g_hash_table_insert(hash, g_strdup(idNO), pos);
}
fclose(fp);
criteria[SENSOR].fieldType = MYINSTSORT;
}   
break;
default:
printHelp();
exit(-1);
break;
}
}
system = NONE;
if (read_traces &&
optind < argc-numArgs)
{ 
for(i=optind;i<argc-numArgs;i++)
{
pqlIn = calloc(1, sizeof(PQLDATA));
pqlIn->fileName = g_strdup(argv[i]);
states.input.Files = g_slist_prepend(states.input.Files, pqlIn);
}
states.input.numFiles = g_slist_length(states.input.Files);
system = PQLSYSTEM;
}
return system;
}
void make_top()
{
char version[35];
topWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
sprintf(version, "PQLX - v%s", PROG_VERSION);
gtk_window_set_title(GTK_WINDOW(topWindow), version);
gtk_container_set_border_width(GTK_CONTAINER(topWindow), 2);
g_signal_connect(topWindow, "destroy", G_CALLBACK(gtk_main_quit), NULL);
gtk_widget_set_events(topWindow, gtk_widget_get_events(topWindow) 
| GDK_KEY_PRESS_MASK);
g_signal_connect(topWindow, "key_press_event", G_CALLBACK(FKeyEvent), NULL);
topBox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(topWindow), topBox);
gtk_window_set_position(GTK_WINDOW(topWindow), GTK_WIN_POS_CENTER);
}
void dbConnect(int cmd)
{
SQLDI sqldi;
switch(cmd)
{
case DISCONNECT:
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DISCONNECT;
db_request(&sqldi);
break;
}
}
gboolean _makePixmap(gpointer s);
int main(int argc, char **argv)
{
int system=NONE;
if (argc == 2) 
{
if (strcmp(argv[1], "-h") == 0)
{
printHelp();
exit(0);
}
else if (strcmp(argv[1], "-debug") == 0)
{
debugOUTPUT = TRUE;
}
}
if (argv[0])
progname = argv[0];
else
progname = "";
read_defaults_file(&settings, DEFAULTSET);
read_defaults_file(&settings, FILEDEFSET);
if (argc > 1 && !debugOUTPUT)
{
system = myCmdLine(argc, argv);
}
pqlxStates.machine.numCPUs = get_ncpu_pqlx();
g_thread_init(NULL);
gtk_init(&argc, &argv);
make_top();
make_pql(FALSE);
make_pdf();
make_stn();
if (system == NONE)
{
getSystemStartup();
system = pqlxStates.startupSys;
}
if (system != PQLSYSTEM)
gtk_combo_box_set_active(GTK_COMBO_BOX(sysCbo[pqlxStates.startupSys]), pqlxStates.startupSys);    
gtk_widget_show(topWindow);
switch(system)
{
case PQLSYSTEM:
g_idle_add((GSourceFunc) _makePixmap, GINT_TO_POINTER(TRACESCR));
gtk_widget_hide(systems[PDFSYSTEM]);
gtk_widget_hide(systems[STNSYSTEM]);
break;
case PDFSYSTEM:
{
if (startDB)
{
g_idle_add((GSourceFunc) initDBConn, startDB);
break;
}
if (pdfSettings.general.server &&
pdfSettings.general.database &&
strcmp(pdfSettings.general.server, "NONE"))
{
SRVRDB *srvrDB = calloc(1, sizeof(SRVRDB));
srvrDB->name[SRVRDEFAULT] = pdfSettings.general.server;
srvrDB->name[DBDEFAULT] = pdfSettings.general.database;
g_idle_add((GSourceFunc) initDBConn, srvrDB);
}
}
break;
case STNSYSTEM:
{
if (startDB)
{
g_idle_add((GSourceFunc) initDBConn, startDB);
break;
}
if (stnSettings.general.server &&
stnSettings.general.database &&
strcmp(stnSettings.general.server, "NONE"))
{
SRVRDB *srvrDB = calloc(1, sizeof(SRVRDB));
srvrDB->name[SRVRDEFAULT] = stnSettings.general.server;
srvrDB->name[DBDEFAULT] = stnSettings.general.database;
g_idle_add((GSourceFunc) initDBConn, srvrDB);
}
}
break;
}
gtk_main();
if (pqlxStates.conn.state == SRVRCONNECTED)
dbConnect(DISCONNECT);
return 0;
}
