#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_pdf.h"
#include "pqlx_stn.h"
#include "gtk_pdf_externs.h"
#include "gtk_stn_externs.h"
static GtkWidget *serverDisp;
extern STNSTATES stnStates;
static GtkWidget *srvrVIEW, *SdispML[2], *Sdetails[SRVRTTLDETAILS];
static GtkTooltips *tips;
static char  toolTip[1000];
static GtkListStore *srvrStore, *dbStore;
static void freeDBInfo(DBLST *dbInfo)
{
free(dbInfo->dbName);
free(dbInfo->organisation);
free(dbInfo->description);
free(dbInfo->techAdminName);
free(dbInfo->techAdminEmail);
free(dbInfo->dataAdminName);
free(dbInfo->dataAdminEmail);
free(dbInfo->type);
free(dbInfo->access);
free(dbInfo->adminPWord);
}
static void freeSrvrInfo(SERVERDBS *srvrDB)
{
GSList *dbIter;
DBLST *dbInfo;
if (srvrDB->data.srvrName)
free(srvrDB->data.srvrName);
if (srvrDB->data.dbName)
free(srvrDB->data.dbName);
for(dbIter = srvrDB->data.dbsList;
dbIter;
dbIter = g_slist_next(dbIter))
{ 
dbInfo = dbIter->data;
freeDBInfo(dbInfo);
free(dbInfo);
}
g_slist_free(srvrDB->data.dbsList);
}
static void srvrDstroy(GtkButton *button, gpointer nothing)
{
serverDisp = NULL;
}
static gint getTTModel(TTMODEL *model, char *modelN)
{
return(strcmp(model->name, modelN));
}
static GtkWidget *makeSrvrHdrModel(int type)
{
GtkWidget *treeview;
GtkListStore *localStore;
switch(type)
{
case PDFSERVER:
srvrStore = gtk_list_store_new(1, G_TYPE_STRING);
localStore = srvrStore;
break;
case PDFDATABASE:
dbStore = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
localStore = dbStore;
break;
}
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL (localStore));
return (treeview);
}
static void add_srvr_hdr_columns(int type, GtkTreeView *treeview)
{
GtkCellRenderer *renderer;
GtkTreeViewColumn *col;
GtkTreeIter iter;
switch(type)
{
case PDFSERVER:
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes("PQLX Servers", 
renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
gtk_list_store_append(srvrStore, &iter);
gtk_list_store_set(srvrStore, &iter, 0, "localhost", -1);
break;
case PDFDATABASE:
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes("DBase Name", 
renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes("Description", 
renderer, "text", 1, NULL);
gtk_tree_view_insert_column(treeview, col, 1);
break;
}
}
static void add_pdfsrvrs()
{ 
GtkTreeIter iter;
GSList  *srvrIter;
SERVERDBS *srvrDB;
if (srvrStore)
gtk_list_store_clear(srvrStore);
if (dbStore)
gtk_list_store_clear(dbStore);
for(srvrIter = pqlxStates.servers.srvrDB;
srvrIter;
srvrIter = g_slist_next(srvrIter))
{
srvrDB = srvrIter->data;
gtk_list_store_append(srvrStore, &iter);
gtk_list_store_set(srvrStore, &iter, 0, srvrDB->data.srvrName, -1);
}
}
static void writePDFsrvrs()
{
int  cntr;
DBLDI dbldi;
DBLRECORDS dblrecs;
GSList  *srvrIter;
SERVERDBS *srvrDB;
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = PDFSRVRST;
dbldi.descr.dataEvent = WRITE_ALL;
dbldi.data = &dblrecs;
for(srvrIter = pqlxStates.servers.srvrDB, cntr=0;
srvrIter;
srvrIter = g_slist_next(srvrIter))
{ 
srvrDB = srvrIter->data;
if (!strcmp(srvrDB->data.srvrName, "localhost"))
continue; 
cntr++;
}
dblrecs.numRecs = cntr;
if((dblrecs.recs = calloc(dblrecs.numRecs, sizeof(void *)))==NULL)
{
fprintf(stderr, "Out of Memory, cannot continue.\n");
exit(-1);
}
for(srvrIter = pqlxStates.servers.srvrDB, cntr=0;
srvrIter;
srvrIter = g_slist_next(srvrIter))
{ 
srvrDB = srvrIter->data;
if (!strcmp(srvrDB->data.srvrName, "localhost"))
continue; 
dblrecs.recs[cntr] = calloc(1, sizeof(PDFSRVR_REC));
((PDFSRVR_REC *) dblrecs.recs[cntr])->name = g_strdup(srvrDB->data.srvrName);
cntr++;
}
dbl_request(&dbldi);
for(cntr=0;cntr < dblrecs.numRecs; cntr++)
free(dblrecs.recs[cntr]);
free(dblrecs.recs);
}
void readPDFsrvrs()
{ 
DBLDI dbldi;
DBLRECORDS dblrecs;
int  j;
GSList  *srvrIter;
SERVERDBS *srvrDB;
for(srvrIter = pqlxStates.servers.srvrDB;
srvrIter;
srvrIter = g_slist_next(srvrIter))
{ 
srvrDB = srvrIter->data;
freeSrvrInfo(srvrDB);
free(srvrDB);
}
g_slist_free(pqlxStates.servers.srvrDB);
pqlxStates.servers.srvrDB = NULL;
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = PDFSRVRST;
dbldi.descr.dataEvent = READ_ALL;
dbldi.data = &dblrecs;
dbl_request(&dbldi);
srvrDB = calloc(1, sizeof(SERVERDBS));
srvrDB->data.srvrName = g_strdup("localhost");
pqlxStates.servers.srvrDB = g_slist_append(pqlxStates.servers.srvrDB, srvrDB);
if(dblrecs.numRecs) 
{
for(j=0;j<dblrecs.numRecs;j++)
{
srvrDB = calloc(1, sizeof(SERVERDBS));
srvrDB->data.srvrName = g_strdup(((PDFSRVR_REC *) (dblrecs.recs[j]))->name);
pqlxStates.servers.srvrDB = g_slist_append(pqlxStates.servers.srvrDB, srvrDB);
free(dblrecs.recs[j]);
} 
free(dblrecs.recs);
}
}
#define NULLNAME(str) (str ? str : "")
static void setSrvrDetails(int kind)
{ 
int   i;
SERVERDBS *srvrDB;
DBLST  *dbInfo;
switch(kind)
{
case SRVRDETSET:
srvrDB = pqlxStates.servers.server;
dbInfo = pqlxStates.servers.dbInfo;
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRHOSTNAME]), NULLNAME(srvrDB->data.srvrName));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDBNAME]), NULLNAME(dbInfo->dbName));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDESC]), NULLNAME(dbInfo->description));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRORG]), NULLNAME(dbInfo->organisation));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRTYPE]), NULLNAME(dbInfo->type));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRACCESS]), NULLNAME(dbInfo->access));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDADMIN]), NULLNAME(dbInfo->dataAdminName));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDADMINEM]), NULLNAME(dbInfo->dataAdminEmail));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRTADMIN]), NULLNAME(dbInfo->techAdminName));
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRTADMINEM]), NULLNAME(dbInfo->techAdminEmail));
break;
case SRVRDETCLEAR:
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRHOSTNAME]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDBNAME]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDESC]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRORG]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRTYPE]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRACCESS]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDADMIN]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRDADMINEM]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRTADMIN]), "");
gtk_entry_set_text(GTK_ENTRY(Sdetails[SRVRTADMINEM]), "");
break;
case SRVRDETUNEDIT:
for(i=3;i<SRVRTTLDETAILS;i++)
gtk_editable_set_editable (GTK_EDITABLE (Sdetails[i]), FALSE);
break;
case SRVRDETEDIT:
for(i=3;i<SRVRTTLDETAILS;i++)
gtk_editable_set_editable (GTK_EDITABLE (Sdetails[i]), TRUE);
break;
}
}
static int srvrSelected;
static void srvrCBack(GtkButton *button, gpointer t)
{
int  type = GPOINTER_TO_INT(t);
static gboolean more=FALSE;
switch(type)
{
case PDFSRVRMORE:
if (!pqlxStates.servers.dbInfo)
break;
setSrvrDetails(SRVRDETCLEAR);
setSrvrDetails(SRVRDETSET);
setSrvrDetails(SRVRDETUNEDIT);
if (!more)
{
gtk_widget_show_all(Sdetails[SRVRDETAILS]);
more = TRUE;
}
else
{
gtk_widget_show(Sdetails[SRVRDETAILS]);
}
gtk_widget_show(SdispML[PDFSRVRLESS]);
gtk_widget_hide(SdispML[PDFSRVRMORE]);
break;
case PDFSRVRLESS:
gtk_window_resize(GTK_WINDOW(serverDisp), 1, 1);
gtk_widget_show(SdispML[PDFSRVRMORE]);
gtk_widget_hide(SdispML[PDFSRVRLESS]);
if (more)
{
gtk_widget_hide(Sdetails[SRVRDETAILS]);
setSrvrDetails(SRVRDETCLEAR);
}
break;
case PDFSRVRDELETE:
{
DBLDI dbldi;
DBLRECORDS dblrecs;
PDFSRVR_REC dataRec;
GtkTreePath *path;
GtkTreeIter iter;
char pathS[4];
if (!strcmp(pqlxStates.servers.server->data.srvrName, "localhost"))
break;  
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
memset(&dataRec, 0, sizeof(PDFSRVR_REC));
dbldi.descr.tableData = PDFSRVRST;
dbldi.descr.dataEvent = DELETE_SNGL;
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &dataRec;
dataRec.name = g_strdup(pqlxStates.servers.server->data.srvrName);
dbl_request(&dbldi);
free(dataRec.name);
free(dblrecs.recs);
sprintf(pathS, "%d", srvrSelected);
path = gtk_tree_path_new_from_string (pathS);
gtk_tree_model_get_iter (GTK_TREE_MODEL (srvrStore), &iter, path);
gtk_tree_path_free(path);
gtk_list_store_remove(srvrStore, &iter);
if (dbStore)
gtk_list_store_clear(dbStore);
}
break;
case PDFSRVRCANCEL:
gtk_grab_remove(serverDisp);
gtk_widget_hide(serverDisp);
break;
}
while(gtk_events_pending())
gtk_main_iteration();
}
static void addSrvrDB(int type, int srvr)
{
GtkTreeIter iter;
SERVERDBS *srvrDB=g_slist_nth_data(pqlxStates.servers.srvrDB, srvr);
char rowS[5];
GtkTreePath *path;
switch(type)
{
case PDFSERVER:
gtk_list_store_append(srvrStore, &iter);
gtk_list_store_set(srvrStore, &iter, 0, srvrDB->data.srvrName, -1);
sprintf(rowS, "%d", srvr);
path = gtk_tree_path_new_from_string(rowS);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW (srvrVIEW), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW (srvrVIEW), path, NULL, FALSE);
gtk_tree_path_free (path);
writePDFsrvrs();   
break;
case PDFDATABASE:
{
GSList *dbIter;
DBLST *dbInfo;
if (dbStore)
gtk_list_store_clear(dbStore);
for(dbIter = srvrDB->data.dbsList;
dbIter;
dbIter = g_slist_next(dbIter))
{ 
dbInfo = dbIter->data;
gtk_list_store_append(dbStore, &iter);
gtk_list_store_set(dbStore, &iter, 
0, dbInfo->dbName, 
1, dbInfo->description,
-1);
}
}
break;
}
}
static void refreshSysState()
{
int j, k;
switch(pqlxStates.system)
{
case PDFSYSTEM:
for(j=0;j<MMAXPDFROWS;j++)
for(k=0;k<MMAXPDFCOLS;k++)
makeDrawing(PDFMAIN, j, k);
break;
case STNSYSTEM:
for(j=0;j<TTLSTNMAINDISPLAYMODES;j++)
{ 
stnStates.pmap.dirty[STNMAIN][j] = TRUE;
}
makeSTNDrawing(STNMAIN);
break;
}
while(gtk_events_pending())
gtk_main_iteration();
}
static int getDBInfo(char *srvr, SERVERDBS *srvrDBsL, gboolean dispMsg)
{
GtkWidget *msg=NULL;
SQLDI sqldi;
LOGIN login;
int  ret;
GSList *iter;
DBLST *dbInfo;
for(iter = srvrDBsL->data.dbsList;
iter;
iter = g_slist_next(iter))
{ 
dbInfo = iter->data;
freeDBInfo(dbInfo);
free(dbInfo);
}
g_slist_free(srvrDBsL->data.dbsList);
srvrDBsL->data.dbsList = NULL;
if (srvrDBsL->data.srvrName)
free(srvrDBsL->data.srvrName);
if (dispMsg)
{
msg = gtk_message_dialog_new_with_markup((GtkWindow *) topWindow, 
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_MESSAGE_INFO,
GTK_BUTTONS_NONE,
"<span font_desc=\"12\">Fetching DB Information... Please Wait</span>");
gtk_widget_show_all(msg);
while(gtk_events_pending())
gtk_main_iteration();
}
memset(&sqldi, 0, sizeof(SQLDI));
memset(&login, 0, sizeof(LOGIN));
memset(srvrDBsL, 0, sizeof(SERVERDBS));
strcpy(login.keys.hostname, srvr);
strcpy(login.keys.username, PQLXCLNT);
strcpy(login.keys.password, PQLXCLNTPW);
sqldi.data = &login;
sqldi.data2 = srvrDBsL;
if (!strcmp(login.keys.hostname, "localhost"))
{
sqldi.descr.tableData = SRVRDBSL;
}
else
{
sqldi.descr.tableData = SRVRDBSR;
}
sqldi.args.dataEvent = METADATA;
ret = db_request(&sqldi);
if (dispMsg)
{
gtk_widget_hide(msg);
gtk_widget_destroy(msg);
while(gtk_events_pending())
gtk_main_iteration();
}
if (ret != PQLXSUCCESS)
{ 
static GtkWidget *dialog=NULL; 
GtkWidget *label;
if (!dialog)
{
dialog = gtk_dialog_new_with_buttons ("OPEN",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span font_desc=\"12\">\n\tCannot Connect to Server...\t\n\tCannot provide DB Names\n</span>");
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), label);
gtk_widget_show_all(dialog);
}
else
{
gtk_widget_show(dialog);
}
gtk_dialog_run(GTK_DIALOG(dialog));
gtk_widget_hide(dialog);
gtk_window_present(GTK_WINDOW(serverDisp));
}
return ret;
}
static gboolean chnMetasRet(SQLDI *sqldi)
{
INSTIDS *instIDs = sqldi->data;
stnStates.data.instIDs = instIDs->data.instIDs;
free(instIDs);
free(sqldi);
return FALSE;
}
static gint getDB(DBLST *dbInfo, char *dbName)
{
return (strcmp(dbInfo->dbName, dbName));
}
static gint getSrvr(SERVERDBS *srvrInfo, char *srvrName)
{
return (strcmp(srvrInfo->data.srvrName, srvrName));
}
void freeGData(int which, GSList *list)
{ 
GSList *iter;
switch (which)
{
case GDATA_SYSPDFS:
{
SYSPDFDEF *sysPDFdef;
for (iter = list;
iter;
iter = g_slist_next(iter))
{
sysPDFdef = iter->data;
IFFREE(sysPDFdef->pdfName);
IFFREE(sysPDFdef->pdfDescr);
free(sysPDFdef);
}
g_slist_free(list);
}
break;
case GDATA_BLINES:
{
BLINEDEF *blineDef;
for (iter = list;
iter;
iter = g_slist_next(iter))
{
blineDef = iter->data;
IFFREE(blineDef->name);
IFFREE(blineDef->descr);
free(blineDef);
}
g_slist_free(list);
}
break;
}
}
static void connectDB(char *srvrNm, char *dbNm)
{
SQLDI sqldi;
LOGIN login;
SERVERDBS *srvrDB;
DBLST  *dbInfo;
GSList *item;
int  ret = PQLXSUCCESS;
char titleBar[65], *dispMsg;
item = g_slist_find_custom(pqlxStates.servers.srvrDB, srvrNm, (GCompareFunc) getSrvr);
if (item)
srvrDB = item->data;
else
return;
if (!srvrDB->data.dbsList)
ret = getDBInfo(srvrNm, srvrDB, FALSE);
if (ret != PQLXSUCCESS)
return;
item = g_slist_find_custom(srvrDB->data.dbsList, dbNm, (GCompareFunc) getDB);
if (!item)
return;
dbInfo = item->data;
if (stnStates.display.pdfBUSY)
{
stnStates.display.pdfRESET = TRUE;
while(stnStates.display.pdfBUSY){};
}
memset(&sqldi, 0, sizeof(SQLDI));
if (pqlxStates.conn.state == SRVRCONNECTED)
{
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DISCONNECT;
db_request(&sqldi);
pqlxStates.conn.state = SRVRNOCONNECTION;
freeGData(GDATA_SYSPDFS, pqlxGData.systemPDFs);  pqlxGData.systemPDFs = NULL;
freeGData(GDATA_BLINES, pqlxGData.systemBLINEs); pqlxGData.systemBLINEs = NULL;
}
if (pqlxStates.conn.srvrNm)
{
free(pqlxStates.conn.srvrNm);
free(pqlxStates.conn.dbNm);
pqlxStates.conn.srvrNm = pqlxStates.conn.dbNm = NULL;
}
if (serverDisp)
srvrCBack(GTK_BUTTON (NULL), GINT_TO_POINTER(PDFSRVRCANCEL));
while (ntw)
{ 
g_node_destroy((GNode *) (ntw->data));
ntw = g_slist_remove(ntw, (ntw->data));
}
while (ntwPDF)
{
g_node_destroy((GNode *) (ntwPDF->data));
ntwPDF = g_slist_remove(ntw, (ntwPDF->data));
}
if (stnStates.data.instIDs)
{
g_hash_table_destroy(stnStates.data.instIDs);
stnStates.data.instIDs = NULL;
}
{ 
TTMODEL *model;
TTNAME *phase;
GSList *modelIter, *phaseIter;
for(modelIter = stnStates.event.models;
modelIter;
modelIter = g_slist_next(modelIter))
{
model = modelIter->data;
free(model->name);
for(phaseIter = model->phases;
phaseIter;
phaseIter = g_slist_next(phaseIter))
{
phase = phaseIter->data;
free(phase->name);
}
g_slist_free(model->phases);
}
g_slist_free(stnStates.event.models);
stnStates.event.models = NULL;
}
sprintf(titleBar, "PQLX - v%s", PROG_VERSION);
gtk_window_set_title(GTK_WINDOW(topWindow), titleBar);
if (dbInfo->dbVersion < PQLX_CLNT_DBVER_MIN)
{ 
dispMsg = g_strdup_printf("PQLX DB Version = %d\n\tClient cannot connect\n\tDatabase must be upgraded, please execute pqlxSrvr.\n\nPQLX DB Technical Support - \n\t%s\n\t(%s)",
dbInfo->dbVersion,
dbInfo->techAdminName,
dbInfo->techAdminEmail);
dispMsgDialogue(dispMsg);
free(dispMsg);
refreshSysState();
return;
}
if (dbInfo->dbVersion > PQLX_CLNT_DBVER_MAX)
{ 
dispMsg = g_strdup_printf("PQLX DB Version = %d\n\tClient cannot connect\n\tClient pqlx must be upgraded,\n\nPQLX DB Technical Support - \n\t%s\n\t(%s)",
dbInfo->dbVersion,
dbInfo->techAdminName,
dbInfo->techAdminEmail);
dispMsgDialogue(dispMsg);
free(dispMsg);
refreshSysState();
return;
}
pqlxStates.conn.state = SRVRCONNECTING;
refreshSysState();
memset(&sqldi, 0, sizeof(SQLDI));
memset(&login, 0, sizeof(LOGIN));
strcpy(login.keys.hostname, srvrDB->data.srvrName);
strcpy(login.keys.dbname, dbInfo->dbName);
login.keys.stnXDays = stnSettings.general.stnXDays;
strcpy(login.keys.username, PQLXCLNT);
strcpy(login.keys.password, PQLXCLNTPW);
sqldi.data = &login;
sqldi.args.dataEvent = CONNECT;
ret = db_request(&sqldi);
if (ret != PQLXSUCCESS)
{
switch(ret)
{
case SRVR_NOT_READY:
{
SRVRSTATE  srvrState;
char   *tabs[TTLSRVRSTT];
int    i;
memset(&srvrState, 0, sizeof(SRVRSTATE));
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.data = &srvrState;
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = SRVRSTT;
ret = db_request(&sqldi);
for(i=0;i<TTLSRVRSTT;i++)
{
if (srvrState.data.cntInfo[i] > 9999)
{
tabs[i] = g_strdup("\t");
}
else
{
tabs[i] = g_strdup("\t\t");
}
}
dispMsg = g_strdup_printf("The PQLX server has not completed its initial execution, client cannot yet connect. Try again later...\n\nCurrent Server State:\n\n\t%d%s: Total Channels\n\t%d%s: Total Traces\n\nUnprocessed Events:\n\t%d%s: Trace Meta-Data\n\t%d%s: Trace PSDs\n\t%d%s: Overlapping Trace PSDs\n\t%d%s: PSD Data Table Indexes\n\t%d%s: System PDFs", 
srvrState.data.cntInfo[SRVRSTTCHN], tabs[SRVRSTTCHN],
srvrState.data.cntInfo[SRVRSTTTRC], tabs[SRVRSTTTRC],
srvrState.data.cntInfo[SRVRSTTMETA], tabs[SRVRSTTMETA],
srvrState.data.cntInfo[SRVRSTTPSD], tabs[SRVRSTTPSD],
srvrState.data.cntInfo[SRVRSTPSDOL], tabs[SRVRSTPSDOL],
srvrState.data.cntInfo[SRVRSTPSDIDX], tabs[SRVRSTPSDIDX],
srvrState.data.cntInfo[SRVRSTSYSPDF], tabs[SRVRSTSYSPDF]);
dispMsgDialogue(dispMsg);
free(dispMsg);
for(i=0;i<TTLSRVRSTT;i++)
{
free(tabs[i]);
}
}
break;
case NO_STATIONS:
if (login.keys.stnXDays)
dispMsg = g_strdup("\n\tNo Qualifying Stations Returned!\n\n\tSet 'Exclude STN Days' "
"in Control Panel to 0 to Retrieve All Stations.\n");
else
dispMsg = g_strdup_printf("\n\tThe SQLX database '%s' contains no analyzed data!\n\n\t"
"Verify the execution of the server via sqlx-admin.\n", login.keys.dbname);
dispMsgDialogue(dispMsg);
free(dispMsg);
break;
}
pqlxStates.conn.state = SRVRNOCONNECTION;
refreshSysState();
return;
}
stnStates.event.models = login.data.models;
if (stnStates.event.models)
{ 
GSList *model;
if (stnSettings.event.modelSel)
{
model = g_slist_find_custom(stnStates.event.models, stnSettings.event.modelSel, 
(GCompareFunc) getTTModel);
stnStates.event.model = model ? model->data : NULL;
}
else
{
stnStates.event.model = NULL;
}
}
else
stnStates.event.model = NULL;
{ 
SYSPDFS sysPDFdefs;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&sysPDFdefs, 0, sizeof(SYSPDFS));
sqldi.data = &sysPDFdefs;
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = SYSPDFDEFS;
ret = db_request(&sqldi);
pqlxGData.systemPDFs = sysPDFdefs.data.sysPDF;
}
{ 
SYSBLINES sysBLineDefs;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&sysBLineDefs, 0, sizeof(sysBLineDefs));
sqldi.data = &sysBLineDefs;
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = SYSBLINEDEFS;
ret = db_request(&sqldi);
pqlxGData.systemBLINEs = sysBLineDefs.data.sysBLINE;
}
pqlxStates.conn.srvrNm = g_strdup(login.keys.hostname);
pqlxStates.conn.dbNm = g_strdup(login.keys.dbname);
pqlxStates.conn.state = SRVRCONNECTED;
sprintf(titleBar, "PQLX - v%s - %s", PROG_VERSION, login.keys.dbname);
gtk_window_set_title(GTK_WINDOW(topWindow), titleBar);
{
SQLDI *sqldiL = calloc(1, sizeof(SQLDI));
INSTIDS *instIDs = calloc(1, sizeof(INSTIDS));
sqldiL->data = instIDs;
sqldiL->args.dataEvent = GET_DATA;
sqldiL->args.callType = ASYNC;
sqldiL->args.sqr = stnSettings.main.lines+1;
sqldiL->args.returnFunc = (void *) chnMetasRet;
sqldiL->descr.tableData = CHNMETAINFOLIST;
ret = db_request(sqldiL);
}
initSTNsystem();
initPDFsystem();
}
static int getDBList(SERVERDBS *srvrDB, int row)
{ 
SQLDI sqldi;
LOGIN login;
GSList *iter;
DBLST *dbInfo;
int  ret;
for(iter = srvrDB->data.dbsList;
iter;
iter = g_slist_next(iter))
{
dbInfo = iter->data;
freeDBInfo(dbInfo);
free(dbInfo);
}
g_slist_free(srvrDB->data.dbsList);
srvrDB->data.dbsList = NULL;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&login, 0, sizeof(LOGIN));
strcpy(login.keys.hostname, srvrDB->data.srvrName);
strcpy(login.keys.username, PQLXCLNT);
strcpy(login.keys.password, PQLXCLNTPW);
sqldi.data = &login;
sqldi.data2 = srvrDB;
if (!strcmp(login.keys.hostname, "localhost"))
{
sqldi.descr.tableData = SRVRDBSL;
}
else
{
sqldi.descr.tableData = SRVRDBSR;
}
sqldi.args.dataEvent = METADATA;
ret = db_request(&sqldi);
if (ret != PQLXSUCCESS)
{ 
dbInfo = calloc(1, sizeof(DBLST));
dbInfo->dbName = g_strdup("NONE");
dbInfo->description = g_strdup("Connection Request Failed");
srvrDB->data.dbsList = g_slist_append(srvrDB->data.dbsList, dbInfo);
}
addSrvrDB(PDFDATABASE, row);
pqlxStates.servers.server = srvrDB;
return (ret);
}
static void srvrInfo(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer t)
{ 
int  type = GPOINTER_TO_INT(t);
int  row;
char *tPath = gtk_tree_path_to_string(arg1);
row = atoi(tPath);
g_free(tPath);
srvrSelected = row;
switch(type)
{
case PDFSRVRREFRESH:
{ 
SERVERDBS *srvrDB=g_slist_nth_data(pqlxStates.servers.srvrDB, row);
getDBList(srvrDB, row);
}
break;
case PDFSRVRCONNECT:
{ 
DBLST *dbInfo = g_slist_nth_data(pqlxStates.servers.server->data.dbsList, row);
connectDB(pqlxStates.servers.server->data.srvrName, dbInfo->dbName);
}
break;
}
}
static void newSrvr(GtkWidget *widget, gpointer t)
{ 
int  type = GPOINTER_TO_INT(t);
SQLDI sqldi;
LOGIN login;
SERVERDBS *srvrDBsL;
int  row, ret;
switch(type)
{
case PDFSRVRFETCH:
memset(&sqldi, 0, sizeof(SQLDI));
memset(&login, 0, sizeof(LOGIN));
srvrDBsL = calloc(1, sizeof(SERVERDBS));
strcpy(login.keys.hostname, gtk_entry_get_text(GTK_ENTRY(widget)));
strcpy(login.keys.username, PQLXCLNT);
strcpy(login.keys.password, PQLXCLNTPW);
sqldi.data = &login;
sqldi.data2 = srvrDBsL;
sqldi.descr.tableData = SRVRDBSR;
sqldi.args.dataEvent = METADATA;
ret = db_request(&sqldi);
if (ret != PQLXSUCCESS)
{ 
static GtkWidget *dialog=NULL; 
GtkWidget *label;
if (!dialog)
{
dialog = gtk_dialog_new_with_buttons ("OPEN",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span font_desc=\"12\">\n\tCannot Connect to Server...\t\n</span>");
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), label);
gtk_widget_show_all(dialog);
}
else
{
gtk_widget_show(dialog);
}
gtk_dialog_run (GTK_DIALOG(dialog));
gtk_widget_hide(dialog);
gtk_window_present(GTK_WINDOW(serverDisp));
return;
}
pqlxStates.servers.srvrDB = g_slist_append(pqlxStates.servers.srvrDB, srvrDBsL);
pqlxStates.servers.server = srvrDBsL;
row = g_slist_length(pqlxStates.servers.srvrDB)-1;
addSrvrDB(PDFSERVER, row);
addSrvrDB(PDFDATABASE, row);
#if 0
row = pqlxStates.servers.numSrvrs++;
pqlxStates.servers.srvrDBs = realloc(pqlxStates.servers.srvrDBs, 
sizeof(SERVERDBS **)*pqlxStates.servers.numSrvrs);
pqlxStates.servers.srvrDBs[row] = srvrDBs = malloc(sizeof(SERVERDBS));
memset(srvrDBs, 0, sizeof(SERVERDBS));
memcpy(srvrDBs, &srvrDBsL, sizeof(SERVERDBS));
gtk_entry_set_text(GTK_ENTRY(widget), "");
addSrvrDB(PDFSERVER, row);
addSrvrDB(PDFDATABASE, row);
pqlxStates.servers.curDisp[PDFSERVER] = row;
#endif
break;
}
}
static void dispSrvr(GtkTreeView *treeview, gpointer t)
{ 
int  type = GPOINTER_TO_INT(t);
switch (type)
{
case PDFSRVRDISPLAY:
{ 
char *rowS;
int  row;
GtkTreePath *path;
gtk_tree_view_get_cursor (treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
srvrSelected = row = atoi(rowS); g_free(rowS);
addSrvrDB(PDFDATABASE, row);
pqlxStates.servers.server = g_slist_nth_data(pqlxStates.servers.srvrDB, row);
}
break;
case PDFDATABASE:
{ 
char *rowS;
int  row;
GtkTreePath *path;
gtk_tree_view_get_cursor (treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
row = atoi(rowS);
g_free(rowS);
pqlxStates.servers.dbInfo = g_slist_nth_data(pqlxStates.servers.server->data.dbsList, row);
setSrvrDetails(SRVRDETSET);
}
break;
}
}
static void make_SrvrScrn()
{
GtkWidget *srvrSW, *frame, *hbox, *vbox, *vbox2;
GtkWidget *label, *entry, *button, *sep, *hdrV, *colour_box;
GtkSizeGroup *size_group;
tips = gtk_tooltips_new();
serverDisp = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_window_set_title (GTK_WINDOW(serverDisp), "PDF Servers"); 
gtk_container_set_border_width(GTK_CONTAINER (serverDisp), 2);
g_signal_connect(serverDisp, "destroy", G_CALLBACK (srvrDstroy), NULL);
colour_box = gtk_event_box_new();
gtk_widget_modify_bg (colour_box, GTK_STATE_NORMAL, &settings.colors.sb[PDFMAIN]);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME (frame), GTK_SHADOW_IN);
gtk_container_add(GTK_CONTAINER (colour_box), frame);
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">New PDF Server:</span>");
entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 40);
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK (newSrvr), GINT_TO_POINTER(PDFSRVRFETCH));
strcpy(toolTip, "Fully Qualified Machine Name or IP Address");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX (vbox), hbox, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
srvrSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW (srvrSW), GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(srvrSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
srvrVIEW = makeSrvrHdrModel(PDFSERVER);
g_signal_connect(srvrVIEW, "row-activated", G_CALLBACK(srvrInfo), GINT_TO_POINTER(PDFSRVRREFRESH));
g_signal_connect(srvrVIEW, "cursor-changed", G_CALLBACK(dispSrvr), GINT_TO_POINTER(PDFSRVRDISPLAY));
gtk_container_add(GTK_CONTAINER(srvrSW), srvrVIEW);
gtk_box_pack_start(GTK_BOX(hbox), srvrSW, FALSE, FALSE, 2);
add_srvr_hdr_columns(PDFSERVER, GTK_TREE_VIEW(srvrVIEW));
gtk_widget_set_size_request(srvrSW, 165, -1);
strcpy(toolTip, "Single-click to VIEW PDF Databases\nDouble-click to REFRESH PDF Database List");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), srvrVIEW, toolTip, toolTip);
srvrSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (srvrSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (srvrSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
hdrV = makeSrvrHdrModel(PDFDATABASE);
g_signal_connect(hdrV, "row-activated", G_CALLBACK (srvrInfo), GINT_TO_POINTER(PDFSRVRCONNECT));
g_signal_connect(hdrV, "cursor-changed", G_CALLBACK (dispSrvr), GINT_TO_POINTER(PDFDATABASE));
gtk_container_add(GTK_CONTAINER (srvrSW), hdrV);
gtk_box_pack_start(GTK_BOX (hbox), srvrSW, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX (vbox), hbox, TRUE, TRUE, 2);
add_srvr_hdr_columns(PDFDATABASE, GTK_TREE_VIEW (hdrV));
gtk_widget_set_size_request(srvrSW, 350, 250);
strcpy(toolTip, "Double-click to CONNECT to PDF Database and Return");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), hdrV, toolTip, toolTip);
hbox = gtk_hbutton_box_new ();
gtk_button_box_set_layout (GTK_BUTTON_BOX (hbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("Delete");
gtk_box_pack_start(GTK_BOX (hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Remove Server from List");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK (srvrCBack), GINT_TO_POINTER(PDFSRVRDELETE));
SdispML[PDFSRVRLESS] = button = gtk_button_new_with_label("<<< LESS");
gtk_box_pack_start(GTK_BOX (hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Display LESS PDF Database Information");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK (srvrCBack), GINT_TO_POINTER(PDFSRVRLESS));
SdispML[PDFSRVRMORE] = button = gtk_button_new_with_label("MORE >>>");
gtk_box_pack_start(GTK_BOX (hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Display MORE PDF Database Information");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK (srvrCBack), GINT_TO_POINTER(PDFSRVRMORE));
button = gtk_button_new_with_label("Cancel");
gtk_box_pack_start(GTK_BOX (hbox), button, FALSE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK (srvrCBack), GINT_TO_POINTER(PDFSRVRCANCEL));
#if 0
button = gtk_button_new_with_label("Connect");
gtk_box_pack_start(GTK_BOX (hbox), button, FALSE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK (srvrInfo), GINT_TO_POINTER(PDFSRVRCONNECT));
#endif
gtk_box_pack_start(GTK_BOX (vbox), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER (frame), vbox);
gtk_container_add(GTK_CONTAINER (serverDisp), colour_box);
gtk_window_set_position(GTK_WINDOW(serverDisp), GTK_WIN_POS_CENTER);
gtk_widget_show_all(serverDisp);
srvrCBack(NULL, GINT_TO_POINTER(PDFSRVRLESS));
gtk_widget_show(serverDisp);
add_pdfsrvrs();
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
Sdetails[SRVRDETAILS] = vbox2 = gtk_vbox_new(FALSE, 0);
sep = gtk_hseparator_new();
gtk_box_pack_start (GTK_BOX (vbox2), sep, FALSE, FALSE, 3);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Hostname: </span>");
Sdetails[SRVRHOSTNAME] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Hostname Providing this PDF Database");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
gtk_editable_set_editable (GTK_EDITABLE (entry), FALSE);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Database Name: </span>");
Sdetails[SRVRDBNAME] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Name of the PDF Database");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
gtk_editable_set_editable (GTK_EDITABLE (entry), FALSE);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Description: </span>");
Sdetails[SRVRDESC] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Database Description");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Organization: </span>");
Sdetails[SRVRORG] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Organization Providing this PDF Database");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Type: </span>");
Sdetails[SRVRTYPE] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Database Type: either PRODUCTION or SCRATCH");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Access: </span>");
Sdetails[SRVRACCESS] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Database Access: either PUBLIC or PRIVATE");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">DB Data Administrator: </span>");
Sdetails[SRVRDADMIN] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Database Data Administrator Name");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Data Administrator E-Mail: </span>");
Sdetails[SRVRDADMINEM] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Database Data Administrator E-Mail Address");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">DB Technical Administrator: </span>");
Sdetails[SRVRTADMIN] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Database Technical Administrator Name");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Technical Administrator E-Mail: </span>");
Sdetails[SRVRTADMINEM] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX (vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
g_object_unref(size_group);
strcpy(toolTip, "Database Technical Administrator E-Mail Address");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), entry, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX (vbox), vbox2, TRUE, TRUE, 2);
return;
}
void servers(GtkButton *button, gpointer nothing)
{
if (stnStates.display.pdfBUSY)
{
stnStates.display.pdfRESET = TRUE;
}
if (!serverDisp)
{
make_SrvrScrn();
gtk_window_resize(GTK_WINDOW(serverDisp), 1, 1);
gtk_window_set_transient_for((GtkWindow *) serverDisp, (GtkWindow *) topWindow);
}
gtk_widget_show(serverDisp);
gtk_grab_add(serverDisp);
return;
}
void srvrDefault(GtkWidget *comboB, gpointer w)
{
GtkWidget *combo[2];
int  ret, i, which = GPOINTER_TO_INT(w);
static int numDBs;
gchar *srvr;
switch(pqlxStates.system)
{
case PDFSYSTEM:
combo[SRVRDEFAULT] = pdfSrvrDefault[SRVRDEFAULT];
combo[DBDEFAULT] = pdfSrvrDefault[DBDEFAULT];
break;
case STNSYSTEM:
combo[SRVRDEFAULT] = stnSrvrDefault[SRVRDEFAULT];
combo[DBDEFAULT] = stnSrvrDefault[DBDEFAULT];
break;
}
srvr = gtk_combo_box_get_active_text(GTK_COMBO_BOX (combo[0]));
if (!strcmp(srvr, "NONE"))
{
for(i=0;i<numDBs;i++)
{
gtk_combo_box_remove_text(GTK_COMBO_BOX (combo[DBDEFAULT]), 0);
}
numDBs = 0;
return;
}
switch(which)
{
case SRVRDEFAULT:
{
SERVERDBS *srvrInfo;
DBLST  *dbInfo;
GSList  *iter;
iter = g_slist_find_custom(pqlxStates.servers.srvrDB, srvr, (GCompareFunc) getSrvr);
if (iter)
srvrInfo = iter->data;
else
return;
ret = getDBInfo(srvr, srvrInfo, TRUE);
if (ret != PQLXSUCCESS)
break;
for(i=0;i<numDBs;i++)
{ 
gtk_combo_box_remove_text(GTK_COMBO_BOX (combo[DBDEFAULT]), 0);
}
for(iter = srvrInfo->data.dbsList;
iter;
iter = g_slist_next(iter))
{
dbInfo = iter->data;
gtk_combo_box_append_text(GTK_COMBO_BOX (combo[DBDEFAULT]), dbInfo->dbName);
}
numDBs = g_slist_length(srvrInfo->data.dbsList);
}
break;
case DBDEFAULT:
{
}
break;
}
}
gboolean initDBConn(SRVRDB *srvrDB)
{
connectDB(srvrDB->name[SRVRDEFAULT], srvrDB->name[DBDEFAULT]);
free(srvrDB);
return FALSE;
}
