#include "pql_defines.h"
#include "pqlx_externs.h"
#include <gdk/gdkkeysyms.h>
void systemChg(GtkComboBox *combo, SOURCEINFO *sysInfo)
{ 
int system, i;
if (combo)  
system = gtk_combo_box_get_active(combo);
else     
system = sysInfo->destSystem;
states.general.sourceSystem = pqlxStates.system;   
pqlxStates.system = system;
for(i=0;i<NUM_SYSTEMS;i++)
{
if (i==system)
{
switch(system)
{
case PQLSYSTEM:
if (!combo)
{ 
switch(states.general.sourceSystem)
{
case STNSYSTEM: 
setupPQL(sysInfo);
break;
case PDFSYSTEM: 
setupPQL(sysInfo);
break;
}
}
break;
case PDFSYSTEM:
{
if(!combo)
{
int nb = (sysInfo->destTab >= TTLPDFTABS) ? SPECTRONB : PDFNB;
int destTab = (nb == PDFNB) ? sysInfo->destTab : SPECTROTAB(sysInfo->destTab);
gtk_notebook_set_current_page((GtkNotebook *) PSDnb, nb);
gtk_notebook_set_current_page((GtkNotebook *) PSDbooks[nb], destTab);
}
}
break;
case STNSYSTEM:
if (!combo)
{
gtk_notebook_set_current_page((GtkNotebook *) STNscreens, sysInfo->destTab);
stnStates.display.dataState = STNDRAWDONE; 
makeSTNDrawing(sysInfo->destTab);
}
break;
}
gtk_widget_show(systems[i]);
g_signal_handler_block(sysCbo[i], sysCboSgnl[i]);  
gtk_combo_box_set_active(GTK_COMBO_BOX (sysCbo[i]), i);
g_signal_handler_unblock(sysCbo[i], sysCboSgnl[i]);
}
else
gtk_widget_hide(systems[i]);
}
}
void dispMsgDialogue(char *msg)
{
GtkWidget *dispWidget;
dispWidget = gtk_message_dialog_new(NULL, GTK_DIALOG_DESTROY_WITH_PARENT, 
GTK_MESSAGE_INFO, GTK_BUTTONS_OK, 
"%s", msg);
gtk_dialog_run (GTK_DIALOG(dispWidget));
gtk_widget_destroy (dispWidget);
}
gboolean FKeyEvent(GtkWidget *widget, GdkEventKey *event, gpointer nil)
{
guint modifiers = gtk_accelerator_get_default_mod_mask();
int  ctrlKey = ((event->state & modifiers) == GDK_CONTROL_MASK) ? CTRL : NONE;
SOURCEINFO sysInfo;
switch(event->keyval)
{
case GDK_F1:
if (pqlxStates.system != PQLSYSTEM)
{
sysInfo.destSystem = PQLSYSTEM;
systemChg(NULL, &sysInfo);
}
else
{
switch(ctrlKey)
{
case CTRL:
break;
default:
switchScreenPQL((states.currentPage+1)%NUMSCREENS);
break;
}
}
break;
case GDK_F2:
sysInfo.destSystem = PDFSYSTEM;
if (pqlxStates.system != PDFSYSTEM)
sysInfo.destTab = pdfStates.screen;
else
sysInfo.destTab = (pdfStates.screen+1)%TTLPDFSCREENS;
systemChg(NULL, &sysInfo);
break;
case GDK_F3:
sysInfo.destSystem = STNSYSTEM;
if (pqlxStates.system != STNSYSTEM)
sysInfo.destTab = stnStates.screen;
else
sysInfo.destTab = (stnStates.screen+1)%TTLSTNSCREENS;
systemChg(NULL, &sysInfo);
break;
}
return FALSE;
}
static void _setSensitive(GtkWidget *widget, gboolean *snstv)
{
if (widget)
gtk_widget_set_sensitive(widget, *snstv);
}
void setSensitive(int system, int array, int scr, gboolean snstv)
{
switch(system)
{
case STNSYSTEM:
if (stnSensitives[array][scr])
{
g_ptr_array_foreach(stnSensitives[array][scr], (GFunc) _setSensitive, (gpointer) &snstv);
}
break;
case PDFSYSTEM:
if (pdfSensitives[array][scr])
{
g_ptr_array_foreach(pdfSensitives[array][scr], (GFunc) _setSensitive, (gpointer) &snstv);
}
break;
}
}
static void _setVisible(GtkWidget *widget, gboolean *visible)
{
if (widget)
{
switch(*visible)
{
case TRUE:
gtk_widget_show(widget);
break;
case FALSE:
gtk_widget_hide(widget);
break;
}
}
}
void setVisible(int system, int array, int scr, gboolean snstv)
{
switch(system)
{
case STNSYSTEM:
if (stnSensitives[array][scr])
{
g_ptr_array_foreach(stnSensitives[array][scr], (GFunc) _setVisible, (gpointer) &snstv);
}
break;
}
}
void execAdmin(GtkButton *button, gpointer nil)
{
int   numArgs;
gchar   **args;
GSpawnFlags flags = G_SPAWN_LEAVE_DESCRIPTORS_OPEN | G_SPAWN_SEARCH_PATH;
if (pqlxStates.conn.srvrNm)
{
numArgs = 3;
args = calloc(numArgs, sizeof(gchar *));
args[0] = g_strdup("pqlx-admin");
args[1] = g_strdup_printf("--dbName=%s:%s", pqlxStates.conn.srvrNm, pqlxStates.conn.dbNm);
args[2] = NULL;
}
else
{
numArgs = 2;
args = calloc(numArgs, sizeof(gchar *));
args[0] = g_strdup("pqlx-admin");
args[1] = NULL;
}
if (!g_spawn_async(NULL, args, NULL, flags, NULL, NULL, NULL, NULL))
{
fprintf(stderr, "Invocation of program 'pqlx-admin' failed, most likely due to bin directory of executable not in $PATH\n");
fprintf(stderr, "Please confirm and try again (you can test this by issuing the command 'pqlx-admin' from the command line.\n");
}
FREESTRINGS(args);
}
void bugReport(GtkButton *button, gpointer nil)
{
static GtkWidget *bugD;
if (!bugD)
{
char  *msg;
GtkWidget *content, *dialog, *label;
bugD = dialog = gtk_dialog_new_with_buttons("Technical Support",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
content = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
msg = g_strdup("\n\tTo Submit a Bug Report, please visit\t\n"
"\n\t\t<a href=\"http://wush.net/bugzilla/PQLX\" "
"title=\"PQLX Bugzilla WebSite\">PQLX Bugzilla WebSite</a>\t\n"
"\t\thttp://wush.net/bugzilla/PQLX\t\n");
label = gtk_label_new(msg);
gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
gtk_container_add(GTK_CONTAINER(content), label);
free(msg);
gtk_widget_show_all(bugD);
}
gtk_dialog_run(GTK_DIALOG(bugD));
gtk_widget_hide(bugD);
}
