#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#ifndef MAC
#include <values.h>
#endif
#include <sys/stat.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "util_externs.h"
#include "dbl_iface.h"
#define offsetS(a) ((int) ((long) &a - (long) &pdfSettings))
#define location(a) ((long) base + (int) a)
typedef struct _defaults {
char desc[20];
int  offset;
int  type;
} dfaults;
static dfaults defaults[] = 
{
{"PDFSRVR", 0, MYSTRINGPTR},
{"PDFDB", 0, MYSTRINGPTR},
{"PDFDF", 0, MYINT},
{"PDFNYQ", 0, MYINT},
{"MDISP", 0, MYINT},
{"DTRC", 0, MYINT},
{"DPDFHR", 0, MYBOOL},
{"CWBSRVR", 0, MYSTRINGPTR},
{"CWBPORT", 0, MYINT},
{"MSBC", 0, MYCOLOR},
{"DSBC", 0, MYCOLOR},
{"RSBC", 0, MYCOLOR},
{"SPMSBC", 0, MYCOLOR},
{"SPRSBC", 0, MYCOLOR},
{"SPMPERB", 0, MYBOOL},
{"SPMPDF", 0, MYBOOL},
{"SPRPERB", 0, MYBOOL},
{"SPRPDF", 0, MYBOOL},
{"SPZOOMSC", 0, MYINT},
{"SPZOOMPCT", 0, MYINT},
{"MVDISP", 0, MYBOOL},
{"MXAB", 0, MYSTRINGPTR},
{"MXABA", 0, MYBOOL},
{"MVSBC", 0, MYCOLOR},
{"MVCBC", 0, MYCOLOR},
{"MVCUM", 0, MYBOOL},
{"MSTATMIN", 0, MYBOOL},  
{"MSTATMAX", 0, MYBOOL},
{"MSTATMODE", 0, MYBOOL},
{"MSTATMEDIAN", 0, MYBOOL},
{"MSTATMEAN", 0, MYBOOL},
{"MSTAT%5", 0, MYBOOL},
{"MSTAT%10", 0, MYBOOL},
{"MSTAT%25", 0, MYBOOL},
{"MSTAT%75", 0, MYBOOL},
{"MSTAT%90", 0, MYBOOL},
{"MSTAT%95", 0, MYBOOL},
{"DSTATMIN", 0, MYBOOL},
{"DSTATMAX", 0, MYBOOL},
{"DSTATMODE", 0, MYBOOL},
{"DSTATMEDIAN", 0, MYBOOL},
{"DSTATMEAN", 0, MYBOOL},
{"DSTAT%5", 0, MYBOOL},
{"DSTAT%10", 0, MYBOOL},
{"DSTAT%25", 0, MYBOOL},
{"DSTAT%75", 0, MYBOOL},
{"DSTAT%90", 0, MYBOOL},
{"DSTAT%95", 0, MYBOOL},
{"RSTATMIN", 0, MYBOOL},
{"RSTATMAX", 0, MYBOOL},
{"RSTATMODE", 0, MYBOOL},
{"RSTATMEDIAN", 0, MYBOOL},
{"RSTATMEAN", 0, MYBOOL},
{"RSTAT%5", 0, MYBOOL},
{"RSTAT%10", 0, MYBOOL},
{"RSTAT%25", 0, MYBOOL},
{"RSTAT%75", 0, MYBOOL},
{"RSTAT%90", 0, MYBOOL},
{"RSTAT%95", 0, MYBOOL},
{"SSTATMIN", 0, MYBOOL},
{"SSTATMAX", 0, MYBOOL},
{"SSTATMODE", 0, MYBOOL},
{"SSTATMEDIAN", 0, MYBOOL},
{"SSTATMEAN", 0, MYBOOL},
{"SSTAT%5", 0, MYBOOL},
{"SSTAT%10", 0, MYBOOL},
{"SSTAT%25", 0, MYBOOL},
{"SSTAT%75", 0, MYBOOL},
{"SSTAT%90", 0, MYBOOL},
{"SSTAT%95", 0, MYBOOL},
{"END", 0, -1}
};
static void set_PDFdefaults()
{
GHashTable *dH;
int   i, j, idx, cnt=sizeof(defaults)/sizeof(dfaults);
dH = g_hash_table_new_full(g_str_hash, g_str_equal, (GDestroyNotify)free, (GDestroyNotify)free);
g_hash_table_insert(dH, g_strdup("PDFSRVR"), g_strdup_printf("%d", offsetS(pdfSettings.general.server)));
g_hash_table_insert(dH, g_strdup("PDFDB"), g_strdup_printf("%d", offsetS(pdfSettings.general.database)));
g_hash_table_insert(dH, g_strdup("PDFSTART"), g_strdup_printf("%d", offsetS(pdfSettings.general.startup)));
g_hash_table_insert(dH, g_strdup("PDFDF"), g_strdup_printf("%d", offsetS(pdfSettings.common.dateFormat)));
g_hash_table_insert(dH, g_strdup("PDFNYQ"), g_strdup_printf("%d", offsetS(pdfSettings.common.fdUnits)));
g_hash_table_insert(dH, g_strdup("MDISP"), g_strdup_printf("%d", offsetS(pdfSettings.main.display)));
g_hash_table_insert(dH, g_strdup("MXAB"), g_strdup_printf("%d", offsetS(pdfSettings.main.xAxis.string)));
g_hash_table_insert(dH, g_strdup("MXABA"), g_strdup_printf("%d", offsetS(pdfSettings.main.xAxis.active)));
g_hash_table_insert(dH, g_strdup("DTRC"), g_strdup_printf("%d", offsetS(pdfSettings.detail.trcExtract)));
g_hash_table_insert(dH, g_strdup("DPDFHR"), g_strdup_printf("%d", offsetS(pdfSettings.detail.pdfHrMode)));
g_hash_table_insert(dH, g_strdup("CWBSRVR"), g_strdup_printf("%d", offsetS(pdfSettings.detail.CWB.inetAddr)));
g_hash_table_insert(dH, g_strdup("CWBPORT"), g_strdup_printf("%d", offsetS(pdfSettings.detail.CWB.port)));
g_hash_table_insert(dH, g_strdup("MSBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.sbC[PDFMAIN].red)));
g_hash_table_insert(dH, g_strdup("DSBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.sbC[PDFDETAIL].red)));
g_hash_table_insert(dH, g_strdup("RSBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.sbC[PDFREQUEST].red)));
g_hash_table_insert(dH, g_strdup("SPMSBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.sbC[SPECTROMAIN].red)));
g_hash_table_insert(dH, g_strdup("SPRSBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.sbC[SPECTRODETREQ].red)));
g_hash_table_insert(dH, g_strdup("SPMPERB"), g_strdup_printf("%d", offsetS(pdfSettings.spmain.xAxis.active)));
g_hash_table_insert(dH, g_strdup("SPMPDF"), g_strdup_printf("%d", offsetS(pdfSettings.spmain.PDF)));
g_hash_table_insert(dH, g_strdup("SPRPERB"), g_strdup_printf("%d", offsetS(pdfSettings.spreq.xAxis.active)));
g_hash_table_insert(dH, g_strdup("SPRPDF"), g_strdup_printf("%d", offsetS(pdfSettings.spreq.PDF)));
g_hash_table_insert(dH, g_strdup("SPZOOMSC"), g_strdup_printf("%d", offsetS(pdfSettings.spreq.zoom.scope)));
g_hash_table_insert(dH, g_strdup("SPZOOMPCT"), g_strdup_printf("%d", offsetS(pdfSettings.spreq.zoom.scrollPct)));
g_hash_table_insert(dH, g_strdup("MVDISP"), g_strdup_printf("%d", offsetS(pdfSettings.movie.display)));
g_hash_table_insert(dH, g_strdup("MVSBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.sbC[PDFMOVIE].red)));
g_hash_table_insert(dH, g_strdup("MVCBC"), g_strdup_printf("%d", offsetS(pdfSettings.drawing.ctrlBar.red)));
g_hash_table_insert(dH, g_strdup("MVCUM"), g_strdup_printf("%d", offsetS(pdfSettings.movie.cumulative)));
for(idx=0; idx<cnt-1; idx++)
{
if (!strcmp(defaults[idx].desc, "MSTATMIN"))
break;
}
for(j=0; j<TTLPDFSCREENS; j++)
{
for(i=0; i<TTLPDFSTATS; i++)
{
g_hash_table_insert(dH, g_strdup(defaults[idx++].desc), g_strdup_printf("%d", offsetS(pdfSettings.common.statistics[j][i])));
}
}
for(i=0;i<cnt-1;i++)
defaults[i].offset = atoi(g_hash_table_lookup(dH, defaults[i].desc));
g_hash_table_destroy(dH);
pdfSettings.common.dateFormat = PDF_DF_4;
pdfSettings.common.fdUnits = FDUNIT_PER;
pdfSettings.main.display = PDFGROUP;
pdfSettings.main.xAxis.string = g_strdup("");
pdfSettings.main.xAxis.active = OFF;
pdfSettings.main.bline.pct = BLINEPCTDEF;
pdfSettings.detail.trcExtract = PDFDTRCPSD;
pdfSettings.detail.pdfHrMode = INCLUSIVE;
pdfSettings.spmain.xAxis.active = OFF;
pdfSettings.spmain.PDF = ON;
pdfSettings.spreq.xAxis.active = OFF;
pdfSettings.spreq.PDF = ON;
pdfSettings.spreq.zoom.scrollPct = 8;
pdfSettings.spreq.zoom.scope = ZOOMSINGLE;
pdfSettings.movie.display = MVDISP2;
pdfSettings.movie.cumulative = FALSE;
for(i=0;i<TTLMOVIESCREENS;i++)
pdfStates.movie.state[i] = PDFM_NONE;
pdfSettings.drawing.sbC[PDFMAIN].red = settings.colors.sb[TRACESCR].red;
pdfSettings.drawing.sbC[PDFMAIN].green = settings.colors.sb[TRACESCR].green;
pdfSettings.drawing.sbC[PDFMAIN].blue = settings.colors.sb[TRACESCR].blue;
pdfSettings.drawing.sbC[PDFDETAIL].red = settings.colors.sb[MAGNIFYSCR].red;
pdfSettings.drawing.sbC[PDFDETAIL].green = settings.colors.sb[MAGNIFYSCR].green;
pdfSettings.drawing.sbC[PDFDETAIL].blue = settings.colors.sb[MAGNIFYSCR].blue;
pdfSettings.drawing.sbC[PDFREQUEST].red = settings.colors.sb[SPECTRASCR].red;
pdfSettings.drawing.sbC[PDFREQUEST].green = settings.colors.sb[SPECTRASCR].green;
pdfSettings.drawing.sbC[PDFREQUEST].blue = settings.colors.sb[SPECTRASCR].blue;
pdfSettings.drawing.sbC[SPECTROMAIN].red = settings.colors.sb[SPECTRASCR].red;
pdfSettings.drawing.sbC[SPECTROMAIN].green = settings.colors.sb[SPECTRASCR].green;
pdfSettings.drawing.sbC[SPECTROMAIN].blue = settings.colors.sb[SPECTRASCR].blue;
pdfSettings.drawing.sbC[SPECTRODETREQ].red = settings.colors.sb[SPECTRASCR].red;
pdfSettings.drawing.sbC[SPECTRODETREQ].green = settings.colors.sb[SPECTRASCR].green;
pdfSettings.drawing.sbC[SPECTRODETREQ].blue = settings.colors.sb[SPECTRASCR].blue;
pdfSettings.drawing.sbC[PDFMOVIE].red = settings.colors.sb[SPECTRASCR].red;
pdfSettings.drawing.sbC[PDFMOVIE].green = settings.colors.sb[SPECTRASCR].green;
pdfSettings.drawing.sbC[PDFMOVIE].blue = settings.colors.sb[SPECTRASCR].blue;
pdfSettings.drawing.ctrlBar.red = 205*256;
pdfSettings.drawing.ctrlBar.green = 121*256;
pdfSettings.drawing.ctrlBar.blue = 222*256;
pdfSettings.common.statistics[PDFMAIN][PDFSTAT_MODE] = TRUE;
pdfSettings.common.statistics[PDFDETAIL][PDFSTAT_MODE] = TRUE;
pdfSettings.common.statistics[PDFDETAIL][PDFSTAT_P10] = TRUE;
pdfSettings.common.statistics[PDFDETAIL][PDFSTAT_P90] = TRUE;
pdfSettings.common.statistics[PDFREQUEST][PDFSTAT_MODE] = TRUE;
pdfSettings.common.statistics[PDFREQUEST][PDFSTAT_P10] = TRUE;
pdfSettings.common.statistics[PDFREQUEST][PDFSTAT_P90] = TRUE;
}
static void makeXAXISstr(PDFSETTINGS *base)
{
GSList   *iter;
XAXISBOUNDSDEF *xAxis;
char   *str1, *str2;
if (base->main.xAxis.string)
{
free(base->main.xAxis.string);
base->main.xAxis.string = g_strdup("");
}
for(iter = base->main.xAxis.defs;
iter;
iter = g_slist_next(iter))
{
xAxis = iter->data;
str1 = g_strdup_printf("%s%s%f%s%f", xAxis->chnGrp, XAXISBNDITEMSEP, 
xAxis->xAxis.bounds[PERSTART], XAXISBNDITEMSEP, 
xAxis->xAxis.bounds[PEREND]);
str2 = base->main.xAxis.string;
base->main.xAxis.string = g_strdup_printf("%s%s%s", str2, XAXISBNDSTRSEP, str1);
free(str1); free(str2);
}
}
void write_PDFdefault(int which)
{
DBLDI dbldi;
DBLRECORDS dblrecs;
int  idx, cnt=sizeof(defaults)/sizeof(dfaults);
PDFSETTINGS *base = &pdfSettings;
switch(which)
{
case XAXISBNDS:
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
makeXAXISstr(&pdfSettings);  
dbldi.descr.tableData = PDFDFAULTST;
dbldi.descr.dataEvent = WRITE_SNGL;
dbldi.data = &dblrecs;
dblrecs.numRecs = 1;
dblrecs.recs = calloc(dblrecs.numRecs, sizeof(void *));
dblrecs.recs[0] = calloc(1, sizeof(DEFAULTS_REC));
for(idx=0; idx<cnt-1; idx++)
{
if (!strcmp(defaults[idx].desc, "MXAB"))
break;
}
strncpy(((DEFAULTS_REC *) dblrecs.recs[0])->name, defaults[idx].desc, strlen(defaults[idx].desc));
sprintf(((DEFAULTS_REC *) dblrecs.recs[0])->value, "%s", (char *) *((char **) location(defaults[idx].offset)));
dbl_request(&dbldi);
free(dblrecs.recs[0]);
free(dblrecs.recs);
break;
}
} 
void write_PDFdefaults(PDFSETTINGS *base)
{
int i, cnt=sizeof(defaults)/sizeof(dfaults);
DBLDI dbldi;
DBLRECORDS dblrecs;
makeXAXISstr(base);  
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = PDFDFAULTST;
dbldi.descr.dataEvent = WRITE_ALL;
dbldi.data = &dblrecs;
dblrecs.numRecs = cnt-1;
if((dblrecs.recs = calloc(dblrecs.numRecs, sizeof(void *)))==NULL)
{
fprintf(stderr, "Out of Memory, cannot continue.\n");
exit(-1);
}
for(i=0; i<dblrecs.numRecs ;i++)
{
dblrecs.recs[i] = calloc(1, sizeof(DEFAULTS_REC));
strncpy(((DEFAULTS_REC *) dblrecs.recs[i])->name, defaults[i].desc, strlen(defaults[i].desc));
switch(defaults[i].type)
{
case MYBOOL:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d", 
*((gboolean *) location(defaults[i].offset)));
break;
case MYSHORT:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d", 
*((guint16 *) location(defaults[i].offset)));
break;
case MYINT:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d", 
*((int *) location(defaults[i].offset)));
break;
case MYFLOAT:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%f", 
*((float *) location(defaults[i].offset)));
break;
case MYSTRING:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%s", 
(char *) location(defaults[i].offset));
break;
case MYSTRINGPTR:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%s", 
(char *) *((char **) location(defaults[i].offset)));
break;
case MYCOLOR:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d %d %d", 
*((guint16 *) location(defaults[i].offset)),
*((guint16 *) location(defaults[i].offset+sizeof(guint16))),
*((guint16 *) location(defaults[i].offset+2*sizeof(guint16))));
break;
}
}
dbl_request(&dbldi);
for(i=0; i<dblrecs.numRecs ;i++)
{
free(dblrecs.recs[i]);
}
free(dblrecs.recs);
}
static gboolean validString(char *string)
{
int i;
gboolean valid = TRUE;
for (i=0;
valid && string[i] != XAXISBNDITEMSEPC; 
i++)
{
if (!isalpha(string[i]))
valid = FALSE;
}
return valid;
}
void read_PDFdefaults(PDFSETTINGS *base)
{
int i, j, cnt=sizeof(defaults)/sizeof(dfaults);
DBLDI dbldi;
DBLRECORDS dblrecs;
set_PDFdefaults();
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = PDFDFAULTST;
dbldi.descr.dataEvent = READ_ALL;
dbldi.data = &dblrecs;
dbl_request(&dbldi);
if(dblrecs.numRecs) 
{
for(j=0;j<dblrecs.numRecs;j++)
{
for(i=0;i<cnt;++i)
if (!strcmp(defaults[i].desc, ((DEFAULTS_REC *) (dblrecs.recs[j]))->name))
break;
if (i==cnt)
continue; 
switch(defaults[i].type)
{
case MYBOOL:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%d", (gboolean *) location(defaults[i].offset));
break;
case MYSHORT:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%hd", (guint16 *) location(defaults[i].offset));
break;
case MYINT:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%d", (int *) location(defaults[i].offset));
break;
case MYFLOAT:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%f", (float *) location(defaults[i].offset));
break;
case MYSTRING:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%s", (char *) location(defaults[i].offset));
break;
case MYSTRINGPTR:
*((char **) location(defaults[i].offset)) = 
g_strdup(((DEFAULTS_REC *) (dblrecs.recs[j]))->value);
break;
case MYCOLOR:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%hd %hd %hd", ((guint16 *) location(defaults[i].offset)),
((guint16 *) location(defaults[i].offset+sizeof(guint16))),
((guint16 *) location(defaults[i].offset+2*sizeof(guint16))));
break;
}
free(dblrecs.recs[j]);
}
if (dblrecs.recs)
free(dblrecs.recs);
}
{ 
GSList   *iter;
XAXISBOUNDSDEF *xAxis;
char   *chnGrp = NULL, *bounds = NULL;
for(iter = pdfSettings.main.xAxis.defs;
iter;
iter = g_slist_next(iter))
{
xAxis = iter->data;
free(xAxis->chnGrp);
for (i=0;i<TTLPERBOUNDS;i++)
free(xAxis->bounds[i]);
free(xAxis);
}
g_slist_free(pdfSettings.main.xAxis.defs);
pdfSettings.main.xAxis.defs = NULL;
if (strlen(pdfSettings.main.xAxis.string))
{ 
for(chnGrp = strtok(pdfSettings.main.xAxis.string, XAXISBNDSTRSEP);
chnGrp;
chnGrp = strtok(NULL, XAXISBNDSTRSEP))
{ 
if (!validString(chnGrp))
continue;
xAxis = calloc(1, sizeof(XAXISBOUNDSDEF));
xAxis->chnGrp = g_strdup(chnGrp);
pdfSettings.main.xAxis.defs = g_slist_append(pdfSettings.main.xAxis.defs, xAxis);
}
for(iter = pdfSettings.main.xAxis.defs;
iter;
iter = g_slist_next(iter))
{ 
xAxis = iter->data;
chnGrp = xAxis->chnGrp;
for(bounds = strtok(chnGrp, XAXISBNDITEMSEP), i = 0;
bounds;
bounds = strtok(NULL, XAXISBNDITEMSEP), i++)
{
switch(i)
{
case 0:
xAxis->chnGrp = g_strdup(bounds);
break;
default:
xAxis->bounds[i-1] = g_strdup(bounds);
xAxis->xAxis.bounds[i-1] = atof(xAxis->bounds[i-1]);
if (xAxis->xAxis.bounds[i-1] == 0.0)
{
free(xAxis->bounds[i-1]);
xAxis->bounds[i-1] = g_strdup("");
}
break;
}
}
free(chnGrp);
}
}
}
}
