#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef DBG_PDF_DETAIL
#include <sys/stat.h>
#endif
#include <sys/types.h>
#include <dirent.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
extern GtkTooltips *tips;
static char  toolTip[1000];
void plot_pdf_traces(TRACEARGS *trcArgs);
void plot_pdf_hours(GdkPixmap *pixmap, int pWidth, int pHeight);
void make_gc(GtkWidget *widget, int scr);
static gboolean plotTrcReturn(gpointer nothing)
{ 
makeDrawing(PDFDETAIL, 0, 1);  
return FALSE;      
}
static void makeMSGpdf(GdkPixmap *pxmp, int type, int w, int h)
{
char *msg;
static int fontH;
if (!fontH)
{
msg = g_strdup("TEST MSG");
fontH = fontSIZEP(msg, MSGF, HEIGHT);
free(msg);
}
switch(type)
{
case NODATA:
msg = g_strdup("No PDF Data Available");
break;
case NOCHNPDF:
msg = g_strdup("No PDF Selected");
break;
case NOSPECTROPDF:
msg = g_strdup("No PDF");
break;
case BUSY:
msg = g_strdup("Retrieving Data...");
break;
case NOSRVR:
msg = g_strdup("No PSD Server Connection");
break;
case SRVRCONNECT:
msg = g_strdup("Connecting...");
break;
case NOMOVIEPDF:
msg = g_strdup("No PDF Movie");
break;
case BUSY_MOVIE:
msg = g_strdup("Retrieving Movie Frames...");
break;
case RESIZE_MOVIE:
msg = g_strdup("Resizing Movie Frames...");
break;
case NOSPECTRO:
msg = g_strdup("No Spectro Selected");
break;
}
fontDrawP(pxmp, msg, 
w/2 - fontSIZEP(msg, MSGF, WIDTH)/2,
h/2 - fontH/2,
MSGF, PDFFMSG);
free(msg);
return;
}
static GdkPixmap *makeHist(GtkWidget *da, int scr, int row, int col)
{
GdkPixmap *pixmap;
PDFREQ  *pdfReq;
int   width = da->allocation.width, height = da->allocation.height,
dispState;
pdfReq = pdfStates.detail.pdfReq[SW];  
if (!ntwPDF)
{
dispState = STATE_NOSRVR;
}
else if (!pdfStates.detail.subPDF[0][0])
dispState = STATE_NOPDF;
else
{
if ((!pdfStates.detail.psdHr.data.numRecs && 
pdfReq->data.numRecs!=NOPSDDATA) ||
(pdfStates.detail.pdfReq[SE] &&
pdfStates.detail.pdfReq[SE]->data.numPSDs == -2))
dispState = STATE_BUSY1;
else
{
if (pdfReq->data.numRecs==NOPSDDATA)
dispState = STATE_NOPSD;
else
dispState = STATE_FINISH;
}
}
pdfStates.pmap.state[scr][row][col] = dispState;
switch(dispState)
{
case STATE_NOSRVR:
setCursor(row, col, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NOSRVR, width, height);
break;
case STATE_NOPDF: 
setCursor(row, col, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NOCHNPDF, width, height);
break;
case STATE_BUSY1:
setCursor(row, col, HG_ON);
pdfStates.detail.idleCnt++;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, BUSY, width, height);
break;
case STATE_NOPSD:
setCursor(row, col, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NODATA, width, height);
if (pdfStates.detail.idleCnt)
pdfStates.detail.idleCnt--;
break;
case STATE_FINISH:
{ 
char dispStr[25];
setCursor(row, col, HG_ON);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][ABNORMALGC], TRUE,
0, 0, width, height);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFTRCBG][ABNORMALGC], TRUE,
PDFSIDEM, PDFTOPM, width-2*PDFSIDEM, height-PDFBOTM-PDFTOPM);
plot_pdf_hours(pixmap, width, height);
strcpy(dispStr, "PSD Start Times");
fontDrawP(pixmap, dispStr, PDFSIDEM, 2, LABELF, PDFFTEXT);
pdfStates.detail.subPDF[row][col] = TRUE;
if (pdfStates.detail.idleCnt)
pdfStates.detail.idleCnt--;
setCursor(row, col, HG_OFF);
}
}
return pixmap;
}
static GdkPixmap *makeTrcs(GtkWidget *da, int scr, int row, int col)
{
GdkPixmap *pixmap;
PDFREQ  *pdfReq;
static TRACEARGS traceArgs;
int   width = da->allocation.width, height = da->allocation.height,
dispState;
pdfReq = pdfStates.detail.pdfReq[SW];  
if (!ntwPDF)
{
dispState = STATE_NOSRVR;
}
else if (!pdfStates.detail.subPDF[0][0])
dispState = STATE_NOPDF;
else
{
if (!pdfStates.detail.psdTrc.data.numRecs && 
pdfReq->data.numRecs!=NOPSDDATA)
dispState = STATE_BUSY1;
else
{
if (pdfStates.pmap.state[scr][row][col]==STATE_BUSY1)
{
if (pdfReq->data.numRecs==NOPSDDATA)
dispState = STATE_NOPSD;
else
dispState = STATE_BUSY2;
}
else
{
dispState = STATE_BUSY3;
}
}
}
pdfStates.pmap.state[scr][row][col] = dispState;
switch(dispState)
{
case STATE_NOSRVR:
setCursor(row, col, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NOSRVR, width, height);
break;
case STATE_NOPDF:
setCursor(row, col, HG_OFF);
freeDetail(NE);  
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NOCHNPDF, width, height);
break;
case STATE_NOPSD: 
setCursor(row, col, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFTRCBG][ABNORMALGC], TRUE,
0, 0, width, (PDFTOPM/2)*3);
if (!GXC[ABNORMALGC][TRACESCR])  
make_gc(da, TRACESCR);
gdk_draw_rectangle(pixmap, GXC[ABNORMALGC][TRACESCR], TRUE,
0, (PDFTOPM/2)*3, width, height-(PDFTOPM/2)*3);
makeMSGpdf(pixmap, NODATA, width, height);
if (pdfStates.detail.idleCnt)
pdfStates.detail.idleCnt--;
break;
case STATE_BUSY1: 
setCursor(row, col, HG_ON);
pdfStates.detail.idleCnt++;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, BUSY, width, height);
memset(&traceArgs, 0, sizeof(TRACEARGS));
break;
case STATE_BUSY2: 
setCursor(row, col, HG_ON);
pdfStates.detail.traceCnt[TRACECNT] = pdfStates.detail.psdTrc.data.numRecs;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, BUSY, width, height);
traceArgs.returnFunc = plotTrcReturn;
makeThread(ASYNC, (GThreadFunc) get_pdf_traces, &traceArgs, NULL);
break;
case STATE_BUSY3: 
setCursor(row, col, HG_ON);
if (pdfStates.detail.idleCnt)
pdfStates.detail.idleCnt--;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFTRCBG][ABNORMALGC], TRUE,
0, 0, width, (PDFTOPM/2)*3);
if (!GXC[ABNORMALGC][TRACESCR])  
make_gc(da, TRACESCR);
gdk_draw_rectangle(pixmap, GXC[ABNORMALGC][TRACESCR], TRUE,
0, (PDFTOPM/2)*3, width, height-(PDFTOPM/2)*3);
if (pdfSettings.detail.trcExtract != PDFDTRCNOPLOT &&
pdfStates.detail.traceCnt[VALIDTRC])
{ 
traceArgs.pixmap = pixmap;
traceArgs.dims[PMW] = width;
traceArgs.dims[PMH] = height - (PDFTOPM/2)*3;
traceArgs.dims[PMM] = (PDFTOPM/2)*3;
traceArgs.callType = SYNC;
traceArgs.returnFunc = plotTrcReturn;
plot_pdf_traces(&traceArgs);
}
{
int  anchor, w, h, total, unavail, avail;
char msg[100], cnt[20];
switch(pdfSettings.detail.trcExtract)
{
case PDFDTRCNOPLOT:
{
total = pdfStates.detail.traceCnt[TRACECNT];
unavail = pdfStates.detail.traceCnt[TRACECNT] - 
pdfStates.detail.traceCnt[VALIDTRC];
avail = pdfStates.detail.traceCnt[VALIDTRC];
strcpy(msg, "Total Traces Identified - None Plotted");
}
break;
case PDFDTRCENTIRE:
{
total = pdfStates.detail.traceCnt[TRACECNT];
unavail = pdfStates.detail.traceCnt[TRACECNT] - 
pdfStates.detail.traceCnt[VALIDTRC];
avail = pdfStates.detail.traceCnt[VALIDTRC];
strcpy(msg, "Total Traces Identified");
}
break;
case PDFDTRCPSD:
total = pdfStates.detail.psdHr.data.numRecs;
unavail = pdfStates.detail.psdHr.data.numRecs - g_slist_length(pdfStates.detail.trcList);
avail = g_slist_length(pdfStates.detail.trcList);
strcpy(msg, "Total PSD Extracts Identified");
break;
}
sprintf(cnt, "%d", total);
w = fontSIZEP(cnt, LABELF, WIDTH);
anchor = PDFTRCMARG + w + PDFTRCSEP/2;
fontDrawP(pixmap, cnt, anchor-PDFTRCSEP/2-w, 2, LABELF, PDFFTRC);
fontDrawP(pixmap, msg, anchor+PDFTRCSEP/2, 2, LABELF, PDFFTRC);
sprintf(cnt, "%d", unavail);
w = fontSIZEP(cnt, LABELF, WIDTH);
h = fontSIZEP(cnt, LABELF, HEIGHT) + 2;
fontDrawP(pixmap, cnt, anchor-PDFTRCSEP/2-w, h, LABELF, PDFFTRC);
strcpy(msg, "Unavailable");   
fontDrawP(pixmap, msg, anchor+PDFTRCSEP/2, h, LABELF, PDFFTRC);
sprintf(cnt, "%d", avail);
w = fontSIZEP(cnt, LABELF, WIDTH);
h = fontSIZEP(cnt, LABELF, HEIGHT)*2 + 2;
fontDrawP(pixmap, cnt, anchor-PDFTRCSEP/2-w, h, LABELF, PDFFTRC);
strcpy(msg, "Available");   
fontDrawP(pixmap, msg, anchor+PDFTRCSEP/2, h, LABELF, PDFFTRC);
}
pdfStates.pmap.state[scr][row][col] = STATE_BUSY1;
pdfStates.detail.subPDF[row][col] = TRUE;
setCursor(row, col, HG_OFF);
break;
}
return pixmap;
}
static GdkPixmap *makeSpectro(GtkWidget *da, int scr, int row, int col)
{
GdkPixmap *pixmap;
int   width = da->allocation.width, height = da->allocation.height;
int   ctxtType, dispState;
SPECREQ  *specReq = &pdfStates.spdetreq.specReq[row][col];
graph  *gr;
switch (scr)
{
case SPECTROMAIN:
specReq = &pdfStates.spmain.specReq[row][0];
gr = &pdfStates.spmain.specGR[row][0];
break;
case SPECTRODETREQ:
specReq = &pdfStates.spdetreq.specReq[row][0];
gr = &pdfStates.spdetreq.specGR[row][0];
break;
}
pdfStates.pmap.state[scr][row][col] = STATE_NOSPECTRO;
if (!ntwPDF)
{
if (pqlxStates.conn.state == SRVRCONNECTING)
dispState = STATE_SRVRCNCT;
else
dispState = STATE_NOSRVR;
}
else if (!specReq->keys.chnKey || 
(scr == SPECTROMAIN && 
!pdfStates.spmain.group.pdfKey))
dispState = STATE_NOSPECTRO;
else
{
if (!specReq->data.numRecs)
dispState = STATE_BUSY1;
else
{
switch(specReq->data.numRecs)
{
case NOPSDDATA:
dispState = STATE_NOPSD;
break;
case NOPSDBADSR:
dispState = STATE_BADSR;
break;
default:
dispState = STATE_FINISH;
break;
}
}
}
pdfStates.pmap.state[scr][row][col] = dispState;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
switch (dispState)
{
case STATE_NOPSD:
case STATE_FINISH:
case STATE_BADSR:
ctxtType = PDFTEXT;
break;
default:
ctxtType = PDFMSG;
break;
}
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[ctxtType][ABNORMALGC], TRUE, 0, 0, width, height);
switch(dispState)
{
case STATE_SRVRCNCT:
setCursor(row, col, HG_ON);
makeMSGpdf(pixmap, SRVRCONNECT, width, height);
break;
case STATE_NOSRVR:
setCursor(row, col, HG_OFF);
makeMSGpdf(pixmap, NOSRVR, width, height);
strcpy(toolTip, "To Select A Server, Use the Servers Button on the Side-Panel of the Main Tab");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, toolTip, toolTip);
break;
case STATE_NOSPECTRO:
setCursor(row, col, HG_OFF);
makeMSGpdf(pixmap, NOSPECTRO, width, height);
strcpy(toolTip, "To Select a Spectrogram, From the Side Panel:"
"\n\tMake a Selection Using the Request Button");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, toolTip, toolTip);
break;
case STATE_BUSY1: 
setCursor(row, col, HG_ON);
makeMSGpdf(pixmap, BUSY, width, height);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, "", "");
if (!specReq->busy)
{
g_idle_add((GSourceFunc) idlePDF, GINT_TO_POINTER(REFNUM(scr, row, col)));
specReq->busy = TRUE;
}
break;
case STATE_NOPSD:
case STATE_FINISH:
case STATE_BADSR:
{
PLOTPDFARGS plotPDFArgs;
memset(&plotPDFArgs, 0, sizeof(PLOTPDFARGS));
setCursor(row, col, HG_ON);
specReq->busy = FALSE;
if ((scr == SPECTRODETREQ) &&
pdfSettings.spreq.PDF &&
specReq->plot.replot)
{ 
SPECTROPDF(row);  
}
plotPDFArgs.pmap = pixmap;
plotPDFArgs.req = (gpointer) specReq;
plotPDFArgs.width = width;
plotPDFArgs.height = height;
plotPDFArgs.type = SPECTROPLOT;
plotPDFArgs.scr = scr;
plotPDFArgs.dateFmt = pdfSettings.common.dateFormat;
plotPDFArgs.fdUnits = pdfSettings.common.fdUnits;
setPeriodBounds(specReq->keys.chnKey, &plotPDFArgs.xAxis);
plotSPECTRO(&plotPDFArgs);
if (dispState == STATE_FINISH)
{
GList  *start = specReq->plot.start ? specReq->plot.start : specReq->data.spectro;
SPECTRODATA *spectroData = start->data;
viewport(gr, PDFSIDEM, width-PDFSIDEM, PDFTOPM, height-PDFBOTM);
window(gr, (double) spectroData->psdRef, (double) spectroData->psdRef + specReq->plot.numDivs, 
(double) specReq->data.yBounds[YMIN], (double) specReq->data.yBounds[YMAX], 
FALSE, 0);
}
setCursor(row, col, HG_OFF);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, "", "");
}
break;
}
return pixmap;
}
static GdkPixmap *makePDF(GtkWidget *da, int scr, int row, int col)
{
GdkPixmap *pixmap;
graph  *gr;
PDFREQ  *pdfReq;
static gboolean busyReq[MMAXPDFROWS][MMAXPDFCOLS];
static IDXTMPARGS idxArgs;
int   width = da->allocation.width, height = da->allocation.height;
int   ctxtType, dispState;
float  *perB;
gboolean idlePDFcall=TRUE, tmpTbl=FALSE;
if (!(pdfSettings.drawing.ctxts[PDFMSG][NORMALGC]))
{
make_pdf_gc(da);
initPDFFont();
}
switch(scr)
{
case PDFMAIN:
pdfReq = &pdfStates.main.pdfReq[pdfSettings.main.display][row][col];
gr = &pdfStates.main.gr[pdfSettings.main.display][row][col];
perB = (float *) &pdfStates.main.perB[pdfSettings.main.display][row][col];
break;
case PDFDETAIL:
pdfReq = pdfStates.detail.pdfReq[row];
gr = &pdfStates.detail.gr[row][col];
perB = (float *) &pdfStates.detail.perB[row][col];
if (pdfReq && row == 0)
tmpTbl = !pdfReq->keys.tmpFilled;
switch(row)
{
case 0:
idlePDFcall = TRUE;
break;
case 1:
idlePDFcall = FALSE;
break;
}
break;
case PDFREQUEST:
pdfReq = &pdfStates.request.pdfReq[row][col];
gr = &pdfStates.request.gr[row][col];
perB = (float *) &pdfStates.request.perB[row][col];
break;
case SPECTROMAIN:
pdfReq = &pdfStates.spmain.pdfReq[row][0];
gr = &pdfStates.spmain.pdfGR[row][0];
perB = (float *) &pdfStates.spmain.perB[row][col];
break;
case SPECTRODETREQ:
pdfReq = &pdfStates.spdetreq.pdfReq[row][0];
gr = &pdfStates.spdetreq.pdfGR[row][0];
perB = (float *) &pdfStates.spdetreq.perB[row][col];
break;
}
if (!ntwPDF)
{
if (pqlxStates.conn.state == SRVRCONNECTING)
dispState = STATE_SRVRCNCT;
else
dispState = STATE_NOSRVR;
}
else if (!pdfReq || !pdfReq->keys.chnKey || !pdfReq->keys.pdfKey)
dispState = STATE_NOPDF;
else
{
if (!pdfReq->data.numRecs)
dispState = STATE_BUSY1;
else
{
switch(pdfReq->data.numRecs)
{
case NOPSDDATA:
dispState = STATE_NOPSD;
break;
case NOPSDBADSR:
dispState = STATE_BADSR;
break;
default:
dispState = STATE_FINISH;
break;
}
}
}
pdfStates.pmap.state[scr][row][col] = dispState;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
switch (dispState)
{
case STATE_NOPSD:
case STATE_FINISH:
case STATE_BADSR:
ctxtType = PDFTEXT;
break;
default:
ctxtType = PDFMSG;
break;
}
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[ctxtType][ABNORMALGC], TRUE, 0, 0, width, height);
switch(dispState)
{
case STATE_SRVRCNCT:
setCursor(row, col, HG_ON);
makeMSGpdf(pixmap, SRVRCONNECT, width, height);
break;
case STATE_NOSRVR:
setCursor(row, col, HG_OFF);
makeMSGpdf(pixmap, NOSRVR, width, height);
strcpy(toolTip, "To Select A Server, Use the Servers Button on the Side-Panel of the Main Tab");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, toolTip, toolTip);
break;
case STATE_NOPDF:
setCursor(row, col, HG_OFF);
switch (scr)
{
case SPECTROMAIN:
case SPECTRODETREQ: 
makeMSGpdf(pixmap, NOSPECTROPDF, width, height);
break;
default:
makeMSGpdf(pixmap, NOCHNPDF, width, height);
strcpy(toolTip, "To Select a PDF, From the Side Panel:"
"\n\tSelect the Appropriate Combinations"
"\n\tof PDF's, Stations, and/or Channels");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, toolTip, toolTip);
break;
}
break;
case STATE_BUSY1: 
setCursor(row, col, HG_ON);
makeMSGpdf(pixmap, BUSY, width, height);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, "", "");
if (idlePDFcall &&
!pdfReq->busy)
{
g_idle_add((GSourceFunc) idlePDF, GINT_TO_POINTER(REFNUM(scr, row, col)));
pdfReq->busy = TRUE;
if (scr == PDFMAIN)
busyReq[row][col] = TRUE;
}
if (scr == PDFDETAIL)
pdfStates.detail.idleCnt++;
break;
case STATE_NOPSD:
case STATE_FINISH:
case STATE_BADSR:
{
PLOTPDFARGS plotPDFArgs;
memset(&plotPDFArgs, 0, sizeof(PLOTPDFARGS));
setCursor(row, col, HG_ON);
if (scr == PDFMAIN)
busyReq[row][col] = FALSE;
pdfReq->busy = FALSE;
if (tmpTbl)
{ 
idxArgs.table = IDXTMPTBL1;
idxArgs.reqType = SUBPDF;
g_idle_add((GSourceFunc) idleTMP, (gpointer) &idxArgs);
}
plotPDFArgs.pmap = pixmap;
plotPDFArgs.req = (gpointer) pdfReq;
plotPDFArgs.width = width;
plotPDFArgs.height = height;
plotPDFArgs.scr = scr;
plotPDFArgs.type = PDFPLOT;
plotPDFArgs.hlnm = TRUE;
#if 0
plotPDFArgs.fdUnits = pdfSettings.common.fdUnits;
plotPDFArgs.dateFmt = pdfSettings.common.dateFormat;
plotPDFArgs.blines = PSDblineCtrlR;
#endif
pdfPrep(PDF_P_DISP, pdfReq, &plotPDFArgs, scr, row, col);
setPeriodBounds(pdfReq->keys.chnKey, &plotPDFArgs.xAxis);
plotPDF(&plotPDFArgs);
if (dispState == STATE_FINISH)
{
perB[PERSTART] = plotPDFArgs.xAxis.bounds[PERSTART];
perB[PEREND] = plotPDFArgs.xAxis.bounds[PEREND];
viewport(gr, PDFSIDEM, width-PDFSIDEM, PDFTOPM, height-PDFBOTM);
switch (pdfSettings.common.fdUnits)
{
case FDUNIT_FREQ:
window(gr, (double) perB[PEREND], (double) perB[PERSTART], 
(double) pdfReq->keys.yBounds[YMIN], (double) pdfReq->keys.yBounds[YMAX], TRUE, 0);
break;
case FDUNIT_PER:
window(gr, (double) perB[PERSTART], (double) perB[PEREND], 
(double) pdfReq->keys.yBounds[YMIN], (double) pdfReq->keys.yBounds[YMAX], TRUE, 0);
break;
}
}
setCursor(row, col, HG_OFF);
if (scr == PDFDETAIL &&
pdfStates.detail.idleCnt)
pdfStates.detail.idleCnt--;
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), da, "", "");
}
break;
}
switch(scr)
{
GdkPixmap *cbpmap;
int   w, h;
case PDFMAIN:
{
int  i, j;
gboolean outstanding = FALSE;
for (i = 0; i < MMAXPDFROWS; i ++)
for (j = 0; j < MMAXPDFROWS; j ++)
if (busyReq[i][j])
outstanding = TRUE;
if (!outstanding)
{
setSensitive(PDFSYSTEM, PDFDATABUSYSENS, PDFMAIN, TRUE);
}
}
break;
case PDFDETAIL:
{
if (width && (row==1&&col==0) &&
dispState == STATE_FINISH)
pdfStates.detail.subPDF[row][col] = TRUE;
if (pdfStates.pmap.state[scr][row][col] == STATE_FINISH)
{ 
w = PDFSIDEM-5;
h = height - (PDFTOPM + PDFBOTM);
cbpmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_rectangle(cbpmap, pdfSettings.drawing.ctxts[PDFTEXT][ABNORMALGC], 
TRUE, 0, 0, w, h);
colorBar(cbpmap, w, h);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_WIDGET_STATE (da)], cbpmap, 0, 0, 
width-PDFSIDEM+3, PDFTOPM, -1, -1);
g_object_unref(cbpmap);
}
}
break;
}
return pixmap; 
}
static GdkPixmap *makePDFMovie(GtkWidget *da, int screen)
{
GdkPixmap *pixmap;
int   width = da->allocation.width, height = da->allocation.height, dispState;
int   row = screen;
long  daAddr = (long) da;
PDFFILM  *pdfFilm = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
if (!ntwPDF)
{
if (pqlxStates.conn.state == SRVRCONNECTING)
dispState = STATE_SRVRCNCT;
else
dispState = STATE_NOSRVR;
}
else if (!pdfFilm)
dispState = STATE_NOPDF;
else if (pdfStates.movie.resize[screen])
dispState = STATE_MVRESIZE;
else if (pdfStates.movie.count[screen][PDFM_FRAMENUM] < pdfStates.movie.count[screen][PDFM_TTLFRAMES])
dispState = STATE_BUSY1;
else
dispState = STATE_FINISH;
pdfStates.pmap.mState[screen] = dispState;
switch(dispState)
{
case STATE_SRVRCNCT:
setCursor(row, row, HG_ON);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, SRVRCONNECT, width, height);
break;
case STATE_NOSRVR:
setCursor(row, row, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NOSRVR, width, height);
break;
case STATE_NOPDF:
setCursor(row, row, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, NOMOVIEPDF, width, height);
break;
case STATE_MVRESIZE:
setCursor(row, row, HG_OFF);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, RESIZE_MOVIE, width, height);
break;
case STATE_BUSY1: 
setCursor(row, row, HG_ON);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGpdf(pixmap, BUSY_MOVIE, width, height);
break;
case STATE_FINISH:
{
PDFFILM *film;
PDFFILMFRAME *frame;
setCursor(row, row, HG_OFF);
film = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
frame = g_hash_table_lookup(film->frames, &film->frameNo);
pixmap = frame->pmap;
}
break;
}
return pixmap;
}
void makeDrawing(int scr, int row, int col)
{
GtkWidget *da;
int   width, height;
dispMsgPDF(UNDISPLAY, NULL);
switch(scr)
{
case PDFMAIN:   
da = MPDFDA[row][col];
break;
case PDFDETAIL:   
da = DPDFDA[row][col];
break;
case PDFREQUEST:  
da = RPDFDA[row][col];
break;
case PDFMOVIE:   
da = MVPDFDA[row];
break;
case SPECTROMAIN:  
da = SPMAINDA[row][col];
break;
case SPECTRODETREQ:  
da = SPREQDA[row][col];
break;
}
if (!da->window ||
pqlxStates.system != PDFSYSTEM)
{
return;
}
width = da->allocation.width;
height = da->allocation.height;
switch(scr)
{
case PDFMAIN:  
pdfStates.main.plotW[row][col][WIDTH] = width;
pdfStates.main.plotW[row][col][HEIGHT] = height;
if (pdfStates.pmap.main[pdfSettings.main.display][row][col])
{
g_object_unref(pdfStates.pmap.main[pdfSettings.main.display][row][col]);
pdfStates.pmap.main[pdfSettings.main.display][row][col] = NULL;
}
pdfStates.pmap.main[pdfSettings.main.display][row][col] = makePDF(da, scr, row, col);
break;
case PDFDETAIL:  
pdfStates.detail.plotW[row][col][WIDTH] = width;
pdfStates.detail.plotW[row][col][HEIGHT] = height;
switch(col)
{
case 0:  
switch(row)
{
case 0:
if (pdfStates.pmap.detail[row][col])
{
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
pdfStates.pmap.detail[row][col] = makePDF(da, scr, row, col);
break;
case 1:
if (pdfStates.pmap.detail[row][col])
{
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
pdfStates.pmap.detail[row][col] = makePDF(da, scr, row, col);
break;
}
break;
case 1:  
switch(row)
{
case 1: 
if (pdfStates.pmap.detail[row][col])
{
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
pdfStates.pmap.detail[row][col] = makeHist(da, scr, row, col);
break;
case 0: 
if (pdfStates.pmap.detail[row][col])
{
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
pdfStates.pmap.detail[row][col] = makeTrcs(da, scr, row, col);
break;
}
break;
}
if (pdfStates.detail.idleCnt == 0)
{
setSensitive(PDFSYSTEM, PDFDATABUSYSENS, PDFDETAIL, TRUE);
pdfStates.detail.idleCnt = NONE;
}
break;
case PDFREQUEST:  
pdfStates.request.plotW[row][col][WIDTH] = width;
pdfStates.request.plotW[row][col][HEIGHT] = height;
if (pdfStates.pmap.request[row][col])
{
g_object_unref(pdfStates.pmap.request[row][col]);
pdfStates.pmap.request[row][col] = NULL;
}
pdfStates.pmap.request[row][col] = makePDF(da, scr, row, col);
break;
case PDFMOVIE:
{
FILMRESIZE *filmR;
int screen = row;
if (pdfStates.movie.plotW[row][WIDTH] &&
(pdfStates.movie.plotW[row][WIDTH] != width ||
pdfStates.movie.plotW[row][HEIGHT] != height))
{ 
pdfStates.movie.plotW[screen][WIDTH] = width;
pdfStates.movie.plotW[screen][HEIGHT] = height;
switch(pdfStates.movie.state[screen])
{ 
case PDFM_BACKWARD:
case PDFM_FORWARD:
movieCmd(screen, PDFM_PAUSE, pdfStates.movie.state[screen]);
break;
}
filmR = calloc(1, sizeof(FILMRESIZE));
filmR->screen = screen;
filmR->frameNo = 0;
if (pdfStates.movie.resize[screen])
{ 
if (!resizeQ[screen])
resizeQ[screen] = g_queue_new();
g_queue_push_tail(resizeQ[screen], filmR);
}
else
{ 
pdfStates.movie.resize[screen] = TRUE;
g_idle_add((GSourceFunc) resizeMovie, filmR);
}
}
else if (resizeQ[screen] &&
!g_queue_is_empty(resizeQ[screen]))
{ 
FILMRESIZE *fR;
pdfStates.movie.resize[screen] = TRUE;
while((fR = g_queue_pop_head(resizeQ[screen])))
{ 
filmR = fR;
}
g_idle_add((GSourceFunc) resizeMovie, filmR);
}
pdfStates.movie.plotW[screen][WIDTH] = width;
pdfStates.movie.plotW[screen][HEIGHT] = height;
if (pdfStates.pmap.movie[row])
{
if (G_IS_OBJECT(pdfStates.pmap.movie[screen]))
g_object_unref(pdfStates.pmap.movie[screen]);
pdfStates.pmap.movie[screen] = NULL;
}
pdfStates.pmap.movie[screen] = makePDFMovie(da, screen);
}
break;
case SPECTROMAIN:  
if (pdfStates.pmap.spmain[row][col])
{
g_object_unref(pdfStates.pmap.spmain[row][col]);
pdfStates.pmap.spmain[row][col] = NULL;
}
switch (col)
{
case COLPDF:
if (pdfSettings.spmain.PDF)
pdfStates.pmap.spmain[row][col] = makePDF(da, scr, row, col);
break;
case COLSPEC:
pdfStates.pmap.spmain[row][col] = makeSpectro(da, scr, row, col);
break;
}
break;
case SPECTRODETREQ:  
if (pdfStates.pmap.spreq[row][col])
{
g_object_unref(pdfStates.pmap.spreq[row][col]);
pdfStates.pmap.spreq[row][col] = NULL;
}
switch (col)
{
case COLPDF:
if (pdfSettings.spreq.PDF)
pdfStates.pmap.spreq[row][col] = makePDF(da, scr, row, col);
break;
case COLSPEC:
pdfStates.pmap.spreq[row][col] = makeSpectro(da, scr, row, col);
break;
}
break;
}
gtk_widget_queue_draw_area(da, 0, 0, width, height); 
}
gboolean _makeDrawing(gpointer r)
{ 
int  row = GPOINTER_TO_INT(r), col = COLPDF;
makeDrawing(SPECTRODETREQ, row, col);
return FALSE;
}
