#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
int ms_doy2md(int year, int jday, int *month, int *mday);
gboolean PDF_cfg(GtkWidget *widget, GdkEventConfigure *event, gpointer s)
{ 
int scr = GPOINTER_TO_INT(s);
int screen = (scr)/MAXNUMBERS;
int row, col, base = (scr - screen*MAXNUMBERS);
switch(screen)
{
case PDFMOVIE:
row = base;
col = 0;
break;
default: 
row = ROWNUM(base);
col = COLNUM(base);
break;
}
if (!topLevel)
{
topLevel = gdk_window_get_toplevel(widget->window);
hourCursor = gdk_cursor_new_for_display(gdk_display_get_default (), GDK_WATCH);
}
if (widget->allocation.height==1 || 
pqlxStates.system != PDFSYSTEM)
return TRUE;     
makeDrawing(screen, row, col);
return TRUE;
}
gboolean PDF_exp(GtkWidget *widget, GdkEventExpose *event, gpointer s)
{ 
int   scr = GPOINTER_TO_INT(s);
GdkPixmap *pixmap;
int screen = (scr)/MAXNUMBERS;
int row, col, base = (scr - screen*MAXNUMBERS);
if (!widget->window)
return TRUE;
switch(screen)
{
case PDFMOVIE:
row = base;
col=0;
break;
default:  
row = ROWNUM(base);
col = COLNUM(base);
break;
}
switch(screen)
{
case PDFMAIN:
pixmap = pdfStates.pmap.main[pdfSettings.main.display][row][col];
break;
case PDFDETAIL:
pixmap = pdfStates.pmap.detail[row][col];
break;
case PDFREQUEST:
pixmap = pdfStates.pmap.request[row][col];
break;
case PDFMOVIE:
pixmap = pdfStates.pmap.movie[row];
break;
case SPECTROMAIN:
pixmap = pdfStates.pmap.spmain[row][col];
break;
case SPECTRODETREQ:
pixmap = pdfStates.pmap.spreq[row][col];
break;
}
if (!pixmap)  
return TRUE;
gdk_draw_drawable(widget->window,
widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
pixmap,
event->area.x, event->area.y,
event->area.x, event->area.y,
event->area.width, event->area.height);
return TRUE;
}
#define MAXROWS 3
#define MAXCOLS 3
void setCursor(int row, int col, gboolean state)
{
static GdkCursor *args[2];
static gboolean states[TTLPDFSCREENS][MAXROWS][MAXCOLS];
static gboolean oldState;
gboolean newState;
int  screen = pdfStates.screen, i, j;
if (!args[1])
{
args[0] = NULL;
args[1] = hourCursor;
}
states[screen][row][col] = state;
newState = HG_OFF;
for (i = 0; i < MAXROWS; i++)
{
for (j = 0; j < MAXCOLS; j++)
{
if (states[screen][i][j])
{
newState = HG_ON;
break;
}
}
}
if (newState == oldState)
return;
oldState = newState;
gdk_window_set_cursor(topLevel, args[newState]);
}
void restore_PDFdefaults(GtkButton *widget, gpointer nothing)
{
read_PDFdefaults(&pdfSettings);
setPdfCtrlSettings();
}
void save_PDFdefaults(GtkButton *button, PDFSETTINGS *save)
{
getPdfCtrlSettings();
write_PDFdefaults(save);
if (pdfSettings.general.startup)
setSystemStartup(PDFSYSTEM);
}
void RReqChg(GtkToggleButton *button, gpointer d)
{ 
int  disp = GPOINTER_TO_INT(d);
int value = gtk_toggle_button_get_active((GtkToggleButton *) button);
if (value != TRUE)
return;
switch(disp)
{
case REQAGO:
gtk_widget_hide(rMDF);
gtk_widget_hide(rYRF);
gtk_widget_hide(rFREQF);
gtk_widget_show(rAGOF);
break;
case REQFREQ:
gtk_widget_hide(rAGOF);
gtk_widget_show(rYRF);
gtk_widget_show(rFREQF);
gtk_widget_show(rMDF);
break;
case REQRANGE:
gtk_widget_hide(rFREQF);
gtk_widget_hide(rAGOF);
gtk_widget_show(rYRF);
gtk_widget_show(rMDF);
break;
}
pdfStates.request.req.reqType = disp;
return;
}
void MDispChg(GtkToggleButton *button, gpointer d)
{ 
int  disp = GPOINTER_TO_INT(d);
int i, j;
int value = gtk_toggle_button_get_active((GtkToggleButton *) button);
if (value != TRUE)
return;
for (i=0;i<NUMPDFMAINDISPLAYMODES;i++)
{
if (i!=disp)
gtk_widget_hide(MButtons[i]);
}
pdfSettings.main.display = disp;
gtk_widget_show(MButtons[disp]);
for(i=0;i<MMAXPDFROWS;i++)
for(j=0;j<MMAXPDFCOLS;j++)
makeDrawing(PDFMAIN, i, j);
return;
}
enum {
OLDTAB,
NEWTAB,
TTLTABS
};
void changeTabPDF(GtkNotebook *notebook, GtkWidget *page, guint newTab, gpointer w)
{ 
static int lastScreen[TTLPSDNB] = {PDFMAIN, SPECTROMAIN}, lastNB = NONE;
int which = GPOINTER_TO_INT(w), tab[TTLTABS];
if (lastNB == NONE)
{ 
if (which == TTLPSDNB)
lastNB = PDFNB;
return;
}
switch (which)
{
case PDFNB:   
case SPECTRONB:  
tab[OLDTAB] = lastScreen[which];
lastScreen[which] = newTab + (which == SPECTRONB ? TTLPDFTABS : 0);
tab[NEWTAB] = lastScreen[which];
break;
case TTLPSDNB:  
tab[OLDTAB] = lastScreen[lastNB];
tab[NEWTAB] = lastScreen[newTab];
pdfStates.system = lastNB = newTab;
break;
}
if (tab[NEWTAB] == tab[OLDTAB])
return;  
gtk_widget_hide(PSDsb[tab[OLDTAB]]);
pdfStates.screen = tab[NEWTAB];
gtk_widget_show(PSDsb[tab[NEWTAB]]);
}
void radioOption(GtkToggleButton *button, gpointer w)
{ 
int which = GPOINTER_TO_INT(w);
switch(which)
{
case RSPDF:
{
int row, scr = pdfStates.screen;
gboolean *pdf;
switch (scr)
{
case SPECTROMAIN:
pdf = &pdfSettings.spmain.PDF;
break;
case SPECTRODETREQ:
pdf = &pdfSettings.spreq.PDF;
break;
}
*pdf = gtk_toggle_button_get_active(button);
if (*pdf)
{
for (row = 0;
row < SMAXROWS;
row++)
{
switch (scr)
{
case SPECTROMAIN:
gtk_widget_queue_resize(SPMAINDA[row][COLPDF]);
break;
case SPECTRODETREQ:
SPECTROPDF(row); 
break;
}
}
}
*pdf ? gtk_widget_show(pdfPane[SPECTROTAB(scr)]) : gtk_widget_hide(pdfPane[SPECTROTAB(scr)]);
}
break;
case RDPDFHR:
pdfSettings.detail.pdfHrMode = gtk_toggle_button_get_active(button);
break;
}
}
void pdfRadioB3_chg(GtkWidget *radio, gpointer g)
{ 
int  group = GPOINTER_TO_INT(g);
int  i, totRadios;
GtkWidget **groupW;
if (!gtk_toggle_button_get_active((GtkToggleButton *) radio))
return;    
switch(group)
{
case TRCEXTRACT:
groupW = pdfTrcW;
totRadios = MAXTRCEXTRACTS;
break;
}
for(i=0;i<totRadios;i++)
{
if(radio == groupW[i])
break;
}
switch(group)
{
case TRCEXTRACT:
pdfSettings.detail.trcExtract = i;
break;
} 
}
void clearDispList()
{
GList *iter;
for(iter = pdfStates.detail.dispList; 
iter; 
iter = g_list_next(iter))
{ 
freePDF(iter->data, FALSE);
if (iter->data)
free(iter->data);
}
g_list_free(pdfStates.detail.dispList);
pdfStates.detail.dispList = NULL;
pdfStates.detail.disp = NULL;
} 
static void freeDispList(GList *elem)
{
GList *iter;
for(iter = g_list_last(pdfStates.detail.dispList); 
iter != elem; 
iter = g_list_last(pdfStates.detail.dispList))
{ 
freePDF(iter->data, FALSE);
if (iter->data)
free(iter->data);
pdfStates.detail.dispList = g_list_delete_link(pdfStates.detail.dispList, iter);
}
} 
static void getStats(PDFREQ *pdfReq)
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = PDFSTATLINES;
sqldi.data = pdfReq;
db_request(&sqldi);
}
void PDFinitDetail(PDFREQ *pdfPtr, gboolean insert)
{
PDFREQ *pdfReq;
int  i, j, pdfNum;
char *markup;
GList *iter;
if (pqlxStates.system != PDFSYSTEM)
{ 
clearDispList();
pqlxStates.system = PDFSYSTEM;
}
pdfReqCopy(&pdfReq, pdfPtr);
memcpy(&pdfReq->keys.statistics, &pdfSettings.common.statistics[PDFDETAIL], 
sizeof(pdfSettings.common.statistics[PDFDETAIL]));
getStats(pdfReq);
freeDetail(ALLCELLS);
switch(insert)
{
case TRUE:
{
PDFREQ *pdfReq1;
if (pdfStates.detail.dispList &&
pdfStates.detail.disp != g_list_last(pdfStates.detail.dispList))
freeDispList(pdfStates.detail.disp);
pdfReqCopy(&pdfReq1, pdfReq);
if (pdfReq1->keys.pdfKey == SUBPDF)
{
pdfReq1->keys.pdfKey = CUSTOMPDF;
}
getStats(pdfReq1);
pdfStates.detail.dispList = g_list_append(pdfStates.detail.dispList, pdfReq1);
pdfStates.detail.disp = g_list_last(pdfStates.detail.dispList);
}
break;
}
pdfStates.detail.pdfReq[NW] = pdfReq;
pdfStates.detail.subPDF[0][0] = FALSE;
for (i=0;i<DMAXPDFROWS;i++)
for (j=0;j<DMAXPDFCOLS;j++)
makeDrawing(PDFDETAIL, i, j);
for(pdfNum = 1, iter=pdfStates.detail.dispList;
iter != pdfStates.detail.disp;
iter = g_list_next(iter))
{
pdfNum++;
}
markup = g_markup_printf_escaped("<span weight=\"bold\" foreground=\"white\"> PDF# %d</span>", pdfNum);
gtk_label_set_markup(GTK_LABEL(pdfDtailCnt), markup); 
g_free(markup);
return;
}
void DDispMv(GtkToggleButton *button, gpointer d)
{ 
int  dir = GPOINTER_TO_INT(d);
PDFREQ *pdfReq;
if (!pdfStates.detail.disp)
return;
switch(dir)
{
case DTLBACK:
pdfStates.detail.disp = g_list_previous(pdfStates.detail.disp);
if (!pdfStates.detail.disp)
{ 
pdfStates.detail.disp = pdfStates.detail.dispList;
gdk_beep();
return;
}
pdfReq = pdfStates.detail.disp->data;
break;
case DTLFORW:
pdfStates.detail.disp = g_list_next(pdfStates.detail.disp);
if (!pdfStates.detail.disp)
{ 
pdfStates.detail.disp = g_list_last(pdfStates.detail.dispList);
gdk_beep();
return;
}
pdfReq = pdfStates.detail.disp->data;
break;
}
pdfReq->keys.tmpFilled = FALSE;
PDFinitDetail(pdfReq, FALSE);
}
static void mergeCrit(PDFREQ *to, PDFREQ *from)
{
int i;
for (i=0; i<MAXNUMPDFREQCRIT;i++)
if (!to->keys.criteria[i])
to->keys.criteria[i] = from->keys.criteria[i];
}
static gboolean PDFHRreturn(SQLDI *sqldi)
{
PDFREQ *pdfReq = sqldi->data;
pdfReq->keys.pdfKey = CUSTOMPDF;
pdfReq->keys.tmpFilled = TRUE;
mergeCrit(pdfReq, pdfStates.detail.pdfReq[NW]);
mergeCrit(pdfReq, pdfStates.detail.pdfReq[SW]);
PDFinitDetail(pdfReq, TRUE);
return FALSE;
}
static void doHourSelect()
{
PDFREQ *pdfReq;
static SQLDI sqldi;
graph *GR=&pdfStates.detail.gr[1][1];
int  tmS, tmE, mnS, mnE, hrS, hrE, 
dayS, dayE, moS, moE, yrS, yrE, tmp;
GdkPoint *bbox = (GdkPoint *) &pdfStates.detail.bbox[SE];
GDate *yr;
PTIME *psdS=&pdfStates.detail.subReq.data.sTime.date, 
*psdE=&pdfStates.detail.subReq.data.eTime.date;
pdfReq = calloc(1, sizeof(PDFREQ));
pdfReq->data.numPSDs = -2;     
pdfStates.detail.pdfReq[SE] = pdfReq;
makeDrawing(PDFDETAIL, 1, 1);
memset(&sqldi, 0, sizeof(SQLDI));
if (bbox[POINT1].x > bbox[POINT2].x)
{
tmp = bbox[POINT1].x;
bbox[POINT1].x = bbox[POINT2].x;
bbox[POINT2].x = tmp;
}
if (bbox[POINT1].y > bbox[POINT2].y)
{
tmp = bbox[POINT1].y;
bbox[POINT1].y = bbox[POINT2].y;
bbox[POINT2].y = tmp;
}
switch(pdfSettings.detail.pdfHrMode)
{
case INCLUSIVE:
tmS = PIX2USERY(GR, bbox[POINT2].y);
tmE = PIX2USERY(GR, bbox[POINT1].y);
break;
case EXCLUSIVE:
tmS = PIX2USERY(GR, bbox[POINT1].y);
tmE = PIX2USERY(GR, bbox[POINT2].y);
break;
}
if (tmS < 0)
tmS = 0;
if (tmE > 24*60)
tmE = 24*60;
dayS = (int) (PIX2USERX(GR, bbox[POINT1].x) + .5) - 1;
dayE = (int) (PIX2USERX(GR, bbox[POINT2].x) + .5) - 1;
hrS = tmS/60;
hrE = tmE/60;
mnS = tmS - hrS*60;
mnE = tmE - hrE*60;
passcal_month_day(psdS, psdS->jday);
passcal_month_day(psdE, psdE->jday);
yr = g_date_new_dmy(psdS->day, psdS->mo, psdS->yr);
g_date_add_days(yr, dayS);
yrS = g_date_get_year(yr);
moS = g_date_get_month(yr);
dayS = g_date_get_day(yr);
g_date_free(yr);
yr = g_date_new_dmy(psdS->day, psdS->mo, psdS->yr);
g_date_add_days(yr, dayE);
yrE = g_date_get_year(yr);
moE = g_date_get_month(yr);
dayE = g_date_get_day(yr);
g_date_free(yr);
pdfReq->reqID = pdfStates.detail.pdfReq[NW]->reqID;
pdfReq->keys.pdfKey = HOURSPDF;
pdfReq->keys.chnKey = pdfStates.detail.pdfReq[NW]->keys.chnKey;
pdfReq->keys.reqType = REQRANGE;
pdfReq->keys.criteria[PDFREQ_YRSTART] = yrS;
pdfReq->keys.criteria[PDFREQ_YREND] = yrE;
pdfReq->keys.criteria[PDFREQ_DYSTARTM] = moS;
pdfReq->keys.criteria[PDFREQ_DYSTARTD] = dayS;
pdfReq->keys.criteria[PDFREQ_DYENDM] = moE;
pdfReq->keys.criteria[PDFREQ_DYENDD] = dayE;
pdfReq->keys.criteria[PDFREQ_HRSTARTH] = hrS;
pdfReq->keys.criteria[PDFREQ_HRSTARTM] = mnS;
pdfReq->keys.criteria[PDFREQ_HRENDH] = hrE;
pdfReq->keys.criteria[PDFREQ_HRENDM] = mnE;
sqldi.descr.tableData = PDFHR;
sqldi.data = pdfReq;
sqldi.args.callType = ASYNC;
sqldi.args.returnFunc = PDFHRreturn;
sqldi.args.dataEvent = GET_DATA;
sqldi.args.sqr = TRUE;
db_request(&sqldi);
}
static void doDetail()
{ 
graph *grL;
int tmp;
static IDXTMPARGS idxArgs;
PDFREQ *sw, *nw;
sw = pdfStates.detail.pdfReq[SW];
nw = pdfStates.detail.pdfReq[NW];
pdfStates.detail.idleCnt = 0;
setSensitive(PDFSYSTEM, PDFDATABUSYSENS, PDFDETAIL, FALSE);
idxArgs.reqType = SUBPDF;
idxArgs.table = IDXTMPTBL2;
pdfStates.detail.subPDF[0][0] = TRUE;
grL = &pdfStates.detail.gr[0][0];
if (pdfStates.detail.bbox[NW][POINT1].x > pdfStates.detail.bbox[NW][POINT2].x)
{
tmp = pdfStates.detail.bbox[NW][POINT1].x;
pdfStates.detail.bbox[NW][POINT1].x = pdfStates.detail.bbox[NW][POINT2].x;
pdfStates.detail.bbox[NW][POINT2].x = tmp;
}
if (pdfStates.detail.bbox[NW][POINT1].y > pdfStates.detail.bbox[NW][POINT2].y)
{
tmp = pdfStates.detail.bbox[NW][POINT1].y;
pdfStates.detail.bbox[NW][POINT1].y = pdfStates.detail.bbox[NW][POINT2].y;
pdfStates.detail.bbox[NW][POINT2].y = tmp;
}
freeDetail(SW);
memcpy(sw, nw, sizeof(PDFREQ));
if (nw->keys.sysPDFB[STARTDT])
{
sw->keys.sysPDFB[STARTDT] = g_strdup(nw->keys.sysPDFB[STARTDT]);
sw->keys.sysPDFB[ENDDT] = g_strdup(nw->keys.sysPDFB[ENDDT]);
}
sw->keys.tmpFilled = FALSE;
memset(&sw->data, 0, sizeof(sw->data));
sw->data.name = g_strdup(nw->data.name);
switch(pdfSettings.common.fdUnits)
{
case FDUNIT_PER:
sw->keys.criteria[PDFREQ_PERIODS] = PIX2USERX(grL, pdfStates.detail.bbox[NW][POINT1].x);
sw->keys.criteria[PDFREQ_PERIODE] = PIX2USERX(grL, pdfStates.detail.bbox[NW][POINT2].x);
break;
case FDUNIT_FREQ:
sw->keys.criteria[PDFREQ_PERIODE] = PIX2USERX(grL, pdfStates.detail.bbox[NW][POINT1].x);
sw->keys.criteria[PDFREQ_PERIODS] = PIX2USERX(grL, pdfStates.detail.bbox[NW][POINT2].x);
break;
}
sw->keys.criteria[PDFREQ_POWERS] = (float) PIX2USERY(grL, pdfStates.detail.bbox[NW][POINT1].y)+.5;
sw->keys.criteria[PDFREQ_POWERE] = (float) PIX2USERY(grL, pdfStates.detail.bbox[NW][POINT2].y)+.5;
g_idle_add((GSourceFunc) idleTMP, (gpointer) &idxArgs);
makeDrawing(PDFDETAIL, 1, 0); 
makeDrawing(PDFDETAIL, 1, 1); 
makeDrawing(PDFDETAIL, 0, 1); 
}
static void plotLabels(GdkPixmap **pixmap, int x, int y, int row, int col, int labelNum, gboolean final)
{
gint  i, hDate[2], mth, mday, pos, x1, marginFact;
char dispStr[25];
double userVals[2];
if (x < PDFSIDEM || x > pdfStates.detail.plotW[row][col][WIDTH] - PDFSIDEM ||  
y < PDFTOPM || y > pdfStates.detail.plotW[row][col][HEIGHT] - PDFBOTM)
{
return;
}
switch(col)
{
case 0:  
switch(final)
{
case FALSE:
userVals[X] = PIX2USERX(&pdfStates.detail.gr[row][col], x);
userVals[Y] = (int) (PIX2USERY(&pdfStates.detail.gr[row][col], y)+.5);
break;
case TRUE:
{
PDFREQ *pdfReq = pdfStates.detail.pdfReq[SW];
userVals[X] = (labelNum - 1) 
? pdfReq->keys.criteria[PDFREQ_PERIODE] 
: pdfReq->keys.criteria[PDFREQ_PERIODS];
userVals[Y] = (int) ((labelNum - 1) 
? pdfReq->keys.criteria[PDFREQ_POWERE] 
: pdfReq->keys.criteria[PDFREQ_POWERS]);
}
break;
}
break;
case 1:  
if (!pdfStates.detail.pdfReq[SW]->data.sTime.date.yr) 
return;
x1 = (int) (PIX2USERX(&pdfStates.detail.gr[row][col], x)+.5);
userVals[X] = (x1==0) ? ++x1 : x1;
userVals[X] = (x1==pdfStates.detail.gr[row][col].user_xmax) ? --x1 : x1;
userVals[Y] = (int) (PIX2USERY(&pdfStates.detail.gr[row][col], y)+((labelNum-1)?.5:-.5));
break;
}
switch(col)
{
case 0:
marginFact = 6 + (labelNum-1)*2;
sprintf(dispStr, "Power:");
pos = fontSIZEP(dispStr, AXISF, WIDTH) + PDFSIDEM*marginFact + 10;
fontDrawP(*pixmap, dispStr, PDFSIDEM*marginFact, PDFTOPM/3+3, AXISF, PDFFTEXT);
sprintf(dispStr, "%d", (int) userVals[Y]);
fontDrawP(*pixmap, dispStr, pos, PDFTOPM/3+3, AXISF, PDFFTEXT);
sprintf(dispStr, "Period:");
fontDrawP(*pixmap, dispStr, PDFSIDEM*marginFact, 2, AXISF, PDFFTEXT);
sprintf(dispStr, "%.3f", (float) userVals[X]);
fontDrawP(*pixmap, dispStr, pos, 2, AXISF, PDFFTEXT);
break;
case 1:
hDate[YEARH] = pdfStates.detail.pdfReq[SW]->data.sTime.date.yr;
hDate[JDAYH] = pdfStates.detail.pdfReq[SW]->data.sTime.date.jday;
hDate[JDAYH] += (int) userVals[X] - 1;
for (i=0;hDate[JDAYH]>yrEnd(hDate[YEARH]);i++)
{
hDate[JDAYH] -= (yrEnd(hDate[YEARH]));
hDate[YEARH]++;
if (hDate[JDAYH] < yrEnd(hDate[YEARH]-1))
break;
}
sprintf(dispStr, "Time:");
pos = fontSIZEP(dispStr, AXISF, WIDTH) + PDFSIDEM*4 + 10;
fontDrawP(*pixmap, dispStr, PDFSIDEM*4, PDFTOPM/3+3, AXISF, PDFFTEXT);
sprintf(dispStr, "%02d:%02d", ((int) userVals[Y])/60, ((int) userVals[Y])%60);
fontDrawP(*pixmap, dispStr, pos, PDFTOPM/3+3, AXISF, PDFFTEXT);
ms_doy2md (hDate[YEARH], hDate[JDAYH], &mth, &mday);
sprintf(dispStr, "Date:");
fontDrawP(*pixmap, dispStr, PDFSIDEM*4, 2, AXISF, PDFFTEXT);
sprintf(dispStr, "%02d-%s-%d / %d:%03d", mday, months[mth-1], 
hDate[YEARH], hDate[YEARH], hDate[JDAYH]);
fontDrawP(*pixmap, dispStr, pos, 2, AXISF, PDFFTEXT);
break;
}
}
static void plotLines(GdkPixmap **pixmap, int x, int y, int row, int col)
{
gint  x1;
GdkPoint lines[2][2]; 
GdkGC *lgc;
double userVals[2];
if (x < PDFSIDEM || x > pdfStates.detail.plotW[row][col][WIDTH] - PDFSIDEM ||  
y < PDFTOPM || y > pdfStates.detail.plotW[row][col][HEIGHT] - PDFBOTM)
{
return;
}
switch(col)
{
case 0:  
userVals[X] = PIX2USERX(&pdfStates.detail.gr[row][col], x);
lgc = pdfSettings.drawing.ctxts[PDFDASHLINE][INVGC];
break;
case 1:  
if (!pdfStates.detail.pdfReq[SW]->data.sTime.date.yr) 
return;
x1 = (int) (PIX2USERX(&pdfStates.detail.gr[row][col], x)+.5);
userVals[X] = (x1==0) ? ++x1 : x1;
userVals[X] = (x1==pdfStates.detail.gr[row][col].user_xmax) ? --x1 : x1;
lgc = pdfSettings.drawing.ctxts[PDFPINKLINE][NORMALGC];
break;
}
userVals[Y] = (int) (PIX2USERY(&pdfStates.detail.gr[row][col], y)+.5);
x = USER2PIXX(&pdfStates.detail.gr[row][col], userVals[X]);
y = USER2PIXY(&pdfStates.detail.gr[row][col], userVals[Y]);
lines[VERT][0].x = x; 
lines[VERT][0].y = PDFTOPM;
lines[VERT][1].x = x; 
lines[VERT][1].y = pdfStates.detail.plotW[row][col][HEIGHT] - PDFBOTM;
gdk_draw_lines(*pixmap, lgc, lines[VERT], 2);
lines[HORIZ][0].x = PDFSIDEM; 
lines[HORIZ][0].y = y;
lines[HORIZ][1].x = pdfStates.detail.plotW[row][col][WIDTH]-PDFSIDEM; 
lines[HORIZ][1].y = y;
gdk_draw_lines(*pixmap, lgc, lines[HORIZ], 2);
return;
}
static void plotBoxes(GdkPixmap *pixmap, int cell, gboolean final)
{ 
GdkPoint rect[6];
switch(cell)
{
case NW:
{
PDFREQ *pdfReq = pdfStates.detail.pdfReq[SW];
int  x[2], y[2], row=0, col=0;
double userVals[2][2];
if (final)
{
userVals[0][X] = pdfReq->keys.criteria[PDFREQ_PERIODS];
userVals[0][Y] = (int) pdfReq->keys.criteria[PDFREQ_POWERS];
userVals[1][X] = pdfReq->keys.criteria[PDFREQ_PERIODE];
userVals[1][Y] = (int) pdfReq->keys.criteria[PDFREQ_POWERE];    
}
else
{
userVals[0][X] = PIX2USERX(&pdfStates.detail.gr[row][col], 
pdfStates.detail.bbox[cell][POINT1].x);
userVals[0][Y] = (int) (PIX2USERY(&pdfStates.detail.gr[row][col], 
pdfStates.detail.bbox[cell][POINT1].y)+.5);
userVals[1][X] = PIX2USERX(&pdfStates.detail.gr[row][col], 
pdfStates.detail.bbox[cell][POINT2].x);
userVals[1][Y] = (int) (PIX2USERY(&pdfStates.detail.gr[row][col], 
pdfStates.detail.bbox[cell][POINT2].y)-.5);
}
x[0] = USER2PIXX(&pdfStates.detail.gr[row][col], userVals[0][X]);
y[0] = USER2PIXY(&pdfStates.detail.gr[row][col], userVals[0][Y]);
x[1] = USER2PIXX(&pdfStates.detail.gr[row][col], userVals[1][X]);
y[1] = USER2PIXY(&pdfStates.detail.gr[row][col], userVals[1][Y]);
rect[0].x = x[0]; 
rect[0].y = y[0];
rect[1].x = x[1]; 
rect[1].y = y[0];
rect[2].x = x[1]; 
rect[2].y = y[1];
rect[3].x = x[0]; 
rect[3].y = y[1];
rect[4].x = x[0]; 
rect[4].y = y[0];
gdk_draw_lines(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][INVGC], rect, 5);
}
break;
case SE:
switch(pdfSettings.detail.pdfHrMode)
{
case INCLUSIVE:
rect[0].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[0].y = pdfStates.detail.bbox[cell][POINT1].y;
rect[1].x = pdfStates.detail.bbox[cell][POINT2].x; 
rect[1].y = pdfStates.detail.bbox[cell][POINT1].y;
rect[2].x = pdfStates.detail.bbox[cell][POINT2].x; 
rect[2].y = pdfStates.detail.bbox[cell][POINT2].y;
rect[3].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[3].y = pdfStates.detail.bbox[cell][POINT2].y;
rect[4].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[4].y = pdfStates.detail.bbox[cell][POINT1].y;
gdk_draw_lines(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][INVGC], rect, 5);
break;
case EXCLUSIVE:
rect[0].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[0].y = PDFTOPM;
rect[1].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[1].y = pdfStates.detail.bbox[cell][POINT1].y;
rect[2].x = pdfStates.detail.bbox[cell][POINT2].x; 
rect[2].y = pdfStates.detail.bbox[cell][POINT1].y;
rect[3].x = pdfStates.detail.bbox[cell][POINT2].x; 
rect[3].y = PDFTOPM;
gdk_draw_lines(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][INVGC], rect, 4);
rect[0].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[0].y = pdfStates.detail.plotW[1][1][HEIGHT] - PDFBOTM;
rect[1].x = pdfStates.detail.bbox[cell][POINT1].x; 
rect[1].y = pdfStates.detail.bbox[cell][POINT2].y;
rect[2].x = pdfStates.detail.bbox[cell][POINT2].x; 
rect[2].y = pdfStates.detail.bbox[cell][POINT2].y;
rect[3].x = pdfStates.detail.bbox[cell][POINT2].x; 
rect[3].y = pdfStates.detail.plotW[1][1][HEIGHT] - PDFBOTM;
gdk_draw_lines(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][INVGC], rect, 4);
break;
}
break;
}
}  
static void plotX(GdkPixmap *pmap, int x, int y)
{
gdk_draw_line(pmap, 
pdfSettings.drawing.ctxts[PDFTEXT][INVGC], 
x - 10, y - 10,
x + 10, y + 10);
gdk_draw_line(pmap, 
pdfSettings.drawing.ctxts[PDFTEXT][INVGC],
x + 10, y - 10,
x - 10, y + 10);
}
gboolean mouseEventPDF(GtkWidget *widget, GdkEventButton *event, gpointer s)
{ 
int scr = GPOINTER_TO_INT(s);
int screen = (scr)/MAXNUMBERS;
int row, col, base = (scr-screen*MAXNUMBERS);
switch(screen)
{
case PDFMAIN:
case PDFDETAIL:
case PDFREQUEST:
row = ROWNUM(base);
col = COLNUM(base);
break;
case PDFMOVIE:
row = base;
col=0;
break;
}
switch(screen)
{
case PDFMAIN:
if (pdfStates.pmap.state[screen][row][col] != STATE_FINISH)
break;  
switch(event->type)
{
case GDK_BUTTON_RELEASE:  
clearDispList();
PDFinitDetail(&pdfStates.main.pdfReq[pdfSettings.main.display][row][col], TRUE);
gtk_notebook_set_current_page((GtkNotebook *) PSDbooks[PDFNB], PDFDETAIL);
break;
default: 
break;
}
break;
case PDFREQUEST:
if (pdfStates.pmap.state[screen][row][col] != STATE_FINISH)
break;
switch(event->type)
{
case GDK_BUTTON_RELEASE:  
pdfStates.request.pdfReq[row][col].keys.tmpFilled = FALSE;
pdfStates.request.pdfReq[row][col].keys.fillTmp = FALSE;
clearDispList();
PDFinitDetail(&pdfStates.request.pdfReq[row][col], TRUE);
gtk_notebook_set_current_page((GtkNotebook *) PSDbooks[PDFNB], PDFDETAIL);
break;
default: 
break;
}
break;
case PDFMOVIE:
{
PDFREQ *pdfReq;
PDFFILM *film;
PDFFILMFRAME *frame;
long daAddr = (long) widget;
switch(event->type)
{
case GDK_BUTTON_RELEASE:  
film = g_hash_table_lookup(pdfStates.movie.films[row], &daAddr);
if (!film) 
break;
frame = g_hash_table_lookup(film->frames, &film->frameNo);
pdfReq = frame->pdfReq;
clearDispList();
PDFinitDetail(pdfReq, TRUE);
gtk_notebook_set_current_page((GtkNotebook *) PSDbooks[PDFNB], PDFDETAIL);
break;
default: 
break;
}
}
break;
case PDFDETAIL:
if( !pdfStates.detail.pdfReq[NW] ||
pdfStates.detail.pdfReq[NW]->data.numRecs == 0)
break;
switch(row+col*2)
{
case NW:  
switch(event->type)
{
case GDK_BUTTON_PRESS:   
if (event->x < PDFSIDEM ||  
event->x > pdfStates.detail.plotW[row][col][WIDTH] - PDFSIDEM ||
event->y < PDFTOPM || 
event->y > pdfStates.detail.plotW[row][col][HEIGHT] - PDFBOTM)
{
break;
}
if (pdfStates.detail.subPDF[row][col])
{ 
GdkEventMotion eventM;
freeDetail(SW);      
pdfStates.detail.subPDF[0][0] = FALSE;
pdfStates.detail.traceCnt[TRACECNT] = 0;
eventM.x = event->x;
eventM.y = event->y;
makeDrawing(PDFDETAIL, 0, 0);
makeDrawing(PDFDETAIL, 1, 0); 
makeDrawing(PDFDETAIL, 1, 1); 
makeDrawing(PDFDETAIL, 0, 1); 
dragEventPDF(widget, &eventM, GINT_TO_POINTER(scr));  
break;
}
pdfStates.detail.bbox[NW][POINT1].x = event->x;
pdfStates.detail.bbox[NW][POINT1].y = event->y;
pdfStates.detail.bbox[NW][POINT2].x = 
pdfStates.detail.bbox[NW][POINT2].y = 0;
pdfStates.detail.mouseDown = TRUE;
break;
case GDK_BUTTON_RELEASE:  
{
GdkPixmap *pixmap;
if (!pdfStates.detail.mouseDown)
break;
pdfStates.detail.bbox[NW][POINT2].x = event->x;
pdfStates.detail.bbox[NW][POINT2].y = event->y;
doDetail();
pixmap = pdfStates.pmap.detail[0][0];
if ((pdfStates.detail.bbox[NW][POINT1].x == 
pdfStates.detail.bbox[NW][POINT2].x) &&
(pdfStates.detail.bbox[NW][POINT1].y == 
pdfStates.detail.bbox[NW][POINT2].y))
{ 
plotX(pixmap,
pdfStates.detail.bbox[NW][POINT1].x,
pdfStates.detail.bbox[NW][POINT1].y);
plotLabels(&pixmap, event->x, event->y, row, col, 1, TRUE);
}
else
{
plotBoxes(pixmap, NW, TRUE);
plotLabels(&pixmap, pdfStates.detail.bbox[NW][POINT1].x, 
pdfStates.detail.bbox[NW][POINT1].y, row, col, 1, TRUE);
plotLabels(&pixmap, pdfStates.detail.bbox[NW][POINT2].x, 
pdfStates.detail.bbox[NW][POINT2].y, row, col, 2, TRUE);
}
pdfStates.detail.mouseDown = FALSE;
}
break;
default:
break;
}
break;
case NE:
switch(event->type)
{ 
PQLDATA *pqlIn;
case GDK_BUTTON_RELEASE:
{
if (!pdfStates.detail.traceCnt[VALIDTRC] ||
!pdfStates.detail.trcList)
{ 
gdk_beep();
break;
}
GSList *trcIter;
static SOURCEINFO sysInfo;
kill_all_traces(ALL);
for(trcIter = pdfStates.detail.trcList;
trcIter;
trcIter = g_slist_next(trcIter))
{
pqlIn = calloc(1, sizeof(PQLDATA));
pqlIn->fileName = NULL;
pqlIn->trc = trcIter->data;
states.input.Files = g_slist_append(states.input.Files, pqlIn);
}
g_slist_free(pdfStates.detail.trcList);
pdfStates.detail.trcList = NULL;
states.reset.reset[TRACESCR] = TRUE;
states.input.numFiles = g_slist_length(states.input.Files);
sysInfo.destSystem = PQLSYSTEM;
sysInfo.destTab = PQLTRC;
systemChg(NULL, (gpointer) &sysInfo);
}
break;
default:
break;
}
break;
case SW:
switch(event->type)
{ 
case GDK_BUTTON_RELEASE:
{
PDFREQ *pdfPtr=pdfStates.detail.pdfReq[SW];
if (!pdfStates.detail.subPDF[row][col])
{
gdk_beep();
break;  
}
pdfPtr->keys.pdfKey = SUBPDF;
pdfPtr->keys.tmpFilled = FALSE;
memcpy(&(pdfPtr->keys.criteria), &(pdfStates.detail.subReq.keys.criteria), 
sizeof(pdfPtr->keys.criteria));   
mergeCrit(pdfPtr, pdfStates.detail.pdfReq[NW]);
PDFinitDetail(pdfPtr, TRUE);
}
break;
default:
break;
}
break;
case SE:
switch(event->type)
{
case GDK_BUTTON_PRESS:
{
pdfStates.detail.bbox[SE][POINT1].x = event->x;
pdfStates.detail.bbox[SE][POINT1].y = event->y;
pdfStates.detail.bbox[SE][POINT2].x = 
pdfStates.detail.bbox[SE][POINT2].y = 0;
pdfStates.detail.mouseDown = TRUE;
}
break;
case GDK_BUTTON_RELEASE:
{
if (!pdfStates.detail.mouseDown)
break;
if (!pdfStates.detail.subPDF[1][0])
break;  
pdfStates.detail.mouseDown = FALSE;
if (pdfStates.detail.bbox[SE][POINT1].x == event->x &&
pdfStates.detail.bbox[SE][POINT1].y == event->y)
{
gdk_beep();
break;  
}
pdfStates.detail.bbox[SE][POINT2].x = event->x;
pdfStates.detail.bbox[SE][POINT2].y = event->y;
doHourSelect();
}
break;
default:
break;
}
break;
}
break;
}
return TRUE;
}
#define SQRSZ 20
#define COLORBW 15
static gboolean colorBDraw(GtkWidget *widget, GdkEventMotion *event, gpointer s)
{
int  scr = GPOINTER_TO_INT(s);
GtkWidget *da;
static GdkWindow *gdkWindow;
GdkPixmap *pixmap, *pixmapSRC, *cbpmap;
int  w, h;
int  screen = (scr)/MAXNUMBERS;
int  row, col, base = (scr-screen*MAXNUMBERS);
switch(screen)
{
case PDFMAIN:
case PDFDETAIL:
case PDFREQUEST:
row = ROWNUM(base);
col = COLNUM(base);
break;
case SPECTRODETREQ:
row = ROWNUM(base);
col = COLPDF;
break;
default:
return TRUE;
break;
}
switch(screen)
{
case PDFMAIN:
pixmapSRC = pdfStates.pmap.main[pdfSettings.main.display][row][col];
da = MPDFDA[row][col];
break;
case PDFDETAIL:
if (col)
return TRUE;
pixmapSRC = pdfStates.pmap.detail[row][col];
da = DPDFDA[row][col];
break;
case PDFREQUEST:
pixmapSRC = pdfStates.pmap.request[row][col];
da = RPDFDA[row][col];
break;
case SPECTRODETREQ:
pixmapSRC = pdfStates.pmap.spreq[row][col];
da = SPREQDA[row][col];
break;
}
if (!gdkWindow)
gdkWindow = gdk_get_default_root_window();
w = PDFSIDEM-5;
h = da->allocation.height - (PDFTOPM + PDFBOTM);
cbpmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_rectangle(cbpmap, pdfSettings.drawing.ctxts[PDFTEXT][ABNORMALGC], 
TRUE, 0, 0, w, h);
colorBar(cbpmap, w, h);
pixmap = gdk_pixmap_new(da->window, da->allocation.width, da->allocation.height, -1);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_WIDGET_STATE (da)], pixmapSRC, 0, 0, 0, 0, -1, -1);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_WIDGET_STATE (da)], cbpmap, 0, 0, 
da->allocation.width-PDFSIDEM+3, PDFTOPM, -1, -1);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_WIDGET_STATE (da)], pixmap, 0, 0, 0, 0, -1, -1);
g_object_unref(cbpmap);
g_object_unref(pixmap);
return TRUE;
}
gboolean dragEventPDF(GtkWidget *widget, GdkEventMotion *event, gpointer s)
{
int scr = GPOINTER_TO_INT(s);
GdkModifierType state;
gint x, y, i, j;
static int dims[2];
static GdkWindow *gdkWindow;
GtkWidget *da;
GdkPixmap *pixmapSRC;
static GdkPixmap *pixmap[DMAXPDFROWS][DMAXPDFCOLS];
int screen = (scr)/MAXNUMBERS;
int base = (scr - screen*MAXNUMBERS); 
int row = ROWNUM(base);
int col = COLNUM(base);
if (!gdkWindow)
gdkWindow = gdk_get_default_root_window();
if (pdfStates.pmap.state[screen][row][col] != STATE_FINISH)
return TRUE;
if ((event->x > widget->allocation.width-SQRSZ &&
event->y > widget->allocation.height-SQRSZ) &&
screen != PDFDETAIL)
{
colorBDraw(widget, event, GINT_TO_POINTER(scr));
gdk_window_get_pointer(gdkWindow, &x, &y, &state);
return TRUE;
}
switch(screen)
{
case PDFMAIN:
pixmapSRC = pdfStates.pmap.main[pdfSettings.main.display][row][col];
da = MPDFDA[row][col];
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmapSRC, 0, 0, 0, 0, -1, -1);
break;
case PDFREQUEST:
pixmapSRC = pdfStates.pmap.request[row][col];
da = RPDFDA[row][col];
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmapSRC, 0, 0, 0, 0, -1, -1);
break;
case PDFDETAIL:
if( !pdfStates.detail.pdfReq[NW] ||
pdfStates.detail.pdfReq[NW]->data.numRecs == 0)  
break;
da = DPDFDA[row][col];
switch(row+2*col)
{
case NW: 
if (dims[WIDTH] != da->allocation.width ||
dims[HEIGHT] != da->allocation.height)
{ 
for(i=0;i<DMAXPDFROWS;i++)
for(j=0;j<DMAXPDFCOLS;j++)
if (pixmap[i][j])
{
g_object_unref(pixmap[i][j]);
pixmap[i][j] = NULL;
}
}
if (!pixmap[row][col])
{
dims[WIDTH] = da->allocation.width;
dims[HEIGHT] = da->allocation.height;
pixmap[row][col] = gdk_pixmap_new(da->window, dims[WIDTH], dims[HEIGHT], -1);
}
switch(pdfStates.detail.mouseDown)
{
case TRUE:  
gdk_draw_drawable(pixmap[row][col], da->style->fg_gc[GTK_STATE_NORMAL],
pdfStates.pmap.detail[row][col], 0, 0, 0, 0, -1, -1);
#if 0
undone: make the PDF detail selection boundaries not allowed to go outside the bounds
pdfStates.detail.bbox[NW][POINT2].x = !(x<PDFSIDEM || 
(x>pdfStates.detail.plotW[row][col][WIDTH] - PDFSIDEM)) ? event->x :
((x<PDFSIDEM) ? PDFSIDEM+1 : 
((x>pdfStates.detail.plotW[row][col][WIDTH] - PDFSIDEM) ?
pdfStates.detail.plotW[row][col][WIDTH] - PDFSIDEM - 1 : 0));
pdfStates.detail.bbox[NW][POINT2].y = (y<PDFTOPM) ? PDFTOPM+1 :
((y > pdfStates.detail.plotW[row][col][HEIGHT] - PDFBOTM) ?
pdfStates.detail.plotW[row][col][HEIGHT] - PDFBOTM - 1 :
event->y);
#endif
pdfStates.detail.bbox[NW][POINT2].x = event->x;
pdfStates.detail.bbox[NW][POINT2].y = event->y;
plotBoxes(pixmap[row][col], NW, FALSE);
plotLabels(&pixmap[row][col], pdfStates.detail.bbox[NW][POINT1].x, 
pdfStates.detail.bbox[NW][POINT1].y, row, col, 1, FALSE);
plotLabels(&pixmap[row][col], event->x, event->y, row, col, 2, FALSE);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmap[row][col], 0, 0, 0, 0, -1, -1);
break;
case FALSE:  
if(pdfStates.detail.subPDF[row][col] ||    
pdfStates.detail.pdfReq[NW]->data.numRecs == 0) 
break;
gdk_draw_drawable(pixmap[row][col], da->style->fg_gc[GTK_STATE_NORMAL],
pdfStates.pmap.detail[row][col], 0, 0, 0, 0, -1, -1);
plotLines(&pixmap[row][col], event->x, event->y, row, col);
plotLabels(&pixmap[row][col], event->x, event->y, row, col, 1, FALSE);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmap[row][col], 0, 0, 0, 0, -1, -1);
break;
}
break;
case SW:  
if (!(pdfStates.detail.subPDF[row][col] && 
(pdfStates.detail.pdfReq[SW]->data.numRecs != NOPSDDATA)))
{ 
break;
}
if (!pixmap[row][col])
{
pixmap[row][col] = gdk_pixmap_new(da->window, dims[WIDTH], dims[HEIGHT], -1);
}
gdk_draw_drawable(pixmap[row][col], da->style->fg_gc[GTK_STATE_NORMAL],
pdfStates.pmap.detail[row][col], 0, 0, 0, 0, -1, -1);
plotLines(&pixmap[row][col], event->x, event->y, row, col);
plotLabels(&pixmap[row][col], event->x, event->y, row, col, 1, FALSE);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmap[row][col], 0, 0, 0, 0, -1, -1);
break;
case SE:  
if (!(pdfStates.detail.subPDF[row][col] && 
(pdfStates.detail.pdfReq[SW]->data.numRecs != NOPSDDATA)))
{ 
break;
}
if (!pixmap[row][col])
{
pixmap[row][col] = gdk_pixmap_new(da->window, dims[WIDTH], dims[HEIGHT], -1);
}
switch(pdfStates.detail.mouseDown)
{
case TRUE:  
gdk_draw_drawable(pixmap[row][col], da->style->fg_gc[GTK_STATE_NORMAL],
pdfStates.pmap.detail[row][col], 0, 0, 0, 0, -1, -1);
pdfStates.detail.bbox[SE][POINT2].x = event->x;
pdfStates.detail.bbox[SE][POINT2].y = event->y;
plotBoxes(pixmap[row][col], SE, FALSE);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmap[row][col], 0, 0, 0, 0, -1, -1);
break;
case FALSE:  
gdk_draw_drawable(pixmap[row][col], da->style->fg_gc[GTK_STATE_NORMAL],
pdfStates.pmap.detail[row][col], 0, 0, 0, 0, -1, -1);
plotLines(&pixmap[row][col], event->x, event->y, row, col);
plotLabels(&pixmap[row][col], event->x, event->y, row, col, 1, FALSE);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmap[row][col], 0, 0, 0, 0, -1, -1);
break;
}
break;
}
break;
}
gdk_window_get_pointer(gdkWindow, &x, &y, &state);
return TRUE;
}
enum {
SET,
GET
};
static gboolean reqParams(int type, int screen, gpointer req)
{
gboolean valid = TRUE;
switch(type)
{
case SET:
set_reqEntries(screen, req);
break;
case GET:
valid = get_reqEntries(screen, req);
break;
}
return(valid);
}
gboolean plotRequest(GtkButton *button, gpointer s)
{ 
int screen = GPOINTER_TO_INT(s);
if (!reqWndw)
make_ReqDialog(TRUE);
switch (screen)
{
case PDFREQUEST:
{
PDFREQ *pdfReq = &pdfStates.request.pdfReq[pdfStates.request.req.row][pdfStates.request.req.col];
reqParams(SET, screen, (gpointer) pdfReq);
gtk_window_set_title(GTK_WINDOW(reqWndw), "PDF REQUESTOR"); 
gtk_widget_hide(reqMenu[PDFREQSPECTRO]);
gtk_widget_show(reqMenu[PDFREQPDF]);
}
break;
case SPECTRODETREQ:
{
SPECREQ *specReq = &pdfStates.spdetreq.specReq[pdfStates.spdetreq.row][0];
reqParams(SET, screen, (gpointer) specReq);
gtk_window_set_title(GTK_WINDOW(reqWndw), "Spectrogram REQUESTOR"); 
gtk_widget_show(reqMenu[PDFREQSPECTRO]);
gtk_widget_hide(reqMenu[PDFREQPDF]);
}
break;
}
gtk_widget_show(reqWndw);
return TRUE;
}
void pdfComboSel(GtkComboBox *combo, gpointer w)
{ 
int which = GPOINTER_TO_INT(w);
switch (which)
{
case PDFCBOZOOMSCOPE:
pdfSettings.spreq.zoom.scope = gtk_combo_box_get_active(combo);
break;
}
}
void cancelPDFReq(GtkWidget *widget, gpointer nil)
{
gtk_grab_remove(reqWndw);
gtk_widget_hide(reqWndw);
}
void requestPDF(GtkButton *button, void *nil)
{ 
int  which = ((pdfStates.screen == PDFREQUEST) 
? PDFREQPDF 
: (pdfStates.screen == SPECTRODETREQ) 
? PDFREQSPECTRO 
: NONE);
gboolean valid = FALSE;
int   screen = pdfStates.screen;  
int   base = gtk_combo_box_get_active(GTK_COMBO_BOX(reqDispCell[which]));
int  row = ROWNUM(base);
int  col = COLNUM(base);
switch (screen)
{
case PDFREQUEST:
{
PDFREQ *pdfReq = &pdfStates.request.pdfReq[row][col];
pdfStates.request.req.row = row;
pdfStates.request.req.col = col;
pdfStates.request.pdfReq[row][col].keys.chnKey = pdfStates.request.req.chnKey;   
memset(pdfReq, 0, sizeof(PDFREQ));
valid = reqParams(GET, screen, pdfReq);
pdfReq->keys.pdfKey = CUSTOMPDF;
pdfReq->keys.fillTmp = TRUE;
}
break;
case SPECTRODETREQ:
{
int  rowSP = base;
SPECREQ *specReq = &pdfStates.spdetreq.specReq[rowSP][0];
PDFREQ *pdfReq = &pdfStates.spdetreq.pdfReq[rowSP][0];
freeSpectro(specReq);
freePDF(pdfReq, TRUE); makeDrawing(SPECTRODETREQ, rowSP, COLPDF);
pdfStates.spdetreq.row = row = rowSP;
pdfStates.spdetreq.col = col = COLSPEC;
valid = reqParams(GET, screen, specReq);
}
break;
}
if (valid)
makeDrawing(screen, row, col);
return;
}
static gboolean filmDel(gpointer nil1, gpointer nil2, gpointer nil3)
{ 
return TRUE;
}
gboolean clearAllReqs(GtkButton *button, gpointer s)
{
int screen = GPOINTER_TO_INT(s);
int i, j;
switch(screen)
{
case PDFMAIN:
{ 
GSList  **list, **chnList;
list = &pdfStates.main.group.list;
chnList = &pdfStates.main.group.chnList;
for (i=0;i<MMAXPDFROWS;i++)
for (j=0;j<MMAXPDFCOLS;j++)
{
freePDF(pdfStates.main.pdfReq[i][j], TRUE);
gtk_widget_queue_resize(MPDFDA[i][j]);
}
if (list)
{
g_slist_free(*list);
if (chnList)
g_slist_free(*chnList);
*list = NULL;
*chnList = NULL;
}
}
break;
case PDFREQUEST:
for (i=0;i<RMAXPDFROWS;i++)
for (j=0;j<RMAXPDFCOLS;j++)
{
freePDF(&pdfStates.request.pdfReq[i][j], TRUE);
gtk_widget_queue_resize(RPDFDA[i][j]);
}
break;
case PDFMOVIE:
for(i=0; i<TTLMOVIESCREENS; i++) 
{
g_hash_table_foreach_remove(pdfStates.movie.films[i], (GHRFunc) filmDel, NULL);
gtk_widget_queue_resize(MVPDFDA[i]);
}
break;
case SPECTROMAIN:
{ 
GSList  **list, **chnList;
list = &pdfStates.spmain.group.list;
chnList = &pdfStates.spmain.group.chnList;
for (i=0; i < SMAXROWS; i++)
{
for (j=0; j < SPDFCOLS; j++)
{
freePDF(&pdfStates.spmain.pdfReq[i][j], TRUE);
}
for (j=0; j < SSPECCOLS; j++)
{
freeSpectro(&pdfStates.spmain.specReq[i][j]);
}
for (j=0; j < SMAXCOLS; j++)
{
if (SPMAINDA[i][j]) gtk_widget_queue_resize(SPMAINDA[i][j]);
}
}
if (list)
{
g_slist_free(*list);
if (chnList)
g_slist_free(*chnList);
*list = NULL;
*chnList = NULL;
}
}
break;
case SPECTRODETREQ:
for (i=0; i < SMAXROWS; i++)
{
for (j=0; j < SPDFCOLS; j++)
{
freePDF(&pdfStates.spdetreq.pdfReq[i][j], TRUE);
}
for (j=0; j < SSPECCOLS; j++)
{
freeSpectro(&pdfStates.spdetreq.specReq[i][j]);
}
for (j=0; j < SMAXCOLS; j++)
{
if (SPREQDA[i][j]) gtk_widget_queue_resize(SPREQDA[i][j]);
}
}
pdfStates.spdetreq.cntr = 0;
break;
}
return TRUE;
}
#include <sys/stat.h>
#include <sys/types.h>
#define PDFSAVEDIR "pqlx"
enum {
PDFSV_PROB,
PDFSV_PSDHR,
PDFSV_STATS,
TTLPDFSV
};
void pdfSave(GtkButton *button, void *nothing)
{
static GtkWidget *dialog, *filename[TTLPDFSV], 
*notebook, *stats[TTLPDFSTATS], *saveInfo;
static char *msgs[2];
PDFREQ  *pdfReq;
gboolean subPdf = pdfStates.detail.subPDF[1][0] ? TRUE : FALSE;
if (!msgs[0])
{
msgs[0] = g_strdup("Saving PDF Data of MAIN Detail PDF");
msgs[1] = g_strdup("Saving PDF Data of Sub-Select PDF");
}
if (!pdfStates.detail.pdfReq[SW] && 
!pdfStates.detail.pdfReq[NW])
{
gdk_beep();
return;
}
if (!dialog)
{
GtkWidget *label, *hbox, *vbox, *radio, *frame;
GtkWidget *hbox1, *vbox1, *vbox2, *radio1, *entry;
GtkTooltips *tips;
char  *toolTip;
int   i;
dialog = gtk_dialog_new_with_buttons ("Save PDF Data/Stats to File",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
vbox = gtk_vbox_new(FALSE, 0);
notebook = gtk_notebook_new();
hbox = gtk_hbox_new(FALSE, 0);
frame = gtk_frame_new("Save PDF Probabilities");
label = gtk_label_new("Filename: ");
filename[PDFSV_PROB] = entry = gtk_entry_new();
tips = gtk_tooltips_new();  
toolTip = g_strdup("Saved to Directory ~/pqlx");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_notebook_append_page (GTK_NOTEBOOK (notebook), frame, gtk_label_new(" PDF "));
hbox = gtk_hbox_new(FALSE, 0);
frame = gtk_frame_new("Save PSD Start Times");
label = gtk_label_new("Filename: ");
filename[PDFSV_PSDHR] = entry = gtk_entry_new();
tips = gtk_tooltips_new();  
toolTip = g_strdup("Saved to Directory ~/pqlx");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_notebook_append_page (GTK_NOTEBOOK (notebook), frame, gtk_label_new(" PSD "));
vbox2 = gtk_vbox_new(FALSE, 0);
frame = gtk_frame_new("Save PDF Statistics");
vbox1 = gtk_vbox_new(FALSE, 0);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox1 = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 4);
}
if (!i)
{
stats[i] = radio1 = gtk_radio_button_new_with_label(NULL, statStr[i]);
radio = radio1;
}
else
{
stats[i] = radio = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), statStr[i]);
}
gtk_box_pack_start(GTK_BOX(hbox1), radio, FALSE, FALSE, 4);
}
gtk_container_add(GTK_CONTAINER(vbox2), vbox1);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Filename: ");
filename[PDFSV_STATS] = entry = gtk_entry_new();
tips = gtk_tooltips_new();  
toolTip = g_strdup("Saved to Directory ~/pqlx");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(vbox2), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox2);
gtk_notebook_append_page (GTK_NOTEBOOK (notebook), frame, gtk_label_new(" Statistics "));
gtk_container_add(GTK_CONTAINER(vbox), notebook);
saveInfo = gtk_label_new(NULL);
gtk_container_add(GTK_CONTAINER(vbox), saveInfo);
label = gtk_label_new("Saved to Directory ~/pqlx");
gtk_container_add(GTK_CONTAINER(vbox), label);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), vbox);
gtk_widget_show_all(dialog);
free(toolTip);
}
else
{
gtk_widget_show(dialog);
}
gtk_label_set_text(GTK_LABEL(saveInfo), subPdf ? msgs[1] : msgs[0]);
if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
{
FILE *fp;
int  i, what;
char * home_dir = g_strdup(getenv("HOME")), *fileName, *file;
what = gtk_notebook_get_current_page(GTK_NOTEBOOK (notebook));
gtk_widget_hide(dialog);
fileName = g_strdup_printf("%s/%s", home_dir, PDFSAVEDIR);
mkdir(fileName, 0777);
free(fileName);
file = g_strdup(gtk_entry_get_text(GTK_ENTRY(filename[what])));
if (!strlen(file))
{
char *msg = g_strdup("\nNo Filename provided, cannot save.\n");
gdk_beep();
error_dialog("Save PDF Data File", msg);
free(msg);
free(file);
free(home_dir);
return;
}
fileName = g_strdup_printf("%s/%s/%s", home_dir, PDFSAVEDIR, file);
if (!(fp=fopen(fileName, "w")))
{
char *msg = g_strdup_printf("\nUnable to open file %s, please check and try again.\n", fileName);
gdk_beep();
error_dialog("Save PDF Data File", msg);
free(msg);
free(file);
free(fileName);
free(home_dir);
return;
}
free(file);
free(fileName);
free(home_dir);
pdfReq = subPdf 
? pdfStates.detail.pdfReq[SW] 
: pdfStates.detail.pdfReq[NW];
switch(what)
{
case PDFSV_PROB: 
for(i=0;i<pdfReq->data.numRecs;i++)
{
fprintf(fp, "%f\t%d\t%d\t%f\n", pdfReq->data.pdf[i].period, 
pdfReq->data.pdf[i].power, 
pdfReq->data.hits->hits[i].hits, 
pdfReq->data.pdf[i].prob);
}
break;
case PDFSV_PSDHR: 
{
gboolean freeData = FALSE;
PSDHRD *psdHr;
SQLDI sqldi;
if (!pdfStates.detail.psdHr.data.numRecs)
{
memset(&sqldi, 0, sizeof(SQLDI));
psdHr = calloc(1, sizeof(PSDHRD));
psdHr->keys.chnKey = pdfReq->keys.chnKey;
sqldi.data = psdHr;
sqldi.data2 = GINT_TO_POINTER(IDX1);
sqldi.descr.tableData = PSDHR;
sqldi.args.dataEvent = GET_DATA;
while(!pdfReq->keys.tmpFilled)
{ 
g_usleep(250000);
}
db_request(&sqldi);
freeData = TRUE;
}
else
{
psdHr = &pdfStates.detail.psdHr;
}
for(i=0;i<psdHr->data.numRecs;i++)
{
passcal_month_day(&psdHr->data.hrList[i]->date, 
psdHr->data.hrList[i]->date.jday);
fprintf(fp, "%04d/%02d/%02d %02d:%02d\n",
psdHr->data.hrList[i]->date.yr,
psdHr->data.hrList[i]->date.mo,
psdHr->data.hrList[i]->date.day,
psdHr->data.hrList[i]->date.hr,
psdHr->data.hrList[i]->date.mn);
}
if (freeData)
{
for(i=0;i<psdHr->data.numRecs;i++)
free(psdHr->data.hrList[i]);
free(psdHr->data.hrList);
free(psdHr);
}
}
break;
case PDFSV_STATS: 
{
int  statistic;
PDFSTATS *pdfStats = pdfReq->data.stats;
for(i=0;i<TTLPDFSTATS;i++)
{
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(stats[i])))
break;
}
statistic = i;
for(i=0;i<pdfStats->ttlPeriods;i++)
{
fprintf(fp, "%f\t%d\n", 
pdfStats->stats[i].period,
pdfStats->stats[i].statV[statistic]); 
}
}     
break;
}
fclose(fp); 
gdk_beep();
}
else
{
gtk_widget_hide(dialog);
}
return;
}
void nextPDFs(GtkButton *button, gpointer d)
{
int   dir = GPOINTER_TO_INT(d), screen = pdfStates.screen;
static int chnStart;
int   i, j, listLen, incr, nRows, nCols, pdfKey, nPDFCols, nSPECCols, pdfType;
GSList  *chnGrpIter, **chnList;
NSLCDATA *chnData;
PDFREQ  *pdfReq, *pdfReqPtr;
GtkWidget **daPtr, *da, *chnCnt;
void  *stats;
switch (screen)
{
case PDFMAIN:
nRows = MMAXPDFROWS;
nCols = nPDFCols = MMAXPDFCOLS;
nSPECCols = 0;
pdfReqPtr = &pdfStates.main.pdfReq[PDFGROUP][0][0];
chnList = &pdfStates.main.group.chnList;
pdfKey = pdfStates.main.group.pdfKey;
pdfType = pdfStates.main.group.pdfType;
daPtr = &MPDFDA[0][0];
chnCnt = chnCntLbl;
break;
case SPECTROMAIN:
nRows = SMAXROWS;
nPDFCols = SPDFCOLS;
nSPECCols = SSPECCOLS;
nCols = nPDFCols + nSPECCols;
pdfReqPtr = &pdfStates.spmain.pdfReq[0][0];
chnList = &pdfStates.spmain.group.chnList;
pdfKey = pdfStates.spmain.group.pdfKey;
pdfType = pdfStates.spmain.group.pdfType;
daPtr = &SPMAINDA[0][0];
chnCnt = SPchnCnt;
break;
}
incr = nRows * nPDFCols;
listLen = g_slist_length(*chnList);
stats = &pdfSettings.common.statistics[screen]; 
switch(dir)
{
case INITIALIZE:
chnStart = 0;
break;
case PDFGREINIT:
chnStart = (chnStart > listLen) ? 0 : (chnStart == -1 ? 0 : chnStart);
break;
case FORWARDS:
if (chnStart + incr >= listLen)
{ 
gdk_beep();
return;
}
chnStart += incr;
break;
case BACKWARDS:
if (chnStart - incr < 0)
{ 
gdk_beep();
return;
}
chnStart -= incr;
break;
}
for(i=0;i<nRows;i++)
{
for(j=0;j<nPDFCols;j++)
{
pdfReq = pdfReqPtr + i*nPDFCols+j;
freePDF(pdfReq, TRUE);
}
}
chnGrpIter = g_slist_nth(*chnList, chnStart);
for(i=0; i<nRows && chnGrpIter; i++)
{
for(j=0; j<nPDFCols && chnGrpIter; j++, chnGrpIter = g_slist_next(chnGrpIter))
{
pdfReq = pdfReqPtr + i*nPDFCols+j;
chnData = chnGrpIter->data;
pdfReq->keys.chnKey = chnData->id;
pdfReq->keys.pdfKey = pdfKey;
pdfReq->keys.pdfType = pdfType;
memcpy(&(pdfReq->keys.statistics), stats, sizeof(gboolean) * TTLPDFSTATS);
switch (pdfType)
{
case PDFTYPE_BASELINE:
pdfReq->keys.fillTmp = TRUE;
pdfReq->keys.bline.bline_fk = pdfSettings.main.bline.blineKey;
break;
}
}
}
if (nSPECCols)
{
SPECREQ  *specReq;
for(i=0;i<nRows;i++)
{ 
for(j=0;j<nSPECCols;j++)
{
specReq = &pdfStates.spmain.specReq[i][j];
freeSpectro(specReq);
}
}
chnGrpIter = g_slist_nth(*chnList, chnStart);
for(i=0; i<nRows && chnGrpIter; i++)
{
for(j=0; j<nSPECCols && chnGrpIter; j++, chnGrpIter = g_slist_next(chnGrpIter))
{
specReq = &pdfStates.spmain.specReq[i][j];
chnData = chnGrpIter->data;
specReq->keys.chnKey = chnData->id;
specReq->keys.pdfKey = pdfKey;
specReq->keys.pdfType = pdfType;
}
}
}
{ 
char *markup;
int  chnEnd;
setSensitive(PDFSYSTEM, PDFDATABUSYSENS, PDFMAIN, FALSE);
for(i=0;i<nRows;i++)
{
for(j=0;j<nCols;j++)
{
da = daPtr[i*nCols + j];
gtk_widget_queue_resize(da);
}
}
chnEnd = (chnStart + incr) > listLen ? listLen : chnStart + incr;
chnStart = chnEnd ? chnStart : -1;
markup = g_markup_printf_escaped("<span weight=\"bold\" foreground=\"white\">%d - %d / %d</span>", 
chnStart+1, chnEnd, listLen);
gtk_label_set_markup(GTK_LABEL(chnCnt), markup);  g_free(markup);
}  
}
void axisToggle(GtkToggleButton *button, gpointer s)
{
int  scr = GPOINTER_TO_INT(s);
int  i, j, nRows, nCols;
gboolean *flag;
SPECREQ *specReq, *specReqPtr=NULL;
switch (scr)
{
case PDFMAIN:
flag = &pdfSettings.main.xAxis.active;
nRows = MMAXPDFROWS;
nCols = MMAXPDFCOLS;
break;
case SPECTROMAIN:
flag = &pdfSettings.spmain.xAxis.active;
nRows = SMAXROWS;
nCols = SMAXCOLS;
specReqPtr = &pdfStates.spmain.specReq[0][0];
break;
case SPECTRODETREQ:
flag = &pdfSettings.spreq.xAxis.active;
nRows = SMAXROWS;
nCols = SMAXCOLS;
specReqPtr = &pdfStates.spdetreq.specReq[0][0];
break;
}
*flag = gtk_toggle_button_get_active(button);
if (specReqPtr)
{
for (i = 0; i < nRows; i++)
{
specReq = specReqPtr + i;
specReq->plot.replot = TRUE;
}
}
for (i = 0; i < nRows; i++)
for (j = 0; j < nCols; j++)
makeDrawing(scr, i, j);
}
