#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#ifdef  DBG_PDF_DETAIL
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
#endif
static SQLDI sqldi[TTLPDFSCREENS][MMAXPDFROWS][MMAXPDFCOLS];
enum {
IDXTMPBLK1,
IDXTMPBLK2,
TTLBLOCKS
};
static gboolean blocks[TTLBLOCKS];
static gboolean idlePDFreturn(SQLDI *sqldi)
{
int screen = (sqldi->args.sqr-1)/MAXNUMBERS;
int base = (sqldi->args.sqr-1-screen*MAXNUMBERS);
int row = ROWNUM(base);
int col = COLNUM(base);
if (screen==PDFDETAIL && row==1 && col==0)
{ 
memcpy(&pdfStates.detail.pdfReq[SW]->data.sTime, 
&pdfStates.detail.subReq.data.sTime, sizeof(MYTIME));
memcpy(&pdfStates.detail.pdfReq[SW]->data.eTime, 
&pdfStates.detail.subReq.data.eTime, sizeof(MYTIME));
}
makeDrawing(screen, row, col);
return FALSE;
}
gboolean idlePDF(gpointer s)
{ 
int   sqr = GPOINTER_TO_INT(s);
gboolean  getData=FALSE;
SQLDI  *sqldiL;
PDFREQ  *pdfReq;
int screen = (sqr)/MAXNUMBERS;
int base = (sqr-screen*MAXNUMBERS);
int row = ROWNUM(base);
int col = COLNUM(base);
if ((screen==PDFDETAIL) && (blocks[IDXTMPBLK1] || blocks[IDXTMPBLK2]))
return TRUE; 
sqldiL = &sqldi[screen][row][col];
memset(sqldiL, 0, sizeof(SQLDI));
sqldiL->args.sqr = sqr+1;
switch(screen)
{
case PDFMAIN:
pdfReq = &pdfStates.main.pdfReq[pdfSettings.main.display][row][col];
sqldiL->data = pdfReq;
switch(pdfReq->keys.pdfType)
{
case PDFTYPE_SYSTEM:
sqldiL->descr.tableData = PDFTBL;
break;
case PDFTYPE_BASELINE:
sqldiL->descr.tableData = PSDTBL;
break;
}
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
pdfReq->reqID = reqID++;
if (pdfReq->keys.chnKey && !(pdfReq->data.numRecs))
getData = TRUE;
break;
case PDFDETAIL:
{ 
PDFREQ *pdfReqNW = pdfStates.detail.pdfReq[NW];
if (pdfStates.detail.subReq.data.numPSDs == NOPSDDATA)
{ 
pdfReq = pdfStates.detail.pdfReq[SW];
pdfReq->data.numRecs = NOPSDDATA;
pdfReq->data.numPSDs = NOPSDDATA;
break;
}
switch(col)
{
case 0:  
switch(row)
{
case 0:
sqldiL->descr.tableData = PSDTBL;
pdfReq = pdfStates.detail.pdfReq[row];
sqldiL->data = pdfReq;
sqldiL->args.callType = SYNC;
sqldiL->args.returnFunc = idlePDFreturn;
if (pdfReq->keys.chnKey && !(pdfReq->data.numRecs))
getData = TRUE;
break;
case 1:
sqldiL->descr.tableData = PSDTBL;
pdfReq = pdfStates.detail.pdfReq[row];
pdfReq->reqID = pdfReqNW->reqID;     
sqldiL->data = pdfReq;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
if (pdfReq->keys.chnKey && !(pdfReq->data.numRecs))
getData = TRUE;
break;
}
break;
case 1:  
switch(row)
{
case 1: 
pdfReq = NULL;
sqldiL->descr.tableData = PSDHR;
pdfStates.detail.psdHr.reqID = pdfReqNW->reqID;
sqldiL->data = &pdfStates.detail.psdHr;
sqldiL->data2 = GINT_TO_POINTER(IDX2);
pdfStates.detail.psdHr.keys.chnKey = pdfReqNW->keys.chnKey;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
if (!pdfStates.detail.psdHr.data.numRecs)
getData = TRUE;
break;
case 0: 
pdfReq = NULL;
sqldiL->descr.tableData = PSDTRC;
pdfStates.detail.psdTrc.keys.chnKey = pdfReqNW->keys.chnKey;
pdfStates.detail.psdTrc.reqID = pdfReqNW->reqID;
sqldiL->data = &pdfStates.detail.psdTrc;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
if (!pdfStates.detail.psdTrc.data.numRecs)
getData = TRUE;
break;
}
break;
}
}
break;
case PDFREQUEST:
sqldiL->descr.tableData = PSDTBL;
pdfReq = &pdfStates.request.pdfReq[row][col];
sqldiL->data = pdfReq;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
pdfReq->reqID = reqID++;
pdfReq->keys.pdfType = PDFTYPE_REQUEST;
if (pdfReq->keys.chnKey && !(pdfReq->data.numRecs))
getData = TRUE;
break;
case SPECTROMAIN:
{
switch (col)
{
case COLPDF:
pdfReq = &pdfStates.spmain.pdfReq[row][0];
switch(pdfReq->keys.pdfType)
{
case PDFTYPE_SYSTEM:
sqldiL->descr.tableData = PDFTBL;
break;
case PDFTYPE_BASELINE:
sqldiL->descr.tableData = PSDTBL;
break;
}
sqldiL->data = pdfReq;
pdfReq->reqID = reqID++;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
break;
case COLSPEC:
{
SPECREQ *specReq;
sqldiL->descr.tableData = SPECTROTBL;
specReq = &pdfStates.spmain.specReq[row][0];
sqldiL->data = specReq;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
}
break;
}
getData = TRUE;
}
break;
case SPECTRODETREQ:
{
SPECREQ *specReq;
sqldiL->descr.tableData = SPECTROTBL;
specReq = &pdfStates.spdetreq.specReq[row][0];
sqldiL->data = specReq;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idlePDFreturn;
getData = TRUE;
}
break;
}
if (getData)
{ 
pdfPrep(PDF_P_DB, pdfReq, NULL, screen, row, col);
sqldiL->args.dataEvent = GET_DATA;
db_request(sqldiL);
}
if (sqldiL->args.callType == SYNC)
idlePDFreturn(sqldiL);
return FALSE;
}
static SQLDI sqldi2[2];
static gboolean idleTMPreturn(SQLDI *sqldi)
{
int sqr = sqldi->args.sqr - 1;
int screen = (sqr)/MAXNUMBERS;
int base = (sqr-screen*MAXNUMBERS);
int row = ROWNUM(base);
int col = COLNUM(base);
switch(screen)
{
case PDFDETAIL:
switch(col)
{
case 0:
switch(row)
{ 
case 0:
blocks[IDXTMPBLK1] = FALSE;
blocks[IDXTMPBLK2] = TRUE;
break;
case 1:
blocks[IDXTMPBLK2] = FALSE;
pdfStates.detail.pdfReq[SW]->keys.tmpFilled = TRUE;
g_idle_add((GSourceFunc) idlePDF, GINT_TO_POINTER(REFNUM(screen, 1, 0)));
g_idle_add((GSourceFunc) idlePDF, GINT_TO_POINTER(REFNUM(screen, 1, 1)));
g_idle_add((GSourceFunc) idlePDF, GINT_TO_POINTER(REFNUM(screen, 0, 1)));
break;
}
break;
}
break;
}
return FALSE;
}
gboolean idleTMP(IDXTMPARGS *args)
{
gboolean getData=FALSE;
SQLDI  *sqldiL;
PDFREQ  *pdfReq;
if (args->reqType == SUBPDF)
{
switch(args->table)
{
case IDXTMPTBL1:
if (blocks[IDXTMPBLK1])
return FALSE;
pdfReq = pdfStates.detail.pdfReq[NW];
if (!pdfReq->keys.tmpFilled)
{
blocks[IDXTMPBLK1] = TRUE;
sqldiL = &sqldi2[0];
memset(sqldiL, 0, sizeof(SQLDI));
sqldiL->args.sqr = 1 + REFNUM(PDFDETAIL, 0, 0);
sqldiL->descr.tableData = IDXTMPTBL1;
sqldiL->data = pdfReq;
sqldiL->data2 = pdfStates.detail.disp;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idleTMPreturn;
getData = TRUE;
}
break;
case IDXTMPTBL2:
if (blocks[IDXTMPBLK1])
{
g_usleep(250000);
return TRUE; 
}
memcpy(&pdfStates.detail.subReq, pdfStates.detail.pdfReq[SW], sizeof(PDFREQ));
pdfReq = &pdfStates.detail.subReq;
if (pdfReq->keys.tmpFilled == TRUE)
return FALSE;
pdfReq = pdfStates.detail.pdfReq[SW];
if (!pdfReq->keys.tmpFilled)
{
blocks[IDXTMPBLK2] = TRUE;
sqldiL = &sqldi2[1];
memset(sqldiL, 0, sizeof(SQLDI));
sqldiL->args.sqr = 1 + REFNUM(PDFDETAIL, 1, 0);
sqldiL->descr.tableData = IDXTMPTBL2;
sqldiL->data = &pdfStates.detail.subReq;
sqldiL->args.callType = ASYNC;
sqldiL->args.returnFunc = idleTMPreturn;
getData = TRUE;
}
break;
}
}
if (getData)
{ 
sqldiL->args.dataEvent = GET_DATA;
db_request(sqldiL);
}
return FALSE;
} 
