#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include <glib/gstdio.h>
#include <unistd.h>
GtkTooltips *tips;
char  toolTip[1000];
GtkSizeGroup *size_group, *size_group1, *size_group2;
enum {
PDFPRINTDIRECTORY,
PDFPRINTFNAME
};
enum {
PDFPRNTALLSELECT,
PDFPRNTALLDESELECT,
PDFPRNTALLTOGGLE,
PDFPRNTPRINT,
PDFPRNTCANCEL
};
GtkWidget *pdfPrintWndw;
GtkWidget *printWdgt[2], *printChk[3][MMAXPDFROWS][MMAXPDFCOLS];
GtkWidget *tables[3];
GtkWidget *PprtFrmt[TTLPRINTFMTS];
static void printSel(int cmd)
{
int   i, j;
switch(cmd)
{
case PDFPRNTALLSELECT:
for(i=0;i<MMAXPDFROWS;i++)
{
for(j=0;j<MMAXPDFCOLS;j++)
{
if (printChk[pdfStates.screen][i][j])
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(printChk[pdfStates.screen][i][j]), TRUE);
}
}
break;
case PDFPRNTALLDESELECT:
for(i=0;i<MMAXPDFROWS;i++)
{
for(j=0;j<MMAXPDFCOLS;j++)
{
if (printChk[pdfStates.screen][i][j])
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(printChk[pdfStates.screen][i][j]), FALSE);
}
}
break;
case PDFPRNTALLTOGGLE:
for(i=0;i<MMAXPDFROWS;i++)
{
for(j=0;j<MMAXPDFCOLS;j++)
{
if (printChk[pdfStates.screen][i][j])
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(printChk[pdfStates.screen][i][j]), 
!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(printChk[pdfStates.screen][i][j])));
}
}
break;
}
}
static void printPDF(int which)
{
int   i, j, k, paperW, paperH;
GtkWidget *da;
static GdkWindow *gdkWindow;
{
GdkPixbuf *pPixbuf;
GdkPixmap *pixmap, *pixmapSRC, *cbpmap;
gchar  *fullFN;
int   w, h, retCode;
if (g_access(gtk_entry_get_text(GTK_ENTRY(printWdgt[PDFPRINTDIRECTORY])), W_OK) == -1)
{
char *msg = g_strdup_printf("\n\tCannot write to directory '%s'\t\n"
"\tModify the permissions or Choose another Directory\t\n",
gtk_entry_get_text(GTK_ENTRY(printWdgt[PDFPRINTDIRECTORY])));
gdk_beep();
error_dialog("Print PNG", msg);
free(msg);
return; 
}
switch(settings.general.print.paperSize)
{
case LETTER:
paperW = LTRH;  
paperH = LTRW;
break;
case A4:
paperW = A4H;  
paperH = A4W;
break;
}
for(i=k=0;i<MMAXPDFROWS;i++)
{
for(j=0;j<MMAXPDFCOLS;j++)
{
if (!printChk[pdfStates.screen][i][j])
continue;
if (!gtk_toggle_button_get_active(
GTK_TOGGLE_BUTTON(printChk[pdfStates.screen][i][j])) ||
(pdfStates.pmap.state[pdfStates.screen][i][j] != STATE_FINISH))
continue;
switch(which)
{
case PRINT_FMT_PS:
fullFN = g_strdup_printf("%s/%s.%d.ps", 
gtk_entry_get_text(GTK_ENTRY(printWdgt[PDFPRINTDIRECTORY])),
gtk_entry_get_text(GTK_ENTRY(printWdgt[PDFPRINTFNAME])), ++k);
retCode = printPSHeadFoot2(fullFN, PRINTHEADER, paperW, paperH);
if (retCode != PQLXSUCCESS)
{
free(fullFN);
continue;
}
break;
case PRINT_FMT_PNG:
fullFN = g_strdup_printf("%s/%s.%d.png", 
gtk_entry_get_text(GTK_ENTRY(printWdgt[PDFPRINTDIRECTORY])),
gtk_entry_get_text(GTK_ENTRY(printWdgt[PDFPRINTFNAME])), ++k);
break;
}
switch(pdfStates.screen)
{
case PDFMAIN:
pixmapSRC = pdfStates.pmap.main[pdfSettings.main.display][i][j];
da = MPDFDA[i][j];
break;
case PDFDETAIL:
pixmapSRC = pdfStates.pmap.detail[i][j];
da = DPDFDA[i][j];
break;
case PDFREQUEST:
pixmapSRC = pdfStates.pmap.request[i][j];
da = RPDFDA[i][j];
break;
}
if (!gdkWindow)
gdkWindow = gdk_get_default_root_window();
w = PDFSIDEM-5;
h = da->allocation.height - (PDFTOPM + PDFBOTM);
cbpmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_rectangle(cbpmap, pdfSettings.drawing.ctxts[PDFTEXT][ABNORMALGC], 
TRUE, 0, 0, w, h);
colorBar(cbpmap, w, h);
pixmap = gdk_pixmap_new(da->window, da->allocation.width, da->allocation.height, -1);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_WIDGET_STATE (da)], 
pixmapSRC, 0, 0, 0, 0, -1, -1);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_WIDGET_STATE (da)], cbpmap, 0, 0, 
da->allocation.width-PDFSIDEM+3, PDFTOPM, -1, -1);
if (!(pPixbuf = gdk_pixbuf_get_from_drawable(NULL, pixmap, NULL, 0, 0, 0, 0, -1, -1)))
{
char *msg = g_strdup("\n\tInternal Error: Failed to Create PIXBUF for Printing, Please Report\t\n");
gdk_beep();
error_dialog("Print PNG", msg);
free(msg);
break;
}
switch(which)
{
case PRINT_FMT_PS:
print_ps_image2(pPixbuf);
printPSHeadFoot2(fullFN, PRINTFOOTER, paperW, paperH);
break;
case PRINT_FMT_PNG:
if (!gdk_pixbuf_save(pPixbuf, fullFN, "png", NULL, NULL))
{
char *msg = g_strdup("\n\tCould not save PDF plot in PNG format.\n"
"\tMost likely cause is missing libpng library.\t\n");
gdk_beep();
error_dialog("Print PNG", msg);
free(msg);
}
break;
}
g_object_unref(cbpmap);
g_object_unref(pixmap);
g_object_unref(pPixbuf);
free(fullFN);
}
}
gdk_beep();
gtk_widget_hide(pdfPrintWndw);
}
}
static void printCmd(GtkButton *button, gpointer c)
{
int  cmd = GPOINTER_TO_INT(c);
switch(cmd)
{
case PDFPRNTALLSELECT:
case PDFPRNTALLDESELECT:
case PDFPRNTALLTOGGLE:
printSel(cmd);
break;
case PDFPRNTPRINT:
switch((gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(PprtFrmt[PRINT_FMT_PNG]))))
{
case TRUE:
printPDF(PRINT_FMT_PNG);
break;
case FALSE:
printPDF(PRINT_FMT_PS);
break;
}
break;
case PDFPRNTCANCEL:
gtk_widget_hide(pdfPrintWndw);
break;
}
}
static void printDstroy(GtkWidget *widget, gpointer nil)
{
pdfPrintWndw = NULL;
}
static void make_PDFPrint()
{
GtkWidget *vbox, *hbox, *button, *checkBox, *label, *entry;
GtkWidget *sep, *frame, *table, *vbox1, *radioB1, *radioB2;
int   i, j;
pdfPrintWndw = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_window_set_title (GTK_WINDOW(pdfPrintWndw), "PDF PRINT Select"); 
gtk_container_set_border_width(GTK_CONTAINER(pdfPrintWndw), 2);
g_signal_connect(pdfPrintWndw, "destroy", G_CALLBACK(printDstroy), NULL);
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbutton_box_new();
vbox1 = gtk_vbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("ALL Select");
gtk_box_pack_start(GTK_BOX(vbox1), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(PDFPRNTALLSELECT));
button = gtk_button_new_with_label("ALL Deselect");
gtk_box_pack_start(GTK_BOX(vbox1), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(PDFPRNTALLDESELECT));
button = gtk_button_new_with_label("ALL Toggle");
gtk_box_pack_start(GTK_BOX(vbox1), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(PDFPRNTALLTOGGLE));
gtk_box_pack_start(GTK_BOX(hbox), vbox1, TRUE, FALSE, 2);
tables[0] = table = gtk_table_new(MMAXPDFROWS, MMAXPDFCOLS, TRUE);
for(i=0;i<MMAXPDFROWS;i++)
{
for(j=0;j<MMAXPDFCOLS;j++)
{
frame = gtk_frame_new(NULL);
printChk[0][i][j] = checkBox = gtk_check_button_new();
gtk_container_add(GTK_CONTAINER(frame), checkBox);
gtk_table_attach(GTK_TABLE(table), frame, j, j+1, i, i+1, 0, 0, 0, 0);
}
}
gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, FALSE, 2);
tables[1] = table = gtk_table_new(DMAXPDFROWS, DMAXPDFCOLS, TRUE);
for(i=0;i<DMAXPDFROWS;i++)
{
for(j=0;j<DMAXPDFCOLS;j++)
{
frame = gtk_frame_new(NULL);
printChk[1][i][j] = checkBox = gtk_check_button_new();
gtk_container_add(GTK_CONTAINER(frame), checkBox);
gtk_table_attach(GTK_TABLE(table), frame, j, j+1, i, i+1, 0, 0, 0, 0);
}
}
gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, FALSE, 2);
tables[2] = table = gtk_table_new(RMAXPDFROWS, RMAXPDFCOLS, TRUE);
for(i=0;i<RMAXPDFROWS;i++)
{
for(j=0;j<RMAXPDFCOLS;j++)
{
frame = gtk_frame_new(NULL);
printChk[2][i][j] = checkBox = gtk_check_button_new();
gtk_container_add(GTK_CONTAINER(frame), checkBox);
gtk_table_attach(GTK_TABLE(table), frame, j, j+1, i, i+1, 0, 0, 0, 0);
}
}
gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_box_pack_start(GTK_BOX(vbox), sep, TRUE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Print Format: ");
gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, FALSE, 2);
PprtFrmt[PRINT_FMT_PNG] = radioB1 = gtk_radio_button_new_with_label(NULL, "PNG");
gtk_box_pack_start(GTK_BOX(hbox), radioB1, TRUE, FALSE, 2);
PprtFrmt[PRINT_FMT_PS] = radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "POSTSCRIPT");
gtk_box_pack_start(GTK_BOX(hbox), radioB2, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Print Directory: ");
printWdgt[PDFPRINTDIRECTORY] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Print Filename: ");
printWdgt[PDFPRINTFNAME] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(printCmd), GINT_TO_POINTER(PDFPRNTPRINT));
sep = gtk_hseparator_new();
gtk_box_pack_start(GTK_BOX(vbox), sep, TRUE, FALSE, 2);
hbox = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("PRINT");
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(PDFPRNTPRINT));
button = gtk_button_new_with_label("CANCEL");
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(PDFPRNTCANCEL));
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(pdfPrintWndw), vbox);
gtk_window_set_transient_for((GtkWindow *) pdfPrintWndw, (GtkWindow *) topWindow);
gtk_window_set_position(GTK_WINDOW(pdfPrintWndw), GTK_WIN_POS_CENTER);
gtk_widget_show_all(pdfPrintWndw);
return;
}
void pdfPrint(GtkButton *button, gpointer t)
{
int tab = GPOINTER_TO_INT(t);
if (!pdfPrintWndw)
{
make_PDFPrint();
}
switch(tab)
{
case PDFMAIN:
gtk_widget_hide(tables[1]);
gtk_widget_hide(tables[2]);
gtk_widget_show(tables[0]);
break;
case PDFDETAIL:
gtk_widget_hide(tables[0]);
gtk_widget_hide(tables[2]);
gtk_widget_show(tables[1]);
break;
case PDFREQUEST:
gtk_widget_hide(tables[1]);
gtk_widget_hide(tables[0]);
gtk_widget_show(tables[2]);
break;
case SPECTROMAIN:
break;
case SPECTRODETREQ:
break;
}
gtk_widget_show(pdfPrintWndw);
gtk_window_resize(GTK_WINDOW(pdfPrintWndw), 1, 1);
return;
}
