#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
enum {
NTWSTORE,
STNSTORE,
LOCSTORE,
TTLSTORES,
LOCSTORE1
};
static GtkTooltips  *tips;
static char   toolTip[1000];
static GtkWidget *STNstnVIEW[TTLSTORES];
static GtkWidget *PDFstnList;
static void stationSel(GtkTreeSelection *selection, gpointer w);
static void stationCBack(GtkButton *button, gpointer t);
enum {
STNCXL,
STNDONE
};
enum {
STNSTN,
STNLOC,
TTLSTNLISTS
};
static GtkListStore *stores[TTLSTORES];
static GSList  *displayed[TTLSTNLISTS]; 
static GSList  *selected[TTLSTNLISTS];  
static void destroyStnStations(GtkWidget *widget, void *nothing)
{
stationCBack(NULL, GINT_TO_POINTER(STNCXL));
return;
}
static void add_hdr_columns(GtkTreeView *treeview, int which)
{
GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
GtkTreeViewColumn *col;
char   *hdr;
switch(which)
{
case NTWSTORE:
hdr = g_strdup("NTW");
break;   
case STNSTORE:
hdr = g_strdup("STN");
break;   
case LOCSTORE:
hdr = g_strdup("LOC");
break;
}
col = gtk_tree_view_column_new_with_attributes(hdr, renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
free(hdr);
}
static GtkWidget *makeHdrModel(int which)
{
GtkWidget *treeview;
stores[which] = gtk_list_store_new(1, G_TYPE_STRING);
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL(stores[which]));
return (treeview);
}
static void add_NTW_info(int which)
{
GtkTreeIter treeIter;
GSList *ntwIter;
GNode *node;
NSLCDATA *nodeD;
if (stores[which])
gtk_list_store_clear(stores[which]);
switch(which)
{
case NTWSTORE:
gtk_list_store_append(stores[which], &treeIter);
gtk_list_store_set(stores[which], &treeIter, 0, "ALL", -1);
for(ntwIter = ntwPDF;ntwIter;ntwIter=g_slist_next(ntwIter))
{ 
node = ntwIter->data;
nodeD = node->data;
gtk_list_store_append(stores[which], &treeIter);
gtk_list_store_set(stores[which], &treeIter, 0, nodeD->name, -1);
}
break;
}
}
static gint locFinder(GNode *one, GNode *two)
{
NSLCDATA *first=one->data, *second=two->data;
return (strcmp(first->name, second->name));
}
static gboolean _addStnInfo(GNode *node, gpointer w)
{
int  which = GPOINTER_TO_INT(w);
GtkTreeIter treeIter;
NSLCDATA *nodeD=node->data;
switch(which)
{
case STNSTORE:
switch(g_node_depth(node))
{ 
case 2: 
displayed[STNSTN] = g_slist_append(displayed[STNSTN], node);
gtk_list_store_append(stores[which], &treeIter);
gtk_list_store_set(stores[which], &treeIter, 0, g_strdup(nodeD->name), -1);
break;
}
break;
case LOCSTORE:
switch(g_node_depth(node))
{ 
case 3: 
if (!g_slist_find_custom(displayed[STNLOC], node, (GCompareFunc) locFinder))
{
displayed[STNLOC] = g_slist_append(displayed[STNLOC], node);
}
break;
}
break;
}
return FALSE;
}
static void add_STNLOC_info(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
GSList *ntwIter, *stnIter, *locIter;
GNode *locNode, *stnNode;
NSLCDATA *nodeD;
char *rowS;
int  rowSel;
switch(which)
{
case STNSTORE:  
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel==0)
{ 
for(ntwIter=ntwPDF;ntwIter;ntwIter=g_slist_next(ntwIter))
{ 
g_node_traverse(ntwIter->data, G_PRE_ORDER, G_TRAVERSE_ALL, 2, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(STNSTORE));
}
}
else
{ 
rowSel--;
ntwIter = g_slist_nth(ntwPDF, rowSel);
g_node_traverse(ntwIter->data, G_PRE_ORDER, G_TRAVERSE_ALL, 2, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(STNSTORE));
}
break;
case LOCSTORE:  
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel==0)
{ 
for(stnIter=displayed[STNSTN]; stnIter ; stnIter=g_slist_next(stnIter))
{
stnNode = stnIter->data;
g_node_traverse(stnNode, G_PRE_ORDER, G_TRAVERSE_ALL, 3, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(LOCSTORE));
nodeD = stnNode->data;
selected[STNSTN] = g_slist_append(selected[STNSTN], nodeD->name);
}
}
else
{ 
rowSel--;
stnIter = g_slist_nth(displayed[STNSTN], rowSel);
stnNode = stnIter->data;
g_node_traverse(stnNode, G_PRE_ORDER, G_TRAVERSE_ALL, 3, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(LOCSTORE));
nodeD = stnNode->data;
selected[STNSTN] = g_slist_append(selected[STNSTN], nodeD->name);
}
break;
case LOCSTORE1:  
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel==0)
{ 
for(locIter=displayed[STNLOC];locIter;locIter=g_slist_next(locIter))
{ 
locNode = locIter->data;
nodeD = locNode->data;
selected[STNLOC] = g_slist_append(selected[STNLOC], nodeD->name);
}
}
else
{ 
rowSel--;
locIter = g_slist_nth(displayed[STNLOC], rowSel);
locNode = locIter->data;
nodeD = locNode->data;
selected[STNLOC] = g_slist_append(selected[STNLOC], nodeD->name);
}
break;
}
g_free(rowS);
}
static void stationSel (GtkTreeSelection *selection, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
GtkTreeIter treeIter;
GNode *node;
NSLCDATA *nodeD;
GSList *locIter;
static GtkTreePath *path;
if (!path)
path=gtk_tree_path_new_from_string("0");
switch(which)
{
case NTWSTORE:
if (stores[STNSTORE])
gtk_list_store_clear(stores[STNSTORE]);
if (displayed[STNSTN]) 
{
g_slist_free(displayed[STNSTN]); 
displayed[STNSTN]=NULL;
}
gtk_list_store_append(stores[STNSTORE], &treeIter);
gtk_list_store_set(stores[STNSTORE], &treeIter, 0, "ALL", -1);
gtk_tree_selection_selected_foreach (selection, 
(GtkTreeSelectionForeachFunc) add_STNLOC_info, GINT_TO_POINTER(STNSTORE));
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, FALSE);
break;
case STNSTORE:
if (stores[LOCSTORE])
gtk_list_store_clear(stores[LOCSTORE]);
if (displayed[STNLOC])
{
g_slist_free(displayed[STNLOC]); 
displayed[STNLOC]=NULL;
}
if (selected[STNSTN])
{
g_slist_free(selected[STNSTN]); 
selected[STNSTN]=NULL;
}
gtk_list_store_append(stores[LOCSTORE], &treeIter);
gtk_list_store_set(stores[LOCSTORE], &treeIter, 0, "ALL", -1);
gtk_tree_selection_selected_foreach (selection,
(GtkTreeSelectionForeachFunc) add_STNLOC_info, GINT_TO_POINTER(LOCSTORE));
for(locIter=displayed[STNLOC];locIter;locIter=g_slist_next(locIter))
{
node = locIter->data;
nodeD = node->data;
gtk_list_store_append(stores[LOCSTORE], &treeIter);
gtk_list_store_set(stores[LOCSTORE], &treeIter, 0, g_strdup(nodeD->name), -1);
}
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, FALSE);
break;
case LOCSTORE:
if (selected[STNLOC])
{
g_slist_free(selected[STNLOC]);
selected[STNLOC]=NULL;
}
gtk_tree_selection_selected_foreach (selection,
(GtkTreeSelectionForeachFunc) add_STNLOC_info, GINT_TO_POINTER(LOCSTORE1));
;
break;   
}
}
static void make_stationList(GtkWidget **PDFstnList)
{
GtkWidget *frame1, *hbox1, *identSW;
GtkWidget *vbox, *vbox1, *button;
GtkTreeSelection *select;
tips = gtk_tooltips_new();
*PDFstnList = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(*PDFstnList), "PDF Station Selector"); 
gtk_container_set_border_width(GTK_CONTAINER(*PDFstnList), 2);
g_signal_connect(*PDFstnList, "destroy", G_CALLBACK(destroyStnStations), NULL);
frame1 = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_IN);
gtk_container_add(GTK_CONTAINER(*PDFstnList), frame1);
vbox1 = gtk_vbox_new(FALSE, 0);
hbox1 = gtk_hbox_new(FALSE, 0);
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW (identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[NTWSTORE] = makeHdrModel(NTWSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[NTWSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), NTWSTORE);
gtk_widget_set_size_request(identSW, 100, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT (select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(NTWSTORE));
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW (identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[STNSTORE] = makeHdrModel(STNSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[STNSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), STNSTORE);
gtk_widget_set_size_request(identSW, 100, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT (select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(STNSTORE));
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW (identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[LOCSTORE] = makeHdrModel(LOCSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[LOCSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), LOCSTORE);
gtk_widget_set_size_request(identSW, 100, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT (select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(LOCSTORE));
vbox = gtk_vbutton_box_new ();
gtk_button_box_set_layout(GTK_BUTTON_BOX(vbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("CANCEL");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return to STN Viewer");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stationCBack), GINT_TO_POINTER(STNCXL));
button = gtk_button_new_with_label("DONE");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return to STN viewer");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stationCBack), GINT_TO_POINTER(STNDONE));
gtk_box_pack_start(GTK_BOX(hbox1), vbox, FALSE, FALSE, 2); 
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 2); 
gtk_container_add(GTK_CONTAINER(frame1), vbox1);
gtk_window_set_position(GTK_WINDOW(*PDFstnList), GTK_WIN_POS_CENTER);
gtk_widget_show_all(*PDFstnList);
gtk_window_set_transient_for((GtkWindow *) *PDFstnList, (GtkWindow *) topWindow); 
}
void make_PDF_stationDialogue(GtkButton *button, gpointer nil)
{
GtkTreePath *path;
if (!PDFstnList)
make_stationList(&PDFstnList);
if (dirty(PDFSYSTEM))
{ 
add_NTW_info(NTWSTORE);
path = gtk_tree_path_new_from_string("0");
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), path, NULL, FALSE);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, FALSE);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, FALSE);
gtk_tree_path_free (path);
}
gtk_widget_show(PDFstnList);
}
static gboolean regPDFChn(GNode *node, GSList **groupChn)
{ 
static char *locName=NULL;
NSLCDATA *nodeD=node->data;
switch(g_node_depth(node))
{
case 3:  
if (locName)
free(locName);
locName = NULL;
if (!g_slist_find_custom(selected[STNLOC], nodeD->name, (GCompareFunc) strcmp))
{ 
break;
}   
locName = g_strdup(nodeD->name);
break;
case 4:
if (!locName)  
break;
if (!isPDFchn(nodeD->name))
break;
*groupChn = g_slist_append(*groupChn, nodeD);
break;
}
return FALSE;
}
static void getPDFChnList(GSList *displayed, GSList *selected)
{
GSList  *stnIter;
NSLCDATA *nodeD;
GNode  *stnchnIter;
int   screen = pdfStates.screen;
GSList  **list;
switch (screen)
{
case PDFMAIN:
list = &pdfStates.main.group.list;
break;
case SPECTROMAIN:
list = &pdfStates.spmain.group.list;
break;
}
g_slist_free(*list); *list = NULL;
for(stnIter=displayed;stnIter;stnIter=g_slist_next(stnIter))
{
stnchnIter = stnIter->data;   
nodeD = stnchnIter->data;   
if (!g_slist_find_custom(selected, nodeD->name, (GCompareFunc) strcmp))
continue;
g_node_traverse(stnchnIter, G_PRE_ORDER, G_TRAVERSE_ALL, -1, (GNodeTraverseFunc) regPDFChn, list);
}
}
static void stationCBack(GtkButton *button, gpointer t)
{ 
int  type = GPOINTER_TO_INT(t);
gtk_widget_hide(PDFstnList);
switch(type)
{
case STNCXL:
break;
case STNDONE:
if (!selected[STNSTN] || !selected[STNLOC])
break;
switch(pqlxStates.system)
{
case PDFSYSTEM:
getPDFChnList(displayed[STNSTN], selected[STNSTN]);   
makeChnFltList();           
nextPDFs(NULL, GINT_TO_POINTER(INITIALIZE));
break;
}
break;
}
}
