#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
void make_pdf_gc(GtkWidget *widget)
{
int   i;
GdkColor *fg, *bg;
static gboolean called=FALSE;
if (called)
return;
called = TRUE;
for (i=0;i<TOTALPDFCONTEXTS;i++)
{
switch(i)
{
case PDFMSG:
fg = &darkBlue; bg = &lightGrey2;
break;
case PDFTEXT:
fg = &myBlack; bg = &myWhite;
break;
#if 0    
#endif
case PDFTRCBG:
fg = &myBlack; bg = &lightGrey1;
break;
case PDFDASHLINE:
fg = &myBlack; bg = &lightGrey1;
break;
case PDFPINKLINE:
fg = &red; bg = &lightGrey1;
break;
}
pdfSettings.drawing.ctxts[i][NORMALGC] = gdk_gc_new(widget->window);
gdk_gc_set_rgb_fg_color(pdfSettings.drawing.ctxts[i][NORMALGC], fg);
gdk_gc_set_rgb_bg_color(pdfSettings.drawing.ctxts[i][NORMALGC], bg);
pdfSettings.drawing.ctxts[i][ABNORMALGC] = gdk_gc_new(widget->window);
gdk_gc_set_rgb_bg_color(pdfSettings.drawing.ctxts[i][ABNORMALGC], fg);
gdk_gc_set_rgb_fg_color(pdfSettings.drawing.ctxts[i][ABNORMALGC], bg);
pdfSettings.drawing.ctxts[i][INVGC] = gdk_gc_new(widget->window);
gdk_gc_set_rgb_bg_color(pdfSettings.drawing.ctxts[i][INVGC], bg);
gdk_gc_set_rgb_fg_color(pdfSettings.drawing.ctxts[i][INVGC], fg);
gdk_gc_set_function(pdfSettings.drawing.ctxts[i][INVGC], GDK_INVERT);
}
gdk_gc_set_line_attributes(pdfSettings.drawing.ctxts[PDFDASHLINE][INVGC],
1, GDK_LINE_ON_OFF_DASH, 0, 0);
return;
}
void initPDFFont()
{
int   i;
GdkColor *fg, *bg;
static gboolean called=FALSE;
if (called)
return;
called = TRUE;
initFontP();
for(i=PDFFMSG;i<NUMFONTGCP;i++)
{
switch(i)
{
case PDFFMSG:
fg = &darkBlue; bg = &lightGrey2;
break;
case PDFFTEXT:
fg = &myBlack; bg = &myWhite;
break;
case PDFFTRC:
fg = &myBlack; bg = &lightGrey1;
break;
case PDFSTATSTEXT:
fg = &myBlack; bg = &lightGrey2;
break;
}
makeFONTGC(i, fg, bg);
}
}
void dispMsgPDF(int action, char *msg)
{
static guint msgContext;
if(!msgContext)
msgContext = gtk_statusbar_get_context_id((GtkStatusbar *) statusBarPDF, "PDFDATASCREENS");
#if 0
if (msgID)
{
gtk_statusbar_remove((GtkStatusbar *) statusBarPDF, msgContext, msgID);
msgID = 0;
}
#endif
switch(action)
{
case DISPLAY:
gtk_statusbar_push((GtkStatusbar *) statusBarPDF, msgContext, msg);
break;
case UNDISPLAY:
gtk_statusbar_pop((GtkStatusbar *) statusBarPDF, msgContext);
break;
}
return ;
}
gint getPeriodBounds(XAXISBOUNDSDEF *xAxis, char *channel)
{
return(strcmp(xAxis->chnGrp, channel));
}
void setPeriodBounds(int chnKey, PDFXAXIS *axis)
{
GSList  *defs = pdfSettings.main.xAxis.defs;
gboolean active = (pdfStates.screen == PDFMAIN) ? pdfSettings.main.xAxis.active 
: (pdfStates.screen == SPECTROMAIN) ? pdfSettings.spmain.xAxis.active
: (pdfStates.screen == SPECTRODETREQ) ? pdfSettings.spreq.xAxis.active
: OFF;
axis->bounds[PERSTART] = 0.0;
axis->bounds[PEREND] = 0.0;
if (active == OFF ||
!defs)
return;
switch(active)
{
case ON:
{
GSList   *xAxisIter;
XAXISBOUNDSDEF *xAxis=NULL;
char    *channel, *chnName;
chnName = ChnName(chnKey);
if (!chnName)
break;
channel = g_strdup_printf("%.2s", (gchar *)(g_strrstr(chnName, ".")+1));
xAxisIter = g_slist_find_custom(defs, channel, (GCompareFunc) getPeriodBounds);
if (xAxisIter)
{
xAxis = xAxisIter->data;
axis->bounds[PERSTART] = xAxis->xAxis.bounds[PERSTART];
axis->bounds[PEREND] = xAxis->xAxis.bounds[PEREND];
}
free(channel);
}
break;
}
}
void resetDrawings()
{
int i, j, k;
switch(pdfStates.screen)
{
case PDFMAIN:
for(j=0; j<MMAXPDFROWS; j++)
for(k=0; k<MMAXPDFCOLS; k++)
makeDrawing(PDFMAIN, j, k);
break;
case PDFDETAIL:
for(j=0, i=0; j<DMAXPDFROWS; j++)
for(k=0; k<DMAXPDFCOLS; k++, i++)
if (pdfStates.detail.pdfReq[i])
makeDrawing(PDFDETAIL, k, j);
break;
case PDFREQUEST:
for(j=0; j<RMAXPDFROWS; j++)
for(k=0; k<RMAXPDFCOLS; k++)
makeDrawing(PDFREQUEST, j, k);
break;
case SPECTROMAIN:
for(j=0; j<SMAXROWS; j++)
for(k=0; k<SMAXCOLS; k++)
{
if (k == COLSPEC)
pdfStates.spmain.specReq[j][0].plot.replot = TRUE;
makeDrawing(SPECTROMAIN, j, k);
}
break;
case SPECTRODETREQ:
for(j=0; j<SMAXROWS; j++)
for(k=0; k<SMAXCOLS; k++)
{
if (k == COLSPEC)
pdfStates.spdetreq.specReq[j][0].plot.replot = TRUE;
makeDrawing(SPECTRODETREQ, j, k);
}
break;
}
}
