#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pql_defines.h"
#include "pqlx_defs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "dbl_iface.h"
static GtkWidget *XAxisScale, *chnNAME, *chnVALS[TTLFDUNITS][TTLPERBOUNDS], *FDUnits[TTLFDUNITS],
*chnNEW, *chnSAVE, *chnDEL, *chnGrpVIEW, *chnAPPLY, *chnDONE;
static GtkTooltips *tips;
static char   toolTip[1000];
static gboolean saveSTATE=FALSE, doneSTATE;
static char  *doneLABELS[] = {"QUIT", "CANCEL"};
static void chnGrpInfo(GtkTreeView *treeview, gpointer which);
static void chnGrpEdit(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer which);
static void chnGrpCBack(GtkButton *button, gpointer type);
static void displayInfo(int screen, gboolean data);
enum {  
CHNNEW,
CHNSAVE,
CHNDEL,
CHNDONE,
CHNAPPLY
};
enum {  
QUIT,
XCEL,
TTLDONESTATES
};
enum {    
CHNGRPCHN,  
TTLCHNGRPSTORES
};
static gint sortchnNAMEs(XAXISBOUNDSDEF *one, XAXISBOUNDSDEF *two)
{
return(strcmp(one->chnGrp, two->chnGrp));
}
GtkListStore *chnStore[TTLCHNGRPSTORES];
static void add_hdr_columns(GtkTreeView *treeview, int which)
{
char  *label=NULL;
GtkCellRenderer *renderer;
GtkTreeViewColumn *col;
switch(which)
{
case CHNGRPCHN:
label = g_strdup("Channel Groups");
break;
}
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(label, renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
free(label);
}
static GtkWidget *makeModel(int which)
{
GtkWidget *treeview;
chnStore[which] = gtk_list_store_new(1, G_TYPE_STRING);
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL(chnStore[which]));
return (treeview);
}
static void makeLists(int which)
{ 
char  *name=NULL;
XAXISBOUNDSDEF *xAxis;
GtkTreeIter iter;
GSList  *listIter, *list = pdfSettings.main.xAxis.defs;
if (chnStore[which])
gtk_list_store_clear(chnStore[which]);
for(listIter = list; listIter; listIter = g_slist_next(listIter))
{
switch(which)
{
case CHNGRPCHN:
xAxis = listIter->data;
name = xAxis->chnGrp;
break;
}
gtk_list_store_append(chnStore[which], &iter);
gtk_list_store_set(chnStore[which], &iter, 0, name, -1);
}
}
static GtkWidget *make_tab(int which)
{
GtkWidget *frame1, *hbox1, *hbox, *scrW;
GtkWidget *vbox, *vbox1, *vbox2, *entry, *label, *button, *view;
GtkSizeGroup *size_group;
if (!tips)
tips = gtk_tooltips_new();
frame1 = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_IN);
switch(which)
{
case CHNGRPCHN:
vbox1 = gtk_vbox_new(FALSE, 0);
hbox1 = gtk_hbox_new(FALSE, 0);
scrW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
chnGrpVIEW = view = makeModel(CHNGRPCHN);
g_signal_connect(view, "row-activated", G_CALLBACK(chnGrpEdit), GINT_TO_POINTER(CHNGRPCHN));
g_signal_connect(view, "cursor-changed", G_CALLBACK(chnGrpInfo), GINT_TO_POINTER(CHNGRPCHN));
gtk_container_add(GTK_CONTAINER(scrW), view);
gtk_box_pack_start(GTK_BOX(hbox1), scrW, TRUE, TRUE, 2);
add_hdr_columns(GTK_TREE_VIEW(view), CHNGRPCHN);
gtk_widget_set_size_request(scrW, -1, 150);
strcpy(toolTip, "Single-click to VIEW\nDouble-click to EDIT");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), view, toolTip, toolTip);
vbox = gtk_vbox_new(FALSE, 0); 
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Name: ");
chnNAME = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "The NAME of the Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
FDUnits[FDUNIT_PER] = vbox2 = gtk_vbox_new(TRUE, 0);
gtk_box_pack_start(GTK_BOX(vbox), vbox2, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Min Period: ");
chnVALS[FDUNIT_PER][PERSTART] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "MINIMUM Period to Display, May be:\n" 
"\t1) Specific Value\n"
"\t2) Blank - Real MINIMUM Period");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Max Period: ");
chnVALS[FDUNIT_PER][PEREND] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "MAXIMUM Period to Display, May be:\n"
"\t1) Specific Value\n"
"\t2) Blank - Actual MAXIMUM Period");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
FDUnits[FDUNIT_FREQ] = vbox2 = gtk_vbox_new(TRUE, 0);
gtk_box_pack_start(GTK_BOX(vbox), vbox2, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Min Frequency: ");
chnVALS[FDUNIT_FREQ][PERSTART] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "MINIMUM Frequency to Display, May be:\n" 
"\t1) Specific Value\n"
"\t2) Blank - Real MINIMUM Frequency");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Max Frequency: ");
chnVALS[FDUNIT_FREQ][PEREND] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "MAXIMUM Frequency to Display, May be:\n"
"\t1) Specific Value\n"
"\t2) Blank - Actual MAXIMUM Frequency");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(hbox1), vbox, FALSE, FALSE, 2);
hbox = gtk_hbutton_box_new ();
gtk_button_box_set_layout (GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
chnNEW = button = gtk_button_new_with_label("NEW");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Make NEW Channel Group Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNNEW));
chnSAVE = button = gtk_button_new_with_label("SAVE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "SET Channel Group Defaults - Restored at Startup");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNSAVE));
chnDEL = button = gtk_button_new_with_label("DELETE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Delete Channel Group from List");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNDEL));
chnAPPLY = button = gtk_button_new_with_label("APPLY");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "APPLY Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNAPPLY));
chnDONE = button = gtk_button_new_with_label(doneLABELS[QUIT]);
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "QUIT = Close Dialog\nCANCEL = Exit Edit Mode - Do Not Adopt Changes");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNDONE));
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2); 
gtk_box_pack_end(GTK_BOX(vbox1), hbox, FALSE, TRUE, 2); 
gtk_container_add(GTK_CONTAINER(frame1), vbox1);
break;
}
return frame1;
}
void make_PeriodScaleDialog(GtkToggleButton *button, gpointer s)
{
GtkWidget *tab, *vbox, *frame;
if (!XAxisScale)
{
XAxisScale = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title (GTK_WINDOW(XAxisScale), "Period Boundary Definition"); 
gtk_container_set_border_width(GTK_CONTAINER(XAxisScale), 2);
gtk_window_set_position(GTK_WINDOW(XAxisScale), GTK_WIN_POS_CENTER);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add (GTK_CONTAINER(XAxisScale), vbox);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
tab = make_tab(CHNGRPCHN);
gtk_container_add(GTK_CONTAINER(frame), tab);
gtk_container_add(GTK_CONTAINER(vbox), frame);
gtk_widget_show_all(XAxisScale);
}
switch (pdfSettings.common.fdUnits)
{
case FDUNIT_FREQ:
gtk_widget_hide(FDUnits[FDUNIT_PER]);
gtk_widget_show(FDUnits[FDUNIT_FREQ]);
break;
case FDUNIT_PER:
gtk_widget_hide(FDUnits[FDUNIT_FREQ]);
gtk_widget_show(FDUnits[FDUNIT_PER]);
break;
}
makeLists(CHNGRPCHN);
gtk_widget_set_sensitive(chnSAVE, saveSTATE);
gtk_widget_set_sensitive(chnNAME, FALSE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(chnAPPLY, FALSE);
gtk_widget_show(XAxisScale);
displayInfo(CHNGRPCHN, FALSE);
doneSTATE = QUIT;
return;
}
static int chnSelected = NONE;
static void displayInfo(int which, gboolean data)
{
XAXISBOUNDSDEF *xAxis;
switch(which)
{
case CHNGRPCHN:
xAxis = g_slist_nth_data(pdfSettings.main.xAxis.defs, chnSelected);
switch(data)
{
case TRUE:
{
gtk_entry_set_text(GTK_ENTRY(chnNAME), xAxis->chnGrp);
if (strlen(xAxis->bounds[PERSTART]))
{
char *freq = g_strdup_printf("%.3f", 1./xAxis->xAxis.bounds[PERSTART]);
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_PER][PERSTART]), xAxis->bounds[PERSTART]);
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_FREQ][PEREND]), freq);
free(freq);
}
else
{
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_PER][PERSTART]), "");
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_FREQ][PEREND]), "");
}
if (strlen(xAxis->bounds[PEREND]))
{
char *freq = g_strdup_printf("%.3f", 1./xAxis->xAxis.bounds[PEREND]);
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_PER][PEREND]), xAxis->bounds[PEREND]);
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_FREQ][PERSTART]), freq);
free(freq);
}
else
{
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_PER][PEREND]), "");
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_FREQ][PERSTART]), "");
}
}
break;
case FALSE:
gtk_entry_set_text(GTK_ENTRY(chnNAME), "");
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_PER][PEREND]), "");
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_FREQ][PEREND]), "");
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_PER][PERSTART]), "");
gtk_entry_set_text(GTK_ENTRY(chnVALS[FDUNIT_FREQ][PERSTART]), "");
gtk_widget_set_sensitive(chnNAME, FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PEREND], FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PERSTART], FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PEREND], FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PERSTART], FALSE);
break;
}
break;
}   
}
static void chnGrpInfo(GtkTreeView *treeview, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
char *rowS;
GtkTreePath *path;
gtk_tree_view_get_cursor (treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
gtk_tree_path_free(path);
switch(which)
{
case CHNGRPCHN:
chnSelected = atoi(rowS);
gtk_widget_set_sensitive(chnAPPLY, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(chnNAME, FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PEREND], FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PERSTART], FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PEREND], FALSE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PERSTART], FALSE);
break;
}
displayInfo(which, TRUE);
g_free(rowS);
}
static void chnGrpEdit(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
switch(which)
{
case CHNGRPCHN:
chnGrpInfo(treeview, w);
doneSTATE = XCEL;
gtk_button_set_label(GTK_BUTTON(chnDONE), doneLABELS[doneSTATE]);
gtk_widget_set_sensitive(chnAPPLY, TRUE);
gtk_widget_set_sensitive(chnDEL, TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PEREND], TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PERSTART], TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PEREND], TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PERSTART], TRUE);
break;
}
}
#include <ctype.h>
#if 0
static gboolean valid(char *scale)
{
int  i;
gboolean valid = TRUE, check = FALSE; 
for(i=0;i<strlen(scale);i++)
{
if (!isdigit(scale[i]) &&
scale[i] != '%' &&
scale[i] != '-' &&
scale[i] != '.')
{
check = TRUE;
scale[i] = toupper(scale[i]);
}
}
return valid; 
}
#endif
static void chnGrpCBack(GtkButton *button, gpointer t)
{
int  type = GPOINTER_TO_INT(t);
switch(type)
{
case CHNNEW:
chnSelected = NONE;
displayInfo(CHNGRPCHN, FALSE);
gtk_widget_set_sensitive(chnAPPLY, TRUE);
gtk_widget_set_sensitive(chnNEW, FALSE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(chnNAME, TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PEREND], TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_PER][PERSTART], TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PEREND], TRUE);
gtk_widget_set_sensitive(chnVALS[FDUNIT_FREQ][PERSTART], TRUE);
doneSTATE = XCEL;
gtk_button_set_label(GTK_BUTTON(chnDONE), doneLABELS[doneSTATE]);
gtk_widget_grab_focus(chnNAME);
break;
case CHNAPPLY:
{
int    i, j;
char   *val;
GSList   *iter;
XAXISBOUNDSDEF *xAxis;
xAxis = calloc(1, sizeof(XAXISBOUNDSDEF));
xAxis->chnGrp = g_strdup(gtk_entry_get_text(GTK_ENTRY(chnNAME)));
for (i=0; i < TTLPERBOUNDS; i++)
{
val = g_strdup(gtk_entry_get_text(GTK_ENTRY(chnVALS[pdfSettings.common.fdUnits][i])));
if (pdfSettings.common.fdUnits == FDUNIT_FREQ &&
strlen(val))
{ 
float ival = 1./atof(val);
free(val);
val = g_strdup_printf("%f", ival);
}
xAxis->bounds[i] = val;
}
if (pdfSettings.common.fdUnits == FDUNIT_FREQ)
{ 
char *tmp = xAxis->bounds[PERSTART];
xAxis->bounds[PERSTART] = xAxis->bounds[PEREND];
xAxis->bounds[PEREND] = tmp;
}
for (i=0; i < TTLPERBOUNDS; i++)
{
switch(strlen(xAxis->bounds[i]))
{
case 0:
xAxis->xAxis.bounds[i] = 0.0;  
break;
default:
xAxis->xAxis.bounds[i] = atof(xAxis->bounds[i]);
break;
}
}
displayInfo(CHNGRPCHN, FALSE);
gtk_widget_set_sensitive(chnAPPLY, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnSAVE, TRUE);
gtk_widget_set_sensitive(chnDEL, FALSE);
doneSTATE = QUIT;
gtk_button_set_label(GTK_BUTTON(chnDONE), doneLABELS[doneSTATE]);
iter = g_slist_find_custom(pdfSettings.main.xAxis.defs, xAxis->chnGrp, (GCompareFunc) getPeriodBounds);
if (iter)
{ 
pdfSettings.main.xAxis.defs = g_slist_remove(pdfSettings.main.xAxis.defs, iter->data);
}
pdfSettings.main.xAxis.defs = g_slist_insert_sorted(pdfSettings.main.xAxis.defs, xAxis, (GCompareFunc) sortchnNAMEs);
makeLists(CHNGRPCHN);
switch (pdfSettings.main.xAxis.active)
{
case ON: 
for (i = 0; i < MMAXPDFROWS; i++)
for (j = 0; j < MMAXPDFCOLS; j++)
makeDrawing(PDFMAIN, i, j);
break;
case OFF: 
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(axisBnds[pdfStates.screen][ON]), TRUE);
break;
}
saveSTATE = TRUE;
}
break;
case CHNSAVE:
{
write_PDFdefault(XAXISBNDS);
saveSTATE = FALSE;
gtk_widget_set_sensitive(chnSAVE, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnNAME, FALSE);
}
break;
case CHNDEL:
{
GSList   *iter;
char   *chnGrp;
chnGrp = g_strdup(gtk_entry_get_text(GTK_ENTRY(chnNAME)));
iter = g_slist_find_custom(pdfSettings.main.xAxis.defs, chnGrp, (GCompareFunc) getPeriodBounds);
if (iter)
{ 
pdfSettings.main.xAxis.defs = g_slist_remove(pdfSettings.main.xAxis.defs, iter->data);
}
makeLists(CHNGRPCHN);
switch (pdfSettings.main.xAxis.active)
{
case ON: 
resetDrawings();
break;
case OFF: 
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(axisBnds[pdfStates.screen][ON]), TRUE);
break;
}
makeLists(CHNGRPCHN);
displayInfo(CHNGRPCHN, FALSE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(chnAPPLY, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnSAVE, TRUE);
doneSTATE = QUIT;
gtk_button_set_label(GTK_BUTTON(chnDONE), doneLABELS[doneSTATE]);
saveSTATE = TRUE;
}
break;
case CHNDONE:
switch (doneSTATE)
{
case QUIT:
gtk_grab_remove(XAxisScale);
gtk_widget_hide(XAxisScale);
break;
case XCEL:
doneSTATE = QUIT;
gtk_button_set_label(GTK_BUTTON(chnDONE), doneLABELS[doneSTATE]);
gtk_widget_set_sensitive(chnAPPLY, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnDEL, FALSE);
displayInfo(CHNGRPCHN, FALSE);
break;
}
break;
}
}
