#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "util_externs.h"
enum {
EVTSPECDETAIL,
EVTSPECZOOM,
EVTSPECINVERT,
EVTSPECCBAR,
TTLSPECEVENTS
};
enum { 
UPPERUP,
UPPERDOWN,
LOWERUP,
LOWERDOWN
};
enum {
HEAD,
TAIL,
TTLLISTENDS
};
#define CHECKBOUND(i, le) { int xval = (le == HEAD) ? xmin : xmax; SPECTRODATA *s = i->data; if (((gboolean)(le == TAIL)) ^ ((gboolean)(zoomType == ZOOMIN)) ? (s)->psdRef >= xval : (s)->psdRef <= xval) { *listEnd = i; break;} }
#define STARTITER(le) ((le == HEAD) ? start : end)
#define NEXTITER(i, le) ((((gboolean)(le == TAIL)) ^ ((gboolean)(zoomType == ZOOMIN))) ? g_list_next(i) : g_list_previous(i))
#define CBARF(yPos) ((yPos < (PDFTOPM - ARROWH)) ? NONE : (yPos < PDFTOPM-ARROWH/2) ? UPPERUP : (yPos < PDFTOPM) ? UPPERDOWN : (yPos) > h - PDFBOTM + ARROWH/2 ? LOWERDOWN : LOWERUP)
typedef struct _MOUSESTATE 
{
gint startX, startY, endX, endY;
gboolean mouseDown;
int  row, col;
} MOUSESTATE;
static MOUSESTATE mouseState;
static GdkGC *gcINV;
static void zoomSpectro(int zoomType, int row, int col)
{
static gboolean zoomed = FALSE;
int   screen = pdfStates.screen, i;
int   xmin, xmax;
GList  *iter, **listEnd;
graph  *gr;
SPECREQ  *specReq;
GList  *start, *end;
if (zoomType == ZOOMIN &&
zoomed)
{
gdk_beep();
return;
}
zoomed = FALSE;
switch (screen)
{
case SPECTROMAIN:
gr = &pdfStates.spmain.specGR[row][0];
specReq = &pdfStates.spmain.specReq[row][0];
break;
case SPECTRODETREQ:
gr = &pdfStates.spdetreq.specGR[row][0];
specReq = &pdfStates.spdetreq.specReq[row][0];
break;
}
if (!specReq->keys.chnKey)  
return;
start = specReq->plot.start;
end = specReq->plot.end;
specReq->plot.bounds[XMIN] = (PIX2USERX(gr, mouseState.startX) > PSDREFABSS(specReq)) 
? PIX2USERX(gr, mouseState.startX)  
: PSDREFABSS(specReq);     
specReq->plot.bounds[XMAX] = (PIX2USERX(gr, mouseState.endX) < PSDREFABSE(specReq))
? PIX2USERX(gr, mouseState.endX)  
: PSDREFABSE(specReq);     
if (specReq->plot.bounds[XMIN] >= specReq->plot.bounds[XMAX])
{ 
gdk_beep();
specReq->plot.bounds[XMAX] = specReq->plot.bounds[XMIN] + 2;
zoomed = TRUE;
}
xmin = specReq->plot.bounds[XMIN];
xmax = specReq->plot.bounds[XMAX];
if (xmin == PSDREFABSS(specReq) &&
xmax == PSDREFABSE(specReq))
{ 
gdk_beep();
specReq->plot.start = specReq->data.spectro;
specReq->plot.end = g_list_last(specReq->data.spectro);
}
else
{
for (i = 0; i < TTLLISTENDS; i++)
{ 
listEnd = (i==HEAD) ? &specReq->plot.start : &specReq->plot.end;
for (iter = STARTITER(i);
iter;
iter = NEXTITER(iter, i))
{
CHECKBOUND(iter, i);
}
}
}
specReq->plot.numDivs = PSDREFPLOTE(specReq) - PSDREFPLOTS(specReq) + 1;
g_date_free(specReq->plot.dateBounds[STARTDT]);
g_date_free(specReq->plot.dateBounds[ENDDT]);
specReq->plot.dateBounds[STARTDT] = g_date_copy(specReq->data.dateBounds[STARTDT]);
g_date_add_days(specReq->plot.dateBounds[STARTDT], xmin/specReq->data.numPSDday);
specReq->plot.dateBounds[ENDDT] = g_date_copy(specReq->data.dateBounds[STARTDT]);
g_date_add_days(specReq->plot.dateBounds[ENDDT], xmax/specReq->data.numPSDday);
specReq->plot.replot = TRUE;
}
gboolean mouseEventSPECTROPDF(GtkWidget *da, GdkEventButton *event, gpointer s)
{
int  scr = GPOINTER_TO_INT(s);
int  screen = (scr)/MAXNUMBERS;
int  base = (scr - screen*MAXNUMBERS);
int  row = ROWNUM(base);
PDFREQ *pdfReq;
SPECREQ *specReq;
switch (screen)
{
case SPECTROMAIN:
specReq = &pdfStates.spmain.specReq[row][0];
pdfReq = &pdfStates.spmain.pdfReq[row][0];
break;
case SPECTRODETREQ:
specReq = &pdfStates.spdetreq.specReq[row][0];
pdfReq = &pdfStates.spdetreq.pdfReq[row][0];
break;
}
if (!pdfReq->data.name)  
return TRUE;
switch(event->type)
{
case GDK_BUTTON_RELEASE:  
if (pdfReq->data.numRecs == NOPSDDATA)
{ 
gdk_beep();
break;
}
SETHG(hourCursor);  
switch (screen)
{
case SPECTROMAIN:
break;
case SPECTRODETREQ:
{
GDate *start, *end;
gint32 epochS;
int  secsPdiv = SECSPDIVSP(specReq);
start = specReq->plot.dateBounds[STARTDT];
end = specReq->plot.dateBounds[ENDDT];
pdfReq->keys.criteria[PDFREQ_YRSTART] = g_date_get_year(start);
pdfReq->keys.criteria[PDFREQ_YREND] = g_date_get_year(end);
pdfReq->keys.criteria[PDFREQ_DYSTARTM] = g_date_get_month(start);
pdfReq->keys.criteria[PDFREQ_DYENDM] = g_date_get_month(end);
pdfReq->keys.criteria[PDFREQ_DYSTARTD] = g_date_get_day(start);
pdfReq->keys.criteria[PDFREQ_DYENDD] = g_date_get_day(end);
epochS = spectroEStart(specReq);      
epochS -= ((gint32) getMidnight((double) epochS));  
pdfReq->keys.criteria[PDFREQ_HRSTARTH] = (epochS) / (ONEHROFSECS);
pdfReq->keys.criteria[PDFREQ_HRSTARTM] = ((epochS) % (ONEHROFSECS)) / ONEMNOFSECS;
if (secsPdiv > ONEMNOFSECS)
{
pdfReq->keys.criteria[PDFREQ_HRSTARTM]--;
pdfReq->keys.criteria[PDFREQ_HRSTARTS] = 0; 
}
else
{
pdfReq->keys.criteria[PDFREQ_HRSTARTS] = 
((epochS) - 
pdfReq->keys.criteria[PDFREQ_HRSTARTH] * ONEHROFSECS -
pdfReq->keys.criteria[PDFREQ_HRSTARTM] * ONEMNOFSECS);
pdfReq->keys.criteria[PDFREQ_HRSTARTS] -= (secsPdiv/2);
}
epochS = spectroEStart(specReq) + TTLSECSSP(specReq); 
epochS -= ((gint32) getMidnight((double) epochS));  
epochS -= secsPdiv;          
pdfReq->keys.criteria[PDFREQ_HRENDH] = (epochS) / (ONEHROFSECS);
pdfReq->keys.criteria[PDFREQ_HRENDM] = ((epochS) % (ONEHROFSECS)) / ONEMNOFSECS;
if (secsPdiv > ONEMNOFSECS)
{
pdfReq->keys.criteria[PDFREQ_HRENDM]++;
pdfReq->keys.criteria[PDFREQ_HRENDS] = 0; 
}
else
{
pdfReq->keys.criteria[PDFREQ_HRENDS] = 
((epochS) - 
pdfReq->keys.criteria[PDFREQ_HRENDH] * ONEHROFSECS -
pdfReq->keys.criteria[PDFREQ_HRENDM] * ONEMNOFSECS);
pdfReq->keys.criteria[PDFREQ_HRENDS] += (secsPdiv/2);
}
pdfReq->keys.pdfKey = CUSTOMPDF;
pdfReq->keys.reqType = REQRANGE2;
}
break;
}
pdfReq->keys.tmpFilled = FALSE;
pdfReq->keys.fillTmp = FALSE;
clearDispList();
PDFinitDetail(pdfReq, TRUE);
gtk_notebook_set_current_page((GtkNotebook *) PSDnb, PDFNB);
gtk_notebook_set_current_page((GtkNotebook *) PSDbooks[PDFNB], PDFDETAIL);
break;
default: 
break;
}
return TRUE;
}
#define MINZOOMPIXELS 10
gboolean mouseEventSPECTRO(GtkWidget *da, GdkEventButton *event, gpointer s)
{
int  scr = GPOINTER_TO_INT(s);
int  screen = (scr)/MAXNUMBERS;
int  base = (scr - screen*MAXNUMBERS);
int  row = ROWNUM(base), col = COLNUM(base);
SPECREQ *specReq = &pdfStates.spdetreq.specReq[row][0];
gint w = da->allocation.width;
gint h = da->allocation.height;
int  type = NONE;
gboolean refresh = FALSE;
if (!gcINV)
{
gcINV = gdk_gc_new(da->window);
gdk_gc_set_function(gcINV, GDK_INVERT);
}
switch (screen)
{
case SPECTROMAIN:
specReq = &pdfStates.spmain.specReq[row][0];
break;
case SPECTRODETREQ:
specReq = &pdfStates.spdetreq.specReq[row][0];
break;
}
if (!specReq->data.name) 
return TRUE;
if ((screen == SPECTROMAIN) &&
(event->x > PDFSIDEM && event->x < w - PDFSIDEM &&
event->y > PDFTOPM && event->y < h - PDFBOTM))
type = EVTSPECDETAIL;
else if ((screen == SPECTRODETREQ) &&
(event->x > PDFSIDEM && event->x < w - PDFSIDEM &&
event->y > PDFTOPM && event->y < h - PDFBOTM))
type = EVTSPECZOOM;
else if (event->x > w - PDFSIDEM && event->x < w - PDFSIDEM + COLORBW &&
event->y > PDFTOPM && event->y < h - PDFBOTM)
type = EVTSPECINVERT;
else if ((screen == SPECTRODETREQ) &&
(event->x > w - PDFSIDEM && event->x < w - PDFSIDEM + COLORBW) &&
(event->y < PDFTOPM || event->y > h - PDFBOTM))
type = EVTSPECCBAR;
switch (type)
{
case NONE:
break;
case EVTSPECDETAIL:  
{
SPECREQ *specReqDet, *specReq;
PDFREQ *pdfReqDet;
int  detRow = pdfStates.spdetreq.cntr % SMAXROWS;
if (event->type == GDK_BUTTON_PRESS)
break;
SETHG(hourCursor);  
specReq = &pdfStates.spmain.specReq[row][0];
specReqDet = &pdfStates.spdetreq.specReq[detRow][0];
pdfReqDet = &pdfStates.spdetreq.pdfReq[detRow][0];
if (specReq->data.numRecs == NOPSDDATA)
{
gdk_beep();
break;
}
freeSpectro(specReqDet);
freePDF(pdfReqDet, TRUE);
specReqCopy(&specReqDet, specReq);
makeDrawing(SPECTRODETREQ, detRow, COLSPEC);
gtk_notebook_set_current_page((GtkNotebook *) PSDbooks[SPECTRONB], SPECTROTAB(SPECTRODETREQ));
pdfStates.spdetreq.cntr++;
}
break;
case EVTSPECCBAR:  
{
if (event->type != GDK_BUTTON_PRESS)
break;
specReq->plot.dBRange = DBFIXED;
switch (CBARF(event->y))
{
case UPPERUP:
specReq->plot.dbBounds[YMAX] += 2;
break;
case UPPERDOWN:
specReq->plot.dbBounds[YMAX] -= 2;
break;
case LOWERUP:
specReq->plot.dbBounds[YMIN] += 2;
break;
case LOWERDOWN:
specReq->plot.dbBounds[YMIN] -= 2;
break;
}
specReq->plot.replot = TRUE;
refresh = TRUE;
}
break;
case EVTSPECINVERT:   
{
int   X, Y, W, H;
GdkPixmap **pmapSrc, *pmapDest;
if (event->type != GDK_BUTTON_PRESS)
return TRUE;
switch (screen)
{
case SPECTROMAIN:
pmapSrc = &pdfStates.pmap.spmain[row][col];
break;
case SPECTRODETREQ:
pmapSrc = &pdfStates.pmap.spreq[row][col];
break;
}
pmapDest = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_drawable(pmapDest, da->style->fg_gc[GTK_STATE_NORMAL], *pmapSrc, 0, 0, 0, 0, -1, -1);
X = PDFSIDEM+1;
Y = PDFTOPM+1;
W = w - (PDFSIDEM*2) - 2;
H = h - (PDFTOPM + PDFBOTM) - 1;
gdk_draw_drawable(pmapDest, gcINV, *pmapSrc, X, Y, X, Y, W, H);
X = w - PDFSIDEM + 3;
Y = PDFTOPM;
W = COLORBW;
H = h - (PDFTOPM + PDFBOTM) + 1;
gdk_draw_drawable(pmapDest, gcINV, *pmapSrc, X, Y, X, Y, W, H);
g_object_unref(*pmapSrc);
*pmapSrc = pmapDest;
gtk_widget_queue_draw_area(da, 0, 0, w, h);  
}
break;
case EVTSPECZOOM:    
switch(event->type)
{
case GDK_BUTTON_PRESS:
mouseState.startX = (event->x > w-PDFSIDEM-1) ? w-PDFSIDEM-1 : event->x;
mouseState.endX = mouseState.endY = 0;
mouseState.mouseDown = TRUE;
mouseState.row = row;
mouseState.col = col;
break;
case GDK_BUTTON_RELEASE:
mouseState.mouseDown = FALSE;
row = mouseState.row;
col = mouseState.col;
if (mouseState.startX > mouseState.endX)
{ 
int tmp = mouseState.startX;
mouseState.startX = mouseState.endX;
mouseState.endX = tmp;
}
if (mouseState.endX - mouseState.startX < MINZOOMPIXELS)
{ 
gdk_beep();
gtk_widget_queue_draw_area(da, 0, 0, w, h); 
break;
}
switch (pdfSettings.spreq.zoom.scope)
{
case ZOOMSINGLE:
zoomSpectro(ZOOMIN, row, col);
makeDrawing(screen, row, col);
break;
case ZOOMALL:
{
int i;
for (i=0;i<SMAXROWS;i++)
{
zoomSpectro(ZOOMIN, i, COLSPEC);
makeDrawing(screen, i, COLSPEC);
}
}
break;
}
break;
default:
break;
}
break;
}
if (refresh)
makeDrawing(screen, row, col);
return TRUE;
}
gboolean dragEventSPECTRO(GtkWidget *da, GdkEventMotion *event, gpointer s)
{
GdkModifierType state;
GdkPixmap *pmapSrc, *pmapDest;
int  scr = GPOINTER_TO_INT(s);
int  screen = (scr)/MAXNUMBERS;
int  base = (scr - screen*MAXNUMBERS);
int  row = ROWNUM(base), col = COLNUM(base);
gint x, y, X, Y, W, H;
gint w = da->allocation.width;
gint h = da->allocation.height;
if (!mouseState.mouseDown || 
mouseState.row != row ||
mouseState.col != col)
goto LEAVE;
if (event->x > w-PDFSIDEM-1)
{
gdk_beep();
goto LEAVE;
}
if (!gcINV)
{
gcINV = gdk_gc_new(da->window);
gdk_gc_set_function(gcINV, GDK_INVERT);
}
pmapSrc = pdfStates.pmap.spreq[row][col];
pmapDest = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_drawable(pmapDest, da->style->fg_gc[GTK_STATE_NORMAL], pmapSrc, 0, 0, 0, 0, -1, -1);
mouseState.endX = mouseState.startX + (event->x - mouseState.startX);
mouseState.startY = PDFTOPM+1;
mouseState.endY = h - PDFBOTM;
X = mouseState.startX < mouseState.endX ? mouseState.startX : mouseState.endX;
Y = mouseState.startY;
W = abs(mouseState.endX - mouseState.startX);
H = h - (PDFTOPM + PDFBOTM) - 1;
gdk_draw_drawable(pmapDest, gcINV, pmapSrc, X, Y, X, Y, W, H);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pmapDest, 0, 0, 0, 0, -1, -1);
g_object_unref(pmapDest);
LEAVE:
gdk_window_get_pointer(event->window, &x, &y, &state);
return TRUE;
}
static gboolean eventDone(gpointer b)
{
gboolean *flag = (gboolean *) b;
*flag = FALSE;
return FALSE;
}
gboolean scrollEventSPECTRO(GtkWidget *da, GdkEventScroll *event, gpointer s)
{ 
static gboolean busy;
int  scr = GPOINTER_TO_INT(s);
int  screen = (scr)/MAXNUMBERS;
int  base = (scr - screen*MAXNUMBERS);
int  row = ROWNUM(base), col = COLNUM(base);
SPECREQ *specReq;
graph *gr;
int  zoomType, zoomDir;
float ttlPixelsPSD;
int  ttlPixels, pctZoom, zoomPct = pdfSettings.spreq.zoom.scrollPct;
if (busy)  
return TRUE;
busy = TRUE;
switch (screen)
{
case SPECTROMAIN:
gr = &pdfStates.spmain.specGR[row][0];
specReq = &pdfStates.spmain.specReq[row][0];
break;
case SPECTRODETREQ:
gr = &pdfStates.spdetreq.specGR[row][0];
specReq = &pdfStates.spdetreq.specReq[row][0];
break;
}
if (!specReq->keys.chnKey)
{ 
busy = FALSE;
return TRUE;
}
SETHG(hourCursor);  
ttlPixelsPSD = (float) gr->pix_xdif/(float) gr->user_xdif;
ttlPixels = gr->pix_xdif;
pctZoom = ((int) (ttlPixels *(zoomPct/100.))) < ttlPixelsPSD 
? ceil(ttlPixelsPSD) 
: ttlPixels *(zoomPct/100.);
zoomType = (event->direction == GDK_SCROLL_UP) ? ZOOMIN : ZOOMOUT;
zoomDir = (zoomType == ZOOMIN) ? 1 : -1;
mouseState.startX = gr->pix_xmin + zoomDir * pctZoom;
mouseState.endX = gr->pix_xmax - zoomDir * pctZoom;
switch (pdfSettings.spreq.zoom.scope)
{
case ZOOMSINGLE:
zoomSpectro(zoomType, row, col);
makeDrawing(screen, row, col);
break;
case ZOOMALL:
{
int i;
for (i=0;i<SMAXROWS;i++)
{
zoomSpectro(zoomType, i, COLSPEC);
makeDrawing(screen, i, COLSPEC);
}
}
break;
}
g_idle_add((GSourceFunc) eventDone, &busy);
return TRUE;
}
void spectroPDF(gpointer r)
{ 
int  row = GPOINTER_TO_INT(r);
SPECREQ *specReq = &pdfStates.spdetreq.specReq[row][0];
PDFREQ *pdfReq = &pdfStates.spdetreq.pdfReq[row][0];
SPECTRODATA *spectroData;
PSDDATA *psdData;
GList *iter, *start, *end;
GSList *iter2;
int  numDB, numPer, *hitMap, x, y, numPSD, nPer, nDB, pos, numRecs, recNum;
float *probMap, *per;
static gboolean busy[SMAXROWS];
if (!specReq->keys.chnKey ||  
busy[row] == TRUE)    
return;
busy[row] = TRUE;
start = specReq->plot.start;
end = specReq->plot.end;
pdfReq->keys.chnKey = specReq->keys.chnKey;
pdfReq->keys.pdfKey = CUSTOMPDF;
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.sqr = row+1;
sqldi.args.threaded = TRUE;
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = PSDCFGPOWERBOUNDS;
sqldi.data = pdfReq;
db_request(&sqldi);
}
numDB = pdfReq->keys.yBounds[YMAX] - pdfReq->keys.yBounds[YMIN] + 1;
numPer = specReq->data.numPeriods;
if (!(per = (float *) calloc(numPer, sizeof(float))))
{
fprintf(stderr, "Unable to allocate memory (%d bytes)\n", (int) (numPer*sizeof(float)));
return;
}
if (!(hitMap = (int *) calloc(numDB*numPer, sizeof(int))))
{
fprintf(stderr, "Unable to allocate memory (%d bytes)\n", (int) (numDB*numPer*sizeof(int)));
return;
}
for (iter = start, numPSD = 0;
iter != (end ? end->next : NULL);
iter = g_list_next(iter), numPSD++)
{
spectroData = iter->data;
for (iter2 = spectroData->psdData, x = 0;
iter2;
iter2 = g_slist_next(iter2), x++)
{
psdData = iter2->data;
if (per[x] == 0.f)
per[x] = psdData->period;
y = psdData->power - pdfReq->keys.yBounds[YMIN];
pos = x * (numDB) + y;
hitMap[pos]++;
}
}
if (!(probMap = (float *) calloc(numDB*numPer, sizeof(float))))
{
fprintf(stderr, "Unable to allocate memory (%d bytes)\n", (int) (numDB*numPer*sizeof(float)));
return;
}
for (nPer = numRecs = 0; nPer < numPer; nPer++)
{
for (nDB = 0; nDB < numDB; nDB++)
{
pos = nPer * numDB + nDB;
if (!hitMap[pos])
continue;
probMap[pos] = (float) ((float) hitMap[pos]) / (float) numPSD;
numRecs++;
}
}
pdfReq->data.numRecs = numRecs;
pdfReq->data.hits = calloc(sizeof(PDFHITS), 1);
pdfReq->data.hits->hits = calloc(sizeof(PDFHITSDATA), pdfReq->data.numRecs);
pdfReq->data.hits->ttlPeriods = numPer;
pdfReq->data.hits->ttlHits = numPSD;
pdfReq->data.hits->ttlRows = pdfReq->data.numRecs;
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
for (nPer = recNum = 0; nPer < numPer; nPer++)
{
for (nDB = 0; nDB < numDB; nDB++)
{
pos = nPer * numDB + nDB;
if (!hitMap[pos])
continue;
pdfReq->data.pdf[recNum].period = per[nPer];
pdfReq->data.pdf[recNum].power = nDB + pdfReq->keys.yBounds[YMIN];
pdfReq->data.pdf[recNum].prob = probMap[pos];
pdfReq->data.hits->hits[recNum].period = pdfReq->data.pdf[recNum].period;
pdfReq->data.hits->hits[recNum].power = pdfReq->data.pdf[recNum].power;
pdfReq->data.hits->hits[recNum].hits = hitMap[pos];
recNum++;
}
}
free(per);
free(hitMap);
free(probMap);
pdfReq->data.sTime.date.yr = g_date_get_year(specReq->plot.dateBounds[STARTDT]);
pdfReq->data.sTime.date.jday = g_date_get_day_of_year(specReq->plot.dateBounds[STARTDT]);
pdfReq->data.eTime.date.yr = g_date_get_year(specReq->plot.dateBounds[ENDDT]);
pdfReq->data.eTime.date.jday = g_date_get_day_of_year(specReq->plot.dateBounds[ENDDT]);
pdfReq->data.name = g_strdup(specReq->data.name);
pdfReq->data.numPSDs = numPSD;
pdfReq->data.numRecs = recNum;
pdfReq->data.dateFmt = specReq->data.dateFmt;
pdfReq->data.ttlEpochs = 1;  
{ 
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = PDFSTATLINES;
memcpy(&pdfReq->keys.statistics, &pdfSettings.common.statistics[SPECTRODETREQ], sizeof(pdfSettings.common.statistics[SPECTRODETREQ]));
if (pdfReq->data.stats)
{
free(pdfReq->data.stats);
pdfReq->data.stats = NULL;
}
sqldi.data = pdfReq;
db_request(&sqldi);
}
busy[row] = FALSE;
g_idle_add((GSourceFunc) _makeDrawing, r);
}
void alignSpectro(GtkButton *button, gpointer nil)
{
int  i, minZoom = G_MAXINT;
SPECREQ *specReq;
SPECTRODATA *specD1, *specD2;
for (i=0; i < SMAXROWS; i++)
{
specReq = &pdfStates.spdetreq.specReq[i][0];
if (!specReq->keys.chnKey)
continue;
specD1 = (specReq->plot.start)->data; 
specD2 = (specReq->plot.end)->data; 
if (minZoom > (specD2->psdRef - specD1->psdRef))
minZoom = specD2->psdRef - specD1->psdRef;
}
}
void spectroPrint(GtkButton *button, gpointer nil)
{
}
