#include <string.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
void plot_pdf_hours(GdkPixmap *pixmap, int pWidth, int pHeight) 
{
XAXISDAYSARGS axisArgs;
graph *GR=&pdfStates.detail.gr[1][1];
int  start[2], end[2], days, x, yS, yE, startM, endM, lastHr, i, x1, x2;
GdkGC *gc=pdfSettings.drawing.ctxts[PDFTRCBG][NORMALGC];
int  fontH, fontW1, length = pdfStates.detail.psdHr.data.length;
gchar *dispStr;
start[YEARH] = pdfStates.detail.subReq.data.sTime.date.yr;
start[JDAYH] = pdfStates.detail.subReq.data.sTime.date.jday;
end[YEARH] = pdfStates.detail.subReq.data.eTime.date.yr;
lastHr = pdfStates.detail.psdHr.data.numRecs-1;
endM = pdfStates.detail.psdHr.data.hrList[lastHr]->date.hr*60 + 
pdfStates.detail.psdHr.data.hrList[lastHr]->date.mn +
length;
end[JDAYH] = (endM < 24*60) 
? pdfStates.detail.subReq.data.eTime.date.jday 
: pdfStates.detail.subReq.data.eTime.date.jday+1;
days = getTotalDays(start, end) + 1;
viewport(GR, PDFSIDEM, pWidth-PDFSIDEM, PDFTOPM, pHeight-PDFBOTM);
window(GR, (double) 0, (double) days, (double) 0, (double) (20), 0, 0);
axisArgs.type = XAXISDAYSPDFHOUR;
axisArgs.plot.pixmap = pixmap;
axisArgs.width = pWidth;
axisArgs.height = pHeight;
axisArgs.gc = gc;
axisArgs.GR = GR;
axisArgs.start[YEARH] = start[YEARH];
axisArgs.start[JDAYH] = start[JDAYH];
axisArgs.end[YEARH] = end[YEARH];
axisArgs.end[JDAYH] = end[JDAYH];
xAxisDAYS(&axisArgs);
yaxisP(pixmap, gc, GR, (double) 0, (double) 0, (double) (20), 1, 0, 12, (double) 0.0, MYINT, AXISF);
yaxisP(pixmap, gc, GR, (double) days, (double) 0, (double) (20), -1, 0, 12, (double) 0.0, MYINT, AXISF);
dispStr = g_strdup("00:00");
fontH = fontSIZEP(dispStr, AXISF, HEIGHT);
fontW1 = fontSIZEP(dispStr, AXISF, WIDTH);
x1 = pWidth-PDFSIDEM+4;
x2 = PDFSIDEM-fontW1-4;
for(i=0;i<5;i++)
{
switch(i)
{
case 0:  
yS=(pHeight-PDFBOTM)-fontH+1;
break;
default:
free(dispStr);
dispStr = g_strdup_printf("%02d:00", i*6);
yS=USER2PIXY(GR, (double) (20./(24./(i*6.))))-fontH/2;
break;
}
fontDrawP(pixmap, dispStr, x2, yS, AXISF, PDFFTEXT);  
fontDrawP(pixmap, dispStr, x1, yS, AXISF, PDFFTEXT);  
}
free(dispStr);
window(GR, (double) 0, (double) days, (double) 0, (double) (24*60), 0, 0);
for(i=0;i<pdfStates.detail.psdHr.data.numRecs;i++)
{
end[YEARH] = pdfStates.detail.psdHr.data.hrList[i]->date.yr;
end[JDAYH] = pdfStates.detail.psdHr.data.hrList[i]->date.jday;
x = USER2PIXX(GR, (double) getTotalDays(start, end));
startM = pdfStates.detail.psdHr.data.hrList[i]->date.hr*60 + 
pdfStates.detail.psdHr.data.hrList[i]->date.mn;
yS = USER2PIXY(GR, (double) (startM));
if ((startM+length) < (24*60))
{ 
yE = USER2PIXY(GR, (double) (startM+length));
gdk_draw_line(pixmap, gc, x, yS, x, yE);  
gdk_draw_line(pixmap, gc, x-1, yS, x, yS);  
gdk_draw_line(pixmap, gc, x, yE, x+1, yE);  
}
else
{ 
yE = USER2PIXY(GR, (double) (24*60));
gdk_draw_line(pixmap, gc, x, yS, x, yE);
gdk_draw_line(pixmap, gc, x-1, yS, x, yS);  
end[JDAYH]++;
x = USER2PIXX(GR, (double) getTotalDays(start, end));
yS = USER2PIXY(GR, (double) (0));
yE = USER2PIXY(GR, (double) (length-(24*60-startM)));
gdk_draw_line(pixmap, gc, x, yS, x, yE);
gdk_draw_line(pixmap, gc, x, yE, x+1, yE);
}
}
}
