#include <string.h>
#include <sys/time.h>
#include <stdlib.h>
#include <unistd.h>
#include <glib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
double ceil();
static void plot();
int readTrace(traceInfo *);
void psd_trace_cut(traceInfo *trc, MYTIME *psdStart, int psdLen);
typedef struct _TRCLIST {
TRCLST *trc;
GSList *psdHrs;  
} TRCLIST;
static traceInfo psdTraces[PDFTRCDISP];
static GSList  *validTrc; 
static GSList  *plotTrc; 
static GSList *doPSDtrc()
{
GSList *trcIter;
TRCLST *trcL;
TRCLIST *trcPSD;
int  psdNum;
double ONESAMPLE;
GSList *trcPSDs; 
trcIter = validTrc;
trcL = trcIter->data;
psdNum = 0;
while(!pdfStates.detail.psdHr.data.numRecs)
{ 
g_usleep(250000);
}
while((pdfStates.detail.psdHr.data.hrList[psdNum]->epochS + 
pdfStates.detail.psdHr.data.length*60) < trcL->times[STARTTIME].epochS)
{ 
psdNum++;
}
trcPSDs = NULL;
for(;   
trcIter;
trcIter = g_slist_next(trcIter))
{
trcL = trcIter->data;
trcPSD = calloc(1, sizeof(TRCLIST));
trcPSD->trc = trcL;
ONESAMPLE = trcL->sampInt/1000000.;  
while (psdNum < pdfStates.detail.psdHr.data.numRecs &&
(pdfStates.detail.psdHr.data.hrList[psdNum]->epochS >= 
trcL->times[STARTTIME].epochS) &&
((pdfStates.detail.psdHr.data.hrList[psdNum]->epochS +
pdfStates.detail.psdHr.data.length*60) - ONESAMPLE <= 
trcL->times[ENDTIME].epochS)
)   
{
trcPSD->psdHrs = g_slist_append(trcPSD->psdHrs, pdfStates.detail.psdHr.data.hrList[psdNum]);
psdNum++;
}
trcPSDs = g_slist_append(trcPSDs, trcPSD);
while (psdNum < pdfStates.detail.psdHr.data.numRecs &&
(pdfStates.detail.psdHr.data.hrList[psdNum]->epochS < 
trcL->times[ENDTIME].epochS) &&
((pdfStates.detail.psdHr.data.hrList[psdNum]->epochS +
pdfStates.detail.psdHr.data.length*60) > 
trcL->times[ENDTIME].epochS))
{ 
psdNum++;
}
}
return (trcPSDs);
}
static void _get_local_data()
{
int  i;
traceInfo *orig, *trc;
GSList *trcIter, *psdIter, *trcPSDs;
TRCLST *trcL;
TRCLIST *trcPSD;
MYTIME *psdHr;
switch(pdfSettings.detail.trcExtract)
{
case PDFDTRCPSD:  
trcPSDs = doPSDtrc();
for(trcIter = trcPSDs, i=0;
trcIter;
trcIter = g_slist_next(trcIter))
{
trcPSD = trcIter->data;
trcL = trcPSD->trc;
orig = calloc(1, sizeof(traceInfo));
orig->data.fileName = g_strdup(trcL->trcName);
for(psdIter = trcPSD->psdHrs;
psdIter;
psdIter = g_slist_next(psdIter), i++)
{
if (i < PDFTRCDISP &&
!orig->data.dataInfo.data)
{ 
orig->data.dataInfo.amps.max = trcL->stats[MAX]; 
orig->data.dataInfo.amps.min = trcL->stats[MIN];
readTrace(orig);
}
psdHr = psdIter->data;
trc = calloc(1, sizeof(traceInfo));
if (i < PDFTRCDISP)
{
memcpy(trc, orig, sizeof(traceInfo));
trc->data.dataInfo.amps.max = 0; 
trc->data.dataInfo.amps.min = 0;
trc->data.dataInfo.data = NULL;
}
trc->data.fileName = g_strdup(orig->data.fileName);
trc->excerpt.epochS = psdHr->epochS;
trc->excerpt.length = pdfStates.detail.psdHr.data.length*60;
pdfStates.detail.trcList = g_slist_append(pdfStates.detail.trcList, trc);
if (i < PDFTRCDISP)
{
trace_excerpt(orig, trc);
plotTrc = g_slist_append(plotTrc, trc);
}
}
g_slist_free(trcPSD->psdHrs);
freeMyData(TRCINFO, orig);
}
g_slist_free(trcPSDs);
break;
case PDFDTRCENTIRE:   
for(i = 0, trcIter = pdfStates.detail.psdTrc.data.trcList;
trcIter;
trcIter = g_slist_next(trcIter), i++)
{
trcL = trcIter->data;
trc = calloc(1, sizeof(traceInfo));
trc->data.fileName = g_strdup(trcL->trcName);
pdfStates.detail.trcList = g_slist_append(pdfStates.detail.trcList, trc);
if (i < PDFTRCDISP)
{
plotTrc = g_slist_append(plotTrc, trc);
trc->data.dataInfo.amps.max = trcL->stats[MAX]; 
trc->data.dataInfo.amps.min = trcL->stats[MIN];
trc->excerpt.length = trcL->times[ENDTIME].epochS - trcL->times[STARTTIME].epochS;
readTrace(trc);
}
}
break;
}
}
static void _set_CWB_hedr(traceInfo *trc, double epochS, int length)
{ 
char *ptr, ntw[12], stn[12], loc[12], chn[12];
ptr = pdfStates.detail.pdfReq[NW]->data.name;
sscanf(ptr, "%[A-Za-z0-9]s", ntw); ptr += strlen(ntw) + 1;
sscanf(ptr, "%[A-Za-z0-9]s", stn); ptr += strlen(stn) + 1;
sscanf(ptr, "%[A-Za-z0-9-]s", loc); ptr += strlen(loc) + 1;
sscanf(ptr, "%[A-Za-z0-9]s", chn);
if (!strcmp(loc, "--"))
{
strcpy(loc, " ");
}
trc->excerpt.epochS = epochS;
trc->excerpt.length = length;
trc->excerpt.CWB.inetAddr = pdfSettings.detail.CWB.inetAddr;
trc->excerpt.CWB.port = pdfSettings.detail.CWB.port;
trc->data.fileType = CWB_DATA;
trc->data.head.year = CWB_DATA;  
strcpy(trc->data.head.network, ntw);
strcpy(trc->data.head.station, stn);
strcpy(trc->data.head.location, loc);
strcpy(trc->data.head.channel, chn);
}
static void _get_CWB_data(TRACEARGS *trcArgs)
{
int  i;
traceInfo *trc;
GSList *trcIter, *psdIter, *trcPSDs;
TRCLST *trcL;
TRCLIST *trcPSD;
MYTIME *psdHr;
switch(pdfSettings.detail.trcExtract)
{
case PDFDTRCPSD:  
trcPSDs = doPSDtrc();
for(trcIter = trcPSDs, i=0;
trcIter;
trcIter = g_slist_next(trcIter))
{
trcPSD = trcIter->data;
trcL = trcPSD->trc;
for(psdIter = trcPSD->psdHrs;
psdIter;
psdIter = g_slist_next(psdIter), i++)
{
psdHr = psdIter->data;
trc = calloc(1, sizeof(traceInfo));
_set_CWB_hedr(trc, psdHr->epochS, pdfStates.detail.psdHr.data.length*60);
pdfStates.detail.trcList = g_slist_append(pdfStates.detail.trcList, trc);
if (i < PDFTRCDISP)
{
trc->excerpt.CWB.mainReturn = trcArgs->returnFunc;
readTrace(trc);     
plotTrc = g_slist_append(plotTrc, trc);
}
}
g_slist_free(trcPSD->psdHrs);
}
g_slist_free(trcPSDs);
break;
case PDFDTRCENTIRE:   
for(i = 0, trcIter = pdfStates.detail.psdTrc.data.trcList;
trcIter;
trcIter = g_slist_next(trcIter), i++)
{
trcL = trcIter->data;
trc = calloc(1, sizeof(traceInfo));
_set_CWB_hedr(trc, trcL->times[STARTTIME].epochS, 
trcL->times[ENDTIME].epochS - trcL->times[STARTTIME].epochS);
pdfStates.detail.trcList = g_slist_append(pdfStates.detail.trcList, trc);
if (i < PDFTRCDISP)
{
trc->excerpt.CWB.mainReturn = trcArgs->returnFunc;
trc->data.dataInfo.amps.max = trcL->stats[MAX];
trc->data.dataInfo.amps.min = trcL->stats[MIN];
readTrace(trc);
plotTrc = g_slist_append(plotTrc, trc);
}
}
break;
}
}
enum {
LOCAL_DATA_READ,
CWB_DATA_READ,
NO_DATA_READ
};
GThreadFunc get_pdf_traces(gpointer data)
{
TRACEARGS *trcArgs = data;
GSList *trcIter;
TRCLST *trcL;
int  readSrc;
g_slist_foreach(pdfStates.detail.trcList, (GFunc) freeTrc, GINT_TO_POINTER(PQLTRCLIST));
g_slist_free(pdfStates.detail.trcList);
pdfStates.detail.trcList = NULL;
trcIter = pdfStates.detail.psdTrc.data.trcList;
for(pdfStates.detail.traceCnt[VALIDTRC]=0, validTrc=NULL;
trcIter;
trcIter = g_slist_next(trcIter))
{
trcL = trcIter->data;
if(!strcmp(trcL->trcName, "/"))
continue;  
if (g_file_test(trcL->trcName, G_FILE_TEST_EXISTS))
{
pdfStates.detail.traceCnt[VALIDTRC]++;
validTrc = g_slist_append(validTrc, trcL);
}
}
if (!validTrc)
{
if (pdfSettings.detail.CWB.inetAddr &&
strlen(pdfSettings.detail.CWB.inetAddr))
{ 
trcIter = pdfStates.detail.psdTrc.data.trcList;
for(pdfStates.detail.traceCnt[VALIDTRC]=0, validTrc=NULL;
trcIter;
trcIter = g_slist_next(trcIter))
{ 
trcL = trcIter->data;
if(!strcmp(trcL->trcName, "/"))
continue;  
pdfStates.detail.traceCnt[VALIDTRC]++;
validTrc = g_slist_append(validTrc, trcL);
}
readSrc = CWB_DATA_READ;
}
else
{ 
readSrc = NO_DATA_READ;
}
}
else
{
readSrc = LOCAL_DATA_READ;
}
readSrc = (pdfSettings.detail.trcExtract == PDFDTRCNOPLOT) ? NO_DATA_READ : readSrc;
switch(readSrc)
{
case LOCAL_DATA_READ:
_get_local_data();
g_slist_free(validTrc);
g_idle_add((GSourceFunc) trcArgs->returnFunc, (gpointer) NULL);
break;
case CWB_DATA_READ:
_get_CWB_data(trcArgs);
g_slist_free(validTrc);
break;
case NO_DATA_READ:
g_idle_add((GSourceFunc) trcArgs->returnFunc, (gpointer) NULL);
break;   
}
return NULL;
}
static int get_data_inc(traceInfo *trc, double secs, int pixwidth)
{
float step;
double inc;
step = (float) (secs / (float) pixwidth) / 
(trc->data.head.sampInt /1000000.);
inc = ceil(step);
if (inc <= 1.)
return (1);
else
return ((int) inc);
}
static void clearData(traceInfo *trc)
{
GSList  *iter;
OVERLAP  *olapData;
free(trc->data.dataInfo.data);  
trc->data.dataInfo.data = NULL;
trc->excerpt.CWB.mainReturn = NULL;
if (trc->trace.gaps)     
{
free(trc->trace.gaps);
trc->trace.gaps = NULL;
}
if (trc->trace.overlaps)    
{
free(trc->trace.overlaps);
trc->trace.overlaps = NULL;
}
for(iter=trc->trace.olapData; iter; iter=g_slist_next(iter))
{
olapData = iter->data;
free(olapData->data);
free(olapData);
}
if (trc->trace.olapData)
{
g_slist_free(trc->trace.olapData);
trc->trace.olapData = NULL;
}
}
static void __plot_pdf_traces(GdkPixmap *pixmap, int pWidth, int pHeight, int topM) 
{
char  *msg;
int  dist, trcNum, h1;
int  increment[PDFTRCDISP];
float trace_depth = pHeight/PDFTRCDISP;
double startTime[PDFTRCDISP], endTime1[PDFTRCDISP], endTime2[PDFTRCDISP], relTimeLen=0;
graph gr;
traceInfo *trc;
GSList *trcIter;
for(trcIter = plotTrc, trcNum = 0;
trcIter;
trcIter = g_slist_next(trcIter), trcNum++) 
{ 
trc = trcIter->data;
startTime[trcNum] = trc->data.head.epochs;
endTime2[trcNum] = startTime[trcNum] + 
(trc->data.dataInfo.head.numSamples * 
(float) (trc->data.head.sampInt / 1000000.));
if (relTimeLen < endTime2[trcNum] - trc->data.head.epochs)
relTimeLen = endTime2[trcNum] - trc->data.head.epochs;
}
for(trcIter = plotTrc, trcNum = 0;
trcIter;
trcIter = g_slist_next(trcIter), trcNum++) 
{ 
endTime1[trcNum] = startTime[trcNum] + relTimeLen;
}
for(trcIter = plotTrc, trcNum = 0;
trcIter;
trcIter = g_slist_next(trcIter), trcNum++) 
{
trc = trcIter->data;
if (!trc->data.dataInfo.data)
{ 
msg = g_strdup("CWB returned NO Data - see stderr for details");
h1 = trcNum*trace_depth+topM + trace_depth/2;
fontDrawP(pixmap, msg, 10, h1, AXISF, PDFFTEXT);
free(msg);
continue;
}
viewport(&gr, PDFTRCMARG, pWidth-PDFTRCMARG, 
trcNum*trace_depth+topM, (trcNum + 1)*trace_depth+topM);
dist = (trc->data.dataInfo.amps.max - trc->data.dataInfo.amps.min) / 30;
window(&gr,  (double) (startTime[trcNum]),
(double) (endTime1[trcNum]),
(double) (trc->data.dataInfo.amps.min - dist), 
(double) (trc->data.dataInfo.amps.max + dist), 0, 0);
increment[trcNum] = get_data_inc(trc, 
endTime1[trcNum] - startTime[trcNum], 
USER2PIXX(&gr, endTime1[trcNum]) - 
USER2PIXX(&gr, startTime[trcNum]));
plot(pixmap, &gr, trc, 
startTime[trcNum], 
endTime2[trcNum], 
(double) 0.0, 
increment[trcNum]);
clearData(trc);
}
g_slist_free(plotTrc);
plotTrc = NULL;
memset(&psdTraces, 0, sizeof(psdTraces));
}
#define FLAGMARGIN 2
#define FLAGFACTOR 12
#define MAXFLAG  10
#define MINFLAG  5
typedef struct
{
traceInfo *trc;
int  stop, dataSize, dataType;
int  ptInc, decInc, inc;
double tm, tm_inc;
struct
{
gint32 *ptr;
short *sptr;
float *lptr;
double *dptr;
} data;
struct
{
int  *gaps, *olaps;
int  gapNum, olapNum;
gboolean gapON, olapON;
} GO;
GdkGC  *gc;
} plotInfo;
#include <stdlib.h>
static int *vertical, flagSize, totVert;
static void checkGO(GdkPixmap *pixmap, graph *gr, plotInfo *pInfo, int x, int y)
{
GdkPoint flag[3];
static int vertPos, gapIter;
int   gapInc;
int   pix_x0, pix_y0, pix_x1, pix_y1, decInc;
double  pt1, pt2;
gboolean gap=FALSE;
traceInfo *trc = pInfo->trc;
if (!flagSize)
{
flagSize = gr->pix_ydif/FLAGFACTOR;
flagSize = (flagSize > MAXFLAG) 
? MAXFLAG 
: ((flagSize < MINFLAG) 
? MINFLAG 
: flagSize);
totVert = 50; 
vertical = (int *) calloc(totVert, sizeof(int));
}
if (pInfo->GO.gapNum < trc->trace.numGaps)
{ 
if (settings.trace.gFlag)
{ 
gapIter = 0;
vertPos=0;
while(x < vertical[vertPos])
vertPos++;
}
if (pInfo->ptInc+pInfo->decInc >= pInfo->GO.gaps[pInfo->GO.gapNum*2])
{ 
gap = TRUE;
pInfo->gc = GGXC[TRACESCR][0];
if (settings.trace.gFlag) 
{ 
pix_x0 = USER2PIXX(gr, pInfo->tm);
if(!gapIter) 
gdk_draw_line(pixmap, pInfo->gc,
pix_x0, gr->pix_ymin + vertPos*(flagSize+1) + FLAGMARGIN, 
pix_x0, y);
flag[0].x = pix_x0;
flag[0].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + FLAGMARGIN;
flag[1].x = pix_x0;
flag[1].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize + FLAGMARGIN;
flag[2].x = pix_x0 + flagSize;
flag[2].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize/2 + FLAGMARGIN;
gdk_draw_polygon(pixmap, pInfo->gc, TRUE, flag, 3);
if (vertPos+gapIter>=totVert)
{
totVert += 50;
vertical = (int *) realloc(vertical, totVert*sizeof(int));
}
vertical[vertPos+gapIter] = flag[2].x + 1;
gapIter++;
}
gapInc = (pInfo->GO.gaps[pInfo->GO.gapNum*2+1] - 
pInfo->GO.gaps[pInfo->GO.gapNum*2] - 
(pInfo->ptInc - pInfo->GO.gaps[pInfo->GO.gapNum*2])) /
pInfo->inc;
if (gapInc)
{ 
int dataType;
dataType = trc->data.head.data_form;
switch (dataType)
{
case BIT32:
pt1 = (double) pInfo->data.ptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.ptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
case BIT16:
pt1 = (double) pInfo->data.sptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.sptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
case MY_FLOAT:
pt1 = (double) pInfo->data.lptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.lptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
case MY_DOUBLE:
pt1 = (double) pInfo->data.dptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.dptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
}
pix_x0 = USER2PIXX(gr, pInfo->tm);
pix_y0 = USER2PIXY(gr, pt1);
pInfo->ptInc += (pInfo->inc * (gapInc));
pInfo->tm += (pInfo->tm_inc * (double) (gapInc));
pix_x1 = USER2PIXX(gr, pInfo->tm);
pix_y1 = USER2PIXY(gr, pt2);
gdk_draw_line(pixmap, pInfo->gc, pix_x0, pix_y0, pix_x1, pix_y1);
}
pInfo->GO.gapNum++;
pInfo->gc = GXC[NORMALGC][TRACESCR];
decInc = pInfo->GO.gaps[pInfo->GO.gapNum*2-1] - pInfo->ptInc;
pInfo->decInc = decInc;
}
}  
if (pInfo->GO.olapNum < trc->trace.numOlaps)
{
if (settings.trace.oFlag && !pInfo->GO.olapON)
{
gapIter = 0;
vertPos=0;
while(x < vertical[vertPos] && vertPos<totVert)
vertPos++;
}
if (!pInfo->GO.olapON && pInfo->ptInc+pInfo->decInc >= pInfo->GO.olaps[pInfo->GO.olapNum*2])
{ 
pInfo->gc = PGXC[TRACESCR][0];
if (settings.trace.oFlag)  
{ 
if (gap)
x = pix_x1;
if(!gapIter) 
gdk_draw_line(pixmap, pInfo->gc, x, gr->pix_ymin + vertPos*(flagSize+1) + FLAGMARGIN, x, y);
flag[0].x = x;
flag[0].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + FLAGMARGIN;
flag[1].x = x;
flag[1].y = gr->pix_ymin+ + vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize + FLAGMARGIN;
flag[2].x = x + flagSize;
flag[2].y = gr->pix_ymin+ vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize/2 + FLAGMARGIN;
gdk_draw_polygon(pixmap, pInfo->gc, TRUE, flag, 3);
if (vertPos+gapIter>=totVert)
{
totVert += 50;
vertical = (int *) realloc(vertical, totVert*sizeof(int));
}
vertical[vertPos+gapIter] = flag[2].x + 1;
gapIter++;
} 
pInfo->GO.olapON = TRUE;
} 
if (pInfo->GO.olapON && pInfo->ptInc+pInfo->decInc >= pInfo->GO.olaps[pInfo->GO.olapNum*2+1])
{ 
pInfo->GO.olapNum++;
pInfo->gc = GXC[NORMALGC][TRACESCR];
pInfo->GO.olapON = FALSE;
}
}  
pInfo->stop = trc->data.dataInfo.head.numSamples;
if (pInfo->GO.olapON)
{
pInfo->stop = pInfo->GO.olaps[pInfo->GO.olapNum*2+1];  
}
else
{
if (pInfo->GO.gapNum < trc->trace.numGaps)
{
pInfo->stop = pInfo->GO.gaps[pInfo->GO.gapNum*2];  
}
if (pInfo->GO.olapNum < trc->trace.numOlaps) 
{
if (pInfo->GO.gapNum < trc->trace.numGaps)
{ 
if (pInfo->GO.olaps[pInfo->GO.olapNum*2] < pInfo->GO.gaps[pInfo->GO.gapNum*2])
{
pInfo->stop = pInfo->GO.olaps[pInfo->GO.olapNum*2];  
}
}
else
{
pInfo->stop = pInfo->GO.olaps[pInfo->GO.olapNum*2];  
}
}
}
}
static void initData(plotInfo *plotI)
{
traceInfo *trc = plotI->trc;
flagSize = 0;
vertical = NULL;
plotI->dataType = trc->data.head.data_form;
plotI->dataSize = dsizes[plotI->dataType];
switch (plotI->dataType) 
{
case BIT32:  
plotI->data.ptr = (gint32 *) trc->data.dataInfo.data;
break;
case BIT16:
plotI->data.sptr = (short *) trc->data.dataInfo.data;
break;
case MY_FLOAT:
plotI->data.lptr = (float *) trc->data.dataInfo.data;
break;
case MY_DOUBLE:
plotI->data.dptr = (double *) trc->data.dataInfo.data;
break;
}
plotI->GO.gaps = trc->trace.gaps;
plotI->GO.olaps = trc->trace.overlaps;
plotI->tm_inc = (double) (((trc->data.head.sampInt) / 1000000.) * ((float) plotI->inc));
plotI->gc = GXC[NORMALGC][NORMALGC];
plotI->GO.gapON = plotI->GO.olapON = FALSE;
plotI->GO.olapNum = plotI->GO.gapNum = 0;
plotI->decInc = 0;
plotI->ptInc = 0;
plotI->stop = trc->data.dataInfo.head.numSamples;     
if (plotI->GO.gapNum < trc->trace.numGaps)
{
plotI->stop = plotI->GO.gaps[0];        
}
if (plotI->GO.olapNum < trc->trace.numOlaps) 
{
if (plotI->GO.gaps)
{ 
if (plotI->GO.olaps[0] < plotI->GO.gaps[0])
{
plotI->stop = plotI->GO.olaps[0];    
}
}
else
{
plotI->stop = plotI->GO.olaps[0];     
}
}
}
static void plot(GdkPixmap *pixmap, graph *gr, traceInfo *trc, 
double begin, double end, double offset, int inc)
{
int y1, y2, pix_x0, pix_x1, pix_y0, pix_y1;
double fmax, fmin, fpt, tmStart, sps;
short *sptr;
gint32 *ptr;
float *lptr;
double *dptr;
plotInfo pInfo;
memset(&pInfo, 0, sizeof(plotInfo));
pInfo.trc = trc;
pInfo.inc = inc;
tmStart = begin + offset;
pInfo.tm = tmStart;
initData(&pInfo);
sps = 1000000. / (double) trc->data.head.sampInt;
switch(pInfo.dataType)
{
case MY_FLOAT:
lptr = (float *) trc->data.dataInfo.data;
break;
case BIT32:
ptr = (gint32 *) trc->data.dataInfo.data;
break;
case BIT16:
sptr = (short *) trc->data.dataInfo.data;
break;
case MY_DOUBLE:
dptr = (double *) trc->data.dataInfo.data;
break;
}
pix_x0 = pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, pInfo.ptInc, fmin);
pix_y0 = pix_y1 = USER2PIXY(gr, (double) fmin);
for (
;pInfo.ptInc < trc->data.dataInfo.head.numSamples - pInfo.inc; 
pix_x0 = pix_x1, pix_y0 = pix_y1)
{
if (pInfo.inc > 1) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
fmax = fmin;
for (fpt = fmax;          
(pInfo.decInc < pInfo.inc) &&     
(pInfo.ptInc + pInfo.decInc < pInfo.stop); 
pInfo.decInc++) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fpt);
if (fpt < fmin)
{
fmin = fpt;
continue;
}
if (fpt > fmax)
fmax = fpt;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}
if (pInfo.ptInc+pInfo.decInc == pInfo.stop)
{ 
int lastStop = pInfo.stop;
checkGO(pixmap, gr, &pInfo, pix_x1, pix_y1);
while (pInfo.stop <= lastStop)
{ 
pix_x1 = USER2PIXX(gr, 
(double) (tmStart + (double) (pInfo.stop/sps)));
checkGO(pixmap, gr, &pInfo, pix_x1, pix_y1);
}
pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
pix_y1 = USER2PIXY(gr, (double) fmin);
}
else
{ 
pInfo.ptInc += pInfo.inc;
pInfo.tm += pInfo.tm_inc;
pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc), fmin);
pix_y1 = USER2PIXY(gr, (double) fmin);
gdk_draw_line(pixmap, pInfo.gc, pix_x0, pix_y0, pix_x1, pix_y1);
pInfo.decInc = 0;
}
}
if(vertical)
free(vertical);
}
void plot_pdf_traces(TRACEARGS *trcArgs)
{
__plot_pdf_traces(trcArgs->pixmap, trcArgs->dims[PMW], trcArgs->dims[PMH], trcArgs->dims[PMM]);
}
