#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include "pql_defines.h"
static FILE *PSfp;
static int paperW, paperH;
int print_ps_imagePDF(GdkPixbuf *pixbuf)
{
char linebuf[80];
int x, y;
int pos;
int startline, ix;
unsigned char b;
const char tohex[16] = "0123456789abcdef";
int bytes_per_line;
int width, height, rowstride, bytes_per_pixel=3;
guchar *data;
int transW, transH, scaleW, scaleH;
data = gdk_pixbuf_get_pixels(pixbuf);
width = gdk_pixbuf_get_width(pixbuf);
height = gdk_pixbuf_get_height(pixbuf);
rowstride = gdk_pixbuf_get_rowstride(pixbuf);
bytes_per_line = width * bytes_per_pixel;
fprintf(PSfp, "DisplayImage\n");
transW = PMARGIN+5;  
transH = PMARGIN*6;
scaleW = paperW-100; 
scaleH = (paperH-94);
fprintf(PSfp, "%d %d\n", transW, transH);  
fprintf(PSfp, "%d %d\n", scaleW, scaleH);  
fprintf(PSfp, "%d %d\n", width, height);  
fprintf(PSfp, "0\n");
fprintf(PSfp, "0\n");
pos = 0;
startline = 0;
for (y = 0; y < height; y++)
{
ix = startline;
for (x = 0; x < bytes_per_line; x++)
{
b = data[ix++];
linebuf[pos++] = tohex[b >> 4];
linebuf[pos++] = tohex[b & 15];
if (pos == 72)
{
linebuf[pos++] = '\n';
if (fwrite (linebuf, sizeof(char), pos, PSfp) < pos)
return -1;
pos = 0;
}
}
startline += rowstride;
}
if (pos)
{
linebuf[pos++] = '\n';
if (fwrite (linebuf, sizeof(char), pos, PSfp) < pos)
return -1;
}
return 0;
}
int printPSHeadFootPDF(char fileName[255], int HF, int pWidth, int pHeight)
{
struct tm *timenow;
time_t  tloc;
time(&tloc);
timenow = gmtime(&tloc);
switch(HF)
{
case PRINTHEADER:
paperW = pWidth;
paperH = pHeight;
if ((PSfp=fopen(fileName, "w")) == NULL)
{
return FAILURE;
}
fprintf(PSfp, "%%!PS-Adobe-3.0\n");
fprintf(PSfp, "%%%%Creator: (PQL II)\n");
fprintf(PSfp, "%%%%Title: (%s)\n", fileName);
fprintf(PSfp, "%%%%CreationDate: (%d:%03d:%02d:%02d:%02d)\n", 
timenow->tm_year+1900, timenow->tm_yday+1,
timenow->tm_hour, timenow->tm_min, timenow->tm_sec);
fprintf(PSfp, "%%%%BoundingBox: 0 0 %d %d\n", pWidth, pHeight);
fprintf(PSfp, "%%%%HiResBoundingBox: 0 0 %d %d\n", pWidth, pHeight);
fprintf(PSfp, "%%%%DocumentData: Clean7Bit\n");
fprintf(PSfp, "%%%%LanguageLevel: 1\n");
fprintf(PSfp, "%%%%PageOrder: Ascend\n");
fprintf(PSfp, "%%%%Pages: 1\n");
fprintf(PSfp, "%%%%EndComments\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "%%%%BeginDefaults\n");
fprintf(PSfp, "%%%%EndDefaults\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "%%%%BeginProlog\n");
fprintf(PSfp, "%%\n");
fprintf(PSfp, "%% Display a color image. The image is displayed in color on\n");
fprintf(PSfp, "%% Postscript viewers or printers that support color, otherwise\n");
fprintf(PSfp, "%% it is displayed as grayscale.\n");
fprintf(PSfp, "%%\n");
fprintf(PSfp, "/DirectClassPacket\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Get a DirectClass packet.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% red.\n");
fprintf(PSfp, " %% green.\n");
fprintf(PSfp, " %% blue.\n");
fprintf(PSfp, " %% length: number of pixels minus one of this color (optional).\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " currentfile color_packet readhexstring pop pop\n");
fprintf(PSfp, " compression 0 eq\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " /number_pixels 3 def\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " currentfile byte readhexstring pop 0 get\n");
fprintf(PSfp, " /number_pixels exch 1 add 3 mul def\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, " 0 3 number_pixels 1 sub\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " pixels exch color_packet putinterval\n");
fprintf(PSfp, " } for\n");
fprintf(PSfp, " pixels 0 number_pixels getinterval\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "/DirectClassImage\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Display a DirectClass image.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " systemdict /colorimage known\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " columns rows 8\n");
fprintf(PSfp, " [\n");
fprintf(PSfp, " columns 0 0\n");
fprintf(PSfp, " rows neg 0 rows\n");
fprintf(PSfp, " ]\n");
fprintf(PSfp, " { DirectClassPacket } false 3 colorimage\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% No colorimage operator; convert to grayscale.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " columns rows 8\n");
fprintf(PSfp, " [\n");
fprintf(PSfp, " columns 0 0\n");
fprintf(PSfp, " rows neg 0 rows\n");
fprintf(PSfp, " ]\n");
fprintf(PSfp, " { GrayDirectClassPacket } image\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "/GrayDirectClassPacket\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Get a DirectClass packet; convert to grayscale.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% red\n");
fprintf(PSfp, " %% green\n");
fprintf(PSfp, " %% blue\n");
fprintf(PSfp, " %% length: number of pixels minus one of this color (optional).\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " currentfile color_packet readhexstring pop pop\n");
fprintf(PSfp, " color_packet 0 get 0.299 mul\n");
fprintf(PSfp, " color_packet 1 get 0.587 mul add\n");
fprintf(PSfp, " color_packet 2 get 0.114 mul add\n");
fprintf(PSfp, " cvi\n");
fprintf(PSfp, " /gray_packet exch def\n");
fprintf(PSfp, " compression 0 eq\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " /number_pixels 1 def\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " currentfile byte readhexstring pop 0 get\n");
fprintf(PSfp, " /number_pixels exch 1 add def\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, " 0 1 number_pixels 1 sub\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " pixels exch gray_packet put\n");
fprintf(PSfp, " } for\n");
fprintf(PSfp, " pixels 0 number_pixels getinterval\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "/GrayPseudoClassPacket\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Get a PseudoClass packet; convert to grayscale.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% index: index into the colormap.\n");
fprintf(PSfp, " %% length: number of pixels minus one of this color (optional).\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " currentfile byte readhexstring pop 0 get\n");
fprintf(PSfp, " /offset exch 3 mul def\n");
fprintf(PSfp, " /color_packet colormap offset 3 getinterval def\n");
fprintf(PSfp, " color_packet 0 get 0.299 mul\n");
fprintf(PSfp, " color_packet 1 get 0.587 mul add\n");
fprintf(PSfp, " color_packet 2 get 0.114 mul add\n");
fprintf(PSfp, " cvi\n");
fprintf(PSfp, " /gray_packet exch def\n");
fprintf(PSfp, " compression 0 eq\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " /number_pixels 1 def\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " currentfile byte readhexstring pop 0 get\n");
fprintf(PSfp, " /number_pixels exch 1 add def\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, " 0 1 number_pixels 1 sub\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " pixels exch gray_packet put\n");
fprintf(PSfp, " } for\n");
fprintf(PSfp, " pixels 0 number_pixels getinterval\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "/PseudoClassPacket\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Get a PseudoClass packet.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% index: index into the colormap.\n");
fprintf(PSfp, " %% length: number of pixels minus one of this color (optional).\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " currentfile byte readhexstring pop 0 get\n");
fprintf(PSfp, " /offset exch 3 mul def\n");
fprintf(PSfp, " /color_packet colormap offset 3 getinterval def\n");
fprintf(PSfp, " compression 0 eq\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " /number_pixels 3 def\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " currentfile byte readhexstring pop 0 get\n");
fprintf(PSfp, " /number_pixels exch 1 add 3 mul def\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, " 0 3 number_pixels 1 sub\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " pixels exch color_packet putinterval\n");
fprintf(PSfp, " } for\n");
fprintf(PSfp, " pixels 0 number_pixels getinterval\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "/PseudoClassImage\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Display a PseudoClass image.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% class: 0-PseudoClass or 1-Grayscale.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /class exch def pop\n");
fprintf(PSfp, " class 0 gt\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /depth exch def pop\n");
fprintf(PSfp, " /grays columns 8 add depth sub depth mul 8 idiv string def\n");
fprintf(PSfp, " columns rows depth\n");
fprintf(PSfp, " [\n");
fprintf(PSfp, " columns 0 0\n");
fprintf(PSfp, " rows neg 0 rows\n");
fprintf(PSfp, " ]\n");
fprintf(PSfp, " { currentfile grays readhexstring pop } image\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% colors: number of colors in the colormap.\n");
fprintf(PSfp, " %% colormap: red, green, blue color packets.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /colors exch def pop\n");
fprintf(PSfp, " /colors colors 3 mul def\n");
fprintf(PSfp, " /colormap colors string def\n");
fprintf(PSfp, " currentfile colormap readhexstring pop pop\n");
fprintf(PSfp, " systemdict /colorimage known\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " columns rows 8\n");
fprintf(PSfp, " [\n");
fprintf(PSfp, " columns 0 0\n");
fprintf(PSfp, " rows neg 0 rows\n");
fprintf(PSfp, " ]\n");
fprintf(PSfp, " { PseudoClassPacket } false 3 colorimage\n");
fprintf(PSfp, " }\n");
fprintf(PSfp, " {\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% No colorimage operator; convert to grayscale.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " columns rows 8\n");
fprintf(PSfp, " [\n");
fprintf(PSfp, " columns 0 0\n");
fprintf(PSfp, " rows neg 0 rows\n");
fprintf(PSfp, " ]\n");
fprintf(PSfp, " { GrayPseudoClassPacket } image\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, " } ifelse\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, "/DisplayImage\n");
fprintf(PSfp, "{\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Display a DirectClass or PseudoClass image.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " %% Parameters:\n");
fprintf(PSfp, " %% x & y translation.\n");
fprintf(PSfp, " %% x & y scale.\n");
fprintf(PSfp, " %% image columns & rows.\n");
fprintf(PSfp, " %% class: 0-DirectClass or 1-PseudoClass.\n");
fprintf(PSfp, " %% compression: 0-none or 1-RunlengthEncoded.\n");
fprintf(PSfp, " %% hex color packets.\n");
fprintf(PSfp, " %%\n");
fprintf(PSfp, " gsave\n");
fprintf(PSfp, " /buffer 512 string def\n");
fprintf(PSfp, " /byte 1 string def\n");
fprintf(PSfp, " /color_packet 3 string def\n");
fprintf(PSfp, " /pixels 768 string def\n");
fprintf(PSfp, "\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /x exch def\n");
fprintf(PSfp, " token pop /y exch def pop\n");
fprintf(PSfp, " x y translate\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /x exch def\n");
fprintf(PSfp, " token pop /y exch def pop\n");
fprintf(PSfp, " x y scale\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /columns exch def\n");
fprintf(PSfp, " token pop /rows exch def pop\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /class exch def pop\n");
fprintf(PSfp, " currentfile buffer readline pop\n");
fprintf(PSfp, " token pop /compression exch def pop\n");
fprintf(PSfp, " class 0 gt { PseudoClassImage } { DirectClassImage } ifelse\n");
fprintf(PSfp, " grestore\n");
fprintf(PSfp, "} bind def\n");
fprintf(PSfp, "%%%%EndProlog\n");
fprintf(PSfp, "%%%%Page: 1 1\n");
fprintf(PSfp, "%%%%PageBoundingBox: 0 0 %d %d\n", pWidth, pHeight);
fprintf(PSfp, "%d 0 translate 90 rotate\n", pHeight+26); 
break;
case PRINTFOOTER:
fprintf(PSfp, "%%%%PageTrailer\n");
fprintf(PSfp, " showpage\n");
fprintf(PSfp, "%%%%Trailer\n");
fprintf(PSfp, "%%%%EOF\n");
fclose(PSfp);
break;
}
return PQLXSUCCESS;
}
