#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "util_externs.h"
static GQueue *dbQ;
static int  masterCnt=0;
static void makeMMSGpdf(GdkPixmap *pxmp, int type, int w, int h, int screen)
{
char *msg1, *msg2;
static int fontH;
if (!fontH)
{
msg1 = g_strdup("TEST MSG");
fontH = fontSIZEP(msg1, MSGF, HEIGHT);
free(msg1);
}
switch(type)
{
case BUSY_MOVIE:
msg1 = g_strdup("Retrieving Movie Frames...");
msg2 = g_strdup_printf("%d / %d",
pdfStates.movie.count[screen][PDFM_FRAMENUM], 
pdfStates.movie.count[screen][PDFM_TTLFRAMES]);
break;
case RESIZE_MOVIE:
msg1 = g_strdup("Resizing Movie Frames...");
msg2 = g_strdup_printf("%d / %d", 
pdfStates.movie.count[screen][PDFM_FRAMENUM], 
pdfStates.movie.count[screen][PDFM_TTLFRAMES]);
break;
}
fontDrawP(pxmp, msg1, 
w/2 - fontSIZEP(msg1, MSGF, WIDTH)/2, 
h/2 - fontH/2, 
MSGF, PDFFMSG);
fontDrawP(pxmp, msg2, 
w/2 - fontSIZEP(msg2, MSGF, WIDTH)/2, 
h/2 + fontH/2 + 2, 
MSGF, PDFFMSG);
free(msg1);
free(msg2);
return; 
}
static GdkPixmap *makePmap(GtkWidget *da, PDFREQ *pdfReq)
{
PLOTPDFARGS plotPDFArgs;
GdkPixmap *pixmap;
int   width = da->allocation.width,
height = da->allocation.height;
pixmap = gdk_pixmap_new(da->window, width, height, -1);
if (!pixmap)
{ 
return NULL;
}
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFTEXT][ABNORMALGC], TRUE,
0, 0, width, height);
memset(&plotPDFArgs, 0, sizeof(PLOTPDFARGS));
plotPDFArgs.pmap = pixmap;
plotPDFArgs.req = (gpointer) pdfReq;
plotPDFArgs.width = width;
plotPDFArgs.height = height;
plotPDFArgs.scr = PDFMOVIE;
plotPDFArgs.type = PDFPLOT;
plotPDFArgs.fdUnits = pdfSettings.common.fdUnits;
plotPDFArgs.dateFmt = pdfSettings.common.dateFormat;
plotPDFArgs.hlnm = TRUE;
setPeriodBounds(pdfReq->keys.chnKey, &plotPDFArgs.xAxis);
plotPDF(&plotPDFArgs);
return pixmap;
}
void newMvDisp(GtkToggleButton *button, gboolean *disp)
{
*disp = gtk_toggle_button_get_active(button);
switch(*disp)
{
case MVDISP1:
gtk_widget_hide(mvDisp[MVDISP2]);
gtk_widget_show(mvDisp[MVDISP1]);
break;
case MVDISP2:
gtk_widget_hide(mvDisp[MVDISP1]);
gtk_widget_show(mvDisp[MVDISP2]);
break;
}
}
gboolean movieRequest(GtkButton *button, gpointer nil)
{ 
if (!movieWndw)
make_MovieDialog(TRUE);
switch(pdfSettings.movie.display)
{
case MVDISP1:
gtk_widget_hide(movieDisp);
break;
case MVDISP2:
gtk_widget_show(movieDisp);
break;
}
gtk_widget_show(movieWndw);
gtk_grab_add(movieWndw);
return TRUE;
}
static void freePmap(int *key, PDFFILMFRAME *frame, gpointer nil)
{
if (frame->pmap &&
G_IS_OBJECT(frame->pmap))
g_object_unref(frame->pmap);
frame->pmap = NULL;
}
void freeFrame(PDFFILMFRAME *frame)
{
if (frame->pmap &&
G_IS_OBJECT(frame->pmap))
g_object_unref(frame->pmap);
freePDF(frame->pdfReq, TRUE);
free(frame->pdfReq);
free(frame);
}
void freeFilm(PDFFILM *film)
{
g_hash_table_destroy(film->frames);
free(film);
}
gboolean resizeMovie(FILMRESIZE *filmR)
{
int screen = filmR->screen;
int frameNo = filmR->frameNo;
PDFFILM  *film;
PDFFILMFRAME *frame;
PDFREQ  *pdfReq;
GtkWidget  *da = MVPDFDA[screen];
long  daAddr = (long) da;
if (resizeQ[screen] &&
!g_queue_is_empty(resizeQ[screen]))
{ 
free(filmR);
makeDrawing(PDFMOVIE, screen, 0); 
return FALSE;
}
film = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
if (!film)
{ 
pdfStates.movie.resize[screen] = FALSE;
free(filmR);
makeDrawing(PDFMOVIE, screen, 0);
return FALSE;
}
frame = g_hash_table_lookup(film->frames, &frameNo);
pdfReq = frame->pdfReq;
if (!pdfReq->data.name) 
return TRUE;  
if (G_IS_OBJECT(frame->pmap))
g_object_unref(frame->pmap);
frame->pmap = makePmap(da, pdfReq);
if (!frame->pmap)
{ 
char *msg;
g_hash_table_foreach(film->frames, (GHFunc) freePmap, NULL);
msg = g_strdup("\nNot enough memory available for allocation, unable to make movie.\n"
"\nYou can reduce memory requirements by:\n"
"\t- Reducing the Size of the Movie Cell\n"
"\t- Reducing the Date Range of the Request\n"
"\t- Increasing the Number of Interval Days\n"
"\nPlease adjust and submit your request again.\n");
error_dialog("Make PDF Movie", msg);
free(msg);
pdfStates.movie.resize[screen] = FALSE;
g_hash_table_remove(pdfStates.movie.films[screen], &daAddr);
makeDrawing(PDFMOVIE, screen, 0);
return FALSE;
}
{
static GdkPixmap *pixmap;
pdfStates.movie.count[screen][PDFM_FRAMENUM] = frameNo+1;
pixmap = gdk_pixmap_new(da->window, da->allocation.width, da->allocation.height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, da->allocation.width, da->allocation.height);
makeMMSGpdf(pixmap, RESIZE_MOVIE, da->allocation.width, da->allocation.height, screen);
gdk_draw_drawable(da->window,
da->style->fg_gc[GTK_WIDGET_STATE (da)],
pixmap,
0, 0, 0, 0, -1, -1);
g_object_unref(pixmap);
}
filmR->frameNo++;
if (filmR->frameNo > film->lastFrame)
{
free(filmR);
pdfStates.movie.resize[screen] = FALSE;
makeDrawing(PDFMOVIE, screen, 0);
return FALSE;
}
return TRUE;
} 
static gboolean pdfMovieReturn(SQLDI *sqldi)
{
int   screen = GPOINTER_TO_INT(sqldi->data2);
GtkWidget  *da = MVPDFDA[screen];
PDFREQ  *pdfReq = sqldi->data;
PDFFILM  *film;
PDFFILMFRAME *frame;
int   frameNo = sqldi->args.sqr-1;
long  daAddr;
static gboolean reqOkay[TTLMOVIESCREENS] = {TRUE, TRUE, TRUE, TRUE, TRUE};
masterCnt--;
pdfStates.movie.count[screen][PDFM_FRAMENUM]++;
free(sqldi);
daAddr = (long) da;
if (!reqOkay[screen])
{
if (pdfStates.movie.count[screen][PDFM_FRAMENUM] == pdfStates.movie.count[screen][PDFM_TTLFRAMES])
{ 
char *msg;
msg = g_strdup("\nNot enough memory available for allocation, unable to make movie.\n"
"\nYou can reduce memory requirements by:\n"
"\t- Reducing the Size of the Movie Cell\n"
"\t- Reducing the Date Range of the Request\n"
"\t- Increasing the Number of Interval Days\n"
"\nPlease adjust and submit your request again.\n");
error_dialog("Make PDF Movie", msg);
free(msg);
g_hash_table_remove(pdfStates.movie.films[screen], &daAddr);
makeDrawing(PDFMOVIE, screen, 0);
reqOkay[screen] = TRUE;
}
return FALSE;
}
film = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
frame = g_hash_table_lookup(film->frames, &frameNo);
frame->pmap = makePmap(da, pdfReq);
if (!frame->pmap)
{ 
g_hash_table_foreach(film->frames, (GHFunc) freePmap, NULL);
reqOkay[screen] = FALSE;
return FALSE;
}
if (pdfStates.movie.count[screen][PDFM_FRAMENUM] == pdfStates.movie.count[screen][PDFM_TTLFRAMES])
{
char *day[2];
day[CHNSTART] = g_strdup_printf("%04d/%02d/%02d", 
g_date_get_year(&film->julian[CHNSTART]),
g_date_get_month(&film->julian[CHNSTART]),
g_date_get_day(&film->julian[CHNSTART]));
day[CHNEND] = g_strdup_printf("%04d/%02d/%02d", 
g_date_get_year(&film->julian[CHNEND]),
g_date_get_month(&film->julian[CHNEND]),
g_date_get_day(&film->julian[CHNEND]));
gtk_label_set_text(GTK_LABEL(mDT[screen][CHNSTART]), day[CHNSTART]);
gtk_label_set_text(GTK_LABEL(mDT[screen][CHNEND]), day[CHNEND]);
free(day[CHNSTART]); free(day[CHNEND]);
makeDrawing(PDFMOVIE, screen, 0);
}
else
{
static GdkPixmap *pixmap;
pixmap = gdk_pixmap_new(da->window, da->allocation.width, da->allocation.height, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[PDFMSG][ABNORMALGC], TRUE,
0, 0, da->allocation.width, da->allocation.height);
makeMMSGpdf(pixmap, BUSY_MOVIE, da->allocation.width, da->allocation.height, screen);
gdk_draw_drawable(da->window,
da->style->fg_gc[GTK_WIDGET_STATE (da)],
pixmap,
0, 0, 0, 0, -1, -1);
g_object_unref(pixmap);
}
if (dbQ &&
!g_queue_is_empty(dbQ))
{
SQLDI *nextSqldi;
nextSqldi = g_queue_pop_head(dbQ);
db_request(nextSqldi);
}
return FALSE;
}
void moviePDF(GtkButton *button, gpointer nil)
{
GDate *bounds[TTLCHNBOUNDS] = {NULL, NULL}, pdfStart, pdfEnd;
struct ptime startStop[TTLCHNBOUNDS];
guint days;
PDFREQ *pdfReq, pdfReqBase;
SQLDI *sqldi;
PDFFILM *film;
PDFFILMFRAME *filmFrame;
int  i, interval=0, *frameNo, screen, ttlDays;
long daAddr, *filmKey;
gboolean getBounds=FALSE, cum = FALSE;
switch(pdfSettings.movie.display)
{
case MVDISP1:
screen = pdfStates.movie.screen = PDFM5;
break;
case MVDISP2:
screen = pdfStates.movie.screen = gtk_combo_box_get_active(GTK_COMBO_BOX(movieDispCell));
break;
}
for(i=0;i<TTLCHNBOUNDS;i++)
memset(&startStop[i], 0, sizeof(struct ptime));
memset(&pdfReqBase, 0, sizeof(PDFREQ));
cum = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(mCUM[0]));
get_chnName(PDFMOVIE, (gpointer) &pdfReqBase);
if (!pdfReqBase.keys.chnKey)
{
char *msg = g_strdup("\nNo PDF Channel Selected , cannot continue.\n");
gdk_beep();
error_dialog("Make PDF Movie", msg);
free(msg);
return;
}
daAddr = (long) MVPDFDA[screen];
film = calloc(1, sizeof(PDFFILM));
film->movieID = daAddr;
film->screen = screen;
filmKey = calloc(1, sizeof(int));
*filmKey = daAddr;
g_hash_table_replace(pdfStates.movie.films[screen], filmKey, film);
film->frames = g_hash_table_new_full(g_int_hash, g_int_equal, free, (GDestroyNotify) freeFrame);
memcpy(&pdfReqBase.keys.statistics, &pdfSettings.common.statistics[PDFMOVIE], sizeof(pdfSettings.common.statistics[PDFMOVIE]));
sscanf(gtk_entry_get_text(GTK_ENTRY(mHR[PDFREQSTART][PDFREQHR])), "%f", &pdfReqBase.keys.criteria[PDFREQ_HRSTARTH]);
sscanf(gtk_entry_get_text(GTK_ENTRY(mHR[PDFREQSTART][PDFREQMN])), "%f", &pdfReqBase.keys.criteria[PDFREQ_HRSTARTM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(mHR[PDFREQEND][PDFREQHR])), "%f", &pdfReqBase.keys.criteria[PDFREQ_HRENDH]);
sscanf(gtk_entry_get_text(GTK_ENTRY(mHR[PDFREQEND][PDFREQMN])), "%f", &pdfReqBase.keys.criteria[PDFREQ_HRENDM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(mDY[PDFREQSTART][PDFREQYR])), "%hd", &startStop[CHNSTART].yr);
sscanf(gtk_entry_get_text(GTK_ENTRY(mDY[PDFREQEND][PDFREQYR])), "%hd", &startStop[CHNEND].yr);
sscanf(gtk_entry_get_text(GTK_ENTRY(mDY[PDFREQSTART][PDFREQMO])), "%hd", &startStop[CHNSTART].mo);
sscanf(gtk_entry_get_text(GTK_ENTRY(mDY[PDFREQEND][PDFREQMO])), "%hd", &startStop[CHNEND].mo);
sscanf(gtk_entry_get_text(GTK_ENTRY(mDY[PDFREQSTART][PDFREQDY])), "%hd", &startStop[CHNSTART].day);
sscanf(gtk_entry_get_text(GTK_ENTRY(mDY[PDFREQEND][PDFREQDY])), "%hd", &startStop[CHNEND].day);
sscanf(gtk_entry_get_text(GTK_ENTRY(mINT)), "%d", &interval);
if (!interval)
interval = 1;
for(i=0;i<TTLCHNBOUNDS;i++)
{ 
if (!startStop[i].yr || startStop[i].yr < 1900 || startStop[i].yr > 2100 ||
!startStop[i].mo || startStop[i].mo < 1 || startStop[i].mo > 12 ||
!startStop[i].day || startStop[i].day < 1 || startStop[i].day > 31)
{
startStop[i].yr = startStop[i].mo = startStop[i].day = 0;
getBounds = TRUE;
continue;
}
bounds[i] = g_date_new_dmy(startStop[i].day, startStop[i].mo, startStop[i].yr);
}
if (getBounds)
{
SQLDI sqldiL;
PDFBOUNDS pdfBounds;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&pdfBounds, 0, sizeof(PDFBOUNDS));
sqldiL.args.dataEvent = GET_DATA;
sqldiL.descr.tableData = PDFBOUNDSTBL;
sqldiL.data = &pdfBounds;
pdfBounds.keys.chnKey = pdfReqBase.keys.chnKey;
db_request(&sqldiL);
if (!pdfBounds.data.bounds[CHNSTART].date.day)
{
char *msg = g_strdup("\nNo PDF Data Available , cannot continue.\n");
gdk_beep();
error_dialog("Make PDF Movie", msg);
free(msg);
return;
}
for(i=0;i<TTLCHNBOUNDS;i++)
{
if(!bounds[i])
{
int day = startStop[i].day ? startStop[i].day : pdfBounds.data.bounds[i].date.day;
int mo = startStop[i].mo ? startStop[i].mo : pdfBounds.data.bounds[i].date.mo;
int yr = startStop[i].yr ? startStop[i].yr : pdfBounds.data.bounds[i].date.yr;
bounds[i] = g_date_new_dmy(day, mo,yr);
}
}
}
for(i=0;i<TTLCHNBOUNDS;i++)
{
memcpy(&film->julian[i], bounds[i], sizeof(GDate));
}
film->cumulative = cum;
film->interval = interval;
memcpy(&pdfStart, bounds[CHNSTART], sizeof(GDate));
memcpy(&pdfEnd, &pdfStart, sizeof(GDate));
days = g_date_get_julian(&film->julian[CHNEND]) - g_date_get_julian(&film->julian[CHNSTART]);
pdfStates.movie.count[screen][PDFM_TTLFRAMES] = 0;
pdfStates.movie.count[screen][PDFM_FRAMENUM] = 0;
for(i=0, ttlDays = 0; 
ttlDays <= days; 
i++, ttlDays += interval)
{
pdfStates.movie.count[screen][PDFM_TTLFRAMES]++;
if (!i)
{
makeDrawing(PDFMOVIE, screen, 0);
while (gtk_events_pending())  
gtk_main_iteration();
}
pdfReq = calloc(1, sizeof(PDFREQ));
filmFrame = calloc(1, sizeof(PDFFILMFRAME));
sqldi = calloc(1, sizeof(SQLDI));
frameNo = calloc(1, sizeof(int));
*frameNo = i;
filmFrame->movieID = daAddr;
filmFrame->frameNo = *frameNo;
filmFrame->pdfReq = pdfReq;
g_hash_table_insert(film->frames, frameNo, filmFrame);
memcpy(&pdfEnd, &pdfStart, sizeof(GDate));
g_date_add_days(&pdfEnd, (cum ? ttlDays+interval-1 : interval-1));
memcpy(pdfReq, &pdfReqBase, sizeof(PDFREQ));
pdfReq->data.name = g_strdup(pdfReqBase.data.name);
pdfReq->keys.criteria[PDFREQ_YRSTART] = g_date_get_year(&pdfStart);
pdfReq->keys.criteria[PDFREQ_DYSTARTM] = g_date_get_month(&pdfStart);
pdfReq->keys.criteria[PDFREQ_DYSTARTD] = g_date_get_day(&pdfStart);
pdfReq->keys.criteria[PDFREQ_YREND] = g_date_get_year(&pdfEnd);
pdfReq->keys.criteria[PDFREQ_DYENDM] = g_date_get_month(&pdfEnd);
pdfReq->keys.criteria[PDFREQ_DYENDD] = g_date_get_day(&pdfEnd);
pdfReq->data.sTime.date.yr = pdfReq->keys.criteria[PDFREQ_YRSTART];
pdfReq->data.sTime.date.jday = g_date_get_day_of_year(&pdfStart);
pdfReq->data.eTime.date.yr = pdfReq->keys.criteria[PDFREQ_YREND];
pdfReq->data.eTime.date.jday = g_date_get_day_of_year(&pdfEnd);
pdfReq->keys.reqType = REQRANGE;
pdfReq->keys.fillTmp = TRUE;
pdfReq->keys.pdfKey = CUSTOMPDF;
sqldi->args.dataEvent = GET_DATA;
sqldi->descr.tableData = PDFMFRAME;
sqldi->data = pdfReq;
sqldi->data2 = GINT_TO_POINTER(screen);
sqldi->args.sqr = i+1;
sqldi->args.callType = ASYNC;
sqldi->args.returnFunc = (void *) pdfMovieReturn;
masterCnt++;
if (masterCnt >= MAXPERSISTENT/2)
{ 
if (!dbQ)
{
dbQ = g_queue_new();
}
g_queue_push_tail(dbQ, sqldi);
}
else
{
db_request(sqldi);
}
if (!cum)
g_date_add_days(&pdfStart, interval);
}
film->lastFrame = i-1;
g_date_free(bounds[0]);
g_date_free(bounds[1]);
}
static void playPause(int screen, int cmd, int cmdo)
{ 
switch (cmdo)
{
case PDFM_PAUSE:
switch(pdfStates.movie.state[screen])
{
case PDFM_BACKWARD:
case PDFM_FORWARD:  
gtk_range_set_value(GTK_RANGE (mFR[screen]), (double) 0);
break;
}
pdfStates.movie.state[screen] = PDFM_NONE;
break;
case PDFM_START:
break;
}
}
static guint  timerID[TTLMOVIESCREENS]; 
static gboolean newFR[TTLMOVIESCREENS];  
static gboolean stop[TTLMOVIESCREENS];  
static gboolean playMovie(PDFFILM *film)
{
int frameNo;
GtkWidget *da = (GtkWidget *) film->movieID;
int width=da->allocation.width, height=da->allocation.height;
int screen = film->screen;
PDFFILMFRAME *frame;
if (stop[screen])
{
stop[screen] = FALSE;
timerID[screen] = 0;
return FALSE;
}
if (newFR[screen])
{ 
timerID[screen] = g_timeout_add(1000/pdfSettings.movie.frameRate[screen], 
(GSourceFunc) playMovie, film);
newFR[screen] = FALSE;
return FALSE;
}
switch(film->cmd)
{
case PDFM_BACKWARD:
frameNo = --(film->frameNo);
if (frameNo < 0)
{ 
switch(pdfSettings.movie.repeat[screen])
{
case TRUE:  
frameNo = film->lastFrame;
g_usleep(1000000);
break;
case FALSE:
film->frameNo = 0;
gdk_beep();
timerID[screen] = 0;
playPause(screen, film->cmd, PDFM_PAUSE);
return FALSE;  
break;
}
}
break;
case PDFM_FORWARD:
frameNo = ++(film->frameNo);
if (frameNo > film->lastFrame)
{ 
switch(pdfSettings.movie.repeat[screen])
{
case TRUE:  
frameNo = 0;
g_usleep(1000000);
break;
case FALSE:
film->frameNo = film->lastFrame;
gdk_beep();
timerID[screen] = 0;
playPause(screen, film->cmd, PDFM_PAUSE);
return FALSE;  
break;
}
}
break;
}
frame = g_hash_table_lookup(film->frames, &frameNo);
pdfStates.pmap.movie[screen] = frame->pmap;
gtk_widget_queue_draw_area(da, 0, 0, width, height); 
return TRUE;
}
void pdfMoviePlay(GtkButton *button, gpointer i)
{
int id = GPOINTER_TO_INT(i);
int screen = id/TTLPDFMCMDS;
int cmd = id%TTLPDFMCMDS, frameNo;
GtkWidget *da = MVPDFDA[screen];
long daAddr = (long) da;
int  width=da->allocation.width, height=da->allocation.height;
PDFFILM  *film;
PDFFILMFRAME *frame;
film = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
if (!film)
{
gdk_beep();
return;
}
film->cmd = cmd;
switch(cmd)
{
case PDFM_BEGIN:
case PDFM_END:
{
if (timerID[screen])
{
stop[screen] = TRUE;
playPause(screen, pdfStates.movie.state[screen], PDFM_PAUSE);
}
film->frameNo = (cmd == PDFM_BEGIN) 
? 0
: film->lastFrame;
frame = g_hash_table_lookup(film->frames, &film->frameNo);
pdfStates.pmap.movie[screen] = frame->pmap;
gtk_widget_queue_draw_area(da, 0, 0, width, height); 
pdfStates.movie.state[screen] = PDFM_NONE;
}
break;
case PDFM_BACKWARD:
{ 
if (timerID[screen])
{
stop[screen] = TRUE;
playPause(screen, pdfStates.movie.state[screen], PDFM_PAUSE);
}
frameNo = --(film->frameNo);
if (frameNo < 0)
{
film->frameNo = 0;
gdk_beep();
pdfStates.movie.state[screen] = PDFM_NONE;
playPause(screen, cmd, PDFM_PAUSE);
break;
}
pdfStates.movie.state[screen] = cmd;
frame = g_hash_table_lookup(film->frames, &frameNo);
pdfStates.pmap.movie[screen] = frame->pmap;
gtk_widget_queue_draw_area(da, 0, 0, width, height); 
if (pdfSettings.movie.frameRate[screen])
{ 
--(film->frameNo);
playPause(screen, cmd, PDFM_START);
timerID[screen] = g_timeout_add(1000/pdfSettings.movie.frameRate[screen], 
(GSourceFunc) playMovie, film);
}
}
break;
case PDFM_FORWARD:
{
if (timerID[screen])
{ 
stop[screen] = TRUE;
playPause(screen, pdfStates.movie.state[screen], PDFM_PAUSE);
}
frameNo = ++(film->frameNo);
if (frameNo > film->lastFrame)
{
film->frameNo = film->lastFrame;
pdfStates.movie.state[screen] = PDFM_NONE;
gdk_beep();
playPause(screen, cmd, PDFM_PAUSE);
break;
}
pdfStates.movie.state[screen] = cmd;
frame = g_hash_table_lookup(film->frames, &frameNo);
pdfStates.pmap.movie[screen] = frame->pmap;
gtk_widget_queue_draw_area(da, 0, 0, width, height); 
if (pdfSettings.movie.frameRate[screen])
{ 
++(film->frameNo);
playPause(screen, cmd, PDFM_START);
timerID[screen] = g_timeout_add(1000/pdfSettings.movie.frameRate[screen], 
(GSourceFunc) playMovie, film);
}
}
break;
case PDFM_PAUSEF:
case PDFM_PAUSEB:
{
stop[screen] = TRUE;
playPause(screen, cmd-1, PDFM_PAUSE);
}
break;
}
return;
}
void movieCmd(int screen, int cmd, int state)
{
int id;
switch(cmd)
{
case PDFM_START:
id = screen*TTLPDFMCMDS+state;
break;
case PDFM_PAUSE:
id = screen*TTLPDFMCMDS+state+1;
break;
}
pdfMoviePlay(NULL, GINT_TO_POINTER(id));
}   
void pdfMFrameRate(GtkRange *range, gpointer s)
{
int screen = GPOINTER_TO_INT(s);
int rate = (int) gtk_range_get_value(range);
pdfSettings.movie.frameRate[screen] = abs(rate);
switch(rate)
{
case 0:  
if (timerID[screen])
movieCmd(screen, PDFM_PAUSE, pdfStates.movie.state[screen]);
break;
default: 
switch(pdfStates.movie.state[screen])
{
case PDFM_NONE:
if (rate < 0)
movieCmd(screen, PDFM_START, PDFM_BACKWARD);
if (rate > 0)
movieCmd(screen, PDFM_START, PDFM_FORWARD);
break;
case PDFM_BACKWARD:
case PDFM_FORWARD:
newFR[screen] = TRUE;
break;
}
break;
}
}
#include <sys/stat.h>
#define CONVERT_CMD "convert"
typedef struct _MOVIEARGS
{
int  screen;
char *outFile, *outDir, *inDir;
gboolean (*returnFunc)(void*);  
} MOVIEARGS;
static gboolean _pdfMovieSaveRet(void *data)
{
MOVIEARGS *movieArgs = data;
char *msg = g_strdup_printf("PDF Movie ' %s ' Successfully Saved to Directory %s", 
movieArgs->outFile, movieArgs->outDir);
dispMsgPDF(DISPLAY, msg);
free(movieArgs->outDir);
free(movieArgs->outFile);
free(movieArgs->inDir);
free(movieArgs);
free(msg);
gdk_beep();
return FALSE;
}
static GThreadFunc _pdfMovieSave(MOVIEARGS *movieArgs)
{
int  screen = movieArgs->screen, 
fR = (pdfSettings.movie.frameRate[screen] ? pdfSettings.movie.frameRate[screen] : 1);
char *outFile = movieArgs->outFile, *inDir = movieArgs->inDir, *outDir = movieArgs->outDir;
char *system_cmd;
system_cmd = g_strdup_printf("%s -delay %d %s/img*.png %s/%s", 
CONVERT_CMD,
100/fR, 
inDir, outDir, outFile);
system(system_cmd);  free(system_cmd);
system_cmd = g_strdup_printf("/bin/rm -r %s", inDir);
system(system_cmd);  free(system_cmd);
if (movieArgs->returnFunc)
g_idle_add((GSourceFunc) movieArgs->returnFunc, (gpointer) movieArgs);
return NULL;
}
static gboolean check_convert()
{
FILE *fp;
char *tmpFile = g_strdup("/tmp/convert.check");
char *cmd = g_strdup_printf("%s --version 1>%s 2>%s", CONVERT_CMD, tmpFile, tmpFile);
char version[15];
gboolean ret;
system(cmd);
free(cmd);
if (!(fp = fopen(tmpFile, "r")))
{
free(tmpFile);
return FALSE;
}
fscanf(fp, "%s", version);
if (!strcmp(version, "Version:"))
ret = TRUE;
else
ret = FALSE;
fclose(fp);
remove(tmpFile);  
free(tmpFile);
return ret;
}
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
#define PDFM_XML_HDR "PDFMOVIE"
#define PDFM_XML_GIF "GIFFILE"
#define PDFM_XML_CREATION "CREATION"
#define PDFM_XML_CHN "CHANNEL"
#define PDFM_XML_SD  "START_DATE"
#define PDFM_XML_ED  "END_DATE"
#define PDFM_XML_SH  "START_HOUR"
#define PDFM_XML_EH  "END_HOUR"
#define PDFM_XML_IVAL "INTERVAL"
#define PDFM_XML_CUM "CUMULATIVE"
#define PDFM_XML_NOTES "NOTES"
static void saveNotes(int screen, GtkWidget *notes, char *outDir, char *fName)
{
FILE  *fp;
GtkTextIter startTI;
GtkTextIter endTI;
gchar   *text, *outFile = g_strdup_printf("%s/%s.xml", outDir, fName);
gchar  *gifFile = g_strdup_printf("%s/%s.gif", outDir, fName);
GtkTextBuffer *buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (notes));
long   daAddr = (long) MVPDFDA[screen];
int   first=0;
PDFFILM  *film = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
PDFFILMFRAME *frame = g_hash_table_lookup(film->frames, &first);
PDFREQ  *pdfReq = frame->pdfReq;
GDate  *start = &film->julian[CHNSTART], 
*end = &film->julian[CHNEND];
char   *timeStr = currentT();
gtk_text_buffer_get_start_iter (buffer, &startTI);
gtk_text_buffer_get_end_iter (buffer, &endTI);
text = gtk_text_buffer_get_text (buffer, &startTI, &endTI, FALSE);
if (!(fp = fopen(outFile, "w")))
return;
fprintf(fp, "<%s>\n", PDFM_XML_HDR);
fprintf(fp, "\t<%s>%s</%s>\n", PDFM_XML_GIF, gifFile, PDFM_XML_GIF);
fprintf(fp, "\t<%s>%s</%s>\n", PDFM_XML_CREATION, timeStr, PDFM_XML_CREATION);
fprintf(fp, "\t<%s>%s</%s>\n", PDFM_XML_CHN, pdfReq->data.name, PDFM_XML_CHN);
fprintf(fp, "\t<%s>%04d/%02d/%02d</%s>\n", 
PDFM_XML_SD, 
g_date_get_year(start), g_date_get_month(start), g_date_get_day(start), 
PDFM_XML_SD);
fprintf(fp, "\t<%s>%04d/%02d/%02d</%s>\n", 
PDFM_XML_ED,
g_date_get_year(end), g_date_get_month(end), g_date_get_day(end),
PDFM_XML_ED);
fprintf(fp, "\t<%s>%02d:%02d</%s>\n", 
PDFM_XML_SH, 
(int) pdfReq->keys.criteria[PDFREQ_HRSTARTH],
(int) pdfReq->keys.criteria[PDFREQ_HRSTARTM],
PDFM_XML_SH);
fprintf(fp, "\t<%s>%02d:%02d</%s>\n", 
PDFM_XML_EH, 
(int) pdfReq->keys.criteria[PDFREQ_HRENDH],
(int) pdfReq->keys.criteria[PDFREQ_HRENDM],
PDFM_XML_EH);
fprintf(fp, "\t<%s>%d</%s>\n", PDFM_XML_IVAL, film->interval, PDFM_XML_IVAL);
fprintf(fp, "\t<%s>%s</%s>\n", PDFM_XML_CUM, (film->cumulative?"TRUE":"FALSE"), PDFM_XML_CUM);
fprintf(fp, "\t<%s>%s</%s>\n", PDFM_XML_NOTES, text, PDFM_XML_NOTES);
fprintf(fp, "</%s>", PDFM_XML_HDR);
fclose(fp);
free(timeStr);
g_free(text);
free(gifFile);
}
static gboolean makeMoviePNG(int screen, char *outDir, char *inDir)
{
char  *fullFN;
GdkPixbuf *pPixbuf;
int   i;
long   daAddr = (long) MVPDFDA[screen];
PDFFILM  *film = g_hash_table_lookup(pdfStates.movie.films[screen], &daAddr);
PDFFILMFRAME *frame;
GdkPixmap *pixmap;
if (!film)
{ 
gdk_beep();
return FALSE;
}
for(i=0; i<=film->lastFrame;i++)
{
frame = g_hash_table_lookup(film->frames, &i);
pixmap = frame->pmap;
fullFN = g_strdup_printf("%s/img%03d.png", inDir, i+1);
if (!(pPixbuf = gdk_pixbuf_get_from_drawable(NULL, pixmap, NULL, 0, 0, 0, 0, -1, -1)))
{
char *msg = g_strdup("Internal Error: Failed to Create PIXBUF for Printing, Please Report\n");
gdk_beep();
error_dialog("Save PDF Movie", msg);
free(msg);
return FALSE;
}
if (!gdk_pixbuf_save(pPixbuf, fullFN, "png", NULL, NULL))
{
char *msg = g_strdup("Could not save PDF plot in PNG format. Most likely cause is missing libpng library.\nYou can obtain this library by downloading the latest release of PQL and re-compiling the PQLX system.\nPQL can be downloaded from: http://www.passcal.nmt.edu/announcements/pqlII.htm\n");
gdk_beep();
error_dialog("Save PDF Movie", msg);
free(msg);
return FALSE;
}
free(fullFN);
}
return TRUE;
}
#define PDFMOVIEDIR "movie"
void pdfMovieSave(GtkButton *button, gpointer nil)
{
MOVIEARGS *movieArgs;
int  i;
char *outDir, *inDir, *home = getenv("HOME");
static gboolean convertExists = FALSE;
static GtkWidget *mSVdialog, *filename, *notes, *cellCombo;
static int outNo=0;
g_static_mutex_lock(&myMutex);
if (!convertExists)
{
if (!check_convert())
{
char *msg = g_strdup("\nIn order to save animated .gif files, ImageMagick must be installed on the machine running the client program pqlx.\nThe program 'convert' is either not in your PATH environment variable or ImageMagick is not installed.\n\nBinary and Source Releases of ImageMagick can be downloaded from:\n\thttp://www.imagemagick.org\n\nPlease install and try again.");
gdk_beep();
error_dialog("Save PDF Movie", msg);
free(msg);
return;
}
else
convertExists = TRUE;
}
if (!mSVdialog)
{
GtkWidget *label, *hbox, *vbox, *bbox, *frame;
GtkWidget *entry, *frame2, *combo;
GtkTooltips *tips;
char  *toolTip;
mSVdialog = gtk_dialog_new_with_buttons ("Save PDF Movie",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
vbox = gtk_vbox_new(FALSE, 2);
bbox = gtk_hbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_SPREAD);
cellCombo = combo = gtk_combo_box_new_text();
for(i=0;i<TTLMOVIEDISPCELLS;i++)
gtk_combo_box_insert_text(GTK_COMBO_BOX(combo), i, movieDispCells[i]);
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
gtk_box_pack_start(GTK_BOX(vbox), combo, TRUE, FALSE, 10);
gtk_container_add(GTK_CONTAINER(vbox), bbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Filename: ");
filename = entry = gtk_entry_new();
tips = gtk_tooltips_new();  
toolTip = g_strdup("Saved to Directory ~/pqlx");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
frame = gtk_frame_new("Notes");
hbox = gtk_hbox_new(TRUE, 2);
frame2 = gtk_frame_new(NULL);
notes = gtk_text_view_new();
gtk_container_add(GTK_CONTAINER(frame2), notes);
gtk_box_pack_start(GTK_BOX(hbox), frame2, TRUE, TRUE, 2);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_container_add(GTK_CONTAINER(vbox), frame);
gtk_widget_set_size_request(notes, 1, 250);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(mSVdialog)->vbox), vbox);
gtk_widget_show_all(mSVdialog);
free(toolTip);
}
else
{
gtk_widget_show(mSVdialog);
}
gtk_widget_grab_focus(filename);
switch(pdfSettings.movie.display)
{
case MVDISP1:
gtk_widget_hide(cellCombo);
break;
case MVDISP2:
gtk_widget_show(cellCombo);
break;
}
if (gtk_dialog_run (GTK_DIALOG (mSVdialog)) == GTK_RESPONSE_OK)
{
int  screen;
char *fName = (char *) gtk_entry_get_text(GTK_ENTRY(filename));
if (!strlen(fName))
{
gdk_beep();
gtk_widget_hide(mSVdialog);
goto GETOUT;
}
switch(pdfSettings.movie.display)
{
case MVDISP1:
screen = PDFM5;
break;
case MVDISP2:
screen = gtk_combo_box_get_active(GTK_COMBO_BOX(cellCombo));
break;
}
gtk_widget_hide(mSVdialog);
outDir = g_strdup_printf("%s/pqlx", home);
mkdir(outDir, 0777); free(outDir);
outDir = g_strdup_printf("%s/pqlx/%s", home, PDFMOVIEDIR);
mkdir(outDir, 0777);
inDir = g_strdup_printf("%s/tmp/", home);
mkdir(inDir, 0777); free(inDir);
inDir = g_strdup_printf("%s/tmp/req%d", home, ++outNo);
mkdir(inDir, 0777);
if (!makeMoviePNG(screen, outDir, inDir)) 
goto GETOUT;
saveNotes(screen, notes, outDir, fName); 
movieArgs = calloc(1, sizeof(MOVIEARGS));
movieArgs->screen = screen;
movieArgs->outDir = outDir;
movieArgs->inDir = inDir;
movieArgs->outFile = g_strdup_printf("%s.gif", fName);
movieArgs->returnFunc = _pdfMovieSaveRet;
remove(movieArgs->outFile);
makeThread(ASYNC, (GThreadFunc) _pdfMovieSave, movieArgs, NULL);  
}
else
{
gtk_widget_hide(mSVdialog);
}
GETOUT:
g_static_mutex_unlock(&myMutex);
}
