#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
static GtkWidget *PDFchFList;
static GtkWidget *pdfChnfltrVIEW;
static GtkTooltips  *tips;
static char   toolTip[1000];
static gboolean listChgd=FALSE;
static void fltrSel(GtkTreeView *treeview, gpointer);
static void fltrCBack(GtkButton *button, gpointer );
static void addStnChnFilt(GtkWidget *widget, gpointer);
enum {
FLTRDEL,
FLTRLSTDONE
};
GtkListStore *fltrStore;
static void add_fltr_hdr_columns(GtkTreeView *treeview)
{
GtkCellRenderer *renderer;
GtkTreeViewColumn *col;
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes("Filters", renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
}
static GtkWidget *makeFltrHdrModel()
{
GtkWidget *treeview;
fltrStore = gtk_list_store_new(1, G_TYPE_STRING);
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL(fltrStore));
return (treeview);
}
static void add_fltrs()
{
int   j;
GtkTreeIter iter;
if (fltrStore)
gtk_list_store_clear(fltrStore);
for(j=0;j<pdfSettings.main.chnFilter.numFilters;j++)
{
gtk_list_store_append(fltrStore, &iter);
gtk_list_store_set(fltrStore, &iter, 0, pdfSettings.main.chnFilter.filts[j], -1);
}
}
static void make_filterList()
{
GtkWidget *frame1, *hbox1, *hbox, *fltrSW;
GtkWidget *vbox, *vbox1, *entry, *label, *button;
tips = gtk_tooltips_new();
PDFchFList = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_window_set_title (GTK_WINDOW(PDFchFList), "Channel Filter Definitions"); 
gtk_container_set_border_width(GTK_CONTAINER(PDFchFList), 2);
frame1 = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_IN);
gtk_container_add(GTK_CONTAINER(PDFchFList), frame1);
vbox1 = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Filter: ");
entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 20);
strcpy(toolTip, "Specify Channel Filter as GLOB pattern.\n<ENTER>-Key to input onto list.");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox1), hbox, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(addStnChnFilt), NULL);
hbox1 = gtk_hbox_new(FALSE, 0);
fltrSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (fltrSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (fltrSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
pdfChnfltrVIEW = makeFltrHdrModel();
g_signal_connect(pdfChnfltrVIEW, "cursor-changed", G_CALLBACK(fltrSel), NULL);
gtk_container_add(GTK_CONTAINER(fltrSW), pdfChnfltrVIEW);
gtk_box_pack_start(GTK_BOX(hbox1), fltrSW, FALSE, FALSE, 2);
add_fltr_hdr_columns(GTK_TREE_VIEW(pdfChnfltrVIEW));
gtk_widget_set_size_request(fltrSW, 100, 200);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), pdfChnfltrVIEW, toolTip, toolTip);
vbox = gtk_vbutton_box_new ();
gtk_button_box_set_layout (GTK_BUTTON_BOX(vbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("DELETE");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Remove Filter from List");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(fltrCBack), GINT_TO_POINTER(FLTRDEL));
button = gtk_button_new_with_label("DONE");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(fltrCBack), GINT_TO_POINTER(FLTRLSTDONE));
gtk_box_pack_start(GTK_BOX(hbox1), vbox, FALSE, FALSE, 2); 
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 2); 
gtk_container_add(GTK_CONTAINER(frame1), vbox1);
gtk_window_set_position(GTK_WINDOW(PDFchFList), GTK_WIN_POS_CENTER);
gtk_widget_show_all (PDFchFList);
gtk_window_set_transient_for((GtkWindow *) PDFchFList, (GtkWindow *) topWindow);
add_fltrs();
}
static void make_filterDialogue(int type)
{
switch(type)
{
case FILTERLIST:
if (!PDFchFList)
make_filterList();
break;
}
}
void setPDFchnFiltCbos()
{
static int prevNumFilters=-1;
static GSList *widgets;
GSList *iter;
int  j;
if (!widgets)
{
widgets = g_slist_prepend(widgets, chnFilterPDF);
widgets = g_slist_prepend(widgets, SPchnFilt);
}
for (iter = widgets;
iter;
iter = g_slist_next(iter))
{
GtkWidget *widget = iter->data;
if (prevNumFilters != -1)
for(j=prevNumFilters+1;j>=0;j--)
gtk_combo_box_remove_text(GTK_COMBO_BOX(widget), j);
gtk_combo_box_insert_text(GTK_COMBO_BOX(widget), 0, "Manage...");
gtk_combo_box_append_text(GTK_COMBO_BOX(widget), "ALL");
for(j=0;j<pdfSettings.main.chnFilter.numFilters;j++)
{ 
gtk_combo_box_append_text(GTK_COMBO_BOX(widget), pdfSettings.main.chnFilter.filts[j]);
}
}
prevNumFilters = pdfSettings.main.chnFilter.numFilters;
}
static int filterSelected;
static void fltrCBack(GtkButton *button, gpointer t)
{ 
int  type = GPOINTER_TO_INT(t);
switch(type)
{
case FLTRDEL:
{
DBLDI dbldi;
DBLRECORDS dblrecs;
STN_CHN_FILTER dataRec;
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNCHNFLTRST;
dbldi.descr.dataEvent = DELETE_SNGL;
dataRec.name = pdfSettings.main.chnFilter.filts[filterSelected];
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &dataRec;
dbl_request(&dbldi);
free(dblrecs.recs);
listChgd = TRUE;
readSTNchnFilters(PDFSYSTEM);
add_fltrs();
}
break;
case FLTRLSTDONE:
gtk_grab_remove(PDFchFList);
gtk_widget_hide(PDFchFList);
if (listChgd)
{
setPDFchnFiltCbos();
listChgd=FALSE;
}
gtk_combo_box_set_active((GtkComboBox *) chnFilterPDF, NOFILTERSELECTION);
pdfStates.main.group.chnFilter.active = NOFILTERSELECTION;
break;
}
}
void makeChnFltList()
{
int  screen = pdfStates.screen;
GSList **chnList, *list;
GSList *listI;
NSLCDATA *chnData;
CHN_FLT_STATE *chnFilter;
gboolean filter;
switch (screen)
{
case PDFMAIN:
list = pdfStates.main.group.list;
chnFilter = &pdfStates.main.group.chnFilter;
chnList = &pdfStates.main.group.chnList;
break;
case SPECTROMAIN:
list = pdfStates.spmain.group.list;
chnFilter = &pdfStates.spmain.group.chnFilter;
chnList = &pdfStates.spmain.group.chnList;
break;
}
filter = chnFilter->filt ? TRUE : FALSE;
if (*chnList)
g_slist_free(*chnList);
*chnList = NULL;
switch (filter)
{
case FALSE:
*chnList = g_slist_copy(list);
break;
case TRUE:
for(listI = list; 
listI; 
listI = g_slist_next(listI))
{
chnData = listI->data;
if (globmatch(chnData->name, chnFilter->filt))
*chnList = g_slist_append(*chnList, chnData);
}
break;
}
return;
}
void pdfChnFltrSelectC(GtkComboBox *combo, gpointer s)
{ 
int  screen = GPOINTER_TO_INT(s);
int  selection = gtk_combo_box_get_active(combo);
int  *active;
char **filt;
switch (screen)
{
case PDFMAIN:
active = &pdfStates.main.group.chnFilter.active;
filt = &pdfStates.main.group.chnFilter.filt;
break;
case SPECTROMAIN:
active = &pdfStates.spmain.group.chnFilter.active;
filt = &pdfStates.spmain.group.chnFilter.filt;
break;
}
*active = selection - 2; 
switch(selection)
{
case -1:
return;
case 0:
{ 
if (!PDFchFList)
{
make_filterDialogue(FILTERLIST);
gtk_window_set_transient_for(GTK_WINDOW(PDFchFList), GTK_WINDOW(topWindow));
}
gtk_widget_show(PDFchFList);
gtk_grab_add(PDFchFList);
*active = NOFILTERSELECTION;
return;
}
break;
case 1:
{ 
if (*filt)
free(*filt);
*filt = NULL;
*active = NOFILTERSELECTION;
}
break;
default:
{   
if (*filt)
free(*filt);
*filt = g_strdup(pdfSettings.main.chnFilter.filts[*active]);
}
break;
}
if (!ntw)    
return;
makeChnFltList();        
nextPDFs(NULL, GINT_TO_POINTER(PDFGREINIT));
}
static void addStnChnFilt(GtkWidget *widget, gpointer nothing)
{
DBLDI dbldi;
DBLRECORDS dblrecs;
STN_CHN_FILTER chnFilter;
chnFilter.name = (char *) gtk_entry_get_text(GTK_ENTRY(widget));
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNCHNFLTRST;
dbldi.descr.dataEvent = WRITE_SNGL;
dbldi.data = &dblrecs;
dblrecs.numRecs = 1;
if((dblrecs.recs = calloc(dblrecs.numRecs, sizeof(void *)))==NULL)
{
fprintf(stderr, "Out of Memory, cannot continue.\n");
exit(-1);
}
dblrecs.recs[0] = &chnFilter;
dbl_request(&dbldi);
free(dblrecs.recs);
readSTNchnFilters(PDFSYSTEM);
add_fltrs();
gtk_entry_set_text(GTK_ENTRY(widget), "");
listChgd = TRUE;
}
static void fltrSel(GtkTreeView *treeview, gpointer nil)
{ 
char *rowS;
GtkTreePath *path;
gtk_tree_view_get_cursor (treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
gtk_tree_path_free(path);
filterSelected = atoi(rowS);
g_free(rowS);
}
