#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
static void make_pdfCtrlScreens();
static GtkTooltips *tips;
static char  toolTip[1000];
static GtkWidget *blineSelectB;
void makeBLINECtrls(int cmd, GSList *blines)
{
int   i;
GSList  *iter;
BLINEDEF  *bline;
switch (cmd)
{
case BLINE_MK_CTRL:
{
static GtkWidget *PSDblines;
BLINECTRL *blineCtrl;
GtkWidget *frame, *box1, *hbox1, *radio1=NULL;
if (PSDblines)
{ 
gtk_widget_destroy(PSDblines); PSDblines = NULL;
makeBLINECtrls(BLINE_MK_LISTDEL, NULL);
}
if (!blines)
{
if (blineOptions) gtk_widget_hide(blineOptions);
return;
}
bline = blines->data;
pdfSettings.main.bline.blineKey = bline->blineKey;
pdfSettings.main.bline.pct = BLINEPCTDEF;
if (!blineOptions)
return;
gtk_widget_show(blineOptions);
makeBLINECtrls(BLINE_MK_LIST, blines);
PSDblines = frame = gtk_frame_new("Select Baseline: ");
box1 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box1);
for(iter = PSDblineCtrlR, i=0;
iter;
iter = g_slist_next(iter), i++)
{
blineCtrl = iter->data;
bline = blineCtrl->blineDef;
if (!(i%3))
{
hbox1 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(box1), hbox1, TRUE, FALSE, 2);
}
blineCtrl->widg = radio1 = gtk_radio_button_new_with_label(
!radio1 ? NULL : gtk_radio_button_get_group((GtkRadioButton *) radio1), 
bline->name);
gtk_box_pack_start(GTK_BOX(hbox1), radio1, FALSE, FALSE, 10);
}
gtk_box_pack_start(GTK_BOX(blineSelectB), PSDblines, FALSE, FALSE, 0);
if (blPct)
gtk_spin_button_set_value(GTK_SPIN_BUTTON(blPct), (gdouble) BLINEPCTDEF);
gtk_widget_show_all(blineOptions);
}
break;
case BLINE_MK_LIST:
{ 
BLINECTRL *blineCtrl;
for(iter = blines, i=0;
iter;
iter = g_slist_next(iter), i++)
{
bline = iter->data;
blineCtrl = calloc(1, sizeof(BLINECTRL)); 
blineCtrl->blineDef = bline;
PSDblineCtrlR = g_slist_append(PSDblineCtrlR, blineCtrl);
}
}
break;
case BLINE_MK_LISTDEL:
{ 
for (iter = PSDblineCtrlR;
iter;
iter = g_slist_next(iter))
{
free(iter->data);
}
g_slist_free(PSDblineCtrlR);
PSDblineCtrlR = NULL;
}
break;
}
}
void raisePdfControls(GtkButton *button, gpointer s)
{ 
int scr = GPOINTER_TO_INT(s);
int screen = (scr)/MAXNUMBERS;
int nb, tab;
if (!pdfCtrlWindow)
{
make_pdfCtrlScreens();
}
setPdfCtrlSettings();
gtk_widget_show(pdfCtrlWindow);
switch (screen)
{
case PDFMAIN:
case PDFDETAIL:
case PDFREQUEST:
case PDFMOVIE:
nb = PDFNB;
tab = screen;
break;
case SPECTROMAIN:
case SPECTRODETREQ:
nb = SPECTRONB;
tab = screen - TTLPDFTABS;
break;
}
gtk_notebook_set_current_page((GtkNotebook *) PSDCTRLnb, nb);
gtk_notebook_set_current_page((GtkNotebook *) PSDCTRLbooks[nb], tab);
return;
}
static void xclPdfControls(GtkButton *button, gpointer t)
{
int  takeon = GPOINTER_TO_INT(t);
if (pdfCtrlWindow)
{ 
gtk_widget_hide(pdfCtrlWindow);
}
if (takeon)
getPdfCtrlSettings();
} 
static gboolean destroyPdfControls(GtkWidget *widget, void *nothing)
{
xclPdfControls(NULL, GINT_TO_POINTER(FALSE));
return TRUE;
}
static gboolean setPdfColour(GtkWidget *widget, gpointer w)
{
int  which = GPOINTER_TO_INT(w);
if (which < TTLPDFSCREENS)
{
gtk_color_button_get_color(GTK_COLOR_BUTTON (widget), &ctrlPdfSettings.drawing.sbC[which]);
ctrlPdfSettings.drawing.sbC[which].pixel = TRUE;
}
else
{
gtk_color_button_get_color(GTK_COLOR_BUTTON (widget), &ctrlPdfSettings.drawing.ctrlBar);
ctrlPdfSettings.drawing.ctrlBar.pixel = TRUE;
}
return TRUE;
}
static GtkWidget *make_controls(int screen)
{
GtkWidget *controlBox, *control_box, *label, *eBox, *hbox, *vbox;
GtkWidget *frame, *box, *controlFrame, *actionB, *button, *hbox1;
GtkWidget *frame1, *colorB, *combo, *entry, *spin;
GtkAdjustment *spinAdj;
static GtkSizeGroup *size_group;
GtkSizeGroup *size_group1;
int   i;
control_box = gtk_event_box_new();
controlFrame = gtk_frame_new(NULL);
controlBox = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(controlBox), 5);
gtk_container_add(GTK_CONTAINER(controlFrame), controlBox);
gtk_container_add(GTK_CONTAINER(control_box), controlFrame);
switch(screen)
{
case PDFMAIN:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">MAIN Screen OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame = gtk_frame_new("PDF System");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 2);
hbox1 = gtk_hbox_new(FALSE, 0);
pdfStart = gtk_check_button_new();
gtk_box_pack_end(GTK_BOX(hbox1), pdfStart, FALSE, FALSE, 2);
label = gtk_label_new("Default Startup System");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(hbox), hbox1, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
strcpy(toolTip, "PDF System is Displayed at Program Startup");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), pdfStart, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 2);
pdfSrvrDefault[SRVRDEFAULT] = combo = gtk_combo_box_new_text();
pdfSignals[PDFSRVRDFAULTSGNL] = 
g_signal_connect(combo, "changed", G_CALLBACK(srvrDefault), GINT_TO_POINTER(SRVRDEFAULT));
label = gtk_label_new("Default PQLX Server");
gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 0, .5);
gtk_widget_set_size_request(combo, 10, -1);
hbox = gtk_hbox_new(FALSE, 2);
pdfSrvrDefault[DBDEFAULT] = combo = gtk_combo_box_new_text();
pdfSignals[PDFDBDFAULTSGNL] = 
g_signal_connect(combo, "changed", G_CALLBACK(srvrDefault), GINT_TO_POINTER(DBDEFAULT));
label = gtk_label_new("Default PQLX Database");
gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 0, .5);
gtk_widget_set_size_request(combo, 10, -1);
frame = gtk_frame_new("PDF Plot Options");
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
hbox = gtk_hbox_new(FALSE, 0);
pdfDateFormat = combo = gtk_combo_box_new_text();
label = gtk_label_new("Date Format");
gtk_widget_set_size_request(combo, 130, -1);
for(i=0; i<TTLPDFDATEFORMATS; i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), dateFormats[i]);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), pdfSettings.common.dateFormat);   
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
fdUnit = combo = gtk_combo_box_new_text();
label = gtk_label_new("X-Axis Units");
gtk_widget_set_size_request(combo, 130, -1);
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), "Period");
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), "Frequency");
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), pdfSettings.common.fdUnits);   
gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
frame = gtk_frame_new("PDF Statistics Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
pdfStats[screen][i] = gtk_check_button_new_with_label(statStr[i]);
gtk_box_pack_start(GTK_BOX(hbox), pdfStats[screen][i], FALSE, FALSE, 4);
}
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
if (pqlxGData.systemBLINEs)
{
blineOptions = frame = gtk_frame_new("Baseline Options");
blineSelectB = vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
makeBLINECtrls(BLINE_MK_CTRL, pqlxGData.systemBLINEs);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Percent: ");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(pdfSettings.spreq.zoom.scrollPct, 5, 95, 1, 1, 0);
blPct = spin = gtk_spin_button_new(spinAdj, 5, 0);
gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin), (gdouble) BLINEPCTDEF);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), spin, FALSE, FALSE, 2);
strcpy(toolTip, "Define % of Baseline Outliers to Select");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), spin, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
}
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Sidebar");
colorB = pdfColors[PDFMAIN] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case PDFDETAIL:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">DETAIL Screen OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("CWB Server");
vbox = gtk_vbox_new(FALSE, 0);
size_group1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
CWBServer = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 16);
gtk_entry_set_max_length(GTK_ENTRY(entry), 15);
label = gtk_label_new("Server IP:");
gtk_size_group_add_widget(size_group1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), CWBServer, FALSE, FALSE, 2);
strcpy(toolTip, "If specified, Read Trace Data from CWB Server, if Local File Does Not Exist\nFormat: Fully Qualified Internet Address (e.g., 129.206.3.1)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
CWBPort = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
label = gtk_label_new("Port Number:");
gtk_size_group_add_widget(size_group1, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), CWBPort, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("PDF Statistics Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
pdfStats[screen][i] = gtk_check_button_new_with_label(statStr[i]);
gtk_box_pack_start(GTK_BOX(hbox), pdfStats[screen][i], FALSE, FALSE, 4);
}
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Sidebar");
colorB = pdfColors[PDFDETAIL] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break; 
case PDFREQUEST:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">REQUEST Screen OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("PDF Statistics Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
pdfStats[screen][i] = gtk_check_button_new_with_label(statStr[i]);
gtk_box_pack_start(GTK_BOX(hbox), pdfStats[screen][i], FALSE, FALSE, 4);
}
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Sidebar");
colorB = pdfColors[PDFREQUEST] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case PDFMOVIE:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">MOVIE Screen OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("PDF Statistics Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
pdfStats[screen][i] = gtk_check_button_new_with_label(statStr[i]);
gtk_box_pack_start(GTK_BOX(hbox), pdfStats[screen][i], FALSE, FALSE, 4);
}
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Sidebar");
colorB = pdfColors[PDFMOVIE] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Controlbar");
colorB = ctrlBar = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Controlbar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(TTLPDFSCREENS));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break; 
case SPECTROMAIN:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">MAIN Screen OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("PDF Statistics Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
pdfStats[screen][i] = gtk_check_button_new_with_label(statStr[i]);
gtk_box_pack_start(GTK_BOX(hbox), pdfStats[screen][i], FALSE, FALSE, 4);
}
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Sidebar");
colorB = pdfColors[screen] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case SPECTRODETREQ:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">REQUEST Screen OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("Zoom/Scrolling Factors");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Zoom: ");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(pdfSettings.spreq.zoom.scrollPct, 5, 30, 1, 1, 0);
spZoomPct = gtk_spin_button_new(spinAdj, 5, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), spZoomPct, FALSE, FALSE, 2);
strcpy(toolTip, "Define % of Zooming, HIGHER = Larger Zoom Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), spZoomPct, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("PDF Statistics Display");
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
for(i=0; i<TTLPDFSTATS; i++)
{
if (!(i%4))
{
hbox = gtk_hbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
}
pdfStats[screen][i] = gtk_check_button_new_with_label(statStr[i]);
gtk_box_pack_start(GTK_BOX(hbox), pdfStats[screen][i], FALSE, FALSE, 4);
}
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Sidebar");
colorB = pdfColors[screen] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setPdfColour), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[screen]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
}
return control_box;
}
static GtkWidget *make_CtrlButtons()
{
GtkWidget *widget, *button, *menu_box;
GtkWidget *actionB;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
actionB = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(widget), actionB, FALSE, FALSE, 0);
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Set Defaults");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(save_PDFdefaults), &ctrlPdfSettings);
sprintf(toolTip, "WRITE PDF System Settings to DEFAULTS File ($HOME/.pql/pdf.dfaults.db), Re-Read on PQLX StartUp");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Restore Defaults");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(restore_PDFdefaults), NULL);
strcpy(toolTip, "RE-READ PDF Settings from DEFAULTS File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Cancel");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclPdfControls), GINT_TO_POINTER(FALSE));
strcpy(toolTip, "DO NOT APPLY Settings Changes");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Bug Reports");
gtk_box_pack_end(GTK_BOX (widget), button, FALSE, FALSE, 0);
g_signal_connect(button, "clicked", G_CALLBACK(bugReport), NULL);
strcpy(toolTip, "Technical Support Information");
gtk_tooltips_set_tip(GTK_TOOLTIPS (tips), button, toolTip, toolTip);
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[PDFMAIN]);
return menu_box;
}
void make_pdfCtrlScreens()
{
int   i, j;
GtkWidget *ctrlBox, *vbox, *nb;
GtkWidget *frame, *container;
if (!pdfCtrlWindow)
{
tips = gtk_tooltips_new();
pdfCtrlWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(pdfCtrlWindow), "PDF System - Controls"); 
gtk_container_set_border_width(GTK_CONTAINER(pdfCtrlWindow), 2);
gtk_window_set_position(GTK_WINDOW(pdfCtrlWindow), GTK_WIN_POS_CENTER);
g_signal_connect(pdfCtrlWindow, "delete-event", G_CALLBACK(destroyPdfControls), NULL);
ctrlBox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(pdfCtrlWindow), ctrlBox);
container = make_CtrlButtons();
gtk_box_pack_start(GTK_BOX(ctrlBox), container, FALSE, FALSE, 0);
vbox = gtk_vbox_new(FALSE, 0);
PSDCTRLnb = nb = gtk_notebook_new();
gtk_box_pack_start(GTK_BOX(vbox), nb, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(ctrlBox), vbox, TRUE, TRUE, 0);
PSDCTRLbooks[PDFNB] = gtk_notebook_new();
gtk_notebook_append_page(GTK_NOTEBOOK(nb), PSDCTRLbooks[PDFNB], gtk_label_new(" PDF "));
for (i = 0; i < TTLPDFTABS; i++)
{ 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(i);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page(GTK_NOTEBOOK(PSDCTRLbooks[PDFNB]), frame, gtk_label_new(pdfNBNames[i]));
}
PSDCTRLbooks[SPECTRONB] = gtk_notebook_new();
gtk_notebook_append_page(GTK_NOTEBOOK(nb), PSDCTRLbooks[SPECTRONB], gtk_label_new(" SPECTRO "));
for (i = TTLPDFTABS, j=0; i < TTLPDFSCREENS; i++, j++)
{ 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(i);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page(GTK_NOTEBOOK(PSDCTRLbooks[SPECTRONB]), frame, gtk_label_new(spectroNBNames[j]));
}
gtk_window_set_transient_for((GtkWindow *) pdfCtrlWindow, (GtkWindow *) topWindow); 
gtk_widget_show_all(pdfCtrlWindow);
}
return;
}
