#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
enum {
SETINIT,
SETREINIT
};
enum {
NSLCOMBO,
CHNGCOMBO,
CHNCOMBO,
PDFCOMBO
};
static gboolean setRow(GNode *node, gpointer t)
{
int    type = GPOINTER_TO_INT(t);
NSLCDATA  *nodeD=node->data;
char   nodeInfo[50], nodeID[50]; 
static char  ntwNm[12], stnNm[12], locNm[12],
ntwID[13], stnID[13], locID[13];
switch(type)
{
case NSLCOMBO:
switch(g_node_depth(node))
{
case NTW+1:
strcpy(ntwNm, nodeD->name);
sprintf(ntwID, "%d", nodeD->id);
gtk_tree_store_append(storeNSL, &nslNI, NULL);
gtk_tree_store_set(storeNSL, &nslNI, 0, ntwNm, 1, ntwID, -1);
break;
case STN+1:
strcpy(stnNm, nodeD->name);
sprintf(stnID, "%d", nodeD->id);
gtk_tree_store_append(storeNSL, &nslSI, &nslNI);
gtk_tree_store_set(storeNSL, &nslSI, 0, stnNm, 1, stnID, -1);
break;
case LOC+1:
strcpy(locNm, nodeD->name);
sprintf(locID, "%d", nodeD->id);
sprintf(nodeInfo, "%s.%s.%s", ntwNm, stnNm, locNm);
sprintf(nodeID, "%s.%s.%s", ntwID, stnID, locID);
gtk_tree_store_append(storeNSL, &nslLI, &nslSI);
gtk_tree_store_set(storeNSL, &nslLI, 0, nodeInfo, 1, nodeID, -1); 
break;
}
break;
case CHNCOMBO:
switch(g_node_depth(node))
{
case NTW+1:
gtk_tree_store_append(storeCHN, &nslcNI, NULL);
gtk_tree_store_set(storeCHN, &nslcNI, 0, nodeD->name, 1, 0, -1);
strcpy(ntwNm, nodeD->name);
break;
case STN+1:
gtk_tree_store_append(storeCHN, &nslcSI, &nslcNI);
gtk_tree_store_set(storeCHN, &nslcSI, 0, nodeD->name, 1, 0, -1);
strcpy(stnNm, nodeD->name);
break;
case LOC+1:
gtk_tree_store_append(storeCHN, &nslcLI, &nslcSI);
gtk_tree_store_set(storeCHN, &nslcLI, 0, nodeD->name, 1, 0, -1); 
strcpy(locNm, nodeD->name);
break;
case CHN+1:
sprintf(nodeInfo, "%s", nodeD->fullname);
gtk_tree_store_append(storeCHN, &nslcCI, &nslcLI);
gtk_tree_store_set(storeCHN, &nslcCI, 0, nodeInfo, 1, nodeD->id, -1);
break;
}
break;
}
return FALSE;
}
static void setCombos()
{
int  i, setType=SETINIT;
GSList *iter;
GtkCellRenderer *renderer;
renderer = gtk_cell_renderer_text_new();
g_object_set(renderer, "scale", 0.8, "scale-set", TRUE, NULL);
if (storeNSL)
{
gtk_tree_store_clear(storeNSL);
setType=SETREINIT;
}
else
{
storeNSL = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
}
for(iter = ntwPDF;iter!=NULL;iter=g_slist_next(iter))
{
g_node_traverse(iter->data, G_PRE_ORDER, G_TRAVERSE_ALL, -1, 
(GNodeTraverseFunc) setRow, GINT_TO_POINTER(NSLCOMBO));
}
gtk_tree_store_append(storeNSL, &nslNI, NULL);
gtk_tree_store_set(storeNSL, &nslNI, 0, "NONE", 1, "0.0.0", -1);
gtk_combo_box_set_model(GTK_COMBO_BOX(md1NSL), GTK_TREE_MODEL(storeNSL));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md1NSL), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md1NSL), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(md2NSL1), GTK_TREE_MODEL(storeNSL));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md2NSL1), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md2NSL1), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(md2NSL2), GTK_TREE_MODEL(storeNSL));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md2NSL2), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md2NSL2), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(md2NSL3), GTK_TREE_MODEL(storeNSL));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md2NSL3), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md2NSL3), renderer, "text", 0, NULL);
}
if (storeCHN)
{
gtk_tree_store_clear(storeCHN);
}
else
{
storeCHN = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_INT);
}
for(iter = ntwPDF;iter!=NULL;iter=g_slist_next(iter))
{
g_node_traverse(iter->data, G_PRE_ORDER, G_TRAVERSE_ALL, -1, (GNodeTraverseFunc) setRow, GINT_TO_POINTER(CHNCOMBO));
}
gtk_tree_store_append(storeCHN, &nslcNI, NULL);
gtk_tree_store_set(storeCHN, &nslcNI, 0, "NONE", 1, 0, -1);
gtk_combo_box_set_model(GTK_COMBO_BOX(md3CHN1), GTK_TREE_MODEL(storeCHN));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md3CHN1), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md3CHN1), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(md3CHN2), GTK_TREE_MODEL(storeCHN));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md3CHN2), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md3CHN2), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(md3CHN3), GTK_TREE_MODEL(storeCHN));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md3CHN3), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md3CHN3), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(rdCHN), GTK_TREE_MODEL(storeCHN));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(rdCHN), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(rdCHN), renderer, "text", 0, NULL);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(rdCHNmv), GTK_TREE_MODEL(storeCHN));
if (setType == SETINIT)
{
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(rdCHNmv), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(rdCHNmv), renderer, "text", 0, NULL);
}
if (setType == SETINIT)
{
if (storePDF)
{
gtk_tree_store_clear(storePDF);
}
else
{
storePDF = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
}
gtk_tree_store_append(storePDF, &pdf1I, NULL);
gtk_tree_store_set(storePDF, &pdf1I, 0, "SYSTEM", 1, 0, -1);
for (iter = pqlxGData.systemPDFs, i=1; iter; iter = g_slist_next(iter), i++)
{ 
SYSPDFDEF *sysPDFdef = iter->data;
char  *value = g_strdup_printf("%d:%d", PDFTYPE_SYSTEM, i);
gtk_tree_store_append(storePDF, &pdf2I, &pdf1I);
gtk_tree_store_set(storePDF, &pdf2I, 0, sysPDFdef->pdfName, 1, value, -1);
free(value);
}
if (pqlxGData.systemBLINEs)
{
gtk_tree_store_append(storePDF, &pdf1I, NULL);
gtk_tree_store_set(storePDF, &pdf1I, 0, "Base-Lines", 1, 0, -1);
for (iter = pqlxGData.systemPDFs, i=1; iter; iter = g_slist_next(iter), i++)
{ 
SYSPDFDEF *sysPDFdef = iter->data;
char  *value = g_strdup_printf("%d:%d", PDFTYPE_BASELINE, i);
gtk_tree_store_append(storePDF, &pdf2I, &pdf1I);
gtk_tree_store_set(storePDF, &pdf2I, 0, sysPDFdef->pdfName, 1, value, -1);
free(value);
}
gtk_tree_store_append(storePDF, &pdf1I, NULL);
gtk_tree_store_set(storePDF, &pdf1I, 0, "NONE", 1, 0, -1);
}
gtk_combo_box_set_model(GTK_COMBO_BOX(md1PDF1), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md1PDF1), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md1PDF1), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md1PDF1), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md1PDF2), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md1PDF2), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md1PDF2), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md1PDF2), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md1PDF3), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md1PDF3), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md1PDF3), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md1PDF3), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md2PDF), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md2PDF), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md2PDF), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md2PDF), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md3PDF1), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md3PDF1), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md3PDF1), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md3PDF1), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md3PDF2), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md3PDF2), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md3PDF2), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md3PDF2), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md3PDF3), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md3PDF3), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md3PDF3), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md3PDF3), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(md4PDF), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(md4PDF), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(md4PDF), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(md4PDF), renderer, "text", 0, NULL);
gtk_combo_box_set_model(GTK_COMBO_BOX(SPpdf), GTK_TREE_MODEL(storePDF));
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(SPpdf), &pdf1I);
gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(SPpdf), renderer, TRUE);
gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(SPpdf), renderer, "text", 0, NULL);
}
return;
}
void initPDFsystem()
{
int  mDisp = pdfSettings.main.display;  
int  screen = pdfStates.screen, sys = pdfStates.system; 
freeDetail(ALLCELLS);
free(pdfStates.detail.pdfReq[SW]);  pdfStates.detail.pdfReq[SW] = NULL;
clearAllReqs(NULL, GINT_TO_POINTER(PDFMAIN));   
clearAllReqs(NULL, GINT_TO_POINTER(PDFREQUEST));  
clearAllReqs(NULL, GINT_TO_POINTER(PDFMOVIE));   
clearAllReqs(NULL, GINT_TO_POINTER(SPECTROMAIN));  
clearAllReqs(NULL, GINT_TO_POINTER(SPECTRODETREQ));  
memset(&pdfStates.main, 0, sizeof(pdfStates.main));
memset(&pdfStates.detail, 0, sizeof(pdfStates.detail));
clearAllReqs(NULL, GINT_TO_POINTER(PDFREQUEST));   
clearAllReqs(NULL, GINT_TO_POINTER(SPECTROMAIN));   
clearAllReqs(NULL, GINT_TO_POINTER(SPECTRODETREQ));   
clearAllReqs(NULL, GINT_TO_POINTER(PDFMOVIE));    
memset(&pdfStates.spmain, 0, sizeof(pdfStates.spmain));
memset(&pdfStates.spdetreq, 0, sizeof(pdfStates.spdetreq));
pdfSettings.main.display = mDisp;
pdfStates.system = sys;
pdfStates.screen = screen;
pdfStates.detail.idleCnt = NONE;
manage_PDF_signals(BLOCKSIGS);
setCombos();  
manage_PDF_signals(SETCOMBOS);
manage_PDF_signals(UNBLOCKSIGS);
makeBLINECtrls(BLINE_MK_CTRL, pqlxGData.systemBLINEs);
{ 
char *markup;
markup = g_markup_printf_escaped("<span weight=\"bold\" foreground=\"white\">%d - %d / %d</span>", 
0, 0, 0);
gtk_label_set_markup(GTK_LABEL(chnCntLbl), markup);
gtk_label_set_markup(GTK_LABEL(SPchnCnt), markup);
g_free(markup);
}
int j,k;
for(j=0;j<DMAXPDFROWS;j++)
for(k=0;k<DMAXPDFCOLS;k++)
gtk_widget_queue_resize(DPDFDA[j][k]);
for(j=0;j<RMAXPDFROWS;j++)
for(k=0;k<RMAXPDFCOLS;k++)
gtk_widget_queue_resize(RPDFDA[j][k]);
for(j=0;j<SMAXROWS;j++)
for(k=0;k<SMAXCOLS;k++)
gtk_widget_queue_resize(SPMAINDA[j][k]);
for(j=0;j<SMAXROWS;j++)
for(k=0;k<SMAXCOLS;k++)
gtk_widget_queue_resize(SPREQDA[j][k]);
for(j=0;j<TTLMOVIESCREENS;j++)
gtk_widget_queue_resize(MVPDFDA[j]);
for(j=0;j<MMAXPDFROWS;j++)
for(k=0;k<MMAXPDFCOLS;k++)
makeDrawing(PDFMAIN, j, k);
}
void pdfReqCopy(PDFREQ **dest, PDFREQ *pdfReq)
{
PDFREQ *copyTo;
copyTo = calloc(1, sizeof(PDFREQ));
memcpy(copyTo, pdfReq, sizeof(PDFREQ));
(copyTo)->keys.sysPDFB[STARTDT] = g_strdup(pdfReq->keys.sysPDFB[STARTDT]);
(copyTo)->keys.sysPDFB[ENDDT] = g_strdup(pdfReq->keys.sysPDFB[ENDDT]);
(copyTo)->data.name = g_strdup(pdfReq->data.name);
(copyTo)->data.pdf = calloc(pdfReq->data.numRecs, sizeof(PDFDATA));
memcpy((copyTo)->data.pdf, pdfReq->data.pdf, pdfReq->data.numRecs*sizeof(PDFDATA));
if (pdfReq->data.hits)
{
(copyTo)->data.hits = calloc(1, sizeof(PDFHITS));
memcpy((copyTo)->data.hits, pdfReq->data.hits, sizeof(PDFHITS));
(copyTo)->data.hits->hits = calloc(pdfReq->data.numRecs, sizeof(PDFHITSDATA));
memcpy((copyTo)->data.hits->hits, pdfReq->data.hits->hits, 
pdfReq->data.numRecs*sizeof(PDFHITSDATA));
}
if (pdfReq->data.stats)
{
(copyTo)->data.stats = calloc(1, sizeof(PDFSTATS));
memcpy((copyTo)->data.stats, pdfReq->data.stats, sizeof(PDFSTATS));
(copyTo)->data.stats->stats = calloc(pdfReq->data.stats->ttlPeriods, sizeof(PDFSTATS1));
memcpy((copyTo)->data.stats->stats, pdfReq->data.stats->stats, pdfReq->data.stats->ttlPeriods*sizeof(PDFSTATS1));
}
(copyTo)->data.statLines = NULL;
*dest = copyTo;
}
static gboolean freePDFreturn(SQLDI *sqldi)
{
free(sqldi);
return FALSE;
}
void freePDF(PDFREQ *pdfReq, gboolean tmpTbl)
{
int  i;
GSList *listI;
if (!pdfReq)
return;
if (pdfReq->data.pdf)
{ 
free(pdfReq->data.pdf);
IFFREE(pdfReq->data.pdfM);
for (i = 0;
i < TTLDATES;
i++)
{
if (pdfReq->keys.sysPDFB[i])
free(pdfReq->keys.sysPDFB[i]);
}
IFFREE(pdfReq->data.name);
IFFREE(pdfReq->data.pdfName);
if (pdfReq->data.hits)
{
free(pdfReq->data.hits->hits);
free(pdfReq->data.hits);
}
if (pdfReq->data.stats)
{
free(pdfReq->data.stats->stats);
free(pdfReq->data.stats);
}
for(listI = pdfReq->data.statLines; listI; listI=g_slist_next(listI))
{
PDFSTATSL *line = listI->data;
free(line->line);
free(line);
}
g_slist_free(pdfReq->data.statLines);
if (tmpTbl)
{ 
SQLDI *sqldi;
sqldi = calloc(1, sizeof(SQLDI));
sqldi->descr.tableData = PSDTBLDEL;
sqldi->data2 = GINT_TO_POINTER(pdfReq->reqID);
sqldi->args.callType = ASYNC;
sqldi->args.returnFunc = freePDFreturn;
sqldi->args.dataEvent = GET_DATA;
db_request(sqldi);
}
}
memset(pdfReq, 0, sizeof(PDFREQ));
}
void specReqCopy(SPECREQ **dest, SPECREQ *specReqSrc)
{
int  i;
GSList *iter2;
GList *iter1;
SPECTRODATA *spectroDataSrc, *spectroDataDest;
SPECREQ  *specReqDest = *dest;
PSDDATA  *psdDataSrc, *psdDataDest;
memcpy(specReqDest, specReqSrc, sizeof(SPECREQ));
specReqDest->data.spectro = NULL;
memset(&specReqDest->plot, 0, sizeof(specReqDest->plot));
specReqDest->data.pdfName = g_strdup(specReqSrc->data.pdfName);
specReqDest->data.name = g_strdup(specReqSrc->data.name);
for (i = 0; i< TTLDATES; i++)
{
specReqDest->keys.sysPDFB[i] = g_strdup(specReqSrc->keys.sysPDFB[i]);
specReqDest->data.dateBounds[i] = g_date_copy(specReqSrc->data.dateBounds[i]);
specReqDest->plot.dateBounds[i] = g_date_copy(specReqSrc->data.dateBounds[i]);
}
for(iter1 = g_list_last(specReqSrc->data.spectro);
iter1;
iter1 = g_list_previous(iter1))
{
spectroDataSrc = iter1->data;
spectroDataDest = calloc(1, sizeof(SPECTRODATA));
spectroDataDest->psdRef = spectroDataSrc->psdRef;
specReqDest->data.spectro = g_list_prepend(specReqDest->data.spectro, spectroDataDest);
for (iter2 = spectroDataSrc->psdData;
iter2;
iter2 = g_slist_next(iter2))
{
psdDataSrc = iter2->data;
psdDataDest = calloc(1, sizeof(PSDDATA));
psdDataDest->period = psdDataSrc->period;
psdDataDest->power = psdDataSrc->power;
spectroDataDest->psdData = g_slist_prepend(spectroDataDest->psdData, psdDataDest);
}
spectroDataDest->psdData = g_slist_reverse(spectroDataDest->psdData);
}
specReqDest->plot.start = specReqDest->data.spectro;
specReqDest->plot.end = g_list_last(specReqDest->data.spectro);
specReqDest->plot.numDivs = specReqDest->data.numDivs;
specReqDest->plot.dBRange = DBRELATIVE;
specReqDest->plot.replot = TRUE;
specReqDest->plot.numPSDs = 0;
}
void freeSpectro(SPECREQ *specReq)
{
int  i;
GSList *iter2;
GList *iter1;
if (!specReq)
return;
IFFREE(specReq->data.pdfName);
IFFREE(specReq->data.name);
for (i = 0; i< TTLDATES; i++)
{
IFFREE(specReq->keys.sysPDFB[i]);
IFFREEGDATE(specReq->data.dateBounds[i]);
IFFREEGDATE(specReq->plot.dateBounds[i]);
}
for(iter1 = specReq->data.spectro;
iter1;
iter1 = g_list_next(iter1))
{
SPECTRODATA *spectroData = iter1->data;
for (iter2 = spectroData->psdData;
iter2;
iter2 = g_slist_next(iter2))
{
g_free(iter2->data);
}
g_slist_free(spectroData->psdData);
g_free(spectroData);
}
g_list_free(specReq->data.spectro);
IFFREE(specReq->plot.dataMap);
IFFREEHT(specReq->plot.gaps);
memset(specReq, 0, sizeof(SPECREQ));
}
void freeTrc(void *data, gpointer w)
{
int  which = GPOINTER_TO_INT(w);
switch (which)
{
case DBTRCLIST:
{
TRCLST *trc=data;
free(trc->trcName);
free(trc);
trc = NULL;
}
break;
case PQLTRCLIST:
{
traceInfo *trc=data;
freeMyData(TRCINFO, trc);
}
break;
}
}
static void freeDetailCell(int which)
{
int  row, col, i;
switch(which)
{
case NE: 
if (pdfStates.detail.pdfReq[NE])
{
freePDF(pdfStates.detail.pdfReq[NE], FALSE);
free(pdfStates.detail.pdfReq[NE]);
pdfStates.detail.pdfReq[NE] = NULL;
}
if (pdfStates.detail.psdTrc.data.numRecs)
{
g_slist_foreach(pdfStates.detail.psdTrc.data.trcList, (GFunc) freeTrc, GINT_TO_POINTER(DBTRCLIST));
g_slist_free(pdfStates.detail.psdTrc.data.trcList);
pdfStates.detail.psdTrc.data.trcList = NULL;
g_slist_foreach(pdfStates.detail.trcList, (GFunc) freeTrc, GINT_TO_POINTER(PQLTRCLIST));
g_slist_free(pdfStates.detail.trcList);
pdfStates.detail.trcList = NULL;
memset(&pdfStates.detail.psdTrc, 0, sizeof(PSDTRCD));
}
break;
case NW: 
if (pdfStates.detail.pdfReq[NW])
{
freePDF(pdfStates.detail.pdfReq[NW], FALSE);
free(pdfStates.detail.pdfReq[NW]);
pdfStates.detail.pdfReq[NW] = NULL;
}
for (row=0;row<DMAXPDFROWS;row++)
for (col=0;col<DMAXPDFCOLS;col++)
{ 
if (pdfStates.pmap.detail[row][col]) 
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
pdfStates.detail.subPDF[0][0] = 
pdfStates.detail.subPDF[0][1] = 
pdfStates.detail.subPDF[1][0] = 
pdfStates.detail.subPDF[1][1] = FALSE;
break;
case SW: 
if (pdfStates.detail.pdfReq[SW])
{
freePDF(pdfStates.detail.pdfReq[SW], FALSE);
}
else
{
pdfStates.detail.pdfReq[SW] = calloc(1, sizeof(PDFREQ));
}
for (row=0;row<DMAXPDFROWS;row++)
for (col=0;col<DMAXPDFCOLS;col++)
{ 
if (row || col)
{
if (pdfStates.pmap.detail[row][col]) 
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
}
break;
case SE: 
if (pdfStates.detail.pdfReq[SE])
{
freePDF(pdfStates.detail.pdfReq[SE], FALSE);
free(pdfStates.detail.pdfReq[SE]);
pdfStates.detail.pdfReq[SE] = NULL;
}
if (pdfStates.detail.psdHr.data.numRecs)
{
for(i=0;i<pdfStates.detail.psdHr.data.numRecs;i++)
free(pdfStates.detail.psdHr.data.hrList[i]);
free(pdfStates.detail.psdHr.data.hrList);
memset(&pdfStates.detail.psdHr, 0, sizeof(PSDTRCD));
}
break;
}
}
void freeDetail(int which)
{
int  i;
switch(which)
{
case NW:
freeDetailCell(NW);
break;
case SW:
freeDetailCell(SW);
freeDetailCell(NE);
freeDetailCell(SE);
break;
case ALLCELLS:
for(i=0;i<ALLCELLS;i++)
freeDetailCell(i);
pdfStates.detail.subPDF[0][0] = FALSE;
#if 0
for(iter=pdfStates.detail.dispList;iter;iter=g_list_next(iter))
{ 
freePDF(iter->data, FALSE);
free(iter->data);
}
g_list_free(pdfStates.detail.dispList);
pdfStates.detail.dispList = pdfStates.detail.disp = NULL;
#endif
break;
}
freePDF(&pdfStates.detail.subReq, FALSE);
pdfStates.detail.subPDF[1][0] = 
pdfStates.detail.subPDF[0][1] = 
pdfStates.detail.subPDF[1][1] = FALSE;
}
void get_chnName(int tab, gpointer req)
{
GtkTreeIter iter;
GValue value = {0, };
switch(tab)
{
case PDFREQUEST:
{
PDFREQ *pdfReq = (PDFREQ *) req;   
gtk_combo_box_get_active_iter(GTK_COMBO_BOX(rdCHN), &iter);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 1, &value);
pdfReq->keys.chnKey = g_value_get_int(&value);
g_value_unset(&value);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 0, &value);
pdfReq->data.name = g_strdup(g_value_get_string(&value));
g_value_unset(&value);
}
break;
case PDFMOVIE:
{
PDFREQ *pdfReq = (PDFREQ *) req;   
gtk_combo_box_get_active_iter(GTK_COMBO_BOX(rdCHNmv), &iter);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 1, &value);
pdfReq->keys.chnKey = g_value_get_int(&value);
g_value_unset(&value);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 0, &value);
pdfReq->data.name = g_strdup(g_value_get_string(&value));
g_value_unset(&value);
}
break;
case SPECTRODETREQ:
{
SPECREQ *specReq = (SPECREQ *) req;   
gtk_combo_box_get_active_iter(GTK_COMBO_BOX(rdCHN), &iter);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 1, &value);
specReq->keys.chnKey = g_value_get_int(&value);
g_value_unset(&value);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 0, &value);
specReq->data.name = g_strdup(g_value_get_string(&value));
g_value_unset(&value);
}
break;
}
}
gboolean get_reqEntries(int screen, gpointer req)
{
gboolean valid = TRUE;
float *criteria;
switch (screen)
{
case PDFREQUEST:
{
PDFREQ *pdfReq = (PDFREQ *) req;
int  reqType = pdfStates.request.req.reqType;
memset(pdfReq, 0, sizeof(PDFREQ));
get_chnName(PDFREQUEST, (gpointer) pdfReq);
pdfReq->keys.reqType = reqType;
memcpy(&pdfReq->keys.statistics, &pdfSettings.common.statistics[PDFREQUEST], 
sizeof(pdfSettings.common.statistics[PDFREQUEST]));
criteria = &pdfReq->keys.criteria[0];
sscanf(gtk_entry_get_text(GTK_ENTRY(rYR[0])), "%f", &criteria[PDFREQ_YRSTART]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rYR[1])), "%f", &criteria[PDFREQ_YREND]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[0][0])), "%f", &criteria[PDFREQ_DYSTARTM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[0][1])), "%f", &criteria[PDFREQ_DYSTARTD]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[1][0])), "%f", &criteria[PDFREQ_DYENDM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[1][1])), "%f", &criteria[PDFREQ_DYENDD]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[0][0])), "%f", &criteria[PDFREQ_HRSTARTH]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[0][1])), "%f", &criteria[PDFREQ_HRSTARTM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[1][0])), "%f", &criteria[PDFREQ_HRENDH]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[1][1])), "%f", &criteria[PDFREQ_HRENDM]);
switch (reqType)
{
case REQAGO: 
sscanf(gtk_entry_get_text(GTK_ENTRY(rDYA[0])), "%f", &criteria[PDFREQ_DYSTARTD]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDYA[1])), "%f", &criteria[PDFREQ_DYENDD]);
if (criteria[PDFREQ_DYSTARTD] < criteria[PDFREQ_DYENDD])
{
error_dialog("PDF - AGO Request",
"\n\tRequest invalid, Start Days AGO must be > End Days AGO\n\n\tPlease re-input...\n");
valid = FALSE;
}
break;
case REQFREQ:
sscanf(gtk_entry_get_text(GTK_ENTRY(rFREQ[0])), "%f", &criteria[PDFREQ_FREQED]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rFREQ[1])), "%f", &criteria[PDFREQ_FREQFD]);
break;
}
}
break;
case SPECTRODETREQ:
{
SPECREQ *specReq = (SPECREQ *) req;
memset(specReq, 0, sizeof(SPECREQ));
get_chnName(SPECTRODETREQ, (gpointer) specReq);
criteria = &specReq->keys.criteria[0];
sscanf(gtk_entry_get_text(GTK_ENTRY(rYR[0])), "%f", &criteria[PDFREQ_YRSTART]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rYR[1])), "%f", &criteria[PDFREQ_YREND]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[0][0])), "%f", &criteria[PDFREQ_DYSTARTM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[0][1])), "%f", &criteria[PDFREQ_DYSTARTD]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[1][0])), "%f", &criteria[PDFREQ_DYENDM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rDY[1][1])), "%f", &criteria[PDFREQ_DYENDD]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[0][0])), "%f", &criteria[PDFREQ_HRSTARTH]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[0][1])), "%f", &criteria[PDFREQ_HRSTARTM]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[1][0])), "%f", &criteria[PDFREQ_HRENDH]);
sscanf(gtk_entry_get_text(GTK_ENTRY(rHR[1][1])), "%f", &criteria[PDFREQ_HRENDM]);
}
break;
}
return(valid);
}
GNode *fndChn;
gboolean findChn(GNode *node, int *id)
{ 
NSLCDATA *nodeD=node->data;
if (nodeD->id == *id)
{
fndChn = node;
return TRUE;
}
return FALSE;
}
void clearReqEntries(GtkButton *button, void *nothing)
{
gtk_entry_set_text(GTK_ENTRY(rYR[0]), "");
gtk_entry_set_text(GTK_ENTRY(rYR[1]), "");
gtk_entry_set_text(GTK_ENTRY(rDY[0][0]), "");
gtk_entry_set_text(GTK_ENTRY(rDY[0][1]), "");
gtk_entry_set_text(GTK_ENTRY(rDY[1][0]), "");
gtk_entry_set_text(GTK_ENTRY(rDY[1][1]), "");
gtk_entry_set_text(GTK_ENTRY(rHR[0][0]), "");
gtk_entry_set_text(GTK_ENTRY(rHR[0][1]), "");
gtk_entry_set_text(GTK_ENTRY(rHR[1][0]), "");
gtk_entry_set_text(GTK_ENTRY(rHR[1][1]), "");
gtk_entry_set_text(GTK_ENTRY(rDYA[0]), "");
gtk_entry_set_text(GTK_ENTRY(rDYA[1]), "");
gtk_entry_set_text(GTK_ENTRY(rFREQ[0]), "");
gtk_entry_set_text(GTK_ENTRY(rFREQ[1]), "");
}
void set_reqEntries(int screen, gpointer req)
{
int   i;
char  *reqStr[TTLDTTMPDFREQ];
float *criteria;
memset(reqStr, 0, sizeof(char *) * TTLDTTMPDFREQ);
clearReqEntries(NULL, NULL);
switch (screen)
{
case PDFREQUEST:
{
PDFREQ *pdfReq = (PDFREQ *) req;
criteria = &pdfReq->keys.criteria[0];
}
break;
case SPECTRODETREQ:
{
SPECREQ *specReq = (SPECREQ *) req;
criteria = &specReq->keys.criteria[0];
}
break;
}
for(i=0; i<TTLDTTMPDFREQ; i++)
{
switch(i)
{
case PDFREQ_DYSTARTM:
case PDFREQ_DYENDM:
if (criteria[i])
{ 
reqStr[i] = g_strdup_printf("%02d", (int) criteria[i]);
i++;
reqStr[i] = g_strdup_printf("%02d", (int) criteria[i]);
}
else 
{
reqStr[i] = g_strdup("");
i++;
if (criteria[i])
{ 
reqStr[i] = g_strdup_printf("%02d", (int) criteria[i]);
}
else
reqStr[i] = g_strdup("");
}
break;
case PDFREQ_HRSTARTH:
case PDFREQ_HRENDH:
case PDFREQ_HRSTARTM:
case PDFREQ_HRENDM:
if ((int) criteria[i])
{
reqStr[i] = g_strdup_printf("%02d", (int) criteria[i]);
}
else
{ 
if (((i==PDFREQ_HRENDM) && (int) criteria[PDFREQ_HRENDH]) ||
((i==PDFREQ_HRENDH) && (int) criteria[PDFREQ_HRENDM]) ||
((i==PDFREQ_HRSTARTM) && (int) criteria[PDFREQ_HRSTARTH]) ||
((i==PDFREQ_HRSTARTH) && (int) criteria[PDFREQ_HRSTARTM]))
{
reqStr[i] = g_strdup_printf("%02d", (int) criteria[i]);
}
else
reqStr[i] = g_strdup("");
}
break;
case PDFREQ_YRSTART:
case PDFREQ_YREND:
if ((int) criteria[i])
{
reqStr[i] = g_strdup_printf("%04d", (int) criteria[i]);
}
else
{
reqStr[i] = g_strdup("");
}
break;
default:
if ((int) criteria[i])
{
reqStr[i] = g_strdup_printf("%d", (int) criteria[i]);
}
else
{
reqStr[i] = g_strdup("");
}
break;
}
}
gtk_entry_set_text(GTK_ENTRY(rYR[0]), reqStr[PDFREQ_YRSTART]);
gtk_entry_set_text(GTK_ENTRY(rYR[1]), reqStr[PDFREQ_YREND]);
switch (pdfStates.request.req.reqType)
{
case REQAGO:
gtk_entry_set_text(GTK_ENTRY(rDYA[0]), reqStr[PDFREQ_DYSTARTD]);
gtk_entry_set_text(GTK_ENTRY(rDYA[1]), reqStr[PDFREQ_DYENDD]);
break;
default:
gtk_entry_set_text(GTK_ENTRY(rDY[0][0]), reqStr[PDFREQ_DYSTARTM]);
gtk_entry_set_text(GTK_ENTRY(rDY[0][1]), reqStr[PDFREQ_DYSTARTD]);
gtk_entry_set_text(GTK_ENTRY(rDY[1][0]), reqStr[PDFREQ_DYENDM]);
gtk_entry_set_text(GTK_ENTRY(rDY[1][1]), reqStr[PDFREQ_DYENDD]);
break;
}
gtk_entry_set_text(GTK_ENTRY(rHR[PDFREQSTART][0]), reqStr[PDFREQ_HRSTARTH]);
gtk_entry_set_text(GTK_ENTRY(rHR[PDFREQSTART][1]), reqStr[PDFREQ_HRSTARTM]);
gtk_entry_set_text(GTK_ENTRY(rHR[PDFREQEND][0]), reqStr[PDFREQ_HRENDH]);
gtk_entry_set_text(GTK_ENTRY(rHR[PDFREQEND][1]), reqStr[PDFREQ_HRENDM]);
gtk_entry_set_text(GTK_ENTRY(rFREQ[0]), reqStr[PDFREQ_FREQED]);
gtk_entry_set_text(GTK_ENTRY(rFREQ[1]), reqStr[PDFREQ_FREQFD]);
for (i = 0; i < TTLDTTMPDFREQ ; i++)
{
IFFREE(reqStr[i]);
}
}
#define WIDGET_SIGNALS 20
#define NB_SIGNALS 3
void manage_PDF_signals(int cmd)
{
int row, col, i;
static struct
{
int  type, screen;
gulong signal;
GtkTreeIter *iter;
GtkWidget *widg;
} widgets[WIDGET_SIGNALS];
static struct
{
int  type, screen;
gulong signal;
GtkTreeIter *iter;
GtkWidget *widg;
} notebooks[NB_SIGNALS];
switch(cmd)
{ 
case CONNECTSIGS:     
memset(widgets, 0, sizeof(widgets));
widgets[0].widg = rdCHNmv; widgets[0].type = CBONSLC; widgets[0].iter = &nslcNI; widgets[0].screen = PDFMOVIE;
widgets[1].widg = md1NSL; widgets[1].type = CBONSL; widgets[1].iter = &nslNI; widgets[1].screen = PDFMAIN;
widgets[2].widg = md1CHNG; widgets[2].type = CBOCHNG; 
widgets[3].widg = md1PDF1; widgets[3].type = CBOPDF; widgets[3].iter = &pdf1I;
widgets[4].widg = md1PDF2; widgets[4].type = CBOPDF; widgets[4].iter = &pdf1I;
widgets[5].widg = md1PDF3; widgets[5].type = CBOPDF; widgets[5].iter = &pdf1I;
widgets[6].widg = md2PDF; widgets[6].type = CBOPDF; widgets[6].iter = &pdf1I;
widgets[7].widg = md2NSL1; widgets[7].type = CBONSL; widgets[7].iter = &nslNI; widgets[7].screen = PDFMAIN;
widgets[8].widg = md2NSL2; widgets[8].type = CBONSL; widgets[8].iter = &nslNI; widgets[8].screen = PDFMAIN;
widgets[9].widg = md2NSL3; widgets[9].type = CBONSL; widgets[9].iter = &nslNI; widgets[9].screen = PDFMAIN;
widgets[10].widg = md2CHNG; widgets[10].type = CBOCHNG;
widgets[11].widg = md3CHN1; widgets[11].type = CBONSLC; widgets[11].iter = &nslcNI; widgets[11].screen = PDFMAIN;
widgets[12].widg = md3CHN2; widgets[12].type = CBONSLC; widgets[12].iter = &nslcNI; widgets[12].screen = PDFMAIN;
widgets[13].widg = md3CHN3; widgets[13].type = CBONSLC; widgets[13].iter = &nslcNI; widgets[13].screen = PDFMAIN;
widgets[14].widg = md3PDF1; widgets[14].type = CBOPDF; widgets[14].iter = &pdf1I;
widgets[15].widg = md3PDF2; widgets[15].type = CBOPDF; widgets[15].iter = &pdf1I;
widgets[16].widg = md3PDF3; widgets[16].type = CBOPDF; widgets[16].iter = &pdf1I;
widgets[17].widg = SPpdf; widgets[17].type = CBOPDF; widgets[17].iter = &pdf1I;
widgets[18].widg = rdCHN; widgets[18].type = CBONSLC; widgets[18].iter = &nslcNI; widgets[18].screen = PDFREQUEST;
widgets[19].widg = md4PDF; widgets[19].type = CBOPDF; widgets[19].iter = &pdf1I;
memset(notebooks, 0, sizeof(notebooks));
notebooks[0].widg = PSDbooks[PDFNB]; notebooks[0].type = 0;
notebooks[0].signal = g_signal_connect(notebooks[0].widg, "switch-page", G_CALLBACK(changeTabPDF), GINT_TO_POINTER(PDFNB));
notebooks[1].widg = PSDbooks[SPECTRONB]; notebooks[1].type = 0;
notebooks[1].signal = g_signal_connect(notebooks[1].widg, "switch-page", G_CALLBACK(changeTabPDF), GINT_TO_POINTER(SPECTRONB));
notebooks[2].widg = PSDnb; notebooks[2].type = 0;
notebooks[2].signal = g_signal_connect(notebooks[2].widg, "switch-page", G_CALLBACK(changeTabPDF), GINT_TO_POINTER(TTLPSDNB));
for(i=0; i<WIDGET_SIGNALS; i++)
{
if (widgets[i].widg)
widgets[i].signal = g_signal_connect(widgets[i].widg, "changed", G_CALLBACK(cboSelect), GINT_TO_POINTER(widgets[i].type));
}
for (row=0;row<DMAXPDFROWS;row++)
{
pdfStates.detail.pdfReq[NW] = pdfStates.detail.pdfReq[SW] = NULL;
for (col=0;col<DMAXPDFCOLS;col++)
{
pdfStates.detail.pdfReq[row*DMAXPDFCOLS + col] = NULL;
if (pdfStates.pmap.detail[row][col])
g_object_unref(pdfStates.pmap.detail[row][col]);
pdfStates.pmap.detail[row][col] = NULL;
}
}
break;
case BLOCKSIGS:      
for(i=0;i<WIDGET_SIGNALS;i++)
{
if (widgets[i].type != CBOCHNG &&
widgets[i].widg)
{
g_signal_handler_block(widgets[i].widg, widgets[i].signal);
}
}
break;
case UNBLOCKSIGS:     
for(i=0;i<WIDGET_SIGNALS;i++)
{
if (widgets[i].type != CBOCHNG &&
widgets[i].widg)
{
g_signal_handler_unblock(widgets[i].widg, widgets[i].signal);
}
}
break;
case SETCOMBOS:      
for(i=0;i<WIDGET_SIGNALS;i++)
{
if (widgets[i].iter)
{
gtk_combo_box_set_active_iter(GTK_COMBO_BOX(widgets[i].widg), widgets[i].iter);
}
}
break;
}
}
void clearMovieEntries(GtkButton *button, void *nothing)
{
int i, j;
for(i=0;i<PDFREQBOUNDS;i++)
{
for(j=0;j<PDFREQDAYS;j++)
gtk_entry_set_text(GTK_ENTRY(mDY[i][j]), "");
for(j=0;j<PDFREQHOURS;j++)
gtk_entry_set_text(GTK_ENTRY(mHR[i][j]), "");
}
gtk_entry_set_text(GTK_ENTRY(mINT), "");
}
void pdfPrep(int prepType, PDFREQ *pdfReq, PLOTPDFARGS *plotPDFArgs, int screen, int row, int col)
{ 
if (!pdfReq)
return;
switch (prepType)
{
case PDF_P_DB:
switch (screen)
{
case PDFMAIN:
case PDFDETAIL:
case PDFREQUEST:
case PDFMOVIE:
switch(pdfReq->keys.pdfType)
{
case PDFTYPE_BASELINE:  
pdfReq->keys.bline.bline_fk = pdfSettings.main.bline.blineKey;
pdfReq->keys.bline.pct = pdfSettings.main.bline.pct;
break;
}
break;
}
break;
case PDF_P_DISP:
switch (screen)
{
case PDFMAIN:
case PDFDETAIL:
case PDFREQUEST:
case PDFMOVIE:
plotPDFArgs->fdUnits = pdfSettings.common.fdUnits;
plotPDFArgs->dateFmt = pdfSettings.common.dateFormat;
plotPDFArgs->blines = pqlxGData.systemBLINEs;
break;
}
break;
}
}
