#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifndef MAC
#include <values.h>
#endif
#include <sys/stat.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "util_externs.h"
#include "dbl_iface.h"
#define offsetS(a) ((int) ((long) &a - (long) &stnSettings))
#define location(a) ((long) base + (int) a)
gboolean _deldbH(gpointer n1, gpointer n2, gpointer n3);
void _delSTNdbRplc(gpointer data);
typedef struct _defaults {
char desc[20];
int  offset;
int  type;
} dfaults;
static dfaults defaults[] = 
{
{"STNSRVR", 0, MYSTRINGPTR},
{"STNDB", 0, MYSTRINGPTR},
{"STNXDAYS", 0, MYINT},
{"STNDD", 0, MYINT},
{"STNDL", 0, MYINT},
{"STNYX", 0, MYBOOL},
{"STNSD", 0, MYINT},
{"STNPQL", 0, MYINT},
{"STNFG", 0, MYCOLOR},
{"STNBG", 0, MYCOLOR},
{"STNSB", 0, MYCOLOR},
{"STNGP", 0, MYCOLOR},
{"STNOP", 0, MYCOLOR},
{"STNEPA", 0, MYCOLOR},
{"STNEUP", 0, MYCOLOR},
{"STNAFG", 0, MYCOLOR},
{"STNABG", 0, MYCOLOR},
{"STNASB", 0, MYCOLOR},
{"STNAGP", 0, MYCOLOR},
{"STNAOP", 0, MYCOLOR},
{"STNAAR", 0, MYCOLOR},
{"STNMNCF", 0, MYINT},
{"STNMND", 0, MYINT},
{"STNMNY", 0, MYINT},
{"STNMNYMAX", 0, MYSTRINGPTR},
{"STNMNYMIN", 0, MYSTRINGPTR},
{"STNANAYX", 0, MYBOOL},
{"STNEVTEO", 0, MYINT},
{"STNEVTMDLSEL", 0, MYSTRINGPTR},
{"STNEVTMDLPH", 0, MYSTRINGPTR},
{"STNEVTXAP", 0, MYSTRINGPTR},
{"STNANAX", 0, MYINT},
{"STNANAY", 0, MYINT},
{"STNANAYMAX", 0, MYSTRINGPTR},
{"STNANAYMIN", 0, MYSTRINGPTR},
{"STNYSCALEGRP", 0, MYSTRINGPTR},
{"STNANCHOR", 0, MYINT},
{"STNMNDUD", 0, MYBOOL},
{"STNMNDU", 0, MYINT},
{"STNAYSCALEGRP", 0, MYSTRINGPTR},
{"STNANADU", 0, MYINT},
{"STNSPPWIN", 0, MYBOOL},
{"STNSPSWIN", 0, MYBOOL},
{"STNSPAMP", 0, MYBOOL},
{"STNSPOV", 0, MYBOOL},
{"STNSPYAX", 0, MYBOOL},
{"STNSPXAX", 0, MYBOOL},
{"STNSPXMIN", 0, MYFLOAT},
{"STNSPXMAX", 0, MYFLOAT},
{"STNSPYMAX", 0, MYFLOAT},
{"STNSPDEC", 0, MYFLOAT},
{"STNSPSFG", 0, MYCOLOR},
{"STNSPSBG", 0, MYCOLOR},
{"STNSPSSB", 0, MYCOLOR},
{"STNSPPFG", 0, MYCOLOR},
{"STNSPPBG", 0, MYCOLOR},
{"STNSPPSB", 0, MYCOLOR},
{"STNSPSW", 0, MYINT},
{"STNSPSH", 0, MYINT},
{"STNSPSX", 0, MYINT},
{"STNSPSY", 0, MYINT},
{"STNSPPW", 0, MYINT},
{"STNSPPH", 0, MYINT},
{"STNSPPX", 0, MYINT},
{"STNSPPY", 0, MYINT},
{"STNSPPHL", 0, MYBOOL},
{"STNSPPYMAX", 0, MYINT},
{"STNSPPYMIN", 0, MYINT},
{"STNSPPXMAX", 0, MYFLOAT},
{"STNSPPXMIN", 0, MYFLOAT},
{"STNSPPHLC", 0, MYCOLOR},
{"STNPMFG", 0, MYCOLOR},
{"STNPMBG", 0, MYCOLOR},
{"STNPMSB", 0, MYCOLOR},
{"STNPMSP", 0, MYCOLOR},
{"STNPMEP", 0, MYCOLOR},
{"STNPMC", 0, MYCOLOR},
{"STNPMEBA", 0, MYCOLOR},
{"STNPMLA", 0, MYCOLOR},
{"STNPMW", 0, MYINT},
{"STNPMH", 0, MYINT},
{"STNPMX", 0, MYINT},
{"STNPMY", 0, MYINT},
{"STNSPPWIN", 0, MYBOOL},
{"STNUP0", 0, MYSTRING},
{"STNUP1", 0, MYSTRING},
{"STNUP2", 0, MYSTRING},
{"STNUP3", 0, MYSTRING},
{"STNUP4", 0, MYSTRING},
{"STNUP5", 0, MYSTRING},
{"STNUP6", 0, MYSTRING},
{"STNUP7", 0, MYSTRING},
{"STNUP8", 0, MYSTRING},
{"STNUP9", 0, MYSTRING},
{"STNUPA", 0, MYINT},
{"END", 0, -1}
};
static void setSTNdefaults()
{
GHashTable *dH;
int   i, cnt=sizeof(defaults)/sizeof(dfaults);
dH = g_hash_table_new_full(g_str_hash, g_str_equal, (GDestroyNotify)free, (GDestroyNotify)free);
g_hash_table_insert(dH, g_strdup("STNSRVR"), g_strdup_printf("%d", offsetS(stnSettings.general.server)));
g_hash_table_insert(dH, g_strdup("STNDB"), g_strdup_printf("%d", offsetS(stnSettings.general.database)));
g_hash_table_insert(dH, g_strdup("STNXDAYS"), g_strdup_printf("%d", offsetS(stnSettings.general.stnXDays)));
g_hash_table_insert(dH, g_strdup("STNDD"), g_strdup_printf("%d", offsetS(stnSettings.main.days)));
g_hash_table_insert(dH, g_strdup("STNDL"), g_strdup_printf("%d", offsetS(stnSettings.main.lines)));
g_hash_table_insert(dH, g_strdup("STNYX"), g_strdup_printf("%d", offsetS(stnSettings.display.yAxis[STNMAIN])));
g_hash_table_insert(dH, g_strdup("STNANAYX"), g_strdup_printf("%d", offsetS(stnSettings.display.yAxis[STNANALYSIS])));
g_hash_table_insert(dH, g_strdup("STNSD"), g_strdup_printf("%d", offsetS(stnSettings.main.shiftDays)));
g_hash_table_insert(dH, g_strdup("STNPQL"), g_strdup_printf("%d", offsetS(stnSettings.pqlDest)));
g_hash_table_insert(dH, g_strdup("STNFG"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNMAIN][STNFG].red)));
g_hash_table_insert(dH, g_strdup("STNBG"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNMAIN][STNBG].red)));
g_hash_table_insert(dH, g_strdup("STNSB"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNMAIN][STNSB].red)));
g_hash_table_insert(dH, g_strdup("STNGP"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNMAIN][STNGP].red)));
g_hash_table_insert(dH, g_strdup("STNOP"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNMAIN][STNOP].red)));
g_hash_table_insert(dH, g_strdup("STNEPA"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNPA].red)));
g_hash_table_insert(dH, g_strdup("STNEUP"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNUP].red)));
g_hash_table_insert(dH, g_strdup("STNAFG"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNFG].red)));
g_hash_table_insert(dH, g_strdup("STNABG"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNBG].red)));
g_hash_table_insert(dH, g_strdup("STNASB"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNSB].red)));
g_hash_table_insert(dH, g_strdup("STNAGP"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNGP].red)));
g_hash_table_insert(dH, g_strdup("STNAOP"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNOP].red)));
g_hash_table_insert(dH, g_strdup("STNAAR"), g_strdup_printf("%d", offsetS(stnSettings.drawing.colors[STNANALYSIS][STNPA].red)));
g_hash_table_insert(dH, g_strdup("STNMNCF"), g_strdup_printf("%d", offsetS(stnSettings.main.chnFilter.active)));
g_hash_table_insert(dH, g_strdup("STNMND"), g_strdup_printf("%d", offsetS(stnSettings.main.data)));
g_hash_table_insert(dH, g_strdup("STNMNY"), g_strdup_printf("%d", offsetS(stnSettings.display.yScale[STNMAIN])));
g_hash_table_insert(dH, g_strdup("STNMNYMAX"), g_strdup_printf("%d", offsetS(stnSettings.display.yFixed[STNMAIN][MAX])));
g_hash_table_insert(dH, g_strdup("STNMNYMIN"), g_strdup_printf("%d", offsetS(stnSettings.display.yFixed[STNMAIN][MIN])));
g_hash_table_insert(dH, g_strdup("STNEVTEO"), g_strdup_printf("%d", offsetS(stnSettings.event.epiOrder)));
g_hash_table_insert(dH, g_strdup("STNEVTMDLSEL"), g_strdup_printf("%d", offsetS(stnSettings.event.modelSel)));
g_hash_table_insert(dH, g_strdup("STNEVTMDLPH"), g_strdup_printf("%d", offsetS(stnSettings.event.modelsSV)));
g_hash_table_insert(dH, g_strdup("STNEVTXAP"), g_strdup_printf("%d", offsetS(stnSettings.event.alignPhase)));
g_hash_table_insert(dH, g_strdup("STNANAX"), g_strdup_printf("%d", offsetS(stnSettings.display.xScale)));
g_hash_table_insert(dH, g_strdup("STNANAY"), g_strdup_printf("%d", offsetS(stnSettings.display.yScale[STNANALYSIS])));
g_hash_table_insert(dH, g_strdup("STNANAYMAX"), g_strdup_printf("%d", offsetS(stnSettings.display.yFixed[STNANALYSIS][MAX])));
g_hash_table_insert(dH, g_strdup("STNANAYMIN"), g_strdup_printf("%d", offsetS(stnSettings.display.yFixed[STNANALYSIS][MIN])));
g_hash_table_insert(dH, g_strdup("STNYSCALEGRP"), g_strdup_printf("%d", offsetS(stnSettings.main.yChnScale.selected)));
g_hash_table_insert(dH, g_strdup("STNANCHOR"), g_strdup_printf("%d", offsetS(stnSettings.analysis.anchor)));
g_hash_table_insert(dH, g_strdup("STNMNDUD"), g_strdup_printf("%d", offsetS(stnSettings.display.unitsD)));
g_hash_table_insert(dH, g_strdup("STNMNDU"), g_strdup_printf("%d", offsetS(stnSettings.display.units[STNMAIN])));
g_hash_table_insert(dH, g_strdup("STNANADU"), g_strdup_printf("%d", offsetS(stnSettings.display.units[STNANALYSIS])));
g_hash_table_insert(dH, g_strdup("STNAYSCALEGRP"), g_strdup_printf("%d", offsetS(stnSettings.analysis.yChnScale.selected)));
g_hash_table_insert(dH, g_strdup("STNSPPWIN"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.type[PSD_WIN])));
g_hash_table_insert(dH, g_strdup("STNSPSWIN"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.type[SPECTRA_WIN])));
g_hash_table_insert(dH, g_strdup("STNSPAMP"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.amp)));
g_hash_table_insert(dH, g_strdup("STNSPOV"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.overlay)));
g_hash_table_insert(dH, g_strdup("STNSPYAX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.yAxis)));
g_hash_table_insert(dH, g_strdup("STNSPXAX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.xAxis)));
g_hash_table_insert(dH, g_strdup("STNSPDEC"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.decades)));
g_hash_table_insert(dH, g_strdup("STNSPXMIN"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.xMin)));
g_hash_table_insert(dH, g_strdup("STNSPXMAX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.xMax)));
g_hash_table_insert(dH, g_strdup("STNSPYMAX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.spectra.yMax)));
g_hash_table_insert(dH, g_strdup("STNSPSFG"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[SPECTRA_WIN][STNFG].red)));
g_hash_table_insert(dH, g_strdup("STNSPSBG"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[SPECTRA_WIN][STNBG].red)));
g_hash_table_insert(dH, g_strdup("STNSPSSB"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB].red)));
g_hash_table_insert(dH, g_strdup("STNSPPFG"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PSD_WIN][STNFG].red)));
g_hash_table_insert(dH, g_strdup("STNSPPBG"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PSD_WIN][STNBG].red)));
g_hash_table_insert(dH, g_strdup("STNSPPSB"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PSD_WIN][STNSB].red)));
g_hash_table_insert(dH, g_strdup("STNSPSW"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[SPECTRA_WIN].width)));
g_hash_table_insert(dH, g_strdup("STNSPSH"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[SPECTRA_WIN].height)));
g_hash_table_insert(dH, g_strdup("STNSPSX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[SPECTRA_WIN].xPos)));
g_hash_table_insert(dH, g_strdup("STNSPSY"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[SPECTRA_WIN].yPos)));
g_hash_table_insert(dH, g_strdup("STNSPPW"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PSD_WIN].width)));
g_hash_table_insert(dH, g_strdup("STNSPPH"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PSD_WIN].height)));
g_hash_table_insert(dH, g_strdup("STNSPPX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PSD_WIN].xPos)));
g_hash_table_insert(dH, g_strdup("STNSPPY"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PSD_WIN].yPos)));
g_hash_table_insert(dH, g_strdup("STNSPPHL"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.psd.hlnm)));
g_hash_table_insert(dH, g_strdup("STNSPPYMAX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.psd.yMax)));
g_hash_table_insert(dH, g_strdup("STNSPPYMIN"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.psd.yMin)));
g_hash_table_insert(dH, g_strdup("STNSPPXMAX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.psd.xMax)));
g_hash_table_insert(dH, g_strdup("STNSPPXMIN"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.psd.xMin)));
g_hash_table_insert(dH, g_strdup("STNSPPHLC"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PSD_WIN][STNHL].red)));
g_hash_table_insert(dH, g_strdup("STNPMFG"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNFG].red)));
g_hash_table_insert(dH, g_strdup("STNPMBG"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNBG].red)));
g_hash_table_insert(dH, g_strdup("STNPMSB"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNSB].red)));
g_hash_table_insert(dH, g_strdup("STNPMSP"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNPMSP].red)));
g_hash_table_insert(dH, g_strdup("STNPMEP"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNPMEP].red)));
g_hash_table_insert(dH, g_strdup("STNPMC"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNPMC].red)));
g_hash_table_insert(dH, g_strdup("STNPMEBA"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNPMEBA].red)));
g_hash_table_insert(dH, g_strdup("STNPMLA"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.colors[PM_WIN][STNPMLA].red)));
g_hash_table_insert(dH, g_strdup("STNPMWIN"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.type[PM_WIN])));
g_hash_table_insert(dH, g_strdup("STNPMW"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PM_WIN].width)));
g_hash_table_insert(dH, g_strdup("STNPMH"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PM_WIN].height)));
g_hash_table_insert(dH, g_strdup("STNPMX"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PM_WIN].xPos)));
g_hash_table_insert(dH, g_strdup("STNPMY"), g_strdup_printf("%d", offsetS(stnSettings.analysis.popup.dims[PM_WIN].yPos)));
g_hash_table_insert(dH, g_strdup("STNUP0"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[0])));
g_hash_table_insert(dH, g_strdup("STNUP1"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[1])));
g_hash_table_insert(dH, g_strdup("STNUP2"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[2])));
g_hash_table_insert(dH, g_strdup("STNUP3"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[3])));
g_hash_table_insert(dH, g_strdup("STNUP4"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[4])));
g_hash_table_insert(dH, g_strdup("STNUP5"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[5])));
g_hash_table_insert(dH, g_strdup("STNUP6"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[6])));
g_hash_table_insert(dH, g_strdup("STNUP7"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[7])));
g_hash_table_insert(dH, g_strdup("STNUP8"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[8])));
g_hash_table_insert(dH, g_strdup("STNUP9"), g_strdup_printf("%d", offsetS(stnSettings.event.userP[9])));
g_hash_table_insert(dH, g_strdup("STNUPA"), g_strdup_printf("%d", offsetS(stnSettings.event.userPA)));
for(i=0;i<cnt-1;i++)
defaults[i].offset = atoi(g_hash_table_lookup(dH, defaults[i].desc));
g_hash_table_destroy(dH);
stnSettings.general.startup = FALSE;
stnSettings.general.stnXDays = 0;
stnSettings.main.lines = 18;
stnSettings.main.days = 7;
stnSettings.display.yAxis[STNMAIN] = OFF;
stnSettings.display.yAxis[STNANALYSIS] = ON;
stnSettings.main.data = STNCVG;
stnSettings.event.dispOrder = EVTDISPSTN;
stnSettings.event.epiOrder = STNEVTEPINEAR1ST;
stnSettings.event.modelsSV = g_strdup("");
stnSettings.event.modelSel = g_strdup("");
stnSettings.event.alignPhase = g_strdup("");
stnSettings.analysis.anchor = MIDDLE;
stnSettings.display.xScale = ABSOLUTE;
stnStates.display.dataState = STNDRAWDONE;
stnStates.display.initiate = TRUE;
stnStates.display.chnFilter.active = stnSettings.main.chnFilter.active = NONE;
stnStates.display.dataFilter.on = OFF;
stnStates.display.dataFilter.active = NONE;
stnSettings.main.shiftDays = 1;
stnStates.analysis.dataFilter.on = OFF;
stnStates.analysis.dataFilter.active = NONE;
stnSettings.analysis.popup.type[SPECTRA_WIN] = STN_POPUP_WIN_SINGLE;
stnSettings.analysis.popup.type[PSD_WIN] = STN_POPUP_WIN_SINGLE;
stnSettings.analysis.popup.type[PM_WIN] = STN_POPUP_WIN_SINGLE;
stnSettings.analysis.popup.spectra.amp = WSCALETRC;
stnSettings.analysis.popup.spectra.overlay = OFF;
stnSettings.analysis.popup.spectra.yAxis = LIN;
stnSettings.analysis.popup.spectra.xAxis = LOG;
stnSettings.analysis.popup.spectra.decades = 3.5;
stnSettings.analysis.popup.spectra.xMin = 0.0;
stnSettings.analysis.popup.spectra.xMax = 0.0;
stnSettings.analysis.popup.spectra.yMax = 0.0;
stnSettings.analysis.popup.psd.hlnm = TRUE;
stnSettings.analysis.popup.psd.yMax = -50;
stnSettings.analysis.popup.psd.yMin = -200;
stnSettings.analysis.popup.psd.xMax = 0;
stnSettings.analysis.popup.psd.xMin = 0;
stnSettings.pqlDest = PQLMAG;
stnSettings.display.yScale[STNMAIN] = DISPS;
stnSettings.display.yScale[STNANALYSIS] = DISPS;
stnSettings.main.yChnScale.selected = g_strdup("");
stnSettings.analysis.yChnScale.selected = g_strdup("");
stnSettings.display.unitsD = FALSE;
stnSettings.display.units[STNMAIN] = STNCOUNTS;
stnSettings.display.units[STNANALYSIS] = STNCOUNTS;
stnSettings.drawing.colors[STNMAIN][STNFG].red = settings.colors.fg[TRACESCR].red;
stnSettings.drawing.colors[STNMAIN][STNFG].green = settings.colors.fg[TRACESCR].green;
stnSettings.drawing.colors[STNMAIN][STNFG].blue = settings.colors.fg[TRACESCR].blue;
stnSettings.drawing.colors[STNMAIN][STNBG].red = settings.colors.bg[TRACESCR].red;
stnSettings.drawing.colors[STNMAIN][STNBG].green = settings.colors.bg[TRACESCR].green;
stnSettings.drawing.colors[STNMAIN][STNBG].blue = settings.colors.bg[TRACESCR].blue;
stnSettings.drawing.colors[STNMAIN][STNSB].red = settings.colors.sb[TRACESCR].red;
stnSettings.drawing.colors[STNMAIN][STNSB].green = settings.colors.sb[TRACESCR].green;
stnSettings.drawing.colors[STNMAIN][STNSB].blue = settings.colors.sb[TRACESCR].blue;
stnSettings.drawing.colors[STNMAIN][STNGP].red = settings.colors.gp[TRACESCR][0].red;
stnSettings.drawing.colors[STNMAIN][STNGP].green = settings.colors.gp[TRACESCR][0].green;
stnSettings.drawing.colors[STNMAIN][STNGP].blue = settings.colors.gp[TRACESCR][0].blue;
stnSettings.drawing.colors[STNMAIN][STNOP].red = settings.colors.op[TRACESCR][0].red;
stnSettings.drawing.colors[STNMAIN][STNOP].green = settings.colors.op[TRACESCR][0].green;
stnSettings.drawing.colors[STNMAIN][STNOP].blue = settings.colors.op[TRACESCR][0].blue;
stnSettings.drawing.colors[STNANALYSIS][STNFG].red = settings.colors.fg[TRACESCR].red;
stnSettings.drawing.colors[STNANALYSIS][STNFG].green = settings.colors.fg[TRACESCR].green;
stnSettings.drawing.colors[STNANALYSIS][STNFG].blue = settings.colors.fg[TRACESCR].blue;
stnSettings.drawing.colors[STNANALYSIS][STNBG].red = settings.colors.bg[TRACESCR].red;
stnSettings.drawing.colors[STNANALYSIS][STNBG].green = settings.colors.bg[TRACESCR].green;
stnSettings.drawing.colors[STNANALYSIS][STNBG].blue = settings.colors.bg[TRACESCR].blue;
stnSettings.drawing.colors[STNANALYSIS][STNSB].red = settings.colors.sb[TRACESCR].red;
stnSettings.drawing.colors[STNANALYSIS][STNSB].green = settings.colors.sb[TRACESCR].green;
stnSettings.drawing.colors[STNANALYSIS][STNSB].blue = settings.colors.sb[TRACESCR].blue;
stnSettings.drawing.colors[STNANALYSIS][STNGP].red = settings.colors.gp[TRACESCR][0].red;
stnSettings.drawing.colors[STNANALYSIS][STNGP].green = settings.colors.gp[TRACESCR][0].green;
stnSettings.drawing.colors[STNANALYSIS][STNGP].blue = settings.colors.gp[TRACESCR][0].blue;
stnSettings.drawing.colors[STNANALYSIS][STNOP].red = settings.colors.op[TRACESCR][0].red;
stnSettings.drawing.colors[STNANALYSIS][STNOP].green = settings.colors.op[TRACESCR][0].green;
stnSettings.drawing.colors[STNANALYSIS][STNOP].blue = settings.colors.op[TRACESCR][0].blue;
stnSettings.drawing.colors[STNANALYSIS][STNPA].red = 139*256;
stnSettings.drawing.colors[STNANALYSIS][STNPA].green = 15*256;
stnSettings.drawing.colors[STNANALYSIS][STNPA].blue = 149*256;
stnSettings.drawing.colors[STNANALYSIS][STNUP].red = 0*256;
stnSettings.drawing.colors[STNANALYSIS][STNUP].green = 199*256;
stnSettings.drawing.colors[STNANALYSIS][STNUP].blue = 8*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNFG].red = 0;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNFG].green = 214*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNFG].blue = 217*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNBG].red = 37*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNBG].green = 7*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNBG].blue = 93*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB].red = 74*256;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB].green = 0;
stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB].blue = 66*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNFG].red = 0;
stnSettings.analysis.popup.colors[PSD_WIN][STNFG].green = 214*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNFG].blue = 217*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNBG].red = 105*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNBG].green = 16*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNBG].blue = 100*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNSB].red = 64*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNSB].green = 22*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNSB].blue = 6*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNHL].red = 41*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNHL].green = 36*256;
stnSettings.analysis.popup.colors[PSD_WIN][STNHL].blue = 36*256;
stnSettings.analysis.popup.colors[PM_WIN][STNFG].red = 157*256;
stnSettings.analysis.popup.colors[PM_WIN][STNFG].green = 159*256;
stnSettings.analysis.popup.colors[PM_WIN][STNFG].blue = 255*256;
stnSettings.analysis.popup.colors[PM_WIN][STNBG].red = 33*256;
stnSettings.analysis.popup.colors[PM_WIN][STNBG].green = 43*256;
stnSettings.analysis.popup.colors[PM_WIN][STNBG].blue = 43*256;
stnSettings.analysis.popup.colors[PM_WIN][STNSB].red = 25*256;
stnSettings.analysis.popup.colors[PM_WIN][STNSB].green = 76*256;
stnSettings.analysis.popup.colors[PM_WIN][STNSB].blue = 48*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMSP].red = 0;
stnSettings.analysis.popup.colors[PM_WIN][STNPMSP].green = 256*256-1;
stnSettings.analysis.popup.colors[PM_WIN][STNPMSP].blue = 0;
stnSettings.analysis.popup.colors[PM_WIN][STNPMEP].red = 256*256-1;
stnSettings.analysis.popup.colors[PM_WIN][STNPMEP].green = 0;
stnSettings.analysis.popup.colors[PM_WIN][STNPMEP].blue = 0;
stnSettings.analysis.popup.colors[PM_WIN][STNPMC].red = 192*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMC].green = 192*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMC].blue = 192*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMEBA].red = 254*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMEBA].green = 0*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMEBA].blue = 128*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMLA].red = 255*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMLA].green = 255*256;
stnSettings.analysis.popup.colors[PM_WIN][STNPMLA].blue = 0*256;
stnSettings.analysis.popup.dims[PM_WIN].width = 727;
stnSettings.analysis.popup.dims[PM_WIN].height = 634;
for (i=0;i<MAXPICKS;i++)
{ 
sprintf(stnSettings.event.userP[i], "%d", i+1);
}
stnStates.display.user.action = NONE;
stnStates.display.user.keyActive = NONE;
stnStates.event.curPick = NONE;
#if 0
if (pqlxStates.user.fname.rplc)
g_hash_table_foreach_remove(pqlxStates.user.fname.rplc, (GHRFunc) _deldbH, NULL);
pqlxStates.user.fname.rplc = g_hash_table_new_full(g_str_hash, g_str_equal, 
(GDestroyNotify)free, (GDestroyNotify)free);
#endif
drawQ = g_async_queue_new();
}
#if 0
static void _dbRplcWrt(char *key, DBRPLCSTR *value, DBLRECORDS *dblrecs)
{
int i = dblrecs->numRecs;
if (strlen(key)==1)   
return;
dblrecs->recs[i] = calloc(1, sizeof(DEFAULTS_REC));r
r
strncpy(((DEFAULTS_REC *) dblrecs->recs[i])->name, key, strlen(key));
sprintf(((DEFAULTS_REC *) dblrecs->recs[i])->value, "%s %s", value->fromStr, value->toStr);
dblrecs->numRecs++;
}
#endif
void write_STNdefaults(STNSETTINGS *base)
{
int i, cnt=sizeof(defaults)/sizeof(dfaults);
DBLDI dbldi;
DBLRECORDS dblrecs;
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNDFAULTST;
dbldi.descr.dataEvent = WRITE_ALL;
dblrecs.numRecs = (cnt - 1);
dbldi.data = &dblrecs;
if((dblrecs.recs = calloc(dblrecs.numRecs, sizeof(void *)))==NULL)
{
fprintf(stderr, "Out of Memory, cannot continue.\n");
exit(-1);
}
for(i=0; i<dblrecs.numRecs ;i++)
{
dblrecs.recs[i] = calloc(1, sizeof(DEFAULTS_REC));
strncpy(((DEFAULTS_REC *) dblrecs.recs[i])->name, defaults[i].desc, strlen(defaults[i].desc));
switch(defaults[i].type)
{
case MYBOOL:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d", 
*((gboolean *) location(defaults[i].offset)));
break;
case MYSHORT:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d", 
*((guint16 *) location(defaults[i].offset)));
break;
case MYINT:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d", 
*((int *) location(defaults[i].offset)));
break;
case MYFLOAT:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%f", 
*((float *) location(defaults[i].offset)));
break;
case MYSTRING:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%s", 
(char *) location(defaults[i].offset));
break;
case MYSTRINGPTR:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%s", 
(char *) *((char **) location(defaults[i].offset)));
break;
case MYCOLOR:
sprintf(((DEFAULTS_REC *) dblrecs.recs[i])->value, "%d %d %d", 
*((guint16 *) location(defaults[i].offset)),
*((guint16 *) location(defaults[i].offset+sizeof(guint16))),
*((guint16 *) location(defaults[i].offset+2*sizeof(guint16))));
break;
}
}
dbl_request(&dbldi);
for(i=0; i<dblrecs.numRecs;i++)
{
free(dblrecs.recs[i]);
}
free(dblrecs.recs);
}
static gint filtOrder(STN_CHN_FILTER *filt1, STN_CHN_FILTER *filt2)
{
return(strcmp(filt1->name, filt2->name));
}
void readSTNchnFilters(int system)
{ 
DBLDI dbldi;
DBLRECORDS dblrecs;
int  j;
GSList *filtLst=NULL;
STN_CHN_FILTER *fltPtr;
CHN_FILTER *chnFilter=NULL;
CHN_FLT_STATE *chnFltState=NULL;
switch(system)
{
case PDFSYSTEM:
chnFilter = &pdfSettings.main.chnFilter;
chnFltState = &pdfStates.main.group.chnFilter;
break;
case STNSYSTEM:
chnFilter = &stnSettings.main.chnFilter.filters;
chnFltState = &stnStates.display.chnFilter;
break;
}
if (chnFilter->numFilters)
{ 
for(j=0;j<chnFilter->numFilters;j++)
{
free(chnFilter->filts[j]);
}
free(chnFilter->filts);
}
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNCHNFLTRST;
dbldi.descr.dataEvent = READ_ALL;
dbldi.data = &dblrecs;
dbl_request(&dbldi);
for(j=0;j<dblrecs.numRecs;j++)
{ 
filtLst = g_slist_prepend(filtLst, dblrecs.recs[j]);
}
filtLst = g_slist_sort(filtLst, (GCompareFunc) filtOrder);
chnFilter->numFilters = dblrecs.numRecs;
chnFilter->filts = calloc(chnFilter->numFilters, sizeof(char *));
if(dblrecs.numRecs) 
{
for(j=0;j<dblrecs.numRecs;j++)
{
fltPtr = (STN_CHN_FILTER *) (filtLst->data);
chnFilter->filts[j] = g_strdup(fltPtr->name);
free(fltPtr);
filtLst = g_slist_next(filtLst);
} 
free(dblrecs.recs);
}
g_slist_free(filtLst);
chnFltState->active = NOFILTERSELECTION;
}
gboolean _deldbH(gpointer n1, gpointer n2, gpointer n3)
{
return TRUE;
}
#if 0
void _delSTNdbRplc(gpointer data)
{
free(data);
}
#endif
#if 0
void readSTNdbRplc(DBLRECORDS *dblrecs)
{
int  i, j, cnt=sizeof(defaults)/sizeof(dfaults);
char *key, fromStr[255], toStr[255];
DBRPLCSTR *value;
for(j=0;j<dblrecs->numRecs;j++)
{
for(i=0;i<cnt;++i)
if (!strcmp(defaults[i].desc, ((DEFAULTS_REC *) (dblrecs->recs[j]))->name))
break;
if (i!=cnt)
continue;
key = g_strdup(((DEFAULTS_REC *) (dblrecs->recs[j]))->name);
value = calloc(1, sizeof(DBRPLCSTR));
sscanf(((DEFAULTS_REC *) (dblrecs->recs[j]))->value, "%s %s", fromStr, toStr); 
value->fromStr = g_strdup(fromStr);
value->toStr = g_strdup(toStr);
g_hash_table_insert(pqlxStates.user.fname.rplc, key, value);
}
}
#endif
void read_STNdefaults(STNSETTINGS *base)
{
int i, j, cnt=sizeof(defaults)/sizeof(dfaults);
DBLDI dbldi;
DBLRECORDS dblrecs;
setSTNdefaults();
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNDFAULTST;
dbldi.descr.dataEvent = READ_ALL;
dbldi.data = &dblrecs;
dbl_request(&dbldi);
if(dblrecs.numRecs) 
{
for(j=0;j<dblrecs.numRecs;j++)
{
for(i=0;i<cnt;++i)
if (!strcmp(defaults[i].desc, ((DEFAULTS_REC *) (dblrecs.recs[j]))->name))
break;
if (i==cnt)  
continue;
switch(defaults[i].type)
{
case MYBOOL:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%d", (gboolean *) location(defaults[i].offset));
break;
case MYSHORT:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%hd", (guint16 *) location(defaults[i].offset));
break;
case MYINT:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%d", (int *) location(defaults[i].offset));
break;
case MYFLOAT:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%f", (float *) location(defaults[i].offset));
break;
case MYSTRING:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%s", (char *) location(defaults[i].offset));
break;
case MYSTRINGPTR:
*((char **) location(defaults[i].offset)) = 
g_strdup(((DEFAULTS_REC *) (dblrecs.recs[j]))->value);
break;
case MYCOLOR:
sscanf(((DEFAULTS_REC *) (dblrecs.recs[j]))->value, 
"%hd %hd %hd", ((guint16 *) location(defaults[i].offset)),
((guint16 *) location(defaults[i].offset+sizeof(guint16))),
((guint16 *) location(defaults[i].offset+2*sizeof(guint16))));
break;
}
}
{ 
char *modelStr=NULL;
GSList *iter;
for(iter = stnSettings.event.models;
iter;
iter = g_slist_next(iter))
{ 
free(iter->data);
}
g_slist_free(stnSettings.event.models);
stnSettings.event.models = NULL;
if (!stnSettings.event.modelsSV &&
stnSettings.event.modelSel)
{
free(stnSettings.event.modelSel);
stnSettings.event.modelSel = NULL;
}
for(modelStr = strtok(stnSettings.event.modelsSV, MODELSSEP);
modelStr;
modelStr = strtok(NULL, MODELSSEP))
{
stnSettings.event.models = g_slist_prepend(stnSettings.event.models, g_strdup(modelStr));
}
}
for(i=0; i<dblrecs.numRecs ;i++)
{
free(dblrecs.recs[i]);
}
free(dblrecs.recs);
}
readSTNchnFilters(STNSYSTEM);
}
