#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
static gboolean getLocChn(GNode *node, GNode *stnNode)
{ 
static char *locName=NULL;
NSLCDATA *nodeD=node->data;
STNCHN *chnPtr, *stnNodeD=stnNode->data;
switch(g_node_depth(node))
{
case 3:  
if (locName)
free(locName);
locName = g_strdup(nodeD->name);
break;
case 4:
chnPtr = calloc(1, sizeof(STNCHN));
chnPtr->name1 = g_strdup(locName);
chnPtr->name2 = g_strdup(nodeD->name);
chnPtr->shortName = g_strdup_printf("%s.%s", chnPtr->name1, chnPtr->name2);
chnPtr->longName = g_strdup_printf("%s.%s.%s.%s", 
stnNodeD->name1, stnNodeD->name2, chnPtr->name1, chnPtr->name2);
chnPtr->key = nodeD->id;
g_node_insert_data(stnNode, -1, chnPtr);
g_hash_table_insert(chnHash, &chnPtr->key, chnPtr);
break;
}
return FALSE;
}
static gboolean getNtwStn(GNode *node, void *nothing)
{ 
static char *ntwName=NULL;
NSLCDATA *nodeD=node->data;
STNCHN *stnPtr;
GNode *stnNode;
switch(g_node_depth(node))
{
case 1: 
if (ntwName)
free(ntwName);
ntwName = g_strdup(nodeD->name);
break;
case 2: 
stnPtr = calloc(1, sizeof(STNCHN));
stnPtr->name1 = g_strdup(ntwName);
stnPtr->name2 = g_strdup(nodeD->name);
stnPtr->shortName = g_strdup_printf("%s.%s", stnPtr->name1, stnPtr->name2);
stnPtr->key = nodeD->id;
stnNode = g_node_new(stnPtr);
stnStates.main.stnList = g_list_append(stnStates.main.stnList, stnNode);
g_node_traverse(node, G_PRE_ORDER, G_TRAVERSE_ALL, -1, 
(GNodeTraverseFunc) getLocChn, stnNode);
stnSettings.ttlStns++;
break;
}
return FALSE;
}
gboolean freeStnChnData(GNode *node, gpointer nothing)
{
STNCHN *nodeD = node->data;
free(nodeD->name1);
free(nodeD->name2);
free(nodeD->shortName);
if (nodeD->longName)
free(nodeD->longName);
free(nodeD);
return FALSE;
}
void initSTNsystem()
{
GSList *iter;
char *srvrDB;
GNode *stnchnIter;
while (stnStates.main.stnList)
{ 
for(stnchnIter=g_node_first_child(stnStates.main.stnList->data);
stnchnIter;
stnchnIter=g_node_next_sibling(stnchnIter))
{
g_node_traverse(stnchnIter, G_PRE_ORDER, G_TRAVERSE_ALL, -1,
(GNodeTraverseFunc) freeStnChnData, NULL);
}
g_node_destroy((GNode *) (stnStates.main.stnList->data));
stnStates.main.stnList = g_list_remove(stnStates.main.stnList, (stnStates.main.stnList->data));
}
if(chnHash)
g_hash_table_destroy(chnHash);
stnStates.main.startStn = NULL;
stnSettings.ttlStns = 0;
chnHash = g_hash_table_new(g_int_hash, g_int_equal); 
for(iter=ntw;iter;iter=g_slist_next(iter))
{ 
g_node_traverse(iter->data, G_PRE_ORDER, G_TRAVERSE_ALL, 2, 
(GNodeTraverseFunc) getNtwStn, NULL);
}
#if 0
if (stnCtrlWindow)
{ 
gtk_widget_set_sensitive(STNrplc[REPLACEFROM], TRUE);
gtk_widget_set_sensitive(STNrplc[REPLACETO], TRUE);
}
#endif
srvrDB = g_strdup_printf("%s.%s", pqlxStates.conn.srvrNm, pqlxStates.conn.dbNm);
free(srvrDB);
gtk_label_set_markup(GTK_LABEL (stnCntLbl), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> 0 / 0 </span>");
if (stnStates.event.models)
{
setVisible(STNSYSTEM, STNNOEVENTSENS1, STNANALYSIS, TRUE);
setSensitive(STNSYSTEM, STNNOEVENTSENS, STNANALYSIS, FALSE);
}
else
{
setVisible(STNSYSTEM, STNNOEVENTSENS1, STNANALYSIS, FALSE);
}
makeModelsCtrls(stnStates.event.models);  
{ 
SQLDI  sqldi;
DATEBNDRY dateBndry;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&dateBndry, 0, sizeof(DATEBNDRY));
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = DTBNDRY;
sqldi.data = &dateBndry;
db_request(&sqldi);
stnSettings.display.dates[STARTDT] = 
g_date_new_dmy( dateBndry.data.dates[STARTDT].date.day, 
dateBndry.data.dates[STARTDT].date.mo, 
dateBndry.data.dates[STARTDT].date.yr);
stnSettings.display.dates[ENDDT] = 
g_date_new_dmy( dateBndry.data.dates[ENDDT].date.day, 
dateBndry.data.dates[ENDDT].date.mo, 
dateBndry.data.dates[ENDDT].date.yr);
}
stnStates.request.type = STNINIT;
stnStates.display.initiate = TRUE;
getAllSTNdata();
}
gboolean getAllSTNdata();
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
static int threadNum;       
static int ttlThreadCount;      
static int threadNums[TTLSTNLOOKAHEADS][2];  
static int threadCount[TTLSTNLOOKAHEADS];  
static int _getSCRNdata(int which)
{
SQLDI *sqldi;
STNDATA *stnData;
SCRNDATA scrnData;
GSList *stnList=NULL, *stnIter, *chnIter, *listCopy;
gpointer chnInfo;
memset(&scrnData, 0, sizeof(SCRNDATA));
switch(which)
{
case STNCURDT:
case STNPREVDT:
case STNNEXTDT:
stnList = stnStates.main.stns[which];
break;
case STNPREVSTN1:
case STNNEXTSTN1:
stnList = stnStates.NP[which-TTLPERIODSTNDATA].stns;
break;
}
for(stnIter=stnList;stnIter;stnIter=g_slist_next(stnIter))
{
stnData = stnIter->data;
listCopy = g_slist_copy(stnData->keys.chnKeys);
scrnData.keys.chnKeys = g_slist_concat(scrnData.keys.chnKeys, listCopy);
}
if (!g_slist_length(scrnData.keys.chnKeys))
return FALSE;  
stnData = stnList->data;
if (!stnData->keys.dates[STARTDT].date.yr)
return FALSE;  
memcpy(&scrnData.keys.dates, &stnData->keys.dates, sizeof(MYTIME)*TTLDATES);
sqldi = calloc(1, sizeof(SQLDI));
sqldi->args.sqr = which;
sqldi->args.dataEvent = GET_DATA;
sqldi->descr.tableData = STNINFO;
sqldi->data = &scrnData;
db_request(sqldi);
free(sqldi);
for(stnIter=stnList;stnIter;stnIter=g_slist_next(stnIter))
{
stnData = stnIter->data;
for(chnIter=stnData->keys.chnKeys;chnIter;chnIter=g_slist_next(chnIter))
{
chnInfo = g_hash_table_lookup(scrnData.data.chnInfo, chnIter->data);
if (!chnInfo)
continue;
stnData->data.chnInfo = g_slist_prepend(stnData->data.chnInfo, chnInfo);
}
g_slist_foreach(stnData->data.chnInfo, (GFunc) chnNameMk, NULL);
stnData->data.chnInfo = g_slist_sort(stnData->data.chnInfo, (GCompareFunc) sortChannels);
}
switch(which)
{ 
case STNCURDT:
case STNNEXTDT:
case STNPREVDT:
stnStates.main.ttlChnCnt[which] = g_hash_table_size(scrnData.data.chnInfo);
break;
case STNPREVSTN1:
case STNNEXTSTN1:
stnStates.NP[which-TTLPERIODSTNDATA].ttlChnCnt = g_hash_table_size(scrnData.data.chnInfo);
break;
}
g_hash_table_destroy(scrnData.data.chnInfo);
g_slist_free(scrnData.keys.chnKeys);
return FALSE;
}
void STNdataRequest(gpointer w)
{ 
int  i, which = GPOINTER_TO_INT(w);
_getSCRNdata(which);
if (which == STNCURDT)
{ 
stnStates.request.state = STNDRAW;
g_idle_add_full(G_PRIORITY_HIGH_IDLE, (GSourceFunc) _mkSTNDrawing, GINT_TO_POINTER(STNMAIN), NULL);
}
ttlThreadCount--;
if (!ttlThreadCount)
{ 
g_static_mutex_unlock(&myMutex);
stnStates.request.dataBUSY = FALSE;
if (stnStates.request.state == STNBUSY)
{ 
g_slist_free(stnStates.main.chnList);
stnStates.main.chnList=NULL;
stnStates.display.initiate = TRUE;
for(i=0;i<TTLSTNLOOKAHEADS;i++)
{
if(stnWidgets[i])
g_signal_handler_unblock(stnWidgets[i], stnSignals[i]);
}
g_idle_add((GSourceFunc) getAllSTNdata, NULL);
}
}
}
gboolean getAllSTNdata()
{
int  i;
g_static_mutex_lock(&myMutex); 
stnStates.request.dataBUSY = TRUE;
stnStates.display.dataState = STNDRAWINIT;
#if 0
if (stnStates.display.pdfBUSY)
{ 
stnStates.display.pdfRESET = TRUE;
}
#endif
if (chkRequest(stnStates.request.type))
{ 
gdk_beep();
return FALSE; 
}
makeSTNList();
for(i=0;i<TTLSTNMAINDISPLAYMODES;i++)
{ 
stnStates.pmap.dirty[STNMAIN][i] = TRUE;
}
threadNum = ttlThreadCount = 0;
memset(&threadCount, 0, sizeof(threadCount));
memset(&threadNums, 0, sizeof(threadNums));
if (!stnStates.main.ttlChnCnt[STNCURDT])
{
stnStates.request.state = STNBUSY;
makeSTNDrawing(STNMAIN);
ttlThreadCount++;
makeThread(ASYNC, (GThreadFunc) STNdataRequest, GINT_TO_POINTER(STNCURDT), NULL);
}
else
{ 
stnStates.request.state = STNDRAW;
makeSTNDrawing(STNMAIN);
}
for(i=STNPREVDT;i<TTLPERIODSTNDATA;i++)
{
if (!stnStates.main.stns[i])    
continue;
if (!stnStates.main.ttlChnCnt[i])
{
ttlThreadCount++;
makeThread(ASYNC, (GThreadFunc) STNdataRequest, GINT_TO_POINTER(i), NULL);
}
}
for(i=0;i<TTLSTNSTNDATA;i++)
{
if (!stnStates.NP[i].stns)     
continue;
if (!stnStates.NP[i].ttlChnCnt)
{
ttlThreadCount++;
makeThread(ASYNC, (GThreadFunc) STNdataRequest, GINT_TO_POINTER(i+TTLPERIODSTNDATA), NULL);
}
}
if (!ttlThreadCount)
{ 
g_static_mutex_unlock(&myMutex);
stnStates.request.dataBUSY = FALSE;
}
return FALSE;         
}
static int _getSTNpdfReturn(SQLDI *sqldi)
{
PDFREQ *pdfReq = sqldi->data;
int  pdfCtr = GPOINTER_TO_INT(sqldi->data2);
if(pdfCtr != stnStates.display.pdfCtr)
{ 
free(sqldi->data);
free(sqldi);
return FALSE;
}
if (pdfReq->data.numRecs!=NOPSDDATA)
{
pdfLBLplot(sqldi->args.sqr-SQRSTNPDF);
}
free(sqldi);
return FALSE;
}
void getSTNpdf()
{
SQLDI  *sqldi;
PDFREQ *pdfReq;
CHNDATA *chnData;
GSList *chnListCopy, *chnIter;
GDate  *end=NULL, *beg=NULL;
int  chnNum=0;
char chnName[15];
stnStates.display.pdfBUSY = TRUE;
end = g_date_new_dmy(stnStates.main.dateRng[ENDDT].day,
stnStates.main.dateRng[ENDDT].mo,
stnStates.main.dateRng[ENDDT].yr);
g_date_subtract_days(end, 1);  
beg = g_date_new_dmy(stnStates.main.dateRng[STARTDT].day,
stnStates.main.dateRng[STARTDT].mo,
stnStates.main.dateRng[STARTDT].yr);
chnListCopy = g_slist_copy(stnStates.main.chnList);
g_slist_free(stnStates.main.pdfList); stnStates.main.pdfList = NULL;
chnIter = chnListCopy;
while(chnIter)
{
chnData = chnIter->data;
memset(chnName, 0, sizeof(chnName)); 
if (chnData->data.trcCnt)
sscanf((strchr(chnData->data.name, '.')+1), "%s", chnName);
if (chnData->keys.chnKey == NONE || !chnData->data.trcCnt || !isPDFchn(chnName))
{ 
stnStates.main.pdfList = g_slist_append(stnStates.main.pdfList, NULL);
chnIter = g_slist_next(chnIter);
chnNum++;
continue;
}
if (chnData->data.pdfReq)
{ 
stnStates.main.pdfList = g_slist_append(stnStates.main.pdfList, chnData->data.pdfReq);
chnIter = g_slist_next(chnIter);
chnNum++;
continue;
}
pdfReq = chnData->data.pdfReq = calloc(1, sizeof(PDFREQ));
pdfReq->data.name = chnData->data.longName;
pdfReq->keys.pdfKey = CUSTOMPDF;
pdfReq->keys.chnKey = chnData->keys.chnKey;
pdfReq->keys.reqType = REQRANGE;
pdfReq->keys.fillTmp = TRUE; 
pdfReq->keys.criteria[PDFREQ_YRSTART] = (float) stnStates.main.dateRng[STARTDT].yr;
pdfReq->keys.criteria[PDFREQ_DYSTARTM] = (float) stnStates.main.dateRng[STARTDT].mo;
pdfReq->keys.criteria[PDFREQ_DYSTARTD] = (float) stnStates.main.dateRng[STARTDT].day;
pdfReq->keys.criteria[PDFREQ_YREND] = (float) g_date_year(end);
pdfReq->keys.criteria[PDFREQ_DYENDM] = (float) g_date_month(end);
pdfReq->keys.criteria[PDFREQ_DYENDD] = (float) g_date_day(end);
pdfReq->data.sTime.date.yr = g_date_year(beg);
pdfReq->data.sTime.date.jday = g_date_get_day_of_year(beg);
pdfReq->data.eTime.date.yr = g_date_year(end);
pdfReq->data.eTime.date.jday = g_date_get_day_of_year(end);
sqldi = calloc(1, sizeof(SQLDI));
sqldi->args.dataEvent = GET_DATA;
sqldi->data2 = GINT_TO_POINTER(stnStates.display.pdfCtr);
sqldi->args.callType = ASYNC;
sqldi->args.sqr = SQRSTNPDF+chnNum;
sqldi->args.returnFunc = (void *) _getSTNpdfReturn;
sqldi->descr.tableData = STNPDF;
sqldi->data = pdfReq;
pdfReq->reqID = reqID++;
db_request(sqldi);
chnNum++;
stnStates.main.pdfList = g_slist_append(stnStates.main.pdfList, pdfReq);
chnIter = g_slist_next(chnIter);
}
g_slist_free(chnListCopy);
stnStates.display.pdfBUSY = FALSE;
stnStates.display.pdfRESET = FALSE;  
}
