#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
void freeTrcData(GSList *trcIter)
{
TRCDATA *trcData;
traceInfo *trc;
while(trcIter)
{
trcData = trcIter->data;
trc = trcData->display.trc;
if (trc && !trc->data.sticky)
{
freeMyData(TRCINFO, trc);
free(trc);
trcData->display.trc = NULL;
}
trcIter = g_slist_next(trcIter);
}
}
void freeAllSTNData()
{
GSList *stnIter, *chnIter;
STNDATA *stnData;
CHNDATA *chnData;
traceInfo *trc;
stnIter = stnStates.main.stns[STNCURDT];
while(stnIter)
{
stnData = stnIter->data;
chnIter = stnData->data.chnInfo;
while(chnIter)
{
chnData = chnIter->data;
freeTrcData(chnData->data.traceFiles);
if (chnData->display.trcData)
{
trc = chnData->display.trcData->display.trc;
if (trc)
{
freeMyData(TRCINFO, trc);
free(trc);
}
chnData->display.trcData = NULL;
free(chnData->display.trcPlot);
chnData->display.trcPlot = NULL;
}
chnIter = g_slist_next(chnIter);
}
stnIter = g_slist_next(stnIter);
} 
}
static int _clearGLAPdata(GLAPS *glapData)
{
free(glapData);
return FALSE;
}
int _clearTRCdata(TRCDATA *trcData)
{
traceInfo *trc=trcData->display.trc;
g_slist_foreach(trcData->data.gaps, (GFunc) _clearGLAPdata, NULL);
g_slist_foreach(trcData->data.olaps, (GFunc) _clearGLAPdata, NULL);
g_slist_free(trcData->data.gaps);
g_slist_free(trcData->data.olaps);
free(trcData->data.name);
if (trc && !trc->data.sticky)
{
freeMyData(TRCINFO, trc);
}
free(trcData);
return FALSE;
}
static int _clearCHNdata(CHNDATA *chnData)
{
GSList *iter;
PDFREQ *pdfReq=chnData->data.pdfReq;
g_slist_foreach(chnData->data.traceFiles, (GFunc) _clearTRCdata, NULL);
g_slist_free(chnData->data.traceFiles);
free(chnData->data.name);
free(chnData->data.longName);
if (chnData->display.trcData) 
{ 
_clearTRCdata(chnData->display.trcData);
}
chnData->display.trcData = NULL;
if (chnData->data.chnMETA)
{ 
for( iter = chnData->data.chnMETA;
iter;
iter = g_slist_next(iter))
free(iter->data);
g_slist_free(chnData->data.chnMETA);
chnData->data.chnMETA = NULL;
}
if (pdfReq)
{ 
if (pdfReq->data.pdf)
free(pdfReq->data.pdf);
if (pdfReq->data.pdfM)
free(pdfReq->data.pdfM);
free(pdfReq);
}
free(chnData);
return FALSE;
}
static int _clearCHNKdata(int *chnKey)
{
free(chnKey);
return FALSE;
}
static int _clearSTNdata(STNDATA *stnData)
{
g_slist_foreach(stnData->data.chnInfo, (GFunc) _clearCHNdata, NULL);
g_slist_foreach(stnData->keys.chnKeys, (GFunc) _clearCHNKdata, NULL);
g_slist_free(stnData->keys.chnKeys);
g_slist_free(stnData->data.chnInfo);
free(stnData->display.pixelPos);
free(stnData->data.name);
free(stnData);
return FALSE;
}
void clearSTNList(GSList **stnIter)
{ 
g_slist_foreach(*stnIter, (GFunc) _clearSTNdata, NULL);
g_slist_free(*stnIter);
*stnIter = NULL;
}
gboolean chkCHN(char *chnNm)
{
if (!stnStates.display.chnFilter.filt || !strlen(stnStates.display.chnFilter.filt))
return TRUE;
return(globmatch(chnNm, stnStates.display.chnFilter.filt));
}
enum
{
CHNCNT,
CHNREG
};
int chnNum(char *ntw, char *stn, char *loc, char *chn)
{
GList  *stnLI;
GNode *stnI, *chnI;
STNCHN *stnD, *chnD=NULL;
gchar *ntwStn, *locChn, *locL;
gboolean found = FALSE;
if (!strlen(loc))
locL = g_strdup("--");
else
locL = loc;
ntwStn = g_strdup_printf("%s.%s", ntw, stn);
locChn = g_strdup_printf("%s.%s", locL, chn);
for(stnLI = stnStates.main.stnList;
stnLI && !found;
stnLI=g_list_next(stnLI))
{
stnI = stnLI->data;
stnD = stnI->data;
if (strcmp(stnD->shortName, ntwStn))
continue;
for(chnI = g_node_first_child(stnI); chnI; chnI = g_node_next_sibling(chnI))
{ 
chnD = chnI->data;
if (!strcmp(chnD->shortName, locChn))
{
found = TRUE;
break;
}
}
}
free(ntwStn);
free(locChn);
if (locL != loc)
free(locL);
return chnD->key;
}
void chnNameMk(CHNDATA *chnData, gpointer nothing)
{
STNCHN *chnPtr = g_hash_table_lookup(chnHash, &chnData->keys.chnKey);
if (!chnPtr)
{
fprintf(stderr, "chnPtr not found for key=%d, cannot assign name\n", chnData->keys.chnKey);
return;
}
chnData->data.name = g_strdup(chnPtr->shortName);
chnData->data.longName = g_strdup(chnPtr->longName);
chnData->data.trcCnt = g_slist_length(chnData->data.traceFiles)-1;  
return;
}
gint sortChannels(CHNDATA *one, CHNDATA *two)
{
return(strcmp(one->data.name, two->data.name));
}
static int chnCnt(GNode *stnNode, int action, STNDATA *stnReq)
{
STNCHN *stnCH;
GNode *chnNode;
int  chnCntr=0, *chnKey;
chnNode = g_node_first_child(stnNode);
while(chnNode)
{
stnCH = (STNCHN *) chnNode->data;
if (chkCHN(stnCH->name2))
{ 
chnCntr++;
if (action==CHNREG)
{ 
chnKey = calloc(1, sizeof(int));
*chnKey = stnCH->key;
stnReq->keys.chnKeys = g_slist_append(stnReq->keys.chnKeys, chnKey);
}
}
chnNode = g_node_next_sibling(chnNode);
}
if (!chnCntr) 
chnCntr=1;
return chnCntr;
}
GList *stnCnt(GList *stnStart, gboolean dir)
{ 
GList *stnNext=stnStart, *stnEnd=g_list_next(stnNext);
int  totChn, chnTtl;
switch(dir)
{ 
case BACKWARDS:
stnNext = stnEnd = g_list_previous(stnNext);
break;
}
for(chnTtl=totChn=0;
stnNext!=NULL;
totChn+=chnTtl,chnTtl=0)
{
chnTtl = chnCnt(stnNext->data, CHNCNT, NULL);
if (totChn+chnTtl > stnSettings.main.lines)
break;
switch(dir)
{
case FORWARDS:
stnNext = g_list_next(stnNext);
stnEnd = stnNext;
break;
case BACKWARDS:
stnEnd = stnNext;
stnNext = g_list_previous(stnNext);
break;
}
}
return stnEnd;
}
void setDates(int cmd, int days)
{
static GDate *doyS=NULL; 
GDate   *doy=NULL;
switch(cmd)
{
case STNINIT:
{
if (stnStates.request.endDate)
{ 
doy = stnStates.request.endDate;
}
else
{ 
doy = g_date_new_julian(g_date_get_julian(stnSettings.display.dates[ENDDT]));
}
memset(&stnStates.main.dateRng, 0, sizeof(PTIME)*TTLSTNDATES);
stnStates.main.dateRng[CURDTE].yr = g_date_get_year(doy);
stnStates.main.dateRng[CURDTE].mo = g_date_get_month(doy);
stnStates.main.dateRng[CURDTE].day = g_date_get_day(doy);
g_date_subtract_days(doy, days); 
stnStates.main.dateRng[CURDTS].yr = g_date_get_year(doy);
stnStates.main.dateRng[CURDTS].mo = g_date_get_month(doy);
stnStates.main.dateRng[CURDTS].day = g_date_get_day(doy);
if (doyS)
g_date_free(doyS);
doyS = g_date_new_julian(g_date_get_julian(doy));
g_date_free(doy);
doy = g_date_new_julian(g_date_get_julian(doyS));
stnStates.main.dateRng[PRVDTE].yr = g_date_get_year(doy);
stnStates.main.dateRng[PRVDTE].mo = g_date_get_month(doy);
stnStates.main.dateRng[PRVDTE].day = g_date_get_day(doy);
g_date_subtract_days(doy, days); 
stnStates.main.dateRng[PRVDTS].yr = g_date_get_year(doy);
stnStates.main.dateRng[PRVDTS].mo = g_date_get_month(doy);
stnStates.main.dateRng[PRVDTS].day = g_date_get_day(doy);
if (stnStates.request.endDate)
{ 
stnStates.request.endDate = NULL;
g_date_free(doy);
doy = g_date_new_julian(g_date_get_julian(doyS));
g_date_add_days(doy, days); 
stnStates.main.dateRng[NXTDTS].yr = g_date_get_year(doy);
stnStates.main.dateRng[NXTDTS].mo = g_date_get_month(doy);
stnStates.main.dateRng[NXTDTS].day = g_date_get_day(doy);
g_date_add_days(doy, days);
stnStates.main.dateRng[NXTDTE].yr = g_date_get_year(doy);
stnStates.main.dateRng[NXTDTE].mo = g_date_get_month(doy);
stnStates.main.dateRng[NXTDTE].day = g_date_get_day(doy);
}
}
break;  
case STNPREVDT:
memcpy(&stnStates.main.dateRng[NXTDTS], &stnStates.main.dateRng[CURDTS], sizeof(PTIME)*2);
memcpy(&stnStates.main.dateRng[CURDTS], &stnStates.main.dateRng[PRVDTS], sizeof(PTIME)*2);
g_date_subtract_days(doyS, days);
doy = g_date_new_julian(g_date_get_julian(doyS));
if (g_date_get_julian(stnSettings.display.dates[STARTDT]) < g_date_get_julian(doy))
{ 
stnStates.main.dateRng[PRVDTE].yr = g_date_get_year(doy);
stnStates.main.dateRng[PRVDTE].mo = g_date_get_month(doy);
stnStates.main.dateRng[PRVDTE].day = g_date_get_day(doy);
g_date_subtract_days(doy, days); 
stnStates.main.dateRng[PRVDTS].yr = g_date_get_year(doy);
stnStates.main.dateRng[PRVDTS].mo = g_date_get_month(doy);
stnStates.main.dateRng[PRVDTS].day = g_date_get_day(doy);
}
else
{
memset(&stnStates.main.dateRng[PRVDTS], 0, sizeof(PTIME)*2);
}
break;
case STNNEXTDT:
memcpy(&stnStates.main.dateRng[PRVDTS], &stnStates.main.dateRng[CURDTS], sizeof(PTIME)*2);
memcpy(&stnStates.main.dateRng[CURDTS], &stnStates.main.dateRng[NXTDTS], sizeof(PTIME)*2);
g_date_add_days(doyS, days);
doy = g_date_new_julian(g_date_get_julian(doyS));
g_date_add_days(doy, stnSettings.main.days);
if (g_date_get_julian(stnSettings.display.dates[ENDDT]) > g_date_get_julian(doy))
{ 
stnStates.main.dateRng[NXTDTS].yr = g_date_get_year(doy);
stnStates.main.dateRng[NXTDTS].mo = g_date_get_month(doy);
stnStates.main.dateRng[NXTDTS].day = g_date_get_day(doy);
g_date_add_days(doy, days);
stnStates.main.dateRng[NXTDTE].yr = g_date_get_year(doy);
stnStates.main.dateRng[NXTDTE].mo = g_date_get_month(doy);
stnStates.main.dateRng[NXTDTE].day = g_date_get_day(doy);
}
else
{
memset(&stnStates.main.dateRng[NXTDTS], 0, sizeof(PTIME)*2);
}
break;
}
#if 0
fprintf(stderr, "\naction: %d\tdoyS: %d/%d/%d\n", cmd, g_date_year(doyS), g_date_month(doyS), g_date_day(doyS));
fprintf(stderr, "CURDT: %d-%02d-%02d %d-%02d-%02d\n", 
stnStates.main.dateRng[CURDTS].yr, stnStates.main.dateRng[CURDTS].mo, stnStates.main.dateRng[CURDTS].day,
stnStates.main.dateRng[CURDTE].yr, stnStates.main.dateRng[CURDTE].mo, stnStates.main.dateRng[CURDTE].day);
fprintf(stderr, "PRVDT: %d-%02d-%02d %d-%02d-%02d\n", 
stnStates.main.dateRng[PRVDTS].yr, stnStates.main.dateRng[PRVDTS].mo, stnStates.main.dateRng[PRVDTS].day,
stnStates.main.dateRng[PRVDTE].yr, stnStates.main.dateRng[PRVDTE].mo, stnStates.main.dateRng[PRVDTE].day);
fprintf(stderr, "NXTDT: %d-%02d-%02d %d-%02d-%02d\n", 
stnStates.main.dateRng[NXTDTS].yr, stnStates.main.dateRng[NXTDTS].mo, stnStates.main.dateRng[NXTDTS].day,
stnStates.main.dateRng[NXTDTE].yr, stnStates.main.dateRng[NXTDTE].mo, stnStates.main.dateRng[NXTDTE].day);
#endif
if (doy)
g_date_free(doy);
return;
}
void initSTNData()
{
clearSTNList(&stnStates.main.stns[STNCURDT]);
clearSTNList(&stnStates.main.stns[STNNEXTDT]);
clearSTNList(&stnStates.main.stns[STNPREVDT]);
clearSTNList(&stnStates.NP[STNNEXTSTN].stns);
clearSTNList(&stnStates.NP[STNPREVSTN].stns);
if (stnStates.main.pdfList)
{
g_slist_free(stnStates.main.pdfList); 
stnStates.main.pdfList = NULL;
}
if (stnStates.main.chnList)
{
g_slist_free(stnStates.main.chnList); 
stnStates.main.chnList = NULL;
}
}
void makeSTNList()
{
GList  *stnI;
STNDATA  *stnD;
STNCHN  *stnCH;
int   i;
switch(stnStates.request.type)
{ 
case STNINIT:
{
GList *stnPtr, *stnList;
stnList = stnStates.main.stnList;
stnPtr = stnStates.main.startStn; 
initSTNData();
memset(&stnStates.main, 0, sizeof(stnStates.main));
memset(&stnStates.NP, 0, sizeof(stnStates.NP));
stnStates.main.stnList = stnList;
stnStates.main.startStn = stnPtr ? stnPtr : stnStates.main.stnList;
}
case STNCURDT:  
stnStates.main.endStn = stnCnt(stnStates.main.startStn, FORWARDS);
stnStates.NP[STNNEXTSTN].startStn = stnStates.main.endStn;
stnStates.NP[STNNEXTSTN].endStn = stnCnt(stnStates.NP[STNNEXTSTN].startStn, FORWARDS);
stnStates.NP[STNPREVSTN].endStn = stnStates.main.startStn;
stnStates.NP[STNPREVSTN].startStn = stnCnt(stnStates.NP[STNPREVSTN].endStn, BACKWARDS);
break;
case STNPREVSTN1: 
clearSTNList(&stnStates.NP[STNNEXTSTN].stns);
stnStates.NP[STNNEXTSTN].ttlChnCnt = 0;
stnStates.NP[STNNEXTSTN].stns = stnStates.main.stns[STNCURDT];
stnStates.NP[STNNEXTSTN].startStn = stnStates.main.startStn;
stnStates.NP[STNNEXTSTN].endStn = stnStates.main.endStn;
stnStates.NP[STNNEXTSTN].ttlChnCnt = stnStates.main.ttlChnCnt[STNCURDT];
stnStates.main.stns[STNCURDT] = stnStates.NP[STNPREVSTN].stns;
stnStates.main.startStn = stnStates.NP[STNPREVSTN].startStn;
stnStates.main.endStn = stnStates.NP[STNPREVSTN].endStn;
stnStates.main.ttlChnCnt[STNCURDT] = stnStates.NP[STNPREVSTN].ttlChnCnt;
clearSTNList(&stnStates.main.stns[STNPREVDT]);
clearSTNList(&stnStates.main.stns[STNNEXTDT]);
stnStates.main.ttlChnCnt[STNPREVDT] = 0;
stnStates.main.ttlChnCnt[STNNEXTDT] = 0;
memset(&stnStates.NP[STNPREVSTN], 0, sizeof(stnStates.NP[STNPREVSTN]));
stnStates.NP[STNPREVSTN].endStn = stnStates.main.startStn;
stnStates.NP[STNPREVSTN].startStn = stnCnt(stnStates.NP[STNPREVSTN].endStn, BACKWARDS);
break;
case STNNEXTSTN1: 
clearSTNList(&stnStates.NP[STNPREVSTN].stns);
stnStates.NP[STNPREVSTN].ttlChnCnt = 0;
stnStates.NP[STNPREVSTN].stns = stnStates.main.stns[STNCURDT];
stnStates.NP[STNPREVSTN].startStn = stnStates.main.startStn;
stnStates.NP[STNPREVSTN].endStn = stnStates.main.endStn;
stnStates.NP[STNPREVSTN].ttlChnCnt = stnStates.main.ttlChnCnt[STNCURDT];
stnStates.main.stns[STNCURDT] = stnStates.NP[STNNEXTSTN].stns;
stnStates.main.startStn = stnStates.NP[STNNEXTSTN].startStn;
stnStates.main.endStn = stnStates.NP[STNNEXTSTN].endStn;
stnStates.main.ttlChnCnt[STNCURDT] = stnStates.NP[STNNEXTSTN].ttlChnCnt;
clearSTNList(&stnStates.main.stns[STNPREVDT]);
clearSTNList(&stnStates.main.stns[STNNEXTDT]);
stnStates.main.ttlChnCnt[STNPREVDT] = 0;
stnStates.main.ttlChnCnt[STNNEXTDT] = 0;
memset(&stnStates.NP[STNNEXTSTN], 0, sizeof(stnStates.NP[STNNEXTSTN]));
stnStates.NP[STNNEXTSTN].startStn = stnStates.main.endStn;
stnStates.NP[STNNEXTSTN].endStn = stnCnt(stnStates.NP[STNNEXTSTN].startStn, FORWARDS);
break;
case STNPREVDT:  
clearSTNList(&stnStates.main.stns[STNNEXTDT]);
stnStates.main.stns[STNNEXTDT] = stnStates.main.stns[STNCURDT];
stnStates.main.ttlChnCnt[STNNEXTDT] = stnStates.main.ttlChnCnt[STNCURDT];
stnStates.main.stns[STNCURDT] = stnStates.main.stns[STNPREVDT];
stnStates.main.ttlChnCnt[STNCURDT] = stnStates.main.ttlChnCnt[STNPREVDT];
stnStates.main.ttlChnCnt[STNPREVDT] = 0;
stnStates.main.stns[STNPREVDT] = NULL;
clearSTNList(&stnStates.NP[STNNEXTSTN].stns);
clearSTNList(&stnStates.NP[STNPREVSTN].stns);
stnStates.NP[STNNEXTSTN].ttlChnCnt = 0;
stnStates.NP[STNPREVSTN].ttlChnCnt = 0;
stnStates.NP[STNNEXTSTN].startStn = stnStates.main.endStn;
stnStates.NP[STNNEXTSTN].endStn = stnCnt(stnStates.NP[STNNEXTSTN].startStn, FORWARDS);
stnStates.NP[STNPREVSTN].endStn = stnStates.main.startStn;
stnStates.NP[STNPREVSTN].startStn = stnCnt(stnStates.NP[STNPREVSTN].endStn, BACKWARDS);
break;
case STNNEXTDT:  
clearSTNList(&stnStates.main.stns[STNPREVDT]);
stnStates.main.stns[STNPREVDT] = stnStates.main.stns[STNCURDT];
stnStates.main.ttlChnCnt[STNPREVDT] = stnStates.main.ttlChnCnt[STNCURDT];
stnStates.main.stns[STNCURDT] = stnStates.main.stns[STNNEXTDT];
stnStates.main.ttlChnCnt[STNCURDT] = stnStates.main.ttlChnCnt[STNNEXTDT];
stnStates.main.ttlChnCnt[STNNEXTDT] = 0;
stnStates.main.stns[STNNEXTDT] = NULL;
clearSTNList(&stnStates.NP[STNNEXTSTN].stns);
clearSTNList(&stnStates.NP[STNPREVSTN].stns);
stnStates.NP[STNNEXTSTN].ttlChnCnt = 0;
stnStates.NP[STNPREVSTN].ttlChnCnt = 0;
stnStates.NP[STNNEXTSTN].startStn = stnStates.main.endStn;
stnStates.NP[STNNEXTSTN].endStn = stnCnt(stnStates.NP[STNNEXTSTN].startStn, FORWARDS);
stnStates.NP[STNPREVSTN].endStn = stnStates.main.startStn;
stnStates.NP[STNPREVSTN].startStn = stnCnt(stnStates.NP[STNPREVSTN].endStn, BACKWARDS);
break;
}
switch(stnStates.request.type)
{ 
case STNINIT:
case STNPREVDT:
case STNNEXTDT:
setDates(stnStates.request.type, stnSettings.main.days);
break;
}
for(i=STNCURDT;i<TTLPERIODSTNDATA;i++)
{
if (!stnStates.main.stns[i] && 
stnStates.main.dateRng[i*2].yr)
{
stnI = stnStates.main.startStn;
while (stnI != stnStates.main.endStn)
{ 
stnCH = (STNCHN *) ((GNode *)stnI->data)->data;
stnD = calloc(1, sizeof(STNDATA));
stnD->keys.stnKey = stnCH->key;
stnD->data.name = g_strdup_printf("%s.%s", stnCH->name1, stnCH->name2);
memcpy(&stnD->keys.dates[STARTDT].date, &stnStates.main.dateRng[i*2], sizeof(PTIME)); 
memcpy(&stnD->keys.dates[ENDDT].date, &stnStates.main.dateRng[i*2+1], sizeof(PTIME)); 
(void) chnCnt(stnI->data, CHNREG, stnD);
stnStates.main.stns[i] = g_slist_append(stnStates.main.stns[i], stnD);
stnI = g_list_next(stnI);
};
}
}
for(i=STNPREVSTN;i<TTLSTNSTNDATA;i++)
{
if (!stnStates.NP[i].stns)
{
stnI = stnStates.NP[i].startStn;
while (stnI && (stnI != stnStates.NP[i].endStn))
{ 
stnCH = (STNCHN *) ((GNode *)stnI->data)->data;
stnD = calloc(1, sizeof(STNDATA));
stnD->keys.stnKey = stnCH->key;
stnD->data.name = g_strdup_printf("%s.%s", stnCH->name1, stnCH->name2);
memcpy(&stnD->keys.dates[STARTDT].date, &stnStates.main.dateRng[CURDTS], sizeof(PTIME));
memcpy(&stnD->keys.dates[ENDDT].date, &stnStates.main.dateRng[CURDTE], sizeof(PTIME)); 
(void) chnCnt(stnI->data, CHNREG, stnD);
stnStates.NP[i].stns = g_slist_append(stnStates.NP[i].stns, stnD);
stnI = g_list_next(stnI);
}
}
}
#if 0
if (debugOUTPUT)
{
char timeStr[50]; TIMESTR(timeStr);
fprintf(stderr, "\n%smakeSTNList: cmd=%s\n", timeStr, STNcmds[stnStates.request.type]);
fprintf(stderr, "\tPRVSTN: stnCnt: %d\tstart: %d\tend: %d\tstns: %d\n", 
g_slist_length(stnStates.NP[0].stns), 
(int) stnStates.NP[0].startStn, 
(int) stnStates.NP[0].endStn, 
(int) stnStates.NP[0].stns);
fprintf(stderr, "\tCURSTN: stnCnt: %d\tstart: %d\tend: %d\tstns: %d\n", 
g_slist_length(stnStates.main.stns[0]), 
(int) stnStates.main.startStn, 
(int) stnStates.main.endStn, 
(int) stnStates.main.stns[0]);
fprintf(stderr, "\tNXTSTN: stnCnt: %d\tstart: %d\tend: %d\tstns: %d\n", 
g_slist_length(stnStates.NP[1].stns), 
(int) stnStates.NP[1].startStn, 
(int) stnStates.NP[1].endStn, 
(int) stnStates.NP[1].stns);
}
#endif
if (stnStates.request.type == STNINIT)
stnStates.request.type = STNCURDT; 
return;
}
gboolean chkRequest(int type)
{ 
gboolean ret=FALSE;
switch(type)
{
case STNPREVSTN1:
if (!stnStates.NP[STNPREVSTN].startStn)
ret=TRUE;
break;
case STNNEXTSTN1:
if (!stnStates.NP[STNNEXTSTN].startStn)
ret= TRUE;
break;
case STNPREVDT:
if (!stnStates.main.dateRng[PRVDTS].yr)
ret= TRUE;
break;
case STNNEXTDT:
if (!stnStates.main.dateRng[NXTDTS].yr)
ret= TRUE;
break;
}
return ret;
}
