#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_pdf.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
void initPDFFont();
void makeMSGstn(GdkPixmap *pxmp, int type, int w, int h)
{
char *msg=NULL;
switch(type)
{
case STNNOSRVR:
msg = g_strdup("No STN Server Connection");
break;
case STNBUSY:
msg = g_strdup("Retrieving Data...");
break;
case STNCNCT:
msg = g_strdup("Connecting...");
break;
case STNNOSEL:
msg = g_strdup("Nothing Selected...");
break;
case TTLSTNMSGS:
msg = g_strdup("Not Yet Functional...");
break;
}
fontDrawP(pxmp, msg, 
w/2 - fontSIZEP(msg, MSGF, WIDTH)/2, 
h/2 - fontSIZEP(msg, MSGF, HEIGHT)/2, 
MSGF, PDFFMSG);
free(msg);
return; 
}
static GdkPixmap *makeANA(GtkWidget *da, int scr)
{
GdkPixmap *pixmap;
int   dispState, width=da->allocation.width, height=da->allocation.height;
if (!ntw)
{ 
if (pqlxStates.conn.state == SRVRCONNECTING)
dispState = STNCNCT;
else
dispState = STNNOSRVR;
}
else 
{ 
dispState = stnStates.request.state;
if (!stnStates.analysis.traces)
{
dispState = STNNOSEL;
}
}
stnStates.analysis.plot.limits.selection.pix.left = 
stnStates.analysis.plot.limits.selection.pix.right = 0;
switch(dispState)
{
case STNNOSRVR:
case STNCNCT:
case STNNOSEL:
if (topLevel)
gdk_window_set_cursor(topLevel, NULL);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle (pixmap, pdfSettings.drawing.ctxts[STNMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGstn(pixmap, dispState, width, height);
stnStates.display.dataState = STNDRAWDONE;
break;
#if 0
case STNBUSY:
gdk_window_set_cursor(topLevel, hourCursor);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle (pixmap, pdfSettings.drawing.ctxts[STNMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGstn(pixmap, STNBUSY, width, height);
break;
#endif
case STNDRAW:
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle (pixmap, stnSettings.drawing.ctxts[scr][STNFGBG][ABNORMALGC], TRUE,
0, 0, width, height);
drawSTNana(pixmap);
break;
}
return pixmap; 
}
static GdkPixmap *makeSTN(GtkWidget *da, int scr)
{
GdkPixmap *pixmap, *pixmap2;
int   dispState, width=da->allocation.width, height=da->allocation.height;
char  *markup;
if (!(pdfSettings.drawing.ctxts[PDFMSG][NORMALGC]))
{
make_pdf_gc(da);
make_stn_gc(da);
initSTNFont();
initPDFFont();
}
if (!ntw)
{ 
if (pqlxStates.conn.state == SRVRCONNECTING)
dispState = STNCNCT;
else
dispState = STNNOSRVR;
}
else 
{
dispState = stnStates.request.state;
}
switch(dispState)
{
case STNNOSRVR:
case STNCNCT:
if (topLevel)
gdk_window_set_cursor(topLevel, NULL);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle (pixmap, pdfSettings.drawing.ctxts[STNMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGstn(pixmap, dispState, width, height);
stnStates.display.dataState = STNDRAWDONE;
break;
case STNBUSY:
if (topLevel)
gdk_window_set_cursor(topLevel, hourCursor);
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle (pixmap, pdfSettings.drawing.ctxts[STNMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGstn(pixmap, STNBUSY, width, height);
break;
case STNDRAW:
pixmap = gdk_pixmap_new(da->window, width, height, -1);
switch (stnSettings.main.data)
{
case STNCVG:
gdk_draw_rectangle (pixmap, 
stnSettings.drawing.ctxts[STNMAIN][STNFGBG][ABNORMALGC], TRUE,
0, 0, width, height);
drawSTNData(pixmap);
break;
case STNDTA:
stnStates.request.plotBUSY = TRUE;
setSensitive(STNSYSTEM, STNDATABUSYSENS, STNMAIN, FALSE);
gdk_draw_rectangle (pixmap, 
pdfSettings.drawing.ctxts[STNMSG][ABNORMALGC], TRUE,
0, 0, width, height);
makeMSGstn(pixmap, STNBUSY, width, height);
pixmap2 = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_rectangle (pixmap2, 
stnSettings.drawing.ctxts[STNMAIN][STNFGBG][ABNORMALGC], TRUE,
0, 0, width, height);
drawSTNData(pixmap2);
break;
}
if (stnStates.main.stnCnt == 1)
{
markup = g_markup_printf_escaped ("<span weight=\"bold\" foreground=\"white\">%d / %d</span>", 
stnStates.main.stnStrtNum, 
stnSettings.ttlStns);
}
else
{
markup = g_markup_printf_escaped ("<span weight=\"bold\" foreground=\"white\">%d - %d / %d</span>", 
stnStates.main.stnStrtNum, 
stnStates.main.stnStrtNum + stnStates.main.stnCnt - 1,
stnSettings.ttlStns);
}
gtk_label_set_markup (GTK_LABEL (stnCntLbl), markup); g_free (markup);
stnStates.pmap.dirty[STNMAIN][stnSettings.main.data] = FALSE;
if (topLevel)
gdk_window_set_cursor(topLevel, NULL);
break;
}
return pixmap; 
}
void makeSTNDrawing(int scr)
{
GtkWidget *da=STNDA[scr];
int  w = da->allocation.width, h = da->allocation.height;
dispMsgSTN(UNDISPLAY, NULL);
if (!da->window ||
stnStates.screen != scr ||
pqlxStates.system != STNSYSTEM)
{
return;
}
switch(scr)
{
case STNMAIN:  
if (!(stnSettings.drawing.ctxts[STNMAIN][STNMSG][NORMALGC]))
{
make_pdf_gc(da);
make_stn_gc(da);
initSTNFont();
initPDFFont();
}
if (stnStates.pmap.dirty[scr][stnSettings.main.data])
{
if (stnStates.pmap.main[stnSettings.main.data])
{
g_object_unref(stnStates.pmap.main[stnSettings.main.data]);
stnStates.pmap.main[stnSettings.main.data] = NULL;
}
stnStates.display.dataState = STNDRAWINIT;
stnStates.pmap.main[stnSettings.main.data] = makeSTN(da, scr);
}
break;
case STNANALYSIS:
if (stnStates.pmap.dirty[scr][0])
{
if (stnStates.pmap.analysis[PMAPBASE])
{
if (stnStates.pmap.analysis[PMAPBASE] !=
stnStates.pmap.analysis[PMAPVISIBLE])
g_object_unref(stnStates.pmap.analysis[PMAPVISIBLE]);
g_object_unref(stnStates.pmap.analysis[PMAPBASE]);
stnStates.pmap.analysis[PMAPBASE] =
stnStates.pmap.analysis[PMAPVISIBLE] = NULL;
}
stnStates.display.dataState = STNDRAWINIT;
stnStates.pmap.analysis[PMAPBASE] =
stnStates.pmap.analysis[PMAPVISIBLE] = makeANA(da,scr);
}
break;
}
if (pqlxStates.system == STNSYSTEM &&
scr != STNANALYSIS)
{
gtk_widget_queue_draw_area(da, 0, 0, w, h);  
}
}
gboolean _mkSTNDrawing(gpointer s)
{
int screen = GPOINTER_TO_INT(s);
makeSTNDrawing(screen);
return FALSE;
}
gboolean readDrawQ(gpointer nothing)
{
int drawEvent=STNNOREQ; 
gpointer Qevent;
while((Qevent = g_async_queue_try_pop(drawQ)))
{ 
drawEvent = GPOINTER_TO_INT(Qevent);
}
switch(drawEvent)
{
case STNREDRAWREQ:  
stnStates.pmap.dirty[stnStates.screen][stnSettings.main.data] = TRUE;
makeSTNDrawing(stnStates.screen);
break;
case STNREINITREQ:  
initSTNScreen(STNREINIT);
break;
}
return FALSE;
}
