#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
int ms_doy2md(int year, int jday, int *month, int *mday);
static GdkWindow *gdkWindow;
static void traceProc(GtkButton *button, gpointer action);
gboolean STN_cfg(GtkWidget *widget, GdkEventConfigure *event, gpointer s)
{ 
int i, screen = GPOINTER_TO_INT(s);
if (!hourCursor)
{
topLevel = gdk_window_get_toplevel(gtk_widget_get_parent_window(widget));
hourCursor = gdk_cursor_new_for_display(gdk_display_get_default (), GDK_WATCH);
}
if (widget->allocation.height==1 ||
!widget->window)
{ 
gtk_widget_queue_resize(widget);
return TRUE;
}
if (g_async_queue_length(drawQ))
return TRUE;
if (screen == stnStates.screen &&
stnStates.display.dataState != STNDRAWDONE)
{
g_async_queue_push(drawQ, GINT_TO_POINTER(STNREDRAWREQ));
return TRUE;
}
if (screen == stnStates.screen)
stnStates.display.dataState = STNDRAWINIT;
for(i=0;i<TTLSTNMAINDISPLAYMODES;i++)
{
stnStates.pmap.dirty[screen][i] = TRUE;
}
makeSTNDrawing(screen);
return TRUE;
}
gboolean STN_exp(GtkWidget *widget, GdkEventExpose *event, gpointer s)
{ 
GdkPixmap *pixmap=NULL;
int   screen = GPOINTER_TO_INT(s);
switch(screen)
{
case STNMAIN:
pixmap = stnStates.pmap.main[stnSettings.main.data];
break;
case STNANALYSIS:
pixmap = stnStates.pmap.analysis[PMAPVISIBLE];
break;
}
if (!pixmap)  
return TRUE;
gdk_draw_drawable(widget->window,
widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
pixmap,
event->area.x, event->area.y,
event->area.x, event->area.y,
event->area.width, event->area.height);
gdk_window_set_cursor(topLevel, NULL);
return TRUE;
}
void changeTabSTN(GtkNotebook *notebook, GtkWidget *page, guint new_page, gpointer nil)
{ 
if (stnStates.screen != new_page)
gtk_widget_hide(STNbuttons[stnStates.screen]);
stnStates.screen = new_page;
gtk_widget_show(STNbuttons[new_page]);
makeSTNDrawing(new_page);
}
void initSTNScreen(int initType)
{
switch(initType)
{
case STNINIT:
gdk_window_set_cursor(topLevel, hourCursor);
stnStates.request.state = STNBUSY;
stnStates.display.pdfCtr++;
g_slist_free(stnStates.main.pdfList); stnStates.main.pdfList = NULL;
g_slist_free(stnStates.main.chnList); stnStates.main.chnList = NULL;
stnStates.display.initiate = TRUE;
freeAllSTNData(); 
getAllSTNdata();
break;
case STNREINIT:
{
GList  *startStn = stnStates.main.startStn;
initSTNData();
stnStates.display.initiate = TRUE;
stnStates.request.type = STNINIT;
stnStates.main.startStn = startStn;
getAllSTNdata();
}
break;
}
}
void dispAdvance(GtkButton *button, gpointer d)
{
int  i, direction = GPOINTER_TO_INT(d);
if (stnStates.request.state == STNBUSY)
{ 
gdk_beep();
return;
}
stnStates.request.type = direction;
if (chkRequest(stnStates.request.type))
{ 
gdk_beep();
return;
}
if (stnStates.display.pdfBUSY)
{
stnStates.display.pdfRESET = TRUE;
}
if (stnStates.request.dataBUSY)
{
for(i=0;i<TTLSTNLOOKAHEADS;i++)
{
if(stnWidgets[i])
g_signal_handler_block(stnWidgets[i], stnSignals[i]);
}
stnStates.request.state = STNBUSY;
for(i=0;i<TTLSTNMAINDISPLAYMODES;i++)
{
stnStates.pmap.dirty[STNMAIN][i] = TRUE;
}
makeSTNDrawing(STNMAIN);
return;
}
initSTNScreen(STNINIT);
}
gint dispShift(GtkButton *button, gpointer d)
{
int  direction = GPOINTER_TO_INT(d);
GDate *doy=NULL;
if (stnStates.request.state == STNBUSY ||
!ntw)
{ 
gdk_beep();
return TRUE;
}
stnStates.request.type = STNINIT;
if (stnStates.display.pdfBUSY)
{
stnStates.display.pdfRESET = TRUE;
}
stnSettings.main.shiftDays = gtk_spin_button_get_value((GtkSpinButton *) ShiftDays);
doy = g_date_new_dmy(stnStates.main.dateRng[CURDTE].day, 
stnStates.main.dateRng[CURDTE].mo, 
stnStates.main.dateRng[CURDTE].yr);
switch(direction)
{
case STNSHIFTBACKWARD:
g_date_subtract_days(doy, stnSettings.main.shiftDays);
break;
case STNSHIFTFORWARD:
g_date_add_days(doy, stnSettings.main.shiftDays);
break;
}
if (g_date_get_julian(doy) > g_date_get_julian(stnSettings.display.dates[ENDDT]) ||
g_date_get_julian(doy) < g_date_get_julian(stnSettings.display.dates[STARTDT]))
{ 
char *msg = g_strdup("Cannot go beyond absolute dates of Database.");
gdk_beep();
dispMsgSTN(DISPLAY, msg);
free(msg);
}
else
{ 
stnStates.request.endDate = g_date_new_julian(g_date_get_julian(doy));
initSTNScreen(STNINIT);
}
g_date_free(doy);
return TRUE;
}
void stnDispChg(GtkToggleButton *button, gpointer d)
{ 
int  display = GPOINTER_TO_INT(d);
if (stnStates.request.state == STNBUSY)
{ 
gdk_beep();
switch(display)
{
case STNCVG:
g_signal_handler_block(stnDisp[STNDTA], stnSignals2[STNDISPDATASGNL][0]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnDisp[STNDTA]), TRUE);
g_signal_handler_unblock(stnDisp[STNDTA], stnSignals2[STNDISPDATASGNL][0]);
break;
case STNDTA:
g_signal_handler_block(stnDisp[STNCVG], stnSignals2[STNDISPCVGSGNL][0]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnDisp[STNCVG]), TRUE);
g_signal_handler_unblock(stnDisp[STNCVG], stnSignals2[STNDISPCVGSGNL][0]);
break;
}
return;
}
if (stnSettings.main.data == display)
return;
stnSettings.main.data = display;
stnStates.request.state = STNDRAW;
stnStates.display.dataState = STNDRAWINIT;
makeSTNDrawing(STNMAIN);
}
void stnRadio_chg(GtkToggleButton *radio, gpointer g)
{ 
int scr=stnStates.screen, i, grp = GPOINTER_TO_INT(g);
if (!gtk_toggle_button_get_active(radio))
return;  
switch(grp)
{
case STNOVERLAY:
{
gboolean prevOL;
prevOL = stnSettings.display.overlay[scr];
for(i=0;i<ON+1;i++)
{
if((GtkWidget *)radio == stnOverlay[scr][i])
{
break;
}
}
stnSettings.display.overlay[scr] = i;
if (stnSettings.display.overlay[scr] &&
(prevOL != stnSettings.display.overlay[scr]) &&
(stnSettings.display.yScale[scr] == DISPS))
{
stnSettings.display.yScale[scr] = WINDS;
setYScaleCbo(YSCALEWINDOW, scr);
}
stnStates.pmap.dirty[scr][0] = TRUE;
}
break;
case STNUNITS:
for(i=0;i<TTLSTNUNITS;i++)
{
if((GtkWidget *)radio == stnUnits[scr][i])
{
break;
}
}
stnSettings.display.units[scr] = i;
stnStates.pmap.dirty[scr][0] = stnStates.pmap.dirty[scr][1] = TRUE;
break;
case STNEPIORDER:
{
for(i=0;i<TTLDISPORDERS;i++)
{
if((GtkWidget *)radio == stnOrder[i])
{
break;
}
}
stnSettings.event.dispOrder = i;
stnStates.pmap.dirty[scr][0] = TRUE;
}
}
makeSTNDrawing(scr);
}
void stnRefresh(GtkWidget *entry, gpointer s)
{
int screen = GPOINTER_TO_INT(s);
switch(screen)
{
case STNMAIN:
stnStates.request.state = STNDRAW;
stnStates.pmap.dirty[screen][stnSettings.main.data] = TRUE;
stnStates.display.dataState = STNDRAWINIT;
break;
case STNANALYSIS:
stnStates.pmap.dirty[screen][0] = TRUE;
break;
}
makeSTNDrawing(screen);
}
static void getXY(GtkWidget *wi, int chnNum, int w, int h, int *x, int *y, int which)
{
int diff;
gtk_window_get_position(GTK_WINDOW(topWindow), x, y);
switch(which)
{
case STNCHNMETAPLT:
(*x) += wi->allocation.x + STNLFTM + 7;
diff = (int) ((chnNum*2)/stnStates.display.ttlChn) ? h*-1+30 : 5;
(*y) += wi->allocation.y + STNTOPM + (chnNum)*stnStates.display.chnH + 
diff + stnStates.display.chnH/2;
break;
case STNSTATSPLT:
case STNPDFPLT:
(*x) += wi->allocation.x + (wi->allocation.width-STNRGTM-w+2);
diff = (int) ((chnNum*2)/stnStates.display.ttlChn) ? h*-1 : 30;
(*y) += wi->allocation.y + STNTOPM + (chnNum)*stnStates.display.chnH +
stnStates.display.chnH/2 + diff;
break;
}
}
static GtkWidget *MetaWin;
static void stnChnMETA(GtkWidget *widget, GdkEventMotion *event)
{
static GtkWidget *view;
static GtkTextBuffer *buffer;
GtkTextIter iter, endIter;
gint x, y, chnNum = event->y/stnStates.display.chnH;
int  w=200, h;
CHNDATA *chnData;
CHNMETA *chnMeta;
GSList *chnIter;
GDate *dMetaS=NULL, *dMetaE=NULL, *dScrn;
gchar *str;
chnData = g_slist_nth_data(stnStates.main.chnList, chnNum);
if (!chnData)
return;
if (chnData->keys.chnKey == NONE)  
return;
if (!MetaWin)
{
GtkWidget  *frame;
MetaWin = gtk_window_new(GTK_WINDOW_POPUP);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
view = gtk_text_view_new();
buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW (view));
gtk_container_add(GTK_CONTAINER(MetaWin), frame);
gtk_container_add(GTK_CONTAINER(frame), view);
gtk_widget_hide(MetaWin);
gtk_text_buffer_create_tag(buffer, "heading", "justification", GTK_JUSTIFY_CENTER, 
"family", "monospace", 
NULL);
gtk_text_buffer_create_tag(buffer, "text", "family", "monospace", 
NULL);
}
gtk_text_buffer_get_iter_at_offset(buffer, &endIter, -1);
gtk_text_buffer_get_iter_at_offset(buffer, &iter, 0);
if (gtk_text_iter_get_offset(&endIter) > 0)
gtk_text_buffer_delete(buffer, &iter, &endIter);
str = g_strdup_printf("%s\n\n", chnData->data.longName);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "heading", NULL); free(str);
dScrn = g_date_new_dmy(stnStates.main.dateRng[CURDTS].day,
stnStates.main.dateRng[CURDTS].mo, 
stnStates.main.dateRng[CURDTS].yr);
for(chnIter = chnData->data.chnMETA; chnIter; chnIter=g_slist_next(chnIter))
{
chnMeta = chnIter->data;
dMetaS = g_date_new_dmy(chnMeta->dates[STARTDT].date.day,
chnMeta->dates[STARTDT].date.mo,
chnMeta->dates[STARTDT].date.yr);
dMetaE = g_date_new_dmy(chnMeta->dates[ENDDT].date.day,
chnMeta->dates[ENDDT].date.mo,
chnMeta->dates[ENDDT].date.yr);
if (g_date_get_julian(dScrn) >= g_date_get_julian(dMetaS) &&
g_date_get_julian(dScrn) < g_date_get_julian(dMetaE))
break;
g_date_free(dMetaS); dMetaS = NULL;
g_date_free(dMetaE); dMetaE = NULL;
}
if (!chnIter)
{
str = g_strdup(" No META-Data Available");
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
}
else
{
chnMeta = chnIter->data;
str = g_strdup_printf(" SiteName: %s \n", chnMeta->siteName);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Start: %04d/%02d/%02d \n",
chnMeta->dates[STARTDT].date.yr,
chnMeta->dates[STARTDT].date.mo, 
chnMeta->dates[STARTDT].date.day);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" End: %04d/%02d/%02d \n",
chnMeta->dates[ENDDT].date.yr,
chnMeta->dates[ENDDT].date.mo, 
chnMeta->dates[ENDDT].date.day);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Latitude: %-11.4f \n", chnMeta->coords[LAT]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Longitude: %-12.4f \n", chnMeta->coords[LON]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Elevation: %-6.1f \n", chnMeta->location[ELEV]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Depth: %-4.1f \n", chnMeta->location[DEPTH]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
if (!strncmp(chnMeta->units, "M/S", 3))
{
str = g_strdup_printf(" Sensitivity: %g Counts/(%s*) \n", chnMeta->sensitivity, chnMeta->units);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" : (* = counts/sensitivity \n");
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" : Valid Over Instrument Passband) \n");
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
}
else
{
str = g_strdup_printf(" Sensitivity: %f Counts/(%s) \n", chnMeta->sensitivity, chnMeta->units);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
}
str = g_strdup_printf(" Inst ID: %s \n", chnMeta->instID);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Azimuth: %-4.1f \n", chnMeta->location[AZIMUTH]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Dip: %-4.1f \n", chnMeta->location[DIP]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Sample Rate: %.1f sps ", 1000000./chnMeta->sampInt);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
}
gtk_window_resize(GTK_WINDOW(MetaWin), w, 1);
h = MetaWin->allocation.height;
getXY(widget, chnNum, w, h, &x, &y, STNCHNMETAPLT);
gtk_window_move(GTK_WINDOW(MetaWin), x, y);
gtk_widget_show_all(MetaWin);
g_date_free(dScrn);
if (dMetaS)
g_date_free(dMetaS);
if (dMetaE)
g_date_free(dMetaE);
}
static GtkWidget *StatsWin;
static void stnStats(GtkWidget *widget, GdkEventMotion *event)
{
static GtkWidget *view;
static GtkTextBuffer *buffer;
GtkTextIter iter, endIter;
gint x, y, chnNum = event->y/stnStates.display.chnH;
int  w=200, h=150;
CHNDATA *chnData;
gchar *str;
chnData = g_slist_nth_data(stnStates.main.chnList, chnNum);
if (!chnData)
return;  
if (!StatsWin)
{
GtkWidget  *frame;
StatsWin = gtk_window_new(GTK_WINDOW_POPUP);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
view = gtk_text_view_new ();
buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
gtk_container_add(GTK_CONTAINER(StatsWin), frame);
gtk_container_add(GTK_CONTAINER(frame), view);
gtk_widget_hide(StatsWin);
gtk_text_buffer_create_tag(buffer, "heading", "justification", GTK_JUSTIFY_CENTER,
"family", "monospace", 
NULL);
gtk_text_buffer_create_tag(buffer, "text", "family", "monospace", 
NULL);
}
if (chnData->keys.chnKey == NONE)
{ 
return;
}
gtk_text_buffer_get_iter_at_offset(buffer, &endIter, -1);
gtk_text_buffer_get_iter_at_offset(buffer, &iter, 0);
if (gtk_text_iter_get_offset(&endIter) > 0)
gtk_text_buffer_delete(buffer, &iter, &endIter);
str = g_strdup_printf("%s\n\n", chnData->data.longName);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "heading", NULL); free(str);
str = g_strdup_printf(" Start: %04d/%02d/%02d\n", 
stnStates.main.dateRng[CURDTS].yr,
stnStates.main.dateRng[CURDTS].mo, 
stnStates.main.dateRng[CURDTS].day);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" End: %04d/%02d/%02d\n",
stnStates.main.dateRng[CURDTE].yr,
stnStates.main.dateRng[CURDTE].mo, 
stnStates.main.dateRng[CURDTE].day);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Traces: %d\n", chnData->data.trcCnt);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Gaps: %d\n", chnData->display.numGaps);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Overlaps: %d\n", chnData->display.numOlaps);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
if (!(!chnData->display.stats[RELATIVE][MIN] && !chnData->display.stats[RELATIVE][MAX]))
{
if ((float) (chnData->display.stats[RELATIVE][MIN] - 
(int) chnData->display.stats[RELATIVE][MIN]) == 0.0)
{
if (chnData->display.stats[RELATIVE][MIN] < 0 &&
chnData->display.stats[RELATIVE][MAX] > 0)
{
str = g_strdup_printf(" Max: +%d \n", (int) chnData->display.stats[RELATIVE][MAX]);
}
else
{
str = g_strdup_printf(" Max: %d \n", (int) chnData->display.stats[RELATIVE][MAX]);
}
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Min: %d ", (int) chnData->display.stats[RELATIVE][MIN]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
}
else
{
if (chnData->display.stats[RELATIVE][MIN] < 0 &&
chnData->display.stats[RELATIVE][MAX] > 0)
{
str = g_strdup_printf(" Max: +%.10f \n", chnData->display.stats[RELATIVE][MAX]);
}
else
{
str = g_strdup_printf(" Max: %.10f \n", chnData->display.stats[RELATIVE][MAX]);
}
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
str = g_strdup_printf(" Min: %.10f ", chnData->display.stats[RELATIVE][MIN]);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "text", NULL); free(str);
}
}
getXY(widget, chnNum, w, h, &x, &y, STNSTATSPLT);
gtk_window_move(GTK_WINDOW(StatsWin), x, y);
gtk_window_resize(GTK_WINDOW(StatsWin), w, 1);
gtk_widget_show_all(StatsWin);
}
static GtkWidget *PDFWin;
static void stnPDF(GtkWidget *widget, GdkEventMotion *event)
{
static GtkWidget *view;
static GtkTextBuffer *buffer;
static GtkWidget *da;
PLOTPDFARGS plotPDFArgs;
PDFREQ  *pdfReq;
GdkPixmap *pixmap=NULL;
GtkTextIter iter, endIter;
gchar  *str;
CHNDATA *chnData;
gint x, y, chnNum = event->y/stnStates.display.chnH;
int  w=200, h=150, pw, ph;
chnData = g_slist_nth_data(stnStates.main.chnList, chnNum); 
if (!PDFWin)
{
GtkWidget  *frame, *vbox;
PDFWin = gtk_window_new(GTK_WINDOW_POPUP);
frame = gtk_frame_new(NULL);
vbox = gtk_vbox_new(FALSE, 0);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
view = gtk_text_view_new();
buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW (view));
gtk_text_buffer_create_tag(buffer, "heading", "justification", GTK_JUSTIFY_CENTER, NULL);
gtk_container_add(GTK_CONTAINER(PDFWin), frame);
gtk_container_add(GTK_CONTAINER(vbox), view);
da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(vbox), da);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_widget_show_all(PDFWin);
gtk_widget_hide(PDFWin);
}
gtk_text_buffer_get_iter_at_offset(buffer, &endIter, -1);
gtk_text_buffer_get_iter_at_offset(buffer, &iter, 0);
if (gtk_text_iter_get_offset(&endIter) > 0)
gtk_text_buffer_delete(buffer, &iter, &endIter);
str = g_strdup_printf("%s", chnData->data.longName);
gtk_text_buffer_insert_with_tags_by_name(buffer, &iter, str, -1, "heading", NULL); free(str);
pdfReq = g_slist_nth_data(stnStates.main.pdfList, chnNum);
if (!pdfReq || !pdfReq->data.pdf)
{ 
return;
}
pw = w-4; ph = h-4;
pixmap = gdk_pixmap_new(da->window, pw, ph, -1);
gdk_draw_rectangle(pixmap, pdfSettings.drawing.ctxts[STNMSG][ABNORMALGC], 
TRUE, 0, 0, pw, ph);
memset(&plotPDFArgs, 0, sizeof(PLOTPDFARGS));
plotPDFArgs.pmap = pixmap;
plotPDFArgs.req = (gpointer) pdfReq;
plotPDFArgs.width = pw-2;
plotPDFArgs.height = ph-2;
plotPDFArgs.scr = STNMAIN;
plotPDFArgs.type = STNICON;
plotPDFArgs.fdUnits = pdfSettings.common.fdUnits;
plotPDFArgs.hlnm = TRUE;
plotPDF(&plotPDFArgs);
gdk_draw_line(pixmap, stnSettings.drawing.ctxts[STNMAIN][STNTEXT][NORMALGC], 0, 0, pw-1, 0);
gdk_draw_line(pixmap, stnSettings.drawing.ctxts[STNMAIN][STNTEXT][NORMALGC], pw-1, 0, pw-1, ph-1);
gdk_draw_line(pixmap, stnSettings.drawing.ctxts[STNMAIN][STNTEXT][NORMALGC], pw-1, ph-1, 0, ph-1);
gdk_draw_line(pixmap, stnSettings.drawing.ctxts[STNMAIN][STNTEXT][NORMALGC], 0, ph-1, 0, 0);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_WIDGET_STATE (da)], 
pixmap, 0, 0, 0, 0, pw, ph);
getXY(widget, chnNum, w, h, &x, &y, STNPDFPLT);
gtk_window_move(GTK_WINDOW(PDFWin), x, y);
gtk_widget_set_size_request(da, pw, ph);
gtk_window_resize(GTK_WINDOW(PDFWin), 1, 1);
gtk_widget_show(PDFWin);
g_object_unref(pixmap);
}
static void plotBoxes(GdkPixmap *pixmap)
{ 
GSList  *boxIter;
GdkPoint rect[5];
GdkPoint *bboxData, *activeBox=stnStates.display.user.box.active;
if (!activeBox[POINT1].y)
{ 
if (stnStates.display.user.box.curChan < stnStates.display.user.box.chnStart)
{ 
activeBox[POINT1].y = (stnStates.display.user.box.curChan < 0
? 0
: stnStates.display.user.box.curChan)
* stnStates.display.chnH + STNTOPM+1;
activeBox[POINT2].y = (stnStates.display.user.box.chnStart+1) * stnStates.display.chnH + STNTOPM-1;
}
else if (stnStates.display.user.box.curChan > stnStates.display.user.box.chnStart)
{ 
activeBox[POINT1].y = stnStates.display.user.box.chnStart * stnStates.display.chnH + STNTOPM+1;
activeBox[POINT2].y = (stnStates.display.user.box.curChan+1 > stnStates.display.ttlChn 
? stnStates.display.ttlChn 
: stnStates.display.user.box.curChan+1) 
* stnStates.display.chnH + STNTOPM-1;
#if 0
activeBox[POINT2].y = (stnStates.display.user.box.curChan+1 > stnStates.main.ttlChnCnt[STNCURDT] 
? stnStates.main.ttlChnCnt[STNCURDT] 
: stnStates.display.user.box.curChan+1) * stnStates.display.chnH + STNTOPM-1;
fprintf(stderr, "ttlChan: %d\tcurChan: %d\n", stnStates.main.ttlChnCnt[STNCURDT], stnStates.display.user.box.curChan);
#endif
}
else
{ 
activeBox[POINT1].y = stnStates.display.user.box.chnStart * stnStates.display.chnH + STNTOPM+1;
activeBox[POINT2].y = (stnStates.display.user.box.chnStart+1) * 
stnStates.display.chnH + STNTOPM-1;  
}
}
for (boxIter = stnStates.display.user.box.list;
boxIter;
boxIter = g_slist_next(boxIter))
{
bboxData = boxIter->data;
rect[0].x = bboxData[POINT1].x; rect[0].y = bboxData[POINT1].y;
rect[1].x = bboxData[POINT2].x; rect[1].y = bboxData[POINT1].y;
rect[2].x = bboxData[POINT2].x; rect[2].y = bboxData[POINT2].y;
rect[3].x = bboxData[POINT1].x; rect[3].y = bboxData[POINT2].y;
rect[4].x = bboxData[POINT1].x; rect[4].y = bboxData[POINT1].y;
gdk_draw_lines(pixmap, stnSettings.drawing.ctxts[STNMAIN][STNTEXT][INVGC], rect, 5);
}
}
gboolean dragEventSTN(GtkWidget *widget, GdkEventMotion *event, gpointer s)
{
GdkModifierType  state;
gint x, y, yBdry, chnNum = (event->y-STNTOPM)/stnStates.display.chnH;
gint dragEvent=STNNOPLT, width=widget->allocation.width, height=widget->allocation.height;
int  screen = GPOINTER_TO_INT(s);
if (!gdkWindow)
gdkWindow = gdk_get_default_root_window();
if (stnStates.request.state != STNDRAW) 
return TRUE;
yBdry = chnNum * stnStates.display.chnH + stnStates.display.chnH/2;  
if ((event->x > width-STNRGTM+2) &&     
(event->y > yBdry-20 && event->y < yBdry) &&  
chnNum < stnStates.display.ttlChn &&    
stnStates.display.user.keyActive == NONE)   
{
dragEvent = STNSTATSPLT;
}
if ((event->x > width-STNRGTM+2) &&     
(event->y > yBdry && event->y < yBdry+20) &&  
chnNum < stnStates.display.ttlChn &&    
stnStates.display.user.keyActive == NONE)   
{
dragEvent = STNPDFPLT;
}
if ((event->x < STNLFTM) &&
(event->y > yBdry-10 &&
event->y < yBdry+10))
{
dragEvent = STNCHNMETAPLT;
}
if (
(stnStates.display.user.dragging == TRUE)  &&
(stnStates.display.user.mouseDown)    && 
(stnStates.display.user.action != NONE)   && 
(stnStates.display.user.box.active))
{
dragEvent = STNTRCSELPLT;
}
switch(dragEvent)
{
case STNNOPLT:
if (MetaWin)
gtk_widget_hide(MetaWin);
if (PDFWin)
gtk_widget_hide(PDFWin);
if (StatsWin)
gtk_widget_hide(StatsWin);
break;
case STNCHNMETAPLT:  
stnChnMETA(widget, event);
break;
case STNSTATSPLT:  
if (PDFWin)
gtk_widget_hide(PDFWin);
if (stnStates.display.initiate)
{
if (!stnStates.display.pdfBUSY)
{ 
makeThread(ASYNC, (GThreadFunc) getSTNpdf, NULL, NULL);
}
}
stnStates.display.initiate = FALSE;
stnStats(widget, event);
break;
case STNPDFPLT:   
if (StatsWin)
gtk_widget_hide(StatsWin);
stnPDF(widget, event);
break;
case STNTRCSELPLT:  
{
GdkPixmap *pixmap;
GtkWidget *da=STNDA[screen];
pixmap = gdk_pixmap_new(da->window, width, height, -1);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_STATE_NORMAL],
stnStates.pmap.main[stnSettings.main.data], 
0, 0, 0, 0, -1, -1);
if (event->x < STNLFTM)
event->x = STNLFTM;       
if ((event->x > width-STNRGTM))
event->x = width-STNRGTM;
stnStates.display.user.box.active[POINT2].x = event->x;
stnStates.display.user.box.curChan = chnNum;
stnStates.display.user.box.active[POINT1].y = 0; 
plotBoxes(pixmap);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], 
pixmap, 0, 0, 0, 0, -1, -1);
g_object_unref(pixmap);
}
break;
}
gdk_window_get_pointer(gdkWindow, &x, &y, &state);
return TRUE;
}
gboolean keyEventSTN(GtkWidget *widget, GdkEventKey *event, gpointer scr)
{ 
static gboolean called;
if (called && event->type != GDK_KEY_RELEASE)
return FALSE;
called=TRUE;
switch(event->type)
{
case GDK_KEY_PRESS:
switch(event->keyval)
{
case GDK_Control_L:
case GDK_Control_R:
stnStates.display.user.keyActive = CTRL;
stnStates.display.user.action = STNTRCPQLA;
break;
case GDK_Shift_L:
case GDK_Shift_R:
stnStates.display.user.keyActive = SHIFT;
stnStates.display.user.action = STNTRCPQLN;
break;
case GDK_a:
stnStates.display.user.keyActive = ALT;
stnStates.display.user.action = STNTRCANAN;
break;
case GDK_s:
stnStates.display.user.keyActive = ALT;
stnStates.display.user.action = STNTRCANAA;
break;
}
break;
case GDK_KEY_RELEASE:
called = FALSE;
stnStates.display.user.valid = FALSE;
switch(stnStates.display.user.action)
{
case STNTRCPQLA:  
case STNTRCPQLN:  
case STNTRCDATA:  
case STNTRCANAN:  
case STNTRCANAA:  
traceProc(NULL, GINT_TO_POINTER(stnStates.display.user.action));
break;
}
stnStates.display.user.action = NONE;
stnStates.display.user.keyActive = NONE;
break;
default:  
break;
}  
return TRUE;
}
static void drawSTNMAINLabel(CHNDATA *chnData, int chnNum)
{
int   labelW, labelH, y;
GdkPixmap *pmap = stnStates.pmap.main[stnSettings.main.data];
if (!chnData->data.name) 
return;
labelW = fontSIZEP(chnData->data.name, STNLBLF, WIDTH);
labelH = fontSIZEP(chnData->data.name, STNLBLF, HEIGHT);
y = stnStates.display.chnH * chnNum + stnStates.display.chnH/2 + STNTOPM;
switch(chnData->display.selected)
{
case FALSE:
fontDrawP(pmap, chnData->data.name, STNLFTM/2 - labelW/2, y - labelH/2, STNLBLF, STNFLBL);
break;
case TRUE:
fontDrawPRev(pmap, chnData->data.name, STNLFTM/2 - labelW/2, y - labelH/2, STNLBLF, STNFLBL, 0);
break;
}
gtk_widget_queue_draw_area(STNDA[STNMAIN], 0, y-labelH-1, STNLFTM, labelH*2); 
}
gboolean mouseEventSTN(GtkWidget *widget, GdkEventButton *event, gpointer s)
{ 
gint chnNum = (event->y-STNTOPM)/stnStates.display.chnH, yBdry;
int  width=widget->allocation.width, height=widget->allocation.height;
int  stnNum=0, dayNum=0, screen = GPOINTER_TO_INT(s);
stnStates.display.user.event = STNNOPLT;
yBdry = chnNum * stnStates.display.chnH + stnStates.display.chnH/2;
if ((event->x > widget->allocation.width-STNRGTM) && 
(event->y > yBdry && event->y < yBdry+20) &&  
chnNum < stnStates.display.ttlChn)   
{
stnStates.display.user.event = STNPDFPLT;
}
if ((event->x < widget->allocation.width-STNRGTM) && 
(event->x > STNLFTM) &&
(chnNum < stnStates.display.ttlChn))
{
stnStates.display.user.event = STNTRCSELPLT;
}
switch(stnStates.display.user.keyActive)
{
case NONE:
if ((event->x < STNLFTM) &&
(event->y > STNTOPM && event->y < height - STNBOTM))
stnStates.display.user.event = STNCHNSELECT;
break;
default: 
if ((event->x < STNLFTM) && 
(event->y < height - STNBOTM))
{
GSList *stnIter;
STNDATA *stnData;
GdkPoint *point;
stnIter = stnStates.main.stns[STNCURDT];
while(stnIter)
{
stnData = stnIter->data;
point = stnData->display.pixelPos;
if ((event->x >= point[FNTLFTT].x) &&
(event->x <= point[FNTRGTB].x) &&
(event->y >= point[FNTLFTT].y) &&
(event->y <= point[FNTRGTB].y))
{
stnStates.display.user.event = STNTRCSELSTN;
break;
}
stnIter = g_slist_next(stnIter);
stnNum++;
}
if (stnStates.display.user.event != STNTRCSELSTN)
{
stnStates.display.user.event = STNTRCSELCHN;
}
}
if ((event->y >= height-STNBOTM) &&
(event->x >= STNLFTM && event->x <= width-STNRGTM))
{
dayNum = (event->x-STNLFTM)/stnStates.display.dayW;
stnStates.display.user.event = STNTRCSELDAY;
}
break;
}
switch(stnStates.display.user.event)
{
case STNPDFPLT:
{
static SOURCEINFO sysInfo;
if (event->type == GDK_BUTTON_RELEASE)
{
PDFREQ *pdfReq=g_slist_nth_data(stnStates.main.pdfList, chnNum);
if (!pdfReq || (pdfReq->data.numRecs == NOPSDDATA)) 
break;
if (stnStates.display.pdfBUSY)
stnStates.display.pdfRESET = TRUE;
if (PDFWin)
gtk_widget_hide(PDFWin);
pdfReq->keys.fillTmp = FALSE;   
pdfReq->keys.tmpFilled = FALSE; 
PDFinitDetail(pdfReq, TRUE);
sysInfo.destSystem = PDFSYSTEM;
sysInfo.destTab = PDFDETAIL;
systemChg(NULL, (gpointer) &sysInfo);
}
}
break;
case STNTRCSELPLT:
if (event->type == GDK_BUTTON_RELEASE)
{ 
stnStates.display.user.mouseDown = FALSE;
stnStates.display.user.dragging = FALSE;
}
else
{ 
stnStates.display.user.mouseDown = TRUE;
stnStates.display.user.box.chnStart = chnNum;
if (stnStates.display.user.keyActive != NONE)
{
stnStates.display.user.box.active = calloc(2, sizeof(GdkPoint));
stnStates.display.user.box.list = g_slist_prepend(stnStates.display.user.box.list, 
stnStates.display.user.box.active);
stnStates.display.user.box.active[POINT1].x = event->x;
stnStates.display.user.box.active[POINT2].x = 0;
stnStates.display.user.dragging = TRUE;
}
}
break;
case STNTRCSELSTN:
if (event->type == GDK_BUTTON_RELEASE &&
!stnStates.display.user.dragging)
{
STNDATA *stnData = g_slist_nth_data(stnStates.main.stns[STNCURDT], stnNum);
stnStates.display.user.box.active = calloc(2, sizeof(GdkPoint));
stnStates.display.user.box.list = g_slist_prepend(stnStates.display.user.box.list, 
stnStates.display.user.box.active);
stnStates.display.user.box.active[POINT1].x = STNLFTM;
stnStates.display.user.box.active[POINT1].y = STNTOPM + 
stnStates.display.chnH * stnData->display.chnCntPre+1;
stnStates.display.user.box.active[POINT2].x = width - STNRGTM;
stnStates.display.user.box.active[POINT2].y = STNTOPM + stnStates.display.chnH * 
(stnData->data.numChannels + stnData->display.chnCntPre)-1;
}
break;
case STNTRCSELCHN:
if (event->type == GDK_BUTTON_RELEASE &&
!stnStates.display.user.dragging)
{
stnStates.display.user.box.active = calloc(2, sizeof(GdkPoint));
stnStates.display.user.box.list = g_slist_prepend(stnStates.display.user.box.list, 
stnStates.display.user.box.active);
stnStates.display.user.box.active[POINT1].x = STNLFTM;
stnStates.display.user.box.active[POINT1].y = STNTOPM + stnStates.display.chnH * chnNum + 1;
stnStates.display.user.box.active[POINT2].x = width - STNRGTM;
stnStates.display.user.box.active[POINT2].y = STNTOPM + stnStates.display.chnH * (chnNum+1) - 1;
}
break;
case STNTRCSELDAY:
{
int yaxisw = (stnSettings.display.yAxis[screen] ? YAXISW : 0 );
if (event->type == GDK_BUTTON_RELEASE &&
!stnStates.display.user.dragging)
{
stnStates.display.user.box.active = calloc(2, sizeof(GdkPoint));
stnStates.display.user.box.list = g_slist_prepend(stnStates.display.user.box.list, 
stnStates.display.user.box.active);
stnStates.display.user.box.active[POINT1].x = STNLFTM + yaxisw + 
dayNum*stnStates.display.dayW + 1;
stnStates.display.user.box.active[POINT1].y = STNTOPM+1;
stnStates.display.user.box.active[POINT2].x = STNLFTM + yaxisw + 
(dayNum+1)*stnStates.display.dayW - 1;
stnStates.display.user.box.active[POINT2].y = STNTOPM + 
(stnStates.display.ttlChn)*stnStates.display.chnH - 1;
}
}
break;
}
if (event->type == GDK_BUTTON_RELEASE)
switch(stnStates.display.user.event)
{
case STNTRCSELSTN:
case STNTRCSELCHN:
case STNTRCSELDAY:
{
GdkPixmap *pixmap;
pixmap = gdk_pixmap_new(widget->window, width, height, -1);
gdk_draw_drawable(pixmap, widget->style->fg_gc[GTK_STATE_NORMAL],
stnStates.pmap.main[stnSettings.main.data],
0, 0, 0, 0, -1, -1);
plotBoxes(pixmap);
gdk_draw_drawable(widget->window, widget->style->fg_gc[GTK_STATE_NORMAL], 
pixmap, 0, 0, 0, 0, -1, -1);
g_object_unref(pixmap);
}
break;
case STNCHNSELECT:
{
CHNDATA *chnData;
int chnNum = event->y/stnStates.display.chnH;
chnData = g_slist_nth_data(stnStates.main.chnList, chnNum);
if (!chnData)
break;
chnData->display.selected = !chnData->display.selected;
drawSTNMAINLabel(chnData, chnNum);
makeSTNSelectionList(STNMAIN);
}  
}
return TRUE;
}  
GSList *trcList, *trcsToMarry;
static int registerTraces(TRCDATA *trcData, gpointer a)
{
int action = GPOINTER_TO_INT(a);
if (!((stnStates.display.user.box.active[POINT1].x >= trcData->display.pixelPos[STARTDT] &&
stnStates.display.user.box.active[POINT1].x <= trcData->display.pixelPos[ENDDT]) ||
(stnStates.display.user.box.active[POINT1].x <= trcData->display.pixelPos[STARTDT] &&
stnStates.display.user.box.active[POINT2].x >= trcData->display.pixelPos[ENDDT]) ||
(stnStates.display.user.box.active[POINT2].x >= trcData->display.pixelPos[STARTDT] &&
stnStates.display.user.box.active[POINT2].x <= trcData->display.pixelPos[ENDDT])))
return FALSE;   
if (!trcData->display.plot)
return FALSE;   
switch(action)
{
case STNTRCPQLA:
case STNTRCPQLN:
case STNTRCEVTA:
case STNTRCEVTN:
case STNTRCANAA:
case STNTRCANAN:
{
PQLDATA *pqlIn;
traceInfo *trc;
pqlIn = calloc(1, sizeof(PQLDATA));
if (trcData->display.trc)
{ 
trc = pqlIn->trc = trcData->display.trc;
trc->data.sticky = TRUE;    
}
else
{ 
pqlIn->fileName = g_strdup(trcData->data.name);
}
pqlIn->trcData = trcData;
trcsToMarry = g_slist_prepend(trcsToMarry, pqlIn);
}
break;
case STNTRCDATA:
{ 
trcData->display.data = STNDTA;
}
break;
}
return FALSE;
}
gint sortTrcs(PQLDATA *pql1, PQLDATA *pql2)
{
TRCDATA *trc1=pql1->trcData, *trc2=pql2->trcData;
return (trc1->display.pixelPos[STARTDT] - trc2->display.pixelPos[STARTDT]);
}
static void traceProc(GtkButton *button, gpointer a)
{
int   startChn, endChn, chnNum, startX, endX, action = GPOINTER_TO_INT(a);
CHNDATA  *chnData;
GSList  *bboxIter, *trcIter;
GtkWidget *da = STNDA[STNMAIN];
if (!stnStates.display.user.box.list)  
return;
if (stnStates.display.user.box.active[POINT1].x == 
stnStates.display.user.box.active[POINT2].x)
{ 
gdk_beep();
free(stnStates.display.user.box.active);
g_slist_free(stnStates.display.user.box.list);
stnStates.display.user.box.list = NULL;
g_slist_free(stnStates.main.selections);
stnStates.main.selections = NULL;
return;
}
gdk_window_set_cursor(topLevel, hourCursor);
while(gtk_events_pending())
gtk_main_iteration();
trcsToMarry = NULL;
for(bboxIter=stnStates.display.user.box.list;
bboxIter;
bboxIter=g_slist_next(bboxIter))
{
stnStates.display.user.box.active = bboxIter->data;
if (stnStates.display.user.box.active[POINT1].x > stnStates.display.user.box.active[POINT2].x)
{ 
int x;
x = stnStates.display.user.box.active[POINT1].x;
stnStates.display.user.box.active[POINT1].x = stnStates.display.user.box.active[POINT2].x;
stnStates.display.user.box.active[POINT2].x = x;
}
startChn = stnStates.display.user.box.active[POINT1].y/stnStates.display.chnH;
endChn = stnStates.display.user.box.active[POINT2].y/stnStates.display.chnH;
startX = stnStates.display.user.box.active[POINT1].x;
endX = stnStates.display.user.box.active[POINT2].x;
for(chnNum = startChn; chnNum < endChn+1; chnNum++)
{
chnData = g_slist_nth_data(stnStates.main.chnList, chnNum);
if (stnStates.main.selections &&
!chnData->display.selected) 
continue;
chnData->display.selected = FALSE; 
drawSTNMAINLabel(chnData, chnNum);
if (chnData->display.trcData)
{ 
registerTraces(chnData->display.trcData, a);
}
else
{ 
g_slist_foreach(chnData->data.traceFiles, (GFunc) registerTraces, a);
trcsToMarry = g_slist_sort(trcsToMarry, (GCompareFunc) sortTrcs);
}
switch(g_slist_length(trcsToMarry))
{ 
double startE, endE;
case 0:
break;
case 1:  
startE = GDate2Epoch(PIX2USERX(&stnStates.main.mainGR, startX));
endE = GDate2Epoch(PIX2USERX(&stnStates.main.mainGR, endX));
trcList = g_slist_append(trcList, cutTrc(trcsToMarry->data, startE, endE));
break;
default: 
startE = GDate2Epoch(PIX2USERX(&stnStates.main.mainGR, startX));
endE = GDate2Epoch(PIX2USERX(&stnStates.main.mainGR, endX));
trcList = g_slist_append(trcList, marryTrcs(trcsToMarry, startE, endE));
break;
}
g_slist_free(trcsToMarry);
trcsToMarry = NULL;
}
free(stnStates.display.user.box.active);
}
g_slist_free(stnStates.display.user.box.list); stnStates.display.user.box.list = NULL;
g_slist_free(stnStates.main.selections);   stnStates.main.selections = NULL;
if (!trcList || !trcList->data)
{
gdk_beep();
gdk_window_set_cursor(topLevel, NULL);
gtk_widget_queue_draw_area(da, 0, 0, da->allocation.width, da->allocation.height);
return;
}
switch(action)
{
case STNTRCPQLN:  
kill_all_traces(ALL);
case STNTRCPQLA:  
{
static SOURCEINFO sysInfo;
memset(&sysInfo, 0, sizeof(SOURCEINFO));
states.input.Files = trcList;
states.input.numFiles = g_slist_length(trcList);
sysInfo.destSystem = PQLSYSTEM;
sysInfo.destTab = (g_slist_length(trcList) > settings.trace.numPlots) 
? PQLTRC
: stnSettings.pqlDest;
sysInfo.yaxis.scale = DISPS;
systemChg(NULL, (gpointer) &sysInfo);
}
break;
case STNTRCDATA:
stnStates.request.state = STNBUSY;
makeSTNDrawing(STNMAIN);
stnStates.request.state = STNDRAW;
makeSTNDrawing(STNMAIN);
break;
case STNTRCANAN:
{
PQLDATA *pqlIn;
for(trcIter=stnStates.analysis.traces;trcIter;trcIter=g_slist_next(trcIter))
{
pqlIn = trcIter->data;
freeMyData(TRCINFO, pqlIn->trc);
free(pqlIn->trc);
freeMyData(ANAINFO, pqlIn->anaData);
free(pqlIn->anaData);
free(pqlIn);
}
g_slist_free(stnStates.analysis.traces);
stnStates.analysis.traces = NULL;
stnStates.analysis.tForm.common = TRUE;
stnStates.analysis.tForm.list = FALSE;
if (stnStates.analysis.tForm.tForms)
{
g_hash_table_destroy(stnStates.analysis.tForm.tForms); 
stnStates.analysis.tForm.tForms = NULL;
}
clearArrivals(stnStates.event.arrivals);
stnStates.event.arrivals = NULL;
IFFREE(stnStates.analysis.tForm.tFormStr);
}
case STNTRCANAA:
g_slist_free(stnStates.analysis.selections); stnStates.analysis.selections = NULL;
stnStates.analysis.traces = g_slist_concat(stnStates.analysis.traces, trcList);
stnStates.pmap.dirty[STNANALYSIS][0] = TRUE;
stnStates.analysis.plot.limits.selection.user.left = 0;
stnStates.analysis.plot.limits.selection.user.right = 0;
gtk_notebook_set_current_page((GtkNotebook *) STNscreens, STNANALYSIS);
break;
}
trcList=NULL;   
}
gboolean grabFocusSTN(GtkWidget *widget, GdkEvent *event, gpointer scr)
{ 
int  screen = GPOINTER_TO_INT(scr);
if (event->type == GDK_ENTER_NOTIFY)
gtk_grab_add(GTK_WIDGET (widget));
else
{ 
switch(screen)
{
case STNMAIN:  
if (MetaWin)
gtk_widget_hide(MetaWin);
if (PDFWin) 
gtk_widget_hide(PDFWin);
if (StatsWin)
gtk_widget_hide(StatsWin);
if (stnStates.display.user.keyActive == NONE)
gtk_grab_remove(GTK_WIDGET (widget));
break;
case STNANALYSIS:
if (AnalysesString)
gtk_widget_hide(AnalysesString);
gtk_grab_remove(GTK_WIDGET (widget));
break;
default:
gtk_grab_remove(GTK_WIDGET (widget));
break;
}
}
return TRUE;
}
void restore_STNdefaults(GtkButton *widget, gpointer nothing)
{
read_STNdefaults(&stnSettings);
setStnCtrlSettings();
}
void save_STNdefaults(GtkButton *button, STNSETTINGS *save)
{
int  i;
getStnCtrlSettings();
for (i=0; i<TTLPOPUPWIN; i++)
{
if (stnStates.analysis.popup[i].same.win)
{
gtk_window_get_size((GtkWindow*)stnStates.analysis.popup[i].same.win,
&save->analysis.popup.dims[i].width,
&save->analysis.popup.dims[i].height);
gtk_window_get_position((GtkWindow*)stnStates.analysis.popup[i].same.win, 
&save->analysis.popup.dims[i].xPos,
&save->analysis.popup.dims[i].yPos);
}
}
write_STNdefaults(save);
if (stnSettings.general.startup)
setSystemStartup(STNSYSTEM);
else
setSystemStartup(PDFSYSTEM);
}
void setStnFiltCbos()
{
int  i, j;
static int prevNumCBOEntries=0;
g_signal_handler_block(stnFltrCbos[STNMAIN], stnSignals2[STNFLTCBOSGNL][STNMAIN]);
g_signal_handler_block(stnFltrCbos[STNANALYSIS], stnSignals2[STNFLTCBOSGNL][STNANALYSIS]);
for(i=0;i<TTLSTNSCREENS;i++)
{
if (!stnFltrCbos[i])
continue;
for(j=prevNumCBOEntries;j>=0;j--)
gtk_combo_box_remove_text(GTK_COMBO_BOX(stnFltrCbos[i]), j);
switch(i)
{
case STNMAIN:
gtk_combo_box_append_text(GTK_COMBO_BOX(stnFltrCbos[i]), "NONE");
break;
case STNANALYSIS:
gtk_combo_box_append_text(GTK_COMBO_BOX(stnFltrCbos[i]), "Filters");
break;
}
gtk_combo_box_set_active(GTK_COMBO_BOX(stnFltrCbos[i]), 0);
for(j=0;j<settings.general.filter.numFilters;j++)
{ 
gtk_combo_box_append_text(GTK_COMBO_BOX(stnFltrCbos[i]), settings.general.filter.filts[j]->name);
}
gtk_combo_box_append_text(GTK_COMBO_BOX(stnFltrCbos[i]), FLTEDITSTR);
}
g_signal_handler_unblock(stnFltrCbos[STNMAIN], stnSignals2[STNFLTCBOSGNL][STNMAIN]);
g_signal_handler_unblock(stnFltrCbos[STNANALYSIS], stnSignals2[STNFLTCBOSGNL][STNANALYSIS]);
prevNumCBOEntries = settings.general.filter.numFilters + 1;
}
void stnApplyFilter(GtkToggleButton *button, gpointer s)
{ 
int screen = GPOINTER_TO_INT(s);
switch(screen)
{
case STNMAIN:
if (stnStates.display.dataFilter.active == NONE)
return;
break;
case STNANALYSIS:
if (stnStates.analysis.dataFilter.active == NONE)
return;
break;
}
switch(screen)
{
case STNMAIN:
if (button)
stnStates.display.dataFilter.on = !gtk_toggle_button_get_active(button);
stnStates.pmap.dirty[STNMAIN][stnSettings.main.data] = TRUE;
stnStates.request.state = STNDRAW;
stnStates.display.dataState = STNDRAWINIT;
break;
case STNANALYSIS:
stnStates.pmap.dirty[screen][0] = TRUE;
break;
}
makeSTNDrawing(screen);
}
gboolean stnIdleFilter(gpointer a)
{
int screen = stnStates.screen;
int active = GPOINTER_TO_INT(a);
switch(screen)
{
case STNMAIN:
stnStates.display.dataFilter.active = active;
setSensitive(STNSYSTEM, STNNOFILTERSENS, STNMAIN, TRUE);
stnStates.display.dataFilter.on = TRUE;
g_signal_handler_block(stnFilter[screen][OFF], stnSignals2[STNFLTSGNL][screen]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(stnFilter[screen][ON]), TRUE);
g_signal_handler_unblock(stnFilter[screen][OFF], stnSignals2[STNFLTSGNL][screen]);
break;
case STNANALYSIS:
stnStates.analysis.dataFilter.active = active;
stnStates.analysis.tForm.transform = ANAFILTER;
break;
}
stnApplyFilter(NULL, GINT_TO_POINTER(screen));
if (active >= FILTERCUSTOMLISTNUM)
{ 
g_signal_handler_block(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
gtk_combo_box_set_active(GTK_COMBO_BOX(stnFltrCbos[screen]), 0);
g_signal_handler_unblock(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
}
return FALSE;
}
void displayFilter(int , gboolean );
void stnFltrSelect(GtkComboBox *combo, gpointer s)
{ 
int filtType, screen = stnStates.screen;
int active = gtk_combo_box_get_active(combo);
if (active == FILTTITLE)  
{
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(stnFilter[screen][OFF]), TRUE);
return;
}
active--;
filtType = FILTNORMAL;
if (active == FILTERCUSTOMLISTNUM)
filtType = FILTCUSTOM;
if (active == FILTERCUSTOMLISTNUM+1)
filtType = FILTEDIT;
switch (filtType)
{
case FILTEDIT:  
displayFilter(FILTERLIST, FALSE);
g_signal_handler_block(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
gtk_combo_box_set_active(GTK_COMBO_BOX(stnFltrCbos[screen]), 0);
g_signal_handler_unblock(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
return;
break;
case FILTCUSTOM:  
displayFilter(FILTERCUSTOM, FALSE);
g_signal_handler_block(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
gtk_combo_box_set_active(GTK_COMBO_BOX(stnFltrCbos[screen]), 0);
g_signal_handler_unblock(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
return;
break;
case FILTNORMAL:
stnIdleFilter(GINT_TO_POINTER(active));
if (screen == STNANALYSIS)
{ 
g_signal_handler_block(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
gtk_combo_box_set_active(GTK_COMBO_BOX(stnFltrCbos[screen]), 0);
g_signal_handler_unblock(stnFltrCbos[screen], stnSignals2[STNFLTCBOSGNL][screen]);
}
break;
} 
}
