#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
enum {
STNSTNLIST,
STNINSTLIST
};
enum {
NTWSTORE,
STNSTORE,
LOCSTORE,
INSTSTORE,
TTLSTORES,
LOCSTORE1
};
enum {
STNSTARTDAY,
STNENDDAY,
TTLSTNDAYRANGE
};
enum {
DR_START,
DR_END,
DR_BOTH,
DR_DAYS,
TTLDRCOMBOS
};
static GtkTooltips  *tips;
static char   toolTip[1000];
static GtkWidget *STNstnVIEW[TTLSTORES], *STNDate[TTLSTNDAYRANGE], *STNDispDays;
static void stationSel(GtkTreeSelection *selection, gpointer w);
static void stationCBack(GtkButton *button, gpointer t);
INSTRUMENTS instruments;
enum {
STNCXL,
STNDONE
};
enum {
STNSTN,
STNLOC,
TTLSTNLISTS
};
enum {
STNINST,
TTLSTNINSTS
};
static GtkListStore *stores[TTLSTORES];
static GSList  *displayed[TTLSTNLISTS]; 
static GSList  *selected[TTLSTNLISTS];  
static GSList  *dispInst[TTLSTNINSTS];  
static GSList  *selectInst[TTLSTNINSTS]; 
static void getDate(GtkButton *button, gpointer w)
{
static GtkWidget *dialog[TTLSTNDAYRANGE], *calendar[TTLSTNDAYRANGE];
GtkWidget *text;
char  *titleStr=NULL;
int   which = GPOINTER_TO_INT(w);
text = STNDate[which];
switch(which)
{
case STNSTARTDAY:
titleStr = g_strdup("Start Day");
break;
case STNENDDAY:
titleStr = g_strdup("END Day");
break;
}
if (!dialog[which])
{
dialog[which] = gtk_dialog_new_with_buttons(titleStr,
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
free(titleStr);
calendar[which] = gtk_calendar_new();
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog[which])->vbox), calendar[which]);
gtk_widget_show_all(dialog[which]);
}
else
{
gtk_widget_show(dialog[which]);
}
gtk_calendar_select_month(GTK_CALENDAR(calendar[which]), 
g_date_get_month(stnSettings.display.dates[ENDDT])-1, 
g_date_get_year(stnSettings.display.dates[ENDDT]));
gtk_calendar_select_day(GTK_CALENDAR(calendar[which]), 
g_date_get_day(stnSettings.display.dates[ENDDT]));
if (gtk_dialog_run(GTK_DIALOG(dialog[which])) == GTK_RESPONSE_OK)
{
guint year, month, day;
char *dateStr;
gtk_calendar_get_date(GTK_CALENDAR(calendar[which]), &year, &month, &day);
dateStr = g_strdup_printf("%i/%02d/%02d", year, month+1, day);
gtk_entry_set_text(GTK_ENTRY(text), dateStr);
free(dateStr);
}
gtk_widget_hide(dialog[which]);
gtk_window_present(GTK_WINDOW(STNstnList));
}
static void destroyStnStations(GtkButton *button, void *nothing)
{
STNstnList = NULL;
return;
}
static void add_hdr_columns(GtkTreeView *treeview, int which)
{
GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
GtkTreeViewColumn *col;
char   *hdr=NULL;
switch(which)
{
case NTWSTORE:
hdr = g_strdup("NTW");
break;   
case STNSTORE:
hdr = g_strdup("STN");
break;   
case LOCSTORE:
hdr = g_strdup("LOC");
break;
case INSTSTORE:
hdr = g_strdup("Instrument");
break;
}
col = gtk_tree_view_column_new_with_attributes(hdr, renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
free(hdr);
}
static GtkWidget *makeHdrModel(int which)
{
GtkWidget *treeview;
stores[which] = gtk_list_store_new(1, G_TYPE_STRING);
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL (stores[which]));
return (treeview);
}
static void add_NTW_info(int which)
{
GtkTreeIter treeIter;
GSList *ntwIter;
GNode *node;
NSLCDATA *nodeD;
if (stores[which])
gtk_list_store_clear(stores[which]);
switch(which)
{
case NTWSTORE:
gtk_list_store_append(stores[which], &treeIter);
gtk_list_store_set(stores[which], &treeIter, 0, "ALL", -1);
for(ntwIter = ntw;ntwIter;ntwIter=g_slist_next(ntwIter))
{ 
node = ntwIter->data;
nodeD = node->data;
gtk_list_store_append(stores[which], &treeIter);
gtk_list_store_set(stores[which], &treeIter, 0, nodeD->name, -1);
}
break;
}
}
static gint locFinder(GNode *one, GNode *two)
{
NSLCDATA *first=one->data, *second=two->data;
return (strcmp(first->name, second->name));
}
static gboolean _addStnInfo(GNode *node, gpointer w)
{
GtkTreeIter treeIter;
NSLCDATA *nodeD=node->data;
int  which = GPOINTER_TO_INT(w);
switch(which)
{
case STNSTORE:
switch(g_node_depth(node))
{ 
case 2: 
displayed[STNSTN] = g_slist_append(displayed[STNSTN], node);
gtk_list_store_append(stores[which], &treeIter);
gtk_list_store_set(stores[which], &treeIter, 0, g_strdup(nodeD->name), -1);
break;
}
break;
case LOCSTORE:
switch(g_node_depth(node))
{ 
case 3: 
if (!g_slist_find_custom(displayed[STNLOC], node, (GCompareFunc) locFinder))
{
displayed[STNLOC] = g_slist_append(displayed[STNLOC], node);
}
break;
}
break;
}
return FALSE;
}
static gboolean getChnKey(GNode *node, gpointer nil)
{ 
static char *locName=NULL;
NSLCDATA *nodeD=node->data;
GSList **chnKeys = &instruments.keys.chnKeys;
switch(g_node_depth(node))
{
case 3:  
if (locName)
free(locName);
locName = NULL;
if (!g_slist_find_custom(selected[STNLOC], nodeD->name, (GCompareFunc) strcmp))
{ 
break;
}   
locName = g_strdup(nodeD->name);
break;
case 4:
if (!locName)  
break;
*chnKeys = g_slist_prepend(*chnKeys, GINT_TO_POINTER(nodeD->id));
free(locName);
locName=NULL;
break;
}
return FALSE;
}
static void getListChnKeys(GSList *displayed, GSList *selected)
{ 
GSList  *stnIter;
GNode  *stnchnIter;
NSLCDATA *nodeD;
for(stnIter=displayed;
stnIter;
stnIter=g_slist_next(stnIter))
{
stnchnIter = stnIter->data;   
nodeD = stnchnIter->data;   
if (!g_slist_find_custom(selected, nodeD->name, (GCompareFunc) strcmp))
continue;
g_node_traverse(stnchnIter, G_PRE_ORDER, G_TRAVERSE_ALL, -1, 
(GNodeTraverseFunc) getChnKey, NULL);
}
}
static void add_STNLOC_info(GtkTreeModel *model, GtkTreePath *path, 
GtkTreeIter *iter, gpointer w)
{ 
GSList *ntwIter, *stnIter, *locIter;
GNode *locNode, *stnNode;
NSLCDATA *nodeD;
char *rowS=NULL;
int  rowSel;
int  which = GPOINTER_TO_INT(w);
switch(which)
{
case STNSTORE:  
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel==0)
{ 
for(ntwIter=ntw;ntwIter;ntwIter=g_slist_next(ntwIter))
{ 
g_node_traverse(ntwIter->data, G_PRE_ORDER, G_TRAVERSE_ALL, 2, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(STNSTORE));
}
}
else
{ 
rowSel--;
ntwIter = g_slist_nth(ntw, rowSel);
g_node_traverse(ntwIter->data, G_PRE_ORDER, G_TRAVERSE_ALL, 2, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(STNSTORE));
}
break;
case LOCSTORE:  
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel==0)
{ 
for(stnIter=displayed[STNSTN]; stnIter ; stnIter=g_slist_next(stnIter))
{
stnNode = stnIter->data;
g_node_traverse(stnNode, G_PRE_ORDER, G_TRAVERSE_ALL, 3, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(LOCSTORE));
nodeD = stnNode->data;
selected[STNSTN] = g_slist_append(selected[STNSTN], nodeD->name);
}
}
else
{ 
rowSel--;
stnIter = g_slist_nth(displayed[STNSTN], rowSel);
stnNode = stnIter->data;
g_node_traverse(stnNode, G_PRE_ORDER, G_TRAVERSE_ALL, 3, 
(GNodeTraverseFunc) _addStnInfo, GINT_TO_POINTER(LOCSTORE));
nodeD = stnNode->data;
selected[STNSTN] = g_slist_append(selected[STNSTN], nodeD->name);
}
break;
case LOCSTORE1:  
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel==0)
{ 
for(locIter=displayed[STNLOC];locIter;locIter=g_slist_next(locIter))
{ 
locNode = locIter->data;
nodeD = locNode->data;
selected[STNLOC] = g_slist_append(selected[STNLOC], nodeD->name);
}
}
else
{ 
rowSel--;
locIter = g_slist_nth(displayed[STNLOC], rowSel);
locNode = locIter->data;
nodeD = locNode->data;
selected[STNLOC] = g_slist_append(selected[STNLOC], nodeD->name);
}
break;
case INSTSTORE:
{
INSTRUMENT *instrument;
rowS = gtk_tree_path_to_string(path);
rowSel = atoi(rowS);
if (rowSel > 0)
{ 
rowSel--;
instrument = g_slist_nth_data(dispInst[STNINST], rowSel);
selectInst[STNINST] = g_slist_append(selectInst[STNINST], instrument);
}
}
break;
}
g_free(rowS);
}
static void stationSel(GtkTreeSelection *selection, gpointer w)
{ 
GtkTreeIter treeIter;
GNode *node;
NSLCDATA *nodeD;
GSList *locIter;
static GtkTreePath *path;
int which=GPOINTER_TO_INT(w);
if (!path)
path=gtk_tree_path_new_from_string("0");
switch(which)
{
case NTWSTORE:
if (stores[STNSTORE])
gtk_list_store_clear(stores[STNSTORE]);
if (displayed[STNSTN]) 
{
g_slist_free(displayed[STNSTN]); 
displayed[STNSTN]=NULL;
}
gtk_list_store_append(stores[STNSTORE], &treeIter);
gtk_list_store_set(stores[STNSTORE], &treeIter, 0, "ALL", -1);
gtk_tree_selection_selected_foreach (selection, 
(GtkTreeSelectionForeachFunc) add_STNLOC_info, 
GINT_TO_POINTER(STNSTORE));
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, FALSE);
break;
case STNSTORE:
if (stores[LOCSTORE])
gtk_list_store_clear(stores[LOCSTORE]);
if (displayed[STNLOC])
{
g_slist_free(displayed[STNLOC]); 
displayed[STNLOC]=NULL;
}
if (selected[STNSTN])
{
g_slist_free(selected[STNSTN]); 
selected[STNSTN]=NULL;
}
gtk_list_store_append(stores[LOCSTORE], &treeIter);
gtk_list_store_set(stores[LOCSTORE], &treeIter, 0, "ALL", -1);
gtk_tree_selection_selected_foreach (selection,
(GtkTreeSelectionForeachFunc) add_STNLOC_info, 
GINT_TO_POINTER(LOCSTORE));
for(locIter=displayed[STNLOC];locIter;locIter=g_slist_next(locIter))
{
node = locIter->data;
nodeD = node->data;
gtk_list_store_append(stores[LOCSTORE], &treeIter);
gtk_list_store_set(stores[LOCSTORE], &treeIter, 0, g_strdup(nodeD->name), -1);
}
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, FALSE);
break;
case LOCSTORE:
if (selected[STNLOC])
{
g_slist_free(selected[STNLOC]);
selected[STNLOC]=NULL;
}
gtk_tree_selection_selected_foreach(selection,
(GtkTreeSelectionForeachFunc) add_STNLOC_info, 
GINT_TO_POINTER(LOCSTORE1));
break;
case INSTSTORE:
{
if (selectInst[STNINST])
{
g_slist_free(selectInst[STNINST]);
selectInst[STNINST]=NULL;
}
gtk_tree_selection_selected_foreach(selection,
(GtkTreeSelectionForeachFunc) add_STNLOC_info, 
GINT_TO_POINTER(INSTSTORE));
}
break;
}
}
static GtkWidget *make_tab(int which)
{
GtkWidget *frame1, *hbox1, *identSW, *ctr, *vbox2, *hbox2;
GtkWidget *vbox, *vbox1, *button, *hbox, *label, *entry;
GtkTreeSelection *select;
GtkAdjustment *spinAdj;
GtkSizeGroup *size_group;
tips = gtk_tooltips_new();
frame1 = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_IN);
switch(which)
{
case STNSTNLIST:
vbox1 = gtk_vbox_new(FALSE, 0);
hbox1 = gtk_hbox_new(FALSE, 0);
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[NTWSTORE] = makeHdrModel(NTWSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[NTWSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), NTWSTORE);
gtk_widget_set_size_request(identSW, 100, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT(select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(NTWSTORE));
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[STNSTORE] = makeHdrModel(STNSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[STNSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), STNSTORE);
gtk_widget_set_size_request(identSW, 100, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT(select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(STNSTORE));
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[LOCSTORE] = makeHdrModel(LOCSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[LOCSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), LOCSTORE);
gtk_widget_set_size_request(identSW, 100, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT(select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(LOCSTORE));
vbox = gtk_vbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(vbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("CANCEL");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return to STN Viewer");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stationCBack), GINT_TO_POINTER(STNCXL));
button = gtk_button_new_with_label("DONE");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return to STN viewer");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stationCBack), GINT_TO_POINTER(STNDONE));
gtk_box_pack_start(GTK_BOX(hbox1), vbox, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 2);
hbox2 = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
vbox2 = gtk_vbox_new(FALSE, 0);
label = gtk_label_new("Starting Date:");
gtk_container_add(GTK_CONTAINER(vbox2), label);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
label = gtk_label_new("Ending Date:");
gtk_container_add(GTK_CONTAINER(vbox2), label);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
label = gtk_label_new("DAYS:");
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
gtk_container_add(GTK_CONTAINER(vbox2), label);
gtk_box_pack_start(GTK_BOX(hbox2), vbox2, FALSE, FALSE, 2);
vbox2 = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
STNDate[STNSTARTDAY] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 11);
button = gtk_button_new_with_label("...");
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(vbox2), hbox);
strcpy(toolTip, "Specify the Start Date to Plot\n\tformat: YYYY/MM/DD");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
strcpy(toolTip, "Start Date Selection using Calendar");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(getDate), GINT_TO_POINTER(STNSTARTDAY));
hbox = gtk_hbox_new(FALSE, 0);
STNDate[STNENDDAY] = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 11);
button = gtk_button_new_with_label("...");
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(vbox2), hbox);
strcpy(toolTip, "Specify the End Date to Plot\n\tformat: YYYY/MM/DD");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
strcpy(toolTip, "End Date Selection using Calendar");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(getDate), GINT_TO_POINTER(STNENDDAY));
hbox = gtk_hbox_new(FALSE, 0);
spinAdj = (GtkAdjustment *) gtk_adjustment_new(0.0, 0.0, MAXSTNDAYS, 1.0, 5.0, 0.0);
STNDispDays = ctr = gtk_spin_button_new(spinAdj, 1.0, 0);
gtk_box_pack_start(GTK_BOX(hbox), ctr, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(vbox2), hbox);
strcpy(toolTip, "Specify the Number of Days to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), ctr, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(hbox2), vbox2, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(vbox1), hbox2);
gtk_container_add(GTK_CONTAINER(frame1), vbox1);
break;
case STNINSTLIST:
hbox1 = gtk_hbox_new(FALSE, 0);
identSW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(identSW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(identSW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
STNstnVIEW[INSTSTORE] = makeHdrModel(INSTSTORE);
gtk_container_add(GTK_CONTAINER(identSW), STNstnVIEW[INSTSTORE]);
gtk_box_pack_start(GTK_BOX(hbox1), identSW, FALSE, FALSE, 2);
add_hdr_columns(GTK_TREE_VIEW(STNstnVIEW[INSTSTORE]), INSTSTORE);
gtk_widget_set_size_request(identSW, 450, 200);
select = gtk_tree_view_get_selection(GTK_TREE_VIEW(STNstnVIEW[INSTSTORE]));
gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE);
g_signal_connect(G_OBJECT(select), "changed", G_CALLBACK(stationSel), GINT_TO_POINTER(INSTSTORE));
vbox = gtk_vbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(vbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("CANCEL");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return to STN Viewer");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stationCBack), GINT_TO_POINTER(STNCXL));
button = gtk_button_new_with_label("DONE");
gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return to STN viewer");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stationCBack), GINT_TO_POINTER(STNDONE));
gtk_box_pack_start(GTK_BOX(hbox1), vbox, FALSE, FALSE, 2); 
gtk_container_add(GTK_CONTAINER(frame1), hbox1);
break;
}
return frame1;
}
static gint instIDCmp(INSTRUMENT *instrument, char *instID)
{
return(strcmp(instrument->instID, instID));
}
static void changeSTNdTab(GtkNotebook *notebook, GtkWidget *page, guint new_page, void *nothing)
{ 
switch(new_page)
{
case 1:
{ 
SQLDI sqldi;
GSList *iter;
GtkTreeIter treeIter;
INSTRUMENT *instrument;
if (stores[INSTSTORE])
gtk_list_store_clear(stores[INSTSTORE]);
if (dispInst[STNINST])
{
g_slist_free(dispInst[STNINST]);
dispInst[STNINST]=NULL;
}
if (selectInst[STNINST])
{
g_slist_free(selectInst[STNINST]); 
selectInst[STNINST]=NULL;
}
gtk_list_store_append(stores[INSTSTORE], &treeIter);
gtk_list_store_set(stores[INSTSTORE], &treeIter, 0, "Retrieving Data - Please Wait", -1);
g_slist_free(instruments.keys.chnKeys);
instruments.keys.chnKeys = NULL;
for(iter = instruments.data.instruments;
iter;
iter = g_slist_next(iter))
{
instrument = iter->data;
free(instrument->instID);
free(instrument);
}
g_slist_free(instruments.data.instruments);
instruments.data.instruments = NULL;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&instruments, 0, sizeof(INSTRUMENTS));
getListChnKeys(displayed[STNSTN], selected[STNSTN]);
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = INSTRTBL;
sqldi.data = &instruments;
db_request(&sqldi);
gtk_list_store_clear(stores[INSTSTORE]);
gtk_list_store_append(stores[INSTSTORE], &treeIter);
gtk_list_store_set(stores[INSTSTORE], &treeIter, 0, "ALL", -1);
for(iter = instruments.data.instruments;
iter;
iter = g_slist_next(iter))
{
instrument = iter->data;
if (g_slist_find_custom(dispInst[STNINST], instrument->instID, (GCompareFunc) instIDCmp))
continue; 
dispInst[STNINST] = g_slist_append(dispInst[STNINST], instrument);
gtk_list_store_append(stores[INSTSTORE], &treeIter);
gtk_list_store_set(stores[INSTSTORE], &treeIter, 
0, instrument->instID, -1);
}
}
break;
}
}
static gboolean regLocChn(GNode *node, GNode *stnNode)
{ 
static char *locName=NULL;
NSLCDATA *nodeD=node->data;
STNCHN *chnPtr, *stnNodeD=stnNode->data;
switch(g_node_depth(node))
{
case 3:  
if (locName)
free(locName);
locName = NULL;
if (!g_slist_find_custom(selected[STNLOC], nodeD->name, (GCompareFunc) strcmp))
{ 
break;
}   
locName = g_strdup(nodeD->name);
break;
case 4:
if (!locName)  
break;
if (selectInst[STNINST])
{ 
char *instID = g_hash_table_lookup(stnStates.data.instIDs, &(nodeD->id));
if (!instID)
break;
if (!g_slist_find_custom(selectInst[STNINST], instID, (GCompareFunc) instIDCmp))
{
break;
}
}
chnPtr = calloc(1, sizeof(STNCHN));
chnPtr->name1 = g_strdup(locName);
chnPtr->name2 = g_strdup(nodeD->name);
chnPtr->shortName = g_strdup_printf("%s.%s", chnPtr->name1, chnPtr->name2);
chnPtr->longName = g_strdup_printf("%s.%s.%s.%s", 
stnNodeD->name1, stnNodeD->name2, 
chnPtr->name1, chnPtr->name2);
chnPtr->key = nodeD->id;
g_node_insert_data(stnNode, -1, chnPtr);
g_hash_table_insert(chnHash, &chnPtr->key, chnPtr);
break;
}
return FALSE;
}
static gboolean chkStnInst(GNode *node, gboolean *hasInst)
{ 
NSLCDATA *nodeD=node->data;
gboolean *ret = hasInst;
char *instID;
if (*ret)
return TRUE; 
switch(g_node_depth(node))
{
case 4: 
instID = g_hash_table_lookup(stnStates.data.instIDs, &(nodeD->id));
if (!instID)
break;
if (g_slist_find_custom(selectInst[STNINST], instID, (GCompareFunc) instIDCmp))
{
*ret = TRUE;
}
break;
}
return *ret;
}
static gboolean getSTNstationList(GSList *displayed, GSList *selected)
{
GSList  *stnIter;
NSLCDATA *nodeD;
GNode  *stnchnIter, *stnNode;
STNCHN  *stnPtr;
GDateDay day;
GDateMonth month;
GDateYear year;
GDate  *bounds[TTLSTNDAYRANGE] = {NULL, NULL};  
gboolean invalid = FALSE;
int   i, dayRCombo;
while (stnStates.main.stnList)
{ 
for(stnchnIter=g_node_first_child(stnStates.main.stnList->data);
stnchnIter;
stnchnIter=g_node_next_sibling(stnchnIter))
{
g_node_traverse(stnchnIter, G_PRE_ORDER, G_TRAVERSE_ALL, -1,
(GNodeTraverseFunc) freeStnChnData, NULL);
}
g_node_destroy((GNode *) (stnStates.main.stnList->data));
stnStates.main.stnList = g_list_remove(stnStates.main.stnList, (stnStates.main.stnList->data));
}
if(chnHash)
g_hash_table_destroy(chnHash);
stnStates.main.startStn = NULL;
stnSettings.ttlStns = 0;
chnHash = g_hash_table_new(g_int_hash, g_int_equal);
for(stnIter=displayed;stnIter;stnIter=g_slist_next(stnIter))
{
stnchnIter = stnIter->data;   
nodeD = stnchnIter->data;   
if (!g_slist_find_custom(selected, nodeD->name, (GCompareFunc) strcmp))
continue; 
if (selectInst[STNINST])
{ 
gboolean hasInst = FALSE;
g_node_traverse(stnchnIter, G_PRE_ORDER, G_TRAVERSE_LEAVES, -1, 
(GNodeTraverseFunc) chkStnInst, (gpointer) &hasInst);
if (!hasInst)
continue;
}
stnPtr = calloc(1, sizeof(STNCHN));
nodeD = stnchnIter->parent->data; 
stnPtr->name1 = g_strdup(nodeD->name);
nodeD = stnchnIter->data;   
stnPtr->name2 = g_strdup(nodeD->name);
stnPtr->shortName = g_strdup_printf("%s.%s", stnPtr->name1, stnPtr->name2);
stnPtr->key = nodeD->id;
stnNode = g_node_new(stnPtr);
stnStates.main.stnList = g_list_append(stnStates.main.stnList, stnNode); 
g_node_traverse(stnchnIter, G_PRE_ORDER, G_TRAVERSE_ALL, -1, 
(GNodeTraverseFunc) regLocChn, stnNode);
stnSettings.ttlStns++;
}
stnStates.request.type = STNINIT;
stnStates.display.initiate = TRUE;
for (i = 0; i<TTLSTNDAYRANGE; i++)
{
char *dateStr = (char *) gtk_entry_get_text(GTK_ENTRY(STNDate[i]));
if (strlen(dateStr))
{
int  yr, mn, dy;
sscanf(dateStr, "%d/%d/%d", &yr, &mn, &dy);
year = yr; month = mn; day = dy;
invalid = chkDateFormat(year, month, day);
if (!invalid)
{
GDate *doy = g_date_new_dmy(day, month, year);
if (g_date_get_julian(doy) > g_date_get_julian(stnSettings.display.dates[ENDDT]) ||
g_date_get_julian(doy) < g_date_get_julian(stnSettings.display.dates[STARTDT]))
{ 
char *msg;
gdk_beep();
msg = g_strdup("Cannot go beyond absolute dates of Database.");
dispMsgSTN(DISPLAY, msg);
free(msg);
invalid = TRUE;
}
else
{ 
bounds[i] = g_date_new_dmy(day, month, year);
}
g_date_free(doy);
}
else
{
error_dialog("STN - Date Selection",
"\n\tDate Format = YYYY/MM/DD\n\n\tPlease Re-Input...\n");
}
}
}
dayRCombo = TTLDRCOMBOS;  
if (bounds[STNSTARTDAY] && bounds[STNENDDAY])
{ 
dayRCombo = DR_BOTH;
}
else if (bounds[STNSTARTDAY])
{ 
dayRCombo = DR_START;
}
else if (bounds[STNENDDAY])
{ 
dayRCombo = DR_END;
}
else if (gtk_spin_button_get_value((GtkSpinButton *) STNDispDays) > 0)
{ 
dayRCombo = DR_DAYS;
}
switch (dayRCombo)
{
case DR_BOTH:
if (g_date_get_julian(bounds[STNSTARTDAY]) >= g_date_get_julian(bounds[STNENDDAY]))
{
char *msg = g_strdup("Start Date Must be BEFORE End Date!");
dispMsgSTN(DISPLAY, msg);
free(msg);
invalid = TRUE;
}
else
{
g_date_add_days(bounds[STNENDDAY], 1);
stnStates.request.endDate = g_date_new_julian(g_date_get_julian(bounds[STNENDDAY]));
stnSettings.main.days = g_date_get_julian(bounds[STNENDDAY]) - g_date_get_julian(bounds[STNSTARTDAY]);
}
g_date_free(bounds[STNSTARTDAY]);
g_date_free(bounds[STNENDDAY]);
break;
case DR_START:
if (gtk_spin_button_get_value((GtkSpinButton *) STNDispDays) > 0)
{ 
stnSettings.main.days = gtk_spin_button_get_value((GtkSpinButton *) STNDispDays);
}
g_date_add_days(bounds[STNSTARTDAY], stnSettings.main.days);
stnStates.request.endDate = g_date_new_julian(g_date_get_julian(bounds[STNSTARTDAY]));
g_date_free(bounds[STNSTARTDAY]);
break;
case DR_END:
if (gtk_spin_button_get_value((GtkSpinButton *) STNDispDays) > 0)
{ 
stnSettings.main.days = gtk_spin_button_get_value((GtkSpinButton *) STNDispDays);
}
g_date_add_days(bounds[STNENDDAY], 1);
stnStates.request.endDate = g_date_new_julian(g_date_get_julian(bounds[STNENDDAY]));
g_date_free(bounds[STNENDDAY]);
break;
case DR_DAYS:
stnSettings.main.days = gtk_spin_button_get_value((GtkSpinButton *) STNDispDays);
break;
}
return (invalid);
}
static void stationCBack(GtkButton *button, gpointer t)
{ 
int type = GPOINTER_TO_INT(t);
switch(type)
{
case STNCXL:
{
gtk_widget_hide(STNstnList);
}
break;
case STNDONE:
if (!selected[STNSTN] || !selected[STNLOC])
break;
switch(pqlxStates.system)
{
case STNSYSTEM:
if (!getSTNstationList(displayed[STNSTN], selected[STNSTN]))
{ 
gtk_widget_hide(STNstnList);
stnStates.request.type = STNINIT;
getAllSTNdata();
}
break;
}
break;
}
}
void make_stationDialogue()
{
GtkTreePath *path;
GtkWidget *tab, *frame, *notebook, *vbox;
if (!STNstnList)
{
STNstnList = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(STNstnList), "STATION Viewer Selector"); 
gtk_container_set_border_width(GTK_CONTAINER(STNstnList), 2);
g_signal_connect(STNstnList, "destroy", G_CALLBACK(destroyStnStations), NULL);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(STNstnList), vbox);
notebook = gtk_notebook_new();
gtk_box_pack_start(GTK_BOX(vbox), notebook, TRUE, TRUE, 0);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
tab = make_tab(STNSTNLIST);
gtk_container_add(GTK_CONTAINER(frame), tab);
gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, gtk_label_new(" Stations "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
tab = make_tab(STNINSTLIST);
gtk_container_add(GTK_CONTAINER(frame), tab);
gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, gtk_label_new(" Instruments "));
g_signal_connect(notebook, "switch-page", G_CALLBACK(changeSTNdTab), NULL);
gtk_window_set_position(GTK_WINDOW(STNstnList), GTK_WIN_POS_CENTER);
gtk_widget_show_all(STNstnList);
gtk_window_set_transient_for((GtkWindow *) STNstnList, (GtkWindow *) topWindow); 
}
if (dirty(STNSYSTEM))
{ 
int  i;
add_NTW_info(NTWSTORE);
path = gtk_tree_path_new_from_string("0");
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), path, NULL, FALSE);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, FALSE);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, FALSE);
gtk_tree_path_free(path);
for (i = 0; i<TTLSTNDAYRANGE; i++)
{
gtk_entry_set_text(GTK_ENTRY(STNDate[i]), "");
}
}
#if 0 
if (!dbName || 
strcmp(dbName, pqlxStates.conn.dbNm) ||
stnXDays != stnSettings.general.stnXDays)
{ 
int  i;
add_NTW_info(NTWSTORE);
if (dbName)
free(dbName);
dbName = g_strdup(pqlxStates.conn.dbNm);
stnXDays = stnSettings.general.stnXDays;
path = gtk_tree_path_new_from_string("0");
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[NTWSTORE]), path, NULL, FALSE);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[STNSTORE]), path, NULL, FALSE);
gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, TRUE, 0.0, 0.0);
gtk_tree_view_set_cursor(GTK_TREE_VIEW(STNstnVIEW[LOCSTORE]), path, NULL, FALSE);
gtk_tree_path_free(path);
for (i = 0; i<TTLSTNDAYRANGE; i++)
{
gtk_entry_set_text(GTK_ENTRY(STNDate[i]), "");
}
}
#endif
gtk_widget_show(STNstnList);
}
