#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
static gboolean nextAnaTrace(gpointer stage);
static GdkGC *STNGXC[TOTALSTNCONTEXTS];
enum {
ANANXTTRC,
ANAPREFINISH,
ANAFINISH
};
typedef struct _ANAARGS
{
PQLDATA  *data;
int   trcNum;
} ANAARGS;
static GdkPixmap *pmap;
static int width, height;
static void freeCG(XYZCOMPONENT *comp)
{
g_hash_table_destroy(comp->comp);
}
#if 0
static void uvwComp(char *key, traceInfo *trcData, gpointer f)
{
int   success = GPOINTER_TO_INT(f);
DATAINFO *dataInfo = &trcData->data.tForm;
switch(success)
{
case TRUE:
break;
case FALSE:
break;
}
}
#endif
static void uvw(char *key, XYZCOMPONENT *comp, gpointer f)
{
int func = GPOINTER_TO_INT(f);
switch(func)
{
case FUNCUVW:
if (g_hash_table_size(comp->comp) == 3)
comp->success = xyzUVW(comp->comp, comp->sensor);
break;
case FUNCMAXMIN:
{
}
break;
}
}
gint getStnArrivals(ARRIVALS *arrival, char *stn)
{
return(strcmp(arrival->keys.stn, stn));
}
static gboolean plotPhase(char *phaseNm)
{
gboolean ret = FALSE;
GSList *iter;
char  *str, *modelStr;
if (!stnSettings.event.modelSel)
return ret;
str = g_strdup_printf("%s%s%s", MODELSEP, phaseNm, MODELSEP);
for(iter = stnSettings.event.models;
iter;
iter = g_slist_next(iter))
{
modelStr = iter->data;
if (g_strrstr(modelStr, stnSettings.event.modelSel))
break;
}
if (g_strrstr(modelStr, str))
ret = TRUE;
free(str);
return ret;
}
static gint sortAnaTraces(PQLDATA *pql1, PQLDATA *pql2, gpointer t)
{
traceInfo *trc1=pql1->trc, *trc2=pql2->trc;
gint  ret=0, type = GPOINTER_TO_INT(t);
switch(type)
{
case STNSORTNAME:
ret = strcmp(trc1->data.head.descr2, trc2->data.head.descr2);
break;
case STNSORTTIME:
ret = trc1->data.head.epochs - trc2->data.head.epochs;
break;
case STNSORTEPI:
{
GSList *arrivals1, *arrivals2;
ARRIVALS *arr1, *arr2;
if (!strcmp(trc1->data.head.station, trc2->data.head.station))
return 0; 
arrivals1 = g_slist_find_custom(stnStates.event.arrivals, trc1->data.head.station, 
(GCompareFunc) getStnArrivals);
arrivals2 = g_slist_find_custom(stnStates.event.arrivals, trc2->data.head.station, 
(GCompareFunc) getStnArrivals);
if (arrivals1 && arrivals2)
{
arr1 = arrivals1->data;
arr2 = arrivals2->data;
ret = (stnSettings.event.epiOrder == STNEVTEPINEAR1ST)
? (arr1->keys.distance < arr2->keys.distance) ? -1 : 1 
: (arr2->keys.distance < arr1->keys.distance) ? -1 : 1;
}
else
{
ret = (!arrivals1 && !arrivals2 ? 0 : (!arrivals1 ? 1 : -1));
}
}
break;
}
return (ret);
}
static gint sortArrivalsList(ARRIVALS *arr1, ARRIVALS *arr2, gpointer t)
{
gint ret=0;
int  type = GPOINTER_TO_INT(t);
switch(type)
{
case STNSORTNAME:
ret = strcmp(arr1->keys.stn, arr2->keys.stn);
break;
case STNSORTEPI:
ret = (stnSettings.event.epiOrder == STNEVTEPINEAR1ST)
? (arr1->keys.distance < arr2->keys.distance) ? -1 : 1 
: (arr2->keys.distance < arr1->keys.distance) ? -1 : 1;
break;
}
return (ret);
}
static gchar *makeTFormString(gchar *tFormStr, int tForm)
{
gchar *labelTmp;
if (tFormStr)
{
switch(tForm)
{
case NONE:  
labelTmp = g_strdup(tFormStr);
break;
case ANAFILTER:
labelTmp = g_strdup_printf("%s : Filter ( %s )", tFormStr, 
settings.general.filter.filts[stnStates.analysis.dataFilter.active]->name);
break;
default:
labelTmp = g_strdup_printf("%s : %s", tFormStr, transforms[tForm]);
break;
}
free(tFormStr);
}
else
{ 
labelTmp = g_strdup("Original");
}
return (labelTmp);
}
static INTERPTT *getPPhase(char *stn, char *phase)
{
GSList  *arrivals, *arrivalsIter=NULL;
ARRIVALS *arrival;
INTERPTT *interpTT;
arrivals = g_slist_find_custom(stnStates.event.arrivals, stn, (GCompareFunc) getStnArrivals);
if (arrivals)
{
arrival = arrivals->data;
for (arrivalsIter=arrival->data.arrivals;
arrivalsIter;
arrivalsIter = g_slist_next(arrivalsIter))
{
interpTT = arrivalsIter->data;
if (!strcmp(phase, interpTT->phaseName))
break;
}
}
if (!arrivalsIter)
interpTT = NULL;
return interpTT;
}
static USERPICK *getUPhase(GSList *userPicks, int pickNum)
{
GSList  *iter;
USERPICK *userPick;
for(iter = userPicks;
iter;
iter = g_slist_next(iter))
{
userPick = iter->data;
if (userPick->pickNum == pickNum)
break;
}
if (!iter)
userPick = NULL;
return userPick;
}
static void drawANAtrc(GSList *traces)
{
GSList  *arrivals, *arrivalsIter;
GSList   *anaIter;
ANADATA  *anaData;
traceInfo *trc;
int   increment, trcCnt = g_slist_length(traces), trcW, trcH, i;
int   labelH, labelW, format;
double   max, min, start, stop, absStart=0, absStop=0, totLen=0, relLen, diff;
graph  trcGR;
int   x1, y1;
char  *axis_label;
gboolean plotted=FALSE, eventE;
double  eventTE;
ARRIVALS *arrival;
INTERPTT *interpTT;
char  *phase;
double  phaseT, offsetT, offset;
double  traceB, traceE;
USERPICK  *userPick;
double   dispBegin = G_MAXDOUBLE;
trcW = width - ANALFTM - ANARGTM;
trcH = (height - (ANATOPM + ANABOTM))/trcCnt;
ANAsetDatas(traces); 
if (stnStates.event.event)
{ 
EVENTINFO *event = stnStates.event.event;
eventTE = event->eventTE;
eventE = TRUE;
}
else
{
eventTE = 0.0;
eventE = FALSE;
}
switch(stnSettings.display.xScale)
{ 
case STNALIGNPRDCT:
{
offset = -1*G_MAXFLOAT;
offsetT = 0.0;
if (!eventE)
break;
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{ 
trc = ((PQLDATA *) (anaIter->data))->trc;
if (trc->magnify.begin == -1)
continue;
if (dispBegin > trc->magnify.begin)      
dispBegin = trc->magnify.begin;
if (totLen < trc->magnify.end - trc->magnify.begin)  
totLen = trc->magnify.end - trc->magnify.begin;
}
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{
trc = ((PQLDATA *) (anaIter->data))->trc;
if (trc->magnify.begin == -1)
continue;
interpTT = getPPhase(trc->data.head.station, stnSettings.event.alignPhase);
if (interpTT)
{
phaseT = eventTE + interpTT->ttime;
if (offset < phaseT - dispBegin)
{
offsetT = phaseT;
offset = phaseT - dispBegin;
}
}
}
}
break;
case STNALIGNUSER:
{
offsetT = 0.0;
offset = -1*G_MAXFLOAT;
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{ 
trc = ((PQLDATA *) (anaIter->data))->trc;
if (trc->magnify.begin == -1)
continue;
if (dispBegin > trc->magnify.begin)      
dispBegin = trc->magnify.begin;
if (totLen < trc->magnify.end - trc->magnify.begin)  
totLen = trc->magnify.end - trc->magnify.begin;
}
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trc = ((PQLDATA *) (anaIter->data))->trc;
if (trc->magnify.begin == -1)
continue;
userPick = getUPhase(anaData->userPicks, stnSettings.event.userPA);
if (userPick)
{
if (offset < userPick->time - trc->magnify.begin)
{
offsetT = userPick->time;
offset = userPick->time - trc->magnify.begin;
}
}
}
}
break;
case RELATIVE:
case ABSOLUTE:
offsetT = 0.0;
break;
}
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{ 
anaData = ((PQLDATA *) (anaIter->data))->anaData;
if (stnSettings.display.units[STNANALYSIS] == STNSENSITIVITY &&
anaData->chnMETA)
{
CHNMETA *chnMeta = anaData->chnMETA->data;
anaData->dataInfo.amps.max /= chnMeta->sensitivity;
anaData->dataInfo.amps.min /= chnMeta->sensitivity;
}
}
switch(stnSettings.display.yScale[STNANALYSIS])
{
case WINDS:
anaIter = traces;
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trc = ((PQLDATA *) (anaIter->data))->trc;
max = anaData->dataInfo.amps.max;
min = anaData->dataInfo.amps.min;
start = trc->data.head.epochs;
stop = start + trc->data.head.length;
for(anaIter = g_slist_next(anaIter);
anaIter;
anaIter = g_slist_next(anaIter))
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trc = ((PQLDATA *) (anaIter->data))->trc;
if (max < anaData->dataInfo.amps.max)
max = anaData->dataInfo.amps.max;
if (min > anaData->dataInfo.amps.min)
min = anaData->dataInfo.amps.min;
if (start < trc->data.head.epochs)
start = trc->data.head.epochs;
if (stop > trc->data.head.epochs + trc->data.head.length)
stop = trc->data.head.epochs + trc->data.head.length;
}
break;
case CHNGROUPS:
{ 
int  i;
double val;
char *chnName, *channel;
GSList *iter, *autoScaleIter;
AUTOSCALE *autoScale;
YCHNSCALE *yChnScale;
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{ 
anaData = ((PQLDATA *) (anaIter->data))->anaData;
anaData->display.stats[ABSOLUTE][MAX] = 
anaData->display.stats[RELATIVE][MAX] = anaData->dataInfo.amps.max;
anaData->display.stats[ABSOLUTE][MIN] = 
anaData->display.stats[RELATIVE][MIN] = anaData->dataInfo.amps.min;
}
for(anaIter=traces;anaIter;anaIter=g_slist_next(anaIter))
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trc = ((PQLDATA *) (anaIter->data))->trc;
switch(strlen(trc->data.head.location))
{
case 0:
channel = g_strdup_printf("--.%s", trc->data.head.channel);
break;
default:
channel = g_strdup_printf("%s.%s", trc->data.head.location, trc->data.head.channel);
break;
}
chnName = getChnGrpName(channel, STNANALYSIS); free(channel);
if (!chnName)
continue;  
autoScaleIter = g_slist_find_custom(stnStates.display.yScaleGrp[STNANALYSIS].autoScale,
chnName, (GCompareFunc) getAutoScale);
if (!autoScaleIter)
continue;
autoScale = autoScaleIter->data;
autoScale->channels = g_slist_append(autoScale->channels, anaData);
}
for(iter = stnStates.display.yScaleGrp[STNANALYSIS].autoScale;
iter;
iter = g_slist_next(iter))
{
autoScale = iter->data;
if (!autoScale->channels) 
continue;
yChnScale = g_slist_find_custom(stnStates.display.yScaleGrp[STNANALYSIS].chnGroupScale->chnScales,
autoScale->name, (GCompareFunc) getChnScale)->data;
for(i=0;i<2; i++)
{ 
if (!strcmp(yChnScale->scale[i], YSCALEAUTO))
{ 
anaIter = autoScale->channels;
anaData = anaIter->data;
val = anaData->display.stats[RELATIVE][i];
for(anaIter=g_slist_next(anaIter);
anaIter;
anaIter=g_slist_next(anaIter))
{ 
anaData = anaIter->data;
switch(i)
{
case MAX:
val = (anaData->display.stats[RELATIVE][i] > val)
? anaData->display.stats[RELATIVE][i]
: val;
break;
case MIN:
val = (anaData->display.stats[RELATIVE][i] < val)
? anaData->display.stats[RELATIVE][i]
: val;
break;
}
}
for(anaIter=autoScale->channels;
anaIter;
anaIter=g_slist_next(anaIter))
{ 
anaData = anaIter->data;
anaData->display.stats[ABSOLUTE][i] = val;
}
}
}
}
}
break;
}
if (stnSettings.display.overlay[stnStates.screen])
{ 
anaIter = traces;
anaData = ((PQLDATA *) (anaIter->data))->anaData;
max = anaData->dataInfo.amps.max;
min = anaData->dataInfo.amps.min;
for(anaIter = g_slist_next(anaIter);
anaIter;
anaIter = g_slist_next(anaIter))
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
if (max < anaData->dataInfo.amps.max)
max = anaData->dataInfo.amps.max;
if (min > anaData->dataInfo.amps.min)
min = anaData->dataInfo.amps.min;
}
}
diff = stnStates.analysis.plot.limits.selection.user.length;
for(anaIter = traces, i=0, relLen=0;
anaIter;
anaIter = g_slist_next(anaIter), i++)
{
trc = ((PQLDATA *) (anaIter->data))->trc;
if (trc->magnify.begin == -1)
continue;
switch(stnSettings.display.xScale)
{
case ABSOLUTE:
start = stnStates.analysis.plot.limits.times[STARTABS] + 
stnStates.analysis.plot.limits.selection.user.left;
stop = (diff && 
(start+diff) < stnStates.analysis.plot.limits.times[STOPABS])
? start + diff : trc->magnify.end;
if (!absStart)
absStart = start;
else if (absStart > start)
absStart = start;
if (absStop < stop)
absStop = stop;
break;
case RELATIVE:
start = trc->magnify.begin;
stop = trc->magnify.end;
if (stop-start > relLen)
relLen = stop - start;
break;
case STNALIGNUSER:
case STNALIGNPRDCT:
if (totLen == 0.0)
{
start = trc->magnify.begin;
stop = trc->magnify.end;
if (stop-start > relLen)
relLen = stop - start;
}
break;
}
}
switch(stnSettings.display.xScale)
{
case ABSOLUTE:
totLen = absStop - absStart;
break;
case RELATIVE:
totLen = relLen;
break;
case STNALIGNUSER:
case STNALIGNPRDCT:
if (totLen == 0.0)
{ 
totLen = relLen;
}
break;
}
for(anaIter = traces, i=0;
anaIter;
anaIter = g_slist_next(anaIter), i++)
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trc = ((PQLDATA *) (anaIter->data))->trc;
switch(stnSettings.display.yScale[STNANALYSIS])
{
case FIXEDS:
{
char *mxmnS;
double maxT=anaData->dataInfo.amps.max, 
minT=anaData->dataInfo.amps.min,
mxmn, diff; 
diff=maxT-minT;
mxmnS = (char *) gtk_entry_get_text(GTK_ENTRY(stnYfixed[STNANALYSIS][MAX]));
if (getUserMaxMin(mxmnS, &mxmn))
{ 
max = maxT - (float) (diff/2) * (float) (mxmn/100.);
}
else
{ 
if (strlen(mxmnS))
max = mxmn;
else
max = maxT;
}
mxmnS = (char *) gtk_entry_get_text(GTK_ENTRY(stnYfixed[STNANALYSIS][MIN]));
if (getUserMaxMin(mxmnS, &mxmn))
{ 
min = minT + (float) (diff/2) * (float) (mxmn/100.);
}
else
{ 
if (strlen(mxmnS))
min = mxmn;
else
min = minT;
}
}
break;
case DISPS:
max = anaData->dataInfo.amps.max;
min = anaData->dataInfo.amps.min;
break;
case CHNGROUPS:
{
char *mxmnS;
double maxT=anaData->display.stats[ABSOLUTE][MAX], 
minT=anaData->display.stats[ABSOLUTE][MIN],
mxmn, diff;
char *channel;
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trc = ((PQLDATA *) (anaIter->data))->trc;
switch(strlen(trc->data.head.location))
{
case 0:
channel = g_strdup_printf("--.%s", trc->data.head.channel);
break;
default:
channel = g_strdup_printf("%s.%s", trc->data.head.location, 
trc->data.head.channel);
break;
}
diff=maxT-minT;
mxmnS = getChnGrpScale(channel, STNANALYSIS, MAX);
if (!strcmp(mxmnS, YSCALEAUTO))
{ 
max = maxT;
}
else if (getUserMaxMin(mxmnS, &mxmn))
{ 
max = maxT - (float) (diff/2) * (float) (mxmn/100.);
}
else
{ 
if (strlen(mxmnS))
max = mxmn;
else
max = maxT;
}
mxmnS = getChnGrpScale(channel, STNANALYSIS, MIN);
if (!strcmp(mxmnS, YSCALEAUTO))
{ 
min = minT;
}
else if (getUserMaxMin(mxmnS, &mxmn))
{ 
min = minT + (float) (diff/2) * (float) (mxmn/100.);
}
else
{ 
min = (strlen(mxmnS)) ? mxmn : minT;
}
free(channel);
}
break;
}
(stnSettings.display.overlay[stnStates.screen])
? viewport(&trcGR, ANALFTM, width-ANARGTM, ANATOPM, height-ANABOTM) 
: viewport(&trcGR, ANALFTM, width-ANARGTM, ANATOPBD(ANATOPM), ANABOTBD(ANATOPM));
if (stnSettings.display.units[STNANALYSIS] == STNSENSITIVITY &&
anaData->chnMETA)
{
CHNMETA *chnMeta = anaData->chnMETA->data;
max *= chnMeta->sensitivity;
min *= chnMeta->sensitivity;
}
switch(stnSettings.display.xScale)
{
case ABSOLUTE:
traceB = absStart;
traceE = absStop;
break;
case RELATIVE:
traceB = trc->magnify.begin;
traceE = trc->magnify.begin + totLen;
break;
case STNALIGNPRDCT:
{
traceB = trc->magnify.begin;
interpTT = getPPhase(trc->data.head.station, stnSettings.event.alignPhase);
if (interpTT)
{
traceB = trc->magnify.begin - (offsetT - (eventTE + interpTT->ttime));
if (dispBegin < trc->data.head.epochs)    
traceB -= (trc->data.head.epochs - dispBegin); 
trc->magnify.begin = (traceB >= trc->data.head.epochs)
? traceB 
: trc->data.head.epochs;
magNumPts(trc, anaData);
}
traceE = traceB + totLen;
}
break;
case STNALIGNUSER:
{
traceB = trc->magnify.begin;
userPick = getUPhase(anaData->userPicks, stnSettings.event.userPA);
if (userPick)
{
traceB = trc->magnify.begin - (offsetT - userPick->time);
if (dispBegin < trc->data.head.epochs)    
traceB -= (trc->data.head.epochs - dispBegin); 
trc->magnify.begin = (traceB >= trc->data.head.epochs)
? traceB 
: trc->data.head.epochs;
magNumPts(trc, anaData);
}
traceE = traceB + totLen;
}
break;
}
window(&trcGR, traceB, traceE, min, max, 0, 0);
memcpy(&trc->magnify.GR[ANAPLOT], &trcGR, sizeof(graph));
trc->magnify.plot.increment = increment = getSTNDataInc(totLen, trcW, trc->data.head.sampInt);
if (trc->magnify.begin != -1)
{
plotted = TRUE;
stn_mag_plot(pmap, &trcGR, trc, anaData, increment, i, STNANALYSIS);
}
if (eventE)
{ 
int   pixX0, pixX1, pixY0, pixY1;
arrivals = g_slist_find_custom(stnStates.event.arrivals, trc->data.head.station, (GCompareFunc) getStnArrivals);
if (arrivals)
{
arrival = arrivals->data;
for (arrivalsIter=arrival->data.arrivals;
arrivalsIter;
arrivalsIter = g_slist_next(arrivalsIter))
{
interpTT = arrivalsIter->data;
phase = interpTT->phaseName;
if (!plotPhase(phase))
continue;
phaseT = eventTE + interpTT->ttime;
pixX0 = pixX1 = USER2PIXX(&trcGR, phaseT);
pixY0 = trcGR.pix_ymin+1;
pixY1 = trcGR.pix_ymax-1;
if (pixX0 >= trcGR.pix_xmin &&
pixX0 <= trcGR.pix_xmax)
{ 
fontDrawP(pmap, phase, pixX0-1-fontSIZEP(phase, AXISF, WIDTH), pixY0, AXISF, STNFLBLA);
gdk_draw_line(pmap, stnSettings.drawing.ctxts[stnStates.screen][STNARR][NORMALGC],
pixX0, pixY0, pixX1, pixY1);
}
}
}
}
if (anaData->userPicks)
{
int   pixX0, pixX1, pixY0, pixY1;
USERPICK *userPick;
char  *pickName;
GSList  *iter;
for(iter = anaData->userPicks;
iter;
iter = g_slist_next(iter))
{
userPick = iter->data;
pixX0 = pixX1 = USER2PIXX(&trcGR, userPick->time);
pixY0 = trcGR.pix_ymin+1;
pixY1 = trcGR.pix_ymax-1;
if (pixX0 >= trcGR.pix_xmin &&
pixX0 <= trcGR.pix_xmax)
{ 
pickName = stnSettings.event.userP[userPick->pickNum];
fontDrawP(pmap, pickName, pixX0+2, pixY0, AXISF, STNFLBLA);
gdk_draw_line(pmap, stnSettings.drawing.ctxts[stnStates.screen][STNPICK][NORMALGC],
pixX0, pixY0, pixX1, pixY1);
}
}
}
{ 
char *units;
if (stnSettings.display.units[STNANALYSIS] == STNSENSITIVITY &&
anaData->chnMETA)
{
CHNMETA *chnMeta = anaData->chnMETA->data;
format = MYFLOAT;
switch (strncmp(chnMeta->units, "M/S", 3))
{
case 0:
units = g_strdup_printf("%s*", chnMeta->units);
break;
default:
units = g_strdup_printf("%s", chnMeta->units);
break;
}
max /= chnMeta->sensitivity;
min /= chnMeta->sensitivity;
}
else if (anaData->tForm.deconvolve &&
anaData->chnMETA)
{ 
CHNMETA *chnMeta = anaData->chnMETA->data;
units = g_strdup_printf("%s", chnMeta->units);
format = MYFLOAT;
}
else
{
units = g_strdup("counts");
format = MYINT;
}
if (stnSettings.display.overlay[stnStates.screen])
{ 
if (!i &&
stnSettings.display.yScale[stnStates.screen] != DISPS)
{
viewport(&trcGR, STNLFTM, width-ANARGTM, ANATOPM+1, height-ANABOTM-1);
window(&trcGR, (double) 0, (double) 10, min, max, 0, 0);
yaxisP(pmap, STNGXC[STNFGBG], &trcGR, (double) 0, 
(double) trcGR.user_ymin, (double) trcGR.user_ymax, 
1, 1, 0, (double) 0.0, format, PDFSTATSF); 
}
}
else
{
if (stnSettings.display.yAxis[STNANALYSIS] == ON &&
trc->magnify.begin != -1)
{
viewport(&trcGR, STNLFTM, ANALFTM, ANATOPBD(ANATOPM), ANABOTBD(ANATOPM));
if (min >= max)
{ 
min = -1;
max = 1;
}
window(&trcGR, (double) 0, (double) 10, min, max, 0, 0);
fontDrawPR(pmap, units, 
STNLFTM - fontSIZEP(units, STNLBLF, HEIGHT) - 2, 
ANABOTBD(ANATOPM) - fontSIZEP(units, STNLBLF, WIDTH) - 1, 
STNLBLF, STNFLBLA);
yaxisP(pmap, STNGXC[STNFGBG], &trcGR, (double) 0, 
(double) trcGR.user_ymin, (double) trcGR.user_ymax, 
1, 1, 0, (double) 0.0, format, PDFSTATSF); 
}
}
free(units);
}
printSTNLabel(pmap, trc, i, STNANALYSIS, FALSE, stnSettings.display.overlay[STNANALYSIS], NULL);
}
viewport(&trcGR, ANALFTM, width-ANARGTM, height-ANABOTM, height);
window(&trcGR, (double) 0, (double) totLen, (double) ANABOTM, (double) 0, 0, 0);
if (plotted)
{
switch(stnSettings.display.xScale)
{
case STNALIGNPRDCT:
case STNALIGNUSER:
case RELATIVE:
{
axis_label = g_strdup("Seconds");
labelW = fontSIZEP(axis_label, AXISF, WIDTH);
labelH = fontSIZEP(axis_label, AXISF, HEIGHT);
x1 = ( STNLFTM < labelW) ? 1 : STNLFTM - labelW+1;
y1 = height - labelH - 1;
xaxisP(pmap, STNGXC[STNFGBG], &trcGR,
(double) 0.0, (double) 9, 
(double) totLen, 1, -1, -1, 
(double) 0.0, FALSE, (double) 0, STNFLBLA);
fontDrawP(pmap, axis_label, x1, y1, AXISF, STNFLBLA);
free(axis_label);
}
break;
case ABSOLUTE:
{
xAxisABSSTN(pmap, STNGXC[STNFGBG], &trcGR, (double) absStart, STNANALYSIS, LABEL_BELOW);
}
break;
}
}
memcpy(&stnStates.analysis.plot.gr[LOCALGR], &trcGR, sizeof(graph));
window(&stnStates.analysis.plot.gr[LOCALGR], (double) 0, totLen, min, max, 0, 0);
if ((!stnStates.analysis.plot.limits.selection.user.left &&
!stnStates.analysis.plot.limits.selection.user.right)) 
{
viewport(&stnStates.analysis.plot.gr[MAINGR], ANALFTM, width-ANARGTM, ANATOPMSG, ANATOPM);
window(&stnStates.analysis.plot.gr[MAINGR], 
(double) 0, (double) totLen, 
(double) 0, (double) (ANATOPXIS),
0, (double) 0.0);
stnStates.analysis.plot.limits.selection.user.left = 0;
stnStates.analysis.plot.limits.selection.user.right = 
stnStates.analysis.plot.limits.selection.user.left + totLen;
stnStates.analysis.plot.limits.selection.user.length =
stnStates.analysis.plot.limits.selection.user.right -
stnStates.analysis.plot.limits.selection.user.left;
}
switch(stnSettings.display.xScale)
{
case STNALIGNPRDCT:
case STNALIGNUSER:
case RELATIVE:
{
xaxisP(pmap, STNGXC[STNFGBG], &stnStates.analysis.plot.gr[MAINGR],
(double) 0.0, (double) 8, 
(double) stnStates.analysis.plot.gr[MAINGR].user_xdif, -1, 1, -1, 
(double) 0.0, FALSE, (double) 0, STNFLBLA);
}
break;
case ABSOLUTE:
{
double absStart = stnStates.analysis.plot.limits.times[STARTABS];
xAxisABSSTN(pmap, STNGXC[STNFGBG], &stnStates.analysis.plot.gr[MAINGR],
absStart, STNANALYSIS, LABEL_ABOVE);
}
break;
}
{ 
int mag_x1, mag_x2;
mag_x1 = USER2PIXX(&stnStates.analysis.plot.gr[MAINGR],
stnStates.analysis.plot.limits.selection.user.left);
mag_x2 = USER2PIXX(&stnStates.analysis.plot.gr[MAINGR],
stnStates.analysis.plot.limits.selection.user.right);
if (mag_x1==mag_x2)
mag_x2++;
gdk_draw_rectangle(pmap, stnSettings.drawing.ctxts[STNANALYSIS][STNFGBG][INVGC], TRUE, 
mag_x1, ANATOPM-10, mag_x2 - mag_x1, 10);
}
{
EVENTINFO *evt=stnStates.event.event;
char *tformStr, *evtStr;
if (evt)
{ 
if (evt == &stnStates.event.user)
{
evtStr = g_strdup_printf("USER Event: %s, %0.1f (%0.3f, %0.3f, %0.1f)",
evt->timeStamp, evt->loc[STNEVTMAG], evt->loc[STNEVTLAT], evt->loc[STNEVTLON], 
evt->loc[STNEVTDEP]);
}
else
{
evtStr = g_strdup_printf("Event: %s, %0.1f (%s), %s, (%0.3f, %0.3f, %0.1f), %s",
evt->timeStamp, evt->loc[STNEVTMAG], evt->magType, evt->catalog,
evt->loc[STNEVTLAT], evt->loc[STNEVTLON], evt->loc[STNEVTDEP],
evt->description);
}
labelH = fontSIZEP(evtStr, STNLBLF, HEIGHT);
fontDrawP(pmap, evtStr, 5, ANATOPMSG1/2 - labelH/2 , STNLBLF, STNFLBLA);
free(evtStr);
}
if (stnStates.analysis.tForm.common &&
!stnStates.analysis.tForm.tFormStr)
{ 
stnStates.analysis.tForm.tFormStr = 
makeTFormString(stnStates.analysis.tForm.tFormStr, ANAORIG);
}
else if (!stnStates.analysis.tForm.common)
{
IFFREE(stnStates.analysis.tForm.tFormStr);
stnStates.analysis.tForm.tFormStr = g_strdup("Transforms differ between traces, mouse-hover on trace label...");
}
tformStr = g_strdup(stnStates.analysis.tForm.tFormStr);
labelH = fontSIZEP(tformStr, STNLBLF, HEIGHT);
fontDrawP(pmap, tformStr, 5, ANATOPMSG1, STNLBLF, STNFLBLA);
free(tformStr);
gdk_draw_line(pmap, STNGXC[STNFGBG], 0, ANATOPMSG-2, width, ANATOPMSG-2);
gdk_draw_line(pmap, STNGXC[STNFGBG], 0, ANATOPMSG-3, width, ANATOPMSG-3);
}
}
static void setCommonFlag()
{
gboolean tFormCommon;
if (!stnStates.analysis.tForm.tForms)
{ 
stnStates.analysis.tForm.common = TRUE;
}
else if (!g_hash_table_size(stnStates.analysis.tForm.tForms))
{ 
stnStates.analysis.tForm.common = TRUE;
}
else if (g_slist_length(stnStates.analysis.traces) != 
g_hash_table_size(stnStates.analysis.tForm.tForms))
{ 
stnStates.analysis.tForm.common = FALSE;
}
else
{
tFormCommon = !stnStates.analysis.selections ? TRUE : FALSE;
stnStates.analysis.tForm.common = stnStates.analysis.tForm.common ? tFormCommon : FALSE;
}
}
static GStaticMutex uvwMutex = G_STATIC_MUTEX_INIT;
static int analyzeTRC(ANAARGS *anaArgs)
{
int   i, tForm, trcNum = anaArgs->trcNum;
PQLDATA  *pqlData=anaArgs->data;
traceInfo *trc;
ANADATA  *anaData;
short  *sptr;
gint32  *ptr;
float  *lptr;
double  *dptr;
trc = pqlData->trc;
anaData = pqlData->anaData;
if (!anaData)
stnStates.analysis.tForm.transform = tForm = ANAORIG;
else
tForm = stnStates.analysis.tForm.transform;
#if 0
if (stnStates.analysis.tForm.zoomOut &&
g_slist_length(stnStates.analysis.tForm.list))
{ 
memcpy(anaData->dataInfo.data, anaData->original, trc->data.dataInfo.head.numSamples*(sizeof(float)));
for(tIter = stnStates.analysis.tForm.list;
tIter;
tIter = g_slist_next(tIter))
{
analyzeData(anaData, *((int *) tIter->data));
}
}
#endif
switch (tForm)
{
case ANATFORMS: 
case NONE:
break;
case ANAORIG: 
if (!anaData)
{ 
GSList *iter, *chnMETA;
sptr = (short *) trc->data.dataInfo.data;
ptr = (gint32 *) trc->data.dataInfo.data;
lptr = (float *) trc->data.dataInfo.data;
dptr = (double *) trc->data.dataInfo.data;
anaData = calloc(1, sizeof(ANADATA));
anaData->original = malloc(trc->data.dataInfo.head.numSamples*(sizeof(float)));
anaData->dataInfo.data = malloc(trc->data.dataInfo.head.numSamples*(sizeof(float)));
for(i=0;i<trc->data.dataInfo.head.numSamples;i++)
{ 
DATAP(trc->data.head.data_form, i, (anaData->original[i]));
}
anaData->trc = trc;
anaData->trcNum = anaArgs->trcNum;
chnMETA = getChnMeta(trc);
if (chnMETA)
{ 
CHNMETA *chnMeta, *chnMeta1;
for(iter=chnMETA;iter;iter=g_slist_next(iter))
{
chnMeta = iter->data;
chnMeta1 = calloc(1, sizeof(CHNMETA));
memcpy(chnMeta1, chnMeta, sizeof(CHNMETA));
anaData->chnMETA = g_slist_prepend(anaData->chnMETA, chnMeta1);
}
}
else if (pqlData->misc.chnMETA)  
anaData->chnMETA = pqlData->misc.chnMETA;
pqlData->anaData = anaData;
if (!pqlData->misc.hashKey)
{ 
time_t  tloc;
struct tm timeN;
time(&tloc);
gmtime_r(&tloc, &timeN);
pqlData->misc.hashKey = timeN.tm_hour*60*60 + timeN.tm_min*60 + 
timeN.tm_sec + ONEDAYOFSECS*trcNum;
}
}
memcpy(anaData->dataInfo.data, anaData->original, trc->data.dataInfo.head.numSamples*(sizeof(float)));
memcpy(&anaData->dataInfo.amps, &trc->data.dataInfo.amps, sizeof(amplitudes));
anaData->dataInfo.head.secsPsamp = (double) (trc->data.head.sampInt/ 1000000.0);
anaData->dataInfo.head.sampInt = trc->data.head.sampInt;
anaData->dataInfo.head.numSamples = trc->data.dataInfo.head.numSamples;
anaData->dataInfo.head.data_form = MY_FLOAT;
if (anaData->tForm.dispStr)
{ 
free(anaData->tForm.dispStr);
anaData->tForm.dispStr = NULL;
}
anaData->tForm.dispStr = makeTFormString(anaData->tForm.dispStr, tForm);
anaData->tForm.deconvolve = FALSE;
break;
case ANAUVW:
{ 
CHNMETA  *chnMeta;
TRC_N_DATA *trcNdata;
XYZCOMPONENT *comp;
char  *CGkey, *instID;
int   sensor;
if (!anaData->chnMETA ||
!anaData->chnMETA->data)
{
STNdispMsg(DISPLAY, "Unable to Transform to UVW, no Meta-DATA Available");
gdk_beep();    
break;
}
chnMeta = anaData->chnMETA->data;
for(sensor=0;sensor<TTLSENSORS;sensor++, g_free(instID))
{
instID = g_ascii_strup(chnMeta->instID, -1);
if (g_strrstr(instID, sensors[sensor]))
break;
}
if (sensor==TTLSENSORS)
break;
g_free(instID);
g_static_mutex_lock(&uvwMutex);
CGkey = g_strdup_printf("%s%s%s%.2s", trc->data.head.network,
trc->data.head.station,
trc->data.head.location,
trc->data.head.channel);
if ((comp = g_hash_table_lookup(CG, CGkey)) == NULL)
{
comp = calloc(1, sizeof(XYZCOMPONENT));
comp->sensor = sensor;
comp->success = FALSE;
comp->comp = g_hash_table_new_full(g_str_hash, g_str_equal, NULL, (GDestroyNotify)free);
g_hash_table_insert(CG, CGkey, comp);
}
else
{
free(CGkey);
}
trcNdata = calloc(1, sizeof(TRC_N_DATA));
trcNdata->data = &anaData->dataInfo;
g_hash_table_insert(comp->comp, &trc->data.head.channel[2], trcNdata);
g_static_mutex_unlock(&uvwMutex);
}
break;
default:
{
GSList *tForms;
analyzeData(anaData, tForm);
anaData->tForm.dispStr = makeTFormString(anaData->tForm.dispStr, tForm);
anaData->display.selected = FALSE;
tForms = g_hash_table_lookup(stnStates.analysis.tForm.tForms, (gconstpointer) &pqlData->misc.hashKey);
if (!tForms)
{
tForms = g_slist_append(tForms, GINT_TO_POINTER(tForm));
g_hash_table_insert(stnStates.analysis.tForm.tForms, 
(gpointer) &pqlData->misc.hashKey, tForms);
}
else
{
tForms = g_slist_append(tForms, GINT_TO_POINTER(tForm));
}
stnStates.analysis.tForm.list = TRUE;
}
break;
}
g_free(anaArgs);
g_idle_add((GSourceFunc) nextAnaTrace, GINT_TO_POINTER(NEXT));
return FALSE;
}
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
static gboolean nextAnaTrace(gpointer w)
{
static GSList *anaIter;
static int  trcNum;
ANAARGS   *anaArgs;
static int  threadCnt;
int    state, when = GPOINTER_TO_INT(w);
if (g_async_queue_length(drawQ))
{ 
if (threadCnt)
{
threadCnt--;
if (!threadCnt)
{ 
g_idle_add((GSourceFunc) readDrawQ, NULL);
}
}
else
{ 
g_idle_add((GSourceFunc) readDrawQ, NULL);
}
return FALSE;
}
if (!stnStates.analysis.tForm.tForms)
{
stnStates.analysis.tForm.tForms = 
g_hash_table_new_full(g_int_hash, g_int_equal, NULL, (GDestroyNotify) g_slist_free);
}
g_static_mutex_lock(&myMutex);
switch(when)
{
case INIT1:
{
gdk_window_set_cursor(topLevel, hourCursor);
if (stnStates.analysis.selections)
anaIter = stnStates.analysis.selections;
else
anaIter = stnStates.analysis.traces;
trcNum = 0;
threadCnt=0;
if (stnStates.analysis.tForm.transform == ANAUVW)
{
CG = g_hash_table_new_full(g_str_hash, g_str_equal, 
(GDestroyNotify)free, (GDestroyNotify)freeCG);
}
#if 0
if (stnStates.analysis.plot.limits.selection.user.right)
ANAsetDatas(stnStates.analysis.traces); 
if ((stnStates.analysis.tForm.left > stnStates.analysis.plot.limits.selection.user.left ||
stnStates.analysis.tForm.right < stnStates.analysis.plot.limits.selection.user.right) &&
g_slist_length(stnStates.analysis.tForm.list))
{
stnStates.analysis.tForm.zoomOut = TRUE;
stnStates.analysis.tForm.left = stnStates.analysis.plot.limits.selection.user.left;
stnStates.analysis.tForm.right = stnStates.analysis.plot.limits.selection.user.right;
}
else
stnStates.analysis.tForm.zoomOut = FALSE;
#endif
if (stnStates.analysis.tForm.transform != NONE &&
stnStates.analysis.tForm.transform != ANATFORMS &&
stnStates.analysis.tForm.transform != ANAORIG)
{
if (stnStates.analysis.tForm.common)
stnStates.analysis.tForm.tFormStr = 
makeTFormString(stnStates.analysis.tForm.tFormStr,
stnStates.analysis.tForm.transform);
}
}
break;
case NEXT:
threadCnt--;
case INIT2:
if (anaIter)
anaIter = g_slist_next(anaIter);
trcNum++;
break;
}
if (anaIter)
{ 
threadCnt++;
state = ANANXTTRC;
}
else
{ 
if (!threadCnt)
state = ANAFINISH;
else
state = ANAPREFINISH;
}
g_static_mutex_unlock(&myMutex);
switch(state)
{
case ANANXTTRC:
anaArgs = calloc(1, sizeof(ANAARGS));
anaArgs->data = (PQLDATA *) anaIter->data;
anaArgs->trcNum = trcNum;
makeThread(ASYNC, (GThreadFunc) analyzeTRC, anaArgs, NULL);
break;
case ANAPREFINISH:
break;     
case ANAFINISH:
{
int i, tForm;
GSList *anaIter, *tIter;
ANADATA *anaData;
PQLDATA *pqlData;
static GtkWidget *da;
if (!da) da=STNDA[STNANALYSIS];
if (stnStates.analysis.tForm.transform == ANAORIG &&
stnStates.analysis.tForm.list)
{ 
ANAsetDatas(stnStates.analysis.traces);
for(anaIter = stnStates.analysis.traces, i=0;
anaIter;
anaIter = g_slist_next(anaIter), i++)
{
pqlData = anaIter->data;
anaData = ((PQLDATA *) (anaIter->data))->anaData;
free(anaData->tForm.dispStr); anaData->tForm.dispStr = NULL;
anaData->tForm.dispStr = makeTFormString(anaData->tForm.dispStr, ANAORIG);
for(tIter = g_hash_table_lookup(stnStates.analysis.tForm.tForms, 
(gconstpointer) &pqlData->misc.hashKey);
tIter;
tIter = g_slist_next(tIter))
{
tForm = GPOINTER_TO_INT(tIter->data);
analyzeData(anaData, tForm);
anaData->tForm.dispStr = 
makeTFormString(anaData->tForm.dispStr, tForm);
}
}
}
setCommonFlag();
switch (stnStates.analysis.tForm.transform)
{
case ANAUVW: 
g_hash_table_foreach(CG, (GHFunc) uvw, GINT_TO_POINTER(FUNCUVW));
break;
}
if (stnStates.event.event)
calcArrivals(FALSE);
drawANAtrc(stnStates.analysis.traces);
stnStates.pmap.dirty[STNANALYSIS][0] = FALSE;
gdk_window_set_cursor(topLevel, NULL);
stnStates.display.dataState = STNDRAWDONE;
stnStates.analysis.tForm.transform = NONE;
gtk_widget_queue_draw_area(da, 0, 0,  
da->allocation.width, 
da->allocation.height);
makeSTNSelectionList(STNANALYSIS);
stnStates.pmap.dirty[STNANALYSIS][stnSettings.main.data] = FALSE;
if (stnStates.event.event &&
EvtPhInfo)
evtPhDisp(NULL, 0, 0);
if (CG)
{
g_hash_table_destroy(CG);
CG = NULL;
}
}
break;
}
return FALSE;
}
int stnAnaInstance(gpointer nothing)
{
int i, maxThreads, trcCnt = g_slist_length(stnStates.analysis.traces);
g_idle_add((GSourceFunc) nextAnaTrace, GINT_TO_POINTER(INIT1));
maxThreads = (pqlxStates.machine.numCPUs*MAXTHREADSPCPU < trcCnt) 
? pqlxStates.machine.numCPUs*MAXTHREADSPCPU 
: trcCnt;
for(i=1;i<maxThreads;i++)
{
g_idle_add((GSourceFunc) nextAnaTrace, GINT_TO_POINTER(INIT2));
}
return FALSE;
}
void drawSTNana(GdkPixmap *pixmap)
{
pmap = pixmap;
gdk_drawable_get_size(pmap, &width, &height);
STNGXC[STNMSG] = stnSettings.drawing.ctxts[STNANALYSIS][STNMSG][NORMALGC];
STNGXC[STNTEXT] = stnSettings.drawing.ctxts[STNANALYSIS][STNTEXT][NORMALGC];
STNGXC[STNFGBG] = stnSettings.drawing.ctxts[STNANALYSIS][STNFGBG][NORMALGC];
STNGXC[STNSBAR] = stnSettings.drawing.ctxts[STNANALYSIS][STNSBAR][NORMALGC];
STNGXC[STNGAPI] = stnSettings.drawing.ctxts[STNANALYSIS][STNGAPI][NORMALGC];
STNGXC[STNOLAP] = stnSettings.drawing.ctxts[STNANALYSIS][STNOLAP][NORMALGC];
if (!stnStates.analysis.tForm.common)
{
IFFREE(stnStates.analysis.tForm.tFormStr);
}
switch(stnSettings.event.dispOrder)
{
case EVTDISPSTN:
stnStates.analysis.traces = g_slist_sort_with_data(stnStates.analysis.traces, 
(GCompareDataFunc) sortAnaTraces,
GINT_TO_POINTER(STNSORTTIME));
stnStates.analysis.traces = g_slist_sort_with_data(stnStates.analysis.traces, 
(GCompareDataFunc) sortAnaTraces, 
GINT_TO_POINTER(STNSORTNAME));
stnStates.event.arrivals = g_slist_sort_with_data(stnStates.event.arrivals, 
(GCompareDataFunc) sortArrivalsList, 
GINT_TO_POINTER(STNSORTNAME));
break;
case EVTDISPEVT:
stnStates.analysis.traces = g_slist_sort_with_data(stnStates.analysis.traces, 
(GCompareDataFunc) sortAnaTraces, 
GINT_TO_POINTER(STNSORTEPI));
stnStates.event.arrivals = g_slist_sort_with_data(stnStates.event.arrivals, 
(GCompareDataFunc) sortArrivalsList, 
GINT_TO_POINTER(STNSORTEPI));
break;
}
stnAnaInstance(NULL);
stnStates.user.keyActive = NONE;
memset(&stnStates.analysis.plot.extra.user.point[0], 0, sizeof(pointID));
memset(&stnStates.analysis.plot.extra.user.point[1], 0, sizeof(pointID));
STNdispMsg(UNDISPLAY, NULL);
}
