#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
char *getResp(ANADATA *anaData)
{ 
traceInfo *trc=anaData->trc;
int   chnKey;
char  *respFile, *msg;
static char *dbNm;
static GHashTable *respHash=NULL;
if (!dbNm)
{ 
dbNm = g_strdup(pqlxStates.conn.dbNm);
}
if (strcmp(pqlxStates.conn.dbNm, dbNm))
{
g_hash_table_destroy(respHash);
respHash = NULL;
free(dbNm);
dbNm = g_strdup(pqlxStates.conn.dbNm);
}
if (!respHash)
respHash = g_hash_table_new_full(g_int_hash, g_int_equal, free, free);
chnKey = chnNum(trc->data.head.network, trc->data.head.station, 
trc->data.head.location, trc->data.head.channel);
if (!(respFile = g_hash_table_lookup(respHash, &chnKey)))
{
SQLDI  sqldi;
RESPFILE resp;
int   *key;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&resp, 0, sizeof(RESPFILE));
sqldi.descr.tableData = RESPTBL;
sqldi.data = &resp;
sqldi.args.dataEvent = GET_DATA;
sqldi.args.sqr = anaData->trcNum;
resp.keys.chnKey = chnKey;
db_request(&sqldi);
if (resp.data.fileName)
{
key = calloc(1, sizeof(int));
*key = chnKey;
respFile = g_strdup(resp.data.fileName);
free(resp.data.fileName);
g_hash_table_insert(respHash, key, respFile);
}
else
respFile = NULL;
}
msg = NULL;
if (!respFile)
{ 
char *chnNm = g_strdup_printf("%s.%s.%s.%s", 
trc->data.head.network, trc->data.head.station, 
trc->data.head.location, trc->data.head.channel);
msg = g_strdup_printf("No Response File found for Channel %s, Cannot make Computation",
chnNm);
free(chnNm);
}
else
{ 
if (!g_file_test(respFile, G_FILE_TEST_EXISTS))
{
msg = g_strdup_printf("Response File '%s' Not Found, Cannot make Computation", respFile);
respFile = NULL;
}
}
if (msg)
{
gdk_beep();
STNdispMsg(DISPLAY, msg);
free(msg);
}
return (respFile);
}
void makeSTNgc(GdkColor *fg, GdkColor *bg, GtkWidget *widget, GdkGC **ctxt)
{
if (ctxt[NORMALGC])
{
g_object_unref(ctxt[NORMALGC]);
g_object_unref(ctxt[ABNORMALGC]);
g_object_unref(ctxt[INVGC]);
}
ctxt[NORMALGC] = gdk_gc_new(widget->window);
gdk_gc_set_rgb_fg_color (ctxt[NORMALGC], fg);
gdk_gc_set_rgb_bg_color (ctxt[NORMALGC], bg);
ctxt[ABNORMALGC] = gdk_gc_new(widget->window);
gdk_gc_set_rgb_bg_color (ctxt[ABNORMALGC], fg);
gdk_gc_set_rgb_fg_color (ctxt[ABNORMALGC], bg);
ctxt[INVGC] = gdk_gc_new(widget->window);
gdk_gc_set_rgb_bg_color (ctxt[INVGC], bg);
gdk_gc_set_rgb_fg_color (ctxt[INVGC], fg);
gdk_gc_set_function (ctxt[INVGC], GDK_INVERT);
}
void makeSTNGC(int screen, int context, GdkColor *fg, GdkColor *bg, GtkWidget *widget)
{
makeSTNgc(fg, bg, widget, (GdkGC **) &(stnSettings.drawing.ctxts[screen][context]));
}
void make_stn_gc(GtkWidget *widget)
{
int   i, j;
GdkColor *fg=NULL, *bg=NULL;
for (j=0;j<TTLSTNSCREENS;j++)
for (i=0;i<TOTALSTNCONTEXTS;i++)
{
switch(i)
{
case STNMSG:
fg = &darkBlue; bg = &darkGrey;
break;    
case STNTEXT:
fg = &myBlack; bg = &myWhite;
break;
case STNFGBG:
fg = &stnSettings.drawing.colors[j][STNFG];
bg = &stnSettings.drawing.colors[j][STNBG];
break;
case STNSBAR:
fg = &stnSettings.drawing.colors[j][STNSB]; 
bg = &stnSettings.drawing.colors[j][STNBG];
break;
case STNGAPI:
fg = &stnSettings.drawing.colors[j][STNGP]; 
bg = &stnSettings.drawing.colors[j][STNBG];
break;
case STNOLAP:
fg = &stnSettings.drawing.colors[j][STNOP]; 
bg = &stnSettings.drawing.colors[j][STNBG];
break;
case STNARR:
fg = &stnSettings.drawing.colors[j][STNPA]; 
bg = &stnSettings.drawing.colors[j][STNBG];
break;
case STNPICK:
fg = &stnSettings.drawing.colors[j][STNUP]; 
bg = &stnSettings.drawing.colors[j][STNBG];
break;
}
makeSTNgc(fg, bg, widget, (GdkGC **) &(stnSettings.drawing.ctxts[j][i]));
}
if (!OGXC[0]) 
make_gc(STNDA[STNMAIN], MAGNIFYSCR);
for (j=0;j<TTLPOPUPWIN;j++)
for (i=0;i<STNMAXPOPUPCOLOURS;i++)
{
fg = &stnSettings.analysis.popup.colors[j][STNFG];
bg = &stnSettings.analysis.popup.colors[j][STNBG];
makeSTNgc(fg, bg, widget, (GdkGC **) &(stnSettings.analysis.popup.ctxt[j][i]));
}
return;
}
void initSTNFont()
{
int   i;
GdkColor *fg=NULL, *bg=NULL;
initFontP();
for(i=STNFLBL;i<NUMFONTGCS;i++)
{
switch(i)
{
case STNFLBL:
fg = &stnSettings.drawing.colors[STNMAIN][STNFG]; 
bg = &stnSettings.drawing.colors[STNMAIN][STNBG];
break;
case STNFLBLA:
fg = &stnSettings.drawing.colors[STNANALYSIS][STNFG]; 
bg = &stnSettings.drawing.colors[STNANALYSIS][STNBG];
break;
case STNFLBLS:
fg = &stnSettings.analysis.popup.colors[SPECTRA_WIN][STNFG];
bg = &stnSettings.analysis.popup.colors[SPECTRA_WIN][STNBG];
break;
case STNFLBLP:
fg = &stnSettings.analysis.popup.colors[PSD_WIN][STNFG];
bg = &stnSettings.analysis.popup.colors[PSD_WIN][STNBG];
break;
case STNFLBLPM:
fg = &stnSettings.analysis.popup.colors[PM_WIN][STNFG];
bg = &stnSettings.analysis.popup.colors[PM_WIN][STNBG];
break;
case STNFLBLPMC:
fg = &stnSettings.analysis.popup.colors[PM_WIN][STNPMC];
bg = &stnSettings.analysis.popup.colors[PM_WIN][STNBG];
break;
case STNFLBLPMEBA:
fg = &stnSettings.analysis.popup.colors[PM_WIN][STNPMEBA];
bg = &stnSettings.analysis.popup.colors[PM_WIN][STNBG];
break;
}
makeFONTGC(i, fg, bg);
}
}
void dispMsgSTN(int action, char *msg)
{
static guint msgContext;
if(!msgContext)
msgContext = gtk_statusbar_get_context_id((GtkStatusbar *) statusBarSTN, "STNDATASCREENS");
switch(action)
{
case DISPLAY:
gtk_statusbar_push((GtkStatusbar *) statusBarSTN, msgContext, msg);
break;
case UNDISPLAY:
gtk_statusbar_pop((GtkStatusbar *) statusBarSTN, msgContext);
break;
}
return ;
}
GSList *getChnMeta(traceInfo *trc)
{
GSList *iter;
CHNDATA *chnData;
char *name = g_strdup_printf("%s.%s.%s.%s", 
trc->data.head.network,
trc->data.head.station,
(strlen(trc->data.head.location) ? trc->data.head.location : "--"),
trc->data.head.channel);
for(iter = stnStates.main.chnList; iter; iter=g_slist_next(iter))
{
chnData = iter->data;
if (chnData->data.longName &&    
!strcmp(chnData->data.longName, name))
break;
}
free(name);
return((iter ? chnData->data.chnMETA : NULL));
}
CHNMETA *getChnMetaD(traceInfo *trc)
{
GSList *chnMETA = getChnMeta(trc), *chnIter;
CHNMETA *chnMeta;
GDate *dMetaS=NULL, *dMetaE=NULL, *dTrc;
PTIME trcT;
if (!chnMETA)
return NULL;
memset(&trcT, 0, sizeof(PTIME));
trcT.yr = trc->data.head.year;
passcal_month_day(&trcT, trc->data.head.day);
dTrc = g_date_new_dmy(trcT.day, trcT.mo, trcT.yr);
for(chnIter = chnMETA; chnIter; chnIter=g_slist_next(chnIter))
{
chnMeta = chnIter->data;
dMetaS = g_date_new_dmy(chnMeta->dates[STARTDT].date.day,
chnMeta->dates[STARTDT].date.mo,
chnMeta->dates[STARTDT].date.yr);
dMetaE = g_date_new_dmy(chnMeta->dates[ENDDT].date.day,
chnMeta->dates[ENDDT].date.mo,
chnMeta->dates[ENDDT].date.yr);
if (g_date_get_julian(dTrc) >= g_date_get_julian(dMetaS) &&
g_date_get_julian(dTrc) < g_date_get_julian(dMetaE))
break;
g_date_free(dMetaS); dMetaS = NULL;
g_date_free(dMetaE); dMetaE = NULL;
}
g_date_free(dTrc);
return (chnIter ? chnIter->data : NULL);
}
