#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "db_iface.h"
#include "dbl_iface.h"
#include "help.h"
#include "helpTextSTN.h"
static GtkWidget *ChnScale, *chnNAME, *chnLOC, *chnCHN, *chnMAX,
*chnMIN, *chnNEW, *chnSAVE, *chnDEL, *chnScaleVIEW;
static GtkWidget *grpNAME, *grpCHNV, *grpGRPDV, *grpNEW, *grpSAVE, *grpDEL;
static GtkTooltips *tips;
static char toolTip[1000];
static gboolean listChgd=FALSE;
static GSList *grpChn, *grpGrp;
static void chnGrpInfo(GtkTreeView *treeview, gpointer which);
static void chnGrpEdit(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer which);
static void chnGrpCBack(GtkButton *button, gpointer type);
enum { 
TRACE_CBO = DISPS,
WINDOW_CBO,
FIXED_CBO,
NUM_YSCALE_STRS
};
char *YSCALESTRS[NUM_YSCALE_STRS] = { "TRACE", "WINDOW", "FIXED"};
enum {  
CHNNEW,
CHNSAVE,
CHNDEL,
CHNDONE,
GRPNEW,
GRPSAVE,
GRPDEL,
GRPDONE,
CHNGRPADD,
CHNGRPDEL
};
enum {  
CHNGRPCHN,  
CHNGRPGRP,  
CHNGRPGRPCHN, 
CHNGRPGRPGRP, 
TTLCHNGRPSTORES
};
static gint sortChnNames(YCHNSCALE *one, YCHNSCALE *two)
{
return(strcmp(one->name, two->name));
}
static gint findChnScale(YCHNSCALE *one, char *name)
{
return(strcmp(one->name, name));
}
static gint sortGrpNames(YCHNGROUP *one, YCHNGROUP *two)
{
return(strcmp(one->name, two->name));
}
gint findGroup(YCHNGROUP *one, char *name)
{
return(strcmp(one->name, name));
}
static gboolean chnMatch(YCHNSCALE *chnScaleData, char *loc, char *chn)
{
gboolean ret;
ret = globmatch(loc, chnScaleData->loc);
if (!ret)
return ret;
ret = globmatch(chn, chnScaleData->chn);
return ret;
}
char *getChnGrpScale(char *chnName, int screen, int which)
{
YCHNSCALE *chnScaleData;
GSList  *iter;
char  loc[12], chn[12], *scale;
static char *empty = "";
scale = empty;
if (!stnStates.display.yScaleGrp[screen].chnGroupScale)
return scale;
sscanf(chnName, "%[^.]s", loc);
sscanf((strchr(chnName, '.')+1), "%s", chn);
for(iter = (stnStates.display.yScaleGrp[screen].chnGroupScale)->chnScales;
iter;
iter = g_slist_next(iter))
{
chnScaleData = iter->data;
if (chnMatch(chnScaleData, loc, chn))
{
scale = chnScaleData->scale[which];
}
}
return scale;
}
gint getAutoScale(AUTOSCALE *one, char *channel)
{
return(strcmp(one->name, channel));
}
gint getChnScale(YCHNSCALE *one, char *name)
{
return(strcmp(one->name, name));
}
char *getChnGrpName(char *chnName, int screen)
{
YCHNSCALE *chnScaleData;
GSList  *iter;
char  loc[12], chn[12], *chnGrpName=NULL;
if (!chnName)
return NULL;
sscanf(chnName, "%[^.]s", loc);
sscanf((strchr(chnName, '.')+1), "%s", chn);
for(iter = (stnStates.display.yScaleGrp[screen].chnGroupScale)->chnScales;
iter;
iter = g_slist_next(iter))
{
chnScaleData = iter->data;
if (chnMatch(chnScaleData, loc, chn))
{
chnGrpName = chnScaleData->name;
}
}
return chnGrpName;
}
GtkListStore *chnStore[TTLCHNGRPSTORES];
static void add_hdr_columns(GtkTreeView *treeview, int which)
{
char  *label=NULL;
GtkCellRenderer *renderer;
GtkTreeViewColumn *col;
switch(which)
{
case CHNGRPCHN:
case CHNGRPGRPCHN:
label = g_strdup("Channels");
break;
case CHNGRPGRP:
label = g_strdup("Groups");
break;
case CHNGRPGRPGRP:
label = g_strdup("Grouped");
break;
}
renderer = gtk_cell_renderer_text_new();
col = gtk_tree_view_column_new_with_attributes(label, renderer, "text", 0, NULL);
gtk_tree_view_insert_column(treeview, col, 0);
free(label);
}
static GtkWidget *makeModel(int which)
{
GtkWidget *treeview;
chnStore[which] = gtk_list_store_new(1, G_TYPE_STRING);
treeview = gtk_tree_view_new_with_model(GTK_TREE_MODEL (chnStore[which]));
return (treeview);
}
static void makeLists(int which)
{ 
char  *name=NULL;
YCHNSCALE *chnData;
YCHNGROUP *grpData;
GtkTreeIter iter;
GSList  *listIter, *list[] = { stnSettings.main.yChnScale.scales,
stnSettings.main.yChnScale.groups,
grpChn,
grpGrp};
if (chnStore[which])
gtk_list_store_clear(chnStore[which]);
for(listIter = list[which]; listIter; listIter = g_slist_next(listIter))
{
switch(which)
{
case CHNGRPCHN:
case CHNGRPGRPGRP:
case CHNGRPGRPCHN:
chnData = listIter->data;
name = chnData->name;
break;
case CHNGRPGRP:
grpData = listIter->data;
name = grpData->name;
break;
}
gtk_list_store_append(chnStore[which], &iter);
gtk_list_store_set(chnStore[which], &iter, 0, name, -1);
}
}
static GtkWidget *helpFrame()
{
static GtkWidget *view;
view = gtk_text_view_new();
gtk_text_view_set_editable(GTK_TEXT_VIEW(view), FALSE);
gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(view), FALSE);
gtk_text_view_set_pixels_below_lines(GTK_TEXT_VIEW(view), 10);
gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(view), GTK_WRAP_WORD);
return view;
}
static int len;
static void formatT(GtkTextBuffer *buffer, int format, int ind, char *str)
{
GtkTextIter start, end;
static GtkTextTag *tagH1, *tagH2, *tagBN, *tagBB, *tagI1, *tagPB1, 
*tagI2, *tagI3, *tagI4, *tagI5, *tagPB0, *tagPA1;
if (!len)
{ 
tagH1 = gtk_text_buffer_create_tag(buffer, "header1", "font", HELPHFONT1, NULL);
tagH2 = gtk_text_buffer_create_tag(buffer, "header2", "font", HELPHFONT2, NULL);
tagBN = gtk_text_buffer_create_tag(buffer, "body1", "font", HELPBFONT, NULL);
tagBB = gtk_text_buffer_create_tag(buffer, "body2", "font", HELPBBFONT, NULL);
tagI1 = gtk_text_buffer_create_tag(buffer, "indent1", "left-margin", HELPIND1, NULL);
tagI2 = gtk_text_buffer_create_tag(buffer, "indent2", "left-margin", HELPIND2, NULL);
tagI3 = gtk_text_buffer_create_tag(buffer, "indent3", "left-margin", HELPIND3, NULL);
tagI4 = gtk_text_buffer_create_tag(buffer, "indent4", "left-margin", HELPIND4, NULL);
tagI5 = gtk_text_buffer_create_tag(buffer, "indent5", "left-margin", HELPIND5, NULL);
tagPB0 = gtk_text_buffer_create_tag(buffer, "pixelsB0", "pixels-below-lines", 0, NULL);
tagPB1 = gtk_text_buffer_create_tag(buffer, "pixelsB1", "pixels-below-lines", 20, NULL);
tagPA1 = gtk_text_buffer_create_tag(buffer, "pixelsA1", "pixels-above-lines", 20, NULL);
}
gtk_text_buffer_get_iter_at_offset(buffer, &start, len);
len += strlen(str);
gtk_text_buffer_get_iter_at_offset(buffer, &end, len);
switch(format)
{
case H1:  
gtk_text_buffer_apply_tag(buffer, tagH1, &start, &end);
break;
case H2:  
gtk_text_buffer_apply_tag(buffer, tagH2, &start, &end);
gtk_text_buffer_apply_tag(buffer, tagPA1, &start, &end);
break;
case BN0:  
gtk_text_buffer_apply_tag(buffer, tagBN, &start, &end);
gtk_text_buffer_apply_tag(buffer, tagPB0, &start, &end);
break;
case BB0:  
gtk_text_buffer_apply_tag(buffer, tagBB, &start, &end);
gtk_text_buffer_apply_tag(buffer, tagPB0, &start, &end);
break;
case BN1:  
gtk_text_buffer_apply_tag(buffer, tagPB1, &start, &end);
gtk_text_buffer_apply_tag(buffer, tagBN, &start, &end);
break;
case BB1:  
gtk_text_buffer_apply_tag(buffer, tagPB1, &start, &end);
gtk_text_buffer_apply_tag(buffer, tagBB, &start, &end);
break;
}
switch (ind)
{
case 1:
gtk_text_buffer_apply_tag(buffer, tagI1, &start, &end);
break;
case 2:
gtk_text_buffer_apply_tag(buffer, tagI2, &start, &end);
break;
case 3:
gtk_text_buffer_apply_tag(buffer, tagI3, &start, &end);
break;
case 4:
gtk_text_buffer_apply_tag(buffer, tagI4, &start, &end);
break;
case 5:
gtk_text_buffer_apply_tag(buffer, tagI5, &start, &end);
break;
}
}
static GtkWidget *helpText()
{
GtkTextBuffer *buffer;
GtkWidget *view=NULL;
char  helpstring[10000];
view = helpFrame();
strcpy(helpstring, STNYCG1);
strcat(helpstring, STNYCG1a);
strcat(helpstring, STNYCG2);
strcat(helpstring, STNYCG3);
strcat(helpstring, STNYCG4);
strcat(helpstring, STNYCG5a);
strcat(helpstring, STNYCG5b);
strcat(helpstring, STNYCG6a);
strcat(helpstring, STNYCG6b);
strcat(helpstring, STNYCG7a);
strcat(helpstring, STNYCG7b);
strcat(helpstring, STNYCG8a);
strcat(helpstring, STNYCG8b);
strcat(helpstring, STNYCG9);
strcat(helpstring, STNYCG10);
strcat(helpstring, STNYCG11a);
strcat(helpstring, STNYCG11b);
strcat(helpstring, STNYCG11c);
strcat(helpstring, STNYCG12a);
strcat(helpstring, STNYCG12b);
strcat(helpstring, STNYCG12c);
strcat(helpstring, STNYCG13a);
strcat(helpstring, STNYCG13b);
strcat(helpstring, STNYCG14);
strcat(helpstring, STNYCG15);
strcat(helpstring, STNYCG16);
strcat(helpstring, STNYCG17);
buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
gtk_text_buffer_set_text(buffer, helpstring, -1);
len=0;
formatT(buffer, H1, 0, STNYCG1);
formatT(buffer, H2, 0, STNYCG1a);
formatT(buffer, BN0, 1, STNYCG2);
formatT(buffer, H2, 0, STNYCG3);
formatT(buffer, BN1, 1, STNYCG4);
formatT(buffer, BB0, 2, STNYCG5a);
formatT(buffer, BN0, 3, STNYCG5b);
formatT(buffer, BB0, 2, STNYCG6a);
formatT(buffer, BN0, 3, STNYCG6b);
formatT(buffer, BB0, 2, STNYCG7a);
formatT(buffer, BN0, 3, STNYCG7b);
formatT(buffer, BB0, 2, STNYCG8a);
formatT(buffer, BN0, 3, STNYCG8b);
formatT(buffer, BN0, 4, STNYCG9);
formatT(buffer, BN0, 4, STNYCG10);
formatT(buffer, BN0, 4, STNYCG11a);
formatT(buffer, BB0, 0, STNYCG11b);
formatT(buffer, BN0, 0, STNYCG11c);
formatT(buffer, BN0, 4, STNYCG12a);
formatT(buffer, BB0, 0, STNYCG12b);
formatT(buffer, BN0, 0, STNYCG12c);
formatT(buffer, BB0, 2, STNYCG13a);
formatT(buffer, BN1, 3, STNYCG13b);
formatT(buffer, BN0, 1, STNYCG14);
formatT(buffer, BN1, 1, STNYCG15);
formatT(buffer, H2, 1, STNYCG16);
formatT(buffer, BN1, 1, STNYCG17);
return (view);
}
static GtkWidget *make_tab(int which)
{
GtkWidget *frame1, *hbox1, *hbox, *scrW, *vbox2;
GtkWidget *vbox, *vbox1, *entry, *label, *button, *view;
GtkSizeGroup *size_group;
if (!tips)
tips = gtk_tooltips_new();
frame1 = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_IN);
switch(which)
{
case CHNGRPCHN:
vbox1 = gtk_vbox_new(FALSE, 0);
hbox1 = gtk_hbox_new(FALSE, 0);
scrW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
chnScaleVIEW = view = makeModel(CHNGRPCHN);
g_signal_connect(view, "row-activated", G_CALLBACK(chnGrpEdit), GINT_TO_POINTER(CHNGRPCHN));
g_signal_connect(view, "cursor-changed", G_CALLBACK(chnGrpInfo), GINT_TO_POINTER(CHNGRPCHN));
gtk_container_add(GTK_CONTAINER(scrW), view);
gtk_box_pack_start(GTK_BOX(hbox1), scrW, TRUE, TRUE, 2);
add_hdr_columns(GTK_TREE_VIEW(view), CHNGRPCHN);
gtk_widget_set_size_request(scrW, 250, 350);
strcpy(toolTip, "Single-click to VIEW\nDouble-click to EDIT");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), view, toolTip, toolTip);
vbox = gtk_vbox_new(FALSE, 0); 
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Name: ");
chnNAME = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), FNAMELEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "The NAME of the Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Location: ");
chnLOC = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "The LOCATIONS to Match (wildcards allowed)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Channel: ");
chnCHN = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "The CHANNELS to Match (wildcards allowed)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Maximum: ");
chnMAX = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "The MAXIMUM Value to Display May be:\n\t1) Specific Value\n\t2)"
" Percentage - of Actual Maximum of Trace - e.g. 50%\n\t3) AUTO"
" - MAX of All Matching Channels\n\t4) Blank - Actual Maximum of Trace");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Minimum: ");
chnMIN = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), STNCHNFLEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "The MINIMUM Value to Display May be:\n\t1) Specific Value\n\t2)"
" Percentage - of Actual Minimum of Trace - e.g. 50%\n\t3) AUTO"
" - MIN of All Matching Channels\n\t4) Blank - Actual Minimum of Trace");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(hbox1), vbox, FALSE, FALSE, 2);
hbox = gtk_hbutton_box_new ();
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
chnNEW = button = gtk_button_new_with_label("NEW");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Make NEW Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNNEW));
chnSAVE = button = gtk_button_new_with_label("SAVE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "SAVE Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNSAVE));
chnDEL = button = gtk_button_new_with_label("DELETE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Delete Channel Group Scale from List");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNDEL));
button = gtk_button_new_with_label("DONE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNDONE));
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2); 
gtk_box_pack_end(GTK_BOX(vbox1), hbox, FALSE, TRUE, 2); 
gtk_container_add(GTK_CONTAINER(frame1), vbox1);
makeLists(CHNGRPCHN);
break;
case CHNGRPGRP:
vbox1 = gtk_vbox_new(FALSE, 0);
hbox1 = gtk_hbox_new(FALSE, 0);
scrW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
view = makeModel(CHNGRPGRP);
g_signal_connect(view, "row-activated", G_CALLBACK(chnGrpEdit), GINT_TO_POINTER(CHNGRPGRP));
g_signal_connect(view, "cursor-changed", G_CALLBACK(chnGrpInfo), GINT_TO_POINTER(CHNGRPGRP));
gtk_container_add(GTK_CONTAINER(scrW), view);
gtk_box_pack_start(GTK_BOX(hbox1), scrW, TRUE, TRUE, 2);
add_hdr_columns(GTK_TREE_VIEW(view), CHNGRPGRP);
gtk_widget_set_size_request(scrW, 250, -1);
strcpy(toolTip, "Single-click to VIEW\nDouble-click to EDIT");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), view, toolTip, toolTip);
vbox2 = gtk_vbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox1), vbox2, TRUE, TRUE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Name: ");
grpNAME = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), FNAMELEN);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
strcpy(toolTip, "The NAME of the Scaling Group");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox2), hbox, TRUE, TRUE, 2);
scrW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
grpCHNV = view = makeModel(CHNGRPGRPCHN);
g_signal_connect(view, "row-activated", G_CALLBACK(chnGrpEdit), GINT_TO_POINTER(CHNGRPGRPCHN));
g_signal_connect(view, "cursor-changed", G_CALLBACK(chnGrpInfo), GINT_TO_POINTER(CHNGRPGRPCHN));
gtk_container_add(GTK_CONTAINER(scrW), view);
gtk_box_pack_start(GTK_BOX(hbox), scrW, TRUE, TRUE, 2);
add_hdr_columns(GTK_TREE_VIEW(view), CHNGRPGRPCHN);
gtk_widget_set_size_request(scrW, 100, -1);
strcpy(toolTip, "Single-click to SELECT\nDouble-click to GROUP");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), view, toolTip, toolTip);
vbox = gtk_vbutton_box_new();
gtk_widget_set_size_request(vbox, 40, -1);
gtk_button_box_set_layout(GTK_BUTTON_BOX(vbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label(">>");
gtk_widget_set_size_request(button, 38, -1);
gtk_container_add(GTK_CONTAINER(vbox), button);
strcpy(toolTip, "GROUP Selected Scaling");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNGRPADD));
button = gtk_button_new_with_label("<<");
gtk_widget_set_size_request(button, 38, -1);
gtk_container_add(GTK_CONTAINER(vbox), button);
strcpy(toolTip, "UN-GROUP Selected Scaling");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(CHNGRPDEL));
gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 2);
scrW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrW),
GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
grpGRPDV = view = makeModel(CHNGRPGRPGRP);
g_signal_connect(view, "row-activated", G_CALLBACK(chnGrpEdit), GINT_TO_POINTER(CHNGRPGRPGRP));
g_signal_connect(view, "cursor-changed", G_CALLBACK(chnGrpInfo), GINT_TO_POINTER(CHNGRPGRPGRP));
gtk_container_add(GTK_CONTAINER(scrW), view);
gtk_box_pack_end(GTK_BOX(hbox), scrW, TRUE, TRUE, 2);
add_hdr_columns(GTK_TREE_VIEW(view), CHNGRPGRPGRP);
gtk_widget_set_size_request(scrW, 100, -1);
strcpy(toolTip, "Single-click to SELECT\nDouble-click to UN-GROUP");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), view, toolTip, toolTip);
hbox = gtk_hbutton_box_new ();
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
grpNEW = button = gtk_button_new_with_label("NEW");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Make NEW Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(GRPNEW));
grpSAVE = button = gtk_button_new_with_label("SAVE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "SAVE Channel Group Scale Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(GRPSAVE));
grpDEL = button = gtk_button_new_with_label("DELETE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Delete Channel Group Scale from List");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(GRPDEL));
button = gtk_button_new_with_label("DONE");
gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
strcpy(toolTip, "Return");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(chnGrpCBack), GINT_TO_POINTER(GRPDONE));
gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2); 
gtk_box_pack_end(GTK_BOX(vbox1), hbox, FALSE, FALSE, 2); 
gtk_container_add(GTK_CONTAINER(frame1), vbox1);
makeLists(CHNGRPGRP);
break;
}
return frame1;
}
static void make_YChnGroupScaleDialog()
{
GtkWidget *tab, *notebook, *vbox, *frame, *helpView, *scrollW;
if (!ChnScale)
{
ChnScale = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(ChnScale), "Channel Group Scaling Management"); 
gtk_container_set_border_width(GTK_CONTAINER(ChnScale), 2);
gtk_window_set_position(GTK_WINDOW(ChnScale), GTK_WIN_POS_CENTER);
vbox = gtk_vbox_new(FALSE, 0);
notebook = gtk_notebook_new ();
gtk_box_pack_start(GTK_BOX(vbox), notebook, TRUE, TRUE, 0);
gtk_container_add (GTK_CONTAINER(ChnScale), vbox);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
tab = make_tab(CHNGRPCHN);
gtk_container_add(GTK_CONTAINER(frame), tab);
gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, gtk_label_new(" Scalings "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
tab = make_tab(CHNGRPGRP);
gtk_container_add(GTK_CONTAINER(frame), tab);
gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, gtk_label_new(" Groups "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
helpView = helpText();
scrollW = gtk_scrolled_window_new(NULL, NULL);
gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrollW), GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollW),
GTK_POLICY_AUTOMATIC,
GTK_POLICY_AUTOMATIC);
gtk_container_add(GTK_CONTAINER(scrollW), helpView);
gtk_container_add(GTK_CONTAINER(frame), scrollW);
gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, gtk_label_new(" HELP "));
gtk_widget_show_all(ChnScale);
gtk_window_set_transient_for((GtkWindow *) ChnScale, (GtkWindow *) topWindow); 
}
gtk_widget_set_sensitive(chnSAVE, FALSE);
gtk_widget_set_sensitive(chnNAME, FALSE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(grpSAVE, FALSE);
gtk_widget_set_sensitive(grpNAME, FALSE);
gtk_widget_set_sensitive(grpDEL, FALSE);
return;
}
static int chnSelected = NONE, grpSelected = NONE;
static int listSelected;
void displayInfo(int screen, gboolean data)
{
YCHNSCALE *chnData;
switch(screen)
{
case CHNGRPCHN:
chnData = g_slist_nth_data(stnSettings.main.yChnScale.scales, chnSelected);
switch(data)
{
case TRUE:
{
gtk_entry_set_text(GTK_ENTRY(chnNAME), chnData->name);
gtk_entry_set_text(GTK_ENTRY(chnLOC), chnData->loc);
gtk_entry_set_text(GTK_ENTRY(chnCHN), chnData->chn);
if (strlen(chnData->scale[MAX]))
gtk_entry_set_text(GTK_ENTRY(chnMAX), chnData->scale[MAX]);
else
gtk_entry_set_text(GTK_ENTRY(chnMAX), "");
if (strlen(chnData->scale[MIN]))
gtk_entry_set_text(GTK_ENTRY(chnMIN), chnData->scale[MIN]);
else
gtk_entry_set_text(GTK_ENTRY(chnMIN), "");      
}
break;
case FALSE:
gtk_entry_set_text(GTK_ENTRY(chnNAME), "");
gtk_entry_set_text(GTK_ENTRY(chnLOC), "");
gtk_entry_set_text(GTK_ENTRY(chnCHN), "");
gtk_entry_set_text(GTK_ENTRY(chnMAX), "");
gtk_entry_set_text(GTK_ENTRY(chnMIN), "");
gtk_widget_set_sensitive(chnNAME, FALSE);
gtk_widget_set_sensitive(chnLOC, FALSE);
gtk_widget_set_sensitive(chnCHN, FALSE);
gtk_widget_set_sensitive(chnMAX, FALSE);
gtk_widget_set_sensitive(chnMIN, FALSE);
break;
}
break;
case CHNGRPGRP:
{
YCHNGROUP *grpData;
GSList  *iter;
g_slist_free(grpGrp); grpGrp = NULL;
g_slist_free(grpChn); grpChn = NULL;
grpData = g_slist_nth_data(stnSettings.main.yChnScale.groups, grpSelected);
switch(data)
{
case TRUE:
if (grpData)
{
gtk_entry_set_text(GTK_ENTRY(grpNAME), grpData->name);
for (iter = grpData->chnScales; iter; iter = g_slist_next(iter))
{ 
chnData = iter->data;
grpGrp = g_slist_append(grpGrp, chnData);
}
for (iter = stnSettings.main.yChnScale.scales; iter; iter = g_slist_next(iter))
{ 
chnData = iter->data;
if (g_slist_find_custom(grpGrp, chnData->name, (GCompareFunc) findChnScale))
continue;
grpChn = g_slist_append(grpChn, chnData);
}
}
break;
case FALSE:
gtk_entry_set_text(GTK_ENTRY(grpNAME), "");
break;
}
makeLists(CHNGRPGRPCHN);
makeLists(CHNGRPGRPGRP);
if (!grpGrp)
gtk_widget_set_sensitive(grpDEL, FALSE);
}
break;
}   
}
static void chnGrpInfo(GtkTreeView *treeview, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
char *rowS;
GtkTreePath *path;
gtk_tree_view_get_cursor (treeview, &path, NULL);
rowS = gtk_tree_path_to_string(path);
gtk_tree_path_free(path);
switch(which)
{
case CHNGRPCHN:
chnSelected = atoi(rowS);
gtk_widget_set_sensitive(chnSAVE, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(chnNAME, FALSE);
gtk_widget_set_sensitive(chnLOC, FALSE);
gtk_widget_set_sensitive(chnCHN, FALSE);
gtk_widget_set_sensitive(chnMAX, FALSE);
gtk_widget_set_sensitive(chnMIN, FALSE);
break;
case CHNGRPGRP:
grpSelected = atoi(rowS);
gtk_widget_set_sensitive(grpCHNV, FALSE);
gtk_widget_set_sensitive(grpGRPDV, FALSE);
gtk_widget_set_sensitive(grpSAVE, FALSE);
gtk_widget_set_sensitive(grpNEW, TRUE);
gtk_widget_set_sensitive(grpDEL, FALSE);
gtk_widget_set_sensitive(grpNAME, FALSE);
break;
case CHNGRPGRPCHN:
case CHNGRPGRPGRP:
listSelected = which;
chnSelected = atoi(rowS);
break;
}
displayInfo(which, TRUE);
g_free(rowS);
}
static void chnGrpEdit(GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
switch(which)
{
case CHNGRPCHN:
chnGrpInfo(treeview, w);
gtk_widget_set_sensitive(chnSAVE, TRUE);
gtk_widget_set_sensitive(chnDEL, TRUE);
gtk_widget_set_sensitive(chnLOC, TRUE);
gtk_widget_set_sensitive(chnCHN, TRUE);
gtk_widget_set_sensitive(chnMAX, TRUE);
gtk_widget_set_sensitive(chnMIN, TRUE);
break;
case CHNGRPGRP:
chnGrpInfo(treeview, w);
gtk_widget_set_sensitive(grpCHNV, TRUE);
gtk_widget_set_sensitive(grpGRPDV, TRUE);
gtk_widget_set_sensitive(grpSAVE, TRUE);
gtk_widget_set_sensitive(grpDEL, TRUE);
break;
case CHNGRPGRPCHN:
grpGrp = g_slist_append(grpGrp, g_slist_nth_data(grpChn, chnSelected));
grpChn = g_slist_remove(grpChn, g_slist_nth_data(grpChn, chnSelected));
makeLists(CHNGRPGRPCHN);
makeLists(CHNGRPGRPGRP);
break;
case CHNGRPGRPGRP:
grpChn = g_slist_append(grpChn, g_slist_nth_data(grpGrp, chnSelected));
grpGrp = g_slist_remove(grpGrp, g_slist_nth_data(grpGrp, chnSelected));
makeLists(CHNGRPGRPCHN);
makeLists(CHNGRPGRPGRP);
break;
}
}
#include <ctype.h>
static gboolean valid(char *scale)
{
int  i;
gboolean valid = TRUE, check = FALSE; 
for(i=0;i<strlen(scale);i++)
{
if (!isdigit(scale[i]) &&
scale[i] != '%' &&
scale[i] != '-' &&
scale[i] != '.')
{
check = TRUE;
scale[i] = toupper(scale[i]);
}
}
if (check &&
strcmp(scale, YSCALEAUTO))
valid = FALSE;
return valid; 
}
static void chnGrpCBack(GtkButton *button, gpointer t)
{
int  type = GPOINTER_TO_INT(t);
switch(type)
{
case CHNGRPADD:
if (listSelected == CHNGRPGRPCHN)
chnGrpEdit(NULL, NULL, NULL, GINT_TO_POINTER(CHNGRPGRPCHN));
else
gdk_beep();
break;
case CHNGRPDEL:
if (listSelected == CHNGRPGRPGRP)
chnGrpEdit(NULL, NULL, NULL, GINT_TO_POINTER(CHNGRPGRPGRP));
else
gdk_beep();
break;
case CHNNEW:
chnSelected = NONE;
displayInfo(CHNGRPCHN, FALSE);
gtk_widget_set_sensitive(chnSAVE, TRUE);
gtk_widget_set_sensitive(chnNEW, FALSE);
gtk_widget_set_sensitive(chnDEL, FALSE);
gtk_widget_set_sensitive(chnNAME, TRUE);
gtk_widget_set_sensitive(chnLOC, TRUE);
gtk_widget_set_sensitive(chnCHN, TRUE);
gtk_widget_set_sensitive(chnMAX, TRUE);
gtk_widget_set_sensitive(chnMIN, TRUE);
gtk_widget_grab_focus(chnNAME);
break;
case CHNSAVE:
{
DBLDI dbldi;
DBLRECORDS dblrecs;
STN_CHN_YSCALE chnDataDB;  
memset(&chnDataDB, 0, sizeof(STN_CHN_YSCALE));
chnDataDB.name = (char *) gtk_entry_get_text(GTK_ENTRY(chnNAME));
chnDataDB.loc = (char *) gtk_entry_get_text(GTK_ENTRY(chnLOC));
chnDataDB.chn = (char *) gtk_entry_get_text(GTK_ENTRY(chnCHN));
if (!strlen(chnDataDB.name) ||
!strlen(chnDataDB.loc) ||
!strlen(chnDataDB.chn))
{
error_dialog("STN - Channel Group Scale Definition",
"\n\tName, Location, and Channel Must"
" ALL be Specified\t\n\n\tPlease Re-Input...\n");     
break;
}
chnDataDB.scale[MAX] = (char *) gtk_entry_get_text(GTK_ENTRY(chnMAX));
chnDataDB.scale[MIN] = (char *) gtk_entry_get_text(GTK_ENTRY(chnMIN));
if (!valid(chnDataDB.scale[MAX]) ||
!valid(chnDataDB.scale[MIN]))
{
error_dialog("STN - Channel Group Scale Definition",
"\n\tMax/Min Specifiers Must be one of:\t\n"
"\tNumber\n\tPercentage\n\tBlank, or\n\tAUTO"
"\n\n\tPlease Re-Input...\n");     
break;    
}
if (!strlen(chnDataDB.scale[MAX]))
chnDataDB.scale[MAX] = g_strdup(BLANK);
if (!strlen(chnDataDB.scale[MIN]))
chnDataDB.scale[MIN] = g_strdup(BLANK);
gtk_widget_set_sensitive(chnSAVE, FALSE);
gtk_widget_set_sensitive(chnNEW, TRUE);
gtk_widget_set_sensitive(chnNAME, FALSE);
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNCHNYSCALE;
dbldi.descr.dataEvent = WRITE_SNGL;
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &chnDataDB;
dbl_request(&dbldi);
free(dblrecs.recs);
listChgd = TRUE;
readChnGrpScales();
makeLists(CHNGRPCHN);
displayInfo(CHNGRPCHN, FALSE);
}
break;
case CHNDEL:
{
DBLDI dbldi;
DBLRECORDS dblrecs;
YCHNSCALE  *chnData;  
STN_CHN_YSCALE chnDataDB;  
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNCHNYSCALE;
dbldi.descr.dataEvent = DELETE_SNGL;
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &chnDataDB;
chnData = g_slist_nth_data(stnSettings.main.yChnScale.scales, chnSelected);
chnDataDB.name = chnData->name;
dbl_request(&dbldi);
free(dblrecs.recs);
{ 
STN_GRP_YSCALE grpDataDB;  
YCHNGROUP *grpData;
GSList *iter, *iter1, *copy;
gboolean resave;
for(iter = stnSettings.main.yChnScale.groups;
iter;
iter = g_slist_next(iter))
{
resave = FALSE;
grpData = iter->data;
copy = g_slist_copy(grpData->chnScales);
for(iter1 = copy;
iter1;
iter1 = g_slist_next(iter1))
{
chnData = iter1->data;
if (!strcmp(chnData->name, chnDataDB.name))
{ 
grpData->chnScales = g_slist_remove(grpData->chnScales, chnData);
resave = TRUE;
}
}
g_slist_free(copy);
if (resave)
{ 
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
memset(&grpDataDB, 0, sizeof(STN_GRP_YSCALE));
dbldi.descr.tableData = STNGRPYSCALE;
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &grpDataDB;
grpDataDB.name = grpData->name;
switch(g_slist_length(grpData->chnScales))
{
case 0:  
dbldi.descr.dataEvent = DELETE_SNGL;
listChgd = TRUE;
break;
default:
{ 
GSList  *iter2;
dbldi.descr.dataEvent = WRITE_SNGL;
grpDataDB.name = grpData->name;
for(iter2 = grpData->chnScales; iter2; iter2 = g_slist_next(iter2))
{ 
chnData = iter2->data;
grpDataDB.chns = g_slist_append(grpDataDB.chns, chnData->name);
}
}
break;
}
dbl_request(&dbldi);
free(dblrecs.recs);
grpSelected = NONE;
}
}
}
readChnGrpScales();
makeLists(CHNGRPCHN);
makeLists(CHNGRPGRP);
displayInfo(CHNGRPCHN, FALSE);
}
break;
case CHNDONE:
gtk_grab_remove(ChnScale);
gtk_widget_hide(ChnScale);
if (listChgd)
{
makeChnGrpScaleCbo();
listChgd=FALSE;
}
setYScaleCbo(NONE, stnStates.screen);
break;
case GRPNEW:
{
GSList *iter;
grpSelected = NONE;
displayInfo(CHNGRPGRP, FALSE);
for (iter = stnSettings.main.yChnScale.scales; iter; iter = g_slist_next(iter))
grpChn = g_slist_append(grpChn, iter->data);
makeLists(CHNGRPGRPCHN);
gtk_widget_set_sensitive(grpSAVE, TRUE);
gtk_widget_set_sensitive(grpNEW, FALSE);
gtk_widget_set_sensitive(grpDEL, FALSE);
gtk_widget_set_sensitive(grpNAME, TRUE);
gtk_widget_set_sensitive(grpCHNV, TRUE);
gtk_widget_set_sensitive(grpGRPDV, TRUE);
gtk_widget_grab_focus(grpNAME);
}
break;
case GRPSAVE:
{
DBLDI dbldi;
DBLRECORDS dblrecs;
YCHNSCALE *chnData;  
STN_GRP_YSCALE grpDataDB;  
GSList  *iter;
gtk_widget_set_sensitive(grpSAVE, FALSE);
gtk_widget_set_sensitive(grpNEW, TRUE);
gtk_widget_set_sensitive(grpNAME, FALSE);
if (!g_slist_length(grpGrp) ||
!strlen((char *) gtk_entry_get_text(GTK_ENTRY(grpNAME))))
{ 
gdk_beep();
error_dialog("Group SAVE", "\n\tCannot SAVE an Empty Group\t\n");
break;
}
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
memset(&grpDataDB, 0, sizeof(STN_GRP_YSCALE));
dbldi.descr.tableData = STNGRPYSCALE;
dbldi.descr.dataEvent = WRITE_SNGL;
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &grpDataDB;
grpDataDB.name = (char *) gtk_entry_get_text(GTK_ENTRY(grpNAME));
for(iter = grpGrp; iter; iter = g_slist_next(iter))
{ 
chnData = iter->data;
grpDataDB.chns = g_slist_append(grpDataDB.chns, chnData->name);
}
dbl_request(&dbldi);
free(dblrecs.recs);
listChgd = TRUE;
readChnGrpScales();
makeLists(CHNGRPGRP);
grpSelected = NONE;
displayInfo(CHNGRPGRP, FALSE);
}
break;
case GRPDEL:
{
DBLDI dbldi;
DBLRECORDS dblrecs;
YCHNGROUP  *grpData;  
STN_GRP_YSCALE grpDataDB;  
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNGRPYSCALE;
dbldi.descr.dataEvent = DELETE_SNGL;
dbldi.data = &dblrecs;
dblrecs.recs = calloc(1, sizeof(void *));
dblrecs.recs[0] = &grpDataDB;
grpData = g_slist_nth_data(stnSettings.main.yChnScale.groups, grpSelected);
grpDataDB.name = grpData->name;
dbl_request(&dbldi);
free(dblrecs.recs);
listChgd = TRUE;
readChnGrpScales();
makeLists(CHNGRPGRP);
displayInfo(CHNGRPGRP, FALSE);
}
break;
case GRPDONE:
gtk_grab_remove(ChnScale);
gtk_widget_hide(ChnScale);
if (listChgd)
{
makeChnGrpScaleCbo();
listChgd=FALSE;
}
setYScaleCbo(NONE, stnStates.screen);
break;
}
}
#if 0
static void block(int block)
{ 
int i;
for(i=0;i<TOTSTNCHNGROUPS;i++)
{
switch(block)
{
case BLOCKSIGS:  
g_signal_handler_block(yScaleCbo[i], stnSignals2[STNYCHNGROUPSGNL][i]);
break;
case UNBLOCKSIGS:
g_signal_handler_unblock(yScaleCbo[i], stnSignals2[STNYCHNGROUPSGNL][i]);
break;
}
}
}
#endif
void setYScaleCbo(int which, int screen)
{
gtk_combo_box_set_active((GtkComboBox *) yScaleCbo[screen], which);
}
void stnYChnGroupSelectC(GtkComboBox *combo, gpointer s)
{ 
int active=gtk_combo_box_get_active(combo), screen = GPOINTER_TO_INT(s);
GSList *iter;
YCHNSCALE *chnScaleData;
AUTOSCALE *autoScale;
stnStates.display.yScaleGrp[screen].active = active - YSCALEFIXEDENTRIES;
if (stnStates.display.yScaleGrp[screen].autoScale)
{
GSList *iter;
for(iter = stnStates.display.yScaleGrp[screen].autoScale;
iter;
iter = g_slist_next(iter))
{
autoScale = iter->data;
g_slist_free(autoScale->channels);
free(iter->data);
}
g_slist_free(stnStates.display.yScaleGrp[screen].autoScale);
}
stnStates.display.yScaleGrp[screen].autoScale = NULL;
switch(active)
{
case NONE:
return;
break;
case YSCALEMANAGE:
{ 
if (!ChnScale)
{
make_YChnGroupScaleDialog();
gtk_window_set_transient_for(GTK_WINDOW(ChnScale), GTK_WINDOW(topWindow));
}
displayInfo(CHNGRPCHN, FALSE);
gtk_widget_show(ChnScale);
gtk_grab_add(ChnScale);
switch(screen)
{
case STNMAIN:
if (stnSettings.main.yChnScale.selected)
free(stnSettings.main.yChnScale.selected);
stnSettings.main.yChnScale.selected = g_strdup("");
break;
case STNANALYSIS:
if (stnSettings.analysis.yChnScale.selected)
free(stnSettings.analysis.yChnScale.selected);
stnSettings.analysis.yChnScale.selected = g_strdup("");
break;
}
return;
}
break;
case YSCALETRACE:
stnSettings.display.yScale[screen] = DISPS;
switch(screen)
{
case STNMAIN:
stnStates.pmap.dirty[screen][stnSettings.main.data] = TRUE;
gtk_widget_hide(stnYfixedB[screen][MAX]);
gtk_widget_hide(stnYfixedB[screen][MIN]);
stnStates.request.state = STNDRAW;
stnStates.display.dataState = STNDRAWINIT;
stnSettings.main.yChnScale.selected = g_strdup(YSCALESTRS[TRACE_CBO]);
break;
case STNANALYSIS:
stnStates.pmap.dirty[screen][0] = TRUE;
gtk_widget_hide(stnYfixedB[screen][MAX]);
gtk_widget_hide(stnYfixedB[screen][MIN]);
stnSettings.analysis.yChnScale.selected = g_strdup(YSCALESTRS[TRACE_CBO]);
break;
}
makeSTNDrawing(screen);
return;
break;
case YSCALEWINDOW:
stnSettings.display.yScale[screen] = WINDS;
switch(screen)
{
case STNMAIN:
stnStates.pmap.dirty[screen][stnSettings.main.data] = TRUE;
gtk_widget_hide(stnYfixedB[screen][MAX]);
gtk_widget_hide(stnYfixedB[screen][MIN]);
stnStates.request.state = STNDRAW;
stnStates.display.dataState = STNDRAWINIT;
stnSettings.main.yChnScale.selected = g_strdup(YSCALESTRS[WINDOW_CBO]);
break;
case STNANALYSIS:
stnStates.pmap.dirty[screen][0] = TRUE;
gtk_widget_hide(stnYfixedB[screen][MAX]);
gtk_widget_hide(stnYfixedB[screen][MIN]);
stnSettings.analysis.yChnScale.selected = g_strdup(YSCALESTRS[WINDOW_CBO]);
break;
}
makeSTNDrawing(screen);
return;
break;
case YSCALEFIXED:
stnSettings.display.yScale[screen] = FIXEDS;
gtk_widget_show(stnYfixedB[screen][MAX]);
gtk_widget_show(stnYfixedB[screen][MIN]);
gtk_widget_grab_focus(stnYfixed[screen][MAX]);
if (strlen(gtk_entry_get_text(GTK_ENTRY(stnYfixed[screen][MAX]))) ||
strlen(gtk_entry_get_text(GTK_ENTRY(stnYfixed[screen][MIN]))))
{
stnRefresh(NULL, s);
}
switch(screen)
{
case STNMAIN:
stnSettings.main.yChnScale.selected = g_strdup(YSCALESTRS[FIXED_CBO]);
break;
case STNANALYSIS:
stnSettings.analysis.yChnScale.selected = g_strdup(YSCALESTRS[FIXED_CBO]);
break;
}
return;
break;
default: 
stnSettings.display.yScale[screen] = CHNGROUPS;
stnStates.display.yScaleGrp[screen].chnGroupScale = 
g_slist_nth_data(stnSettings.main.yChnScale.groups, 
stnStates.display.yScaleGrp[screen].active);
switch(screen)
{
case STNMAIN:
if (stnSettings.main.yChnScale.selected)
free(stnSettings.main.yChnScale.selected);
stnSettings.main.yChnScale.selected = 
g_strdup(stnStates.display.yScaleGrp[screen].chnGroupScale->name);
break;
case STNANALYSIS:
if (stnSettings.analysis.yChnScale.selected)
free(stnSettings.analysis.yChnScale.selected);
stnSettings.analysis.yChnScale.selected = 
g_strdup(stnStates.display.yScaleGrp[screen].chnGroupScale->name);
break;
}
for(iter = stnStates.display.yScaleGrp[screen].chnGroupScale->chnScales;
iter;
iter = g_slist_next(iter))
{
chnScaleData = iter->data; 
if (!strcmp(chnScaleData->scale[MAX], YSCALEAUTO) ||
!strcmp(chnScaleData->scale[MIN], YSCALEAUTO))
{
autoScale = calloc(1, sizeof(AUTOSCALE));
autoScale->name = chnScaleData->name;
stnStates.display.yScaleGrp[screen].autoScale = 
g_slist_append(stnStates.display.yScaleGrp[screen].autoScale, autoScale);
}
}
switch(screen)
{
case STNMAIN:
stnStates.pmap.dirty[screen][stnSettings.main.data] = TRUE;
gtk_widget_hide(stnYfixedB[screen][MAX]);
gtk_widget_hide(stnYfixedB[screen][MIN]);
stnStates.request.state = STNDRAW;
stnStates.display.dataState = STNDRAWINIT;
break;
default:
stnStates.pmap.dirty[screen][0] = TRUE;
gtk_widget_hide(stnYfixedB[screen][MAX]);
gtk_widget_hide(stnYfixedB[screen][MIN]);
break;
}
makeSTNDrawing(screen);
break;  
}
}
void makeChnGrpScaleCbo()
{
int  i, j;
GSList *iter;
char *selected;
YCHNGROUP *grpData;
static int prevNumChnGroups=-1;
for(i=0;i<TOTSTNCHNGROUPS;i++)
for(j=prevNumChnGroups;j>=0;j--)
gtk_combo_box_remove_text(GTK_COMBO_BOX (yScaleCbo[i]), j);
for(i=0;i<TOTSTNCHNGROUPS;i++)
{
gtk_combo_box_insert_text(GTK_COMBO_BOX (yScaleCbo[i]), 0, "Manage...");
gtk_combo_box_append_text(GTK_COMBO_BOX (yScaleCbo[i]), YSCALESTRS[TRACE_CBO]);
gtk_combo_box_append_text(GTK_COMBO_BOX (yScaleCbo[i]), YSCALESTRS[WINDOW_CBO]);
gtk_combo_box_append_text(GTK_COMBO_BOX (yScaleCbo[i]), YSCALESTRS[FIXED_CBO]);
for(iter = stnSettings.main.yChnScale.groups;
iter;
iter = g_slist_next(iter))
{ 
grpData = iter->data;
gtk_combo_box_append_text(GTK_COMBO_BOX (yScaleCbo[i]), grpData->name);
}
prevNumChnGroups = g_slist_length(stnSettings.main.yChnScale.groups) + YSCALEFIXEDENTRIES;
}
for(j=0;j<TOTSTNCHNGROUPS;j++)
{
if (stnSettings.display.yScale[j] < CHNGROUPS)
{
setYScaleCbo(stnSettings.display.yScale[j]+1, j);
continue;
}
switch(j)
{
case 0:
selected = stnSettings.main.yChnScale.selected;
break;
case 1:
selected = stnSettings.analysis.yChnScale.selected;
break;
}
if (selected && strcmp(selected, ""))
{
GSList *item = g_slist_find_custom(stnSettings.main.yChnScale.groups, 
selected, (GCompareFunc) findGroup);
if (item)
{
stnStates.display.yScaleGrp[j].chnGroupScale = item->data;
stnStates.display.yScaleGrp[j].active = 
g_slist_position(stnSettings.main.yChnScale.groups, item);
setYScaleCbo(stnStates.display.yScaleGrp[stnStates.screen].active+YSCALEFIXEDENTRIES, j);
}
else
{
for (i=0;i<NUM_YSCALE_STRS;i++)
{
if (!strcmp(selected, YSCALESTRS[i]))
break;
}
if (i<NUM_YSCALE_STRS)
{
setYScaleCbo(i+1, j);
}
#if 0
else
{
setYScaleCbo(NONE);
}
#endif
}
}
}
}
void readChnGrpScales()
{
DBLDI dbldi;
DBLRECORDS dblrecs;
int  j;
GSList *iter;
YCHNSCALE  *chnData;  
YCHNGROUP  *grpData;  
STN_CHN_YSCALE *chnDataDB;  
STN_GRP_YSCALE *grpDataDB;  
for(iter = stnSettings.main.yChnScale.scales;
iter;
iter = g_slist_next(iter))
{
chnData = iter->data;
free(chnData->name);
free(chnData->loc);
free(chnData->chn);
free(chnData->scale[MAX]);
free(chnData->scale[MIN]);
free(chnData);
}
g_slist_free(stnSettings.main.yChnScale.scales);
stnSettings.main.yChnScale.scales = NULL;
for(iter = stnSettings.main.yChnScale.groups;
iter;
iter = g_slist_next(iter))
{
grpData = iter->data;
free(grpData->name);
g_slist_free(grpData->chnScales);
}
g_slist_free(stnSettings.main.yChnScale.groups);
stnSettings.main.yChnScale.groups = NULL;
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNCHNYSCALE;
dbldi.descr.dataEvent = READ_ALL;
dbldi.data = &dblrecs;
dbl_request(&dbldi);
for(j=0;j<dblrecs.numRecs;j++)
{
chnData = calloc(1, sizeof(YCHNSCALE));
chnDataDB = dblrecs.recs[j];
chnData->name = chnDataDB->name;
chnData->loc = chnDataDB->loc;
chnData->chn = chnDataDB->chn;
chnData->scale[MAX] = chnDataDB->scale[MAX];
chnData->scale[MIN] = chnDataDB->scale[MIN];
stnSettings.main.yChnScale.scales = g_slist_prepend(stnSettings.main.yChnScale.scales, chnData);
}
stnSettings.main.yChnScale.scales = g_slist_sort(stnSettings.main.yChnScale.scales, 
(GCompareFunc) sortChnNames);
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = STNGRPYSCALE;
dbldi.descr.dataEvent = READ_ALL;
dbldi.data = &dblrecs;
dbl_request(&dbldi);
for(j=0;j<dblrecs.numRecs;j++)
{
grpData = calloc(1, sizeof(YCHNGROUP));
stnSettings.main.yChnScale.groups = g_slist_append(stnSettings.main.yChnScale.groups, grpData);
grpDataDB = dblrecs.recs[j];
grpData->name = grpDataDB->name;
for(iter = grpDataDB->chns;
iter;
iter = g_slist_next(iter))
{
grpData->chnScales = g_slist_append(grpData->chnScales, 
(g_slist_find_custom(stnSettings.main.yChnScale.scales, iter->data,
(GCompareFunc) findChnScale))->data);
free(iter->data);
}
g_slist_free(grpDataDB->chns);  
}
stnSettings.main.yChnScale.groups = g_slist_sort(stnSettings.main.yChnScale.groups, 
(GCompareFunc) sortGrpNames);
}
