#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
GdkPixmap *pmap;
int   chnW, labelW, labelH, trcCnt, width, height;
GDate  *startD, *endD;
CHNDATA  dummyCHN;    
static GdkGC *STNGXC[TOTALSTNCONTEXTS];
gboolean stnDataInstance(gpointer nil)
{
int i, maxThreads;
g_idle_add((GSourceFunc) nextChannel, GINT_TO_POINTER(INIT1));
maxThreads = (pqlxStates.machine.numCPUs*MAXTHREADSPCPU < stnStates.display.ttlChn) 
? pqlxStates.machine.numCPUs*MAXTHREADSPCPU 
: stnStates.display.ttlChn;
for(i=1;i<maxThreads;i++)
{
g_idle_add((GSourceFunc) nextChannel, GINT_TO_POINTER(INIT2));
}
return FALSE;
}
void trcPlotCvg(TRCDATA *trcData, TRCPLOT *trcPlot)
{
graph trcGR;
int  gapPs, gapPe, y, chnNum=trcPlot->chnNum;
double gapT, sampInt=trcPlot->chnData->data.sampInt;
GSList *gapIter;
GLAPS *gapData;
viewport(&trcGR, trcPlot->pixel[STARTDT], trcPlot->pixel[ENDDT], STNTOPBD, STNBOTBD);
window(&trcGR, (double) trcPlot->time[STARTDT], (double) trcPlot->time[ENDDT],
(double) 0.0, (double) stnStates.display.chnH, 0, 0);
y = USER2PIXY(&trcGR, (double)(stnStates.display.chnH/2));
gdk_gc_set_line_attributes(STNGXC[STNFGBG], 2, 0, 0, 0);
gdk_draw_line(pmap, STNGXC[STNFGBG], trcPlot->pixel[STARTDT], y, trcPlot->pixel[ENDDT], y);
gapIter = trcData->data.gaps;
while(gapIter)
{
gboolean visible=FALSE;
gdk_gc_set_line_attributes(STNGXC[STNGAPI], 1, 0, 0, 0);
gapData = gapIter->data;
gapT = trcPlot->time[STARTDT] + (gapData->start/(1000000./sampInt))/(double) ONEDAYOFSECS;
gapPs = USER2PIXX(&trcGR, gapT);
gapT = trcPlot->time[STARTDT] + (gapData->end/(1000000./sampInt))/(double) ONEDAYOFSECS;
gapPe = USER2PIXX(&trcGR, gapT);
if (gapPs > trcPlot->bdry[STARTDT] && gapPs < trcPlot->bdry[ENDDT])
{
gdk_draw_line(pmap, STNGXC[STNGAPI], gapPs, y+14, gapPs, y-14);
visible = TRUE;
}
else
{
gapPs = trcPlot->bdry[STARTDT];
}
if (gapPs != gapPe)
{
if (gapPe > trcPlot->bdry[STARTDT] && gapPe < trcPlot->bdry[ENDDT])
{
gdk_gc_set_line_attributes(STNGXC[STNGAPI], 1, 0, 0, 0);
gdk_draw_line(pmap, STNGXC[STNGAPI], gapPe, y+14, gapPe, y-14);
gdk_gc_set_line_attributes(STNGXC[STNGAPI], 2, 0, 0, 0);
gdk_draw_line(pmap, STNGXC[STNGAPI], gapPs, y, gapPe, y);
visible = TRUE;
}
}
if (visible)
trcPlot->chnData->display.numGaps++;
visible=FALSE;
gapIter = g_slist_next(gapIter);
}
gapIter = trcData->data.olaps;
while(gapIter)
{
gboolean visible=FALSE;
gapData = gapIter->data;
gapT = trcPlot->time[STARTDT] + (gapData->start/(1000000./sampInt))/(double) ONEDAYOFSECS;
gapPs = USER2PIXX(&trcGR, gapT);
gapT = trcPlot->time[STARTDT] + (gapData->end/(1000000./sampInt))/(double) ONEDAYOFSECS;
gapPe = USER2PIXX(&trcGR, gapT);
if (gapPs > trcPlot->bdry[STARTDT] && gapPs < trcPlot->bdry[ENDDT])
{
gdk_draw_line(pmap, STNGXC[STNOLAP], gapPs, y+14, gapPs, y-14);
visible = TRUE;
}
else
{
gapPs = trcPlot->bdry[STARTDT];
}
if (gapPs != gapPe)
{
if (gapPe > trcPlot->bdry[STARTDT] && gapPe < trcPlot->bdry[ENDDT])
{
gdk_draw_line(pmap, STNGXC[STNOLAP], gapPe, y+14, gapPe, y-14);
gdk_gc_set_line_attributes(STNGXC[STNOLAP], 2, 0, 0, 0);
gdk_draw_line(pmap, STNGXC[STNOLAP], gapPs, y, gapPe, y);
gdk_gc_set_line_attributes(STNGXC[STNOLAP], 1, 0, 0, 0);
visible = TRUE;
}
}
if (visible)
trcPlot->chnData->display.numOlaps++;
gapIter = g_slist_next(gapIter);
}
gdk_gc_set_line_attributes(STNGXC[STNFGBG], 1, 0, 0, 0);
gdk_gc_set_line_attributes(STNGXC[STNFGBG], 1, 0, 0, 0);
if (trcPlot->pixel[STARTDT]>trcPlot->bdry[STARTDT])
gdk_draw_line(pmap, STNGXC[STNFGBG], trcPlot->pixel[STARTDT], y+4, trcPlot->pixel[STARTDT], y-4);
if (trcPlot->pixel[ENDDT]<trcPlot->bdry[ENDDT])
gdk_draw_line(pmap, STNGXC[STNFGBG], trcPlot->pixel[ENDDT], y+4, trcPlot->pixel[ENDDT], y-4);
}
void pdfLBLplot(int chnNum)
{
graph chnGR;
int  y, x;
viewport(&chnGR, STNLFTM, chnW+STNLFTM, STNTOPBD, STNBOTBD);
window(&chnGR, (double) g_date_julian(startD), (double) g_date_julian(endD),
(double) 0.0, (double) stnStates.display.chnH, 0, 0);
y = USER2PIXY(&chnGR, (double)(stnStates.display.chnH/2));
x = width - STNRGTM/2 - labelW/3;
fontDrawP(pmap, "PDF", x, y + 2, STNLBLF, STNFLBL);
if (STNDA[STNMAIN]->window)
gtk_widget_queue_draw_area(STNDA[STNMAIN], 0, 0, 
STNDA[STNMAIN]->allocation.width, 
STNDA[STNMAIN]->allocation.height);  
}
int chnLblPlot(CHNDATA *chnData, int *chnNumT)
{
graph chnGR;
int  y, chnNum=*chnNumT;
viewport(&chnGR, STNLFTM, chnW+STNLFTM, STNTOPBD, STNBOTBD);
window(&chnGR, (double) g_date_julian(startD), (double) g_date_julian(endD),
(double) 0.0, (double) stnStates.display.chnH, 0, 0);
y = USER2PIXY(&chnGR, (double)(stnStates.display.chnH/2));
if (!labelW)
{
labelW = fontSIZEP(chnData->data.name, STNLBLF, WIDTH);
labelH = fontSIZEP(chnData->data.name, STNLBLF, HEIGHT);
}
switch(chnData->display.selected)
{
case FALSE:
fontDrawP(pmap, chnData->data.name, 
STNLFTM/2 - labelW/2, y - labelH/2, 
STNLBLF, STNFLBL);
break;
case TRUE:
fontDrawPRev(pmap, chnData->data.name, 
STNLFTM/2 - labelW/2, y - labelH/2, 
STNLBLF, STNFLBL, 0);
break;
}
fontDrawP(pmap, "Stats", width - STNRGTM/2 - labelW/3, y - labelH - 2, STNLBLF, STNFLBL);
if (chnData->data.pdfReq && 
chnData->data.pdfReq->data.pdf)
{ 
fontDrawP(pmap, "PDF", width - STNRGTM/2 - labelW/3, y + 2, STNLBLF, STNFLBL);
}
(*chnNumT)++;
return FALSE;
}
static int chnPlotCvg(CHNDATA *chnData, int *chnNumT)
{
graph chnGR;
GSList *trcIter;
TRCDATA *trcData;
TRCPLOT trcPlot;
GDate *start, *end;
int  y, chnNum = *chnNumT;
memset(&trcPlot, 0, sizeof(TRCPLOT));
viewport(&chnGR, STNLFTM, chnW+STNLFTM, STNTOPBD, STNBOTBD);
window(&chnGR, (double) g_date_julian(startD), (double) g_date_julian(endD),
(double) 0.0, (double) stnStates.display.chnH, 0, 0);
y = USER2PIXY(&chnGR, (double)(stnStates.display.chnH/2));
if (!labelW)
{
labelW = fontSIZEP(chnData->data.name, STNLBLF, WIDTH);
labelH = fontSIZEP(chnData->data.name, STNLBLF, HEIGHT);
}
fontDrawP(pmap, chnData->data.name, STNLFTM/2 - labelW/2, y - labelH/2, STNLBLF, STNFLBL);
fontDrawP(pmap, "Stats", width - STNRGTM/2 - labelW/3, y - labelH - 2, STNLBLF, STNFLBL);
if (chnData->data.pdfReq && chnData->data.pdfReq->data.pdf)
{ 
fontDrawP(pmap, "PDF", width - STNRGTM/2 - labelW/3, 
y + 2, STNLBLF, STNFLBL);
}
trcPlot.chnData = chnData;
trcPlot.chnNum = chnNum;
trcPlot.bdry[STARTDT] = chnGR.pix_xmin;
trcPlot.bdry[ENDDT] = chnGR.pix_xmax;
trcIter=chnData->data.traceFiles;
chnData->data.trcCnt = g_slist_length(trcIter) -1; 
while(trcIter)
{
trcData = trcIter->data;
if (!strcmp(trcData->data.name, "/"))
{ 
trcIter = g_slist_next(trcIter);
continue;
}
start = g_date_new_dmy( trcData->data.dates[STARTDT].date.day, 
trcData->data.dates[STARTDT].date.mo, 
trcData->data.dates[STARTDT].date.yr);
trcPlot.time[STARTDT] = (double) ((double) g_date_julian(start) + 
(double) ((double)(trcData->data.dates[STARTDT].date.hr*3600. + 
trcData->data.dates[STARTDT].date.mn*60. +
trcData->data.dates[STARTDT].date.sec)/(double) ONEDAYOFSECS));
end = g_date_new_dmy(trcData->data.dates[ENDDT].date.day, 
trcData->data.dates[ENDDT].date.mo, 
trcData->data.dates[ENDDT].date.yr);
trcPlot.time[ENDDT] = (double) ((double) g_date_julian(end) + 
(double) ((double)(trcData->data.dates[ENDDT].date.hr*3600. + 
trcData->data.dates[ENDDT].date.mn*60. +
trcData->data.dates[ENDDT].date.sec)/(double) ONEDAYOFSECS));
trcData->display.pixelPos[STARTDT] = 
trcPlot.pixel[STARTDT] = USER2PIXX(&chnGR, trcPlot.time[STARTDT]);
trcData->display.pixelPos[ENDDT] = 
trcPlot.pixel[ENDDT] = USER2PIXX(&chnGR, trcPlot.time[ENDDT]);
trcPlot.stats[MAX] = trcData->data.stats[MAX];
trcPlot.stats[MIN] = trcData->data.stats[MIN];
if (trcPlot.pixel[STARTDT] < chnGR.pix_xmin)
trcPlot.pixel[STARTDT] = chnGR.pix_xmin;
if (trcPlot.pixel[ENDDT] > chnGR.pix_xmax)
trcPlot.pixel[ENDDT] = chnGR.pix_xmax;
if (julian(&trcData->data.dates[ENDDT].date) == 
(g_date_get_day_of_year(stnSettings.display.dates[ENDDT])-1) &&
!trcIter->next)  
{
trcData->display.pixelPos[ENDDT] = chnGR.pix_xmax;
trcData->display.lastDay = TRUE; 
}
if (trcPlot.pixel[STARTDT] == trcPlot.pixel[ENDDT])
{ 
trcData->display.plot = FALSE;
chnData->data.trcCnt--;   
trcIter = g_slist_next(trcIter);
continue;
}
trcPlotCvg(trcData, &trcPlot);
trcIter = g_slist_next(trcIter);
}
maxMin(chnData);
(*chnNumT)++;
return FALSE;
}
void drawSTNData(GdkPixmap *pixmap)
{
GSList *stnIter = stnStates.main.stns[STNCURDT];
GList *stnIter2;
GDate *dayIter;
STNDATA *stnData;
GSList *chnIter;
CHNDATA *chnData;
GdkPoint *point;
gchar *dispStr;
int  i, chnNum, fontW1, lastEnd, iSv, extra, leftM;
int  fontW2, y1, y2, x, jday, oldYr, prevChnNum;
float oneday;
pmap = pixmap;
stnData = stnIter->data;
if (stnSettings.display.yAxis[STNMAIN] && 
stnSettings.main.data)
leftM = STNLFTM+YAXISW;
else
leftM = STNLFTM;
gdk_drawable_get_size(pmap, &width, &height);
stnStates.display.ttlChn = chnNum = trcCnt = 0;
width = width;
labelW=labelH=0;
STNGXC[STNMSG] = stnSettings.drawing.ctxts[STNMAIN][STNMSG][NORMALGC];
STNGXC[STNTEXT] = stnSettings.drawing.ctxts[STNMAIN][STNTEXT][NORMALGC];
STNGXC[STNFGBG] = stnSettings.drawing.ctxts[STNMAIN][STNFGBG][NORMALGC];
STNGXC[STNSBAR] = stnSettings.drawing.ctxts[STNMAIN][STNSBAR][NORMALGC];
STNGXC[STNGAPI] = stnSettings.drawing.ctxts[STNMAIN][STNGAPI][NORMALGC];
STNGXC[STNOLAP] = stnSettings.drawing.ctxts[STNMAIN][STNOLAP][NORMALGC];
startD = g_date_new_dmy(stnData->keys.dates[STARTDT].date.day, 
stnData->keys.dates[STARTDT].date.mo, 
stnData->keys.dates[STARTDT].date.yr);
endD = g_date_new_dmy( stnData->keys.dates[ENDDT].date.day, 
stnData->keys.dates[ENDDT].date.mo, 
stnData->keys.dates[ENDDT].date.yr);
g_slist_free(stnStates.main.chnList);
stnStates.main.chnList = NULL;
stnStates.main.stnCnt=0;
for( i=1, stnIter2=stnStates.main.stnList;
stnIter2!=stnStates.main.startStn;
stnIter2=g_list_next(stnIter2))
i++;
stnStates.main.stnStrtNum = i;
while(stnIter)
{ 
int  chnCntr;
stnData = stnIter->data;
chnIter = stnData->data.chnInfo;
chnCntr=0;
while(chnIter)
{
chnData = chnIter->data;
chnCntr++;
trcCnt += chnData->data.trcCnt;
stnStates.main.chnList = g_slist_append(stnStates.main.chnList, chnData);  
chnIter = g_slist_next(chnIter);
}
if (!chnCntr)       
{ 
chnCntr = 1;  
dummyCHN.keys.chnKey = NONE;
stnStates.main.chnList = g_slist_append(stnStates.main.chnList, &dummyCHN);
}
stnData->display.chnCntPre = stnStates.display.ttlChn;
stnData->data.numChannels = chnCntr;
stnStates.display.ttlChn += chnCntr;
stnStates.main.stnCnt++;
stnIter = g_slist_next(stnIter);
}
if (stnSettings.display.yAxis[STNMAIN] && 
stnSettings.main.data)
extra = STNRGTM + STNLFTM + YAXISW;
else
extra = STNRGTM + STNLFTM;
chnW = width - extra;
stnStates.display.chnH = (height - (STNTOPM + STNBOTM))/stnStates.display.ttlChn;
stnStates.display.dayW = (float) (chnW)/(float) stnSettings.main.days;
stnIter = stnStates.main.stns[STNCURDT];
while(stnIter)
{ 
stnData = stnIter->data;
prevChnNum = chnNum;
switch (stnSettings.main.data)
{
case STNCVG:
g_slist_foreach(stnData->data.chnInfo, (GFunc) chnPlotCvg, &chnNum);
break;
case STNDTA:
g_slist_foreach(stnData->data.chnInfo, (GFunc) chnLblPlot, &chnNum);
break;
}
if (chnNum == prevChnNum)
{ 
fontDrawP(pmap, "No CHANNELS Match Current Filter", 
STNLFTM, STNTOPM + chnNum*stnStates.display.chnH + stnStates.display.chnH/3, 
STNLBLF, STNFLBL);
chnNum++;
}
fontDrawP(pmap, stnData->data.name, 2, 
STNTOPM + 2 + prevChnNum*stnStates.display.chnH, STNLBLF, STNFLBL);
point = stnData->display.pixelPos = calloc(2, sizeof(GdkPoint));
point[FNTLFTT].x = 2;
point[FNTLFTT].y = STNTOPM + 2 + prevChnNum*stnStates.display.chnH;
point[FNTRGTB].x = point[FNTLFTT].x + fontSIZEP(stnData->data.name, STNLBLF, WIDTH);
point[FNTRGTB].y = point[FNTLFTT].y + fontSIZEP(stnData->data.name, STNLBLF, HEIGHT);
stnIter = g_slist_next(stnIter);
if (stnIter)
{
int y = STNTOPM+stnStates.display.chnH*chnNum;
gdk_draw_line(pmap, STNGXC[STNFGBG], 0, y, STNLFTM-2, y);
gdk_draw_line(pmap, STNGXC[STNFGBG], STNLFTM-2, y-2, STNLFTM-2, y+3);
}
}
oneday = (float)((float)chnW/(float)stnSettings.main.days);
dispStr = g_strdup("2006");
fontW1 = fontSIZEP(dispStr, AXISF, WIDTH)/2;
free(dispStr);
dispStr = g_strdup("366");
fontW2 = fontSIZEP(dispStr, AXISF, WIDTH)/2;
free(dispStr);
y1 = height-STNBOTM;
y2 = height-STNBOTM/2-2;
dayIter = g_date_new_julian(g_date_get_julian(startD));
for(lastEnd=iSv=i=oldYr=0;i<stnSettings.main.days;i++, g_date_add_days(dayIter, 1))
{
#if 0
if (stnSettings.main.yAxis && stnSettings.main.data)
x = STNLFTM+YAXISW+(int)(oneday*(float)i);
else
x = STNLFTM+(int)(oneday*(float)i);
#endif
x = leftM+(int)(oneday*(float)i);
if((lastEnd+YAXISW) < (x-fontW1))
{ 
if (oldYr != g_date_get_year(dayIter))
{
dispStr = g_strdup_printf("%d", g_date_get_year(dayIter));
fontDrawP(pixmap, dispStr, x-fontW1, y1, AXISF, STNFLBL);
oldYr = g_date_get_year(dayIter);
free(dispStr);
}
jday = g_date_get_day_of_year(dayIter);
dispStr = g_strdup_printf("%03d", jday);
fontDrawP(pixmap, dispStr, x-fontW2, y2, AXISF, STNFLBL);
free(dispStr);
gdk_draw_line(pmap, STNGXC[STNFGBG], x, height-STNBOTM-3, x, height-STNBOTM);
iSv = i;
lastEnd = x + fontW1;
}
}
viewport(&stnStates.main.mainGR, leftM, chnW+leftM, 0, 0);
window(&stnStates.main.mainGR, (double) g_date_julian(startD), 
(double) g_date_julian(endD), (double) 0.0, (double) 0.0, 0, 0);
if (stnSettings.display.yAxis[STNMAIN] && 
stnSettings.main.data)
x = STNLFTM+YAXISW;
else
x = STNLFTM;
gdk_draw_line(pmap, STNGXC[STNFGBG], width-STNRGTM, 
height-STNBOTM-3, width-STNRGTM, height-STNBOTM);
gdk_draw_line(pmap, STNGXC[STNFGBG], x, height-STNBOTM, 
width-STNRGTM+1, height-STNBOTM);
if (stnSettings.main.data)
{
stnDataInstance(NULL);
}
else
{
stnStates.display.dataState = STNDRAWDONE;
}
}
