#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
enum {
COMP_1,
COMP_2,
TTLCOMPS
};
enum {  
QNE1,
QNE2,
QSE1,
QSE2,
QSW1,
QSW2,
QNW1,
QNW2
};
#define NOLAT 181
#define NOLON NOLAT
#define QUAD(deg)(deg < 45) ? QNE1: (deg < 90) ? QNE2: (deg <= 135) ? QSE1: (deg < 180) ? QSE2: (deg <= 225) ? QSW1: (deg < 270) ? QSW2: (deg < 315) ? QNW1: QNW2
#define BSIDE ((h - (PM_MARGIN*2))/2.) 
static inline int getSide(int h, float deg)
{
int  b = BSIDE;
float A = (deg > 90.) ? (deg - 360.) : deg;
int  a = ((double) b * sin(TORAD(A))) / sin(TORAD(90-A));
return a;
}
static void setLine(int h, float deg, GdkPoint *guide)
{
int  a, quad = QUAD(deg), b = BSIDE, x1, y1, x2, y2;
float deg1;
switch (quad)
{ 
case QNE2:
case QNW2:
deg1 = abs((quad+1)*45 - deg);
a = getSide(h, deg1);
a = (b - a);
break;
case QSW2:
case QSE2:
deg1 = abs((quad+1)*45 - deg);
a = getSide(h, deg1);
break;
case QSW1:
case QNW1:
deg1 = deg - (quad * 45);
a = getSide(h, deg1);
a = (b - a);
break;
case QNE1:
case QSE1:
deg1 = deg - (quad * 45);
a = getSide(h, deg1);
break;
}
x1 = y1 = x2 = y2 = 0;
switch (quad)
{
case QNE1:
case QSE2:
x1 = b;
case QSW1:
case QNW2:
x1 += a;
x2 = 2 * b - x1;
break;
case QSE1:
case QSW2:
y1 = b;
case QNE2:
case QNW1:
y1 += a;
y2 = 2 * b - y1;
break;
}
switch (quad)
{
case QNW1:
case QSW2:
x2 = 2 * b;
break;
case QNW2:
case QNE1:
y2 = 2 * b;
break;
case QSW1:
case QSE2:
y1 = (2 * b);
break;
case QSE1:
case QNE2:
x1 = (2 * b);
break;
}
guide[POINT1].x = PM_MARGIN + x1;
guide[POINT1].y = PM_MARGIN + y1;
guide[POINT2].x = PM_MARGIN + x2;
guide[POINT2].y = PM_MARGIN + y2;
}
static void plotLabelPM(char *str, int quad, GdkPoint *guide, GdkPixmap *pmap, int fontGC)
{
char *printStr = g_strdup(str);
int  x1 = guide[POINT1].x, y1 = guide[POINT1].y;
switch (quad)
{ 
case QSE2:
case QSW1:
y1 -= fontSIZEP(printStr, AXISF, HEIGHT);
break;
case QSW2:
case QNW1:
x1 += 4;
break;
case QNE1:
case QNW2:
x1 += 2;
y1 += 2;
break;
case QSE1:
case QNE2:
x1 -= (fontSIZEP(printStr, AXISF, WIDTH) + 4);
y1 -= fontSIZEP(printStr, AXISF, HEIGHT)/2;
break;
}
fontDrawP(pmap, printStr, x1, y1, AXISF, fontGC);
free(printStr);
}
void stn_PM_plot(ANAPOPUP *PM)
{
short *sptr;
gint32 *ptr;
float *lptr;
double *dptr;
int  format;
GtkWidget *da = PM->da;
GdkPixmap *pmap = PM->pmap; 
GdkGC  *gc = stnSettings.analysis.popup.ctxt[PM_WIN][STNFG][NORMALGC];
int   i, j, w = da->allocation.width, h = da->allocation.height;
traceInfo *trc1 = (traceInfo *) ((ANAPOPUPDATA *) (g_slist_nth_data(PM->data, 0)))->trc,
*trc2 = (traceInfo *) ((ANAPOPUPDATA *) (g_slist_nth_data(PM->data, 1)))->trc,
*trcC[TTLCOMPS];  
char   *ntw = trc1->data.head.network, 
*stn = trc1->data.head.station, 
*loc = trc1->data.head.location;
DATAINFO  *dI;
GdkPoint  *line, ends[TTLPOINTS];
graph  grL;
double  cosA, sinA;
float  degC[TTLCOMPS], stnLat, stnLon;
int   nSamps = trc1->data.dataInfo.head.numSamples, diff,
max, min, quad;
int   x1, y1;
char   *printStr;
gboolean  revSign2;
do { 
CHNMETA *chnMeta;
stnLat = NOLAT;
stnLon = NOLON;
trcC[COMP_1] = trc1;
trcC[COMP_2] = trc2;
degC[COMP_1] = 90;  
degC[COMP_2] = 0;  
chnMeta = getChnMetaD(trcC[COMP_1]);
if (!chnMeta)
break;
degC[COMP_1] = chnMeta->location[AZIMUTH];
chnMeta = getChnMetaD(trcC[COMP_2]);
if (!chnMeta)
break;
degC[COMP_2] = chnMeta->location[AZIMUTH];
revSign2 = FALSE;
if ((degC[COMP_1] >= 90. && degC[COMP_1] > degC[COMP_2]) ||
(degC[COMP_1] >= 0. && degC[COMP_1] < 90. && degC[COMP_2] >= 270.))
revSign2 = TRUE;
stnLat = chnMeta->coords[LAT];
stnLon = chnMeta->coords[LON];
#if 0
this code removed due to re-working of algorithm
instead of finding closest channel to north
we now assume trc1 is north
all down-stream calculations are then relative to this
which is always right
deg = (deg1 > 270 || deg2 > 270)
? abs(360 - deg1) < abs(360 - deg2) ? deg1 : deg2
: deg1 < deg2 ? deg1 : deg2;
nComp = (deg == deg1) ? trc1 : trc2;
eComp = (nComp == trc1) ? trc2 : trc1;
degN = (nComp == trc1) ? deg1 : deg2;
degE = (degN == deg1) ? deg2 : deg1;
revSign2 = (((int)(degN+91))%360 > degE) ? FALSE : TRUE;
#endif
} while(0);
if (stnLat != NOLAT &&
stnStates.event.event)
{ 
GdkPoint guide[2];
EVENTINFO *evtI = stnStates.event.event;
float  BA;
BA = backAZ(stnLat, stnLon, evtI->loc[STNEVTLAT], evtI->loc[STNEVTLON]);
quad = QUAD(BA);
setLine(h, BA, guide);
guide[POINT2].x = guide[POINT2].y = PM_MARGIN + BSIDE;
gdk_gc_set_rgb_fg_color(gc, &stnSettings.analysis.popup.colors[PM_WIN][STNPMEBA]); 
gdk_draw_lines(pmap, gc, guide, 2);
plotLabelPM("EBA", quad, guide, pmap, STNFLBLPMEBA);
printStr = g_strdup_printf("Event Back Azimuth = %g Deg", BA);
}
else
{ 
if (stnLat == NOLAT)
printStr = g_strdup_printf("\t(No Meta Data Available)");
else if (!stnStates.event.event)
printStr = g_strdup_printf("\t(No Event Selected)");
if (printStr)
{ 
x1 = w/2 + 2;
y1 = h - PM_MARGIN/2 + 1;
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPMEBA);
free(printStr);
}
printStr = g_strdup_printf("Event Back Azimuth = NONE");
}
x1 = w/2 + 2;
y1 = h - PM_MARGIN/2 - fontSIZEP(printStr, AXISF, HEIGHT);
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPMEBA);
free(printStr);
line = calloc(nSamps, sizeof(GdkPoint));
for (i = 0;
i < TTLCOMPS;
i++)
{ 
dI = &trcC[i]->data.dataInfo;
format = dI->head.data_form;
sptr = (short *) dI->data;
ptr = (gint32 *) dI->data;
lptr = (float *) dI->data;
dptr = (double *) dI->data;
for (j=0; j<nSamps; j++)
{
gint *dv = (i == COMP_1)
? &line[j].y
: &line[j].x; 
DATAP(format, j, *dv);
if (revSign2 &&
i == COMP_2)
*dv *= -1;
}
}
{ 
int  m, x, y;
double rad = TORAD(360.-degC[COMP_1]);
cosA = cos(rad);
sinA = sin(rad);
max = min = 0;
for (i=0; i<nSamps; i++)
{
x = line[i].x;
y = line[i].y;
line[i].x = x * cosA - y * sinA;
line[i].y = x * sinA + y * cosA;
m = (line[i].x < line[i].y ? line[i].y : line[i].x);
if (max < m)
{
max = m;
}
m = (line[i].x > line[i].y ? line[i].y : line[i].x);
if (min > m)
min = m;
}
}
memset(&grL, 0, sizeof(graph));
diff = (abs(max) > abs(min) ? abs(max) : abs(min)) * 2;
diff += diff/10;
viewport(&grL, PM_MARGIN, w-PM_MARGIN-1, PM_MARGIN, h-PM_MARGIN-1);
window(&grL, (double) (diff/2 * -1), (double) (diff/2), 
(double) (diff/2 * -1), (double) (diff/2), 
XLIN, YLIN);
for (i=0; i<nSamps; i++)
{ 
line[i].x = USER2PIXX(&grL, line[i].x);
line[i].y = USER2PIXY(&grL, line[i].y);
}
gdk_gc_set_rgb_fg_color(gc, &stnSettings.analysis.popup.colors[PM_WIN][STNFG]);
gdk_draw_lines(pmap, gc, line, nSamps);
ends[POINT1].x = line[0].x;
ends[POINT1].y = line[0].y;
ends[POINT2].x = line[nSamps-1].x;
ends[POINT2].y = line[nSamps-1].y;
PM->plot.PM.line = line;
{ 
GdkPoint border[5];
border[0].x = PM_MARGIN; border[0].y = PM_MARGIN;
border[1].x = w-PM_MARGIN; border[1].y = PM_MARGIN;
border[2].x = w-PM_MARGIN; border[2].y = h-PM_MARGIN;
border[3].x = PM_MARGIN; border[3].y = h-PM_MARGIN;
border[4].x = PM_MARGIN; border[4].y = PM_MARGIN;
gdk_gc_set_rgb_fg_color(gc, &stnSettings.analysis.popup.colors[PM_WIN][STNPMC]);
gdk_draw_lines(pmap, gc, border, 5);
}
{ 
static GdkGC *gcL = NULL;
GdkPoint   guide[TTLPOINTS];
if (!gcL)
{
gcL = gdk_gc_new(pmap);
gdk_gc_set_line_attributes(gcL, 1, GDK_LINE_ON_OFF_DASH, 0, 0);
}
gdk_gc_set_rgb_fg_color(gcL, &stnSettings.analysis.popup.colors[PM_WIN][STNPMC]);
guide[POINT1].x = USER2PIXX(&grL, 0.0); guide[POINT1].y = PM_MARGIN+1;
guide[POINT2].x = guide[POINT1].x;  guide[POINT2].y = h-PM_MARGIN;
gdk_draw_lines(pmap, gcL, guide, TTLPOINTS);
guide[POINT1].x = PM_MARGIN+1; guide[POINT1].y = USER2PIXY(&grL, 0.0);
guide[POINT2].x = w-PM_MARGIN; guide[POINT2].y = guide[POINT1].y;
gdk_draw_lines(pmap, gcL, guide, TTLPOINTS);
gdk_gc_set_rgb_fg_color(gcL, &stnSettings.analysis.popup.colors[PM_WIN][STNFG]);
for (i = 0;
i < TTLCOMPS;
i++)
{
quad = QUAD(degC[i]);
setLine(h, degC[i], guide);
gdk_draw_lines(pmap, gcL, guide, TTLPOINTS);
plotLabelPM(trcC[i]->data.head.channel, quad, guide, pmap, STNFLBLPM);
}
}
{ 
static GdkGC *gcL = NULL;
if (!gcL)
{
gcL = gdk_gc_new(pmap);
}
gdk_gc_set_rgb_fg_color(gcL, &stnSettings.analysis.popup.colors[PM_WIN][STNPMSP]); 
gdk_draw_arc(pmap, gcL, TRUE, 
ends[POINT1].x-DOTSIZE, ends[POINT1].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_draw_arc(pmap, gcL, FALSE, 
ends[POINT1].x-DOTSIZE, ends[POINT1].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_gc_set_rgb_fg_color(gcL, &stnSettings.analysis.popup.colors[PM_WIN][STNPMEP]); 
gdk_draw_arc(pmap, gcL, TRUE, 
ends[POINT2].x-DOTSIZE, ends[POINT2].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_draw_arc(pmap, gcL, FALSE, 
ends[POINT2].x-DOTSIZE, ends[POINT2].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
}
{ 
PTIME date;
int  len, msec;
double start, stop;
printStr = g_strdup_printf("%s.%s.%s", ntw, stn, loc);
len = fontSIZEP(printStr, AXISF, WIDTH);
x1 = PM_MARGIN + 2;
y1 = PM_MARGIN/2 - fontSIZEP(printStr, AXISF, HEIGHT)/2;
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPM);
free(printStr);
start = trcC[COMP_2]->data.head.epochs;
passcal_etoh(&date, start);
msec = (((float) (start - (int) start))*1000.0);
printStr = g_strdup_printf("Start: %i %03i %02i:%02i:%02i.%03i",
date.yr, get_julday(date.mo, date.day, date.yr), 
date.hr, date.mn, (int) date.sec, (int) msec);
x1 = x1 + len + 12;
y1 = PM_MARGIN/2 - fontSIZEP(printStr, AXISF, HEIGHT);
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPM);
free(printStr);
stop = start + trcC[COMP_2]->data.head.length;
passcal_etoh(&date, stop);
msec = (((float) (stop - (int) stop))*1000.0);
printStr = g_strdup_printf("Stop: %i %03i %02i:%02i:%02i.%03i",
date.yr, get_julday(date.mo, date.day, date.yr), 
date.hr, date.mn, (int) date.sec, (int) msec);
y1 = PM_MARGIN/2 + 1;
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPM);
free(printStr);
printStr = g_strdup_printf("%s Azimuth = %g Deg", trcC[COMP_1]->data.head.channel, degC[COMP_1]);
x1 = PM_MARGIN + 2;
y1 = h - PM_MARGIN/2 - fontSIZEP(printStr, AXISF, HEIGHT);
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPM);
free(printStr);
printStr = g_strdup("N");
x1 = PM_MARGIN + BSIDE + 4;
y1 = PM_MARGIN + 2;
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPMC);
free(printStr);
printStr = g_strdup("E");
x1 = w - PM_MARGIN - fontSIZEP(printStr, AXISF, WIDTH) - 4;
y1 = PM_MARGIN + BSIDE - fontSIZEP(printStr, AXISF, HEIGHT) - 2;
fontDrawP(pmap, printStr, x1, y1, AXISF, STNFLBLPMC);
free(printStr);
}
}
