#include <string.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
double   min_freq, max_freq;
static double min_amp, max_amp;
#define YAXISPOS 28
static void sp_plot(GdkPixmap *pixmap, graph *gr, int npts, char *udata, 
traceInfo *trcData, int recNo, int scr)
{
double x, xmin, ymin, ymax, xmax;
float *ptr, delta;
int skip, n_data;
int pix_x0, pix_x1, pix_y0, pix_y1;
double exp();
GdkGC   *localGC;
switch(recNo)
{
case -1:
localGC = stnSettings.analysis.popup.ctxt[scr][STNFG][NORMALGC];
break;
default:
{
int gcidx = recNo % 30;
localGC = OGXC[gcidx];
}
}
delta = (1./(2. * trcData->data.head.sampInt/1000000.)) / npts;
xmin = min_freq;
xmax = max_freq;
ymin = min_amp;
ymax = max_amp;
skip = (int) (xmin * 2 * npts * (trcData->data.head.sampInt / 1000000.));
if (skip < 0)
skip = 0;
n_data = npts - skip;
if (n_data < 2)
return; 
ptr = (float *) udata;
ptr = (float *) (ptr + (skip * 2));
x = xmin;
pix_x0 = USER2PIXX(gr, x);
if ((double) *ptr < ymin)
pix_y0 = USER2PIXY(gr, ymin);
else if ((double) *ptr > ymax)
pix_y0 = USER2PIXY(gr, ymax);
else
pix_y0 = USER2PIXY(gr, (double) *ptr);
ptr = (float *) (ptr + 2);
x += (double) delta;
pix_x1 = USER2PIXX(gr, x);
if ( ((double) *ptr < ymin))
pix_y1 = USER2PIXY(gr, ymin);
else if ((double) *ptr > ymax)
pix_y1 = USER2PIXY(gr, ymax);
else
pix_y1 = USER2PIXY(gr, (double) *ptr);
gdk_draw_line(pixmap, localGC, pix_x0, pix_y0, pix_x1, pix_y1);
pix_x0 = pix_x1;
pix_y0 = pix_y1;
n_data--;
for (; n_data > 1; n_data--, pix_x0 = pix_x1, pix_y0 = pix_y1) 
{
ptr = (float *) (ptr + 2);
x += (double) delta;
if (x > xmax) 
break;
pix_x1 = USER2PIXX(gr, x);
if (((double) *ptr < ymin))
pix_y1 = USER2PIXY(gr, ymin);
else if ((double) *ptr > ymax)
pix_y1 = USER2PIXY(gr, ymax);
else
pix_y1 = USER2PIXY(gr, (double) *ptr);
gdk_draw_line(pixmap, localGC, pix_x0, pix_y0, pix_x1, pix_y1);
}
}
void stn_spectra_plot(ANAPOPUP *specPsd, int win_record, int which)
{
GtkWidget *da = specPsd->da;
int   wwidth = da->allocation.width, wheight = da->allocation.height;
int  i, trcH, trcCnt = g_slist_length(specPsd->data);
double  pow();
graph trans_tmp, *gr=NULL;
traceInfo *trc;
gboolean overlay=FALSE, xAxis=FALSE, yAxis=FALSE;
char   axis_label[80];
int   axis_label_y_pos, pixS=0, pixE=0;
int    label_width, labelW, scr=0, fontGC=0;
GSList   *specIter;
ANAPOPUPDATA *specData;
SPECSETTINGS *specSettings = &specPsd->settings.spec;
PSDSETTINGS  *psdSettings = &specPsd->settings.psd;
GdkGC   *localGC = stnSettings.analysis.popup.ctxt[which][STNFG][NORMALGC];
trcH = (wheight - (SPECTOPM + ANABOTM))/trcCnt;
label_width = ANALFTM;
switch(which)
{
case SPECTRA_WIN:
overlay = specSettings->overlay;
xAxis = specSettings->xAxis;
yAxis = specSettings->yAxis;
pixS = ANALFTM+YAXISPOS;
pixE = wwidth-ANARGTM;
scr = STNSPECTRA;
fontGC = STNFLBLS;
break;
case PSD_WIN:
overlay = psdSettings->overlay;
xAxis = LOG;
yAxis = LIN;
pixE = ANALFTM+YAXISPOS;
pixS = wwidth-ANARGTM;
scr = STNPSD;
fontGC = STNFLBLP;
break;
}
for (specIter = specPsd->data, i=0;
specIter;
specIter = g_slist_next(specIter), i++)
{
if (win_record != i && win_record != -1)
continue;  
specData = specIter->data;
trc = specData->trc;
if (trc->spectra.beg == -1 ) 
continue;
gr = &specData->spectra.gr;
switch(which)
{
case SPECTRA_WIN:
{
switch(specSettings->amp)
{
case TRUE: 
max_amp = specSettings->yMax
? specSettings->yMax
: trc->spectra.ampMax;
min_amp = max_amp / pow((double) 10., (double) settings.spectra.display.decades);
break;
case FALSE: 
max_amp = specSettings->yMax 
? specSettings->yMax
: specPsd->plot.spectra.glob[SPEC_MAXAMP];
min_amp = specPsd->plot.spectra.glob[SPEC_MINAMP] = (float) ((double) max_amp) /
pow((double) 10., (double) specSettings->decades);
break;
}
max_freq = specSettings->xMax 
? specSettings->xMax 
: specPsd->plot.spectra.glob[SPEC_MAXFREQ];
min_freq = specPsd->plot.spectra.glob[SPEC_MINFREQ] =
specSettings->xMin 
? specSettings->xMin 
: 1. / specPsd->plot.spectra.user_length;
}
break;
case PSD_WIN:
{
min_amp = psdSettings->yMin;
max_amp = psdSettings->yMax;
max_freq = psdSettings->xMin ?
1. / psdSettings->xMin :
specPsd->plot.spectra.glob[SPEC_MAXFREQ];
min_freq = specPsd->plot.spectra.glob[SPEC_MINFREQ] =
psdSettings->xMax ?
1. / psdSettings->xMax :
1. / specPsd->plot.spectra.user_length;
}
break;
}
switch (overlay) 
{
case TRUE:
viewport(gr, pixS, pixE, SPECTOPM+1, wheight - ANABOTM-1);
break;
case FALSE:
viewport(gr, pixS, pixE, ANATOPBD(SPECTOPM), ANABOTBD(SPECTOPM));
break;
}
window(gr, min_freq, max_freq, min_amp, max_amp, xAxis, yAxis);
sp_plot(specPsd->pmap, gr, trc->spectra.numPts / 2, trc->spectra.data,
trc, (overlay?i:-1), which);
if (win_record != -1)
continue;  
if (which == PSD_WIN &&
psdSettings->hlnm &&
!overlay)
{
viewport(&trans_tmp, ANALFTM+YAXISPOS, wwidth-ANARGTM, ANATOPBD(SPECTOPM), ANABOTBD(SPECTOPM));
window(&trans_tmp, (double) 1./max_freq, (double) 1./min_freq, min_amp, max_amp, xAxis, yAxis);
stnHLNM(specPsd->pmap, &trans_tmp, &stnSettings.analysis.popup.colors[PSD_WIN][STNHL]);
}
printSTNLabel(specPsd->pmap, trc, i, scr, FALSE, overlay, specPsd);
if (!overlay) 
{ 
int h1, w1, pixY;
char *dispStr;
viewport(&trans_tmp, label_width, label_width+YAXISPOS, 
i * trcH + SPECTOPM + 1, 
(i + 1) * trcH + SPECTOPM-1);
window(&trans_tmp, 0, YAXISPOS, min_amp, max_amp, FALSE, yAxis);
yaxisP(specPsd->pmap, localGC, &trans_tmp, 
(double) 15, (double) min_amp, (double) max_amp, 
1, -1, 0, (double) 0.0, MYFLOAT, PDFSTATSF);
switch(which)
{
case PSD_WIN:
dispStr = g_strdup_printf("dB");
h1 = fontSIZEP(dispStr, AXISF, HEIGHT);
w1 = fontSIZEP(dispStr, AXISF, WIDTH);
pixY = USER2PIXY(&trans_tmp, (min_amp-max_amp)/2 + max_amp);
fontDrawPR(specPsd->pmap, dispStr, label_width-h1/2, pixY-w1/2, AXISF, fontGC);
free(dispStr);
break;
}
#if 0
switch(which)
{
case SPECTRA_WIN:
dispStr = g_strdup_printf("counts / Hz");
break;
case PSD_WIN:
dispStr = g_strdup_printf("dB");
break;
}
h1 = fontSIZEP(dispStr, AXISF, HEIGHT);
w1 = fontSIZEP(dispStr, AXISF, WIDTH);
pixY = USER2PIXY(&trans_tmp, (min_amp-max_amp)/2 + max_amp);
fontDrawPR(specPsd->pmap, dispStr, label_width-h1/2, pixY-w1/2, AXISF, fontGC);
free(dispStr);
#endif
}
} 
if (win_record != -1)
return;  
switch(which)
{
case SPECTRA_WIN:
if (overlay && 
specSettings->amp == FALSE)
{ 
viewport(&trans_tmp, label_width, label_width+YAXISPOS, 
SPECTOPM+1, wheight - ANABOTM-1); 
window(&trans_tmp, 0, YAXISPOS, min_amp, max_amp, FALSE, yAxis);
yaxisP(specPsd->pmap, localGC, &trans_tmp,
(double) 15, (double) min_amp, (double) max_amp,
1, -1, 0, (double) 0.0, MYFLOAT, PDFSTATSF);
}
break;
case PSD_WIN:
if (overlay)
{
if (psdSettings->hlnm)
{
viewport(gr, ANALFTM+YAXISPOS, wwidth-ANARGTM, SPECTOPM+1, wheight - ANABOTM-1);
window(gr, (double) 1./max_freq, (double) 1./min_freq, min_amp, max_amp, TRUE, FALSE);
stnHLNM(specPsd->pmap, gr, &stnSettings.analysis.popup.colors[PSD_WIN][STNHL]);
}
viewport(&trans_tmp, label_width, label_width+YAXISPOS, 
SPECTOPM+1, wheight - ANABOTM-1); 
window(&trans_tmp, 0, YAXISPOS, min_amp, max_amp, FALSE, yAxis);
yaxisP(specPsd->pmap, localGC, &trans_tmp, 
(double) 15, (double) min_amp, (double) max_amp, 
1, -1, 0, (double) 0.0, MYINT, PDFSTATSF);
}
break;
}
switch(which)
{
case SPECTRA_WIN: 
if (xAxis == LOG)
{ 
sprintf(axis_label,"Period (Sec)");
labelW = fontSIZEP(axis_label, STNLBLF, WIDTH);
axis_label_y_pos = 5;
fontDrawP(specPsd->pmap, axis_label, ((label_width-labelW)<0)?0:(label_width-labelW), 
axis_label_y_pos, STNLBLF, fontGC);
viewport(&trans_tmp, 
wwidth-10, label_width+YAXISPOS, 
2, MAG_T_MARGIN);
window(&trans_tmp, 
1./max_freq, 1./min_freq, 
(double) 2, (double) MAG_T_MARGIN, 
xAxis, FALSE);
xaxisP(specPsd->pmap, localGC, &trans_tmp, 
1./max_freq, (double) 10.0, 1./min_freq, 
-1, 1, -1, (double) 0.0, TRUE, (double) 0.0, PDFSTATSF);
}
sprintf(axis_label,"Frequency (Hz)");
axis_label_y_pos = ((int) wheight - 20);
labelW = fontSIZEP(axis_label, STNLBLF, WIDTH);
fontDrawP(specPsd->pmap, axis_label, ((label_width-labelW)<0)?0:(label_width-labelW), 
axis_label_y_pos, STNLBLF, fontGC);
viewport(&trans_tmp, label_width+YAXISPOS, wwidth-10,
wheight - MAG_B_MARGIN, wheight);
window(&trans_tmp, 
min_freq, max_freq, 
(double) 0, (double) MAG_B_MARGIN, 
xAxis, FALSE);
xaxisP(specPsd->pmap, localGC, &trans_tmp, 
min_freq, (double) 19, max_freq, 
1, -1, -1, (double) 0.0, FALSE, (double) 0.0, PDFSTATSF);
break;
case PSD_WIN:
sprintf(axis_label,"Period (Sec)");
labelW = fontSIZEP(axis_label, STNLBLF, WIDTH);
axis_label_y_pos = ((int) wheight - 20);
fontDrawP(specPsd->pmap, axis_label, ((label_width-labelW)<0)?0:(label_width-labelW), 
axis_label_y_pos, STNLBLF, fontGC);
viewport(&trans_tmp, 
label_width+YAXISPOS, wwidth-10, 
wheight - MAG_B_MARGIN, wheight);
window(&trans_tmp, 
1./max_freq, 1./min_freq,
(double) 0, (double) MAG_B_MARGIN, 
xAxis, FALSE);
xaxisP(specPsd->pmap, localGC, &trans_tmp, 
1./max_freq, (double) 19, 1./min_freq, 
1, -1, -1, (double) 0.0, FALSE, (double) 0.0, PDFSTATSF);
break;
}
return;
}
