#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
#include "evresp.h"
int stnRemResp(traceInfo *trc, char *respFile)
{
int i, startStage, stopStage, stdioF, nfreqs;
char *verbose = NULL, datetime[18], rtype[3];
static char *resploc=NULL;
float *power;
double *freqs=NULL, delta;
struct response *resp=NULL;
if (trc->data.head.location[0]==0 ||
!strcmp(trc->data.head.location, "--"))
{
resploc = g_strdup("*");
} 
else 
{
resploc = g_strdup(trc->data.head.location);
}
sprintf(datetime, "%d,%03d,00:00:00", trc->data.head.year, trc->data.head.day);
startStage = -1;      
stopStage = 0;       
#if 0
if (analysis->conf->last_stage > 0) 
{
startStage = 1;
stopStage = analysis->conf->last_stage;
}
#endif
stdioF = 0;            
nfreqs = trc->spectra.numPts/2+1;      
strcpy(rtype, "cs");         
if ((freqs = malloc(nfreqs * sizeof(double)))==NULL)
{
return(NO_MEMORY);
}
delta = trc->data.head.sampInt / 1000000.;
for (i=0; i<nfreqs;i++) 
{
freqs[i] = 1./((double) (trc->spectra.numPts*delta)/(double) i);
}
resp = evresp(trc->data.head.station, trc->data.head.channel, trc->data.head.network, 
resploc, datetime, "ACC", respFile, 
freqs, nfreqs, rtype, verbose, startStage, stopStage, stdioF, 0);
free(freqs);
if (resp==NULL) 
{
return(EVALRESP_FAILURE);
}
#ifdef DEBUG1
{
FILE *dbg; 
char *fName;
fName = g_strdup_printf("%s/response.txt", getenv("PQLXLOG"));
dbg = fopen(fName, "w");
free(fName);
#endif
#define AMP ((double)((resp->rvec[i].real * resp->rvec[i].real) + (resp->rvec[i].imag * resp->rvec[i].imag)))
power = (float *) trc->spectra.data;
for (i=0; i<trc->spectra.numPts/2;i++, power+=2) 
{
*power = (float) (10.0 * log10(*power/AMP)); 
}
#if 0
fclose(dbg);
}
#endif
free_response(resp);  
return(PQLXSUCCESS);
}
