#include <string.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
double ceil();
int readTrace(traceInfo *);
static int tScale;
int getSTNDataInc(double secs, int pixwidth, double sampInt)
{
float step;
double inc;
step = (float) (secs / (float) pixwidth) / (sampInt / 1000000.);
inc = ceil(step);
if (inc <= 1.)
return (1);
else
return ((int) inc);
}
#define FLAGMARGIN 2
#define FLAGFACTOR 12
#define MAXFLAG  10
#define MINFLAG  5
typedef struct
{
int  stop, dataSize, dataType;
int  ptInc, decInc, inc;
int  samples;
double tm, tm_inc;
struct
{
gint32 *ptr;
short *sptr;
float *lptr;
double *dptr;
} data;
struct
{
int  *gaps, *olaps;
int  gapNum, olapNum;
gboolean gapON, olapON;
} GO;
GdkGC  *gc;
traceInfo *trc;
} plotInfo;
#include <stdlib.h>
static int *vertical, flagSize, totVert;
static void checkGO(GdkPixmap *pixmap, graph *gr, plotInfo *pInfo, int x, int y)
{
GdkPoint flag[3];
static int vertPos, gapIter;
int   gapInc;
int   pix_x0, pix_y0, pix_x1=0, pix_y1, decInc;
double  pt1=0, pt2=0;
gboolean gap=FALSE;
if (stnSettings.display.overlay[stnStates.screen])
return;  
if (!flagSize)
{
flagSize = gr->pix_ydif/FLAGFACTOR;
flagSize = (flagSize > MAXFLAG) 
? MAXFLAG 
: ((flagSize < MINFLAG) 
? MINFLAG 
: flagSize);
totVert = 50; 
vertical = (int *) calloc(totVert, sizeof(int));
}
if (pInfo->GO.gapNum < pInfo->trc->trace.numGaps)
{ 
if (settings.trace.gFlag)
{ 
gapIter = 0;
vertPos=0;
while(x < vertical[vertPos])
vertPos++;
}
if (pInfo->ptInc+pInfo->decInc >= pInfo->GO.gaps[pInfo->GO.gapNum*2])
{ 
gap = TRUE;
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNGAPI][NORMALGC];
if (settings.trace.gFlag) 
{ 
pix_x0 = USER2PIXX(gr, pInfo->tm);
if(!gapIter) 
gdk_draw_line(pixmap, pInfo->gc,
pix_x0, gr->pix_ymin + vertPos*(flagSize+1) + FLAGMARGIN, 
pix_x0, y);
flag[0].x = pix_x0;
flag[0].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + FLAGMARGIN;
flag[1].x = pix_x0;
flag[1].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize + FLAGMARGIN;
flag[2].x = pix_x0 + flagSize;
flag[2].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize/2 + FLAGMARGIN;
gdk_draw_polygon(pixmap, pInfo->gc, TRUE, flag, 3);
if (vertPos+gapIter>=totVert)
{
totVert += 50;
vertical = (int *) realloc(vertical, totVert*sizeof(int));
}
vertical[vertPos+gapIter] = flag[2].x + 1;
gapIter++;
}
gapInc = (pInfo->GO.gaps[pInfo->GO.gapNum*2+1] - 
pInfo->GO.gaps[pInfo->GO.gapNum*2] - 
(pInfo->ptInc - pInfo->GO.gaps[pInfo->GO.gapNum*2])) /
pInfo->inc;
if (gapInc)
{ 
switch (pInfo->dataType)
{
case BIT32:
pt1 = (double) pInfo->data.ptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.ptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
case BIT16:
pt1 = (double) pInfo->data.sptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.sptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
case MY_FLOAT:
pt1 = (double) pInfo->data.lptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.lptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
case MY_DOUBLE:
pt1 = (double) pInfo->data.dptr[pInfo->GO.gaps[pInfo->GO.gapNum*2]-1];
pt2 = (double) pInfo->data.dptr[pInfo->GO.gaps[pInfo->GO.gapNum*2+1]];
break;
}
pix_x0 = USER2PIXX(gr, pInfo->tm);
pix_y0 = USER2PIXY(gr, pt1);
pInfo->ptInc += (pInfo->inc * (gapInc));
pInfo->tm += (pInfo->tm_inc * (double) (gapInc));
pix_x1 = USER2PIXX(gr, pInfo->tm);
pix_y1 = USER2PIXY(gr, pt2);
gdk_draw_line(pixmap, pInfo->gc, pix_x0, pix_y0, pix_x1, pix_y1);
}
pInfo->GO.gapNum++;
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
decInc = pInfo->GO.gaps[pInfo->GO.gapNum*2-1] - pInfo->ptInc;
pInfo->decInc = decInc;
}
}  
if (pInfo->GO.olapNum < pInfo->trc->trace.numOlaps)
{
if (settings.trace.oFlag && !pInfo->GO.olapON)
{
gapIter = 0;
vertPos=0;
while(x < vertical[vertPos] && vertPos<totVert)
vertPos++;
}
if (!pInfo->GO.olapON && pInfo->ptInc+pInfo->decInc >= pInfo->GO.olaps[pInfo->GO.olapNum*2])
{ 
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNOLAP][NORMALGC];
if (settings.trace.oFlag)  
{
if (gap)
x = pix_x1;
if(!gapIter) 
gdk_draw_line(pixmap, pInfo->gc, x, gr->pix_ymin + vertPos*(flagSize+1) + FLAGMARGIN, x, y);
flag[0].x = x;
flag[0].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + FLAGMARGIN;
flag[1].x = x;
flag[1].y = gr->pix_ymin+ + vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize + FLAGMARGIN;
flag[2].x = x + flagSize;
flag[2].y = gr->pix_ymin+ vertPos*(flagSize+1) + gapIter*(flagSize+1) + flagSize/2 + FLAGMARGIN;
gdk_draw_polygon(pixmap, pInfo->gc, TRUE, flag, 3);
if (vertPos+gapIter>=totVert)
{
totVert += 50;
vertical = (int *) realloc(vertical, totVert*sizeof(int));
}
vertical[vertPos+gapIter] = flag[2].x + 1;
gapIter++;
} 
pInfo->GO.olapON = TRUE;
pInfo->decInc = 0;
} 
if (pInfo->GO.olapON && pInfo->ptInc+pInfo->decInc >= pInfo->GO.olaps[pInfo->GO.olapNum*2+1])
{ 
pInfo->GO.olapNum++;
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
pInfo->GO.olapON = FALSE;
}
}  
pInfo->stop = pInfo->samples;
if (pInfo->GO.olapON)
{
pInfo->stop = pInfo->GO.olaps[pInfo->GO.olapNum*2+1];  
}
else
{
if (pInfo->GO.gapNum < pInfo->trc->trace.numGaps)
{
pInfo->stop = pInfo->GO.gaps[pInfo->GO.gapNum*2];  
}
if (pInfo->GO.olapNum < pInfo->trc->trace.numOlaps) 
{
if (pInfo->GO.gapNum < pInfo->trc->trace.numGaps)
{ 
if (pInfo->GO.olaps[pInfo->GO.olapNum*2] < pInfo->GO.gaps[pInfo->GO.gapNum*2])
{
pInfo->stop = pInfo->GO.olaps[pInfo->GO.olapNum*2];  
}
}
else
{
pInfo->stop = pInfo->GO.olaps[pInfo->GO.olapNum*2];  
}
}
}
}
static void initData(plotInfo *plotI, traceInfo *trc, ANADATA *anaData, int recNo)
{
gboolean filtON = FALSE;
int   activeFilter;
DATAINFO *dataInfo;
char  *dataPtr;
flagSize = 0;
vertical = NULL;
tScale = stnSettings.display.yScale[stnStates.screen];
switch(stnStates.screen)
{
case STNMAIN:
activeFilter = stnStates.display.dataFilter.active;
filtON = stnStates.display.dataFilter.on;
dataPtr = trc->data.dataInfo.data;
plotI->samples = trc->data.dataInfo.head.numSamples;
break;
case STNANALYSIS:
activeFilter = stnStates.analysis.dataFilter.active;
filtON = stnStates.analysis.dataFilter.on;
dataPtr = anaData->dataInfo.data;
plotI->data.lptr = (float *) dataPtr;
plotI->dataSize = sizeof(float);
plotI->dataType = MY_FLOAT;
plotI->samples = anaData->dataInfo.head.numSamples;
break;
}
if (filtON)
{
dataInfo = g_slist_nth_data(trc->data.dataFilt, activeFilter);
plotI->data.lptr = (float *) dataInfo->data;
plotI->dataType = MY_FLOAT;
plotI->dataSize = dsizes[plotI->dataType];
}
else if (stnStates.screen != STNANALYSIS)
{
plotI->dataType = trc->data.head.data_form;
plotI->dataSize = dsizes[plotI->dataType];
plotI->data.ptr = (gint32 *) dataPtr;
plotI->data.sptr = (short *) dataPtr;
plotI->data.lptr = (float *) dataPtr;
plotI->data.dptr = (double *) dataPtr;
}
if (stnSettings.display.overlay[stnStates.screen])
{
int gcidx = recNo % 30;
plotI->gc = OGXC[gcidx];
}
else
{
plotI->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
}
plotI->GO.gaps = trc->trace.gaps;
plotI->GO.olaps = trc->trace.overlaps;
plotI->tm_inc = (double) (((trc->data.head.sampInt) / 1000000.) * ((float) plotI->inc));
plotI->GO.gapON = plotI->GO.olapON = FALSE;
plotI->GO.olapNum = plotI->GO.gapNum = 0;
plotI->decInc = 0;
plotI->ptInc = 0;
plotI->stop = plotI->samples;      
if (plotI->GO.gapNum < trc->trace.numGaps)
{
plotI->stop = plotI->GO.gaps[0];    
}
if (plotI->GO.olapNum < trc->trace.numOlaps) 
{
if (plotI->GO.gaps)
{ 
if (plotI->GO.olaps[0] < plotI->GO.gaps[0])
{
plotI->stop = plotI->GO.olaps[0];  
}
}
else
{
plotI->stop = plotI->GO.olaps[0];   
}
}
}
void plotSTNtrc(GdkPixmap *pixmap, graph *gr, traceInfo *trc, ANADATA *anaData,
double begin, int inc, int recNo, int screen)
{
int y1, y2, pix_x0, pix_x1, pix_y0, pix_y1;
double fmax, fmin=0, fpt, tmStart=0, sps;
short *sptr;
gint32 *ptr;
float *lptr;
double *dptr;
plotInfo pInfo;
memset(&pInfo, 0, sizeof(plotInfo));
sps = 1000000./trc->data.head.sampInt;
pInfo.inc = inc;
switch(screen)
{
case STNMAIN:
tmStart = begin;
break;
case STNANALYSIS:
tmStart = begin + (trc->data.head.epochs-begin);
break;
}
pInfo.tm = tmStart; 
pInfo.trc = trc;
initData(&pInfo, trc, anaData, recNo);
lptr = pInfo.data.lptr;
ptr = pInfo.data.ptr;
sptr = pInfo.data.sptr;
dptr = pInfo.data.dptr;
pix_x0 = pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, pInfo.ptInc, fmin);
if (tScale == FIXEDS ||
tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
}
pix_y0 = pix_y1 = USER2PIXY(gr, (double) fmin);
for ( ;
pInfo.ptInc < pInfo.samples - pInfo.inc; 
pix_x0 = pix_x1, pix_y0 = pix_y1)
{
if (pInfo.inc > 1) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
fmax = fmin;
for (fpt = fmax;          
(pInfo.decInc < pInfo.inc) &&     
(pInfo.ptInc + pInfo.decInc < pInfo.stop); 
pInfo.decInc++) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fpt);
if (fpt < fmin)
{
fmin = fpt;
continue;
}
if (fpt > fmax)
fmax = fpt;
}
if (tScale == FIXEDS ||
tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if(fmax>gr->user_ymax)
fmax = gr->user_ymax;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
if(fmax<gr->user_ymin)
fmax = gr->user_ymin;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}
if (pInfo.ptInc+pInfo.decInc == pInfo.stop)
{ 
int lastStop = pInfo.stop;
checkGO(pixmap, gr, &pInfo, pix_x1, pix_y1);
while (pInfo.stop < lastStop)    
{ 
pix_x1 = USER2PIXX(gr, (double) (tmStart + (double) (pInfo.stop/sps)));
lastStop = pInfo.stop;
checkGO(pixmap, gr, &pInfo, pix_x1, pix_y1);
}
pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
if (tScale == FIXEDS ||
tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
}
pix_y1 = USER2PIXY(gr, (double) fmin);
}
else
{ 
pInfo.ptInc += pInfo.inc;
pInfo.tm += pInfo.tm_inc;
pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc), fmin);
if (tScale == FIXEDS ||
tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
}
pix_y1 = USER2PIXY(gr, (double) fmin);
gdk_draw_line(pixmap, pInfo.gc, pix_x0, pix_y0, pix_x1, pix_y1);
pInfo.decInc = 0;
}
}
if (pInfo.inc > 1) 
{ 
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
fmax = fmin;
for (fpt = fmin;
pInfo.decInc + pInfo.ptInc < pInfo.samples;
pInfo.decInc++)
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fpt);
if (fpt < fmin)
fmin = fpt;
if (fpt > fmax)
fmax = fpt;
}
if (tScale == FIXEDS ||
tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if(fmax>gr->user_ymax)
fmax = gr->user_ymax;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
if(fmax<gr->user_ymin)
fmax = gr->user_ymin;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}  
if(vertical)
free(vertical);
}
