#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_pql_externs.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
void get_trans_data_stn(traceInfo *trcData, float *data)
{
int num_samples, j;
float *get_data, *read_flt;
double exp2(), pow(), sps;
if (trcData->spectra.beg == -1)
return;
sps = (1000000. / trcData->data.head.sampInt);
num_samples = ((trcData->spectra.end - trcData->spectra.beg) + 
trcData->spectra.fill_beg) * sps;
if (num_samples > trcData->data.dataInfo.head.numSamples)
num_samples = trcData->data.dataInfo.head.numSamples;
for (j = 1; (int) pow((double) 2, (double) j) < num_samples; ++j);
trcData->spectra.numPts = (int) pow((double) 2, (double) (j));
if ((trcData->spectra.data = 
(char *) calloc((unsigned) trcData->spectra.numPts + 2, sizeof(float))) == NULL) 
{
fprintf(stderr, "Out of MEMORY, cannot continue, exiting...\n");
exit(-1);
}
get_data = (float *) trcData->spectra.data;
trcData->spectra.avg = 0;
read_flt = ((float *) (((long) data) + (int) (trcData->spectra.beg*sps)*sizeof(float)));
for (j = 0; j < num_samples; j++)
{
get_data[j] = read_flt[j];
trcData->spectra.avg += (float) (get_data[j] / num_samples);
}
trcData->spectra.data_end = (float *) (&get_data[j-1]); 
for (j = 0; j < num_samples; ++j)
{
get_data[j] -= (float) trcData->spectra.avg;
}
}
void transform_dataPSD(traceInfo *trcData)
{
int i, j;
float *udata, delta, amp;
double sqrt(), pow(), scale; 
if (trcData->spectra.beg == -1)
return;
cfftr((float *) trcData->spectra.data, trcData->spectra.numPts);
#if 0
in = fftw_malloc(sizeof(double) * trcData->spectra.numPts);
out = fftw_malloc(sizeof(fftw_complex) * trcData->spectra.numPts);
for (j=0, udata=(float *) trcData->spectra.data; 
j<trcData->spectra.numPts; 
j++)
{
in[j] = (double) udata[j];
}
plan = fftw_plan_dft_r2c_1d(trcData->spectra.numPts, in, out, FFTW_ESTIMATE);
fftw_execute(plan);
#endif
delta = trcData->data.head.sampInt / 1000000.;
scale = 2.0 * delta * (double) 1.1428571/ (double) trcData->spectra.numPts;
for (j=0, i=0, udata=(float *) trcData->spectra.data; 
j<trcData->spectra.numPts-1; 
j+=2, i++)
{
amp = (float) ((double) (udata[j] * udata[j]) + (double) (udata[j+1] * udata[j+1]));
udata[j] = amp * scale;
#if 0
amp = out[i][0]*out[i][0] + out[i][1]*out[i][1];
udata[j] = (out[i][0]*out[i][0] + out[i][1]*out[i][1]) * scale;
#endif
}
#if 0
fftw_destroy_plan(plan);
fftw_free(in);
fftw_free(out);
#endif
}
void specPointPU(ANAPOPUP *popupD, int trcNum, int x, pointID *ptID)
{
SPECPT *specPt;
ANAPOPUPDATA *specData = g_slist_nth_data(popupD->data, trcNum);
traceInfo *trc = specData->trc;
graph *gr = &specData->spectra.gr;
specPt = spec_point(trc, x, gr);
ptID->freqVal = specPt->trans_mouse_freq;
ptID->minAmp = ptID->maxAmp = specPt->trans_mouse_amp;
#if 0
if (settings.general.units == MYVOLTS && 
trcData->data.fileType == SEGY_DATA)
{ 
float scale = trcData->data.head.scale_fac / (float) trcData->data.head.gainConst;
ptr->minAmp *= scale;
ptr->maxAmp *= scale;
}
#endif
ptID->xVal = specPt->trans_x;
ptID->yVal = specPt->trans_y;
}
