#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
void makePopupDrawing(int which, ANAPOPUP *popupD)
{
GtkWidget *da = (which != PM_TRC) ? popupD->da : popupD->plot.PM.da;
GdkPixmap *pixmap, **pmap;
int   w = da->allocation.width, h = da->allocation.height;
int   popupW = which < PM_WIN ? which : PM_WIN;
pmap = (which != PM_TRC) ? &popupD->pmap : &popupD->plot.PM.pmap;
if (*pmap)
{
g_object_unref(*pmap);
*pmap = NULL;
}
pixmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_rectangle(pixmap, stnSettings.analysis.popup.ctxt[popupW][STNBG][ABNORMALGC], 
TRUE, 0, 0, w, h);
*pmap = pixmap;
switch (which)
{
case SPECTRA_WIN:
case PSD_WIN:
stn_spectra_plot(popupD, -1, which);
break;
case PM_PLOT:
stn_PM_plot(popupD);
break;
case PM_TRC:
break;
}
gtk_widget_queue_draw_area(da, 0, 0, w, h);   
}
void specPsdDo(int which)
{
gboolean first, valid;
ANAPOPUP *specPsd;
ANAPOPUPDATA *specData;
ANADATA  *anaData;
PQLDATA  *pqlData;
traceInfo *trcData, *trc;
GSList  *traceI;
int  w = stnSettings.analysis.popup.dims[which].width ?
stnSettings.analysis.popup.dims[which].width :
settings.general.startUP.winDims[WIDTH],
h = stnSettings.analysis.popup.dims[which].height ?
stnSettings.analysis.popup.dims[which].height :
settings.general.startUP.winDims[HEIGHT];
gint xPos = stnSettings.analysis.popup.dims[which].xPos,
yPos = stnSettings.analysis.popup.dims[which].yPos;
specPsd = calloc(1, sizeof(ANAPOPUP));
specPsd->which = which;
valid = FALSE;
for(traceI = stnStates.analysis.selections 
? stnStates.analysis.selections 
: stnStates.analysis.traces, first = TRUE; 
traceI; 
traceI = g_slist_next(traceI), first=FALSE)
{
pqlData = traceI->data;
anaData = pqlData->anaData;
trcData = pqlData->trc;
specData = calloc(1, sizeof(ANAPOPUP));
specPsd->data = g_slist_append(specPsd->data, specData);
specPsd->plot.spectra.user_length = stnStates.analysis.plot.limits.selection.user.length;
get_trans_times(trcData, stnStates.analysis.plot.limits.selection.user.left,
stnStates.analysis.plot.limits.selection.user.right, 
stnSettings.display.xScale,
stnStates.analysis.plot.limits.times[STARTABS]);
get_trans_data_stn(trcData, (float *) anaData->dataInfo.data);
taper(trcData);
switch(which)
{
case SPECTRA_WIN:
memcpy(&specPsd->settings.spec, &stnSettings.analysis.popup.spectra, sizeof(SPECSETTINGS));
transform_data(trcData, stnSettings.analysis.popup.spectra.xMin ? 
stnSettings.analysis.popup.spectra.xMin : 
1. / stnStates.analysis.plot.limits.selection.user.length,
&specPsd->settings.spec);
setSpecGlobals(specPsd->plot.spectra.glob, first, trcData, &specPsd->settings.spec);
trc = specData->trc = trcCopy(trcData, TRCSPECTRA);
trcData->spectra.data = NULL;
valid = TRUE;
break;
case PSD_WIN:
{ 
char *respFile;
memcpy(&specPsd->settings.psd, &stnSettings.analysis.popup.psd, sizeof(PSDSETTINGS));
respFile = getResp(anaData);
if (respFile)
{
transform_dataPSD(trcData);
trc = specData->trc = trcCopy(trcData, TRCSPECTRA);
trcData->spectra.data = NULL;
stnRemResp(trc, respFile);
trc->spectra.ampMin = specPsd->plot.spectra.glob[SPEC_MINAMP] = 
specPsd->settings.psd.yMin;
trc->spectra.ampMax = specPsd->plot.spectra.glob[SPEC_MAXAMP] =
specPsd->settings.psd.yMax;
if (1./(2. * (trcData->data.head.sampInt / 1000000.)) > 
specPsd->plot.spectra.glob[SPEC_MAXFREQ])
specPsd->plot.spectra.glob[SPEC_MAXFREQ] = 
1./(2. * (trcData->data.head.sampInt / 1000000.));
valid = TRUE;
}
}
}
}
if (!valid)
return;
switch(stnSettings.analysis.popup.type[which])
{
case STN_POPUP_WIN_SINGLE:
if (stnStates.analysis.popup[which].same.data)
{
specPsd->topW = stnStates.analysis.popup[which].same.data->topW;
specPsd->da = stnStates.analysis.popup[which].same.data->da;
freePopupData(which, stnStates.analysis.popup[which].same.data);
}
stnStates.analysis.popup[which].same.data = specPsd;
if (!stnStates.analysis.popup[which].same.win)
{
makePOPUP(which, STN_POPUP_WIN_SINGLE, specPsd);
stnStates.analysis.popup[which].same.win = specPsd->topW;
gtk_window_resize(GTK_WINDOW(specPsd->topW), w, h);
if (xPos && yPos)
gtk_window_move(GTK_WINDOW(specPsd->topW), xPos, yPos);
gtk_widget_show_all(specPsd->topW);    
}
else
{
gtk_window_present(GTK_WINDOW(stnStates.analysis.popup[which].same.win));
gtk_widget_queue_resize(specPsd->da);   
}
break;
case STN_POPUP_WIN_SEPARATE:
{
long *daAddr;
if (!stnStates.analysis.popup[which].separate.data)
{
stnStates.analysis.popup[which].separate.data = 
g_hash_table_new_full(g_int_hash, g_int_equal, free, NULL);
}
makePOPUP(which, STN_POPUP_WIN_SEPARATE, specPsd);
daAddr = calloc(1, sizeof(long));
*daAddr = (long) specPsd->da;
g_hash_table_insert(stnStates.analysis.popup[which].separate.data, daAddr, specPsd);
gtk_window_resize(GTK_WINDOW(specPsd->topW), w, h);
if (xPos && yPos)
gtk_window_move(GTK_WINDOW(specPsd->topW), xPos, yPos);
gtk_widget_show_all(specPsd->topW); 
}
break;
}
}
static gboolean isHor(char *chn)
{ 
gboolean ret = TRUE;
int i;
for (i = 0;
i < TTLCOMPGROUPS;
i++)
{ 
if (chn[2] == compNm[i][2][0])
{
ret = FALSE;
break;
}
}
return ret;
}
static void deMean(DATAINFO *dI, double mean)
{
gint32 *ptr;
short *sptr;
float *lptr;
double *dptr, val;
int  i, numSamps = dI->head.numSamples, format = dI->head.data_form;
sptr = (short *) dI->data;
ptr = (gint32 *) dI->data;
lptr = (float *) dI->data;
dptr = (double *) dI->data;
for (i=0; i<numSamps; i++)
{
DATAP(format, i, val);
val -= mean;
DATAPSET(format, i, val);
}
}
static void scaleChnData(DATAINFO *dI, double scale)
{
short *sptr;
gint32 *ptr;
float *lptr;
double *dptr;
double val;
int  i, format = dI->head.data_form, samples = dI->head.numSamples;
sptr = (short *) dI->data;
ptr = (gint32 *) dI->data;
lptr = (float *) dI->data;
dptr = (double *) dI->data;
for (i=0; i<samples; ++i)
{
DATAP(format, i, val);
val *= scale;
DATAPSET(format, i, val);
}
}
#define NUMPMCHANS 2
void particleMotion(int which)
{
int   i;
gboolean  match;
ANAPOPUP  *PM;
ANAPOPUPDATA *PMD, *PMData[NUMPMCHANS];
PQLDATA  *pqlData[NUMPMCHANS];
traceInfo *trcData[NUMPMCHANS], *trcPM[NUMPMCHANS];
CHNMETA  *chnMeta[NUMPMCHANS];
GSList  *traceI1, *traceI2;
char   *stn[NUMPMCHANS], *loc[NUMPMCHANS], *chn[NUMPMCHANS];
double  startE=0, endE=0;
int  w = stnSettings.analysis.popup.dims[PM_WIN].width 
? stnSettings.analysis.popup.dims[PM_WIN].width 
: settings.general.startUP.winDims[WIDTH],
h = stnSettings.analysis.popup.dims[PM_WIN].height 
? stnSettings.analysis.popup.dims[PM_WIN].height
: settings.general.startUP.winDims[HEIGHT];
gint xPos = stnSettings.analysis.popup.dims[PM_WIN].xPos,
yPos = stnSettings.analysis.popup.dims[PM_WIN].yPos;
for(traceI1 = stnStates.analysis.selections 
? stnStates.analysis.selections 
: stnStates.analysis.traces, match = FALSE; 
!match && traceI1; 
traceI1 = g_slist_next(traceI1))
{
pqlData[0] = traceI1->data;
trcData[0] = pqlData[0]->trc;
stn[0] = trcData[0]->data.head.station;
loc[0] = trcData[0]->data.head.location;
chn[0] = trcData[0]->data.head.channel;
if (!isHor(chn[0]))
continue;
for(traceI2 = g_slist_next(traceI1); 
!match && traceI2; 
traceI2 = g_slist_next(traceI2))
{
pqlData[1] = traceI2->data;
trcData[1] = pqlData[1]->trc;
stn[1] = trcData[1]->data.head.station;
loc[1] = trcData[1]->data.head.location;
chn[1] = trcData[1]->data.head.channel;
if (strcmp(stn[0], stn[1]) ||
strcmp(loc[0], loc[1]))
continue;
if (!isHor(chn[1]) || 
!strcmp(chn[0], chn[1]))
continue;
match = TRUE;
}
}
if (!match)
{
gdk_beep();
STNdispMsg(DISPLAY, "No matching horizontal components found, Hodogram not possible");
return;
}
PM = calloc(1, sizeof(ANAPOPUP));
PM->which = PM_WIN;
PMD = PMData[0] = calloc(1, sizeof(ANAPOPUPDATA));
PM->data = g_slist_append(PM->data, PMD);
PMData[0]->trc = trcCopy(trcData[0], TRCPM);
PMD = PMData[1] = calloc(1, sizeof(ANAPOPUPDATA));
PM->data = g_slist_append(PM->data, PMD);
PMData[1]->trc = trcCopy(trcData[1], TRCPM);
{ 
PQLDATA  *pqlIn, *pqlOut;
traceInfo *trc;
int   i;
for (i=0;i<2;i++)
{
trc = PMData[i]->trc;
switch(stnSettings.display.xScale)
{
case ABSOLUTE:
startE = stnStates.analysis.plot.limits.times[STARTABS] + 
stnStates.analysis.plot.limits.selection.user.left;
endE = stnStates.analysis.plot.limits.times[STARTABS] + 
stnStates.analysis.plot.limits.selection.user.right;
break;
case RELATIVE:
startE = trc->data.head.epochs + 
stnStates.analysis.plot.limits.selection.user.left;
endE = trc->data.head.epochs + 
stnStates.analysis.plot.limits.selection.user.right;
break;
}
pqlIn = calloc(1, sizeof(PQLDATA));
pqlIn->trc = trc;
pqlOut = cutTrc(pqlIn, startE, endE);
trcPM[i] = PMData[i]->trc = pqlOut->trc;
free(pqlOut);
freeMyData(TRCINFO, trc);
}
}
for (i=0; i<NUMPMCHANS; i++)
deMean(&trcPM[i]->data.dataInfo, trcPM[i]->data.dataInfo.amps.mean);
for (i=0; i<NUMPMCHANS; i++)
chnMeta[i] = getChnMetaD(trcData[i]);
if (chnMeta[0] && chnMeta[1] &&
chnMeta[0]->sensitivity != chnMeta[1]->sensitivity)
{ 
double  scale;
gboolean  N, D = (chnMeta[0]->sensitivity < chnMeta[1]->sensitivity)
? 0
: 1;
N = !D;
scale = chnMeta[N]->sensitivity / chnMeta[D]->sensitivity;
scaleChnData(&trcPM[D]->data.dataInfo, scale);
}
switch(stnSettings.analysis.popup.type[which])
{
case STN_POPUP_WIN_SINGLE:
if (stnStates.analysis.popup[which].same.data)
{
PM->topW = stnStates.analysis.popup[which].same.data->topW;
PM->da = stnStates.analysis.popup[which].same.data->da;
PM->statusBar = stnStates.analysis.popup[which].same.data->statusBar;
freePopupData(which, stnStates.analysis.popup[which].same.data);
}
stnStates.analysis.popup[which].same.data = PM;
if (!stnStates.analysis.popup[which].same.win)
{
makePOPUP(which, STN_POPUP_WIN_SINGLE, PM);
stnStates.analysis.popup[which].same.win = PM->topW;
gtk_window_resize(GTK_WINDOW(PM->topW), w, h);
if (xPos && yPos)
gtk_window_move(GTK_WINDOW(PM->topW), xPos, yPos);
gtk_widget_show_all(PM->topW);    
}
else
{
gtk_window_present(GTK_WINDOW(stnStates.analysis.popup[which].same.win));
gtk_widget_queue_resize(PM->da);   
}
break;
case STN_POPUP_WIN_SEPARATE:
{
long *daAddr;
if (!stnStates.analysis.popup[which].separate.data)
{
stnStates.analysis.popup[which].separate.data = 
g_hash_table_new_full(g_int_hash, g_int_equal, free, NULL);
}
makePOPUP(which, STN_POPUP_WIN_SEPARATE, PM);
daAddr = calloc(1, sizeof(long));
*daAddr = (long) PM->da;
g_hash_table_insert(stnStates.analysis.popup[which].separate.data, daAddr, PM);
#if 0
daAddr = calloc(1, sizeof(long));
*daAddr = (long) PM->plot.PM.da;
g_hash_table_insert(stnStates.analysis.popup[which].separate.data, daAddr, PM);
#endif
gtk_window_resize(GTK_WINDOW(PM->topW), w, h);
if (xPos && yPos)
gtk_window_move(GTK_WINDOW(PM->topW), xPos, yPos);
gtk_widget_show_all(PM->topW);    
}
break;
}
}
