#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#define getPopupD(popupW, daAddr)(stnSettings.analysis.popup.type[popupW] == STN_POPUP_WIN_SINGLE)? stnStates.analysis.popup[popupW].same.data: g_hash_table_lookup(stnStates.analysis.popup[popupW].separate.data, daAddr);
#define POPUPW(which) (which < PM_WIN ? which : PM_WIN)
static void dispMsgPU(int action, char *msg, GtkWidget *statusB)
{ 
guint   msgContext;
msgContext = gtk_statusbar_get_context_id((GtkStatusbar *) statusB, "POPUP_WIN");
gtk_statusbar_pop((GtkStatusbar *) statusB, msgContext);
switch(action)
{
case DISPLAY:
gtk_statusbar_push((GtkStatusbar *) statusB, msgContext, msg);
break;
}
return;
}
gboolean STN_popup_cfg(GtkWidget *da, GdkEventConfigure *event, gpointer w)
{ 
int  which = GPOINTER_TO_INT(w);
int  popupW = POPUPW(which);
long daAddr = (long) da;
ANAPOPUP *popupD=NULL;
#if 0
if (!hourCursor)
{
topLevel = gdk_window_get_toplevel(gtk_widget_get_parent_window(da));
hourCursor = gdk_cursor_new_for_display(gdk_display_get_default (), GDK_WATCH);
}
#endif
if (da->allocation.height==1 ||
!da->window)
{ 
return TRUE;
}
popupD = getPopupD(popupW, &daAddr);
if (popupD->statusBar)
dispMsgPU(UNDISPLAY, NULL, popupD->statusBar);
makePopupDrawing(which, popupD);
return TRUE;
}
gboolean STN_popup_exp(GtkWidget *da, GdkEventExpose *event, gpointer w)
{ 
int   which = GPOINTER_TO_INT(w);
int   popupW = POPUPW(which);
GdkPixmap *pixmap=NULL;
ANAPOPUP *popupD = NULL;
long  daAddr = (long) da;
popupD = getPopupD(popupW, &daAddr);
if (!popupD)  
return TRUE;
pixmap = (which != PM_TRC) ? popupD->pmap : popupD->plot.PM.pmap;
gdk_draw_drawable(da->window,
da->style->fg_gc[GTK_WIDGET_STATE (da)],
pixmap,
event->area.x, event->area.y,
event->area.x, event->area.y,
event->area.width, event->area.height);
gdk_window_set_cursor(topLevel, NULL);
return TRUE;
}
void stnPopupPrint(GtkButton *button, ANAPOPUP *specPsd)
{
stnStates.pmap.specPsdPrint = specPsd->pmap;
stnPrint(NULL, GINT_TO_POINTER(STNSPECTRA));
}
void closePopup(GtkButton *button, GtkWidget **topW)
{
gtk_widget_destroy(*topW);
}
void freePopupData(int which, ANAPOPUP *popupD)
{
ANAPOPUPDATA *popupData;
GSList *iter;
traceInfo *trc;
if (!popupD)
return;
if (popupD->pmap)
g_object_unref(popupD->pmap);
popupD->pmap = NULL;
switch (popupD->which)
{ 
case PM_WIN:
if (popupD->plot.PM.pmap)
g_object_unref(popupD->plot.PM.pmap);
popupD->plot.PM.pmap = NULL;
if (popupD->plot.PM.line)
free(popupD->plot.PM.line);
popupD->plot.PM.line = 0;
break;
}
for(iter=popupD->data; iter; iter = g_slist_next(iter))
{
popupData = iter->data;
trc = popupData->trc;
freeMyData(TRCINFO, trc);
free(popupData);
}
g_slist_free(popupD->data);
popupD->data = NULL;
}
void destroyPopup(GtkWidget *da, gpointer w)
{
int which = GPOINTER_TO_INT(w);
int popupW = POPUPW(which);
switch(stnSettings.analysis.popup.type[popupW])
{
case STN_POPUP_WIN_SINGLE:
stnStates.analysis.popup[popupW].same.win = NULL;
freePopupData(which, stnStates.analysis.popup[popupW].same.data);
stnStates.analysis.popup[popupW].same.data = NULL;
break;
case STN_POPUP_WIN_SEPARATE:
{
ANAPOPUP *popupD=NULL;
long daAddr = (long) da;
if (stnStates.analysis.popup[popupW].separate.data)
{ 
popupD = g_hash_table_lookup(stnStates.analysis.popup[popupW].separate.data,
&daAddr);
}
if (!popupD)
{ 
stnStates.analysis.popup[popupW].same.win = NULL;
freePopupData(which, stnStates.analysis.popup[popupW].same.data);
stnStates.analysis.popup[popupW].same.data = NULL;
}
else
{
freePopupData(which, popupD);
g_hash_table_remove(stnStates.analysis.popup[popupW].separate.data, &daAddr);
}
}
break;
}
return;
}
void specSetting(GtkToggleButton *radio, SET_ARGS *args)
{ 
gboolean *valPtr = args->val;
int  setting = args->setting;
gboolean val = !gtk_toggle_button_get_active(radio);
*valPtr = val;
switch(setting)
{
case STNAMPSCALE:
stnSettings.analysis.popup.spectra.amp = val;
break;
}
}
void reDrawPopup(GtkToggleButton *radio, GtkWidget **da)
{
gtk_widget_queue_resize(*da);
}
static void _reDrawSeparate(gpointer key, ANAPOPUP *specPsd, gpointer which)
{
int   scr = GPOINTER_TO_INT(which);
gboolean amp, overlayS, overlayP;
amp = specPsd->settings.spec.amp;
overlayS = specPsd->settings.spec.overlay;
overlayP = specPsd->settings.psd.overlay;
memcpy(&specPsd->settings.spec, &stnSettings.analysis.popup.spectra, sizeof(SPECSETTINGS));
memcpy(&specPsd->settings.psd, &stnSettings.analysis.popup.psd, sizeof(PSDSETTINGS));
specPsd->settings.spec.amp = amp;
specPsd->settings.spec.overlay = overlayS;
specPsd->settings.psd.overlay = overlayP;
gtk_widget_modify_bg(specPsd->sb, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[scr][STNSB]);
gtk_widget_queue_resize(specPsd->da);
}
gboolean reSetPopup(gpointer win)
{ 
int which = GPOINTER_TO_INT(win);
switch(stnSettings.analysis.popup.type[which])
{
case STN_POPUP_WIN_SINGLE:
{
ANAPOPUP *specPsd = stnStates.analysis.popup[which].same.data;
gboolean amp, overlayS, overlayP;
if (specPsd)
{ 
amp = specPsd->settings.spec.amp;
overlayS = specPsd->settings.spec.overlay;
overlayP = specPsd->settings.psd.overlay;
memcpy(&specPsd->settings.spec, &stnSettings.analysis.popup.spectra, sizeof(SPECSETTINGS));
memcpy(&specPsd->settings.psd, &stnSettings.analysis.popup.psd, sizeof(PSDSETTINGS));
specPsd->settings.spec.amp = amp;
specPsd->settings.spec.overlay = overlayS;
specPsd->settings.psd.overlay = overlayP;
gtk_widget_queue_resize(specPsd->da);
gtk_widget_modify_bg(specPsd->sb, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[which][STNSB]);
gtk_window_present(GTK_WINDOW(stnStates.analysis.popup[which].same.win));
}
}
break;
case STN_POPUP_WIN_SEPARATE:
if (stnStates.analysis.popup[which].separate.data)
g_hash_table_foreach(stnStates.analysis.popup[which].separate.data,
(GHFunc) _reDrawSeparate, GINT_TO_POINTER(which));
break;
}
return FALSE;
}
static struct {
struct {
gboolean down;
GdkPoint ends[TTLPOINTS];
int   activeKey;
} mouse;
} state;
static void mousePM(GtkWidget *da, GdkEventButton *event, ANAPOPUP *popupD)
{ 
switch (event->type)
{
case GDK_BUTTON_PRESS:
{
int  w = da->allocation.width, h = da->allocation.height;
dispMsgPU(UNDISPLAY, NULL, popupD->statusBar);
gtk_widget_queue_draw_area(da, 0, 0, w, h);   
state.mouse.ends[POINT1].x = event->x;
state.mouse.ends[POINT1].y = event->y;
}
break;
case GDK_BUTTON_RELEASE:
state.mouse.ends[POINT2].x = event->x;
state.mouse.ends[POINT2].y = event->y;
break;
default:
break;
}
}
static void specPT(GtkWidget *da, int pixX, int pixY, ANAPOPUP *popupD)
{ 
int   w = da->allocation.width, h = da->allocation.height;
SPECSETTINGS *specSettings = &popupD->settings.spec;
gboolean  overlay = specSettings->overlay;
int   trcCnt = g_slist_length(popupD->data);
int   trcH = (h - (SPECTOPM + ANABOTM))/trcCnt;
int   trcNum = !overlay ? (pixY - SPECTOPM)/trcH : specSettings->topTrc;
GdkPixmap *pixmap = gdk_pixmap_new(da->window, w, h, -1);
GdkGC  *localGC = stnSettings.analysis.popup.ctxt[SPECTRA_WIN][STNFG][INVGC];
int   xpos = 10;
pointID  pntID;
char  *str;
specPointPU(popupD, trcNum, pixX, &pntID);
gdk_draw_drawable(pixmap, da->style->fg_gc[GTK_STATE_NORMAL], popupD->pmap, 0, 0, 0, 0, -1, -1);
gdk_draw_line(pixmap, localGC, 
pntID.xVal - xpos, pntID.yVal - 10,
pntID.xVal + xpos, pntID.yVal + 10);
gdk_draw_line(pixmap, localGC, 
pntID.xVal + xpos, pntID.yVal - 10,
pntID.xVal - xpos, pntID.yVal + 10);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], pixmap, 0, 0, 0, 0, -1, -1);
g_object_unref(pixmap);
str = (specSettings->xAxis == LOG)
? g_strdup_printf("Frequency = % 3.4f Hz / Period = % 4.1f Sec // Amplitude = %7.6f", 
pntID.freqVal, 1./pntID.freqVal, pntID.minAmp)
: g_strdup_printf("Frequency = % 3.4f Hz // Amplitude = %7.6f", pntID.freqVal, pntID.minAmp);
dispMsgPU(DISPLAY, str, popupD->statusBar);
free(str);
}   
static void mouseSPECTRA(GtkWidget *da, GdkEventButton *event, ANAPOPUP *popupD)
{ 
guint modifiers;
int  action = NONE;
int  w = da->allocation.width, h = da->allocation.height;
SPECSETTINGS *specSettings = &popupD->settings.spec;
gboolean  overlay = specSettings->overlay;
if (event->type == GDK_BUTTON_RELEASE)
return;
modifiers = gtk_accelerator_get_default_mod_mask();
state.mouse.activeKey = ((event->state & modifiers) == GDK_CONTROL_MASK) ? CTRL : NONE;
if (event->x > ANALFTM &&
state.mouse.activeKey == CTRL)
action = PU_SPECTRA_POINT;
else if (overlay)
action = PU_SPECTRA_DRAW_TOP;
switch (action)
{
case PU_SPECTRA_POINT:
{ 
specPT(da, (int) event->x, (int) event->y, popupD);
}
break;
case PU_SPECTRA_DRAW_TOP:
{ 
int trcCnt = g_slist_length(popupD->data);
int trcH = (h - (SPECTOPM + ANABOTM))/trcCnt;
int trcNum = (event->y - SPECTOPM)/trcH;
stn_spectra_plot(popupD, trcNum, SPECTRA_WIN);
gtk_widget_queue_draw_area(da, 0, 0, w, h);   
specSettings->topTrc = trcNum;
}
break;
}
}
gboolean mouseEventPU(GtkWidget *da, GdkEventButton *event, gpointer w)
{ 
int   which = GPOINTER_TO_INT(w);
int   popupW = POPUPW(which);
long  daAddr = (long) da;
ANAPOPUP *popupD = getPopupD(popupW, &daAddr);
switch (event->type)
{
case GDK_BUTTON_PRESS:
state.mouse.down = TRUE;
break;
case GDK_BUTTON_RELEASE:
state.mouse.down = FALSE;
break;
default: break;
}
switch(popupW)
{
case PM_WIN:  
mousePM(da, event, popupD);
break;
case SPECTRA_WIN: 
mouseSPECTRA(da, event, popupD);
break;
}
return TRUE;
}
static void dragPM(GtkWidget *da, GdkEventMotion *event, ANAPOPUP *popupD)
{ 
GdkPixmap *pmapSRC, *pmap;
int   w = da->allocation.width, h = da->allocation.height;
GdkPoint ends[TTLPOINTS];
static GdkGC *gcL = NULL;
if (!state.mouse.down ||  
event->x < PM_MARGIN ||  
event->x > w - PM_MARGIN ||
event->y < PM_MARGIN ||
event->y > h - PM_MARGIN)
return;
ends[POINT1].x = state.mouse.ends[POINT1].x;
ends[POINT1].y = state.mouse.ends[POINT1].y;
ends[POINT2].x = event->x;
ends[POINT2].y = event->y;
pmapSRC = popupD->pmap;
if (!gcL)
gcL = gdk_gc_new(pmapSRC);
gdk_gc_set_rgb_fg_color(gcL, &stnSettings.analysis.popup.colors[PM_WIN][STNPMLA]); 
pmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_drawable(pmap, da->style->fg_gc[GTK_STATE_NORMAL], pmapSRC, 0, 0, 0, 0, -1, -1);
gdk_draw_lines(pmap, gcL, ends, TTLPOINTS);
gdk_draw_arc(pmap, gcL, TRUE, 
ends[POINT1].x-DOTSIZE, ends[POINT1].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_draw_arc(pmap, gcL, FALSE, 
ends[POINT1].x-DOTSIZE, ends[POINT1].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_draw_arc(pmap, gcL, TRUE, 
ends[POINT2].x-DOTSIZE, ends[POINT2].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_draw_arc(pmap, gcL, FALSE, 
ends[POINT2].x-DOTSIZE, ends[POINT2].y-DOTSIZE,
DOTSIZE*2, DOTSIZE*2,
0, 360*64);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], pmap, 0, 0, 0, 0, -1, -1);
g_object_unref(pmap);
{ 
char *msg;
int  a = ends[POINT2].x - ends[POINT1].x, 
c = ends[POINT2].y - ends[POINT1].y; 
double az;
az = asin(a * sin(TORAD(90))/sqrt((a*a) + (c*c)));
az = TODEG(az);
az = (ends[POINT2].y <= ends[POINT1].y) 
? (az < 0) ? 360 + az : az   
: 90. + (90. - az);    
msg = g_strdup_printf("Line Azimuth = %g", az);
dispMsgPU(DISPLAY, msg, popupD->statusBar);
free(msg);
}
}
static void dragSPECTRA(GtkWidget *da, GdkEventMotion *event, ANAPOPUP *popupD)
{ 
static int action;
action = NONE;
if (event->x > ANALFTM &&
state.mouse.down &&
state.mouse.activeKey == CTRL)
{
action = PU_SPECTRA_POINT;
}
switch (action)
{
case PU_SPECTRA_POINT:
{
specPT(da, (int) event->x, (int) event->y, popupD);
}
break;
}
}
gboolean dragEventPU(GtkWidget *da, GdkEventMotion *event, gpointer w)
{ 
int which = GPOINTER_TO_INT(w);
int   popupW = POPUPW(which);
long  daAddr = (long) da;
ANAPOPUP *popupD = getPopupD(popupW, &daAddr);
static GdkWindow *gdkWindow;
GdkModifierType modType;
int   x, y;
if (!gdkWindow)
{ 
gdkWindow = gdk_get_default_root_window();
state.mouse.activeKey = NONE;
gdk_window_get_pointer(gdkWindow, &x, &y, &modType);
return TRUE;
}
switch(popupW)
{
case PM_WIN:  
dragPM(da, event, popupD);
break;
case SPECTRA_WIN: 
dragSPECTRA(da, event, popupD);
break;
}
gdk_window_get_pointer(gdkWindow, &x, &y, &modType);
return TRUE;
}
#define PMFFACT 500
enum {
PM_FORW,
PM_BACK
};
typedef struct _PMFRAME
{
GtkWidget *da;
ANAPOPUP *PM;
} PMFRAME;
static int  PMfSpeed;
static gboolean started = FALSE;
static gboolean PM_frame(PMFRAME *PMf)
{ 
GtkWidget *da = PMf->da;
ANAPOPUP *PM = PMf->PM;
int   w, h;
GdkPoint pt, *line = PM->plot.PM.line;
int   *ptNum = &PM->plot.PM.ptNum;
traceInfo *trc1;
int   nSamps;
gboolean PMfDir;
GdkPixmap *pmapSRC;
static GdkPixmap *pmap;
static GdkGC *gcL = NULL;
if (!PMfSpeed || 
!PM->pmap)  
{
started = FALSE;
return FALSE;
}
w = da->allocation.width, h = da->allocation.height;
trc1 = (traceInfo *) ((ANAPOPUPDATA *) (g_slist_nth_data(PM->data, 0)))->trc;
nSamps = trc1->data.dataInfo.head.numSamples;
PMfDir = (PMfSpeed > 0) ? PM_FORW : PM_BACK; 
switch(PMfDir)
{
case PM_FORW:
(*ptNum)++;
if (*ptNum > nSamps - 1)
{
(*ptNum)--;
PMfSpeed = 0;
started = FALSE;
gdk_beep();
return FALSE;
}
break;
case PM_BACK:
(*ptNum)--;
if (*ptNum < 0)
{
(*ptNum)=0;
PMfSpeed = 0;
started = FALSE;
gdk_beep();
return FALSE;
}
break;
default:
return FALSE;
break;
}
pmapSRC = PM->pmap;
pt.x = line[*ptNum].x;
pt.y = line[*ptNum].y;
if (!gcL)
gcL = gdk_gc_new(pmapSRC);
gdk_gc_set_rgb_fg_color(gcL, &stnSettings.analysis.popup.colors[PM_WIN][STNPMSP]); 
pmap = gdk_pixmap_new(da->window, w, h, -1);
gdk_draw_drawable(pmap, da->style->fg_gc[GTK_STATE_NORMAL], pmapSRC, 0, 0, 0, 0, -1, -1);
gdk_draw_arc(pmap, gcL, TRUE, 
pt.x-DOTSIZEF, pt.y-DOTSIZEF,
DOTSIZEF*2, DOTSIZEF*2,
0, 360*64);
gdk_draw_arc(pmap, gcL, FALSE, 
pt.x-DOTSIZEF, pt.y-DOTSIZEF,
DOTSIZEF*2, DOTSIZEF*2,
0, 360*64);
gdk_draw_drawable(da->window, da->style->fg_gc[GTK_STATE_NORMAL], pmap, 0, 0, 0, 0, -1, -1);
g_object_unref(pmap);
if (abs(PMfSpeed))
g_timeout_add(PMFFACT/abs(PMfSpeed*3), (GSourceFunc) PM_frame, PMf);
else
started = FALSE;
return FALSE;
} 
gboolean scrollPopup(GtkWidget *da, GdkEventScroll *event, gpointer nil)
{ 
long  daAddr = (long) da;
ANAPOPUP *PM = getPopupD(PM_WIN, &daAddr);
switch(event->direction)
{ 
case GDK_SCROLL_UP:  
PMfSpeed++;
break;
case GDK_SCROLL_DOWN:
PMfSpeed--;
break;
default:
return TRUE;
break;
}
if (PMfSpeed && 
!started)
{
PMFRAME *PMf = calloc(1, sizeof(PMFRAME));
PMf->da = da;
PMf->PM = PM;
g_timeout_add(PMFFACT/abs(PMfSpeed*3), (GSourceFunc) PM_frame, PMf);
started = TRUE;
}
return TRUE;
} 
