#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
static GtkWidget *makeSB(int scr, ANAPOPUP *popupD)
{
GtkWidget *widget, *menu_box, *eBox, *button, *mouseBox;
GtkWidget *frame, *box, *radioB, *radioB1, *commandB;
GtkWidget *label, *sep;
GtkTooltips *tips;
char  toolTip[1000];
SET_ARGS *setArgs;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
tips = gtk_tooltips_new();
gtk_widget_set_size_request(widget, BUTTONW+28, 10);
switch(scr)
{
case SPECTRA_WIN:
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">Spectra</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &white);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Window Scale");
box = gtk_vbox_new(FALSE, 0);
radioB1 = gtk_radio_button_new_with_label(NULL, "Trace");
gtk_container_add(GTK_CONTAINER(box), radioB1);
radioB = gtk_radio_button_new_with_label(gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Window");
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "AMPLITUDE Scale Defined by MAX/MIN of INDIVIDUAL Spectra");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "AMPLITUDE Scale Defined by MAX/MIN of ALL Spectras Displayed");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_toggle_button_set_active(
GTK_TOGGLE_BUTTON ((stnSettings.analysis.popup.spectra.amp) ? radioB1 : radioB), TRUE);
setArgs = calloc(1, sizeof(SET_ARGS));
setArgs->val = &popupD->settings.spec.amp;
setArgs->setting = STNAMPSCALE;
g_signal_connect(radioB, "toggled", G_CALLBACK(specSetting), (gpointer) setArgs);
g_signal_connect(radioB, "toggled", G_CALLBACK(reDrawPopup), (gpointer) &popupD->da);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Overlay");
box = gtk_hbox_new(FALSE, 0);
radioB1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(box), radioB1);
radioB = 
gtk_radio_button_new_with_label(gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (radioB), TRUE);
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "DISPLAY Spectras in OVERLAY Mode");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "DISPLAY Spectras Individually");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
setArgs = calloc(1, sizeof(SET_ARGS));
setArgs->val = &popupD->settings.spec.overlay;
setArgs->setting = NONE;
g_signal_connect(radioB, "toggled", G_CALLBACK(specSetting), (gpointer) setArgs);
g_signal_connect(radioB, "toggled", G_CALLBACK(reDrawPopup), (gpointer) &popupD->da);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Display Units");
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new("Counts / Hz");
gtk_container_add(GTK_CONTAINER(box), label);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "STN Control Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raiseStnControls), GINT_TO_POINTER(STNSPECCTRL));
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print Screen to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stnPopupPrint), (gpointer) popupD);
button = gtk_button_new_with_label("Close");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Close Spectra Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(closePopup), (gpointer) &popupD->topW);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "Within PLOT Region:\n"
" Data Point:\t\tCTRL+CLICK\n"
" Scan Data Points:\tCTRL+CLICK+DRAG\n\n"
"On LABEL (in Overlay Mode):\n"
" Bring Trace to TOP:\tCLICK\n");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
break;
case PSD_WIN:
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">PSD</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &white);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Overlay");
box = gtk_hbox_new(FALSE, 0);
radioB1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(box), radioB1);
radioB = 
gtk_radio_button_new_with_label(gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (radioB), TRUE);
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "DISPLAY PSDs in OVERLAY Mode");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "DISPLAY PSDs Individually");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
setArgs = calloc(1, sizeof(SET_ARGS));
setArgs->val = &popupD->settings.psd.overlay;
setArgs->setting = NONE;
g_signal_connect(radioB, "toggled", G_CALLBACK(specSetting), (gpointer) setArgs);
g_signal_connect(radioB, "toggled", G_CALLBACK(reDrawPopup), (gpointer) &popupD->da);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "STN Control Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raiseStnControls), GINT_TO_POINTER(STNPSDCTRL));
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print Screen to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stnPopupPrint), (gpointer) popupD);
button = gtk_button_new_with_label("Close");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Close PSD Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(closePopup), (gpointer) &popupD->topW);
break;
case PM_WIN:
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">PM</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &white);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "STN Control Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raiseStnControls), GINT_TO_POINTER(STNPMCTRL));
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print Screen to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stnPopupPrint), (gpointer) popupD);
button = gtk_button_new_with_label("Close");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Close PM Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(closePopup), (gpointer) &popupD->topW);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "Within PM PLOT Region:\n"" User Azimuth Line:\t\tCLICK+DRAG\n\n"" Follow PM Path:\n""\tStart From Beginning /\n\tIncrease Speed:\tMouse Wheel UP\n\n""\tStart From End /\n\tDecrease Speed:\tMouse Wheel DOWN\n");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
break;
}
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &stnSettings.analysis.popup.colors[scr][STNSB]);
return menu_box;
}
GtkWidget *makeDA(int which, ANAPOPUP *popupD)
{
GtkWidget *frame, *da;
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
switch (which)
{
case SPECTRA_WIN:
case PSD_WIN:
{
GtkWidget *vbox;
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
popupD->da = da = gtk_drawing_area_new();
g_signal_connect(da, "destroy", G_CALLBACK(destroyPopup), GINT_TO_POINTER(which));
gtk_box_pack_start(GTK_BOX(vbox), da, TRUE, TRUE, 0);
g_signal_connect(da, "configure_event", G_CALLBACK(STN_popup_cfg), GINT_TO_POINTER(which));
g_signal_connect(da, "expose_event", G_CALLBACK(STN_popup_exp), GINT_TO_POINTER(which));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventPU), GINT_TO_POINTER(which));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPU), GINT_TO_POINTER(which));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPU), GINT_TO_POINTER(which));
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_LEAVE_NOTIFY_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_POINTER_MOTION_MASK
| GDK_POINTER_MOTION_HINT_MASK
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK);
popupD->statusBar = gtk_statusbar_new();
gtk_box_pack_end(GTK_BOX(vbox), popupD->statusBar, FALSE, FALSE, 0);
}
break;
case PM_WIN:
{
GtkWidget *aspectF, *vbox;
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
aspectF = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1., FALSE);
gtk_box_pack_start(GTK_BOX(vbox), aspectF, TRUE, TRUE, 0);
popupD->da = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(aspectF), da);
g_signal_connect(da, "destroy", G_CALLBACK(destroyPopup), GINT_TO_POINTER(PM_PLOT));
g_signal_connect(da, "configure_event", G_CALLBACK(STN_popup_cfg), GINT_TO_POINTER(PM_PLOT));
g_signal_connect(da, "expose_event", G_CALLBACK(STN_popup_exp), GINT_TO_POINTER(PM_PLOT));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPU), GINT_TO_POINTER(PM_PLOT));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventPU), GINT_TO_POINTER(PM_PLOT));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPU), GINT_TO_POINTER(PM_PLOT));
g_signal_connect(da, "scroll_event", G_CALLBACK(scrollPopup), NULL);
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_LEAVE_NOTIFY_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_POINTER_MOTION_MASK
| GDK_POINTER_MOTION_HINT_MASK
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK);
#if 0
popupD->plot.PM.da = da = gtk_drawing_area_new();
gtk_paned_pack2(GTK_PANED(vpane), da, TRUE, FALSE);
g_signal_connect(da, "configure_event", G_CALLBACK(STN_popup_cfg), GINT_TO_POINTER(PM_TRC));
g_signal_connect(da, "expose_event", G_CALLBACK(STN_popup_exp), GINT_TO_POINTER(PM_TRC));
gtk_paned_set_position((GtkPaned *) vpane, 450);
#endif
popupD->statusBar = gtk_statusbar_new();
gtk_box_pack_end(GTK_BOX(vbox), popupD->statusBar, FALSE, FALSE, 0);
}
break;
}
return frame;
}
void makePOPUP(int which, int type, ANAPOPUP *popupD)
{
GtkWidget *dataBox, *frame;
GtkWidget *topWindow, *menu;
char *title=NULL;
topWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_widget_set_events(topWindow, gtk_widget_get_events(topWindow) | GDK_KEY_PRESS_MASK);
g_signal_connect(topWindow, "key_press_event", G_CALLBACK(FKeyEvent), NULL);
switch(which)
{
case SPECTRA_WIN:
title = g_strdup("STN Spectra");
break;
case PSD_WIN:
title = g_strdup("STN PSD");
break;
case PM_WIN:
title = g_strdup("STN Particle Motion");
break;
}
switch(type)
{
case STN_POPUP_WIN_SEPARATE:
{
char *titleTmp;
int num = g_hash_table_size(stnStates.analysis.popup[which].separate.data)+1;
titleTmp = g_strdup_printf("%s - %d", title, num);
free(title);
title = titleTmp;
}
break;
}
gtk_window_set_title(GTK_WINDOW(topWindow), title); free(title);
popupD->topW = topWindow;
gtk_container_set_border_width(GTK_CONTAINER(topWindow), 2);
dataBox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(topWindow), dataBox);
popupD->sb = menu = makeSB(which, popupD);
gtk_box_pack_start(GTK_BOX(dataBox), menu, FALSE, FALSE, 0);
frame = makeDA(which, popupD);
gtk_container_add(GTK_CONTAINER(dataBox), frame);
}
