#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
static GtkTooltips *tips;
static char   toolTip[1000];
static GtkSizeGroup *size_group, *size_group2;
static GtkWidget *make_buttons(int screen)
{
GtkWidget *widget, *button, *menu_box, *eBox;
GtkWidget *commandB, *box, *mouseBox, *hbox, *vbox;
GtkWidget *frame, *radioB, *combo, *radioB1;
GtkWidget *label, *sep, *entry, *ctr;
GtkAdjustment *spinAdj;
int scr, i;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">STN</span>");
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
gtk_widget_set_size_request(sep, BUTTONW+18, 10);
switch (screen)
{
case STNMAIN:
scr = STNMAIN;
stnSensitives[STNDATABUSYSENS][scr] = g_ptr_array_new();
stnSensitives[STNNOFILTERSENS][scr] = g_ptr_array_new();
button = gtk_button_new_with_label("STATIONS");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 3);
strcpy(toolTip, "Select STATIONS for Viewing");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(make_stationDialogue), NULL);
STNeventB[0] = eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[STNMAIN][STNSB]);
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Channels </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(TRUE, 0);
chnFilter = combo = gtk_combo_box_new_text();
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], combo);
gtk_widget_set_size_request(combo, 10, -1);
stnSignals2[STNCHNFLTSGNL][0] = g_signal_connect(combo, "changed", G_CALLBACK(stnChnFltrSelectC), NULL);
strcpy(toolTip, "CHANNEL Display Filter");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), box, TRUE, TRUE, 2);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 0);
STNeventB[1] = eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[STNMAIN][STNSB]);
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Stations </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
box = gtk_vbox_new(FALSE, 0);
stnCntLbl = label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> 0 / 0 </span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 2);
vbox = gtk_vbox_new(TRUE, 1);
hbox = gtk_hbox_new(TRUE, 1);
stnWidgets[STNPREVSTN1] = button = gtk_button_new_with_label("<<");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
gtk_widget_set_size_request(button, 5, -1);
stnSignals[STNPREVSTN1] = 
g_signal_connect(button, "clicked", G_CALLBACK(dispAdvance), GINT_TO_POINTER(STNPREVSTN1));
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);
strcpy(toolTip, "Display PREVIOUS Set of Stations");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
stnWidgets[STNNEXTSTN1] = button = gtk_button_new_with_label(">>");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
gtk_widget_set_size_request(button, 5, -1);
stnSignals[STNNEXTSTN1] = 
g_signal_connect(button, "clicked", G_CALLBACK(dispAdvance), GINT_TO_POINTER(STNNEXTSTN1));
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);
strcpy(toolTip, "Display NEXT Set of Stations");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(box), vbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
STNeventB[2] = eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[STNMAIN][STNSB]);
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Time </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
box = gtk_vbox_new(FALSE, 0);
vbox = gtk_vbox_new(TRUE, 1);
hbox = gtk_hbox_new(TRUE, 1); 
stnWidgets[STNPREVDT] = button = gtk_button_new_with_label("<<");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
stnSignals[STNPREVDT] = 
g_signal_connect(button, "clicked", G_CALLBACK(dispAdvance), GINT_TO_POINTER(STNPREVDT));
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);
strcpy(toolTip, "Display PREVIOUS Time Range of Data");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
stnWidgets[STNNEXTDT] = button = gtk_button_new_with_label(">>");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
stnSignals[STNNEXTDT] = 
g_signal_connect(button, "clicked", G_CALLBACK(dispAdvance), GINT_TO_POINTER(STNNEXTDT));
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);
strcpy(toolTip, "Display NEXT Time Range of Data");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(box), vbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
STNeventB[3] = eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[STNMAIN][STNSB]);
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Shift </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
box = gtk_vbox_new(FALSE, 0);
vbox = gtk_vbox_new(TRUE, 1);
hbox = gtk_hbox_new(TRUE, 1); 
stnShiftB[0] = button = gtk_button_new_with_label("<<");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
g_signal_connect(button, "clicked", G_CALLBACK(dispShift), GINT_TO_POINTER(STNSHIFTBACKWARD));
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);
strcpy(toolTip, "Shift Start Day of Displayed Data X Days");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
stnShiftB[1] = button = gtk_button_new_with_label(">>");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], button);
g_signal_connect(button, "clicked", G_CALLBACK(dispShift), GINT_TO_POINTER(STNSHIFTFORWARD));
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);
strcpy(toolTip, "Shift End Day of Displayed Data X Days");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
hbox = gtk_hbox_new(TRUE, 1);
spinAdj = (GtkAdjustment *) gtk_adjustment_new(stnSettings.main.shiftDays, 1.0, 
MAXSTNDAYS, 1.0, 5.0, 0.0);
ShiftDays = ctr = gtk_spin_button_new(spinAdj, 1.0, 0);
gtk_widget_set_size_request(ctr, 36, -1);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">DAYS:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), ctr, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(box), vbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
gtk_widget_set_size_request(sep, BUTTONW, 10);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Data Display");
box = gtk_vbox_new(FALSE, 0);
stnDisp[STNCVG] = radioB = gtk_radio_button_new_with_label(NULL, "Coverage");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], radioB);
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Display Data as Coverage");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
stnDisp[STNDTA] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Data");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], radioB);
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Display Data as Actual");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Y-Axis Scale");
box = gtk_vbox_new(FALSE, 0);
size_group2 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
yScaleCbo[STNCHNGRPMAIN] = combo = gtk_combo_box_new_text();
strcpy(toolTip, "Set Y-Axis Scaling Rules");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], combo);
gtk_widget_set_size_request(combo, 10, -1);
stnSignals2[STNYCHNGROUPSGNL][STNCHNGRPMAIN] = 
g_signal_connect(combo, "changed", G_CALLBACK(stnYChnGroupSelectC), GINT_TO_POINTER(scr));
gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 0);
gtk_container_add(GTK_CONTAINER(box), hbox);
stnYfixedB[scr][MAX] = hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("max:");
gtk_size_group_add_widget(size_group2, label);
stnYfixed[scr][MAX] = entry = gtk_entry_new();
g_signal_connect(entry, "activate", G_CALLBACK(stnRefresh), GINT_TO_POINTER(scr));
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(box), hbox);
strcpy(toolTip, "MAX: define as absolute (e.g., 1000) or as Percentage of MAX/MIN Mean (e.g., 50%) (BLANK = Real MAX)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
stnYfixedB[scr][MIN] = hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("min:");
gtk_size_group_add_widget(size_group2, label);
stnYfixed[scr][MIN] = entry = gtk_entry_new();
g_signal_connect(entry, "activate", G_CALLBACK(stnRefresh), GINT_TO_POINTER(scr));
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(box), hbox);
strcpy(toolTip, "MIN: define as absolute (e.g., 1000) or as Percentage of MAX/MIN Mean (e.g., 50%) (BLANK = Real MIN)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
stnUnitsB[screen] = eBox = gtk_event_box_new();
frame = gtk_frame_new("Display Units");
box = gtk_vbox_new(FALSE, 0);
stnUnits[scr][STNCOUNTS] = radioB = gtk_radio_button_new_with_label(NULL, "Counts");
gtk_container_add(GTK_CONTAINER(box), radioB);
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], radioB);
strcpy(toolTip, "Display Data as COUNTS");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
stnUnits[scr][STNSENSITIVITY] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Sensitivity");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], radioB);
strcpy(toolTip, "Display Data with Sensitivity Applied");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Filter");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(TRUE, 0);
stnFltrCbos[scr] = combo = gtk_combo_box_new_text();
strcpy(toolTip, "Apply Filter");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], combo);
gtk_widget_set_size_request(combo, 10, -1);
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
stnFilter[scr][ON] = radioB1 = gtk_radio_button_new_with_label(NULL, "On");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], radioB1);
g_ptr_array_add(stnSensitives[STNNOFILTERSENS][scr], radioB1);
gtk_container_add(GTK_CONTAINER(hbox), radioB1);
stnFilter[scr][OFF] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][scr], radioB);
g_ptr_array_add(stnSensitives[STNNOFILTERSENS][scr], radioB);
gtk_container_add(GTK_CONTAINER(hbox), radioB);
gtk_box_pack_start(GTK_BOX(box), hbox, TRUE, TRUE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "Turn Filter ON");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "Turn Filter OFF");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 0);
gtk_widget_set_size_request(sep, -1, 10);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Servers");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Connect to STN/PSD Server/Database");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(servers), NULL);
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print Screen to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stnPrint), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raiseStnControls), GINT_TO_POINTER(STNMAINCTRL));
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Admin");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Start PQLX Admin Program");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(execAdmin), NULL);
button = gtk_button_new_with_label("About");
gtk_container_add(GTK_CONTAINER(commandB), button);
g_signal_connect(button, "clicked", G_CALLBACK(about), GINT_TO_POINTER(STNSYSTEM));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
stnProgBar = gtk_progress_bar_new();
gtk_widget_set_size_request(stnProgBar, BUTTONW, BUTTONH);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"
" F1 - Go To Trace Viewer\n"
" F2 - Go To PSD Viewer\n"
" F3 - Go To STN::Analysis\n"
"\nOn Stats:\n""\tDisplay Stats & PDF:\t HOVER\n""On PDF:\n""\tDisplay PDF:\t HOVER\n""\tTake to PDF Detail:\t CLICK\n""Within Plot Region:\n""\tTake to PQL (new):\tSHIFT+CLICK+DRAG\n""\tTake to PQL (add):\tCTRL+CLICK+DRAG\n""\tTake to Analysis (new):\ta-key+CLICK+DRAG\n""\tTake to Analysis (add):\ts-key+CLICK+DRAG\n""On Station Label:\n""\tSelect all Station's data:\tCLICK\nOn Channel Label:\n""\tSelect all Channel's data:\tCLICK\nIn X-axis Day Range:\n""\tSelect all Day's data:\t\tCLICK\n");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_box_pack_end(GTK_BOX(box), stnProgBar, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(widget), box);
if (stnSettings.display.yFixed[scr][MAX])
gtk_entry_set_text(GTK_ENTRY(stnYfixed[scr][MAX]), stnSettings.display.yFixed[scr][MAX]);
if (stnSettings.display.yFixed[scr][MIN])
gtk_entry_set_text(GTK_ENTRY(stnYfixed[scr][MIN]), stnSettings.display.yFixed[scr][MIN]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnDisp[stnSettings.main.data]), TRUE);  
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnFilter[scr][OFF]), TRUE);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnUnits[scr][stnSettings.display.units[screen]]), TRUE);
stnSignals2[STNDISPCVGSGNL][0] = g_signal_connect(stnDisp[STNCVG], "toggled", G_CALLBACK(stnDispChg), GINT_TO_POINTER(STNCVG));
stnSignals2[STNDISPDATASGNL][0] = g_signal_connect(stnDisp[STNDTA], "toggled", G_CALLBACK(stnDispChg), GINT_TO_POINTER(STNDTA));
stnSignals2[STNFLTSGNL][STNMAIN] = g_signal_connect(stnFilter[STNMAIN][OFF], "toggled", G_CALLBACK(stnApplyFilter), GINT_TO_POINTER(STNMAIN));
stnSignals2[STNFLTCBOSGNL][STNMAIN] = g_signal_connect(stnFltrCbos[STNMAIN], "changed", G_CALLBACK(stnFltrSelect), GINT_TO_POINTER(STNMAIN));
g_signal_connect(stnUnits[scr][STNCOUNTS], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNUNITS));
g_signal_connect(stnUnits[scr][STNSENSITIVITY], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNUNITS));
break;
case STNANALYSIS:
scr = STNANALYSIS;
stnSensitives[STNNOEVENTSENS][scr] = g_ptr_array_new();
stnSensitives[STNNOEVENTSENS1][scr] = g_ptr_array_new();
button = gtk_button_new_with_label("EVENTS");
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 3);
strcpy(toolTip, "Select a Seismic Event");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(eventSelect), NULL);
g_ptr_array_add(stnSensitives[STNNOEVENTSENS1][scr], button);
eBox = gtk_event_box_new();
frame = gtk_frame_new(" Trace Order ");
box = gtk_vbox_new(FALSE, 0);
stnOrder[EVTDISPSTN] = radioB = gtk_radio_button_new_with_label(NULL, "Station");
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Order Data by Station Name");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
stnOrder[EVTDISPEVT] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Epicentral");
gtk_container_add(GTK_CONTAINER(box), radioB);
g_ptr_array_add(stnSensitives[STNNOEVENTSENS][scr], radioB);
g_ptr_array_add(stnSensitives[STNNOEVENTSENS1][scr], radioB);
strcpy(toolTip, "Order Data by Epicentral Distance");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Analysis");
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Original");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(stnTFormSel), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "Un-Do All Transforms");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
stnTForms = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
strcpy(toolTip, "Apply Transform Function to Traces");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
for(i=0;i<TTLSTNANALYSES;i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), transforms[i]);
}   
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), ANATFORMS);
stnSignals2[STNANATFORMSGNL][scr] = g_signal_connect(combo, "changed", G_CALLBACK(stnTFormSel), GINT_TO_POINTER(FALSE));
stnFltrCbos[scr] = combo = gtk_combo_box_new_text();
gtk_widget_set_size_request(combo, 10, -1);
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
strcpy(toolTip, "Apply Filter");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
button = gtk_button_new_with_label("CUT");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(cutANA), NULL);
strcpy(toolTip, "Make Displayed Data New Selection");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("X-Axis Alignment");
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
stnXScales = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
strcpy(toolTip, "Define X-Axis Display Alignment");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
for(i=0;i<MAXALIGNMENTS;i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), STNxscales[i]);
}   
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), stnSettings.display.xScale);
g_signal_connect(combo, "changed", G_CALLBACK(stnComboSel), GINT_TO_POINTER(STNXSCALE));
eBox = gtk_event_box_new();
frame = gtk_frame_new("Y-Axis Scale");
box = gtk_vbox_new(FALSE, 0);
size_group2 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
yScaleCbo[STNCHNGRPANALYSIS] = combo = gtk_combo_box_new_text();
gtk_widget_set_size_request(combo, 10, -1);
stnSignals2[STNYCHNGROUPSGNL][STNCHNGRPANALYSIS] = 
g_signal_connect(combo, "changed", G_CALLBACK(stnYChnGroupSelectC), GINT_TO_POINTER(scr));
gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 0);
gtk_container_add(GTK_CONTAINER(box), hbox);
strcpy(toolTip, "Set Y-Axis Scaling Rules");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
stnYfixedB[scr][MAX] = hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("max:");
gtk_size_group_add_widget(size_group2, label);
stnYfixed[scr][MAX] = entry = gtk_entry_new();
g_signal_connect(entry, "activate", G_CALLBACK(stnRefresh), GINT_TO_POINTER(scr));
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(box), hbox);
strcpy(toolTip, "MAX: define as absolute (e.g., 1000) or as Percentage of MAX/MIN Mean (e.g., 50%) (BLANK = Real MAX)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
stnYfixedB[scr][MIN] = hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("min:");
gtk_size_group_add_widget(size_group2, label);
stnYfixed[scr][MIN] = entry = gtk_entry_new();
g_signal_connect(entry, "activate", G_CALLBACK(stnRefresh), GINT_TO_POINTER(scr));
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_container_add(GTK_CONTAINER(hbox), label);
gtk_container_add(GTK_CONTAINER(hbox), entry);
gtk_container_add(GTK_CONTAINER(box), hbox);
strcpy(toolTip, "MIN: define as absolute (e.g., 1000) or as Percentage of MAX/MIN Mean (e.g., 50%) (BLANK = Real MIN)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
stnUnitsB[screen] = eBox = gtk_event_box_new();
frame = gtk_frame_new("Display Units");
box = gtk_vbox_new(FALSE, 0);
stnUnits[scr][STNCOUNTS] = radioB = gtk_radio_button_new_with_label(NULL, "Counts");
gtk_container_add(GTK_CONTAINER(box), radioB);
stnUnits[scr][STNSENSITIVITY] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Sensitivity");
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
frame = gtk_frame_new(" Overlay ");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
stnOverlay[scr][ON] = radioB = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(hbox), radioB);
strcpy(toolTip, "Turn Overlay On");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
stnOverlay[scr][OFF] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Off");
gtk_container_add(GTK_CONTAINER(hbox), radioB);
strcpy(toolTip, "Turn Overlay Off");
gtk_container_add(GTK_CONTAINER(box), hbox);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
STNSnap = button = gtk_button_new_with_label("SNAP");
g_signal_connect(button, "clicked", G_CALLBACK(ANAreMag), GINT_TO_POINTER(SNAP));
strcpy(toolTip, "MOVE (SNAP) Vertical Line to ZOOM Anchor Point");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 2);
STNMag = button = gtk_button_new_with_label("MAGNIFY");
g_signal_connect(button, "clicked", G_CALLBACK(ANAreMag), GINT_TO_POINTER(MAG));
strcpy(toolTip, "MAGNIFY current Double Boundary Selection");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 2);
STNZoomBox = eBox = gtk_event_box_new();
frame = gtk_frame_new("Zoom Anchor");
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
stnZAnchors = combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
strcpy(toolTip, "Define ZOOM Point");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
for(i=0;i<TOTMANCHORS;i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), zanchors[i]);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), stnSettings.analysis.anchor);
g_signal_connect(combo, "changed", G_CALLBACK(stnComboSel), GINT_TO_POINTER(STNZANCHOR));
#if 0
STNAnchor[LEFT] = gtk_radio_button_new_with_label(NULL, "Left");
STNAnchor[MIDDLE] = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) STNAnchor[LEFT]), "Middle");
STNAnchor[RIGHT] = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) STNAnchor[LEFT]), "Right");
STNAnchor[MOUSE] = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) STNAnchor[LEFT]), "Mouse");
gtk_container_add(GTK_CONTAINER(box), STNAnchor[LEFT]);
gtk_container_add(GTK_CONTAINER(box), STNAnchor[MIDDLE]);
gtk_container_add(GTK_CONTAINER(box), STNAnchor[RIGHT]);
gtk_container_add(GTK_CONTAINER(box), STNAnchor[MOUSE]);
strcpy(toolTip, "Define ZOOM Anchor as LEFT Edge of Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNAnchor[LEFT], toolTip, toolTip);
strcpy(toolTip, "Define ZOOM Anchor as MIDDLE of Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNAnchor[MIDDLE], toolTip, toolTip);
strcpy(toolTip, "Define ZOOM Anchor as RIGHT Edge of Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNAnchor[RIGHT], toolTip, toolTip);
strcpy(toolTip, "Define ZOOM Anchor as Point Defined by Mouse @ Drag Start");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNAnchor[MOUSE], toolTip, toolTip);
#endif
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Remove");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "DELETE Selected Traces from Display List");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(selectSTNT), GINT_TO_POINTER(REMOVE));
button = gtk_button_new_with_label("Select All");
gtk_container_add(GTK_CONTAINER(commandB), button);
g_signal_connect(button, "clicked", G_CALLBACK(selectSTNT), GINT_TO_POINTER(SELECT));
strcpy(toolTip, "SELECT ALL Traces");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Deselect All");
gtk_container_add(GTK_CONTAINER(commandB), button);
g_signal_connect(button, "clicked", G_CALLBACK(selectSTNT), GINT_TO_POINTER(DESELECT));
strcpy(toolTip, "DE-SELECT ALL Traces");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
gtk_box_set_spacing(GTK_BOX(commandB), 2);
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print Screen to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(stnPrint), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raiseStnControls), GINT_TO_POINTER(STNANLCTRL));
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"
" F1 - Go To Trace Viewer\n"
" F2 - Go To PSD Viewer\n"
" F3 - Go To STN::MAIN\n"
"nWithin PLOT Region:n"
" Vertical Line:ttCLICKn"
" ZOOM In:ttCLICK+DRAG RIGHTn"
"ttttMouse Wheel UPn"
"ttttArrow Key UPn"
"ttttZ-Key + LINESn"
" ZOOM Out:ttCLICK+DRAG LEFTn"
"ttttMouse Wheel DOWNn"
"ttttArrow Key DOWNn"
"ttttX-Key + LINESn"
"t(Adjust ZOOM Speed via PQL Controls Panel)nn"
" Data Point(s):tCTRL+CLICKn"
" Scan Data Points:tCTRL+CLICK+DRAGn"
" Define Pick:ttPICK# +CLICKnn"
"Within LABEL Region (in Overlay Mode):n"
" Bring Trace to TOP:tCLICKnn"
"Within Top AXIS Region:n"
" Scroll Window:tMouse Wheel UP/DOWNn"
"\t\t\t\tArrow Key LEFT/RIGHT\n");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnOrder[stnSettings.event.dispOrder]), TRUE);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnOverlay[scr][OFF]), TRUE);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnUnits[scr][stnSettings.display.units[screen]]), TRUE);
stnSignals2[STNOVLYSGNL][scr] = g_signal_connect(stnOverlay[scr][OFF], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNOVERLAY));
g_signal_connect(stnOverlay[scr][ON], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNOVERLAY));
stnSignals2[STNFLTCBOSGNL][scr] = g_signal_connect(stnFltrCbos[scr], "changed", G_CALLBACK(stnFltrSelect), GINT_TO_POINTER(scr));
g_signal_connect(stnUnits[scr][STNCOUNTS], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNUNITS));
g_signal_connect(stnUnits[scr][STNSENSITIVITY], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNUNITS));
g_signal_connect(stnOrder[EVTDISPSTN], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNEPIORDER));
g_signal_connect(stnOrder[EVTDISPEVT], "toggled", G_CALLBACK(stnRadio_chg), GINT_TO_POINTER(STNEPIORDER));
break;
}
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &stnSettings.drawing.colors[screen][STNSB]);
gtk_size_group_add_widget(size_group, widget);
return menu_box;
}
void make_STN_dataScreens()
{
int    i;
GtkWidget   *vbox, *hbox, *da;
GtkWidget   *frame;
tips = gtk_tooltips_new();
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
systems[STNSYSTEM] = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(topBox), systems[STNSYSTEM]);
vbox = gtk_vbox_new(FALSE, 0);     
sysCbo[STNSYSTEM] = gtk_combo_box_new_text();
for (i=0;i<NUM_SYSTEMS;i++)
{
gtk_combo_box_insert_text(GTK_COMBO_BOX(sysCbo[STNSYSTEM]), i, systemNames[i]);
}
gtk_box_pack_start(GTK_BOX(vbox), sysCbo[STNSYSTEM], FALSE, FALSE, 0);
sysCboSgnl[STNSYSTEM] = g_signal_connect(sysCbo[STNSYSTEM], "changed", G_CALLBACK(systemChg), NULL);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(systems[STNSYSTEM]), vbox, FALSE, FALSE, 0);
STNbuttons[STNMAIN] = make_buttons(STNMAIN);
gtk_box_pack_start(GTK_BOX(hbox), STNbuttons[STNMAIN], TRUE, FALSE, 0);
STNbuttons[STNANALYSIS] = make_buttons(STNANALYSIS);
gtk_box_pack_start(GTK_BOX(hbox), STNbuttons[STNANALYSIS], TRUE, FALSE, 0);
vbox = gtk_vbox_new(FALSE, 0);
STNscreens = gtk_notebook_new();
g_ptr_array_add(stnSensitives[STNDATABUSYSENS][STNMAIN], STNscreens);
statusBarSTN = gtk_statusbar_new();
gtk_box_pack_end(GTK_BOX(vbox), statusBarSTN, FALSE, FALSE, 0);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
STNDA[STNMAIN] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
g_signal_connect(da, "configure_event", G_CALLBACK(STN_cfg), (gpointer) GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "expose_event", G_CALLBACK(STN_exp), (gpointer) GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventSTN), GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventSTN), GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventSTN), GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "key_press_event", G_CALLBACK(FKeyEvent), NULL);
g_signal_connect(da, "key_press_event", G_CALLBACK(keyEventSTN), GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "key_release_event", G_CALLBACK(keyEventSTN), GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "enter_notify_event", G_CALLBACK(grabFocusSTN), GINT_TO_POINTER(STNMAIN));
g_signal_connect(da, "leave_notify_event", G_CALLBACK(grabFocusSTN), GINT_TO_POINTER(STNMAIN));
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_LEAVE_NOTIFY_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_POINTER_MOTION_MASK
| GDK_POINTER_MOTION_HINT_MASK
| GDK_KEY_PRESS_MASK
| GDK_KEY_RELEASE_MASK
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK);
gtk_notebook_append_page(GTK_NOTEBOOK(STNscreens), frame, gtk_label_new(" MAIN "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
STNDA[STNANALYSIS] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
g_signal_connect(da, "configure_event", G_CALLBACK(STN_cfg), GINT_TO_POINTER(STNANALYSIS));
g_signal_connect(da, "expose_event", G_CALLBACK(STN_exp), GINT_TO_POINTER(STNANALYSIS));
g_signal_connect(da, "scroll_event", G_CALLBACK(anaScrollEvent), NULL);
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventANA), GINT_TO_POINTER(STNANALYSIS));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventANA), GINT_TO_POINTER(STNANALYSIS));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventANA), GINT_TO_POINTER(STNANALYSIS));
g_signal_connect(da, "key_press_event", G_CALLBACK(FKeyEvent), NULL);
g_signal_connect(da, "key_press_event", G_CALLBACK(keyEventANA), NULL);
g_signal_connect(da, "key_release_event", G_CALLBACK(ctrlKeyEventANA), NULL);
g_signal_connect(da, "key_release_event", G_CALLBACK(keyEventANA), NULL);
g_signal_connect(da, "enter_notify_event", G_CALLBACK(grabFocusSTN), GINT_TO_POINTER(STNANALYSIS));
g_signal_connect(da, "leave_notify_event", G_CALLBACK(grabFocusSTN), GINT_TO_POINTER(STNANALYSIS));
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_LEAVE_NOTIFY_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_POINTER_MOTION_MASK
| GDK_POINTER_MOTION_HINT_MASK
| GDK_KEY_PRESS_MASK
| GDK_KEY_RELEASE_MASK
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK);
gtk_notebook_append_page(GTK_NOTEBOOK(STNscreens), frame, gtk_label_new(" Analysis "));
g_signal_connect(STNscreens, "switch-page", G_CALLBACK(changeTabSTN), NULL);
gtk_box_pack_start(GTK_BOX(vbox), STNscreens, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(systems[STNSYSTEM]), vbox, TRUE, TRUE, 0);
return;
}
void make_stn()
{
int i;
stnSignals2[STNCHNFLTSGNL] = calloc(1, sizeof(gulong));
stnSignals2[STNFLTSGNL] = calloc(1, TTLSTNSCREENS * sizeof(gulong));
stnSignals2[STNFLTCBOSGNL] = calloc(1, TTLSTNSCREENS * sizeof(gulong));
stnSignals2[STNANATFORMSGNL] = calloc(1, TTLSTNSCREENS * sizeof(gulong));
stnSignals2[STNOVLYSGNL] = calloc(1, TTLSTNSCREENS * sizeof(gulong));
stnSignals2[STNSRVRDFAULTSGNL] = calloc(1, sizeof(gulong));
stnSignals2[STNDBDFAULTSGNL] = calloc(1, sizeof(gulong));
stnSignals2[STNDISPCVGSGNL] = calloc(1, sizeof(gulong));
stnSignals2[STNDISPDATASGNL] = calloc(1, sizeof(gulong));
stnSignals2[STNYCHNGROUPSGNL] = calloc(1, TOTSTNCHNGROUPS*sizeof(gulong));
memset(&stnStates, 0, sizeof(STNSTATES));
memset(&stnSettings, 0, sizeof(STNSETTINGS));
read_STNdefaults(&stnSettings);
make_STN_dataScreens();
setSTNchnFiltCbos();
setStnFiltCbos();
readChnGrpScales();
makeChnGrpScaleCbo();
gtk_widget_show_all(systems[STNSYSTEM]);
pqlxStates.system = STNSYSTEM;
setSensitive(STNSYSTEM, STNNOFILTERSENS, STNMAIN, FALSE);
setSensitive(STNSYSTEM, STNNOEVENTSENS, STNANALYSIS, FALSE);
if (!stnSettings.display.unitsD)
{
gtk_widget_hide(stnUnitsB[STNMAIN]);
gtk_widget_hide(stnUnitsB[STNANALYSIS]);
}
gtk_widget_hide(STNbuttons[STNANALYSIS]);
for(i=0;i<TTLSTNSCREENS;i++)
{
if (stnSettings.display.yScale[i] != FIXEDS)
{
gtk_widget_hide(stnYfixedB[i][MAX]);
gtk_widget_hide(stnYfixedB[i][MIN]);
}
}
gtk_widget_hide(stnProgBar);
gtk_widget_hide(STNMag);
stnStates.pmap.dirty[STNMAIN][0] = stnStates.pmap.dirty[STNMAIN][1] = TRUE;  
stnStates.pmap.dirty[STNANALYSIS][0] = TRUE;
return ;
}
