#!/bin/bash

if [ "$1" = "" ] ; then
	echo "usage: $0 [HOST:]DBName"
	echo "example:	$0 micros"
	echo "	returns a list of all PSD channels in the database micros"
	echo "	output format - one per line:"
	echo "NTW STN LOC CHN"
	exit
fi

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

HOST=`echo $1 | sed 's/:.*//'`
DBn=`echo $1 | sed 's/.*://'`

if [ "$HOST" = "$DBn" ] ; then
	HOST=localhost
fi

# check that the database exists
check=`$PQLXBIN/_checkDB $HOST $DBn DE`
if [ "$check" = "FALSE" ] ; then
	exit
fi

PWORD=PqLXClnT
execCMD="${mysqlexec} --host=$HOST --database=$DBn --user=pqlxClnt --password=$PWORD --compress"

# make the SQL command
sql="SELECT ntw, stn, loc, chn FROM nslc n, PSDCFG p WHERE p.chni_fk = n.chni_pk order by ntw, stn, loc, chn"

# execute
echo $sql | ${execCMD} | grep -v ntw
