#!/bin/bash

if [ $# -ne 1 ] ; then
	echo "usage: $0 hostname"
	echo "example:	$0 localhost"
	echo "	returns the last date for which Seismic Event Information exists in the DB"
	exit
fi

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

HOST=`echo $1`

PWORD=PqLXAdmiN
execCMD="${mysqlexec} --host=$HOST --database=$DBn --user=pqlxAdmin --password=$PWORD --compress"

sql="SELECT DATE(MAX(time)) as d FROM PQLXMETA.SEISEVENT"

echo $sql | ${execCMD} | grep -v d
