#!/bin/bash

if [ $# -ne 2 ] ; then
	echo "usage: $0 [HOST:]DBName inputFile"
	echo "	Delete Channels listed in file inputFile from Specified PQLX DB"
	echo "example:	$0 micros delChannels.lst"
	echo "	Delete the Channels listed in file delChannels.lst from the micros DB"
	echo "  Including ALL Corresponding Data"
	exit
fi

hostDB=$1
chnFile=$2

HOST=`echo ${hostDB} | sed 's/:.*//'`
DBn=`echo ${hostDB} | sed 's/.*://'`

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

if [ "$HOST" = "$DBn" ] ; then
	HOST=localhost
fi

# check that the database exists
check=`$PQLXBIN/_checkDB $HOST $DBn DE`
if [ "$check" == "FALSE"  ] ; then
	exit
fi

outFile=$PQLXLOG/delChans-`date +%Y.%j.%H%M`.log
echo "Deleting Channels Listed in File '${chnFile}'" 
echo "Output to File '${outFile}'"
echo "Deleting Channels Listed in '${chnFile}'" >>$outFile

cat ${chnFile} |  	# Our Input
while read channel  # until it's done
do
	timeStamp=`date '+%Y %j %H:%M:%S'` 
	echo "${timeStamp}>>	Deleting channel '${channel}'	" >>$outFile
	$PQLXBIN/delChannel.sh ${hostDB} ${channel} >>$outFile
	echo "" >>$outFile
done
