#!/bin/bash

if [ "$1" = "" ] ; then
	echo "Usage: $0 dbName"
	echo "	where dbName is the name of the PQLX database to delete"
	echo "  (can only be executed on 'localhost')"
	exit
fi

dbN="$1"

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

# script deletes specified PQLX database

# check that the database exists
check=`$PQLXBIN/_checkDB localhost "$dbN" DE`
if [ "$check" == "FALSE"  ] ; then
	exit
fi

# set up the MySQL password
PWORD=PqLXAdmiN
execCMD="${mysqlexec} --user=pqlxAdmin --password=$PWORD"

# and if they get the password right
check=`echo "select adminPWord from PQLXMETA.PQLXDBS where dbName='$dbN'" | ${execCMD} | grep -v adminPWord`
echo
echo "Please enter the System Administrator password for the PDF Database '$dbN'"
read pword
if [ "$check" != "$pword" ] ; then
	echo "System Administrator Password does not match."
	echo "PQLX Database '$dbN' not deleted, Quitting without doing anything... Goodbye"
	exit
fi

# finally, if it's a non-PRODUCTION dbases to be dropped, ask again
check=`echo "select type from PQLXMETA.PQLXDBS where dbName='$dbN'" | ${execCMD} | grep -v type`
if [ "$check" = "PRODUCTION" ] ; then
	echo "WARNING!!  PQLX Database '$dbN' is designated a PRODUCTION database, are you really sure this should be deleted? (Y | N)"
	read ans
	if [ "$ans" != "Y" ] ; then
		echo "Database '$dbN' not deleted, Quitting without doing anything... Goodbye"
		exit
	fi
fi

echo "This action will delete the PQLX database '$dbN' and all corresponding PSD data..."

echo
echo "Are you absolutely sure you want to do this (data recovery is not possible!)? (Y | N)"
read ans
if [ "$ans" != "Y" ] ; then
	echo "Database '$dbN' not deleted, Quitting without doing anything... Goodbye"
	exit
fi

# drop requested database 
db=$dbN
echo "DROP database \`${db}\`" | ${execCMD}
echo "DROP database \`${db}DATA\`" | ${execCMD}
echo "DROP database \`${db}STATS\`" | ${execCMD}
echo "DROP database \`${db}TMP\`" | ${execCMD}
echo "delete from PQLXMETA.PQLXDBS where dbName='$dbN'" | ${execCMD}

echo "PQLX Database '$dbN' and ALL subordinate data deleted."
