#!/bin/bash

if [ $# -ne 6 ] ; then
	echo "usage: $0 [HOST:]DBName NTW STN LOC CHN YYYY-MM-DD"
	echo "example:	$0 micros IU ANMO -- BHE 2009-01-18"
	echo "	deletes the trace record for the specified channel "
	echo "  from the specified PQLX database including all "
	echo "  corresponding data (gaps, overlaps, PSD's, etc.)"
	exit
fi

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

HOST=`echo $1 | sed 's/:.*//'`
DBn=`echo $1 | sed 's/.*://'`
NTWi=$2
STNi=$3
LOCi=$4
CHNi=$5
dateD=$6

if [ "$HOST" = "$DBn" ] ; then
	HOST=localhost
fi

# check that the database exists
check=`$PQLXBIN/_checkDB $HOST $DBn DE`
if [ "$check" == "FALSE"  ] ; then
	exit
fi

PWORD=PqLXAdmiN
execCMD="${mysqlexec} --host=$HOST --database=$DBn --user=pqlxAdmin --password=$PWORD --compress"

chniFK=`echo "SELECT chni_pk FROM  ${DBn}.nslc WHERE ntw = '$NTWi' and stn = '$STNi' and loc = '$LOCi' and chn = '$CHNi'" | ${execCMD} | grep -v chni_pk`
if [ "$chniFK" = "" ] ; then
	echo "No channel instance found for $NTWi.$STNi.$LOCi.$CHNi, please try again..."
	echo "Quitting without doing anything... Goodbye"
	exit
fi

echo "Removing Trace File for day $dateD (channel $NTWi.$STNi.$LOCi.$CHNi) from PQLX database ${DBn}..."

sql="DELETE T.* FROM TRC T where T.chni_fk = ${chniFK} and DATE(start) = '$dateD'"
echo $sql | ${execCMD}
	
echo "... Done"

