#!/bin/bash

if [ $# -ne 1 ] ; then
	echo "usage: $0 [HOST:]DBName"
	echo "example:	$0 micros"
	echo "	Force a refresh of all System PDF's and PNG's for specified Database"
	echo "  N.B. pqlxSrvr process must be executed manually once complete"
	exit
fi

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

HOST=`echo $1 | sed 's/:.*//'`
DBn=`echo $1 | sed 's/.*://'`

if [ "$HOST" = "$DBn" ] ; then
	HOST=localhost
fi

# check that the database exists
check=`$PQLXBIN/_checkDB $HOST $DBn DE`
if [ "$check" == "FALSE"  ] ; then
	exit
fi

PWORD=PqLXAdmiN
execCMD="${mysqlexec} --host=$HOST --database=$DBn --user=pqlxAdmin --password=$PWORD --compress"

# insert the SPS EPOCH events
sql="DELETE FROM EVENTQ WHERE type = 93;INSERT INTO EVENTQ (type, typeKey, processed) SELECT 93, chni_pk, 'NOPROC' FROM CHNI WHERE nTraces > 0"
echo $sql | ${execCMD}

# insert the SYSTEM PDF events
sql="DELETE FROM EVENTQ WHERE type = 100;INSERT INTO EVENTQ (type, typeKey, processed) SELECT 100, chni_fk, 'NOPROC' FROM PSDCFG p, CHNI c where p.chni_fk <> 0 and c.chni_pk = p.chni_fk and c.nTraces <> 0"
echo $sql | ${execCMD}

# insert the PDFPNG events
# we don't do this here since the server will do it for us automatically based on the existence of
# event 100 above
#sql="INSERT INTO EVENTQ (type, typeKey, processed) SELECT 101, chni_fk, 'NOPROC' FROM PSDCFG p, CHNI c where p.chni_fk <> 0 and c.chni_pk = p.chni_fk and c.nTraces <> 0"
#echo $sql | ${execCMD}

echo "Please now execute pqlxSrvr_safe against database $DBn to remake all System PDF's"
