#!/bin/bash

if	[ $# -ne 3 ] ; then
	echo "usage: $0 [HOST:]DBName CHANNEL_GROUP OVERLAP_%"
	echo "	Sets the PSD Overlap % for the Specified Channel Group"
	echo
	echo "example:	$0 micros BH 95"
	echo "	Set the Overlap % to 95% for all BH* Channels"
	exit
fi

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

HOST=`echo $1 | sed 's/:.*//'`
DBn=`echo $1 | sed 's/.*://'`

if [ "$HOST" = "$DBn" ] ; then
	HOST=localhost
fi

# check that the database exists
check=`$PQLXBIN/_checkDB $HOST $DBn DE`
if [ "$check" == "FALSE"  ] ; then
	exit
fi

changrp=$2
overlap=$3

PWORD=PqLXAdmiN
execCMD="${mysqlexec} --host=$HOST --database=$DBn --user=pqlxAdmin --password=$PWORD --compress"

# update the directory
sql="UPDATE PSDCFG SET overlap = $overlap WHERE channel = '$changrp'"
echo $sql | ${execCMD}

$PQLXBIN/refreshSysPDF.sh $1
