#!/bin/bash

if	[ $# -ne 3 ] || \
	[ "$2" != "PDF" -a "$2" != "SPECTRO" ] ; then
	echo "usage: $0 [HOST:]DBName TYPE (PDF | SPECTRO) Directory"
	echo "	Sets the PNG Output Directory for the Specified System Plot for the Specified Database"
	echo
	echo "example:	$0 micros SPECTRO /tmp/wwwSP"
	echo "	Set the Output Directory for System Spectrograms for DB micros"
	exit
fi

if [ "$MYSQLBIN" = "" ] ; then
	mysqlexec=mysql
else
	mysqlexec=$MYSQLBIN/mysql
fi

HOST=`echo $1 | sed 's/:.*//'`
DBn=`echo $1 | sed 's/.*://'`

if [ "$HOST" = "$DBn" ] ; then
	HOST=localhost
fi

# check that the database exists
check=`$PQLXBIN/_checkDB $HOST $DBn DE`
if [ "$check" == "FALSE"  ] ; then
	exit
fi

if [ "$2" = "PDF" ] ; then
	type=101
fi
if [ "$2" = "SPECTRO" ] ; then
	type=102
fi

dir=$3

PWORD=PqLXAdmiN
execCMD="${mysqlexec} --host=$HOST --database=$DBn --user=pqlxAdmin --password=$PWORD --compress"

# update the directory
sql="UPDATE PNGWWW SET wwwDir = '$dir' WHERE type = $type"
echo $sql | ${execCMD}

$PQLXBIN/refreshSysPDF.sh $1
