-- MySQL dump 10.10
--
-- Host: localhost    Database: pqlx
-- ------------------------------------------------------
-- Server version	5.0.18-standard

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `CHNI`
--

DROP TABLE IF EXISTS `CHNI`;
CREATE TABLE `CHNI` (
  `chni_pk` mediumint(9) NOT NULL auto_increment,
  `sampRate` float unsigned NOT NULL default '0',
  `lat` float NOT NULL default '0',
  `lon` float NOT NULL default '0',
  `startT` timestamp NOT NULL default '0000-00-00 00:00:00',
  `endT` timestamp NOT NULL default '0000-00-00 00:00:00',
  `nTraces` int(10) unsigned NOT NULL default '0',
  `GapMax` mediumint(9) unsigned default NULL,
  `GapMin` mediumint(8) unsigned default NULL,
  `GapAvg` float unsigned NOT NULL default '0',
  `OlapMax` mediumint(8) unsigned default NULL,
  `OlapMin` mediumint(8) unsigned default NULL,
  `OlapAvg` float unsigned NOT NULL default '0',
  `MaxMax` int(11) default NULL,
  `MaxMin` int(11) default NULL,
  `MaxAvg` float NOT NULL default '0',
  `MinMax` int(11) default NULL,
  `MinMin` int(11) default NULL,
  `MinAvg` float NOT NULL default '0',
  `MeanMax` float default NULL,
  `MeanMin` float default NULL,
  `MeanAvg` float NOT NULL default '0',
  `NTW_FK` mediumint(9) unsigned NOT NULL,
  `STN_FK` mediumint(9) unsigned NOT NULL,
  `LOC_FK` mediumint(9) unsigned NOT NULL,
  `CHN_FK` mediumint(9) unsigned NOT NULL,
  PRIMARY KEY  (`chni_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `CHNI`
--


/*!40000 ALTER TABLE `CHNI` DISABLE KEYS */;
LOCK TABLES `CHNI` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `CHNI` ENABLE KEYS */;

/*!50003 SET @OLD_SQL_MODE=@@SQL_MODE*/;
DELIMITER ;;
/*!50003 SET SESSION SQL_MODE="NO_AUTO_VALUE_ON_ZERO" */;;
/*!50003 CREATE TRIGGER `CHNIDEPENDENCIES` AFTER INSERT ON `CHNI` FOR EACH ROW
BEGIN
	--	insert a DUMMY trace for the new channel, 
	--  this is necessary for imported PDF's with no link back to the original trace
	INSERT INTO TRC (CHNI_FK) VALUES (NEW.CHNI_PK);

	--	insert all system (automatically computed) PDF's for the new channel
	INSERT INTO PDFIDX (PDFCFG_FK, CHNI_FK) SELECT PDFCFG_PK, NEW.CHNI_PK FROM PDFCFG P;

	--	insert the default PSD configuration parameters according to the channel name and PSDCFG entries
	INSERT INTO PSDCFG (channel, description, minPower, maxPower, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, chni_fk) SELECT channel, description, minPower, maxPower, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, NEW.CHNI_PK FROM PSDCFG P, IDS I WHERE P.CHNI_FK = 0 AND I.IDS_PK = NEW.CHN_FK AND LEFT(I.NAME,2) = P.channel;

END */;;

DELIMITER ;
/*!50003 SET SESSION SQL_MODE=@OLD_SQL_MODE */;

--
-- Table structure for table `DIRS`
--

DROP TABLE IF EXISTS `DIRS`;
CREATE TABLE `DIRS` (
  `dir_pk` int(11) NOT NULL auto_increment,
  `directory` varchar(255) NOT NULL,
  `time` int(11) NOT NULL default '0',
  `TYPE` enum('FILESCAN','PDFIMPORT') NOT NULL default 'FILESCAN',
  `STATUS` enum('ACTIVE','INACTIVE') NOT NULL default 'ACTIVE',
  PRIMARY KEY  (`dir_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `CONSTANT`
--

DROP TABLE IF EXISTS `CONSTANT`;
CREATE TABLE `CONSTANT` (
  `const_pk` mediumint(9) NOT NULL auto_increment,
  `val` mediumint(9) NOT NULL default '0',
  `description` varchar(250) NOT NULL default '',
  `type` enum('ERRORMSG', 'LOGMSG', 'DBCONST') NOT NULL,
  PRIMARY KEY  (`const_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `CONSTANT`
--


/*!40000 ALTER TABLE `CONSTANT` DISABLE KEYS */;
LOCK TABLES `CONSTANT` WRITE;
INSERT INTO `CONSTANT` (val, description, type) VALUES (100,'Out of Memory','ERRORMSG'),(101,'Unknown System Event','ERRORMSG'),(102,'Server Crash','ERRORMSG'),(103,'No Such Record','ERRORMSG'),(105,'SQL Error','ERRORMSG'),(1001,'No Response File','ERRORMSG'),(1002,'Not Enough Data','ERRORMSG'),(1003,'Files Discontinuous','ERRORMSG'),(1004,'Internal FFT Error','ERRORMSG'),(1005,'PERIOD Mismatch','ERRORMSG'),(1006,'Error Reading File','ERRORMSG'),(1007,'File Does Not Exist','ERRORMSG'),(1101,'Problem reading hour.idx File','ERRORMSG'),(1102,'Problem reading HJJJ.bin File','ERRORMSG');
UNLOCK TABLES;
/*!40000 ALTER TABLE `CONSTANT` ENABLE KEYS */;

--
-- Table structure for table `EVENTQ`
--

DROP TABLE IF EXISTS `EVENTQ`;
CREATE TABLE `EVENTQ` (
  `evtq_id` mediumint(8) unsigned NOT NULL auto_increment,
  `type` mediumint(8) unsigned NOT NULL,
  `typeKey` mediumint(8) unsigned NOT NULL,
  `typeKey2` mediumint(8) unsigned NOT NULL default '0',
  `processed` enum('UNPROC','INPROC','PROCD') NOT NULL default 'UNPROC',
  `error_no` smallint(6) NOT NULL default '0',
  `user_fk` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`evtq_id`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `EVENTQ`
--

/*!40000 ALTER TABLE `EVENTQ` DISABLE KEYS */;
LOCK TABLES `EVENTQ` WRITE;
INSERT INTO `EVENTQ` (type, processed) VALUES (1000, 'PROCD');
UNLOCK TABLES;
/*!40000 ALTER TABLE `EVENTQ` ENABLE KEYS */;

--
-- Table structure for table `GLAP`
--

DROP TABLE IF EXISTS `GLAP`;
CREATE TABLE `GLAP` (
  `glap_pk` mediumint(9) NOT NULL auto_increment,
  `trc_fk` int(10) unsigned NOT NULL,
  `type` enum('GAP','OLAP') NOT NULL,
  `startPt` mediumint(8) unsigned NOT NULL,
  `endPt` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY  (`glap_pk`),
  KEY `trc_fk` (`trc_fk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `GLAP`
--


/*!40000 ALTER TABLE `GLAP` DISABLE KEYS */;
LOCK TABLES `GLAP` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `GLAP` ENABLE KEYS */;

--
-- Table structure for table `IDS`
--

DROP TABLE IF EXISTS `IDS`;
CREATE TABLE `IDS` (
  `IDS_PK` mediumint(9) unsigned NOT NULL auto_increment,
  `type` enum('NTW','STN','LOC','CHN') NOT NULL,
  `name` char(12) NOT NULL default '',
  `alias` char(25) default NULL,
  PRIMARY KEY  (`IDS_PK`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `IDS`
--


/*!40000 ALTER TABLE `IDS` DISABLE KEYS */;
LOCK TABLES `IDS` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `IDS` ENABLE KEYS */;

--
-- Table structure for table `LOG`
--

DROP TABLE IF EXISTS `LOG`;
CREATE TABLE `LOG` (
  `log_pk` int(11) NOT NULL,
  `user_fk` mediumint(8) unsigned default '0',
  `type_fk` mediumint(8) unsigned default '0',
  PRIMARY KEY  (`log_pk`),
  KEY `user_fk` (`user_fk`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='all system messages';

--
-- Dumping data for table `LOG`
--


/*!40000 ALTER TABLE `LOG` DISABLE KEYS */;
LOCK TABLES `LOG` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `LOG` ENABLE KEYS */;

--
-- Table structure for table `PSDCFG`
--

DROP TABLE IF EXISTS `PSDCFG`;
CREATE TABLE `PSDCFG` (
  `psdcfg_pk` int(11) NOT NULL auto_increment,
  `channel` char(2) NOT NULL,
  `description` varchar(255) NOT NULL,
  `minPower` int(11) NOT NULL default '0' COMMENT 'Minimum dB',
  `maxPower` int(11) NOT NULL default '0' COMMENT 'Maximum dB',
  `sections` int(11) NOT NULL default '0',
  `steps` int(11) NOT NULL default '0',
  `duration` int(11) NOT NULL default '0' COMMENT 'Duration of one PSD, in seconds',
  `dbOffset` int(11) NOT NULL default '0' COMMENT 'Added to db before output',
  `maxPeriod` decimal(12,6) NOT NULL default '0' COMMENT 'center period of smoothing bins',
  `binWidth` float NOT NULL default '0' COMMENT 'width of smoothing bins, fractional octave',
  `gapThresh` float NOT NULL default '0' COMMENT 'max allowed gap, in sample intervals',
  `units` char(4) NOT NULL default '' COMMENT 'Units of instrument response',
  `lastStage` int(11) NOT NULL default '-1' COMMENT 'Last Response Stage to Remove',
  `chni_fk` mediumint(9) NOT NULL,
  PRIMARY KEY  (`psdcfg_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='PSD Execution Config Parameters';

--
-- Dumping data for table `PSDCFG`
--


/*!40000 ALTER TABLE `PSDCFG` DISABLE KEYS */;
LOCK TABLES `PSDCFG` WRITE;
INSERT INTO `PSDCFG` (channel, description, minPower, maxPower, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, chni_fk) 
VALUES 
('LN','PSD Configuration for LN* Channels',-200,-50,4,4,10800,0,1000,1,-1,'ACC',-1,0),
('LH','PSD Configuration for LH* Channels',-200,-50,4,4,10800,0,1000,1,-1,'ACC',-1,0),
('BH','PSD Configuration for BH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('BL','PSD Configuration for BL* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('HG','PSD Configuration for HG* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('BG','PSD Configuration for BG* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('HH','PSD Configuration for HH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('SH','PSD Configuration for SH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('SN','PSD Configuration for SN* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('EH','PSD Configuration for EH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('EN','PSD Configuration for EN* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('EP','PSD Configuration for EP* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),
('HN','PSD Configuration for HN* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0),
('HG','PSD Configuration for HG* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0),
('HL','PSD Configuration for HL* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0),
('BN','PSD Configuration for BN* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `PSDCFG` ENABLE KEYS */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

DROP TABLE IF EXISTS `PDFIDX`;
CREATE TABLE `PDFIDX` (
  `pdf_pk` int(11) NOT NULL auto_increment,
  `pdfcfg_fk` int(10) NOT NULL,
  `chni_fk` mediumint(9) NOT NULL,
  `dayS` date NOT NULL,
  `dayE` date NOT NULL,
  PRIMARY KEY  (`pdf_pk`),
  KEY `chni_fk` (`chni_fk`, `pdf_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `PDFCFG`;
CREATE TABLE `PDFCFG` (
  `pdfcfg_pk` int(11) NOT NULL auto_increment,
  `name` char(15) NOT NULL,
  `description` varchar(100),
  PRIMARY KEY  (`pdfcfg_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `PDFCFG` DISABLE KEYS */;
LOCK TABLES `PDFCFG` WRITE;
INSERT INTO `PDFCFG` VALUES (1, "ALL", "ALL PSDs"), (3, "WEEK", "LAST WEEK OF AVAILABLE PSDs"), (2, "MONTH", "LAST MONTH OF AVAILABLE PSDs"), (4, "L MONTH", "LAST LAST MONTH OF AVAILABLE PSDs"), (5, "LL MONTH", "LAST LAST LAST MONTH OF AVAILABLE PSDs"), (6, "YEAR", "THIS YEAR OF AVAILABLE PSDs"), (7, "L YEAR", "LAST YEAR OF AVAILABLE PSDs");
UNLOCK TABLES;
/*!40000 ALTER TABLE `PDFCFG` ENABLE KEYS */;

--
-- Table structure for table `RESP`
--

DROP TABLE IF EXISTS `RESP`;
CREATE TABLE `RESP` (
  `resp_pk` mediumint(8) unsigned NOT NULL auto_increment,
  `chni_fk` mediumint(8) unsigned NOT NULL,
  `directory` varchar(1993) NOT NULL,
  `filename` varchar(55) NOT NULL default '',
  PRIMARY KEY  (`resp_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `RESP`
--


/*!40000 ALTER TABLE `RESP` DISABLE KEYS */;
LOCK TABLES `RESP` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `RESP` ENABLE KEYS */;

--
-- Table structure for table `SCAN`
--

DROP TABLE IF EXISTS `SCAN`;
CREATE TABLE `SCAN` (
  `scn_pk` int(11) NOT NULL auto_increment,
  `dir_fk` mediumint(8) unsigned NOT NULL,
  `time` int(11) NOT NULL default '0',
  `realTime` timestamp,
  `traces` mediumint(9) NOT NULL default '0',
  `responses` mediumint(9) NOT NULL default '0',
  `ntw` smallint(6) NOT NULL default '0',
  `stn` smallint(6) NOT NULL default '0',
  `loc` smallint(6) NOT NULL default '0',
  `chn` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`scn_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


/*!50003 SET @OLD_SQL_MODE=@@SQL_MODE*/;
DELIMITER ;;
/*!50003 SET SESSION SQL_MODE="NO_AUTO_VALUE_ON_ZERO" */;;
/*!50003 CREATE TRIGGER `DIRSUPD` BEFORE INSERT ON `SCAN` FOR EACH ROW
BEGIN
UPDATE DIRS D
SET D.time = NEW.time
WHERE D.dir_pk = NEW.dir_fk;
END */;;

DELIMITER ;
/*!50003 SET SESSION SQL_MODE=@OLD_SQL_MODE */;

--
-- Table structure for table `STATS_DAY`
--

DROP TABLE IF EXISTS `STATS_DAY`;
CREATE TABLE `STATS_DAY` (
  `day_pk` mediumint(9) unsigned NOT NULL auto_increment,
  `chni_fk` mediumint(9) unsigned default NULL,
  `year` smallint(6) unsigned default NULL,
  `day` smallint(6) unsigned default NULL,
  `gaps` mediumint(9) unsigned default NULL,
  `overlaps` mediumint(9) unsigned default NULL,
  `min` bigint(20) default NULL,
  `max` bigint(20) default NULL,
  PRIMARY KEY  (`day_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `STATS_DAY`
--


/*!40000 ALTER TABLE `STATS_DAY` DISABLE KEYS */;
LOCK TABLES `STATS_DAY` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `STATS_DAY` ENABLE KEYS */;

--
-- Table structure for table `TRC`
--

DROP TABLE IF EXISTS `TRC`;
CREATE TABLE `TRC` (
  `trc_pk` int(10) unsigned NOT NULL auto_increment,
  `chni_fk` mediumint(8) unsigned NOT NULL default '0',
  `format` enum('MSEED','SAC','AH','DR100','SEGY','NANO','DUMMY') NOT NULL default 'DUMMY',
  `directory` varchar(1993) NOT NULL default '',
  `filename` varchar(55) NOT NULL default '',
  `start` timestamp NOT NULL default '0000-00-00 00:00:00',
  `startM` mediumint(9) NOT NULL default '0',
  `end` timestamp NOT NULL default '0000-00-00 00:00:00',
  `endM` mediumint(9) NOT NULL default '0',
  `nsamps` mediumint(8) unsigned NOT NULL default '0',
  `gaps` mediumint(8) unsigned NOT NULL default '0',
  `olaps` mediumint(8) unsigned NOT NULL default '0',
  `max` double NOT NULL default '0',
  `min` double NOT NULL default '0',
  `mean` double NOT NULL default '0',
  `sRate` int(9) NOT NULL default '0',
  PRIMARY KEY  (`trc_pk`),
  KEY `chni_fk` (`chni_fk`,`start`,`end`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `TRC`
--


/*!40000 ALTER TABLE `TRC` DISABLE KEYS */;
LOCK TABLES `TRC` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `TRC` ENABLE KEYS */;


DELIMITER $$

DROP PROCEDURE IF EXISTS `EVENTQ_PSD1`$$
CREATE PROCEDURE `EVENTQ_PSD1` (IN EVTQ_ID INT)
BEGIN
	-- INSERT PSD1 EVENT TO EVENTQ IF PSDCFG EXISTS FOR CHNI
	DECLARE	TRC1 INT;
	DECLARE	CHNIFK INT;
	DECLARE PSDCFGFK INT;

	-- GET THE PSDCFG KEY FOR CHNI
	SELECT	P.PSDCFG_PK
	FROM	PSDCFG P, TRC T
	WHERE	T.TRC_PK = TRC1 AND
			P.CHNI_FK = T.CHNI_FK
	INTO	PSDCFGFK;

	IF (PSDCFGFK IS NOT NULL) THEN
		-- EXTRACT THE KEYS FROM THE EVENTQ TABLE
		SELECT	E.TYPEKEY 
		FROM	EVENTQ E 
		WHERE	E.EVTQ_ID = EVTQ_ID
		INTO	TRC1;
	
		SELECT	E.CHNI_FK 
		FROM	EVENTQ E 
		WHERE	E.EVTQ_ID = EVTQ_ID
		INTO	CHNIFK;

		INSERT INTO EVENTQ (TYPE, CHNI_FK, TYPEKEY) VALUES (2, CHNIFK, TRC1);
	END IF;

END$$

DELIMITER ;

DELIMITER $$

DROP PROCEDURE IF EXISTS `EVENTQ_PSD1A`$$
CREATE PROCEDURE `EVENTQ_PSD1A` (IN TRC_KEY INT)
BEGIN
	-- INSERT PSD EVENT (ENTIRE TRACE) TO EVENTQ IF PSDCFG EXISTS FOR CHNI
	DECLARE PSDCFGFK INT;
	DECLARE CHNIFK INT;

	-- GET THE PSDCFG KEY FOR CHNI
	SELECT	P.PSDCFG_PK
	FROM	PSDCFG P, TRC T
	WHERE	T.TRC_PK = TRC_KEY AND
			P.CHNI_FK = T.CHNI_FK
	INTO	PSDCFGFK;

	IF (PSDCFGFK IS NOT NULL) THEN
		INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2) VALUES (2, TRC_KEY, 0);
	END IF;

END$$

DELIMITER ;

DELIMITER $$

DROP PROCEDURE IF EXISTS `EVENTQ_PSD2`$$
CREATE PROCEDURE `EVENTQ_PSD2` (IN EVTQ_ID INT)
BEGIN
	-- INSERT PSD2 EVENT (OVERLAPPING PSD) TO EVENTQ IF NEXT TRACE (IN TIME) EXISTS
	-- AND PSD1 EVENT HAS COMPLETED FOR GIVEN EVENT
	DECLARE	TRC1 INT;
	DECLARE TRC2 INT;

	-- EXTRACT THE TRACE KEY FROM THE EVENTQ TABLE
	SELECT	E.TYPEKEY 
	FROM	EVENTQ E 
	WHERE	E.EVTQ_ID = EVTQ_ID
	INTO	TRC1;

	-- GET THE NEXT TRACE (IN TIME) KEY
	SELECT	T2.TRC_PK 
	FROM	TRC T1, TRC T2	
	WHERE	TRC1 = T1.TRC_PK AND 
			T1.END >= DATE_SUB(T2.START, INTERVAL '2' MINUTE) AND
			T1.END <= T2.START AND
			T1.CHNI_FK = T2.CHNI_FK
	INTO	TRC2;

	IF (TRC2 IS NOT NULL) THEN
		INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2) VALUES (3, TRC1, TRC2);
	END IF;

END$$

DELIMITER ;

DELIMITER $$

DROP PROCEDURE IF EXISTS `EVENTQ_PSD2A`$$
CREATE PROCEDURE `EVENTQ_PSD2A` (IN TRC_KEY INT)
BEGIN
	-- INSERT PSD2 EVENT (OVERLAPPING PSD) TO EVENTQ IF PREVIOUS TRACE (IN TIME) EXISTS
	-- AND TRC_KEY RECORD END IS BEFORE TODAY
	-- we do not want to insert this event for today's traces
	DECLARE TRC2 INT;
	DECLARE CHNIFK INT;

	-- GET THE PREV TRACE (IN TIME) KEY
	SELECT	T2.TRC_PK 
	FROM	TRC T1, TRC T2	
	WHERE	T1.TRC_PK = TRC_KEY AND 
			T1.CHNI_FK = T2.CHNI_FK AND
			T1.END < UTC_DATE()	AND
			T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND
			T1.START >= T2.END
	INTO	TRC2;

	IF (TRC2 IS NOT NULL) THEN
		INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2) VALUES (3, TRC2, TRC_KEY);
	END IF;

END$$

DELIMITER ;

/*!50003 SET @OLD_SQL_MODE=@@SQL_MODE*/;
DELIMITER ;;
/*!50003 SET SESSION SQL_MODE="" */;;
/*!50003 CREATE TRIGGER `TRC-DEL` AFTER DELETE ON `TRC` FOR EACH ROW
BEGIN
	-- when deleting a TRC record, must clean up some stuff

	-- delete any unprocessed events for this deleted trace file
	DELETE FROM	EVENTQ WHERE typeKey = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC';
	DELETE FROM	EVENTQ WHERE typeKey2 = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC';

	-- insert event 91 (PSDDEL) onto the EVENTQ for processing by the server for PSD channels
	IF ((SELECT count(*) FROM PSDCFG WHERE CHNI_FK = OLD.CHNI_FK) = 1) THEN
		INSERT INTO EVENTQ (type, typeKey, typeKey2) VALUES (91, OLD.TRC_PK, OLD.CHNI_FK);
	END IF;
	
END */;;

DELIMITER ;
/*!50003 SET SESSION SQL_MODE=@OLD_SQL_MODE */;


/*!50003 SET @OLD_SQL_MODE=@@SQL_MODE*/;
DELIMITER $$

DROP PROCEDURE IF EXISTS `spCHNIupd`$$
CREATE PROCEDURE `spCHNIupd` ()
BEGIN

	-- called once at end of server execution once all events have been processed
	UPDATE CHNI C
	SET 	
		C.STARTT = (SELECT MIN(T.START) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.ENDT = (SELECT MAX(T.END) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.GAPMAX = (SELECT MAX(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.GAPMIN = (SELECT MIN(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.GAPAVG = (SELECT AVG(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.OLAPMAX = (SELECT MAX(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.OLAPMIN = (SELECT MIN(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.OLAPAVG = (SELECT AVG(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.MAXMAX = (SELECT MAX(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.MAXMIN = (SELECT MIN(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.MAXAVG = (SELECT AVG(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.MINMAX = (SELECT MAX(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.MINMIN = (SELECT MIN(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.MINAVG = (SELECT AVG(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.MEANMAX = (SELECT MAX(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.MEANMIN = (SELECT MIN(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), 
		C.MEANAVG = (SELECT AVG(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),
		C.NTRACES = (SELECT COUNT(*) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0);

END$$

DELIMITER ;
/*!50003 SET SESSION SQL_MODE=@OLD_SQL_MODE */;

--
-- Table structure for table `USER`
--

DROP TABLE IF EXISTS `USER`;
CREATE TABLE `USER` (
  `user_pk` int(11) NOT NULL auto_increment,
  `name` varchar(25) NOT NULL default '',
  `type` enum('SRVR','CLNT') NOT NULL,
  `ip` char(15) character set latin1 NOT NULL default '',
  PRIMARY KEY  (`user_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='PQLX Users Table';

--
-- Dumping data for table `USER`
--


/*!40000 ALTER TABLE `USER` DISABLE KEYS */;
LOCK TABLES `USER` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `USER` ENABLE KEYS */;

--
-- Table structure for table `USER_LOG`
--

DROP TABLE IF EXISTS `USER_LOG`;
CREATE TABLE `USER_LOG` (
  `ulog_pk` mediumint(8) unsigned NOT NULL auto_increment,
  `user_fk` mediumint(8) unsigned NOT NULL default '0',
  `evt_type` enum('LOGIN','LOGOUT') NOT NULL,
  `dtime` timestamp not null default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ulog_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='User Log/History';

--
-- Dumping data for table `USER_LOG`
--


/*!40000 ALTER TABLE `USER_LOG` DISABLE KEYS */;
LOCK TABLES `USER_LOG` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `USER_LOG` ENABLE KEYS */;

--
-- Table structure for table `chn`
--

DROP TABLE IF EXISTS `chn`;
/*!50001 DROP VIEW IF EXISTS `chn`*/;
/*!50001 DROP TABLE IF EXISTS `chn`*/;
/*!50001 CREATE TABLE `chn` (
  `ids_pk` mediumint(9) unsigned,
  `type` varchar(3),
  `name` char(12),
  `alias` char(25)
) */;

--
-- Table structure for table `loc`
--

DROP TABLE IF EXISTS `loc`;
/*!50001 DROP VIEW IF EXISTS `loc`*/;
/*!50001 DROP TABLE IF EXISTS `loc`*/;
/*!50001 CREATE TABLE `loc` (
  `ids_pk` mediumint(9) unsigned,
  `type` varchar(3),
  `name` char(12),
  `alias` char(25)
) */;

--
-- Table structure for table `ns`
--

DROP TABLE IF EXISTS `ns`;
/*!50001 DROP VIEW IF EXISTS `ns`*/;
/*!50001 DROP TABLE IF EXISTS `ns`*/;
/*!50001 CREATE TABLE `ns` (
  `ntw` char(12),
  `stn` char(12)
) */;

--
-- Table structure for table `nslc`
--

DROP TABLE IF EXISTS `nslc`;
/*!50001 DROP VIEW IF EXISTS `nslc`*/;
/*!50001 DROP TABLE IF EXISTS `nslc`*/;
/*!50001 CREATE TABLE `nslc` (
  `ntw` char(12),
  `ntw_FK` mediumint(9) unsigned,
  `stn` char(12),
  `stn_fk` mediumint(9) unsigned,
  `loc` char(12),
  `loc_fk` mediumint(9) unsigned,
  `chn` char(12),
  `chni_pk` mediumint(9)
) */;

--
-- Table structure for table `ntw`
--

DROP TABLE IF EXISTS `ntw`;
/*!50001 DROP VIEW IF EXISTS `ntw`*/;
/*!50001 DROP TABLE IF EXISTS `ntw`*/;
/*!50001 CREATE TABLE `ntw` (
  `ids_pk` mediumint(9) unsigned,
  `type` varchar(3),
  `name` char(12),
  `alias` char(25)
) */;

--
-- Table structure for table `stn`
--

DROP TABLE IF EXISTS `stn`;
/*!50001 DROP VIEW IF EXISTS `stn`*/;
/*!50001 DROP TABLE IF EXISTS `stn`*/;
/*!50001 CREATE TABLE `stn` (
  `ids_pk` mediumint(9) unsigned,
  `type` varchar(3),
  `name` char(12),
  `alias` char(25)
) */;

--
-- View structure for view `chn`
--

/*!50001 DROP TABLE IF EXISTS `chn`*/;
/*!50001 DROP VIEW IF EXISTS `chn`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `chn` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'CHN' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'chn')*/;

--
-- View structure for view `loc`
--

/*!50001 DROP TABLE IF EXISTS `loc`*/;
/*!50001 DROP VIEW IF EXISTS `loc`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `loc` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'LOC' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'loc')*/;

--
-- View structure for view `ns`
--

/*!50001 DROP TABLE IF EXISTS `ns`*/;
/*!50001 DROP VIEW IF EXISTS `ns`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `ns` AS select `ntw`.`name` AS `ntw`,`stn`.`name` AS `stn` from ((`ntw` join `stn`) join `CHNI`) where ((`CHNI`.`NTW_FK` = `ntw`.`ids_pk`) and (`CHNI`.`STN_FK` = `stn`.`ids_pk`))*/;

--
-- View structure for view `nslc`
--

/*!50001 DROP TABLE IF EXISTS `nslc`*/;
/*!50001 DROP VIEW IF EXISTS `nslc`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `nslc` AS select `i1`.`name` AS `ntw`,`CHNI`.`NTW_FK` AS `ntw_FK`,`i2`.`name` AS `stn`,`CHNI`.`STN_FK` AS `stn_fk`,`i3`.`name` AS `loc`,`CHNI`.`LOC_FK` AS `loc_fk`,`i4`.`name` AS `chn`,`CHNI`.`chni_pk` AS `chni_pk` from ((((`CHNI` join `IDS` `i1`) join `IDS` `i2`) join `IDS` `i3`) join `IDS` `i4`) where ((`i1`.`type` = _latin1'ntw') and (`i1`.`IDS_PK` = `CHNI`.`NTW_FK`) and (`i2`.`type` = _latin1'stn') and (`i2`.`IDS_PK` = `CHNI`.`STN_FK`) and (`i3`.`type` = _latin1'loc') and (`i3`.`IDS_PK` = `CHNI`.`LOC_FK`) and (`i4`.`type` = _latin1'chn') and (`i4`.`IDS_PK` = `CHNI`.`CHN_FK`)) order by `i1`.`name`,`i2`.`name`,`i3`.`name`,`i4`.`name`*/;

--
-- View structure for view `ntw`
--

/*!50001 DROP TABLE IF EXISTS `ntw`*/;
/*!50001 DROP VIEW IF EXISTS `ntw`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `ntw` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'ntw' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'ntw')*/;

--
-- View structure for view `stn`
--

/*!50001 DROP TABLE IF EXISTS `stn`*/;
/*!50001 DROP VIEW IF EXISTS `stn`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `stn` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'STN' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'stn')*/;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

DELIMITER $$

DROP PROCEDURE IF EXISTS `spRegUser`$$
CREATE PROCEDURE `spRegUser` (	IN UNAME VARCHAR(25), 
								IN UIP VARCHAR(25), 
								IN ETYP VARCHAR(6), 
								IN UTYP VARCHAR(6))
BEGIN

	-- register user LOGIN and LOGOUT events
	DECLARE USERPK INT;

	-- Has user ever before logged in?
	SELECT	user_pk
	FROM	`USER` 
	WHERE	name = UNAME and
			ip = UIP and
			type = UTYP
	INTO	USERPK;

	-- If not, then make a new user
	IF (USERPK IS NULL) THEN
		INSERT INTO `USER` (name, ip, type) VALUES (UNAME, UIP, UTYP) ;

		SELECT	user_pk
		FROM	`USER` 
		WHERE	name = UNAME and
				ip = UIP and
				type = UTYP
	INTO	USERPK;
	END IF;

	-- and log their existence
	INSERT INTO USER_LOG (user_fk, evt_type) VALUES (USERPK, ETYP);
	
END$$

DELIMITER ;

DELIMITER $$

DROP PROCEDURE IF EXISTS `spNextEvent`$$
CREATE PROCEDURE `spNextEvent` ()
BEGIN

	-- get the next available event and mark as INPROC
	DECLARE	EVENT_PK	INT;
	DECLARE	SQLCMD		VARCHAR(100);

	SELECT	EVTQ_ID
	FROM	EVENTQ
	WHERE	PROCESSED = 'UNPROC'
	ORDER BY TYPE
	LIMIT	1
	INTO	EVENT_PK;

	IF (EVENT_PK IS NOT NULL) THEN
		UPDATE EVENTQ SET PROCESSED = 'INPROC' WHERE evtq_id = EVENT_PK;
		SELECT evtq_id, TYPE, TYPEKEY, TYPEKEY2 FROM EVENTQ WHERE evtq_id = EVENT_PK;
	ELSE
		SELECT 0, 0, 0, 0;
	END IF;

END$$

-- DELIMITER ;
-- 
-- /*!50003 SET @OLD_SQL_MODE=@@SQL_MODE*/;
-- DELIMITER ;;
-- /*!50003 SET SESSION SQL_MODE="NO_AUTO_VALUE_ON_ZERO" */;;
-- /*!50003 CREATE TRIGGER `NEWRESPONSEFILE` AFTER DELETE ON `RESP` FOR EACH ROW
-- BEGIN
-- 
-- 	-- new response file being inserted, make event to deal with it
-- 	INSERT INTO EVENTQ (type, typeKey)
-- 	SELECT 10, OLD.resp_pk;
-- 	
-- END */;;
-- 
-- DELIMITER ;
-- /*!50003 SET SESSION SQL_MODE=@OLD_SQL_MODE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

