#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
#include "db_admin_sql.h"
static char *msgTypes[2] = {"LOG", "ERROR"};
static int stripDirs(MYSQL *conn, SQLDI *sqldi, char *dbName)
{ 
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_DD_STRIP,
dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
}
return (ret);
}
static gboolean isLastMsg(char *msg)
{ 
gboolean last;
int pos;
pos = strlen(msg) - strlen(PQLXENDEDMSG);
if (pos < 1)
{ 
last = FALSE;
}
else
{ 
last = !(strncmp(&msg[pos], PQLXENDEDMSG, strlen(PQLXENDEDMSG)));
}
return last;
}
static gint logSort(LOGMSG *log1, LOGMSG *log2)
{
return (log1->keys.logKey - log2->keys.logKey);
}
static void makeBothLogs(SRVRLOG *srvrLog)
{ 
GSList *log, *err;
if (srvrLog->data.msgs[MSGTYPE_BOTH])
g_slist_free(srvrLog->data.msgs[MSGTYPE_BOTH]);
srvrLog->data.msgs[MSGTYPE_BOTH] = NULL;
log = g_slist_copy(srvrLog->data.msgs[MSGTYPE_LOG]);
err = g_slist_copy(srvrLog->data.msgs[MSGTYPE_ERR]);
srvrLog->data.msgs[MSGTYPE_BOTH] = g_slist_concat(log, err);
srvrLog->data.msgs[MSGTYPE_BOTH] = g_slist_sort(srvrLog->data.msgs[MSGTYPE_BOTH], (GCompareFunc)logSort);
}
static int newPSDdata(MYSQL *conn, PSDCONF *psdConf, my_ulonglong psdcfg_pk)
{
int  chnKey, ret = PQLXSUCCESS;
GSList *chans=NULL, *chanIter;
char *sqlStr;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
sqlStr = g_strdup(SQL_ADMIN_PSDCFG_CHANS);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
chans = g_slist_prepend(chans, GINT_TO_POINTER(atoi(row[0])));
}
mysql_free_result(res_set); res_set=NULL;
for (chanIter = chans; chanIter ; chanIter = g_slist_next(chanIter))
{
chnKey = GPOINTER_TO_INT(chanIter->data);
sqlStr = g_strdup_printf(SQL_ADMIN_PSDCFG_NEW_CHANS, 
chnKey, (int) psdcfg_pk);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
PSDTblProc(conn, chnKey);
sqlStr = g_strdup_printf(SQL_ADMIN_PSDCFG_PSDEVT, 
PSD1evt, "UNPROC", chnKey, chnKey);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_ADMIN_PSDCFG_SYSPDF, 
SYSPDF, chnKey, "NOPROC", chnKey);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
}
g_slist_free(chans);
return ret;
}
int db_admin(SQLDI *sqldi)
{
int  ret=PQLXSUCCESS;
gchar *sqlStr;
MYSQL *conn = mngDBConn(sqldi, GETDBCONN);
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
switch(sqldi->descr.tableData)
{
case LOGNEXTEXEC:
{ 
NEWEXEC *newExec = sqldi->data;
sqlStr = g_strdup_printf(SQL_LOGEXEC_NEXT, newExec->keys.lastExec);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
newExec->data.started = (gboolean) atoi(row[0]); 
mysql_free_result(res_set); res_set=NULL;
}
break;
case LOGEXECTBL:
{ 
SRVREXEC *srvrExec = sqldi->data;
SRVRLOG  *srvrLog;
sqlStr = g_strdup(SQL_LOGEXEC_GET);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
srvrLog = calloc(1, sizeof(SRVRLOG));
srvrLog->keys.execKey = atoi(row[0]);
srvrLog->data.pgmName = g_strdup(row[1]);
srvrLog->data.time[STARTTIME] = g_strdup(row[2]);
srvrLog->data.time[ENDTIME] = g_strdup(row[3]);
srvrLog->data.duration = g_strdup(row[4]);
srvrLog->data.complete = TRUE;
srvrExec->data.execs = g_slist_prepend(srvrExec->data.execs, srvrLog);
}
mysql_free_result(res_set); res_set=NULL;
srvrLog = g_slist_nth_data(srvrExec->data.execs, 0);
if (!srvrLog)
break;
sqlStr = g_strdup_printf(SQL_LOGMSG_GETLAST,
srvrLog->keys.execKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
if((row=mysql_fetch_row(res_set)))
{
char *msg = row[0];
srvrLog->data.complete = isLastMsg(msg);
}
mysql_free_result(res_set); res_set=NULL;
}
break;
case LOGEXECUPD:
{ 
SRVRLOG *srvrLog = sqldi->data;
sqlStr = g_strdup_printf(SQL_LOGEXEC_UPD, srvrLog->keys.execKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
srvrLog->data.time[ENDTIME] = g_strdup(row[0]); 
srvrLog->data.duration = g_strdup(row[1]); 
mysql_free_result(res_set); res_set=NULL;
}
break;
case LOGMSGTBL:
{ 
int  i, type;
SRVRLOG *srvrLog = sqldi->data;
LOGMSG *lastLog;
for (i=0;i<TTLSRVRLOGTYPES-1;i++)
{
srvrLog->data.updated[i] = FALSE;
sqlStr = g_strdup_printf(SQL_LOGMSG_GET, 
srvrLog->keys.execKey,
msgTypes[i]);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
LOGMSG *logMsg = calloc(1, sizeof(LOGMSG));
type = atoi(row[0]);
logMsg->data.type = (type == MSGTYPE_LOG ? type : MSGTYPE_ERR);
logMsg->data.time = g_strdup(row[1]);
logMsg->data.msg = g_strdup(row[2]);
logMsg->keys.logKey = atoi(row[3]);
srvrLog->data.msgs[i] = g_slist_prepend(srvrLog->data.msgs[i], logMsg);
}
mysql_free_result(res_set); res_set=NULL;
}
makeBothLogs(srvrLog);
srvrLog->keys.lastLog = srvrLog->data.msgs[MSGTYPE_BOTH] 
? g_slist_last(srvrLog->data.msgs[MSGTYPE_BOTH])->data
: NULL;
lastLog = srvrLog->data.msgs[MSGTYPE_LOG]
? g_slist_last(srvrLog->data.msgs[MSGTYPE_LOG])->data
: NULL;
srvrLog->data.complete = lastLog 
? isLastMsg(lastLog->data.msg)
: TRUE;
}
break;
case LOGMSGTBLNEXT:
{ 
int  i, type;
SRVRLOG *srvrLog = sqldi->data;
LOGMSG *logMsg, *lastLog = srvrLog->keys.lastLog;
gboolean updated = FALSE;
for (i=0;i<TTLSRVRLOGTYPES-1;i++)
{
srvrLog->data.updated[i] = FALSE;
sqlStr = g_strdup_printf(SQL_LOGMSG_NEXT, 
srvrLog->keys.execKey,
lastLog->keys.logKey,
msgTypes[i]);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
logMsg = calloc(1, sizeof(LOGMSG));
type = atoi(row[0]);
logMsg->data.type = (type == MSGTYPE_LOG ? type : MSGTYPE_ERR);
logMsg->data.time = g_strdup(row[1]);
logMsg->data.msg = g_strdup(row[2]);
logMsg->keys.logKey = atoi(row[3]);
srvrLog->data.msgs[i] = g_slist_append(srvrLog->data.msgs[i], logMsg);
updated = srvrLog->data.updated[i] = TRUE;
}
mysql_free_result(res_set); res_set=NULL;
}
if (updated)
{
makeBothLogs(srvrLog);
srvrLog->keys.lastLog = g_slist_last(srvrLog->data.msgs[MSGTYPE_BOTH])->data;
}
if (!srvrLog->data.msgs[MSGTYPE_LOG])
break;
lastLog = g_slist_last(srvrLog->data.msgs[MSGTYPE_LOG])->data;
if (!lastLog)
break;
srvrLog->data.complete = isLastMsg(lastLog->data.msg);
}
break;
case ADMIN_EVENTQ:
{
EVENTQLIST *eventQ = sqldi->data;
EQREC *eqRec;
GSList *iter;
if (eventQ->events)
{
for (iter = eventQ->events;
iter;
iter = g_slist_next(iter))
{
eqRec = iter->data;
free(eqRec->descr);
free(eqRec->error);
}
g_slist_free(eventQ->events);
eventQ->events = NULL;
}
sqlStr = g_strdup_printf(SQL_ADMIN_EVENTQ, 
dbName, dbName, dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
eqRec = calloc(1, sizeof(EQREC));
eqRec->count = atoi(row[0]);
eqRec->descr = g_strdup(row[1]);
eqRec->status = atoi(row[2]);
eqRec->error = g_strdup(row[3]);
eventQ->events = g_slist_prepend(eventQ->events, eqRec);
}
mysql_free_result(res_set); res_set=NULL;
bug15752(conn);
}
break;
case ADMIN_DBDEL:
{
DBLST *dbListing = sqldi->data;
fprintf(stdout, "Deleting PQLX DB '%s'\n", dbListing->dbName);
sqlStr = g_strdup_printf(SQL_ADMIN_DB_DELETE,
dbListing->dbName, dbListing->dbName, 
dbListing->dbName, dbListing->dbName, 
dbListing->dbName);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
fprintf(stdout, "Deletion Successful\n");
free(dbName);
dbName = NULL;
}
break;
case ADMIN_DBCREATE:
{
int  i, numStrings = sizeof(dbStrings)/sizeof(char*);
DBDEF *dbInfo = sqldi->data;
DBLST *dbListing = &dbInfo->dbListing;
PNGWWW *pngWWW, *pdfWWW;
DATADIR *dataDir;
GSList *ddIter, *wwwIter;
char *name = getUserName();
dbName = g_strdup(dbListing->dbName);
fprintf(stdout, "Creating PQLX DB '%s'\n", dbListing->dbName);
sqlStr = g_strdup_printf(SQL_ADMIN_DB_MAKE,
dbListing->dbName, dbListing->dbName, dbListing->dbName);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
for (i=0; i< numStrings; i++)
{
sqlStr = g_strdup_printf(SQL_ADMIN_DB_CREATE,
dbListing->dbName, dbStrings[i]);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
if (i != numStrings)
break;
for (ddIter=dbInfo->dataDirs;
ddIter;
ddIter = g_slist_next(ddIter))
{
dataDir = ddIter->data;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_DD_INSERT,
dbListing->dbName,
dataDir->directory, 
dataDir->statusI);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
stripDirs(conn, sqldi, dbListing->dbName);
sqlStr = g_strdup_printf(SQL_ADMIN_DB_META_MAKE,
dbListing->dbName,
dbListing->organisation,
dbListing->description,
dbListing->techAdminName,
dbListing->techAdminEmail,
dbListing->dataAdminName,
dbListing->dataAdminEmail,
dbListing->typeI+1,
dbListing->accessI+1,
name,
dbListing->adminPWord,
dbListing->hint);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
free(name);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
{ 
SQLDI sqldiL;
LOGIN login;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&login, 0, sizeof(LOGIN));
sqldiL.args.dataEvent = DBUPGRADE;
sqldiL.data = &login;
login.data.dbVersion = 0;
ret = db_upgrade(&sqldiL);
if (ret != PQLXSUCCESS)
break;
}
for (wwwIter = dbInfo->pngWWW;
wwwIter;
wwwIter = g_slist_next(wwwIter))
{
pngWWW = wwwIter->data;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PNG,
dbListing->dbName,
pngWWW->width, pngWWW->height, pngWWW->border+1,
pngWWW->r, pngWWW->g, pngWWW->b,
pngWWW->Iwidth, pngWWW->Iheight, pngWWW->Iborder+1,
pngWWW->Ir, pngWWW->Ig, pngWWW->Ib,
pngWWW->dir, pngWWW->type);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
if (pngWWW->type == SYSPDFPNG)
pdfWWW = pngWWW;
}
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PNGSTATS,
dbListing->dbName, 
pdfWWW->stats[PDFSTAT_MIN]+1, pdfWWW->stats[PDFSTAT_MAX]+1,
pdfWWW->stats[PDFSTAT_MODE]+1, pdfWWW->stats[PDFSTAT_MEDIAN]+1,
pdfWWW->stats[PDFSTAT_MEAN]+1, pdfWWW->stats[PDFSTAT_P5]+1,
pdfWWW->stats[PDFSTAT_P10]+1, pdfWWW->stats[PDFSTAT_P25]+1,
pdfWWW->stats[PDFSTAT_P75]+1, pdfWWW->stats[PDFSTAT_P90]+1,
pdfWWW->stats[PDFSTAT_P95]+1, pdfWWW->HLNM+1, pdfWWW->dateFmt);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
fprintf(stdout, "PQLX DB Creation Successful\n");
ret = PQLXSUCCESS;
}
break;
case ADMIN_DBSAVE:
{
DBDEF *dbInfo = sqldi->data;
DBLST *dbListing = &dbInfo->dbListing;
PNGWWW *pngWWW, *pdfWWW;
DATADIR *dataDir;
PSDCONF *psdConf;
GSList *ddIter, *wwwIter, *psdIter, *psdConfs;
gboolean newPSDCFGfollowup = FALSE;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_META_UPD,
dbListing->organisation,
dbListing->description,
dbListing->techAdminName,
dbListing->techAdminEmail,
dbListing->dataAdminName,
dbListing->dataAdminEmail,
dbListing->typeI+1,
dbListing->accessI+1,
dbListing->adminPWord,
dbListing->dbName);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
for (ddIter = dbInfo->dataDirs;
ddIter;
ddIter = g_slist_next(ddIter))
{
dataDir = ddIter->data;
switch(dataDir->admin.cmdFlag)
{
case DU_NONE:
continue;
break;
case DU_NEW:
sqlStr = g_strdup_printf(SQL_ADMIN_DB_DD_INSERT,
dbListing->dbName,
dataDir->directory, 
dataDir->statusI+1);
break;
case DU_UPD:
sqlStr = g_strdup_printf(SQL_ADMIN_DB_DD_UPD,
dbListing->dbName,
dataDir->statusI+1,
dataDir->directory);
break;
}
dataDir->admin.cmdFlag = DU_NONE;
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
stripDirs(conn, sqldi, dbListing->dbName);
psdConfs = NULL;
for (psdIter = dbInfo->psdConfs;
psdIter;
psdIter = g_slist_next(psdIter))
{
psdConf = psdIter->data;
switch(psdConf->admin.cmdFlag)
{
case DU_NONE:
continue;
break;
case DU_NEW:
{
char *descr = g_strdup_printf("PSD Configuration for %s* Channels",
psdConf->chnGroup);
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PSD_INSERT,
dbName,
psdConf->chnGroup,
psdConf->min_power,
psdConf->max_power,
psdConf->psd_dur,
psdConf->max_period,
psdConf->type,
psdConf->overlap,
descr);
free(descr);
newPSDCFGfollowup = TRUE;
}
break;
case DU_UPD:
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PSD_UPD,
dbName,
psdConf->min_power,
psdConf->max_power,
psdConf->psd_dur,
psdConf->max_period,
psdConf->type,
psdConf->overlap,
psdConf->chnGroup);
psdConfs = g_slist_prepend(psdConfs, psdIter);  
break;
}
psdConf->admin.cmdFlag = DU_NONE;
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
bug15752(conn);     
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
if (newPSDCFGfollowup)
{
my_ulonglong psdcfg_pk = mysql_insert_id(conn);
bug15752(conn);
newPSDdata(conn, psdConf, psdcfg_pk);
newPSDCFGfollowup = FALSE;
}
}
for (psdIter = psdConfs;
psdIter;
psdIter = g_slist_next(psdIter))
{
int  chnKey;
GSList *chnList = NULL, *chnListIter;
psdConf = psdIter->data;
if (!psdConf->admin.data)  
continue;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PSD_CHNLIST,
dbListing->dbName,
psdConf->chnGroup);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
chnList = g_slist_prepend(chnList, GINT_TO_POINTER(atoi(row[0])));
}
mysql_free_result(res_set);  res_set = NULL;
for (chnListIter = chnList;
chnListIter;
chnListIter = g_slist_next(chnListIter))
{
chnKey = GPOINTER_TO_INT(chnListIter->data);
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PSD_DEL,
dbListing->dbName, chnKey,
dbListing->dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PSD_PSD1,
dbListing->dbName, PSD1evt, chnKey, chnKey,
dbListing->dbName, SYSPDF, chnKey,
dbListing->dbName, SYSPDF, chnKey, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
g_slist_free(chnList);  chnList = NULL;
}
g_slist_free(psdConfs);
for (wwwIter = dbInfo->pngWWW;
wwwIter;
wwwIter = g_slist_next(wwwIter))
{
pngWWW = wwwIter->data;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PNG,
dbListing->dbName,
pngWWW->width, pngWWW->height, pngWWW->border+1,
pngWWW->r, pngWWW->g, pngWWW->b,
pngWWW->Iwidth, pngWWW->Iheight, pngWWW->Iborder+1,
pngWWW->Ir, pngWWW->Ig, pngWWW->Ib,
pngWWW->dir, pngWWW->type);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
if (pngWWW->type == SYSPDFPNG)
pdfWWW = pngWWW;
}
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PNGSTATS,
dbListing->dbName, 
pdfWWW->stats[PDFSTAT_MIN]+1, pdfWWW->stats[PDFSTAT_MAX]+1,
pdfWWW->stats[PDFSTAT_MODE]+1, pdfWWW->stats[PDFSTAT_MEDIAN]+1,
pdfWWW->stats[PDFSTAT_MEAN]+1, pdfWWW->stats[PDFSTAT_P5]+1,
pdfWWW->stats[PDFSTAT_P10]+1, pdfWWW->stats[PDFSTAT_P25]+1,
pdfWWW->stats[PDFSTAT_P75]+1, pdfWWW->stats[PDFSTAT_P90]+1,
pdfWWW->stats[PDFSTAT_P95]+1, pdfWWW->HLNM+1, pdfWWW->dateFmt);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
break;
case SYSPDFREFRESH:
{ 
sqlStr = g_strdup_printf(SQL_ADMIN_PDFREFRESH,
SPSE, SPSE,
SYSPDF, SYSPDF);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
}
break;
case ADMIN_CHNINFO:
{ 
DBDEF *dbInfo = sqldi->data;
CHNSTATS *chnStats;
GSList *iter;
for (iter = dbInfo->chnInfo;
iter;
iter = g_slist_next(iter))
{
chnStats = iter->data;
free(chnStats->name);
free(chnStats->dataDate[STARTTIME]);
free(chnStats->dataDate[ENDTIME]);
free(chnStats->response);
free(chnStats);
}
g_slist_free(dbInfo->chnInfo);
dbInfo->chnInfo = NULL;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_CHNINFO);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
chnStats = calloc(1, sizeof(CHNSTATS));
chnStats->name = g_strdup(row[0]);
chnStats->dataDate[STARTTIME] = g_strdup(row[1]);
chnStats->dataDate[ENDTIME] = g_strdup(row[2]);
chnStats->nTrace = atoi(row[3]);
chnStats->nPSD = atoi(row[4]);
chnStats->chnKey = atoi(row[5]);
chnStats->nSPSepoch = atoi(row[6]);
chnStats->response = g_strdup(row[7]);
dbInfo->chnInfo = g_slist_prepend(dbInfo->chnInfo, chnStats);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case ADMIN_DDINFO:
{ 
DBDEF *dbInfo = sqldi->data;
DATADIR *dataDir;
GSList *iter;
for (iter = dbInfo->dataDirs;
iter;
iter = g_slist_next(iter))
{
dataDir = iter->data;
free(dataDir->directory);
free(dataDir->lastFile);
free(dataDir->status);
free(dataDir);
}
g_slist_free(dbInfo->dataDirs);
dbInfo->dataDirs = NULL;
sqlStr = g_strdup_printf(SQL_DIRS_GETALL,
dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
dataDir = calloc(1, sizeof(DATADIR));
dataDir->pk = atoi(row[0]);
dataDir->directory = g_strdup(row[1]);
dataDir->lastFile = g_strdup(row[2]);
dataDir->status = g_strdup(row[3]);
dataDir->statusI = (!strcmp(row[3], "ACTIVE")) ? ACTIVE : INACTIVE;
dataDir->ttlTrace = atoi(row[4]);
dataDir->ttlResp = atoi(row[5]);
dataDir->admin.cmdFlag = DU_NONE;
dbInfo->dataDirs = g_slist_prepend(dbInfo->dataDirs, dataDir);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case ADMIN_DBINFO:
{ 
SQLDI sqldiL;
DBDEF *dbInfo = sqldi->data;
DBLST *dbListing = &dbInfo->dbListing;
SRVREXEC *srvrExec = &dbInfo->srvrExec;
CHNSTATS *chnStats;
SPSEPOCH *spsEpoch;
PSDCONF *psdConf;
GSList *iter;
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.data = dbListing;
sqldiL.descr.tableData = DBLISTING;
getData(conn, &sqldiL);
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.data = &dbInfo->pngWWW;
sqldiL.descr.tableData = PNGWWWDEF;
getData(conn, &sqldiL);
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = ADMIN_DDINFO;
sqldiL.data = dbInfo;
db_admin(&sqldiL);
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = ADMIN_CHNINFO;
sqldiL.data = dbInfo;
db_admin(&sqldiL);
sqlStr = g_strdup(SQL_ADMIN_DB_PSD_GET);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
psdConf = calloc(1, sizeof(PSDCONF));
psdConf->chnGroup = g_strdup(row[0]);
psdConf->min_power = atoi(row[1]);
psdConf->max_power = atoi(row[2]);
psdConf->psd_dur = atoi(row[3]);
psdConf->max_period = atoi(row[4]);
psdConf->type = atoi(row[5]);
psdConf->overlap = atoi(row[6]);
psdConf->admin.cmdFlag = DU_NONE;
dbInfo->psdConfs = g_slist_prepend(dbInfo->psdConfs, psdConf);
}
mysql_free_result(res_set); res_set = NULL;
dbInfo->psdConfs = g_slist_reverse(dbInfo->psdConfs);
for (iter = dbInfo->psdConfs;
iter;
iter = g_slist_next(iter))
{
psdConf = iter->data;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_PSD_CNT, psdConf->chnGroup);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
psdConf->admin.data = (atoi(row[0]) == 0) ? FALSE : TRUE;
mysql_free_result(res_set); res_set = NULL;
}
for(iter=dbInfo->chnInfo;
iter;
iter = g_slist_next(iter))
{
chnStats = iter->data;
if (!chnStats->nSPSepoch)
continue;
sqlStr = g_strdup_printf(SQL_ADMIN_DB_SPSEPOCH,
chnStats->chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
spsEpoch = calloc(1, sizeof(SPSEPOCH));
spsEpoch->sampInt = atoi(row[0]);
spsEpoch->dates[STARTTIME] = g_strdup(row[1]);
spsEpoch->dates[ENDTIME] = g_strdup(row[2]);
chnStats->spsEpochs = g_slist_prepend(chnStats->spsEpochs, spsEpoch);
}
mysql_free_result(res_set); res_set = NULL;
}
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.data = srvrExec;
sqldiL.descr.tableData = LOGEXECTBL;
db_admin(&sqldiL);
}
break;
case ADMIN_REPSD:
{
REPSD *rePSD = sqldi->data;
GSList *channels = rePSD->channels, *iter;
CHNSTATS *chnData;
GDate *startDt = rePSD->dtBounds[STARTDT], *endDt = rePSD->dtBounds[ENDDT];
int  chn, evtq_id, i;
char *startD, *endD;
startD = g_strdup_printf("%d-%d-%d", g_date_get_year(startDt), g_date_get_month(startDt), g_date_get_day(startDt));
endD = g_strdup_printf("%d-%d-%d", g_date_get_year(endDt), g_date_get_month(endDt), g_date_get_day(endDt));
for (iter = channels;
iter;
iter = g_slist_next(iter))
{
chnData = iter->data;
chn = chnData->chnKey;
sqlStr = g_strdup_printf(SQL_ADMIN_REPSD1A,
PSDDELDTE, chn, chn);
ret = db_exec_sql(conn, sqlStr);
evtq_id = mysql_insert_id(conn);
bug15752(conn); 
sqlStr = g_strdup_printf(SQL_ADMIN_REPSD1B,
evtq_id, startD, endD);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_ADMIN_REPSD2,
PSD1evt, chn,
startD, endD);
ret = db_exec_sql(conn, sqlStr); bug15752(conn); 
sqlStr = g_strdup_printf(SQL_ADMIN_REPSD3,
PSD1evt, chn, chn,
startD, endD);
ret = db_exec_sql(conn, sqlStr); bug15752(conn); 
sqlStr = g_strdup_printf(SQL_ADMIN_REPSD4,
SYSPDF, chn,
SYSPDF, chn, chn);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
free(startD); free(endD);
for (i=0; i<TTLDATES; i++)
g_date_free(rePSD->dtBounds[i]);
g_slist_free(rePSD->channels); rePSD->channels = NULL;
{ 
SQLDI sqldiL;
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = PSDDELDATE;
_db_system(conn, &sqldiL);
}
}
break;
}
if (ret == FAILURE)
{
switch(sqldi->descr.tableData)
{
case ADMIN_DBCREATE:
{ 
SQLDI sqldiD;
memset(&sqldiD, 0, sizeof(SQLDI));
sqldiD.descr.tableData = ADMIN_DBDEL;
sqldiD.data = sqldi->data;
db_admin(&sqldiD);
}
break;
}
}
return ret;
}
