#include <mysql.h>
#include <glib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
static int regUser(SQLDI *sqldi)
{
MYSQL *conn = mngDBConn(sqldi, GETDBCONN);
char *sqlStr;
int  ret;
getUIP();
sqlStr = g_strdup_printf(SQL_USER_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
return ret;
}
sqlStr = g_strdup_printf(SQL_REG_USER, 
myuname, 
myipaddr, 
eTypes[LOGINEVT], 
uTypes[myutype]);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
}
else
ret = PQLXSUCCESS;
sqlStr = g_strdup_printf(SQL_USER_UNLOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
}
return (ret);
}
static int _db_request(SQLDI *sqldi)
{
int ret = FAILURE;
gboolean releaseConn=TRUE;
switch(sqldi->args.dataEvent)
{
case CONNECT:
ret = db_conn(sqldi->args.dataEvent, sqldi);
if (ret != PQLXSUCCESS)
break;
if (!strcmp(dbName, PQLXMETADB))
break;
sqldi->args.dataEvent = INIT;
ret = db_data(sqldi);
if (ret != PQLXSUCCESS)
break;
ret = regUser(sqldi);
if (ret != PQLXSUCCESS)
break;
break;
case DISCONNECT:   
case DBMAINTRUNNING:  
ret = db_conn(sqldi->args.dataEvent, sqldi);
break;
case EVENTQ:  
ret = db_event(sqldi);
break;
case GET_DATA:
case INSERT_DATA:
case UPDATE_DATA: 
ret = db_data(sqldi);
break;
case METADATA:  
ret = db_conn(METADATA, sqldi);
break;
case SYSTEM_DATA: 
ret = db_system(sqldi);
break;
case DBUPGRADE:
ret = db_upgrade(sqldi);
break;
case DBMAINTAIN:
ret = db_maintain(sqldi);
break;
case DBADMIN:
ret = db_admin(sqldi);
break;
}
switch(sqldi->descr.tableData)
{
case CHNMETAINFOLIST:
mngDBConn(sqldi, DISDBCONN);
break;
default:
if (releaseConn) 
mngDBConn(sqldi, RLSDBCONN);
break;
}
if (sqldi->args.callType == ASYNC)
{ 
if (sqldi->args.returnFunc)
{ 
g_idle_add_full(G_PRIORITY_HIGH_IDLE, 
(GSourceFunc) sqldi->args.returnFunc, sqldi, NULL);
}
mysql_thread_end();
g_thread_exit(NULL);
}
if (sqldi->args.threaded)
mysql_thread_end();
return ret;
}
int db_request(SQLDI *sqldi)
{
#ifdef PQLX_THREAD_DEBUG
db_debug(sqldi);
#endif
if (sqldi->args.sqr && sqldi->args.callType == ASYNC)
{ 
mysql_thread_init();
g_thread_create((GThreadFunc) _db_request, sqldi, FALSE, NULL);
return PQLXSUCCESS;
}
if (sqldi->args.threaded)
mysql_thread_init();
sqldi->args.callType = SYNC;
return _db_request(sqldi);
}
