#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
int _db_system(MYSQL *conn, SQLDI *sqldi)
{
int   ret=PQLXSUCCESS, chnCnt;
gchar  *sqlStr;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
SQLDI  sqldiL;
MYSQL  *conn1;
switch(sqldi->descr.tableData)
{
case SYSKEEPALIVE:
{
sqlStr = g_strdup(SQL_SYS_KEEPALIVE);
db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case SYSEVENTCNT:
{
int event = GPOINTER_TO_INT(sqldi->data2);
sqlStr = g_strdup_printf(SQL_EVENT_CNT, event);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
ret = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFTBL:
{
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(SYSPDF);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
fprintf(stdout, "Computing System PDFs and Statistics for %d channels\n", chnCnt);
ret = procThread(conn, cpu[USERCPU], SYSPDF, sysPDFinit, sysPDFproc, sysPDFdone);
}
break;
case SYSTBLOPT:
{
fprintf(stdout, "Doing Some Table Maintenance\n");
sqlStr = g_strdup(SQL_TRC_CLEAN1);
db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup(SQL_TRC_CLEAN2);
db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup(SQL_TRC_CLEAN3);
db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_TRC_DELDUP,
dbName, dbName);
db_exec_sql(conn, sqlStr);  bug15752(conn);
#if 0
char *tmpTbl = g_strdup_printf("`%s`", "TRCTMPCLEAN");
char *trcTbl = g_strdup_printf("`%s`.`TRC`", dbName);
sqlStr = g_strdup_printf(SQL_TRC_DELDUP1,
tmpTbl, 
dbName, dbName);
db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_TRC_DELDUP2,
trcTbl, tmpTbl);
db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_TRC_DELDUP3,
tmpTbl);
db_exec_sql(conn, sqlStr);  bug15752(conn);
free(tmpTbl);
free(trcTbl);
#endif
#if 0
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&dbMaint, 0, sizeof(DBMAINT));
sqldiL.descr.tableData = SYSDBTBLOPT;
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.data = &dbMaint;
dbMaint.keys.tableName = g_strdup_printf("`%s`.`TRC`", dbName);
sqldiL.args.sqr = 1;  
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
free(dbMaint.keys.tableName);
dbMaint.keys.tableName = g_strdup_printf("`%s`.`GLAP`", dbName);
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
free(dbMaint.keys.tableName);
#endif
}
break;
case SYSTBLREPAIR:
{ 
char *tblName = sqldi->data;
sqlStr = g_strdup_printf(SQL_TABLE_REPAIR,
tblName);
db_exec_sql(conn, sqlStr);  bug15752(conn);
free(sqldi);
free(tblName);
}
break;
case SYSSPSEPOCHS:
{
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(SPSE);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
fprintf(stdout, "Computing Sample Rate Epochs\n");
ret = procThread(conn, cpu[ALLCPU], SPSE, spsEpochInit, spsEpochProc, spsEpochDone);
if (ret != PQLXSUCCESS)
break;
{ 
SQLDI sqldiL;
DBMAINT dbMaint;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&dbMaint, 0, sizeof(DBMAINT));
sqldiL.descr.tableData = SYSDBTBLOPT;
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.data = &dbMaint;
dbMaint.keys.tableName = g_strdup_printf("`%s`.`EPOCHSPS`", dbName);
sqldiL.args.sqr = 1;  
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
free(dbMaint.keys.tableName);
}    
}
break;
case SYSBASELINE:
{
int  blineCnt;
GSList *list;
gboolean ret;
sqlStr = g_strdup_printf(SQL_BLINE_ACTIVE_CNT,
dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
blineCnt = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL; bug15752(conn);
if (blineCnt == 0)
{ 
sqlStr = g_strdup_printf(SQL_EVENT_BLINE_DEL,
SYSBLINECMP);
ret = db_exec_sql(conn, sqlStr);
bug15752(conn);
break;
}
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(SYSPDF);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
list = BLList(conn, BLLIST_INIT);
if (list == NULL)
{
fprintf(stdout, "Unable to Retrieve Baseline Definitions, Cannot Compute Baseline Comparisons.\n");
break;
}
sqlStr = g_strdup_printf(SQL_EVENT_BLINE,
SYSBLINECMP, SYSPDF);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
fprintf(stdout, "Computing Baseline Statistics\n");
ret = procThread(conn, cpu[ALLCPU], SYSBLINECMP, BLineCmpInit, BLineCmpProc, BLineCmpDone);
}
break;
case SPCHNIUPD:
{
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(STATCHNI);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
fprintf(stdout, "Updating Channel Statistics\n");
ret = procThread(conn, cpu[ALLCPU], STATCHNI, NULL, chniStats, NULL);
}
break;
case SYSDIRSTATS:
{
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(STATDIR);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
fprintf(stdout, "Updating Directory Statistics\n");
ret = procThread(conn, cpu[ALLCPU], STATDIR, NULL, dirStats, NULL);
}
break;
case PSDINDECES:
{
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(PSDIDX);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
fprintf(stdout, "Creating PSD Table Indeces\n");
ret = procThread(conn, cpu[USERCPU], PSDIDX, NULL, psdIndex, NULL);
}
break;
case PSDCHNDELETE:
{
ret = procThread(conn, cpu[ALLCPU], PSDDELCHN, NULL, psdDelProc, NULL);
if (ret != PQLXSUCCESS)
break;
sqlStr = g_strdup_printf(SQL_PSDIDX_91F,
dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
break;
case PSDDELDATE:
{
ret = procThread(conn, cpu[ALLCPU], PSDDELDTE, NULL, psdDelDateProc, NULL);
if (ret != PQLXSUCCESS)
break;
}
break;
case PSDDELETIONS:
{
GSList  *channels=NULL, *iter;
int   chni_fk;
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSEVENTCNT;
sqldiL.data2 = GINT_TO_POINTER(PSDDELTRC);
chnCnt = _db_system(conn, &sqldiL);
if (chnCnt == 0)
break;
fprintf(stdout, "Processing PSD Deletions\n");
sqlStr = g_strdup_printf(SQL_PSDIDX_91C, PSDDELTRC);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
bug15752(conn);
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
res_set = mysql_store_result(conn);
while ((row = mysql_fetch_row(res_set)))
{
channels = g_slist_prepend(channels, GINT_TO_POINTER(atoi(row[0])));
}
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SYS_GLAPDEL, PSDDELTRC);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
for (iter = channels;
iter;
iter = g_slist_next(iter))
{
chni_fk = GPOINTER_TO_INT(iter->data);
sqlStr = g_strdup_printf(SQL_PSDIDX_91I,
dbName, 
chni_fk,
dbName,
chni_fk,
dbName,
PSDDELTRC,
chni_fk);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
g_slist_free(channels);
sqlStr = g_strdup_printf(SQL_PSDIDX_91D, PSDDELTRC);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_PSDIDX_91N,
PSDDELCHN,
dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
ret = 1; 
}
break;
case SYSSRVRFINISH:
{ 
DBMAINT dbMaint;
LOGIN *login = sqldi->data;
int  dow, dsl;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&dbMaint, 0, sizeof(DBMAINT));
sqldiL.descr.tableData = SYSDBTBLOPT;
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.data = &dbMaint;
dbMaint.keys.tableName = g_strdup_printf("`%s`.`RESP`", dbName);
sqldiL.args.sqr = 1;  
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
free(dbMaint.keys.tableName);
dbMaint.keys.tableName = g_strdup("CHNMETA");
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
free(dbMaint.keys.tableName);
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.descr.tableData = SYSDBLOGS;
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
sqldiL.args.dataEvent = EVENTQ;
sqldiL.descr.tableData = EVENT_RESUME;
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
if (login->data.initialExecution)
{
sqlStr = g_strdup_printf(SQL_EVENT_DEL1000, SRVRINIT);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.descr.tableData = SYSEVENTCLEAN;
conn1 = mngDBConn(&sqldiL, GETDBCONN);
_db_maintain(conn1, &sqldiL); bug15752(conn1);
mngDBConn(&sqldiL, DISDBCONN);
sqlStr = g_strdup_printf(SQL_PSDOPT_DOW);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FALSE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
dow = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
if (dow == SATURDAY)
{ 
ret = TRUE;
break;
}
sqlStr = g_strdup_printf(SQL_PSDOPT_DSL);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FALSE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
dsl = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
if (dsl > MINSRVREXECS)
{ 
ret = TRUE;
break;
}
ret = FALSE;
}
break;
}
return ret;
}
int db_system(SQLDI *sqldi)
{
int   ret;
MYSQL  *conn;
conn = mngDBConn(sqldi, GETDBCONN);
#if 0
switch(sqldi->descr.tableData)
{
case SYSKEEPALIVE:
conn = connG[sqldi->args.call.connNum];
break;
default:
conn = mngDBConn(sqldi, GETDBCONN);
break;
}
#endif
ret = _db_system(conn, sqldi);
return ret;
}
