#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
int chniStats(MYSQL *conn, THREADARGS *threadArgs)
{
int  chnKey = threadArgs->typeKey;
int  ret;
char *sqlStr;
sqlStr = g_strdup_printf(SQL_CHNI_STATS, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
int dirStats(MYSQL *conn, THREADARGS *threadArgs)
{
int  dirKey = threadArgs->typeKey;
int  ret;
char *sqlStr;
sqlStr = g_strdup_printf(SQL_DIRS_STATS, dirKey, dirKey, dirKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
int psdIndex(MYSQL *conn, THREADARGS *threadArgs)
{
int  chnKey = threadArgs->typeKey;
int  ret;
char *sqlStr;
sqlStr = g_strdup_printf(SQL_PSDIDX_MKIDX,
dbName, chnKey,
dbName, chnKey,
dbName, chnKey,
dbName, chnKey,
dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
#define BLINETMP(dbn, thn) g_strdup_printf("`%sTMP`.`bcmpKeys%d`", dbn, thn)
int BLineCmpInit(MYSQL *conn, int threadNum)
{
char *tableName = BLINETMP(dbName, threadNum);
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_PSDTBL_TMPMK,
tableName, tableName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
free(tableName);
return ret;
}
int BLineCmpDone(MYSQL *conn, int threadNum)
{
char  *tableName = BLINETMP(dbName, threadNum);
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_PSDTBL_DROP,
tableName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
free(tableName);
return ret;
}
int BLineCmpProc(MYSQL *conn, THREADARGS *threadArgs)
{
int  threadNum = threadArgs->threadNum, chnKey = threadArgs->typeKey;
BLINEDEF *blineDef;
BLINEINTERP *blineInterp;
MYSQL_RES *res_set;
MYSQL_ROW row;
char   *tableName = BLINETMP(dbName, threadNum);
char   *sqlStr;
float  perMAX;
gboolean dir;
int   ret, sps_pk, psdKey, ttlPeriods, bline_pk, blinei_pk, sampInt;
GSList  *bllist = BLList(NULL, BLLIST_FETCH), *iter;
if (!bllist)
return FAILURE;
sqlStr = g_strdup_printf(SQL_BLINE_EPOCHSPK,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
sps_pk = atoi(row[0]);
sampInt = atoi(row[1]);
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_BLINE_PSDKEY,
dbName, chnKey,
dbName, sps_pk);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
if (!row) 
{ 
mysql_free_result(res_set); res_set=NULL;
return PQLXSUCCESS;
}
psdKey = atoi(row[0]);
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_BLINE_PERMAX,
dbName, chnKey, psdKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
perMAX = (float) atof(row[0]);
mysql_free_result(res_set); res_set=NULL;
for (iter = bllist;
iter;
iter = g_slist_next(iter))
{
blineDef = iter->data;
if (!blineDef->active)  
continue;
bline_pk = blineDef->blineKey;
dir = blineDef->dir;
#if 0
sqlStr = g_strdup_printf(SQL_BLINE_PSDKEYS,
tableName, tableName, 
dbName, chnKey,
dbName, sps_pk, 
dbName, chnKey,
bline_pk);
#endif
sqlStr = g_strdup_printf(SQL_BLINE_PSDKEYS1,
tableName, tableName, 
dbName, chnKey,
dbName, sps_pk, 
dbName, chnKey,
bline_pk);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
continue; 
sqlStr = g_strdup_printf(SQL_BLINE_INTERP,
dbName, dbName, 
bline_pk, sampInt, perMAX);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
continue; 
res_set = mysql_store_result(conn);
switch(mysql_num_rows(res_set))
{
case 0:
{ 
mysql_free_result(res_set); res_set=NULL;
blineInterp = BLInterp(conn, bline_pk, chnKey, psdKey, sampInt, perMAX);
}
break;
default:
row = mysql_fetch_row(res_set);
blineInterp = calloc(1, sizeof(BLINEINTERP));
blineInterp->blinei_pk = atoi(row[0]);
blineInterp->ttlPeriods = atoi(row[1]);
mysql_free_result(res_set); res_set=NULL;
break;
}
if (!blineInterp)
{
fprintf(stderr, "Creation/Retrieval of Interpolated Baseline Failed, Cannot Compute.\n");
continue;
}
blinei_pk = blineInterp->blinei_pk;
ttlPeriods = blineInterp->ttlPeriods;
sqlStr = g_strdup_printf(SQL_BLINE_CMP1,
dbName, chnKey,
bline_pk, tableName);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_BLINE_CMP,
dbName, chnKey, tableName,
ttlPeriods,
dbName, chnKey, dbName,
blinei_pk, ((dir == BLINECMP_UP) ? "<=" : ">"),
bline_pk);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
free(blineInterp);
}
return ret;
}
#define EPOCHSPSTMP(dbn, thn) g_strdup_printf("`%sTMP`.`epochspsTEMP%d`", dbn, thn)
int spsEpochInit(MYSQL *conn, int threadNum)
{
char *tableName = EPOCHSPSTMP(dbName, threadNum);
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_SPS_TMPMK,
tableName, tableName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
free(tableName);
return ret;
}
int spsEpochProc(MYSQL *conn, THREADARGS *threadArgs)
{
int  threadNum = threadArgs->threadNum, chnKey = threadArgs->typeKey;
char  *tableName = EPOCHSPSTMP(dbName, threadNum);
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_SPS_TMPFILL, 
tableName, tableName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
return ret;
sqlStr = g_strdup_printf(SQL_SPS_SPSE, 
dbName, chnKey,
dbName,
tableName, tableName,
tableName,
tableName,
chnKey,
tableName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
free(tableName);
sqlStr = g_strdup_printf(SQL_SPS_BDRY, 
chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
int spsEpochDone(MYSQL *conn, int threadNum)
{
char  *tableName = EPOCHSPSTMP(dbName, threadNum);
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_SPS_TMPDROP,
tableName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
free(tableName);
return ret;
}
int psdDelProc(MYSQL *conn, THREADARGS *threadArgs)
{
int  chnKey = threadArgs->typeKey;
int  ret;
ret = delPSD(conn, PSDDEL_CHANNEL, chnKey, 0, NULL, NULL);
return ret;
}
int psdDelDateProc(MYSQL *conn, THREADARGS *threadArgs)
{
int  threadNum = threadArgs->threadNum, chnKey = threadArgs->typeKey;
int  evtq_id = threadArgs->evtq_id;
char *sqlStr;
int  ret;
char *psdD, *psdI;
psdD = g_strdup_printf("`%sDATA`.`psd%d`", dbName, chnKey);
psdI = g_strdup_printf("`%sDATA`.`psd%didx`", dbName, chnKey);
sqlStr = g_strdup_printf(SQL_PSDD_DATE,
psdD, psdI,
psdD, psdI,
psdD, psdI,
evtq_id,
chnKey,
psdI);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
free(psdD); free(psdI);
return ret;
}
{ 
SQLDI sqldiL;
DBMAINT dbMaint;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&dbMaint, 0, sizeof(DBMAINT));
sqldiL.args.sqr = threadNum;
sqldiL.descr.tableData = SYSDBTBLOPT;
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.data = &dbMaint;
dbMaint.keys.tableName = psdD;
_db_maintain(conn, &sqldiL);
dbMaint.keys.tableName = psdI;
_db_maintain(conn, &sqldiL);
}
free(psdD); free(psdI);
return ret;
}
typedef struct _EPOCHSPS
{
char *startD;
char *endD;
} EPOCHSPS;
int sysPDFinit(MYSQL *conn, int threadNum)
{
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_PSDTMP_TMPMK, TMPTBLIDX, TMPTBLCNT);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
int sysPDFdone(MYSQL *conn, int threadNum)
{
char *sqlStr;
int  ret;
sqlStr = g_strdup_printf(SQL_PSDTMP_TMPDROP, TMPTBLIDX, TMPTBLCNT);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
int sysPDFproc(MYSQL *conn, THREADARGS *threadArgs)
{
int   chnKey = threadArgs->typeKey;
MYSQL_RES *res_set;
MYSQL_ROW row;
PDFHITS  *pdfHits;
PDFSTATS *stats;
SQLDI  sqldiS;
EPOCHSPS *epochSPS;
GSList  *iter, *epochs=NULL; 
GSList  *iter2;
SYSPDFDEF *sysPDF;
PDFREQ  pdfReq;
WHEREARGS whereArgs;
PDFPERIOD pdfPeriod;
GSList  *sysPDFs=NULL;  
char  *from, *whereClause=NULL, *epochBounds[TTLDATES], *sqlStr;
int   ttlPeriods, ttlRows, rowN, ttlHits, epochNum, psdKey, ret;
sqlStr = g_strdup_printf(SQL_PDF_TRUNC,
dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
return ret;
}
sqlStr = g_strdup_printf(SQL_PDFST_TRUNC,
dbName, chnKey,
dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
return ret;
}
sqlStr = g_strdup_printf(SQL_PDFIDX_CLEAN,
chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
return ret;
}
sqlStr = g_strdup_printf(SQL_PDF_EPOCHS,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
while ((row = mysql_fetch_row(res_set)))
{
epochSPS = calloc(1, sizeof(EPOCHSPS));
epochSPS->startD = g_strdup(row[0]);
epochSPS->endD = g_strdup(row[1]);
epochs = g_slist_append(epochs, epochSPS);
}
mysql_free_result(res_set); res_set=NULL;
sysPDFs = systemPDFdb;
for (iter = epochs, epochNum=0;
iter;
iter = g_slist_next(iter), epochNum++, 
free(epochSPS->startD), free(epochSPS->endD), free(epochSPS))
{ 
epochSPS = iter->data;
epochBounds[STARTDT] = epochSPS->startD;
epochBounds[ENDDT] = epochSPS->endD;
if (strcmp(epochBounds[STARTDT], epochBounds[ENDDT]) > 0)
continue;
sqlStr = g_strdup_printf(SQL_TRC_SAMPRATE,
chnKey,
epochBounds[STARTDT], epochBounds[ENDDT]);
ret = db_exec_sql(conn, sqlStr);  
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
ttlRows = mysql_num_rows(res_set);
if (ttlRows > 1)
{
ret = FAILURE;
bug15752(conn);
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_NSLC_NAME,
chnKey);
ret = db_exec_sql(conn, sqlStr);
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
fprintf(stderr, "ERROR: Multiple Sample Rates exist for channel %s," 
" cannot compute System PDF and PDF Statistics\n", 
row[0]);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_PDF_SRC,
NOPSDBADSR,
chnKey);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
}
return ret;
}
bug15752(conn);
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_PDFIDX_MK,
chnKey, epochNum);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
for(iter2 = sysPDFs;
iter2;
iter2 = g_slist_next(iter2))
{
sysPDF = iter2->data;
memset(&pdfReq, 0, sizeof(PDFREQ));
pdfReq.keys.pdfKey = sysPDF->pdfKey;
pdfReq.keys.chnKey = chnKey;
pdfReq.keys.sysPDFB[STARTDT] = epochBounds[STARTDT];
pdfReq.keys.sysPDFB[ENDDT] = epochBounds[ENDDT];
whereArgs.chnKey = pdfReq.keys.chnKey;
whereArgs.sysPdfKey = pdfReq.keys.pdfKey;
whereArgs.sysPDFB = pdfReq.keys.sysPDFB;
whereArgs.criteria = pdfReq.keys.criteria;
whereArgs.reqType = pdfReq.keys.reqType;
whereClause = makeWhere(PDFDETAILREQ, &whereArgs);
ADDPREFIX(whereClause, PFX_AND);
sqlStr = g_strdup_printf(SQL_PSDD_CNTI,
TMPTBLIDX, TMPTBLCNT, TMPTBLIDX, 
dbName, chnKey, chnKey,
whereClause,
TMPTBLCNT, TMPTBLIDX);
free(whereClause);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
sqlStr = g_strdup_printf(SQL_PDFKEY_CNT,
TMPTBLCNT);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
ttlHits = (row) ? atoi(row[0]) : 0;
bug15752(conn);
mysql_free_result(res_set); res_set=NULL;
if (!ttlHits)
{ 
continue;
}
sqlStr = g_strdup_printf(SQL_PDFKEY_KEY,
TMPTBLIDX, "");
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
psdKey = (row) ? atoi(row[0]) : 0;
bug15752(conn); mysql_free_result(res_set); res_set=NULL;
if (!psdKey)
{ 
continue;
}
memset(&sqldiS, 0, sizeof(SQLDI));
memset(&pdfPeriod, 0, sizeof(PDFPERIOD));
pdfPeriod.keys.chnKey = pdfReq.keys.chnKey;
pdfPeriod.keys.psdKey = psdKey;
sqldiS.descr.tableData = PDFPERIODTTL;
sqldiS.args.dataEvent = GET_DATA;
sqldiS.data = &pdfPeriod;
getData(conn, &sqldiS);
if (sqldiS.event.errorNO)
{
break;
}
ttlPeriods = pdfPeriod.data.ttlPeriods;
sqlStr = g_strdup_printf(SQL_PDFST_HITSI,
dbName, chnKey,
sysPDF->pdfKey,
dbName, chnKey,
TMPTBLIDX);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
sqlStr = g_strdup_printf(SQL_PDFST_HITSPER,
dbName, chnKey,
sysPDF->pdfKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
ttlRows = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
if (ttlRows != ttlPeriods)
{
fprintf(stderr, "Database Corruption! Number of Periods Does Not Match! Cannot Compute PDF.\n"
"\t(channel = %d, pdfKey = %d, ttlRows = %d, ttlPeriods = %d)\n", 
chnKey, sysPDF->pdfKey, ttlRows, ttlPeriods);
continue;
}
sqlStr = g_strdup_printf(SQL_PDF_INS1,
dbName, chnKey,
ttlHits,
dbName, chnKey,
sysPDF->pdfKey, chnKey, 
sysPDF->pdfKey, epochNum);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
from = g_strdup_printf(SQL_PDF_INS2,
dbName, chnKey,
TMPTBLIDX);
sqlStr = g_strdup_printf(SQL_PDF_METASTATS,
ttlHits,
from,
chnKey,
sysPDF->pdfKey,
epochNum);
#if 0
break;
default:
sqlStr = g_strdup_printf(SQL_PDF_METASTATSI,
sysPDF->pdfKey,
chnKey,
epochNum,
ttlHits,
from,
chnKey,
sysPDF->pdfKey,
epochNum);
#endif
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
sqlStr = g_strdup_printf(SQL_PDF_DTS,
from,
chnKey,
sysPDF->pdfKey,
epochNum);
free(from);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
if (epochNum)  
continue;  
sqlStr = g_strdup_printf(SQL_PDFST_HITSG,
dbName, chnKey,
sysPDF->pdfKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
ttlRows = mysql_num_rows(res_set);
pdfHits = calloc(1, sizeof(PDFHITS));
pdfHits->pdfKey = sysPDF->pdfKey;
pdfHits->ttlPeriods = ttlPeriods;
pdfHits->hits = calloc(ttlRows, sizeof(PDFHITSDATA));
pdfHits->ttlRows = ttlRows;
for(rowN=0; (row = mysql_fetch_row(res_set)); rowN++)
{
pdfHits->hits[rowN].period = atof(row[0]);
pdfHits->hits[rowN].power = atoi(row[1]);
pdfHits->hits[rowN].hits = atoi(row[2]);
}
mysql_free_result(res_set); res_set = NULL;
pdfHits->ttlHits = ttlHits;
stats = pdf_STATS(pdfHits);
free(pdfHits->hits);
free(pdfHits);
if (stats)
{
stats->pdfKey = sysPDF->pdfKey;
memset(&sqldiS, 0, sizeof(SQLDI));
sqldiS.descr.tableData = SYSPDFSTATS;
sqldiS.data = stats;
sqldiS.data2 = GINT_TO_POINTER(chnKey);
insertData(conn, &sqldiS);
free(stats->stats);
free(stats);
if (sqldiS.event.errorNO)
{
break;
}
}
else
{ 
fprintf(stderr, "Unable to compute statistics for channel %d, ttlPeriods = %d\n", chnKey, ttlPeriods);
}
}
}
sqlStr = g_strdup_printf(SQL_CHNI_TTLPSD,
chnKey,
chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
g_slist_free(epochs); epochs = NULL;
return ret;
}
