#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
#include "db_upgrade_sql.h"
const char *upgradeStr = "\t... ";
static int upgradeDB(MYSQL *conn, int version)
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gchar *sqlStr;
int  ret=PQLXSUCCESS;
switch(version)
{
case DBVERSION1:
{
char *table;
int  *pdfCHN;
GSList *PDFchnI, *PDFchn=NULL;
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
sqlStr = g_strdup_printf(SQL_DBUPG_1_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)) != NULL)
{
pdfCHN = malloc(sizeof(int));
*pdfCHN = atoi(row[0]);
PDFchn = g_slist_prepend(PDFchn, pdfCHN);
}
mysql_free_result(res_set); res_set = NULL;
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying column definition for 'period' of PSD and PDF data tables (from float to decimal(12,6)).\n",
upgradeStr);
for(PDFchnI = PDFchn; PDFchnI; PDFchnI = g_slist_next(PDFchnI))
{
pdfCHN = PDFchnI->data;
table = g_strdup_printf("psd%d", *pdfCHN); 
sqlStr = g_strdup_printf(SQL_DBUPG_1_A, dbName, table);
if (mysql_query(conn, sqlStr))
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
free(table);     
free(pdfCHN);     
break;
}
free(sqlStr); bug15752(conn);
free(table);
sqlStr = g_strdup_printf(SQL_PDF_TRUNC, dbName, *pdfCHN);
if (mysql_query(conn, sqlStr))
{
}
free(sqlStr); bug15752(conn);
table = g_strdup_printf("pdf%d", *pdfCHN); 
sqlStr = g_strdup_printf(SQL_DBUPG_1_A, dbName, table);
if (mysql_query(conn, sqlStr))
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
free(table);     
free(pdfCHN);     
break;
}
free(sqlStr); bug15752(conn);
free(table);
free(pdfCHN);     
}
g_slist_free(PDFchn);
}
break;
case DBVERSION2:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
#if 0
fprintf(stdout, "Recreating TRIGGER 'CHNIDEPENDENCIES'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_2_A3, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_2_A2);
if (mysql_query(conn, sqlStr) != 0)
{
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_2_A3);
if (mysql_query(conn, sqlStr) != 0)
{
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_2_A4);
if (mysql_query(conn, sqlStr) != 0)
{
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
#endif   
fprintf(stdout, "%sModifying Table PDFCFG Definition\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_2_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding New System PDF Definitions\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_2_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column 'ttlPSD' to Table PDFIDX.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_2_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRecreating TABLE PDFIDX\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_2_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying TABLE USER_LOG, Column user_pk\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_2_F);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION3:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying table PDFIDX: ENGINE=INNODB\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_3_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_3_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying column definition 'dayEnd' and 'dayStart' on table PDFCFG: \n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_3_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION4:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sCreating new table CHNMETA\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAltering table CHNI, dropping columns sampRate, lat, lon\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAltering table TRC, changing column name sRate to sampInt.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Index to PSDCFG.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_F);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Indeces to CHNI.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_G);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Index to RESP.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_H);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Indeces to TRC.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_I);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Index to IDS.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_4_J);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION5:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying Column EVENTQ.processed, adding enum type 'NOPROC'\n",
upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_5_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding SYSTEM PDF Events\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_5_B, SYSPDF);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION6:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying column CONSTANT.type, adding enum type 'EVENT'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_6_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRecreating CONSTANT table\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_6_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sConverting EVENTQ.error_no = -2 to new value (1008)\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_6_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION7:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying table EVENTQ: Column evtq_id as BIGINT\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_7_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION8:
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
GSList *PSDchn=NULL;  
GSList *PSDchnI;
char *chn;
sqlStr = g_strdup_printf(SQL_PSDCFG_ALL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
chn = g_strdup(row[0]);
PSDchn = g_slist_prepend(PSDchn, chn);
}
mysql_free_result(res_set);
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sCreating New Database %sSTATS\n", upgradeStr, dbName);
sqlStr = g_strdup_printf(SQL_DBUPG_8_A,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New PDF Statistics Tables %sSTATS.hits and %sSTATS.stats\n",
upgradeStr, dbName, dbName);
for(PSDchnI=PSDchn;PSDchnI;PSDchnI=g_slist_next(PSDchnI))
{
chn = PSDchnI->data;
sqlStr = g_strdup_printf(SQL_DBUPG_8_B,
dbName, chn);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_8_C,
dbName, chn);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
free(chn);
}
g_slist_free(PSDchn);
fprintf(stdout, "%sAdding Statistics Display Columns to PDFCFG.\n", 
upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_8_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_8_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION9:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding PDF Date Format column to PDFCFG.\n", 
upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_9_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Columns for CHNI and PDFIDX.\n", 
upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_9_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION10:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying column GLAP.glap_pk.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_10_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION11:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying PDFIDX columns pdfcfg_pk and ttlPSD.\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_11_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding TMP table dbMaint.\n", 
upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_11_B,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding CONSTANT table value 1009.\n", 
upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_11_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION12:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding CONSTANT table value 1010.\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_12_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION13:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sResetting MYSQL password for pqlxAdmin\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_13_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRe-Ordering EVENTQ.type column ENUM types\n", 
upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_13_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION14:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying CHNMETA column 'sensitivity'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_14_A, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION15:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying TRC column 'sampInt'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_15_A, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying CHNMETA column 'sampInt'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_15_B, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION16:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sCreating TABLE PDFWWW\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_16_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_16_B, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION17:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding column HLNM to TABLE PDFWWW\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_17_A, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION18:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying EVENTQ columns 'typeKey' and 'typeKey2'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_18_A, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION19:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding EVENTQ column 'chni_fk'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_A, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying SP EVENTQ_PSD1()\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_19_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying SP EVENTQ_PSD2()\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_F);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_19_G);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCleaning up SP's\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_H);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_19_I);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
#if 0
new trigger definition removed since drop trigger does not work on upgraded mysql
fprintf(stdout, "%sModifying Trigger 'TRC-DEL'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_J);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_19_K);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
#endif
fprintf(stdout, "%sCreating View eventQV\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_L);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying SP spNextEvent()\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_19_M);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_19_N);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION20:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sRe-Creating Trigger 'TRC-DEL'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_Z1);
mysql_query(conn, sqlStr);  
free(sqlStr); bug15752(conn);
sqlStr = g_strdup(SQL_DBUPG_20_Z2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to Recreate DB Trigger 'TRC-DEL'\n");
fprintf(stderr, "Due to a Modification in MYSQL, this problem must be solved by hand, (sorry...)\n");
fprintf(stderr, "Please carry out the following actions in a command shell:\n");
fprintf(stderr, "\t1) Locate the MYSQL Configuration File named 'my.cnf':\n");
fprintf(stderr, "\t\t1.1) Using the locate command, or the find command: \n""\t\t It is typically located in a subdirectory of /etc.\n");
fprintf(stderr, "\t2) Identify the MYSQL Data Directory:\n");
fprintf(stderr, "\t\t2.1) sh> grep datadir /dir/path/my.cnf \n""\t\t (where /dir/path is the directory identified in step 1)\n");
fprintf(stderr, "\t3) Delete the Trigger-relevant files for this Database:\n""\t\t3.1) sh> sudo rm /mysql/datadir/dbName/TRC-DEL.TRN\n""\t\t3.2) sh> sudo rm /mysql/datadir/dbName/TRC.TRG\n""\t\t (where /mysql/datadir is the directory identified in step 2)\n""\t\t (and dbName is '%s')\n", dbName);
fprintf(stderr, "\t4) N.B. When step 3 fails, it may be necessary to Stop and Re-Start the MYSQL server:\n""\t\t4.1) sh> mysqladmin shutdown\n""\t\t4.2) execute steps 3.1 and 3.2\n""\t\t4.3) sh> mysqld_safe -umysql (or other normal MYSQL Startup Procedure)\n");
fprintf(stderr, "\t5) Re-execute this command to continue this Upgrade Procedure\n");
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Tables Character Set\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying DB Collation\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_B, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding columns to DIRS table (ttlTrace, ttlResp)\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new SP dirsUpd()\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRemoving Trailing '/' from DIRS.directory Column\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding ENUM 'ADMIN' to USER.type column\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_F);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying SP spRegUser()\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_G);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Column Definitions for Table PDFCFG\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_H);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_20_I);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Enum Definitions for Table PDFWWW\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_J);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Enum Definitions for Table DIRS\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_K);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sUpdating Column PDFCFG.dateFmt\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_L);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column `ttlPSD` to Table CHNI\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_M);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column wwwDIR to table PDFWWW\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_20_N,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New Tables SRVREXEC and SRVRLOG\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_O);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column 'epoch' to Table PDFIDX\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_P);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New View 'epochsps'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_Q);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column 'type' to Table PDFCFG\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_R);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr); 
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sUpdating System PDF Definitions\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_20_S);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION21:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sRe-Creating Trigger 'CHNIDEPENDENCIES'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_21_A);
mysql_query(conn, sqlStr);  
free(sqlStr); bug15752(conn);
sqlStr = g_strdup(SQL_DBUPG_21_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to Recreate DB Trigger 'CHNIDEPENDENCIES'\n");
fprintf(stderr, "Due to a Modification in MYSQL, this problem must be solved by hand, (sorry...)\n");
fprintf(stderr, "Please carry out the following actions in a command shell:\n");
fprintf(stderr, "\t1) Locate the MYSQL Configuration File named 'my.cnf':\n");
fprintf(stderr, "\t\t1.1) Using the locate command, or the find command: \n""\t\t It is typically located in a subdirectory of /etc.\n");
fprintf(stderr, "\t2) Identify the MYSQL Data Directory:\n");
fprintf(stderr, "\t\t2.1) sh> grep datadir /dir/path/my.cnf \n""\t\t (where /dir/path is the directory identified in step 1)\n");
fprintf(stderr, "\t3) Delete the Trigger-relevant files for this Database:\n""\t\t3.1) sh> sudo rm /mysql/datadir/dbName/CHNIDEPENDENCIES.TRN\n""\t\t3.2) sh> sudo rm /mysql/datadir/dbName/CHNI.TRG\n""\t\t (where /mysql/datadir is the directory identified in step 2)\n""\t\t (and dbName is '%s')\n", dbName);
fprintf(stderr, "\t4) N.B. When step 3 fails, it may be necessary to Stop and Re-Start the MYSQL server:\n""\t\t4.1) sh> mysqladmin shutdown\n""\t\t4.2) execute steps 3.1 and 3.2\n""\t\t4.3) sh> mysqld_safe -umysql (or other normal MYSQL Startup Procedure)\n");
fprintf(stderr, "\t5) Re-execute this command to continue this Upgrade Procedure\n");
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding PSDCFG Column 'type'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_21_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_21_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION22:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sRe-Creating Stored Procedure 'EVENTQ_PSD2'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_22_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_22_B,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New Stored Procedure 'EVENTQ_PSD2ERR'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_22_C, 
TRCKEYTMPTBL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sDropping View 'epochSPS' and Re-Creating as Table 'EPOCHSPS'\n", 
upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_22_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup(SQL_DBUPG_22_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding New Event '%d' to CONSTANT Table\n", upgradeStr, PSDDELCHN);
sqlStr = g_strdup_printf(SQL_DBUPG_22_F, PSDDELCHN);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding New Event '%d' to CONSTANT Table\n", upgradeStr, SPSE);
sqlStr = g_strdup_printf(SQL_DBUPG_22_G1, SPSE);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating Events to Calculate SPS Epochs\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_22_G2, SPSE);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating Stored Procedure EVENTQ_SPSE\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_22_G3);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding New Event '%d' to CONSTANT Table\n", upgradeStr, STATCHNI);
sqlStr = g_strdup_printf(SQL_DBUPG_22_H1, STATCHNI);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating Stored Procedure EVENTQ_CHNI\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_22_H2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding New Event '%d' to CONSTANT Table\n", upgradeStr, STATDIR);
sqlStr = g_strdup_printf(SQL_DBUPG_22_I1, STATDIR);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION23:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding New Event '%d' to CONSTANT Table\n", upgradeStr, PAUSEevt);
sqlStr = g_strdup_printf(SQL_DBUPG_23_A, PAUSEevt);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRe-Defining View 'eventQV'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_23_B, NONE);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRe-Defining Procedure 'spNextEvent'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_23_C1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_23_C2, NONE, PAUSEevt);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column 'doneTime' to SRVREXEC Table\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_23_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New Table EVENTQerr\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_23_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sDropping Table 'dbMaint'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_23_F, dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Table 'DIRS' to Engine = InnoDB\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_23_G);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION24:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding Default Value for Column EVENTQ.typeKey2\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_24_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sDropping SP's EVENTQ_CHNI and EVENTQ_SPSE\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_24_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New SP EVENTQ_FOLLOWUPS\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_24_C, 
STATCHNI, STATCHNI,
SPSE, SPSE,
SYSPDF, SYSPDF);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New SP EVENTQ_DIRS\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_24_D, 
STATDIR, STATDIR);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION25:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sDropping and Re-Creating Trigger 'TRC-DEL'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_25_A1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_25_A2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Table CHNI to InnoDB Engine\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_25_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sModifying Table PDFIDX to InnoDB Engine\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_25_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Primary Key Column to Table 'EPOCHSPS'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_25_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION26:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sRe-Creating View 'eventQV'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_26_A1, NONE);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRe-Creating SP 'spNextEvent'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_26_A2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_26_A3, NONE, PAUSEevt);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRe-Creating SP 'EVENTQ_FOLLOWUPS'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_26_B1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_26_B2, 
STATCHNI, STATCHNI,
SPSE, SPSE,
SYSPDF, SYSPDF);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION27:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sMoving Column 'HLNM' from 'PDFWWW' to 'PDFCFG'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_27_A1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_27_A2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sRe-Naming Table 'PDFWWW' to 'PNGWWW'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_27_B1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Columns 'pngwww_pk' and 'type_fk' to Table 'PNGWWW'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_27_B2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Constants 'PDF' and 'SPECTRO' PNG to Table 'CONSTANT'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_27_C1,
SYSPDFPNG,
SYSSPECPNG, SYSSPECPNG);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sUpdating PDF Record (Table 'PNGWWW')\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_27_D1,
SYSPDFPNG);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating TMP table PSDOPT\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_27_E1, 
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sReplacing Stored Procedure 'EVENTQ_PSD2()'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_27_F1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_27_F2,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
#if 0
sqlStr = g_strdup_printf(SQL_DBUPG_27_E2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
#endif
}
break;
case DBVERSION28:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sInserting SPECTRO PNGWWW Defaults\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_28_A1,
1000, 300, "ON", 0, 0, 0,
175, 75, "ON", 0, 0, 0,
"NONE", SYSSPECPNG);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sInserting Two New System PDF's (One and Two Days Ago)\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_28_B1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sReplacing Stored Procedure 'EVENTQ_PSD2()'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_28_C1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_28_C2,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sAdding Column 'overlap' to Table 'PSDCFG'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_28_D1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sUpdate Trigger 'CHNIDEPENDENCIES'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_28_E1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup(SQL_DBUPG_28_E2);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION29:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sCreating new Stored Procedure 'RESP_INSERT'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_29_A,
NO_RESP_FILE);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION30:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sReplacing Stored Procedure 'EVENTQ_PSD2()'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_30_A1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_30_A2,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL,
TRCKEYTMPTBL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION31:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sUpdating CONSTANT Table\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_31_A1,
TRC1evt,
PSD1evt,
PSD2evt,
PSDIDX,
PSDDELTRC,
PSDDELCHN,
SYSPDFPNG,
SYSSPECPNG);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_31_A2,
TRC1evt,
PSD1evt,
PSD2evt,
PSDIDX,
PSDDELTRC,
PSDDELCHN,
SYSPDFPNG,
SYSSPECPNG);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating New Table 'EVENTQargs'\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_31_B,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_31_C,
PSDDELDTE);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION32:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sUpdating SRVRLOG.type ENUM Values\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_32_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION33:
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
GSList *PSDchn=NULL;  
GSList *PSDchnI;
int  chn;
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
#if 0
fprintf(stdout, "%sRe-Creating SP 'EVENTQ_FOLLOWUPS'\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_33_A1);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_33_A2, 
STATCHNI, STATCHNI,
SPSE, SPSE,
SYSPDF, SYSPDF,
SYSBLINECMP, SYSBLINECMP);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
#endif
fprintf(stdout, "%sCreating New Event Baseline Statistics\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_33_B1, 
SYSBLINECMP);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating Baseline Tables\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_33_C,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_33_D,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_33_E,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_33_F,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDCFG_ALL);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
PSDchn = g_slist_prepend(PSDchn, GINT_TO_POINTER(atoi(row[0])));
}
mysql_free_result(res_set);
for(PSDchnI=PSDchn;PSDchnI;PSDchnI=g_slist_next(PSDchnI))
{
chn = GPOINTER_TO_INT(PSDchnI->data);
sqlStr = g_strdup_printf(SQL_DBUPG_33_G,
dbName, chn);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
g_slist_free(PSDchn);
fprintf(stdout, "%sImporting HLNM as Baselines\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPG_33_H1,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_DBUPG_33_H2,
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case DBVERSION34:
{
fprintf(stdout, "Upgrading Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying Column Definition GLAP.startPt, GLAP.endPT, TRC.nsamps\n", upgradeStr);
sqlStr = g_strdup(SQL_DBUPG_34_A1);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
sqlStr = g_strdup(SQL_DBUPG_34_A2);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
}
break;
}
return ret;
}
int db_upgrade(SQLDI *sqldi)
{
LOGIN  *login=sqldi->data;
gchar   *sqlStr;
int   ret, i;
MYSQL  *conn = mngDBConn(sqldi, GETDBCONN);
for (i=login->data.dbVersion+1, 
ret = PQLXSUCCESS;
i<=MINIMUM_DB_VERSION && 
ret == PQLXSUCCESS;  
i++)
{
ret = upgradeDB(conn, i);
switch (ret)
{
case PQLXSUCCESS:
fprintf(stdout, "%s Database Successfully Upgraded to version 0.%d\n", dbName, i);
login->data.dbVersion = i;
sqlStr = g_strdup_printf(SQL_DBVERSION_UPD, 
login->data.dbVersion, 
dbName);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
}
free(sqlStr); bug15752(conn);
break;
default:
fprintf(stdout, "There was a problem Upgrading the Database to version 0.%d\n",i);
fprintf(stdout, "\tCheck the .err file for details.\n");
break;
}
}
return ret;
}
static int upgradePQLXMETAdb(MYSQL *conn, int version)
{
gchar *sqlStr;
int  ret=PQLXSUCCESS;
switch(version)
{
case PDBVERSION0:
{
fprintf(stdout, "Upgrading PQLXMETA Database to Version 0.%d\n", version);
fprintf(stdout, "%sDropping columns 'ntw', 'stn', 'loc', 'chn' in PQLXMET.PQLXDBS\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_0_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new entry for PQLXMETA in PQLXDBS\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_0_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case PDBVERSION1:
{
fprintf(stdout, "Upgrading PQLXMETA Database to Version 0.%d\n", version);
fprintf(stdout, "%sCreating new table SEISEVENT\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_1_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new table SEISMAG\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_1_B);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new table MODELNM\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_1_C);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new table MODELPH\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_1_D);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new table MODELTT\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_1_E);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
fprintf(stdout, "%sCreating new table MODELTB\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_1_F);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case PDBVERSION2:
{
fprintf(stdout, "Upgrading PQLXMETA Database to Version 0.%d\n", version);
fprintf(stdout, "%sModifying Collation to be Case Sensitive\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_2_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
case PDBVERSION3:
{
fprintf(stdout, "Upgrading PQLXMETA Database to Version 0.%d\n", version);
fprintf(stdout, "%sAdding Column `hint` to Table PQLXDBS\n", upgradeStr);
sqlStr = g_strdup_printf(SQL_DBUPGP_3_A);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
}
break;
}
return ret;
}
int pdb_upgrade(SQLDI *sqldi, int pdbVersion)
{
LOGIN  *login=sqldi->data;
gchar   *sqlStr;
int   ret=0, i;
MYSQL  *conn = mngDBConn(sqldi, GETDBCONN);
for (i=pdbVersion; 
i<MINIMUM_PDB_VERSION;  
)
{
i++;      
ret = upgradePQLXMETAdb(conn, i);
if (ret != PQLXSUCCESS)
{
fprintf(stdout, "There was a problem Upgrading the PQLXMETA Database to version 0.%d\n", i);
fprintf(stdout, "\t\t\t\t\t\tCheck the .err file for details.\n");
break;
}
else
{
fprintf(stdout, "PQLXMETA Database Successfully Upgraded to version 0.%d\n", i);
}
}
if (ret != PQLXSUCCESS)
return ret;
login->data.dbVersion = i;
sqlStr = g_strdup_printf(SQL_PDBVERSION_UPD, login->data.dbVersion);
if (mysql_query(conn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
}
free(sqlStr); bug15752(conn);
return ret;
}
