#include <unistd.h>
#include <my_global.h>
#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
static char *opt_host_name = NULL;  
static char *opt_user_name = NULL;  
static char *opt_password = NULL;  
static unsigned int opt_port_num = 0; 
static char *opt_socket_name = NULL;  
static char *opt_db_name = NULL;   
static unsigned int conn_timeout=MYSQLTIMEOUT; 
extern gboolean debugOUTPUT;
int metaVersionCheck(SQLDI *sqldi, MYSQL **conn);
int dbVersionCheck(SQLDI *sqldi, MYSQL **conn);
static int setUser(char *userName)
{
int userT = NONE;
if (!strcmp(userName, PQLXSRVR))
{
userT = SRVR;
}
if (!strcmp(userName, PQLXCLNT))
{
userT = CLNT;
}
if (!strcmp(userName, PQLXADMIN))
{
userT = ADMIN;
}
return userT;
}
int db_conn(int REQ_TYPE, SQLDI *sqldi)
{
int ret=PQLXSUCCESS, i;
gchar *sqlStr;
MYSQL **conn;
static gboolean firstTime=TRUE;
int   connectAttempts;
my_bool  resetFlag = TRUE;
int   netReadTimeout = 90;
switch(REQ_TYPE)
{
case DBMAINTRUNNING:
{ 
LOGIN  *login=sqldi->data;
ret = PQLXSUCCESS;
if (checkDBMaintExec(login->keys.dbname))
{
ret = DBMAINT_RUNNING;
break;
}
MYSQL *conn = mngDBConn(sqldi, GETDBCONN);
sqlStr = g_strdup_printf(SQL_PSDIDX_91M,
login->keys.dbname, login->keys.dbname);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
}
break;
case CONNECT:
{ 
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
LOGIN  *login=sqldi->data;
gboolean initialExecution;
myutype = setUser(login->keys.username);
if (firstTime && opt_host_name)
{ 
free(opt_host_name);
free(opt_user_name);
free(opt_password);
free(opt_db_name);
free(dbName);
free(myuname);
}
opt_host_name = g_strdup(login->keys.hostname);
opt_user_name = g_strdup(login->keys.username);
opt_password = g_strdup(login->keys.password);
opt_db_name = g_strdup(login->keys.dbname);
conn = &connG[0];
(*conn) = mysql_init(NULL);
if (conn == NULL)
{
fprintf (stderr, "mysql_init() failed (probably out of memory)\n");
ret = FAILURE;
}
mysql_options((*conn),MYSQL_OPT_CONNECT_TIMEOUT,(const char *) &conn_timeout);
connectAttempts = 0;
while(connectAttempts < MAXDBRETRIES)
{ 
if (mysql_real_connect((*conn), opt_host_name, opt_user_name, opt_password,
opt_db_name, opt_port_num, opt_socket_name, 
CLIENT_COMPRESS | CLIENT_MULTI_STATEMENTS) != NULL)
{
break;
}
usleep(1000);
connectAttempts++;
}
if (connectAttempts >= MAXDBRETRIES)
{
fprintf (stderr, "Connection request to the PQLX database failed using the following:\n");
fprintf (stderr, "\tHOSTNAME - [ %s ]\n\tDATABASE - [ %s ]\n\tUSERNAME - [ %s ]\n",
opt_host_name, opt_db_name, opt_user_name);
fprintf (stderr, " MySQL Error: %s\n", mysql_error((*conn)));
fprintf (stderr, " If all connection info is correct, please verify database server is running and try again...\n");
mysql_close((*conn)); (*conn) = NULL;
ret = FAILURE;
break;
}
mysql_options((*conn),MYSQL_OPT_RECONNECT,(const void *) &resetFlag);
sqlStr = g_strdup_printf(SQL_SET_READTIMEOUT, netReadTimeout);
ret = db_exec_sql(*conn, sqlStr);
sqlStr = g_strdup_printf(SQL_SET_MODE_NUS);
ret = db_exec_sql(*conn, sqlStr);
cpu[USERCPU] = login->keys.numCPUs;
cpu[ALLCPU] = get_ncpu_pqlx();
dbName = g_strdup(login->keys.dbname);  
keepAliveReg(0, CLEARKEEPALIVE);   
for (i=0;i<MAXDBCONNS;i++)
dbConns[i] = FALSE;      
for(i=1;i<MAXSQRCONNS;i++)
connG[i] = NULL;      
switch(myutype)
{
case CLNT: 
{
if (firstTime)
{ 
sqlStr = g_strdup_printf(SQL_DBVERSION, dbName);
if (mysql_query((*conn), sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error((*conn)));
mysql_close ((*conn)); (*conn) = NULL;
ret = FAILURE;
}
free(sqlStr);
res_set = mysql_store_result((*conn));
row = mysql_fetch_row(res_set);
login->data.dbVersion = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
firstTime = FALSE;
}
dbVersion = login->data.dbVersion;
sqlStr = g_strdup_printf(SQL_SRVR_DONE, SRVRINIT);
if (mysql_query((*conn), sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error((*conn)));
mysql_close ((*conn)); (*conn) = NULL;
ret = FAILURE;
}
free(sqlStr);
res_set = mysql_store_result((*conn));
row = mysql_fetch_row(res_set);
initialExecution = atoi(row[0]);
bug15752((*conn)); 
mysql_free_result(res_set);  res_set = NULL;
switch (initialExecution)
{
case 1:
ret = SRVR_NOT_READY;
if (dbName)
{
free(dbName);
dbName = NULL;
}
break;
case 0:
keepAliveReg(0, REGISTERKEEPALIVE);
break;
}
}
break;
case SRVR:
{
if (firstTime)
{ 
ret = metaVersionCheck(sqldi, conn);
if (ret != PQLXSUCCESS)
break;
ret = dbVersionCheck(sqldi, conn);
if (ret != PQLXSUCCESS)
break;
sqlStr = g_strdup_printf(SQL_SP_SNE1);
ret = db_exec_sql((*conn), sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
bug15752(*conn);
sqlStr = g_strdup_printf(SQL_SP_SNE2, EVTQIC, EVTQIC, EVTQIC, EVTQIC, NONE, PAUSEevt);
ret = db_exec_sql((*conn), sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
bug15752(*conn);
sqlStr = g_strdup_printf(SQL_SRVR_DONE, SRVRINIT);
if (mysql_query((*conn), sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error((*conn)));
mysql_close ((*conn)); (*conn) = NULL;
ret = FAILURE;
}
free(sqlStr);
res_set = mysql_store_result((*conn));
row = mysql_fetch_row(res_set);
initialExecution = atoi(row[0]);
bug15752((*conn));
mysql_free_result(res_set); res_set = NULL;
switch (initialExecution)
{
case 1:
login->data.initialExecution = TRUE;
break;
case 0:
login->data.initialExecution = FALSE;
break;
}
sqldi->descr.tableData = LOGEXECTBL;
insertData((*conn), sqldi);
keepAliveReg(0, REGISTERKEEPALIVE);
firstTime = FALSE;
#if 0
code moved to above, cant execute until after dbMaint is done
sqlStr = g_strdup_printf(SQL_PSDIDX_91M,
dbName, dbName);
ret = db_exec_sql(*conn, sqlStr); bug15752(*conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
#endif
}
}
break;
case ADMIN:
{
gboolean metaDB = FALSE;
if (!strcmp(dbName, PQLXMETADB))
{
metaDB = TRUE;  
}
if (firstTime)
{ 
ret = metaVersionCheck(sqldi, conn);
if (ret != PQLXSUCCESS)
break;
if (!metaDB)
{ 
ret = dbVersionCheck(sqldi, conn);
if (ret != PQLXSUCCESS)
break;
}
}
}
break;
}
}
break;
case RECONNECT:
{ 
conn = &connG[sqldi->args.call.connNum];
(*conn) = mysql_init(NULL);
if ((*conn) == NULL)
{
fprintf(stderr, "mysql_init() failed (probably out of memory)\n");
ret = FAILURE;
}
connectAttempts = 0;
while(connectAttempts < MAXDBRETRIES)
{ 
if (mysql_real_connect((*conn), opt_host_name, opt_user_name, opt_password,
opt_db_name, opt_port_num, opt_socket_name, 
CLIENT_COMPRESS | CLIENT_MULTI_STATEMENTS) != NULL)
{
break;
}
usleep(1000);
connectAttempts++;
}
if (connectAttempts >= MAXDBRETRIES)
{
fprintf(stderr, "Re-Connection request to the PQLX database failed using the following:\n");
fprintf (stderr, "\tHOSTNAME - [ %s ]\n\tDATABASE - [ %s ]\n\tUSERNAME - [ %s ]\n",
opt_host_name, opt_db_name, opt_user_name);
fprintf (stderr, " MySQL Error: %s\n", mysql_error((*conn)));
fprintf (stderr, " If all connection info is correct, please verify database server is running and try again...\n");
mysql_close((*conn)); (*conn) = NULL;
ret = FAILURE;
break;
}
mysql_options((*conn),MYSQL_OPT_RECONNECT,(const void *) &resetFlag);
sqlStr = g_strdup_printf(SQL_SET_READTIMEOUT, netReadTimeout);
ret = db_exec_sql(*conn, sqlStr);
if (sqldi->args.call.connNum == LOGCONN)
break;
switch(myutype)
{
case CLNT:
sqlStr = g_strdup_printf(SQL_PSDTMP_TMPMK, TMPTBLIDX, TMPTBLCNT);
ret = db_exec_sql(*conn, sqlStr); bug15752(*conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
fprintf(stderr, "Unable to create temporary table\n");
break;
}
sqlStr = g_strdup_printf(SQL_KEYTMP_TMPMK, KEYTMPTBL);
ret = db_exec_sql(*conn, sqlStr); bug15752(*conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
fprintf(stderr, "Unable to create temporary table\n");
break;
}
break;
}
}
break;
case DISCONNECT:
{
gchar *sqlStr;
conn = &connG[0];
if (!(*conn))
break;
switch(myutype)
{
case CLNT:
{ 
sqlStr = g_strdup_printf(SQL_PSDTMP_DROP,
tmpTblNm[IDX1][LONGNM],
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX2][LONGNM],
tmpTblNm[CNT2][LONGNM]);
ret = db_exec_sql(*conn, sqlStr); bug15752(*conn);
g_slist_free(systemPDFdb);
systemPDFdb = NULL;
firstTime = TRUE;
}
break;
case ADMIN:
firstTime = TRUE;  
case SRVR:
break;
}
if (dbName)
{ 
switch(myutype)
{ 
case ADMIN:
{
gboolean metaDB = FALSE;
if (!strcmp(dbName, PQLXMETADB))
{
metaDB = TRUE;  
}
if (metaDB)  
break;
}
case CLNT:
case SRVR:
sqlStr = g_strdup_printf(SQL_USER_LOCK, dbName);
ret = db_exec_sql((*conn), sqlStr); bug15752((*conn));
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_REG_USER, myuname, 
myipaddr, eTypes[LOGOUTEVT], uTypes[myutype]);
ret = db_exec_sql((*conn), sqlStr);  bug15752((*conn));
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_USER_UNLOCK, dbName);
ret = db_exec_sql((*conn), sqlStr);  bug15752((*conn));
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
sqldi->event.errorNO = SQL_FAILURE;
break;
}
break;
}
}
for(i=1;i<MAXSQRCONNS;i++)
{
if (connG[i])
{
keepAliveReg(i, DEREGISTERKEEPALIVE);
mysql_close(connG[i]);
connG[i] = NULL;
}
}
}
break;
case DISCONNECTSNGL:
{
conn = &connG[sqldi->args.call.connNum];
if (!(*conn))
break;
keepAliveReg(sqldi->args.call.connNum, DEREGISTERKEEPALIVE);
mysql_close((*conn));
}
break;
case METADATA:
{   
static gboolean first = TRUE;
MYSQL *localConn;
LOGIN *login=sqldi->data;
SERVERDBS *srvrDB= sqldi->data2;
DBLST *dbListing;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
char *opt_host_name = NULL;  
char *opt_user_name = NULL;  
char *opt_password = NULL;  
char *opt_db_name = NULL;
opt_host_name = login->keys.hostname;
opt_user_name = login->keys.username;
opt_password = login->keys.password;
opt_db_name = g_strdup(PQLXMETADB);
localConn = mysql_init(NULL);
if (localConn == NULL)
{
fprintf (stderr, "mysql_init() failed (probably out of memory)\n");
ret = FAILURE;
}
mysql_options(localConn,MYSQL_OPT_CONNECT_TIMEOUT,(const char *) &conn_timeout);
connectAttempts = 0;
while(connectAttempts < MAXDBRETRIES)
{ 
if (mysql_real_connect(localConn, opt_host_name, opt_user_name, opt_password,
opt_db_name, opt_port_num, opt_socket_name, 
CLIENT_COMPRESS | CLIENT_MULTI_STATEMENTS) != NULL)
{
break;
}
usleep(1000);
connectAttempts++;
}
if (connectAttempts >= MAXDBRETRIES)
{
fprintf(stderr, "Re-Connection request to the PQLX database failed using the following:\n");
fprintf (stderr, "\tHOSTNAME - [ %s ]\n\tDATABASE - [ %s ]\n\tUSERNAME - [ %s ]\n",
opt_host_name, opt_db_name, opt_user_name);
fprintf (stderr, " MySQL Error: %s\n", mysql_error(localConn));
fprintf (stderr, " If all connection info is correct, please verify database server is running and try again...\n");
mysql_close(localConn); localConn = NULL;
free(opt_db_name);
ret = FAILURE;
break;
}
free(opt_db_name);
mysql_options(localConn ,MYSQL_OPT_RECONNECT,(const void *) &resetFlag);
sqlStr = g_strdup_printf(SQL_SET_READTIMEOUT, netReadTimeout);
ret = db_exec_sql(localConn, sqlStr);
if (first)
{ 
metaVersionCheck(sqldi, &localConn);
first = FALSE;
}
switch(sqldi->descr.tableData)
{
case SRVRDBSL:
sqlStr = g_strdup(SQL_SRVR_DBSL);
break;
case SRVRDBSR:
sqlStr = g_strdup(SQL_SRVR_DBSR);
break;
case SRVRDBLST:
sqlStr = g_strdup_printf(SQL_SRVR_DBLST, login->keys.dbname);
break;
default:
return FAILURE;
break;
}
if (mysql_query(localConn, sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(localConn));
return FAILURE;
}
free(sqlStr);
res_set = mysql_store_result(localConn);
while((row=mysql_fetch_row(res_set)) != NULL)
{
dbListing = calloc(1, sizeof(DBLST));
dbListing->dbName = g_strdup(row[0]);
dbListing->organisation = g_strdup(row[1]);
dbListing->description = g_strdup(row[2]);
dbListing->techAdminName = g_strdup(row[3]);
dbListing->techAdminEmail = g_strdup(row[4]);
dbListing->dataAdminName = g_strdup(row[5]);
dbListing->dataAdminEmail = g_strdup(row[6]);
dbListing->type = g_strdup(row[7]);
dbListing->access = g_strdup(row[8]);
dbListing->adminPWord = g_strdup(row[9]); 
dbListing->dbVersion = atoi(row[10]);
dbListing->typeI = atoi(row[11])-1;
dbListing->accessI = atoi(row[12])-1;
dbListing->hint = g_strdup(row[13]);
srvrDB->data.dbsList = g_slist_append(srvrDB->data.dbsList, dbListing);
}
srvrDB->data.srvrName = g_strdup(login->keys.hostname);
mysql_free_result(res_set); res_set = NULL;
mysql_close (localConn);
}
break;
}
return ret;
}
void mngDBConnClose()
{
int i;
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
for (i=1; i < MAXPERSISTENT; i++)
{
if (!connG[i])
continue;
sqldi.args.call.connNum = i;
db_conn(DISCONNECTSNGL, &sqldi);
connG[sqldi.args.call.connNum] = NULL;   
dbConns[sqldi.args.call.connNum] = FALSE;  
}
}
GStaticMutex myDBMutex = G_STATIC_MUTEX_INIT;
MYSQL *mngDBConn(SQLDI *sqldi, int request)
{
int  i=1;
MYSQL (*conn)=NULL;
switch(sqldi->descr.tableData)
{
case PDFSTATLINES:
return NULL;  
break;
}
switch (sqldi->args.sqr)
{
case 0:  
sqldi->args.call.connNum = 0;
switch(request)
{
case GETDBCONN:
conn = connG[sqldi->args.call.connNum];
dbConns[sqldi->args.call.connNum] = TRUE;     
break;
case RLSDBCONN:  
dbConns[sqldi->args.call.connNum] = FALSE;
break;
case RESETDBCONN:
db_conn(DISCONNECTSNGL, sqldi);
connG[sqldi->args.call.connNum] = NULL;  
g_static_mutex_lock(&myDBMutex); 
dbConns[sqldi->args.call.connNum] = FALSE; 
g_static_mutex_unlock(&myDBMutex);
break;
}
break;
case LOGCONN: 
{
switch(request)
{
case GETDBCONN:
{
conn = connG[LOGCONN];
sqldi->args.call.connNum = LOGCONN;
if (conn == NULL)
{
db_conn(RECONNECT, sqldi);
conn = connG[LOGCONN];
}
keepAliveReg(sqldi->args.call.connNum, DEREGISTERKEEPALIVE); 
}
break;
case RLSDBCONN:  
keepAliveReg(sqldi->args.call.connNum, REGISTERKEEPALIVE);
break;
case RESETDBCONN:
db_conn(DISCONNECTSNGL, sqldi);
connG[LOGCONN] = NULL;  
break;
}
}
break;
default: 
switch(request) 
{
case GETDBCONN:
g_static_mutex_lock(&myDBMutex);
while(dbConns[i++]&&(i<MAXSQRCONNS));
dbConns[--i] = TRUE;     
g_static_mutex_unlock(&myDBMutex);
conn = connG[i];
sqldi->args.call.connNum = i;
keepAliveReg(sqldi->args.call.connNum, DEREGISTERKEEPALIVE); 
if (conn == NULL)
{ 
db_conn(RECONNECT, sqldi);
conn = connG[sqldi->args.call.connNum];
}
break;
case DISDBCONN:
conn = NULL;
if (!sqldi->args.call.connNum)
break;
db_conn(DISCONNECTSNGL, sqldi);
connG[sqldi->args.call.connNum] = NULL;   
g_static_mutex_lock(&myDBMutex); 
dbConns[sqldi->args.call.connNum] = FALSE; 
g_static_mutex_unlock(&myDBMutex); 
break;
case RLSDBCONN:
conn = NULL;
if (!sqldi->args.call.connNum)
break;
if (sqldi->args.call.connNum > MAXPERSISTENT)
{
db_conn(DISCONNECTSNGL, sqldi);
connG[sqldi->args.call.connNum] = NULL;  
}
else 
keepAliveReg(sqldi->args.call.connNum, REGISTERKEEPALIVE); 
g_static_mutex_lock(&myDBMutex); 
dbConns[sqldi->args.call.connNum] = FALSE; 
g_static_mutex_unlock(&myDBMutex);
break;
case RESETDBCONN:
db_conn(DISCONNECTSNGL, sqldi);
connG[sqldi->args.call.connNum] = NULL;   
g_static_mutex_lock(&myDBMutex); 
dbConns[sqldi->args.call.connNum] = FALSE; 
g_static_mutex_unlock(&myDBMutex);
break;
}
break;
}
return conn;
}
int metaVersionCheck(SQLDI *sqldi, MYSQL **conn)
{
char   *sqlStr;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
int   pdbVersion, ret = PQLXSUCCESS;
LOGIN  *login = sqldi->data;
sqlStr = g_strdup_printf(SQL_PDBVERSION_G0);
if (mysql_query((*conn), sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error((*conn)));
mysql_close ((*conn)); (*conn) = NULL;
ret = FAILURE;
}
free(sqlStr);
res_set = mysql_store_result((*conn));
row = mysql_fetch_row(res_set);
pdbVersion = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
if (pdbVersion == 1)
{ 
sqlStr = g_strdup_printf(SQL_PDBVERSION_G1);
if (mysql_query((*conn), sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error((*conn)));
mysql_close ((*conn)); (*conn) = NULL;
ret = FAILURE;
}
free(sqlStr);
res_set = mysql_store_result((*conn));
row = mysql_fetch_row(res_set);
pdbVersion = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
}
else 
pdbVersion = -1;
login->data.pdbVersion = pdbVersion;
if (MINIMUM_PDB_VERSION > pdbVersion)
{ 
ret = pdb_upgrade(sqldi, pdbVersion);
}
return ret;
}
int dbVersionCheck(SQLDI *sqldi, MYSQL **conn)
{
char   *sqlStr;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
int   ret = PQLXSUCCESS;
LOGIN  *login = sqldi->data;
if (!strcmp(dbName, PQLXMETADB)) 
return PQLXSUCCESS;    
sqlStr = g_strdup_printf(SQL_DBVERSION, dbName);
if (mysql_query((*conn), sqlStr) != 0)
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error((*conn)));
mysql_close ((*conn)); (*conn) = NULL;
ret = FAILURE;
}
free(sqlStr);
res_set = mysql_store_result((*conn));
row = mysql_fetch_row(res_set);
login->data.dbVersion = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
if (MINIMUM_DB_VERSION > login->data.dbVersion)
{ 
sqldi->args.dataEvent = DBUPGRADE;
ret = db_upgrade(sqldi);
}
dbVersion = login->data.dbVersion;
return ret;
}
