#include <mysql.h>
#include <glib.h>
#include <errmsg.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
gboolean keepAliveSend(int *connNum)
{
SQLDI sqldi;
if (dbConns[*connNum] == TRUE)
return FALSE;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = SYSKEEPALIVE;
sqldi.args.call.connNum = *connNum;
_db_system(connG[sqldi.args.call.connNum], &sqldi);
return TRUE;
}
void keepAliveReg(int connNum, int action)
{
static guint keepAliveID[MAXDBCONNS];
static int connNums[MAXDBCONNS];
GSource *keepAliveSource;
switch(action)
{
case CLEARKEEPALIVE:
{ 
int i;
for (i=0;i<MAXDBCONNS;i++)
keepAliveID[i] = 0;
}
break;
case REGISTERKEEPALIVE:
{
connNums[connNum] = connNum;
if (keepAliveID[connNum])
{
keepAliveSource = g_main_context_find_source_by_id(NULL, keepAliveID[connNum]);
if (keepAliveSource)
g_source_destroy(keepAliveSource);
}
keepAliveID[connNum] = g_timeout_add(KEEPALIVETIME, (GSourceFunc) keepAliveSend, &connNums[connNum]);
}
break;
case DEREGISTERKEEPALIVE:
{
if (keepAliveID[connNum])
{
keepAliveSource = g_main_context_find_source_by_id(NULL, keepAliveID[connNum]);
if (keepAliveSource)
g_source_destroy(keepAliveSource);
keepAliveID[connNum] = 0;
}
}
break;
}
}
int db_exec_sql(MYSQL *conn, char *sqlStr)
{
int ret;
if (!conn)
{
fprintf(stderr, "Cannot execute sql '%s' since conn is NULL!\n", sqlStr);
free(sqlStr);
return FAILURE;
}
switch (mysql_query(conn, sqlStr))
{
case 0:  
ret = PQLXSUCCESS;
break;
default:
{
ret = SQL_FAILURE;
switch(mysql_errno(conn))
{
case CR_SERVER_LOST:
case CR_SERVER_GONE_ERROR:
{ 
SQLDI sqldi;
int connNum;
for (connNum = 0;
connNum < MAXDBCONNS;
connNum++)
{ 
if (conn == connG[connNum])
break;
}
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.call.connNum = connNum;
sqldi.args.sqr = connNum;
mngDBConn(&sqldi, RESETDBCONN);
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "MySQL Connection is gone, Resetting for next call.\n");
}
break;
default:
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
fflush(stderr);
break;
}
}
break;
}
free(sqlStr);
return ret;
}
#if 0
int db_exec_sql(MYSQL *conn, char *sqlStr)
{
int ret = PQLXSUCCESS;
if (!conn)
{
fprintf(stderr, "Cannot execute sql '%s' since conn is NULL!\n", sqlStr);
free(sqlStr);
return FAILURE;
}
if (mysql_query(conn, sqlStr))
{
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
fflush(stderr);
ret = SQL_FAILURE;
}
free(sqlStr);
return ret;
}
#endif
gint findSysPDF(SYSPDFDEF *s1, gpointer k)
{
int pdfKey = GPOINTER_TO_INT(k);
return (s1->pdfKey - pdfKey);
}
void bug15752(MYSQL *conn)
{ 
MYSQL_RES *res_set=NULL;
res_set = mysql_store_result(conn);
do { } while (!mysql_next_result(conn));
if(res_set) mysql_free_result(res_set); 
}
gboolean isPDFchn(char *channel)
{ 
gboolean ret = FALSE;
GSList  *PDFchnI;
PDFCFG  *pdfCFG;
for(PDFchnI=PDFchn;
PDFchnI && !ret;
PDFchnI=g_slist_next(PDFchnI))
{
pdfCFG = PDFchnI->data;
if(!strncmp(channel, pdfCFG->chn, 2))
ret = TRUE;
}  
return ret;
}
void getPSDCFG(MYSQL *conn, PDFREQ *pdfReq)
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gchar   *sqlStr=NULL;
int  chnKey = pdfReq->keys.chnKey, ret;
GSList *PDFcfgI;
PDFCFG *pdfCFG = NULL;
for(PDFcfgI = PDFcfg;
PDFcfgI;
PDFcfgI=g_slist_next(PDFcfgI))
{
pdfCFG = PDFcfgI->data;
if(pdfCFG->chnKey == chnKey)
break;
}
if (!PDFcfgI)
{ 
sqlStr = g_strdup_printf(SQL_PDF_YBDS,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
pdfCFG = calloc(1, sizeof(PDFCFG));
pdfCFG->chnKey = chnKey;
pdfCFG->yBounds[YMIN] = atoi(row[0]);
pdfCFG->yBounds[YMAX] = atoi(row[1]);
pdfCFG->type = atoi(row[2]);
PDFcfg = g_slist_prepend(PDFcfg, pdfCFG);
mysql_free_result(res_set); res_set = NULL;
}
if (pdfCFG)
{
pdfReq->keys.yBounds[YMIN] = pdfCFG->yBounds[YMIN];
pdfReq->keys.yBounds[YMAX] = pdfCFG->yBounds[YMAX];
pdfReq->keys.type = pdfCFG->type;
}
}
void freeStr(char *str, gpointer nil)
{
if (str)
free(str);
}
int insertPSD(MYSQL *conn, SQLDI *sqldi, int chnKey, GPtrArray *strings)
{
int  ret;
char *valuesPtr, *sqlStr;
g_ptr_array_add(strings, NULL);
valuesPtr = g_strjoinv(",", (char **) strings->pdata);
sqlStr = g_strdup_printf(SQL_PSDD_INS1, dbName, chnKey, valuesPtr);
free(valuesPtr);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
g_ptr_array_foreach(strings, (GFunc) freeStr, NULL);
g_ptr_array_free(strings, TRUE);
return ret;
}
int delPSD(MYSQL *conn, int cmd, int chnKey, int trcKey, PTIME *s1, PTIME *s2)
{
int  ret;
char *sqlStr;
switch (cmd)
{
case PSDDEL_OVERLAP:
sqlStr = g_strdup_printf(SQL_PSDD_RECS,
dbName, chnKey,
dbName, chnKey,
trcKey,
s1->yr, s1->jday,
s1->hr, s1->mn,
s2->hr, s2->mn, (int) s2->sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
bug15752(conn);
break;
}
bug15752(conn);
break;
case PSDDEL_CHANNEL:
sqlStr = g_strdup_printf(SQL_PSDIDX_91P1,
dbName, chnKey,
dbName, chnKey,
dbName, dbName, chnKey,
dbName, chnKey, dbName); 
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
sqlStr = g_strdup_printf(SQL_PSDIDX_91P,
dbName, chnKey,
dbName, chnKey,
dbName, dbName, chnKey,
dbName, chnKey, dbName, 
dbName, chnKey, 
dbName, chnKey, 
dbName, dbName, chnKey, 
dbName, chnKey, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
sqlStr = g_strdup_printf(SQL_PSDOPT_INS,
dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
break;
}
return ret;
}
GSList *BLList(MYSQL *conn, int cmd)
{
static SYSBLINES blines;
GSList *list;
switch (cmd)
{
case BLLIST_INIT:
{
SQLDI sqldi;
GSList *bllist;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&blines, 0, sizeof(SYSBLINES));
sqldi.descr.tableData = SYSBLINEDEFS;
sqldi.data = &blines;
getData(conn, &sqldi);
#if 0
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
char  *sqlStr;
int   ret;
if (bllist)
{
g_slist_free(bllist);
bllist = NULL;
}
sqlStr = g_strdup_printf(SQL_BLINE_LIST, dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
list = FALSE;  
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
while ((row = mysql_fetch_row(res_set)))
{
blineDef = calloc(1, sizeof(BLINEDEF));
blineDef->blineKey = atoi(row[0]);
blineDef->name = g_strdup(row[1]);
blineDef->descr = g_strdup(row[2]);
blineDef->dir = atoi(row[3])-1;
blineDef->active = atoi(row[4])-1;
blineDef->chnKey = atoi(row[5]);
bllist = g_slist_prepend(bllist, blineDef);
}
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
#endif
bllist = blines.data.sysBLINE;
switch (g_slist_length(bllist))
{
case 0:
list = (GSList *) FALSE; 
break;
default:
list = (GSList *) TRUE;  
break;
}
}
break;
case BLLIST_FETCH:
list = blines.data.sysBLINE;;
break;
}
return list;
}
static int insertINTERP(MYSQL *conn, int blinei_pk, GSList *interpBLine)
{
int  ret;
char *valuesPtr, *sqlStr, *str;
GPtrArray *strings;
PSDDATA *psdData;
GSList *iter;
for (iter = interpBLine, strings = g_ptr_array_new();
iter;
iter = g_slist_next(iter))
{ 
psdData = iter->data;
str = g_strdup_printf("(%d,%.10f,%d)", blinei_pk, 
psdData->period, psdData->power);
g_ptr_array_add(strings, str);
}
g_ptr_array_add(strings, NULL);
valuesPtr = g_strjoinv(",", (char **) strings->pdata);
sqlStr = g_strdup_printf(SQL_INTERP_INSDATA, dbName, valuesPtr);
free(valuesPtr);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
g_ptr_array_foreach(strings, (GFunc) freeStr, NULL);
g_ptr_array_free(strings, TRUE);
return ret;
}
static BLINEINTERP *interpolate(MYSQL *conn, int bline_pk, int chnKey, int psdKey, int sampInt)
{
MYSQL_RES *res_set;
MYSQL_ROW row;
char   *sqlStr;
GSList  *psdPeriods = NULL, *blinePeriods = NULL, *interpBLine = NULL;
GSList  *psdIter, *blineIter1, *blineIter2, *iter;
PSDDATA  *psdData, *blineData, *interpData, *periodBLINE1, *periodBLINE2;
BLINEINTERP *blineInterp;
float  perMAX, periodPSD, blinePerStart, blinePerEnd;
int   ret, blinei_pk;
sqlStr = g_strdup_printf(SQL_PSD_PERIODS,
dbName, chnKey, psdKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
return NULL;
res_set = mysql_store_result(conn);
while ((row = mysql_fetch_row(res_set)))
{
psdData = calloc(1, sizeof(PSDDATA));
psdData->period = atof(row[0]);
psdPeriods = g_slist_prepend(psdPeriods, psdData);
}
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_BLINE_PERIODS,
dbName, bline_pk);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
return NULL;
res_set = mysql_store_result(conn);
while ((row = mysql_fetch_row(res_set)))
{
blineData = calloc(1, sizeof(PSDDATA));
blineData->period = atof(row[0]);
blineData->power = atoi(row[1]);
blinePeriods = g_slist_prepend(blinePeriods, blineData);
}
mysql_free_result(res_set); res_set=NULL;
periodBLINE1 = blinePeriods->data;
blinePerStart = periodBLINE1->period;
periodBLINE2 = (g_slist_last(blinePeriods))->data;
blinePerEnd = periodBLINE2->period;
for(psdIter = psdPeriods;
psdIter;
psdIter = g_slist_next(psdIter))
{
psdData = psdIter->data;
periodPSD = psdData->period;
if (periodPSD < blinePerStart)  
continue;
if (periodPSD > blinePerEnd)   
break;
for (blineIter1 = blinePeriods, blineIter2 = g_slist_next(blinePeriods);
blineIter2;
blineIter1 = blineIter2, blineIter2 = g_slist_next(blineIter2))
{ 
periodBLINE1 = blineIter1->data;
periodBLINE2 = blineIter2->data;
if (periodPSD == periodBLINE1->period)
{ 
periodBLINE2 = periodBLINE1;  
break;
}
if (periodPSD > periodBLINE1->period &&
periodPSD < periodBLINE2->period)
{ 
break;
}
}
interpData = calloc(1, sizeof(PSDDATA));
if (periodBLINE1 == periodBLINE2)
{ 
interpData->period = periodPSD;
interpData->power = periodBLINE1->power;
}
else
{ 
interpData->period = periodPSD;
interpData->power = periodBLINE1->power + (((periodPSD - periodBLINE1->period) *
(periodBLINE2->power - periodBLINE1->power)) /
(periodBLINE2->period - periodBLINE1->period));
}
interpBLine = g_slist_append(interpBLine, interpData);
}
for (iter = psdPeriods;
iter;
iter = g_slist_next(iter))
{ 
free(iter->data);
}
g_slist_free(psdPeriods);
for (iter = blinePeriods;
iter;
iter = g_slist_next(iter))
{ 
free(iter->data);
}
g_slist_free(blinePeriods); 
psdData = g_slist_last(interpBLine)->data;
perMAX = psdData->period;
sqlStr = g_strdup_printf(SQL_INTERP_MAKE,
dbName, bline_pk, sampInt, perMAX);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
return NULL;
blinei_pk = mysql_insert_id(conn);
bug15752(conn);
ret = insertINTERP(conn, blinei_pk, interpBLine);
if (ret != PQLXSUCCESS)
return NULL;
blineInterp = calloc(1, sizeof(BLINEINTERP));
blineInterp->blinei_pk = blinei_pk;
blineInterp->ttlPeriods = g_slist_length(interpBLine);
for (iter = interpBLine;
iter;
iter = g_slist_next(iter))
{ 
free(iter->data);
}
g_slist_free(interpBLine); 
return (blineInterp);
}
GStaticMutex blineMutex = G_STATIC_MUTEX_INIT;
BLINEINTERP *BLInterp(MYSQL *conn, int bline_pk, int chnKey, int psdKey, int sampInt, float perMAX)
{
MYSQL_RES *res_set;
MYSQL_ROW row;
BLINEINTERP *blineInterp;
char  *sqlStr;
int   ret;
g_static_mutex_lock(&blineMutex);
sqlStr = g_strdup_printf(SQL_BLINE_INTERP,
dbName, dbName, 
bline_pk, sampInt, perMAX);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
bug15752(conn); 
blineInterp = NULL;
goto BLInterpExit;
}
res_set = mysql_store_result(conn);
switch(mysql_num_rows(res_set))
{
case 0:
{ 
bug15752(conn); 
mysql_free_result(res_set); res_set=NULL;
blineInterp = interpolate(conn, bline_pk, chnKey, psdKey, sampInt);
}
break;
default:
row = mysql_fetch_row(res_set);
blineInterp = calloc(1, sizeof(BLINEINTERP));
blineInterp->blinei_pk = atoi(row[0]);
blineInterp->ttlPeriods = atoi(row[1]);
bug15752(conn); 
mysql_free_result(res_set); res_set=NULL;
break;
}
BLInterpExit:
g_static_mutex_unlock(&blineMutex);
return blineInterp;
}
#define TMPPSFILE "/tmp/pqlx.pstmp"
gboolean checkDBMaintExec(char *dbName)
{ 
char  *psCmd, *psArgs;
int  instances;
gboolean running = FALSE;
FILE *fp=NULL; 
#if defined LINUX
psArgs = g_strdup_printf("-ef");
#elif defined SOLARIS
psArgs = g_strdup_printf("-ef");
#elif defined MAC
psArgs = g_strdup_printf("aex");
#endif
psCmd = g_strdup_printf("ps %s | grep -v PID | grep -v grep | grep %s | grep %s | wc -l >%s",
psArgs, PQLXDBMAINT, dbName, TMPPSFILE);
system(psCmd);
free(psArgs);
free(psCmd);
fp = fopen(TMPPSFILE, "r");
if (!fp)
{ 
goto checkDBMaintExecExit;
}
if ((fscanf(fp, "%d", &instances)) != 1)
{ 
goto checkDBMaintExecExit;
}
if (instances > 0)
running = TRUE;
checkDBMaintExecExit:
if (fp) fclose(fp);
remove(TMPPSFILE);
return running;
}
void PSDTblProc(MYSQL *conn, int chnKey)
{
char *sqlStr;
sqlStr = g_strdup_printf(SQL_PSDIDX_MKTBL, dbName, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDD_MKTBL, dbName, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDFD_MK, dbName, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDFSH_MK, dbName, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDFSS_MK, dbName, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_BLINE_TBLMK, dbName, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENT_PUTNP, PSDIDX, chnKey, 0, chnKey);
db_exec_sql(conn, sqlStr); bug15752(conn);
}
