#include <time.h>
#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
int get_julday(int month, int day, int year);
#define AND(a) if (g_slist_length(a) > 0) a = g_slist_append(a, g_strdup(" AND "))
#define OR(a) if (g_slist_length(a) > 0) a = g_slist_append(a, g_strdup(" OR "))
static char *makeSubWhere(float *criteria)
{
int  i;
char *whereClause;
GSList *wheres=NULL;
for(i=MAXNUMPDFREQCRIT-1;i>=0;i--)
{ 
switch(i)
{
case PDFREQ_PERIODE: 
if (criteria[i]) 
{
if (criteria[PDFREQ_PERIODE] == 
criteria[PDFREQ_PERIODS])
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_PRD, 
(criteria[i-1]-.001), 
(criteria[i]+.001)));
}
else
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_PRD, 
criteria[i-1]-.001, 
criteria[i]+.001));
}
}
i--; 
break;
case PDFREQ_POWERE:  
if (criteria[i]) 
{
if (criteria[PDFREQ_POWERE] == criteria[PDFREQ_POWERS])
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_PWRP, 
(int) criteria[i-1]));
}
else
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_PWRR, 
(int) criteria[i],
(int) criteria[i-1]));
}
}
i--; 
break;
}
}
switch (g_slist_length(wheres))
{
case 0:  
whereClause = NULL;
break;
default:
{
int  numArgs, i;
GSList *iter;
gchar **whereStr;
numArgs = g_slist_length(wheres)+1;
whereStr = calloc(numArgs, sizeof(gchar *));
for(iter = wheres, i=0;
iter;
iter = g_slist_next(iter), i++)
{
whereStr[i] = iter->data;
}
whereStr[i] = NULL;
whereClause = g_strjoinv(NULL, whereStr);
FREESTRINGS(whereStr);
g_slist_free(wheres); wheres = NULL;
}
break;
}
return (whereClause);
}
static char *makeMainWhere(int chnKey, int sysPdfKey, char **sysPDFB, float *criteria, int reqType)
{
int  i;
SYSPDFDEF *sysPDFdef;
gboolean sysPDF = FALSE;
char  *whereClause;
GSList  *wheres=NULL, *sysPDFiter=NULL;
if (sysPdfKey > 0)
{
sysPDFiter = g_slist_find_custom(systemPDFdb, GINT_TO_POINTER(sysPdfKey), 
(GCompareFunc) findSysPDF);
if (sysPDFiter)
{
sysPDF = TRUE;
sysPDFdef = sysPDFiter->data;
}
}
switch (sysPDF)
{ 
case TRUE:  
wheres = g_slist_append(wheres, g_strdup_printf(SQL_SYSPDF_EPOCH,
sysPDFB[STARTDT],
sysPDFB[ENDDT]));
switch (sysPDFdef->type)
{
case REQRANGE:
switch(sysPDFdef->year)
{
case -1: 
break;  
default:
AND(wheres);
wheres = g_slist_append(wheres, 
g_strdup_printf(SQL_SYSPDF_YRB, 
sysPDFdef->year*-1));
break;
}
break;
case REQAGO:
{
AND(wheres);
wheres = g_slist_append(wheres,
g_strdup_printf(SQL_SYSPDF_AGOS,
sysPDFB[ENDDT], 
sysPDFdef->dayStart*-1));
AND(wheres);
wheres = g_slist_append(wheres,
g_strdup_printf(SQL_SYSPDF_AGOE,
sysPDFB[ENDDT], 
sysPDFdef->dayEnd*-1));
}
break;
}
break;
case FALSE:  
switch(reqType)
{ 
case REQRANGE:
case REQFREQ:
case REQAGO:
for(i=MAXNUMPDFREQCRIT-1;i>=0;i--)
{ 
switch(i)
{
case PDFREQ_HRSTARTM: 
if (criteria[i] || criteria[i-1]) 
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_HRS, (int) criteria[i-1],
(int) criteria[i]));
}
i--;
break;
case PDFREQ_HRENDM:  
if (criteria[i] || criteria[i-1]) 
{
if (criteria[PDFREQ_HRSTARTH] > 
criteria[PDFREQ_HRENDH])
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_HRSE, 
(int) criteria[i-1],
(int) criteria[i], 
(int) criteria[PDFREQ_HRSTARTH],
(int) criteria[PDFREQ_HRSTARTM]));
i=PDFREQ_HRSTARTH; 
}
else
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_HRE, 
(int) criteria[i-1],
(int) criteria[i]));
i--; 
}
}
break;
}
}
break;
}
switch(reqType)
{ 
case REQRANGE2:
{
int jdayE = get_julday((int) criteria[PDFREQ_DYENDM], (int) criteria[PDFREQ_DYENDD], (int) criteria[PDFREQ_YREND]);
int jdayS = get_julday((int) criteria[PDFREQ_DYSTARTM], (int) criteria[PDFREQ_DYSTARTD], (int) criteria[PDFREQ_YRSTART]); 
int daysBtwn = jdayE - jdayS;
switch (daysBtwn)
{
case 0:  
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ2_DAY0,
(int) criteria[PDFREQ_YRSTART],
(int) criteria[PDFREQ_DYSTARTM],
(int) criteria[PDFREQ_DYSTARTD],
(int) criteria[PDFREQ_HRSTARTH],
(int) criteria[PDFREQ_HRSTARTM],
(int) criteria[PDFREQ_HRSTARTS],
(int) criteria[PDFREQ_HRENDH],
(int) criteria[PDFREQ_HRENDM],
(int) criteria[PDFREQ_HRENDS]));
break;
default: 
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ2_BEG,
(int) criteria[PDFREQ_YRSTART],
(int) criteria[PDFREQ_DYSTARTM],
(int) criteria[PDFREQ_DYSTARTD],
(int) criteria[PDFREQ_HRSTARTH],
(int) criteria[PDFREQ_HRSTARTM],
(int) criteria[PDFREQ_HRSTARTS]));
OR(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ2_END,
(int) criteria[PDFREQ_YREND],
(int) criteria[PDFREQ_DYENDM],
(int) criteria[PDFREQ_DYENDD],
(int) criteria[PDFREQ_HRENDH],
(int) criteria[PDFREQ_HRENDM],
(int) criteria[PDFREQ_HRENDS]));
if (daysBtwn > 1)
{ 
OR(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ2_BTWN,
(int) criteria[PDFREQ_YRSTART],
(int) criteria[PDFREQ_DYSTARTM],
(int) criteria[PDFREQ_DYSTARTD],
(int) criteria[PDFREQ_YREND],
(int) criteria[PDFREQ_DYENDM],
(int) criteria[PDFREQ_DYENDD]));
}
break;
}
}
break;
case REQRANGE:
case REQFREQ:
for(i=MAXNUMPDFREQCRIT-1;i>=0;i--)
{ 
switch(i)
{
case PDFREQ_YRSTART:
if (criteria[i]) 
{
if (criteria[PDFREQ_DYSTARTM])
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_DYS, 
(int) criteria[i],
(int) criteria[PDFREQ_DYSTARTM],
(int) criteria[PDFREQ_DYSTARTD]));
}
else
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_YRS, 
(int) criteria[i]));
}
}
break;
case PDFREQ_YREND:
if (criteria[i])
{
if (criteria[PDFREQ_DYSTARTM])
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_DYE, 
(int) criteria[i],
(int) criteria[PDFREQ_DYENDM],
(int) criteria[PDFREQ_DYENDD]));
}
else
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_YRE, 
(int) criteria[i]));
}
}
break;
case PDFREQ_DYSTARTD: 
if ((criteria[i] || criteria[i-1]) &&
!(criteria[PDFREQ_YRSTART]))
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_DYSR, (int) criteria[i-1],
(int) criteria[i]));
i--; 
}
break;
case PDFREQ_DYENDD:  
if (criteria[i] || criteria[i-1]) 
{ 
if ((criteria[i] || criteria[i-1]) &&
!(criteria[PDFREQ_YREND]))
{ 
if ((criteria[PDFREQ_DYSTARTM] > 
criteria[PDFREQ_DYENDM]) ||
((criteria[PDFREQ_DYSTARTM] == 
criteria[PDFREQ_DYENDM]) && 
(criteria[PDFREQ_DYSTARTD] > 
criteria[PDFREQ_DYENDD])))
{ 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_DYSER, (int) criteria[i-1],
(int) criteria[i],
(int) criteria[PDFREQ_DYSTARTM],
(int) criteria[PDFREQ_DYSTARTD]));
i=PDFREQ_DYSTARTM; 
}
else
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_DYER, (int) criteria[i-1],
(int) criteria[i]));
i--; 
}
}
}
break;
case PDFREQ_FREQED:
if (reqType != REQFREQ)
break;
if (criteria[i]) 
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_FREQED, 
(int) criteria[PDFREQ_YRSTART],
(int) criteria[PDFREQ_DYSTARTM],
(int) criteria[PDFREQ_DYSTARTD],
(int) (criteria[i] + 
criteria[i+1]),
(int) criteria[i]));
}
break;
}
}
break;
case REQAGO:
for(i=MAXNUMPDFREQCRIT-1;i>=0;i--)
{ 
switch(i)
{
case PDFREQ_DYSTARTD: 
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_AGOS, 
dbName, chnKey,
(int) criteria[i]));
break;
case PDFREQ_DYENDD: 
if(criteria[i])
{
AND(wheres);
wheres = g_slist_append(wheres, g_strdup_printf(SQL_REQ_AGOE, 
dbName, chnKey,
(int) criteria[i]));
}
break;
}
}
break;
}
break;
}
switch (g_slist_length(wheres))
{
case 0:  
whereClause = NULL;
break;
default:
{
int  numArgs;
GSList *iter;
gchar **whereStr;
numArgs = g_slist_length(wheres)+1;
whereStr = calloc(numArgs, sizeof(gchar *));
for(iter = wheres, i=0;
iter;
iter = g_slist_next(iter), i++)
{
whereStr[i] = iter->data;
}
whereStr[i] = NULL;
whereClause = g_strjoinv(NULL, whereStr);
FREESTRINGS(whereStr);
g_slist_free(wheres); wheres = NULL;
}
break;
}
return (whereClause);
}
char *makeWhere(int subType, WHEREARGS *whereArgs)
{
char *whereG = NULL;
switch(subType)
{
case PDFDETAILREQ:
whereG = makeMainWhere(whereArgs->chnKey, whereArgs->sysPdfKey, 
whereArgs->sysPDFB, whereArgs->criteria, 
whereArgs->reqType);
break;
case PDFSUBREQ:
whereG = makeSubWhere(whereArgs->criteria);
break;
}
if (!whereG)
whereG = g_strdup("");
return(whereG);
}
