#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
enum {
NTWGLBL,
NTWPDF
};
static int makeCHNList(MYSQL_RES *res_set, int which)
{
MYSQL_ROW row;
GSList  **chnList=NULL;
int   i, j;
char  prevNm[3][12] = { "", "", ""};
GNode  *nodeI[3]={NULL, NULL, NULL};
NSLCDATA *nodeD=NULL;
int   chniCnt=0;
if (!res_set)
return 0;
switch(which)
{
case NTWGLBL:
chnList = &ntw;
break;
case NTWPDF:
chnList = &ntwPDF;
break;
}
while((row=mysql_fetch_row(res_set)) != NULL)
{
for(i=0;i<3;i++)
{ 
if(strcmp(prevNm[i], row[i*2]))
{ 
nodeD = (NSLCDATA*) calloc(1, sizeof(NSLCDATA));
strcpy(nodeD->name, row[i*2]);     
nodeD->id = atoi(row[i*2+1]);     
strcpy(prevNm[i], row[i*2]);     
if (!(i))
{ 
nodeI[i] = g_node_new(nodeD);
*chnList = g_slist_prepend(*chnList, nodeI[i]);
}
else
{ 
nodeI[i] = g_node_insert_data(nodeI[i-1], -1, nodeD);
}
for(j=i+1;j<3;j++)
{ 
prevNm[j][0]=1;
}
}
}
nodeD = (NSLCDATA*) calloc(1, sizeof(NSLCDATA));
strcpy(nodeD->name, row[6]);     
sprintf(nodeD->fullname, "%s.%s.%s.%s", row[0], row[2], row[4], row[6]);
nodeD->id = atoi(row[7]);      
g_node_insert_data(nodeI[2], -1, nodeD);
chniCnt++;
}
return chniCnt;
}
int initDB(MYSQL *conn, SQLDI *sqldi)
{
int  ret=PQLXSUCCESS;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gchar *sqlStr;
LOGIN *login=sqldi->data;
{ 
PDFCFG *pdfCFG;
GSList *PDFchnI;
if (PDFchn)
{ 
for(PDFchnI=PDFchn;PDFchnI;PDFchnI=g_slist_next(PDFchnI))
{
pdfCFG = PDFchnI->data;
free(pdfCFG->chn);
free(pdfCFG);
}
g_slist_free(PDFchn);
PDFchn = NULL;
for(PDFchnI=PDFcfg;PDFchnI;PDFchnI=g_slist_next(PDFchnI))
{
free(PDFchnI->data);
}
g_slist_free(PDFcfg);
PDFcfg = NULL;
}
sqlStr = g_strdup_printf(SQL_PSD_CFG);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return FAILURE;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)) != NULL)
{
pdfCFG = calloc(1, sizeof(PDFCFG));
pdfCFG->chn = g_strdup(row[0]);
pdfCFG->yBounds[YMIN] = atoi(row[1]);
pdfCFG->yBounds[YMAX] = atoi(row[2]);
pdfCFG->type = atoi(row[3]);
PDFchn = g_slist_prepend(PDFchn, pdfCFG);
}
mysql_free_result(res_set); res_set = NULL;
}
switch(myutype)
{
case CLNT: 
switch(login->keys.stnXDays)
{
case 0:
sqlStr = g_strdup_printf(SQL_NSLC_GETALLSTNS);
break;
default: 
sqlStr = g_strdup_printf(SQL_NSLC_GETLIVESTNS, login->keys.stnXDays);
break;
}
if (stnSQL)
free(stnSQL);
stnSQL = g_strdup(sqlStr);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
return FAILURE;
}
sqlStr = g_strdup_printf(SQL_NSLC_GETLIVE);
break;
case ADMIN: 
case SRVR: 
sqlStr = g_strdup_printf(SQL_NSLC_GETALL);
break;
}
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return FAILURE;
}
res_set = mysql_store_result(conn);
login->data.numChn = makeCHNList(res_set, NTWGLBL);
mysql_free_result(res_set); res_set = NULL;
if (myutype == CLNT &&
!login->data.numChn)
return (NO_STATIONS);
if (MINIMUM_DB_VERSION >= 2)
{ 
SQLDI sqldi;
SYSPDFS sysPDFdefs;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&sysPDFdefs, 0, sizeof(SYSPDFS));
sqldi.data = &sysPDFdefs;
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = SYSPDFDEFS;
ret = getData(conn, &sqldi);
systemPDFdb = sysPDFdefs.data.sysPDF;
}
switch(myutype)
{
case CLNT:
{
char *svNm=NULL;
gboolean successful = FALSE;
TTNAME *phase;
TTMODEL *model;
gboolean models;
switch(login->keys.stnXDays)
{
case 0:
sqlStr = g_strdup_printf(SQL_NSLC_PSDGET);
break;
default: 
sqlStr = g_strdup_printf(SQL_NSLC_PSDGET_X, login->keys.stnXDays);
break;
}
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return FAILURE;
}
res_set = mysql_store_result(conn);
(void) makeCHNList(res_set, NTWPDF);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_PDBVERSION_G0);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return FAILURE;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
models = atoi(row[0]) == 1 ? TRUE : FALSE;
mysql_free_result(res_set); res_set = NULL;
if (models)
{
sqlStr = g_strdup_printf(SQL_MODEL_GETNM);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return FAILURE;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
if (!svNm ||
strcmp(svNm, row[0]))
{ 
model = calloc(1, sizeof(TTMODEL));
model->name = g_strdup(row[0]);
model->key = atoi(row[1]);
login->data.models = g_slist_prepend(login->data.models, model);
svNm = model->name;
}
phase = calloc(1, sizeof(TTNAME));
phase->name = g_strdup(row[2]);
phase->key = atoi(row[3]);
model->phases = g_slist_prepend(model->phases, phase);
}
mysql_free_result(res_set); res_set = NULL;
}
else
{
login->data.models = NULL;
}
while(!successful)
{
struct timeval tv;
struct timezone tz;
int  tmpTblID;
gettimeofday(&tv, &tz);
srand(tv.tv_usec); 
tmpTblID = (int) ((float) 10000000 * rand()/(RAND_MAX+1.0));
tmpTblNm[IDX1][LONGNM] = g_strdup_printf(TMPTBLNM, dbName, tmpTblID, IDXTBL, TMPTBL1);
tmpTblNm[CNT1][LONGNM] = g_strdup_printf(TMPTBLNM, dbName, tmpTblID, CNTTBL, TMPTBL1);
tmpTblNm[IDX2][LONGNM] = g_strdup_printf(TMPTBLNM, dbName, tmpTblID, IDXTBL, TMPTBL2);
tmpTblNm[CNT2][LONGNM] = g_strdup_printf(TMPTBLNM, dbName, tmpTblID, CNTTBL, TMPTBL2);
sqlStr = g_strdup_printf(SQL_PSDTMP_MK, 
tmpTblNm[IDX1][LONGNM],
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX2][LONGNM],
tmpTblNm[CNT2][LONGNM]);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{ 
continue;
}
successful = TRUE;
}
sqlStr = g_strdup_printf(SQL_KEYTMP_TMPMK, KEYTMPTBL);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case SRVR: 
{ 
sqlStr = g_strdup_printf(SQL_PSD2TMP_TMPMK, TRCKEYTMPTBL);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVTQIC_TMPMK, EVTQIC);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
}
return ret;
}
int db_data(SQLDI *sqldi)
{
int   ret=PQLXSUCCESS;
MYSQL  *conn = mngDBConn(sqldi, GETDBCONN);
switch(sqldi->args.dataEvent)
{
case INIT:
ret = initDB(conn, sqldi);
break;
case INSERT_DATA:
insertData(conn, sqldi);
break;
case UPDATE_DATA:
if (sqldi->event.id)
{ 
updateByEvent(conn, sqldi);
}
else
{ 
updateByData(conn, sqldi);
}
break;
case GET_DATA:
ret = getData(conn, sqldi);
while( sqldi->args.call.errorNO && 
sqldi->args.call.cnt < MAXDBRETRIES)
{ 
mngDBConn(sqldi, DISDBCONN);
conn = mngDBConn(sqldi, GETDBCONN);
ret = getData(conn, sqldi);
}
if (sqldi->args.call.cnt >= MAXDBRETRIES)
{
fprintf(stderr, "Attempted to re-establish database connection %d times and re-request.\n",
MAXDBRETRIES);
fprintf(stderr, "\tAll attempts have failed: Cannot continue since connection to database is lost or corrupt.\n\n");
db_conn(DISCONNECT, sqldi);
exit(-1);
}
break;
}
return ret;
}
