#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
gint32 passcal_htoe(PTIME *t, gboolean convertJuls);
int getData(MYSQL *conn, SQLDI *sqldi)
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gchar   *sqlStr=NULL;
int   i, ret=PQLXSUCCESS;
switch(sqldi->descr.tableData)
{
case STNINFO:
case DTBNDRY:
case STNPDF:
case EVENTINFOTBL:
case TTMODELTBL:
case INSTRTBL:
case CHNMETAINFOLIST:   
getDataSTN(conn, sqldi);
break;
case DBLISTING:
{ 
DBLST *dbListing = sqldi->data;
sqlStr = g_strdup_printf(SQL_SRVR_DBLST,
dbListing->dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
if ((row=mysql_fetch_row(res_set)) != NULL)
{
dbListing->organisation = g_strdup(row[1]);
dbListing->description = g_strdup(row[2]);
dbListing->techAdminName = g_strdup(row[3]);
dbListing->techAdminEmail = g_strdup(row[4]);
dbListing->dataAdminName = g_strdup(row[5]);
dbListing->dataAdminEmail = g_strdup(row[6]);
dbListing->type = g_strdup(row[7]);
dbListing->access = g_strdup(row[8]);
dbListing->adminPWord = g_strdup(row[9]);
dbListing->dbVersion = atoi(row[10]);
dbListing->typeI = atoi(row[11])-1;
dbListing->accessI = atoi(row[12])-1;
dbListing->hint = g_strdup(row[13]);
}
mysql_free_result(res_set); res_set = NULL; bug15752(conn);
}
break;
case PNGWWWDEF:
{ 
GSList **pngs = sqldi->data;
PNGWWW *pngWWW, *pdfWWW;
sqlStr = g_strdup_printf(SQL_PNGWWW,
dbName, dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
pngWWW = calloc(1, sizeof(PNGWWW));
pngWWW->width = atoi(row[0]);
pngWWW->height = atoi(row[1]);
pngWWW->border = atoi(row[2]);
pngWWW->r = atoi(row[3]);
pngWWW->g = atoi(row[4]);
pngWWW->b = atoi(row[5]);
pngWWW->Iwidth = atoi(row[6]);
pngWWW->Iheight = atoi(row[7]);
pngWWW->Iborder = atoi(row[8]);
pngWWW->Ir = atoi(row[9]);
pngWWW->Ig = atoi(row[10]);
pngWWW->Ib = atoi(row[11]);
pngWWW->dir = g_strdup(row[12]);
pngWWW->type = atoi(row[13]);
pngWWW->name = g_strdup(row[14]);
*pngs = g_slist_append(*pngs, pngWWW);
if (pngWWW->type == SYSPDFPNG)
pdfWWW = pngWWW;
}
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SYSPDF_STATS);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row = mysql_fetch_row(res_set)))
{
for(i=0;i<TTLPDFSTATS;i++)
{ 
pdfWWW->stats[i] = atoi(row[2+i]);
}
pdfWWW->dateFmt = atoi(row[2+i]);
pdfWWW->HLNM = atoi(row[3+i]);
break;  
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case SCANTBL:
{
SCANS *scans = sqldi->data;
SCAN *scan;
sqlStr = g_strdup_printf(SQL_DIRS_GET);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
scan = calloc(1, sizeof(SCAN));
scan->keys.dirKey = atoi(row[0]);
strcpy(scan->keys.directory, row[1]);
scan->keys.scanTime = atoi(row[2]);
scans->data.scans = g_slist_append(scans->data.scans, scan);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case IDTBL:
{
IDS *ids = sqldi->data;
sqlStr = g_strdup_printf(SQL_IDS_GET, ids->keys.type, ids->data.name);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (row)
{
ids->keys.idKey = atoi(row[0]);
}
else
{
ids->keys.idKey = 0;
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case SRVRSTT:
{
SRVRSTATE *srvrState=sqldi->data;
int   evtType;
sqlStr = g_strdup_printf(SQL_SRVR_STATE);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
evtType = atoi(row[0]);
switch(evtType)
{
case TRC1evt:
srvrState->data.cntInfo[SRVRSTTMETA] = atoi(row[1]);
break;
case PSD1evt:
srvrState->data.cntInfo[SRVRSTTPSD] = atoi(row[1]);
break;
case PSD2evt:
srvrState->data.cntInfo[SRVRSTPSDOL] = atoi(row[1]);
break;
case PSDIDX:
srvrState->data.cntInfo[SRVRSTPSDIDX] = atoi(row[1]);
break;
case SYSPDF:
srvrState->data.cntInfo[SRVRSTSYSPDF] = atoi(row[1]);
break;
}
}
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SRVR_CHNICNT);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (row)
{
srvrState->data.cntInfo[SRVRSTTCHN] = atoi(row[0]);
}
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SRVR_TRCCNT);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (row)
{
srvrState->data.cntInfo[SRVRSTTTRC] = atoi(row[0]);
}
mysql_free_result(res_set); res_set = NULL;
mysql_close(conn);  connG[0] = NULL;
}
break;
case PSDCFGPOWERBOUNDS:
{
PDFREQ *pdfReq = sqldi->data;
getPSDCFG(conn, pdfReq);
}
break;
case PDFBOUNDSTBL:
{
PDFBOUNDS *pdfBounds = sqldi->data;
sqlStr = g_strdup_printf(SQL_PDF_BOUNDS,
dbName,
pdfBounds->keys.chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (row && row[0])
{
pdfBounds->data.bounds[CHNSTART].date.day = atoi(row[0]);
pdfBounds->data.bounds[CHNSTART].date.mo = atoi(row[1]);
pdfBounds->data.bounds[CHNSTART].date.yr = atoi(row[2]);
pdfBounds->data.bounds[CHNEND].date.day = atoi(row[3]);
pdfBounds->data.bounds[CHNEND].date.mo = atoi(row[4]);
pdfBounds->data.bounds[CHNEND].date.yr = atoi(row[5]);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case TRCTBL:
{
TRCKEY *trcKey = sqldi->data;
sqlStr = g_strdup_printf(SQL_TRC_KEY2, 
trcKey->keys.chni, 
trcKey->keys.trcTime.yr,
trcKey->keys.trcTime.mo,
trcKey->keys.trcTime.day,
trcKey->keys.trcTime.hr,
trcKey->keys.trcTime.mn,
trcKey->keys.trcTime.yr,
trcKey->keys.trcTime.mo,
trcKey->keys.trcTime.day,
trcKey->keys.trcTime.hr,
trcKey->keys.trcTime.mn);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (row)
{
trcKey->keys.trcKey = atoi(row[0]);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case TRCTBLNEXT:
{
TRCNEXT *trcNext = sqldi->data;
sqlStr = g_strdup_printf(SQL_TRC_NEXT, 
trcNext->keys.chnKey,
trcNext->keys.trcKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (row)
{
trcNext->data.trcKey = atoi(row[0]);
trcNext->data.filename = g_strdup(row[1]);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFDATES:
{ 
int  which = GPOINTER_TO_INT(sqldi->data2);
int  chnKey, pdfKey, *numPSDs, *numRecs, num_rows;
char **startD, **endD;
MYTIME *sTime, *eTime;
switch (which)
{ 
case PDFTBL:
{
PDFREQ *pdfReq = sqldi->data;
chnKey = pdfReq->keys.chnKey;
pdfKey = pdfReq->keys.pdfKey;
numPSDs = &pdfReq->data.numPSDs;
numRecs = &pdfReq->data.numRecs;
startD = &pdfReq->keys.sysPDFB[STARTDT];
endD = &pdfReq->keys.sysPDFB[ENDDT];
sTime = &pdfReq->data.sTime;
eTime = &pdfReq->data.eTime;
}
break;
case SPECTROTBL:
{
SPECREQ *specReq = sqldi->data;
chnKey = specReq->keys.chnKey;
pdfKey = specReq->keys.pdfKey;
numPSDs = &specReq->data.numPSDs;
numRecs = &specReq->data.numRecs;
startD = &specReq->keys.sysPDFB[STARTDT];
endD = &specReq->keys.sysPDFB[ENDDT];
sTime = NULL;
eTime = NULL;
}
break;
}
sqlStr = g_strdup_printf(SQL_PDF_PDFRNG,
chnKey,
pdfKey,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
num_rows = mysql_num_rows(res_set);
if (!num_rows)
{ 
*numPSDs = NOPSDDATA;
*numRecs = NOPSDDATA;
mysql_free_result(res_set); res_set = NULL;
break;
}
row=mysql_fetch_row(res_set);
*numPSDs = atoi(row[4]);
if (*numPSDs == NOPSDBADSR)
{ 
*numPSDs = NOPSDBADSR;
*numRecs = NOPSDBADSR;
mysql_free_result(res_set); res_set = NULL;
break;
}
if (sTime)
{
sTime->date.yr = atoi(row[0]);
sTime->date.jday = (row[1] ? atoi(row[1]) : 0);
eTime->date.yr = atoi(row[2]);
eTime->date.jday = (row[3] ? atoi(row[3]) : 0);
}
*startD = g_strdup(row[5]);
*endD = g_strdup(row[6]);
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFTBL:
{
PDFREQ  *pdfReq = sqldi->data;
PDFSTATS1 *pdfStats;
PDFHITS  *pdfHits;
int   periodNum, rowNum, ttlRows;
{ 
SQLDI sqldiL;
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = PDFDATES;
sqldiL.args.dataEvent = GET_DATA;
sqldiL.data = pdfReq;
sqldiL.data2 = GINT_TO_POINTER(PDFTBL);
getData(conn, &sqldiL);
}
if(pdfReq->data.numPSDs == NOPSDDATA)
{ 
break;
}
getPSDCFG(conn, pdfReq);
sqlStr = g_strdup_printf(SQL_PDF_QRY,
dbName,
pdfReq->keys.chnKey,
pdfReq->keys.chnKey,
pdfReq->keys.pdfKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
pdfReq->data.numRecs = mysql_num_rows(res_set);
if(!(pdfReq->data.numRecs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
mysql_free_result(res_set); res_set = NULL;
break;
}
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
for(rowNum=0; (row=mysql_fetch_row(res_set)); rowNum++)
{
pdfReq->data.pdf[rowNum].period = atof(row[0]);
pdfReq->data.pdf[rowNum].power = atoi(row[1]);
pdfReq->data.pdf[rowNum].prob = atof(row[2]);
}    
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_PDFST_STATSG,
dbName,
pdfReq->keys.chnKey,
pdfReq->keys.pdfKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
pdfReq->data.stats = calloc(1, sizeof(PDFSTATS));
pdfReq->data.stats->ttlPeriods = mysql_num_rows(res_set);
pdfReq->data.stats->stats = pdfStats = 
calloc(pdfReq->data.stats->ttlPeriods, sizeof(PDFSTATS1));
for(periodNum=0; (row=mysql_fetch_row(res_set)); periodNum++)
{
for(i=0;i<TTLPDFSTATS;i++)
{
pdfStats[periodNum].statV[i] = atoi(row[i]);
}
pdfStats[periodNum].period = atof(row[i]);
}
mysql_free_result(res_set); res_set = NULL;
pdfReq->data.statLines = stats_LINES(pdfReq->data.stats, pdfReq->keys.statistics);
sqlStr = g_strdup_printf(SQL_PDFST_HITSG,
dbName,
pdfReq->keys.chnKey,
pdfReq->keys.pdfKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
ttlRows = mysql_num_rows(res_set);
pdfHits = calloc(1, sizeof(PDFHITS));
pdfHits->pdfKey = pdfReq->keys.pdfKey;
pdfHits->ttlPeriods = pdfReq->data.stats->ttlPeriods;
pdfHits->hits = calloc(ttlRows, sizeof(PDFHITSDATA));
pdfHits->ttlRows = ttlRows;
for(rowNum=0; (row = mysql_fetch_row(res_set)); rowNum++)
{
pdfHits->hits[rowNum].period = atof(row[0]);
pdfHits->hits[rowNum].power = atoi(row[1]);
pdfHits->hits[rowNum].hits = atoi(row[2]);
}
mysql_free_result(res_set); res_set = NULL;
pdfReq->data.hits = pdfHits;
pdfReq->data.ttlEpochs = 1;  
}
break;
case PDFDATERNG:
{
PDFREQ *pdfReq = sqldi->data;
int  which = GPOINTER_TO_INT(sqldi->data2);
char  *idxTbl = tmpTblNm[which][LONGNM];
int  num_rows;
sqlStr = g_strdup_printf(SQL_PDF_PSDRNG,
dbName, pdfReq->keys.chnKey,
idxTbl, 
pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
num_rows = mysql_num_rows(res_set);
if (!num_rows)
{
ret = FAILURE;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
mysql_free_result(res_set); res_set = NULL;
break;
}
row=mysql_fetch_row(res_set);
pdfReq->data.sTime.date.yr = atoi(row[0]);
pdfReq->data.sTime.date.jday = atoi(row[1]);
pdfReq->data.eTime.date.yr = atoi(row[2]);
pdfReq->data.eTime.date.jday = atoi(row[3]);
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFPERPOW:
{
PDFREQ *pdfReq = sqldi->data;
WHEREARGS whereArgs;
char *whereG;  
whereArgs.chnKey = pdfReq->keys.chnKey;
whereArgs.sysPdfKey = pdfReq->keys.pdfKey;
whereArgs.sysPDFB = pdfReq->keys.sysPDFB;
whereArgs.criteria = pdfReq->keys.criteria;
whereArgs.reqType = pdfReq->keys.reqType;
whereG = makeWhere(PDFSUBREQ, &whereArgs);  
ADDPREFIX(whereG, PFX_AND);
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY2A,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
tmpTblNm[CNT2][LONGNM], pdfReq->reqID,
tmpTblNm[IDX2][LONGNM],
tmpTblNm[IDX1][LONGNM],
dbName, pdfReq->keys.chnKey,
pdfReq->reqID,
whereG,
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,
tmpTblNm[CNT1][LONGNM], pdfReq->reqID,
tmpTblNm[IDX1][LONGNM],
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM], pdfReq->reqID);
free(whereG);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
do { } while (!mysql_next_result(conn));
}
break;
case PDFDATE:
{
PDFREQ *pdfReq = sqldi->data;
WHEREARGS whereArgs;
char *whereG;  
gboolean doSql = TRUE;
int  which = GPOINTER_TO_INT(sqldi->data2);
whereArgs.chnKey = pdfReq->keys.chnKey;
whereArgs.sysPdfKey = pdfReq->keys.pdfKey;
whereArgs.sysPDFB = pdfReq->keys.sysPDFB;
whereArgs.criteria = pdfReq->keys.criteria;
whereArgs.reqType = pdfReq->keys.reqType;
whereG = makeWhere(PDFDETAILREQ, &whereArgs);  
switch(which)
{
case 1:
{
int sql = (g_strrstr(whereG, "z.") == NULL) 
? SQL_WOUTZ 
: SQL_WITHZ;
switch(sql)
{
case SQL_WITHZ:
ADDPREFIX(whereG, PFX_AND);
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY1Az,
tmpTblNm[IDX1][LONGNM],
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM],
pdfReq->reqID, dbName, pdfReq->keys.chnKey,
dbName, pdfReq->keys.chnKey,
whereG, 
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM], pdfReq->reqID);
break;
case SQL_WOUTZ:
if (whereG)  
ADDPREFIX(whereG, PFX_WHERE);
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY1A,
tmpTblNm[IDX1][LONGNM],
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM],
pdfReq->reqID, dbName, pdfReq->keys.chnKey,
whereG, 
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM], pdfReq->reqID);
break;
}
}
break;
case 2:
if (strlen(whereG))
{ 
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY1C,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,  
tmpTblNm[CNT2][LONGNM], pdfReq->reqID,  
tmpTblNm[IDX2][LONGNM],      
dbName, pdfReq->keys.chnKey,    
tmpTblNm[IDX1][LONGNM],      
pdfReq->reqID,
whereG,          
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,  
tmpTblNm[CNT1][LONGNM], pdfReq->reqID,  
tmpTblNm[IDX1][LONGNM],      
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,  
tmpTblNm[CNT1][LONGNM],      
tmpTblNm[IDX1][LONGNM], pdfReq->reqID);  
}
else
{
doSql = FALSE;
}
break;
}
free(whereG);
if (doSql)
{
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
bug15752(conn);
}
}
break;
case PSDIDXLOCK:
{
PDFREQ  *pdfReq = sqldi->data;
int   cmd = GPOINTER_TO_INT(sqldi->data2);
switch(cmd)
{
case PQLXLOCK:
sqlStr = g_strdup_printf(SQL_PSDIDX_LOCK,
dbName, 
pdfReq->keys.chnKey);
break;
case PQLXUNLOCK:
sqlStr = g_strdup_printf(SQL_PSDIDX_UNLCK,
dbName, 
pdfReq->keys.chnKey);
break;
}
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
bug15752(conn);
}
break;
case IDXTMPTBL1:
{
PDFREQ *pdfReq = sqldi->data, *pdfIter;
GList *iter, *disp = sqldi->data2;
int  chnKey = pdfReq->keys.chnKey;
sqldi->descr.tableData = PSDIDXLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXLOCK);
getData(conn, sqldi);
switch (pdfReq->keys.pdfType)
{
case PDFTYPE_BASELINE:
{
int  bline_fk = pdfReq->keys.bline.bline_fk, 
pct = pdfReq->keys.bline.pct;
if (!pdfReq->keys.tmpFilled)
{ 
#if 0
sqlStr = g_strdup_printf(SQL_PDF_EPOCHS,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
return ret;
}
res_set = mysql_store_result(conn);
while ((row = mysql_fetch_row(res_set)))
{
epochBounds[STARTDT] = g_strdup(row[0]);
epochBounds[ENDDT] = g_strdup(row[1]);
}
mysql_free_result(res_set); res_set=NULL;
pdfReq->keys.sysPDFB[STARTDT] = epochBounds[STARTDT];
pdfReq->keys.sysPDFB[ENDDT] = epochBounds[ENDDT];
#endif
sqlStr = g_strdup_printf(SQL_BLINE_PDF,
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,
tmpTblNm[CNT1][LONGNM], pdfReq->reqID,
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,
dbName, chnKey,
bline_fk, pct,
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM],
pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
}
pdfReq->keys.tmpFilled = TRUE;
}
break;
case PDFTYPE_SYSTEM:
case PDFTYPE_REQUEST:
if (!pdfReq->keys.tmpFilled)
{ 
if (pdfReq->keys.pdfKey > 0 ||   
pdfReq->keys.pdfKey == CUSTOMPDF) 
{
sqldi->data2 = GINT_TO_POINTER(1);    
sqldi->descr.tableData = PDFDATE;
getData(conn, sqldi);
if (pdfReq->keys.criteria[PDFREQ_PERIODE] || 
pdfReq->keys.criteria[PDFREQ_PERIODS] ||
pdfReq->keys.criteria[PDFREQ_POWERE] || 
pdfReq->keys.criteria[PDFREQ_POWERS])
{ 
sqldi->descr.tableData = PDFPERPOW;
getData(conn, sqldi);
}
if (disp)
{ 
sqldi->data2 = GINT_TO_POINTER(2);  
for(iter=g_list_previous(disp);
iter;
iter = g_list_previous(iter))
{
pdfIter = iter->data;
sqldi->data = pdfIter;
sqldi->descr.tableData = PDFDATE;
getData(conn, sqldi);
if (pdfIter->keys.criteria[PDFREQ_PERIODE] || 
pdfIter->keys.criteria[PDFREQ_PERIODS] ||
pdfIter->keys.criteria[PDFREQ_POWERE] || 
pdfIter->keys.criteria[PDFREQ_POWERS])
{ 
sqldi->descr.tableData = PDFPERPOW;
getData(conn, sqldi);
}
}
}
}
else 
{ 
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY1B,
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,
tmpTblNm[CNT1][LONGNM], pdfReq->reqID,
tmpTblNm[IDX1][LONGNM],
tmpTblNm[IDX2][LONGNM],
pdfReq->reqID,
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM],
pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
}
pdfReq->keys.tmpFilled = TRUE;
}
break;
}
sqldi->descr.tableData = PSDIDXLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXUNLOCK);
getData(conn, sqldi);
}
break;
case IDXTMPTBL2:
{
PDFREQ *pdfReq = sqldi->data;
WHEREARGS whereArgs;
char *whereG;  
if (pdfReq->keys.criteria[PDFREQ_PERIODS])
{ 
sqlStr = g_strdup_printf(SQL_PER_BD1I, 
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
tmpTblNm[IDX2][LONGNM],
pdfReq->reqID,
dbName, pdfReq->keys.chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
do { } while (!mysql_next_result(conn));
sqlStr = g_strdup_printf(SQL_PER_BD1S, 
dbName, pdfReq->keys.chnKey,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
pdfReq->keys.criteria[PDFREQ_PERIODS],
dbName,
pdfReq->keys.chnKey,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
if (!res_set)
{
fprintf(stderr, "No data returned for sql:s\n\t%s,\naborting query\n", sqlStr);
ret = FAILURE;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
}
row=mysql_fetch_row(res_set);
pdfReq->keys.criteria[PDFREQ_PERIODS] = atof(row[0]) - .000002;
mysql_free_result(res_set); 
sqlStr = g_strdup_printf(SQL_PER_BD2I, 
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
tmpTblNm[IDX2][LONGNM],
pdfReq->reqID,
dbName, pdfReq->keys.chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
do { } while (!mysql_next_result(conn));
sqlStr = g_strdup_printf(SQL_PER_BD2S, 
dbName,
pdfReq->keys.chnKey,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
pdfReq->keys.criteria[PDFREQ_PERIODE],
dbName,
pdfReq->keys.chnKey,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
if (!res_set)
{
fprintf(stderr, "No data returned for sql:s\n\t%s,\naborting query\n", sqlStr);
ret = FAILURE;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
}
row=mysql_fetch_row(res_set);
pdfReq->keys.criteria[PDFREQ_PERIODE] = atof(row[0]);
mysql_free_result(res_set); 
res_set = NULL;
}
whereArgs.chnKey = pdfReq->keys.chnKey;
whereArgs.sysPdfKey = pdfReq->keys.pdfKey;
whereArgs.sysPDFB = pdfReq->keys.sysPDFB;
whereArgs.criteria = pdfReq->keys.criteria;
whereArgs.reqType = pdfReq->keys.reqType;
whereG = makeWhere(PDFSUBREQ, &whereArgs);   
ADDPREFIX(whereG, PFX_AND);
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY2,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
tmpTblNm[CNT2][LONGNM], pdfReq->reqID,
tmpTblNm[IDX2][LONGNM],
tmpTblNm[IDX1][LONGNM],
dbName, pdfReq->keys.chnKey,
pdfReq->reqID,
whereG,
tmpTblNm[CNT2][LONGNM],
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
tmpTblNm[CNT2][LONGNM], pdfReq->reqID);
free(whereG);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
for (i=0;i<4;i++) { mysql_next_result(conn); };
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (!res_set->row_count)
{
ret = FAILURE;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
pdfReq->data.numPSDs = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
do { } while (!mysql_next_result(conn));
pdfReq->keys.tmpFilled = TRUE;
if (!(pdfReq->data.numPSDs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
break;
}
sqldi->descr.tableData = PDFDATERNG;
sqldi->data2 = GINT_TO_POINTER(IDX2);
getData(conn, sqldi);
}
break;
case PSDTBLDEL:
{
int  reqID = GPOINTER_TO_INT(sqldi->data2);
sqlStr = g_strdup_printf(SQL_PSDREQ_DEL,
tmpTblNm[IDX1][LONGNM], reqID,
tmpTblNm[CNT1][LONGNM], reqID,
tmpTblNm[IDX2][LONGNM], reqID,
tmpTblNm[CNT2][LONGNM], reqID);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case PSDTBL:
{
PDFREQ *pdfReq = sqldi->data;
PDFPERIOD pdfPeriod;
char *idxTbl, *cntTbl, *where;
int  rowNum, ttlPeriods, psdKey;
SQLDI sqldiL;
if (pdfReq->keys.fillTmp)
{ 
sqldi->descr.tableData = IDXTMPTBL1;
getData(conn, sqldi);
where = g_strdup_printf("WHERE reqID = %d", pdfReq->reqID);
sqlStr = g_strdup_printf(SQL_PSDD_CNTR,
tmpTblNm[CNT1][LONGNM], where);
free(where);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
if (!row ||      
atoi(row[0])==0)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
mysql_free_result(res_set); 
res_set = NULL;
break;
}
mysql_free_result(res_set); 
res_set = NULL;
sqldi->descr.tableData = PDFDATERNG;
sqldi->data2 = GINT_TO_POINTER(IDX1);
getData(conn, sqldi);
idxTbl = tmpTblNm[IDX1][LONGNM];
cntTbl = tmpTblNm[CNT1][LONGNM];
}
else
{ 
sqldi->descr.tableData = PDFDATERNG;
sqldi->data2 = GINT_TO_POINTER(IDX2);
getData(conn, sqldi);
idxTbl = tmpTblNm[IDX2][LONGNM];
cntTbl = tmpTblNm[CNT2][LONGNM];
}
getPSDCFG(conn, pdfReq);
where = g_strdup_printf("WHERE reqID = %d", pdfReq->reqID);
sqlStr = g_strdup_printf(SQL_PDFKEY_KEY,
idxTbl, where);
free(where);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
psdKey = atoi(row[0]);
bug15752(conn); mysql_free_result(res_set); res_set=NULL;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&pdfPeriod, 0, sizeof(PDFPERIOD));
pdfPeriod.keys.chnKey = pdfReq->keys.chnKey;
pdfPeriod.keys.psdKey = psdKey;
sqldiL.descr.tableData = PDFPERIODTTL;
sqldiL.args.dataEvent = GET_DATA;
sqldiL.data = &pdfPeriod;
getData(conn, &sqldiL);
if (sqldiL.event.errorNO)
{
sqldi->event.errorNO = sqldiL.event.errorNO;
break;
}
ttlPeriods = pdfPeriod.data.ttlPeriods;
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY3B,
cntTbl, pdfReq->reqID, 
dbName, pdfReq->keys.chnKey,
idxTbl, pdfReq->reqID); 
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
pdfReq->data.numRecs = mysql_num_rows(res_set);
if(!(pdfReq->data.numRecs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
pdfReq->data.hits = calloc(sizeof(PDFHITS), 1);
pdfReq->data.hits->hits = calloc(sizeof(PDFHITSDATA), pdfReq->data.numRecs);
pdfReq->data.hits->ttlPeriods = ttlPeriods;
pdfReq->data.hits->ttlRows = pdfReq->data.numRecs;
for(rowNum=0;(row=mysql_fetch_row(res_set)); rowNum++)
{
pdfReq->data.pdf[rowNum].period = atof(row[0]);
pdfReq->data.pdf[rowNum].power = atoi(row[1]);
pdfReq->data.pdf[rowNum].prob = atof(row[3]);
pdfReq->data.hits->hits[rowNum].period = pdfReq->data.pdf[rowNum].period;
pdfReq->data.hits->hits[rowNum].power = pdfReq->data.pdf[rowNum].power;
pdfReq->data.hits->hits[rowNum].hits = atoi(row[2]);
}
mysql_free_result(res_set);
sqlStr = g_strdup_printf(SQL_PDF_PSDCNT, 
cntTbl, pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
pdfReq->data.hits->ttlHits = pdfReq->data.numPSDs = atoi(row[0]);
mysql_free_result(res_set);
sqlStr = g_strdup_printf(SQL_PDF_EPOCHSCNT,   
pdfReq->keys.chnKey, 
pdfReq->data.sTime.date.yr,
pdfReq->data.sTime.date.jday,
pdfReq->data.eTime.date.yr,
pdfReq->data.eTime.date.jday);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
pdfReq->data.ttlEpochs = atoi(row[0]);
mysql_free_result(res_set);
if (pdfReq->data.ttlEpochs == 1)
{ 
pdfReq->data.stats = pdf_STATS(pdfReq->data.hits);
pdfReq->data.statLines = stats_LINES(pdfReq->data.stats, pdfReq->keys.statistics);
}
}
break;
case PSDTRC:
{
PSDTRCD *psdTrc = sqldi->data;
TRCLST *trc;
sqlStr = g_strdup_printf(SQL_PDF_TRCQRY,
dbName, psdTrc->keys.chnKey,
tmpTblNm[IDX2][LONGNM], psdTrc->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
psdTrc->data.numRecs = mysql_num_rows(res_set);
while((row=mysql_fetch_row(res_set)))
{
trc = calloc(1, sizeof(TRCLST));
trc->trcName = g_strdup(row[0]);
trc->stats[MAX] = atof(row[1]); 
trc->stats[MIN] = atof(row[2]); 
trc->stats[MEAN] = atof(row[3]);
trc->times[STARTTIME].date.yr = atoi(row[4]);
trc->times[STARTTIME].date.day = atoi(row[5]);
trc->times[STARTTIME].date.hr = atoi(row[6]);
trc->times[STARTTIME].date.mn = atoi(row[7]);
trc->times[STARTTIME].epochS = passcal_htoe(&trc->times[STARTTIME].date, FALSE);
trc->times[STARTTIME].date.sec = atoi(row[8]); 
trc->times[ENDTIME].date.yr = atoi(row[9]);
trc->times[ENDTIME].date.day = atoi(row[10]);
trc->times[ENDTIME].date.hr = atoi(row[11]);
trc->times[ENDTIME].date.mn = atoi(row[12]);
trc->times[ENDTIME].date.sec = atoi(row[13]);
trc->times[ENDTIME].m_secs = atoi(row[14]);
trc->times[ENDTIME].epochS = passcal_htoe(&trc->times[ENDTIME].date, FALSE) + (float) (trc->times[ENDTIME].m_secs/1000.);
trc->sampInt = strtod(row[15], (char **)NULL);
psdTrc->data.trcList = g_slist_prepend(psdTrc->data.trcList, trc);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case PSDHR:
{ 
PSDHRD *psdHr = sqldi->data;
int  trcNum = 0;
int  idx = GPOINTER_TO_INT(sqldi->data2);
sqlStr = g_strdup_printf(SQL_PDF_HRQRY,
dbName, psdHr->keys.chnKey,
tmpTblNm[idx][LONGNM], psdHr->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
psdHr->data.numRecs = mysql_num_rows(res_set);
if (psdHr->data.numRecs)
{
psdHr->data.hrList = calloc(psdHr->data.numRecs, sizeof(MYTIME *));
row=mysql_fetch_row(res_set);
psdHr->data.hrList[trcNum] = calloc(1, sizeof(MYTIME));
psdHr->data.hrList[trcNum]->date.yr = atoi(row[0]);
psdHr->data.hrList[trcNum]->date.jday = atoi(row[1]);
psdHr->data.hrList[trcNum]->date.day = psdHr->data.hrList[trcNum]->date.jday;
psdHr->data.hrList[trcNum]->date.hr = atoi(row[2]);
psdHr->data.hrList[trcNum]->date.mn = atoi(row[3]);
psdHr->data.hrList[trcNum]->epochS = passcal_htoe(&psdHr->data.hrList[trcNum]->date, FALSE);
trcNum++;
psdHr->data.length = atoi(row[4]);  
}
while((row=mysql_fetch_row(res_set)))
{
psdHr->data.hrList[trcNum] = calloc(1, sizeof(MYTIME));
psdHr->data.hrList[trcNum]->date.yr = atoi(row[0]);
psdHr->data.hrList[trcNum]->date.jday = atoi(row[1]);
psdHr->data.hrList[trcNum]->date.day = psdHr->data.hrList[trcNum]->date.jday;
psdHr->data.hrList[trcNum]->date.hr = atoi(row[2]);
psdHr->data.hrList[trcNum]->date.mn = atoi(row[3]);
psdHr->data.hrList[trcNum]->epochS = passcal_htoe(&psdHr->data.hrList[trcNum]->date, FALSE);
trcNum++;
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFHR:
{
PDFREQ *pdfReq = sqldi->data;
WHEREARGS whereArgs;
PDFPERIOD pdfPeriod;
char *whereG, *where;
int  rowNum, ttlPeriods, psdKey;
SQLDI sqldiL;        
whereArgs.chnKey = pdfReq->keys.chnKey;
whereArgs.sysPdfKey = pdfReq->keys.pdfKey;
whereArgs.sysPDFB = pdfReq->keys.sysPDFB;
whereArgs.criteria = pdfReq->keys.criteria;
whereArgs.reqType = pdfReq->keys.reqType;
whereG = makeWhere(PDFDETAILREQ, &whereArgs); 
ADDPREFIX(whereG, PFX_AND);
sqlStr = g_strdup_printf(SQL_PDF_HRPDF1,
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,
tmpTblNm[CNT1][LONGNM], pdfReq->reqID,
tmpTblNm[IDX1][LONGNM],
dbName, pdfReq->keys.chnKey,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID,
whereG,
tmpTblNm[CNT1][LONGNM],
tmpTblNm[IDX1][LONGNM], pdfReq->reqID,
tmpTblNm[IDX2][LONGNM], pdfReq->reqID);
free(whereG);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
bug15752(conn);
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDF_HRPDF2,
tmpTblNm[CNT1][LONGNM], pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
row=mysql_fetch_row(res_set);
if (!res_set->row_count)
{
ret = FAILURE;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
pdfReq->data.numPSDs = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
pdfReq->keys.tmpFilled = TRUE;
if (!(pdfReq->data.numPSDs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
break;
}
getPSDCFG(conn, pdfReq);
where = g_strdup_printf("WHERE reqID = %d ", pdfReq->reqID);
sqlStr = g_strdup_printf(SQL_PDFKEY_KEY,
tmpTblNm[IDX1][LONGNM], where);
free(where);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
psdKey = atoi(row[0]);
bug15752(conn); mysql_free_result(res_set); res_set=NULL;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&pdfPeriod, 0, sizeof(PDFPERIOD));
pdfPeriod.keys.chnKey = pdfReq->keys.chnKey;
pdfPeriod.keys.psdKey = psdKey;
sqldiL.descr.tableData = PDFPERIODTTL;
sqldiL.args.dataEvent = GET_DATA;
sqldiL.data = &pdfPeriod;
getData(conn, &sqldiL);
if (sqldiL.event.errorNO)
{
sqldi->event.errorNO = sqldiL.event.errorNO;
bug15752(conn);
break;
}
ttlPeriods = pdfPeriod.data.ttlPeriods;
sqlStr = g_strdup_printf(SQL_PDF_PSDRNG,
dbName, pdfReq->keys.chnKey,
tmpTblNm[IDX1][LONGNM], 
pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
if (!res_set)
{
fprintf(stderr, "No data returned for sql:s\n\t%s,\naborting\n", sqlStr);
ret = FAILURE;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
}
row=mysql_fetch_row(res_set);
pdfReq->data.sTime.date.yr = atoi(row[0]);
pdfReq->data.sTime.date.jday = atoi(row[1]);
pdfReq->data.eTime.date.yr = atoi(row[2]);
pdfReq->data.eTime.date.jday = atoi(row[3]);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_PDF_PSDQRY3B,
tmpTblNm[CNT1][LONGNM], pdfReq->reqID,
dbName, pdfReq->keys.chnKey,
tmpTblNm[IDX1][LONGNM], pdfReq->reqID);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
pdfReq->data.numRecs = mysql_num_rows(res_set);
if(!(pdfReq->data.numRecs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
pdfReq->data.hits = calloc(sizeof(PDFHITS), 1);
pdfReq->data.hits->hits = calloc(sizeof(PDFHITSDATA), pdfReq->data.numRecs);
pdfReq->data.hits->ttlPeriods = ttlPeriods;
pdfReq->data.hits->ttlRows = pdfReq->data.numRecs;
for(rowNum=0;(row=mysql_fetch_row(res_set)); rowNum++)
{
pdfReq->data.pdf[rowNum].period = atof(row[0]);
pdfReq->data.pdf[rowNum].power = atoi(row[1]);
pdfReq->data.pdf[rowNum].prob = atof(row[3]);
pdfReq->data.hits->hits[rowNum].period = pdfReq->data.pdf[rowNum].period;
pdfReq->data.hits->hits[rowNum].power = pdfReq->data.pdf[rowNum].power;
pdfReq->data.hits->hits[rowNum].hits = atoi(row[2]);
}
mysql_free_result(res_set); res_set=NULL;
pdfReq->data.hits->ttlHits = pdfReq->data.numPSDs;
pdfReq->data.stats = pdf_STATS(pdfReq->data.hits);
pdfReq->data.statLines = stats_LINES(pdfReq->data.stats, pdfReq->keys.statistics);
}
break;
case PDFSTATLINES:
{
PDFREQ *pdfReq = sqldi->data;
GSList *lineI;
PDFSTATSL *line;
for(lineI = pdfReq->data.statLines; lineI; lineI = g_slist_next(lineI))
{
line = lineI->data;
free(line->line);
free(line);   
}
g_slist_free(pdfReq->data.statLines);
if (!(pdfReq->data.ttlEpochs > 1))
{ 
if (!pdfReq->data.stats)
pdfReq->data.stats = pdf_STATS(pdfReq->data.hits);
pdfReq->data.statLines = stats_LINES(pdfReq->data.stats, pdfReq->keys.statistics);
}
}
break;
case SPECTROTBL:
{
SPECREQ  *specReq = sqldi->data;
WHEREARGS whereArgs;
SPECTRODATA *spectroData;
PSDDATA  *psdData;
int   chnKey = specReq->keys.chnKey, numRows, numPers;
int   psd_fk, psdRef, dB, psd_pk, opsd_pk;
char  *whereG;
if (specReq->keys.pdfKey > 0)   
{ 
SQLDI sqldiL;
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = PDFDATES;
sqldiL.args.dataEvent = GET_DATA;
sqldiL.data = specReq;
sqldiL.data2 = GINT_TO_POINTER(SPECTROTBL);
getData(conn, &sqldiL);
if(specReq->data.numPSDs == NOPSDDATA)
{ 
break;
}
}
memset(&whereArgs, 0, sizeof(WHEREARGS));
whereArgs.chnKey = specReq->keys.chnKey;
whereArgs.sysPdfKey = specReq->keys.pdfKey;
whereArgs.sysPDFB = specReq->keys.sysPDFB;
whereArgs.criteria = specReq->keys.criteria;
whereArgs.reqType = specReq->keys.reqType;   
whereG = makeWhere(PDFDETAILREQ, &whereArgs);  
ADDPREFIX(whereG, PFX_WHERE);
sqlStr = g_strdup_printf(SQL_SPECTRO_PSD,
TMPTBLIDX, TMPTBLCNT, TMPTBLIDX, 
dbName, chnKey,
whereG,
TMPTBLCNT, TMPTBLIDX);
free(whereG);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_SPECTRO_FK,
TMPTBLIDX);
ret = db_exec_sql(conn, sqlStr);
res_set = mysql_store_result(conn);
numRows = mysql_num_rows(res_set);
if (!numRows)
{ 
specReq->data.numRecs = NOPSDDATA;
mysql_free_result(res_set); res_set = NULL;    
break;
}
row = mysql_fetch_row(res_set);
psd_fk = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SPECTRO_PSDDAY,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
specReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
specReq->data.numPSDday = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SPECTRO_YBDS,
dbName, chnKey, 
psd_fk);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
specReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
specReq->data.yBounds[YMIN] = atof(row[0]);
specReq->data.yBounds[YMAX] = atof(row[1]);
specReq->data.numPeriods = atoi(row[2]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_SPECTRO_DATA,
TMPTBLIDX,
dbName, chnKey, 
dbName, chnKey,
dbName, chnKey,
psd_fk,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
specReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
numRows = mysql_num_rows(res_set);
if (!numRows)
{
specReq->data.numRecs = NOPSDDATA;
mysql_free_result(res_set); res_set = NULL;    
break;
}
specReq->data.numRecs = numRows;
row = mysql_fetch_row(res_set);
spectroData = calloc(1, sizeof(SPECTRODATA));
specReq->data.spectro = g_list_prepend(specReq->data.spectro, spectroData);
psdData = calloc(1, sizeof(PSDDATA));
spectroData->psdRef = atoi(row[0]);
psdData->period = atof(row[1]);
dB = psdData->power = atoi(row[2]);
spectroData->psdData = g_slist_prepend(spectroData->psdData, psdData);
specReq->data.dbBounds[YMIN] = dB;
specReq->data.dbBounds[YMAX] = dB;
specReq->data.dbBounds[YMIN] = -49;
specReq->data.dbBounds[YMAX] = -201;
numPers = 1;
opsd_pk = atoi(row[3]);
while((row=mysql_fetch_row(res_set)))
{
psdRef = atoi(row[0]);
psd_pk = atoi(row[3]);
if (psd_pk != opsd_pk)
{
if (numPers != specReq->data.numPeriods)
{
specReq->data.numRecs = NOPSDBADSR;
break;
}
spectroData = calloc(1, sizeof(SPECTRODATA));
spectroData->psdRef = psdRef;
specReq->data.spectro = g_list_append(specReq->data.spectro, spectroData);
numPers = 0;
opsd_pk = psd_pk;
}
psdData = calloc(1, sizeof(PSDDATA));
psdData->period = atof(row[1]);
dB = psdData->power = atoi(row[2]);
spectroData->psdData = g_slist_prepend(spectroData->psdData, psdData);
numPers++;
if (dB < specReq->data.dbBounds[YMIN])
specReq->data.dbBounds[YMIN] = dB;
if (dB > specReq->data.dbBounds[YMAX])
specReq->data.dbBounds[YMAX] = dB;
}
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
specReq->plot.bounds[XMIN] = PSDREFABSS(specReq);
specReq->plot.bounds[XMAX] = PSDREFABSE(specReq)+1; 
if (specReq->data.numRecs == NOPSDBADSR)
{ 
GSList *iter;
GList *iter1;
for (iter1 = specReq->data.spectro;
iter1;
iter1 = g_list_next(iter1))
{
spectroData = iter1->data;
for (iter = spectroData->psdData;
iter;
iter = g_slist_next(iter))
{
free(iter->data);
}
g_slist_free(spectroData->psdData); spectroData->psdData = NULL;
free(spectroData);
}
g_list_free(specReq->data.spectro); specReq->data.spectro = NULL;
break;
}
specReq->plot.start = specReq->data.spectro;
specReq->plot.end = g_list_last(specReq->data.spectro);
specReq->data.numDivs = PSDREFPLOTE(specReq) - PSDREFPLOTS(specReq) + 1;
specReq->data.dbBounds[YMIN]--;
specReq->data.dbBounds[YMAX]++;
specReq->plot.numDivs = specReq->data.numDivs;
specReq->plot.dBRange = DBRELATIVE;
specReq->plot.replot = TRUE;
sqlStr = g_strdup_printf(SQL_SPECTRO_CNT,
TMPTBLCNT);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
specReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
specReq->data.numPSDs = atof(row[0]);
mysql_free_result(res_set); res_set = NULL;
specReq->plot.numPSDs = 0;  
sqlStr = g_strdup_printf(SQL_SPECTRO_DATES,
TMPTBLIDX, 
dbName, chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
specReq->data.numRecs = NOPSDDATA;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
specReq->data.dateBounds[STARTDT] = g_date_new_dmy(atoi(row[0]), atoi(row[1]), atoi(row[2]));
specReq->data.dateBounds[ENDDT] = g_date_new_dmy(atoi(row[3]), atoi(row[4]), atoi(row[5]));
mysql_free_result(res_set); res_set = NULL;
specReq->plot.dateBounds[STARTDT] = g_date_copy(specReq->data.dateBounds[STARTDT]);
specReq->plot.dateBounds[ENDDT] = g_date_copy(specReq->data.dateBounds[ENDDT]);
}
break;
case RESPTBL:
{
RESPFILE *resp = sqldi->data;
sqlStr = g_strdup_printf(SQL_RESP_FILE,
resp->keys.chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
if ((row = mysql_fetch_row(res_set)))
{
resp->data.fileName = g_strdup(row[0]);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case CRASHEVENTS:
{
CRASHD *crash = sqldi->data;
switch (crash->keys.which)
{
case TRCCRASH:
{
TRCLST *trcCrash;
sqlStr = g_strdup_printf(SQL_TRC_CRASH, RESP1);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
trcCrash = calloc(1, sizeof(TRCLST));
trcCrash->event = atoi(row[0]);
trcCrash->trcName = g_strdup(row[1]);
crash->data.crashList = g_slist_append(crash->data.crashList, trcCrash);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case SYSCRASH:
{
SYSLST *sysCrash;
sqlStr = g_strdup(SQL_SYS_CRASH);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
break;
}
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
sysCrash = calloc(1, sizeof(SYSLST));
sysCrash->event = atoi(row[0]);
sysCrash->chnKey = atoi(row[1]);
sysCrash->chnName = g_strdup(row[2]);
crash->data.crashList = g_slist_append(crash->data.crashList, sysCrash);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
}
sqlStr = g_strdup_printf(SQL_EVT_CLOSE, SRVR_CRASH);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
ret = FAILURE;
break;
}
}
break;
case SYSPDFPNG:
{
int  i;
PDFPNG *pdfPNG=sqldi->data;
PDFREQ *pdfReq;
sqlStr = g_strdup_printf(SQL_SYSPDF_STATS);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row = mysql_fetch_row(res_set)))
{
pdfReq = calloc(1, sizeof(PDFREQ));
pdfPNG->data.pdfReqs = g_slist_prepend(pdfPNG->data.pdfReqs, pdfReq);
pdfReq->keys.chnKey = pdfPNG->keys.chnKey;
pdfReq->keys.pdfKey = atoi(row[0]);
pdfReq->data.pdfName = g_strdup(row[1]);
for(i=0;i<strlen(pdfReq->data.pdfName);i++)
{ 
if (pdfReq->data.pdfName[i] == ' ')
{
memmove(&pdfReq->data.pdfName[i], 
&pdfReq->data.pdfName[i+1],
strlen(pdfReq->data.pdfName) - i);
i--;
}
}
for(i=0;i<TTLPDFSTATS;i++)
{ 
pdfReq->keys.statistics[i] = atoi(row[2+i]);
}
pdfReq->data.dateFmt = atoi(row[2+i]);  
}
mysql_free_result(res_set); res_set = NULL;
{ 
GSList *pdfReqIter;
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = PDFTBL;
sqldi.args.dataEvent = GET_DATA;
for(pdfReqIter = pdfPNG->data.pdfReqs; 
pdfReqIter; 
pdfReqIter = g_slist_next(pdfReqIter))
{
sqldi.data = pdfReqIter->data;
getData(conn, &sqldi);
}
}
sqlStr = g_strdup_printf(SQL_NSLC_NAMES, pdfPNG->keys.chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
pdfPNG->data.ntw = g_strdup(row[0]);
pdfPNG->data.stn = g_strdup(row[1]);
pdfPNG->data.loc = g_strdup(row[2]);
pdfPNG->data.chn = g_strdup(row[3]);
mysql_free_result(res_set); res_set = NULL;
}
break;   
case SYSSPECPNG:
{
int  i;
SPECPNG *specPNG=sqldi->data;
SPECREQ *specReq;
sqlStr = g_strdup_printf(SQL_SYSPDF_LST);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row = mysql_fetch_row(res_set)))
{
specReq = calloc(1, sizeof(SPECREQ));
specPNG->data.specReqs = g_slist_prepend(specPNG->data.specReqs, specReq);
specReq->keys.chnKey = specPNG->keys.chnKey;
specReq->keys.pdfKey = atoi(row[0]);
specReq->data.pdfName = g_strdup(row[1]);
for(i=0;i<strlen(specReq->data.pdfName);i++)
{ 
if (specReq->data.pdfName[i] == ' ')
{
memmove(&specReq->data.pdfName[i], 
&specReq->data.pdfName[i+1],
strlen(specReq->data.pdfName) - i);
i--;
}
}
specReq->data.dateFmt = atoi(row[7]);
}
mysql_free_result(res_set); res_set = NULL; bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDTMP_TMPMK, TMPTBLIDX, TMPTBLCNT);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
{ 
GSList *specReqIter;
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = SPECTROTBL;
sqldi.args.dataEvent = GET_DATA;
for(specReqIter = specPNG->data.specReqs; 
specReqIter; 
specReqIter = g_slist_next(specReqIter))
{
sqldi.data = specReqIter->data;
getData(conn, &sqldi);
}
}
sqlStr = g_strdup_printf(SQL_NSLC_NAMES, specPNG->keys.chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
specPNG->data.ntw = g_strdup(row[0]);
specPNG->data.stn = g_strdup(row[1]);
specPNG->data.loc = g_strdup(row[2]);
specPNG->data.chn = g_strdup(row[3]);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_PSDTMP_TMPDROP, TMPTBLIDX, TMPTBLCNT);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;   
case SYSPDFDEFS:
{
SYSPDFS  *sysPDFs = sqldi->data;
SYSPDFDEF *sysPDFdef;
sqlStr = g_strdup_printf(SQL_SYSPDF_LST);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row = mysql_fetch_row(res_set)))
{
sysPDFdef = calloc(1, sizeof(SYSPDFDEF));
sysPDFdef->pdfKey = atoi(row[0]);
sysPDFdef->pdfName = g_strdup(row[1]);
sysPDFdef->pdfDescr = g_strdup(row[2]);
sysPDFdef->dayStart = atoi(row[3]);
sysPDFdef->dayEnd = atoi(row[4]);
sysPDFdef->year = atoi(row[5]);
sysPDFdef->type = atoi(row[6]);
sysPDFs->data.sysPDF = g_slist_append(sysPDFs->data.sysPDF, sysPDFdef);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case SYSBLINEDEFS:
{
SYSBLINES *sysBLINEs = sqldi->data;
BLINEDEF *blineDef;
GSList  *iter;
BLINEPT  *points;
int   ptNum;
sqlStr = g_strdup_printf(SQL_BLINE_ACTIVE,
dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
while((row = mysql_fetch_row(res_set)))
{
blineDef = calloc(1, sizeof(BLINEDEF));
blineDef->blineKey = atoi(row[0]);
blineDef->name = g_strdup(row[1]);
blineDef->descr = g_strdup(row[2]);
blineDef->dir = atoi(row[3])-1;
blineDef->active = atoi(row[4])-1;
blineDef->chnKey = atoi(row[4]);
blineDef->global = (blineDef->chnKey == 0) ? TRUE : FALSE;
sysBLINEs->data.sysBLINE = g_slist_append(sysBLINEs->data.sysBLINE, blineDef);
}
mysql_free_result(res_set); res_set = NULL;
for(iter = sysBLINEs->data.sysBLINE;
iter;
iter = g_slist_next(iter))
{
blineDef = iter->data;
sqlStr = g_strdup_printf(SQL_BLINE_CNT,
dbName,
blineDef->blineKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
blineDef->lineDef.numPts = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
if (blineDef->lineDef.numPts == 0)    
continue;
points = blineDef->lineDef.points = calloc(blineDef->lineDef.numPts, sizeof(BLINEPT));
sqlStr = g_strdup_printf(SQL_BLINE_PTS,
dbName,
blineDef->blineKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
ptNum = 0;
while((row = mysql_fetch_row(res_set)))
{
points[ptNum].period = atof(row[0]);
points[ptNum].power = atof(row[1]);
ptNum++;
}
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFPERIODTTL:
{
PDFPERIOD *pdfPeriod = sqldi->data;
int   chnKey = pdfPeriod->keys.chnKey,
psdKey = pdfPeriod->keys.psdKey;
sqlStr = g_strdup_printf(SQL_PDFST_TTLPER,
dbName, chnKey,
psdKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
pdfPeriod->data.ttlPeriods = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
}
break;
case PDFMFRAME:
{
PDFREQ *pdfReq = sqldi->data;
WHEREARGS whereArgs;
PDFPERIOD pdfPeriod;
int  rowNum, psdKey;
char *whereG;
SQLDI sqldiL;
whereArgs.chnKey = pdfReq->keys.chnKey;
whereArgs.sysPdfKey = pdfReq->keys.pdfKey;
whereArgs.sysPDFB = pdfReq->keys.sysPDFB;
whereArgs.criteria = pdfReq->keys.criteria;
whereArgs.reqType = pdfReq->keys.reqType;
whereG = makeWhere(PDFDETAILREQ, &whereArgs);  
ADDPREFIX(whereG, PFX_AND);
sqlStr = g_strdup_printf(SQL_PSDD_CNTI,
TMPTBLIDX, TMPTBLCNT, TMPTBLIDX, 
dbName, pdfReq->keys.chnKey,
pdfReq->keys.chnKey,
whereG,
TMPTBLCNT, TMPTBLIDX);
free(whereG);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->args.call.cnt++;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
break;
}
sqlStr = g_strdup_printf(SQL_PSDD_CNTR, TMPTBLCNT, "");
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->args.call.cnt++;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
if (!res_set->row_count)
{
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
ret = FAILURE;
break;
}
row=mysql_fetch_row(res_set);
pdfReq->data.numPSDs = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_PSDD_QRYB,
pdfReq->data.numPSDs, 
dbName, pdfReq->keys.chnKey,
TMPTBLIDX);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->args.call.cnt++;
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
pdfReq->data.numRecs = mysql_num_rows(res_set);
if(!(pdfReq->data.numRecs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
mysql_free_result(res_set); res_set=NULL;
bug15752(conn);
break;
}
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
pdfReq->data.hits = calloc(sizeof(PDFHITS), 1);
pdfReq->data.hits->hits = calloc(sizeof(PDFHITSDATA), pdfReq->data.numRecs);
pdfReq->data.hits->ttlHits = pdfReq->data.numPSDs;
pdfReq->data.hits->ttlRows = pdfReq->data.numRecs;
for(rowNum=0;(row=mysql_fetch_row(res_set)); rowNum++)
{
pdfReq->data.pdf[rowNum].period = atof(row[0]);
pdfReq->data.pdf[rowNum].power = atoi(row[1]);
pdfReq->data.pdf[rowNum].prob = atof(row[3]);
pdfReq->data.hits->hits[rowNum].period = pdfReq->data.pdf[rowNum].period;
pdfReq->data.hits->hits[rowNum].power = pdfReq->data.pdf[rowNum].power;
pdfReq->data.hits->hits[rowNum].hits = atoi(row[2]);
}
bug15752(conn); mysql_free_result(res_set); res_set=NULL;
getPSDCFG(conn, pdfReq);
sqlStr = g_strdup_printf(SQL_PDFKEY_KEY,
TMPTBLIDX, "");
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
psdKey = atoi(row[0]);
bug15752(conn); mysql_free_result(res_set); res_set=NULL;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&pdfPeriod, 0, sizeof(PDFPERIOD));
pdfPeriod.keys.chnKey = pdfReq->keys.chnKey;
pdfPeriod.keys.psdKey = psdKey;
sqldiL.descr.tableData = PDFPERIODTTL;
sqldiL.args.dataEvent = GET_DATA;
sqldiL.data = &pdfPeriod;
getData(conn, &sqldiL);
if (sqldiL.event.errorNO)
{
sqldi->event.errorNO = sqldiL.event.errorNO;
break;
}
pdfReq->data.hits->ttlPeriods = pdfPeriod.data.ttlPeriods;
pdfReq->data.hits->ttlHits = pdfReq->data.numPSDs;
pdfReq->data.stats = pdf_STATS(pdfReq->data.hits);
pdfReq->data.statLines = stats_LINES(pdfReq->data.stats, pdfReq->keys.statistics);
}
break;
#if 0
case NEW_DATA_EXTRACT:
{
}
break;
#endif
}
return ret;
}
