#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
int getDataSTN(MYSQL *conn, SQLDI *sqldi)
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gchar   *sqlStr;
int   ret=PQLXSUCCESS;
switch(sqldi->descr.tableData)
{
case STNINFO:
{
SCRNDATA *scrnData = sqldi->data;
CHNDATA  *chnData=NULL;
TRCDATA  *trcData=NULL;
GLAPS  *glapPtr;
int   svChnKey=-1, chnCnt=0, trcKey, svTrcKey=-1;
char  chnKeyW[1024], *chnIns, *chnWPtr;
GSList  *chnKeyL=scrnData->keys.chnKeys;
GHashTable *traceHash, *chnHash;
chnIns = g_strdup_printf(" %d", *(int*)chnKeyL->data);
chnWPtr = g_stpcpy(chnKeyW, chnIns);
free(chnIns);
for(chnKeyL=g_slist_next(chnKeyL);chnKeyL;chnKeyL=g_slist_next(chnKeyL))
{
chnIns = g_strdup_printf(", %d", *(int*)chnKeyL->data);
chnWPtr = g_stpcpy(chnWPtr, chnIns);
free(chnIns);
}
sqlStr = g_strdup_printf(SQL_STN_TRCINS,
KEYTMPTBL, KEYTMPTBL,
chnKeyW,
scrnData->keys.dates[ENDDT].date.yr,
scrnData->keys.dates[ENDDT].date.mo,
scrnData->keys.dates[ENDDT].date.day,
scrnData->keys.dates[STARTDT].date.yr,
scrnData->keys.dates[STARTDT].date.mo,
scrnData->keys.dates[STARTDT].date.day);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_STN_TRC, KEYTMPTBL);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
traceHash = g_hash_table_new(g_int_hash, g_int_equal);
chnHash = g_hash_table_new(g_int_hash, g_int_equal);
scrnData->data.chnInfo = chnHash;
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
if(atoi(row[0]) != svChnKey)
{ 
chnData = calloc(1, sizeof(CHNDATA));
chnData->keys.chnKey = atoi(row[0]);
chnData->data.sampInt = strtod(row[1], (char **)NULL);
g_hash_table_insert(chnHash, &chnData->keys.chnKey, chnData);
svChnKey = chnData->keys.chnKey;
chnCnt++;
}
trcData = calloc(1, sizeof(TRCDATA));
trcData->data.name = g_strdup_printf("%s/%s", row[2], row[3]);
sscanf(row[4], "%hd-%hd-%hd %hd:%hd:%f", 
&trcData->data.dates[STARTDT].date.yr,
&trcData->data.dates[STARTDT].date.mo,
&trcData->data.dates[STARTDT].date.day,
&trcData->data.dates[STARTDT].date.hr,
&trcData->data.dates[STARTDT].date.mn,
&trcData->data.dates[STARTDT].date.sec);
trcData->data.dates[STARTDT].m_secs = atoi(row[5]);
sscanf(row[6], "%hd-%hd-%hd %hd:%hd:%f", 
&trcData->data.dates[ENDDT].date.yr,
&trcData->data.dates[ENDDT].date.mo,
&trcData->data.dates[ENDDT].date.day,
&trcData->data.dates[ENDDT].date.hr,
&trcData->data.dates[ENDDT].date.mn,
&trcData->data.dates[ENDDT].date.sec);
trcData->data.dates[ENDDT].m_secs = atoi(row[7]);
trcData->keys.trcKey = atoi(row[8]);
trcData->data.stats[MAX] = (double) atof(row[9]);
trcData->data.stats[MIN] = (double) atof(row[10]);
trcData->data.stats[MEAN] = (double) atof(row[11]);
trcData->data.gaps = NULL; trcData->data.olaps = NULL;
trcData->display.plot = TRUE;
chnData->data.traceFiles = g_slist_prepend(chnData->data.traceFiles, trcData);
g_hash_table_insert(traceHash, &trcData->keys.trcKey, trcData);
}
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_STN_GLAP,
KEYTMPTBL);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
if(atoi(row[0]) != svTrcKey)
{ 
trcKey = atoi(row[0]);
trcData = g_hash_table_lookup(traceHash, &trcKey);
svTrcKey = trcKey;
}
if (!trcData) 
continue;
glapPtr = calloc(1, sizeof(GLAPS));
glapPtr->start = atoi(row[2]);
glapPtr->end = atoi(row[3]);
if (!strcmp(row[1], "GAP"))
{
trcData->data.gaps = g_slist_prepend(trcData->data.gaps, glapPtr);
}
else
{
trcData->data.olaps = g_slist_prepend(trcData->data.olaps, glapPtr);
}
}
mysql_free_result(res_set); res_set = NULL;
g_hash_table_destroy(traceHash);
if (dbVersion >= XML_VERSION_MIN)
{
sqlStr = g_strdup_printf(SQL_CHNMETA_GET,
chnKeyW,
scrnData->keys.dates[ENDDT].date.yr,
scrnData->keys.dates[ENDDT].date.mo,
scrnData->keys.dates[ENDDT].date.day,
scrnData->keys.dates[STARTDT].date.yr,
scrnData->keys.dates[STARTDT].date.mo,
scrnData->keys.dates[STARTDT].date.day);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
int chnKey;
CHNMETA *chnMeta;
chnKey = atoi(row[0]);
chnData = g_hash_table_lookup(chnHash, &chnKey);
chnMeta = calloc(1, sizeof(CHNMETA));
sscanf(row[1], "%hd-%hd-%hd %hd:%hd:%f", 
&chnMeta->dates[STARTDT].date.yr,
&chnMeta->dates[STARTDT].date.mo,
&chnMeta->dates[STARTDT].date.day,
&chnMeta->dates[STARTDT].date.hr,
&chnMeta->dates[STARTDT].date.mn,
&chnMeta->dates[STARTDT].date.sec);
sscanf(row[2], "%hd-%hd-%hd %hd:%hd:%f", 
&chnMeta->dates[ENDDT].date.yr,
&chnMeta->dates[ENDDT].date.mo,
&chnMeta->dates[ENDDT].date.day,
&chnMeta->dates[ENDDT].date.hr,
&chnMeta->dates[ENDDT].date.mn,
&chnMeta->dates[ENDDT].date.sec);
chnMeta->siteName = g_strdup(row[3]);
chnMeta->coords[LAT] = atof(row[4]);
chnMeta->coords[LON] = atof(row[5]);
chnMeta->location[ELEV] = (float) atof(row[6]);
chnMeta->location[DEPTH] = (float) atof(row[7]);
chnMeta->sensitivity = atof(row[8]);
chnMeta->units = g_strdup(row[9]);
chnMeta->instID = g_strdup(row[10]);
chnMeta->location[AZIMUTH] = (float) atof(row[11]);
chnMeta->location[DIP] = (float) atof(row[12]);
chnMeta->sampInt = strtod(row[13], (char **)NULL);
chnData->data.chnMETA = g_slist_append(chnData->data.chnMETA, chnMeta);
}
mysql_free_result(res_set); res_set = NULL;
}
}
break;
case DTBNDRY:
{
DATEBNDRY *dateBdry = sqldi->data;
sqlStr = g_strdup_printf(SQL_STN_DBDRY);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
if (!res_set->row_count)
{
mysql_free_result(res_set); res_set = NULL;
ret = FAILURE;
break;
}
row=mysql_fetch_row(res_set);
dateBdry->data.dates[STARTDT].date.yr = atoi(row[0]);
dateBdry->data.dates[STARTDT].date.mo = atoi(row[1]);
dateBdry->data.dates[STARTDT].date.day = atoi(row[2]);
dateBdry->data.dates[ENDDT].date.yr = atoi(row[3]);
dateBdry->data.dates[ENDDT].date.mo = atoi(row[4]);
dateBdry->data.dates[ENDDT].date.day = atoi(row[5]);
mysql_free_result(res_set); res_set = NULL;
}
break;
case STNPDF:
{
PDFREQ *pdfReq = sqldi->data;
WHEREARGS whereArgs;
PDFPERIOD pdfPeriod;
int  rowNum, psdKey;
char *whereG;
SQLDI sqldiL;
whereArgs.chnKey = pdfReq->keys.chnKey;
whereArgs.sysPdfKey = pdfReq->keys.pdfKey;
whereArgs.sysPDFB = pdfReq->keys.sysPDFB;
whereArgs.criteria = pdfReq->keys.criteria;
whereArgs.reqType = pdfReq->keys.reqType;
whereG = makeWhere(PDFDETAILREQ, &whereArgs);  
ADDPREFIX(whereG, PFX_AND);
sqlStr = g_strdup_printf(SQL_PSDD_CNTI,
TMPTBLIDX, TMPTBLCNT, TMPTBLIDX, 
dbName, pdfReq->keys.chnKey,
pdfReq->keys.chnKey,
whereG,
TMPTBLCNT, TMPTBLIDX);
free(whereG);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
free(sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDD_CNTR, TMPTBLCNT, "");
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
res_set = mysql_store_result(conn);
if (!res_set->row_count)
{
mysql_free_result(res_set); res_set = NULL;
ret = FAILURE;
break;
}
row=mysql_fetch_row(res_set);
pdfReq->data.numPSDs = atoi(row[0]);
free(sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDD_QRYB,
pdfReq->data.numPSDs, 
dbName, pdfReq->keys.chnKey,
TMPTBLIDX);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
pdfReq->data.numRecs = mysql_num_rows(res_set);
if(!(pdfReq->data.numRecs))
{ 
pdfReq->data.numPSDs = NOPSDDATA;
pdfReq->data.numRecs = NOPSDDATA;
bug15752(conn);
break;
}
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
pdfReq->data.hits = calloc(sizeof(PDFHITS), 1);
pdfReq->data.hits->hits = calloc(sizeof(PDFHITSDATA), pdfReq->data.numRecs);
pdfReq->data.hits->ttlHits = pdfReq->data.numPSDs;
pdfReq->data.hits->ttlRows = pdfReq->data.numRecs;
for(rowNum=0;(row=mysql_fetch_row(res_set)); rowNum++)
{
pdfReq->data.pdf[rowNum].period = atof(row[0]);
pdfReq->data.pdf[rowNum].power = atoi(row[1]);
pdfReq->data.pdf[rowNum].prob = atof(row[3]);
pdfReq->data.hits->hits[rowNum].period = pdfReq->data.pdf[rowNum].period;
pdfReq->data.hits->hits[rowNum].power = pdfReq->data.pdf[rowNum].power;
pdfReq->data.hits->hits[rowNum].hits = atoi(row[2]);
}
mysql_free_result(res_set); res_set=NULL;
getPSDCFG(conn, pdfReq);
sqlStr = g_strdup_printf(SQL_PDFKEY_KEY,
TMPTBLIDX, "");
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = ret;
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
psdKey = atoi(row[0]);
bug15752(conn); mysql_free_result(res_set); res_set=NULL;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&pdfPeriod, 0, sizeof(PDFPERIOD));
pdfPeriod.keys.chnKey = pdfReq->keys.chnKey;
pdfPeriod.keys.psdKey = psdKey;
sqldiL.descr.tableData = PDFPERIODTTL;
sqldiL.args.dataEvent = GET_DATA;
sqldiL.data = &pdfPeriod;
getData(conn, &sqldiL);
if (sqldiL.event.errorNO)
{
sqldi->event.errorNO = sqldiL.event.errorNO;
break;
}
pdfReq->data.hits->ttlPeriods = pdfPeriod.data.ttlPeriods;
}
break;
case EVENTINFOTBL:
{
SEISEVENTS *events = sqldi->data;
EVENTINFO *evtInfo;
sqlStr = g_strdup_printf(SQL_SEISE_GET,
events->keys.day[STNEVTYR],
events->keys.day[STNEVTMO],
events->keys.day[STNEVTDY]);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
evtInfo = calloc(1, sizeof(EVENTINFO));
evtInfo->eventID = atoi(row[0]);
evtInfo->originID = atoi(row[1]);
evtInfo->catalog = g_strdup(row[2]);
evtInfo->dtime[STNEVTYR] = atoi(row[3]);
evtInfo->dtime[STNEVTMO] = atoi(row[4]);
evtInfo->dtime[STNEVTDY] = atoi(row[5]);
evtInfo->dtime[STNEVTHR] = atoi(row[6]);
evtInfo->dtime[STNEVTMN] = atoi(row[7]);
evtInfo->dtime[STNEVTSC] = atoi(row[8]);
evtInfo->dtime[STNEVTMSC] = atoi(row[9]);
evtInfo->loc[STNEVTLAT] = atof(row[10]);
evtInfo->loc[STNEVTLON] = atof(row[11]);
evtInfo->loc[STNEVTDEP] = atof(row[12]);
evtInfo->loc[STNEVTMAG] = atof(row[13]);
evtInfo->magType = g_strdup(row[14]);
evtInfo->eventKey = atoi(row[15]);
evtInfo->description = g_strdup(row[16]);
evtInfo->timeStamp = g_strdup_printf("%s%04d", row[17], atoi(row[18]));
events->data.events = g_slist_prepend(events->data.events, evtInfo);
}
mysql_free_result(res_set); res_set=NULL;
}
break;
enum {
TTDEP,
TTDIST,
TTLTTVALS,
TTMIN=0,
TTMAX,
TTLTTBDRYS
};
case TTMODELTBL:
{
int   i, j, saveKey=-1;
char  *depth, *dist, *time;
ARRIVALS *arrivals = sqldi->data;
TTIME  *ttime;
GSList  *phase=NULL;
char  *ttvals[TTLTTVALS][TTLTTBDRYS];
sqlStr = g_strdup_printf(SQL_MODEL_GETTB,
arrivals->keys.modelKey, arrivals->keys.depth, 
arrivals->keys.modelKey, arrivals->keys.depth, 
arrivals->keys.modelKey, arrivals->keys.distance,
arrivals->keys.modelKey, arrivals->keys.distance);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
res_set = mysql_store_result(conn);
for(i=0;i<TTLTTVALS;i++)
{
for(j=0;j<TTLTTBDRYS;j++)
{
row = mysql_fetch_row(res_set);
ttvals[i][j] = g_strdup(row[0]);
}
}
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_MODEL_GETT,
arrivals->keys.modelKey, ttvals[TTDEP][TTMIN], ttvals[TTDIST][TTMIN],
arrivals->keys.modelKey, ttvals[TTDEP][TTMIN], ttvals[TTDIST][TTMAX],
arrivals->keys.modelKey, ttvals[TTDEP][TTMAX], ttvals[TTDIST][TTMIN],
arrivals->keys.modelKey, ttvals[TTDEP][TTMAX], ttvals[TTDIST][TTMAX]);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
for(i=0;i<TTLTTVALS;i++)
for(j=0;j<TTLTTBDRYS;j++)
free(ttvals[i][j]);
res_set = mysql_store_result(conn);
while((row=mysql_fetch_row(res_set)))
{
if (saveKey != atoi(row[0]))
{ 
if (phase)
{ 
arrivals->data.phases = g_slist_prepend(arrivals->data.phases, phase);
phase = NULL;
}
saveKey = atoi(row[0]);
ttime = NULL;
}
if (ttime &&
!strcmp(depth,row[2]) && 
!strcmp(dist, row[3])  
&& strcmp(time, row[4])) 
continue;
ttime = calloc(1, sizeof(TTIME));
ttime->phaseKey = atoi(row[0]); 
ttime->phaseName = g_strdup(row[1]);
ttime->depth = atof(row[2]);
ttime->distance = atof(row[3]);
ttime->ttime = atof(row[4]);
phase = g_slist_prepend(phase, ttime);
depth = row[2];
dist = row[3];
time = row[4];
}
if (phase)
{
arrivals->data.phases = g_slist_prepend(arrivals->data.phases, phase);
phase = NULL;
}
mysql_free_result(res_set); res_set=NULL;
}
break;
case INSTRTBL:
{
INSTRUMENTS *insts = sqldi->data;
INSTRUMENT *inst;
GSList  *iter;
int   chnKey;
char  *values, *valuesPtr=NULL, *valuesStr;
chnKey = GPOINTER_TO_INT(insts->keys.chnKeys->data);
values = g_strdup_printf("( %d", chnKey);
valuesStr = g_strdup(values); free(values);
for (iter = g_slist_next(insts->keys.chnKeys);
iter;
iter = g_slist_next(iter))
{
chnKey = GPOINTER_TO_INT(iter->data);
values = g_strdup_printf(", %d", chnKey); 
valuesPtr = g_strconcat(valuesStr, values, NULL);
free(values);
free(valuesStr);
valuesStr = valuesPtr;
}
valuesPtr = g_strconcat(valuesStr, ")", NULL);
free(valuesStr);
sqlStr = g_strdup_printf(SQL_CHNMETA_GETINST,
valuesPtr);
sqldi->args.call.errorNO = mysql_query(conn, sqlStr);
if (sqldi->args.call.errorNO)
{
sqldi->args.call.cnt++;
fprintf(stderr, "Unable to execute SQL '%s'\n", sqlStr);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr); free(valuesPtr);
res_set = mysql_store_result(conn);
while ((row=mysql_fetch_row(res_set)))
{
inst = calloc(1, sizeof(INSTRUMENT));
inst->chnKey = atoi(row[0]);
inst->instID = g_strdup(row[1]);
insts->data.instruments = g_slist_prepend(insts->data.instruments, inst);
}
mysql_free_result(res_set); res_set=NULL;
}
break;
case CHNMETAINFOLIST:
{
INSTIDS *instIDs = sqldi->data;
char *instID;
int  *chnKey=NULL;
instIDs->data.instIDs = g_hash_table_new_full(g_int_hash, g_int_equal, free, free);
sqldi->args.call.errorNO = mysql_query(conn, stnSQL);
bug15752(conn);
sqlStr = g_strdup(SQL_CHNMETA_LIST);
sqldi->args.call.errorNO = db_exec_sql(conn, sqlStr);
res_set = mysql_store_result(conn);
while ((row=mysql_fetch_row(res_set)))
{
if (chnKey &&
*chnKey == atoi(row[0])) 
continue;
chnKey = calloc(1, sizeof(int));
*chnKey = atoi(row[0]);
instID = g_strdup(row[1]);
g_hash_table_insert(instIDs->data.instIDs, chnKey, instID);
}
mysql_free_result(res_set); res_set=NULL; bug15752(conn);
}
break;
#if 0
case NEW_DATA_EXTRACT:
{
}
break;
#endif
}
return ret;
}
