#ifdef PQLX_THREAD_DEBUG
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>
#include <glib.h>
#include "pqlx_defs.h"
struct tm *getTime();
enum {
DBGDIRECTORY,
DBGFILE
};
FILE *dbgFP[MAXDBCONNS];
char timeStamp[15];
static gboolean mkDBG(int what, int which)
{
static char *path;
switch(what)
{
case DBGDIRECTORY:
{
char *home=getenv("HOME"), *fname;
path = g_strdup_printf("%s/.pql/debug", home);
if (mkdir(path, 0777) == -1)
{
if (errno != EEXIST)
{
fprintf(stderr, "Unable to make debug output file directory ~/.pql/debug,");
fprintf(stderr, "no debugging information will be generated.\n");
g_free(path);
return FALSE;
}
}
g_free(path);
path = g_strdup_printf("%s/.pql/debug/pqlx%s", home, timeStamp);
if (mkdir(path, 0777) == -1)
{
if (errno != EEXIST)
{
fprintf(stderr, "Unable to make debug output file directory %s,", path);
fprintf(stderr, "no debugging information will be generated.\n");
g_free(path);
return FALSE;
}
}
fname = g_strdup_printf("%s/stderr.dbg", path);
if (freopen(fname, "w", stderr)==NULL)
{
fprintf(stderr, "Unable to make debug output file directory %s,", path);
fprintf(stderr, "no debugging information will be generated.\n");
g_free(path);
g_free(fname);
return FALSE;
}
g_free(fname);
}
break;
case DBGFILE:
{
char *fname;
fname = g_strdup_printf("%s/th%d.dbg", path, which);
if ((dbgFP[which] = fopen(fname, "w")) == NULL)
{
fprintf(stderr, "Unable to make debug output file %s,", fname);
fprintf(stderr, "no debugging information will be generated from this point on.\n");
g_free(fname);
return FALSE;
}
g_free(fname);
}
break;
}
return TRUE;
}
void db_debug(SQLDI *sqldi)
{
static gboolean valid=TRUE, init=TRUE;
struct timeval tv;
char *timeS;
if (!valid)
return;
if (sqldi->descr.tableData < STNINFO || sqldi->descr.tableData > STNPDF)
{ 
return;
}
if (init)
{
struct tm *timeN;
timeN = getTime();
sprintf(timeStamp, "%d%03d%02d%02d", 
timeN->tm_year + 1900, 
timeN->tm_yday+1, 
timeN->tm_hour,
timeN->tm_min);
valid = mkDBG(DBGDIRECTORY, 0);
init = FALSE;
if (!valid)
return;
}
#if 0  
if(!dbgFP[sqldi->args.sqr])
{
valid = mkDBG(DBGFILE, sqldi->args.sqr);
if (!valid)
return;
}
gettimeofday(&tv, NULL);
timeS = g_strdup_printf("%d.%d", (int) tv.tv_sec, (int) tv.tv_usec);
fprintf(dbgFP[sqldi->args.sqr], "%s:\tdb request:", timeS);
fprintf(dbgFP[sqldi->args.sqr], "\n\tsqr: %d\n\tcallType: %d\n\tdataEvent: %d\n\ttableData: %d\n",
sqldi->args.sqr, sqldi->args.callType, sqldi->args.dataEvent, sqldi->descr.tableData);
fflush(dbgFP[sqldi->args.sqr]);
g_free(timeS);
#endif
gettimeofday(&tv, NULL);
timeS = g_strdup_printf("%d.%d", (int) tv.tv_sec, (int) tv.tv_usec);
fprintf(stderr, "%s:\tdb request:", timeS);
fprintf(stderr, "\n\tsqr: %d\n\tcallType: %d\n\tdataEvent: %d\n\ttableData: %d\n",
sqldi->args.sqr, sqldi->args.callType, sqldi->args.dataEvent, sqldi->descr.tableData);
g_free(timeS);
} 
#endif
