#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
GSList *stats_LINES(PDFSTATS *pdfStats, gboolean *statistics)
{
GSList  *lines=NULL;
PDFSTATSL *pdfStatsL;
PDFSTATSL1 *pdfStatsL1;
int   i, rowNum;
if (!pdfStats ||
!statistics)
return NULL;
for(i=0;i<TTLPDFSTATS;i++)
{
if (!statistics[i])
continue;
pdfStatsL = calloc(1, sizeof(PDFSTATSL));
pdfStatsL->statistic = i;
pdfStatsL->numPts = pdfStats->ttlPeriods;
pdfStatsL->line = pdfStatsL1 = calloc(pdfStats->ttlPeriods, sizeof(PDFSTATSL1));
lines = g_slist_append(lines, pdfStatsL);
for(rowNum = 0; rowNum < pdfStats->ttlPeriods; rowNum++)
{
pdfStatsL1[rowNum].period = pdfStats->stats[rowNum].period;
pdfStatsL1[rowNum].power = pdfStats->stats[rowNum].statV[i];
}
}
return lines;
}
PDFSTATS *pdf_STATS(PDFHITS *pdfHits)
{
PDFSTATS *pdfStats;
PDFSTATS1 *pdfStats1;
int  PCT5, PCT10, PCT25, PCT50, PCT75, PCT90, PCT95;
int  totHits, row, period, ttlPeriods, ttlRows, hitSum, maxHits;
double powerSum;
if (!pdfHits ||
!pdfHits->ttlPeriods)
{
return NULL;
}
ttlPeriods = pdfHits->ttlPeriods;
totHits = pdfHits->ttlHits;
ttlRows = pdfHits->ttlRows;
PCT5 = totHits * .05;
PCT10 = totHits * .1;
PCT25 = totHits * .25;
PCT50 = totHits * .50;
PCT75 = totHits * .75;
PCT90 = totHits * .9;
PCT95 = totHits * .95;
pdfStats = calloc(1, sizeof(PDFSTATS));
pdfStats->stats = pdfStats1 = calloc(ttlPeriods, sizeof(PDFSTATS1));
pdfStats->ttlPeriods = ttlPeriods;
for(row=0, period=0; row<ttlRows; period++)
{ 
powerSum = hitSum = maxHits = 0;
pdfStats1[period].period = pdfHits->hits[row].period;
pdfStats1[period].statV[PDFSTAT_MIN] = pdfHits->hits[row].power;
for(;
row < ttlRows &&
pdfStats1[period].period == pdfHits->hits[row].period;   
row++)
{ 
hitSum += pdfHits->hits[row].hits;  
powerSum += (pdfHits->hits[row].power * pdfHits->hits[row].hits); 
if (!pdfStats1[period].statV[PDFSTAT_P5] && hitSum > PCT5)
pdfStats1[period].statV[PDFSTAT_P5] = pdfHits->hits[row].power;
if (!pdfStats1[period].statV[PDFSTAT_P10] && hitSum > PCT10)
pdfStats1[period].statV[PDFSTAT_P10] = pdfHits->hits[row].power;
if (!pdfStats1[period].statV[PDFSTAT_P25] && hitSum > PCT25)
pdfStats1[period].statV[PDFSTAT_P25] = pdfHits->hits[row].power;
if (!pdfStats1[period].statV[PDFSTAT_MEDIAN] && hitSum > PCT50)
pdfStats1[period].statV[PDFSTAT_MEDIAN] = pdfHits->hits[row].power;
if (!pdfStats1[period].statV[PDFSTAT_P75] && hitSum > PCT75)
pdfStats1[period].statV[PDFSTAT_P75] = pdfHits->hits[row].power;
if (!pdfStats1[period].statV[PDFSTAT_P90] && hitSum > PCT90)
pdfStats1[period].statV[PDFSTAT_P90] = pdfHits->hits[row].power;
if (!pdfStats1[period].statV[PDFSTAT_P95] && hitSum > PCT95)
pdfStats1[period].statV[PDFSTAT_P95] = pdfHits->hits[row].power;
if (maxHits < pdfHits->hits[row].hits)
{
maxHits = pdfHits->hits[row].hits;
pdfStats1[period].statV[PDFSTAT_MODE] = pdfHits->hits[row].power;
}
}
pdfStats1[period].statV[PDFSTAT_MAX] = pdfHits->hits[row-1].power;
pdfStats1[period].statV[PDFSTAT_MEAN] = (int) ((double) powerSum / (double) totHits);
}
return pdfStats;
}
