#ifndef _PQLX_DB_H
#define _PQLX_DB_H

#define PQLX_DB_1 "CREATE TABLE `CHNI` ("\
"  `chni_pk` mediumint(9) NOT NULL auto_increment,"\
"  `sampRate` float unsigned NOT NULL default '0',"\
"  `lat` float NOT NULL default '0',"\
"  `lon` float NOT NULL default '0',"\
"  `startT` timestamp NOT NULL default '0000-00-00 00:00:00',"\
"  `endT` timestamp NOT NULL default '0000-00-00 00:00:00',"\
"  `nTraces` int(10) unsigned NOT NULL default '0',"\
"  `GapMax` mediumint(9) unsigned default NULL,"\
"  `GapMin` mediumint(8) unsigned default NULL,"\
"  `GapAvg` float unsigned NOT NULL default '0',"\
"  `OlapMax` mediumint(8) unsigned default NULL,"\
"  `OlapMin` mediumint(8) unsigned default NULL,"\
"  `OlapAvg` float unsigned NOT NULL default '0',"\
"  `MaxMax` int(11) default NULL,"\
"  `MaxMin` int(11) default NULL,"\
"  `MaxAvg` float NOT NULL default '0',"\
"  `MinMax` int(11) default NULL,"\
"  `MinMin` int(11) default NULL,"\
"  `MinAvg` float NOT NULL default '0',"\
"  `MeanMax` float default NULL,"\
"  `MeanMin` float default NULL,"\
"  `MeanAvg` float NOT NULL default '0',"\
"  `NTW_FK` mediumint(9) unsigned NOT NULL,"\
"  `STN_FK` mediumint(9) unsigned NOT NULL,"\
"  `LOC_FK` mediumint(9) unsigned NOT NULL,"\
"  `CHN_FK` mediumint(9) unsigned NOT NULL,"\
"  PRIMARY KEY  (`chni_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_2 "CREATE TRIGGER `CHNIDEPENDENCIES` AFTER INSERT ON `CHNI` FOR EACH ROW \n"\
"BEGIN \n"\
"	--	insert a DUMMY trace for the new channel,  \n"\
"	--  this is necessary for imported PDF's with no link back to the original trace \n"\
"	INSERT INTO TRC (CHNI_FK) VALUES (NEW.CHNI_PK); \n"\
" \n"\
"	--	insert all system (automatically computed) PDF's for the new channel \n"\
"	INSERT INTO PDFIDX (PDFCFG_FK, CHNI_FK) SELECT PDFCFG_PK, NEW.CHNI_PK FROM PDFCFG P; \n"\
" \n"\
"	--	insert the default PSD configuration parameters according to the channel name and PSDCFG entries \n"\
"	INSERT INTO PSDCFG (channel, description, minPower, maxPower, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, chni_fk) SELECT channel, description, minPower, maxPower, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, NEW.CHNI_PK FROM PSDCFG P, IDS I WHERE P.CHNI_FK = 0 AND I.IDS_PK = NEW.CHN_FK AND LEFT(I.NAME,2) = P.channel; \n"\
" \n"\
"END"

#define PQLX_DB_3 "CREATE TABLE `DIRS` ("\
"  `dir_pk` int(11) NOT NULL auto_increment,"\
"  `directory` varchar(255) NOT NULL,"\
"  `time` int(11) NOT NULL default '0',"\
"  `TYPE` enum('FILESCAN','PDFIMPORT') NOT NULL default 'FILESCAN',"\
"  `STATUS` enum('ACTIVE','INACTIVE') NOT NULL default 'ACTIVE',"\
"  PRIMARY KEY  (`dir_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_4 "CREATE TABLE `CONSTANT` ("\
"  `const_pk` mediumint(9) NOT NULL auto_increment,"\
"  `val` mediumint(9) NOT NULL default '0',"\
"  `description` varchar(250) NOT NULL default '',"\
"  `type` enum('ERRORMSG', 'LOGMSG', 'DBCONST') NOT NULL,"\
"  PRIMARY KEY  (`const_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1;"\
"LOCK TABLES `CONSTANT` WRITE;"\
"INSERT INTO `CONSTANT` (val, description, type) VALUES (100,'Out of Memory','ERRORMSG'),(101,'Unknown System Event','ERRORMSG'),(102,'Server Crash','ERRORMSG'),(103,'No Such Record','ERRORMSG'),(105,'SQL Error','ERRORMSG'),(1001,'No Response File','ERRORMSG'),(1002,'Not Enough Data','ERRORMSG'),(1003,'Files Discontinuous','ERRORMSG'),(1004,'Internal FFT Error','ERRORMSG'),(1005,'PERIOD Mismatch','ERRORMSG'),(1006,'Error Reading File','ERRORMSG'),(1007,'File Does Not Exist','ERRORMSG'),(1101,'Problem reading hour.idx File','ERRORMSG'),(1102,'Problem reading HJJJ.bin File','ERRORMSG');"\
"UNLOCK TABLES"

#define PQLX_DB_5 "CREATE TABLE `EVENTQ` ("\
"  `evtq_id` mediumint(8) unsigned NOT NULL auto_increment,"\
"  `type` mediumint(8) unsigned NOT NULL,"\
"  `typeKey` mediumint(8) unsigned NOT NULL,"\
"  `typeKey2` mediumint(8) unsigned NOT NULL default '0',"\
"  `processed` enum('UNPROC','INPROC','PROCD') NOT NULL default 'UNPROC',"\
"  `error_no` smallint(6) NOT NULL default '0',"\
"  `user_fk` mediumint(8) unsigned NOT NULL default '0',"\
"  PRIMARY KEY  (`evtq_id`),"\
"  KEY `type` (`type`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_6 "LOCK TABLES `EVENTQ` WRITE;"\
"INSERT INTO `EVENTQ` (type, processed) VALUES (1000, 'PROCD');"\
"UNLOCK TABLES;"

#define PQLX_DB_7 "CREATE TABLE `GLAP` ("\
"  `glap_pk` mediumint(9) NOT NULL auto_increment,"\
"  `trc_fk` int(10) unsigned NOT NULL,"\
"  `type` enum('GAP','OLAP') NOT NULL,"\
"  `startPt` mediumint(8) unsigned NOT NULL,"\
"  `endPt` mediumint(8) unsigned NOT NULL,"\
"  PRIMARY KEY  (`glap_pk`),"\
"  KEY `trc_fk` (`trc_fk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_8 "CREATE TABLE `IDS` ("\
"  `IDS_PK` mediumint(9) unsigned NOT NULL auto_increment,"\
"  `type` enum('NTW','STN','LOC','CHN') NOT NULL,"\
"  `name` char(12) NOT NULL default '',"\
"  `alias` char(25) default NULL,"\
"  PRIMARY KEY  (`IDS_PK`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_9 "CREATE TABLE `LOG` ("\
"  `log_pk` int(11) NOT NULL,"\
"  `user_fk` mediumint(8) unsigned default '0',"\
"  `type_fk` mediumint(8) unsigned default '0',"\
"  PRIMARY KEY  (`log_pk`),"\
"  KEY `user_fk` (`user_fk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_10 "CREATE TABLE `PSDCFG` ("\
"  `psdcfg_pk` int(11) NOT NULL auto_increment,"\
"  `channel` char(2) NOT NULL,"\
"  `description` varchar(255) NOT NULL,"\
"  `minPower` int(11) NOT NULL default '0' COMMENT 'Minimum dB',"\
"  `maxPower` int(11) NOT NULL default '0' COMMENT 'Maximum dB',"\
"  `sections` int(11) NOT NULL default '0',"\
"  `steps` int(11) NOT NULL default '0',"\
"  `duration` int(11) NOT NULL default '0' COMMENT 'Duration of one PSD, in seconds',"\
"  `dbOffset` int(11) NOT NULL default '0' COMMENT 'Added to db before output',"\
"  `maxPeriod` decimal(12,6) NOT NULL default '0' COMMENT 'center period of smoothing bins',"\
"  `binWidth` float NOT NULL default '0' COMMENT 'width of smoothing bins, fractional octave',"\
"  `gapThresh` float NOT NULL default '0' COMMENT 'max allowed gap, in sample intervals',"\
"  `units` char(4) NOT NULL default '' COMMENT 'Units of instrument response',"\
"  `lastStage` int(11) NOT NULL default '-1' COMMENT 'Last Response Stage to Remove',"\
"  `chni_fk` mediumint(9) NOT NULL,"\
"  PRIMARY KEY  (`psdcfg_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_11 "INSERT INTO `PSDCFG` (channel, description, minPower, maxPower, sections, "\
					"steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, chni_fk) "\
"VALUES "\
"('LN','PSD Configuration for LN* Channels',-200,-50,4,4,10800,0,1000,1,-1,'ACC',-1,0),"\
"('LH','PSD Configuration for LH* Channels',-200,-50,4,4,10800,0,1000,1,-1,'ACC',-1,0),"\
"('BH','PSD Configuration for BH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('BL','PSD Configuration for BL* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('BG','PSD Configuration for BG* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('HH','PSD Configuration for HH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('SH','PSD Configuration for SH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('EH','PSD Configuration for EH* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('EN','PSD Configuration for EN* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('EP','PSD Configuration for EP* Channels',-200,-50,4,4,3600,0,183.8,1,-1,'ACC',-1,0),"\
"('HN','PSD Configuration for HN* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0),"\
"('HL','PSD Configuration for HL* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0),"\
"('HG','PSD Configuration for HG* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0),"\
"('BN','PSD Configuration for BN* Channels',-150,10,4,4,3600,0,4,1,-1,'ACC',-1,0);"

#define PQLX_DB_12 "CREATE TABLE `PDFIDX` ("\
"  `pdf_pk` int(11) NOT NULL auto_increment,"\
"  `pdfcfg_fk` int(10) NOT NULL,"\
"  `chni_fk` mediumint(9) NOT NULL,"\
"  `dayS` date NOT NULL,"\
"  `dayE` date NOT NULL,"\
"  PRIMARY KEY  (`pdf_pk`),"\
"  KEY `chni_fk` (`chni_fk`, `pdf_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_13 "CREATE TABLE `PDFCFG` ("\
"  `pdfcfg_pk` int(11) NOT NULL auto_increment,"\
"  `name` char(15) NOT NULL,"\
"  `description` varchar(100),"\
"  PRIMARY KEY  (`pdfcfg_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_14 "INSERT INTO `PDFCFG` VALUES "\
					"(1, 'ALL', 'ALL PSDs'), "\
					"(3, 'WEEK', 'LAST WEEK OF AVAILABLE PSDs'), "\
					"(2, 'MONTH', 'LAST MONTH OF AVAILABLE PSDs'), "\
					"(4, 'L MONTH', 'LAST LAST MONTH OF AVAILABLE PSDs'), "\
					"(5, 'LL MONTH', 'LAST LAST LAST MONTH OF AVAILABLE PSDs'), "\
					"(6, 'YEAR', 'THIS YEAR OF AVAILABLE PSDs'), "\
					"(7, 'L YEAR', 'LAST YEAR OF AVAILABLE PSDs')"

#define PQLX_DB_15 "CREATE TABLE `RESP` ("\
"  `resp_pk` mediumint(8) unsigned NOT NULL auto_increment,"\
"  `chni_fk` mediumint(8) unsigned NOT NULL,"\
"  `directory` varchar(1993) NOT NULL,"\
"  `filename` varchar(55) NOT NULL default '',"\
"  PRIMARY KEY  (`resp_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_16 "CREATE TABLE `SCAN` ("\
"  `scn_pk` int(11) NOT NULL auto_increment,"\
"  `dir_fk` mediumint(8) unsigned NOT NULL,"\
"  `time` int(11) NOT NULL default '0',"\
"  `realTime` timestamp,"\
"  `traces` mediumint(9) NOT NULL default '0',"\
"  `responses` mediumint(9) NOT NULL default '0',"\
"  `ntw` smallint(6) NOT NULL default '0',"\
"  `stn` smallint(6) NOT NULL default '0',"\
"  `loc` smallint(6) NOT NULL default '0',"\
"  `chn` smallint(6) NOT NULL default '0',"\
"  PRIMARY KEY  (`scn_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_17 "CREATE TRIGGER `DIRSUPD` BEFORE INSERT ON `SCAN` FOR EACH ROW \n"\
"BEGIN \n"\
"UPDATE DIRS D \n"\
"SET D.time = NEW.time \n"\
"WHERE D.dir_pk = NEW.dir_fk; \n"\
"END "

#define PQLX_DB_18 "CREATE TABLE `STATS_DAY` ("\
"  `day_pk` mediumint(9) unsigned NOT NULL auto_increment,"\
"  `chni_fk` mediumint(9) unsigned default NULL,"\
"  `year` smallint(6) unsigned default NULL,"\
"  `day` smallint(6) unsigned default NULL,"\
"  `gaps` mediumint(9) unsigned default NULL,"\
"  `overlaps` mediumint(9) unsigned default NULL,"\
"  `min` bigint(20) default NULL,"\
"  `max` bigint(20) default NULL,"\
"  PRIMARY KEY  (`day_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_19 "CREATE TABLE `TRC` ("\
"  `trc_pk` int(10) unsigned NOT NULL auto_increment,"\
"  `chni_fk` mediumint(8) unsigned NOT NULL default '0',"\
"  `format` enum('MSEED','SAC','AH','DR100','SEGY','NANO','DUMMY') NOT NULL default 'DUMMY',"\
"  `directory` varchar(1993) NOT NULL default '',"\
"  `filename` varchar(55) NOT NULL default '',"\
"  `start` timestamp NOT NULL default '0000-00-00 00:00:00',"\
"  `startM` mediumint(9) NOT NULL default '0',"\
"  `end` timestamp NOT NULL default '0000-00-00 00:00:00',"\
"  `endM` mediumint(9) NOT NULL default '0',"\
"  `nsamps` mediumint(8) unsigned NOT NULL default '0',"\
"  `gaps` mediumint(8) unsigned NOT NULL default '0',"\
"  `olaps` mediumint(8) unsigned NOT NULL default '0',"\
"  `max` double NOT NULL default '0',"\
"  `min` double NOT NULL default '0',"\
"  `mean` double NOT NULL default '0',"\
"  `sRate` int(9) NOT NULL default '0',"\
"  PRIMARY KEY  (`trc_pk`),"\
"  KEY `chni_fk` (`chni_fk`,`start`,`end`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#if 0
#define PQLX_DB_20 "CREATE PROCEDURE `EVENTQ_PSD1` (IN EVTQ_ID INT) \n"\
"BEGIN \n"\
"	-- INSERT PSD1 EVENT TO EVENTQ IF PSDCFG EXISTS FOR CHNI \n"\
"	DECLARE	TRC1 INT; \n"\
"	DECLARE	CHNIFK INT; \n"\
"	DECLARE PSDCFGFK INT; \n"\
" \n"\
"	-- GET THE PSDCFG KEY FOR CHNI \n"\
"	SELECT	P.PSDCFG_PK \n"\
"	FROM	PSDCFG P, TRC T \n"\
"	WHERE	T.TRC_PK = TRC1 AND \n"\
"			P.CHNI_FK = T.CHNI_FK \n"\
"	INTO	PSDCFGFK; \n"\
" \n"\
"	IF (PSDCFGFK IS NOT NULL) THEN \n"\
"		-- EXTRACT THE KEYS FROM THE EVENTQ TABLE \n"\
"		SELECT	E.TYPEKEY \n"\
"		FROM	EVENTQ E  \n"\
"		WHERE	E.EVTQ_ID = EVTQ_ID \n"\
"		INTO	TRC1; \n"\
" \n"\
"		SELECT	E.CHNI_FK \n"\
"		FROM	EVENTQ E \n"\
"		WHERE	E.EVTQ_ID = EVTQ_ID \n"\
"		INTO	CHNIFK; \n"\
" \n"\
"		INSERT INTO EVENTQ (TYPE, CHNI_FK, TYPEKEY) VALUES (2, CHNIFK, TRC1); \n"\
"	END IF; \n"\
"END "

#define PQLX_DB_21 "CREATE PROCEDURE `EVENTQ_PSD1A` (IN TRC_KEY INT) \n"\
"BEGIN \n"\
"	-- INSERT PSD EVENT (ENTIRE TRACE) TO EVENTQ IF PSDCFG EXISTS FOR CHNI \n"\
"	DECLARE PSDCFGFK INT; \n"\
"	DECLARE CHNIFK INT; \n"\
" \n"\
"	-- GET THE PSDCFG KEY FOR CHNI \n"\
"	SELECT	P.PSDCFG_PK \n"\
"	FROM	PSDCFG P, TRC T \n"\
"	WHERE	T.TRC_PK = TRC_KEY AND \n"\
"			P.CHNI_FK = T.CHNI_FK \n"\
"	INTO	PSDCFGFK; \n"\
" \n"\
"	IF (PSDCFGFK IS NOT NULL) THEN \n"\
"		INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2) VALUES (2, TRC_KEY, 0); \n"\
"	END IF; \n"\
" \n"\
"END "

#define PQLX_DB_22 "CREATE PROCEDURE `EVENTQ_PSD2` (IN EVTQ_ID INT) \n"\
"BEGIN \n"\
"	-- INSERT PSD2 EVENT (OVERLAPPING PSD) TO EVENTQ IF NEXT TRACE (IN TIME) EXISTS \n"\
"	-- AND PSD1 EVENT HAS COMPLETED FOR GIVEN EVENT \n"\
"	DECLARE	TRC1 INT; \n"\
"	DECLARE TRC2 INT; \n"\
" \n"\
"	-- EXTRACT THE TRACE KEY FROM THE EVENTQ TABLE \n"\
"	SELECT	E.TYPEKEY \n"\
"	FROM	EVENTQ E \n"\
"	WHERE	E.EVTQ_ID = EVTQ_ID \n"\
"	INTO	TRC1; \n"\
" \n"\
"	-- GET THE NEXT TRACE (IN TIME) KEY \n"\
"	SELECT	T2.TRC_PK \n"\
"	FROM	TRC T1, TRC T2 \n"\
"	WHERE	TRC1 = T1.TRC_PK AND \n"\
"			T1.END >= DATE_SUB(T2.START, INTERVAL '2' MINUTE) AND \n"\
"			T1.END <= T2.START AND \n"\
"			T1.CHNI_FK = T2.CHNI_FK \n"\
"	INTO	TRC2; \n"\
" \n"\
"	IF (TRC2 IS NOT NULL) THEN \n"\
"		INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2) VALUES (3, TRC1, TRC2); \n"\
"	END IF; \n"\
" \n"\
"END "

#define PQLX_DB_23 "CREATE PROCEDURE `EVENTQ_PSD2A` (IN TRC_KEY INT) \n"\
"BEGIN \n"\
"	-- INSERT PSD2 EVENT (OVERLAPPING PSD) TO EVENTQ IF PREVIOUS TRACE (IN TIME) EXISTS \n"\
"	-- AND TRC_KEY RECORD END IS BEFORE TODAY \n"\
"	-- we do not want to insert this event for today's traces \n"\
"	DECLARE TRC2 INT; \n"\
"	DECLARE CHNIFK INT; \n"\
" \n"\
"	-- GET THE PREV TRACE (IN TIME) KEY \n"\
"	SELECT	T2.TRC_PK \n"\
"	FROM	TRC T1, TRC T2 \n"\
"	WHERE	T1.TRC_PK = TRC_KEY AND \n"\
"			T1.CHNI_FK = T2.CHNI_FK AND \n"\
"			T1.END < UTC_DATE()	AND \n"\
"			T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND \n"\
"			T1.START >= T2.END \n"\
"	INTO	TRC2; \n"\
" \n"\
"	IF (TRC2 IS NOT NULL) THEN \n"\
"		INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2) VALUES (3, TRC2, TRC_KEY); \n"\
"	END IF; \n"\
" \n"\
"END"
#endif

#define PQLX_DB_24 "CREATE TRIGGER `TRC-DEL` AFTER DELETE ON `TRC` FOR EACH ROW \n"\
"BEGIN \n"\
"	-- when deleting a TRC record, must clean up some stuff \n"\
" \n"\
"	-- delete any unprocessed events for this deleted trace file \n"\
"	DELETE FROM	EVENTQ WHERE typeKey = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC'; \n"\
"	DELETE FROM	EVENTQ WHERE typeKey2 = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC'; \n"\
" \n"\
"	-- insert event 91 (PSDDEL) onto the EVENTQ for processing by the server for PSD channels \n"\
"	IF ((SELECT count(*) FROM PSDCFG WHERE CHNI_FK = OLD.CHNI_FK) = 1) THEN \n"\
"		INSERT INTO EVENTQ (type, typeKey, typeKey2) VALUES (91, OLD.TRC_PK, OLD.CHNI_FK); \n"\
"	END IF; \n"\
" \n"\
"END"

#define PQLX_DB_25 "CREATE PROCEDURE `spCHNIupd` () \n"\
"BEGIN \n"\
" \n"\
"	-- called once at end of server execution once all events have been processed \n"\
"	UPDATE CHNI C \n"\
"	SET 	 \n"\
"		C.STARTT = (SELECT MIN(T.START) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.ENDT = (SELECT MAX(T.END) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.GAPMAX = (SELECT MAX(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.GAPMIN = (SELECT MIN(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.GAPAVG = (SELECT AVG(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.OLAPMAX = (SELECT MAX(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.OLAPMIN = (SELECT MIN(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.OLAPAVG = (SELECT AVG(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.MAXMAX = (SELECT MAX(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.MAXMIN = (SELECT MIN(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.MAXAVG = (SELECT AVG(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.MINMAX = (SELECT MAX(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.MINMIN = (SELECT MIN(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.MINAVG = (SELECT AVG(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.MEANMAX = (SELECT MAX(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.MEANMIN = (SELECT MIN(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0),  \n"\
"		C.MEANAVG = (SELECT AVG(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), \n"\
"		C.NTRACES = (SELECT COUNT(*) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0); \n"\
" \n"\
"END"

#define PQLX_DB_26 "CREATE TABLE `USER` ("\
"  `user_pk` int(11) NOT NULL auto_increment,"\
"  `name` varchar(25) NOT NULL default '',"\
"  `type` enum('SRVR','CLNT') NOT NULL,"\
"  `ip` char(15) character set latin1 NOT NULL default '',"\
"  PRIMARY KEY  (`user_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_27 "CREATE TABLE `USER_LOG` ("\
"  `ulog_pk` mediumint(8) unsigned NOT NULL auto_increment,"\
"  `user_fk` mediumint(8) unsigned NOT NULL default '0',"\
"  `evt_type` enum('LOGIN','LOGOUT') NOT NULL,"\
"  `dtime` timestamp not null default CURRENT_TIMESTAMP,"\
"  PRIMARY KEY  (`ulog_pk`)"\
") ENGINE=MyISAM DEFAULT CHARSET=latin1"

#define PQLX_DB_28 "CREATE ALGORITHM=UNDEFINED VIEW `ntw` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'ntw' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'ntw');"
#define PQLX_DB_29 "CREATE ALGORITHM=UNDEFINED VIEW `stn` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'STN' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'stn');"
#define PQLX_DB_30 "CREATE ALGORITHM=UNDEFINED VIEW `loc` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'LOC' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'loc');"
#define PQLX_DB_31 "CREATE ALGORITHM=UNDEFINED VIEW `chn` AS select `IDS`.`IDS_PK` AS `ids_pk`,_latin1'CHN' AS `type`,`IDS`.`name` AS `name`,`IDS`.`alias` AS `alias` from `IDS` where (`IDS`.`type` = _latin1'chn');"
#define PQLX_DB_32 "CREATE ALGORITHM=UNDEFINED VIEW `ns` AS select `ntw`.`name` AS `ntw`,`stn`.`name` AS `stn` from ((`ntw` join `stn`) join `CHNI`) where ((`CHNI`.`NTW_FK` = `ntw`.`ids_pk`) and (`CHNI`.`STN_FK` = `stn`.`ids_pk`));"
#define PQLX_DB_33 "CREATE ALGORITHM=UNDEFINED VIEW `nslc` AS select `i1`.`name` AS `ntw`,`CHNI`.`NTW_FK` AS `ntw_FK`,`i2`.`name` AS `stn`,`CHNI`.`STN_FK` AS `stn_fk`,`i3`.`name` AS `loc`,`CHNI`.`LOC_FK` AS `loc_fk`,`i4`.`name` AS `chn`,`CHNI`.`chni_pk` AS `chni_pk` from ((((`CHNI` join `IDS` `i1`) join `IDS` `i2`) join `IDS` `i3`) join `IDS` `i4`) where ((`i1`.`type` = _latin1'ntw') and (`i1`.`IDS_PK` = `CHNI`.`NTW_FK`) and (`i2`.`type` = _latin1'stn') and (`i2`.`IDS_PK` = `CHNI`.`STN_FK`) and (`i3`.`type` = _latin1'loc') and (`i3`.`IDS_PK` = `CHNI`.`LOC_FK`) and (`i4`.`type` = _latin1'chn') and (`i4`.`IDS_PK` = `CHNI`.`CHN_FK`)) order by `i1`.`name`,`i2`.`name`,`i3`.`name`,`i4`.`name`;"
#define PQLX_DB_34 "CREATE PROCEDURE `spRegUser` (	IN UNAME VARCHAR(25),  \n"\
"								IN UIP VARCHAR(25),  \n"\
"								IN ETYP VARCHAR(6),  \n"\
"								IN UTYP VARCHAR(6)) \n"\
"BEGIN \n"\
" \n"\
"	-- register user LOGIN and LOGOUT events \n"\
"	DECLARE USERPK INT; \n"\
" \n"\
"	-- Has user ever before logged in? \n"\
"	SELECT	user_pk \n"\
"	FROM	`USER`  \n"\
"	WHERE	name = UNAME COLLATE latin1_general_cs and \n"\
"			ip = UIP COLLATE latin1_general_cs and \n"\
"			type = UTYP COLLATE latin1_general_cs\n"\
"	INTO	USERPK; \n"\
" \n"\
"	-- If not, then make a new user \n"\
"	IF (USERPK IS NULL) THEN \n"\
"		INSERT INTO `USER` (name, ip, type) VALUES (UNAME, UIP, UTYP) ; \n"\
" \n"\
"		SELECT	user_pk \n"\
"		FROM	`USER` \n"\
"		WHERE	name = UNAME COLLATE latin1_general_cs and \n"\
"				ip = UIP COLLATE latin1_general_cs and \n"\
"				type = UTYP COLLATE latin1_general_cs\n"\
"	INTO	USERPK; \n"\
"	END IF; \n"\
" \n"\
"	-- and log their existence \n"\
"	INSERT INTO USER_LOG (user_fk, evt_type) VALUES (USERPK, ETYP); \n"\
" \n"\
"END"

#define PQLX_DB_35 "CREATE PROCEDURE `spNextEvent` () \n"\
"BEGIN \n"\
" \n"\
"	-- get the next available event and mark as INPROC \n"\
"	DECLARE	EVENT_PK	INT; \n"\
"	DECLARE	SQLCMD		VARCHAR(100); \n"\
" \n"\
"	SELECT	EVTQ_ID \n"\
"	FROM	EVENTQ \n"\
"	WHERE	PROCESSED = 'UNPROC' \n"\
"	ORDER BY TYPE \n"\
"	LIMIT	1 \n"\
"	INTO	EVENT_PK; \n"\
" \n"\
"	IF (EVENT_PK IS NOT NULL) THEN \n"\
"		UPDATE EVENTQ SET PROCESSED = 'INPROC' WHERE evtq_id = EVENT_PK; \n"\
"		SELECT evtq_id, TYPE, TYPEKEY, TYPEKEY2 FROM EVENTQ WHERE evtq_id = EVENT_PK; \n"\
"	ELSE \n"\
"		SELECT 0, 0, 0, 0; \n"\
"	END IF; \n"\
" \n"\
"END"

static char *dbStrings[] = {
	PQLX_DB_1,
	PQLX_DB_2,
	PQLX_DB_3,
	PQLX_DB_4,
	PQLX_DB_5,
	PQLX_DB_6,
	PQLX_DB_7,
	PQLX_DB_8,
	PQLX_DB_9,
	PQLX_DB_10,
	PQLX_DB_11,
	PQLX_DB_12,
	PQLX_DB_13,
	PQLX_DB_14,
	PQLX_DB_15,
	PQLX_DB_16,
	PQLX_DB_17,
	PQLX_DB_18,
	PQLX_DB_19,
//	PQLX_DB_20,
//	PQLX_DB_21,
//	PQLX_DB_22,
//	PQLX_DB_23,
	PQLX_DB_24,
	PQLX_DB_25,
	PQLX_DB_26,
	PQLX_DB_27,
	PQLX_DB_28,
	PQLX_DB_29,
	PQLX_DB_30,
	PQLX_DB_31,
	PQLX_DB_32,
	PQLX_DB_33,
	PQLX_DB_34,
	PQLX_DB_35
};

#endif
