#ifndef __DBUPG_H
#define __DBUPG_H
#define SQL_DBVERSION_UPD "Update PQLXMETA.PQLXDBS set dbVersion = '%d' where dbName = '%s'"
#define SQL_DBUPG_1_A "ALTER TABLE `%sDATA`.`%s` MODIFY COLUMN `period` DECIMAL(12,6) NOT NULL DEFAULT 0"
#define SQL_DBUPG_1_B "SELECT CHNI_FK FROM PSDCFG WHERE CHNI_FK <> 0"
#define SQL_DBUPG_2_B "ALTER TABLE `PDFCFG` ADD COLUMN `year` TINYINT SIGNED NOT NULL DEFAULT 0 AFTER `description`, ""ADD COLUMN `dayEnd` TINYINT UNSIGNED NOT NULL DEFAULT 0 AFTER `description`, ""ADD COLUMN `dayStart` TINYINT UNSIGNED NOT NULL DEFAULT 0 AFTER `description`;"
#define SQL_DBUPG_2_C "TRUNCATE PDFCFG; INSERT INTO `PDFCFG` (name, description, dayStart, dayEnd, year) ""VALUES ('ALL', 'ALL PSDs', 1, 1, 0), ""('WEEK', 'LAST WEEK OF AVAILABLE PSDs', 7, 0, -1), ""('L WEEK', 'LAST LAST WEEK OF AVAILABLE PSDs', 14, 7, -1), ""('MONTH', 'LAST MONTH OF AVAILABLE PSDs', 30, 0, -1), ""('L MONTH', 'LAST LAST MONTH OF AVAILABLE PSDs', 60, 30, -1), ""('YEAR', 'THIS YEAR OF AVAILABLE PSDs', 0, 0, 0), ""('L YEAR', 'LAST YEAR OF AVAILABLE PSDs', 0, 0, 1)"
#define SQL_DBUPG_2_D "ALTER TABLE `PDFIDX` ADD COLUMN `ttlPSD` MEDIUMINT UNSIGNED NOT NULL DEFAULT 0"
#define SQL_DBUPG_2_E "TRUNCATE PDFIDX; INSERT INTO PDFIDX (PDFCFG_FK, CHNI_FK) SELECT PDFCFG_PK, ""P1.chni_fk FROM PDFCFG P, PSDCFG P1 WHERE P1.chni_fk <> 0"
#define SQL_DBUPG_2_F "ALTER TABLE `USER_LOG` MODIFY COLUMN `ulog_pk` INT UNSIGNED NOT NULL auto_increment"
#define SQL_DBUPG_3_A "TRUNCATE PDFIDX"
#define SQL_DBUPG_3_B "ALTER TABLE `PDFIDX` ENGINE = InnoDB"
#define SQL_DBUPG_3_E "ALTER TABLE `PDFCFG` MODIFY COLUMN `dayEnd` SMALLINT UNSIGNED NOT NULL DEFAULT 0, ""MODIFY COLUMN `dayStart` SMALLINT UNSIGNED NOT NULL DEFAULT 0"
#define SQL_DBUPG_4_A "CREATE TABLE `CHNMETA` (`chnmeta_pk` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, ""`chni_fk` mediumint(9) NOT NULL, `startT` DATETIME NOT NULL DEFAULT 0, ""`endT` DATETIME NOT NULL DEFAULT 0, `sitename` VARCHAR(100), `latitude` DECIMAL(11,8), ""`longitude` DECIMAL(12,8), `elevation` DECIMAL(6,1), `depth` DECIMAL(4,1), ""`sensitivity` DECIMAL(12,1), `units` VARCHAR(50), `instID` VARCHAR(100), ""`azimuth` DECIMAL(4,1), `dip` DECIMAL(4,1), `sampInt` INT(9), ""PRIMARY KEY(`chnmeta_pk`), KEY `period` (`chni_fk`, `startT`, `endT`)) ""ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPG_4_D "ALTER TABLE CHNI DROP COLUMN `sampRate`, DROP COLUMN `lat`, DROP COLUMN `lon`"
#define SQL_DBUPG_4_E "ALTER TABLE TRC CHANGE COLUMN `sRate` `sampInt` int(9) NOT NULL default '0'"
#define SQL_DBUPG_4_F "ALTER TABLE PSDCFG ADD INDEX chni_fk (chni_fk)"
#define SQL_DBUPG_4_G "ALTER TABLE CHNI ADD INDEX stn_fk (stn_fk, nTraces), ""ADD INDEX startT (startT, nTraces), ADD INDEX endT (endT, nTraces), ""ADD INDEX nTraces (nTraces)"
#define SQL_DBUPG_4_H "ALTER TABLE RESP ADD INDEX chni_fk (chni_fk)"
#define SQL_DBUPG_4_I "ALTER TABLE TRC ADD INDEX dir (chni_fk, directory(200), filename), ""ADD INDEX nsamps (nSamps, format)"
#define SQL_DBUPG_4_J "ALTER TABLE IDS ADD INDEX type (type, name)"
#define SQL_DBUPG_5_A "ALTER TABLE `EVENTQ` MODIFY COLUMN `processed` ""enum('UNPROC','INPROC','PROCD', 'NOPROC') NOT NULL default 'UNPROC'"
#define SQL_DBUPG_5_B "INSERT INTO EVENTQ (type, typeKey, processed) ""SELECT %d, P1.chni_fk, 'NOPROC' FROM PSDCFG P1 WHERE P1.chni_fk <> 0"
#define SQL_DBUPG_6_A "ALTER TABLE `CONSTANT` MODIFY COLUMN `type` enum('ERRORMSG', 'LOGMSG', 'DBCONST', 'EVENT') NOT NULL"
#define SQL_DBUPG_6_B "TRUNCATE TABLE CONSTANT; INSERT INTO `CONSTANT` (val, description, type) ""VALUES (1,'Trace Analysis - Statistics','EVENT'), ""(2,'Trace Analysis - PSD','EVENT'), ""(3,'Trace Analysis - Overlapping PSD','EVENT'), ""(90,'PSD Table - Create Index','EVENT'), ""(91,'PSD Table - Delete Trace PSDs','EVENT'), ""(100,'System PDF','EVENT'), (101,'System PDF PNG','EVENT'), ""(0,'No Error','ERRORMSG'), (100,'Out of Memory','ERRORMSG'), ""(101,'Unknown System Event','ERRORMSG'), ""(102,'Server Crash','ERRORMSG'), (103,'No Such Record','ERRORMSG'), ""(104,'Server Not Ready','ERRORMSG'), (105,'SQL Error','ERRORMSG'), ""(106,'No Stations','ERRORMSG'), (1001,'No Response File','ERRORMSG'), ""(1002,'Not Enough Data','ERRORMSG'), (1003,'Files Discontinuous','ERRORMSG'), ""(1004,'Internal FFT Error','ERRORMSG'), (1005,'PERIOD Mismatch','ERRORMSG'), ""(1006,'Error Reading File','ERRORMSG'), (1007,'File Does Not Exist','ERRORMSG'), ""(1008,'evalresp() Failure','ERRORMSG'), (1101,'Problem reading hour.idx File','ERRORMSG'), ""(1102,'Problem reading HJJJ.bin File','ERRORMSG');"
#define SQL_DBUPG_6_C "UPDATE EVENTQ set error_no = 1008 where error_no = -2;"
#define SQL_DBUPG_7_A "ALTER TABLE `EVENTQ` MODIFY COLUMN `evtq_id` BIGINT NOT NULL AUTO_INCREMENT"
#define SQL_DBUPG_8_A "CREATE DATABASE `%sSTATS`"
#define SQL_DBUPG_8_B "CREATE TABLE `%sSTATS`.`hits%s` (`pdfcfg_fk` TINYINT UNSIGNED NOT NULL, ""`period` DECIMAL(12,6) NOT NULL DEFAULT 0, `power` SMALLINT NOT NULL DEFAULT 0, ""`hits` MEDIUMINT UNSIGNED NOT NULL DEFAULT 0, KEY (`pdfcfg_fk`, `period`, `power`)) ""ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPG_8_C "CREATE TABLE `%sSTATS`.`stats%s` (`pdfcfg_fk` TINYINT UNSIGNED NOT NULL, ""`period` DECIMAL(12,6) NOT NULL DEFAULT 0, `min` SMALLINT NOT NULL DEFAULT 0, ""`max` SMALLINT NOT NULL DEFAULT 0, `mode` SMALLINT NOT NULL DEFAULT 0, ""`median` SMALLINT NOT NULL DEFAULT 0, `mean` SMALLINT NOT NULL DEFAULT 0, ""`p5` SMALLINT NOT NULL DEFAULT 0, `p10` SMALLINT NOT NULL DEFAULT 0, ""`p25` SMALLINT NOT NULL DEFAULT 0, `p75` SMALLINT NOT NULL DEFAULT 0, ""`p90` SMALLINT NOT NULL DEFAULT 0, `p95` SMALLINT NOT NULL DEFAULT 0, ""KEY (`pdfcfg_fk`, `period`)) ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPG_8_D "ALTER TABLE PDFCFG ADD COLUMN min TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN max TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN mode TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN median TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN mean TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN p5 TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN p10 TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN p25 TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN p75 TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN p90 TINYINT UNSIGNED NOT NULL DEFAULT 0, ""ADD COLUMN p95 TINYINT UNSIGNED NOT NULL DEFAULT 0"
#define SQL_DBUPG_8_E "UPDATE PDFCFG SET mode = 1"
#define SQL_DBUPG_9_A "ALTER TABLE PDFCFG ADD COLUMN dateFmt TINYINT UNSIGNED NOT NULL DEFAULT 4"
#define SQL_DBUPG_9_B "ALTER TABLE `CHNI` MODIFY COLUMN `GapAvg` float unsigned default '0', ""MODIFY COLUMN `OlapAvg` float unsigned default '0', ""MODIFY COLUMN `MaxAvg` float unsigned default '0', ""MODIFY COLUMN `MinAvg` float unsigned default '0', ""MODIFY COLUMN `MeanAvg` float unsigned default '0'; ""ALTER TABLE PDFIDX MODIFY COLUMN `dayS` date, MODIFY COLUMN `dayE` date;"
#define SQL_DBUPG_10_A "ALTER TABLE GLAP MODIFY COLUMN glap_pk BIGINT UNSIGNED NOT NULL auto_increment"
#define SQL_DBUPG_11_A "ALTER TABLE PDFIDX MODIFY COLUMN pdfcfg_fk SMALLINT UNSIGNED NOT NULL, ""MODIFY COLUMN ttlPSD INT"
#define SQL_DBUPG_11_B "CREATE TABLE `%sTMP`.`dbMaint` (`chni_fk` mediumint(9) NOT NULL) ""ENGINE=MyISAM DEFAULT CHARSET=latin1;"
#define SQL_DBUPG_11_C "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(1009,'Sample Rate Change','ERRORMSG')"
#define SQL_DBUPG_12_A "INSERT INTO `CONSTANT` (val, description, type) ""VALUES (1010,'File Too Large','ERRORMSG')"
#define SQL_DBUPG_13_A "SET PASSWORD FOR 'pqlxAdmin'@'localhost' = PASSWORD('PqLXAdmiN'); ""SET PASSWORD FOR 'pqlxAdmin'@'%' = PASSWORD('PqLXAdmiN')"
#define SQL_DBUPG_13_B "ALTER TABLE `EVENTQ` MODIFY COLUMN `processed` ""ENUM('INPROC','UNPROC','NOPROC','PROCD') NOT NULL default 'UNPROC'"
#define SQL_DBUPG_14_A "ALTER TABLE `%s`.`CHNMETA` MODIFY COLUMN `sensitivity` DOUBLE DEFAULT NULL"
#define SQL_DBUPG_15_A "ALTER TABLE `%s`.`TRC` MODIFY COLUMN `sampInt` DOUBLE DEFAULT 0"
#define SQL_DBUPG_15_B "ALTER TABLE `%s`.`CHNMETA` MODIFY COLUMN `sampInt` DOUBLE DEFAULT 0"
#define SQL_DBUPG_16_A "CREATE TABLE `PDFWWW` (`width` SMALLINT UNSIGNED NOT NULL DEFAULT 550,""`height` smallint UNSIGNED NOT NULL DEFAULT 425,""`border` ENUM('ON','OFF') NOT NULL default 'ON',""`bordercolorR` TINYINT UNSIGNED NOT NULL DEFAULT 0,""`bordercolorG` tinyint UNSIGNED NOT NULL DEFAULT 0,""`bordercolorB` tinyint UNSIGNED NOT NULL DEFAULT 0,""`Iwidth` smallint UNSIGNED NOT NULL DEFAULT 170,""`Iheight` smallint UNSIGNED NOT NULL DEFAULT 145,""`Iborder` ENUM('ON','OFF') NOT NULL DEFAULT 'ON',""`IbordercolorR` TINYINT UNSIGNED NOT NULL DEFAULT 0,""`IbordercolorG` TINYINT UNSIGNED NOT NULL DEFAULT 0,""`IbordercolorB` TINYINT UNSIGNED NOT NULL DEFAULT 0) ""ENGINE = MyISAM DEFAULT CHARACTER SET latin1 COLLATE latin1_general_cs"
#define SQL_DBUPG_16_B "INSERT INTO `%s`.`PDFWWW` (width) VALUES (550)"
#define SQL_DBUPG_17_A "ALTER TABLE `%s`.`PDFWWW` ADD COLUMN `HLNM` ENUM('ON','OFF') NOT NULL default 'ON'"
#define SQL_DBUPG_18_A "ALTER TABLE `%s`.`EVENTQ` MODIFY COLUMN `typeKey` INTEGER UNSIGNED NOT NULL, ""MODIFY COLUMN `typeKey2` INTEGER UNSIGNED NOT NULL"
#define SQL_DBUPG_19_A "ALTER TABLE `%s`.`EVENTQ` ADD COLUMN `chni_fk` MEDIUMINT UNSIGNED NOT NULL DEFAULT 0"
#define SQL_DBUPG_19_D "DROP PROCEDURE IF EXISTS `EVENTQ_PSD1`"
#define SQL_DBUPG_19_E "CREATE PROCEDURE `EVENTQ_PSD1`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE PSDCFGFK INT; \n"" DECLARE CHNIFK INT; \n"" SELECT P.PSDCFG_PK, T.CHNI_FK \n"" FROM PSDCFG P, TRC T \n"" WHERE T.TRC_PK = TRC_KEY AND \n""   P.CHNI_FK = T.CHNI_FK \n"" INTO PSDCFGFK, CHNIFK; \n"" IF (PSDCFGFK IS NOT NULL) THEN \n""  INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) VALUES (2, TRC_KEY, 0, CHNIFK); \n"" END IF; \n""END "
#define SQL_DBUPG_19_F "DROP PROCEDURE IF EXISTS `EVENTQ_PSD2`"
#define SQL_DBUPG_19_G "CREATE PROCEDURE `EVENTQ_PSD2`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE TRC2 INT; \n"" DECLARE CHNIFK INT; \n"" SELECT T2.TRC_PK, T2.CHNI_FK \n"" FROM TRC T1, TRC T2 \n"" WHERE T1.TRC_PK = TRC_KEY AND \n""   T1.CHNI_FK = T2.CHNI_FK AND \n""   T1.END < UTC_DATE() AND \n""   T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND \n""   T1.START >= T2.END \n"" INTO TRC2, CHNIFK; \n"" IF (TRC2 IS NOT NULL) THEN \n""  INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) VALUES (3, TRC2, TRC_KEY, CHNIFK); \n"" END IF; \n""END "
#define SQL_DBUPG_19_H "DROP PROCEDURE IF EXISTS `EVENTQ_PSD1A`"
#define SQL_DBUPG_19_I "DROP PROCEDURE IF EXISTS `EVENTQ_PSD2A`"
#define SQL_DBUPG_19_L "CREATE OR REPLACE ALGORITHM=UNDEFINED VIEW `eventQV` AS ""(select `EVENTQ`.`evtq_id` AS `EVTQ_ID`,`EVENTQ`.`type` AS `TYPE`,""`EVENTQ`.`typeKey` AS `TYPEKEY`,`EVENTQ`.`typeKey2` AS `TYPEKEY2` ""FROM `EVENTQ` WHERE (`EVENTQ`.`processed` = _latin1'UNPROC') ""ORDER BY `EVENTQ`.`type` limit 1) ""UNION ""(select 0 AS `EVTQ_ID`,0 AS `TYPE`,0 AS `TYPEKEY`,0 AS `typeKey2`)"
#define SQL_DBUPG_19_M "DROP PROCEDURE IF EXISTS `spNextEvent`"
#define SQL_DBUPG_19_N "CREATE PROCEDURE `spNextEvent` () \n""BEGIN \n"" -- get the next available event and mark as INPROC \n"" DECLARE EVENT_PK, T, TK, TK2 INT; \n"" SELECT evtq_id, type, typekey, typekey2 \n"" FROM eventQV \n"" LIMIT 1 \n"" INTO EVENT_PK, T, TK, TK2; \n"" IF (EVENT_PK <> 0) THEN \n""  UPDATE EVENTQ SET PROCESSED = 'INPROC' WHERE evtq_id = EVENT_PK; \n"" END IF; \n"" SELECT EVENT_PK, T, TK, TK2; \n""END "
#define SQL_DBUPG_20_Z1 "DROP TRIGGER `TRC-DEL`"
#define SQL_DBUPG_20_Z2 "CREATE TRIGGER `TRC-DEL` AFTER DELETE ON `TRC` FOR EACH ROW \n""BEGIN \n"" -- when deleting a TRC record, must clean up some stuff \n"" -- delete any unprocessed events for this deleted trace file \n"" DELETE FROM EVENTQ WHERE typeKey = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC'; \n"" DELETE FROM EVENTQ WHERE typeKey2 = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC'; \n"" -- insert event 91 (PSDDEL) onto the EVENTQ for processing by the server for PSD channels \n"" IF ((SELECT count(*) FROM PSDCFG WHERE CHNI_FK = OLD.CHNI_FK) = 1) THEN \n""  INSERT INTO EVENTQ (type, typeKey, typeKey2, chni_fk, processed) VALUES (91, OLD.TRC_PK, OLD.CHNI_FK, OLD.CHNI_FK, 'NOPROC'); \n"" END IF; \n""END "
#define SQL_DBUPG_20_A "ALTER TABLE `LOG` CONVERT TO CHARSET latin1;""ALTER TABLE `PSDCFG` CONVERT TO CHARSET latin1;""ALTER TABLE `USER` CONVERT TO CHARSET latin1;""ALTER TABLE `USER_LOG` CONVERT TO CHARSET latin1;"
#define SQL_DBUPG_20_B "ALTER DATABASE `%s` COLLATE latin1_general_cs"
#define SQL_DBUPG_20_C "ALTER TABLE `DIRS` ADD COLUMN `ttlTrace` INT UNSIGNED NOT NULL DEFAULT 0 AFTER `STATUS`, ""ADD COLUMN `ttlResp` int UNSIGNED NOT NULL DEFAULT 0 AFTER `ttlTrace`"
#define SQL_DBUPG_20_D "CREATE PROCEDURE `dirsStats` () \n""BEGIN \n"" UPDATE `DIRS` d \n"" SET \n""  d.ttlTrace = (select count(*) from `TRC` t WHERE LOCATE(concat(d.directory, '/'), concat(t.directory, '/')) > 0 and t.nsamps <> 0), \n""  d.ttlResp = (select count(*) from `RESP` r WHERE LOCATE(concat(d.directory, '/'), concat(r.directory, '/')) > 0); \n""END "
#define SQL_DBUPG_20_E "UPDATE `DIRS` SET directory = SUBSTR(directory, 1, length(directory)-1) WHERE RIGHT(directory, 1) = '/'"
#define SQL_DBUPG_20_F "ALTER TABLE `USER` MODIFY COLUMN `type` enum('SRVR', 'CLNT', 'ADMIN') NOT NULL"
#define SQL_DBUPG_20_G "DROP PROCEDURE IF EXISTS `spRegUser`; ""CREATE PROCEDURE `spRegUser` ( IN UNAME VARCHAR(25), \n""        IN UIP VARCHAR(25), \n""        IN ETYP VARCHAR(6), \n""        IN UTYP VARCHAR(6)) \n""BEGIN \n"" \n"" -- register user LOGIN and LOGOUT events \n"" DECLARE USERPK INT; \n"" \n"" -- Has user ever before logged in? \n"" SELECT user_pk \n"" FROM `USER` \n"" WHERE name = UNAME COLLATE latin1_general_cs and \n""   ip = UIP COLLATE latin1_general_cs and \n""   type = UTYP COLLATE latin1_general_cs\n"" INTO USERPK; \n"" \n"" -- If not, then make a new user \n"" IF (USERPK IS NULL) THEN \n""  INSERT INTO `USER` (name, ip, type) VALUES (UNAME, UIP, UTYP) ; \n"" \n""  SELECT user_pk \n""  FROM `USER` \n""  WHERE name = UNAME COLLATE latin1_general_cs and \n""    ip = UIP COLLATE latin1_general_cs and \n""    type = UTYP COLLATE latin1_general_cs\n"" INTO USERPK; \n"" END IF; \n"" \n"" -- and log their existence \n"" INSERT INTO USER_LOG (user_fk, evt_type) VALUES (USERPK, ETYP); \n"" \n""END"
#define SQL_DBUPG_20_H "UPDATE PDFCFG SET ""min = min + 1,""max = max + 1,""mode = mode + 1,""median = median + 1,""mean = mean + 1,""p5 = p5 + 1,""p10 = p10 + 1,""p25 = p25 + 1,""p75 = p75 + 1,""p90 = p90 + 1,""p95 = p95 + 1;"
#define SQL_DBUPG_20_I "ALTER TABLE `PDFCFG` ""MODIFY COLUMN `min` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `max` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `mode` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `median` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `mean` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `p5` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `p10` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `p25` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `p75` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `p90` ENUM('OFF','ON') DEFAULT 'OFF',""MODIFY COLUMN `p95` ENUM('OFF','ON') NOT NULL DEFAULT 'OFF',""MODIFY COLUMN `dateFmt` TINYINT(3) UNSIGNED NOT NULL DEFAULT 3;"
#define SQL_DBUPG_20_J "ALTER TABLE `PDFWWW` ""MODIFY COLUMN `border` ENUM('OFF','ON') NOT NULL DEFAULT 'ON',""MODIFY COLUMN `Iborder` ENUM('OFF','ON') NOT NULL DEFAULT 'ON',""MODIFY COLUMN `HLNM` ENUM('OFF','ON') NOT NULL DEFAULT 'ON';"
#define SQL_DBUPG_20_K "ALTER TABLE `DIRS` ""MODIFY COLUMN `STATUS` ENUM('INACTIVE','ACTIVE') NOT NULL DEFAULT 'ACTIVE'"
#define SQL_DBUPG_20_L "UPDATE PDFCFG SET dateFmt = dateFmt - 1"
#define SQL_DBUPG_20_M "ALTER TABLE `CHNI` ADD COLUMN `ttlPSD` INTEGER NOT NULL DEFAULT 0"
#define SQL_DBUPG_20_N "ALTER TABLE `PDFWWW` ADD COLUMN `wwwDir` varchar(250) NOT NULL DEFAULT 'NONE' FIRST;""UPDATE `PDFWWW` p, `PQLXMETA` m SET p.wwwDir = m.wwwDir where m.dbName = '%s'"
#define SQL_DBUPG_20_O "CREATE TABLE `SRVREXEC` (`srvrExec_pk` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, ""`pgmName` varchar(50) NOT NULL, ""`execTime` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, ""PRIMARY KEY(`srvrExec_pk`)) ""ENGINE = MYISAM DEFAULT CHARSET=latin1; ""CREATE TABLE `SRVRLOG` (`srvrLog_pk` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, ""`srvrExec_fk` INTEGER UNSIGNED NOT NULL, ""`logTime` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, ""`type` ENUM('LOG', 'ERROR') NOT NULL, ""`msg` varchar(2500) NOT NULL, ""PRIMARY KEY(`srvrLog_pk`), ""KEY `srvrExec` (`srvrExec_fk`, `logTime`)) ""ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPG_20_P "ALTER TABLE `PDFIDX` ADD COLUMN `epoch` TINYINT UNSIGNED NOT NULL DEFAULT 0 ""AFTER `chni_fk`, DROP INDEX `chni_fk`, ""ADD INDEX `chni` (`chni_fk`, `pdfcfg_fk`, `epoch`)"
#define SQL_DBUPG_20_Q "CREATE OR REPLACE ALGORITHM=UNDEFINED VIEW `epochSPS` AS ""SELECT chni_fk, sampInt, MIN(DATE(start)) startD, MAX(DATE(end)) endD ""FROM TRC ""WHERE sampInt <> 0 ""GROUP BY 1, 2 ""ORDER BY 1, 3"
#define SQL_DBUPG_20_R "ALTER TABLE `PDFCFG` ADD COLUMN `type` tinyint NOT NULL DEFAULT 0 ""AFTER `description`"
#define SQL_DBUPG_20_S "UPDATE `PDFCFG` SET dayStart = 0, dayEnd = 0, year = -1 WHERE name = 'ALL'; ""UPDATE `PDFCFG` SET type = 2 WHERE dayStart > 0;"
#define SQL_DBUPG_21_A "DROP TRIGGER `CHNIDEPENDENCIES`"
#define SQL_DBUPG_21_B "CREATE TRIGGER `CHNIDEPENDENCIES` AFTER INSERT ON `CHNI` FOR EACH ROW \n""BEGIN \n"" -- insert a DUMMY trace for the new channel, \n"" -- this is necessary for imported PDF's with no link back to the original trace \n"" INSERT INTO TRC (CHNI_FK) VALUES (NEW.CHNI_PK); \n"" \n"" -- insert all system (automatically computed) PDF's for the new channel \n"" INSERT INTO PDFIDX (PDFCFG_FK, CHNI_FK) SELECT PDFCFG_PK, NEW.CHNI_PK FROM PDFCFG P; \n"" \n"" -- insert the default PSD configuration parameters according to the channel name and PSDCFG entries \n"" INSERT INTO PSDCFG (channel, description, minPower, maxPower, sections, steps, duration, dbOffset, "" maxPeriod, binWidth, gapThresh, units, lastStage, type, chni_fk) "" SELECT channel, description, minPower, maxPower, sections, steps, duration, dbOffset, "" maxPeriod, binWidth, gapThresh, units, lastStage, P.type, NEW.CHNI_PK "" FROM PSDCFG P, IDS I WHERE P.CHNI_FK = 0 AND I.IDS_PK = NEW.CHN_FK AND LEFT(I.NAME,2) = P.channel; \n"" \n""END"
#define SQL_DBUPG_21_C "ALTER TABLE `PSDCFG` ADD COLUMN `type` tinyint NOT NULL DEFAULT 0 ""AFTER `lastStage`"
#define SQL_DBUPG_21_D "UPDATE `PSDCFG` SET type = 1 WHERE duration = 30"
#define SQL_DBUPG_22_A "DROP PROCEDURE IF EXISTS `EVENTQ_PSD2`"
#define SQL_DBUPG_22_B "CREATE PROCEDURE `EVENTQ_PSD2`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE TRC2 INT; \n"" DECLARE CHNIFK INT; \n"" TRUNCATE TABLE `%s`; \n"" INSERT INTO `%s` \n"" SELECT T2.TRC_PK \n"" FROM TRC T1, TRC T2 \n"" WHERE T1.TRC_PK = TRC_KEY AND \n""   T1.CHNI_FK = T2.CHNI_FK AND \n""   T1.END < UTC_DATE() AND \n""   T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND \n""   T1.START >= T2.END; \n"" IF ((SELECT COUNT(*) FROM `%s`) = 1) THEN \n""  INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) \n""  SELECT 3, t1.trc_fk, TRC_KEY, t2.chni_fk FROM `%s` t1, TRC t2 WHERE t1.trc_fk = t2.trc_pk; \n"" END IF; \n"" IF ((SELECT COUNT(*) FROM `%s`) > 1) THEN \n""  SELECT 1; \n"" ELSE \n""  SELECT 0; \n"" END IF; \n""END "
#define SQL_DBUPG_22_C "CREATE PROCEDURE `EVENTQ_PSD2ERR`() \n""BEGIN \n"" SELECT CONCAT(directory, '/', filename) FROM `%s` t1, TRC t2 \n"" WHERE t1.trc_fk = t2.trc_pk; \n""END "
#define SQL_DBUPG_22_D "DROP VIEW IF EXISTS `epochSPS`"
#define SQL_DBUPG_22_E "CREATE TABLE `EPOCHSPS` (""chni_fk mediumint unsigned NOT NULL, ""sampInt int NOT NULL, ""startD date NOT NULL, ""endD date NOT NULL, ""KEY `chni_fk` (`chni_fk`, `startD`))""ENGINE=InnoDB DEFAULT CHARSET=latin1"
#define SQL_DBUPG_22_F "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'PSD Table - Delete Channel PSDs','EVENT')"
#define SQL_DBUPG_22_G1 "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'Sample Rate Epoch','EVENT')"
#define SQL_DBUPG_22_G2 "INSERT INTO EVENTQ (type, typeKey, processed) ""SELECT %d, chni_pk, 'NOPROC' FROM CHNI WHERE nTraces > 0"
#define SQL_DBUPG_22_G3 "CREATE PROCEDURE `EVENTQ_SPSE`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE CHNIFK INT; \n"" SELECT chni_fk \n"" FROM TRC \n"" WHERE trc_pk = TRC_KEY \n"" INTO CHNIFK; \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = 93 AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (93, CHNIFK, 'NOPROC'); \n"" END IF; \n""END "
#define SQL_DBUPG_22_H1 "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'Channel Statistics','EVENT')"
#define SQL_DBUPG_22_H2 "CREATE PROCEDURE `EVENTQ_CHNI`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE CHNIFK INT; \n"" SELECT chni_fk \n"" FROM TRC \n"" WHERE trc_pk = TRC_KEY \n"" INTO CHNIFK; \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = 97 AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (97, CHNIFK, 'NOPROC'); \n"" END IF; \n""END "
#define SQL_DBUPG_22_I1 "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'Directory Statistics','EVENT')"
#define SQL_DBUPG_23_A "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'Server PAUSE','EVENT')"
#define SQL_DBUPG_23_B "CREATE OR REPLACE ALGORITHM=UNDEFINED VIEW `eventQV` AS ""(select `EVENTQ`.`evtq_id` AS `EVTQ_ID`,`EVENTQ`.`type` AS `TYPE`,""`EVENTQ`.`typeKey` AS `TYPEKEY`,`EVENTQ`.`typeKey2` AS `TYPEKEY2` ""FROM `EVENTQ` WHERE (`EVENTQ`.`processed` = _latin1'UNPROC') ""ORDER BY `EVENTQ`.`type` limit 1) ""UNION ""(select %d AS `EVTQ_ID`,0 AS `TYPE`,0 AS `TYPEKEY`,0 AS `typeKey2`)"
#define SQL_DBUPG_23_C1 "DROP PROCEDURE IF EXISTS `spNextEvent`"
#define SQL_DBUPG_23_C2 "CREATE PROCEDURE `spNextEvent` () \n""BEGIN \n"" -- get the next available event and mark as INPROC \n"" DECLARE EVENT_PK, T, TK, TK2 INT; \n"" SELECT evtq_id, type, typekey, typekey2 \n"" FROM eventQV \n"" LIMIT 1 \n"" INTO EVENT_PK, T, TK, TK2; \n"" IF (EVENT_PK > %d AND T > %d) THEN \n""  UPDATE EVENTQ SET PROCESSED = 'INPROC' WHERE evtq_id = EVENT_PK; \n"" END IF; \n"" SELECT EVENT_PK, T, TK, TK2; \n""END "
#define SQL_DBUPG_23_D "ALTER TABLE SRVREXEC ADD COLUMN `doneTime` TIMESTAMP NULL DEFAULT NULL"
#define SQL_DBUPG_23_E "CREATE TABLE `EVENTQerr` ("" `srvrExec_fk` INT unsigned NOT NULL, "" `evtq_id` bigint unsigned NOT NULL, "" `type` mediumint unsigned NOT NULL,"" `typeKey` INT unsigned NOT NULL,"" `typeKey2` INT unsigned NOT NULL,"" `error_no` smallint NOT NULL default '0',"" `user_fk` mediumint unsigned NOT NULL,"" `chni_fk` mediumint unsigned NOT NULL,"" KEY `exec` (`srvrExec_fk`, `evtq_id`, `type`)"") ENGINE=MyISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPG_23_F "DROP TABLE `%sTMP`.`dbMaint`"
#define SQL_DBUPG_23_G "ALTER TABLE `DIRS` ENGINE = InnoDB"
#define SQL_DBUPG_24_A "ALTER TABLE EVENTQ ALTER COLUMN `typeKey2` SET DEFAULT 0"
#define SQL_DBUPG_24_B "DROP PROCEDURE `EVENTQ_CHNI`; DROP PROCEDURE `EVENTQ_SPSE`"
#define SQL_DBUPG_24_C "CREATE PROCEDURE `EVENTQ_FOLLOWUPS`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE PSDCFGFK INT; \n"" DECLARE CHNIFK INT; \n"" \n"" -- get the chni_fk we're interested in \n"" SELECT chni_fk \n"" FROM TRC \n"" WHERE trc_pk = TRC_KEY \n"" INTO CHNIFK; \n"" \n"" -- insert the CHNI event \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, CHNIFK, 'NOPROC'); \n"" END IF; \n"" \n"" -- insert the SPSE event \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, CHNIFK, 'NOPROC'); \n"" END IF; \n"" \n"" -- get the PSDCFG_PK, if there is one \n"" SELECT P.PSDCFG_PK \n"" FROM PSDCFG P \n"" WHERE P.CHNI_FK = CHNIFK \n"" INTO PSDCFGFK; \n"" IF (PSDCFGFK IS NOT NULL) THEN \n""  IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""   INSERT INTO EVENTQ (type, typeKey, processed, chni_fk) VALUES (%d, CHNIFK, 'NOPROC', CHNIFK); \n"" END IF; \n"" END IF; \n""END "
#define SQL_DBUPG_24_D "CREATE PROCEDURE `EVENTQ_DIRS`(IN DIR_KEY INT) \n""BEGIN \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = DIR_KEY) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, DIR_KEY, 'NOPROC'); \n"" END IF; \n""END "
#define SQL_DBUPG_25_A1 "DROP TRIGGER `TRC-DEL`"
#define SQL_DBUPG_25_A2 "CREATE TRIGGER `TRC-DEL` AFTER DELETE ON `TRC` FOR EACH ROW \n""BEGIN \n"" -- when deleting a TRC record, must clean up some stuff \n"" -- delete any unprocessed events for this deleted trace file \n"" DELETE FROM EVENTQ WHERE typeKey = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC'; \n"" DELETE FROM EVENTQ WHERE typeKey2 = OLD.TRC_PK and type in (1, 2, 3) and processed = 'UNPROC'; \n"" -- insert event 91 (PSDDEL) onto the EVENTQ for processing by the server for PSD channels \n"" IF (OLD.nsamps > 0) THEN \n""  IF ((SELECT count(*) FROM PSDCFG WHERE CHNI_FK = OLD.CHNI_FK) = 1) THEN \n""   INSERT INTO EVENTQ (type, typeKey, typeKey2, chni_fk, processed) VALUES (91, OLD.TRC_PK, OLD.CHNI_FK, OLD.CHNI_FK, 'NOPROC'); \n""  END IF; \n"" END IF; \n""END "
#define SQL_DBUPG_25_B "ALTER TABLE `CHNI` ENGINE = InnoDB"
#define SQL_DBUPG_25_C "ALTER TABLE `PDFIDX` ENGINE = InnoDB"
#define SQL_DBUPG_25_D "ALTER TABLE `EPOCHSPS` ADD COLUMN `sps_pk` INT UNSIGNED ""NOT NULL AUTO_INCREMENT FIRST, ADD PRIMARY KEY(`sps_pk`)"
#define SQL_DBUPG_26_A1 "CREATE OR REPLACE ALGORITHM=UNDEFINED VIEW `eventQV` AS \n""(select `EVENTQ`.`evtq_id` AS `EVTQ_ID`,`EVENTQ`.`type` AS `TYPE`, \n""`EVENTQ`.`typeKey` AS `TYPEKEY`,`EVENTQ`.`typeKey2` AS `TYPEKEY2`, \n""`EVENTQ`.`chni_fk` AS CHNI_FK \n""FROM `EVENTQ` WHERE (`EVENTQ`.`processed` = _latin1'UNPROC') \n""ORDER BY `EVENTQ`.`type` limit 1) \n""UNION \n""(select %d AS `EVTQ_ID`,0 AS `TYPE`,0 AS `TYPEKEY`,0 AS `typeKey2`, 0 AS `CHNI_FK`)"
#define SQL_DBUPG_26_A2 "DROP PROCEDURE IF EXISTS `spNextEvent`"
#define SQL_DBUPG_26_A3 "CREATE PROCEDURE `spNextEvent` () \n""BEGIN \n"" -- get the next available event and mark as INPROC \n"" DECLARE EVENT_PK, T, TK, TK2, CHNK INT; \n"" SELECT EVTQ_ID, TYPE, TYPEKEY, TYPEKEY2, CHNI_FK \n"" FROM eventQV \n"" LIMIT 1 \n"" INTO EVENT_PK, T, TK, TK2, CHNK; \n"" IF (EVENT_PK > %d AND T > %d) THEN \n""  UPDATE EVENTQ SET PROCESSED = 'INPROC' WHERE evtq_id = EVENT_PK; \n"" END IF; \n"" SELECT EVENT_PK, T, TK, TK2, CHNK; \n""END "
#define SQL_DBUPG_26_B1 "DROP PROCEDURE `EVENTQ_FOLLOWUPS`"
#define SQL_DBUPG_26_B2 "CREATE PROCEDURE `EVENTQ_FOLLOWUPS`(IN CHNIFK INT) \n""BEGIN \n"" DECLARE PSDCFGFK INT; \n"" \n"" -- insert the CHNI event \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, CHNIFK, 'NOPROC'); \n"" END IF; \n"" \n"" -- insert the SPSE event \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, CHNIFK, 'NOPROC'); \n"" END IF; \n"" \n"" -- get the PSDCFG_PK, if there is one \n"" SELECT P.PSDCFG_PK \n"" FROM PSDCFG P \n"" WHERE P.CHNI_FK = CHNIFK \n"" INTO PSDCFGFK; \n"" IF (PSDCFGFK IS NOT NULL) THEN \n""  IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""   INSERT INTO EVENTQ (type, typeKey, processed, chni_fk) VALUES (%d, CHNIFK, 'NOPROC', CHNIFK); \n"" END IF; \n"" END IF; \n""END "
#define SQL_DBUPG_27_A1 "ALTER TABLE `PDFCFG` ADD COLUMN `HLNM` ENUM('OFF','ON') NOT NULL default 'ON'"
#define SQL_DBUPG_27_A2 "UPDATE `PDFCFG` p, `PDFWWW` w SET p.HLNM = w.HLNM" 
#define SQL_DBUPG_27_B1 "RENAME TABLE `PDFWWW` to `PNGWWW`"
#define SQL_DBUPG_27_B2 "ALTER TABLE `PNGWWW` ADD COLUMN `pngwww_pk` TINYINT UNSIGNED NOT NULL AUTO_INCREMENT FIRST, ""ADD COLUMN `type` SMALLINT UNSIGNED NOT NULL DEFAULT 0 AFTER `pngwww_pk`, ""DROP COLUMN `HLNM`, ""ADD PRIMARY KEY(`pngwww_pk`)"
#define SQL_DBUPG_27_C1 "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'PDF','DBCONST'), ""(%d,'SPECTROGRAM','DBCONST'), ""(%d,'SYSTEM SPECTRO PNG','EVENT') "
#define SQL_DBUPG_27_D1 "UPDATE `PNGWWW` SET `type` = %d"
#define SQL_DBUPG_27_E1 "CREATE TABLE `%sTMP`.`PSDOPT` (`chni_fk` MEDIUMINT UNSIGNED NOT NULL, ""KEY `chnKey` (`chni_fk`)) ENGINE = InnoDB"
#define SQL_DBUPG_27_F1 "DROP PROCEDURE IF EXISTS `EVENTQ_PSD2`"
#define SQL_DBUPG_27_F2 "CREATE PROCEDURE `EVENTQ_PSD2`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE TRC2 INT; \n"" DECLARE CHNIFK INT; \n"" TRUNCATE TABLE `%s`; \n"" INSERT INTO `%s` \n"" SELECT T2.TRC_PK \n"" FROM TRC T1, TRC T2 \n"" WHERE T1.TRC_PK = TRC_KEY AND \n""   T1.CHNI_FK = T2.CHNI_FK AND \n""   T1.START < UTC_DATE() AND \n""   T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND \n""   T1.START >= T2.END; \n"" IF ((SELECT COUNT(*) FROM `%s`) = 1) THEN \n""  INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) \n""  SELECT 3, t1.trc_fk, TRC_KEY, t2.chni_fk FROM `%s` t1, TRC t2 WHERE t1.trc_fk = t2.trc_pk; \n"" END IF; \n"" IF ((SELECT COUNT(*) FROM `%s`) > 1) THEN \n""  SELECT 1; \n"" ELSE \n""  SELECT 0; \n"" END IF; \n""END "
#if 0
#define SQL_DBUPG_27_E2 "UPDATE `PDFCFG` ""SET dayStart = 8, dayEnd = 1 ""WHERE dayStart = 7;""UPDATE `PDFCFG` ""SET dayStart = 15, dayEnd = 8 ""WHERE dayStart = 14;""UPDATE `PDFCFG` ""SET dayStart = 31, dayEnd = 1 ""WHERE dayStart = 30;""UPDATE `PDFCFG` ""SET dayStart = 61, dayEnd = 31 ""WHERE dayStart = 60"
#endif
#define SQL_DBUPG_28_A1 "INSERT INTO `PNGWWW` ""(width, height, border, bordercolorR, bordercolorG, bordercolorB, ""Iwidth, Iheight, Iborder, IbordercolorR, IbordercolorG, IbordercolorB, ""wwwDir, type) VALUES ""(%d, %d, '%s', %d, %d, %d, %d, %d, '%s', %d, %d, %d, '%s', %d)"
#define SQL_DBUPG_28_B1 "INSERT INTO `PDFCFG` (name, description, type, dayStart, dayEnd, year) ""VALUES ('YDAY', 'ONE DAY AGO', 2, 2, 1, -1), ""('LYDAY', 'TWO DAYS AGO', 2, 3, 2, -1)"
#define SQL_DBUPG_28_C1 "DROP PROCEDURE IF EXISTS `EVENTQ_PSD2`"
#define SQL_DBUPG_28_C2 "CREATE PROCEDURE `EVENTQ_PSD2`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE TRC2 INT; \n"" DECLARE CHNIFK INT; \n"" TRUNCATE TABLE `%s`; \n"" INSERT INTO `%s` \n"" SELECT T2.TRC_PK \n"" FROM TRC T1, TRC T2 \n"" WHERE T1.TRC_PK = TRC_KEY AND \n""   T1.CHNI_FK = T2.CHNI_FK AND \n""   T1.START < UTC_DATE() AND \n""   T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND \n""   T1.START >= T2.END; \n"" IF ((SELECT COUNT(*) FROM `%s`) = 1) THEN \n""  INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) \n""  SELECT 3, t1.trc_fk, TRC_KEY, t2.chni_fk FROM `%s` t1, TRC t2 WHERE t1.trc_fk = t2.trc_pk; \n"" END IF; \n"" IF ((SELECT COUNT(*) FROM `%s`) > 1) THEN \n""  SELECT 1; \n"" ELSE \n""  SELECT 0; \n"" END IF; \n""END "
#define SQL_DBUPG_28_D1 "ALTER TABLE `PSDCFG` ADD COLUMN `overlap` TINYINT UNSIGNED NOT NULL DEFAULT 50 ""AFTER `maxPower`"
#define SQL_DBUPG_28_E1 "DROP TRIGGER `CHNIDEPENDENCIES`"
#define SQL_DBUPG_28_E2 "CREATE TRIGGER `CHNIDEPENDENCIES` AFTER INSERT ON `CHNI` FOR EACH ROW \n""BEGIN \n"" -- insert a DUMMY trace for the new channel, \n"" -- this is necessary for imported PDF's with no link back to the original trace \n"" INSERT INTO TRC (CHNI_FK) VALUES (NEW.CHNI_PK); \n"" \n"" -- insert all system (automatically computed) PDF's for the new channel \n"" INSERT INTO PDFIDX (PDFCFG_FK, CHNI_FK) SELECT PDFCFG_PK, NEW.CHNI_PK FROM PDFCFG P; \n"" \n"" -- insert the default PSD configuration parameters according to the channel name and PSDCFG entries \n"" INSERT INTO PSDCFG (channel, description, type, minPower, maxPower, overlap, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, chni_fk) \n"" SELECT channel, description, P.type, minPower, maxPower, overlap, sections, steps, duration, dbOffset, maxPeriod, binWidth, gapThresh, units, lastStage, NEW.CHNI_PK \n"" FROM PSDCFG P, IDS I WHERE P.CHNI_FK = 0 AND I.IDS_PK = NEW.CHN_FK AND LEFT(I.NAME,2) = P.channel; \n"" \n""END"
#define SQL_DBUPG_29_A "CREATE PROCEDURE `RESP_INSERT` \n"" (IN CHNKEY INT, IN DIR VARCHAR(1993), IN FN VARCHAR(55)) \n""BEGIN \n"" DECLARE RESPPK INT; \n"" DECLARE RESPDIR VARCHAR(2000); \n"" DECLARE RESPFN VARCHAR(60); \n"" SELECT RESP_PK, DIRECTORY, FILENAME \n"" FROM RESP \n"" WHERE CHNI_FK = CHNKEY \n"" INTO RESPPK, RESPDIR, RESPFN; \n"" IF (RESPPK IS NOT NULL) THEN \n""  IF (RESPDIR <> DIR OR RESPFN <> FN) THEN \n""   DELETE FROM RESP WHERE RESP_PK = RESPPK; \n""   INSERT INTO RESP (CHNI_FK, DIRECTORY, FILENAME) VALUES (CHNKEY, DIR, FN); \n""  END IF; \n"" ELSE \n""  INSERT INTO RESP (CHNI_FK, DIRECTORY, FILENAME) VALUES (CHNKEY, DIR, FN); \n""  UPDATE EVENTQ E SET E.processed = 'UNPROC' WHERE E.processed = 'PROCD' \n""   AND E.error_no = %d AND E.chni_fk = CHNKEY; \n"" END IF; \n""END "
#define SQL_DBUPG_30_A1 "DROP PROCEDURE IF EXISTS `EVENTQ_PSD2`"
#define SQL_DBUPG_30_A2 "CREATE PROCEDURE `EVENTQ_PSD2`(IN TRC_KEY INT) \n""BEGIN \n"" DECLARE TRC2 INT; \n"" DECLARE TRC1 INT; \n"" DECLARE CNT INT; \n"" TRUNCATE TABLE `%s`; \n"" INSERT INTO `%s` \n"" SELECT T2.TRC_PK \n"" FROM TRC T1, TRC T2 \n"" WHERE T1.TRC_PK = TRC_KEY AND \n""   T1.CHNI_FK = T2.CHNI_FK AND \n""   T1.START < UTC_DATE() AND \n""   T1.START <= DATE_ADD(T2.END, INTERVAL '2' MINUTE) AND \n""   T1.START >= T2.END \n"" ORDER BY 1 DESC; \n"" IF ((SELECT COUNT(*) FROM `%s`) > 0) THEN \n""  INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) \n""  SELECT 3, t1.trc_fk, TRC_KEY, t2.chni_fk FROM `%s` t1, TRC t2 WHERE t1.trc_fk = t2.trc_pk LIMIT 1; \n"" END IF; \n"" SELECT COUNT(*) FROM `%s` INTO CNT; \n"" IF (CNT > 2) THEN \n""  SELECT 1; \n"" ELSE \n""  IF (CNT = 2) THEN \n""   SELECT trc_fk FROM `%s` ORDER BY 1 ASC LIMIT 1 INTO TRC1; \n""   SELECT trc_fk FROM `%s` ORDER BY 1 DESC LIMIT 1 INTO TRC2; \n""   IF ((SELECT COUNT(*) FROM TRC t1, TRC t2 \n""    WHERE t1.trc_pk = TRC1 and t2.trc_pk = TRC2 \n""    AND t1.directory = t2.directory AND t1.filename = t2.filename) = 1) THEN \n""    SELECT 0; \n""   ELSE \n""    SELECT 1; \n""   END IF; \n""  ELSE \n""   SELECT 0; \n""  END IF; \n"" END IF; \n""END "
#define SQL_DBUPG_31_A1 "DELETE FROM CONSTANT WHERE type = 'EVENT' AND val IN (%d, %d, %d, %d, %d, %d, %d, %d)" 
#define SQL_DBUPG_31_A2 "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'TRACE - Statistics','EVENT'), ""(%d,'TRACE - PSD','EVENT'), ""(%d,'Multi-TRACE - PSD','EVENT'), ""(%d,'PSD - Index Create','EVENT'), ""(%d,'PSD - Delete by Trace','EVENT'), ""(%d,'PSD - Delete by Channel','EVENT'), ""(%d,'PNG - System PDF','EVENT'), ""(%d,'PNG - System SPECTRO','EVENT')"
#define SQL_DBUPG_31_B "CREATE TABLE `%s`.`EVENTQargs` ""(`evtq_id` bigint(20) UNSIGNED NOT NULL, "" `arg1` varchar(25) NOT NULL, "" `arg2` varchar(25) NOT NULL, "" `arg3` varchar(25) NOT NULL, "" `arg4` varchar(25) NOT NULL, "" `arg5` varchar(25) NOT NULL) ENGINE = MyISAM"
#define SQL_DBUPG_31_C "INSERT INTO `CONSTANT` (val, description, type) ""VALUES (%d, 'PSD - Delete by Date', 'EVENT')"
#define SQL_DBUPG_32_A "ALTER TABLE `SRVRLOG` MODIFY COLUMN `type` ENUM('LOG','INFO','WARN','ERROR')" 
#define SQL_DBUPG_33_A1 "DROP PROCEDURE `EVENTQ_FOLLOWUPS`"
#define SQL_DBUPG_33_A2 "CREATE PROCEDURE `EVENTQ_FOLLOWUPS`(IN CHNIFK INT) \n""BEGIN \n"" DECLARE PSDCFGFK INT; \n"" \n"" -- insert the CHNI event \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, CHNIFK, 'NOPROC'); \n"" END IF; \n"" \n"" -- insert the SPSE event \n"" IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""  INSERT INTO EVENTQ (type, typeKey, processed) VALUES (%d, CHNIFK, 'NOPROC'); \n"" END IF; \n"" \n"" -- get the PSDCFG_PK, if there is one \n"" SELECT P.PSDCFG_PK \n"" FROM PSDCFG P \n"" WHERE P.CHNI_FK = CHNIFK \n"" INTO PSDCFGFK; \n"" IF (PSDCFGFK IS NOT NULL) THEN \n""  IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""   INSERT INTO EVENTQ (type, typeKey, processed, chni_fk) VALUES (%d, CHNIFK, 'NOPROC', CHNIFK); \n""  END IF; \n""  IF ((SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND typeKey = CHNIFK) = 0) THEN \n""   INSERT INTO EVENTQ (type, typeKey, processed, chni_fk) VALUES (%d, CHNIFK, 'NOPROC', CHNIFK); \n""  END IF; \n"" END IF; \n""END "
#define SQL_DBUPG_33_B1 "INSERT INTO `CONSTANT` (val, description, type) VALUES ""(%d,'Baseline Statistics','EVENT') "
#define SQL_DBUPG_33_C "CREATE TABLE `%s`.`BLine` ( "" `bline_pk` MEDIUMINT UNSIGNED NOT NULL AUTO_INCREMENT, "" `name` VARCHAR(55) NOT NULL, "" `descr` varchar(255) NOT NULL, "" `dir` enum ('UP', 'DOWN') NOT NULL, "" `active` enum ('N', 'Y') NOT NULL DEFAULT 'Y', "" `chni_fk` MEDIUMINT NOT NULL DEFAULT 0, "" PRIMARY KEY (`bline_pk`)) ""ENGINE = MyISAM COMMENT = 'Baseline Definition';"
#define SQL_DBUPG_33_D "CREATE TABLE `%sSTATS`.`BLineD` "" (`bline_fk` MEDIUMINT NOT NULL, "" `period` decimal(12,6) NOT NULL, "" `power` decimal(8,4) NOT NULL, "" KEY `order` (`bline_fk`, `period`)) ""ENGINE = MyISAM COMMENT = 'Baseline Data';"
#define SQL_DBUPG_33_E "CREATE TABLE `%sSTATS`.`BLineI` "" (`blinei_pk` MEDIUMINT NOT NULL AUTO_INCREMENT, "" `bline_fk` MEDIUMINT NOT NULL, "" `sampInt` INTEGER NOT NULL, "" `periodMAX` DECIMAL(12,6) NOT NULL, "" PRIMARY KEY (`blinei_pk`)) ""ENGINE = MyISAM COMMENT = 'Baseline Index - Interpolated';"
#define SQL_DBUPG_33_F "CREATE TABLE `%sSTATS`.`BLineID` "" (`blinei_fk` MEDIUMINT NOT NULL, "" `period` decimal(12,6) NOT NULL, "" `power` smallINT NOT NULL, "" KEY `order` (`blinei_fk`, `period`)) ""ENGINE = MyISAM COMMENT = 'Baseline Data - Interpolated';"
#define SQL_DBUPG_33_G "CREATE TABLE `%sSTATS`.`BLineS%d` "" (`bline_fk` mediumint NOT NULL, "" `psd_fk` integer NOT NULL, "" `pct` decimal(5,2) UNSIGNED NOT NULL, "" KEY `bline_fk` (`bline_fk`)) ""ENGINE = MyISAM COMMENT = 'Baseline Statistics';"
#define SQL_DBUPG_33_H1 "INSERT INTO `%s`.BLine (bline_pk, name, descr, dir, active, chni_fk) ""VALUES (1, 'HNM', 'High Noise Model', 'UP', 'N', 0), ""(2, 'LNM', 'Low Noise Model', 'DOWN', 'N', 0)"
#include "hlnm.txt"
#define SQL_DBUPG_33_H2 BLINE_DATA_DEF
#define SQL_DBUPG_34_A1 "ALTER TABLE GLAP MODIFY COLUMN startPt INT UNSIGNED, ""MODIFY COLUMN endPt INT UNSIGNED"
#define SQL_DBUPG_34_A2 "ALTER TABLE TRC MODIFY COLUMN nsamps INT UNSIGNED"
#define SQL_PDBVERSION_UPD "UPDATE PQLXMETA.PQLXDBS SET dbVersion = '%d' WHERE dbName = 'PQLXMETA'"
#define SQL_DBUPGP_0_A "ALTER TABLE PQLXMETA.PQLXDBS DROP COLUMN `ntw`, DROP COLUMN `stn`, DROP COLUMN `loc`, DROP COLUMN `chn`"
#define SQL_DBUPGP_0_B "INSERT INTO PQLXMETA.PQLXDBS (dbName, organisation, description, techAdminName, ""dataAdminName, status, type, access, dbMaker, dbVersion, adminPWord, ""techAdminEmail, dataAdminEmail, wwwDir) ""VALUES ('PQLXMETA', 'PQLX', 'PQLX Meta Database', 'PQLX', 'PQLX', ""'ACTIVE', 'PRODUCTION', 'PUBLIC', 'PQLX', '0', 'dOn0Tt0vCh', 'none', 'none', 'NONE')"
#define SQL_DBUPGP_1_A "CREATE TABLE `PQLXMETA`.`SEISEVENT` (`seisevent_pk` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, ""`eventID` INTEGER UNSIGNED NOT NULL DEFAULT 0, `originID` INTEGER UNSIGNED NOT NULL DEFAULT 0, ""`description` VARCHAR(250) NOT NULL DEFAULT '', ""`catalog` VARCHAR(30) NOT NULL DEFAULT '', `time` DATETIME NOT NULL DEFAULT 0, ""`msec` MEDIUMINT NOT NULL DEFAULT 0, `lat` FLOAT NOT NULL DEFAULT 0, `lon` FLOAT NOT NULL DEFAULT 0, ""`depth` FLOAT NOT NULL DEFAULT 0, PRIMARY KEY(`seisevent_pk`), KEY `time` (`time`)) ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPGP_1_B "CREATE TABLE `PQLXMETA`.`SEISMAG` (`seisevent_fk` INTEGER UNSIGNED NOT NULL, ""`magnitude` FLOAT NOT NULL DEFAULT 0, `type` VARCHAR(5) NOT NULL DEFAULT '', "" KEY `seisevent_fk` (`seisevent_fk`)) ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPGP_1_C "CREATE TABLE `PQLXMETA`.`MODELNM` (`model_pk` SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT, ""`name` varchar(50) NOT NULL DEFAULT '', `importT` timestamp NOT NULL default '0000-00-00 00:00:00', ""PRIMARY KEY(`model_pk`)) ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPGP_1_D "CREATE TABLE `PQLXMETA`.`MODELPH` (`phase_pk` SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT, ""`model_fk` SMALLINT UNSIGNED NOT NULL, `name` varchar(10), PRIMARY KEY(`phase_pk`), ""KEY(`model_fk`, `phase_pk`)) ENGINE = MYISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs"
#define SQL_DBUPGP_1_E "CREATE TABLE `PQLXMETA`.`MODELTT` (`model_fk` SMALLINT UNSIGNED NOT NULL, ""`phase_fk` SMALLINT UNSIGNED NOT NULL, `depth` DECIMAL(5,2) NOT NULL DEFAULT 0, ""`distance` DECIMAL(6,3) NOT NULL DEFAULT 0, `ttime` DECIMAL(7,3) NOT NULL DEFAULT 0, ""KEY(`model_fk`, `phase_fk`, `depth`, `distance`)) ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPGP_1_F "CREATE TABLE `PQLXMETA`.`MODELTB` (`model_fk` SMALLINT UNSIGNED NOT NULL, ""`type` ENUM('DEPTH', 'DISTANCE') not null, `value` DECIMAL(6,3) NOT NULL DEFAULT 0, ""KEY `value` (`model_fk`, `type`, `value`)) ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_DBUPGP_2_A "ALTER DATABASE PQLXMETA COLLATE latin1_general_cs"
#define SQL_DBUPGP_3_A "ALTER TABLE PQLXMETA.PQLXDBS ADD COLUMN `hint` varchar(255) NOT NULL DEFAULT ''"
#endif
