#ifndef __DBIF_H
#define __DBIF_H
#include <time.h>
#include <glib.h>
#include "ptime.h"
#include "db_iface_defs.h"
#include "db_iface_head.h"
typedef struct _SRVRSTATE
{
struct {
int cntInfo[TTLSRVRSTT];
} data;
} SRVRSTATE;
typedef struct _PSDCONF
{
char *chnGroup;
int last_stage;
int min_power, max_power;
int overlap;
int sections;
int steps;
int hourly_data;
int psd_dur; 
int db_offset; 
float max_period; 
float bin_width; 
float gap_thresh; 
char *units; 
int type; 
struct {
int cmdFlag; 
gboolean data; 
} admin;
} PSDCONF;
typedef struct _PDFBOUNDS
{
struct {
int chnKey;
} keys;
struct {
MYTIME bounds[TTLCHNBOUNDS];
} data;
} PDFBOUNDS;
typedef struct _SCAN
{
struct {
int dirKey;
char directory[MAX_DIR_STR];
unsigned long long scanTime;
int scanType;
} keys;
struct {
int nTrace; 
int nResp; 
int nNtw; 
int nStn; 
int nLoc;
int nChn;
} data;
} SCAN;
typedef struct _SCANS
{
struct {
GSList *scans; 
} data;
} SCANS;
typedef struct _TRC
{
struct {
int trcKey;
int chni;
struct ptime trcTime;
} keys;
} TRCKEY;
typedef struct _TRCNEXT
{
struct {
int chnKey;
int trcKey;
} keys;
struct {
int trcKey;
char *filename;
} data; 
} TRCNEXT;
typedef struct _TRC1
{
struct {
int chnKey;
int fileType; 
char directory[MAX_DIR_STR];
char filename[MAX_FILE_STR];
} keys;
struct {
MYTIME sTime, eTime; 
int nSamps, nGaps, nOlaps; 
int *gaps; 
int *olaps; 
double stats[MAXSTATS]; 
double sampInt; 
} data;
} TRC1;
typedef struct _RESPFILE
{
struct {
int respKey;
int chnKey;
} keys;
struct {
char *fileName;
} data;
} RESPFILE;
typedef struct _SYSPDFDEF
{
int pdfKey;
char *pdfName;
char *pdfDescr;
int type, dayStart, dayEnd, year;
} SYSPDFDEF;
typedef struct _SYSPDFS
{
struct {
GSList *sysPDF; 
} data;
} SYSPDFS;
typedef struct _BLINEPT
{
float period;
float power;
} BLINEPT;
typedef struct _BLINEPTS
{
int numPts; 
BLINEPT *points; 
} BLINEPTS;
typedef struct _BLINEDEF
{
int blineKey; 
char *name, *descr;
gboolean global; 
gboolean dir;
gboolean active;
int chnKey;
BLINEPTS lineDef;
int R, G, B; 
} BLINEDEF;
typedef struct _SYSBLINES
{
struct {
GSList *sysBLINE; 
} data; 
} SYSBLINES;
typedef struct _PSD1
{
struct {
int chnKey, trcKey, trcKey2; 
char ntw[11], stn[11], loc[11], chn[11];
int year, jday; 
int fileType; 
char filename[2][MAX_DIR_STR + MAX_FILE_STR];
RESPFILE resp;
PSDCONF conf;
MYTIME psdTime; 
gboolean overlapPSD; 
} keys;
struct {
int nPeriods; 
float *period; 
int *power; 
MYTIME sTime, eTime; 
int psdKey;
} data;
} PSD1;
typedef struct _PDFPNG
{
struct {
int chnKey;
} keys;
struct {
char *ntw, *stn, *loc, *chn; 
GSList *pdfReqs; 
} data;
} PDFPNG;
typedef struct _PSDDATA
{
float period;
int power;
} PSDDATA;
typedef struct _SPECTRODATA
{
int psdRef;
GSList *psdData; 
} SPECTRODATA;
typedef struct _SPECREQ
{
struct {
int pdfType; 
int pdfKey; 
int chnKey; 
char *sysPDFB[TTLDATES]; 
float criteria[MAXNUMPDFREQCRIT]; 
int reqType; 
} keys;
struct {
char *pdfName; 
char *name; 
int numDivs; 
int numPSDs; 
int numRecs; 
int numPeriods; 
int numPSDday; 
GDate *dateBounds[TTLDATES]; 
float yBounds[TTLYBOUNDS]; 
int dbBounds[TTLYBOUNDS]; 
GList *spectro; 
int dateFmt; 
} data;
struct {
int dBRange; 
GDate *dateBounds[TTLDATES]; 
int bounds[TTLXCOORDS]; 
int dbBounds[TTLYBOUNDS]; 
GList *start, *end; 
guchar *dataMap; 
int numPSDs; 
int numDivs; 
gboolean replot; 
GHashTable *gaps; 
} plot;
gboolean busy; 
} SPECREQ;
typedef struct _SPECPNG
{
struct {
int chnKey;
} keys;
struct {
char *ntw, *stn, *loc, *chn; 
GSList *specReqs; 
} data;
} SPECPNG;
#if 0
typedef struct _PDFSTATSDATA
{
struct {
int chnKey;
GSList *hits; 
} keys;
struct {
GSList *stats; 
} data;
} PDFSTATSDATA;
#endif
typedef struct _TRCLST
{ 
char *trcName; 
MYTIME times[TTLTIMES]; 
double stats[MAXSTATS]; 
int event; 
double sampInt;
} TRCLST;
typedef struct _PSDTRCD
{ 
int reqID;
struct {
int chnKey;
} keys;
struct {
int numRecs;
GSList *trcList; 
} data;
} PSDTRCD;
typedef struct _PSDHRD
{ 
int reqID;
struct {
int chnKey;
} keys;
struct {
int numRecs;
MYTIME **hrList;
int length;
} data;
} PSDHRD;
typedef struct _SYSLST
{ 
int chnKey;
char *chnName; 
int event;
} SYSLST;
typedef struct _CRASHD
{ 
struct {
int which;
} keys;
struct {
GSList *crashList; 
} data;
} CRASHD;
typedef struct _GLAPS
{ 
int start, end;
} GLAPS;
typedef struct _TRCDATA
{
struct {
int trcKey;
} keys;
struct {
char *name;
MYTIME dates[TTLDATES];
double stats[MAXSTATS]; 
GSList *gaps;
GSList *olaps;
} data;
struct {
int data; 
int pixelPos[TTLDATES]; 
void *trc;
gboolean plot; 
gboolean lastDay; 
} display;
} TRCDATA;
typedef struct _CHNMETA
{
MYTIME dates[TTLDATES];
char *siteName;
double coords[TTLCOORDS];
float location[TTLLOCATIONS];
double sensitivity;
char *units;
char *instID;
double sampInt;
} CHNMETA;
typedef struct _INSTIDS
{
struct {
GHashTable *instIDs; 
} data;
} INSTIDS;
typedef struct _CHNDATA
{
struct {
int chnKey; 
} keys;
struct {
char *name; 
char *longName; 
GSList *traceFiles; 
int trcCnt;
double sampInt; 
PDFREQ *pdfReq;
GSList *chnMETA; 
} data;
struct {
double stats[2][MAXSTATS]; 
int numGaps, numOlaps;
TRCDATA *trcData; 
void *trcPlot; 
gboolean selected; 
} display;
} CHNDATA;
typedef struct _PDFPERIOD
{
struct {
int chnKey;
int psdKey;
} keys;
struct {
int ttlPeriods; 
} data;
} PDFPERIOD;
typedef struct _STNDATA
{ 
struct {
int stnKey;
GSList *chnKeys; 
MYTIME dates[TTLDATES]; 
} keys;
struct {
gchar *name; 
int numChannels;
GSList *chnInfo; 
}data;
struct {
int chnCntPre; 
void *pixelPos; 
} display;
} STNDATA;
typedef struct _INSTRUMENT
{
int chnKey;
char *instID;
} INSTRUMENT;
typedef struct _INSTRUMENTS
{
struct {
GSList *chnKeys; 
} keys;
struct {
GSList *instruments; 
} data;
} INSTRUMENTS;
typedef struct _SCRNDATA
{ 
struct {
GSList *chnKeys; 
MYTIME dates[TTLDATES]; 
} keys;
struct {
GHashTable *chnInfo; 
}data;
} SCRNDATA;
typedef struct _DATEBNDRY 
{
struct {
MYTIME dates[TTLDATES];
} data;
} DATEBNDRY;
typedef struct _REPSD
{
GDate *dtBounds[TTLDATES];
GSList *channels; 
}
REPSD;
typedef struct _XMLINFO
{
struct {
GSList *info;
} data;
} XMLINFO;
typedef struct _TTNAME
{
char *name;
int key; 
} TTNAME;
typedef struct _TTIME
{
int phaseKey;
char *phaseName;
float depth;
float distance;
float ttime;
} TTIME;
typedef struct _TTMODEL
{
char *name;
int key;
GSList *phases; 
} TTMODEL;
typedef struct _TTINFO
{
struct {
TTMODEL *model;
} keys;
struct {
GSList *ttimes; 
} data; 
} TTINFO;
typedef struct _ARRIVALS
{
struct {
int modelKey; 
float depth; 
float distance; 
char *stn; 
} keys;
struct {
GSList *phases; 
GSList *arrivals; 
} data;
} ARRIVALS;
typedef struct _EVENTINFO
{
int eventKey; 
int eventID, originID;
char *description;
char *catalog;
char *timeStamp;
char *magType;
int dtime[TTLSTNEVTTIMES];
float loc[TTLSTNEVTLOCS];
double eventTE;
} EVENTINFO;
typedef struct _SEISEVENTS
{
struct {
int day[TTLSTNEVTTIMES]; 
} keys;
struct {
GSList *events; 
} data;
} SEISEVENTS;
typedef struct _DBMAINT
{
struct {
char *tableName;
} keys;
struct {
GSList *channels;
} data;
} DBMAINT;
#endif
