#ifndef _DBIF_HEAD_H
#define _DBIF_HEAD_H
typedef struct _SQL_INFO
{
int sqr; 
gboolean callType; 
gboolean threaded; 
int dataEvent; 
void *returnFunc; 
struct {
int connNum; 
int errorNO; 
int cnt; 
} call;
} SQL_INFO;
typedef struct _EVNT_INFO
{ 
int id; 
int type; 
int typeKey; 
int typeKey2; 
int chnKey; 
int errorNO;
} EVNT_INFO;
typedef struct _DATA_INFO
{ 
int tableData; 
} DATA_INFO;
typedef struct _SQLDI
{ 
SQL_INFO args;
EVNT_INFO event;
DATA_INFO descr;
void *data;
void *data2;
} SQLDI;
typedef struct _LOGIN
{
struct {
char hostname[65];
char username[25];
char password[25];
char dbname[25];
int stnXDays;
char pgmName[50];
int numCPUs;
} keys;
struct {
int numChn;
int logKey;
int dbVersion;
int pdbVersion;
gboolean initialExecution;
GSList *models; 
} data;
} LOGIN;
typedef struct _IDS
{
struct {
int idKey;
char type[4];
} keys;
struct {
char name[10];
char alias[55];
} data;
} IDS;
typedef struct _CHNI
{
struct {
int chniKey;
int idKeys[4];
char *name;
} keys;
void* data; 
} CHNI;
typedef struct _SPSEPOCH
{
int sampInt;
char *dates[TTLTIMES];
} SPSEPOCH;
typedef struct _CHNSTATS
{
int chnKey;
char *name;
char *dataDate[TTLTIMES]; 
int nTrace;
int nPSD;
int nSPSepoch;
char *response;
double sampInt;
GSList *spsEpochs; 
} CHNSTATS;
typedef struct _PNGWWW
{
int type; 
char *name;
char *dir; 
gboolean border, Iborder, HLNM; 
int width, height, Iwidth, Iheight; 
int r, g, b, Ir, Ig, Ib; 
gboolean stats[TTLPDFSTATS]; 
int dateFmt;
} PNGWWW;
typedef struct _EQREC
{
char *descr;
int count;
int status;
char *error;
} EQREC;
typedef struct _EVENTQLIST
{
GSList *events; 
} EVENTQLIST;
typedef struct _LOGMSG
{
struct {
int logKey;
char *dbName;
} keys;
struct {
int type;
char *time;
char *msg;
} data;
} LOGMSG;
typedef struct _SRVRLOG
{
struct {
int execKey;
LOGMSG *lastLog; 
} keys;
struct {
char *pgmName;
char *time[TTLTIMES]; 
char *duration;
gboolean complete;
gboolean updated[TTLSRVRLOGTYPES];
GSList *msgs[TTLSRVRLOGTYPES]; 
} data;
} SRVRLOG;
typedef struct _SRVREXEC
{
struct {
GSList *execs; 
} data;
} SRVREXEC;
typedef struct _NEWEXEC
{
struct {
int lastExec;
} keys;
struct {
gboolean started;
} data;
} NEWEXEC;
typedef struct _DATADIR
{
int pk;
char *directory;
char *lastFile;
char *status;
int statusI;
int ttlTrace;
int ttlResp;
struct {
int cmdFlag; 
} admin;
} DATADIR;
typedef struct _DBLST
{
char *hostName;
char *dbName;
char *organisation;
char *description;
char *techAdminName;
char *techAdminEmail;
char *dataAdminName;
char *dataAdminEmail;
char *type; 
char *access;
int typeI, accessI; 
char *adminPWord;
char *hint;
int dbVersion;
} DBLST;
typedef struct _DBDEF
{
DBLST dbListing;
GSList *pngWWW; 
GSList *dataDirs; 
GSList *psdConfs; 
GSList *chnInfo; 
SRVREXEC srvrExec; 
} DBDEF;
typedef struct _SERVERDBS
{
struct {
char *srvrName;
char *dbName;
GSList *dbsList; 
} data;
} SERVERDBS;
typedef struct _PDFDATA
{
float period;
int power;
double prob;
} PDFDATA;
typedef struct _PDFHITSDATA
{
float period;
int power;
int hits;
} PDFHITSDATA;
typedef struct _PDFHITS
{
int pdfKey;
int ttlPeriods;
int ttlHits; 
int ttlRows; 
PDFHITSDATA *hits; 
} PDFHITS;
typedef struct _PDFSTATS1
{ 
float period;
int statV[TTLPDFSTATS];
} PDFSTATS1;
typedef struct _PDFSTATS
{
int pdfKey;
int ttlPeriods;
PDFSTATS1 *stats; 
} PDFSTATS;
typedef struct _PDFSTATSL1
{
float period;
int power;
} PDFSTATSL1;
typedef struct _PDFSTATSL
{ 
int statistic; 
int numPts; 
PDFSTATSL1 *line;
} PDFSTATSL;
typedef struct _MYTIME
{
double epochS;
PTIME date;
short m_secs;
} MYTIME;
typedef struct _PDFREQ
{
int reqID; 
struct {
int pdfType; 
int pdfKey; 
int chnKey; 
char *sysPDFB[TTLDATES]; 
int yBounds[TTLYBOUNDS]; 
gboolean statistics[TTLPDFSTATS]; 
int reqType; 
float criteria[MAXNUMPDFREQCRIT]; 
gboolean tmpFilled; 
gboolean fillTmp; 
int type; 
struct {
int bline_fk; 
int pct; 
} bline;
} keys;
struct {
char *pdfName; 
char *name; 
int numPSDs; 
int numRecs; 
PDFDATA *pdf; 
float *pdfM; 
MYTIME sTime, eTime; 
PDFHITS *hits; 
PDFSTATS *stats; 
GSList *statLines; 
int dateFmt; 
int ttlEpochs; 
} data;
gboolean busy; 
} PDFREQ;
#endif
