#ifndef _GDBM_H_
#define _GDBM_H_
#define GDBM_READER 0 
#define GDBM_WRITER 1 
#define GDBM_WRCREAT 2 
#define GDBM_NEWDB 3 
#define GDBM_FAST 0x10 
#define GDBM_SYNC 0x20 
#define GDBM_NOLOCK 0x40 
#define GDBM_INSERT 0 
#define GDBM_REPLACE 1 
#define GDBM_CACHESIZE 1 
#define GDBM_FASTMODE 2 
#define GDBM_SYNCMODE 3 
#define GDBM_CENTFREE 4 
#define GDBM_COALESCEBLKS 5 
typedef struct {
char *dptr;
int dsize;
} datum;
typedef struct {int dummy[10];} *GDBM_FILE;
#ifndef __P
#if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define __P(x) x
#else
#define __P(x) ()
#endif
#endif
extern char *gdbm_version; 
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
extern GDBM_FILE gdbm_open __P((char *, int, int, int, void (*)()));
extern void gdbm_close __P((GDBM_FILE));
extern int gdbm_store __P((GDBM_FILE, datum, datum, int));
extern datum gdbm_fetch __P((GDBM_FILE, datum));
extern int gdbm_delete __P((GDBM_FILE, datum));
extern datum gdbm_firstkey __P((GDBM_FILE));
extern datum gdbm_nextkey __P((GDBM_FILE, datum));
extern int gdbm_reorganize __P((GDBM_FILE));
extern void gdbm_sync __P((GDBM_FILE));
extern int gdbm_exists __P((GDBM_FILE, datum));
extern int gdbm_setopt __P((GDBM_FILE, int, int *, int));
extern int gdbm_fdesc __P((GDBM_FILE));
#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
#define GDBM_NO_ERROR 0
#define GDBM_MALLOC_ERROR 1
#define GDBM_BLOCK_SIZE_ERROR 2
#define GDBM_FILE_OPEN_ERROR 3
#define GDBM_FILE_WRITE_ERROR 4
#define GDBM_FILE_SEEK_ERROR 5
#define GDBM_FILE_READ_ERROR 6
#define GDBM_BAD_MAGIC_NUMBER 7
#define GDBM_EMPTY_DATABASE 8
#define GDBM_CANT_BE_READER 9
#define GDBM_CANT_BE_WRITER 10
#define GDBM_READER_CANT_DELETE 11
#define GDBM_READER_CANT_STORE 12
#define GDBM_READER_CANT_REORGANIZE 13
#define GDBM_UNKNOWN_UPDATE 14
#define GDBM_ITEM_NOT_FOUND 15
#define GDBM_REORGANIZE_FAILED 16
#define GDBM_CANNOT_REPLACE 17
#define GDBM_ILLEGAL_DATA 18
#define GDBM_OPT_ALREADY_SET 19
#define GDBM_OPT_ILLEGAL 20
typedef int gdbm_error; 
extern gdbm_error gdbm_errno;
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
extern char *gdbm_strerror __P((gdbm_error));
#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
#endif
