// CONTROLS HELP
#define CTRLH1 "CONTROLS Panel\n"
#define CTRLB1 "The CONTROLS Panel holds settings relating to the control of PQL execution.  Screen-specific settings are described in the Help page of the Screen itself; the settings described here are those which are not screen-specific, namely, the FILTER, PRINT, SORT, and OVERLAY settings.\n"

#define CTRLH2 "SIDEBAR Functions\n"
#define CTRLH2A "Buttons\n"
#define CTRLB2 "Set Defaults\n"
#define CTRLB21 "Write all current settings to the PQL defaults file.  This file, named '.pqldfaults', is located in the HOME directory of the executing user.  In addition to all settings defined within the Control Panel, all relevant Display settings for each screen are also saved.  As well, information such as PQL window size, current data directory (of the TRACES File Selector), and other information is saved here.\n"
#define CTRLB3 "Restore Defaults\n"
#define CTRLB31 "Re-Read settings currently held in defaults file and apply.  To return PQL to Factory Defaults, remove or rename the defaults files and restart PQL.\n"
#define CTRLB4 "HELP\n"
#define CTRLB41 "Display this HELP Panel.\n"
#define CTRLB5 "Cancel\n"
#define CTRLB51 "Do not apply any changes made and return to the current Screen.\n"

#define CTRLH3 "FILTER Settings\n"
#define CTRLB6A "Via the FILTER ON/OFF Sidebar Display Setting (on MAGNIFY, SPECTRA and SPLIT Screens), an IIR Filter is applied to the currently selected traces only.  The FILTER ON/OFF setting is global in nature, turning the Filter ON in one screen, turns it ON for all (relevant) screens.  The Filter is automatically turned OFF when selecting new traces for MAGNIFY or SPECTRA Screen processing.\n"
#define CTRLB6B "The FILTER Settings are found on the Filter/Print Tab, defined as:\n"
#define CTRLB61 "Filter Options:\n"
#define CTRLB611 "High Pass Filter\n"
#define CTRLB6111 "Poles:\n"
#define CTRLB61111 "Define the number of poles to use for the High Pass Filter.  Specify 0 Poles to turn High Pass Filter OFF.\n"
#define CTRLB6112 "Cutoff Freq (Hz):\n"
#define CTRLB61121 "Define the High Pass Filter Cutoff Frequency.  This may be explicitly defined here, or via the SPECTRA Screen (see SPECTRA Screen MOUSE Functions Help for details).  This value must be less than the Low Pass Cutoff Frequency.\n"

#define CTRLB621 "Low Pass Filter\n"
#define CTRLB6211 "Poles:\n"
#define CTRLB62111 "Define the number of poles to use for the Low Pass Filter.  Specify 0 Poles to turn Low Pass Filter OFF.\n"
#define CTRLB6212 "Cutoff Freq (Hz):\n"
#define CTRLB62121 "Define the Low Pass Filter Cutoff Frequency.  This may be explicitly defined here, or via the SPECTRA Screen.  This value must be less than or equal to Nyquist.\n"

#define CTRLH4 "PRINT Settings\n"
#define CTRLB7A "Printing of PQL Screens may be done directly to a Printer, to a File, or both, with output in PS-Adobe-3.0 Postscript format, conforming to the following rules:\n"
#define CTRLB7B "If only a Filename is specified, PRINT uses this as a basename (adding sequential numbers) and writes its output to this File only.\n"
#define CTRLB7C "If only the Print Command is specified, PRINT writes its output directly to the currently defined Printer, (a temporary file is created and immediately deleted).\n"
#define CTRLB7D "If both a Filename and the Print Command are specified, PRINT writes its output to both the File and the Printer.\n"
#define CTRLB7E "If neither are specified, a file selector dialog is presented with PRINT output written to the user-specified file.\n"
#define CTRLB7F "The PRINT Settings are found on the Filter/Print Tab, defined as:\n"
#define CTRLB71 "Printing:\n"
#define CTRLB711 "Filename:\n"
#define CTRLB7111 "Define the output File Basename to use for writing to a File.\n"
#define CTRLB712 "Print Command:\n"
#define CTRLB7121 "Define the Print Command of this computer.\n"
#define CTRLB713 "Resolution:\n"
#define CTRLB7131 "Define the Resolution of the PRINT output.  LOW resolution is better if wanting to view the output on the screen (via some Postscript viewer), and HIGH resolution is better if wanting to send PRINT output to a Printer.\n"
#define CTRLB714 "Paper Size:\n"
#define CTRLB7141 "Define the Paper Size of the Printer, either Letter (8.5in X 11.5in), or A4 (210mm X 297mm).\n"

#define CTRLH5 "SORT Settings\n"
#define CTRLB8A "Sorting of input Trace files is possible via the Sort Button found on the Sort Tab of the Controls Panel.\n"
#define CTRLB8AA "SORT Criteria:\n"
#define CTRLB8B "Criteria #:\n"
#define CTRLB8C "Pre-defined Sort Criteria options allow input Traces to be sorted on all defined criteria, either Ascending or Descending.  The complete list of current Criteria Options are all those listed via Criteria #1 pulldown.\n"
#define CTRLB8 "Buttons\n"
#define CTRLB81 "New Sort\n"
#define CTRLB811 "Clear current Sort Criteria Settings, ready for new Sort specification starting with Criteria #1.\n"
#define CTRLB91 "Sort\n"
#define CTRLB911 "SORT the current input list of Trace files and return.  If HEADERS Screen is currently displayed, HEADERS Screen contents will be re-ordered and displayed.  If HEADERS Screen is not currently displayed, PQL will return to the TRACE Screen displaying the newly ordered traces starting from the beginning of the list.\n"

#define CTRLH6 "OVERLAY Colors\n"
#define CTRLB9A "The Overlay Tab defines the 30 overlay colors that are used with the MAGNIFY and SPECTRA screens with Overlay Mode ON.  These are user-defined and may be specified here.  When overlaying more than 30 Traces or Transforms, Overlay colors are re-used starting from color #1.\n"
