//	INTRODUCTION HELP TAB
#define INTROH1	"PQL II - Seismic Trace Viewer\n"
#define INTROB1 "Providing a quick and easy method to view seismic trace files, PQL has been thoroughly modernized and enhanced.  These HELP pages provide all the necessary information for successful execution.\n"

#define INTROH7 "FUNCTIONAL FEATURES\n"
#define INTROH7A "PQL II features include:\n"
#define INTROB22 "MULTIPLE FILE FORMATS\n"
#define INTROB221 "Auto-detection of seismic data file formats AH, SEGY, SAC, NANO, and mini-SEED with simultaneous display\n"
#define INTROB23 "EITHER ENDIAN FORMATS\n"
#define INTROB231 "Auto-detection of either endian-type file by PQL II running on either endian-type machine\n"
#define INTROB24 "MAGNIFICATION\n"
#define INTROB241 "Magnify specific portions of trace files for closer viewing with full ZOOMing abilities\n"
#define INTROB25 "FFT TRANSFORMATION\n"
#define INTROB251 "Transform specific protions of trace files for further analysis\n"
#define INTROB26 "SPLIT SCREEN\n"
#define INTROB261 "Allowing viewing of entire trace, magnification, and transformation screens simultaneously\n"
#define INTROB27 "HEADER DISPLAY\n"
#define INTROB271 "Header and other trace-specific information listed in table format\n"
#define INTROB28 "FILTERING\n"
#define INTROB281 "Application of an IIR High and/or Low Pass Filter with user-defined number of Poles and Cutoff Frequencies\n"
#define INTROB29 "SORTING\n"
#define INTROB291 "Full sorting capabilities against multiple criteria\n"
#define INTROB30 "MULTIPLE DISPLAY MODES\n"
#define INTROB301 "Several possibilites to display traces, such as:\n"
#define INTROB3011 "Time Axis in Relative or Absolute Time\n"
#define INTROB3012 "Amplitude Axis Scaling by individual trace or all traces on display\n"
#define INTROB3013 "COUNTS or VOLTS\n"
#define INTROB3014 "Overlay mode of traces using user-definable overlay colors\n"
#define INTROB31 "PICKING\n"
#define INTROB311 "Picking capabilities allowing up to 10 user-defined Picks, writing all picks to user-defined file, with optional KEYWORDS and COMMENTARY output allowing for further description of the Picks themselves\n"
#define INTROB32 "PRINTING\n"
#define INTROB321 "Postscript output to either a printer, a file, or both\n"
#define INTROB33 "GAP/OVERLAP DETECTION\n"
#define INTROB331 "For mini-SEED trace files, automatic GAP and OVERLAP detection and display\n"

#define INTROH6 "DISPLAY LAYOUT\n"
#define INTROB11 "PQL II screens are laid out as:\n"
#define INTROH6S1 "SIDEBAR\n"
#define INTROB12 "On left side of display - containing various action buttons and display settings specific to the screen currently being displayed.  Contents of the sidebar change according to the SCREEN TAB currently selected.\n"
#define INTROH6S2 "SCREEN TABS\n"
#define INTROB13 "Across top of display - defining the screens available for data viewing.  Selecting a tab displays the desired screen.\n"
#define INTROH6S3 "STATUS BAR\n"
#define INTROB14 "Across bottom of display - providing an area to display messages to the user.\n"
#define INTROH6S4 "DATA DISPLAY\n"
#define INTROB15 "In middle of display - displaying the graphical output of PQL II.\n"

#define INTROH4 "SCREEN TABS\n"
#define INTROH4A "PQL II Screens are:\n"
#define INTROH4S1 "TRACE\n"
#define INTROB16 "Displays seismic trace files in their entirety.\n"
#define INTROH4S2 "MAGNIFY\n"
#define INTROB17 "Displays the selected portion of the currently selected trace files.\n"
#define INTROH4S3 "SPECTRA\n"
#define INTROB18 "Displays the FFT (fast fourier transform) of the selected portion of the currently selected trace files.\n" 
#define INTROH4S4 "SPLIT\n"
#define INTROB19 "Displays 2 or 3 split screens, each containing one of TRACE, MAGNIFY, or SPECTRA display data.  Useful when wanting to see the data of the screens simultaneously.\n"
#define INTROH4S5 "HEADERS\n"
#define INTROB20 "Displays various header data and other information of the trace files.  See the HEADERS Tab of the Control Panel for a complete list of information displayed here.\n"

#define INTROH5 "MOUSE Functions\n"
#define INTROB21 "All mouse functions throughout PQL are executed with a single (left) mouse CLICK plus (possible) modifier keys: SHIFT, CTRL, and ALT.  Each screen provides an easy-to-access Mouse Tips popup (at bottom of sidebar) describing all Mouse functions specific to that screen.\n"

#define INTROH2 "VIEWING TRACES\n"
#define INTROB2 "Viewing seismic trace files occurs by:\n"
#define INTROB2A "specifying Trace files on the execution command line\n"
#define INTROB2B "specifying Trace files in a Sort File, or\n"
#define INTROB2C "reading Trace files via the TRACES File Selector interface\n"
#define INTROB2D "On the command line, Trace files may be specified as:\n"
#define INTROBI1 "\tpql [-h] [TRACES | -s sortFile]\n"
#define INTROB3 "That is, either individual trace files or a Sort File may be specified on the command line.\n"
#define INTROB3A "If specifying trace files on the command line, trace files are displayed in the order specified.  If a current Sort Order is defined (via the Controls Panel), this will be applied before traces are displayed.\n"
#define INTROB4 "If specifying a Sort File, (holding a list of the trace files to view, one trace per line), trace files are displayed in the order defined by this file.\n"
#define INTROH3 "TRACES File Selector\n"
#define INTROB5 "Alternatively, no trace files or Sort File may be specified.  In this case, PQL will be invoked displaying no traces, ready to read input via the TRACES button on the TRACE screen's sidebar.\n"
#define INTROB6 "With this file selector, trace files are read in for viewing, reading either individual files or the files of one or more directories for viewing:\n"
#define INTROB7 "If selecting one or more files from the right-side display box, PQL reads these files for processing.\n"
#define INTROB8 "If selecting one or more directories, PQL reads the files in these directories, accepting as input all files auto-detected of a valid format.\n"
#define INTROB9 "Multiple selections of Files and/or Directories can be made using:\n"
#define INTROB9A "the SHIFT Key to select a range of files or directories, or \n"
#define INTROB9B "the CTRL Key to select individual files and/or directories.\n"
#define INTROB9C "A single option allows the user to specify whether the input trace files should replace, or be added to the list of trace files currently being viewed (useful when traces span multiple directories).  The resulting list of input files is automatically re-sorted according to the current Sort Order (defined in the Controls Panel).\n"
#define INTROB10 "The headers of all traces are read and traces are displayed starting from first trace of the current Sort Order.\n"

