// TRACE HELP TAB
#define TRACEH1	"TRACE Screen\n"
#define TRACEB1 "The TRACE screen displays the input traces.  Since PQL is a trace-based viewer, each trace displayed reflects the entire contents of the trace file.  Traces are presented, ordered top to bottom, with the:\n"
#define TRACEBI1 "TRACE LABEL\tto the left of the trace\n"
#define TRACEBI2 "TRACE DECIMATION\tto the right of the trace (that is, the number of data points held within a single vertical display pixel), and\n"
#define TRACEBI3 "TIME AXIS\tat the bottom of the display (in seconds)\n"

#define TRACEH2A "SIDEBAR Functions\n"
#define TRACEH2 "SCREEN Buttons\n"
#define TRACEH2S1 "TRACES"
#define TRACEB2 "\t\tInvoke the Trace File Selector (see Intro Help for Details and Usage)\n"
#define TRACEH2S2 "NEXT"
#define TRACEB3 "\t\tDisplay the next screen of traces\n"
#define TRACEH2S3 "PREVIOUS"
#define TRACEB4 "\tDisplay the previous screen of traces\n"

#define TRACEH3 "DISPLAY Settings\n"
#define TRACEH3S1 "Window Scale:\n"
#define TRACEH3S1A	"Define the Amplitude Axis maximum and minimum values of each individual trace\n"
#define TRACEH3S11 "by TRACE\n"
#define TRACEB5 "Use max and min values of the Trace itself\n"
#define TRACEH3S12 "by WINDOW\n"
#define TRACEB6 "Use max and min values of all Traces currently displayed\n"
#define TRACEH3S3 "Time Axis:\n"
#define TRACEH3S3A "Define how the Time Axis is to be represented\n" 
#define TRACEH3S31 "RELATIVE\n"
#define TRACEB7 "Use the maximum length (in seconds) of ALL traces on display\n"
#define TRACEH3S32 "ABSOLUTE\n"
#define TRACEB8 "Use the Absolute Start Times defined by the headers of the traces on display (this setting also defining the MAGNIFY Screen Time Axis)\n"

#define TRACEH3S2 "Display as:\n"
#define TRACEB33 "Display trace values in Counts or Volts.  This is automatically set specific to the trace file format(s) currently on display as follows:\n"
#define TRACEB34 "COUNTS only"
#define TRACEB35 "\tmini-SEED\n"
#define TRACEB36 "VOLTS only"
#define TRACEB37 "\tAH, SAC, and NANO\n"
#define TRACEB38 "Both"
#define TRACEB39 "\t\tSEGY\n"

#define TRACEH4 "TRACE Buttons\n"
#define TRACEH4S1 "REMOVE"
#define TRACEB9 "\t\t\tDelete the selected trace(s) from the current input list\n"
#define TRACEH4S2 "SELECT ALL"
#define TRACEB10 "\t\tSelect all traces on display\n"
#define TRACEH4S3 "DESELECT ALL"
#define TRACEB11 "\tDe-select all traces on display\n"
#define TRACEH4S4 "MARK\n"
#define TRACEB11A "Write the selected traces to MARK File.  Filename is MARK base filename (via Controls Panel) plus '.' and MARK file number.  MARK File can be subsequently used as input for further processing, e.g., deleting, moving, or further analyzing the saved file(s).\n"

#define TRACEH5 "GENERAL Buttons\n"
#define TRACEH5S1 "PRINT\n"
#define TRACEB12 "Create Postscript output of the current screen, either directly to a printer, to a file, or both, see Controls Panel HELP for more info regarding options\n"
#define TRACEH5S2 "CONTROLS"
#define TRACEB13 "\tAccess the Control Panel settings for PQL\n"
#define TRACEH5S3 "ABOUT"
#define TRACEB14 "\t\tDisplay Version, Authorship and Licensing Information\n"
#define TRACEH5S4 "QUIT"
#define TRACEB15 "\t\tExit PQL\n"

#define TRACEH6 "CONTROL Screen Options\n"
#define TRACEH6S1 "Plotting\n"
#define TRACEH6S11 "Number of Traces\n"
#define TRACEB16 "Define the number of traces to display per screen, maximum 100\n"
#define TRACEH6S12 "Magnify Interval\n"
#define TRACEB17 "Define the magnify interval to use when specifying only a single magnify boundary, defaults to 10% of trace length\n"
#define TRACEH6S2 "Trace Label\n"
#define TRACEB17A "Specify how the label should be displayed.\n"
#define TRACEH6S21 "Filename\n"
#define TRACEB18 "Label is the full pathname\n"
#define TRACEH6S22 "Pathless\n"
#define TRACEB19 "Label is the filename only\n"
#define TRACEH6S23 "Header Info\n"
#define TRACEB20 "Label is header information: Start Time, Sensor ID or Station Name, and Channel (n.b. when there is not enough space for two line display, label will be displayed in Pathless mode)\n"
#define TRACEH6S24 "Maximum Pixels/Filename\n"
#define TRACEB21 "Label is exactly this many pixels wide. (0=automatic)\n"

#define TRACEH6S6 "MARKing\n"
#define TRACEH6S61 "Mark Base Filename\n"
#define TRACEB21A "Define the MARK base filename to use when MARKing Files\n"

#define TRACEH6S3 "Indicator Flags\n"
#define TRACEB22 "Turn ON and OFF Gap and Overlap flags\n"
#define TRACEB221 "A Gap is identified if the next data packet start time is more than 1 sample's worth of time greater than expected.  Gaps and Overlaps are checked for vs. mini-SEED trace files only.\n"
#define TRACEH6S4 "Colors\n"
#define TRACEB23 "Define the various settable colors for the screen\n"
#define TRACEH6S5 "Buttons\n"
#define TRACEH6S51 "Continue\n"
#define TRACEB24 "Apply new settings and return to the TRACE screen\n"
#define TRACEH6S52 "Restart\n"
#define TRACEB25 "Apply new settings and return to the TRACE screen, displaying from trace #1"

#define TRACEH7 "MOUSE Functions\n"
#define TRACEH7S1 "Select/Deslect Trace(s)\n"
#define TRACEB26 "CLICK on trace label to select an individual trace, CLICK+DRAG to select multiple traces\n"
#define TRACEH7S3 "Define Magnification Boundary\n"
#define TRACEB28 "CLICK within plot region at desired boundary location, may be 1 or 2 lines.\nWhen specifying a single line, magnify interval (see below) will be used in defining magnify screen display length.\n"
#define TRACEH7S4 "Display Data Point Values and Deltas - Time and Amplitude\n"
#define TRACEB29 "CTRL+CLICK within desired trace, information is displayed in status bar at bottom.\nSelect a 2nd data point to see the differences with the 1st point, works across multiple traces.\n"
#define TRACEH7S6 "Scan Data Point Values - Time and Amplitude\n"
#define TRACEB31 "CTRL+CLICK+DRAG within desired trace.\n"
#define TRACEH7S7 "Make Trace First on Display\n"
#define TRACEB32 "SHIFT+CLICK anywhere on trace\n"

