#ifndef __PQL_DATA_STRUCTS_H
#define __PQL_DATA_STRUCTS_H
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <sys/types.h>
#include <stdio.h>
#include "ptime.h"
#define offsetD(a, b) ((int) ((long) &a - (long) &b))
typedef struct { 
int destSystem; 
int destTab; 
struct {
int scale; 
char *fixed[2]; 
} yaxis;
} SOURCEINFO;
typedef struct _SORTPARAMS
{
int type; 
int sortCrit;
} SORTPARAMS;
typedef struct _HDRITEM
{
char desc[255];
int offset;
int fieldType;
} HDRITEM;
typedef struct _CRITITEM
{
char *desc; 
int unique; 
int selected; 
int offset; 
int fieldType; 
} CRITITEM;
typedef struct _CRITDEF
{
int num; 
gboolean dir; 
} CRITDEF;
typedef struct _SORTINFO
{
int sortNum; 
GSList *criteria; 
GSList *user; 
} SORTINFO;
typedef struct {
char name[FNAMELEN];
int poles[2];
float cutoff[2];
} filter;
typedef struct {
int length;
int left;
int right;
} bounds;
typedef struct {
double length;
double left;
double right;
} coords;
typedef struct {
double max;
double min;
double diff;
double diffVolts;
double mean;
} amplitudes;
typedef struct {
double start;
double end;
double shift;
double diff;
} times;
typedef struct {
int rec_num;
double epoch;
struct ptime timeVal;
double minAmp;
double maxAmp;
double freqVal;
int xVal;
int yVal;
} pointID;
typedef struct {
pointID point[2];
} points;
typedef struct {
int pick[MAXPICKS]; 
int errorPick[MAXPICKS][2]; 
} picks;
typedef struct {
int pickN; 
gboolean pickE; 
double pickT; 
gboolean pickS; 
} pickInfo;
typedef struct {
int bounds[2];
} glaps;
typedef struct _SPECPT
{
int trans_x, trans_y;
double trans_mouse_freq;
double trans_mouse_amp;
} SPECPT;
typedef struct _TIMEENTRY
{ 
char *str;
int year, jday, hour, minute, second, msec;
double epochs;
} TIMEENTRY;
typedef struct _SOHMSG
{
int year, jday, hour, minute, second;
char *msg;
} SOHMSG;
typedef struct _SOHINFO
{
int seqnum; 
GSList *msgs; 
} SOHINFO;
typedef struct _INSTSOH
{
char *fileName; 
char *instID; 
GSList *SOH; 
} INSTSOH;
typedef struct _SPECSETTINGS
{
gboolean amp, 
overlay; 
gboolean yAxis, 
xAxis; 
float xMax,
xMin,
yMax;
float decades;
int topTrc;
} SPECSETTINGS;
typedef struct _PSDSETTINGS
{
gboolean hlnm; 
int yMin, yMax;
float xMin, xMax;
gboolean overlay;
} PSDSETTINGS;
typedef struct _settings
{
struct {
int numPlots;
gboolean amp; 
gboolean time; 
gboolean gFlag, oFlag; 
} trace;
struct {
int Tamp; 
gboolean Wamp, 
overlay; 
int zoomFactor,
scrollFactor;
gboolean gFlag, oFlag; 
int anchor; 
float length;
char *pickFile;
gboolean pickKEYOn, pickCOMOn; 
char pickKEY[41];
char pickComment[81];
char pickTag[MAXPICKS][11]; 
gboolean pick; 
gboolean dispBox[NUMBOXES]; 
} magnify;
struct {
SPECSETTINGS display; 
int newFilter[NUMDATASCREENS]; 
} spectra;
struct {
int DA[2][NUMSPLITSCRNS]; 
int DT[2][NUMSPLITSCRNS]; 
int pane; 
int traceDisp; 
} split;
struct {
int display; 
gboolean dispHdr[NUM_HDR_COLS]; 
} headers;
struct {
int dispType; 
int display; 
} logs;
struct {
struct {
int mode; 
struct {
float gain[3]; 
char *gainS[3]; 
float spread; 
} gather;
} display;
struct {
char *lastDir; 
int openReplace;
int winDims[2];
int panePos[3];
} startUP;
struct {
char *last[MAXFTYPES];
} dirs;
struct {
int format; 
int length; 
} label;
int unitsConv; 
struct {
int format; 
char *command;
char *fileN;
gboolean paperSize; 
gboolean paperRes; 
} print;
struct {
int defaultSort; 
int selected; 
char *str; 
GSList *sorts; 
GHashTable *instOrder; 
} sort;
struct {
int numFilters; 
filter **filts;
int AGCidx; 
struct {
int winLen;
int dwin;
gboolean detect;
float threshold;
} AGC;
} filter;
struct {
int uvwSensor; 
} tForm;
struct {
char *fileN; 
int num; 
} mark;
struct {
GtkWidget *DA;
GdkGC *GC;
int font; 
PangoContext *context[NUMDATASCREENS];
PangoFontDescription *desc[NUMFONTTYPES];
} font;
struct {
GSList *shotTimes; 
int shotLength; 
struct {
char *directory; 
char *filter; 
char *mseedInc; 
char *mseedExc; 
char *mseedLen; 
gboolean replace; 
} file;
} input;
gboolean myWordOrder; 
} general;
struct {
GdkColor fg[NUMDATASCREENS], 
bg[NUMDATASCREENS], 
sb[NUMDATASCREENS], 
gp[2][MAXGAPC], 
op[2][MAXOLAPC], 
ol[MAXOVERLAYCOLOURS];
} colors;
} plot_settings;
typedef struct _states
{
struct {
GSList *traces[TTLDISPGRPS]; 
struct {
struct {
coords user; 
bounds pix[NUMPLOTS]; 
} selection;
bounds margin[NUMPLOTS]; 
} limits;
amplitudes absAmp; 
times absTime; 
double relTimeLen; 
float trace_depth[NUMPLOTS]; 
int numSelected;
GSList *selection; 
int startRec;
graph GR[NUMPLOTS]; 
struct {
int label_width[NUMPLOTS];
int dispScale;
double length[2]; 
} plot;
struct {
int defGR; 
points window; 
} point;
gboolean selectionChanged; 
} trace;
struct {
gboolean dirty; 
struct {
int label_width[NUMPLOTS];
} plot;
amplitudes absAmp;
times absTime;
struct {
struct {
coords user;
bounds pix;
} selection;
bounds margin[NUMPLOTS];
} limits;
float trace_depth[NUMPLOTS]; 
graph GR[NUMPLOTS]; 
graph mainGR[NUMPLOTS]; 
struct {
int defGR; 
points window; 
} point;
struct {
int curPick; 
picks window; 
gboolean reset; 
} pick;
gboolean selectionChanged; 
GSList *selection; 
} magnify;
struct {
struct {
struct {
coords user;
bounds pix;
} selection;
bounds margin[NUMPLOTS];
} limits;
float trace_depth[NUMPLOTS]; 
graph GR[NUMPLOTS]; 
struct {
double glob[TTLSPECGLOBALS];
int label_width[NUMPLOTS];
} plot;
struct {
int defGR; 
pointID window; 
} point;
} spectra;
struct {
GSList *instSOH; 
} data;
struct {
int panes; 
gboolean realized[3]; 
gboolean resetPixmaps;
gboolean resetPixmap[2][NUMSPLITSCRNS]; 
gboolean refreshPixmap[2][NUMDATASCREENS]; 
} split;
struct {
gboolean reset[3]; 
gboolean refresh[3]; 
gboolean cursor; 
} reset;
struct {
int event; 
int mouseActive; 
gboolean mouseLeft; 
int keyActive; 
struct {
int startRec; 
int endRec;
gboolean xAxis; 
} drag;
struct {
int startX; 
int startY;
} mouseLoc;
struct{
int magnify; 
int spectra;
} topRec;
pointID *pointPtr; 
} user;
struct{
int filter; 
gboolean on; 
} tForm;
struct {
gboolean newCols;
} header;
struct {
GtkTextBuffer *buffer; 
gboolean visible; 
GSList *logs; 
} logs;
struct {
int numFiles; 
GSList *Files; 
GSList *RTfiles; 
} input;
int currentPage;
int currentScreen; 
int currentScr; 
int currentGraph; 
int currentDA;
char *msg; 
struct {
int numTraces; 
int sourceSystem; 
int numCPUs; 
struct {
int state; 
} plot;
} general;
} plot_states;
typedef struct _HEADINFO
{
int data_form, dataSize;
gboolean endianSwap;
double sampInt; 
int year, day, hour, minute, second, m_secs;
double epochs; 
double epochStop;
double length; 
int gainConst;
float scale_fac;
int units; 
char *descr1, *descr2, *longFN, *shortFN;
char network[10], station[10], location[10], channel[10], sensorID[10];
gint64 MSstartTime; 
void *fileHdr; 
} HEADINFO;
typedef struct {
char *tFormStr; 
char *data; 
struct {
int numSamples;
int data_form;
double sampInt;
double secsPsamp; 
} head;
amplitudes amps;
} DATAINFO;
typedef struct _TRACEINFO 
{
struct {
int original; 
int current; 
} position; 
char *fileName; 
int fileType; 
HEADINFO head; 
DATAINFO dataInfo; 
GSList *dataFilt; 
gboolean sticky; 
DATAINFO tForm; 
} TRACEINFO;
typedef struct _OVERLAP 
{
int bounds[2]; 
int len; 
char *data; 
} OVERLAP;
typedef struct _traceInfo
{
TRACEINFO data;
struct {
int numGaps, numOlaps, numPicks; 
int *gaps; 
int *overlaps; 
GSList *olapData; 
double RMS; 
pickInfo *picks; 
graph GR[NUMPLOTS];
gboolean selected; 
struct {
int increment;
double startTime, 
endTime1, 
endTime2, 
offset;
double minAmp, maxAmp;
} plot;
} trace;
struct {
gboolean selected;
int num_points_shown;
double begin, end, offset;
char *data_start;
graph GR[NUMPLOTS];
struct {
int increment;
double minAmp, maxAmp;
PangoLayout *layout[2];
} plot;
amplitudes amps;
double RMS;
struct {
picks trace; 
} pick;
struct {
points trace; 
} point;
} magnify;
struct {
float ampMax;
float ampMin;
double avg;
float beg, end, fill_beg, fill_end;
int numPts;
char *data;
float *data_end;
graph GR[NUMPLOTS];
} spectra;
struct {
double epochS; 
float length; 
char *description; 
struct {
char *inetAddr; 
int port; 
void *mainReturn; 
} CWB;
} excerpt;
struct { 
int blkSize;
GSList *packets; 
} mplex;
} traceInfo;
#define CHNARGSEP ","
typedef struct {
GSList *incChans; 
GSList *excChans; 
int length; 
} MPLX_MSEED;
typedef struct _TRC_N_DATA
{
traceInfo *trc;
DATAINFO *data;
} TRC_N_DATA;
typedef struct _XYZCOMPONENT
{
int sensor; 
GHashTable *comp; 
gboolean success;
} XYZCOMPONENT;
typedef struct _LOGTEXT
{
double startT;
char *text;
} LOGTEXT;
typedef struct _LOGDATA
{
char *fileName, *inst, *station;
double startT, endT; 
GSList *text; 
} LOGDATA;
#include "util_externs.h"
#endif
