#ifndef __PQLX_DEFS_H
#define __PQLX_DEFS_H
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pqlx_defs_head.h"
#define MINIMUM_PDB_VERSION 3
#define MINIMUM_DB_VERSION 34
#define PQLX_CLNT_DBVER_MIN 33
#define PQLX_CLNT_DBVER_MAX 34
#define XML_VERSION_MIN 4
#define XML_CHNMETA_VER 4
#define XML_EVENT_VER 1
#define ONEMIL (1000000.0)
#define ENVXML "PQLXXML"
#define ENVBIN "PQLXBIN"
#define ENVTRASH "PQLXTRASH"
#define ENVLOG "PQLXLOG"
#define ENVDBDEF "PQLXDBDEF"
enum { 
PDFMAIN,
PDFDETAIL,
PDFREQUEST,
PDFMOVIE,
TTLPDFTABS
};
enum {
SPECTROMAIN=TTLPDFTABS,
SPECTRODETREQ,
TTLPDFSCREENS
};
#define SPECTROTAB(a) (a-SPECTROMAIN)
#define TTLSPECTROTABS (TTLPDFSCREENS-TTLPDFTABS)
enum { 
STNMAIN,
STNANALYSIS,
TTLSTNSCREENS,
STNSPECTRA=TTLSTNSCREENS,
STNPSD
};
enum {
STNICON,
PDFPLOT,
SPECTROPLOT,
WWWPLOT
};
enum {
PMAPVISIBLE,
PMAPBASE,
TTLPMAPTYPES
};
enum {
NOTRACES,
READHDRS,
READDATA,
DATAPLOT,
DATADONE
};
enum { 
SEGY_DATA, 
AH_DATA, 
SAC_DATA, 
MSEED_DATA, 
DR100_DATA,
NANO_DATA,
RT130_DATA,
RT125_DATA,
RT125A_DATA,
MSEED_MPLEX_DATA,
CWB_DATA,
TOTALDATATYPE
};
enum {
PQL_UNITS_VOLTS,
PQL_UNITS_COUNTS,
PQL_UNITS_DISP,
PQL_UNITS_VEL,
PQL_UNITS_ACC,
PQL_UNITS_UNKNWN,
PQL_UNITS_TTL
};
#if 0
enum {
MYVOLTS,
MYCOUNTS,
TTLDISPUNITS
};
#endif
enum {
NTW,
STN,
LOC,
CHN,
NUMIDS
};
#define MSEEDNLOC " "
#define RESPNLOC "??"
#define PQLXNLOC "--"
#define UNKNOWN "XX"
enum {
TRC1DATA,
PSD1DATA,
TRCINFO,
ANAINFO,
NUMDATAS
};
enum { 
BBAND_CONT,
STMO_TRIG,
TTLPSDCONFIGTYPES
};
enum { 
CUSTOMPDF = -1,
SUBPDF = -2,
HOURSPDF = -3
};
enum { 
REQRANGE,
REQFREQ,
REQAGO,
REQRANGE2, 
NUMREQTYPES
};
#define NOPSDDATA -1
#define NOPSDBADSR -2
enum {
NOCHNPDF,
BUSY,
NODATA,
NOSRVR,
SRVRCONNECT,
NOMOVIEPDF,
BUSY_MOVIE,
RESIZE_MOVIE,
BAD_SR,
NOSPECTRO,
NOSPECTROPDF
};
enum {
PQLSYSTEM,
PDFSYSTEM,
STNSYSTEM,
NUM_SYSTEMS
};
enum {
TRACEMODE,
GATHERMODE,
TTLPQLDISPLAYMODES
};
enum {
ALLPOPUPS,
INFOPOPUP,
SOHPOPUP
};
enum {
MAINGR,
LOCALGR,
TTLGR
};
enum {
STNDATABUSYSENS,
STNNOFILTERSENS,
STNNOEVENTSENS,
STNNOEVENTSENS1,
TTLSTNSENSARRAYS
};
enum {
PDFDATABUSYSENS,
TTLPDFSENSARRAYS
};
enum {
SORTDIRECT,
SORTUSER
};
#define SORTSTARTTIME 8 
#define SORTINSTID 7
enum {
RELATIVE,
ABSOLUTE,
TTLTIMESCALES
};
enum { 
SPEC_MINAMP,
SPEC_MAXAMP,
SPEC_MINFREQ,
SPEC_MAXFREQ,
TTLSPECGLOBALS
};
enum {
LIN,
LOG,
};
enum {
START,
END
};
#define MAXPLOTS 500
#define MAXFREQ 10000
#define MINFREQ 1
#define MAXPOLES 12
enum {
BIT32,
BIT16,
MY_FLOAT, 
MY_DOUBLE,
MY_CHAR,
TTLDTYPES
};
#define MAIN_MARGIN 25
#define TRC_B_MARGIN 30
#define MAG_T_MARGIN 25
#define MAG_B_MARGIN 30
#define MAG_TFORM_MARGIN 10
enum {
REPLACEFROM,
REPLACETO,
TTLREPLACE
};
enum {
PRINT_FMT_PS,
PRINT_FMT_PNG,
TTLPRINTFMTS
};
enum { 
PRINT_FILE,
PRINT_W_USER,
PRINT_PRINTER
};
enum { 
LABEL_FILE,
LABEL_FILE_SHORT,
LABEL_HEADER,
LABEL_GATHERMODE,
TTLLABELS
};
#define PQLDFAULTSFILE "/.pqldfaults"
enum { 
SPLIT3,
SPLIT2,
MAIN,
PRINT,
NUMPLOTS
};
enum { 
TRACESCR,
MAGNIFYSCR,
SPECTRASCR,
SPLITSCR,
HEADERSCR,
LOGSCR,
NUMSCREENS
};
enum { 
MAGTFORM,
SPECTFORM,
SPLITTFORM,
TTLTFORMSCR
};
enum { 
TFORMORIG,
TFORMANA,
TFORMFILT
};
enum { 
PQLTFORMS,
PQLDEMEAN,
PQLDETREND,
PQLREVPOL,
PQLDIFFERENTIATE,
PQLINTEGRATE,
PQLUVW,
TTLPQLANALYSES,
PQLORIG,
PQLFILTER
};
#define FLTEDITSTR "Edit..."
#define FLTCUSTSTR "Custom..."
#define FLTAGCSTR "AGC"
enum { 
FILTTITLE,
FILTNORMAL,
FILTCUSTOM,
FILTEDIT,
TTLFILTTYPES
};
enum {
STS2,
TRILLIUM,
TTLSENSORS
};
enum {
FUNCUVW,
FUNCMAXMIN,
FUNCFREE
};
enum {
INITGROUP,
PREVGROUP,
NEXTGROUP
};
enum {
PREVGRP,
CURGRP,
NEXTGRP,
TTLDISPGRPS
};
#define NOFILTERSELECTION (NONE)
enum {
WSCALETRC,
WSCALEWIND,
TTLWSCALES
};
enum {
TRCWSCALE,
TRCXAXIS,
TRCDISPU,
TTLTRCCBOS
};
enum {
MAGTSCALE,
MAGWSCALE,
MAGDISPU,
MAGZANCHOR,
MAGPICKING,
TTLMAGCBOS
};
enum {
SPECWSCALE,
SPECDISPU,
TTLSPECCBOS
};
enum {
TRACEH,
MAGNIFYH,
SPECTRAH,
TTLHDTYPES
};
enum {
SPLITTOP,
SPLITBOT,
SPLITMID,
SPLITTDISP,
SPLITTSCALE,
SPLITWSCALE,
TTLHCBOS
};
enum {
MAGFILTERCBO,
SPECFILTERCBO,
SPLTFILTERCBO,
TOTFILTERCBOS
};
enum {
LABEL_ABOVE,
LABEL_BELOW
};
enum {
DEFAULTSET,
FILEDEFSET
};
#define NUMDATASCREENS 4 
#define SAMESCR 15
#define TRACEDA TRACESCR
#define MAGNIFYDA MAGNIFYSCR
#define SPECTRADA SPECTRASCR
#define SPLITDA3T 3
#define SPLITDA3M 4
#define SPLITDA3B 5
#define SPLITDA2T 6
#define SPLITDA2M 7
#define SPLITDA2B 8
#define TOTALDA (SPLITDA2B+1)
#define SPLITSCR2 14
#define SPLITSCR3 8
#define SPLITSCR1 9
enum { 
TRACECTRL,
MAGCTRL,
SPECCTRL,
SPLITCTRL,
HEADERCTRL,
GENCTRL,
OVERLAYCTRL,
NUMCTRLSCRNS
};
#define HELPCTRL (NUMCTRLSCRNS+1)
enum {
PQLSORT,
AHSORT,
SEGYSORT,
SACSORT,
TTLSORTTYPES
};
enum { 
AHINPUT,
AHSTN,
AHCHN,
AHABSTIME,
AHSLAT,
AHSLON,
AHELEV,
AHELAT,
AHELON,
AHDEP,
AHOT,
TTLAHSORTCRITERIA
};
enum { 
SACINPUT,
SACKINST,
SACKNETWK,
SACKSTNM,
SACKKHOLE,
SACKCMPNM,
SACNZYEAR,
SACNZJDAY,
SACNZHOUR,
SACNZMIN,
SACNZSEC,
SACNZMSEC,
SACSTLA,
SACSTLO,
SACSTEL,
SACCMPAZ,
SACCMPINC,
SACO,
SACKEVNM,
SACEVLA,
SACEVLO,
SACEVEL,
SACEVDP,
SACMAG,
SACNEVID,
SACNORID,
SACDIST,
SACAZ,
SACBAZ,
SACGCARC,
TTLSACSORTCRITERIA
};
enum { 
SEGYINPUT,
SEGYSTN,
SEGYCHN,
SEGYSENSOR,
SEGYINSTNO,
SEGYCHNNUM,
SEGYYEAR,
SEGYJDAY,
SEGYHOUR,
SEGYMINUTE,
SEGYSECOND,
SEGYMILLISEC,
SEGYLINESEQ,
SEGYREELSEQ,
SEGYEVTNUM,
SEGYS2RDIST,
SEGYRECELEV,
SEGYSRCSURFELEV,
SEGYSRCDEP,
SEGYDTELEVREC,
SEGYDTELEVSOURCE,
SEGYSRCWATERDEP,
SEGYRECWATERDEP,
SEGYSRCLATY,
SEGYSRCLONX,
SEGYRECLATY,
SEGYRECLONX,
SEGYSRCUPHOLET,
SEGYRECUPHOLET,
SEGYTYEAR,
SEGYTJDAY,
SEGYTHOUR,
SEGYTMINUTE,
SEGYTSECOND,
SEGYTMILLS,
TTLSEGYSORTCRITERIA
};
enum { 
INPUT,
LONGFN,
SHORTFN,
NETWORK,
STATION,
LOCATION,
CHANNEL,
SENSOR,
ABSSTART,
FILETYPE,
TTLPQLSORTCRITERIA 
};
#define MAXTTLSORTCRITERIA TTLSEGYSORTCRITERIA
#define BUTTONW 85 
#define BUTTONH 24 
enum {
TOP,
MID,
BOT,
NUMSPLITSCRNS
};
#define NUMPOLES 7
#define NUMZOOMS 4
enum {
ZOOMABS,
ZOOMX,
ZOOMOUT,
ZOOMIN
};
enum {
BACKWARDS,
FORWARDS,
INITIALIZE,
PDFGREINIT
};
enum {
HEIGHT,
WIDTH,
TTLDIMS
};
enum {
FILTERTYPE,
DISPLAYTYPE,
MAGSCRTYPE,
NRADIOS
};
enum {
FILTERLIST,
FILTERCUSTOM,
TTLFILTEREXTRA
};
enum {
LOWPOLE,
HIGHPOLE,
TTLPOLETYPES
};
enum {
JAN,
FEB,
MAR,
APR,
MAY,
JUN,
JUL,
AUG,
SEP,
OCT,
NOV,
DEC,
TOTALMTHS
};
enum {
SELECT,
DESELECT,
REMOVE
};
enum {
JUMPL,
MOVEL,
MOVER,
JUMPR
};
#define JUMPFACTOR .75
#define MOVEFACTOR .1
#define LABELFONT "Sans 9"
#define AXISFONT "Sans 9"
#define MSGFONT "Sans 18"
#define PDFSTATSFONT "Sans 8"
#define PQLLABELXTRA 20
#define PQLINCXTRA 8
enum {
NORMALGC,
INVGC,
ABNORMALGC,
TTLGCTYPES
};
#define OVERLAY (ABNORMALGC+1)
#define MAXOVERLAY MAXPLOTS
#define MAXOVERLAYCOLOURS 30
#define TRACENONE 8
#define MAGNONE 48
#define SPECNONE 64
#define TMAXPIXMAPS (TRACENONE+1)
#define MMAXPIXMAPS (MAGNONE+1)
#define SMAXPIXMAPS (SPECNONE+1)
#define HMAXPIXMAPS 6
#define MAXMAXPIXMAPS (SMAXPIXMAPS)
#define MAXMARKS 9
enum { 
MYSTRING,
MYINT,
MYDOUBLE,
SORTFILE,
MYFLOAT,
MYSHORT,
MYCOLOR,
MYSORT,
MYAMPS,
MYEPOCHS,
MYSPS,
MYFILETYPE,
MYDIRECTORY,
MYBOOL,
MYSTRINGPTR,
MYINSTSORT,
MYPTIME,
MYFLOATSHORT
};
#define ASC TRUE
#define DESC FALSE
enum { 
SORTSGNL,
FILTSGNL,
PICKSGNL,
DISPSGNL,
BTNPRSSGNL,
BTNRLSSGNL,
MTNNTFYSGNL,
NTBKSGNL,
FILTCBOSGNL,
TRACESCALESGNL,
WNDWSCALESGNL,
OVERLAYSGNL,
MAXSIGNALTYPES
};
enum { 
TRACESIGNAL,
MAGSIGNAL,
SPECSIGNAL,
SPLITSIGNAL,
MAXSCRNSGNLS
};
#define MAXGAPC 1
#define MAXOLAPC 2
enum {
GC1, 
GC2,
GC3
};
enum {
OL1 
};
enum { 
ZOOM,
REPLOT,
XAXIS,
FREQCUTOFF,
SELECTTR,
MAGBOUNDARY,
VLINE,
SCROLL
};
enum {
ALL,
DISPLAYED,
SELECTED,
TTLDISPLAYTYPES
};
enum {
ZANCHOR,
YSCALE,
HSCALE,
ALIGNMENT,
MAXRADIOGROUPS
};
enum {
DISPS,
WINDS,
FIXEDS,
CHNGROUPS,
MAXYSCALES
};
enum { 
LEFT,
RIGHT,
MIDDLE,
MOUSE,
TOTMANCHORS
};
enum {
FNTLFTT,
FNTRGTB
};
enum {
ZOOMBOX,
PICKBOX,
NUMBOXES
};
enum { 
CTRL,
SHIFT,
ALT,
DKEY,
ZKEY,
XKEY
};
enum {
PICK0,
PICK1,
PICK2,
PICK3,
PICK4,
PICK5,
PICK6,
PICK7,
PICK8,
PICK9,
MAXPICKS 
};
enum {
PICKFTYPE,
PRINTFTYPE,
MARKFTYPE,
MAXFTYPES
};
enum {
SNAP,
MAG,
KEY
};
enum {
HIGHF,
LOWF,
};
enum 
{
HDR_LFN, 
HDR_SFN, 
HDR_SID, 
HDR_NTW, 
HDR_STN, 
HDR_LOC, 
HDR_CHN, 
HDR_TIME, 
HDR_LEN, 
HDR_SPS, 
HDR_NDP, 
HDR_FMT, 
HDR_GAIN, 
HDR_SCALE, 
HDR_AMPS, 
HDR_GAPS, 
HDR_OLAPS, 
NUM_HDR_COLS 
};
enum { 
LOGFILESW,
LOGTRCSW,
LOGVIEWSW,
TTLLOGSW
};
enum {
LOGDISPBY,
LOGONDISP
};
enum { 
LOGFILE,
LOGTRC,
TTLLOGTYPES
};
enum {
LOGF_HDR_INST,
LOGF_HDR_START,
LOGF_HDR_END,
LOGF_HDR_FILEN,
NUM_LOGF_HDR_COLS
};
enum {
LOGT_HDR_INST,
LOGT_HDR_START,
LOGT_HDR_END,
LOGT_HDR_STATION,
NUM_LOGT_HDR_COLS
};
enum { 
LETTER,
A4,
PAPERSIZES
};
enum {
PRINTHEADER,
PRINTFOOTER
};
enum {
HIGHRES,
LOWRES,
MAXRES
};
enum { 
USER,
TEMP,
BASE
};
enum { 
TRCSPECTRA,
TRCPM,
TTLTRCCOPYOPTIONS
};
#define PMARGIN 10
#define LTRW 612 
#define LTRH 792
#define A4W 594 
#define A4H 840
#define OLAPBEG (pInfo->GO.olapNum*2)
#define OLAPEND (pInfo->GO.olapNum*2+1)
#define GAPBEG (pInfo->GO.gapNum*2)
#define GAPEND (pInfo->GO.gapNum*2+1)
enum {
PDFMSG, 
PDFTEXT, 
PDFHLNM, 
PDFTRCBG, 
PDFDASHLINE, 
PDFPINKLINE, 
TOTALPDFCONTEXTS
};
enum {
PDFFMSG,
PDFFTEXT,
PDFFTRC,
WWWFTEXT,
PDFSTATSTEXT,
NUMFONTGCP
};
enum{
STNFLBL=NUMFONTGCP, 
STNFLBLA, 
STNFLBLS, 
STNFLBLP, 
STNFLBLPM, 
STNFLBLPMC, 
STNFLBLPMEBA, 
NUMFONTGCS
};
enum {
LABELF,
AXISF,
MSGF,
STNLBLF,
WWWLABELF1,
WWWLABELF2,
WWWLABELF3,
WWWLABELF4,
WWWLABELF5,
WWWLABELF6,
PDFSTATSF,
NUMFONTTYPES
};
enum { 
LABEL,
INC 
};
enum {
POINT1,
POINT2,
TTLPOINTS
};
enum {
GLAPBEG,
GLAPEND
};
enum {
ROW,
COL
};
enum {
DTLBACK,
DTLFORW
};
enum {
PQLTRC,
PQLMAG,
PQLSPLT2,
PQLSPLT3,
TTLPQLDESTS
};
enum {
E,
N,
Z,
TTLCOMPONENTS
};
enum {
ENZ,
ONE23,
ONE2Z,
TTLCOMPGROUPS
};
enum {
GDATA_SYSPDFS,
GDATA_BLINES
};
enum { 
DBRELATIVE,
DBFIXED,
TTLDBSETTINGS
};
enum {
SMALLLINE,
LARGELINE,
TTLLINESIZES
};
#define LEG_LINE_START 10
#define LEG_LINE_LEN 23
#define WWWPDFW 550
#define WWWPDFH 425
#define WWWPDFICOW 170
#define WWWPDFICOH 145
#define MAXNUMBERS 20
#define MMAXPDFROWS 3
#define MMAXPDFCOLS 3
#define DMAXPDFCOLS 2
#define DMAXPDFROWS 2
#define RMAXPDFCOLS 3
#define RMAXPDFROWS 3
#define MVMAXROWS 2
#define MVMAXCOLS 2
#define SPDFCOLS 1 
#define SSPECCOLS 1
#define SMAXCOLS (SPDFCOLS+SSPECCOLS)
#define SMAXROWS 3
#define MISSING_CONFIG_VALUE -1
#define LIC_UNLIMITED 0
#define ONEMNOFSECS (60)
#define ONEHROFSECS (ONEMNOFSECS*60)
#define ONEDAYOFSECS (ONEHROFSECS*24)
#define BLANK "nil"
#define STNCOMPFN "STN Composite"
#define PQLXENDEDMSG "Process ENDED"
#define PQLXPAUSEMSG "Execution PAUSED"
#define PQLXRESUMEMSG "Execution RESUMED"
enum { 
LOG_OUTPUT, 
LOG_FLUSH, 
LOG_SHUTDOWN, 
TTLLOGCMDS
};
enum { 
LOG_WRITEFUNC, 
LOG_ERRORFUNC, 
TTLLOGFUNCS
};
enum { 
LOGMSG_PROG_STARTUP,
LOGMSG_PROG_QUIT,
LOGMSG_CONN_ATTEMPT,
LOGMSG_CONN_SUCCESS,
TTLSRVRLOGMSGS
};
#define FILTERCUSTOMLISTNUM (settings.general.filter.numFilters-1)
#define strReplace(a, b, c, d) {char **strs = g_strsplit(a, c, -1); b = g_strjoinv(d, strs); g_strfreev(strs);}
#define g_date_copy(dt) g_date_new_dmy(g_date_get_day(dt), g_date_get_month(dt), g_date_get_year(dt))
#define IFFREE(str) {if (str) free(str), str = NULL;}
#define IFFREEGDATE(dt) {if (dt) g_date_free(dt);}
#define IFFREEHT(ht) {if (ht) g_hash_table_destroy(ht);}
#define SETHG(h) {gdk_window_set_cursor(topLevel, h);while (g_main_context_iteration(NULL, FALSE));}
#define FREESTRINGS(sa) {int i=0;while(sa && (sa[i]!=NULL)) {IFFREE(sa[i]); i++;} IFFREE(sa); sa=NULL;}
#define PSDREFPLOTS(a) (((SPECTRODATA*)a->plot.start->data)->psdRef)
#define PSDREFPLOTE(a) (((SPECTRODATA*)a->plot.end->data)->psdRef)
#define PSDREFABSS(a) (((SPECTRODATA*)a->data.spectro->data)->psdRef)
#define PSDREFABSE(a) (((SPECTRODATA*)((g_list_last)(a->data.spectro))->data)->psdRef)
#define DATAP(b, c, d) {switch (b) { case BIT32: d=ptr[c];break; case BIT16: d=sptr[c];break; case MY_FLOAT: d=lptr[c];break; case MY_DOUBLE: d=dptr[c];break; } }
#define DATAPSET(b, c, d) {switch (b) { case BIT32: ptr[c]=d;break; case BIT16: sptr[c]=d;break; case MY_FLOAT: lptr[c]=d;break; case MY_DOUBLE: dptr[c]=d;break; } }
#ifndef PQL_ONLY
#endif
#include <math.h>
#define LOG10(x) ((double) (log(x)*.434294))
#define POW10(x) ((double) (exp(x*2.302585)))
#define USER2PIXX(gr, x) ((rint)(((((gr)->logx?LOG10((double)x):(double)x)-(gr)->user_xmin)/(gr)->user_xdif)*((double) (gr)->pix_xdif)+((double) (gr)->pix_xmin)))
#define PIX2USERX(gr, x) ((gr)->logx?POW10((((double)(x-(gr)->pix_xmin))/((double)(gr)->pix_xdif)*(double)((gr)->user_xdif)+(gr)->user_xmin)):(((double)(x-(gr)->pix_xmin))/((double)(gr)->pix_xdif)*(double)((gr)->user_xdif)+(gr)->user_xmin))
#define USER2PIXY(gr, y) ((int)(((double)(gr)->pix_ydif)-((double)(((gr)->logy?LOG10(y):y)-(gr)->user_ymin)/(gr)->user_ydif)*((double)(gr)->pix_ydif)+((double)(gr)->pix_ymin)))
#define PIX2USERY(gr, y) ((gr)->logy?POW10(((1.-(((double)y-(gr)->pix_ymin)/((double)(gr)->pix_ydif)))*(gr)->user_ydif+(gr)->user_ymin)):((1.-(((double)y-(gr)->pix_ymin)/((double)(gr)->pix_ydif)))*(gr)->user_ydif+(gr)->user_ymin))
#define CHOMP(str) for(i=0;i<sizeof(str);i++) if (str[i]==' ') {str[i]=0;break;}
#define TOUPPER(a) { int i; for( i = 0; a[i]; i++) a[i] = toupper(a[i]);}
#endif
