#ifndef __PQLX_PDF_INCLUDE
#define __PQLX_PDF_INCLUDE
#include "pqlx_pdf_head.h"
enum {
PDFNB,
SPECTRONB,
TTLPSDNB
};
enum { 
PDFSTND, 
PDFPDFD, 
PDFBOTHD, 
PDFGROUP, 
NUMPDFMAINDISPLAYMODES
};
enum { 
MBUT1,
MBUT2,
MBUT3
};
enum { 
CBONSL, 
CBONSLC, 
CBOCHNG, 
CBOPDF 
};
enum { 
NW,
SW,
NE,
SE,
ALLCELLS
};
enum {
UL,
UM,
UR,
ML,
MM,
MR,
LL,
LM,
LR,
TTLREQDISPCELLS
};
enum {
ULM,
URM,
LLM,
LRM,
TTLMOVIEDISPCELLS
};
enum {
XAXISBNDS
};
enum {
PDFREQPDF,
PDFREQSPECTRO,
TTLPDFREQTYPES
};
enum { 
PDFREQSTART, 
PDFREQEND, 
PDFREQBOUNDS
};
enum {
PDFREQYR,
PDFREQMO,
PDFREQDY,
PDFREQDAYS
};
enum {
PDFREQHR,
PDFREQMN,
PDFREQHOURS
};
enum {
PDFREQNUMEXTRACT, 
PDFREQFREQUENCY 
};
enum {
YEARH,
JDAYH
};
enum {
HORIZ,
VERT
};
enum {
TRACECNT,
VALIDTRC,
TOTALTRCCNTS
};
enum {
STATE_NOSRVR,
STATE_NOPDF,
STATE_BUSY1,
STATE_BUSY2,
STATE_BUSY3,
STATE_FINISH,
STATE_NOPSD,
STATE_SRVRCNCT,
STATE_NOMOVIEPDF,
STATE_MVRESIZE,
STATE_BADSR,
STATE_NOSPECTRO,
TTLSTATES
};
enum {
PDFALLSELECT,
PDFALLTOGGLE,
TTLPDFPRINTCMDS
};
enum {
PDFCHNFLTSGNL,
PDFSRVRDFAULTSGNL,
PDFDBDFAULTSGNL,
SPECTROCHNFLTSGNL,
MAXPDFSIGNALTYPES
};
enum { 
X,
Y
};
enum {
PMW, 
PMH, 
PMM, 
TTLPMD
};
enum {
INCLUSIVE,
EXCLUSIVE
};
enum {
DBTRCLIST,
PQLTRCLIST
};
enum {
PDFDTRCNOPLOT,
PDFDTRCENTIRE,
PDFDTRCPSD,
MAXTRCEXTRACTS
};
enum {
TRCEXTRACT
};
enum {
FDUNIT_PER,
FDUNIT_FREQ,
TTLFDUNITS
};
enum {
MVDISP1, 
MVDISP2, 
TTLMOVIEDISPLAYS
};
enum { 
PDFM1,
PDFM2,
PDFM3,
PDFM4,
PDFM5,
TTLMOVIESCREENS
};
enum { 
PDFM_BACKWARD,
PDFM_PAUSEB,
PDFM_FORWARD,
PDFM_PAUSEF,
TTLPDFMCMDBUTTONS,
PDFM_BEGIN = TTLPDFMCMDBUTTONS,
PDFM_END,
TTLPDFMCMDS,
PDFM_NONE
};
enum {
PDFM_PAUSE,
PDFM_START,
PDFM_CANCEL
};
enum {
PDFM_FRAMENUM,
PDFM_TTLFRAMES,
TTLPDFFRAMECOUNTERS
};
enum { 
RDPDFHR,
RSPDF
};
enum {
COLPDF,
COLSPEC,
TTLSPECCOLS
};
enum {
ZOOMSINGLE,
ZOOMALL,
TTLZOOMSCOPES
};
enum {
PDFCBOZOOMSCOPE
};
enum {
PDF_P_DB,
PDF_P_DISP
};
enum {
BLINE_MK_CTRL,
BLINE_MK_LIST,
BLINE_MK_LISTDEL
};
#define SPECTROPDF(rowNum) {makeThread(ASYNC, (GThreadFunc) spectroPDF, GINT_TO_POINTER(rowNum), NULL);}
#define REFNUM(scr, row, col) (scr*MAXNUMBERS + row*scrSizes[scr][COL] + col)
#define ROWNUM(a) (a / scrSizes[screen][COL])
#define COLNUM(a) (a % scrSizes[screen][COL])
#define PDFLABELFONT "Sans 11"
#define WWWLABELFONT1 "Sans 14"
#define WWWLABELFONT2 "Sans 13"
#define WWWLABELFONT3 "Sans 12"
#define WWWLABELFONT4 "Sans 11"
#define WWWLABELFONT5 "Sans 9"
#define WWWLABELFONT6 "Sans 7"
#define PDFMAXFRAMERATE 30
#define PDFMINFRAMERATE -30
#define XAXISBNDSTRSEP "|"
#define XAXISBNDITEMSEP "`"
#define XAXISBNDITEMSEPC '`'
#define BLINEPCTDEF 15
typedef struct _BLINECTRL
{
gulong id; 
GtkWidget *widg; 
BLINEDEF *blineDef; 
gboolean plot; 
} BLINECTRL;
typedef struct _XAXISBOUNDSDEF
{
char *chnGrp; 
char *bounds[TTLPERBOUNDS]; 
PDFXAXIS xAxis; 
} XAXISBOUNDSDEF;
typedef struct _FILMRESIZE
{
int screen;
int frameNo;
} FILMRESIZE;
typedef struct _PDFFILMFRAME
{
long movieID; 
int frameNo; 
PDFREQ *pdfReq; 
GdkPixmap *pmap; 
} PDFFILMFRAME;
typedef struct _PDFFILM
{
long movieID; 
int screen; 
GDate julian[2]; 
int interval; 
gboolean cumulative; 
int frameNo; 
int lastFrame; 
int cmd; 
GHashTable *frames; 
} PDFFILM;
typedef struct _TRACEARGS
{
GdkPixmap *pixmap; 
int dims[TTLPMD]; 
gboolean callType; 
gboolean (*returnFunc)(gpointer); 
} TRACEARGS;
typedef struct _IDXTMPARGS
{
int reqType;
int table;
} IDXTMPARGS;
typedef struct _PDFSETTINGS
{
struct {
int display; 
CHN_FILTER chnFilter;
struct {
char *string; 
GSList *defs; 
gboolean active; 
} xAxis;
struct {
int blineKey; 
int pct; 
} bline;
} main;
struct {
int trcExtract; 
gboolean pdfHrMode; 
struct {
char *inetAddr; 
int port; 
} CWB;
} detail;
struct {
gboolean display; 
int frameRate[TTLMOVIESCREENS]; 
gboolean repeat[TTLMOVIESCREENS]; 
gboolean cumulative; 
} movie;
struct {
struct {
gboolean active; 
} xAxis;
gboolean PDF; 
} spmain;
struct {
struct {
gboolean active; 
} xAxis;
gboolean PDF; 
struct {
int scrollPct; 
int scope; 
} zoom;
} spreq;
struct { 
gboolean statistics[TTLPDFSCREENS][TTLPDFSTATS]; 
int dateFormat; 
int fdUnits; 
} common;
struct {
GdkGC *ctxts[TOTALPDFCONTEXTS][TTLGCTYPES];
GdkColor sbC[TTLPDFSCREENS]; 
GdkColor ctrlBar; 
} drawing;
struct {
gboolean startup; 
char *server;
char *database;
struct {
int format; 
} print;
} general;
} PDFSETTINGS;
typedef struct _PDFSTATES
{
struct {
int plotW[MMAXPDFROWS][MMAXPDFCOLS][TTLDIMS];
graph gr[NUMPDFMAINDISPLAYMODES][MMAXPDFROWS][MMAXPDFCOLS];
GdkPixmap *pmap[NUMPDFMAINDISPLAYMODES][MMAXPDFROWS][MMAXPDFCOLS];
PDFREQ pdfReq[NUMPDFMAINDISPLAYMODES][MMAXPDFROWS][MMAXPDFCOLS];
float perB[NUMPDFMAINDISPLAYMODES][MMAXPDFROWS][MMAXPDFCOLS][TTLPERBOUNDS];
struct {
GSList *list; 
GSList *chnList; 
CHN_FLT_STATE chnFilter; 
int pdfKey; 
int pdfType; 
} group; 
} main;
struct {
gboolean subPDF[DMAXPDFROWS][DMAXPDFCOLS]; 
int plotW[DMAXPDFROWS][DMAXPDFCOLS][TTLDIMS]; 
graph gr[DMAXPDFROWS][DMAXPDFCOLS]; 
float perB[DMAXPDFROWS][DMAXPDFCOLS][TTLPERBOUNDS]; 
GdkPoint bbox[ALLCELLS][TTLPOINTS]; 
gboolean mouseDown;
PDFREQ *pdfReq[ALLCELLS]; 
PDFREQ subReq; 
PSDTRCD psdTrc; 
int traceCnt[TOTALTRCCNTS]; 
PSDHRD psdHr; 
GList *disp, *dispList; 
GSList *trcList; 
int idleCnt; 
} detail;
struct {
struct {
int chnKey;
int row, col;
int reqType; 
} req;
int plotW[RMAXPDFROWS][RMAXPDFCOLS][TTLDIMS];
graph gr[RMAXPDFROWS][RMAXPDFCOLS];
float perB[RMAXPDFROWS][RMAXPDFCOLS][TTLPERBOUNDS];
PDFREQ pdfReq[RMAXPDFROWS][RMAXPDFCOLS];
} request;
struct {
int screen; 
int plotW[TTLMOVIESCREENS][TTLDIMS]; 
GHashTable *films[TTLMOVIESCREENS]; 
int dbReq[TTLMOVIESCREENS]; 
int resize[TTLMOVIESCREENS]; 
int state[TTLMOVIESCREENS]; 
int count[TTLMOVIESCREENS][TTLPDFFRAMECOUNTERS]; 
} movie;
struct {
int row, col;
SPECREQ specReq[SMAXROWS][SSPECCOLS]; 
graph specGR[SMAXROWS][SSPECCOLS]; 
PDFREQ pdfReq[SMAXROWS][SPDFCOLS]; 
graph pdfGR[SMAXROWS][SPDFCOLS]; 
float perB[SMAXROWS][SMAXCOLS][TTLPERBOUNDS];
struct {
GSList *list; 
GSList *chnList; 
CHN_FLT_STATE chnFilter; 
int pdfKey; 
int pdfType; 
} group; 
} spmain;
struct {
int row, col;
SPECREQ specReq[SMAXROWS][SSPECCOLS]; 
graph specGR[SMAXROWS][SSPECCOLS]; 
PDFREQ pdfReq[SMAXROWS][SPDFCOLS]; 
graph pdfGR[SMAXROWS][SPDFCOLS]; 
float perB[SMAXROWS][SMAXCOLS][TTLPERBOUNDS];
int cntr; 
} spdetreq;
struct { 
GdkPixmap *main[NUMPDFMAINDISPLAYMODES][MMAXPDFROWS][MMAXPDFCOLS];
GdkPixmap *detail[DMAXPDFROWS][DMAXPDFCOLS];
GdkPixmap *request[RMAXPDFROWS][RMAXPDFCOLS];
GdkPixmap *movie[TTLMOVIESCREENS];
GdkPixmap *spmain[SMAXROWS][SMAXCOLS];
GdkPixmap *spreq[SMAXROWS][SMAXCOLS];
int state[TTLPDFSCREENS][MMAXPDFROWS][MMAXPDFCOLS]; 
int mState[TTLMOVIESCREENS];
} pmap;
int system; 
int screen; 
} PDFSTATES;
#endif
