#include <stdlib.h>
#include <stdio.h> 
#include <dirent.h> 
#ifndef MAC
#include <sys/types.h>
#endif
#include <sys/stat.h> 
#include <string.h> 
#include <unistd.h> 
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "importPDF.h"
FILE *fp_prob;
SCAN  *scanPtr;
gboolean channelReset;
CHNLIST *chnList;
char timeStr[50]; 
static struct PSD_INFO
{
char ntw[12], stn[12], loc[12], chn[12];
int  year, jday, hour, min;
int  chni;
} psd_info;
void problemFile(int type, char *probFile, int lineNo)
{
char filename[256] = "problem_PSD_files.txt";
if (!fp_prob)
{
if ((fp_prob=fopen(filename, "w"))==NULL)
{
TIMESTR(timeStr);
fprintf(stderr, "%sUnable to open file %s to record problem PSD files, using stderr instead.", 
timeStr, filename);
fp_prob = stderr;
}
}
fprintf(fp_prob, "%s, line %d\n", probFile, lineNo);
}
int getTrcKey()
{
SQLDI sqldi;
TRCKEY trcKey;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&trcKey, 0, sizeof(TRCKEY));
trcKey.keys.chni = psd_info.chni;
trcKey.keys.trcTime.yr = psd_info.year;
trcKey.keys.trcTime.day = psd_info.jday;
trcKey.keys.trcTime.hr = psd_info.hour;
trcKey.keys.trcTime.mn = psd_info.min;
passcal_month_day(&trcKey.keys.trcTime, trcKey.keys.trcTime.day);
sqldi.descr.tableData = TRCTBL;
sqldi.data = &trcKey;
sqldi.args.dataEvent = GET_DATA;
db_request(&sqldi);
if (!trcKey.keys.trcKey)
{ 
TIMESTR(timeStr);
fprintf(stderr, "%simportPDFdata: INTERNAL ERROR: No TRC table key returned, unable to process, quitting (this should never happen! please report...).\n", timeStr);
exit(-1);
}
return(trcKey.keys.trcKey);
}
void initChn(FILE *fp, PSD1 *psd)
{
int  numPeriods;
char hour[10], svHour[10], inputLn[MAXINPUT];
if(psd->data.period)
{
free(psd->data.period);
free(psd->data.power);
}
rewind(fp);
fgets(inputLn, MAXINPUT, fp);
sscanf(inputLn, "%s", hour);
strcpy(svHour, hour);
fgets(inputLn, MAXINPUT, fp);
sscanf(inputLn, "%s", hour);
numPeriods = 1;
while(!strcmp(hour, svHour))
{
numPeriods++;
fgets(inputLn, MAXINPUT, fp);
sscanf(inputLn, "%s", hour);
}
psd->data.period = calloc(numPeriods, sizeof(double));
psd->data.power = calloc(numPeriods, sizeof(int));
psd->data.nPeriods = numPeriods;
rewind(fp);
}
int importHOURdata(int *totPSD)
{
int  curJday=0, period, hours=0, ret=PQLXSUCCESS, idxLnNum=0, totPSDs=0;
gboolean dbWrite;
char  idxFile[20], psdFile[20], idxHourIdx[10], psdHourIdx[10];
char idxLn[80], pdfLn[80];
FILE *fp_idx, *fp_psd=NULL;
SQLDI sqldi;
static PSD1 psd;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = PSDTBL;
sqldi.args.dataEvent = INSERT_DATA;
sqldi.data = (void *) &psd;
strcpy(idxFile, "HOUR/hour.idx");
if ((fp_idx = fopen(idxFile, "r")) == NULL)
{
return (IDX_OPEN_FAIL);
}
while(fgets(idxLn, MAXINPUT, fp_idx))
{
sscanf(idxLn, "%d %d:%d %s", &psd_info.jday, &psd_info.hour, 
&psd_info.min, idxHourIdx);
if(idxLn[strlen(idxLn)-2] != 'h' &&
idxLn[strlen(idxLn)-3] != 'h')
{
problemFile(IDXFILE, idxFile, idxLnNum);
break;
}
if (!curJday)
{ 
curJday = psd_info.jday;
sprintf(psdFile, "HOUR/H%03d.bin", curJday);
if ((fp_psd = fopen(psdFile, "r")) == NULL)
{
ret = PSD_OPEN_FAIL;
break;
}
}
else if (psd_info.jday != curJday)
{ 
fclose(fp_psd);
curJday = psd_info.jday;
sprintf(psdFile, "HOUR/H%03d.bin", curJday);
if ((fp_psd = fopen(psdFile, "r")) == NULL)
{
ret = PSD_OPEN_FAIL;
break;
}
totPSDs += hours;
hours=0;
}
if (channelReset)
{
initChn(fp_psd, &psd);
channelReset = FALSE;
}
memset(psd.data.period, 0, psd.data.nPeriods * sizeof(float));
memset(psd.data.power, 0, psd.data.nPeriods * sizeof(int));
for (dbWrite = TRUE, period=0;period<psd.data.nPeriods;period++)
{
fgets(pdfLn, MAXINPUT, fp_psd);
sscanf(pdfLn, "%s %f %d", psdHourIdx, 
&psd.data.period[period], 
&psd.data.power[period]);
}
psd.keys.chnKey = psd_info.chni;
psd.keys.trcKey = getTrcKey();
psd.data.sTime.date.yr = psd_info.year;
psd.data.sTime.date.jday = psd_info.jday;
psd.data.sTime.date.hr = psd_info.hour;
psd.data.sTime.date.mn = psd_info.min;
psd.data.eTime.date.hr = psd_info.hour+1;
psd.data.eTime.date.mn = psd_info.min;
if (dbWrite)
{
db_request(&sqldi);
hours++;
}
}
fflush(stdout);
if (fp_psd)
fclose(fp_psd);
fclose(fp_idx);
*totPSD += totPSDs + hours;
return (ret);
}
typedef struct _dirInfo
{
int dirType;
char dirName[15];
} DIR_INFO;
static int totalPSD=0;
int processDir(int dirType, char *dirName)
{
int  ret=PQLXSUCCESS, totPSD=0;
char *ptr;
DIR  *chnDir, *yrDir;
struct dirent *chnEntry, *yrEntry;
switch(dirType)
{
case STN_DIR:
TIMESTR(timeStr);
fprintf(stdout, "%sProcessing STATION %s channels:\n", timeStr, dirName);
fflush(stdout);
ptr = dirName;
SUB(ptr, psd_info.ntw);
SUB(ptr, psd_info.stn)
SUB(ptr, psd_info.loc)
chnDir = opendir(dirName);
chdir(dirName);
while((chnEntry = readdir(chnDir)))
{
if (!strcmp(chnEntry->d_name, ".") || !strcmp(chnEntry->d_name, ".."))
continue;
if (strlen(chnEntry->d_name) != 3)
continue;
strcpy(psd_info.chn, chnEntry->d_name);
psd_info.chni = chnID(scanPtr, psd_info.ntw, psd_info.stn,
psd_info.loc, psd_info.chn);
if (chnList->channels)
{
chnList->channels = (int *) realloc(chnList->channels, (chnList->numChn+1)*sizeof(int));
}
else
{
chnList->channels = (int *) malloc((chnList->numChn+1)*sizeof(int));
}
chnList->channels[chnList->numChn] = psd_info.chni;
chnList->numChn++;
channelReset = TRUE;
processDir(CHN_DIR, chnEntry->d_name);
}
(void) closedir(chnDir);
chdir("..");
break;
case CHN_DIR:
fprintf(stdout, "\t%s:\n", dirName);
fflush(stdout);
yrDir = opendir(dirName);
chdir(dirName);
while((yrEntry = readdir(yrDir)))
{
if (!strcmp(yrEntry->d_name, ".") || !strcmp(yrEntry->d_name, ".."))
continue;
if(yrEntry->d_name[0] != 'Y')
continue;
sscanf(yrEntry->d_name, "Y%d", &psd_info.year);
fprintf(stdout, "\t\tYEAR %d:", psd_info.year);
fflush(stdout);
chdir(yrEntry->d_name);
ret = importHOURdata(&totPSD);
fprintf(stdout, "\t%d PSDs imported\n", totPSD);
totalPSD += totPSD;
totPSD=0;
if(ret != PQLXSUCCESS)
{
fprintf(stderr, "Problem processing directory %s (error: %d)\n",
dirName, ret);
}
chdir("..");
}
(void) closedir(yrDir);
chdir("..");
break;
}
return ret;
}
void importPDFdata(SCAN *scan, GSList *PDFDirs, CHNLIST *chnL)
{
GSList *stnDirElem=PDFDirs;
scanPtr = scan;
chnList = chnL;
do {
processDir(STN_DIR, stnDirElem->data);
} while((stnDirElem = g_slist_next(stnDirElem)));
TIMESTR(timeStr);
fprintf(stdout, "\n%sTotal PSDs imported: %d\n", timeStr, totalPSD);
if (fp_prob && fp_prob != stderr)
{
fclose(fp_prob);
}
}
