#include <unistd.h>
#include <dirent.h>
#include "pql_defines.h"
#include "pqlx_defs.h"
#include "util_externs.h"
#include "db_iface.h"
#include "ezxml.h"
#include "importTT.h"
#define TT_MODEL_FILE "tt"
#define TT_MODEL_HEAD "head"
#define TT_PHASES_FILE "phases"
#define TTINPUTLINELEN 255
#define TTCOLCNT  4
static gint findPhase(TTNAME *phaseD, char *phaseN)
{
return(strcmp(phaseD->name, phaseN));
}
static void printPhases(TTNAME *phname, FILE **fp)
{
fprintf(*fp, "%s\n", phname->name);
}
static gint sortPhases(TTNAME *p1, TTNAME *p2)
{
return(strcmp(p1->name, p2->name));
}
void tt_extract(char *modelName)
{
TTNAME *name;
char line[TTINPUTLINELEN+1], phase[25], *in;
GSList *phaseL=NULL; 
FILE *fpP, *fpT;
float depth, distance, time;
gchar *file;
GSList *phaseList=NULL;
file = g_strdup_printf("%s.%s", modelName, TT_MODEL_FILE);
if (!(fpT = fopen(file, "r")))
{
fprintf(stderr, "Unable to open file %s, skipping\n", file);
free(file);
return;
}
fprintf(stdout, "Examining Travel Time Table file %s - extracting phases ...\n", file);
free(file);
while ((in=fgets(line, TTINPUTLINELEN, fpT)))
{ 
if (sscanf(line, "%s %f %f %f", phase, &depth, &distance, &time) != TTCOLCNT)
continue;
phaseL = g_slist_find_custom(phaseList, phase, (GCompareFunc) findPhase);
if (phaseL)
continue;
name = calloc(1, sizeof(TTNAME));
name->name = g_strdup(phase);
phaseList = g_slist_prepend(phaseList, name);
}
fclose(fpT);
file = g_strdup_printf("%s.%s", modelName, TT_PHASES_FILE);
fprintf(stdout, "Extracting phases for model %s\n""Writing to file $PQLXXML/%s\n", 
modelName, file);
if (!(fpP = fopen(file, "w")))
{
fprintf(stdout, "Unable to open file %s, sending output to stderr\n", file);
fpP = stderr;
}
phaseList = g_slist_sort(phaseList, (GCompareFunc) sortPhases);
g_slist_foreach(phaseList, (GFunc) printPhases, &fpP);
if (fpP != stderr)
fclose(fpP);
#if 0
for(iter=phaseList;
iter;
iter = g_slist_next(iter))
{
name = iter->data;
fprintf(fpP, "%s\n", name->name);
}
#endif
return;
}
#if 0
void process_tt_phases(char *modelName)
{
gchar *xmlInputDir, *prodDir;
char cwd[MAX_PATH_STR+1];
getcwd(cwd, MAX_PATH_STR+1);
prodDir = getenv("PQLXPROD");
if (!prodDir)
{
fprintf(stderr, "Environment variable PQLXPROD not defined. Cannot import XML data.\n");
return;
}
xmlInputDir = g_strdup_printf("%s/XMLINPUT", prodDir);
if (chdir(xmlInputDir))
{
fprintf(errFP, "Unable to change to XMLINPUT directory %s, Cannot import Travel Time data.\n",
xmlInputDir);
free(xmlInputDir);
fflush(errFP);
return;
}
currentDir = g_strdup(xmlInputDir);
_tt_phase(modelName);
free(xmlInputDir);
free(currentDir);
chdir(cwd);
}
#endif
