#include "pql_defines.h"
#include "pqlx_defs.h"
#include "db_iface.h"
#include "pqlx_externs.h"
#include "pqlxSrvr.h"
#define NOMORECHANNELS -1
extern PQLXSRVRSTRUCT pqlxSrvr;
static int numThreads;
extern GAsyncQueue *commQ;
static GQueue *channelsQ;
static GStaticMutex QMutex = G_STATIC_MUTEX_INIT;  
typedef struct _DBMARGS
{
GThreadFunc returnFunc;
int  threadNum;
} DBMARGS;
static void finishDBM()
{
numThreads--;
if (!numThreads)
{
g_async_queue_push(commQ, "DONE");
}
}
static int getChnKey()
{
int *chnKey;
g_static_mutex_lock(&QMutex);
chnKey = g_queue_pop_head(channelsQ);
g_static_mutex_unlock(&QMutex);
if (chnKey)
return *chnKey;
else
return NOMORECHANNELS;
}
static void _dbMaintain(DBMARGS *dbmArgs)
{
SQLDI  sqldi;
DBMAINT dbMaint;
int  chnKey;
GThreadFunc retFunc = dbmArgs->returnFunc;
int  threadNum = dbmArgs->threadNum;
free(dbmArgs);
memset(&sqldi, 0, sizeof(SQLDI));
memset(&dbMaint, 0, sizeof(DBMAINT));
sqldi.args.dataEvent = DBMAINTAIN;
sqldi.data = &dbMaint;
sqldi.args.sqr = threadNum;
sqldi.args.threaded = TRUE;
chnKey = getChnKey();
while (chnKey != NOMORECHANNELS)
{
dbMaint.keys.tableName = g_strdup_printf("%sDATA.psd%d", pqlxSrvr.dbName, chnKey);
fprintf(stdout, "\t%s - Verifying Integrity\n", dbMaint.keys.tableName);
sqldi.descr.tableData = SYSDBPSDCLEAN;
sqldi.data2 = GINT_TO_POINTER(chnKey);
db_request(&sqldi);
sqldi.descr.tableData = SYSDBTBLOPT;
fprintf(stdout, "\t%s\n", dbMaint.keys.tableName);
db_request(&sqldi);
free(dbMaint.keys.tableName);
dbMaint.keys.tableName = g_strdup_printf("%sDATA.psd%didx", pqlxSrvr.dbName, chnKey);
fprintf(stdout, "\t%s\n", dbMaint.keys.tableName);
db_request(&sqldi);
free(dbMaint.keys.tableName);
sqldi.descr.tableData = SYSDBPSDDELCHAN;
sqldi.data2 = GINT_TO_POINTER(chnKey);
db_request(&sqldi);
chnKey = getChnKey();
}
(*(retFunc))(NULL);
}
void dbMaintThreads(GQueue *c, int ncpu)
{
int i;
numThreads = ncpu;
channelsQ = c;
for(i=0;i<numThreads;i++)
{
DBMARGS *dbmArgs;
dbmArgs = calloc(1, sizeof(DBMARGS));
dbmArgs->returnFunc = (GThreadFunc) finishDBM;
dbmArgs->threadNum = i+2;
makeThread(ASYNC, (GThreadFunc) _dbMaintain, (void *) dbmArgs, NULL);
}
}
