#include <unistd.h>
#include <stdio.h>
#include "pql_defines.h"
#include "pqlx_defs.h"
#include "pqlxSrvr.h"
#include "pqlxSrvrUtils.h"
#define NUMHEDRFIELDS 9
int stdinPDF(gchar *pngName, gchar *wwwDIR, int w, int h, gboolean border, gboolean icon)
{
PDFPNG pdfPNG;
PDFREQ *pdfReq;
PDFDATA *pdfData;
PNGARGS pngArgs;
char *lineptr, ntw[10], stn[10], loc[10], chn[10];
int  rowNum, prob, numFields;
GSList *pdfDataList=NULL, *dataIter;
GIOChannel *stdinCH = g_io_channel_unix_new(STDIN_FILENO);
if (!pngName || ! wwwDIR)
return FAILURE;
memset(&pdfPNG, 0, sizeof(PDFPNG));
pdfReq = calloc(1, sizeof(PDFREQ));
g_io_channel_read_line(stdinCH, &lineptr, NULL, NULL, NULL);
numFields = sscanf(lineptr, "%s %s %s %s %hd %hd %hd %hd %d", 
ntw, stn, loc, chn,
&pdfReq->data.sTime.date.yr, 
&pdfReq->data.sTime.date.jday,
&pdfReq->data.eTime.date.yr,
&pdfReq->data.eTime.date.jday,
&pdfReq->data.numPSDs);
if (numFields != NUMHEDRFIELDS)
{
fprintf(stderr, "Expected %d Header Row fields, got %d, cannot continue\n",
NUMHEDRFIELDS, numFields);
fprintf(stderr, "When piping to sqlxPNG via an SQLX ex* script, the -PNG argument is required.\n");
return FAILURE;
}
pdfPNG.data.ntw = g_strdup(ntw);
pdfPNG.data.stn = g_strdup(stn);
pdfPNG.data.loc = g_strdup(loc);
pdfPNG.data.chn = g_strdup(chn);
pdfReq->data.pdfName = pngName;
rowNum=0;
while(g_io_channel_read_line(stdinCH, &lineptr, NULL, NULL, NULL) != G_IO_STATUS_EOF)
{
pdfData = calloc(1, sizeof(PDFDATA));
sscanf(lineptr, "%f %d %d",
&pdfData->period,
&pdfData->power,
&prob);
pdfData->prob = (float) (float) prob/ (float) pdfReq->data.numPSDs;
pdfDataList = g_slist_append(pdfDataList, pdfData);
rowNum++;
}
pdfReq->data.numRecs = rowNum;
pdfReq->keys.yBounds[YMIN] = -200;
pdfReq->keys.yBounds[YMAX] = -50;
pdfReq->data.pdf = calloc(sizeof(PDFDATA), pdfReq->data.numRecs);
for(rowNum=0,dataIter = pdfDataList; 
dataIter; 
dataIter = g_slist_next(dataIter), rowNum++)
{
pdfData = dataIter->data;
pdfReq->data.pdf[rowNum].period = pdfData->period; 
pdfReq->data.pdf[rowNum].power = pdfData->power;
pdfReq->data.pdf[rowNum].prob = pdfData->prob;
free(pdfData);
}    
pdfPNG.data.pdfReqs = g_slist_prepend(pdfPNG.data.pdfReqs, pdfReq);
memset(&pngArgs, 0, sizeof(PNGARGS));
pngArgs.plot.type = SYSPDFPNG;
pngArgs.data.PDF.plotHLNM = TRUE;
pngArgs.data.PDF.pdfPNG = &pdfPNG;
pngArgs.plot.wwwDir = wwwDIR;
pngArgs.plot.width = w;
pngArgs.plot.height = h;
pngArgs.plot.border = border;
pngArgs.plot.R = 0;
pngArgs.plot.G = 0;
pngArgs.plot.B = 0;
makePNG(&pngArgs);
#if 0
if (icon)
{
pngArgs.plot.width = WWWPDFICOW;
pngArgs.plot.height = WWWPDFICOH;
makePNG(&pngArgs); 
}
#endif
freePNGData(SYSPDFPNG, &pdfPNG);
return PQLXSUCCESS;
}
