#include "pql_defines.h"
#include "pqlx_defs.h"
#include "pqlx_types.h"
GOptionContext *context;
char *statStr[TTLPDFSTATS] = { "Min", "Max", "Mode", "Median", "Mean", "5%", "10%",
"25%", "75%", "90%", "95%"};
int systemPDF(gchar *dbName, gchar *pngDIR, int w, int h, gboolean pngNOBrder, gboolean PDFicon);
int stdinPDF(gchar *pngName, gchar *pngDIR, int w, int h, gboolean pngNOBrder, gboolean PDFicon);
static void printHelp()
{
int argc=2;
char **argv;
GError *error = NULL;
argv = calloc(2, sizeof(char*));
argv[0] = g_strdup("pqlxPNG");
argv[1] = g_strdup("--help");
g_option_context_parse(context, &argc, &argv, &error);
}
static gchar *pngDIR;
static gboolean PDFsys, PDFinput; 
static gchar *dbName, *pngName;
static gboolean icon = FALSE;
#define MAX_DIR_PATH 2048  
int main(int argc, char **argv)
{
int  ret;
char *widthHelp, *heightHelp;
static int w=0, h=0;
GError *error = NULL;
gboolean override, PNGborder;
static union {
int PNGborder;
gboolean border;
} border;
static union {
int PNGborder;
gboolean border;
} noBorder;
static GOptionEntry entries[] = 
{
{ "width", 0, 0, G_OPTION_ARG_INT, &w, NULL, NULL },
{ "height", 0, 0, G_OPTION_ARG_INT, &h, NULL, NULL },
{ "border", 0, 0, G_OPTION_ARG_NONE, &border.border, "Draw A Border Around PDF Plot - optional", NULL },
{ "noBorder", 0, 0, G_OPTION_ARG_NONE, &noBorder.border, "Do NOT Draw A Border Around PDF Plot - optional", NULL },
{ "icon", 0, 0, G_OPTION_ARG_NONE, &icon, "Make PNG Icon plot as well - optional", NULL },
{ "systemPDF", 0, 0, G_OPTION_ARG_NONE, &PDFsys, "Make PNG plots of System PDF's:", NULL },
{ "dbName", 0, 0, G_OPTION_ARG_STRING, &dbName, "\t For Database pqlxDB on SERVER - required", "[SERVER:]pqlxDB" },
{ "pngDir", 0, 0, G_OPTION_ARG_STRING, &pngDIR, "\t Directory Where to Place PNG Files - optional", "/path/to" },
{ "inputPDF", 0, 0, G_OPTION_ARG_NONE, &PDFinput, "Make PNG plot of PDF provided via stdin:", NULL },
{ "pngName", 0, 0, G_OPTION_ARG_STRING, &pngName, "\t Name of PDF to provide in PNG Filename - required", "90TH" },
{ "pngDir", 0, 0, G_OPTION_ARG_STRING, &pngDIR, "\t Directory Where to Place PNG Files - required", "/path/to" },
{ NULL }
};
border.PNGborder = noBorder.PNGborder = NONE;
override = FALSE;
widthHelp = g_strdup_printf("Width of Plot (in pixels, default = (SystemPDF = DB Value) (InputPDF = %d)", WWWPDFW);
heightHelp = g_strdup_printf("Height of Plot (in pixels, default = (SystemPDF = DB Value) (InputPDF = %d))", WWWPDFH);
entries[0].description = widthHelp;
entries[1].description = heightHelp;
context = g_option_context_new("- Make PNG Plot(s) of PDF Data");
g_option_context_add_main_entries(context, entries, NULL);
g_option_context_parse(context, &argc, &argv, &error);
if (border.PNGborder != NONE)
{
PNGborder = TRUE;
override = TRUE;
}
if (noBorder.PNGborder != NONE)
{
PNGborder = FALSE;
override = TRUE;
}
if (PDFsys)
{ 
if (!dbName)
printHelp();
else
{
g_thread_init(NULL);
ret = systemPDF(dbName, pngDIR, w, h,
(override) ? PNGborder : NONE,
icon);
}
}
else if (PDFinput)
{ 
if (!w)
{
w = WWWPDFW;
h = WWWPDFH;
}
if (!pngName || !pngDIR)
printHelp();
else
ret = stdinPDF(pngName, pngDIR, w, h, 
(override) ? PNGborder : TRUE, 
icon);
}
else
{
printHelp();
}
return ret;
}
