#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "pql_defines.h"
#include "pqlx_defs.h"
#include "pqlx_externs.h"
#include "pqlxSrvr.h"
#include "pqlxSrvrUtils.h"
static GQueue *channels;
static char *wwwDir;  
static gboolean PNGicon;
void TIMESTR(char *);
GSList *ntw, *ntwPDF;  
static char *procName;
typedef struct _PNGTARGS
{
GThreadFunc returnFunc;
int  threadNum;
PNGWWW *pngWWW;
int  type;
} PNGTARGS;
#define PQLXPNG_MIN_DBVERSION 2
static int  num_threads;
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
static GAsyncQueue  *commQ;
static void finish(int ret)
{
g_async_queue_push(commQ, "DONE");
}
static void *getNextPDF()
{
PDFPNG *pdfPNG;
g_static_mutex_lock(&myMutex);
pdfPNG = g_queue_pop_head(channels);
g_static_mutex_unlock(&myMutex);
return pdfPNG;
}
static void getPdfPng(PNGTARGS *pngTArgs)
{
SQLDI *sqldi;
void *pdfPNG;
PNGARGS pngArgs;
PNGWWW *pngWWW = pngTArgs->pngWWW;
sqldi = calloc(1, sizeof(SQLDI));
sqldi->args.sqr = pngTArgs->threadNum;
sqldi->descr.tableData = pngTArgs->type;
sqldi->args.dataEvent = GET_DATA;
sqldi->args.threaded = TRUE;
memset(&pngArgs, 0, sizeof(PNGARGS));
pngArgs.threadNum = pngTArgs->threadNum;
pngArgs.plot.type = pngTArgs->type;
pngArgs.data.PDF.plotHLNM = pngWWW->HLNM;
pngArgs.plot.wwwDir = pngWWW->dir;
pdfPNG = getNextPDF();
while(pdfPNG)
{
sqldi->data = pdfPNG;
db_request(sqldi);
switch (pngArgs.plot.type)
{
case SYSPDFPNG:
pngArgs.data.PDF.pdfPNG = pdfPNG;
break;
case SYSSPECPNG:
pngArgs.data.SPECTRO.specPNG = pdfPNG;
break;
}
pngArgs.plot.width = pngWWW->width;
pngArgs.plot.height = pngWWW->height;
pngArgs.plot.border = pngWWW->border;
pngArgs.plot.R = pngWWW->r;
pngArgs.plot.G = pngWWW->g;
pngArgs.plot.B = pngWWW->b;
makePNG(&pngArgs); 
if (PNGicon)
{
pngArgs.plot.width = pngWWW->Iwidth;
pngArgs.plot.height = pngWWW->Iheight;
pngArgs.plot.border = pngWWW->Iborder;
pngArgs.plot.R = pngWWW->Ir;
pngArgs.plot.G = pngWWW->Ig;
pngArgs.plot.B = pngWWW->Ib;
makePNG(&pngArgs); 
}
freePNGData(pngArgs.plot.type, pdfPNG);
pdfPNG = getNextPDF();
}
free(sqldi);
(*(pngTArgs->returnFunc))(NULL);
}
static gboolean registerPDF(GNode *node, gpointer nil)
{
NSLCDATA *nodeD=node->data;
PDFPNG *pdfPNG;
if (!isPDFchn(nodeD->name))
return FALSE;
pdfPNG = calloc(1, sizeof(PDFPNG));
pdfPNG->keys.chnKey = nodeD->id;
g_queue_push_tail(channels, pdfPNG);
return FALSE;
}
void finishPdfPng()
{
num_threads--;
if (!num_threads)
{
finish(PQLXSUCCESS);
}
}
int systemPDF(gchar *dbName, gchar *pngDIR, int w, int h, int border, gboolean icon)
{
SQLDI sqldi;
LOGIN login;
GSList *ntwIter;
int  ret=PQLXSUCCESS, ncpu = get_ncpu_pqlx(), i;
char execTime[50], *nothing;
GSList *pngWWW = NULL, *iter;
PNGWWW *pngWWWd;
memset(&login, 0, sizeof(LOGIN));
if(strchr(dbName, ':'))
{ 
sscanf(dbName, "%[^:]%*[:]%s", login.keys.hostname, login.keys.dbname);
}
else
{
strcpy(login.keys.hostname, "localhost");
strcpy(login.keys.dbname, dbName);
}
TIMESTR(execTime);
if (!loggingInit("PNG", login.keys.dbname, execTime, TRUE, TRUE))
{
fprintf(stderr, "Unable to initialize Logging, quitting...\n");
exit(-1);
}
commQ = g_async_queue_new();
procName = g_strdup("pqlxPNG");
PNGicon = icon;
memset(&sqldi, 0, sizeof(SQLDI));
strcpy(login.keys.username, PQLXSRVR);
strcpy(login.keys.password, PQLXSRVRPW);
strcpy(login.keys.pgmName, procName);
login.keys.numCPUs = ncpu;
sqldi.data = &login;
sqldi.args.dataEvent = CONNECT;
logMsg(LOGMSG_PROG_STARTUP, &login);
logMsg(LOGMSG_CONN_ATTEMPT, &login);
ret = db_request(&sqldi);
if (ret != PQLXSUCCESS)
{
fprintf(stdout, "Connection Failed (error code = %d), cannot continue.\n", ret);
fprintf(stderr, "Unable to connect to Database, cannot continue.\n");
exit(-1); 
}
logging(LOG_OUTPUT);
logMsg(LOGMSG_CONN_SUCCESS, &login);
sqldi.data = &pngWWW;
sqldi.descr.tableData = PNGWWWDEF;
sqldi.args.dataEvent = GET_DATA;
db_request(&sqldi);
for (iter = pngWWW;
iter;
iter = g_slist_next(iter))
{
pngWWWd = iter->data;
if (w || h)
{ 
pngWWWd->width = w;
pngWWWd->height = h;
}
if (border != NONE)
pngWWWd->border = pngWWWd->Iborder = (gboolean) border;
wwwDir = pngWWWd->dir;
if (!pngDIR)
{ 
if (!strcmp(wwwDir, "NONE"))
{
fprintf(stderr, "No WWWDir specified for database...\n");
fprintf(stderr, "Either provide this directory as part of the "
"$DBDEF/%s.pqlx database definition file, or\n", 
login.keys.dbname);
fprintf(stderr, "provide this via argument --pngDir= when executing this program.\n");
fprintf(stderr, "(To update the database with the lastest information "
"from the $PQLXDBDEF/%s.pqlx file, execute the "
"script 'updatePQLXdb.sh')\n", login.keys.dbname);
finish(FAILURE);
ret = FAILURE;
}
}
else
{ 
wwwDir = g_strdup(pngDIR);
}
fprintf(stdout, "Outputting %s Plots to Directory '%s'\n", pngWWWd->name, wwwDir);
fprintf(stdout, "Starting %d Worker Threads\n", ncpu);
channels = g_queue_new();
for(ntwIter = ntw; ntwIter && ret==0; ntwIter = g_slist_next(ntwIter))
{
g_node_traverse(ntwIter->data, G_IN_ORDER, G_TRAVERSE_LEAVES, -1, 
(GNodeTraverseFunc) registerPDF, NULL);
}
num_threads = 0;
for(i=0;i<ncpu && i<g_queue_get_length(channels);i++)
{
PNGTARGS *pngTArgs;
pngTArgs = calloc(1, sizeof(PNGARGS));
pngTArgs->returnFunc = (GThreadFunc) finishPdfPng;
pngTArgs->threadNum = ++num_threads;
pngTArgs->pngWWW = pngWWWd;
pngTArgs->type = pngWWWd->type;
makeThread(ASYNC, (GThreadFunc) getPdfPng, (void *) pngTArgs, NULL);
}
nothing = g_async_queue_pop(commQ);  
g_queue_free(channels);
}
{ 
SQLDI sqldi;
logMsg(LOGMSG_PROG_QUIT, procName);
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = DISCONNECT;
db_request(&sqldi);
logging(LOG_SHUTDOWN);
}
return ret;
}
