#include "pqlxSrvr.h"
#include <glib/gstdio.h>
static SCAN *scanPtr;
gboolean scanDir(SCAN *scnPtr, gboolean firstTime, gboolean *scanForked, char *inDir)
{
GDir *dir;    
const gchar *dirFile;  
char *cwd;
struct stat dir_stat; 
SQLDI sqldi;
TRC1 trc1;
static time_t scanTime, sinceES, cutoff;
char *realDir;
char *symDir;
gboolean logFile, retVal, topLevel=FALSE;
int cutO;
if ((g_chdir(inDir)==-1))
{
fprintf(stdout, "Cannot 'cd' to Directory ('%s'), Not Scanning ", inDir);
perror("");
return FALSE;
}
if (scnPtr)
{ 
time_t tloc;
struct tm *timeN;
PTIME ptimeN;
fprintf(stdout, "Scanning Directory %s ...\n", inDir);
topLevel = TRUE;
memset(&ptimeN, 0, sizeof(PTIME));
scanPtr = scnPtr;  
scanTime = sinceES = scanPtr->keys.scanTime; 
cutO = (firstTime) ? 0 : 1;
time(&tloc);
timeN = localtime(&tloc);
ptimeN.yr = timeN->tm_year + 1900;
if (timeN->tm_yday+1-(cutO-1) < 0)
{ 
ptimeN.yr--;
ptimeN.jday = timeN->tm_yday+1-(cutO-1) + (passcal_isleap(ptimeN.yr) ? 366 : 365);
}
else
{ 
ptimeN.jday = timeN->tm_yday+1-(cutO-1); 
}
if(!cutO)
{ 
ptimeN.hr = timeN->tm_hour;
ptimeN.mn = timeN->tm_min;
ptimeN.sec = timeN->tm_sec;
}
cutoff = passcal_htoe(&ptimeN, FALSE);
}
if (!(cwd = g_get_current_dir()))
{
perror("g_get_current_dir ");
return FALSE;
}
realDir = symDir = NULL;
if (strcmp(inDir, cwd))
{
realDir = g_strdup(cwd);
symDir = g_strdup(inDir);
}
memset(&trc1, 0, sizeof(TRC1));
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = INSERT_DATA;
sqldi.data = &trc1;
dir = g_dir_open(cwd, 0, NULL);
if (!dir) 
{
fprintf(stderr, "Cannot Open Directory for Reading ('%s') ", cwd);
perror("");
free(cwd);
return FALSE;
}
while ((dirFile = g_dir_read_name(dir))) 
{
if (dirFile[0] == '.')
continue;  
if (g_stat(dirFile, &dir_stat) == -1) 
{ 
continue;
}
if (S_ISDIR(dir_stat.st_mode)) 
{ 
gboolean scanRet;
char *dirName = symDir ? g_strdup_printf("%s/%s", symDir, dirFile)
: g_strdup_printf("%s/%s", cwd, dirFile);
scanRet = scanDir(NULL, firstTime, scanForked, dirName);
free(dirName);
if (!scanRet)
continue;
if (g_chdir("..") == -1) 
{
fprintf(stderr, "Cannot 'cd' Back to '%s' ", cwd);
perror("");
return FALSE;
}
}
else
{ 
int findRet;
if (dir_stat.st_mtime > sinceES)
{
strcpy(trc1.keys.directory, cwd);
strcpy(trc1.keys.filename, dirFile);
findRet = trc1.keys.chnKey = findChn(&trc1, scanPtr);
if (!findRet || findRet == NONE) 
{ 
continue;
}
logFile = FALSE;
switch(trc1.keys.fileType)
{
case MSEED_DATA:
case SEGY_DATA:
case AH_DATA:
case SAC_DATA:
case DR100_DATA:
case NANO_DATA:
if (firstTime || dir_stat.st_mtime < cutoff)
{ 
logFile = TRUE;
sqldi.descr.tableData = TRCTBL;
scanPtr->data.nTrace++;
}
break;
case RESPFILE:
logFile = TRUE;
sqldi.descr.tableData = RESPTBL;
scanPtr->data.nResp++;
break;
}
if (logFile)
{ 
char *dir = NULL;
if (realDir) 
strReplace(cwd, dir, realDir, symDir);
strcpy(trc1.keys.directory, (dir ? dir : cwd));
strcpy(trc1.keys.filename, dirFile);
db_request(&sqldi);
IFFREE(dir);
if (dir_stat.st_mtime > scanTime)
{ 
scanTime = dir_stat.st_mtime;
}
}
if (pqlxSrvr.fork &&       
!*scanForked &&        
pqlxSrvr.numCPUS > 1 &&      
scanPtr->data.nTrace==NTRCSSTARTEVENTPROC) 
{ 
fprintf(stdout, "Starting %d Event Processors\n", pqlxSrvr.numCPUS - 1);
*scanForked = forkEventProcs(TRUE, pqlxSrvr.numCPUS - 1);
}
}
}
}
g_dir_close(dir);
free(cwd);
retVal = TRUE;  
if (topLevel)
{ 
retVal = (scanPtr->keys.scanTime == scanTime) ? FALSE : TRUE;
scanPtr->keys.scanTime = scanTime;
}
if (realDir)
{
free(realDir);
free(symDir);
}
return retVal;
}
