#include <unistd.h>
#include "pqlxSrvr.h"
static gint findWWW(PNGWWW *pngWWW, int *type)
{
return (*type - pngWWW->type);
}
int pqlxEventProc(LOGIN *login, gboolean forked)
{
int  ret; 
SQLDI evtRd;
SQLDI sqldi;
gboolean paused = FALSE;
if (!trashDir())
{ 
fprintf(stdout, "Nothing Analyzed, PQLXTRASH not set, check .err file for details.\n");
ret = PQLXSUCCESS;
if (forked)
exit(ret);
else
return ret;
}
if (forked)
{
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.data = login;
sqldi.args.dataEvent = CONNECT;
ret = db_request(&sqldi);
if (ret != PQLXSUCCESS)
{
fprintf(stderr, "Unable to connect to Database, quitting.\n");
if (forked)
exit(ret);
else
return ret;
}
}
memset(&evtRd, 0, sizeof(SQLDI));
evtRd.args.dataEvent = EVENTQ;
evtRd.descr.tableData = EVENT_GET;
ret = db_request(&evtRd);
while (evtRd.event.id > NONE &&
!paused)
{ 
switch(evtRd.event.type)
{
case PAUSEevt:
paused = TRUE;  
continue;
break;
case TRC1evt:
{
TRC1 *trcPtr = evtRd.data;
evtRd.event.errorNO = an_trc(trcPtr);
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
freeMyData(TRC1DATA, evtRd.data);
free(evtRd.data);
}
break;
case PSD1evt:
case PSD2evt:
{
PSD1 *psd = evtRd.data;
evtRd.event.errorNO = an_psd(evtRd.event.type, psd);
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
if (psd->keys.resp.data.fileName)
free(psd->keys.resp.data.fileName);
free(psd->keys.conf.units);
free(evtRd.data);
}
break;
case SYSPDFPNG:
{
PDFPNG *pdfPNG = evtRd.data;
GSList *www;
PNGWWW *pngWWW;
PNGARGS pngArgs;
www = g_slist_find_custom(pqlxSrvr.pngWWW, &evtRd.event.type, 
(GCompareFunc) findWWW);
if (!www)
{
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
freePNGData(SYSPDFPNG, pdfPNG);
free(evtRd.data);
break;
}
pngWWW = www->data;
memset(&pngArgs, 0, sizeof(PNGARGS));
pngArgs.plot.type = SYSPDFPNG;
pngArgs.data.PDF.pdfPNG = pdfPNG;
pngArgs.data.PDF.plotHLNM = pngWWW->HLNM;
pngArgs.plot.wwwDir = pngWWW->dir;
pngArgs.plot.width = pngWWW->width;
pngArgs.plot.height = pngWWW->height;
pngArgs.plot.border = pngWWW->border;
pngArgs.plot.R = pngWWW->r;
pngArgs.plot.G = pngWWW->g;
pngArgs.plot.B = pngWWW->b;
evtRd.event.errorNO = makePNG(&pngArgs); 
if (evtRd.event.errorNO == PQLXSUCCESS)
{
pngArgs.plot.width = pngWWW->Iwidth;
pngArgs.plot.height = pngWWW->Iheight;
pngArgs.plot.border = pngWWW->Iborder;
pngArgs.plot.R = pngWWW->Ir;
pngArgs.plot.G = pngWWW->Ig;
pngArgs.plot.B = pngWWW->Ib;
evtRd.event.errorNO = makePNG(&pngArgs);
}
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
freePNGData(SYSPDFPNG, pdfPNG);
free(evtRd.data);
}
break;
case SYSSPECPNG:
{
SPECPNG *specPNG = evtRd.data;
GSList *www;
PNGWWW *pngWWW;
PNGARGS pngArgs;
www = g_slist_find_custom(pqlxSrvr.pngWWW, &evtRd.event.type, 
(GCompareFunc) findWWW);
if (!www)
{
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
freePNGData(SYSSPECPNG, specPNG);
free(evtRd.data);
break;
}
pngWWW = www->data;
memset(&pngArgs, 0, sizeof(PNGARGS));
pngArgs.plot.type = evtRd.event.type;
pngArgs.data.SPECTRO.specPNG = specPNG;
pngArgs.plot.wwwDir = pngWWW->dir;
pngArgs.plot.width = pngWWW->width;
pngArgs.plot.height = pngWWW->height;
pngArgs.plot.border = pngWWW->border;
pngArgs.plot.R = pngWWW->r;
pngArgs.plot.G = pngWWW->g;
pngArgs.plot.B = pngWWW->b;
evtRd.event.errorNO = makePNG(&pngArgs); 
if (evtRd.event.errorNO == PQLXSUCCESS)
{
pngArgs.plot.width = pngWWW->Iwidth;
pngArgs.plot.height = pngWWW->Iheight;
pngArgs.plot.border = pngWWW->Iborder;
pngArgs.plot.R = pngWWW->Ir;
pngArgs.plot.G = pngWWW->Ig;
pngArgs.plot.B = pngWWW->Ib;
evtRd.event.errorNO = makePNG(&pngArgs);
}
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
freePNGData(SYSSPECPNG, specPNG);
free(evtRd.data);
}
break;
#if 0   
case RESP1:
{
RESPFILE *respPtr = evtRd.data;
evtRd.event.errorNO = an_psd2(psdPtr);
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
free(evtRd.data);
}
break;
#endif
default: 
evtRd.event.errorNO = UNKNOWN_EVENT;
evtRd.args.dataEvent = UPDATE_DATA;
ret = db_request(&evtRd);
break;
}
memset(&evtRd, 0, sizeof(SQLDI));
evtRd.args.dataEvent = EVENTQ;
evtRd.descr.tableData = EVENT_GET;
ret = db_request(&evtRd);
while(evtRd.event.id == NONE &&
scanIsLocked(login->keys.dbname))
{ 
sleep(1);
ret = db_request(&evtRd);
}
}
if (forked)
{ 
sqldi.args.dataEvent = DISCONNECT;
db_request(&sqldi);
}
ret = paused ? PQLXSRVRPAUSE : PQLXSUCCESS;
if (forked)
exit(ret);
else
return ret;
}
#include <sys/types.h>
#include <sys/wait.h>
int forkEvents(LOGIN *login, int numProcs)
{
pid_t pid;
int  i, status, exitStatus;
gboolean forkAgain = FALSE;
for(i=0;i<numProcs;i++)
{
switch(pid=fork())
{
case -1:
fprintf(stderr, "Can't fork the PQLX Server Event Processor, Quitting...\n");
getOut();
case 0 :
pqlxSrvr.forkNum = i;
pqlxEventProc(login, TRUE);  
exit(0);
default:;       
}
}
while(numProcs)
{
wait(&status);
forkAgain = FALSE;
if(!WIFEXITED(status))
{ 
forkAgain = TRUE;
}
else
{ 
exitStatus = WEXITSTATUS(status); 
if (exitStatus != PQLXSUCCESS &&
exitStatus != PQLXSRVRPAUSE)
{ 
forkAgain = TRUE;
}
else
{ 
forkAgain = FALSE;
numProcs--;
}
}
if (forkAgain)
{
switch(pid=fork())
{
case -1: 
fprintf(stderr, "Can't fork the PQLX Server Event Processor, Quitting...\n");
getOut();
case 0 : 
fprintf(stderr, "pqlxSrvr Event Processor abnormally exited: re-initiating...\n");
pqlxEventProc(login, TRUE);   
exit(0); 
}
}
}
exit(exitStatus);
}
