#include <stdlib.h>
#include <stdio.h> 
#include <dirent.h> 
#ifndef MAC
#include <sys/types.h>
#endif
#include <sys/stat.h> 
#include <string.h> 
#include <unistd.h> 
#include <sys/wait.h>
#include "pqlxSrvr.h"
void reAnalyze(char *dbname)
{
SQLDI sqldi;
SCAN  scan;
TRC1  *trc1;
FILE  *inFP;
char  *dir, *msg;
char  filename[MAX_DIR_PATH];
gboolean logFile, instanceFound=FALSE;
int  scanForked=0, i;
int  status;
fprintf(stdout, "(Re-)Analyzing Files Specified in file %s\n", pqlxSrvr.identFile);
memset(filename, 0, MAX_DIR_PATH);
memset(&sqldi, 0, sizeof(SQLDI));
memset(&scan, 0, sizeof(SCAN));
sqldi.args.dataEvent = INSERT_DATA;
trc1 = sqldi.data = (TRC1 *) malloc(sizeof(TRC1));
if ((inFP = fopen(pqlxSrvr.identFile, "r")) == NULL)
{
fprintf(stderr, "Unable to open file %s for reading, nothing to do.... quitting\n",
pqlxSrvr.identFile);
return;
}
scanLockFile(dbname, SCAN_FCREATE);  
while(fscanf(inFP, "%s", filename) != EOF)
{
memset(trc1, 0, sizeof(TRC1));
dir = strrchr(filename, '/');
if (!dir)
continue; 
strncpy(trc1->keys.directory, filename, (int) (dir-filename));
strcpy(trc1->keys.filename, (char *) (dir+1));
trc1->keys.chnKey = findChn(trc1, &scan);
if (!trc1->keys.chnKey || trc1->keys.chnKey == NONE)
{ 
fprintf(stderr, "Warning: File %s not identified as any valid PQLX type.\n", filename);
continue;
}
logFile = FALSE;
switch(trc1->keys.fileType)
{
case MSEED_DATA:
case SEGY_DATA:
case AH_DATA:
case SAC_DATA:
case DR100_DATA:
case NANO_DATA:
logFile = TRUE;
sqldi.descr.tableData = TRCTBL;
scan.data.nTrace++;
break;
case RESPFILE:
logFile = TRUE;
sqldi.descr.tableData = RESPTBL;
scan.data.nResp++;
break;
}
if (logFile)
{
instanceFound = TRUE;
db_request(&sqldi);
}
if (pqlxSrvr.fork &&       
!scanForked &&       
pqlxSrvr.numCPUS > 1 &&     
scan.data.nTrace==NTRCSSTARTEVENTPROC) 
{ 
scanForked = (int) forkEventProcs(TRUE, pqlxSrvr.numCPUS - 1);
}
}
fclose(inFP);
scanLockFile(dbname, SCAN_FDELETE);  
fprintf(stdout, "Read Input File %s and found NEW instances of:\n", pqlxSrvr.identFile);
outputScanStats(&scan, TRUE);
msg = NULL;
if (pqlxSrvr.fork)
{
sqldi.args.dataEvent = DISCONNECT;
db_request(&sqldi);
if(instanceFound)   
{ 
scanForked += (int) forkEventProcs(FALSE, 0);
for(i=scanForked; i> 0 ; i--)
{
wait(&status);   
}
scanForked=0;    
msg = g_strdup("Analysis complete, control returned to MAIN.");
}
}
else
{
if(instanceFound)
{ 
fprintf(stdout, "Beginning Data Analysis...\n");
pqlxEventProc(&pqlxSrvr.login, FALSE);
msg = g_strdup("Analysis complete.");
}
}
if (msg)
{
fprintf(stdout, "%s\n", msg);
free(msg);
}
return;
}
