#include <unistd.h>
#include <dirent.h>
#include "pqlxSrvr.h"
#include "db_iface.h"
#include "xml_input.h"
#include "ezxml.h"
char *database, *executionTime, *currentDir;
char *chnMETAXMLfn[] = {"NTW", "STN", "LOC", "CHN", "START", "END", 
"SITENAME", "LATITUDE", "LONGITUDE", "ELEVATION", "DEPTH", 
"SENSITIVITY", "UNITS", "INSTID", "AZIMUTH", 
"DIP", "SRATE"};
char *eventXMLfn[] = { "ID", "DESCRIPTION", "ORIGIN", "ID", "CATALOG", "LOCATION", 
"TIME", "LATITUDE", "LONGITUDE", "DEPTH", "MAGNITUDE"};
static void _xml_chnMETA(gboolean initialExec, char *xmlInputDir)
{
DIR* dir;     
struct dirent* entry;  
int   i, cnt=0, channelID;
SQLDI  sqldi;
XMLINFO  xmlInfo;
CHNMETAINFO *chnMETAInfo;
char  *names[4];
ezxml_t  chnMETA, child;
SCAN  scan;
GSList  *iter, *xmlFiles=NULL, *fileIter;
char  *empty = "", *file, *match = g_strdup_printf("%s.%s", database, CHNMETA_INFO_FILE);
gboolean freeLOC, fileFound;
ezxml_t  chnMETAFile;
dir = opendir(xmlInputDir);
if (!dir)
{
fprintf(stderr, "Cannot read directory '%s': \n", xmlInputDir);
perror("");
return;
}
fileFound = FALSE;
while ((entry = readdir(dir))) 
{
if (!strcmp(entry->d_name, ".") || !strcmp(entry->d_name, ".."))
continue;
if (globmatch(entry->d_name, match))
{
if (initialExec)
{
fileFound = TRUE;
break;
}
xmlFiles = g_slist_append(xmlFiles, g_strdup(entry->d_name));
}
}
closedir(dir);
free(match);
if (initialExec && fileFound)
{ 
fprintf(stdout, "Importation of XML files not possible with first execution of server.\n");
fprintf(stdout, "Please execute the server again once initial execution is completed to import.\n");
return;
}
for(fileIter = xmlFiles;fileIter;fileIter=g_slist_next(fileIter))
{
file = g_strdup_printf("%s", (char *) fileIter->data);
fprintf(stdout, "Importing XML file %s... ", file);
chnMETAFile = ezxml_parse_file(file);
if (!chnMETAFile)
{
free(file);
free(fileIter->data);
continue;  
}
memset(&scan, 0, sizeof(SCAN));
memset(&sqldi, 0, sizeof(SQLDI));
memset(&xmlInfo, 0, sizeof(xmlInfo));
sqldi.descr.tableData = CHNMETAINFOTBL;
sqldi.data = &xmlInfo;
sqldi.args.dataEvent = INSERT_DATA;
for (chnMETA = ezxml_child(chnMETAFile, chnMETAXMLTag), cnt=0;
chnMETA;
chnMETA = ezxml_next(chnMETA), cnt++)
{
freeLOC = FALSE;
names[0] = (char *) ezxml_attr(chnMETA, chnMETAXMLfn[XMLCHNMETANTW]);
names[1] = (char *) ezxml_attr(chnMETA, chnMETAXMLfn[XMLCHNMETASTN]);
names[2] = (char *) ezxml_attr(chnMETA, chnMETAXMLfn[XMLCHNMETALOC]);
names[3] = (char *) ezxml_attr(chnMETA, chnMETAXMLfn[XMLCHNMETACHN]);
if (!strcmp(names[2], RESPNLOC) ||
!strcmp(names[2], MSEEDNLOC) ||
!strlen(names[2]))
{ 
names[2] = g_strdup(PQLXNLOC);
freeLOC = TRUE;
}
channelID = chnID(&scan, names[0], names[1], names[2], names[3], FALSE);
if (freeLOC)
free(names[2]);
if (channelID == NONE)
{ 
continue;
}
chnMETAInfo = calloc(1, sizeof(CHNMETAINFO));
chnMETAInfo->values[DBCHNMETACHNID] = g_strdup_printf("%d", channelID);
chnMETAInfo->values[DBCHNMETASTART] = (char *) ezxml_attr(chnMETA, chnMETAXMLfn[XMLCHNMETASTART]);
chnMETAInfo->values[DBCHNMETAEND] = (char *) ezxml_attr(chnMETA, chnMETAXMLfn[XMLCHNMETAEND]);
for(i=3;i<TTLDBCHNMETA-1;i++)
{
child = ezxml_child(chnMETA, chnMETAXMLfn[i+3]);
if (child)
chnMETAInfo->values[i] = (char *) child->txt;
else
chnMETAInfo->values[i] = empty;
}
child = ezxml_child(chnMETA, chnMETAXMLfn[i+3]);
if (child)
chnMETAInfo->values[i] = g_strdup(child->txt);
else
chnMETAInfo->values[i] = g_strdup(empty);
if (strlen(chnMETAInfo->values[DBCHNMETASAMPINT]))
{
char *str = chnMETAInfo->values[DBCHNMETASAMPINT];
chnMETAInfo->values[DBCHNMETASAMPINT] = g_strdup_printf("%d", (int) ((1000000./atof(str))+.5));
free(str);
}
xmlInfo.data.info = g_slist_prepend(xmlInfo.data.info, chnMETAInfo);
}
if (db_request(&sqldi) != PQLXSUCCESS)
fprintf(stdout, "\tImport FAILURE! Not all records have been imported. Please check .err file.\n");
else
{
char *newFile = g_strdup_printf("%s/history/%s.%s", currentDir, file, executionTime);
char *oldFile = g_strdup_printf("%s/%s", currentDir, file);
rename(oldFile, newFile);
free(newFile); free(oldFile);
fprintf(stdout, "\tImported %d records.\n", cnt);
}
for(iter = xmlInfo.data.info;iter;iter=g_slist_next(iter))
{
chnMETAInfo = iter->data;
free(chnMETAInfo->values[DBCHNMETACHNID]);
free(chnMETAInfo->values[DBCHNMETASAMPINT]);
free(chnMETAInfo);
}
g_slist_free(xmlInfo.data.info);
free(file);
ezxml_free(chnMETAFile);
free(fileIter->data);
}
g_slist_free(xmlFiles);
{ 
SQLDI sqldiL;
DBMAINT dbMaint;
memset(&sqldiL, 0, sizeof(SQLDI));
memset(&dbMaint, 0, sizeof(DBMAINT));
sqldiL.descr.tableData = SYSDBTBLOPT;
sqldiL.args.dataEvent = DBMAINTAIN;
sqldiL.data = &dbMaint;
dbMaint.keys.tableName = g_strdup("CHNMETA");
db_request(&sqldiL);
free(dbMaint.keys.tableName);
}
}
#if MINIMUM_DB_VERSION >= XML_EVENT_VER
static void _xml_event(gboolean initialExec)
{ 
int   cnt=0;
SQLDI  sqldi;
XMLINFO  xmlInfo;
ORIGININFO *originInfo;
MAGINFO  *magInfo;
GSList  *iter, *iter1;
ezxml_t  event, origin, loc, tim, lat, lon, dep, mag;
char  *empty = "";
gchar *file = g_strdup_printf("%s.%s", database, EVENT_INFO_FILE);
ezxml_t eventInfoFile = ezxml_parse_file(file);
if (!eventInfoFile)
{
free(file);
return;
}
if (initialExec)
{ 
fprintf(stdout, "Importation of XML files not possible with first execution of server.\n");
fprintf(stdout, "Please execute the server again once initial execution is completed to import.\n");
ezxml_free(eventInfoFile);
free(file);
return;
}
fprintf(stdout, "Importing XML file %s... ", EVENT_INFO_FILE);
memset(&sqldi, 0, sizeof(SQLDI));
memset(&xmlInfo, 0, sizeof(xmlInfo));
sqldi.descr.tableData = EVENTINFOTBL;
sqldi.data = &xmlInfo;
sqldi.args.dataEvent = INSERT_DATA;
for (event = ezxml_child(eventInfoFile, eventXMLTag);
event;
event = ezxml_next(event))
{
for(origin = ezxml_child(event, eventXMLfn[XMLEVENTORIGIN]); 
origin; 
origin = ezxml_next(origin), cnt++)
{
originInfo = calloc(1, sizeof(ORIGININFO));
originInfo->values[DBSEISEVENTID] = (char *) ezxml_attr(event, eventXMLfn[XMLEVENTID]);
originInfo->values[DBSEISDESCR] = (char *) ezxml_attr(event, eventXMLfn[XMLEVENTDESCR]);
originInfo->values[DBSEISORIGINID] = (char *) ezxml_attr(origin, eventXMLfn[XMLEVENTORIGINID]);
originInfo->values[DBSEISCAT] = (char *) (ezxml_child(origin, eventXMLfn[XMLEVENTCAT]))->txt;
loc = ezxml_child(origin, eventXMLfn[XMLEVENTLOC]);
if (!loc)
{
free(originInfo);
cnt--;
continue;
}
tim = ezxml_child(loc, eventXMLfn[XMLEVENTTIME]);
if (tim)
{ 
int  len1, len2, len3;
char *date, *time;
const char *str = ezxml_attr(tim, "VALUE");
len1 = (int) (strchr(str, 'T') - str);
date = g_strndup(str, len1);
len2 = (int) (strchr(str, '.') - &str[++len1]);
time = g_strndup(&str[len1], len2);
originInfo->values[DBSEISTIME] = g_strdup_printf("%s %s", date, time);
free(date); free(time);
len3 = (int) (strchr(str, 'Z') - &str[len1+(++len2)]);
originInfo->values[DBSEISMSEC] = g_strndup(&str[len1+len2], len3);
}
lat = ezxml_child(loc, eventXMLfn[XMLEVENTLAT]);
if (lat)
originInfo->values[DBSEISLAT] = (char *) ezxml_attr(lat, "VALUE");
else
originInfo->values[DBSEISLAT] = empty;     
lon = ezxml_child(loc, eventXMLfn[XMLEVENTLON]);
if (lon)
originInfo->values[DBSEISLON] = (char *) ezxml_attr(lon, "VALUE");
else
originInfo->values[DBSEISLON] = empty;     
dep = ezxml_child(loc, eventXMLfn[XMLEVENTDEPTH]);
if (dep)
originInfo->values[DBSEISDEPTH] = (char *) ezxml_attr(dep, "VALUE");
else
originInfo->values[DBSEISDEPTH] = empty;     
for(mag = ezxml_child(origin, eventXMLfn[XMLEVENTMAG]);
mag; 
mag = ezxml_next(mag))
{
magInfo = calloc(1, sizeof(MAGINFO));
magInfo->values[DBMAGMAG] = (char *) ezxml_attr(mag, "VALUE");
magInfo->values[DBMAGTYPE] = (char *) ezxml_attr(mag, "TYPE");
originInfo->mags = g_slist_prepend(originInfo->mags, magInfo);
}
xmlInfo.data.info = g_slist_prepend(xmlInfo.data.info, originInfo);
}
}
if (db_request(&sqldi) != PQLXSUCCESS)
fprintf(stdout, "\tImport FAILURE! Not all records have been imported. Please check .err file.\n");
else
{
char *newFile = g_strdup_printf("%s/history/%s.%s", currentDir, file, executionTime);
char *oldFile = g_strdup_printf("%s/%s", currentDir, file);
rename(oldFile, newFile);
free(newFile); free(oldFile);
fprintf(stdout, "\tImported %d records.\n", cnt);
}
for(iter = xmlInfo.data.info;iter;iter=g_slist_next(iter))
{
originInfo = iter->data;
free(originInfo->values[DBSEISTIME]);
free(originInfo->values[DBSEISMSEC]);
for(iter1 = originInfo->mags;
iter1;
iter1 = g_slist_next(iter1))
{
free(iter1->data);
}
g_slist_free(originInfo->mags);
free(originInfo);
}
g_slist_free(xmlInfo.data.info);
ezxml_free(eventInfoFile);
g_free(file);
{ 
SQLDI sqldiL;
memset(&sqldiL, 0, sizeof(SQLDI));
sqldiL.descr.tableData = SYSMETATBLOPTEVENT;
sqldiL.args.dataEvent = DBMAINTAIN;
db_request(&sqldiL);
}
}
#endif  
void process_xml_input(LOGIN *login, char *execTime)
{
gchar year[5], jday[4], hr[3], mn[3];
gchar *xmlInputDir;
char cwd[MAX_DIR_PATH+1];
getcwd(cwd, MAX_DIR_PATH+1);
xmlInputDir = getenv(ENVXML);
if (!xmlInputDir)
{
fprintf(stderr, "Environment variable PQLXXML not defined, XML import not possible.\n");
return;
}
if (chdir(xmlInputDir))
{
fprintf(stderr, "Unable to change to PQLXXML directory %s, Cannot import XML data.\n",
xmlInputDir);
return;
}
sscanf(execTime, "%s %s %2s:%2s", year, jday, hr, mn);
executionTime = g_strdup_printf("%s.%s.%s.%s", year, jday, hr, mn);
database = login->keys.dbname;
currentDir = g_strdup(xmlInputDir);
#if MINIMUM_PDB_VERSION >= XML_EVENT_VER
_xml_event(login->data.initialExecution);
#endif
#if MINIMUM_DB_VERSION >= XML_CHNMETA_VER
_xml_chnMETA(login->data.initialExecution, xmlInputDir);
#endif
free(currentDir);
free(executionTime);
chdir(cwd);
}
