#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "PSD.h"
#include "fft_prep.h"
#include "fftw3.h"
typedef struct _GAP
{
int first, last;
} GAP;
static void deMandS(double *data, int numSamps, int dataStart, PSD_DATA *analysis)
{
int i;
double flNumSamps;
double alpha, avg, slope;
int  firstSample, firstCalcSample, gapSamps, lastSample;
int  lessSamples, gapNum; 
gboolean hasGap;
GSList *gaps, *gapIter;
GAP  *gap;
switch(analysis->gaps.numGaps)
{
case 0:
firstCalcSample = 0;
hasGap = FALSE;
break;
default:
{
gaps = NULL;
firstCalcSample = 0;
hasGap = FALSE;
firstSample = trcInfo.dataLoc + dataStart;
lastSample = firstSample + numSamps;
if (lastSample <= analysis->gaps.gaps[0])
{ 
break;
}
for(gapNum=0;
gapNum < analysis->gaps.numGaps &&
firstSample >= analysis->gaps.gaps[GAPSTOPA];
gapNum++);
if (gapNum == analysis->gaps.numGaps)
{ 
break;
}
if (firstSample >= analysis->gaps.gaps[GAPSTARTA] &&
firstSample < analysis->gaps.gaps[GAPSTOPA])
{ 
firstCalcSample = analysis->gaps.gaps[GAPSTOPA] - firstSample;
gapNum++;
}
if (gapNum == analysis->gaps.numGaps ||
lastSample <= analysis->gaps.gaps[GAPSTARTA])
{ 
break;
}
hasGap = TRUE;
for(;
gapNum < analysis->gaps.numGaps &&
lastSample > analysis->gaps.gaps[GAPSTARTA];
gapNum++)
{
gap = calloc(1, sizeof(GAP));
gap->first = analysis->gaps.gaps[GAPSTARTA] - firstSample;
gap->last = analysis->gaps.gaps[GAPSTOPA] - firstSample;
gaps = g_slist_append(gaps, gap);
}
}
break;
}
avg = 0;
slope = 0;
switch(hasGap)
{
case FALSE:
for(i=0;i<numSamps;i++) 
{
avg += *(data+i);
slope += *(data+i) * (double) i;
}
flNumSamps = (double) numSamps;
break;
case TRUE:
gapIter = gaps;
gap = gapIter->data;
for(i=firstCalcSample, lessSamples = 0;
i<numSamps;
i++) 
{
if (gap &&
i==gap->first)
{ 
gapSamps = (gap->last - gap->first);
i += gapSamps;
if (i >= numSamps)
{ 
lessSamples += (numSamps - gap->first);
break;
}
lessSamples += gapSamps;
gapIter = g_slist_next(gapIter);
if (gapIter)
gap = gapIter->data;
else
gap = NULL;
}
avg += *(data+i);
slope += *(data+i) * (double) i;
}
flNumSamps = (double) (numSamps - lessSamples);
break;
}
avg /= flNumSamps;
slope = 12.0*slope/(flNumSamps*(flNumSamps*flNumSamps-1.0)) - 6.0*avg/(flNumSamps-1.0);
alpha = avg - 0.5*(flNumSamps+1.0)*slope;
for(i=firstCalcSample;i<numSamps;i++) 
{ 
*(data+i) -= (double) (i * slope + alpha);
}
switch(hasGap)
{ 
case TRUE:
for(gapIter = gaps;
gapIter;
gapIter = g_slist_next(gapIter))
{ 
gap = gapIter->data;
if (gap->last > numSamps) 
break;
gapSamps = (gap->last - gap->first);
memset(&data[gap->first], 0, gapSamps*sizeof(DType));
}
if (gapIter)
{ 
gapSamps = numSamps - gap->first;
memset(&data[gap->first], 0, gapSamps*sizeof(DType));
}
for(gapIter = gaps;
gapIter;
gapIter = g_slist_next(gapIter))
{
free(gapIter->data);
}
g_slist_free(gaps);
break;
}
}
#if 0
static void cosTaper(double *data, int numSamps)
{
int j, ffl;
double *data_e, *data_s, tap;
ffl = (int) ((double) (numSamps*(TAPER_PCT/100.)));
for (j = 0, data_e = data+numSamps-1, data_s = data; 
j < ffl; ++j, ++data_s, --data_e) 
{
tap = .5 - .5 * cos((3.1415926 * (double) (j) / (double) (ffl)));
*data_s *= tap;
*data_e *= tap;
}  
}
#endif
static void sinTaper(double *data, int numSamps)
{
int j, ffl;
double *data_e, *data_s;
double Pi, fivePi, x;
Pi = acos(-1.0);
fivePi = 5.0 * Pi;
ffl = (int) ((double) (numSamps*(TAPER_PCT/100.)));
x = (double) (fivePi/(double) numSamps);
for (j = 0, data_e = data+numSamps-1, data_s = data; 
j < ffl; ++j, ++data_s, --data_e) 
{
*data_s *= sin(j*x);
*data_e *= sin((numSamps-j)*x);
}  
}
typedef struct _FFTWWISDOM
{
int  segLength, segments;
char *wisdom;
} FFTWWISDOM;
static gint findPlan(FFTWWISDOM *plan, FFTWWISDOM *planKeys)
{
if (plan->segLength == planKeys->segLength &&
plan->segments == planKeys->segments)
return 0;
return 1;
}
int PSD_analyze(RDATA *realData, PSD_DATA *analysis)
{
static int PSDalloc;
static DType *rData;
DType  *dTypePtr, *dTypePtr2;
static int numSamps,dataAlloc,seg_length,segments,dataStart;
static FACT *pf = NULL;
static fftw_plan plan=NULL;
static FFTWWISDOM *planData=NULL;
FFTWWISDOM planKeys;
static GSList *FFTWplans=NULL;
GSList  *planIter;
int  trial_seg_length;
int  i, seg, realPos;
DType *power, *period;
DType delta, amp, sum_amp=0, scale;
if (realData->totPts==0) 
return(NOT_ENOUGH_DATA);   
numSamps = realData->totAnalysisPts = 0.5 + 
analysis->conf->psd_dur / analysis->secsPsamp;
trial_seg_length = numSamps / analysis->conf->sections;
seg_length = prepFFT(trial_seg_length, &pf);
if (seg_length < 0) 
{
return(FFT_ERROR);
}
dataStart = trial_seg_length / analysis->conf->steps;
segments = 1 + analysis->conf->steps * 
(analysis->conf->sections - 1);
analysis->secData.cnt = seg_length/2 + 1;
#ifdef DEBUG
fprintf(stderr, "PSD is %d seconds, %d data points\n",
analysis->conf->psd_dur, numSamps);
fprintf(stderr, "%d segments of %d points, skip %d points\n",
segments, seg_length, dataStart);
#endif
if (!(analysis->secData.power)) 
{ 
PSDalloc = (int) analysis->secData.cnt*sizeof(DType) * 1.1;
if ((analysis->secData.power = myMalloc(PSDalloc)) == NULL) 
{
return(NO_MEMORY);
}
if ((analysis->secData.period = myMalloc(PSDalloc)) == NULL) 
{
return(NO_MEMORY);
}
} else 
{ 
if (analysis->secData.cnt*(signed)sizeof(DType) > PSDalloc) 
{
PSDalloc = analysis->secData.cnt*(signed)sizeof(DType) + 
(int)(.1*(analysis->secData.cnt)*(signed)sizeof(DType));
if ((analysis->secData.power = myRealloc(analysis->secData.power, PSDalloc)) == NULL) 
{
return(NO_MEMORY);
}
if ((analysis->secData.period = myRealloc(analysis->secData.period, PSDalloc)) 
== NULL) 
{
return(NO_MEMORY);
}
}
}
power = analysis->secData.power;
period = analysis->secData.period;
memset(power, 0, analysis->secData.cnt*sizeof(DType));
memset(period, 0, analysis->secData.cnt*sizeof(DType));
if (!rData) 
{
dataAlloc = (seg_length + 2) * sizeof(DType) * segments;
if ((rData = myMalloc(dataAlloc)) == NULL) 
{
return(NO_MEMORY);
}
} else 
{ 
if ((seg_length+2)*sizeof(DType) * segments > dataAlloc) 
{
dataAlloc = (seg_length + 2) * sizeof(DType) * segments;
if ((rData = myRealloc(rData, dataAlloc)) == NULL) 
{
return(NO_MEMORY);
}
}
}
if (!planData ||
(planData->segLength != seg_length ||
planData->segments != segments))
{
if (plan)
{ 
free(planData->wisdom);
planData->wisdom = fftw_export_wisdom_to_string();
fftw_destroy_plan(plan);
}
planKeys.segLength = seg_length;
planKeys.segments = segments;
planIter = g_slist_find_custom(FFTWplans, &planKeys, (GCompareFunc) findPlan);
if (planIter)
{ 
planData = planIter->data;
fftw_import_wisdom_from_string(planData->wisdom);
}
plan = fftw_plan_many_dft_r2c(1, &seg_length, segments,
rData, NULL, 1, seg_length + 2,
(fftw_complex*)rData, NULL, 1, (seg_length + 2)/2,
FFTW_MEASURE);
if (!planIter)
{ 
planData = calloc(1, sizeof(FFTWWISDOM));
planData->segLength = seg_length;
planData->segments = segments;
planData->wisdom = fftw_export_wisdom_to_string();
FFTWplans = g_slist_prepend(FFTWplans, planData);
}
}
for(seg=0;seg<segments;seg++) 
{ 
dTypePtr = rData + seg * (seg_length+2);
dTypePtr2 = realData->rData + (seg*dataStart);
memcpy(dTypePtr, dTypePtr2, sizeof(DType)*seg_length);
deMandS(dTypePtr, seg_length, seg*dataStart, analysis);   
sinTaper(dTypePtr, seg_length);   
}
#ifdef DEBUG
sprintf(fname, "in.%03d", fno);
dbg = fopen(fname, "w"); 
for(i=0;i < seg_length; i++) {
fprintf(dbg, "%4d %10.4e\n", i, realData->rData[i]);
}
fclose(dbg);
#endif
delta = analysis->secsPsamp;
fftw_execute(plan);
#define REALPOS (rData+(2*i+seg*(seg_length+2)))
#define IMAGPOS (rData+(2*i+1+seg*(seg_length+2)))
for(i=0; i<analysis->secData.cnt-1; i++) 
{
sum_amp = 0.0;
for (seg = 0; seg < segments; seg++) 
{
sum_amp += (*(REALPOS) * *(REALPOS) +
*(IMAGPOS) * *(IMAGPOS));
}
*(power+i) = sum_amp;
}
for (seg = 0; seg < segments; seg++) 
{
sum_amp = 0.0;
realPos = 2*(analysis->secData.cnt-1) + seg * seg_length;
amp = *(rData+realPos) * *(rData+realPos);
sum_amp += amp;
}
*(power+analysis->secData.cnt-1) = sum_amp;
scale = 2.0 * delta * (DType) 1.1428571 / (segments * seg_length);
power[0] = 0.0;
period[0] = 10000;   
for (i=1,power++,period++;i<analysis->secData.cnt;i++, power++, period++) 
{
*(power) *= scale;
*(period) = ((DType)(seg_length*analysis->secsPsamp)/(DType)(i)); 
}
#ifdef DEBUG
sprintf(fname, "fft.%03d", fno++);
dbg = fopen(fname, "w"); 
for(i=0;i<analysis->secData.cnt;i++) {
fprintf(dbg, "%10.4e %10.4e\n", analysis->secData.period[i],
analysis->secData.power[i]);
}
fclose(dbg);
#endif
return(PQLXSUCCESS);
}
