#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "PSD.h"
enum {
PSD_TOTAL,
PSD_FULL,
PSD_PARTIAL
};
#define PSDPARTIAL(overlap) (((100/(100-overlap))-1))
#define PSDTOTAL(totSamp, incr) ((totSamp)/(incr))
#define PSDFULL(totSamp, overlap, incr) (PSDTOTAL(totSamp, incr) - PSDPARTIAL(overlap))
int readTrace(traceInfo *);
void *myMalloc(int size)
{
void *ptr;
if ((ptr = calloc(size, 1))==NULL) 
{
return(NULL);
}
return(ptr);
}
void *myRealloc(void *ptr, int size)
{
if ((ptr = realloc(ptr, size))==NULL) 
{
return(NULL);
}
return(ptr);
}
void myFree(void *ptr)
{
if (ptr)
free(ptr);
}
static int getStart(int tStart, int psdDur, int trcLen)
{ 
int bdry, start1, start2, startTime;
if (!psdDur)     
return (FILESTARTTIME);  
bdry = tStart/psdDur;
start1 = bdry * psdDur;   
start2 = (bdry+1) * psdDur;  
if (abs(start1 - tStart) < abs(start2 - tStart))
{ 
startTime = FILESTARTTIME;  
}
else
{
startTime = start2;
}
if (trcLen < psdDur &&
startTime == FILESTARTTIME)
{
if (tStart - start1 > STARTTIMETOL)
startTime = PSD_DONOTPROC;
}
return startTime;
}
int readTracePSD2(PSD_DATA *analysis, PSD1 *psd)
{
traceInfo trace1, trace2;
int   fileType = psd->keys.fileType, overlap = analysis->conf->overlap, ttlSamplesT1;
int   ret=PQLXSUCCESS, startMinT, startMin, numSamples, ttlPSDt1;
float  overlapSecs;
double  ONESAMPLE;   
double  endSecs, begSecs;
void  *dataPtr;
memset(&trace1, 0, sizeof(traceInfo));
memset(&trace2, 0, sizeof(traceInfo));
memset(&trcInfo, 0, sizeof(TRCDATAINFO));
trace1.data.fileName = g_strdup(psd->keys.filename[0]);
trace1.data.fileType = fileType;
ret = readTrace(&trace1); 
if (ret != PQLXSUCCESS)
{ 
goto GETOUT;    
}
trace2.data.fileName = g_strdup(psd->keys.filename[1]);
trace2.data.fileType = fileType;
ret = readTrace(&trace2); 
if (ret != PQLXSUCCESS)
{ 
goto GETOUT;    
}
ONESAMPLE = trace1.data.head.sampInt;
numSamples = trace1.data.dataInfo.head.numSamples;
endSecs = trace1.data.head.epochs + ((double)((numSamples-1) * ONESAMPLE)/1000000.);
begSecs = trace2.data.head.epochs;
if (abs((abs)((int)((begSecs-endSecs)*1000000))-ONESAMPLE) > ONESAMPLE*2)
{
fprintf(stderr, "Files Discontinuous by %g seconds "
"(tolerance = %.3g seconds)\n\t('%s', '%s')\n", 
begSecs-endSecs, (ONESAMPLE*2.)/1000000., 
trace1.data.fileName, trace2.data.fileName);
ret = FILES_DISCONTINUOUS;
goto GETOUT;
}
analysis->secsPsamp = ONESAMPLE/1000000.;
analysis->numSamples = 0.5 + (analysis->conf->psd_dur/2) / analysis->secsPsamp;
analysis->sampsPsec = 1000000./ONESAMPLE;
startMinT = trace1.data.head.hour*60 + trace1.data.head.minute;  
startMin = getStart(startMinT, analysis->conf->psd_dur/2/60, 
(trace1.data.head.length + .5)/60);   
switch(startMin)
{
case PSD_DONOTPROC:
ret = PSD_DONOTPROC;
goto GETOUT;
break;
case FILESTARTTIME:    
trcInfo.dataLoc = 0;  
break;
default:
trcInfo.dataLoc = (startMin - startMinT)*60*analysis->sampsPsec;
break;
}
trcInfo.length = trace1.data.head.length + trace2.data.head.length;
trcInfo.numSamples = trace1.data.dataInfo.head.numSamples + trace2.data.dataInfo.head.numSamples;
trcInfo.sampInt = trace1.data.head.sampInt;
trcInfo.epochS = trace1.data.head.epochs;
trcInfo.dataFormat = trace1.data.head.data_form;
dataPtr = trace1.data.dataInfo.data;
trace1.data.dataInfo.data = NULL;   
if (trace1.trace.numGaps + trace2.trace.numGaps)
{ 
int gapNum;
analysis->gaps.numGaps = trace1.trace.numGaps + trace2.trace.numGaps;
analysis->gaps.gaps = calloc(TTLGAPS(analysis->gaps.numGaps), sizeof(int));
if (trace1.trace.numGaps)
memcpy(analysis->gaps.gaps, trace1.trace.gaps, TTLGAPS(trace1.trace.numGaps) * sizeof(int));
if (trace2.trace.numGaps)
memcpy(&analysis->gaps.gaps[TTLGAPS(trace1.trace.numGaps)], 
trace2.trace.gaps, TTLGAPS(trace2.trace.numGaps) * sizeof(int));
for(gapNum = TTLGAPS(trace1.trace.numGaps);
gapNum < TTLGAPS(analysis->gaps.numGaps);
gapNum += 2)
{ 
analysis->gaps.gaps[gapNum] += trace1.data.dataInfo.head.numSamples;
analysis->gaps.gaps[gapNum+1] += trace1.data.dataInfo.head.numSamples;
}
}
trcInfo.dataB = realloc(dataPtr, trcInfo.numSamples * dsizes[trcInfo.dataFormat]);
if (!trcInfo.dataB)
{
fprintf(stderr, "Unable to reallocate %d bytes of memory\n",
trcInfo.numSamples * dsizes[trcInfo.dataFormat]);
ret = NO_MEMORY;
goto GETOUT;
}
memcpy(&trcInfo.dataB[trace1.data.dataInfo.head.numSamples * dsizes[trcInfo.dataFormat]],
trace2.data.dataInfo.data, trace2.data.dataInfo.head.numSamples * dsizes[trcInfo.dataFormat]);
overlapSecs = ((float) (100 - analysis->conf->overlap)/100.) * analysis->conf->psd_dur;
trcInfo.overlapIncr = overlapSecs * analysis->sampsPsec;
ttlSamplesT1 = trace1.data.dataInfo.head.numSamples - trcInfo.dataLoc;
ttlPSDt1 = PSDFULL(ttlSamplesT1, overlap, trcInfo.overlapIncr);
ttlSamplesT1 += trcInfo.overlapIncr/4;  
trcInfo.ttlPSD = PSDPARTIAL(overlap) + 
(PSDFULL(ttlSamplesT1, overlap, trcInfo.overlapIncr) - ttlPSDt1);
trcInfo.dataLoc += (ttlPSDt1 * trcInfo.overlapIncr);
GETOUT:
freeMyData(TRCINFO, &trace1);
freeMyData(TRCINFO, &trace2);
return(ret);
}
int readTracePSD1(PSD_DATA *analysis, PSD1 *psd)
{
char   *fileName = psd->keys.filename[0];
int   fileType = psd->keys.fileType;
int   ret=PQLXSUCCESS, startMinT, startMin;
float  overlapSecs;
traceInfo trace;
memset(&trace, 0, sizeof(traceInfo));
memset(&trcInfo, 0, sizeof(TRCDATAINFO));
trace.data.fileName = g_strdup(fileName);
trace.data.fileType = fileType;
ret = readTrace(&trace); 
if (ret != PQLXSUCCESS)
{ 
return(ret);
}
trcInfo.length = trace.data.head.length;
trcInfo.numSamples = trace.data.dataInfo.head.numSamples;
trcInfo.sampInt = trace.data.head.sampInt;
trcInfo.epochS = trace.data.head.epochs;
trcInfo.dataFormat = trace.data.head.data_form;
trcInfo.dataB = trace.data.dataInfo.data;
trace.data.dataInfo.data = NULL;   
if (trace.trace.numGaps)
{ 
analysis->gaps.numGaps = trace.trace.numGaps;
analysis->gaps.gaps = calloc(trace.trace.numGaps*2, sizeof(int));
memcpy(analysis->gaps.gaps, trace.trace.gaps, trace.trace.numGaps * 2 * sizeof(int));
}
analysis->secsPsamp = trace.data.head.sampInt/1000000.;
analysis->numSamples = 0.5 + (analysis->conf->psd_dur/2) / analysis->secsPsamp;
analysis->sampsPsec = 1000000./trace.data.head.sampInt;
startMinT = trace.data.head.hour*60+trace.data.head.minute;  
startMin = getStart(startMinT, analysis->conf->psd_dur/2/60, 
(trace.data.head.length + .5)/60);  
freeMyData(TRCINFO, &trace);
switch(startMin)
{
case PSD_DONOTPROC:
return PSD_DONOTPROC;
break;
case FILESTARTTIME:    
trcInfo.dataLoc = 0;  
break;
default:
trcInfo.dataLoc = (startMin - startMinT)*60*analysis->sampsPsec;
break;
}
overlapSecs = ((float) (100 - analysis->conf->overlap)/100.) * analysis->conf->psd_dur;
trcInfo.overlapIncr = overlapSecs * analysis->sampsPsec;
trcInfo.ttlPSD = PSDFULL((trcInfo.numSamples - trcInfo.dataLoc), 
analysis->conf->overlap, trcInfo.overlapIncr);
psd->keys.overlapPSD = TRUE;
return ret;
}
static gboolean hasGapsMS(PSD_DATA *analysis)
{
int totSamp = analysis->numSamples * 2;
int firstSample = trcInfo.dataLoc;
int lastSample = firstSample + totSamp;
int gapNum;
if (analysis->gaps.numGaps == 0)
return FALSE;
if (lastSample <= analysis->gaps.gaps[0])
{ 
return FALSE;
}
for(gapNum=0;
gapNum < analysis->gaps.numGaps &&
firstSample >= analysis->gaps.gaps[GAPSTOPA];
gapNum++);
if (gapNum == analysis->gaps.numGaps)
{ 
return FALSE;
}
if (firstSample >= analysis->gaps.gaps[GAPSTARTA] &&
firstSample < analysis->gaps.gaps[GAPSTOPA])
{ 
return TRUE;
}
if (firstSample <= analysis->gaps.gaps[GAPSTARTA] &&
lastSample > analysis->gaps.gaps[GAPSTOPA])
{
return TRUE;
}
if (lastSample >= analysis->gaps.gaps[GAPSTARTA] &&
lastSample < analysis->gaps.gaps[GAPSTOPA])
{
return TRUE;
}
return FALSE;
}
static int hasGaps(PSDSTRUCTS *psdStructs)
{
PSD1   *psd = psdStructs->psd;
PSD_DATA *analysis = psdStructs->analysis;
RDATA  *realData = psdStructs->realData;
DType  *rdataDest = realData->rData;
int   totSamp = analysis->numSamples * 2;
int   gapStatus = DATA_NOGAP, i;
switch (psd->keys.fileType)
{
case MSEED_DATA:
if (hasGapsMS(analysis))
gapStatus = DATA_HASGAP;
break;
case SAC_DATA: 
for(i=0;i<totSamp;i++)
{
if (*(rdataDest+i) == -12345.)
{
gapStatus = DATA_HASGAP;
break;
}
}
break;
default: 
for(i=0;i<totSamp;i++)
{
if (*(rdataDest+i) != 0)
break;
}
if (i == totSamp)
gapStatus = DATA_HASGAP;
break;
}
return (gapStatus);
}
static int extractData(PSDSTRUCTS *psdStructs)
{
PSD_DATA *analysis = psdStructs->analysis;
RDATA  *realData = psdStructs->realData;
int   i, ret=PQLXSUCCESS, *npts;
int   totSamp, dataLoc;
int   *numAlloc;
DType  **rdata, *rdataDest;
double   begEpochs;
struct ptime begTime;
gint32   *ptr;
short   *sptr;
float   *lptr;
double   *dptr;
if (trcInfo.ttlPSD == 0)
return(PSD_NOMOREDATA); 
trcInfo.ttlPSD--;
rdata = &realData->rData;
npts = &realData->totPts;
numAlloc = &realData->numAlloc;
trcInfo.dataLoc += ((*rdata) ? trcInfo.overlapIncr : 0);
*npts = totSamp = analysis->numSamples * 2;
if (!(*rdata)) 
{
*numAlloc = totSamp * sizeof(DType);
if ((*rdata = malloc(*numAlloc))==NULL)
{
fprintf(stderr, "Unable to allocate memory (%d bytes), quitting\n", *numAlloc);
exit(-1);
}
}
if (trcInfo.dataLoc + totSamp > trcInfo.numSamples)
{ 
return(NOT_ENOUGH_DATA);
}
memset(*rdata, 0, *numAlloc);
dataLoc = trcInfo.dataLoc;
ptr= (gint32 *) &trcInfo.dataB[dataLoc*dsizes[trcInfo.dataFormat]];
sptr= (short *) &trcInfo.dataB[dataLoc*dsizes[trcInfo.dataFormat]];
lptr= (float *) &trcInfo.dataB[dataLoc*dsizes[trcInfo.dataFormat]];
dptr= (double *) &trcInfo.dataB[dataLoc*dsizes[trcInfo.dataFormat]];
rdataDest = *rdata;
for(i=0;i<totSamp;i++)
DATAP(trcInfo.dataFormat, i, *(rdataDest+i));
begEpochs = trcInfo.epochS + (double) ((double) trcInfo.dataLoc/ (double) analysis->sampsPsec);
passcal_etoh(&begTime, begEpochs);
realData->curYear = begTime.yr;
realData->curJDay = get_julday(begTime.mo, begTime.day, begTime.yr);
realData->curHour = begTime.hr;
realData->curMin = begTime.mn;
realData->curSec = begTime.sec;
analysis->year = realData->curYear;
analysis->jday = realData->curJDay;
return ret;
}
int getRealData(PSDSTRUCTS *psdStructs)
{
gboolean noGap = psdStructs->noGap; 
int   retVal, gapStatus;
retVal = extractData(psdStructs);
if (!noGap || 
retVal != PQLXSUCCESS)
return (retVal);
gapStatus = hasGaps(psdStructs);
while (retVal == PQLXSUCCESS && 
gapStatus == DATA_HASGAP) 
{
retVal = extractData(psdStructs);
if (retVal != PQLXSUCCESS)
continue;
gapStatus = hasGaps(psdStructs);
} 
return (retVal);
}
void cleanUP(PSDSTRUCTS *psdStructs)
{
PSD_DATA *analysis = psdStructs->analysis;
RDATA  *realData = psdStructs->realData;
if (trcInfo.dataB)
{
free(trcInfo.dataB);
trcInfo.dataB = NULL;
}
free_PSDDATA(analysis);
if (realData->rData) myFree(realData->rData);
realData->rData = NULL;
}
