#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "PSD.h"
#include "db_iface.h"
static GSList *PSDData;
void free_PSDDATA(PSD_DATA *analysis)
{
myFree(analysis->hzData.period);
myFree(analysis->hzData.power);
myFree(analysis->secData.period);
myFree(analysis->secData.power);
myFree(analysis->hourBinHit);
myFree(analysis->gaps.gaps);
analysis->hzData.period = NULL;
analysis->hzData.power = NULL;
analysis->secData.period = NULL;
analysis->secData.power = NULL;
analysis->hourBinHit = NULL;
}
void storePDFResults(PSD_DATA *analysis, PSD1 *psd)
{
int period, power, j, numperiods, *binhit;
int maxpwrs = analysis->conf->max_power - analysis->conf->min_power + 1;
DType *periods;
PSD1 *savePSD;
savePSD = malloc(sizeof(PSD1));
memcpy(savePSD, psd, sizeof(PSD1));
periods = analysis->hzData.period;
binhit = analysis->hourBinHit;
numperiods = analysis->hzData.cnt;
savePSD->data.period = myMalloc(numperiods * sizeof(float));
savePSD->data.power = myMalloc(numperiods * sizeof(int));
savePSD->data.nPeriods = numperiods;
for (period=0; period<numperiods; period++) 
{
for(j = analysis->conf->min_power, power=0; 
j <= analysis->conf->max_power; 
j++, power++)
{
if (!*(binhit+period*maxpwrs+power))
continue;   
savePSD->data.period[period] = (float) periods[period];
savePSD->data.power[period] = j;
}
}
PSDData = g_slist_prepend(PSDData, savePSD);
}
void DbPDFResults(int type)
{
SQLDI sqldi;
if (!PSDData)
return;
PSDData = g_slist_reverse(PSDData);
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.descr.tableData = PSDTBL;
sqldi.args.dataEvent = INSERT_DATA;
sqldi.data = (void *) PSDData;
sqldi.data2 = GINT_TO_POINTER(type);
db_request(&sqldi);
#if 0
freed in db_put.c
for(iter = PSDData;
iter;
iter = g_slist_next(iter))
{
psd = iter->data;
myFree(psd->data.period);
myFree(psd->data.power);
free(psd);
}
#endif
g_slist_free(PSDData);
PSDData = NULL;
return;
}
