#include <stdlib.h>
#include <stdio.h>
#include "fft_prep.h"
static long last_nfft = 1;
static FACT *fft_list = (FACT *)NULL;
static int prime[3] = {2, 3, 5};
static int Debug = 0;
void fftPrepDebug( int level )
{
Debug = level;
return;
}
long buildFacList( long new_nfft )
{
long i, j, next_nfft;
FACT *this, *next, *ins_before;
if (last_nfft == 1)
{
if ( (fft_list = (FACT *)calloc(1, sizeof(FACT))) == (FACT *)NULL)
return -1;
this = fft_list;
this->nfft = prime[0];
this->fact_power[0] = 1;
next = this;
for (i = 1; i < N_RADIX; i++)
{
if ( (next->next = (FACT *)calloc(1, sizeof(FACT))) == (FACT *)NULL)
return -1;
next = next->next;
next->nfft = last_nfft * prime[i];
next->fact_power[i]++;
}
} 
else
{
this = fft_list;
while (this->nfft < last_nfft )
{
if (this->next == (FACT *) NULL)
{
fprintf(stderr, "buildFacList: Walked off end of list this %ld last %ld\n",
this->nfft, last_nfft);
if (Debug > 0)
printFacList();
return -2;
}
this = this->next;
}
if (this->nfft != last_nfft)
{
fprintf(stderr, "buildFacList: last %ld does not match this %ld\n", 
last_nfft, this->nfft);
if (Debug > 0)
printFacList();
return -2;
}
}
last_nfft = this->nfft;
while (this->nfft <= new_nfft)
{
ins_before = this;
for (i = 0; i < N_RADIX; i++)
{
next_nfft = last_nfft * prime[i];
while( ins_before->next != (FACT *)NULL && 
ins_before->next->nfft < next_nfft)
ins_before = ins_before->next;
if (ins_before->next != (FACT *)NULL && 
ins_before->next->nfft == next_nfft)
{ 
continue;
}
if ( ( next = (FACT *)calloc(1, sizeof(FACT))) == (FACT *)NULL)
return -1;
next->nfft = next_nfft;
for (j = 0; j < N_RADIX; j++)
next->fact_power[j] = this->fact_power[j];
next->fact_power[i]++;
next->next = ins_before->next;
ins_before->next = next;
}
this = this->next;
last_nfft = this->nfft;
}
return 0;
}
long prepFFT( long n, FACT **pf )
{
FACT *this;
int rc;
FACT *evenFact = NULL;
if ( n > last_nfft)
{
if ( (rc = buildFacList( n )) < 0 ) 
return rc;
}
this = fft_list;
while( this->nfft <= n && this->next != (FACT *)NULL ) {
if (this->nfft % 2 == 0) evenFact = this;
this = this->next;
}
if (evenFact == NULL) {
fprintf(stderr, "prepFFT ERROR: nfft not found for %ld\n", n);
return -2;
}
*pf = evenFact;
return evenFact->nfft;
}
void printFacList( )
{
FACT *this;
this = fft_list;
while( this != (FACT *)NULL)
{
fprintf(stderr, "%6ld %2ld %2ld %2ld\n", this->nfft, this->fact_power[0], 
this->fact_power[1], this->fact_power[2]);
this = this->next;
}
return;
}
void trimFacList( long n )
{
FACT *this;
if (n >= last_nfft)
return;
this = fft_list;
while(this->nfft < n)
{
fft_list = this->next;
free( this );
this = fft_list;
}
return;
}
