#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "PSD.h"
TRCDATAINFO trcInfo;
int an_psd(int type, PSD1 *psd)
{
PSDSTRUCTS psdStructs;
PSD_DATA analysis; 
RDATA  realData; 
int   dataRet, retVal;
int   endT;
gboolean first=TRUE;
memset(&analysis, 0, sizeof(PSD_DATA));
memset(&realData, 0, sizeof(RDATA));
psdStructs.psd = psd;
psdStructs.analysis = &analysis;
psdStructs.realData = &realData;
strcpy(analysis.StnInfo.network, psd->keys.ntw);
strcpy(analysis.StnInfo.station, psd->keys.stn);
strcpy(analysis.StnInfo.location, psd->keys.loc);
strcpy(analysis.StnInfo.channel, psd->keys.chn);
analysis.StnInfo.respFile = psd->keys.resp.data.fileName;
analysis.conf = &psd->keys.conf;
psdStructs.noGap = (analysis.conf->type == STMO_TRIG) ? TRUE : FALSE;
switch (type)
{
case PSD1evt:
retVal = readTracePSD1(&analysis, psd);
break;
case PSD2evt:
retVal = readTracePSD2(&analysis, psd);
break;
}
if (retVal != PQLXSUCCESS)
goto GETOUT;
switch((dataRet = getRealData(&psdStructs)))
{
case NOT_ENOUGH_DATA: 
case PSD_NOMOREDATA: 
retVal = PQLXSUCCESS;
goto GETOUT;
break;
case PQLXSUCCESS:
break;
}
do 
{ 
retVal = PSD_analyze(&realData, &analysis); 
CHKERR(retVal)
retVal = remResp(&analysis, first);
CHKERR(retVal)
first = FALSE;
retVal = PSD_smooth(&analysis);   
CHKERR(retVal)
retVal = PSD_bin(&analysis); 
CHKERR(retVal)
psd->data.sTime.date.yr = realData.curYear;
psd->data.sTime.date.jday = realData.curJDay;
psd->data.sTime.date.hr = realData.curHour;
psd->data.sTime.date.mn = realData.curMin;
psd->data.sTime.date.sec = realData.curSec;
endT = realData.curHour * 60 * 60 + realData.curMin * 60 + realData.curSec + analysis.conf->psd_dur;
psd->data.eTime.date.hr = endT/(60*60);
psd->data.eTime.date.mn = (endT - psd->data.eTime.date.hr*60*60)/60;
psd->data.eTime.date.sec = (realData.curSec + analysis.conf->psd_dur)%60;
storePDFResults(&analysis, psd);
retVal = getRealData(&psdStructs);
switch (retVal)
{ 
case NOT_ENOUGH_DATA: 
case PSD_NOMOREDATA: 
retVal = PQLXSUCCESS;
goto GETOUT;
break;
}
} while (TRUE);
GETOUT:
cleanUP(&psdStructs);
DbPDFResults(type);
return retVal;
}
