#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "PSD.h"
int remResp(PSD_DATA *analysis, gboolean reRead)
{
int i, startStage, stopStage, stdioF, nfreqs;
char *verbose = NULL, datetime[18], rtype[3];
static char *resploc=NULL;
DType *power, *period;
double *freqs=NULL, amp;
static struct response *resp=NULL;
if (reRead)
{
if (resploc) free(resploc);
if (!strcmp(analysis->StnInfo.location, "--")) 
resploc = g_strdup("*");
else 
resploc = g_strdup(analysis->StnInfo.location);
sprintf(datetime, "%d,%03d,00:00:00", analysis->year, analysis->jday); 
startStage = -1;      
stopStage = 0;       
if (analysis->conf->last_stage > 0) 
{
startStage = 1;
stopStage = analysis->conf->last_stage;
}
stdioF = 0;            
nfreqs = analysis->secData.cnt;       
strcpy(rtype, "cs");         
if ((freqs = malloc(nfreqs * sizeof(double)))==NULL) 
{
return(NO_MEMORY);
}
period = analysis->secData.period;
for (i=0; i<nfreqs;i++) 
{
freqs[i] = 1./(*(period+i));
}
if (resp) free_response(resp);  
resp = evresp(analysis->StnInfo.station, analysis->StnInfo.channel, analysis->StnInfo.network, 
resploc, datetime, analysis->conf->units, analysis->StnInfo.respFile, 
freqs, nfreqs, rtype, verbose, startStage, stopStage, stdioF, 0);
myFree(freqs);
if (resp==NULL) 
{
return(EVALRESP_FAILURE);
}
}
power = analysis->secData.power;
for (i=0; i<analysis->secData.cnt;i++, power++) 
{
amp = (resp->rvec[i].real * resp->rvec[i].real) + 
(resp->rvec[i].imag * resp->rvec[i].imag);
*power = *power/amp;
}
return(PQLXSUCCESS);
}
