#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "PSD.h"
int PSD_smooth(PSD_DATA *analysis)
{
int j, periodStart, perAlloc, numperiods;
int periodNum, bandCnt;
DType center_period, bandSum, bandAve, hiCorner, loCorner, nextHi;
DType *period, *power, *periodHz, *powerdB;
DType binHalfWidth;
binHalfWidth = pow(2.0, analysis->conf->bin_width / 2.0);
if (!analysis->hzData.cnt) 
{ 
for (numperiods=0,
hiCorner = (2*analysis->secsPsamp)/binHalfWidth; 
hiCorner < analysis->conf->max_period / binHalfWidth;
hiCorner*=pow(2.0, BIN_STEP), numperiods++) 
{;} 
analysis->hzData.cnt = numperiods;
} 
else 
{
numperiods = analysis->hzData.cnt;
}
perAlloc=numperiods*sizeof(DType);
if (!(analysis->hzData.period)) 
{ 
if ((analysis->hzData.period = malloc(perAlloc)) == NULL) 
{
return(NO_MEMORY);
}
if ((analysis->hzData.power = malloc(perAlloc)) == NULL) 
{
return(NO_MEMORY);
}
}
period = analysis->secData.period;
power = analysis->secData.power;
periodHz = analysis->hzData.period;
powerdB = analysis->hzData.power;
memset(periodHz, 0, perAlloc);  
memset(powerdB, 0, perAlloc);
periodStart = analysis->secData.cnt-1;
for (hiCorner = (2.0 * analysis->secsPsamp) / binHalfWidth, periodNum = 0;
periodNum < numperiods;
periodNum++, hiCorner *= (DType) pow(2.0,BIN_STEP)) 
{
center_period = hiCorner * binHalfWidth;
loCorner = center_period * binHalfWidth;
nextHi = hiCorner * (DType) pow(2.0,BIN_STEP);
for(j=periodStart, bandSum=0, bandCnt=0; j>=0 && period[j] <= loCorner; j--) 
{ 
if (period[j] < hiCorner) 
continue;
bandSum += power[j];  
bandCnt++;
if (period[j] >= nextHi && period[j+1] < nextHi)
periodStart = j;
}
bandAve = bandSum/bandCnt;
*(periodHz+periodNum) = center_period;
*(powerdB+periodNum) = (DType) (10.0 * log10(bandAve));
} 
if (analysis->hzData.cnt != periodNum) 
{
return(PERIOD_MISMATCH);
}
return(PQLXSUCCESS);
}
