#ifndef __PDF_include
#define __PDF_include
#include <stdio.h>
#include "pqlx_defs.h"
#include "libmseed.h"
#include "evresp.h"
#include "pql_defines.h"
#include "db_iface.h"
#include "util_externs.h"
#define EVALRESPVER "3.2.34"
#define FILESTARTTIME -1
#define PSD_DONOTPROC -2
#define PSD_NOMOREDATA -3
#define DATA_HASGAP  -4
#define DATA_NOGAP  PQLXSUCCESS
#define STARTTIMETOL 10
#define TAPER_PCT 10.
#define TTLGAPS(a) (a*2)
#define GAPNUM1
#define GAPSTARTA (gapNum*2)
#define GAPSTOPA (gapNum*2+1)
#define BIN_STEP 0.125
#define DType double
typedef struct _SEIS_DATA
{
DType *period, *power;
int  cnt;
} SEIS_DATA;
typedef struct _STN_DATA
{
char network[255], station[255], location[255], channel[255];
char *respFile;
} STN_DATA;
typedef struct _GAP_INFO
{
int numGaps;
int *gaps;
} GAP_INFO;
typedef struct _PSD_DATA
{
SEIS_DATA secData;
SEIS_DATA hzData;
int   *hourBinHit;
float  secsPsamp, sampsPsec;
int   numSamples;    
PSDCONF  *conf;
int   year, jday;
STN_DATA StnInfo;
GAP_INFO gaps;     
} PSD_DATA;
typedef struct _RDATA
{
DType *rData;
int totPts, totAnalysisPts, numAlloc;
int curYear, curJDay, curHour, curMin, curSec;
} RDATA;
typedef struct _TRCDATAINFO {
int  numSamples;
double length;
int  dataFormat;
double sampInt;
double epochS;
char *dataB;
int  dataLoc;
int  ttlPSD;    
int  overlapIncr;  
} TRCDATAINFO;
typedef struct _PSDSTRUCTS
{
PSD1  *psd;  
PSD_DATA *analysis; 
RDATA  *realData; 
gboolean noGap;  
} PSDSTRUCTS;
#define CHKERR(x) {if(x!=PQLXSUCCESS)break;}     
#define SLASH(x) {if(x[strlen(x)-1]!='/') strcat(x, "/");} 
#include "PSDglobals.h" 
#endif
