#include <stdlib.h>
#include <stdio.h> 
#include <dirent.h> 
#include <sys/stat.h> 
#include <string.h> 
#include <mysql.h>
#include <unistd.h>
#ifdef MAC
#include <float.h>
#define MAXFLOAT FLT_MAX
#define MINFLOAT FLT_MIN
#else
#include <values.h>
#endif
#include "pqlx_defs.h"
#include "pql_defines.h"
int readTrace(traceInfo *);
void passcal_etoh(struct ptime *, double);
extern char *dataTypes[];
int an_trc(TRC1 *trc1)
{
int   i, gapNum, lessSamples, gapSamps, ret, numSamples;
char  filename[2048], *logMsg=NULL;
traceInfo trace;
double  dataVal;
short  *sptr, format;
gint32  *ptr;
float  *lptr;
double  *dptr;
sprintf(filename, "%s/%s", trc1->keys.directory, trc1->keys.filename);
memset(&trace, 0, sizeof(traceInfo));
trace.data.fileName = g_strdup(filename);
trace.data.fileType = trc1->keys.fileType;
ret = readTrace(&trace);
numSamples = trace.data.dataInfo.head.numSamples;
switch(ret) 
{
case PQLXSUCCESS:  
break;     
case FILE_TOO_LARGE:
case FILE_DNE:
case NOT_ENOUGH_DATA:
if (ret == NOT_ENOUGH_DATA)
{
logMsg = g_strdup_printf("%s:\tFile contains no data points and will be deleted from database.", filename);
fprintf(stderr, "%s\n", logMsg);
}
if (ret == FILE_TOO_LARGE)
{
logMsg = g_strdup_printf("%s:\tFile is too large to process and will be deleted from database.", filename);
fprintf(stderr, "%s\n", logMsg);
}
if (ret == FILE_DNE)
{
logMsg = g_strdup_printf("%s:\tFile DOES NOT EXIST on disk and will be deleted from database.", filename);
fprintf(stderr, "%s\n", logMsg);
}
trc1->data.stats[MIN] = 0;
trc1->data.stats[MAX] = 0;
trc1->data.stats[MEAN] = 0;
trc1->data.nSamps = 0;
trc1->data.nGaps = 0;
trc1->data.nOlaps = 0;
freeMyData(TRCINFO, &trace);
break;
default:
logMsg = g_strdup_printf("%s:\tProblem reading file, cannot process. (error code = %d)", filename, ret);
fprintf(stderr, "%s\n", logMsg);
break;
}
if (logMsg)
free(logMsg);
if (ret != PQLXSUCCESS)
return (ret);
format = trace.data.head.data_form;
switch(format)
{
case BIT16:
sptr=(short *) trace.data.dataInfo.data;
break;
case BIT32:
ptr= (gint32 *) trace.data.dataInfo.data;
break;
case MY_FLOAT:
lptr= (float *) trace.data.dataInfo.data;
break;
case MY_DOUBLE:
dptr= (double *) trace.data.dataInfo.data;
break;
}
if (trace.trace.gaps)
{
trc1->data.nGaps = trace.trace.numGaps;
trc1->data.gaps = calloc(trace.trace.numGaps*2, sizeof(int));
memcpy(trc1->data.gaps, trace.trace.gaps, trc1->data.nGaps * 2 * sizeof(int));
}
if (trace.trace.overlaps)
{
trc1->data.nOlaps = trace.trace.numOlaps;
trc1->data.olaps = calloc(trace.trace.numOlaps*2, sizeof(int));
memcpy(trc1->data.olaps, trace.trace.overlaps, trc1->data.nOlaps * 2 * sizeof(int));
}
DATAP(format, 0, dataVal);
trc1->data.stats[MIN] = dataVal;
trc1->data.stats[MAX] = dataVal;
lessSamples=0;
switch (trace.trace.numGaps)
{
case 0:
for (i=0; i < numSamples; ++i)
{
DATAP(format, i, dataVal);
trc1->data.stats[MEAN] += dataVal;
if (dataVal > trc1->data.stats[MAX])
{
trc1->data.stats[MAX] = dataVal;
continue;
}
if (dataVal < trc1->data.stats[MIN])
trc1->data.stats[MIN] = dataVal;
}
break;
default:
for (i=gapNum=0; i < numSamples; ++i)
{
if ((gapNum/2) < trace.trace.numGaps)
{
if (i==trace.trace.gaps[gapNum])
{ 
gapSamps = (trace.trace.gaps[gapNum+1] - trace.trace.gaps[gapNum]);
i += gapSamps;
lessSamples += gapSamps;
gapNum += 2;
}
}
DATAP(format, i, dataVal);
trc1->data.stats[MEAN] += dataVal;
if (dataVal > trc1->data.stats[MAX])
{
trc1->data.stats[MAX] = dataVal;
continue;
}
if (dataVal < trc1->data.stats[MIN])
trc1->data.stats[MIN] = dataVal;
}
break;
}
trc1->data.stats[MEAN] /= (numSamples-lessSamples);
trc1->data.nSamps = numSamples - lessSamples; 
trc1->keys.fileType = trace.data.fileType;
trc1->data.sTime.epochS = trace.data.head.epochs;
passcal_etoh(&trc1->data.sTime.date, trc1->data.sTime.epochS);
trc1->data.sTime.m_secs = (int) (((trc1->data.sTime.date.sec - 
(int) trc1->data.sTime.date.sec)) * 1000);
trc1->data.eTime.epochS = trace.data.head.epochs + trace.data.head.length;
passcal_etoh(&trc1->data.eTime.date, trc1->data.eTime.epochS);
trc1->data.eTime.m_secs = (int) (((trc1->data.eTime.date.sec - 
(int) trc1->data.eTime.date.sec)) * 1000);
trc1->data.sampInt = trace.data.head.sampInt;
freeMyData(TRCINFO, &trace);
return ret;
}
