#!/bin/bash

if [ "$1" == "" ] ; then
	echo "usage: $0"
	exit
fi

export PQLX=$1
if [ ! -e $PQLX/PQLXprodVars ] ; then
	echo "$1 does not contain PQLXprodVars.  Cannot continue, exiting."
	exit
fi
source $PQLX/PQLXprodVars

# Once per Week: clean up log directory
if [ "`date +%w`" -eq "0" ] ; then
# delete all log files older than one week
	find $PQLXLOG -mtime +7 -exec rm -f {} \;
fi

# execute PQLX server program for each active database
# replace DB1, DB2, DB3, etc. with the real name of the PQLX Database
# supplying [args] appropriately:
#   - execute $PQLXBIN/pqlxSrvr without arguments for usage
# and uncomment the appropriate lines
#$PQLXBIN/PQLX-Server.sh --dbName=DB1 [args]
#$PQLXBIN/PQLX-Server.sh --dbName=DB2 [args]
#$PQLXBIN/PQLX-Server.sh --dbName=DB2 [args]

