#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "dbl_iface.h"
#include "pqlx_errors.h"
int dbl_request(DBLDI *dbldi);
int dblg_request(DBLDI *dbldi);
#define ARG1 "CONVERT"
int main(int argc, char **argv)
{
DBLRECORDS dblrecs;
DBLDI dbldig, dbldit;
int  i, j, ret;
gboolean success = TRUE;
char *home_dir = g_strdup(g_get_home_dir()), *Odir, *Ndir;
if (argc == 1 ||
(argc == 2 && strcmp(argv[1], ARG1)))
{
fprintf(stderr, "Program to Convert Local PQL Settings Files...\n"); 
fprintf(stderr, "Usage:\n");
fprintf(stderr, "%s [%s]\n", argv[0], ARG1);
fprintf(stderr, "where:\n");
fprintf(stderr, "\twith '%s'\t=> Perform Conversion\n", ARG1);
fprintf(stderr, "\tw/out '%s'\t=> Print this Message and QUIT\n\n", ARG1);
return 0;
}
Odir = g_strdup_printf("%s/.pql", home_dir);
Ndir = g_strdup_printf("%s/.pqlg", home_dir);
rename(Odir, Ndir);
free(home_dir);  free(Odir);
for (i=0; i < NLTABLES; i++)
{
memset(&dbldig, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldig.descr.tableData = i;
dbldig.descr.dataEvent = READ_ALL;
dbldig.data = &dblrecs;
ret = dblg_request(&dbldig);
if (!dblrecs.numRecs ||
ret == FAILURE)
continue;
memset(&dbldit, 0, sizeof(DBLDI));
dbldit.descr.tableData = i;
dbldit.descr.dataEvent = WRITE_ALL;
dbldit.data = &dblrecs;
ret = dbl_request(&dbldit);
if (ret == FAILURE)
success = FALSE;
for (j = 0; j < dblrecs.numRecs; j++)
free(dblrecs.recs[j]);
free(dblrecs.recs);
}
switch (success)
{
case FALSE:
fprintf(stderr, "Part of the conversion failed!\n");
fprintf(stderr, "Old files can be found in directory '%s'\n", Ndir);
break;
case TRUE:
{ 
char *cmd = g_strdup_printf("/bin/rm -r %s", Ndir);
system(cmd);
free(cmd);
fprintf(stderr, "Conversion Successful!\n");
}
break;
}
return success;
}
