#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <rpc/rpc.h>
#include <math.h>
#include <unistd.h>
#include "ahhead.h"
#include "pql_defines.h"
#include "pql_externs.h"
int xdr_ahhead();
int ah_errno = 0;
int ah_nerr = 10;
#define AE_RHED  1 
#define AE_DTYPE 2 
#define AE_WHED  3 
#define AE_RDATA 4 
#define AE_WDATA 5 
#define AE_WRECORD 6 
#define AE_RRECORD 7 
#define AE_TTYOUT 8 
#define AE_TTYIN 9 
char *ah_errlist[] = {
"no error",  
"read header error", 
"bad data type", 
"write header error", 
"read data error", 
"write data error", 
"write record error", 
"read record error", 
"tty can't get binary", 
"tty can't send binary" 
};
void get_null_head(ahhed *hed)
{
int i;
strcpy(hed->station.code,"null");
strcpy(hed->station.chan,"null");
strcpy(hed->station.stype,"null");
hed->station.slat= 0.0;
hed->station.slon= 0.0;
hed->station.elev= 0.0;
hed->station.DS= 0.0;
hed->station.A0= 0.0;
for(i=0; i< NOCALPTS; ++i)
{
hed->station.cal[i].pole.r= 0.0;
hed->station.cal[i].pole.i= 0.0;
hed->station.cal[i].zero.r= 0.0;
hed->station.cal[i].zero.i= 0.0;
}
hed->event.lat= 0.0;
hed->event.lon= 0.0;
hed->event.dep= 0.0;
hed->event.ot.yr= (short)0;
hed->event.ot.mo= (short)0;
hed->event.ot.day= (short)0;
hed->event.ot.hr= (short)0;
hed->event.ot.mn= (short)0;
hed->event.ot.sec= 0.0;
strcpy(hed->event.ecomment,"null");
hed->record.type= (short)0;
hed->record.ndata= 0L;
hed->record.delta= 0.0;
hed->record.maxamp= 0.0;
hed->record.abstime.yr= (short)0;
hed->record.abstime.mo= (short)0;
hed->record.abstime.day= (short)0;
hed->record.abstime.hr= (short)0;
hed->record.abstime.mn= (short)0;
hed->record.abstime.sec= 0.0;
hed->record.rmin= 0.0;
strcpy(hed->record.rcomment,"null");
strcpy(hed->record.log,"null");
for(i=0; i< NEXTRAS; ++i)
hed->extra[i]= 0.0;
return;
}
int gethead(head,file_pt)
FILE *file_pt;
ahhed *head;
{
int ierr=0, 
i; 
int sizefloat, 
sizelong, 
sizeshort; 
sizelong = sizeof(long) ;
sizefloat = sizeof(float) ;
sizeshort = sizeof(short) ;
if ((ierr = fread(head->station.code, CODESIZE, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(head->station.chan, CHANSIZE, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(head->station.stype, STYPESIZE, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(&head->station.slat, sizefloat, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(&head->station.slon, sizefloat, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(&head->station.elev, sizefloat, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(&head->station.DS, sizefloat, 1, file_pt)) == -1) goto CH4ERROR;
if ((ierr = fread(&head->station.A0, sizefloat, 1, file_pt)) == -1) goto CH4ERROR;
for (i=0; i< NOCALPTS ; i++) {
if ((ierr=fread(&head->station.cal[i].pole.r,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->station.cal[i].pole.i,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->station.cal[i].zero.r,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->station.cal[i].zero.i,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
} 
if ((ierr=fread(&head->event.lat,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.lon,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.dep,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.ot.yr,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.ot.mo,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.ot.day,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.ot.hr,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.ot.mn,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->event.ot.sec,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(head->event.ecomment,COMSIZE,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.type,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.ndata,sizelong,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.delta,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.maxamp,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.abstime.yr,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.abstime.mo,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.abstime.day,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.abstime.hr,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.abstime.mn,sizeshort,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.abstime.sec,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(&head->record.rmin,sizefloat,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(head->record.rcomment,COMSIZE,1,file_pt)) == -1) goto CH4ERROR;
if ((ierr=fread(head->record.log,LOGSIZE,1,file_pt)) == -1) goto CH4ERROR;
for (i=0; i < NEXTRAS ; i++) {
if ((ierr=fread(&head->extra[i],sizefloat, 1,file_pt)) == -1) goto CH4ERROR;
}
if((head->record.type < TYPEMIN) || (head->record.type > TYPEMAX))
{
get_null_head(head);
ierr = -2; 
ah_errno= AE_DTYPE;
}
CH4ERROR: if (ierr == -1)
{
get_null_head(head);
ierr = -1;
ah_errno= AE_RHED;
}
return(ierr);
}
int puthead(head,file_pt)
FILE *file_pt;
ahhed *head;
{
int ierr = 0;
if((ierr= fwrite((char *)head,sizeof(ahhed),1,file_pt)) != 1)
{
ah_errno= AE_WHED;
ierr= -1;
}
return(ierr);
}
int size(head)
ahhed *head;
{
int type_size = 0;
switch(head->record.type)
{
case 1:  
type_size= sizeof(float);
break;
case 2:  
type_size= sizeof(complex);
break;
case 3:  
type_size= sizeof(vector);
break;
case 4:  
type_size= sizeof(tensor);
break;
case 5:  
type_size= 2*sizeof(complex);
break;
case 6:  
type_size=sizeof(double);
break;
default: 
type_size= -1;
ah_errno= AE_DTYPE;
break;
}
return(type_size);
}
int tohead(n,file_pt)
FILE *file_pt;
int n;
{
ahhed head;
int i,ierr;
rewind(file_pt);
for(i=1; i<n; ++i)
{
if(gethead(&head,file_pt) == 1)
{
if(fseek(file_pt,(long)(head.record.ndata)*(size(&head)),1) == -1)
{
ierr = -2; 
ah_errno= AE_RHED;
return(ierr);
}
}
else
{
ierr = -1; 
ah_errno= AE_RHED;
return(ierr);
}
}
return(i); 
}
int getdata(head,array,file_pt)
ahhed *head;
char *array;
FILE *file_pt;
{
int ierr = 0;
if((ierr = fread(array,size(head),(int)head->record.ndata,file_pt)) != (int)head->record.ndata)
{
ah_errno= AE_RDATA;
ierr = -1;
}
return(ierr);
}
int putdata(head,array,file_pt)
ahhed *head;
char *array;
FILE *file_pt;
{
int ierr = 0;
if((ierr = fwrite(array,size(head),(int)head->record.ndata,file_pt)) != (int)head->record.ndata)
{
ah_errno= AE_WDATA;
ierr = -1;
}
return(ierr);
}
int putrecord(head,array,file_pt)
ahhed *head;
char *array;
FILE *file_pt;
{
int ierr = 0;
(puthead(head,file_pt) == 1) ? ((putdata(head,array,file_pt) < 0) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
if(ierr)
ah_errno= AE_WRECORD;
return(ierr);
}
int getrecord(head,array,file_pt)
ahhed *head;
char *array;
FILE *file_pt;
{
int ierr = 0;
(gethead(head,file_pt) == 1) ? ((getdata(head,array,file_pt) < 0) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
if(ierr)
ah_errno= AE_RRECORD;
return(ierr);
}
int getrecord2(head,array,file_pt)
ahhed *head;
char **array;
FILE *file_pt;
{
int ierr = 0;
int gethead();
char *mkdatspace();
if(gethead(head, file_pt) != 1) {
ierr = -1;
return(ierr);
}
*array= mkdatspace(head);
if(*array == NULL) {
ierr= -2;
return(ierr);
}
if(getdata(head,*array,file_pt) < 0)
ierr= -1;
return(ierr);
}
int gogethead(n,head,file_pt)
int n;
ahhed *head;
FILE *file_pt;
{
int ierr = 0;
(tohead(n,file_pt) == n) ? ((gethead(head,file_pt) < 1) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
return(ierr);
}
int gogetrecord(n,head,array,file_pt)
int n;
ahhed *head;
char *array;
FILE *file_pt;
{
int ierr = 0;
(tohead(n,file_pt) == n) ? ((getrecord(head,array,file_pt) < 0) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
return(ierr);
}
int logger(char_pt,head_pt)
ahhed *head_pt;
char *char_pt;
{
int org,in,err,diff;
err=0;
org=strlen(head_pt->record.log); 
in=strlen(char_pt); 
if(*(char_pt+in-1) != ';')
{ 
err=(-1);
*(char_pt+in)=';';
*(char_pt+in+1)='\0';
in+=1;
}
if(in > LOGENT)
{ 
err=(-2);
*(char_pt+LOGENT-1)=';';
*(char_pt+LOGENT)='\0';
in=LOGENT;
}
diff=LOGSIZE-(org+in);
if(diff == -in) return(-3); 
if(diff < 0)diff*=(-1),err=(-3);  
strncat(head_pt->record.log,char_pt,diff); 
return(err);
}
int out_is_tty()
{
if(isatty(1)) 
{
ah_errno= AE_TTYOUT;
return(1);
}
return(0);
}
int in_is_tty()
{
if(isatty(0)) 
{
ah_errno= AE_TTYIN;
return(1);
}
return(0);
}
char *mkdatspace(head)
ahhed *head;
{
return((char *)calloc((unsigned)head->record.ndata,(unsigned)size(head)));
}
void acpy(from,to,nbytes)
char *from;
char *to;
unsigned nbytes;
{
while(nbytes--)
*from++ = *to++;
return;
}
void ah_error(s1,s2,status)  
char *s1,*s2;
int status;
{
extern char *progname;
if(progname)
fprintf(stderr,"%s: ",progname);
fprintf(stderr,s1,s2);
if(ah_errno > 0 && ah_errno < ah_nerr)
fprintf(stderr," (%s)",ah_errlist[ah_errno]);
fprintf(stderr,"\n");
exit(status);
}
int maxamp(head,data)
ahhed *head;
char *data;
{
float *fpt;
double *dpt, dmin, dmax;
float max,min;
long n_data_pts;
switch(head->record.type)
{
case FLOAT:
n_data_pts= head->record.ndata;
break;
case COMPLEX:
case VECTOR:
n_data_pts= 2 * head->record.ndata;
break;
case TENSOR:
n_data_pts= 3 * head->record.ndata;
break;
case 5:
n_data_pts= 4 * head->record.ndata;
break;
case DOUBLE:
n_data_pts= head->record.ndata;
break;
default:
ah_errno= AE_DTYPE;
return(-1);
break;
}
if (head->record.type == DOUBLE) {
dpt= (double *)data;
dmax= dmin= *dpt;
while(n_data_pts--)
{
dmax= MAX(dmax,*dpt);
dmin= MIN(dmin,*dpt);
++dpt;
}
((fabs(dmax) > fabs(dmin)) ? (head->record.maxamp= (float) dmax) : (head->record.maxamp= (float) -dmin));
}
else {
fpt= (float *)data;
max= min= *fpt;
while(n_data_pts--)
{
max= MAX(max,*fpt);
min= MIN(min,*fpt);
++fpt;
}
((fabs((double)max) > fabs((double)min)) ? (head->record.maxamp= max) : (head->record.maxamp= -min));
}
return(0);
}
int xdr_gethead(head,xdrs)
XDR *xdrs;
ahhed *head;
{
int ierr = 0;
if((ierr = xdr_ahhead(xdrs, head)) == 1)
{
if((head->record.type < TYPEMIN) || (head->record.type > TYPEMAX))
{
get_null_head(head);
ierr = -2; 
ah_errno= AE_DTYPE;
}
}
else  
{
get_null_head(head);
ierr = -1;
ah_errno= AE_RHED;
}
return(ierr);
}
int xdr_puthead(head,xdrs)
XDR *xdrs;
ahhed *head;
{
int ierr = 0;
if((ierr= xdr_ahhead(xdrs, head)) != 1)
{
ah_errno= AE_WHED;
ierr= -1;
}
return(ierr);
}
int xdr_tohead(n,xdrs)
XDR *xdrs;
int n;
{
ahhed head;
int i,ierr,j;
float float_dum;
double double_dum;
complex complex_dum;
tensor tensor_dum;
xdr_setpos(xdrs, (u_int) 0);
for(i=1; i<n; ++i)
{
if(xdr_gethead(&head,xdrs) == 1)
{
switch (head.record.type) {
case FLOAT:
for (j = 0; j < head.record.ndata; j++) {
if (!xdr_float(xdrs, &float_dum)) {
ierr = -2; 
ah_errno= AE_RHED;
return(ierr);
}
}
break;
case COMPLEX:
case VECTOR:
for (j = 0; j < head.record.ndata; j++) {
if (!xdr_float(xdrs, &complex_dum.i) ||
!xdr_float(xdrs, &complex_dum.r)) {
ierr = -2; 
ah_errno= AE_RHED;
return(ierr);
}
}
break;
case TENSOR:
for (j = 0; j < head.record.ndata; j++) {
if (!xdr_float(xdrs, &tensor_dum.xx) ||
!xdr_float(xdrs, &tensor_dum.yy) ||
!xdr_float(xdrs, &tensor_dum.xy)) {
ierr = -2; 
ah_errno= AE_RHED;
return(ierr);
}
}
break;
case 5:
for (j = 0; j < 4 * head.record.ndata; j++) {
if (!xdr_float(xdrs, &float_dum)) {
ierr = -2; 
ah_errno= AE_RHED;
return(ierr);
}
}
break;
case DOUBLE:
for (j = 0; j < head.record.ndata; j++) {
if (!xdr_double(xdrs, &double_dum)) {
ierr = -2; 
ah_errno= AE_RHED;
return(ierr);
}
}
break;
default:
ierr = -2; 
ah_errno= AE_DTYPE;
return(ierr);
}
}
else
{
ierr = -1; 
ah_errno= AE_RHED;
return(ierr);
}
}
return(i); 
}
int xdr_getdata(head,array,xdrs)
ahhed *head;
char *array;
XDR *xdrs;
{
int ierr = 0;
float *pfloat;
double *pdouble;
complex *pcomplex;
tensor *ptensor;
int i;
switch(head->record.type) {
case FLOAT:
pfloat = (float *) array;
for (i = 0; i < head->record.ndata; i++) {
if (! xdr_float(xdrs, pfloat++) ) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case COMPLEX:
case VECTOR:
pcomplex = (complex *) array;
for (i = 0; i < head->record.ndata; i++) {
if (!xdr_float(xdrs, &(pcomplex->r)) ||
!xdr_float(xdrs, &(pcomplex++->i))) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case TENSOR:
ptensor = (tensor *) array;
for (i = 0; i < head->record.ndata; i++) {
if (!xdr_float(xdrs, &(ptensor->xx)) ||
!xdr_float(xdrs, &(ptensor->yy)) ||
!xdr_float(xdrs, &(ptensor++->xy))) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case 5:
pfloat = (float *) array;
for (i = 0; i < 4 * head->record.ndata; i++) {
if (! xdr_float(xdrs, pfloat++) ) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case DOUBLE:
pdouble = (double *) array;
for (i = 0; i < head->record.ndata; i++) {
if (! xdr_double(xdrs, pdouble++) ) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
default:
ierr = -1;
ah_errno= AE_DTYPE;
return(ierr);
}
return(ierr);
}
int xdr_putdata(head,array,xdrs)
ahhed *head;
char *array;
XDR *xdrs;
{
int ierr = 0;
float *pfloat;
double *pdouble;
complex *pcomplex;
tensor *ptensor;
int i;
switch(head->record.type) {
case FLOAT:
pfloat = (float *) array;
for (i = 0; i < head->record.ndata; i++) {
if (! xdr_float(xdrs, pfloat++) ) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case COMPLEX:
case VECTOR:
pcomplex = (complex *) array;
for (i = 0; i < head->record.ndata; i++) {
if (!xdr_float(xdrs, &(pcomplex->r)) ||
!xdr_float(xdrs, &(pcomplex++->i))) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case TENSOR:
ptensor = (tensor *) array;
for (i = 0; i < head->record.ndata; i++) {
if (!xdr_float(xdrs, &(ptensor->xx)) ||
!xdr_float(xdrs, &(ptensor->yy)) ||
!xdr_float(xdrs, &(ptensor++->xy))) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case 5:
pfloat = (float *) array;
for (i = 0; i < 4 * head->record.ndata; i++) {
if (! xdr_float(xdrs, pfloat++) ) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
case DOUBLE:
pdouble = (double *) array;
for (i = 0; i < head->record.ndata; i++) {
if (! xdr_double(xdrs, pdouble++) ) {
ah_errno= AE_RDATA;
ierr = -1;
return(ierr);
}
++ierr;
}
break;
default:
ierr = -1;
ah_errno= AE_DTYPE;
return(ierr);
}
return(ierr);
}
int xdr_putrecord(head,array,xdrs)
ahhed *head;
char *array;
XDR *xdrs;
{
int ierr = 0;
(xdr_puthead(head,xdrs) == 1) ? ((xdr_putdata(head,array,xdrs) < 0) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
if(ierr)
ah_errno= AE_WRECORD;
return(ierr);
}
int xdr_getrecord(head,array,xdrs)
ahhed *head;
char *array;
XDR *xdrs;
{
int ierr = 0;
(xdr_gethead(head,xdrs) == 1) ? ((xdr_getdata(head,array,xdrs) < 0) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
if(ierr)
ah_errno= AE_RRECORD;
return(ierr);
}
int xdr_getrecord2(head,array,xdrs)
ahhed *head;
char **array;
XDR *xdrs;
{
int ierr = 0;
int xdr_gethead();
char *mkdatspace();
if(xdr_gethead(head, xdrs) != 1) {
ierr = -1;
return(ierr);
}
*array= mkdatspace(head);
if(*array == NULL)
{
ierr= -2;
return(ierr);
}
if(xdr_getdata(head,*array,xdrs) < 0)
ierr= -1;
return(ierr);
}
int xdr_gogethead(n,head,xdrs)
int n;
ahhed *head;
XDR *xdrs;
{
int ierr = 0;
(xdr_tohead(n,xdrs) == n) ? ((xdr_gethead(head,xdrs) < 1) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
return(ierr);
}
int xdr_gogetrecord(n,head,array,xdrs)
int n;
ahhed *head;
char *array;
XDR *xdrs;
{
int ierr = 0;
(xdr_tohead(n,xdrs) == n) ? ((xdr_getrecord(head,array,xdrs) < 0) ? (ierr = -2) : (ierr = 0)) : (ierr = -1);
return(ierr);
}
int xdr_ahhead(xdrsp, ahheadp)
XDR *xdrsp;
ahhed *ahheadp;
{
u_int l;
char **pp, *p;
float **ppf, *pf;
l = CODESIZE;
p = ahheadp->station.code;
pp = &p;
if (!xdr_bytes(xdrsp, pp, &l, (u_int) CODESIZE))
return(0);
l = CHANSIZE;
p = ahheadp->station.chan;
pp = &p;
if (!xdr_bytes(xdrsp, pp, &l, CHANSIZE))
return(0);
l = STYPESIZE;
p = ahheadp->station.stype;
pp = &p;
if (!xdr_bytes(xdrsp, pp, &l, STYPESIZE))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.slat))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.slon))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.elev))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.DS))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.A0))
return(0);
for (l = 0; l < NOCALPTS; l++) {
if (!xdr_float(xdrsp, &ahheadp->station.cal[l].pole.r))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.cal[l].pole.i))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.cal[l].zero.r))
return(0);
if (!xdr_float(xdrsp, &ahheadp->station.cal[l].zero.i))
return(0);
}
if (!xdr_float(xdrsp, &ahheadp->event.lat))
return(0);
if (!xdr_float(xdrsp, &ahheadp->event.lon))
return(0);
if (!xdr_float(xdrsp, &ahheadp->event.dep))
return(0);
if (!xdr_short(xdrsp, &ahheadp->event.ot.yr))
return(0);
if (!xdr_short(xdrsp, &ahheadp->event.ot.mo))
return(0);
if (!xdr_short(xdrsp, &ahheadp->event.ot.day))
return(0);
if (!xdr_short(xdrsp, &ahheadp->event.ot.hr))
return(0);
if (!xdr_short(xdrsp, &ahheadp->event.ot.mn))
return(0);
if (!xdr_float(xdrsp, &ahheadp->event.ot.sec))
return(0);
l = COMSIZE;
p = ahheadp->event.ecomment;
pp = &p;
if (!xdr_bytes(xdrsp, pp, &l, COMSIZE))
return(0);
if (!xdr_short(xdrsp, &ahheadp->record.type))
return(0);
if (!xdr_int(xdrsp, &ahheadp->record.ndata))
return(0);
if (!xdr_float(xdrsp, &ahheadp->record.delta))
return(0);
if (!xdr_float(xdrsp, &ahheadp->record.maxamp))
return(0);
if (!xdr_short(xdrsp, &ahheadp->record.abstime.yr))
return(0);
if (!xdr_short(xdrsp, &ahheadp->record.abstime.mo))
return(0);
if (!xdr_short(xdrsp, &ahheadp->record.abstime.day))
return(0);
if (!xdr_short(xdrsp, &ahheadp->record.abstime.hr))
return(0);
if (!xdr_short(xdrsp, &ahheadp->record.abstime.mn))
return(0);
if (!xdr_float(xdrsp, &ahheadp->record.abstime.sec))
return(0);
if (!xdr_float(xdrsp, &ahheadp->record.rmin))
return(0);
l = COMSIZE;
p = ahheadp->record.rcomment;
pp = &p;
if (!xdr_bytes(xdrsp, pp, &l, COMSIZE))
return(0);
l = LOGSIZE;
p = ahheadp->record.log;
pp = &p;
if (!xdr_bytes(xdrsp, pp, &l, LOGSIZE))
return(0);
l = NEXTRAS;
pf = ahheadp->extra;
ppf = &pf;
if (!xdr_array(xdrsp, (caddr_t *) ppf, &l, NEXTRAS, sizeof(float), (xdrproc_t) xdr_float))
return(0);
return(1);
}
