#include <stdio.h>
#include <sys/types.h>
#include <limits.h>
#include <glib.h>
#include "steim.h"
static int extractDiffs(char *bytes, int *diffs, gboolean rev) 
{
int nibbles;
int currNibble = 0;
int dnib = 0;
int tempInt, i, d;
int currNum = 0, offset = 0;
if (rev)
rmemcpy((u_char *)&nibbles, (u_char *) &bytes[offset], 4);
else
memcpy(&nibbles, &bytes[offset], 4);
for (i=1; i<16; i++) 
{
currNibble = (nibbles >> (30 - i*2 ) ) & 0x03;
switch (currNibble) {
case 1:
diffs[currNum++] = (int) (bytes[offset+(i*4)]);
diffs[currNum++] = (int) (bytes[offset+(i*4)+1]);
diffs[currNum++] = (int) (bytes[offset+(i*4)+2]);
diffs[currNum++] = (int) (bytes[offset+(i*4)+3]);
break;
case 2:
if (rev)
rmemcpy((u_char *)&tempInt, (u_char *) &bytes[offset+(i*4)], 4);
else
memcpy(&tempInt, &bytes[offset+(i*4)], 4);
dnib = (tempInt >> 30) & 0x03;
switch (dnib) 
{
case 1:
diffs[currNum++] = (tempInt << 2) >> 2;
break;
case 2:
diffs[currNum++] = (tempInt << 2) >> 17; 
diffs[currNum++] = (tempInt << 17) >> 17; 
break;
case 3:
diffs[currNum++] = (tempInt << 2) >> 22; 
diffs[currNum++] = (tempInt << 12) >> 22; 
diffs[currNum++] = (tempInt << 22) >> 22; 
break;
default:
break;
}
break;
case 3:
if (rev)
rmemcpy((u_char *)&tempInt, (u_char *) &bytes[offset+(i*4)], 4);
else
memcpy(&tempInt, &bytes[offset+(i*4)], 4);
dnib = (tempInt >> 30) & 0x03;
int diffCount = 0; 
int bitSize = 0; 
int headerSize = 0; 
switch (dnib) 
{
case 0:
headerSize = 2;
diffCount = 5;
bitSize = 6;
break;
case 1:
headerSize = 2;
diffCount = 6;
bitSize = 5;
break;
case 2:
headerSize = 4;
diffCount = 7;
bitSize = 4;
break;
default:
break;
}
if (diffCount > 0) {
for (d=0; d<diffCount; d++) { 
diffs[currNum++] = ( tempInt << (headerSize+(d*bitSize)) ) >> (((diffCount-1)*bitSize) + headerSize);
}
}
}
}
return currNum;
}
#define TOTALDIFFS (7*15+1) 
int steim2(char *b, int *samples, int *last_x, int blocksize, gboolean rev)
{
int diffSamps[TOTALDIFFS];  
int x0, xn;
int current, j, i;
int numSamps, totSamps;
int lastValue=*last_x;
gboolean first = (*last_x == INT_MIN ? TRUE : FALSE);
if (rev) 
{
rmemcpy((u_char *)&x0, (u_char *)&b[68], 4);
rmemcpy((u_char *)&xn, (u_char *)&b[72], 4);
}
else
{
memcpy(&x0, &b[68], 4);
memcpy(&xn, &b[72], 4);
}
if (first)
lastValue = *last_x = x0;
for (i=64, totSamps = current = 0; i<blocksize; i+=64)
{
memset(diffSamps, 0, sizeof(int) * TOTALDIFFS);
numSamps = extractDiffs((char *) &b[i], &diffSamps[0], rev); 
for (j = 0; j < numSamps; j++, current++)
{
lastValue = samples[current] = lastValue + diffSamps[j]; 
}
totSamps += numSamps;
}
*last_x = lastValue;
return totSamps;
}
