#ifndef __AHHEAD
#define __AHHEAD
#include <glib.h>
#include "ptime.h"
#define AHHEADSIZE 1024
#define CODESIZE 6
#define CHANSIZE 6
#define STYPESIZE 8
#define COMSIZE 80
#define TYPEMIN 1
#define TYPEMAX 6
#define LOGSIZE 202
#define LOGENT 10
#define NEXTRAS 21
#define NOCALPTS 30
typedef struct {
float x;
float y;
} vector;
typedef struct {
float r;
float i;
} complex;
typedef struct {
double r;
double i;
} d_complex;
typedef struct {
float xx;
float yy;
float xy;
} tensor;
struct ah_time {
short  yr; 
short  mo; 
short  day; 
short  hr; 
short  mn; 
float  sec; 
};
struct calib {
complex  pole; 
complex  zero; 
};
struct station_info {
char  code[CODESIZE]; 
char  chan[CHANSIZE]; 
char  stype[STYPESIZE];
float  slat;  
float  slon;  
float  elev;  
float  DS; 
float  A0; 
struct calib cal[NOCALPTS]; 
};
struct event_info {
float  lat;  
float  lon;  
float  dep;  
struct ptime ot;  
char  ecomment[COMSIZE]; 
};
struct record_info {
short  type; 
gint32  ndata; 
float  delta; 
float  maxamp; 
struct ptime abstime;
float  rmin; 
char  rcomment[COMSIZE]; 
char  log[LOGSIZE]; 
};
typedef struct {
struct station_info station; 
struct event_info event;  
struct record_info record;  
float  extra[NEXTRAS]; 
} ahhed;
#define FLOAT 1
#define COMPLEX 2
#define VECTOR 3
#define TENSOR 4
#define DOUBLE 6
#endif
