#ifndef NANO_H
#define NANO_H
#include <sys/types.h>
#define MAXFILENAMELENGTH  128
typedef struct NmxTraceHeader  
{
u_short usVersion;
u_short usOffset;
struct STNCHN
{
u_short usStnKey;  
u_char achStation[6];
u_char achLocation[3];
u_char achChannel[4];
u_short usLongWordOrder; 
u_short usWordOrder;  
char szNetworkID[52]; 
u_char szSiteName[62];  
u_char szComment[32];  
u_char szSensorType[52]; 
char achDataFormat[7]; 
float rLatitude;  
float rLongitude;  
float rElevation;  
float rDepth;   
float rAzimuth;  
float rDip;   
float rSensitivity;  
float rSensFreq;  
guint32 ulRespKey;  
u_char szSensUnits[22]; 
u_char szCalibUnits[22]; 
float rSampleRate;  
float rMaxClkDrift;  
char achChanFlags[27]; 
u_char uchUpdateFlag;  
double rtmUpdateTime1;  
double rtmUpdateTime2;  
char achGroupId[5];  
u_char uchFep;   
u_char uchPort;  
u_char uchChan;  
u_char uchDataCode;  
double rtmTimeCorrect;  
float rSensorSensitivity; 
float rRd3Sensitivity; 
u_short usInstrumentID;  
guint32 ulCommID;  
double rtmLoadDate;
} stStnChn;
struct SERIES
{
guint32 ulSeriesKey;  
u_char achStation[6];
u_char achLocation[3];
u_char achChannel[4];
double rtmStartTime1;
double rtmEndTime1;
guint32 ulNumSamples;  
gint32 IDCOffset;  
gint32 IMaxAmplitude;  
gint32 IMinAmplitude;  
u_char szFileName[MAXFILENAMELENGTH]; 
u_char szFormatVersion[7]; 
u_char szFormat[7];  
u_short usMachineFormat; 
guint32 ulFileLocation;  
u_short usFileSubLocation; 
struct TRACE *pstTrace; 
struct SERIES *pstNextSeriesAll; 
struct SERIES *pstNextSeriesStn; 
guint32 ulCommID;  
double rtmLoadDate;
} stSeries;
} NMXTRACE3;
typedef struct NmxTraceHeader1 {
guint32 ulDataOffset; 
guint32 ulBitMapOffset; 
guint32 ulNumSamples; 
u_char uchDataType;  
char achNetId[5];  
char achSiteId[9];  
char achGroupId[5]; 
char achChanID[5];  
float fLatitude;  
float fLongitude;  
float fElevation;  
u_char uchFep;  
u_char uchPort;  
u_char uchChan;  
guint32 ulBaud;  
u_short usSampleRate; 
u_short usDecimation; 
u_char uchDataCode;  
u_char uchFormat;  
gint32 lTimeCorSecs;  
short sTimeCorMs;  
char achKeyResponse[5]; 
float fRd3Sensitivity; 
float fInputResistance; 
float fSensitivity;  
char achSensorType[21]; 
float fDamping;  
float fExtResistance; 
char achUnits[21];  
guint32 ulTimeSecs;  
u_short usTimeMs;  
} NMXTRACE1;
typedef struct RecHdr {
char seq_num[6]; 
char DHI_1;  
char DHI_2;  
char stat_ID[5]; 
char loc_ID[2];  
char chan_ID[3]; 
char reserved1[2]; 
gint32 sec;  
short msec;  
char reserved2[4]; 
u_short sample_count; 
short samsec;  
short s_factor;  
char activity_flag; 
char io_flag;  
char quality_flag; 
char n_blockettes; 
gint32 time_cor;  
u_short d_offset; 
u_short b_offset; 
char reserved3[16]; 
} RECHDR;
#endif 
