#ifndef SEGY_H
#define SEGY_H
typedef struct SegyHead { 
gint32 lineSeq; 
gint32 reelSeq; 
gint32 event_number; 
gint32 channel_number; 
gint32 energySourcePt; 
gint32 cdpEns; 
gint32 traceInEnsemble; 
short traceID; 
short vertSum; 
short horSum; 
short dataUse; 
gint32 sourceToRecDist; 
gint32 recElevation; 
gint32 sourceSurfaceElevation; 
gint32 sourceDepth; 
gint32 datumElevRec; 
gint32 datumElevSource; 
gint32 sourceWaterDepth; 
gint32 recWaterDepth; 
short elevationScale; 
short coordScale; 
gint32 sourceLongOrX; 
gint32 sourceLatOrY; 
gint32 recLongOrX; 
gint32 recLatOrY; 
short coordUnits; 
short weatheringVelocity;
short subWeatheringVelocity; 
short sourceUpholeTime; 
short recUpholeTime; 
short sourceStaticCor; 
short recStaticCor; 
short totalStatic; 
short lagTimeA; 
short lagTimeB; 
short delay; 
short muteStart; 
short muteEnd; 
short sampleLength; 
short deltaSample; 
short gainType; 
short gainConst; 
short initialGain; 
short correlated; 
short sweepStart; 
short sweepEnd; 
short sweepLength; 
short sweepType; 
short sweepTaperAtStart; 
short sweepTaperAtEnd; 
short taperType; 
short aliasFreq; 
short aliasSlope; 
short notchFreq; 
short notchSlope; 
short lowCutFreq; 
short hiCutFreq; 
short lowCutSlope; 
short hiCutSlope; 
short year; 
short day; 
short hour; 
short minute; 
short second; 
short timeBasisCode; 
short traceWeightingFactor; 
short phoneRollPos1; 
short phoneFirstTrace; 
short phoneLastTrace; 
short gapSize; 
short taperOvertravel; 
char station_name[6]; 
char sensor_serial[8]; 
char channel_name[4]; 
short totalStaticHi; 
gint32 samp_rate; 
short data_form; 
short m_secs; 
short trigyear; 
short trigday; 
short trighour; 
short trigminute; 
short trigsecond; 
short trigmills; 
float scale_fac; 
unsigned short inst_no; 
short not_to_be_used; 
gint32 num_samps; 
gint32 max; 
gint32 min; 
} SEGYHEAD; 
#endif 
