#ifndef TAPESTRC_H
#define TAPESTRC_H
struct pack_head_strc {   
char type[2];    
char exper_num[1];  
char year[1];   
char unit_id[2];  
char time[6];   
char bpp[2];   
char seq_num[2];  
};
struct channel_strc {   
char number[2];   
char name[10];    
char azimuth[10];   
char incline[10];   
char loc_x[10];    
char loc_y[10];    
char loc_z[10];    
char units_xy[4];   
char units_z[4];   
char preamp[4];    
char sens_mod[12];   
char sens_ser[12];   
char cmmnt[40];    
char volts[8] ;   
};
struct statn_chnl_def {   
struct pack_head_strc header;  
char ex_num[2];    
char ex_name[24];   
char ex_cmmmnt[40];   
char st_num[4];    
char st_name[24];   
char st_cmmnt[40];   
char das_mod[12];   
char das_ser[12];   
char ex_start[14];   
char clock_type[4];   
char clock_ser[10];   
struct channel_strc channel[5]; 
char reserved[92];   
};
struct event_def {   
unsigned char  trg_chan[16]; 
unsigned char  min_chan[2]; 
unsigned char  trg_wndw[8]; 
unsigned char  pre_trg_len[8]; 
unsigned char  pst_trg_len[8]; 
unsigned char  rec_len[8]; 
unsigned char  reserve[8]; 
unsigned char  sta_lng[8]; 
unsigned char  lta_lng[8]; 
unsigned char  mean_r[8]; 
unsigned char  trg_rat[8]; 
unsigned char  dtrg_rat[8]; 
unsigned char  lta_hold[4]; 
unsigned char  reserved[60]; 
};
struct timseq_def {   
unsigned char  start_time[14];  
unsigned char  rep_int[8];  
unsigned char  num_int[4]; 
unsigned char  pre_trg_len[8];  
unsigned char  rec_len[8];  
unsigned char reserved[120] ;
};
struct timelist_def {    
unsigned char start_time1[14];
unsigned char start_time2[14];
unsigned char start_time3[14];
unsigned char start_time4[14];
unsigned char start_time5[14];
unsigned char start_time6[14];
unsigned char start_time7[14];
unsigned char start_time8[14];
unsigned char start_time9[14];
unsigned char start_time10[14];
unsigned char start_time11[14];
unsigned char rec_len[8] ;
};
struct level_def {   
unsigned char  level[8];  
unsigned char  pre_trg_len[8];  
unsigned char  rec_len[8];  
unsigned char reserved[138] ;
};
struct rx_def {    
unsigned char  pre_trg_len[8];  
unsigned char  rec_len[8];  
unsigned char reserved[146] ;
};
struct con_def {   
unsigned char  rec_len[8];  
unsigned char reserved[154] ;
};
struct crs_def {   
unsigned char  trg_stm[2]; 
unsigned char  pre_trg_len[8];  
unsigned char  rec_len[8];  
unsigned char reserved[144] ;
};
struct strm_strc {    
char number[2];    
char name[24];    
char channels[16];   
char smp_rat[4];   
char dat_formt[2];   
char fltnum[8][2];   
char trg_typ[4];   
union    
{
struct event_def event ;
struct timseq_def tims ;
struct level_def levl ;
struct rx_def  radext ;
struct con_def  cont ;
struct crs_def  cross ;
} trigger ;
};
struct d_strm_def {    
struct pack_head_strc header;  
struct strm_strc stream[4];  
char reserved[88];    
};
struct filt_def {    
struct pack_head_strc header;  
char flt_num[2];   
char dec_fct[2];   
char num_coef[4];   
char delay[4];    
char offset[4];    
char coef[124][8];   
};
struct data_def {    
struct pack_head_strc header;  
char evnt_num[2];   
char strm_num[1];   
char chn_num[1];   
char num_samples[2];   
char data_format[2];   
char data[1000];    
};
struct health_def {    
struct pack_head_strc header;  
char count[4];    
char reserved[4];   
char info[1000];   
};
typedef struct event_time_def {  
char year[4] ;   
char day[3] ;    
char hour[2] ;    
char min[2] ;   
char sec[2] ;   
char msec[3] ;   
} EventTime;
struct event_trailer_def {  
struct pack_head_strc header; 
char evnt_num[2] ;  
char strm_num[1] ;  
char reserve[5] ;  
char trigger_time_msg[15]; 
EventTime trigger_time;
char reserved[969] ;
};
typedef struct event_trailer_new { 
struct pack_head_strc header; 
char evnt_num[2] ;   
char strm_num[1] ;   
char reserve[4] ;   
char data_format[1];  
char trigger_time_msg[33]; 
char filler[7] ;   
char stream_name[24] ;  
char sample_rate[4] ;  
char trigger_type[4] ;  
EventTime trigger_time;
EventTime first_sample_time;
EventTime detrigger_time;
EventTime last_sample_time;
char data_bit_weights[128]; 
char true_bit_weights[128];
char gain[16];
char ADResolution[16];
char FSA[16];
char channelCode[64];
char sensorFSA[16];
char sensorVPU[96];
char sensorUnits[16];
char channelNumber[48];
char reserved[156];
char totalChannels[2];
char comment[40];
char digFiltList[16];
char position[26];
char RT120[80];
} EventTrailer;
typedef EventTrailer EventHeader; 
struct calibration_def {  
struct pack_head_strc header ; 
char start[14] ;  
char rep_int[8] ;  
char num_int[4] ;  
char length[8] ;  
char step[4] ;  
char step_period[8] ; 
char step_size[8] ;  
char step_ampl[8] ;  
char step_output[4] ; 
char freq[4] ;  
char freq_start[8] ;  
char freq_stop[8] ;  
char freq_ampl[8] ;  
char freq_output[4] ; 
char noise[4] ;  
char noise_ampl[8] ;  
char noise_output[4] ; 
char reserve[894] ;
};
struct dstrm_def {  
unsigned char  number[2];  
unsigned char  name[24];  
unsigned char  ch_nums[16];  
unsigned char  rate[4];  
unsigned char  dat_formt[2];  
unsigned char  trg_type[4];  
union {     
struct event_def  evt;
struct timseq_def tim;
struct level_def  lev;
struct rx_def   radext;
struct con_def  con;
struct crs_def  crs;
} trigger;
};
struct smp_def {  
unsigned char  rate_num[2];  
unsigned char  num_stage[2];  
unsigned char  fltnum[8][2];  
};
struct filter_def {  
unsigned char  flt_num[2];  
unsigned char  dec_fct[2];  
unsigned char  num_coef[4];  
unsigned char  delay[4];  
unsigned char  flt_coef[512][8]; 
};
struct wake_def {   
unsigned char seq_no[2] ;  
unsigned char  start_time[12];  
unsigned char  pwr_dur[6];  
unsigned char  rep_int[6];  
unsigned char  num_int[2];  
};
struct mode_def {   
unsigned char  pwr_stt[2];  
unsigned char  rec_mod[2];  
};
struct wakeup_seq_def { 
struct pack_head_strc header;  
struct mode_def mode;
struct wake_def wake_info[8]; 
};
#endif 
