#include <stdlib.h>
#include <stdio.h> 
#include <dirent.h> 
#ifndef MAC
#include <sys/types.h>
#endif
#include <sys/stat.h> 
#include <string.h> 
#include <unistd.h> 
#define MAX_DIR_PATH 2048  
enum {
IDS_NTW,
IDS_STN,
IDS_LOC,
IDS_CHN,
TTLIDS
};
static char *IDStrs[TTLIDS] = { "NTW", "STN", "LOC", "CHN"};
#include <mysql.h>
#include "pqlx_defs.h"
typedef struct _CHNNAME
{
int  chni_pk;
char *chnName;
} CHNNAME;
typedef struct _CHNIArgs
{
SCAN *scanPtr; 
int level;
GNode *nodeN;
char *trcIDs[TTLIDS]; 
int *idKeys[TTLIDS];
} CHNIArgs;
typedef struct _FINDArgs
{
char *trcIDs[TTLIDS]; 
int *idKeys[TTLIDS];
} FINDArgs;
typedef struct _RECFIND
{
GNode *pNodeN;
NSLCDATA *nodeD;
int  level;
} RECFIND;
extern GSList *ntw;
extern GSList *ntwPDF;
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
static GNode * newID(int type, char *name, GNode *parNode)
{
SQLDI id;
IDS   idData;
GNode *nodeN=NULL;
NSLCDATA *new;
memset(&id, 0, sizeof(SQLDI));
id.descr.tableData = IDTBL;
id.data = (void *) &idData;
strcpy(idData.data.name, name);
strcpy(idData.keys.type, IDStrs[type]);
switch(type)
{
case IDS_NTW:
case IDS_STN:
id.args.dataEvent = INSERT_DATA;
db_request(&id); 
break;
case IDS_LOC:
case IDS_CHN:
id.args.dataEvent = GET_DATA;
db_request(&id);
if (idData.keys.idKey == 0)
{ 
id.args.dataEvent = INSERT_DATA;
db_request(&id);
}
break;
}
new = (NSLCDATA *) calloc(1, sizeof(NSLCDATA));
strcpy(new->name, name);
new->id = idData.keys.idKey;
switch (type)
{
case IDS_NTW:
nodeN = g_node_new(new);
ntw = g_slist_prepend(ntw, nodeN);
break;
case IDS_STN:
case IDS_LOC:
case IDS_CHN:
nodeN = g_node_insert_data(parNode, -1, new);
break;
}
return nodeN;
}
static inline NSLCDATA *makeCHNI(CHNIArgs *chniArgs)
{
int  i;
SCAN *scanPtr = chniArgs->scanPtr; 
int level = chniArgs->level;
GNode *nodeN = chniArgs->nodeN;
NSLCDATA  *nodeD=NULL;
for (i = level;
i < TTLIDS;
i++)
{ 
nodeN = newID(i, chniArgs->trcIDs[i], nodeN);
nodeD = nodeN->data;
*chniArgs->idKeys[i] = nodeD->id;
switch(i)
{
case IDS_NTW:
scanPtr->data.nNtw++;
break;
case IDS_STN:
scanPtr->data.nStn++;
break;
case IDS_LOC:
scanPtr->data.nLoc++;
break;
case IDS_CHN:
scanPtr->data.nChn++;
break;
}
}
{ 
SQLDI sqldi;
CHNI  chni;
memset(&sqldi, 0, sizeof(SQLDI));
memset(&chni, 0, sizeof(CHNI));
sqldi.descr.tableData = CHNITBL;
sqldi.args.dataEvent = INSERT_DATA;
sqldi.data = &chni;
chni.keys.name = chniArgs->trcIDs[IDS_CHN];
for(i=0;i<TTLIDS;i++)
{ 
chni.keys.idKeys[i] = *chniArgs->idKeys[i];
}
db_request(&sqldi);    
nodeD->id = chni.keys.chniKey; 
}
return nodeD;
}
static RECFIND *findNode(GNode *next, int level, FINDArgs *findArgs)
{
static RECFIND recFind;
GSList   *iter;
NSLCDATA *nodeD=NULL;
GNode  *pNodeN=NULL, *cNodeN=NULL;
gboolean found;
recFind.pNodeN = next;
recFind.nodeD = NULL;
recFind.level = level;
switch (level)
{
case IDS_NTW:
for (iter = ntw, found = FALSE;
iter;
iter = g_slist_next(iter))
{
pNodeN = iter->data;
nodeD = pNodeN->data;
if(!strcmp(nodeD->name, findArgs->trcIDs[IDS_NTW]))
{
found = TRUE;
break;
}
}
if (!found)  
break;
recFind.pNodeN = pNodeN;
*findArgs->idKeys[level] = nodeD->id;
return (findNode(recFind.pNodeN, level+1, findArgs));
break;
case IDS_STN:
case IDS_LOC:
case IDS_CHN:
{ 
int    nKids, j;
nKids = g_node_n_children(next);
for(j = 0, found = FALSE;
j < nKids;
j++, nodeD = NULL)   
{
cNodeN = g_node_nth_child(next, j);
nodeD = (NSLCDATA *) cNodeN->data;
if (!strcmp(nodeD->name, findArgs->trcIDs[level]))
{ 
found = TRUE;
break;
}
}
if (!found ||     
level == IDS_CHN)   
{
recFind.nodeD = nodeD;  
break;
}
recFind.pNodeN = cNodeN;
*findArgs->idKeys[level] = nodeD->id;
return (findNode(recFind.pNodeN, level+1, findArgs));
}
break;
}
return (&recFind);
}
static gboolean hashEQ(char *a, char *b)
{
return (!strcmp(a, b));
}
int chnID(SCAN *scanPtr, char *network, char *station, char *location, char *channel, gboolean create)
{
int    i, level, idKeys[TTLIDS];
NSLCDATA  *nodeD=NULL;
GNode  *pNodeN=NULL;
char   *trcIDs[TTLIDS], *channelNM;
CHNIArgs  chniArgs;
FINDArgs  findArgs;
RECFIND  *recFind;
static GHashTable *hashLookup;
g_static_mutex_lock(&myMutex);
if (!hashLookup)
{
hashLookup = g_hash_table_new_full(g_str_hash, (GEqualFunc) hashEQ, free, NULL);
}
channelNM = g_strdup_printf("%s%s%s%s", network, station, location, channel);
if ((nodeD = g_hash_table_lookup(hashLookup, channelNM)))
{ 
free(channelNM);
goto GETOUT;
}
trcIDs[IDS_NTW] = network;
trcIDs[IDS_STN] = station;
trcIDs[IDS_LOC] = location;
trcIDs[IDS_CHN] = channel;
memset(&findArgs,0,sizeof(FINDArgs));
for (i = 0; i < TTLIDS; i++)
{
findArgs.trcIDs[i] = trcIDs[i];   
findArgs.idKeys[i] = &idKeys[i];  
}
recFind = findNode(NULL, IDS_NTW, &findArgs);
pNodeN = recFind->pNodeN;
nodeD = recFind->nodeD;
level = recFind->level;
if (!nodeD &&
create)
{ 
memset(&chniArgs,0,sizeof(CHNIArgs));
chniArgs.scanPtr = scanPtr;
chniArgs.level = level;
chniArgs.nodeN = pNodeN;
for (i = 0;
i < TTLIDS;
i++)
{
chniArgs.trcIDs[i] = trcIDs[i];
chniArgs.idKeys[i] = &idKeys[i];
}
nodeD = makeCHNI(&chniArgs);
}
if (nodeD)
g_hash_table_insert(hashLookup, channelNM, nodeD);
GETOUT:
g_static_mutex_unlock(&myMutex);
return (nodeD ? nodeD->id : NONE);
}
static gboolean getName(GNode *node, CHNNAME *chnName)
{
NSLCDATA *nodeD=node->data;
if (nodeD->id == chnName->chni_pk)
{
chnName->chnName = nodeD->fullname;
return TRUE;
}
return FALSE;
}
char *ChnName(int chni_pk)
{
GSList  *ntwIter;
CHNNAME  chnName;
memset(&chnName, 0, sizeof(CHNNAME));
chnName.chni_pk = chni_pk;
for(ntwIter = ntwPDF; ntwIter; ntwIter = g_slist_next(ntwIter))
{
g_node_traverse(ntwIter->data, G_IN_ORDER, G_TRAVERSE_LEAVES, -1, 
(GNodeTraverseFunc) getName, &chnName);
if (chnName.chnName)
break;
}
return (chnName.chnName);
}
