#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
enum {
A_LABEL_TOP,
A_LABEL_MID,
A_LABEL_BOT
};
#define OUTSTRSIZE 20
static double p[77] = {1e-38, 1e-37, 1e-36, 1e-35, 1e-34, 1e-33, 1e-32, 1e-31, 1e-30,
1e-29, 1e-28, 1e-27, 1e-26, 1e-25, 1e-24, 1e-23, 1e-22, 1e-21,
1e-20, 1e-19, 1e-18, 1e-17, 1e-16, 1e-15, 1e-14, 1e-13, 1e-12,
1e-11, 1e-10, 1e-9, 1e-8, 1e-7, 1e-6, 1e-5, 1e-4, 1e-3, 1e-2,
1e-1, 1e0, 1e1, 1e2, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9, 1e10,
1e11, 1e12, 1e13, 1e14, 1e15, 1e16, 1e17, 1e18, 1e19, 1e20, 1e21,
1e22, 1e23, 1e24, 1e25, 1e26, 1e27, 1e28, 1e29, 1e30, 1e31, 1e32,
1e33, 1e34, 1e35, 1e36, 1e37, 1e38};
static int   majtick = 7; 
static int   midtick = 4;
static double  eps;
static int   pwr, ts, ns, pix_xmax;
static GdkPixmap *pixmap;
static GdkGC  *grct;
static graph  *locgrph;
static int   strwidth; 
static int   charheight;
static int   frmt;
static int   fontT;
static double  lastnum; 
static double  nextnum; 
static double  label_offset;
static double  startTime;
static gboolean g_eq(x, y, e)
double x, y, e;
{
if ((x < y - e) || (x > y + e))
return (0);
else
return (1);
}
static void g_xmajt(pt, xpt, ypt, inv, prt, font)
double pt;
int xpt, ypt, prt;
gboolean  inv;
int    font;
{
char outpt[OUTSTRSIZE];
int len, hz_offset, pix_x0, pix_y0;
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt - majtick);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt + majtick);
if (!ns || !prt)
return;
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0 && !startTime)
sprintf(outpt, "%.4g", pt + label_offset);
else 
{
memset(outpt, 0, OUTSTRSIZE);
if (startTime)
{ 
static int  day;
struct ptime date;
int    msec, jday;
double   startT;
startT = startTime + pt;
passcal_etoh(&date, startT);
msec = (((float) (startT - (int) startT))*1000.0);
jday = get_julday(date.mo, date.day, date.yr);
if (day != jday)
{
sprintf(outpt, "%03d %02d:%02d:%02d.%03d", jday, date.hr, date.mn, (int) date.sec, msec);
day = jday;
}
else
{
sprintf(outpt, "%02d:%02d:%02d.%03d", date.hr, date.mn, (int) date.sec, msec);
}
}
else
{ 
if (!locgrph)
sprintf(outpt, "%10.4f", pt);
else
{
if (pt >= 1.)
sprintf(outpt, "%.0f", pt);
else
if(locgrph->logx)
sprintf(outpt, "%.4f", pt);
else
sprintf(outpt, "%.1f", pt);
}
}
if (strchr(outpt, '.'))
{
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
}
for (len = 0; outpt[len] != '\0'; len++);
if (outpt[len - 1] == '.') 
{
outpt[len - 1] = '\0';
len--;
}
if (!charheight)
charheight = fontSIZEP(outpt, fontT, HEIGHT);
g_strstrip(outpt);
strwidth = fontSIZEP(outpt, fontT, WIDTH);
hz_offset = strwidth / 2;
pix_x0 = xpt - hz_offset;
nextnum = PIX2USERX(locgrph, pix_x0);
if (nextnum > lastnum) 
{ 
if (pix_x0 + strwidth > pix_xmax)
pix_x0 = pix_xmax - strwidth - 1;
if ((ns == 1) && (ts != 1))
pix_y0 = ypt - charheight - 1; 
else if ((ns == 1) && (ts == 1))
pix_y0 = ypt - 2 * majtick;
else if ((ns == -1) && (ts != -1))
pix_y0 = ypt + 2;
else if ((ns == -1) && (ts == -1))
pix_y0 = ypt + charheight + 2 * majtick;
fontDrawPGC(pixmap, outpt, pix_x0, pix_y0, font, grct);
lastnum = PIX2USERX(locgrph, xpt + hz_offset);
}
}
static void g_xmidt(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt - midtick);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt + midtick);
}
static void g_xmint(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt - midtick);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt + midtick);
}
static void g_ymajt(pt, xpt, ypt, print, pos, font)
double pt;
int xpt, ypt, pos, font;
gboolean  print;
{
int len, hz_offset, pix_x0, pix_y0;
char outpt[OUTSTRSIZE];
font = AXISF;
switch (ts)
{
case 1:
gdk_draw_line(pixmap, grct, xpt, ypt, xpt + majtick, ypt);
break;
case -1:
gdk_draw_line(pixmap, grct, xpt, ypt, xpt - majtick, ypt);
break;
}
if (!print)
return;
switch(frmt)
{
case MYFLOATSHORT:
case MYFLOAT:
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0)
sprintf(outpt, "%.5g", pt + label_offset);
else 
{
memset(outpt, 0, OUTSTRSIZE);
if (pt < 1.)
{
(frmt == MYFLOAT) 
? sprintf(outpt, "%.8f", pt)
: sprintf(outpt, "%.3f", pt);
}
else
{
if (pt < 100.)
sprintf(outpt, "%.1f", pt);
else
sprintf(outpt, "%d", (int) pt);
}
if (strstr(outpt, "."))
{ 
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
}
break;
#if 0
case MYFLOAT:
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0)
sprintf(outpt, "%.5g", pt + label_offset);
else 
{
memset(outpt, 0, OUTSTRSIZE);
if (abs(pt) < 1.)
{
sprintf(outpt, "%.12f", pt);
}
else
{
sprintf(outpt, "%.2f", pt);
}
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
break;
#endif
case MYINT:
memset(outpt, 0, OUTSTRSIZE);
sprintf(outpt, "%d", (int) pt);
break;
}
for (len = 0; outpt[len] != '\0'; len++);
if (outpt[len - 1] == '.') 
{
if(abs(atof(outpt))>=1)
outpt[len - 1] = '\0';
else
strcpy(outpt, "0.0");
}
charheight = fontSIZEP(outpt, font, HEIGHT);
hz_offset = fontSIZEP(outpt, font, WIDTH);
switch(pos) 
{
case A_LABEL_MID:
pix_y0 = ypt - charheight/2;
break;
case A_LABEL_TOP:
pix_y0 = (ns == 1) ? ypt : ypt - charheight/2;
break;
case A_LABEL_BOT:
pix_y0 = (ns == 1) ? ypt - charheight : ypt - charheight/2;
break;
}
if ((ns == 1) && (ts != 1))
pix_x0 = xpt + majtick;
else if ((ns == 1) && (ts == 1))
pix_x0 = xpt + 2 * majtick;
else if ((ns == -1) && (ts == -1))
pix_x0 = xpt - hz_offset - 2 * majtick;
else if ((ns == -1) && (ts != -1))
pix_x0 = xpt - hz_offset - majtick/2;
fontDrawPGC(pixmap, outpt, pix_x0, pix_y0, font, grct);
}
static void g_ymidt(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt + midtick, ypt);
else if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt - midtick, ypt);
}
static void g_ymint(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt + midtick, ypt);
else if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt - midtick, ypt);
}
void xaxisP(GdkPixmap *pixmp, GdkGC *grc, graph *grph, 
double x0, double y0, double xn, 
int tside, int nside, int ndivs, double offset, 
gboolean inv, double epoch, int font)
{
double xylen, ptr, cnt, divcon, mincon, maxcon;
double true_xmin, true_xmax;
int pix_x0, pix_x1, pix_y0, last_pix_x0=0, height;
double exp();
grct = grc;
pixmap = pixmp;
locgrph = grph;
startTime = epoch;
fontT = font;
gdk_drawable_get_size(pixmp, &pix_xmax, &height);
if (locgrph->logx) {
true_xmin = exp(2.302585 * locgrph->user_xmin);
true_xmax = exp(2.302585 * locgrph->user_xmax);
}
else {
true_xmin = locgrph->user_xmin;
true_xmax = locgrph->user_xmax;
}
mincon = (true_xmin < 0.) ? 1.01 :.99;
maxcon = (true_xmax < 0.) ?.99 : 1.01;
if (x0 < true_xmin * mincon || xn > true_xmax * maxcon) {
fprintf(stderr, "xaxis: x axis outside xy window\n");
return;
}
if (x0 > xn) {
fprintf(stderr, "xaxis: start point greater than end point\n");
return;
}
if ((tside != -1 && tside != 0 && tside != 1) || (nside != -1 && nside != 0 && nside != 1)) {
fprintf(stderr, "xaxis: tside and nside must be -1, 0 or 1\n");
return;
}
lastnum = true_xmin;
if (ndivs <= 1)
ndivs = 10;  
if (locgrph->logx) 
{ 
for (pwr = 76; p[pwr] > x0; pwr--);
label_offset = 0.;
}
else 
{ 
xylen = xn - x0;
for (pwr = 76; p[pwr] >= xylen; pwr--);
label_offset = offset;
}
ptr = 0.;
cnt = ((locgrph->logx == 0) ? ((double) ndivs) : 0.);
divcon = p[pwr] / (double) ndivs; 
eps =.5 * p[pwr - 2]; 
ts = tside;   
ns = nside;   
if (x0 + label_offset != 0.) {
while (1) {
if (locgrph->logx)
cnt += 1.;
if (x0 + label_offset > 0.) {
ptr += p[pwr];
if (ptr > x0 + label_offset)
break;
}
else {
ptr -= p[pwr];
if (ptr < x0 + label_offset)
break;
}
}
if (!(locgrph->logx)) {
if (x0 + label_offset < 0.)
cnt = 0.;
while (1) {
if (x0 + label_offset > 0.) {
ptr -= divcon;
cnt -= 1.;
if (ptr - eps < x0 + label_offset)
break;
}
else {
ptr += divcon;
cnt += 1.;
if (ptr + eps > x0 + label_offset)
break;
}
}
if (x0 + label_offset > 0.) {
ptr += divcon;
cnt += 1.;
}
}
}
ptr -= label_offset;
pix_x0 = USER2PIXX(locgrph, x0);
pix_x1 = USER2PIXX(locgrph, xn);
pix_y0 = USER2PIXY(locgrph, y0);
gdk_draw_line(pixmap, grct, pix_x0, pix_y0, pix_x1, pix_y0);
g_xmajt(x0, pix_x0, pix_y0, inv, TRUE, font);
if (startTime) last_pix_x0 = pix_x0 - strwidth/2;  
if (locgrph->logx) 
{
while (ptr <= xn + eps) 
{
pix_x0 = USER2PIXX(locgrph, ptr);
if (cnt == 10.) 
{
g_xmajt(ptr, pix_x0, pix_y0, inv, TRUE, font);
cnt = 1.;
pwr++;
}
else
g_xmidt(pix_x0, pix_y0);
ptr += p[pwr];
cnt += 1.;
}
}
else 
{
while (ptr <= xn + eps) 
{
pix_x0 = USER2PIXX(locgrph, ptr);
if (!startTime)
{ 
if (g_eq(cnt, (double) ndivs,.1)) 
{ 
g_xmajt(ptr, pix_x0, pix_y0, inv, TRUE, font);
cnt = 1.;
}
else {
if (g_eq(cnt, (double) ndivs *.5,.1))
g_xmidt(pix_x0, pix_y0);
else
g_xmint(pix_x0, pix_y0);
cnt += 1.;
}
}
else
{ 
if (pix_x0 >= last_pix_x0 + strwidth*1.3)
{
g_xmajt(ptr, pix_x0, pix_y0, FALSE, TRUE, font);
last_pix_x0 = pix_x0;
}
else
{
if (pix_x0 < 0)
{
fprintf(stderr, "internal error: please report (ptr=%g, xn=%g, divcon=%g)\n", 
ptr, xn, divcon);
break;
}
else
{
g_xmidt(pix_x0, pix_y0);
}
}
}
ptr += divcon;
}
}
g_xmajt(xn, pix_x1, pix_y0, inv, !inv, font);
}
void yaxisP(GdkPixmap *pixmp, GdkGC *grc, graph *grph, 
double x0, double y0, double yn, 
int tside, int nside, int ndivs, 
double offset, int format, int font)
{
double xylen, ptr, cnt, divcon, mincon, maxcon;
double true_ymin, true_ymax;
int pix_x0, pix_y0, pix_y1;
gboolean  print;
double exp();
grct = grc;
pixmap = pixmp;
locgrph = grph;
frmt = format;
print = (nside ==1 || nside == 0) ? FALSE : TRUE;
if (locgrph->logy) 
{
true_ymin = exp(2.302585 * locgrph->user_ymin);
true_ymax = exp(2.302585 * locgrph->user_ymax);
}
else 
{
true_ymin = locgrph->user_ymin;
true_ymax = locgrph->user_ymax;
}
mincon = (true_ymin < 0.) ? 1.01 :.99;
maxcon = (true_ymax < 0.) ?.99 : 1.01;
if (y0 < true_ymin * mincon || yn > true_ymax * maxcon) {
fprintf(stderr, "yaxis: y axis outside xy window\n");
return;
}
if (y0 > yn) {
fprintf(stderr, "yaxis: start point greater than end point\n");
return;
}
if ((tside != -1 && tside != 0 && tside != 1) || (nside != -1 && nside != 0 && nside != 1)) {
fprintf(stderr, "yaxis: tside and nside must be -1, 0 or 1\n");
return;
}
lastnum = true_ymin;
if (ndivs <= 0)
ndivs = 10;
if (locgrph->logy) 
{ 
for (pwr = 76; p[pwr] > y0; pwr--);
label_offset = 0.;
}
else 
{ 
xylen = yn - y0;
for (pwr = 76; p[pwr] >= xylen; pwr--);
label_offset = offset;
}
if (pwr <2)  
pwr = 2;
ptr = 0.;
cnt = ((locgrph->logy == 0) ? ((double) ndivs) : 0.);
divcon = p[pwr] / (double) ndivs;
eps =.5 * p[pwr - 2];
ts = tside;
ns = nside;
if (y0 + label_offset != 0.) {
while (1) {
if (locgrph->logy)
cnt += 1.;
if (y0 + label_offset > 0.) 
{
ptr += p[pwr];
if (ptr > y0 + label_offset)
break;
}
else 
{
ptr -= p[pwr];
if (ptr < y0 + label_offset)
break;
}
}
if (!(locgrph->logy)) {
if (y0 + label_offset < 0.)
cnt = 0.;
while (1) {
if (y0 + label_offset > 0.) {
ptr -= divcon;
cnt -= 1.;
if (ptr - eps < y0 + label_offset)
break;
}
else {
ptr += divcon;
cnt += 1.;
if (ptr + eps > y0 + label_offset)
break;
}
}
if (y0 + label_offset > 0.) {
ptr += divcon;
cnt += 1.;
}
}
}
ptr -= label_offset;
pix_x0 = USER2PIXX(locgrph, x0);
pix_y0 = USER2PIXY(locgrph, y0);
pix_y1 = USER2PIXY(locgrph, yn);
gdk_draw_line(pixmap, grct, pix_x0, pix_y0, pix_x0, pix_y1);
g_ymajt(y0, pix_x0, pix_y0, (font == AXISF) ? FALSE : TRUE, A_LABEL_BOT, font);
if (locgrph->logy) {
while (ptr <= yn + eps) {
pix_y0 = USER2PIXY(locgrph, ptr);
if (cnt == 10.) {
g_ymajt(ptr, pix_x0, pix_y0, (font == AXISF) ? FALSE : print, A_LABEL_MID, font);
cnt = 1.;
pwr++;
}
else
g_ymidt(pix_x0, pix_y0);
ptr += p[pwr];
cnt += 1.;
}
}
else {
while (ptr <= yn + eps) {
pix_y0 = USER2PIXY(locgrph, ptr);
if (g_eq(cnt, (double) ndivs,.1)) {
g_ymajt(ptr, pix_x0, pix_y0, (font == AXISF) ? FALSE : print, A_LABEL_MID, font);
cnt = 1.;
}
else {
if (g_eq(cnt, (double) ndivs *.5,.1))
g_ymidt(pix_x0, pix_y0);
else
g_ymint(pix_x0, pix_y0);
cnt += 1.;
}
ptr += divcon;
}
}
g_ymajt(yn, pix_x0, pix_y1, (font == AXISF) ? FALSE : TRUE, A_LABEL_TOP, font);
}
int yrEnd(int yr)
{
return passcal_isleap(yr) ? 366 : 365;
}
int getTotalDays(int *start, int *end)
{
int  i, totalD;
totalD = (yrEnd(start[YEARH]) - start[JDAYH] + 1) + 
(start[YEARH] < end[YEARH] ? end[JDAYH] : (yrEnd(end[YEARH])-end[JDAYH])*(-1));
for(i=start[YEARH]+1;i<end[YEARH];i++)
{ 
totalD += yrEnd(i);
}
return totalD;
}
void xAxisDAYS(XAXISDAYSARGS *axisArgs)
{
GdkPixmap *pixmap = axisArgs->plot.pixmap;
int  pWidth = axisArgs->width, pHeight = axisArgs->height;
GdkGC *gc = axisArgs->gc;
graph *GR = axisArgs->GR;
int  *start = axisArgs->start, *end = axisArgs->end, type = axisArgs->type;
int  iSv, y1, y2, lastEnd, oldYr, startT, tick;
int  x, yS, yE, i, days, xStr;
int  fontW1, fontW2;
gchar *dispStr;
switch (type)
{
case XAXISDAYSPDFHOUR:
startT = 1;
tick = -1;
break;
case XAXISDAYSSPECTRO:
startT = 0;
tick = -1;
break;
}
days = getTotalDays(start, end) + startT;
yS=pHeight-PDFBOTM;
yE=pHeight-PDFBOTM + (4 * tick);
dispStr = g_strdup("2006");
fontW1 = fontSIZEP(dispStr, AXISF, WIDTH)/2;
free(dispStr);
y1 = pHeight-PDFBOTM+1;
y2 = pHeight-PDFBOTM/2-2;
end[YEARH] = start[YEARH]; end[JDAYH] = start[JDAYH];
for(lastEnd = oldYr = 0, i= iSv = startT; i < days; i++)
{
x=USER2PIXX(GR, (double) i);
if((lastEnd+10) < (x-fontW1))
{ 
end[JDAYH] += (i-iSv);
if (end[JDAYH] > yrEnd(end[YEARH]))
{
end[JDAYH]-= yrEnd(end[YEARH]);
end[YEARH]++;
} 
if (oldYr != end[YEARH])
{
dispStr = g_strdup_printf("%d", end[YEARH]);
fontW1 = fontSIZEP(dispStr, AXISF, WIDTH)/2;
xStr = (x-fontW1) < GR->pix_xmin ? GR->pix_xmin : (x-fontW1); 
fontDrawP(pixmap, dispStr, xStr, y1, AXISF, PDFFTEXT);
oldYr = end[YEARH];
free(dispStr);
}
dispStr = g_strdup_printf("%03d", end[JDAYH]);
fontW2 = fontSIZEP(dispStr, AXISF, WIDTH)/2;
xStr = (x-fontW2) < GR->pix_xmin ? GR->pix_xmin : (x-fontW2); 
fontDrawP(pixmap, dispStr, xStr, y2, AXISF, PDFFTEXT);
free(dispStr);
gdk_draw_line(pixmap, gc, x, yS, x, yE);
iSv = i;
lastEnd = xStr + fontW1;
}
}
gdk_draw_line(pixmap, gc, PDFSIDEM, yS, pWidth-PDFSIDEM-1, yS);
}
static int bdryIvals[] = { 
60, 120, 300,       
600, 900, 1800, 2700,     
3600, 7200, 14400, 21600, 43200, 86400 
};
void xAxisTIME(XAXISDAYSARGS *axisArgs)
{ 
GdkPixmap *pmap = axisArgs->plot.pixmap;
int  pWidth = axisArgs->width;
GdkGC *gc = axisArgs->gc;
graph *GR = axisArgs->GR;
double start = axisArgs->startE;
struct ptime date;
int   x, y, y1, y2, x1, x2, yPos=GR->pix_ymin-1, curYr;
int   i, labelW, dir=0, ttl;
double  nextPrint;
int   incIval;
gchar  *label;
dir = -1;
passcal_etoh(&date, start);
curYr = date.yr;
x1 = 0;        
y1 = USER2PIXY(GR, (double) 0);  
label = g_strdup_printf("%02i:%02i", date.hr, date.mn);
y2 = USER2PIXY(GR, (double) (fontSIZEP(label, AXISF, HEIGHT))); 
free(label);
ttl = sizeof(bdryIvals)/sizeof(int);
for(i=0;
i < ttl &&
(float) (GR->user_xdif/15) > (float) bdryIvals[i]; 
i++);
if (i==ttl)
{
for (i = 2;
(float) (GR->user_xdif/15) > (float) i * ONEDAYOFSECS;
i += 2);
incIval = i * ONEDAYOFSECS;
}
else
{
incIval = bdryIvals[i];
}
if (incIval > 1)
{
for(nextPrint = (int) start+1;
(int) nextPrint % incIval;
nextPrint++);
}
for(; 
nextPrint < start + GR->user_xdif;
nextPrint += incIval)
{
passcal_etoh(&date, nextPrint);
if (incIval < 1)
{ 
if (!date.hr && !date.mn && !((int)date.sec) && 
!((int) ((date.sec - (int) date.sec)*10)))
label = g_strdup_printf("%04i:%03i", date.yr, get_julday(date.mo, date.day, date.yr));
else
label = g_strdup_printf("%02i:%02i:%02i.%1d", date.hr, date.mn, (int) date.sec, 
(int) ((date.sec - (int) date.sec)*10));
}
else if (incIval < 60) 
{ 
if (!date.hr && !date.mn && !((int)date.sec))
label = g_strdup_printf("%04i:%03i", date.yr, get_julday(date.mo, date.day, date.yr));
else
label = g_strdup_printf("%02i:%02i:%02i", date.hr, date.mn, (int) date.sec);
}
else
{
if (!date.hr && !date.mn)
{
y = y2;
if (curYr == date.yr)
label = g_strdup_printf("%03i", get_julday(date.mo, date.day, date.yr));
else
{
label = g_strdup_printf("%04i:%03i", date.yr, get_julday(date.mo, date.day, date.yr));
curYr = date.yr;
}
}
else
{
y = y1;
label = g_strdup_printf("%02i:%02i", date.hr, date.mn);  
}
}
x = USER2PIXX(GR, (nextPrint-start));
gdk_draw_line(pmap, gc, x, yPos, x, yPos+(4*dir));
labelW = fontSIZEP(label, AXISF, WIDTH);
x2 = x - labelW/2;
if (x2 < x1 + 5)
goto NEXTLOOP;
if (x2 < GR->pix_xmin)
x2 = GR->pix_xmin;
else if (x2 + labelW > pWidth)
x2 = pWidth - labelW - 1;
fontDrawP(pmap, label, x2, y, AXISF, PDFFTEXT);
x1 = x2 + labelW; 
NEXTLOOP:
free(label);
}
gdk_draw_line(pmap, gc, GR->pix_xmin, GR->pix_ymin-1, GR->pix_xmax, GR->pix_ymin-1);
}
