#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#define MIDM 0
#define BELOW 1
#define ABOVE 2
static double 
p[77] = {1e-38, 1e-37, 1e-36, 1e-35, 1e-34, 1e-33, 1e-32, 1e-31, 1e-30,
1e-29, 1e-28, 1e-27, 1e-26, 1e-25, 1e-24, 1e-23, 1e-22, 1e-21,
1e-20, 1e-19, 1e-18, 1e-17, 1e-16, 1e-15, 1e-14, 1e-13, 1e-12,
1e-11, 1e-10, 1e-9, 1e-8, 1e-7, 1e-6, 1e-5, 1e-4, 1e-3, 1e-2,
1e-1, 1e0, 1e1, 1e2, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9, 1e10,
1e11, 1e12, 1e13, 1e14, 1e15, 1e16, 1e17, 1e18, 1e19, 1e20, 1e21,
1e22, 1e23, 1e24, 1e25, 1e26, 1e27, 1e28, 1e29, 1e30, 1e31, 1e32,
1e33, 1e34, 1e35, 1e36, 1e37, 1e38};
static int majtick = 7; 
static int midtick = 4;
typedef struct _axisArgs
{
graph *locgrph;
double lastnum; 
double   startTime;
int    pwr, ts, ns, pix_xmax;
cairo_t   *cr;
int    format;
} AXISARGS;
static gboolean g_eq(x, y, e)
double x, y, e;
{
if ((x < y - e) || (x > y + e))
return (0);
else
return (1);
}
static int g_xmajt(pt, xpt, ypt, inv, prt, font, axisArgs, label_offset)
double pt;
int xpt, ypt, prt;
gboolean  inv;
int    font;
AXISARGS  *axisArgs;
double   label_offset;
{
char outpt[20];
int strwidth, charheight=0; 
int len, hz_offset, pix_x0, pix_y0;
double   nextnum, startTime, *lastnum;
int    pwr, ts, ns, pix_xmax;
graph   *locgrph;
cairo_t   *cr;
ts = axisArgs->ts;
ns = axisArgs->ns;
pwr = axisArgs->pwr;
pix_xmax = axisArgs->pix_xmax;
locgrph = axisArgs->locgrph;
startTime = axisArgs->startTime;
cr = axisArgs->cr;
lastnum = &axisArgs->lastnum;
if (ts == 1)
{
cairo_move_to(cr, xpt+.5, ypt+.5);
cairo_line_to(cr, xpt+.5, ypt - majtick+.5);
}
else 
if (ts == -1)
{
cairo_move_to(cr, xpt+.5, ypt+.5);
cairo_line_to(cr, xpt+.5, ypt + majtick+.5);
}
if (!ns || !prt)
return 0;
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0 && !startTime)
sprintf(outpt, "%.4g", pt + label_offset);
else 
{
memset(outpt, 0, 20);
if (startTime)
{ 
static int  day;
struct ptime  date;
int    msec, jday;
double   startT;
startT = startTime + pt;
passcal_etoh(&date, startT);
msec = (((float) (startT - (int) startT))*1000.0);
jday = get_julday(date.mo, date.day, date.yr);
if (day != jday)
{
sprintf(outpt, "%03d %02d:%02d:%02d.%03d", 
jday, date.hr, date.mn, (int) date.sec, msec);
day = jday;
}
else
{
sprintf(outpt, "%02d:%02d:%02d.%03d", 
date.hr, date.mn, (int) date.sec, msec);
}
}
else
{ 
if (!locgrph)
sprintf(outpt, "%10.4f", pt);
else
{
if (pt >= 1.)
sprintf(outpt, "%.0f", pt);
else
sprintf(outpt, "%.1f", pt);
}
}
if (strchr(outpt, '.'))
{
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
}
for (len = 0; outpt[len] != '\0'; len++);
if (outpt[len - 1] == '.') 
{
outpt[len - 1] = '\0';
len--;
}
if (!charheight)
charheight = fontSIZEPCairo(cr, outpt, font, HEIGHT);
g_strstrip(outpt);
strwidth = fontSIZEPCairo(cr, outpt, font, WIDTH);
hz_offset = strwidth / 2;
pix_x0 = xpt - hz_offset;
nextnum = PIX2USERX(locgrph, pix_x0);
if (nextnum > *lastnum) 
{ 
if (pix_x0 + strwidth > pix_xmax)
pix_x0 = pix_xmax - strwidth - 1;
if ((ns == 1) && (ts != 1))
pix_y0 = ypt - majtick - 10;
else if ((ns == 1) && (ts == 1))
pix_y0 = ypt - 2 * majtick;
else if ((ns == -1) && (ts != -1))
pix_y0 = ypt + 2;
else if ((ns == -1) && (ts == -1))
pix_y0 = ypt + charheight + 2 * majtick;
fontDrawPCairo(cr, outpt, pix_x0, pix_y0, font, FALSE);
*lastnum = PIX2USERX(locgrph, xpt + hz_offset);
}
return strwidth;
}
static void g_xmidt(xpt, ypt, axisArgs)
int xpt, ypt;
AXISARGS  *axisArgs;
{
int ts = axisArgs->ts;
cairo_t *cr = axisArgs->cr;
if (ts == 1)
{
cairo_move_to(cr, xpt+.5, ypt+.5);
cairo_line_to(cr, xpt+.5, ypt - midtick+.5);
}
else 
if (ts == -1)
{
cairo_move_to(cr, xpt+.5, ypt+.5);
cairo_line_to(cr, xpt+.5, ypt + midtick+.5);
}
}
static void g_xmint(xpt, ypt, axisArgs)
int xpt, ypt;
AXISARGS  *axisArgs;
{
int ts = axisArgs->ts;
cairo_t *cr = axisArgs->cr;
if (ts == 1)
{
cairo_move_to(cr, xpt+.5, ypt+.5);
cairo_line_to(cr, xpt+.5, ypt - midtick+.5);
}
else 
if (ts == -1)
{
cairo_move_to(cr, xpt+.5, ypt+.5);
cairo_line_to(cr, xpt+.5, ypt + midtick+.5);
}
}
void xaxisPCairo(cairo_surface_t *surface, graph *grph, 
double x0, double y0, double xn, 
int tside, int nside, int ndivs, double offset, 
gboolean inv, double epoch, int font)
{
double xylen, ptr, cnt, divcon, mincon, maxcon;
double true_xmin, true_xmax, eps, startTime;
int pix_x0, pix_x1, pix_y0, last_pix_x0=0, strwidth;
double exp(), label_offset;
cairo_t   *cr;
AXISARGS  axisArgs;
graph   *locgrph;
axisArgs.locgrph = locgrph = grph;
if (locgrph->logx) 
{
true_xmin = exp(2.302585 * locgrph->user_xmin);
true_xmax = exp(2.302585 * locgrph->user_xmax);
}
else 
{
true_xmin = locgrph->user_xmin;
true_xmax = locgrph->user_xmax;
}
axisArgs.lastnum = true_xmin;
mincon = (true_xmin < 0.) ? 1.01 :.99;
maxcon = (true_xmax < 0.) ?.99 : 1.01;
if (x0 < true_xmin * mincon || xn > true_xmax * maxcon) {
fprintf(stderr, "xaxis: x axis outside xy window\n");
return;
}
if (x0 > xn) {
fprintf(stderr, "xaxis: start point greater than end point\n");
return;
}
if ((tside != -1 && tside != 0 && tside != 1) || (nside != -1 && nside != 0 && nside != 1)) {
fprintf(stderr, "xaxis: tside and nside must be -1, 0 or 1\n");
return;
}
axisArgs.startTime = startTime = epoch;
axisArgs.cr = cr = cairo_create(surface);
axisArgs.pix_xmax = cairo_image_surface_get_width(surface);
axisArgs.ts = tside;
axisArgs.ns = nside;
cairo_set_line_width(cr, 1.0);
if (ndivs <= 1)
ndivs = 10;  
if (locgrph->logx) 
{
for (axisArgs.pwr = 76; p[axisArgs.pwr] > x0; axisArgs.pwr--);
label_offset = 0.;
}
else 
{
xylen = xn - x0;
for (axisArgs.pwr = 76; p[axisArgs.pwr] >= xylen; axisArgs.pwr--);
label_offset = offset;
}
ptr = 0.;
cnt = ((locgrph->logx == 0) ? ((double) ndivs) : 0.);
divcon = p[axisArgs.pwr] / (double) ndivs; 
eps =.5 * p[axisArgs.pwr - 2]; 
if (x0 + label_offset != 0.) {
while (1) {
if (locgrph->logx)
cnt += 1.;
if (x0 + label_offset > 0.) {
ptr += p[axisArgs.pwr];
if (ptr > x0 + label_offset)
break;
}
else {
ptr -= p[axisArgs.pwr];
if (ptr < x0 + label_offset)
break;
}
}
if (!(locgrph->logx)) {
if (x0 + label_offset < 0.)
cnt = 0.;
while (1) {
if (x0 + label_offset > 0.) {
ptr -= divcon;
cnt -= 1.;
if (ptr - eps < x0 + label_offset)
break;
}
else {
ptr += divcon;
cnt += 1.;
if (ptr + eps > x0 + label_offset)
break;
}
}
if (x0 + label_offset > 0.) {
ptr += divcon;
cnt += 1.;
}
}
}
ptr -= label_offset;
pix_x0 = USER2PIXX(locgrph, x0);
pix_x1 = USER2PIXX(locgrph, xn);
pix_y0 = USER2PIXY(locgrph, y0);
cairo_move_to(cr, pix_x0+.5, pix_y0+.5);
cairo_line_to(cr, pix_x1+.5, pix_y0+.5);
strwidth = g_xmajt(x0, pix_x0, pix_y0, inv, TRUE, font, &axisArgs, label_offset);
if (startTime) last_pix_x0 = pix_x0 - strwidth/2;  
if (locgrph->logx) 
{
while (ptr <= xn + eps) 
{
pix_x0 = USER2PIXX(locgrph, ptr);
if (cnt == 10.) 
{
strwidth = g_xmajt(ptr, pix_x0, pix_y0, inv, TRUE, font, &axisArgs, label_offset);
cnt = 1.;
axisArgs.pwr++;
}
else
g_xmidt(pix_x0, pix_y0, &axisArgs);
ptr += p[axisArgs.pwr];
cnt += 1.;
}
}
else 
{
while (ptr <= xn + eps) 
{
pix_x0 = USER2PIXX(locgrph, ptr);
if (!startTime)
{ 
if (g_eq(cnt, (double) ndivs,.1)) 
{ 
strwidth = g_xmajt(ptr, pix_x0, pix_y0, inv, TRUE, font, &axisArgs, label_offset);
cnt = 1.;
}
else {
if (g_eq(cnt, (double) ndivs *.5,.1))
g_xmidt(pix_x0, pix_y0, &axisArgs);
else
g_xmint(pix_x0, pix_y0, &axisArgs);
cnt += 1.;
}
}
else
{ 
if (pix_x0 >= last_pix_x0 + strwidth*1.3)
{
strwidth = g_xmajt(ptr, pix_x0, pix_y0, FALSE, TRUE, font, &axisArgs, label_offset);
last_pix_x0 = pix_x0;
}
else
{
if (pix_x0 < 0)
{
fprintf(stderr, "internal error: please report (ptr=%g, xn=%g, divcon=%g)\n", 
ptr, xn, divcon);
break;
}
else
{
g_xmidt(pix_x0, pix_y0, &axisArgs);
}
}
}
ptr += divcon;
}
}
strwidth = g_xmajt(xn, pix_x1, pix_y0, inv, !inv, font, &axisArgs, label_offset);
cairo_stroke(cr);
cairo_destroy(cr);
}
static void g_ymajt(pt, xpt, ypt, print, pos, font, axisArgs, label_offset)
double pt;
int xpt, ypt, print, pos, font;
AXISARGS  *axisArgs;
double   label_offset;
{
int len, hz_offset, pix_x0, pix_y0;
int    ts, ns, pwr, charheight, frmt;
char outpt[20];
cairo_t   *cr;
ts = axisArgs->ts;
ns = axisArgs->ns;
pwr = axisArgs->pwr;
cr = axisArgs->cr;
frmt = axisArgs->format;
switch (ts)
{ 
case 1:
pix_x0 = xpt + majtick;
break;
case -1:
pix_x0 = xpt - majtick;
break;
}
if (ts != 0)
{
cairo_move_to(cr, xpt, ypt+.5);
cairo_line_to(cr, pix_x0, ypt+.5);
}
if (ns == 0 || print == 0)
return;
switch(frmt)
{
case MYFLOATSHORT:
case MYFLOAT:
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0)
sprintf(outpt, "%.5g", pt + label_offset);
else 
{
memset(outpt, 0, 20);
if (pt < 1.)
{
(frmt == MYFLOAT) 
? sprintf(outpt, "%.8f", pt)
: sprintf(outpt, "%.3f", pt);
}
else
{
if (pt < 100.)
sprintf(outpt, "%.1f", pt);
else
sprintf(outpt, "%d", (int) pt);
}
if (strstr(outpt, "."))
{ 
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
}
break;
case MYINT:
memset(outpt, 0, 20);
sprintf(outpt, "%d", (int) pt);
break;
}
for (len = 0; outpt[len] != '\0'; len++);
if (outpt[len - 1] == '.') 
{
if(abs(atof(outpt))>=1)
outpt[len - 1] = '\0';
else
strcpy(outpt, "0.0");
}
charheight = fontSIZEPCairo(cr, outpt, font, HEIGHT);
hz_offset = fontSIZEPCairo(cr, outpt, font, WIDTH);
switch(pos) 
{
case MIDM:
pix_y0 = ypt - charheight/2;
break;
case BELOW:
pix_y0 = ypt - 4;
break;
case ABOVE:
pix_y0 = ypt - charheight/2;
break;
}
if ((ns == 1) && (ts != 1))
pix_x0 = xpt + majtick;
else if ((ns == 1) && (ts == 1))
pix_x0 = xpt + 2 * majtick;
else if ((ns == -1) && (ts == -1))
pix_x0 = xpt - hz_offset - 2 * majtick;
else if ((ns == -1) && (ts != -1))
pix_x0 = xpt - hz_offset - majtick/2;
fontDrawPCairo(cr, outpt, pix_x0, pix_y0, font, FALSE);
}
static void g_ymidt(xpt, ypt, axisArgs)
int xpt, ypt;
AXISARGS  *axisArgs;
{
int ts = axisArgs->ts;
cairo_t *cr = axisArgs->cr;
if (ts == 1)
{
cairo_move_to(cr, xpt, ypt+.5);
cairo_line_to(cr, xpt + midtick, ypt+.5);
}
else if (ts == -1)
{
cairo_move_to(cr, xpt, ypt+.5);
cairo_line_to(cr, xpt - midtick, ypt+.5);
}
}
static void g_ymint(xpt, ypt, axisArgs)
int xpt, ypt;
AXISARGS  *axisArgs;
{
int ts = axisArgs->ts;
cairo_t *cr = axisArgs->cr;
if (ts == 1)
{
cairo_move_to(cr, xpt, ypt+.5);
cairo_line_to(cr, xpt + midtick, ypt+.5);
}
else if (ts == -1)
{
cairo_move_to(cr, xpt, ypt+.5);
cairo_line_to(cr, xpt - midtick, ypt+.5);
}
}
void yaxisPCairo(cairo_surface_t *surface, graph *grph, 
double x0, double y0, double yn, 
int tside, int nside, int ndivs, 
double offset, int format, int font)
{
double xylen, ptr, cnt, divcon, mincon, maxcon;
double true_ymin, true_ymax, eps;
int pix_x0, pix_y0, pix_y1, pwr, label_offset;
double exp();
AXISARGS  axisArgs;
graph   *locgrph;
cairo_t   *cr;
axisArgs.locgrph = locgrph = grph;
if (locgrph->logy) {
true_ymin = exp(2.302585 * locgrph->user_ymin);
true_ymax = exp(2.302585 * locgrph->user_ymax);
}
else {
true_ymin = locgrph->user_ymin;
true_ymax = locgrph->user_ymax;
}
mincon = (true_ymin < 0.) ? 1.01 :.99;
maxcon = (true_ymax < 0.) ?.99 : 1.01;
if (y0 < true_ymin * mincon || yn > true_ymax * maxcon) {
fprintf(stderr, "yaxis: y axis outside xy window\n");
return;
}
if (y0 > yn) {
fprintf(stderr, "yaxis: start point greater than end point\n");
return;
}
if ((tside != -1 && tside != 0 && tside != 1) || (nside != -1 && nside != 0 && nside != 1)) {
fprintf(stderr, "yaxis: tside and nside must be -1, 0 or 1\n");
return;
}
axisArgs.cr = cr = cairo_create(surface);
axisArgs.pix_xmax = cairo_image_surface_get_width(surface);
axisArgs.ts = tside;
axisArgs.ns = nside;
axisArgs.format = format;
cairo_set_line_width(cr, 1.0);
if (ndivs <= 0)
ndivs = 10;
if (locgrph->logy) 
{ 
for (pwr = 76; p[pwr] > y0; pwr--);
label_offset = 0.;
}
else 
{ 
xylen = yn - y0;
for (pwr = 76; p[pwr] >= xylen; pwr--);
label_offset = offset;
}
if (pwr <2)  
pwr = 2;
ptr = 0.;
cnt = ((locgrph->logy == 0) ? ((double) ndivs) : 0.);
divcon = p[pwr] / (double) ndivs;
eps =.5 * p[pwr - 2];
if (y0 + label_offset != 0.) 
{
while (1) 
{
if (locgrph->logy)
cnt += 1.;
if (y0 + label_offset > 0.) 
{
ptr += p[pwr];
if (ptr > y0 + label_offset)
break;
}
else 
{
ptr -= p[pwr];
if (ptr < y0 + label_offset)
break;
}
}
if (!(locgrph->logy)) 
{ 
if (y0 + label_offset < 0.)
cnt = 0.;
while (1) 
{
if (y0 + label_offset > 0.) 
{
ptr -= divcon;
cnt -= 1.;
if (ptr - eps < y0 + label_offset)
break;
}
else 
{
ptr += divcon;
cnt += 1.;
if (ptr + eps > y0 + label_offset)
break;
}
}
if (y0 + label_offset > 0.) 
{ 
ptr += divcon;
cnt += 1.;
}
}
}
ptr -= label_offset;
pix_x0 = USER2PIXX(locgrph, x0);
pix_y0 = USER2PIXY(locgrph, y0);
pix_y1 = USER2PIXY(locgrph, yn);
cairo_move_to(cr, pix_x0+.5, pix_y0+.5);
cairo_line_to(cr, pix_x0+.5, pix_y1+.5);
axisArgs.pwr = pwr;
g_ymajt(y0, pix_x0, pix_y0, 1, ABOVE, font, &axisArgs, label_offset);
if (locgrph->logy) 
{
while (ptr <= yn + eps) 
{
pix_y0 = USER2PIXY(locgrph, ptr);
axisArgs.pwr = pwr;
if (cnt == 10.) 
{
g_ymajt(ptr, pix_x0, pix_y0, TRUE, MIDM, font, &axisArgs, label_offset);
cnt = 1.;
pwr++;
}
else
{
g_ymidt(pix_x0, pix_y0, &axisArgs);
}
ptr += p[pwr];
cnt += 1.;
}
}
else 
{
while (ptr <= yn + eps) 
{
pix_y0 = USER2PIXY(locgrph, ptr);
if (g_eq(cnt, (double) ndivs,.1)) 
{
g_ymajt(ptr, pix_x0, pix_y0, TRUE, MIDM, font, &axisArgs, label_offset);
cnt = 1.;
}
else 
{ 
if (g_eq(cnt, (double) ndivs *.5,.1))
g_ymidt(pix_x0, pix_y0, &axisArgs);
else
g_ymint(pix_x0, pix_y0, &axisArgs);
cnt += 1.;
}
ptr += divcon;
}
}
g_ymajt(yn, pix_x0, pix_y1, TRUE, BELOW, font, &axisArgs, label_offset);
cairo_stroke(cr);
cairo_destroy(cr);
}
void xAxisDAYSCairo(XAXISDAYSARGS *axisArgs)
{
cairo_surface_t *surface = axisArgs->plot.surface;
cairo_t *cr;
int  pWidth = axisArgs->width, pHeight = axisArgs->height;
graph *GR = axisArgs->GR;
int  *start = axisArgs->start, *end = axisArgs->end, type = axisArgs->type;
int  iSv, y1, y2, lastEnd, oldYr, startT, tick;
int  x, yS, yE, i, days, xStr;
int  fontW1, fontW2;
gchar *dispStr;
cr = cairo_create(surface);
cairo_set_line_width(cr, 1.0);
switch (type)
{
case XAXISDAYSPDFHOUR:
startT = 1;
tick = -1;
break;
case XAXISDAYSSPECTRO:
startT = 0;
tick = -1;
break;
}
days = getTotalDays(start, end) + startT;
yS=pHeight-PDFBOTM;
yE=pHeight-PDFBOTM + (4 * tick);
dispStr = g_strdup("2006");
fontW1 = fontSIZEPCairo(cr, dispStr, AXISF, WIDTH)/2;
free(dispStr);
y1 = pHeight-PDFBOTM+1;
y2 = pHeight-PDFBOTM/2-2;
end[YEARH] = start[YEARH]; end[JDAYH] = start[JDAYH];
for(lastEnd=oldYr=0,i=iSv=startT; i<days; i++)
{
x=USER2PIXX(GR, (double) i);
if((lastEnd+10) < (x-fontW1))
{ 
end[JDAYH] += (i-iSv);
if (end[JDAYH] > yrEnd(end[YEARH]))
{
end[JDAYH]-= yrEnd(end[YEARH]);
end[YEARH]++;
} 
if (oldYr != end[YEARH])
{
dispStr = g_strdup_printf("%d", end[YEARH]);
fontW1 = fontSIZEPCairo(cr, dispStr, AXISF, WIDTH)/2;
xStr = (x-fontW1) < GR->pix_xmin ? GR->pix_xmin : (x-fontW1); 
fontDrawPCairo(cr, dispStr, xStr, y1, AXISF, FALSE);
oldYr = end[YEARH];
free(dispStr);
}
dispStr = g_strdup_printf("%03d", end[JDAYH]);
fontW2 = fontSIZEPCairo(cr, dispStr, AXISF, WIDTH)/2;
xStr = (x-fontW2) < GR->pix_xmin ? GR->pix_xmin : (x-fontW2); 
fontDrawPCairo(cr, dispStr, xStr, y2, AXISF, FALSE);
free(dispStr);
cairo_move_to(cr, x+.5, yS);
cairo_line_to(cr, x+.5, yE);
iSv = i;
lastEnd = xStr + fontW1;
}
}
cairo_move_to(cr, PDFSIDEM, yS+.5);
cairo_line_to(cr, pWidth-PDFSIDEM-1, yS+.5);
cairo_stroke(cr);
cairo_destroy(cr);
}
static int bdryIvals[] = { 
60, 120, 300,       
600, 900, 1800, 2700,     
3600, 7200, 14400, 21600, 43200, 86400 
};
void xAxisTIMECairo(XAXISDAYSARGS *axisArgs)
{ 
cairo_surface_t *surface = axisArgs->plot.surface;
cairo_t *cr;
int  pWidth = axisArgs->width;
graph *GR = axisArgs->GR;
double start = axisArgs->startE;
struct ptime date;
int   x, y, y1, y2, x1, x2, yPos=GR->pix_ymin-1, curYr;
int   i, labelW, dir=0, ttl;
double  nextPrint;
int   incIval;
gchar  *label;
cr = cairo_create(surface);
cairo_set_line_width(cr, 1.0);
dir = -1;
passcal_etoh(&date, start);
curYr = date.yr;
x1 = 0;        
y1 = USER2PIXY(GR, (double) 0);  
label = g_strdup_printf("%02i:%02i", date.hr, date.mn);
y2 = USER2PIXY(GR, (double) (fontSIZEPCairo(cr, label, AXISF, HEIGHT))); 
free(label);
ttl = sizeof(bdryIvals)/sizeof(int);
for(i=0;
i < ttl &&
(float) (GR->user_xdif/15) > (float) bdryIvals[i]; 
i++);
if (i==ttl)
{
for (i = 2;
(float) (GR->user_xdif/15) > (float) i * ONEDAYOFSECS;
i += 2);
incIval = i * ONEDAYOFSECS;
}
else
{
incIval = bdryIvals[i];
}
if (incIval > 1)
{
for(nextPrint = (int) start+1;
(int) nextPrint % incIval;
nextPrint++);
}
for(; 
nextPrint < start + GR->user_xdif;
nextPrint += incIval)
{
passcal_etoh(&date, nextPrint);
if (incIval < 1)
{ 
if (!date.hr && !date.mn && !((int)date.sec) && 
!((int) ((date.sec - (int) date.sec)*10)))
label = g_strdup_printf("%04i:%03i", date.yr, get_julday(date.mo, date.day, date.yr));
else
label = g_strdup_printf("%02i:%02i:%02i.%1d", date.hr, date.mn, (int) date.sec, 
(int) ((date.sec - (int) date.sec)*10));
}
else if (incIval < 60) 
{ 
if (!date.hr && !date.mn && !((int)date.sec))
label = g_strdup_printf("%04i:%03i", date.yr, get_julday(date.mo, date.day, date.yr));
else
label = g_strdup_printf("%02i:%02i:%02i", date.hr, date.mn, (int) date.sec);
}
else
{
if (!date.hr && !date.mn)
{
y = y2;
if (curYr == date.yr)
label = g_strdup_printf("%03i", get_julday(date.mo, date.day, date.yr));
else
{
label = g_strdup_printf("%04i:%03i", date.yr, get_julday(date.mo, date.day, date.yr));
curYr = date.yr;
}
}
else
{
y = y1;
label = g_strdup_printf("%02i:%02i", date.hr, date.mn);  
}
}
x = USER2PIXX(GR, (nextPrint-start));
cairo_move_to(cr, x, yPos+.5);
cairo_line_to(cr, x, yPos+(4*dir)+.5);
labelW = fontSIZEPCairo(cr, label, AXISF, WIDTH);
x2 = x - labelW/2;
if (x2 < x1 + 5)
goto NEXTLOOP;
if (x2 < GR->pix_xmin)
x2 = GR->pix_xmin;
else if (x2 + labelW > pWidth)
x2 = pWidth - labelW - 1;
fontDrawPCairo(cr, label, x2, y, AXISF, FALSE);
x1 = x2 + labelW; 
NEXTLOOP:
free(label);
}
cairo_move_to(cr, GR->pix_xmin, GR->pix_ymin-1+.5);
cairo_line_to(cr, GR->pix_xmax, GR->pix_ymin-1+.5);
cairo_stroke(cr);
cairo_destroy(cr);
}
