#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_pdf.h"
#include "pqlx_stn.h"
#include "gtk_pdf_externs.h"
#define SPANSTR "<span"
static struct {
PangoContext *context;
PangoFontDescription *desc;
} font[NUMFONTTYPES];
static GdkGC *gc[NUMFONTGCS][3];
void makeFONTGC(int which, GdkColor *fg, GdkColor *bg)
{
GdkPixmap *pmap;
GdkGC  **ctxt = (GdkGC **) &gc[which];
gint depth = gdk_visual_get_best_depth();
depth = (depth > 24 ) ? 24 : depth;  
pmap=gdk_pixmap_new(NULL, 100, 100, depth); 
if (ctxt[NORMALGC])
{
g_object_unref(ctxt[NORMALGC]);
g_object_unref(ctxt[ABNORMALGC]);
g_object_unref(ctxt[INVGC]);
}
ctxt[NORMALGC] = gdk_gc_new(pmap);
gdk_gc_set_rgb_fg_color(ctxt[NORMALGC], fg);
gdk_gc_set_rgb_bg_color(ctxt[NORMALGC], bg);
ctxt[ABNORMALGC] = gdk_gc_new(pmap);
gdk_gc_set_rgb_bg_color(ctxt[ABNORMALGC], fg);
gdk_gc_set_rgb_fg_color(ctxt[ABNORMALGC], bg);
ctxt[INVGC] = gdk_gc_new(pmap);
gdk_gc_set_rgb_bg_color(ctxt[INVGC], bg);
gdk_gc_set_rgb_fg_color(ctxt[INVGC], fg);
gdk_gc_set_function(ctxt[INVGC], GDK_INVERT);
g_object_unref(pmap);
}
void initFontP()
{
static gboolean called=FALSE;
int  i;
char *fontName;
if (called)  
return;
called = TRUE;
for(i=0;i<NUMFONTTYPES;i++)
{
switch(i)
{
case WWWLABELF1:
fontName = g_strdup(WWWLABELFONT1);
break;
case WWWLABELF2:
fontName = g_strdup(WWWLABELFONT2);
break;
case WWWLABELF3:
fontName = g_strdup(WWWLABELFONT3);
break;
case WWWLABELF4:
fontName = g_strdup(WWWLABELFONT4);
break;
case WWWLABELF5:
fontName = g_strdup(WWWLABELFONT5);
break;
case WWWLABELF6:
fontName = g_strdup(WWWLABELFONT6);
break;
case LABELF:
fontName = g_strdup(PDFLABELFONT);
break;
case AXISF:
fontName = g_strdup(AXISFONT);
break;
case MSGF:
fontName = g_strdup(MSGFONT);
break;
case STNLBLF:
fontName = g_strdup(LABELFONT);
break;
case PDFSTATSF:
fontName = g_strdup(PDFSTATSFONT);
break;
}  
font[i].context = gdk_pango_context_get();
font[i].desc = pango_font_description_from_string(fontName);
g_free(fontName);
}
}
int fontSIZEP(char *str, int fType, int type)
{
PangoLayout *layout;
int width, height, ret;
layout = pango_layout_new(font[fType].context);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
pango_layout_get_pixel_size(layout, &width, &height);
g_object_unref(layout);
switch(type)
{
case HEIGHT:
ret = height;
break;
case WIDTH:
ret = width;
break;
}
return(ret);
}
void fontDrawP(GdkDrawable *pxmp, char *str, int x, int y, int fType, int gcid)
{
PangoLayout *layout=NULL;
GdkGC *gcL;
if (gcid < NUMFONTGCS)
{
gcL = gc[gcid][ABNORMALGC];
gdk_draw_rectangle(pxmp, gcL, TRUE, x-2, y-1, 
fontSIZEP(str, fType, WIDTH) + 4,
fontSIZEP(str, fType, HEIGHT) + 1);
gcL = gc[gcid][NORMALGC];
}
else
{ 
gcid = gcid - NUMFONTGCS;
gcid = gcid % 30;
gcL = OGXC[gcid];
}
layout = pango_layout_new(font[fType].context);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
gdk_draw_layout(pxmp, gcL, x, y, layout);
g_object_unref(layout);
return;
}
void fontDrawPGC(GdkDrawable *pxmp, char *str, int x, int y, int fType, GdkGC *gcL)
{
PangoLayout *layout=NULL;
layout = pango_layout_new(font[fType].context);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
gdk_draw_layout(pxmp, gcL, x, y, layout);
g_object_unref(layout);
return;
}
void fontDrawPRev(GdkDrawable *pxmp, char *str, int x, int y, int fType, int gcid, int ogcid)
{ 
PangoLayout *layout=NULL;
GdkGC *gcL;
gcL = gc[gcid][NORMALGC];
gdk_draw_rectangle (pxmp, gcL, TRUE, x-2, y-1, 
fontSIZEP(str, fType, WIDTH) + 4,
fontSIZEP(str, fType, HEIGHT) + 1);
if (ogcid >= NUMFONTGCS)
{ 
ogcid = ogcid - NUMFONTGCS;
ogcid = ogcid % 30;
gcL = OGXC[ogcid];
}
else
{
gcL = gc[gcid][ABNORMALGC];
}
layout = pango_layout_new(font[fType].context);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
gdk_draw_layout(pxmp, gcL, x, y, layout);
g_object_unref (layout);
return;
}
void fontDrawPR(GdkDrawable *pxmp, char *str, int x, int y, int fType, int gcid)
{ 
PangoLayout  *layout=NULL;
PangoMatrix  rotated_matrix = PANGO_MATRIX_INIT;
GdkGC   *gcL;
PangoContext *context;
context = gdk_pango_context_get();
layout = pango_layout_new(context);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
pango_matrix_rotate(&rotated_matrix, (double) 90.);
pango_context_set_matrix(context, &rotated_matrix);
pango_layout_context_changed(layout);
gcL = gc[gcid][NORMALGC];
gdk_draw_layout(pxmp, gcL, x, y, layout);
g_object_unref(layout);
g_object_unref(context);
return;
}
