#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_pdf.h"
#include "pqlx_stn.h"
#include "gtk_pdf_externs.h"
#define SPANSTR "<span"
static struct {
PangoFontDescription *desc;
} font[NUMFONTTYPES];
static void initFontPCairo()
{
static gboolean called=FALSE;
int  i;
char *fontName;
if (called)  
return;
called = TRUE;
for(i=0;i<NUMFONTTYPES;i++)
{
switch(i)
{
case WWWLABELF1:
fontName = g_strdup(WWWLABELFONT1);
break;
case WWWLABELF2:
fontName = g_strdup(WWWLABELFONT2);
break;
case WWWLABELF3:
fontName = g_strdup(WWWLABELFONT3);
break;
case WWWLABELF4:
fontName = g_strdup(WWWLABELFONT4);
break;
case WWWLABELF5:
fontName = g_strdup(WWWLABELFONT5);
break;
case WWWLABELF6:
fontName = g_strdup(WWWLABELFONT6);
break;
case LABELF:
fontName = g_strdup(PDFLABELFONT);
break;
case AXISF:
fontName = g_strdup(AXISFONT);
break;
case MSGF:
fontName = g_strdup(MSGFONT);
break;
case STNLBLF:
fontName = g_strdup(LABELFONT);
break;
case PDFSTATSF:
fontName = g_strdup(PDFSTATSFONT);
break;
}
font[i].desc = pango_font_description_from_string (fontName);
g_free(fontName);
}
}
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
int fontSIZEPCairo(cairo_t *cr, char *str, int fType, int type)
{
PangoLayout *layout;
int width, height, ret;
g_static_mutex_lock(&myMutex);
if (!font[0].desc)
initFontPCairo();
layout = pango_cairo_create_layout(cr);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
pango_layout_get_pixel_size(layout, &width, &height);
g_static_mutex_unlock(&myMutex);
g_object_unref(layout);
switch(type)
{
case HEIGHT:
ret = height;
break;
case WIDTH:
ret = width;
break;
}
return(ret);
}
void fontDrawPCairo(cairo_t *cr, char *str, int x, int y, int fType, gboolean rotate)
{
PangoLayout *layout=NULL;
if (!font[0].desc)
initFontPCairo();
cairo_save(cr);
cairo_set_source_rgb (cr, 0.0, 0.0, 0.0);
g_static_mutex_lock(&myMutex);
layout = pango_cairo_create_layout(cr);
pango_layout_set_font_description(layout, font[fType].desc);
if (!strncmp(str, SPANSTR, strlen(SPANSTR)))
{
pango_layout_set_markup(layout, str, -1);
}
else
{
pango_layout_set_text(layout, str, -1);
}
cairo_move_to(cr, x, y);
if (rotate)
{
double rad = -(90. * (G_PI/180.));
cairo_rotate(cr, rad);
pango_cairo_update_layout(cr, layout);
}
pango_cairo_show_layout(cr, layout);
g_static_mutex_unlock(&myMutex);
g_object_unref(layout);
cairo_restore(cr);
return;
}
#if 0
void fontDrawPRev(GdkDrawable *pxmp, char *str, int x, int y, int fType, int gcid, int ogcid)
{ 
PangoLayout *layout=NULL;
GdkGC *gcL;
gcL = gc[gcid][NORMALGC];
gdk_draw_rectangle (pxmp, gcL, TRUE, x-2, y-1, 
fontSIZEP(str, fType, WIDTH) + 4,
fontSIZEP(str, fType, HEIGHT) + 1);
if (ogcid >= NUMFONTGCS)
{ 
ogcid = ogcid - NUMFONTGCS;
ogcid = ogcid % 30;
gcL = OGXC[ogcid];
}
else
{
gcL = gc[gcid][ABNORMALGC];
}
layout = pango_layout_new(font[fType].context);
pango_layout_set_text (layout, str, -1);
pango_layout_set_font_description (layout, font[fType].desc);
gdk_draw_layout(pxmp, gcL, x, y, layout);
g_object_unref (layout);
return;
}
#endif
