#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <math.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "pqlx_externs.h"
#include "magnify.h"
#include "noiseModels.h"

typedef struct _PDFPLOTARGS
{
int w, h, scr, type;
float *perB;
graph *gr;
GdkPixmap *pixmap;
PDFREQ *pdfReq;
gboolean data;
int  fdUnits;
int  dateFmt;
GSList *bLines;  
} PDFPLOTARGS;

static void bline(PDFPLOTARGS *pdfPlotArgs)
{
graph  grL;
GdkPoint  *line;
GdkColor  *lgtGry=&lightGrey;
static GdkGC *gcHLNM=NULL;
int   pixX, pixY, lineCnt, i, j, sideM, topM, botM;
int   w=pdfPlotArgs->w, h=pdfPlotArgs->h;
GdkPixmap *pixmap=pdfPlotArgs->pixmap;
float  *perB=pdfPlotArgs->perB;
int   fdUnits=pdfPlotArgs->fdUnits, totPts;
PDFREQ  *pdfReq = pdfPlotArgs->pdfReq;
int    yBounds[TTLYBOUNDS];
int   bline_fk = pdfReq->keys.bline.bline_fk;
int   pixYStart, height, widthMax; 
GSList  *iter;
BLINEDEF *bLineDef;
BLINEPT  *bLinePts;

if (!gcHLNM)
{
GdkColor *bg = &myWhite;
gcHLNM = gdk_gc_new(pixmap);
gdk_gc_set_rgb_bg_color(gcHLNM, bg);
}

yBounds[YMIN] = pdfReq->keys.yBounds[YMIN];
yBounds[YMAX] = pdfReq->keys.yBounds[YMAX];

sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
gdk_gc_set_line_attributes(gcHLNM, 2, 0, 0, 0);
gdk_gc_set_rgb_fg_color(gcHLNM, lgtGry);

viewport(&grL, sideM, w-sideM-1, topM, h-botM-1); 
switch(fdUnits)
{
case FDUNIT_FREQ:
window(&grL, (double) perB[PEREND], (double) perB[PERSTART], 
(double) yBounds[YMIN], (double) yBounds[YMAX], XLOG, YLIN);
break;
case FDUNIT_PER:
window(&grL, (double) perB[PERSTART], (double) perB[PEREND], 
(double) yBounds[YMIN], (double) yBounds[YMAX], XLOG, YLIN);
break;
}

pixYStart = USER2PIXY(&grL, (double) (yBounds[YMAX]-5));

for (iter = pdfPlotArgs->bLines, j = 0;
iter;
iter = g_slist_next(iter))
{
bLineDef = iter->data;
if (bLineDef->blineKey != bline_fk)
continue;

bLinePts = bLineDef->lineDef.points;
totPts = bLineDef->lineDef.numPts;
height = fontSIZEP(bLineDef->name, PDFSTATSF, HEIGHT);
line = calloc(sizeof(GdkPoint), totPts);

for(lineCnt=i=0; i<totPts; i++)
{
pixX = USER2PIXX(&grL, (double) bLinePts[i].period);
pixY = USER2PIXY(&grL, (double) bLinePts[i].power);
if (pixY > grL.pix_ymax || pixY < grL.pix_ymin ||
pixX > grL.pix_xmax || pixX < grL.pix_xmin)
continue;
if (lineCnt && 
(pixX == line[lineCnt-1].x && pixY == line[lineCnt-1].y))
continue;

line[lineCnt].x = pixX;
line[lineCnt++].y = pixY;
}
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);

widthMax = fontSIZEP(bLineDef->name, PDFSTATSF, WIDTH);
switch(fdUnits)
{
case FDUNIT_PER:
pixX = USER2PIXX(&grL, (double) perB[PEREND]); 
pixY = pixYStart + j*height;
fontDrawP(pixmap, bLineDef->name, pixX-widthMax-1, pixY-height/2, PDFSTATSF, PDFSTATSTEXT);
break;
case FDUNIT_FREQ:
pixX = USER2PIXX(&grL, (double) perB[PEREND]) 
+ (widthMax*2) + 42;
pixY = pixYStart + j*height;
fontDrawP(pixmap, bLineDef->name, pixX-widthMax*2-34, pixY-height/2, PDFSTATSF, PDFSTATSTEXT);
break;
}
line[0].x = pixX - widthMax;
line[0].y = pixY;
line[1].x = pixX - widthMax - 32;
line[1].y = pixY;
gdk_draw_lines(pixmap, gcHLNM, line, 2);

free(line);
j++;
} 
}

static void HLNM(PDFPLOTARGS *pdfPlotArgs)
{ 
graph  grL;
GdkPoint *line;
GdkColor *lgtGry=&lightGrey, *drkGry = &darkGrey;
static GdkGC *gcHLNM=NULL;
int   pixX, pixY, lineCnt, i, sideM, topM, botM;
int   w=pdfPlotArgs->w, h=pdfPlotArgs->h, type=pdfPlotArgs->type;
GdkPixmap *pixmap=pdfPlotArgs->pixmap;
float  *perB=pdfPlotArgs->perB;
int   fdUnits=pdfPlotArgs->fdUnits;
PDFREQ  *pdfReq = pdfPlotArgs->pdfReq;
int   yBounds[TTLYBOUNDS];

yBounds[YMIN] = pdfReq->keys.yBounds[YMIN];
yBounds[YMAX] = pdfReq->keys.yBounds[YMAX];

if (!gcHLNM)
{
GdkColor *bg = &myWhite;
gcHLNM = gdk_gc_new(pixmap);
gdk_gc_set_rgb_bg_color(gcHLNM, bg);
}

switch(type)
{
case STNICON:
sideM = 1;
topM = 1;
botM = 1;
gdk_gc_set_line_attributes(gcHLNM, 1, 0, 0, 0);
gdk_gc_set_rgb_fg_color(gcHLNM, drkGry);
break;
case PDFPLOT:
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
gdk_gc_set_line_attributes(gcHLNM, 2, 0, 0, 0);
gdk_gc_set_rgb_fg_color(gcHLNM, lgtGry);
break;
case WWWPLOT:
if (w >= THUMBSIZEMAXWPDF)
{
sideM = WWWSIDEM;
topM = WWWTOPM;
botM = WWWBOTM;
}
else
{
sideM = THUMBSIDEM;
topM = THUMBTOPM;
botM = THUMBBOTM;
}
gdk_gc_set_line_attributes(gcHLNM, 1, 0, 0, 0);
gdk_gc_set_rgb_fg_color(gcHLNM, lgtGry);
break;
}
viewport(&grL, sideM, w-sideM-1, topM, h-botM-1);

switch(fdUnits)
{
case FDUNIT_FREQ:
window(&grL, (double) perB[PEREND], (double) perB[PERSTART], 
(double) yBounds[YMIN], (double) yBounds[YMAX], XLOG, YLIN);
break;
case FDUNIT_PER:
window(&grL, (double) perB[PERSTART], (double) perB[PEREND], 
(double) yBounds[YMIN], (double) yBounds[YMAX], XLOG, YLIN);
break;
}

line = calloc(sizeof(GdkPoint), 1001);
for(lineCnt=i=0;i<1001;i++)
{
pixX = USER2PIXX(&grL, (double) highNM[i][0]);
pixY = USER2PIXY(&grL, (double) (highNM[i][1]));
if (pixY > grL.pix_ymax || pixY < grL.pix_ymin ||
pixX > grL.pix_xmax || pixX < grL.pix_xmin)
continue;
if (lineCnt && 
(pixX == line[lineCnt-1].x && pixY == line[lineCnt-1].y))
continue;

line[lineCnt].x = pixX;
line[lineCnt++].y = pixY;
}
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);

for(lineCnt=i=0;i<1001;i++)
{
pixX = USER2PIXX(&grL, (double) lowNM[i][0]);
pixY = USER2PIXY(&grL, (double) (lowNM[i][1]));
if (pixY > grL.pix_ymax || pixY < grL.pix_ymin ||
pixX > grL.pix_xmax || pixX < grL.pix_xmin)
continue;
if (lineCnt && 
(pixX == line[lineCnt-1].x && pixY == line[lineCnt-1].y))
continue;

line[lineCnt].x = pixX;
line[lineCnt++].y = pixY;
}
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);
free(line);
}

void stnHLNM(GdkPixmap *pixmap, graph *grL, GdkColor *lineC)
{ 
GdkPoint *line;
static GdkColor lineSv;
static GdkGC *gcHLNM=NULL; 
int   pixX, pixY, lineCnt, i;

if (!gcHLNM ||
memcmp(&lineSv, lineC, sizeof(GdkColor)))
{
if (gcHLNM)
g_object_unref(gcHLNM);
GdkColor *bg = &myWhite;
gcHLNM = gdk_gc_new(pixmap);
gdk_gc_set_rgb_bg_color (gcHLNM, bg);
gdk_gc_set_rgb_fg_color(gcHLNM, lineC);
gdk_gc_set_line_attributes(gcHLNM, 2, 0, 0, 0);
memcpy(&lineSv, lineC, sizeof(GdkColor));
}

line = calloc(sizeof(GdkPoint), 1001);
for(lineCnt=i=0;i<1001;i++)
{
pixX = USER2PIXX(grL, (double) highNM[i][0]);
pixY = USER2PIXY(grL, (double) highNM[i][1]);
if (pixY > grL->pix_ymax || pixY < grL->pix_ymin ||
pixX > grL->pix_xmax || pixX < grL->pix_xmin)
{
if (lineCnt)
{
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);
lineCnt = 0;
}
continue;
}
if (lineCnt && 
(pixX == line[lineCnt-1].x && pixY == line[lineCnt-1].y))
continue;

line[lineCnt].x = pixX;
line[lineCnt++].y = pixY;
}
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);

for(lineCnt=i=0;i<1001;i++)
{
pixX = USER2PIXX(grL, (double) lowNM[i][0]);
pixY = USER2PIXY(grL, (double) lowNM[i][1]);
if (pixY > grL->pix_ymax || pixY < grL->pix_ymin ||
pixX > grL->pix_xmax || pixX < grL->pix_xmin)
{
if (lineCnt)
{
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);
lineCnt = 0;
}
continue;
}
if (lineCnt && 
(pixX == line[lineCnt-1].x && pixY == line[lineCnt-1].y))
continue;

line[lineCnt].x = pixX;
line[lineCnt++].y = pixY;
}
gdk_draw_lines(pixmap, gcHLNM, line, lineCnt);
free(line);
}

static void plot_stats(PDFPLOTARGS *pdfPlotArgs)
{
graph  grL;
GdkPoint *line = NULL;
static GdkGC *gcSTATS[TTLLINESIZES][TTLPDFSTATS], *gcLegend;
int   pixX, pixY, lineCnt, i, sideM, topM, botM, stat, j, pixH=0, pixYStart;
int   w=pdfPlotArgs->w, h=pdfPlotArgs->h, lineSize, numPts, height, width;
GdkPixmap *pixmap=pdfPlotArgs->pixmap;
float  *perB=pdfPlotArgs->perB;
GSList  *lineI;
PDFREQ  *pdfReq=pdfPlotArgs->pdfReq;
PDFSTATSL *pdfStatsL;
int   fdUnits = pdfPlotArgs->fdUnits;
int   yBounds[TTLYBOUNDS];

yBounds[YMIN] = pdfReq->keys.yBounds[YMIN];
yBounds[YMAX] = pdfReq->keys.yBounds[YMAX];

if (!pdfReq->data.statLines)
return;

sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
lineSize = (h < 350) ? SMALLLINE : LARGELINE;

viewport(&grL, sideM, w-sideM-1, topM, h-botM-1);
switch(fdUnits)
{
case FDUNIT_FREQ:
window(&grL, (double) perB[PEREND], (double) perB[PERSTART], 
(double) yBounds[YMIN], (double) yBounds[YMAX], TRUE, 0);
break;
case FDUNIT_PER:
window(&grL, (double) perB[PERSTART], (double) perB[PEREND], 
(double) yBounds[YMIN], (double) yBounds[YMAX], TRUE, 0);
break;
}

pixYStart = USER2PIXY(&grL, (double) (yBounds[YMIN]+5));
width = fontSIZEP(statStr[PDFSTAT_MEDIAN], PDFSTATSF, WIDTH);
height = fontSIZEP(statStr[PDFSTAT_MEDIAN], PDFSTATSF, HEIGHT);
pixH = abs(pixYStart - USER2PIXY(&grL, (double) (yBounds[YMIN]+8)));
if (pixH < height/2)
{
pixH = height/2;
}

if (!gcLegend)
{
gcLegend = gdk_gc_new(pixmap);
gdk_gc_set_rgb_fg_color(gcLegend, &lightGrey2);
}
for(lineI=pdfReq->data.statLines, j=0;
lineI;
lineI=g_slist_next(lineI), j++)
{
pdfStatsL = lineI->data;
stat = pdfStatsL->statistic;
if (!gcSTATS[lineSize][stat])
{
GdkColor offWhite = {0, 255*256-1, 242*256-1, 222*256-1},
green = {0, 0, 255*256-1, 0};
GdkColor *lineCol[TTLLINESIZES][TTLPDFSTATS] = {
{&green, &green, &myBlack, &myBlack, &myBlack, &myWhite, 
&myWhite, &myWhite, &myWhite, &myWhite, &myWhite},
{&green, &green, &myBlack, &myBlack, &myBlack, &offWhite, 
&offWhite, &offWhite, &offWhite, &offWhite, &offWhite}};
int   lineAtt[TTLPDFSTATS] = {GDK_LINE_SOLID, GDK_LINE_SOLID, 
GDK_LINE_SOLID, GDK_LINE_ON_OFF_DASH, GDK_LINE_ON_OFF_DASH,
GDK_LINE_SOLID, GDK_LINE_ON_OFF_DASH, GDK_LINE_ON_OFF_DASH,
GDK_LINE_ON_OFF_DASH, GDK_LINE_ON_OFF_DASH, GDK_LINE_SOLID};
gcSTATS[lineSize][stat] = gdk_gc_new(pixmap);
gdk_gc_set_rgb_fg_color(gcSTATS[lineSize][stat], lineCol[lineSize][stat]);
gdk_gc_set_line_attributes(gcSTATS[lineSize][stat], lineSize+1, lineAtt[stat], 0, 0);

#if 0
switch(stat)
{
gint8 dash[2] = {4, 3}, ddash[6] = {(gint8) 6, (gint8) 3, (gint8) 3, (gint8) 3};
case PDFSTAT_MEDIAN:
case PDFSTAT_P10:
case PDFSTAT_P90:
break;

case PDFSTAT_MEAN:
case PDFSTAT_P25:
case PDFSTAT_P75:
gdk_gc_set_dashes(gcSTATS[lineSize][stat], 0, ddash, 4);
break;

default:
break;
}
#endif

#if 0
switch(lineAtt[stat])
{
case GDK_LINE_DOUBLE_DASH:
gdk_gc_set_rgb_bg_color(gcSTATS[lineSize][stat], &offWhite);
break;
}
#endif

}

if (!line || 
numPts != pdfStatsL->numPts)
{ 
if (line)
free(line);
numPts = pdfStatsL->numPts;
line = calloc(sizeof(GdkPoint), numPts);
}
for(lineCnt=i=0;i<numPts;i++)
{
if (pdfStatsL->line[i].period < perB[PERSTART] ||
pdfStatsL->line[i].period > perB[PEREND])
continue;

pixX = USER2PIXX(&grL, (double) pdfStatsL->line[i].period);
pixY = USER2PIXY(&grL, (double) pdfStatsL->line[i].power);
if (pixY > grL.pix_ymax || pixY < grL.pix_ymin ||
pixX > grL.pix_xmax || pixX < grL.pix_xmin)
continue;
if (lineCnt && 
(pixX == line[lineCnt-1].x && pixY == line[lineCnt-1].y))
continue;

line[lineCnt].x = pixX;
line[lineCnt++].y = pixY;
}
gdk_draw_lines(pixmap, gcSTATS[lineSize][stat], line, lineCnt);

switch(fdUnits)
{
case FDUNIT_PER:
pixX = USER2PIXX(&grL, (double) perB[PERSTART]); 
pixY = pixYStart - j*pixH*2;
gdk_draw_rectangle(pixmap, gcLegend, TRUE, pixX+(LEG_LINE_START-2), pixY - pixH-1, 
(LEG_LINE_START-2+LEG_LINE_LEN+width+2), pixH*2+2);
break;
case FDUNIT_FREQ:
pixX = USER2PIXX(&grL, (double) perB[PERSTART]) 
- (width+LEG_LINE_START+LEG_LINE_LEN+8);
pixY = pixYStart - j*pixH*2;
gdk_draw_rectangle(pixmap, gcLegend, TRUE, pixX+(LEG_LINE_START-2), pixY - pixH-1, 
(LEG_LINE_START-2+LEG_LINE_LEN+width+2), pixH*2+2);
break;
}
line[0].x = pixX + LEG_LINE_START;
line[0].y = pixY;
line[1].x = pixX + (LEG_LINE_START + LEG_LINE_LEN);
line[1].y = pixY;
gdk_draw_lines(pixmap, gcSTATS[lineSize][stat], line, 2);

fontDrawP(pixmap, statStr[stat], pixX+38, pixY-height/2, PDFSTATSF, PDFSTATSTEXT);
}
free(line);
}

static void plot_pdf_extras(PDFPLOTARGS *pdfPlotArgs)
{
char  *dispStr;
gboolean thumb = FALSE;
graph  grL;
static GdkGC *gc=NULL;
int   pixX, pixY, i, horz, vert, w1, w2, h1, sideM, topM, botM;
int   w=pdfPlotArgs->w, h=pdfPlotArgs->h, scr=pdfPlotArgs->scr, type=pdfPlotArgs->type;
GdkPixmap *pixmap=pdfPlotArgs->pixmap;
PDFREQ  *pdfReq=pdfPlotArgs->pdfReq;
float  *perB=pdfPlotArgs->perB;
int   font, gcid;
int   yrS, yrE, moS, moE, dyS, dyE, jdayS, jdayE;
int   fdUnits = pdfPlotArgs->fdUnits;
int   dateFmt = pdfPlotArgs->dateFmt;
int   yBounds[TTLYBOUNDS], x1;

yBounds[YMIN] = pdfReq->keys.yBounds[YMIN];
yBounds[YMAX] = pdfReq->keys.yBounds[YMAX];

switch(type)
{
case PDFPLOT:
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
font = LABELF;
gcid = PDFFTEXT;
break;
case WWWPLOT:
gcid = WWWFTEXT;
if (w >= THUMBSIZEMAXWPDF)
{
sideM = WWWSIDEM;
topM = WWWTOPM;
botM = WWWBOTM;
}
else
{
sideM = THUMBSIDEM;
topM = THUMBTOPM;
botM = THUMBBOTM;
thumb = TRUE;
}
if (w >= 500)
font = WWWLABELF1;
else if (w >= 400)
font = WWWLABELF2;
else if (w >= 300)
font = WWWLABELF3;
else if (w >= THUMBSIZEMAXWPDF)
font = WWWLABELF4;
else
font = WWWLABELF6;
break;
}

if (!gc)
{
GdkColor *fg=&myBlack, *bg = &myWhite;
gc = gdk_gc_new(pixmap);
gdk_gc_set_rgb_fg_color(gc, fg);
gdk_gc_set_rgb_bg_color(gc, bg);
}

if (!pdfReq->data.name)
pdfReq->data.name = g_strdup(ChnName(pdfReq->keys.chnKey));
switch(pdfPlotArgs->data)
{
case TRUE:
dispStr = g_strdup_printf("%s : %d PSDs", pdfReq->data.name, pdfReq->data.numPSDs);
break;
case FALSE:
dispStr = g_strdup_printf("%s : 0 PSDs", pdfReq->data.name);
break;
}
vert = topM/2 - fontSIZEP(dispStr, font, HEIGHT);
w1 = fontSIZEP(dispStr, font, WIDTH)/2;
switch(scr)
{
case PDFMAIN:
case PDFREQUEST:
case PDFMOVIE:
case SPECTROMAIN:
case SPECTRODETREQ:
horz = w/2 - w1;
break;

case PDFDETAIL:
horz = sideM;
break;
}
fontDrawP(pixmap, dispStr, horz, vert, font, gcid);
free(dispStr);

if(pdfPlotArgs->data)
{ 
passcal_month_day(&pdfReq->data.sTime.date, pdfReq->data.sTime.date.jday);
passcal_month_day(&pdfReq->data.eTime.date, pdfReq->data.eTime.date.jday);
jdayS = pdfReq->data.sTime.date.jday;
jdayE = pdfReq->data.eTime.date.jday;
yrS = pdfReq->data.sTime.date.yr;
yrE = pdfReq->data.eTime.date.yr;
moS = pdfReq->data.sTime.date.mo;
moE = pdfReq->data.eTime.date.mo;
dyS = pdfReq->data.sTime.date.day;
dyE = pdfReq->data.eTime.date.day;

switch(dateFmt)
{
case PDF_DF_1:
dispStr = g_strdup_printf("%04d:%03d / %04d:%03d", yrS, jdayS, yrE, jdayE);
break;
case PDF_DF_2:
dispStr = g_strdup_printf("%04d-%02d-%02d / %04d-%02d-%02d", yrS, moS, dyS, yrE, moE, dyE);
break;
case PDF_DF_3:
dispStr = g_strdup_printf("%02d-%02d-%04d / %02d-%02d-%04d", dyS, moS, yrS, dyE, moE, yrE);
break;
case PDF_DF_4:
dispStr = g_strdup_printf("%02d-%s-%04d / %02d-%s-%04d", dyS, months[moS-1], yrS, dyE, months[moE-1], yrE);
break;
}

vert = topM/2;
w2 = fontSIZEP(dispStr, font, WIDTH)/2;
switch(scr)
{
case PDFMAIN:
case PDFREQUEST:
case PDFMOVIE:
case SPECTROMAIN:
case SPECTRODETREQ:
horz = w/2 - w2;
break;

case PDFDETAIL:
horz = sideM + w1 - w2;
break;
}
fontDrawP(pixmap, dispStr, horz, vert, font, gcid);
free(dispStr);
}

if (!pdfPlotArgs->data)
{ 
switch(pdfReq->data.numRecs)
{
case NOPSDDATA:
dispStr = g_strdup_printf("NO PDF Data Available");
break;
case NOPSDBADSR:
dispStr = g_strdup_printf("NO PDF Possible:\nMultiple Sample Rates");
break;
}
fontDrawP(pixmap, dispStr,
w/2 - fontSIZEP(dispStr, MSGF, WIDTH)/2, 
h/2 - fontSIZEP(dispStr, MSGF, HEIGHT)/2, 
MSGF, PDFFMSG);
free(dispStr);
return;
}

if (thumb)
{ 
gdk_draw_line(pixmap, gc, sideM, topM, w-sideM, topM);
}

if (!thumb)
{
switch(fdUnits)
{
case FDUNIT_FREQ:
dispStr = g_strdup("Frequency (Hz)");
h1 = fontSIZEP(dispStr, AXISF, HEIGHT);
w1 = fontSIZEP(dispStr, AXISF, WIDTH);
fontDrawP(pixmap, dispStr, (w/2-w1/2), h-1-h1, AXISF, PDFFTEXT);
free(dispStr);
break;
case FDUNIT_PER:
dispStr = g_strdup("Period (Sec)");
h1 = fontSIZEP(dispStr, AXISF, HEIGHT);
w1 = fontSIZEP(dispStr, AXISF, WIDTH);
fontDrawP(pixmap, dispStr, (w/2-w1/2), h-1-h1, AXISF, PDFFTEXT);
free(dispStr);
break;
}
}

viewport(&grL, sideM, w-sideM-1, h-botM, h);
switch(fdUnits)
{
case FDUNIT_FREQ:
window(&grL, (double) 1./perB[PEREND], (double) 1./perB[PERSTART], 
(double) 0, (double) botM, TRUE, 0);
xaxisP(pixmap, gc, &grL, (double) 1./perB[PEREND], (double) botM, 
(double) 1./perB[PERSTART], 1, -1, -1, (double) 0.0, TRUE, (double) 0.0, PDFFTEXT);
break;
case FDUNIT_PER:
window(&grL, (double) perB[PERSTART], (double) perB[PEREND], 
(double) 0, (double) botM, TRUE, 0);
xaxisP(pixmap, gc, &grL, (double) perB[PERSTART], (double) botM, 
(double) perB[PEREND], 1, -1, -1, (double) 0.0, FALSE, (double) 0.0, (thumb ? font : AXISF));
break;
}

if (thumb)
return;  

viewport(&grL, 0, sideM, topM, h-botM);
switch(fdUnits)
{
case FDUNIT_FREQ:
window(&grL, (double) sideM, (double) 0, (double) yBounds[YMIN], (double) yBounds[YMAX], 0, 0);
break;
case FDUNIT_PER:
window(&grL, (double) 0, (double) sideM, (double) yBounds[YMIN], (double) yBounds[YMAX], 0, 0);
break;
}

window(&grL, (double) 0, (double) sideM, (double) yBounds[YMIN], (double) yBounds[YMAX], 0, 0);
pixX = USER2PIXX(&grL, sideM);
dispStr = g_strdup("-200");
h1 = fontSIZEP(dispStr, AXISF, HEIGHT);
free(dispStr);
for(i=0;i<(yBounds[YMAX]-yBounds[YMIN])/10+1;i++)
{
pixY = USER2PIXY(&grL, yBounds[YMAX]-i*10);
gdk_draw_line(pixmap, gc, pixX, pixY, pixX+4, pixY);
if (!(i%3))
{
switch(pdfReq->keys.type)
{
case BBAND_CONT:
dispStr = g_strdup_printf("%d", yBounds[YMAX]-i*10);
font = AXISF;
break;
case STMO_TRIG:
dispStr = g_strdup_printf("<span>10<sup>%d</sup></span>", (yBounds[YMAX]-i*10+20)/10);
font = PDFSTATSF;
break;
}
w1 = fontSIZEP(dispStr, font, WIDTH);
fontDrawP(pixmap, dispStr, sideM-4-w1, pixY-h1/2, font, PDFFTEXT);
}
}
gdk_draw_line(pixmap, gc, sideM, topM, sideM, h-botM);   
gdk_draw_line(pixmap, gc, w-sideM-1, topM, w-sideM-1, h-botM); 
switch(pdfReq->keys.type)
{
case BBAND_CONT:
dispStr = g_strdup_printf("dB");
x1 = sideM/2-h1;
font = AXISF;
break;
case STMO_TRIG:
dispStr = g_strdup_printf("<span>(cm/sec<sup>2</sup>)<sup>2</sup></span>");
x1 = sideM/2-h1*1.5;
font = PDFSTATSF;
break;
}
h1 = fontSIZEP(dispStr, font, HEIGHT);
w1 = fontSIZEP(dispStr, font, WIDTH);
pixY = USER2PIXY(&grL, (yBounds[YMIN]+yBounds[YMAX])/2);
fontDrawPR(pixmap, dispStr, x1, pixY-w1/2, font, PDFFTEXT);
free(dispStr);

}

static gboolean pdf(guchar *rgbbuf, 
int widthDISP, 
int heightDISP, 
PDFREQ *pdfReq, 
graph *grP, 
float *perB, 
int fdUnits)
{
gboolean ret;
int   prob, i;
int   pixX, pixY, pixelPos;
guchar   *probMapS;
int   widthIN, heightIN, perCnt; 
double   oldPer;
float  maxProbability = PDFPLOT_MAX_PROB;
int   yBounds[TTLYBOUNDS];
MAGARGS  magArgs;

yBounds[YMIN] = pdfReq->keys.yBounds[YMIN];
yBounds[YMAX] = pdfReq->keys.yBounds[YMAX];

if (!perB[PERSTART])
{
perB[PERSTART] = pdfReq->data.pdf[0].period;
}
if (!perB[PEREND])
{
perB[PEREND] = pdfReq->data.pdf[pdfReq->data.numRecs-1].period;
}

for(i=0, perCnt=0, oldPer=0;
i<pdfReq->data.numRecs &&
pdfReq->data.pdf[i].period <= perB[PEREND];
i++)
{
if (pdfReq->data.pdf[i].period < perB[PERSTART] ||
pdfReq->data.pdf[i].period == oldPer)
continue;

perCnt++;
oldPer=pdfReq->data.pdf[i].period;
}
widthIN = perCnt;
heightIN = yBounds[YMAX] - yBounds[YMIN];

if (!(probMapS = (guchar *) calloc(widthIN*heightIN, sizeof(guchar))))
{
fprintf(stderr, "Unable to allocate %d bytes, quitting\n", 
(int) (widthIN*heightIN*sizeof(guchar)));
exit(-1);
}

viewport(grP, 0, widthIN-1, 0, heightIN-1);
switch(fdUnits)
{
case FDUNIT_FREQ:
window(grP,  (double) (perB[PEREND]), (double) (perB[PERSTART]),
(double) yBounds[YMIN], (double) yBounds[YMAX], 
XLOG, YLIN);
break;

case FDUNIT_PER:
window(grP,  (double) (perB[PERSTART]), (double) (perB[PEREND]),
(double) yBounds[YMIN], (double) yBounds[YMAX], 
XLOG, YLIN);
break;
}

for(i=0;i<pdfReq->data.numRecs;i++)
{
pixX = USER2PIXX(grP, (double) pdfReq->data.pdf[i].period);
pixY = USER2PIXY(grP, (double) pdfReq->data.pdf[i].power);

if (pixY > grP->pix_ymax || pixY < grP->pix_ymin ||
pixX > grP->pix_xmax || pixX < grP->pix_xmin ||
pdfReq->data.pdf[i].prob == 0.0)
continue;

prob = (pdfReq->data.pdf[i].prob*100.+.5)*PROBFACT;

pixelPos = pixY*(widthIN) + pixX;
probMapS[pixelPos] = (char) ((prob>MAX_PIXEL_VALUE) ? MAX_PIXEL_VALUE : prob);
}

memset(&magArgs, 0, sizeof(MAGARGS));
magArgs.plotType = PDFPLOT;
magArgs.probMapS = probMapS;
magArgs.rgbbuf = &rgbbuf;
magArgs.widthIN = widthIN;
magArgs.heightIN = heightIN;
magArgs.widthDISP = widthDISP;
magArgs.heightDISP = heightDISP;
ret = magnify(&magArgs);
free(probMapS);

return ret;
}

void plotPDF(PLOTPDFARGS *plotPDFArgs)
{
GdkPixmap *pmap = plotPDFArgs->pmap;
PDFREQ  *pdfReq = (PDFREQ *) plotPDFArgs->req;
int   width = plotPDFArgs->width, height = plotPDFArgs->height, 
scr = plotPDFArgs->scr, type = plotPDFArgs->type;
int   fdUnits = plotPDFArgs->fdUnits, dateFmt = plotPDFArgs->dateFmt;
gboolean ret;
guchar  *rgbbuf;
graph  gr;
int   wL, hL, sideM, topM, botM, yBounds[TTLYBOUNDS];
static GdkGC *gc=NULL;
float   perB[TTLPERBOUNDS];
PDFPLOTARGS pdfPlotArgs;
gboolean plotExtras, hlnm = plotPDFArgs->hlnm;
int   bline_fk = pdfReq->keys.bline.bline_fk;

perB[PERSTART] = plotPDFArgs->xAxis.bounds[PERSTART];
perB[PEREND] = plotPDFArgs->xAxis.bounds[PEREND];
yBounds[YMIN] = pdfReq->keys.yBounds[YMIN];
yBounds[YMAX] = pdfReq->keys.yBounds[YMAX];
pdfPlotArgs.bLines = plotPDFArgs->blines;

if (pdfReq->data.numRecs != -1 &&
yBounds[YMIN] == 0 &&
yBounds[YMAX] == 0)
{
fprintf(stderr, "Internal Error: PDF Y-Axis size/dimension == 0, not allowed.\n");
return;
}

if (!gc)
gc = gdk_gc_new(pmap);
switch(type)
{
case STNICON:
sideM = 1;
topM = 1;
botM = 1;
plotExtras = FALSE;
break;
case PDFPLOT:
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
plotExtras = TRUE;
break;
case WWWPLOT:
if (width >= THUMBSIZEMAXWPDF)
{
sideM = WWWSIDEM;
topM = WWWTOPM;
botM = WWWBOTM;
}
else
{
sideM = THUMBSIDEM;
topM = THUMBTOPM;
botM = THUMBBOTM;
}
plotExtras = TRUE;
break;
}
wL = width - 2*sideM;
hL = height - (topM + botM);

if (wL <= 0 ||  
hL <= 0)
return;

pdfPlotArgs.pixmap = pmap;
pdfPlotArgs.pdfReq = pdfReq;
pdfPlotArgs.gr = &gr;
pdfPlotArgs.perB = perB;
pdfPlotArgs.w = width;
pdfPlotArgs.h = height;
pdfPlotArgs.scr = scr;
pdfPlotArgs.type = type;
pdfPlotArgs.dateFmt = dateFmt;
pdfPlotArgs.fdUnits = fdUnits;
if (pdfReq->data.numRecs == NOPSDDATA ||
pdfReq->data.numRecs == NOPSDBADSR)
pdfPlotArgs.data = FALSE;
else
pdfPlotArgs.data = TRUE;

rgbbuf = malloc(wL * hL * 3);
memset(rgbbuf, 240, wL * hL * 3);  
if (pdfPlotArgs.data)
{
ret = pdf(rgbbuf, wL, hL, pdfReq, &gr, perB, fdUnits);
if (ret)
{
gdk_draw_rgb_image(pmap, gc, sideM, topM, wL, hL, GDK_RGB_DITHER_NONE, rgbbuf, wL*3);
if (hlnm && !bline_fk)
HLNM(&pdfPlotArgs);
else if (bline_fk)
bline(&pdfPlotArgs);

plot_stats(&pdfPlotArgs);
}
else
plotExtras = FALSE;
}
else
{
gdk_draw_rgb_image(pmap, gc, sideM, topM, wL, hL, GDK_RGB_DITHER_NONE, rgbbuf, wL*3);
}

if (plotExtras)
{
plot_pdf_extras(&pdfPlotArgs);
}

plotPDFArgs->xAxis.bounds[PERSTART] = perB[PERSTART];
plotPDFArgs->xAxis.bounds[PEREND] = perB[PEREND];

free(rgbbuf);
return;
}

void colorBar(GdkPixmap *pmap, int w, int h)
{
int  i, j, y, y1;
graph grL;
myColorStruct *colorProb;
guchar *pos, *rgbbuf;
gchar *str;
static GdkGC *gc=NULL;

if (!gc)
gc = gdk_gc_new(pmap);

if (w <= 0 ||  
h <= 0)
return;

rgbbuf = malloc(COLORBW * h * 3);
viewport(&grL, 0, COLORBW, 0, h);
window(&grL, (double) 0, (double) COLORBW, (double) 0., (double) 30.0, 0, 0);
pos = rgbbuf;
for(i=0;i<h;i++)
{
colorProb = colorP(PDFPLOT, (float) PIX2USERY(&grL, i));
for(j=0;j<COLORBW;j++)
{
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos++ = colorProb->B;
}
}
gdk_draw_rgb_image (pmap, gc, 0, 0, COLORBW, h, GDK_RGB_DITHER_NONE, rgbbuf, COLORBW*3);
free(rgbbuf);

for(i=0;i<31;i+=6)
{
y = USER2PIXY(&grL, (double) i);
switch(i)
{
case 0:
str = g_strdup_printf("%d%%", i);
y1 = y - fontSIZEP(str, AXISF, HEIGHT);
y -=1;
break;
case 30:
str = g_strdup_printf("%d+", i);
y1 = y -2;
break;
default:
str = g_strdup_printf("%d%%", i);
y1 = y - fontSIZEP(str, AXISF, HEIGHT)/2;
break;
}
fontDrawP(pmap, str, COLORBW+2, y1, AXISF, PDFFTEXT);
free(str);
}
}

