#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <math.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "pqlx_externs.h"
#include "magnify.h"
typedef struct _SPECPLOTARGS
{
int  scr;
int  w, h;
float *perB;
GdkPixmap *pixmap;
SPECREQ *specReq;
gboolean data;
int  dateFmt;
int  fdUnits;
} SPECPLOTARGS;
GdkColor myWhite = {0, 255*256-1, 255*256-1, 255*256-1},
myBlack = {0, 0, 0, 0},
myRed = {0, 255*256-1, 0, 0},
myBlue = {0, 0, 0, 255*256-1};
static GdkPixmap *arrowPmap()
{
static GdkPixmap *arrows;
if (!arrows)
{
GdkPoint points[3];
GdkGC  *gcUP, *gcDOWN, *gc;
gint  depth, width = ARROWW,
height = ARROWW*2+1,
arrowH = height/2;
GdkColor *up=&myRed, *down = &myBlue, *fg = &myWhite;
depth = gdk_visual_get_best_depth();
depth = (depth > 24 ) ? 24 : depth;  
arrows = gdk_pixmap_new(NULL, width, height, depth);
gc = gdk_gc_new(arrows);
gdk_gc_set_rgb_fg_color(gc, fg);
gcUP = gdk_gc_new(arrows);
gdk_gc_set_rgb_fg_color(gcUP, up);
gcDOWN = gdk_gc_new(arrows);
gdk_gc_set_rgb_fg_color(gcDOWN, down);
gdk_draw_rectangle(arrows, gc, TRUE, 0, 0, width, height);
points[0].x = width/2; points[0].y = 0;
points[1].x = width; points[1].y = arrowH;
points[2].x = 0;  points[2].y = arrowH;
gdk_draw_polygon(arrows, gcUP, TRUE, points, 3);
points[0].x = width/2; points[0].y = height;
points[1].x = width; points[1].y = height - arrowH;
points[2].x = 0;  points[2].y = height - arrowH;
gdk_draw_polygon(arrows, gcDOWN, TRUE, points, 3);
g_object_unref(gcUP);
g_object_unref(gcDOWN);
g_object_unref(gc);
}
return arrows;
}
void colorBarS(GdkPixmap *pmap, int w, int h, SPECREQ *specReq)
{
int  i, j, y, dbRange, value;
float inc;
graph grL;
myColorStruct *colorProb;
guchar *pos, *rgbbuf;
gchar *str;
static GdkGC *gc=NULL;
if (!gc)
gc = gdk_gc_new(pmap);
if (w <= 0 ||  
h <= 0)
return;
rgbbuf = calloc(sizeof(char), COLORBW * (h-10) * 3);
viewport(&grL, 0, COLORBW, 0, h-10);
window(&grL, (double) 0, (double) COLORBW, (double) 0., (double) SPECTROPLOT_MAX_PROB, 0, 0);
pos = rgbbuf;
for(i=0;i<(h-10);i++)
{
colorProb = colorP(SPECTROPLOT, (float) PIX2USERY(&grL, i));
for(j=0;j<COLORBW;j++)
{
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos++ = colorProb->B;
}
}
gdk_draw_rgb_image(pmap, gc, 0, 5, COLORBW, h-10, GDK_RGB_DITHER_NONE, rgbbuf, COLORBW*3);
free(rgbbuf);
viewport(&grL, 0, COLORBW, 5, h-10);
window(&grL, (double) 0, (double) COLORBW, 
(double) specReq->plot.dbBounds[YMIN], (double) specReq->plot.dbBounds[YMAX], 
0, 0);
y = USER2PIXY(&grL, (double) specReq->plot.dbBounds[YMIN]);
value = specReq->plot.dbBounds[YMIN];
str = g_strdup_printf("%d", value);
y -= fontSIZEP(str, PDFSTATSF, HEIGHT)/2;
fontDrawP(pmap, str, COLORBW+2, y, PDFSTATSF, PDFFTEXT);
free(str);
y = USER2PIXY(&grL, (double) specReq->plot.dbBounds[YMAX]);
value = specReq->plot.dbBounds[YMAX];
str = g_strdup_printf("%d", value);
y -= fontSIZEP(str, PDFSTATSF, HEIGHT)/2;
fontDrawP(pmap, str, COLORBW+2, y, PDFSTATSF, PDFFTEXT);
free(str);
viewport(&grL, 0, COLORBW, 5, h-10);
window(&grL, (double) 0, (double) COLORBW, 
(double) specReq->plot.dbBounds[YMIN], (double) specReq->plot.dbBounds[YMAX], 
0, 0);
dbRange = specReq->plot.dbBounds[YMAX] - specReq->plot.dbBounds[YMIN];
inc = (float) dbRange/10.f;
for(i = 1;
i < 10;
i++)
{
value = specReq->plot.dbBounds[YMIN] + i * inc; 
y = USER2PIXY(&grL, (double) value);
str = g_strdup_printf("%d", value);
y -= fontSIZEP(str, PDFSTATSF, HEIGHT)/2;
fontDrawP(pmap, str, COLORBW+2, y, PDFSTATSF, PDFFTEXT);
free(str);
}
}
gint32 spectroEStart(SPECREQ *specReq)
{ 
PTIME startD;
int  secsPdiv;
gint32 startE;
memset(&startD, 0, sizeof(PTIME));
secsPdiv = SECSPDIVSP(specReq);
startD.yr = g_date_get_year(specReq->data.dateBounds[STARTDT]);
startD.day = g_date_get_day_of_year(specReq->data.dateBounds[STARTDT]);
startE = passcal_htoe(&startD, FALSE) + PSDREFABSS(specReq) * secsPdiv;
startE += ((specReq->plot.bounds[XMIN] - PSDREFABSS(specReq)) * secsPdiv);
return (startE);
} 
static void plot_spectro_extras(SPECPLOTARGS *specPlotArgs)
{
char  *dispStr;
graph  grL;
static GdkGC *gc=NULL, *gcCbar;
int   pixY, horz, vert, w1, sideM, topM, botM;
int   w=specPlotArgs->w, h=specPlotArgs->h;
GdkPixmap *pixmap=specPlotArgs->pixmap;
SPECREQ  *specReq=specPlotArgs->specReq;
int   font, gcid;
int   yrS, yrE, moS, moE, dyS, dyE, jdayS, jdayE, x1;
int   dateFmt = specPlotArgs->dateFmt, fdUnits = specPlotArgs->fdUnits;
int   scr = specPlotArgs->scr;
float   perB[TTLPERBOUNDS];
perB[YMIN] = specPlotArgs->perB[YMIN];
perB[YMAX] = specPlotArgs->perB[YMAX];
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
font = LABELF;
gcid = PDFFTEXT;
if (!gc)
{
GdkColor *fg=&myBlack, *bg = &myWhite;
gc = gdk_gc_new(pixmap);
gdk_gc_set_rgb_fg_color(gc, fg);
gdk_gc_set_rgb_bg_color(gc, bg);
gdk_gc_set_line_attributes(gc, 1, GDK_LINE_SOLID, GDK_CAP_BUTT, GDK_JOIN_MITER);
gcCbar = gdk_gc_new(pixmap);
gdk_gc_set_rgb_fg_color(gcCbar, bg);
gdk_gc_set_rgb_bg_color(gcCbar, fg);
}
if (!specReq->data.name)
specReq->data.name = g_strdup(ChnName(specReq->keys.chnKey));
switch(specPlotArgs->data)
{
case TRUE:
dispStr = g_strdup_printf("%s : %d PSDs", specReq->data.name, specReq->plot.numPSDs);
break;
case FALSE:
dispStr = g_strdup_printf("%s : 0 PSDs", specReq->data.name);
break;
}
vert = topM/2 - fontSIZEP(dispStr, font, HEIGHT);
w1 = fontSIZEP(dispStr, font, WIDTH)/2;
horz = sideM + 5;
fontDrawP(pixmap, dispStr, horz, vert, font, gcid);
free(dispStr);
if(specPlotArgs->data)
{ 
GDate *dateS = specReq->plot.dateBounds[STARTDT], 
*dateE = specReq->plot.dateBounds[ENDDT];
jdayS = g_date_get_day_of_year(dateS);
jdayE = g_date_get_day_of_year(dateE);
yrS = g_date_get_year(dateS);
yrE = g_date_get_year(dateE);
moS = g_date_get_month(dateS);
moE = g_date_get_month(dateE);
dyS = g_date_get_day(dateS);
dyE = g_date_get_day(dateE);
switch(dateFmt)
{
case PDF_DF_1:
dispStr = g_strdup_printf("%04d:%03d / %04d:%03d", yrS, jdayS, yrE, jdayE);
break;
case PDF_DF_2:
dispStr = g_strdup_printf("%04d-%02d-%02d / %04d-%02d-%02d", yrS, moS, dyS, yrE, moE, dyE);
break;
case PDF_DF_3:
dispStr = g_strdup_printf("%02d-%02d-%04d / %02d-%02d-%04d", dyS, moS, yrS, dyE, moE, yrE);
break;
case PDF_DF_4:
dispStr = g_strdup_printf("%02d-%s-%04d / %02d-%s-%04d", dyS, months[moS-1], yrS, dyE, months[moE-1], yrE);
break;
}
vert = topM/2;
horz = sideM + 5;
fontDrawP(pixmap, dispStr, horz, vert, font, gcid);
free(dispStr);
}
if (!specPlotArgs->data)
{ 
switch(specReq->data.numRecs)
{
case NOPSDDATA:
dispStr = g_strdup_printf("NO PSD Data Available");
break;
case NOPSDBADSR:
dispStr = g_strdup_printf("NO SPECTROGRAM Possible:\nMultiple Sample Rates");
break;
}
fontDrawP(pixmap, dispStr,
w/2 - fontSIZEP(dispStr, MSGF, WIDTH)/2, 
h/2 - fontSIZEP(dispStr, MSGF, HEIGHT)/2, 
MSGF, gcid);
free(dispStr);
gdk_draw_line(pixmap, gc, sideM, topM, w-sideM, topM);
gdk_draw_line(pixmap, gc, w-sideM, topM, w-sideM, h-botM);
gdk_draw_line(pixmap, gc, w-sideM, h-botM, sideM, h-botM);
gdk_draw_line(pixmap, gc, sideM, h-botM, sideM, topM);
return;
}
{ 
XAXISDAYSARGS axisArgs;
graph GR;
axisArgs.type = XAXISDAYSSPECTRO;
axisArgs.plot.pixmap = pixmap;
axisArgs.width = w;
axisArgs.height = h;
axisArgs.gc = gc;
axisArgs.GR = &GR;
axisArgs.startE = (double) spectroEStart(specReq);
viewport(&GR, PDFSIDEM, w-PDFSIDEM-1, h-PDFBOTM+1, h);
window(&GR, (double) 0, (double) TTLSECSSP(specReq), (double) PDFBOTM, (double) 0, 0, 0);
xAxisTIME(&axisArgs);
}
viewport(&grL, 0, sideM, topM+1, h-botM);
switch (fdUnits)
{
case FDUNIT_FREQ:
dispStr = g_strdup_printf("Frequency (Hz)");
window(&grL, (double) 0, (double) sideM, (double) 1./perB[YMAX], (double) 1./perB[YMIN], 0, TRUE);
yaxisP(pixmap, gc, &grL, (double) sideM, (double) 1./perB[YMAX], (double) 1./perB[YMIN], 
1, -1, 1, (double) 0., MYFLOATSHORT, PDFSTATSF);
break;
case FDUNIT_PER:
dispStr = g_strdup_printf("Period (sec)");
window(&grL, (double) 0, (double) sideM, (double) perB[YMIN], (double) perB[YMAX], 0, TRUE);
yaxisP(pixmap, gc, &grL, (double) sideM, (double) perB[YMIN], (double) perB[YMAX], 
1, -1, 1, (double) 0., MYFLOATSHORT, PDFSTATSF);
break;
}
gdk_draw_line(pixmap, gc, sideM, topM, w-sideM-1, topM);
gdk_draw_line(pixmap, gc, w-sideM-1, topM, w-sideM-1, h-botM+1);
font = AXISF;
w1 = fontSIZEP(dispStr, font, WIDTH);
pixY = h/2-w1/2;
x1 = 8;
fontDrawPR(pixmap, dispStr, x1, pixY, font, PDFFTEXT);
free(dispStr);
{ 
GdkPixmap *cbpmap;
int  width, height;
static gint depth;
if (!depth)
{
depth = gdk_visual_get_best_depth();
depth = (depth > 24 ) ? 24 : depth;  
}
width = PDFSIDEM-5;
height = h - (PDFTOPM + PDFBOTM) + 11;
cbpmap = gdk_pixmap_new(NULL, width, height, depth);
gdk_draw_rectangle(cbpmap, gcCbar, TRUE, 0, 0, width, height);
colorBarS(cbpmap, width, height, specReq);
gdk_draw_drawable(pixmap, gc, cbpmap, 0, 0, w-PDFSIDEM+3, PDFTOPM-5, -1, -1);
g_object_unref(cbpmap);
}
if (scr == SPECTRODETREQ)
{ 
GdkPixmap *arrows = arrowPmap();
gdk_draw_drawable(pixmap, gc, arrows, 0, 0, w-PDFSIDEM+3, PDFTOPM-ARROWH-1, -1, -1);
gdk_draw_drawable(pixmap, gc, arrows, 0, 0, w-PDFSIDEM+3, h-PDFBOTM+1, -1, -1);
}
}
void getDbRange(GList *start, GList *end, int *dbBounds, int *perRecs)
{
GList  *iter;
GSList  *iter2;
SPECTRODATA *spectroData;
PSDDATA  *psdData;
int   rec, startRec, endRec;
startRec = perRecs ? perRecs[PERSTART] : 0;
endRec = perRecs ? perRecs[PEREND] : g_slist_length(((SPECTRODATA*)(start->data))->psdData);
for (iter = start;
iter != (end ? end->next : NULL);
iter = g_list_next(iter))
{
spectroData = iter->data;
rec = startRec;
for (iter2 = g_slist_nth(spectroData->psdData, rec);
iter2 && rec < endRec;
iter2 = g_slist_next(iter2), rec++)
{
psdData = iter2->data;   
if (dbBounds[YMIN] > psdData->power)
{
dbBounds[YMIN] = psdData->power;
}
if (dbBounds[YMAX] < psdData->power)
dbBounds[YMAX] = psdData->power;
}
}
dbBounds[YMIN]--;
dbBounds[YMAX]++;
}
static void setPerRecs(SPECREQ *specReq, float *perB, int *perRecs)
{
SPECTRODATA *spectroData = (SPECTRODATA *) ((specReq->plot.start)->data);
PSDDATA *psdData;
GSList *iter;
int  rec;
for (iter = spectroData->psdData, rec = 0;
iter; 
iter = g_slist_next(iter), rec++)
{
psdData = iter->data;
if (perRecs[PERSTART] == NONE &&
psdData->period >= perB[PERSTART])
perRecs[PERSTART] = rec;
if (perRecs[PEREND] == NONE &&
psdData->period >= perB[PEREND])
{
perRecs[PEREND] = rec;
break;
}
}
if (perRecs[PEREND] == NONE)
perRecs[PEREND] = rec;
}
static gboolean spectro(guchar *rgbbuf, 
int widthDISP, 
int heightDISP, 
SPECREQ *specReq,
float *perB,
int fdUnits)
{
gboolean ret;
int  prob, x, oldPixX, i, rec;
int  pixX, pixY, pixelPos;
guchar **dataMap = &specReq->plot.dataMap;
int  widthIN, heightIN, dbRange, refStart; 
float maxProbability = SPECTROPLOT_MAX_PROB;
int  dbBounds[TTLYBOUNDS];
GList *iter;
GSList *iter2;
SPECTRODATA *spectroData;
PSDDATA *psdData;
MAGARGS magArgs;
GHashTable *gaps;
int  perRecs[TTLPERBOUNDS] = {NONE, NONE};
graph gr;
gboolean perBounds = (perB[PERSTART] != 0.0f || perB[PEREND] != 0.0f) ? TRUE : FALSE;
for (i = 0; i < TTLPERBOUNDS; i++)
{ 
if (perB[i] == 0.0f)
perB[i] = specReq->data.yBounds[i];
}
setPerRecs(specReq, perB, &perRecs[0]);
widthIN = specReq->plot.numDivs;
heightIN = perRecs[PEREND] - perRecs[PERSTART]; 
if (specReq->plot.replot)
{ 
viewport(&gr, 0, widthIN, 0, heightIN);
window(&gr, (double) 0, (double) widthDISP, (double) 0, (double) heightDISP, FALSE, FALSE);
switch (specReq->plot.dBRange)
{
case DBRELATIVE:
if (specReq->plot.start == specReq->data.spectro &&
specReq->plot.numPSDs == 0 &&  
!perBounds)
{     
dbBounds[YMIN] = specReq->data.dbBounds[YMIN];
dbBounds[YMAX] = specReq->data.dbBounds[YMAX];
}
else
{
dbBounds[YMIN] = -49;
dbBounds[YMAX] = -201;
getDbRange(specReq->plot.start, specReq->plot.end, &dbBounds[0], perRecs);
}
specReq->plot.dbBounds[YMIN] = dbBounds[YMIN];
specReq->plot.dbBounds[YMAX] = dbBounds[YMAX];
break;
case DBFIXED:
dbBounds[YMIN] = specReq->plot.dbBounds[YMIN];
dbBounds[YMAX] = specReq->plot.dbBounds[YMAX];
break;
}
dbRange = dbBounds[YMAX] - dbBounds[YMIN] + 1;
if (specReq->plot.gaps)
g_hash_table_destroy(specReq->plot.gaps);
gaps = specReq->plot.gaps = g_hash_table_new(NULL, NULL);
if (*dataMap)
free(*dataMap);
if (!(*dataMap = (guchar *) calloc(widthIN*heightIN, sizeof(guchar))))
{
fprintf(stderr, "Unable to allocate %d bytes, quitting\n", 
(int) (widthIN*heightIN*sizeof(guchar)));
exit(-1);
}
refStart = ((SPECTRODATA *) ((specReq->plot.start)->data))->psdRef;
for (iter = specReq->plot.start, x = 0;
iter != (specReq->plot.end)->next;
iter = g_list_next(iter), x++, oldPixX = pixX)
{
spectroData = iter->data;
pixX = spectroData->psdRef - refStart;
if (pixX >= widthIN)
{ 
break;
}
if (x && oldPixX != pixX - 1)
{ 
int startX = (int) PIX2USERX(&gr, oldPixX),
endX = (int) PIX2USERX(&gr, pixX), j;
for (j = startX;
j < endX+1;
j++)
{
g_hash_table_insert(gaps, GINT_TO_POINTER(j), GINT_TO_POINTER(j));
}
}
rec = perRecs[PERSTART];
pixY = (fdUnits == FDUNIT_PER) ? heightIN-1 : 0;
for (iter2 = g_slist_nth(spectroData->psdData, rec);
iter2 && rec < perRecs[PEREND]; 
iter2 = g_slist_next(iter2), rec++)
{
psdData = iter2->data;
prob = (((float) (psdData->power + dbBounds[YMIN]*-1)
/ (float) dbRange) * 100) 
* (float) PROBFACT;
pixelPos = pixY * (widthIN) + pixX;    
(*dataMap)[pixelPos] = (char) ((prob>MAX_PIXEL_VALUE) ? MAX_PIXEL_VALUE
: (prob<0.f) ? 0.f 
: prob);
pixY = (fdUnits == FDUNIT_PER) ? pixY-1 : pixY+1;
}
}
specReq->plot.numPSDs = x;
}
memset(&magArgs, 0, sizeof(MAGARGS));
magArgs.plotType = SPECTROPLOT;
magArgs.probMapS = *dataMap;
magArgs.rgbbuf = &rgbbuf;
magArgs.widthIN = widthIN;
magArgs.heightIN = heightIN;
magArgs.widthDISP = widthDISP;
magArgs.heightDISP = heightDISP;
magArgs.gaps = specReq->plot.gaps;
ret = magnify(&magArgs);
return ret;
}
void plotSPECTRO(PLOTPDFARGS *plotPDFArgs)
{
GdkPixmap *pmap = plotPDFArgs->pmap;
SPECREQ  *specReq = (SPECREQ *) plotPDFArgs->req;
int   width = plotPDFArgs->width, height = plotPDFArgs->height;
int   fdUnits = plotPDFArgs->fdUnits, dateFmt = plotPDFArgs->dateFmt;
float  perB[TTLPERBOUNDS], yBounds[TTLYBOUNDS];
guchar  *rgbbuf;
int   wL, hL, sideM, topM, botM;
static GdkGC *gc=NULL;
SPECPLOTARGS specPlotArgs;
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
perB[PERSTART] = plotPDFArgs->xAxis.bounds[PERSTART];
perB[PEREND] = plotPDFArgs->xAxis.bounds[PEREND];
yBounds[YMIN] = specReq->data.yBounds[YMIN];
yBounds[YMAX] = specReq->data.yBounds[YMAX];
if (specReq->data.numRecs != NONE &&
yBounds[YMIN] == 0. &&
yBounds[YMAX] == 0.)
{
fprintf(stderr, "Internal Error: Y-Axis size/dimension == 0, not allowed (channel %s).\n",
specReq->data.name);
return;
}
if (!gc)
gc = gdk_gc_new(pmap);
wL = width - 2*sideM;
hL = height - (topM + botM);
if (wL <= 0 ||  
hL <= 0)
return;
specPlotArgs.scr = plotPDFArgs->scr;
specPlotArgs.pixmap = pmap;
specPlotArgs.specReq = specReq;
specPlotArgs.perB = perB;
specPlotArgs.w = width;
specPlotArgs.h = height;
specPlotArgs.dateFmt = dateFmt;
specPlotArgs.fdUnits = fdUnits;
if (specReq->data.numRecs == NOPSDDATA ||
specReq->data.numRecs == NOPSDBADSR ||
!specReq->data.spectro)
specPlotArgs.data = FALSE;
else
specPlotArgs.data = TRUE;
rgbbuf = calloc(sizeof(char), wL * hL * 3);
memset(rgbbuf, 255, sizeof(char) * wL * hL * 3); 
if (specPlotArgs.data)
{
if (!spectro(rgbbuf, wL, hL, specReq, perB, fdUnits))
specPlotArgs.data = FALSE;
}
gdk_draw_rgb_image(pmap, gc, sideM, topM, wL, hL, GDK_RGB_DITHER_NONE, rgbbuf, wL*3);
plot_spectro_extras(&specPlotArgs);
specReq->plot.replot = FALSE;
free(rgbbuf);
return;
}
