#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <cairo.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "pqlx_externs.h"
#include "magnify.h"
typedef struct _SPECPLOTARGS
{
int  w, h, type;
SPECREQ *specReq;
gboolean data, thumb;
int  dateFmt;
cairo_surface_t *surface;
cairo_t *cr;
} SPECPLOTARGS;
static void plot_spectro_extras(SPECPLOTARGS *specPlotArgs)
{
char  *dispStr;
graph  grL;
int   pixY, horz, vert, w1, sideM, topM, botM;
int   w=specPlotArgs->w, h=specPlotArgs->h, type=specPlotArgs->type;
SPECREQ  *specReq=specPlotArgs->specReq;
gboolean thumb = specPlotArgs->thumb;
int   font;
int   yrS, yrE, moS, moE, dyS, dyE, jdayS, jdayE, x1;
int   dateFmt = specPlotArgs->dateFmt;
float   yBounds[TTLYBOUNDS];
cairo_t  *cr = specPlotArgs->cr;
cairo_surface_t *surface = specPlotArgs->surface;
yBounds[YMIN] = specReq->data.yBounds[YMIN];
yBounds[YMAX] = specReq->data.yBounds[YMAX];
cairo_save(cr);
cairo_set_source_rgb(cr, 0.0, 0.0, 0.0);
cairo_set_line_width(cr, 1.0);
switch(type)
{
case PDFPLOT:
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
font = LABELF;
break;
case WWWPLOT:
if (w >= THUMBSIZEMAXWSPEC)
{
sideM = WWWSIDEM;
topM = WWWTOPM;
botM = WWWBOTM;
}
else
{
sideM = 0;
topM = THUMBTOPM;
botM = 0;
}
if (w >= 500)
font = WWWLABELF1;
else if (w >= 400)
font = WWWLABELF2;
else if (w >= 300)
font = WWWLABELF3;
else if (w >= THUMBSIZEMAXWSPEC)
font = WWWLABELF4;
else
font = WWWLABELF6;
break;
}
if (!specReq->data.name)
specReq->data.name = g_strdup(ChnName(specReq->keys.chnKey));
switch(specPlotArgs->data)
{
case TRUE:
dispStr = g_strdup_printf("%s : %d PSDs", specReq->data.name, specReq->plot.numPSDs);
break;
case FALSE:
dispStr = g_strdup_printf("%s : 0 PSDs", specReq->data.name);
break;
}
vert = topM/2 - fontSIZEPCairo(cr, dispStr, font, HEIGHT);
w1 = fontSIZEPCairo(cr, dispStr, font, WIDTH)/2;
horz = w/2 - w1;
fontDrawPCairo(cr, dispStr, horz, vert, font, FALSE);
free(dispStr);
if(specPlotArgs->data)
{ 
GDate *dates[TTLDATES];
dates[STARTDT] = g_date_copy(specReq->data.dateBounds[STARTDT]);
g_date_add_days(dates[STARTDT], specReq->plot.bounds[XMIN]/specReq->data.numPSDday);
dates[ENDDT] = g_date_copy(dates[STARTDT]);
g_date_add_days(dates[ENDDT], 
(specReq->plot.bounds[XMAX]-specReq->plot.bounds[XMIN]-1) /
specReq->data.numPSDday);
jdayS = g_date_get_day_of_year(dates[STARTDT]);
jdayE = g_date_get_day_of_year(dates[ENDDT]);
yrS = g_date_get_year(dates[STARTDT]);
yrE = g_date_get_year(dates[ENDDT]);
moS = g_date_get_month(dates[STARTDT]);
moE = g_date_get_month(dates[ENDDT]);
dyS = g_date_get_day(dates[STARTDT]);
dyE = g_date_get_day(dates[ENDDT]);
g_date_free(dates[STARTDT]);
g_date_free(dates[ENDDT]);
switch(dateFmt)
{
case PDF_DF_1:
dispStr = g_strdup_printf("%04d:%03d / %04d:%03d", yrS, jdayS, yrE, jdayE);
break;
case PDF_DF_2:
dispStr = g_strdup_printf("%04d-%02d-%02d / %04d-%02d-%02d", yrS, moS, dyS, yrE, moE, dyE);
break;
case PDF_DF_3:
dispStr = g_strdup_printf("%02d-%02d-%04d / %02d-%02d-%04d", dyS, moS, yrS, dyE, moE, yrE);
break;
case PDF_DF_4:
dispStr = g_strdup_printf("%02d-%s-%04d / %02d-%s-%04d", dyS, months[moS-1], yrS, dyE, months[moE-1], yrE);
break;
}
vert = topM/2;
horz = w/2 - w1;
fontDrawPCairo(cr, dispStr, horz, vert, font, FALSE);
free(dispStr);
}
if (!specPlotArgs->data)
{ 
switch(specReq->data.numRecs)
{
case NOPSDDATA:
dispStr = g_strdup_printf("NO PSD Data Available");
break;
case NOPSDBADSR:
dispStr = g_strdup_printf("NO SPECTROGRAM Possible:\nMultiple Sample Rates");
break;
}
font = thumb ? font : MSGF;
fontDrawPCairo(cr, dispStr,
w/2 - fontSIZEPCairo(cr, dispStr, font, WIDTH)/2, 
h/2 - fontSIZEPCairo(cr, dispStr, font, HEIGHT)/2, 
font, FALSE);
free(dispStr);
cairo_move_to(cr, (double) sideM+.5, topM-.5);
cairo_line_to(cr, (double) w-sideM-1+.5, topM-.5);
cairo_line_to(cr, (double) w-sideM-1+.5, h-botM+.5);
cairo_line_to(cr, (double) sideM+.5, h-botM+.5);
cairo_line_to(cr, (double) sideM+.5, topM-.5);
goto GETOUT;
}
if (thumb)
{
cairo_move_to(cr, (double) sideM+.5, topM-.5);
cairo_line_to(cr, (double) w-sideM-1+.5, topM-.5);
goto GETOUT;
}
{ 
XAXISDAYSARGS axisArgs;
graph GR;
axisArgs.type = XAXISDAYSSPECTRO;
axisArgs.plot.surface = surface;
axisArgs.width = w;
axisArgs.height = h;
axisArgs.GR = &GR;
axisArgs.start[YEARH] = yrS;
axisArgs.start[JDAYH] = jdayS;
axisArgs.end[YEARH] = yrE;
axisArgs.end[JDAYH] = jdayE;
axisArgs.startE = (double) spectroEStart(specReq);
viewport(&GR, PDFSIDEM, w-PDFSIDEM-1, h-PDFBOTM+1, h);
window(&GR, (double) 0, (double) TTLSECSSP(specReq), (double) PDFBOTM, (double) 0, 0, 0);
xAxisTIMECairo(&axisArgs);
}
viewport(&grL, 0, sideM, topM, h-botM);
window(&grL, (double) 0, (double) sideM, (double) yBounds[YMIN], (double) yBounds[YMAX], 0, TRUE);
yaxisPCairo(surface, &grL, (double) sideM, (double) yBounds[YMIN], (double) yBounds[YMAX], 
1, -1, 1, (double) 0., MYFLOATSHORT, PDFSTATSF);
font = AXISF;
dispStr = g_strdup_printf("Period (sec)");
w1 = fontSIZEPCairo(cr, dispStr, font, WIDTH);
pixY = h/2 + w1/2;
x1 = 8;
fontDrawPCairo(cr, dispStr, x1, pixY, font, TRUE);
free(dispStr);
cairo_move_to(cr, (double) sideM+.5, topM-.5);
cairo_line_to(cr, (double) w-sideM-1+.5, topM-.5);
cairo_line_to(cr, (double) w-sideM-1+.5, h-botM+1);
GETOUT:
cairo_stroke(cr);
cairo_restore(cr);
}
static gboolean spectro(guchar *rgbbuf, 
int widthDISP, 
int heightDISP, 
SPECREQ *specReq,
int stride)
{
gboolean ret;
int  prob, x, numSkip, oldPixX;
int  pixX, pixY, pixelPos;
guchar **dataMap = &specReq->plot.dataMap;
int  widthIN, heightIN, dbRange, refStart; 
float maxProbability = SPECTROPLOT_MAX_PROB;
int  dbBounds[TTLYBOUNDS];
GList *iter, *start, *end;
GSList *iter2;
SPECTRODATA *spectroData;
PSDDATA *psdData;
MAGARGS magArgs;
GHashTable *gaps;
graph gr;
numSkip = 0;
widthIN = specReq->data.numDivs;
heightIN = specReq->data.numPeriods-numSkip;
if (!*dataMap)
{ 
viewport(&gr, 0, widthIN, 0, heightIN);
window(&gr, (double) 0, (double) widthDISP, (double) 0, (double) heightDISP, FALSE, FALSE);
gaps = specReq->plot.gaps = g_hash_table_new(NULL, NULL);
if (!(*dataMap = (guchar *) calloc(widthIN*heightIN, sizeof(guchar))))
{
fprintf(stderr, "Unable to allocate %d bytes, quitting\n", 
(int) (widthIN*heightIN*sizeof(guchar)));
exit(-1);
}
start = specReq->plot.start;
end = specReq->plot.end;
refStart = ((SPECTRODATA *) (start->data))->psdRef;
if (start == specReq->data.spectro &&
end == NULL)
{
dbBounds[YMIN] = specReq->data.dbBounds[YMIN];
dbBounds[YMAX] = specReq->data.dbBounds[YMAX];
}
else
{
dbBounds[YMIN] = -49;
dbBounds[YMAX] = -201;
getDbRange(start, end, &dbBounds[0], NULL);
}
specReq->plot.dbBounds[YMIN] = dbBounds[YMIN];
specReq->plot.dbBounds[YMAX] = dbBounds[YMAX];
dbRange = dbBounds[YMAX] - dbBounds[YMIN];
for (iter = start, x = 0;
iter != (end ? end->next : NULL);
iter = g_list_next(iter), x++, oldPixX = pixX)
{
spectroData = iter->data;
pixX = spectroData->psdRef - refStart;
if (pixX >= widthIN)
{
break;
}
if (x && oldPixX != pixX - 1)
{
int startX = (int) PIX2USERX(&gr, oldPixX),
endX = (int) PIX2USERX(&gr, pixX), j;
for (j = startX;
j < endX+1;
j++)
{
g_hash_table_insert(gaps, GINT_TO_POINTER(j), GINT_TO_POINTER(j));
}
}
for (iter2 = g_slist_nth(spectroData->psdData, numSkip), pixY = heightIN-1;
iter2;
iter2 = g_slist_next(iter2), pixY--)
{
psdData = iter2->data;
prob = (((float) (psdData->power + dbBounds[YMIN]*-1)
/ (float) dbRange) * 100) 
* (float) PROBFACT;
pixelPos = pixY * (widthIN) + pixX;    
(*dataMap)[pixelPos] = (char) ((prob>MAX_PIXEL_VALUE) ? MAX_PIXEL_VALUE : prob);
}
if (pixY != -1)
printf("Number of periods does not match! (%d)\n", pixY);
}
specReq->plot.numPSDs = x;
}
memset(&magArgs, 0, sizeof(MAGARGS));
magArgs.plotType = SPECTROPLOT;
magArgs.probMapS = *dataMap;
magArgs.rgbbuf = &rgbbuf;
magArgs.widthIN = widthIN;
magArgs.heightIN = heightIN;
magArgs.widthDISP = widthDISP;
magArgs.heightDISP = heightDISP;
magArgs.stride = stride;
magArgs.gaps = specReq->plot.gaps;
ret = magnifyC(&magArgs);
return ret;
}
void plotSPECTROCairo(cairo_surface_t *surface, SPECREQ *specReq, 
int width, int height, int scr, int type)
{
guchar *rgbbuf;
int  wL, hL, sideM, topM, botM;
float yBounds[TTLYBOUNDS];
cairo_surface_t *specOut;
cairo_t *cr;
int  stride;
SPECPLOTARGS specPlotArgs;
yBounds[YMIN] = specReq->data.yBounds[YMIN];
yBounds[YMAX] = specReq->data.yBounds[YMAX];
if (specReq->data.numRecs != NONE &&
yBounds[YMIN] == 0 &&
yBounds[YMAX] == 0)
{
fprintf(stderr, "Internal Error: PDF Y-Axis size/dimension == 0, not allowed (channel %s).\n",
specReq->data.name);
return;
}
cr = cairo_create(surface);
switch(type)
{
case PDFPLOT:
sideM = PDFSIDEM;
topM = PDFTOPM;
botM = PDFBOTM;
break;
case WWWPLOT:
if (width >= THUMBSIZEMAXWSPEC)
{
sideM = WWWSIDEM;
topM = WWWTOPM;
botM = WWWBOTM;
specPlotArgs.thumb = FALSE;
}
else
{
sideM = 0;
topM = THUMBTOPM;
botM = 0;
specPlotArgs.thumb = TRUE;
}
break;
}
wL = width - 2*sideM;
hL = height - (topM + botM);
if (wL <= 0 ||  
hL <= 0)
return;
specPlotArgs.type = type;
specPlotArgs.surface = surface;
specPlotArgs.cr = cr;
specPlotArgs.specReq = specReq;
specPlotArgs.w = width;
specPlotArgs.h = height;
specPlotArgs.dateFmt = specReq->data.dateFmt;
if (specReq->data.numRecs == NOPSDDATA ||
specReq->data.numRecs == NOPSDBADSR ||
!specReq->data.spectro)
specPlotArgs.data = FALSE;
else
specPlotArgs.data = TRUE;
stride = CAIRO_STRIDE_FOR_WIDTH_BPPM(wL, 32);
rgbbuf = malloc(stride * hL);
memset(rgbbuf, 255, stride * hL);  
if (specPlotArgs.data)
{
spectro(rgbbuf, wL, hL, specReq, stride);
}
specOut = cairo_image_surface_create_for_data(rgbbuf, CAIRO_FORMAT_RGB24, wL, hL, stride);
cairo_set_source_surface(cr, specOut, sideM, topM);
cairo_rectangle(cr, sideM, topM, wL, hL);
cairo_fill(cr);
cairo_surface_destroy(specOut);
plot_spectro_extras(&specPlotArgs);
free(rgbbuf);
cairo_destroy(cr);
return;
}
cairo_surface_t *colorBarSPEC(CBARARGS *cBarArgs)
{
int  w = cBarArgs->w, h = cBarArgs->h;
SPECREQ *specReq = cBarArgs->specReq;
int  i, j, y, stride, dbRange, value, strideW;
float inc;
graph grL;
myColorStruct *colorProb;
guchar *pos, *rgbbuf;
gchar *str;
cairo_surface_t *cBar, *cBar2;
cairo_t *cr;
guint32 *pixel;
if (h <= 0)  
return NULL;
stride = CAIRO_STRIDE_FOR_WIDTH_BPPM(COLORBW, 32);
strideW = stride/4;
rgbbuf = malloc(stride * h);
viewport(&grL, 0, COLORBW, 0, h);
window(&grL, (double) 0, (double) COLORBW, (double) 0., (double) SPECTROPLOT_MAX_PROB, 0, 0);
for(i=0;i<h;i++)
{
colorProb = colorP(SPECTROPLOT, (float) PIX2USERY(&grL, i));
for(j=0;j<COLORBW;j++)
{
pos = rgbbuf + (i*strideW + j)*4;  
pixel = (guint32 *)pos;
*pixel = (0 << 24) | (colorProb->R << 16) | (colorProb->G << 8) | (colorProb->B);
}
}
cBar = cairo_image_surface_create_for_data(rgbbuf, CAIRO_FORMAT_RGB24, COLORBW, h, stride);
cBar2 = cairo_image_surface_create(CAIRO_FORMAT_RGB24, w, h);
cr = cairo_create(cBar2);
cairo_set_source_rgb(cr, 1.0, 1.0, 1.0);
cairo_paint(cr);
cairo_set_source_surface(cr, cBar, 0, 0);
cairo_paint(cr);
cairo_surface_destroy(cBar);
free(rgbbuf);
viewport(&grL, 0, COLORBW, 5, h-10);
window(&grL, (double) 0, (double) COLORBW, 
(double) specReq->plot.dbBounds[YMIN], (double) specReq->plot.dbBounds[YMAX], 
0, 0);
y = USER2PIXY(&grL, (double) specReq->plot.dbBounds[YMIN]);
value = specReq->plot.dbBounds[YMIN];
str = g_strdup_printf("%d", value);
y -= fontSIZEPCairo(cr, str, PDFSTATSF, HEIGHT)/2;
fontDrawPCairo(cr, str, COLORBW+2, y, PDFSTATSF, FALSE);
free(str);
y = USER2PIXY(&grL, (double) specReq->plot.dbBounds[YMAX]);
value = specReq->plot.dbBounds[YMAX];
str = g_strdup_printf("%d", value);
y -= fontSIZEPCairo(cr, str, PDFSTATSF, HEIGHT)/2;
fontDrawPCairo(cr, str, COLORBW+2, y, PDFSTATSF, FALSE);
free(str);
viewport(&grL, 0, COLORBW, 5, h-10);
window(&grL, (double) 0, (double) COLORBW, 
(double) specReq->plot.dbBounds[YMIN], (double) specReq->plot.dbBounds[YMAX], 
0, 0);
dbRange = specReq->plot.dbBounds[YMAX] - specReq->plot.dbBounds[YMIN];
inc = (float) dbRange/10.f;
for(i = 1;
i < 10;
i++)
{
value = specReq->data.dbBounds[YMIN] + i * inc; 
y = USER2PIXY(&grL, (double) value);
str = g_strdup_printf("%d", value);
y -= fontSIZEPCairo(cr, str, PDFSTATSF, HEIGHT)/2;
fontDrawPCairo(cr, str, COLORBW+2, y, PDFSTATSF, FALSE);
free(str);
}
cairo_destroy(cr);
return cBar2;
}
