#include <stdlib.h>
#include <stdio.h>
#include "pqlx_defs.h"
#include "magnify.h"
float a=-.5;
#define TTLPDFCG 6
static int CGpdf[TTLPDFCG][3] =
{{255, 0, 255},  
{0, 0, 255},  
{0, 255, 255},  
{0, 255, 0},  
{255, 255, 0},  
{240, 240, 240}}; 
#define TTLSPECTROCG 5
static int CGspectro[TTLSPECTROCG][3] = {
{0, 0, 255},  
{0, 255, 255},  
{0, 255, 0},  
{255, 255, 0},  
{255, 0, 0}};   
int gcd(int a, int b)
{ 
if (!b)
return a;
else
return gcd(b, a%b);
}
myColorStruct * colorP(int plotType, float prob)
{
int      probI = prob, cg; 
static myColorStruct probColor;
switch (plotType)
{
case PDFPLOT:
if (prob < 1.f)
{
probColor.R = 240 - prob*27.; 
probColor.G = 240 - prob*240.; 
probColor.B = 240 + prob*15.; 
return &probColor;
}
cg = probI/TTLPDFCG;
if (cg>4) 
{
cg = 4;
prob = 30.f;
}
probColor.R = CGpdf[cg][0]; 
probColor.G = CGpdf[cg][1]; 
probColor.B = CGpdf[cg][2];
switch(cg)
{
case 0:
probColor.R = 255 - (prob*(MAX_PIXEL_VALUE/6.));  
break;             
case 1:
probColor.G = (prob-6.)*(MAX_PIXEL_VALUE/6.);   
break;             
case 2:
probColor.B = 255 - ((prob-12.)*(MAX_PIXEL_VALUE/6.)); 
break;             
case 3:
probColor.R = (prob-18.)*(MAX_PIXEL_VALUE/6.);  
break;             
case 4:
probColor.G = 255 - ((prob-24.)*(MAX_PIXEL_VALUE/6.)); 
break;             
}
break;
case SPECTROPLOT:
{
int cgBoundary = ((100)/(TTLSPECTROCG-1));
float value;
cg = probI/cgBoundary;
probColor.R = CGspectro[cg][0]; 
probColor.G = CGspectro[cg][1]; 
probColor.B = CGspectro[cg][2];
value = probI - cg*cgBoundary;
value /= cgBoundary;
switch(cg)
{
case 0:  
probColor.G = value * MAX_PIXEL_VALUE;
break;
case 1:  
probColor.B = MAX_PIXEL_VALUE - value * MAX_PIXEL_VALUE;
break;
case 2:  
probColor.R = value * MAX_PIXEL_VALUE;
break;
case 3:  
probColor.G = MAX_PIXEL_VALUE - value * MAX_PIXEL_VALUE;
break;
}
}
break;
}
return &probColor;
}
#if 0
void magnify(int plotType, guchar *probMapS, guchar **rgbbuf, int widthIN, 
int heightIN, int widthDISP, int heightDISP)
{
int  in_width, in_height, out_width, out_height;
int  n_horizontal, d_horizontal, n_vertical, d_vertical, j, k, l, m, index;
int  *Lhorz, *Lvert;
float maxProbability;
guchar *g, *probMapD, *pos;
int  pixelPos, GCD;
myColorStruct *colorProb;
int  xi, yi;
float x;
float *cvert, *chorz;
float *h;
float prob;
switch (plotType)
{
case PDFPLOT:
maxProbability = PDFPLOT_MAX_PROB;
break;
case SPECTROPLOT:
maxProbability = SPECTROPLOT_MAX_PROB;
break;
}
GCD = gcd(widthDISP, widthIN);
n_horizontal = widthDISP/GCD;
d_horizontal = widthIN/GCD;
GCD = gcd(heightDISP, heightIN);
n_vertical = heightDISP/GCD; 
d_vertical = heightIN/GCD;
in_width = widthIN; 
in_height = heightIN;
out_width = widthDISP;
out_height = heightDISP;
if (!(probMapD = (guchar *) calloc(out_width*out_height, sizeof(guchar))))
{
fprintf(stderr, "Unable to allocate %d bytes, quitting\n", 
(int) (out_width*out_height*sizeof(guchar)));
exit(-1);
}
Lvert = calloc(sizeof(int), out_height);
Lhorz = calloc(sizeof(int), out_width);
cvert = calloc(sizeof(float), 4 * out_height);
chorz = calloc(sizeof(float), 4 * out_width);
h = calloc(sizeof(float), in_width);
for (k = 0; k < out_width; k++)
Lhorz[k] = (k * d_horizontal) / n_horizontal;
for (k = 0; k < out_height; k++)
Lvert[k] = (k * d_vertical) / n_vertical;
for (k = 0; k < n_horizontal; k++) 
{
x = (float)((k * d_horizontal) % n_vertical) / (float)n_vertical;
chorz[0*out_width+k] = C0(x);
chorz[1*out_width+k] = C1(x);
chorz[2*out_width+k] = C2(x);
chorz[3*out_width+k] = C3(x);
}
for (k = n_horizontal; k < out_width; k++)
for (l = 0; l < 4; l++)
chorz[l*out_width+k] = chorz[l*out_width + (k % n_horizontal)];
for (k = 0; k < n_vertical; k++) 
{
x = (float)((k * d_vertical) % n_vertical) / (float)n_vertical;
cvert[0*out_height+k] = C0(x);
cvert[1*out_height+k] = C1(x);
cvert[2*out_height+k] = C2(x);
cvert[3*out_height+k] = C3(x);
}
for (k = n_vertical; k < out_height; k++)
for (l = 0; l < 4; l++)
cvert[l*out_height+k] = cvert[l*out_height + (k % n_vertical)];
g = probMapD; 
for (k = 0; k < out_height; k++) 
{
for (j = 0; j < in_width; j++) 
{
h[j] = 0.0f;
for (l = 0; l < 4; l++) 
{
index = Lvert[k] + l - 1;
index = (index < 0) ? 0 : (index >= in_height) ? in_height - 1 : index; 
h[j] += probMapS[index*in_width+j] * cvert[(3 - l)*out_height+k];
}
}
for (m = 0; m < out_width; m++) 
{
x = 0.5f;
for (l = 0; l < 4; l++) 
{
index = Lhorz[m] + l - 1;
index = (index < 0) ? 0 : (index >= in_width) ? in_width - 1 : index;
x += h[index] * chorz[(3 - l)*out_width+m];
}
*g++ = (x <= 0.0f) ? 0 : (x > MAX_PIXEL_VALUE) ? MAX_PIXEL_VALUE : (unsigned char)x;
}
}
pos = *rgbbuf;
for (yi = 0; yi < out_height; yi++)
{
for (xi = 0; xi < out_width; xi++)
{
pixelPos = yi*out_width + xi;
prob = (float) probMapD[pixelPos]/(float) PROBFACT;
if (prob == 0.0f)
{
pos += 3;
continue;
}
colorProb = colorP(plotType, prob);
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos++ = colorProb->B;
}
}
free(probMapD);
free(cvert);
free(chorz);
free(Lvert);
free(Lhorz);
free(h);
}
void prob2rgb(int plotType, guchar *probMapD, guchar **rgbbuf, int widthDISP, int heightDISP)
{
int  yi, xi;
for (yi = 0; yi < heightDISP; yi++)
{
for (xi = 0; xi < widthDISP; xi++)
{
CHECKPROB(plotType, probMapD[xi]);
colorProb = colorP(plotType, prob[xi]);
pos = *rgbbuf + (yi*widthDISP + (xi))*3;  
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos = colorProb->B;
colorProb = colorP(plotType, prob);
pos = *rgbbuf + (pixelPos * 3);  
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos++ = colorProb->B;
}
}
}
#endif
gboolean magnify(MAGARGS *magArgs)
{
int  plotType = magArgs->plotType;
guchar *probMapS = magArgs->probMapS, **rgbbuf = magArgs->rgbbuf; 
int  widthIN = magArgs->widthIN, heightIN = magArgs->heightIN, 
widthDISP = magArgs->widthDISP, heightDISP = magArgs->heightDISP;
GHashTable *gaps = magArgs->gaps;
int  in_width, in_height, widthMAG, heightMAG, larger_out_dimension;
int  n, d, j, k, l, m, index, probSize;
int  *L;
float maxProbability;
guchar *g, *probMapD, *pos;
int  pixelPos, GCD, scaleBy;
myColorStruct *colorProb;
float x, wR, hR;
float *c;
float *h;
float *prob;
switch (plotType)
{
case PDFPLOT:
maxProbability = PDFPLOT_MAX_PROB;
break;
case SPECTROPLOT:
maxProbability = SPECTROPLOT_MAX_PROB;
break;
}
wR = (float) widthDISP/(float) widthIN;
hR = (float) heightDISP/(float) heightIN;
if (wR < hR)
{ 
GCD = gcd(heightDISP, heightIN);
n=heightDISP/GCD; d=heightIN/GCD;
heightMAG = heightDISP;
widthMAG = widthIN * hR;
scaleBy = MAG_WIDTH;
probSize = heightMAG;
}
else
{ 
GCD = gcd(widthDISP, widthIN);
n=widthDISP/GCD; d=widthIN/GCD;
heightMAG = heightIN * wR;
widthMAG = widthDISP;
scaleBy = MAG_HEIGHT;
probSize = widthMAG;
}
larger_out_dimension = (widthMAG > heightMAG) ? widthMAG : heightMAG;
in_width = widthIN; 
in_height = heightIN; 
if (!(probMapD = (guchar *) calloc(widthMAG*heightMAG, sizeof(guchar))))
{
fprintf(stderr, "Unable to allocate %d bytes, cannot plot\n", 
(int) (widthMAG*heightMAG*sizeof(guchar)));
return FALSE;
}
if (!(prob = (float *) calloc(probSize, sizeof(float))))
{
fprintf(stderr, "Unable to allocate %d bytes, cannot plot\n", 
(int) (probSize*sizeof(float)));
return FALSE;
}
L = calloc(sizeof(int), larger_out_dimension);
c = calloc(sizeof(float), 4 * larger_out_dimension);
h = calloc(sizeof(float), in_width);
for (k = 0; k < larger_out_dimension; k++)
L[k] = (k * d) / n;
for (k = 0; k < n; k++) 
{
x = (float)((k * d) % n) / (float)n;
c[0*larger_out_dimension + k] = C0(x);
c[1*larger_out_dimension + k] = C1(x);
c[2*larger_out_dimension + k] = C2(x);
c[3*larger_out_dimension + k] = C3(x);
}
for (k = n; k < larger_out_dimension; k++)
for (l = 0; l < 4; l++)
c[l*larger_out_dimension + k] = c[l*larger_out_dimension + (k % n)];
g=probMapD; 
for (k = 0; k < heightMAG; k++) 
{
for (j = 0; j < in_width; j++) 
{
h[j] = 0.0f;
for (l = 0; l < 4; l++) 
{
index = L[k] + l - 1;
index = (index < 0) ? 0 : (index >= in_height) ? in_height -1 : index;
h[j] += probMapS[index*in_width+j] * c[(3 - l)*larger_out_dimension + k];
}
}
for (m = 0; m < widthMAG; m++) 
{
x = 0.5f;
for (l = 0; l < 4; l++) 
{
index = L[m] + l - 1;
index = (index < 0) ? 0 : (index >= in_width) ? in_width -1 : index;
x += h[index] * c[(3 - l)*larger_out_dimension + m];
}
*g++ = (x <= 0.0f) ? 0 : (x > MAX_PIXEL_VALUE) ? MAX_PIXEL_VALUE : (unsigned char)x;
}
}
switch (scaleBy)
{
int  yi, xi;
case MAG_HEIGHT:
{ 
int  rows, yn, oldY;
float scaleFactor = (float) heightMAG/(float) heightDISP;
for (rows=oldY=yi=0; yi < heightMAG; yi++, rows++)
{
yn = (yi/scaleFactor);  
if (yn != oldY)
{ 
for (xi = 0; xi < widthMAG; xi++)
{
CHECKPROB(plotType, prob[xi], xi);
prob[xi] = prob[xi]/(float)rows;
colorProb = colorP(plotType, prob[xi]);
pos = *rgbbuf + (oldY*widthDISP + (xi))*3;  
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos = colorProb->B;
prob[xi]=0;
}
oldY = yn;
rows=0;
}
for (xi = 0; xi < widthMAG; xi++)
{
pixelPos = yi*widthMAG + xi;
prob[xi] += (float) probMapD[pixelPos]/(float) PROBFACT;
}
}
for (xi = 0; xi < widthMAG; xi++)
{
CHECKPROB(plotType, prob[xi], xi);
prob[xi] = prob[xi]/(float)rows;
pos = *rgbbuf + (yn*widthDISP + (xi))*3;  
colorProb = colorP(plotType, prob[xi]);
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos = colorProb->B;
}
}
break;
case MAG_WIDTH:
{ 
int  oldX, xn, cols;
float scaleFactor = (float) widthMAG/(float) widthDISP;
for (cols=oldX=xi=0; xi < widthMAG; xi++, cols++)
{
xn = (xi/scaleFactor);   
if (xn != oldX)
{ 
for (yi = 0; yi < heightMAG; yi++)
{
CHECKPROB(plotType, prob[yi], xn);
prob[yi] = prob[yi]/(float)cols;
colorProb = colorP(plotType, prob[yi]);
pos = *rgbbuf + (yi*widthDISP + (oldX))*3;  
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos = colorProb->B;
prob[yi]=0;
}
cols=0;
oldX = xn;
}
for (yi = 0; yi < heightMAG; yi++)
{
pixelPos = yi*widthMAG + xi;  
prob[yi] += (float) probMapD[pixelPos]/(float) PROBFACT;
}
}
for (yi = 0; yi < heightMAG; yi++)
{
CHECKPROB(plotType, prob[yi], xn);
prob[yi] = prob[yi]/(float)cols;
colorProb = colorP(plotType, prob[yi]);
pos = *rgbbuf + (yi*widthDISP + (xn))*3;
*pos++ = colorProb->R;
*pos++ = colorProb->G;
*pos = colorProb->B;
}
}
break;
}
free(probMapD);
free(c);
free(L);
free(h);
free(prob);
return TRUE;
}
