#include <stdlib.h>
#include <stdio.h>
#include "pqlx_defs.h"
#include "magnify.h"
static float a=-.5;
gboolean magnifyC(MAGARGS *magArgs)
{ 
int  plotType = magArgs->plotType;
guchar *probMapS = magArgs->probMapS, **rgbbuf = magArgs->rgbbuf; 
int  widthIN = magArgs->widthIN, heightIN = magArgs->heightIN, 
widthDISP = magArgs->widthDISP, heightDISP = magArgs->heightDISP,
stride = magArgs->stride;
GHashTable *gaps = magArgs->gaps;
int  in_width, in_height, widthMag, heightMag, larger_out_dimension;
int  n, d, j, k, l, m, index;
int  *L, scaleBy, probSize;
guchar *g, *probMapD, *pos;
int  pixelPos, GCD;
myColorStruct *colorProb;
float maxProbability;
float x, wR, hR;
float *c;
float *h;
float *prob;
switch (plotType)
{
case PDFPLOT:
maxProbability = PDFPLOT_MAX_PROB;
break;
case SPECTROPLOT:
maxProbability = SPECTROPLOT_MAX_PROB;
break;
}
wR = (float) widthDISP/(float) widthIN;
hR = (float) heightDISP/(float) heightIN;
if (wR < hR)
{ 
GCD = gcd(heightDISP, heightIN);
n=heightDISP/GCD; d=heightIN/GCD;
heightMag = heightDISP;
widthMag = widthIN * hR;
scaleBy = MAG_WIDTH;
probSize = heightMag;
}
else
{ 
GCD = gcd(widthDISP, widthIN);
n=widthDISP/GCD; d=widthIN/GCD;
heightMag = heightIN * wR;
widthMag = widthDISP;
scaleBy = MAG_HEIGHT;
probSize = widthMag;
}
larger_out_dimension = (widthMag > heightMag) ? widthMag : heightMag;
in_width = widthIN; 
in_height = heightIN; 
if (!(probMapD = (guchar *) calloc(widthMag*heightMag, sizeof(guchar))))
{
fprintf(stderr, "Unable to allocate %d bytes, quitting\n", 
(int) (widthMag*heightMag*sizeof(guchar)));
return FALSE;
}
if (!(prob = (float *) calloc(probSize, sizeof(float))))
{
fprintf(stderr, "Unable to allocate %d bytes, quitting\n", 
(int) (probSize*sizeof(float)));
return FALSE;
}
L = calloc(sizeof(int), larger_out_dimension);
c = calloc(sizeof(float), 4 * larger_out_dimension);
h = calloc(sizeof(float), in_width);
for (k = 0; k < larger_out_dimension; k++)
L[k] = (k * d) / n;
for (k = 0; k < n; k++) 
{
x = (float)((k * d) % n) / (float)n;
c[0*larger_out_dimension + k] = C0(x);
c[1*larger_out_dimension + k] = C1(x);
c[2*larger_out_dimension + k] = C2(x);
c[3*larger_out_dimension + k] = C3(x);
}
for (k = n; k < larger_out_dimension; k++)
for (l = 0; l < 4; l++)
c[l*larger_out_dimension + k] = c[l*larger_out_dimension + (k % n)];
g=probMapD; 
for (k = 0; k < heightMag; k++) 
{
for (j = 0; j < in_width; j++) 
{
h[j] = 0.0f;
for (l = 0; l < 4; l++) 
{
index = L[k] + l - 1;
index = (index < 0) ? 0 : (index >= in_height) ? in_height -1 : index;
h[j] += probMapS[index*in_width+j] * c[(3 - l)*larger_out_dimension + k];
}
}
for (m = 0; m < widthMag; m++) 
{
x = 0.5f;
for (l = 0; l < 4; l++) 
{
index = L[m] + l - 1;
index = (index < 0) ? 0 : (index >= in_width) ? in_width -1 : index;
x += h[index] * c[(3 - l)*larger_out_dimension + m];
}
*g++ = (x <= 0.0f) ? 0 : (x > MAX_PIXEL_VALUE) ? MAX_PIXEL_VALUE : (unsigned char)x;
}
}
switch (scaleBy)
{
int  yi, xi, strideW;
guint32 *pixel;
case MAG_HEIGHT:
{ 
int  rows, yn, oldY;
float scaleFactor = (float) heightMag/(float) heightDISP;
strideW = stride/4;
for (rows=oldY=yi=0; yi < heightMag; yi++, rows++)
{
yn = (yi/scaleFactor);  
if (yn != oldY)
{ 
for (xi = 0; xi < widthMag; xi++)
{
CHECKPROB(plotType, prob[xi], xi);
prob[xi] = prob[xi]/(float)rows;
colorProb = colorP(plotType, prob[xi]);
pos = *rgbbuf + (oldY*strideW + (xi))*4;  
pixel = (guint32*)pos;
*pixel = (0 << 24) | (colorProb->R << 16) | (colorProb->G << 8) | (colorProb->B);
prob[xi]=0;
}
oldY = yn;
rows=0;
}
for (xi = 0; xi < widthMag; xi++)
{
pixelPos = yi*widthMag + xi;
prob[xi] += (float) probMapD[pixelPos]/(float) PROBFACT;
}
}
for (xi = 0; xi < widthMag; xi++)
{
CHECKPROB(plotType, prob[xi], xi);
prob[xi] = prob[xi]/(float)rows;
colorProb = colorP(plotType, prob[xi]);
pos = *rgbbuf + (yn*strideW + (xi))*4;  
pixel = (guint32*)pos;
*pixel = (0 << 24) | (colorProb->R << 16) | (colorProb->G << 8) | (colorProb->B);
}
}
break;
case MAG_WIDTH:
{ 
int  oldX, xn, cols;
float scaleFactor = (float) widthMag/(float) widthDISP;
strideW = stride/4;
for (cols=oldX=xi=0; xi < widthMag; xi++, cols++)
{
xn = (xi/scaleFactor);   
if (xn != oldX)
{ 
for (yi = 0; yi < heightMag; yi++)
{
CHECKPROB(plotType, prob[yi], xn);
prob[yi] = prob[yi]/(float)cols;
colorProb = colorP(plotType, prob[yi]);
pos = *rgbbuf + (yi*strideW + (oldX))*4;  
pixel = (guint32*)pos;
*pixel = (0 << 24) | (colorProb->R << 16) | (colorProb->G << 8) | (colorProb->B);
prob[yi]=0;
}
cols=0;
oldX = xn;
}
for (yi = 0; yi < heightMag; yi++)
{
pixelPos = yi*widthMag + xi;  
prob[yi] += (float) probMapD[pixelPos]/(float) PROBFACT;
}
}
for (yi = 0; yi < heightMag; yi++)
{
CHECKPROB(plotType, prob[yi], xn);
prob[yi] = prob[yi]/(float)cols;
colorProb = colorP(plotType, prob[yi]);
pos = *rgbbuf + (yi*strideW + (xn))*4;  
pixel = (guint32*)pos;
*pixel = (0 << 24) | (colorProb->R << 16) | (colorProb->G << 8) | (colorProb->B);
}
}
break;
}
free(probMapD);
free(c);
free(L);
free(h);
free(prob);
return TRUE;
}
