#ifndef __MAGNIFY_H
#define __MAGNIFY_H
#include <glib.h>
#include "pql_defines.h"
enum {
MAG_WIDTH,
MAG_HEIGHT
};
typedef struct _myColorStruct
{
guchar R, G, B;
} myColorStruct;
typedef struct _MAGARGS
{
int  plotType; 
guchar *probMapS;
guchar **rgbbuf; 
int  widthIN, heightIN;
int  widthDISP, heightDISP;
int  stride;     
GHashTable *gaps;    
} MAGARGS;
gboolean magnifyC(MAGARGS *);
gboolean magnify(MAGARGS *);
myColorStruct * colorP(int plotType, float prob);
void viewport(graph *gr, int xmin, int xmax, int ymin, int ymax);
void window(graph *gr, double xmin, double xmax, double ymin, double ymax, int lx, int ly);
char *ChnName(int chni_pk);
int  gcd(int a, int b);
#define PDFPLOT_MAX_PROB 30.f
#define SPECTROPLOT_MAX_PROB 100.f
#define MAX_PIXEL_VALUE 255
#define PROBFACT  (MAX_PIXEL_VALUE/maxProbability)
#define CAIRO_STRIDE_ALIGNMENTM (32)
#define CAIRO_STRIDE_FOR_WIDTH_BPPM(w,bpp) (((bpp)*(w)+7)/8 + CAIRO_STRIDE_ALIGNMENTM-1) & ~(CAIRO_STRIDE_ALIGNMENTM-1)
#define ISGAP(c) ((g_hash_table_lookup(gaps, GINT_TO_POINTER(c)) == NULL) ? FALSE : TRUE)
#define CHECKPROB(pT, pV, col)switch (pT){case SPECTROPLOT:if (gaps && ISGAP(col)){continue;}break;case PDFPLOT:if (pV == 0.0f){continue;}break;}
#define C0(t)(-a*t*t*t+a*t*t)
#define C1(t)(-(a+2.0f)*t*t*t+(2.0f*a+3.0f)*t*t-a*t)
#define C2(t)((a+2.0f)*t*t*t-(a+3.0f)*t*t+1.0f)
#define C3(t)(a*t*t*t-2.0f*a*t*t+a*t)
#endif
