#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "pql_defines.h"
#include "pql_externs.h"
gboolean beepMe(gpointer nil);
typedef struct
{
double real ;
double imag ;
} iircomplex ;
void highpass(), lowpass(), filt();
int _iir(DATAINFO *fromData, DATAINFO *toData, int active_filter)
{ 
gint32  *ptr;
short *iptr;
float   *fptr;
double  *dptr;
int   NH, NL, i;
iircomplex add_c(), sub_c(), cmul_c(), div_c(), polar_c() ;
iircomplex conj_c(), mul_c(), cart_c(), sqrt_c() ;
iircomplex pl[12], ph[12] ;
double  FH, FL, dt, b0l, b0h ;
double  a1, a2, b1, b2 ;
double *af, trcMean, secsPsamp;
char   *to_data_pp, *from_data_p=fromData->data;
int   data_form;
int   numSamples;
trcMean = fromData->amps.mean;
data_form = fromData->head.data_form;
numSamples = fromData->head.numSamples;
secsPsamp = fromData->head.secsPsamp;
to_data_pp = toData->data;
NH = -1 ;
while((NH != 0) && ((NH%2) != 0) && (NH < 13))
{
NH = settings.general.filter.filts[active_filter]->poles[HIGHF];
}
FH = 0 ;
if ( NH != 0)
{
while(FH == 0)
{
FH = (settings.general.filter.filts[active_filter]->cutoff[HIGHF]);
if(FH == 0) {
g_idle_add(beepMe, NULL);
states.msg = g_strdup("High Frequency Cutoff = 0, Not Allowed. "
"Please Adjust Value via Controls Panel or Spectra Screen.");
return FAILURE;
}
}
} 
NL = -1 ;
while((NL != 0) && ((NL%2) != 0) && (NL < 13))
{
NL = settings.general.filter.filts[active_filter]->poles[LOWF];
}
FL = 0 ;
if ( NL != 0)
{
FL = (settings.general.filter.filts[active_filter]->cutoff[LOWF]);
if(FL == 0) {
g_idle_add(beepMe, NULL);
states.msg = g_strdup("High Frequency Cutoff = 0, Not Allowed. Please Adjust Value.");
return FAILURE;
}
else {
FL = 0 ;
if ( FH != 0)
{
while(FH > FL)
{
FL = (settings.general.filter.filts[active_filter]->cutoff[LOWF]);
if (FL > ((1/secsPsamp)/2)) {
NL = 0;
g_idle_add(beepMe, NULL);
states.msg = g_strdup_printf("Low Frequency Cutoff Must Be <= %f. Please Adjust Value.", 
(float) 1./secsPsamp/2.);
return FAILURE;
}
if(FL == 0) {
g_idle_add(beepMe, NULL);
states.msg = g_strdup("Low Frequency Cutoff = 0, Not Allowed. Please Adjust Value.");
return FAILURE;
}
if(FL < FH) {
g_idle_add(beepMe, NULL);
states.msg = g_strdup("Low Frequency Cutoff Must Be > High Cutoff Frequency. Please Adjust Values.");
return FAILURE;
}
} 
} 
else 
{
FL = (settings.general.filter.filts[active_filter]->cutoff[LOWF]);
if (FL > ((1/secsPsamp)/2)) {
NL = 0;
g_idle_add(beepMe, NULL);
states.msg = g_strdup_printf("Low Frequency Cutoff Must Be <= %f. Please Adjust Value.", 
(float) 1./secsPsamp/2.);
return FAILURE;
}
if(FL == 0) {
g_idle_add(beepMe, NULL);
states.msg = g_strdup("Low Cutoff Frequency = 0, Not Allowed. Please Adjust Value.");
return FAILURE;
}
}
} 
}
dt = 0 ;
while (dt <= 0)
{
dt = secsPsamp;
}
if(NH != 0)
{
highpass(FH,dt,NH,ph,&b0h) ;
}
if(NL != 0)
{
lowpass(FL,dt,NL,pl,&b0l) ;
}
if ((af = (double *)calloc(numSamples,sizeof(double))) == NULL) {
fprintf(stderr,"Out of memory.\n");
exit(-1);
} 
switch (data_form) 
{ 
case BIT32:
ptr = (gint32 *)from_data_p;
for (i=0; i<numSamples; i++ ) 
{
af[i] = (float) (ptr[i] - trcMean);
}
break;
case BIT16:
iptr = (short *)from_data_p;
for (i=0; i<numSamples; i++ ) 
{
af[i] = (float) (iptr[i] - trcMean);
}
break;
case MY_FLOAT:
fptr = (float *)from_data_p;
for (i=0; i<numSamples; i++ ) 
{
af[i] = (float) (fptr[i] - trcMean);
}
break;
case MY_DOUBLE:
dptr = (double *)from_data_p;
for (i=0; i<numSamples; i++ ) 
{
af[i] = (float) (dptr[i] - trcMean);
}
break;
}
if(NH != 0)
{
for ( i=0 ; i<NH ; i +=2)
{
a1 = -2*ph[i].real ;
a2 = ph[i].real*ph[i].real + ph[i].imag*ph[i].imag ;
b1 = -2 ;
b2 = 1 ;
filt (a1, a2, b1, b2, numSamples, af, af) ;
}
for ( i=0 ; i<numSamples ; i++)
{
af[i] = b0h*af[i] ;
}
}
if ( NL != 0)
{
for ( i=0 ; i<NL ; i +=2)
{
a1 = -2*pl[i].real ;
a2 = pl[i].real*pl[i].real + pl[i].imag*pl[i].imag ;
b1 = 2 ;
b2 = 1 ;
filt (a1, a2, b1, b2, numSamples, af, af) ;
}
for ( i=0 ; i<numSamples ; i++)
{
af[i] = b0l*af[i] ;
}
}
{
double *minPtr = &toData->amps.min;
double *maxPtr = &toData->amps.max;
double *meanPtr = &toData->amps.mean, mean=0;
double *diffPtr = &toData->amps.diff;
fptr = (float*)(to_data_pp);
*minPtr = *maxPtr = af[0];
for (i=0; i< numSamples; i++ ) 
{
fptr[i] = (float)af[i];
mean += fptr[i];
if (fptr[i] > *maxPtr)
{
*maxPtr = fptr[i];
continue;
}
if (fptr[i] < *minPtr)
*minPtr = fptr[i];
}
*meanPtr = mean/numSamples;
*diffPtr = *maxPtr - *minPtr;
}
free(af);
return PQLXSUCCESS;
}
iircomplex add_c (u,v)
iircomplex u ;
iircomplex v;
{
iircomplex w ;
w.real = u.real + v.real ;
w.imag = u.imag + v.imag ;
return (w) ;
}
iircomplex mul_c (u,v)
iircomplex  u ;
iircomplex  v ;
{
iircomplex  w ;
w.real = u.real*v.real - u.imag*v.imag ;
w.imag = u.real*v.imag + u.imag*v.real ;
return (w) ;
}
iircomplex cmul_c (a,u)
double a ;
iircomplex u ;
{
iircomplex w ;
w.real = a * u.real ;
w.imag = a * u.imag ;
return (w) ;
}
iircomplex sub_c(u,v)
iircomplex u ;
iircomplex v ;
{
iircomplex w ;
w.real = u.real - v.real ;
w.imag = u.imag - v.imag ;
return (w) ;
}
iircomplex div_c(u,v)
iircomplex u ;
iircomplex v ;
{
iircomplex w ;
if (!(v.real == 0 && v.imag == 0))      
{
w.real = ((u.real * v.real) + (u.imag * v.imag)) /
((v.real * v.real) + (v.imag * v.imag)) ;
w.imag = ((u.imag * v.real) - (u.real * v.imag)) /
((v.real * v.real) + (v.imag * v.imag)) ;
return (w) ;
}
else
{
fprintf (stderr, "ERROR: iircomplex division by 0 in div_c\n") ;
exit (1) ;
}
}
iircomplex conj_c(u)
iircomplex  u ;
{
iircomplex  w ;
w.real = u.real ;
w.imag = -u.imag ;
return (w) ;
}
#if 0
void sweep(f1, f0, npts, dt, as)
double f1, f0, dt, as[] ;
int npts ;
{
double tf, df, tt ;
int i ;
tf = npts*dt ; 
df = 2.*G_PI*(f1-f0)/(tf*2) ; 
for( i=0 ; i<npts ; i++)
{
tt = i*dt ;
as[i] = sin(f0*tt + df*tt*tt) ;
}
}
#endif
void filt (a1, a2, b1, b2, npts, fi, fo)
double a1, a2, b1, b2 ;
double fi[], fo[] ;
int npts ;
{
double d1, d2, out ;
int i ;
d1 = 0 ;
d2 = 0 ;
for ( i=0 ; i<npts ; i++)
{
out = fi[i] + d1 ;
d1 = b1*fi[i] - a1*out + d2 ;
d2 = b2*fi[i] - a2*out ;
fo[i] = out ;
}
}
void wdat (FF, npts, dt, ar)
char FF[] ;
int npts ;
double dt ;
double ar[] ;
{
int i ;
FILE *fn ;
if((fn = fopen(FF,"w+")) == NULL)
{
printf("cannot create output file ") ;
exit (1) ;
}
for ( i=0 ; i<npts ; i++)
{
fprintf(fn, "%16.8le\n", ar[i]) ;
}
fclose(fn) ;
}
void lowpass(fc,dt,n,p,b)
double fc, dt, *b ;
iircomplex p[] ;
int n ;
{ 
double wcp, wc, b0 ;
int  i, i1 ;
iircomplex add_c(), mul_c(), div_c(), cmul_c(), sub_c() ;
iircomplex conj_c() ;
iircomplex one, x, y ;
wcp = 2 * fc * G_PI ;
wc = (2./dt)*tan(wcp*dt/2.) ;
one.real = 1. ;
one.imag = 0. ;
for (i=0 ; i<n ; i += 2)
{
i1 = i + 1 ;
p[i].real = -wc*cos(i1*G_PI/(2*n)) ;
p[i].imag = wc*sin(i1*G_PI/(2*n)) ;
p[i+1] = conj_c(p[i]) ;
}
for ( i=0 ; i<n ; i += 2)
{
p[i] = cmul_c(dt/2,p[i]) ;
x = add_c(one,p[i]) ;
y = sub_c(one,p[i]) ;
p[i] = div_c(x,y) ;
p[i+1] = conj_c(p[i]) ;
}
b0 = 1. ;
for (i=0 ; i<n ; i +=2)
{
x = sub_c(one,p[i]) ;
y = sub_c(one,p[i+1]) ;
x = mul_c(x,y) ;
b0 = b0*4./x.real ;
}
b0 = 1./b0 ;
*b = b0 ;
}
void highpass(fc,dt,n,p,b)
double fc, dt, *b ;
iircomplex p[] ;
int n ;
{ 
double wcp, wc, alpha, b0 ;
int  i ;
iircomplex add_c(), mul_c(), div_c(), cmul_c(), sub_c() ;
iircomplex conj_c() ;
iircomplex one, x, y ;
wcp = 2 * fc * G_PI ;
wc = (2./dt)*tan(wcp*dt/2.) ;
alpha = cos(wc*dt) ;
one.real = 1. ;
one.imag = 0. ;
lowpass(fc,dt,n,p,&b0) ;
for (i=0 ; i<n ; i+=2)
{
x = cmul_c (alpha,one) ;
x = sub_c (x,p[i]) ;
y = cmul_c (alpha,p[i]) ;
y = sub_c(one,y) ;
p[i] = div_c(x,y) ;
p[i+1] = conj_c(p[i]) ;
}
b0 = 1. ;
for (i=0 ; i<n ; i += 2)
{
x = add_c(one,p[i]) ;
y = add_c(one,p[i+1]) ;
x = mul_c(x,y) ;
b0 = b0*4./x.real ;
}     
b0 = 1./b0 ;
*b = b0 ;
}
