#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>           // stat(), etc
#include <dirent.h>
#include <glib.h>
#include "ref2sac.h"
#include "reftek.h"

int get_rt130_data(traceInfo *), get_rt125A_data(traceInfo *), get_rt125_data(traceInfo *);
GSList	*IDrt130(FILE*,char*), *IDrt125A(FILE*,char*), *IDrt125(FILE*,char*);
//GSList	*get_rt125_SOH(FILE *), *get_rt125A_SOH(FILE *), *get_rt130_SOH(FILE *);

void freeData2(traceInfo *trc)
{
	if (trc->data.fileName)
		free(trc->data.fileName);
	if (trc->data.head.shortFN)
		free(trc->data.head.shortFN);
	if (trc->data.head.descr1)
		free(trc->data.head.descr1);
	if (trc->data.head.descr2)
		free(trc->data.head.descr2);
	if (trc->data.dataInfo.data)			// data array
		free(trc->data.dataInfo.data);
	trc->data.dataInfo.data = NULL;
}

int readTrace(traceInfo *trace)
{
	int ret;
	struct stat	file_stat;

    // stat() the entry for the filesize
    if (stat(trace->data.fileName, &file_stat) == -1) 
	{	// if we can't stat the file, then we can't read it either, move on...
	    return(FILE_DNE);
    }

	switch(trace->data.fileType)
	{
	  case RT130_DATA:
		ret = get_rt130_data(trace);
		break;

	  case RT125A_DATA:
		ret = get_rt125A_data(trace);
		break;

	  case RT125_DATA:
		ret = get_rt125_data(trace);
		break;
	}

	return ret;
}

GSList *identifyTrace(char *fileName)
{
	FILE *fp;
	GSList	*traces=NULL;

	if ((fp=fopen(fileName, "r")) == NULL)
	{
		return((GSList *)FILE_DNE);
	}

//case RT130_DATA:
	if ((traces=IDrt130(fp, fileName))) 
	{
		fclose(fp);
		return traces;
	}

//case RT125A_DATA:
	if ((traces=IDrt125A(fp, fileName))) 
	{
		fclose(fp);
		return traces;
	}

//case RT125_DATA:		// 125A format check must come before 125 format check!
	if ((traces=IDrt125(fp, fileName))) 
	{
		fclose(fp);
		return traces;
	}

	fclose(fp);
	return (NULL);
}

#if 0
static int fileType(char *name)
{	// is the input a file or a directory?
	// can't use extended field d_type from dirent.h, doesn't exist on SOLARIS
	DIR		*dp;
	int 	ret = FTFILE;
	
	if (!((dp=opendir(name))==NULL))
	{	// succeeded, it's a directory
		ret = FTDIR;
		closedir(dp);
	}

	return ret;
}

static char * getSOHFile(char *sohDir)
{
	DIR		*dp;
	struct dirent *ep;
	char	*sohFile=NULL;

	if ((dp=opendir(sohDir))==NULL)
	{	// failed
		return sohFile;
	}
	
	while((ep=readdir(dp)))
	{
		if (!strcmp(ep->d_name,".") || 
			!strcmp(ep->d_name, ".."))
			continue;	// don't read '.' and '..' directories

#ifdef WIN32
		sohFile = g_strdup_printf("%s\\%s", sohDir, ep->d_name);	
#else
		sohFile = g_strdup_printf("%s/%s", sohDir, ep->d_name);	
#endif
		switch(fileType(sohFile))
		{
			case FTDIR:		// it's another directory, ignore
				free(sohFile);
				sohFile = NULL;
				continue;
			break;
			case FTFILE:	// found a file, assume it's the one we want
				break;
			break;
		}
	}

	closedir(dp);
	return sohFile;
}
#endif

