#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <glib.h>
#include "ref2sac.h"

extern GSList	*fileList;

static void registerFile(char *file)
{
	fileList = g_slist_prepend(fileList, g_strdup(file));
}

static int fileType(char *name)
{	// is the input a file or a directory?
	// can't use extended field d_type from dirent.h, doesn't exist on SOLARIS
	DIR		*dp;
	int 	ret = FTFILE;
	
	if (!((dp=opendir(name))==NULL))
	{	// succeeded, it's a directory
		ret = FTDIR;
		closedir(dp);
	}

	return ret;
}

void getFiles(char *dirFile)
{	// recursive function: 
	// descend into every directory and 
	//  1) if it's a directory call us again, or
	//	2) if it's a file, register for processing
	DIR		*dp;
	struct dirent *ep;
	char *newDirFile;

	if ((dp=opendir(dirFile))==NULL)
	{	// failed, it must be a file
		registerFile(dirFile);
	}
	else
	{	// succeeded, it must be a directory
		while((ep=readdir(dp)))
		{
			if (!strcmp(ep->d_name,".") || 
				!strcmp(ep->d_name, ".."))
				continue;	// don't read '.' and '..' directories

			if (!strcmp(ep->d_name, "0"))
				continue;	// don't process '0' directory (for RT130 data)

#ifdef WIN32
			newDirFile = g_strdup_printf("%s\\%s", dirFile, ep->d_name);	
#else
			newDirFile = g_strdup_printf("%s/%s", dirFile, ep->d_name);	
#endif
			switch(fileType(newDirFile))
			{
				case FTDIR:
					getFiles(newDirFile);
				break;
				case FTFILE:
					registerFile(newDirFile);
				break;
			}
			free(newDirFile);
		}
		closedir(dp);
	}
}


