#ifndef __REF2SAC_H
#define __REF2SAC_H

// copyright (c) 2010 - R.I. Boaz

#define	REF2SAC_VER	"2010.103"

#include "pql_data_struct.h"

enum {
	FTDIR,
	FTFILE
};

enum {
	BIT32,
	BIT16,
	MY_FLOAT,
	MY_DOUBLE,
	MY_CHAR,
	TTLDTYPES
};

enum {
	SUCCESS,
	FAILURE,
	FILE_DNE,
	NOT_ENOUGH_DATA
};

enum {
	RT130_DATA,
	RT125A_DATA,
	RT125_DATA
};

#define MY_BIG_ENDIAN		1

typedef struct _CHNDEF
{
	char	*ntw, 
			*stn, 
			*loc, 
			*chn;
} CHNDEF;

GSList *identifyTrace(char *);
int readTrace(traceInfo *trace);
void revmem(u_char *buf, int size);
void passcal_etoh(register struct ptime *t, double epoch);
int get_julday(int month, int day, int year);
gint32 passcal_htoe(struct ptime *t, gboolean convertJul);
void getFiles(char *dirFile);
void freeData2(traceInfo *trc);
int testByteOrder();

// terribly useful macros
// generic data extractor
// in order to use this, the names of the data pointers 
// must be set to point to the data array, and be exactly named, as:
// gint32	*ptr;	to integer (32-bit) data
// short	*sptr;	to short data
// float	*lptr;	to float data
// double	*dptr;	to double data
#define DATAP(b, c, d) {switch (b) { \
							case BIT32: d=ptr[c];break;		\
							case BIT16: d=sptr[c];break;		\
							case MY_FLOAT: d=lptr[c];break;	\
							case MY_DOUBLE: d=dptr[c];break;	\
							}	\
						}

#endif
