#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
GtkTooltips *tips;
char  toolTip[1000];
GtkSizeGroup *size_group, *size_group1, *size_group2;
enum {
STNPRINTDIRECTORY,
STNPRINTFNAME
};
enum {
STNPRNTPRINT,
STNPRNTCANCEL
};
GtkWidget *stnPrintWndw;
GtkWidget *printWdgt[2];
GtkWidget *PprtFrmt[TTLPRINTFMTS];
GdkPixmap *pixmap;
static void printSTN(int which)
{
int   paperW=0, paperH=0;
static GdkWindow *gdkWindow;
GdkPixbuf *pPixbuf;
gchar  *fullFN=NULL;
int   retCode;
switch(settings.general.print.paperSize)
{
case LETTER:
paperW = LTRH;  
paperH = LTRW;
break;
case A4:
paperW = A4H;  
paperH = A4W;
break;
}
switch(which)
{
case PRINT_FMT_PS:
fullFN = g_strdup_printf("%s/%s.ps", 
gtk_entry_get_text(GTK_ENTRY(printWdgt[STNPRINTDIRECTORY])),
gtk_entry_get_text(GTK_ENTRY(printWdgt[STNPRINTFNAME])));
retCode = printPSHeadFoot2(fullFN, PRINTHEADER, paperW, paperH);
if (retCode != PQLXSUCCESS)
{
free(fullFN);
return;
}
break;
case PRINT_FMT_PNG:
fullFN = g_strdup_printf("%s/%s.png", 
gtk_entry_get_text(GTK_ENTRY(printWdgt[STNPRINTDIRECTORY])),
gtk_entry_get_text(GTK_ENTRY(printWdgt[STNPRINTFNAME])));
break;
}
if (!gdkWindow)
gdkWindow = gdk_get_default_root_window();
if (!(pPixbuf = gdk_pixbuf_get_from_drawable(NULL, pixmap, NULL, 0, 0, 0, 0, -1, -1)))
{
fprintf(stderr, "Internal Error: Failed to Create PIXBUF for Printing, Please Report\n");
}
switch(which)
{
case PRINT_FMT_PS:
print_ps_image2(pPixbuf);
printPSHeadFoot2(fullFN, PRINTFOOTER, paperW, paperH);
break;
case PRINT_FMT_PNG:
if (!gdk_pixbuf_save(pPixbuf, fullFN, "png", NULL, NULL))
{
fprintf(stderr, "Could not save STN plot in PNG format. Most likely cause is missing libpng library.\n");
fprintf(stderr, "You can obtain this library by downloading the latest release of PQL and re-compiling the PQLX system.\n");
fprintf(stderr, "PQL can be downloaded from: http://www.passcal.nmt.edu/announcements/pqlII.htm\n");
}
break;
}
g_object_unref(pPixbuf);
free(fullFN);
gdk_beep();
gtk_widget_hide(stnPrintWndw);
}
static void printCmd(GtkButton *button, gpointer c)
{
int cmd = GPOINTER_TO_INT(c);
switch(cmd)
{
case STNPRNTPRINT:
switch((gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(PprtFrmt[PRINT_FMT_PNG]))))
{
case TRUE:
printSTN(PRINT_FMT_PNG);
break;
case FALSE:
printSTN(PRINT_FMT_PS);
break;
}
break;
case STNPRNTCANCEL:
gtk_widget_hide(stnPrintWndw);
break;
}
}
static void printDstroy(GtkWidget *widget, void *nothing)
{
stnPrintWndw = NULL;
}
static void make_STNPrint()
{
GtkWidget *vbox, *hbox, *button, *label, *entry;
GtkWidget *sep, *radioB1, *radioB2;
stnPrintWndw = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(stnPrintWndw), "STN PRINT"); 
gtk_container_set_border_width(GTK_CONTAINER(stnPrintWndw), 2);
g_signal_connect(stnPrintWndw, "destroy", G_CALLBACK(printDstroy), NULL);
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Print Format: ");
gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, FALSE, 2);
PprtFrmt[PRINT_FMT_PNG] = radioB1 = gtk_radio_button_new_with_label(NULL, "PNG");
gtk_box_pack_start(GTK_BOX(hbox), radioB1, TRUE, FALSE, 2);
PprtFrmt[PRINT_FMT_PS] = radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "POSTSCRIPT");
gtk_box_pack_start(GTK_BOX(hbox), radioB2, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Print Directory: ");
printWdgt[STNPRINTDIRECTORY] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Print Filename: ");
printWdgt[STNPRINTFNAME] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(printCmd), GINT_TO_POINTER(STNPRNTPRINT));
sep = gtk_hseparator_new();
gtk_box_pack_start(GTK_BOX(vbox), sep, TRUE, FALSE, 2);
hbox = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
button = gtk_button_new_with_label("PRINT");
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(STNPRNTPRINT));
button = gtk_button_new_with_label("CANCEL");
gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, FALSE, 2);
g_signal_connect(button, "clicked", G_CALLBACK(printCmd), GINT_TO_POINTER(STNPRNTCANCEL));
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(stnPrintWndw), vbox);
gtk_window_set_transient_for((GtkWindow *) stnPrintWndw, (GtkWindow *) topWindow);
gtk_window_set_position(GTK_WINDOW(stnPrintWndw), GTK_WIN_POS_CENTER);
gtk_widget_show_all(stnPrintWndw);
return;
}
void stnPrint(GtkButton *button, gpointer s)
{
int  screen = GPOINTER_TO_INT(s);
switch(screen)
{
case STNMAIN:
pixmap = stnStates.pmap.main[stnSettings.main.data];
break;
case STNANALYSIS:
pixmap = stnStates.pmap.analysis[PMAPVISIBLE];
break;
case STNSPECTRA:
case STNPSD:
pixmap = stnStates.pmap.specPsdPrint;
break;
}
if (!stnPrintWndw)
{
make_STNPrint();
}
gtk_widget_show(stnPrintWndw);
return;
}
